/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 89;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 63,
  Feature_HasRCPC_IMMOBit = 82,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 62,
  Feature_HasSHA3Bit = 61,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 88,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 80,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 74,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 43,
  Feature_HasSVEAESBit = 36,
  Feature_HasSVE2SM4Bit = 40,
  Feature_HasSVE2SHA3Bit = 87,
  Feature_HasSVEBitPermBit = 38,
  Feature_HasSMEandIsNonStreamingSafeBit = 55,
  Feature_HasSMEBit = 49,
  Feature_HasSMEF64F64Bit = 51,
  Feature_HasSMEI16I64Bit = 54,
  Feature_HasSME2andIsNonStreamingSafeBit = 58,
  Feature_HasSME2Bit = 57,
  Feature_HasSME2p1Bit = 60,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 46,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 41,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 47,
  Feature_HasLUTBit = 48,
  Feature_HasSME_LUTv2Bit = 59,
  Feature_HasSMEF8F16Bit = 52,
  Feature_HasSMEF8F32Bit = 50,
  Feature_HasFPRCVTBit = 14,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 39,
  Feature_HasSVE2_or_SMEBit = 32,
  Feature_HasSVE2_or_SME2Bit = 45,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 35,
  Feature_HasSVE2p1_or_SMEBit = 56,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 44,
  Feature_HasSVE2p2_or_SME2p2Bit = 31,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 53,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 37,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 71,
  Feature_HasRCPCBit = 81,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 86,
  Feature_HasMatMulFP64Bit = 42,
  Feature_HasLS64Bit = 78,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 79,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 69,
  Feature_IsBEBit = 75,
  Feature_UseExperimentalZeroingPseudosBit = 34,
  Feature_UseAlternateSExtLoadCVTF32Bit = 73,
  Feature_UseScalarIncVLBit = 33,
  Feature_NoUseScalarIncVLBit = 85,
  Feature_UseSVEFPLD1RBit = 84,
  Feature_UseLDAPURBit = 83,
  Feature_NotForCodeSizeBit = 72,
  Feature_UseSTRQroBit = 70,
  Feature_TailCallX16X17Bit = 65,
  Feature_TailCallX17Bit = 76,
  Feature_TailCallNotX16Bit = 77,
  Feature_TailCallAnyBit = 64,
  Feature_SLSBLRMitigationBit = 68,
  Feature_NoSLSBLRMitigationBit = 67,
  Feature_OptimizedGISelOrOtherSelectorBit = 66,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return MI.getOpcode() == TargetOpcode::G_ADD ||
                (MI.getOpcode() == TargetOpcode::G_OR &&
                 MI.getFlag(MachineInstr::MIFlag::Disjoint));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(837), /*)*//*default:*//*Label 154*/ GIMT_Encode4(402522),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3146),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(34649),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(47997),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(49826),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(49908), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(49990),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(57736),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(69783), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(75722), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(83246), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(93190),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(93681),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(94172),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(94440),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(94590),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(95081), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(95114),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(103710),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(104760), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(107729), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(121041),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(122392),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(123384),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(124376),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(125868), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(127360),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(128352),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(129344),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(130336),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(131328),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(132320), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 31*/ GIMT_Encode4(133312), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 32*/ GIMT_Encode4(133363),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 33*/ GIMT_Encode4(243096), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 34*/ GIMT_Encode4(253352),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 35*/ GIMT_Encode4(253642),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 36*/ GIMT_Encode4(255079),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 37*/ GIMT_Encode4(255199), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 38*/ GIMT_Encode4(255440),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 39*/ GIMT_Encode4(257338),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 40*/ GIMT_Encode4(258992),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 41*/ GIMT_Encode4(261771),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 42*/ GIMT_Encode4(262551),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 43*/ GIMT_Encode4(262944), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 44*/ GIMT_Encode4(263720),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 45*/ GIMT_Encode4(263850), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 46*/ GIMT_Encode4(264343), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 47*/ GIMT_Encode4(268919), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 48*/ GIMT_Encode4(269625),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 49*/ GIMT_Encode4(270109),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 50*/ GIMT_Encode4(270593),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 51*/ GIMT_Encode4(271023),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 52*/ GIMT_Encode4(271453),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 53*/ GIMT_Encode4(271883), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 54*/ GIMT_Encode4(272313),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 55*/ GIMT_Encode4(274111),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 56*/ GIMT_Encode4(274849),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 57*/ GIMT_Encode4(278945), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 58*/ GIMT_Encode4(295218), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 59*/ GIMT_Encode4(295834),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 60*/ GIMT_Encode4(299341),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 61*/ GIMT_Encode4(299589),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 62*/ GIMT_Encode4(299777),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 63*/ GIMT_Encode4(300840),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 64*/ GIMT_Encode4(301903),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 65*/ GIMT_Encode4(306300),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 66*/ GIMT_Encode4(310075),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 67*/ GIMT_Encode4(310395),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 68*/ GIMT_Encode4(310715), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 69*/ GIMT_Encode4(311572),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 70*/ GIMT_Encode4(311854),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 71*/ GIMT_Encode4(312232),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 72*/ GIMT_Encode4(312610),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 73*/ GIMT_Encode4(312960),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(313310),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(314013), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(314716),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(315120),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(315524),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(315928),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(316332),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(317147),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(317313),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(317412), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 84*/ GIMT_Encode4(317428),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 85*/ GIMT_Encode4(322440),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 86*/ GIMT_Encode4(349837), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 87*/ GIMT_Encode4(352755), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(354461), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(354613), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(355287),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(355447),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(355761),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(355915), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(356406),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(356706),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(357197),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(357688), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(358179),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(359305),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(359921),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(363643), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(364259),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(379866), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(380166),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(380180),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 106*/ GIMT_Encode4(380201), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 107*/ GIMT_Encode4(380226), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 108*/ GIMT_Encode4(380536),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 109*/ GIMT_Encode4(380707),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 110*/ GIMT_Encode4(380878),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 111*/ GIMT_Encode4(381049),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 112*/ GIMT_Encode4(381220), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 113*/ GIMT_Encode4(382349),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 114*/ GIMT_Encode4(382552),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 115*/ GIMT_Encode4(382755),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 116*/ GIMT_Encode4(382958), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   2994 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 117*/ GIMT_Encode4(383161), GIMT_Encode4(0),
     /*   3002 */ /*AArch64::G_BSP*//*Label 118*/ GIMT_Encode4(383301),
     /*   3006 */ /*AArch64::G_DUP*//*Label 119*/ GIMT_Encode4(383841),
     /*   3010 */ /*AArch64::G_DUPLANE16*//*Label 120*/ GIMT_Encode4(385664),
     /*   3014 */ /*AArch64::G_DUPLANE32*//*Label 121*/ GIMT_Encode4(385919),
     /*   3018 */ /*AArch64::G_DUPLANE64*//*Label 122*/ GIMT_Encode4(386174),
     /*   3022 */ /*AArch64::G_DUPLANE8*//*Label 123*/ GIMT_Encode4(386320),
     /*   3026 */ /*AArch64::G_EXT*//*Label 124*/ GIMT_Encode4(386499),
     /*   3030 */ /*AArch64::G_FCMEQ*//*Label 125*/ GIMT_Encode4(388149),
     /*   3034 */ /*AArch64::G_FCMEQZ*//*Label 126*/ GIMT_Encode4(388488),
     /*   3038 */ /*AArch64::G_FCMGE*//*Label 127*/ GIMT_Encode4(388718),
     /*   3042 */ /*AArch64::G_FCMGEZ*//*Label 128*/ GIMT_Encode4(389382),
     /*   3046 */ /*AArch64::G_FCMGT*//*Label 129*/ GIMT_Encode4(389612),
     /*   3050 */ /*AArch64::G_FCMGTZ*//*Label 130*/ GIMT_Encode4(390276),
     /*   3054 */ /*AArch64::G_FCMLEZ*//*Label 131*/ GIMT_Encode4(390506),
     /*   3058 */ /*AArch64::G_FCMLTZ*//*Label 132*/ GIMT_Encode4(390736),
     /*   3062 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(390966),
     /*   3066 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(391120),
     /*   3070 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(391296),
     /*   3074 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(391570),
     /*   3078 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(391776),
     /*   3082 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(392175),
     /*   3086 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(392545),
     /*   3090 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(392662),
     /*   3094 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(393895),
     /*   3098 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(394675),
     /*   3102 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(395455),
     /*   3106 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(395661),
     /*   3110 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(396528),
     /*   3114 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(396898),
     /*   3118 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(397015),
     /*   3122 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(398248),
     /*   3126 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(399028),
     /*   3130 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(399808),
     /*   3134 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(400506),
     /*   3138 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(400962),
     /*   3142 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(401742),
     /*   3146 */ // Label 0: @3146
     /*   3146 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(34648),
     /*   3157 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3245),
     /*   3161 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(4768), GIMT_Encode4(0),
     /*   3169 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(9860),
     /*   3173 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(13468),
     /*   3177 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(19370),
     /*   3181 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(22868),
     /*   3185 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(29046),
     /*   3189 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(29896),
     /*   3193 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(33474), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3213 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(34198), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3225 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(34570), GIMT_Encode4(0),
     /*   3233 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(34596), GIMT_Encode4(0),
     /*   3241 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(34622),
     /*   3245 */ // Label 155: @3245
     /*   3245 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4767),
     /*   3250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3256 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3289), // Rule ID 12916 //
     /*   3261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3276 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3287 */     GIR_RootConstrainSelectedInstOperands,
     /*   3288 */     // GIR_Coverage, 12916,
     /*   3288 */     GIR_EraseRootFromParent_Done,
     /*   3289 */   // Label 170: @3289
     /*   3289 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3441), // Rule ID 13343 //
     /*   3294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3321 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3324 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3329 */     // MIs[2] pattern
     /*   3329 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3332 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3343 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3343 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3346 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3350 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3369 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3372 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3376 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3440 */     // GIR_Coverage, 13343,
     /*   3440 */     GIR_EraseRootFromParent_Done,
     /*   3441 */   // Label 171: @3441
     /*   3441 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3593), // Rule ID 15200 //
     /*   3446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3473 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3476 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3481 */     // MIs[2] pattern
     /*   3481 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3484 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3495 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3495 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3498 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3502 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3509 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3512 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3516 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3521 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3524 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3528 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3575 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3592 */     // GIR_Coverage, 15200,
     /*   3592 */     GIR_EraseRootFromParent_Done,
     /*   3593 */   // Label 172: @3593
     /*   3593 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3745), // Rule ID 15212 //
     /*   3598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3625 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3628 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3633 */     // MIs[2] pattern
     /*   3633 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3636 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3647 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3647 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3650 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3654 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3673 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3676 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3680 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3744 */     // GIR_Coverage, 15212,
     /*   3744 */     GIR_EraseRootFromParent_Done,
     /*   3745 */   // Label 173: @3745
     /*   3745 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3897), // Rule ID 15224 //
     /*   3750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3777 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3780 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3785 */     // MIs[2] pattern
     /*   3785 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3788 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3799 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3813 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3816 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3820 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3825 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3828 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3832 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3840 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3845 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   3857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3879 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3896 */     // GIR_Coverage, 15224,
     /*   3896 */     GIR_EraseRootFromParent_Done,
     /*   3897 */   // Label 174: @3897
     /*   3897 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3930), // Rule ID 91 //
     /*   3902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3917 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3928 */     GIR_RootConstrainSelectedInstOperands,
     /*   3929 */     // GIR_Coverage, 91,
     /*   3929 */     GIR_EraseRootFromParent_Done,
     /*   3930 */   // Label 175: @3930
     /*   3930 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4082), // Rule ID 2642 //
     /*   3935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3966 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3969 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3974 */     // MIs[2] pattern
     /*   3974 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3977 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3984 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4064 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4081 */     // GIR_Coverage, 2642,
     /*   4081 */     GIR_EraseRootFromParent_Done,
     /*   4082 */   // Label 176: @4082
     /*   4082 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4234), // Rule ID 9787 //
     /*   4087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4118 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4121 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4126 */     // MIs[2] pattern
     /*   4126 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4129 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4136 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4136 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4139 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4143 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4162 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4165 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4169 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4172 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4233 */     // GIR_Coverage, 9787,
     /*   4233 */     GIR_EraseRootFromParent_Done,
     /*   4234 */   // Label 177: @4234
     /*   4234 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4386), // Rule ID 9799 //
     /*   4239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4270 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4273 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4278 */     // MIs[2] pattern
     /*   4278 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4281 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4288 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4288 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4291 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4295 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4314 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4317 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4321 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4329 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4358 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4368 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4385 */     // GIR_Coverage, 9799,
     /*   4385 */     GIR_EraseRootFromParent_Done,
     /*   4386 */   // Label 178: @4386
     /*   4386 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4538), // Rule ID 9811 //
     /*   4391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4422 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4425 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4430 */     // MIs[2] pattern
     /*   4430 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4433 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4440 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4440 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4443 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4447 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4454 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4457 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4461 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4466 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4469 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4473 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4476 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4481 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4486 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4520 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4537 */     // GIR_Coverage, 9811,
     /*   4537 */     GIR_EraseRootFromParent_Done,
     /*   4538 */   // Label 179: @4538
     /*   4538 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4571), // Rule ID 12920 //
     /*   4543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4558 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4569 */     GIR_RootConstrainSelectedInstOperands,
     /*   4570 */     // GIR_Coverage, 12920,
     /*   4570 */     GIR_EraseRootFromParent_Done,
     /*   4571 */   // Label 180: @4571
     /*   4571 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4607), // Rule ID 13483 //
     /*   4576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4591 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4605 */     GIR_RootConstrainSelectedInstOperands,
     /*   4606 */     // GIR_Coverage, 13483,
     /*   4606 */     GIR_EraseRootFromParent_Done,
     /*   4607 */   // Label 181: @4607
     /*   4607 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4640), // Rule ID 97 //
     /*   4612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4627 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4638 */     GIR_RootConstrainSelectedInstOperands,
     /*   4639 */     // GIR_Coverage, 97,
     /*   4639 */     GIR_EraseRootFromParent_Done,
     /*   4640 */   // Label 182: @4640
     /*   4640 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4676), // Rule ID 3863 //
     /*   4645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4660 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4674 */     GIR_RootConstrainSelectedInstOperands,
     /*   4675 */     // GIR_Coverage, 3863,
     /*   4675 */     GIR_EraseRootFromParent_Done,
     /*   4676 */   // Label 183: @4676
     /*   4676 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4709), // Rule ID 12918 //
     /*   4681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4696 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4707 */     GIR_RootConstrainSelectedInstOperands,
     /*   4708 */     // GIR_Coverage, 12918,
     /*   4708 */     GIR_EraseRootFromParent_Done,
     /*   4709 */   // Label 184: @4709
     /*   4709 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4742), // Rule ID 95 //
     /*   4714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4729 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 95,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 185: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4766), // Rule ID 93 //
     /*   4747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4759 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   4759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   4764 */     GIR_RootConstrainSelectedInstOperands,
     /*   4765 */     // GIR_Coverage, 93,
     /*   4765 */     GIR_Done,
     /*   4766 */   // Label 186: @4766
     /*   4766 */   GIM_Reject,
     /*   4767 */ // Label 169: @4767
     /*   4767 */ GIM_Reject,
     /*   4768 */ // Label 156: @4768
     /*   4768 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(9859),
     /*   4773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   4776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   4779 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4915), // Rule ID 5313 //
     /*   4784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4817 */     // MIs[1] Operand 2
     /*   4817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4852 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4857 */     // MIs[3] Operand 2
     /*   4857 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   4868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   4870 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   4870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   4873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   4877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   4890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   4904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   4914 */     // GIR_Coverage, 5313,
     /*   4914 */     GIR_EraseRootFromParent_Done,
     /*   4915 */   // Label 188: @4915
     /*   4915 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5051), // Rule ID 5312 //
     /*   4920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4953 */     // MIs[1] Operand 2
     /*   4953 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4980 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   4984 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4988 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4993 */     // MIs[3] Operand 2
     /*   4993 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5004 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5006 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5033 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5050 */     // GIR_Coverage, 5312,
     /*   5050 */     GIR_EraseRootFromParent_Done,
     /*   5051 */   // Label 189: @5051
     /*   5051 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5187), // Rule ID 5322 //
     /*   5056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5089 */     // MIs[1] Operand 2
     /*   5089 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5120 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5124 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5129 */     // MIs[3] Operand 2
     /*   5129 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5142 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   5149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5169 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5186 */     // GIR_Coverage, 5322,
     /*   5186 */     GIR_EraseRootFromParent_Done,
     /*   5187 */   // Label 190: @5187
     /*   5187 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5323), // Rule ID 5311 //
     /*   5192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5225 */     // MIs[1] Operand 2
     /*   5225 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   5256 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5260 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5265 */     // MIs[3] Operand 2
     /*   5265 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5278 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5322 */     // GIR_Coverage, 5311,
     /*   5322 */     GIR_EraseRootFromParent_Done,
     /*   5323 */   // Label 191: @5323
     /*   5323 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5459), // Rule ID 5310 //
     /*   5328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5361 */     // MIs[1] Operand 2
     /*   5361 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5392 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5396 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5401 */     // MIs[3] Operand 2
     /*   5401 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5414 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5458 */     // GIR_Coverage, 5310,
     /*   5458 */     GIR_EraseRootFromParent_Done,
     /*   5459 */   // Label 192: @5459
     /*   5459 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5527), // Rule ID 6819 //
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5489 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   5493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5505 */     // MIs[2] Rn
     /*   5505 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5510 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   5514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5516 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 6819,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 193: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5595), // Rule ID 13644 //
     /*   5532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5557 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   5561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5573 */     // MIs[2] Rn
     /*   5573 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   5582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5584 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5593 */     GIR_RootConstrainSelectedInstOperands,
     /*   5594 */     // GIR_Coverage, 13644,
     /*   5594 */     GIR_EraseRootFromParent_Done,
     /*   5595 */   // Label 194: @5595
     /*   5595 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5628), // Rule ID 12917 //
     /*   5600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5615 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5622 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5626 */     GIR_RootConstrainSelectedInstOperands,
     /*   5627 */     // GIR_Coverage, 12917,
     /*   5627 */     GIR_EraseRootFromParent_Done,
     /*   5628 */   // Label 195: @5628
     /*   5628 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5761), // Rule ID 3915 //
     /*   5633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   5665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5670 */     // MIs[2] Operand 2
     /*   5670 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   5681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5689 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5693 */     // MIs[3] Operand 1
     /*   5693 */     // No operand predicates
     /*   5693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5699 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   5702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5711 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   5718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   5736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   5757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5759 */     GIR_RootConstrainSelectedInstOperands,
     /*   5760 */     // GIR_Coverage, 3915,
     /*   5760 */     GIR_EraseRootFromParent_Done,
     /*   5761 */   // Label 196: @5761
     /*   5761 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5856), // Rule ID 3913 //
     /*   5766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5811 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5815 */     // MIs[3] Operand 1
     /*   5815 */     // No operand predicates
     /*   5815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5821 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5833 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3913,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 197: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5951), // Rule ID 3914 //
     /*   5861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   5910 */     // MIs[3] Operand 1
     /*   5910 */     // No operand predicates
     /*   5910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5916 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5928 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   5938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5949 */     GIR_RootConstrainSelectedInstOperands,
     /*   5950 */     // GIR_Coverage, 3914,
     /*   5950 */     GIR_EraseRootFromParent_Done,
     /*   5951 */   // Label 198: @5951
     /*   5951 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5984), // Rule ID 92 //
     /*   5956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5971 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5982 */     GIR_RootConstrainSelectedInstOperands,
     /*   5983 */     // GIR_Coverage, 92,
     /*   5983 */     GIR_EraseRootFromParent_Done,
     /*   5984 */   // Label 199: @5984
     /*   5984 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6117), // Rule ID 13493 //
     /*   5989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   6025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6030 */     // MIs[2] Operand 2
     /*   6030 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   6041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6053 */     // MIs[3] Operand 1
     /*   6053 */     // No operand predicates
     /*   6053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6055 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   6058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6067 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   6074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   6092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   6113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6115 */     GIR_RootConstrainSelectedInstOperands,
     /*   6116 */     // GIR_Coverage, 13493,
     /*   6116 */     GIR_EraseRootFromParent_Done,
     /*   6117 */   // Label 200: @6117
     /*   6117 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6212), // Rule ID 13491 //
     /*   6122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6171 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6175 */     // MIs[3] Operand 1
     /*   6175 */     // No operand predicates
     /*   6175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6177 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6189 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6210 */     GIR_RootConstrainSelectedInstOperands,
     /*   6211 */     // GIR_Coverage, 13491,
     /*   6211 */     GIR_EraseRootFromParent_Done,
     /*   6212 */   // Label 201: @6212
     /*   6212 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6307), // Rule ID 13492 //
     /*   6217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6266 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   6270 */     // MIs[3] Operand 1
     /*   6270 */     // No operand predicates
     /*   6270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6272 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6284 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6305 */     GIR_RootConstrainSelectedInstOperands,
     /*   6306 */     // GIR_Coverage, 13492,
     /*   6306 */     GIR_EraseRootFromParent_Done,
     /*   6307 */   // Label 202: @6307
     /*   6307 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6389), // Rule ID 12928 //
     /*   6312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6361 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6372 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6387 */     GIR_RootConstrainSelectedInstOperands,
     /*   6388 */     // GIR_Coverage, 12928,
     /*   6388 */     GIR_EraseRootFromParent_Done,
     /*   6389 */   // Label 203: @6389
     /*   6389 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6471), // Rule ID 12929 //
     /*   6394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6443 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6454 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6469 */     GIR_RootConstrainSelectedInstOperands,
     /*   6470 */     // GIR_Coverage, 12929,
     /*   6470 */     GIR_EraseRootFromParent_Done,
     /*   6471 */   // Label 204: @6471
     /*   6471 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6553), // Rule ID 123 //
     /*   6476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6525 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6529 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6536 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6551 */     GIR_RootConstrainSelectedInstOperands,
     /*   6552 */     // GIR_Coverage, 123,
     /*   6552 */     GIR_EraseRootFromParent_Done,
     /*   6553 */   // Label 205: @6553
     /*   6553 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(6635), // Rule ID 125 //
     /*   6558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6618 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6633 */     GIR_RootConstrainSelectedInstOperands,
     /*   6634 */     // GIR_Coverage, 125,
     /*   6634 */     GIR_EraseRootFromParent_Done,
     /*   6635 */   // Label 206: @6635
     /*   6635 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6693), // Rule ID 13338 //
     /*   6640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6663 */     // MIs[1] pattern
     /*   6663 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6666 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6677 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6691 */     GIR_RootConstrainSelectedInstOperands,
     /*   6692 */     // GIR_Coverage, 13338,
     /*   6692 */     GIR_EraseRootFromParent_Done,
     /*   6693 */   // Label 207: @6693
     /*   6693 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6751), // Rule ID 15195 //
     /*   6698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6713 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6716 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6721 */     // MIs[1] pattern
     /*   6721 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6724 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6735 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6749 */     GIR_RootConstrainSelectedInstOperands,
     /*   6750 */     // GIR_Coverage, 15195,
     /*   6750 */     GIR_EraseRootFromParent_Done,
     /*   6751 */   // Label 208: @6751
     /*   6751 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6809), // Rule ID 15207 //
     /*   6756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6771 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6774 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   6779 */     // MIs[1] pattern
     /*   6779 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6782 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6793 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   6796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6807 */     GIR_RootConstrainSelectedInstOperands,
     /*   6808 */     // GIR_Coverage, 15207,
     /*   6808 */     GIR_EraseRootFromParent_Done,
     /*   6809 */   // Label 209: @6809
     /*   6809 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6867), // Rule ID 15219 //
     /*   6814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6829 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6832 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   6837 */     // MIs[1] pattern
     /*   6837 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6840 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6851 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6865 */     GIR_RootConstrainSelectedInstOperands,
     /*   6866 */     // GIR_Coverage, 15219,
     /*   6866 */     GIR_EraseRootFromParent_Done,
     /*   6867 */   // Label 210: @6867
     /*   6867 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6925), // Rule ID 2639 //
     /*   6872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6891 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6894 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6899 */     // MIs[1] pattern
     /*   6899 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6902 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6909 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6923 */     GIR_RootConstrainSelectedInstOperands,
     /*   6924 */     // GIR_Coverage, 2639,
     /*   6924 */     GIR_EraseRootFromParent_Done,
     /*   6925 */   // Label 211: @6925
     /*   6925 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6983), // Rule ID 9784 //
     /*   6930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6949 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6952 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6957 */     // MIs[1] pattern
     /*   6957 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6960 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6967 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6981 */     GIR_RootConstrainSelectedInstOperands,
     /*   6982 */     // GIR_Coverage, 9784,
     /*   6982 */     GIR_EraseRootFromParent_Done,
     /*   6983 */   // Label 212: @6983
     /*   6983 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7041), // Rule ID 9796 //
     /*   6988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7007 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7010 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   7015 */     // MIs[1] pattern
     /*   7015 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7018 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7025 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   7028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7039 */     GIR_RootConstrainSelectedInstOperands,
     /*   7040 */     // GIR_Coverage, 9796,
     /*   7040 */     GIR_EraseRootFromParent_Done,
     /*   7041 */   // Label 213: @7041
     /*   7041 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7099), // Rule ID 9808 //
     /*   7046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7065 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7068 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   7073 */     // MIs[1] pattern
     /*   7073 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7076 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7083 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   7086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7097 */     GIR_RootConstrainSelectedInstOperands,
     /*   7098 */     // GIR_Coverage, 9808,
     /*   7098 */     GIR_EraseRootFromParent_Done,
     /*   7099 */   // Label 214: @7099
     /*   7099 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7262), // Rule ID 13610 //
     /*   7104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7146 */     // MIs[1] Operand 2
     /*   7146 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7163 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7163 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7166 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7170 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7177 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7180 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7184 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7189 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7192 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7196 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   7221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7261 */     // GIR_Coverage, 13610,
     /*   7261 */     GIR_EraseRootFromParent_Done,
     /*   7262 */   // Label 215: @7262
     /*   7262 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(7425), // Rule ID 13607 //
     /*   7267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   7291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7309 */     // MIs[1] Operand 2
     /*   7309 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7326 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7326 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7329 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7333 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7352 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7359 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7367 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   7384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7389 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7424 */     // GIR_Coverage, 13607,
     /*   7424 */     GIR_EraseRootFromParent_Done,
     /*   7425 */   // Label 216: @7425
     /*   7425 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(7575), // Rule ID 13616 //
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7463 */     // MIs[1] Operand 2
     /*   7463 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7480 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7506 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7509 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7557 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7574 */     // GIR_Coverage, 13616,
     /*   7574 */     GIR_EraseRootFromParent_Done,
     /*   7575 */   // Label 217: @7575
     /*   7575 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(7725), // Rule ID 13619 //
     /*   7580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7613 */     // MIs[1] Operand 2
     /*   7613 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7630 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7656 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7663 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   7688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7707 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7724 */     // GIR_Coverage, 13619,
     /*   7724 */     GIR_EraseRootFromParent_Done,
     /*   7725 */   // Label 218: @7725
     /*   7725 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(7875), // Rule ID 13615 //
     /*   7730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7763 */     // MIs[1] Operand 2
     /*   7763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7780 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7780 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7783 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7787 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7794 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7797 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7801 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7806 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7809 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7813 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7857 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7874 */     // GIR_Coverage, 13615,
     /*   7874 */     GIR_EraseRootFromParent_Done,
     /*   7875 */   // Label 219: @7875
     /*   7875 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8038), // Rule ID 5295 //
     /*   7880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7926 */     // MIs[1] Operand 2
     /*   7926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7939 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7939 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7942 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7946 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7965 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7968 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   7972 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7975 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   7997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8037 */     // GIR_Coverage, 5295,
     /*   8037 */     GIR_EraseRootFromParent_Done,
     /*   8038 */   // Label 220: @8038
     /*   8038 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8201), // Rule ID 5292 //
     /*   8043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8089 */     // MIs[1] Operand 2
     /*   8089 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8102 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8102 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8105 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8109 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8128 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8131 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   8135 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8165 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8183 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8200 */     // GIR_Coverage, 5292,
     /*   8200 */     GIR_EraseRootFromParent_Done,
     /*   8201 */   // Label 221: @8201
     /*   8201 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8351), // Rule ID 5319 //
     /*   8206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8243 */     // MIs[1] Operand 2
     /*   8243 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8256 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8256 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8259 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8263 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8282 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8285 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8289 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8292 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8297 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8333 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8350 */     // GIR_Coverage, 5319,
     /*   8350 */     GIR_EraseRootFromParent_Done,
     /*   8351 */   // Label 222: @8351
     /*   8351 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8501), // Rule ID 5325 //
     /*   8356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8393 */     // MIs[1] Operand 2
     /*   8393 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8406 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8420 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8423 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8427 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8432 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8439 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8452 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   8464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8483 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8500 */     // GIR_Coverage, 5325,
     /*   8500 */     GIR_EraseRootFromParent_Done,
     /*   8501 */   // Label 223: @8501
     /*   8501 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8651), // Rule ID 5318 //
     /*   8506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8543 */     // MIs[1] Operand 2
     /*   8543 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8556 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8556 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8559 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8563 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8582 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8585 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8589 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8650 */     // GIR_Coverage, 5318,
     /*   8650 */     GIR_EraseRootFromParent_Done,
     /*   8651 */   // Label 224: @8651
     /*   8651 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8684), // Rule ID 12921 //
     /*   8656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8671 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8682 */     GIR_RootConstrainSelectedInstOperands,
     /*   8683 */     // GIR_Coverage, 12921,
     /*   8683 */     GIR_EraseRootFromParent_Done,
     /*   8684 */   // Label 225: @8684
     /*   8684 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8720), // Rule ID 13484 //
     /*   8689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8704 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8718 */     GIR_RootConstrainSelectedInstOperands,
     /*   8719 */     // GIR_Coverage, 13484,
     /*   8719 */     GIR_EraseRootFromParent_Done,
     /*   8720 */   // Label 226: @8720
     /*   8720 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8753), // Rule ID 98 //
     /*   8725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8740 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8751 */     GIR_RootConstrainSelectedInstOperands,
     /*   8752 */     // GIR_Coverage, 98,
     /*   8752 */     GIR_EraseRootFromParent_Done,
     /*   8753 */   // Label 227: @8753
     /*   8753 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(8789), // Rule ID 3864 //
     /*   8758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8773 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8787 */     GIR_RootConstrainSelectedInstOperands,
     /*   8788 */     // GIR_Coverage, 3864,
     /*   8788 */     GIR_EraseRootFromParent_Done,
     /*   8789 */   // Label 228: @8789
     /*   8789 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(8822), // Rule ID 12919 //
     /*   8794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8809 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8820 */     GIR_RootConstrainSelectedInstOperands,
     /*   8821 */     // GIR_Coverage, 12919,
     /*   8821 */     GIR_EraseRootFromParent_Done,
     /*   8822 */   // Label 229: @8822
     /*   8822 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(8855), // Rule ID 96 //
     /*   8827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8842 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8853 */     GIR_RootConstrainSelectedInstOperands,
     /*   8854 */     // GIR_Coverage, 96,
     /*   8854 */     GIR_EraseRootFromParent_Done,
     /*   8855 */   // Label 230: @8855
     /*   8855 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(8911), // Rule ID 13027 //
     /*   8860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8875 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8878 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   8883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8898 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   8901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8909 */     GIR_RootConstrainSelectedInstOperands,
     /*   8910 */     // GIR_Coverage, 13027,
     /*   8910 */     GIR_EraseRootFromParent_Done,
     /*   8911 */   // Label 231: @8911
     /*   8911 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(8967), // Rule ID 13039 //
     /*   8916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   8939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8954 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   8957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8965 */     GIR_RootConstrainSelectedInstOperands,
     /*   8966 */     // GIR_Coverage, 13039,
     /*   8966 */     GIR_EraseRootFromParent_Done,
     /*   8967 */   // Label 232: @8967
     /*   8967 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9034), // Rule ID 13245 //
     /*   8972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   8987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8996 */     // MIs[1] imm
     /*   8996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9004 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9008 */     // MIs[2] Operand 1
     /*   9008 */     // No operand predicates
     /*   9008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9018 */     // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9032 */     GIR_RootConstrainSelectedInstOperands,
     /*   9033 */     // GIR_Coverage, 13245,
     /*   9033 */     GIR_EraseRootFromParent_Done,
     /*   9034 */   // Label 233: @9034
     /*   9034 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9101), // Rule ID 13633 //
     /*   9039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9063 */     // MIs[1] imm
     /*   9063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9075 */     // MIs[2] Operand 1
     /*   9075 */     // No operand predicates
     /*   9075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9085 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9099 */     GIR_RootConstrainSelectedInstOperands,
     /*   9100 */     // GIR_Coverage, 13633,
     /*   9100 */     GIR_EraseRootFromParent_Done,
     /*   9101 */   // Label 234: @9101
     /*   9101 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(9168), // Rule ID 13248 //
     /*   9106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9130 */     // MIs[1] imm
     /*   9130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9138 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9142 */     // MIs[2] Operand 1
     /*   9142 */     // No operand predicates
     /*   9142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9152 */     // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9166 */     GIR_RootConstrainSelectedInstOperands,
     /*   9167 */     // GIR_Coverage, 13248,
     /*   9167 */     GIR_EraseRootFromParent_Done,
     /*   9168 */   // Label 235: @9168
     /*   9168 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(9235), // Rule ID 13636 //
     /*   9173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9197 */     // MIs[1] imm
     /*   9197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9205 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9209 */     // MIs[2] Operand 1
     /*   9209 */     // No operand predicates
     /*   9209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9219 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9233 */     GIR_RootConstrainSelectedInstOperands,
     /*   9234 */     // GIR_Coverage, 13636,
     /*   9234 */     GIR_EraseRootFromParent_Done,
     /*   9235 */   // Label 236: @9235
     /*   9235 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(9291), // Rule ID 990 //
     /*   9240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9259 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9262 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   9267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9278 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9289 */     GIR_RootConstrainSelectedInstOperands,
     /*   9290 */     // GIR_Coverage, 990,
     /*   9290 */     GIR_EraseRootFromParent_Done,
     /*   9291 */   // Label 237: @9291
     /*   9291 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(9347), // Rule ID 1051 //
     /*   9296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9315 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9318 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   9323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9334 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9345 */     GIR_RootConstrainSelectedInstOperands,
     /*   9346 */     // GIR_Coverage, 1051,
     /*   9346 */     GIR_EraseRootFromParent_Done,
     /*   9347 */   // Label 238: @9347
     /*   9347 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(9414), // Rule ID 2112 //
     /*   9352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9380 */     // MIs[1] imm
     /*   9380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9392 */     // MIs[2] Operand 1
     /*   9392 */     // No operand predicates
     /*   9392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9398 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9412 */     GIR_RootConstrainSelectedInstOperands,
     /*   9413 */     // GIR_Coverage, 2112,
     /*   9413 */     GIR_EraseRootFromParent_Done,
     /*   9414 */   // Label 239: @9414
     /*   9414 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(9481), // Rule ID 6197 //
     /*   9419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9447 */     // MIs[1] imm
     /*   9447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9459 */     // MIs[2] Operand 1
     /*   9459 */     // No operand predicates
     /*   9459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9465 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9479 */     GIR_RootConstrainSelectedInstOperands,
     /*   9480 */     // GIR_Coverage, 6197,
     /*   9480 */     GIR_EraseRootFromParent_Done,
     /*   9481 */   // Label 240: @9481
     /*   9481 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(9548), // Rule ID 2121 //
     /*   9486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9514 */     // MIs[1] imm
     /*   9514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9526 */     // MIs[2] Operand 1
     /*   9526 */     // No operand predicates
     /*   9526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9532 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9546 */     GIR_RootConstrainSelectedInstOperands,
     /*   9547 */     // GIR_Coverage, 2121,
     /*   9547 */     GIR_EraseRootFromParent_Done,
     /*   9548 */   // Label 241: @9548
     /*   9548 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(9615), // Rule ID 6203 //
     /*   9553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9581 */     // MIs[1] imm
     /*   9581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9593 */     // MIs[2] Operand 1
     /*   9593 */     // No operand predicates
     /*   9593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9599 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9613 */     GIR_RootConstrainSelectedInstOperands,
     /*   9614 */     // GIR_Coverage, 6203,
     /*   9614 */     GIR_EraseRootFromParent_Done,
     /*   9615 */   // Label 242: @9615
     /*   9615 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(9663), // Rule ID 13026 //
     /*   9620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9650 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9661 */     GIR_RootConstrainSelectedInstOperands,
     /*   9662 */     // GIR_Coverage, 13026,
     /*   9662 */     GIR_EraseRootFromParent_Done,
     /*   9663 */   // Label 243: @9663
     /*   9663 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(9711), // Rule ID 13038 //
     /*   9668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9698 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9709 */     GIR_RootConstrainSelectedInstOperands,
     /*   9710 */     // GIR_Coverage, 13038,
     /*   9710 */     GIR_EraseRootFromParent_Done,
     /*   9711 */   // Label 244: @9711
     /*   9711 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(9759), // Rule ID 989 //
     /*   9716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9746 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9757 */     GIR_RootConstrainSelectedInstOperands,
     /*   9758 */     // GIR_Coverage, 989,
     /*   9758 */     GIR_EraseRootFromParent_Done,
     /*   9759 */   // Label 245: @9759
     /*   9759 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(9807), // Rule ID 1050 //
     /*   9764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9794 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9805 */     GIR_RootConstrainSelectedInstOperands,
     /*   9806 */     // GIR_Coverage, 1050,
     /*   9806 */     GIR_EraseRootFromParent_Done,
     /*   9807 */   // Label 246: @9807
     /*   9807 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(9831), // Rule ID 94 //
     /*   9812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9824 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*   9824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*   9829 */     GIR_RootConstrainSelectedInstOperands,
     /*   9830 */     // GIR_Coverage, 94,
     /*   9830 */     GIR_Done,
     /*   9831 */   // Label 247: @9831
     /*   9831 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(9858), // Rule ID 1600 //
     /*   9836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9851 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*   9851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*   9856 */     GIR_RootConstrainSelectedInstOperands,
     /*   9857 */     // GIR_Coverage, 1600,
     /*   9857 */     GIR_Done,
     /*   9858 */   // Label 248: @9858
     /*   9858 */   GIM_Reject,
     /*   9859 */ // Label 187: @9859
     /*   9859 */ GIM_Reject,
     /*   9860 */ // Label 157: @9860
     /*   9860 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(13467),
     /*   9865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9871 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10059), // Rule ID 6840 //
     /*   9876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*   9888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9913 */     // MIs[2] Operand 2
     /*   9913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*   9924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   9928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9932 */     // MIs[3] Rn
     /*   9932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9937 */     // MIs[3] Operand 2
     /*   9937 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*   9948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   9952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*   9956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9960 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9964 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9968 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9972 */     // MIs[5] Rn
     /*   9972 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9977 */     // MIs[5] Operand 2
     /*   9977 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*   9988 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*   9992 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9996 */     // MIs[6] Rn
     /*   9996 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10001 */     // MIs[6] Operand 2
     /*  10001 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10012 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10014 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10058 */     // GIR_Coverage, 6840,
     /*  10058 */     GIR_EraseRootFromParent_Done,
     /*  10059 */   // Label 250: @10059
     /*  10059 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10247), // Rule ID 13655 //
     /*  10064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  10076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10101 */     // MIs[2] Operand 2
     /*  10101 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  10112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  10116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10120 */     // MIs[3] Rn
     /*  10120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10125 */     // MIs[3] Operand 2
     /*  10125 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  10136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  10140 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  10144 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10148 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10152 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10156 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10160 */     // MIs[5] Rn
     /*  10160 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10165 */     // MIs[5] Operand 2
     /*  10165 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10176 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10180 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10184 */     // MIs[6] Rn
     /*  10184 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10189 */     // MIs[6] Operand 2
     /*  10189 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10200 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10202 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10246 */     // GIR_Coverage, 13655,
     /*  10246 */     GIR_EraseRootFromParent_Done,
     /*  10247 */   // Label 251: @10247
     /*  10247 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(10383), // Rule ID 5309 //
     /*  10252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10285 */     // MIs[1] Operand 2
     /*  10285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10316 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10320 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10325 */     // MIs[3] Operand 2
     /*  10325 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10336 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10338 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10382 */     // GIR_Coverage, 5309,
     /*  10382 */     GIR_EraseRootFromParent_Done,
     /*  10383 */   // Label 252: @10383
     /*  10383 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(10519), // Rule ID 5308 //
     /*  10388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10421 */     // MIs[1] Operand 2
     /*  10421 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10452 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10456 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10461 */     // MIs[3] Operand 2
     /*  10461 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10474 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10518 */     // GIR_Coverage, 5308,
     /*  10518 */     GIR_EraseRootFromParent_Done,
     /*  10519 */   // Label 253: @10519
     /*  10519 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(10655), // Rule ID 5321 //
     /*  10524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10557 */     // MIs[1] Operand 2
     /*  10557 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10576 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10584 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10588 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10592 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10597 */     // MIs[3] Operand 2
     /*  10597 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10608 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10610 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  10617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10637 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10654 */     // GIR_Coverage, 5321,
     /*  10654 */     GIR_EraseRootFromParent_Done,
     /*  10655 */   // Label 254: @10655
     /*  10655 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(10791), // Rule ID 5307 //
     /*  10660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10693 */     // MIs[1] Operand 2
     /*  10693 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10724 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10728 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10733 */     // MIs[3] Operand 2
     /*  10733 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10744 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10746 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10773 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10790 */     // GIR_Coverage, 5307,
     /*  10790 */     GIR_EraseRootFromParent_Done,
     /*  10791 */   // Label 255: @10791
     /*  10791 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(10927), // Rule ID 5306 //
     /*  10796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10829 */     // MIs[1] Operand 2
     /*  10829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10869 */     // MIs[3] Operand 2
     /*  10869 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10882 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10926 */     // GIR_Coverage, 5306,
     /*  10926 */     GIR_EraseRootFromParent_Done,
     /*  10927 */   // Label 256: @10927
     /*  10927 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11090), // Rule ID 13609 //
     /*  10932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  10956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  10964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10974 */     // MIs[1] Operand 2
     /*  10974 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10991 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10991 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  10994 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10998 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11005 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11008 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11012 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11017 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11020 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11024 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11072 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11089 */     // GIR_Coverage, 13609,
     /*  11089 */     GIR_EraseRootFromParent_Done,
     /*  11090 */   // Label 257: @11090
     /*  11090 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11253), // Rule ID 13606 //
     /*  11095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     // MIs[1] Operand 2
     /*  11137 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11154 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11154 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11157 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11161 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11168 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11171 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11175 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11180 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11187 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11195 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  11212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11252 */     // GIR_Coverage, 13606,
     /*  11252 */     GIR_EraseRootFromParent_Done,
     /*  11253 */   // Label 258: @11253
     /*  11253 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11403), // Rule ID 13614 //
     /*  11258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11291 */     // MIs[1] Operand 2
     /*  11291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11308 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11308 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11311 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11315 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11334 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11337 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11341 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11385 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11402 */     // GIR_Coverage, 13614,
     /*  11402 */     GIR_EraseRootFromParent_Done,
     /*  11403 */   // Label 259: @11403
     /*  11403 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11553), // Rule ID 13618 //
     /*  11408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11441 */     // MIs[1] Operand 2
     /*  11441 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11458 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11484 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  11516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11552 */     // GIR_Coverage, 13618,
     /*  11552 */     GIR_EraseRootFromParent_Done,
     /*  11553 */   // Label 260: @11553
     /*  11553 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11703), // Rule ID 13613 //
     /*  11558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11591 */     // MIs[1] Operand 2
     /*  11591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11608 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11608 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11611 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11615 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11634 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11637 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11641 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11649 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11654 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11671 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11702 */     // GIR_Coverage, 13613,
     /*  11702 */     GIR_EraseRootFromParent_Done,
     /*  11703 */   // Label 261: @11703
     /*  11703 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11866), // Rule ID 5294 //
     /*  11708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  11736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11754 */     // MIs[1] Operand 2
     /*  11754 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11767 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11865 */     // GIR_Coverage, 5294,
     /*  11865 */     GIR_EraseRootFromParent_Done,
     /*  11866 */   // Label 262: @11866
     /*  11866 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12029), // Rule ID 5291 //
     /*  11871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11917 */     // MIs[1] Operand 2
     /*  11917 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11930 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11933 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11937 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11956 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  11988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11993 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12028 */     // GIR_Coverage, 5291,
     /*  12028 */     GIR_EraseRootFromParent_Done,
     /*  12029 */   // Label 263: @12029
     /*  12029 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12179), // Rule ID 5317 //
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12071 */     // MIs[1] Operand 2
     /*  12071 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12084 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12110 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12117 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12178 */     // GIR_Coverage, 5317,
     /*  12178 */     GIR_EraseRootFromParent_Done,
     /*  12179 */   // Label 264: @12179
     /*  12179 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12329), // Rule ID 5324 //
     /*  12184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12221 */     // MIs[1] Operand 2
     /*  12221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12234 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12234 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12237 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12241 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12260 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  12292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12311 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12328 */     // GIR_Coverage, 5324,
     /*  12328 */     GIR_EraseRootFromParent_Done,
     /*  12329 */   // Label 265: @12329
     /*  12329 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12479), // Rule ID 5316 //
     /*  12334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12371 */     // MIs[1] Operand 2
     /*  12371 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12384 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12384 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12387 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12391 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12410 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12417 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12461 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12478 */     // GIR_Coverage, 5316,
     /*  12478 */     GIR_EraseRootFromParent_Done,
     /*  12479 */   // Label 266: @12479
     /*  12479 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12548), // Rule ID 13061 //
     /*  12484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12499 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12502 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12511 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12531 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12546 */     GIR_RootConstrainSelectedInstOperands,
     /*  12547 */     // GIR_Coverage, 13061,
     /*  12547 */     GIR_EraseRootFromParent_Done,
     /*  12548 */   // Label 267: @12548
     /*  12548 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12617), // Rule ID 13073 //
     /*  12553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12568 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12571 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12600 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  12603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12615 */     GIR_RootConstrainSelectedInstOperands,
     /*  12616 */     // GIR_Coverage, 13073,
     /*  12616 */     GIR_EraseRootFromParent_Done,
     /*  12617 */   // Label 268: @12617
     /*  12617 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12673), // Rule ID 13023 //
     /*  12622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12637 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12640 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  12645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12660 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  12663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12671 */     GIR_RootConstrainSelectedInstOperands,
     /*  12672 */     // GIR_Coverage, 13023,
     /*  12672 */     GIR_EraseRootFromParent_Done,
     /*  12673 */   // Label 269: @12673
     /*  12673 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12729), // Rule ID 13035 //
     /*  12678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12693 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12696 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  12701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12716 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  12719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12727 */     GIR_RootConstrainSelectedInstOperands,
     /*  12728 */     // GIR_Coverage, 13035,
     /*  12728 */     GIR_EraseRootFromParent_Done,
     /*  12729 */   // Label 270: @12729
     /*  12729 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12796), // Rule ID 13265 //
     /*  12734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  12749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12758 */     // MIs[1] imm
     /*  12758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12766 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12770 */     // MIs[2] Operand 1
     /*  12770 */     // No operand predicates
     /*  12770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12780 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  12783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12794 */     GIR_RootConstrainSelectedInstOperands,
     /*  12795 */     // GIR_Coverage, 13265,
     /*  12795 */     GIR_EraseRootFromParent_Done,
     /*  12796 */   // Label 271: @12796
     /*  12796 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12863), // Rule ID 13286 //
     /*  12801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  12816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12825 */     // MIs[1] imm
     /*  12825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12837 */     // MIs[2] Operand 1
     /*  12837 */     // No operand predicates
     /*  12837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12847 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  12850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12861 */     GIR_RootConstrainSelectedInstOperands,
     /*  12862 */     // GIR_Coverage, 13286,
     /*  12862 */     GIR_EraseRootFromParent_Done,
     /*  12863 */   // Label 272: @12863
     /*  12863 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12932), // Rule ID 1358 //
     /*  12868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12887 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12890 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12899 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12915 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12930 */     GIR_RootConstrainSelectedInstOperands,
     /*  12931 */     // GIR_Coverage, 1358,
     /*  12931 */     GIR_EraseRootFromParent_Done,
     /*  12932 */   // Label 273: @12932
     /*  12932 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13001), // Rule ID 1481 //
     /*  12937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12956 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12959 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12968 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12984 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  12987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12999 */     GIR_RootConstrainSelectedInstOperands,
     /*  13000 */     // GIR_Coverage, 1481,
     /*  13000 */     GIR_EraseRootFromParent_Done,
     /*  13001 */   // Label 274: @13001
     /*  13001 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13057), // Rule ID 986 //
     /*  13006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13025 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13028 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  13033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13044 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13055 */     GIR_RootConstrainSelectedInstOperands,
     /*  13056 */     // GIR_Coverage, 986,
     /*  13056 */     GIR_EraseRootFromParent_Done,
     /*  13057 */   // Label 275: @13057
     /*  13057 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13113), // Rule ID 1047 //
     /*  13062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13081 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13084 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  13089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13100 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13111 */     GIR_RootConstrainSelectedInstOperands,
     /*  13112 */     // GIR_Coverage, 1047,
     /*  13112 */     GIR_EraseRootFromParent_Done,
     /*  13113 */   // Label 276: @13113
     /*  13113 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13180), // Rule ID 2229 //
     /*  13118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  13137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13146 */     // MIs[1] imm
     /*  13146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13158 */     // MIs[2] Operand 1
     /*  13158 */     // No operand predicates
     /*  13158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13164 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  13167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13178 */     GIR_RootConstrainSelectedInstOperands,
     /*  13179 */     // GIR_Coverage, 2229,
     /*  13179 */     GIR_EraseRootFromParent_Done,
     /*  13180 */   // Label 277: @13180
     /*  13180 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13247), // Rule ID 2288 //
     /*  13185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  13204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13213 */     // MIs[1] imm
     /*  13213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13225 */     // MIs[2] Operand 1
     /*  13225 */     // No operand predicates
     /*  13225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13231 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  13234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13245 */     GIR_RootConstrainSelectedInstOperands,
     /*  13246 */     // GIR_Coverage, 2288,
     /*  13246 */     GIR_EraseRootFromParent_Done,
     /*  13247 */   // Label 278: @13247
     /*  13247 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13295), // Rule ID 13022 //
     /*  13252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13282 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13293 */     GIR_RootConstrainSelectedInstOperands,
     /*  13294 */     // GIR_Coverage, 13022,
     /*  13294 */     GIR_EraseRootFromParent_Done,
     /*  13295 */   // Label 279: @13295
     /*  13295 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13343), // Rule ID 13034 //
     /*  13300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13330 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13341 */     GIR_RootConstrainSelectedInstOperands,
     /*  13342 */     // GIR_Coverage, 13034,
     /*  13342 */     GIR_EraseRootFromParent_Done,
     /*  13343 */   // Label 280: @13343
     /*  13343 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13391), // Rule ID 985 //
     /*  13348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13378 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13389 */     GIR_RootConstrainSelectedInstOperands,
     /*  13390 */     // GIR_Coverage, 985,
     /*  13390 */     GIR_EraseRootFromParent_Done,
     /*  13391 */   // Label 281: @13391
     /*  13391 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13439), // Rule ID 1046 //
     /*  13396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13426 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13437 */     GIR_RootConstrainSelectedInstOperands,
     /*  13438 */     // GIR_Coverage, 1046,
     /*  13438 */     GIR_EraseRootFromParent_Done,
     /*  13439 */   // Label 282: @13439
     /*  13439 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13466), // Rule ID 1097 //
     /*  13444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13459 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  13464 */     GIR_RootConstrainSelectedInstOperands,
     /*  13465 */     // GIR_Coverage, 1097,
     /*  13465 */     GIR_Done,
     /*  13466 */   // Label 283: @13466
     /*  13466 */   GIM_Reject,
     /*  13467 */ // Label 249: @13467
     /*  13467 */ GIM_Reject,
     /*  13468 */ // Label 158: @13468
     /*  13468 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(19369),
     /*  13473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  13476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  13479 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13597), // Rule ID 13200 //
     /*  13484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13531 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13544 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13548 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13552 */     // MIs[4] Operand 1
     /*  13552 */     // No operand predicates
     /*  13552 */     // MIs[2] Operand 2
     /*  13552 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13567 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13576 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13595 */     GIR_RootConstrainSelectedInstOperands,
     /*  13596 */     // GIR_Coverage, 13200,
     /*  13596 */     GIR_EraseRootFromParent_Done,
     /*  13597 */   // Label 285: @13597
     /*  13597 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13715), // Rule ID 13201 //
     /*  13602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13649 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13662 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13666 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13670 */     // MIs[4] Operand 1
     /*  13670 */     // No operand predicates
     /*  13670 */     // MIs[2] Operand 2
     /*  13670 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13694 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13713 */     GIR_RootConstrainSelectedInstOperands,
     /*  13714 */     // GIR_Coverage, 13201,
     /*  13714 */     GIR_EraseRootFromParent_Done,
     /*  13715 */   // Label 286: @13715
     /*  13715 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13833), // Rule ID 13230 //
     /*  13720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13767 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13776 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13780 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13784 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13788 */     // MIs[4] Operand 1
     /*  13788 */     // No operand predicates
     /*  13788 */     // MIs[2] Operand 2
     /*  13788 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13803 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13812 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13831 */     GIR_RootConstrainSelectedInstOperands,
     /*  13832 */     // GIR_Coverage, 13230,
     /*  13832 */     GIR_EraseRootFromParent_Done,
     /*  13833 */   // Label 287: @13833
     /*  13833 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13951), // Rule ID 13231 //
     /*  13838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13881 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13885 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13889 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13898 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13902 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13906 */     // MIs[4] Operand 1
     /*  13906 */     // No operand predicates
     /*  13906 */     // MIs[2] Operand 2
     /*  13906 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13921 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13930 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13949 */     GIR_RootConstrainSelectedInstOperands,
     /*  13950 */     // GIR_Coverage, 13231,
     /*  13950 */     GIR_EraseRootFromParent_Done,
     /*  13951 */   // Label 288: @13951
     /*  13951 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14069), // Rule ID 2035 //
     /*  13956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14003 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14011 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14020 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14024 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14028 */     // MIs[4] Operand 1
     /*  14028 */     // No operand predicates
     /*  14028 */     // MIs[2] Operand 2
     /*  14028 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14039 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14048 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14067 */     GIR_RootConstrainSelectedInstOperands,
     /*  14068 */     // GIR_Coverage, 2035,
     /*  14068 */     GIR_EraseRootFromParent_Done,
     /*  14069 */   // Label 289: @14069
     /*  14069 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14187), // Rule ID 13199 //
     /*  14074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14121 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14125 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14129 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14142 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14146 */     // MIs[4] Operand 1
     /*  14146 */     // No operand predicates
     /*  14146 */     // MIs[2] Operand 2
     /*  14146 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14157 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14166 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14185 */     GIR_RootConstrainSelectedInstOperands,
     /*  14186 */     // GIR_Coverage, 13199,
     /*  14186 */     GIR_EraseRootFromParent_Done,
     /*  14187 */   // Label 290: @14187
     /*  14187 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14305), // Rule ID 2087 //
     /*  14192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14243 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14252 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14256 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14260 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14264 */     // MIs[4] Operand 1
     /*  14264 */     // No operand predicates
     /*  14264 */     // MIs[2] Operand 2
     /*  14264 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14275 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14284 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14303 */     GIR_RootConstrainSelectedInstOperands,
     /*  14304 */     // GIR_Coverage, 2087,
     /*  14304 */     GIR_EraseRootFromParent_Done,
     /*  14305 */   // Label 291: @14305
     /*  14305 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14423), // Rule ID 13229 //
     /*  14310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14370 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14374 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14378 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14382 */     // MIs[4] Operand 1
     /*  14382 */     // No operand predicates
     /*  14382 */     // MIs[2] Operand 2
     /*  14382 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14393 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14402 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14421 */     GIR_RootConstrainSelectedInstOperands,
     /*  14422 */     // GIR_Coverage, 13229,
     /*  14422 */     GIR_EraseRootFromParent_Done,
     /*  14423 */   // Label 292: @14423
     /*  14423 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14510), // Rule ID 13105 //
     /*  14428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14455 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14458 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14467 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14491 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14508 */     GIR_RootConstrainSelectedInstOperands,
     /*  14509 */     // GIR_Coverage, 13105,
     /*  14509 */     GIR_EraseRootFromParent_Done,
     /*  14510 */   // Label 293: @14510
     /*  14510 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14597), // Rule ID 13129 //
     /*  14515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14542 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14545 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14554 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14578 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14595 */     GIR_RootConstrainSelectedInstOperands,
     /*  14596 */     // GIR_Coverage, 13129,
     /*  14596 */     GIR_EraseRootFromParent_Done,
     /*  14597 */   // Label 294: @14597
     /*  14597 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(14684), // Rule ID 1692 //
     /*  14602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14633 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14636 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14645 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14665 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14682 */     GIR_RootConstrainSelectedInstOperands,
     /*  14683 */     // GIR_Coverage, 1692,
     /*  14683 */     GIR_EraseRootFromParent_Done,
     /*  14684 */   // Label 295: @14684
     /*  14684 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(14771), // Rule ID 1770 //
     /*  14689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14720 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14723 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14732 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14752 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14769 */     GIR_RootConstrainSelectedInstOperands,
     /*  14770 */     // GIR_Coverage, 1770,
     /*  14770 */     GIR_EraseRootFromParent_Done,
     /*  14771 */   // Label 296: @14771
     /*  14771 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(14886), // Rule ID 13195 //
     /*  14776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14819 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14823 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14827 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14836 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14840 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14844 */     // MIs[4] Operand 1
     /*  14844 */     // No operand predicates
     /*  14844 */     // MIs[2] Operand 2
     /*  14844 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14866 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  14869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14884 */     GIR_RootConstrainSelectedInstOperands,
     /*  14885 */     // GIR_Coverage, 13195,
     /*  14885 */     GIR_EraseRootFromParent_Done,
     /*  14886 */   // Label 297: @14886
     /*  14886 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15001), // Rule ID 13194 //
     /*  14891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14939 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14943 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14947 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14956 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14960 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14964 */     // MIs[4] Operand 1
     /*  14964 */     // No operand predicates
     /*  14964 */     // MIs[2] Operand 2
     /*  14964 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14979 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14981 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  14984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14999 */     GIR_RootConstrainSelectedInstOperands,
     /*  15000 */     // GIR_Coverage, 13194,
     /*  15000 */     GIR_EraseRootFromParent_Done,
     /*  15001 */   // Label 298: @15001
     /*  15001 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15116), // Rule ID 13225 //
     /*  15006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15049 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15053 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15057 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15062 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15066 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15070 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15074 */     // MIs[4] Operand 1
     /*  15074 */     // No operand predicates
     /*  15074 */     // MIs[2] Operand 2
     /*  15074 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15096 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15114 */     GIR_RootConstrainSelectedInstOperands,
     /*  15115 */     // GIR_Coverage, 13225,
     /*  15115 */     GIR_EraseRootFromParent_Done,
     /*  15116 */   // Label 299: @15116
     /*  15116 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15231), // Rule ID 13224 //
     /*  15121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15169 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15173 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15177 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15186 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15190 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15194 */     // MIs[4] Operand 1
     /*  15194 */     // No operand predicates
     /*  15194 */     // MIs[2] Operand 2
     /*  15194 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15211 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15229 */     GIR_RootConstrainSelectedInstOperands,
     /*  15230 */     // GIR_Coverage, 13224,
     /*  15230 */     GIR_EraseRootFromParent_Done,
     /*  15231 */   // Label 300: @15231
     /*  15231 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15300), // Rule ID 1794 //
     /*  15236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15283 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15298 */     GIR_RootConstrainSelectedInstOperands,
     /*  15299 */     // GIR_Coverage, 1794,
     /*  15299 */     GIR_EraseRootFromParent_Done,
     /*  15300 */   // Label 301: @15300
     /*  15300 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15369), // Rule ID 1793 //
     /*  15305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15352 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15367 */     GIR_RootConstrainSelectedInstOperands,
     /*  15368 */     // GIR_Coverage, 1793,
     /*  15368 */     GIR_EraseRootFromParent_Done,
     /*  15369 */   // Label 302: @15369
     /*  15369 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15438), // Rule ID 1710 //
     /*  15374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15421 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  15424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15436 */     GIR_RootConstrainSelectedInstOperands,
     /*  15437 */     // GIR_Coverage, 1710,
     /*  15437 */     GIR_EraseRootFromParent_Done,
     /*  15438 */   // Label 303: @15438
     /*  15438 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15507), // Rule ID 1792 //
     /*  15443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15490 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15505 */     GIR_RootConstrainSelectedInstOperands,
     /*  15506 */     // GIR_Coverage, 1792,
     /*  15506 */     GIR_EraseRootFromParent_Done,
     /*  15507 */   // Label 304: @15507
     /*  15507 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15576), // Rule ID 1791 //
     /*  15512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15559 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15574 */     GIR_RootConstrainSelectedInstOperands,
     /*  15575 */     // GIR_Coverage, 1791,
     /*  15575 */     GIR_EraseRootFromParent_Done,
     /*  15576 */   // Label 305: @15576
     /*  15576 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15691), // Rule ID 13193 //
     /*  15581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15636 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15649 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15653 */     // MIs[4] Operand 1
     /*  15653 */     // No operand predicates
     /*  15653 */     // MIs[2] Operand 2
     /*  15653 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15671 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15689 */     GIR_RootConstrainSelectedInstOperands,
     /*  15690 */     // GIR_Coverage, 13193,
     /*  15690 */     GIR_EraseRootFromParent_Done,
     /*  15691 */   // Label 306: @15691
     /*  15691 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15806), // Rule ID 2033 //
     /*  15696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15756 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15769 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15773 */     // MIs[4] Operand 1
     /*  15773 */     // No operand predicates
     /*  15773 */     // MIs[2] Operand 2
     /*  15773 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15784 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15786 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15804 */     GIR_RootConstrainSelectedInstOperands,
     /*  15805 */     // GIR_Coverage, 2033,
     /*  15805 */     GIR_EraseRootFromParent_Done,
     /*  15806 */   // Label 307: @15806
     /*  15806 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(15921), // Rule ID 13223 //
     /*  15811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15866 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15879 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15883 */     // MIs[4] Operand 1
     /*  15883 */     // No operand predicates
     /*  15883 */     // MIs[2] Operand 2
     /*  15883 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15899 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15901 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15919 */     GIR_RootConstrainSelectedInstOperands,
     /*  15920 */     // GIR_Coverage, 13223,
     /*  15920 */     GIR_EraseRootFromParent_Done,
     /*  15921 */   // Label 308: @15921
     /*  15921 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16036), // Rule ID 2085 //
     /*  15926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15986 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15991 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15995 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15999 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16003 */     // MIs[4] Operand 1
     /*  16003 */     // No operand predicates
     /*  16003 */     // MIs[2] Operand 2
     /*  16003 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16014 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16016 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16034 */     GIR_RootConstrainSelectedInstOperands,
     /*  16035 */     // GIR_Coverage, 2085,
     /*  16035 */     GIR_EraseRootFromParent_Done,
     /*  16036 */   // Label 309: @16036
     /*  16036 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16103), // Rule ID 13117 //
     /*  16041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16084 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16101 */     GIR_RootConstrainSelectedInstOperands,
     /*  16102 */     // GIR_Coverage, 13117,
     /*  16102 */     GIR_EraseRootFromParent_Done,
     /*  16103 */   // Label 310: @16103
     /*  16103 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16170), // Rule ID 13147 //
     /*  16108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16151 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16168 */     GIR_RootConstrainSelectedInstOperands,
     /*  16169 */     // GIR_Coverage, 13147,
     /*  16169 */     GIR_EraseRootFromParent_Done,
     /*  16170 */   // Label 311: @16170
     /*  16170 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16237), // Rule ID 1722 //
     /*  16175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16218 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16235 */     GIR_RootConstrainSelectedInstOperands,
     /*  16236 */     // GIR_Coverage, 1722,
     /*  16236 */     GIR_EraseRootFromParent_Done,
     /*  16237 */   // Label 312: @16237
     /*  16237 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16304), // Rule ID 1812 //
     /*  16242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16285 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16302 */     GIR_RootConstrainSelectedInstOperands,
     /*  16303 */     // GIR_Coverage, 1812,
     /*  16303 */     GIR_EraseRootFromParent_Done,
     /*  16304 */   // Label 313: @16304
     /*  16304 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16385), // Rule ID 13103 //
     /*  16309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16336 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16339 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16348 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16368 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16383 */     GIR_RootConstrainSelectedInstOperands,
     /*  16384 */     // GIR_Coverage, 13103,
     /*  16384 */     GIR_EraseRootFromParent_Done,
     /*  16385 */   // Label 314: @16385
     /*  16385 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16466), // Rule ID 13127 //
     /*  16390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16417 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16420 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16429 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16449 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16464 */     GIR_RootConstrainSelectedInstOperands,
     /*  16465 */     // GIR_Coverage, 13127,
     /*  16465 */     GIR_EraseRootFromParent_Done,
     /*  16466 */   // Label 315: @16466
     /*  16466 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16547), // Rule ID 1690 //
     /*  16471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16502 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16505 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16514 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16530 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16545 */     GIR_RootConstrainSelectedInstOperands,
     /*  16546 */     // GIR_Coverage, 1690,
     /*  16546 */     GIR_EraseRootFromParent_Done,
     /*  16547 */   // Label 316: @16547
     /*  16547 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16628), // Rule ID 1768 //
     /*  16552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16583 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16586 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16595 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16611 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16626 */     GIR_RootConstrainSelectedInstOperands,
     /*  16627 */     // GIR_Coverage, 1768,
     /*  16627 */     GIR_EraseRootFromParent_Done,
     /*  16628 */   // Label 317: @16628
     /*  16628 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(16720), // Rule ID 13198 //
     /*  16633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16685 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16689 */     // MIs[3] Operand 1
     /*  16689 */     // No operand predicates
     /*  16689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16700 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16718 */     GIR_RootConstrainSelectedInstOperands,
     /*  16719 */     // GIR_Coverage, 13198,
     /*  16719 */     GIR_EraseRootFromParent_Done,
     /*  16720 */   // Label 318: @16720
     /*  16720 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(16812), // Rule ID 13197 //
     /*  16725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16786 */     // MIs[3] Operand 1
     /*  16786 */     // No operand predicates
     /*  16786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16792 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16810 */     GIR_RootConstrainSelectedInstOperands,
     /*  16811 */     // GIR_Coverage, 13197,
     /*  16811 */     GIR_EraseRootFromParent_Done,
     /*  16812 */   // Label 319: @16812
     /*  16812 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(16904), // Rule ID 13228 //
     /*  16817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16869 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16873 */     // MIs[3] Operand 1
     /*  16873 */     // No operand predicates
     /*  16873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16884 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16902 */     GIR_RootConstrainSelectedInstOperands,
     /*  16903 */     // GIR_Coverage, 13228,
     /*  16903 */     GIR_EraseRootFromParent_Done,
     /*  16904 */   // Label 320: @16904
     /*  16904 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(16996), // Rule ID 13227 //
     /*  16909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16966 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16970 */     // MIs[3] Operand 1
     /*  16970 */     // No operand predicates
     /*  16970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16976 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16994 */     GIR_RootConstrainSelectedInstOperands,
     /*  16995 */     // GIR_Coverage, 13227,
     /*  16995 */     GIR_EraseRootFromParent_Done,
     /*  16996 */   // Label 321: @16996
     /*  16996 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17088), // Rule ID 13196 //
     /*  17001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17057 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17061 */     // MIs[3] Operand 1
     /*  17061 */     // No operand predicates
     /*  17061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17068 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17086 */     GIR_RootConstrainSelectedInstOperands,
     /*  17087 */     // GIR_Coverage, 13196,
     /*  17087 */     GIR_EraseRootFromParent_Done,
     /*  17088 */   // Label 322: @17088
     /*  17088 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17180), // Rule ID 2034 //
     /*  17093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17158 */     // MIs[3] Operand 1
     /*  17158 */     // No operand predicates
     /*  17158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17160 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17178 */     GIR_RootConstrainSelectedInstOperands,
     /*  17179 */     // GIR_Coverage, 2034,
     /*  17179 */     GIR_EraseRootFromParent_Done,
     /*  17180 */   // Label 323: @17180
     /*  17180 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17272), // Rule ID 13226 //
     /*  17185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17245 */     // MIs[3] Operand 1
     /*  17245 */     // No operand predicates
     /*  17245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17252 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17270 */     GIR_RootConstrainSelectedInstOperands,
     /*  17271 */     // GIR_Coverage, 13226,
     /*  17271 */     GIR_EraseRootFromParent_Done,
     /*  17272 */   // Label 324: @17272
     /*  17272 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17364), // Rule ID 2086 //
     /*  17277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17338 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17342 */     // MIs[3] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17344 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17362 */     GIR_RootConstrainSelectedInstOperands,
     /*  17363 */     // GIR_Coverage, 2086,
     /*  17363 */     GIR_EraseRootFromParent_Done,
     /*  17364 */   // Label 325: @17364
     /*  17364 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17415), // Rule ID 13141 //
     /*  17369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17401 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17413 */     GIR_RootConstrainSelectedInstOperands,
     /*  17414 */     // GIR_Coverage, 13141,
     /*  17414 */     GIR_EraseRootFromParent_Done,
     /*  17415 */   // Label 326: @17415
     /*  17415 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17466), // Rule ID 13111 //
     /*  17420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17452 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 13111,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 327: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(17517), // Rule ID 13140 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17503 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17515 */     GIR_RootConstrainSelectedInstOperands,
     /*  17516 */     // GIR_Coverage, 13140,
     /*  17516 */     GIR_EraseRootFromParent_Done,
     /*  17517 */   // Label 328: @17517
     /*  17517 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(17568), // Rule ID 1806 //
     /*  17522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17554 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17566 */     GIR_RootConstrainSelectedInstOperands,
     /*  17567 */     // GIR_Coverage, 1806,
     /*  17567 */     GIR_EraseRootFromParent_Done,
     /*  17568 */   // Label 329: @17568
     /*  17568 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(17619), // Rule ID 1716 //
     /*  17573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17605 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17617 */     GIR_RootConstrainSelectedInstOperands,
     /*  17618 */     // GIR_Coverage, 1716,
     /*  17618 */     GIR_EraseRootFromParent_Done,
     /*  17619 */   // Label 330: @17619
     /*  17619 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(17670), // Rule ID 1805 //
     /*  17624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17656 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17668 */     GIR_RootConstrainSelectedInstOperands,
     /*  17669 */     // GIR_Coverage, 1805,
     /*  17669 */     GIR_EraseRootFromParent_Done,
     /*  17670 */   // Label 331: @17670
     /*  17670 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(17726), // Rule ID 13029 //
     /*  17675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17690 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17693 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17713 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17724 */     GIR_RootConstrainSelectedInstOperands,
     /*  17725 */     // GIR_Coverage, 13029,
     /*  17725 */     GIR_EraseRootFromParent_Done,
     /*  17726 */   // Label 332: @17726
     /*  17726 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17782), // Rule ID 13041 //
     /*  17731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17746 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17749 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  17754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17769 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  17772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17780 */     GIR_RootConstrainSelectedInstOperands,
     /*  17781 */     // GIR_Coverage, 13041,
     /*  17781 */     GIR_EraseRootFromParent_Done,
     /*  17782 */   // Label 333: @17782
     /*  17782 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(17849), // Rule ID 13269 //
     /*  17787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  17802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17811 */     // MIs[1] imm
     /*  17811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17823 */     // MIs[2] Operand 1
     /*  17823 */     // No operand predicates
     /*  17823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17833 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  17836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17847 */     GIR_RootConstrainSelectedInstOperands,
     /*  17848 */     // GIR_Coverage, 13269,
     /*  17848 */     GIR_EraseRootFromParent_Done,
     /*  17849 */   // Label 334: @17849
     /*  17849 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(17916), // Rule ID 13290 //
     /*  17854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  17869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17878 */     // MIs[1] imm
     /*  17878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17890 */     // MIs[2] Operand 1
     /*  17890 */     // No operand predicates
     /*  17890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17900 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  17903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17914 */     GIR_RootConstrainSelectedInstOperands,
     /*  17915 */     // GIR_Coverage, 13290,
     /*  17915 */     GIR_EraseRootFromParent_Done,
     /*  17916 */   // Label 335: @17916
     /*  17916 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(17972), // Rule ID 992 //
     /*  17921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17940 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17943 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17959 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17970 */     GIR_RootConstrainSelectedInstOperands,
     /*  17971 */     // GIR_Coverage, 992,
     /*  17971 */     GIR_EraseRootFromParent_Done,
     /*  17972 */   // Label 336: @17972
     /*  17972 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18028), // Rule ID 1053 //
     /*  17977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17996 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17999 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  18004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18015 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18026 */     GIR_RootConstrainSelectedInstOperands,
     /*  18027 */     // GIR_Coverage, 1053,
     /*  18027 */     GIR_EraseRootFromParent_Done,
     /*  18028 */   // Label 337: @18028
     /*  18028 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18095), // Rule ID 2233 //
     /*  18033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  18052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18061 */     // MIs[1] imm
     /*  18061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18073 */     // MIs[2] Operand 1
     /*  18073 */     // No operand predicates
     /*  18073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18079 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  18082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18093 */     GIR_RootConstrainSelectedInstOperands,
     /*  18094 */     // GIR_Coverage, 2233,
     /*  18094 */     GIR_EraseRootFromParent_Done,
     /*  18095 */   // Label 338: @18095
     /*  18095 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18162), // Rule ID 2292 //
     /*  18100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  18119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18128 */     // MIs[1] imm
     /*  18128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18136 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18140 */     // MIs[2] Operand 1
     /*  18140 */     // No operand predicates
     /*  18140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18146 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  18149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18160 */     GIR_RootConstrainSelectedInstOperands,
     /*  18161 */     // GIR_Coverage, 2292,
     /*  18161 */     GIR_EraseRootFromParent_Done,
     /*  18162 */   // Label 339: @18162
     /*  18162 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18232), // Rule ID 6836 //
     /*  18167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18205 */     // MIs[2] Rn
     /*  18205 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18210 */     // MIs[2] Rm
     /*  18210 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18217 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18230 */     GIR_RootConstrainSelectedInstOperands,
     /*  18231 */     // GIR_Coverage, 6836,
     /*  18231 */     GIR_EraseRootFromParent_Done,
     /*  18232 */   // Label 340: @18232
     /*  18232 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18302), // Rule ID 13651 //
     /*  18237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18275 */     // MIs[2] Rn
     /*  18275 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18280 */     // MIs[2] Rm
     /*  18280 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18287 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18300 */     GIR_RootConstrainSelectedInstOperands,
     /*  18301 */     // GIR_Coverage, 13651,
     /*  18301 */     GIR_EraseRootFromParent_Done,
     /*  18302 */   // Label 341: @18302
     /*  18302 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18365), // Rule ID 1790 //
     /*  18307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18350 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18363 */     GIR_RootConstrainSelectedInstOperands,
     /*  18364 */     // GIR_Coverage, 1790,
     /*  18364 */     GIR_EraseRootFromParent_Done,
     /*  18365 */   // Label 342: @18365
     /*  18365 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18428), // Rule ID 1789 //
     /*  18370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18413 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18426 */     GIR_RootConstrainSelectedInstOperands,
     /*  18427 */     // GIR_Coverage, 1789,
     /*  18427 */     GIR_EraseRootFromParent_Done,
     /*  18428 */   // Label 343: @18428
     /*  18428 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18491), // Rule ID 1709 //
     /*  18433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18476 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  18479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18489 */     GIR_RootConstrainSelectedInstOperands,
     /*  18490 */     // GIR_Coverage, 1709,
     /*  18490 */     GIR_EraseRootFromParent_Done,
     /*  18491 */   // Label 344: @18491
     /*  18491 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18554), // Rule ID 1788 //
     /*  18496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18539 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18552 */     GIR_RootConstrainSelectedInstOperands,
     /*  18553 */     // GIR_Coverage, 1788,
     /*  18553 */     GIR_EraseRootFromParent_Done,
     /*  18554 */   // Label 345: @18554
     /*  18554 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18617), // Rule ID 1787 //
     /*  18559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18602 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18615 */     GIR_RootConstrainSelectedInstOperands,
     /*  18616 */     // GIR_Coverage, 1787,
     /*  18616 */     GIR_EraseRootFromParent_Done,
     /*  18617 */   // Label 346: @18617
     /*  18617 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18678), // Rule ID 13116 //
     /*  18622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18661 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  18664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18676 */     GIR_RootConstrainSelectedInstOperands,
     /*  18677 */     // GIR_Coverage, 13116,
     /*  18677 */     GIR_EraseRootFromParent_Done,
     /*  18678 */   // Label 347: @18678
     /*  18678 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18739), // Rule ID 13146 //
     /*  18683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18722 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  18725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18737 */     GIR_RootConstrainSelectedInstOperands,
     /*  18738 */     // GIR_Coverage, 13146,
     /*  18738 */     GIR_EraseRootFromParent_Done,
     /*  18739 */   // Label 348: @18739
     /*  18739 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18787), // Rule ID 13139 //
     /*  18744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18774 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18785 */     GIR_RootConstrainSelectedInstOperands,
     /*  18786 */     // GIR_Coverage, 13139,
     /*  18786 */     GIR_EraseRootFromParent_Done,
     /*  18787 */   // Label 349: @18787
     /*  18787 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18835), // Rule ID 13028 //
     /*  18792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  18807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18822 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  18825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18833 */     GIR_RootConstrainSelectedInstOperands,
     /*  18834 */     // GIR_Coverage, 13028,
     /*  18834 */     GIR_EraseRootFromParent_Done,
     /*  18835 */   // Label 350: @18835
     /*  18835 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18883), // Rule ID 13110 //
     /*  18840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18870 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  18873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18881 */     GIR_RootConstrainSelectedInstOperands,
     /*  18882 */     // GIR_Coverage, 13110,
     /*  18882 */     GIR_EraseRootFromParent_Done,
     /*  18883 */   // Label 351: @18883
     /*  18883 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18931), // Rule ID 13040 //
     /*  18888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  18903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18918 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18929 */     GIR_RootConstrainSelectedInstOperands,
     /*  18930 */     // GIR_Coverage, 13040,
     /*  18930 */     GIR_EraseRootFromParent_Done,
     /*  18931 */   // Label 352: @18931
     /*  18931 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18979), // Rule ID 13138 //
     /*  18936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18966 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18977 */     GIR_RootConstrainSelectedInstOperands,
     /*  18978 */     // GIR_Coverage, 13138,
     /*  18978 */     GIR_EraseRootFromParent_Done,
     /*  18979 */   // Label 353: @18979
     /*  18979 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19040), // Rule ID 1721 //
     /*  18984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19023 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  19026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19038 */     GIR_RootConstrainSelectedInstOperands,
     /*  19039 */     // GIR_Coverage, 1721,
     /*  19039 */     GIR_EraseRootFromParent_Done,
     /*  19040 */   // Label 354: @19040
     /*  19040 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19101), // Rule ID 1811 //
     /*  19045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  19087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19099 */     GIR_RootConstrainSelectedInstOperands,
     /*  19100 */     // GIR_Coverage, 1811,
     /*  19100 */     GIR_EraseRootFromParent_Done,
     /*  19101 */   // Label 355: @19101
     /*  19101 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19149), // Rule ID 1804 //
     /*  19106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19136 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19147 */     GIR_RootConstrainSelectedInstOperands,
     /*  19148 */     // GIR_Coverage, 1804,
     /*  19148 */     GIR_EraseRootFromParent_Done,
     /*  19149 */   // Label 356: @19149
     /*  19149 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19197), // Rule ID 991 //
     /*  19154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  19173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19184 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19195 */     GIR_RootConstrainSelectedInstOperands,
     /*  19196 */     // GIR_Coverage, 991,
     /*  19196 */     GIR_EraseRootFromParent_Done,
     /*  19197 */   // Label 357: @19197
     /*  19197 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19245), // Rule ID 1715 //
     /*  19202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19232 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  19235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19243 */     GIR_RootConstrainSelectedInstOperands,
     /*  19244 */     // GIR_Coverage, 1715,
     /*  19244 */     GIR_EraseRootFromParent_Done,
     /*  19245 */   // Label 358: @19245
     /*  19245 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19293), // Rule ID 1052 //
     /*  19250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  19269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19280 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19291 */     GIR_RootConstrainSelectedInstOperands,
     /*  19292 */     // GIR_Coverage, 1052,
     /*  19292 */     GIR_EraseRootFromParent_Done,
     /*  19293 */   // Label 359: @19293
     /*  19293 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19341), // Rule ID 1803 //
     /*  19298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19328 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19339 */     GIR_RootConstrainSelectedInstOperands,
     /*  19340 */     // GIR_Coverage, 1803,
     /*  19340 */     GIR_EraseRootFromParent_Done,
     /*  19341 */   // Label 360: @19341
     /*  19341 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19368), // Rule ID 1099 //
     /*  19346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19361 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  19361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  19366 */     GIR_RootConstrainSelectedInstOperands,
     /*  19367 */     // GIR_Coverage, 1099,
     /*  19367 */     GIR_Done,
     /*  19368 */   // Label 361: @19368
     /*  19368 */   GIM_Reject,
     /*  19369 */ // Label 284: @19369
     /*  19369 */ GIM_Reject,
     /*  19370 */ // Label 159: @19370
     /*  19370 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(22867),
     /*  19375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  19378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  19381 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19517), // Rule ID 5305 //
     /*  19386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19419 */     // MIs[1] Operand 2
     /*  19419 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19450 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19454 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19459 */     // MIs[3] Operand 2
     /*  19459 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19472 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19499 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19516 */     // GIR_Coverage, 5305,
     /*  19516 */     GIR_EraseRootFromParent_Done,
     /*  19517 */   // Label 363: @19517
     /*  19517 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19653), // Rule ID 5304 //
     /*  19522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19555 */     // MIs[1] Operand 2
     /*  19555 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19578 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19582 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19586 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19590 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19595 */     // MIs[3] Operand 2
     /*  19595 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19608 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19652 */     // GIR_Coverage, 5304,
     /*  19652 */     GIR_EraseRootFromParent_Done,
     /*  19653 */   // Label 364: @19653
     /*  19653 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19789), // Rule ID 5320 //
     /*  19658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19691 */     // MIs[1] Operand 2
     /*  19691 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19718 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19722 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19726 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19731 */     // MIs[3] Operand 2
     /*  19731 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19742 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19744 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  19751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19788 */     // GIR_Coverage, 5320,
     /*  19788 */     GIR_EraseRootFromParent_Done,
     /*  19789 */   // Label 365: @19789
     /*  19789 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19925), // Rule ID 5303 //
     /*  19794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19827 */     // MIs[1] Operand 2
     /*  19827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19854 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19858 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19862 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19867 */     // MIs[3] Operand 2
     /*  19867 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19878 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19880 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19907 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19924 */     // GIR_Coverage, 5303,
     /*  19924 */     GIR_EraseRootFromParent_Done,
     /*  19925 */   // Label 366: @19925
     /*  19925 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20061), // Rule ID 5302 //
     /*  19930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19963 */     // MIs[1] Operand 2
     /*  19963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19990 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19994 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19998 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20003 */     // MIs[3] Operand 2
     /*  20003 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20014 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20016 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  20023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  20036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20043 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20060 */     // GIR_Coverage, 5302,
     /*  20060 */     GIR_EraseRootFromParent_Done,
     /*  20061 */   // Label 367: @20061
     /*  20061 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20194), // Rule ID 13656 //
     /*  20066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  20090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20111 */     // MIs[1] Operand 2
     /*  20111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20122 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20126 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20130 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20134 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20138 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20142 */     // MIs[5] Rn
     /*  20142 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20147 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20149 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20176 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20193 */     // GIR_Coverage, 13656,
     /*  20193 */     GIR_EraseRootFromParent_Done,
     /*  20194 */   // Label 368: @20194
     /*  20194 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20327), // Rule ID 6841 //
     /*  20199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20244 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20248 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  20252 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20256 */     // MIs[4] Rn
     /*  20256 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20261 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20265 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20269 */     // MIs[3] Operand 2
     /*  20269 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20280 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20282 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20326 */     // GIR_Coverage, 6841,
     /*  20326 */     GIR_EraseRootFromParent_Done,
     /*  20327 */   // Label 369: @20327
     /*  20327 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20490), // Rule ID 13608 //
     /*  20332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  20356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20374 */     // MIs[1] Operand 2
     /*  20374 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20391 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20391 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20394 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20398 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20405 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20408 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20412 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20417 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20420 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20424 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20427 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20432 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20437 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  20449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20489 */     // GIR_Coverage, 13608,
     /*  20489 */     GIR_EraseRootFromParent_Done,
     /*  20490 */   // Label 370: @20490
     /*  20490 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20653), // Rule ID 13605 //
     /*  20495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  20519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20537 */     // MIs[1] Operand 2
     /*  20537 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20554 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20554 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20557 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20561 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20580 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20587 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  20612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20652 */     // GIR_Coverage, 13605,
     /*  20652 */     GIR_EraseRootFromParent_Done,
     /*  20653 */   // Label 371: @20653
     /*  20653 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20803), // Rule ID 13612 //
     /*  20658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20691 */     // MIs[1] Operand 2
     /*  20691 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20708 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  20766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20802 */     // GIR_Coverage, 13612,
     /*  20802 */     GIR_EraseRootFromParent_Done,
     /*  20803 */   // Label 372: @20803
     /*  20803 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20953), // Rule ID 13617 //
     /*  20808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20841 */     // MIs[1] Operand 2
     /*  20841 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20858 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20884 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20891 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  20916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20952 */     // GIR_Coverage, 13617,
     /*  20952 */     GIR_EraseRootFromParent_Done,
     /*  20953 */   // Label 373: @20953
     /*  20953 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21103), // Rule ID 13611 //
     /*  20958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20991 */     // MIs[1] Operand 2
     /*  20991 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21008 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21008 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21011 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21015 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  21041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21085 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21102 */     // GIR_Coverage, 13611,
     /*  21102 */     GIR_EraseRootFromParent_Done,
     /*  21103 */   // Label 374: @21103
     /*  21103 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21266), // Rule ID 5293 //
     /*  21108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  21136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21154 */     // MIs[1] Operand 2
     /*  21154 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21167 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21167 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21170 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21174 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21193 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21196 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  21225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21230 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21248 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21265 */     // GIR_Coverage, 5293,
     /*  21265 */     GIR_EraseRootFromParent_Done,
     /*  21266 */   // Label 375: @21266
     /*  21266 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21429), // Rule ID 5290 //
     /*  21271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  21299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21317 */     // MIs[1] Operand 2
     /*  21317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21330 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  21388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21428 */     // GIR_Coverage, 5290,
     /*  21428 */     GIR_EraseRootFromParent_Done,
     /*  21429 */   // Label 376: @21429
     /*  21429 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21579), // Rule ID 5315 //
     /*  21434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21471 */     // MIs[1] Operand 2
     /*  21471 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21484 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21484 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21487 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21491 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21510 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21530 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21578 */     // GIR_Coverage, 5315,
     /*  21578 */     GIR_EraseRootFromParent_Done,
     /*  21579 */   // Label 377: @21579
     /*  21579 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21729), // Rule ID 5323 //
     /*  21584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21621 */     // MIs[1] Operand 2
     /*  21621 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21634 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21634 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21637 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21641 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21648 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21651 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21655 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21660 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21667 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21675 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  21692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21711 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21728 */     // GIR_Coverage, 5323,
     /*  21728 */     GIR_EraseRootFromParent_Done,
     /*  21729 */   // Label 378: @21729
     /*  21729 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21879), // Rule ID 5314 //
     /*  21734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21771 */     // MIs[1] Operand 2
     /*  21771 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21784 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21784 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21787 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21791 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21798 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21801 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21805 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21810 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21813 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21817 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21878 */     // GIR_Coverage, 5314,
     /*  21878 */     GIR_EraseRootFromParent_Done,
     /*  21879 */   // Label 379: @21879
     /*  21879 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21948), // Rule ID 13057 //
     /*  21884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  21907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  21915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21931 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  21931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  21934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  21942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  21946 */     GIR_RootConstrainSelectedInstOperands,
     /*  21947 */     // GIR_Coverage, 13057,
     /*  21947 */     GIR_EraseRootFromParent_Done,
     /*  21948 */   // Label 380: @21948
     /*  21948 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22017), // Rule ID 13069 //
     /*  21953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21968 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21971 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  21976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21980 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  21984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22000 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22015 */     GIR_RootConstrainSelectedInstOperands,
     /*  22016 */     // GIR_Coverage, 13069,
     /*  22016 */     GIR_EraseRootFromParent_Done,
     /*  22017 */   // Label 381: @22017
     /*  22017 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22073), // Rule ID 13019 //
     /*  22022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22037 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22040 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22060 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22071 */     GIR_RootConstrainSelectedInstOperands,
     /*  22072 */     // GIR_Coverage, 13019,
     /*  22072 */     GIR_EraseRootFromParent_Done,
     /*  22073 */   // Label 382: @22073
     /*  22073 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22129), // Rule ID 13031 //
     /*  22078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22093 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22096 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22116 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22127 */     GIR_RootConstrainSelectedInstOperands,
     /*  22128 */     // GIR_Coverage, 13031,
     /*  22128 */     GIR_EraseRootFromParent_Done,
     /*  22129 */   // Label 383: @22129
     /*  22129 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22196), // Rule ID 13261 //
     /*  22134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22158 */     // MIs[1] imm
     /*  22158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22170 */     // MIs[2] Operand 1
     /*  22170 */     // No operand predicates
     /*  22170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22180 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22194 */     GIR_RootConstrainSelectedInstOperands,
     /*  22195 */     // GIR_Coverage, 13261,
     /*  22195 */     GIR_EraseRootFromParent_Done,
     /*  22196 */   // Label 384: @22196
     /*  22196 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22263), // Rule ID 13282 //
     /*  22201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22225 */     // MIs[1] imm
     /*  22225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22237 */     // MIs[2] Operand 1
     /*  22237 */     // No operand predicates
     /*  22237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22247 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22261 */     GIR_RootConstrainSelectedInstOperands,
     /*  22262 */     // GIR_Coverage, 13282,
     /*  22262 */     GIR_EraseRootFromParent_Done,
     /*  22263 */   // Label 385: @22263
     /*  22263 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22332), // Rule ID 1354 //
     /*  22268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22287 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22290 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  22295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22315 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  22318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22330 */     GIR_RootConstrainSelectedInstOperands,
     /*  22331 */     // GIR_Coverage, 1354,
     /*  22331 */     GIR_EraseRootFromParent_Done,
     /*  22332 */   // Label 386: @22332
     /*  22332 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22401), // Rule ID 1477 //
     /*  22337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22356 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22359 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  22364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22384 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22399 */     GIR_RootConstrainSelectedInstOperands,
     /*  22400 */     // GIR_Coverage, 1477,
     /*  22400 */     GIR_EraseRootFromParent_Done,
     /*  22401 */   // Label 387: @22401
     /*  22401 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22457), // Rule ID 982 //
     /*  22406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22444 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22455 */     GIR_RootConstrainSelectedInstOperands,
     /*  22456 */     // GIR_Coverage, 982,
     /*  22456 */     GIR_EraseRootFromParent_Done,
     /*  22457 */   // Label 388: @22457
     /*  22457 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22513), // Rule ID 1043 //
     /*  22462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22481 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22484 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22500 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22511 */     GIR_RootConstrainSelectedInstOperands,
     /*  22512 */     // GIR_Coverage, 1043,
     /*  22512 */     GIR_EraseRootFromParent_Done,
     /*  22513 */   // Label 389: @22513
     /*  22513 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22580), // Rule ID 2225 //
     /*  22518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22546 */     // MIs[1] imm
     /*  22546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22558 */     // MIs[2] Operand 1
     /*  22558 */     // No operand predicates
     /*  22558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22564 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22578 */     GIR_RootConstrainSelectedInstOperands,
     /*  22579 */     // GIR_Coverage, 2225,
     /*  22579 */     GIR_EraseRootFromParent_Done,
     /*  22580 */   // Label 390: @22580
     /*  22580 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22647), // Rule ID 2284 //
     /*  22585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22613 */     // MIs[1] imm
     /*  22613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22625 */     // MIs[2] Operand 1
     /*  22625 */     // No operand predicates
     /*  22625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22631 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22645 */     GIR_RootConstrainSelectedInstOperands,
     /*  22646 */     // GIR_Coverage, 2284,
     /*  22646 */     GIR_EraseRootFromParent_Done,
     /*  22647 */   // Label 391: @22647
     /*  22647 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22695), // Rule ID 13018 //
     /*  22652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22682 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22693 */     GIR_RootConstrainSelectedInstOperands,
     /*  22694 */     // GIR_Coverage, 13018,
     /*  22694 */     GIR_EraseRootFromParent_Done,
     /*  22695 */   // Label 392: @22695
     /*  22695 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(22743), // Rule ID 13030 //
     /*  22700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22730 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22741 */     GIR_RootConstrainSelectedInstOperands,
     /*  22742 */     // GIR_Coverage, 13030,
     /*  22742 */     GIR_EraseRootFromParent_Done,
     /*  22743 */   // Label 393: @22743
     /*  22743 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(22791), // Rule ID 981 //
     /*  22748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22778 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22789 */     GIR_RootConstrainSelectedInstOperands,
     /*  22790 */     // GIR_Coverage, 981,
     /*  22790 */     GIR_EraseRootFromParent_Done,
     /*  22791 */   // Label 394: @22791
     /*  22791 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(22839), // Rule ID 1042 //
     /*  22796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22826 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22837 */     GIR_RootConstrainSelectedInstOperands,
     /*  22838 */     // GIR_Coverage, 1042,
     /*  22838 */     GIR_EraseRootFromParent_Done,
     /*  22839 */   // Label 395: @22839
     /*  22839 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(22866), // Rule ID 1095 //
     /*  22844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22859 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  22864 */     GIR_RootConstrainSelectedInstOperands,
     /*  22865 */     // GIR_Coverage, 1095,
     /*  22865 */     GIR_Done,
     /*  22866 */   // Label 396: @22866
     /*  22866 */   GIM_Reject,
     /*  22867 */ // Label 362: @22867
     /*  22867 */ GIM_Reject,
     /*  22868 */ // Label 160: @22868
     /*  22868 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(29045),
     /*  22873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22879 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(22997), // Rule ID 13191 //
     /*  22884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  22899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  22927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  22935 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  22940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22944 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22948 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  22952 */     // MIs[4] Operand 1
     /*  22952 */     // No operand predicates
     /*  22952 */     // MIs[2] Operand 2
     /*  22952 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  22963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22967 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  22976 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  22976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  22979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  22988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  22992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  22995 */     GIR_RootConstrainSelectedInstOperands,
     /*  22996 */     // GIR_Coverage, 13191,
     /*  22996 */     GIR_EraseRootFromParent_Done,
     /*  22997 */   // Label 398: @22997
     /*  22997 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23115), // Rule ID 13192 //
     /*  23002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23049 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23053 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23066 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23070 */     // MIs[4] Operand 1
     /*  23070 */     // No operand predicates
     /*  23070 */     // MIs[2] Operand 2
     /*  23070 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23094 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 13192,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 399: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23233), // Rule ID 13221 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23167 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23180 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23184 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23188 */     // MIs[4] Operand 1
     /*  23188 */     // No operand predicates
     /*  23188 */     // MIs[2] Operand 2
     /*  23188 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23203 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23212 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23231 */     GIR_RootConstrainSelectedInstOperands,
     /*  23232 */     // GIR_Coverage, 13221,
     /*  23232 */     GIR_EraseRootFromParent_Done,
     /*  23233 */   // Label 400: @23233
     /*  23233 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(23351), // Rule ID 13222 //
     /*  23238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23281 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23285 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23289 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23294 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23298 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23302 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23306 */     // MIs[4] Operand 1
     /*  23306 */     // No operand predicates
     /*  23306 */     // MIs[2] Operand 2
     /*  23306 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23321 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23330 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23349 */     GIR_RootConstrainSelectedInstOperands,
     /*  23350 */     // GIR_Coverage, 13222,
     /*  23350 */     GIR_EraseRootFromParent_Done,
     /*  23351 */   // Label 401: @23351
     /*  23351 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(23469), // Rule ID 2032 //
     /*  23356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23403 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23407 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23411 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23420 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23424 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23428 */     // MIs[4] Operand 1
     /*  23428 */     // No operand predicates
     /*  23428 */     // MIs[2] Operand 2
     /*  23428 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23439 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23448 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23467 */     GIR_RootConstrainSelectedInstOperands,
     /*  23468 */     // GIR_Coverage, 2032,
     /*  23468 */     GIR_EraseRootFromParent_Done,
     /*  23469 */   // Label 402: @23469
     /*  23469 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(23587), // Rule ID 13190 //
     /*  23474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23521 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23525 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23529 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23538 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23542 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23546 */     // MIs[4] Operand 1
     /*  23546 */     // No operand predicates
     /*  23546 */     // MIs[2] Operand 2
     /*  23546 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23557 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23566 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23585 */     GIR_RootConstrainSelectedInstOperands,
     /*  23586 */     // GIR_Coverage, 13190,
     /*  23586 */     GIR_EraseRootFromParent_Done,
     /*  23587 */   // Label 403: @23587
     /*  23587 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(23705), // Rule ID 2084 //
     /*  23592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23639 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23660 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23664 */     // MIs[4] Operand 1
     /*  23664 */     // No operand predicates
     /*  23664 */     // MIs[2] Operand 2
     /*  23664 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23675 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23684 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23703 */     GIR_RootConstrainSelectedInstOperands,
     /*  23704 */     // GIR_Coverage, 2084,
     /*  23704 */     GIR_EraseRootFromParent_Done,
     /*  23705 */   // Label 404: @23705
     /*  23705 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(23823), // Rule ID 13220 //
     /*  23710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23761 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23774 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23778 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23782 */     // MIs[4] Operand 1
     /*  23782 */     // No operand predicates
     /*  23782 */     // MIs[2] Operand 2
     /*  23782 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23793 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23802 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23821 */     GIR_RootConstrainSelectedInstOperands,
     /*  23822 */     // GIR_Coverage, 13220,
     /*  23822 */     GIR_EraseRootFromParent_Done,
     /*  23823 */   // Label 405: @23823
     /*  23823 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(23910), // Rule ID 13101 //
     /*  23828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23855 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23858 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23867 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23891 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  23908 */     GIR_RootConstrainSelectedInstOperands,
     /*  23909 */     // GIR_Coverage, 13101,
     /*  23909 */     GIR_EraseRootFromParent_Done,
     /*  23910 */   // Label 406: @23910
     /*  23910 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(23997), // Rule ID 13125 //
     /*  23915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23942 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23945 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23954 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23978 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  23981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  23995 */     GIR_RootConstrainSelectedInstOperands,
     /*  23996 */     // GIR_Coverage, 13125,
     /*  23996 */     GIR_EraseRootFromParent_Done,
     /*  23997 */   // Label 407: @23997
     /*  23997 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24084), // Rule ID 1688 //
     /*  24002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24033 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24036 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24045 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24065 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  24068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24082 */     GIR_RootConstrainSelectedInstOperands,
     /*  24083 */     // GIR_Coverage, 1688,
     /*  24083 */     GIR_EraseRootFromParent_Done,
     /*  24084 */   // Label 408: @24084
     /*  24084 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24171), // Rule ID 1766 //
     /*  24089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24120 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24123 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24132 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24152 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  24155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24169 */     GIR_RootConstrainSelectedInstOperands,
     /*  24170 */     // GIR_Coverage, 1766,
     /*  24170 */     GIR_EraseRootFromParent_Done,
     /*  24171 */   // Label 409: @24171
     /*  24171 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24286), // Rule ID 13186 //
     /*  24176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24219 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24227 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24236 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24240 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24244 */     // MIs[4] Operand 1
     /*  24244 */     // No operand predicates
     /*  24244 */     // MIs[2] Operand 2
     /*  24244 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24266 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24284 */     GIR_RootConstrainSelectedInstOperands,
     /*  24285 */     // GIR_Coverage, 13186,
     /*  24285 */     GIR_EraseRootFromParent_Done,
     /*  24286 */   // Label 410: @24286
     /*  24286 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24401), // Rule ID 13185 //
     /*  24291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24339 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24343 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24356 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24360 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24364 */     // MIs[4] Operand 1
     /*  24364 */     // No operand predicates
     /*  24364 */     // MIs[2] Operand 2
     /*  24364 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24379 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24381 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24399 */     GIR_RootConstrainSelectedInstOperands,
     /*  24400 */     // GIR_Coverage, 13185,
     /*  24400 */     GIR_EraseRootFromParent_Done,
     /*  24401 */   // Label 411: @24401
     /*  24401 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24516), // Rule ID 13216 //
     /*  24406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24449 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24453 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24457 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24462 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24466 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24470 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24474 */     // MIs[4] Operand 1
     /*  24474 */     // No operand predicates
     /*  24474 */     // MIs[2] Operand 2
     /*  24474 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24496 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24514 */     GIR_RootConstrainSelectedInstOperands,
     /*  24515 */     // GIR_Coverage, 13216,
     /*  24515 */     GIR_EraseRootFromParent_Done,
     /*  24516 */   // Label 412: @24516
     /*  24516 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24631), // Rule ID 13215 //
     /*  24521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24573 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24582 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24586 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24590 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24594 */     // MIs[4] Operand 1
     /*  24594 */     // No operand predicates
     /*  24594 */     // MIs[2] Operand 2
     /*  24594 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24609 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24611 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24629 */     GIR_RootConstrainSelectedInstOperands,
     /*  24630 */     // GIR_Coverage, 13215,
     /*  24630 */     GIR_EraseRootFromParent_Done,
     /*  24631 */   // Label 413: @24631
     /*  24631 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24700), // Rule ID 1786 //
     /*  24636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24683 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 1786,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 414: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24769), // Rule ID 1785 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24752 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24767 */     GIR_RootConstrainSelectedInstOperands,
     /*  24768 */     // GIR_Coverage, 1785,
     /*  24768 */     GIR_EraseRootFromParent_Done,
     /*  24769 */   // Label 415: @24769
     /*  24769 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(24838), // Rule ID 1708 //
     /*  24774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24821 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  24824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24836 */     GIR_RootConstrainSelectedInstOperands,
     /*  24837 */     // GIR_Coverage, 1708,
     /*  24837 */     GIR_EraseRootFromParent_Done,
     /*  24838 */   // Label 416: @24838
     /*  24838 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24907), // Rule ID 1784 //
     /*  24843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24890 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24905 */     GIR_RootConstrainSelectedInstOperands,
     /*  24906 */     // GIR_Coverage, 1784,
     /*  24906 */     GIR_EraseRootFromParent_Done,
     /*  24907 */   // Label 417: @24907
     /*  24907 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(24976), // Rule ID 1783 //
     /*  24912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24959 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24974 */     GIR_RootConstrainSelectedInstOperands,
     /*  24975 */     // GIR_Coverage, 1783,
     /*  24975 */     GIR_EraseRootFromParent_Done,
     /*  24976 */   // Label 418: @24976
     /*  24976 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25091), // Rule ID 13184 //
     /*  24981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25028 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25036 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25041 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25045 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25049 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25053 */     // MIs[4] Operand 1
     /*  25053 */     // No operand predicates
     /*  25053 */     // MIs[2] Operand 2
     /*  25053 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25071 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25089 */     GIR_RootConstrainSelectedInstOperands,
     /*  25090 */     // GIR_Coverage, 13184,
     /*  25090 */     GIR_EraseRootFromParent_Done,
     /*  25091 */   // Label 419: @25091
     /*  25091 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25206), // Rule ID 2030 //
     /*  25096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25165 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25169 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25173 */     // MIs[4] Operand 1
     /*  25173 */     // No operand predicates
     /*  25173 */     // MIs[2] Operand 2
     /*  25173 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25186 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25204 */     GIR_RootConstrainSelectedInstOperands,
     /*  25205 */     // GIR_Coverage, 2030,
     /*  25205 */     GIR_EraseRootFromParent_Done,
     /*  25206 */   // Label 420: @25206
     /*  25206 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25321), // Rule ID 13214 //
     /*  25211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25279 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25283 */     // MIs[4] Operand 1
     /*  25283 */     // No operand predicates
     /*  25283 */     // MIs[2] Operand 2
     /*  25283 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25299 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25301 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25319 */     GIR_RootConstrainSelectedInstOperands,
     /*  25320 */     // GIR_Coverage, 13214,
     /*  25320 */     GIR_EraseRootFromParent_Done,
     /*  25321 */   // Label 421: @25321
     /*  25321 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25436), // Rule ID 2082 //
     /*  25326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25382 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25386 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25391 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25395 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25399 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25403 */     // MIs[4] Operand 1
     /*  25403 */     // No operand predicates
     /*  25403 */     // MIs[2] Operand 2
     /*  25403 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25414 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25416 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25434 */     GIR_RootConstrainSelectedInstOperands,
     /*  25435 */     // GIR_Coverage, 2082,
     /*  25435 */     GIR_EraseRootFromParent_Done,
     /*  25436 */   // Label 422: @25436
     /*  25436 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25503), // Rule ID 13115 //
     /*  25441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25484 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25501 */     GIR_RootConstrainSelectedInstOperands,
     /*  25502 */     // GIR_Coverage, 13115,
     /*  25502 */     GIR_EraseRootFromParent_Done,
     /*  25503 */   // Label 423: @25503
     /*  25503 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25570), // Rule ID 13145 //
     /*  25508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25551 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25568 */     GIR_RootConstrainSelectedInstOperands,
     /*  25569 */     // GIR_Coverage, 13145,
     /*  25569 */     GIR_EraseRootFromParent_Done,
     /*  25570 */   // Label 424: @25570
     /*  25570 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25637), // Rule ID 1720 //
     /*  25575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25618 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25635 */     GIR_RootConstrainSelectedInstOperands,
     /*  25636 */     // GIR_Coverage, 1720,
     /*  25636 */     GIR_EraseRootFromParent_Done,
     /*  25637 */   // Label 425: @25637
     /*  25637 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25704), // Rule ID 1810 //
     /*  25642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25685 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25702 */     GIR_RootConstrainSelectedInstOperands,
     /*  25703 */     // GIR_Coverage, 1810,
     /*  25703 */     GIR_EraseRootFromParent_Done,
     /*  25704 */   // Label 426: @25704
     /*  25704 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(25785), // Rule ID 13099 //
     /*  25709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25736 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25739 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25748 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25768 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25783 */     GIR_RootConstrainSelectedInstOperands,
     /*  25784 */     // GIR_Coverage, 13099,
     /*  25784 */     GIR_EraseRootFromParent_Done,
     /*  25785 */   // Label 427: @25785
     /*  25785 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(25866), // Rule ID 13123 //
     /*  25790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25817 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25820 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25829 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25849 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  25852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25864 */     GIR_RootConstrainSelectedInstOperands,
     /*  25865 */     // GIR_Coverage, 13123,
     /*  25865 */     GIR_EraseRootFromParent_Done,
     /*  25866 */   // Label 428: @25866
     /*  25866 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(25947), // Rule ID 1686 //
     /*  25871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25902 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25905 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25914 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25930 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25945 */     GIR_RootConstrainSelectedInstOperands,
     /*  25946 */     // GIR_Coverage, 1686,
     /*  25946 */     GIR_EraseRootFromParent_Done,
     /*  25947 */   // Label 429: @25947
     /*  25947 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26028), // Rule ID 1764 //
     /*  25952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25983 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25986 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25995 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26011 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  26011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  26014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  26022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  26026 */     GIR_RootConstrainSelectedInstOperands,
     /*  26027 */     // GIR_Coverage, 1764,
     /*  26027 */     GIR_EraseRootFromParent_Done,
     /*  26028 */   // Label 430: @26028
     /*  26028 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26120), // Rule ID 13189 //
     /*  26033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26085 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26089 */     // MIs[3] Operand 1
     /*  26089 */     // No operand predicates
     /*  26089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26100 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26118 */     GIR_RootConstrainSelectedInstOperands,
     /*  26119 */     // GIR_Coverage, 13189,
     /*  26119 */     GIR_EraseRootFromParent_Done,
     /*  26120 */   // Label 431: @26120
     /*  26120 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26212), // Rule ID 13188 //
     /*  26125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26186 */     // MIs[3] Operand 1
     /*  26186 */     // No operand predicates
     /*  26186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26192 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26210 */     GIR_RootConstrainSelectedInstOperands,
     /*  26211 */     // GIR_Coverage, 13188,
     /*  26211 */     GIR_EraseRootFromParent_Done,
     /*  26212 */   // Label 432: @26212
     /*  26212 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26304), // Rule ID 13219 //
     /*  26217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26269 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26273 */     // MIs[3] Operand 1
     /*  26273 */     // No operand predicates
     /*  26273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26284 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26302 */     GIR_RootConstrainSelectedInstOperands,
     /*  26303 */     // GIR_Coverage, 13219,
     /*  26303 */     GIR_EraseRootFromParent_Done,
     /*  26304 */   // Label 433: @26304
     /*  26304 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26396), // Rule ID 13218 //
     /*  26309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26366 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26370 */     // MIs[3] Operand 1
     /*  26370 */     // No operand predicates
     /*  26370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26376 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26394 */     GIR_RootConstrainSelectedInstOperands,
     /*  26395 */     // GIR_Coverage, 13218,
     /*  26395 */     GIR_EraseRootFromParent_Done,
     /*  26396 */   // Label 434: @26396
     /*  26396 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26488), // Rule ID 13187 //
     /*  26401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26461 */     // MIs[3] Operand 1
     /*  26461 */     // No operand predicates
     /*  26461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26468 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26486 */     GIR_RootConstrainSelectedInstOperands,
     /*  26487 */     // GIR_Coverage, 13187,
     /*  26487 */     GIR_EraseRootFromParent_Done,
     /*  26488 */   // Label 435: @26488
     /*  26488 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26580), // Rule ID 2031 //
     /*  26493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26554 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26558 */     // MIs[3] Operand 1
     /*  26558 */     // No operand predicates
     /*  26558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26560 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26578 */     GIR_RootConstrainSelectedInstOperands,
     /*  26579 */     // GIR_Coverage, 2031,
     /*  26579 */     GIR_EraseRootFromParent_Done,
     /*  26580 */   // Label 436: @26580
     /*  26580 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26672), // Rule ID 13217 //
     /*  26585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26641 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26645 */     // MIs[3] Operand 1
     /*  26645 */     // No operand predicates
     /*  26645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26652 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26670 */     GIR_RootConstrainSelectedInstOperands,
     /*  26671 */     // GIR_Coverage, 13217,
     /*  26671 */     GIR_EraseRootFromParent_Done,
     /*  26672 */   // Label 437: @26672
     /*  26672 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(26764), // Rule ID 2083 //
     /*  26677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26742 */     // MIs[3] Operand 1
     /*  26742 */     // No operand predicates
     /*  26742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26744 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26762 */     GIR_RootConstrainSelectedInstOperands,
     /*  26763 */     // GIR_Coverage, 2083,
     /*  26763 */     GIR_EraseRootFromParent_Done,
     /*  26764 */   // Label 438: @26764
     /*  26764 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(26815), // Rule ID 13137 //
     /*  26769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26801 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26813 */     GIR_RootConstrainSelectedInstOperands,
     /*  26814 */     // GIR_Coverage, 13137,
     /*  26814 */     GIR_EraseRootFromParent_Done,
     /*  26815 */   // Label 439: @26815
     /*  26815 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(26866), // Rule ID 13109 //
     /*  26820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26852 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  26855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26864 */     GIR_RootConstrainSelectedInstOperands,
     /*  26865 */     // GIR_Coverage, 13109,
     /*  26865 */     GIR_EraseRootFromParent_Done,
     /*  26866 */   // Label 440: @26866
     /*  26866 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(26917), // Rule ID 13136 //
     /*  26871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26903 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26915 */     GIR_RootConstrainSelectedInstOperands,
     /*  26916 */     // GIR_Coverage, 13136,
     /*  26916 */     GIR_EraseRootFromParent_Done,
     /*  26917 */   // Label 441: @26917
     /*  26917 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(26968), // Rule ID 1802 //
     /*  26922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26954 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  26961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26966 */     GIR_RootConstrainSelectedInstOperands,
     /*  26967 */     // GIR_Coverage, 1802,
     /*  26967 */     GIR_EraseRootFromParent_Done,
     /*  26968 */   // Label 442: @26968
     /*  26968 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27019), // Rule ID 1714 //
     /*  26973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27005 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  27008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27017 */     GIR_RootConstrainSelectedInstOperands,
     /*  27018 */     // GIR_Coverage, 1714,
     /*  27018 */     GIR_EraseRootFromParent_Done,
     /*  27019 */   // Label 443: @27019
     /*  27019 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27070), // Rule ID 1801 //
     /*  27024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27056 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  27059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27068 */     GIR_RootConstrainSelectedInstOperands,
     /*  27069 */     // GIR_Coverage, 1801,
     /*  27069 */     GIR_EraseRootFromParent_Done,
     /*  27070 */   // Label 444: @27070
     /*  27070 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27139), // Rule ID 13063 //
     /*  27075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27090 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27093 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27102 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27122 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27137 */     GIR_RootConstrainSelectedInstOperands,
     /*  27138 */     // GIR_Coverage, 13063,
     /*  27138 */     GIR_EraseRootFromParent_Done,
     /*  27139 */   // Label 445: @27139
     /*  27139 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27208), // Rule ID 13075 //
     /*  27144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27159 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27162 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27191 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27206 */     GIR_RootConstrainSelectedInstOperands,
     /*  27207 */     // GIR_Coverage, 13075,
     /*  27207 */     GIR_EraseRootFromParent_Done,
     /*  27208 */   // Label 446: @27208
     /*  27208 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27264), // Rule ID 13025 //
     /*  27213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27228 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27231 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27251 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27262 */     GIR_RootConstrainSelectedInstOperands,
     /*  27263 */     // GIR_Coverage, 13025,
     /*  27263 */     GIR_EraseRootFromParent_Done,
     /*  27264 */   // Label 447: @27264
     /*  27264 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27320), // Rule ID 13037 //
     /*  27269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27284 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27287 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27307 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27318 */     GIR_RootConstrainSelectedInstOperands,
     /*  27319 */     // GIR_Coverage, 13037,
     /*  27319 */     GIR_EraseRootFromParent_Done,
     /*  27320 */   // Label 448: @27320
     /*  27320 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27387), // Rule ID 13267 //
     /*  27325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27349 */     // MIs[1] imm
     /*  27349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27361 */     // MIs[2] Operand 1
     /*  27361 */     // No operand predicates
     /*  27361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27371 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27385 */     GIR_RootConstrainSelectedInstOperands,
     /*  27386 */     // GIR_Coverage, 13267,
     /*  27386 */     GIR_EraseRootFromParent_Done,
     /*  27387 */   // Label 449: @27387
     /*  27387 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(27454), // Rule ID 13288 //
     /*  27392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27416 */     // MIs[1] imm
     /*  27416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27428 */     // MIs[2] Operand 1
     /*  27428 */     // No operand predicates
     /*  27428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27438 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27452 */     GIR_RootConstrainSelectedInstOperands,
     /*  27453 */     // GIR_Coverage, 13288,
     /*  27453 */     GIR_EraseRootFromParent_Done,
     /*  27454 */   // Label 450: @27454
     /*  27454 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(27523), // Rule ID 1360 //
     /*  27459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27478 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27481 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27490 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27506 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27521 */     GIR_RootConstrainSelectedInstOperands,
     /*  27522 */     // GIR_Coverage, 1360,
     /*  27522 */     GIR_EraseRootFromParent_Done,
     /*  27523 */   // Label 451: @27523
     /*  27523 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(27592), // Rule ID 1483 //
     /*  27528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27547 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27550 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27559 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27575 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27590 */     GIR_RootConstrainSelectedInstOperands,
     /*  27591 */     // GIR_Coverage, 1483,
     /*  27591 */     GIR_EraseRootFromParent_Done,
     /*  27592 */   // Label 452: @27592
     /*  27592 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(27648), // Rule ID 988 //
     /*  27597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27616 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27619 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27635 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27646 */     GIR_RootConstrainSelectedInstOperands,
     /*  27647 */     // GIR_Coverage, 988,
     /*  27647 */     GIR_EraseRootFromParent_Done,
     /*  27648 */   // Label 453: @27648
     /*  27648 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(27704), // Rule ID 1049 //
     /*  27653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27691 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27702 */     GIR_RootConstrainSelectedInstOperands,
     /*  27703 */     // GIR_Coverage, 1049,
     /*  27703 */     GIR_EraseRootFromParent_Done,
     /*  27704 */   // Label 454: @27704
     /*  27704 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(27771), // Rule ID 2231 //
     /*  27709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27737 */     // MIs[1] imm
     /*  27737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27749 */     // MIs[2] Operand 1
     /*  27749 */     // No operand predicates
     /*  27749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27755 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27769 */     GIR_RootConstrainSelectedInstOperands,
     /*  27770 */     // GIR_Coverage, 2231,
     /*  27770 */     GIR_EraseRootFromParent_Done,
     /*  27771 */   // Label 455: @27771
     /*  27771 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(27838), // Rule ID 2290 //
     /*  27776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27804 */     // MIs[1] imm
     /*  27804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27812 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27816 */     // MIs[2] Operand 1
     /*  27816 */     // No operand predicates
     /*  27816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27822 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27836 */     GIR_RootConstrainSelectedInstOperands,
     /*  27837 */     // GIR_Coverage, 2290,
     /*  27837 */     GIR_EraseRootFromParent_Done,
     /*  27838 */   // Label 456: @27838
     /*  27838 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(27908), // Rule ID 6837 //
     /*  27843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  27855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  27881 */     // MIs[2] Rn
     /*  27881 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27886 */     // MIs[2] Rm
     /*  27886 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27893 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27906 */     GIR_RootConstrainSelectedInstOperands,
     /*  27907 */     // GIR_Coverage, 6837,
     /*  27907 */     GIR_EraseRootFromParent_Done,
     /*  27908 */   // Label 457: @27908
     /*  27908 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(27978), // Rule ID 13652 //
     /*  27913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  27925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  27951 */     // MIs[2] Rn
     /*  27951 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27956 */     // MIs[2] Rm
     /*  27956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27963 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27976 */     GIR_RootConstrainSelectedInstOperands,
     /*  27977 */     // GIR_Coverage, 13652,
     /*  27977 */     GIR_EraseRootFromParent_Done,
     /*  27978 */   // Label 458: @27978
     /*  27978 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28041), // Rule ID 1782 //
     /*  27983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28026 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28039 */     GIR_RootConstrainSelectedInstOperands,
     /*  28040 */     // GIR_Coverage, 1782,
     /*  28040 */     GIR_EraseRootFromParent_Done,
     /*  28041 */   // Label 459: @28041
     /*  28041 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28104), // Rule ID 1781 //
     /*  28046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28089 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28102 */     GIR_RootConstrainSelectedInstOperands,
     /*  28103 */     // GIR_Coverage, 1781,
     /*  28103 */     GIR_EraseRootFromParent_Done,
     /*  28104 */   // Label 460: @28104
     /*  28104 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28167), // Rule ID 1707 //
     /*  28109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28152 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  28155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28165 */     GIR_RootConstrainSelectedInstOperands,
     /*  28166 */     // GIR_Coverage, 1707,
     /*  28166 */     GIR_EraseRootFromParent_Done,
     /*  28167 */   // Label 461: @28167
     /*  28167 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28230), // Rule ID 1780 //
     /*  28172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28215 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28228 */     GIR_RootConstrainSelectedInstOperands,
     /*  28229 */     // GIR_Coverage, 1780,
     /*  28229 */     GIR_EraseRootFromParent_Done,
     /*  28230 */   // Label 462: @28230
     /*  28230 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(28293), // Rule ID 1779 //
     /*  28235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28278 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28291 */     GIR_RootConstrainSelectedInstOperands,
     /*  28292 */     // GIR_Coverage, 1779,
     /*  28292 */     GIR_EraseRootFromParent_Done,
     /*  28293 */   // Label 463: @28293
     /*  28293 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(28354), // Rule ID 13114 //
     /*  28298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28337 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28352 */     GIR_RootConstrainSelectedInstOperands,
     /*  28353 */     // GIR_Coverage, 13114,
     /*  28353 */     GIR_EraseRootFromParent_Done,
     /*  28354 */   // Label 464: @28354
     /*  28354 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(28415), // Rule ID 13144 //
     /*  28359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28398 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28413 */     GIR_RootConstrainSelectedInstOperands,
     /*  28414 */     // GIR_Coverage, 13144,
     /*  28414 */     GIR_EraseRootFromParent_Done,
     /*  28415 */   // Label 465: @28415
     /*  28415 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(28463), // Rule ID 13135 //
     /*  28420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28450 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28461 */     GIR_RootConstrainSelectedInstOperands,
     /*  28462 */     // GIR_Coverage, 13135,
     /*  28462 */     GIR_EraseRootFromParent_Done,
     /*  28463 */   // Label 466: @28463
     /*  28463 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(28511), // Rule ID 13024 //
     /*  28468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28498 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28509 */     GIR_RootConstrainSelectedInstOperands,
     /*  28510 */     // GIR_Coverage, 13024,
     /*  28510 */     GIR_EraseRootFromParent_Done,
     /*  28511 */   // Label 467: @28511
     /*  28511 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(28559), // Rule ID 13108 //
     /*  28516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28546 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28557 */     GIR_RootConstrainSelectedInstOperands,
     /*  28558 */     // GIR_Coverage, 13108,
     /*  28558 */     GIR_EraseRootFromParent_Done,
     /*  28559 */   // Label 468: @28559
     /*  28559 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(28607), // Rule ID 13036 //
     /*  28564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28594 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28605 */     GIR_RootConstrainSelectedInstOperands,
     /*  28606 */     // GIR_Coverage, 13036,
     /*  28606 */     GIR_EraseRootFromParent_Done,
     /*  28607 */   // Label 469: @28607
     /*  28607 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(28655), // Rule ID 13134 //
     /*  28612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28642 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28653 */     GIR_RootConstrainSelectedInstOperands,
     /*  28654 */     // GIR_Coverage, 13134,
     /*  28654 */     GIR_EraseRootFromParent_Done,
     /*  28655 */   // Label 470: @28655
     /*  28655 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(28716), // Rule ID 1719 //
     /*  28660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28699 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28714 */     GIR_RootConstrainSelectedInstOperands,
     /*  28715 */     // GIR_Coverage, 1719,
     /*  28715 */     GIR_EraseRootFromParent_Done,
     /*  28716 */   // Label 471: @28716
     /*  28716 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(28777), // Rule ID 1809 //
     /*  28721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28775 */     GIR_RootConstrainSelectedInstOperands,
     /*  28776 */     // GIR_Coverage, 1809,
     /*  28776 */     GIR_EraseRootFromParent_Done,
     /*  28777 */   // Label 472: @28777
     /*  28777 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(28825), // Rule ID 1800 //
     /*  28782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28812 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28823 */     GIR_RootConstrainSelectedInstOperands,
     /*  28824 */     // GIR_Coverage, 1800,
     /*  28824 */     GIR_EraseRootFromParent_Done,
     /*  28825 */   // Label 473: @28825
     /*  28825 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(28873), // Rule ID 987 //
     /*  28830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28860 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28871 */     GIR_RootConstrainSelectedInstOperands,
     /*  28872 */     // GIR_Coverage, 987,
     /*  28872 */     GIR_EraseRootFromParent_Done,
     /*  28873 */   // Label 474: @28873
     /*  28873 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(28921), // Rule ID 1713 //
     /*  28878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28908 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28919 */     GIR_RootConstrainSelectedInstOperands,
     /*  28920 */     // GIR_Coverage, 1713,
     /*  28920 */     GIR_EraseRootFromParent_Done,
     /*  28921 */   // Label 475: @28921
     /*  28921 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(28969), // Rule ID 1048 //
     /*  28926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28956 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28967 */     GIR_RootConstrainSelectedInstOperands,
     /*  28968 */     // GIR_Coverage, 1048,
     /*  28968 */     GIR_EraseRootFromParent_Done,
     /*  28969 */   // Label 476: @28969
     /*  28969 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29017), // Rule ID 1799 //
     /*  28974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29004 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  29007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  29015 */     GIR_RootConstrainSelectedInstOperands,
     /*  29016 */     // GIR_Coverage, 1799,
     /*  29016 */     GIR_EraseRootFromParent_Done,
     /*  29017 */   // Label 477: @29017
     /*  29017 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(29044), // Rule ID 1098 //
     /*  29022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29037 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  29042 */     GIR_RootConstrainSelectedInstOperands,
     /*  29043 */     // GIR_Coverage, 1098,
     /*  29043 */     GIR_Done,
     /*  29044 */   // Label 478: @29044
     /*  29044 */   GIM_Reject,
     /*  29045 */ // Label 397: @29045
     /*  29045 */ GIM_Reject,
     /*  29046 */ // Label 161: @29046
     /*  29046 */ GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(29895),
     /*  29051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29057 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(29190), // Rule ID 13657 //
     /*  29062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29107 */     // MIs[1] Operand 2
     /*  29107 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  29118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  29122 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29126 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29130 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29134 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29138 */     // MIs[5] Rn
     /*  29138 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29143 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29145 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29172 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29189 */     // GIR_Coverage, 13657,
     /*  29189 */     GIR_EraseRootFromParent_Done,
     /*  29190 */   // Label 480: @29190
     /*  29190 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(29323), // Rule ID 6842 //
     /*  29195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  29232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29244 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  29248 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29252 */     // MIs[4] Rn
     /*  29252 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29257 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  29261 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29265 */     // MIs[3] Operand 2
     /*  29265 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  29276 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29278 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29322 */     // GIR_Coverage, 6842,
     /*  29322 */     GIR_EraseRootFromParent_Done,
     /*  29323 */   // Label 481: @29323
     /*  29323 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(29392), // Rule ID 13053 //
     /*  29328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29375 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29390 */     GIR_RootConstrainSelectedInstOperands,
     /*  29391 */     // GIR_Coverage, 13053,
     /*  29391 */     GIR_EraseRootFromParent_Done,
     /*  29392 */   // Label 482: @29392
     /*  29392 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(29461), // Rule ID 13065 //
     /*  29397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29424 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29444 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29459 */     GIR_RootConstrainSelectedInstOperands,
     /*  29460 */     // GIR_Coverage, 13065,
     /*  29460 */     GIR_EraseRootFromParent_Done,
     /*  29461 */   // Label 483: @29461
     /*  29461 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(29528), // Rule ID 13257 //
     /*  29466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29490 */     // MIs[1] imm
     /*  29490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29498 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29502 */     // MIs[2] Operand 1
     /*  29502 */     // No operand predicates
     /*  29502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29512 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29526 */     GIR_RootConstrainSelectedInstOperands,
     /*  29527 */     // GIR_Coverage, 13257,
     /*  29527 */     GIR_EraseRootFromParent_Done,
     /*  29528 */   // Label 484: @29528
     /*  29528 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(29595), // Rule ID 13278 //
     /*  29533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29557 */     // MIs[1] imm
     /*  29557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29569 */     // MIs[2] Operand 1
     /*  29569 */     // No operand predicates
     /*  29569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29579 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29593 */     GIR_RootConstrainSelectedInstOperands,
     /*  29594 */     // GIR_Coverage, 13278,
     /*  29594 */     GIR_EraseRootFromParent_Done,
     /*  29595 */   // Label 485: @29595
     /*  29595 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(29664), // Rule ID 1350 //
     /*  29600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29619 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29622 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29631 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29647 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29662 */     GIR_RootConstrainSelectedInstOperands,
     /*  29663 */     // GIR_Coverage, 1350,
     /*  29663 */     GIR_EraseRootFromParent_Done,
     /*  29664 */   // Label 486: @29664
     /*  29664 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(29733), // Rule ID 1473 //
     /*  29669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29688 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29691 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29700 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29716 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29731 */     GIR_RootConstrainSelectedInstOperands,
     /*  29732 */     // GIR_Coverage, 1473,
     /*  29732 */     GIR_EraseRootFromParent_Done,
     /*  29733 */   // Label 487: @29733
     /*  29733 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(29800), // Rule ID 2221 //
     /*  29738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29766 */     // MIs[1] imm
     /*  29766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29778 */     // MIs[2] Operand 1
     /*  29778 */     // No operand predicates
     /*  29778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29784 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29798 */     GIR_RootConstrainSelectedInstOperands,
     /*  29799 */     // GIR_Coverage, 2221,
     /*  29799 */     GIR_EraseRootFromParent_Done,
     /*  29800 */   // Label 488: @29800
     /*  29800 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(29867), // Rule ID 2280 //
     /*  29805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29833 */     // MIs[1] imm
     /*  29833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29845 */     // MIs[2] Operand 1
     /*  29845 */     // No operand predicates
     /*  29845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29851 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29865 */     GIR_RootConstrainSelectedInstOperands,
     /*  29866 */     // GIR_Coverage, 2280,
     /*  29866 */     GIR_EraseRootFromParent_Done,
     /*  29867 */   // Label 489: @29867
     /*  29867 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(29894), // Rule ID 1093 //
     /*  29872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29887 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  29892 */     GIR_RootConstrainSelectedInstOperands,
     /*  29893 */     // GIR_Coverage, 1093,
     /*  29893 */     GIR_Done,
     /*  29894 */   // Label 490: @29894
     /*  29894 */   GIM_Reject,
     /*  29895 */ // Label 479: @29895
     /*  29895 */ GIM_Reject,
     /*  29896 */ // Label 162: @29896
     /*  29896 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(33473),
     /*  29901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29907 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(29994), // Rule ID 13097 //
     /*  29912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29939 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  29942 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29951 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29975 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  29975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  29978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  29987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  29992 */     GIR_RootConstrainSelectedInstOperands,
     /*  29993 */     // GIR_Coverage, 13097,
     /*  29993 */     GIR_EraseRootFromParent_Done,
     /*  29994 */   // Label 492: @29994
     /*  29994 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30081), // Rule ID 13121 //
     /*  29999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30026 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30029 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30038 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30062 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30079 */     GIR_RootConstrainSelectedInstOperands,
     /*  30080 */     // GIR_Coverage, 13121,
     /*  30080 */     GIR_EraseRootFromParent_Done,
     /*  30081 */   // Label 493: @30081
     /*  30081 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(30168), // Rule ID 1684 //
     /*  30086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30117 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30120 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30129 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30149 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  30152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30166 */     GIR_RootConstrainSelectedInstOperands,
     /*  30167 */     // GIR_Coverage, 1684,
     /*  30167 */     GIR_EraseRootFromParent_Done,
     /*  30168 */   // Label 494: @30168
     /*  30168 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30255), // Rule ID 1762 //
     /*  30173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30204 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30207 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30216 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30236 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30253 */     GIR_RootConstrainSelectedInstOperands,
     /*  30254 */     // GIR_Coverage, 1762,
     /*  30254 */     GIR_EraseRootFromParent_Done,
     /*  30255 */   // Label 495: @30255
     /*  30255 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30324), // Rule ID 1778 //
     /*  30260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30307 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30322 */     GIR_RootConstrainSelectedInstOperands,
     /*  30323 */     // GIR_Coverage, 1778,
     /*  30323 */     GIR_EraseRootFromParent_Done,
     /*  30324 */   // Label 496: @30324
     /*  30324 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(30393), // Rule ID 1777 //
     /*  30329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30376 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30391 */     GIR_RootConstrainSelectedInstOperands,
     /*  30392 */     // GIR_Coverage, 1777,
     /*  30392 */     GIR_EraseRootFromParent_Done,
     /*  30393 */   // Label 497: @30393
     /*  30393 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(30462), // Rule ID 1706 //
     /*  30398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30445 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  30448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30460 */     GIR_RootConstrainSelectedInstOperands,
     /*  30461 */     // GIR_Coverage, 1706,
     /*  30461 */     GIR_EraseRootFromParent_Done,
     /*  30462 */   // Label 498: @30462
     /*  30462 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(30531), // Rule ID 1776 //
     /*  30467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30514 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30529 */     GIR_RootConstrainSelectedInstOperands,
     /*  30530 */     // GIR_Coverage, 1776,
     /*  30530 */     GIR_EraseRootFromParent_Done,
     /*  30531 */   // Label 499: @30531
     /*  30531 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(30600), // Rule ID 1775 //
     /*  30536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30583 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30598 */     GIR_RootConstrainSelectedInstOperands,
     /*  30599 */     // GIR_Coverage, 1775,
     /*  30599 */     GIR_EraseRootFromParent_Done,
     /*  30600 */   // Label 500: @30600
     /*  30600 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(30667), // Rule ID 13113 //
     /*  30605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30648 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30665 */     GIR_RootConstrainSelectedInstOperands,
     /*  30666 */     // GIR_Coverage, 13113,
     /*  30666 */     GIR_EraseRootFromParent_Done,
     /*  30667 */   // Label 501: @30667
     /*  30667 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(30734), // Rule ID 13143 //
     /*  30672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30715 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30732 */     GIR_RootConstrainSelectedInstOperands,
     /*  30733 */     // GIR_Coverage, 13143,
     /*  30733 */     GIR_EraseRootFromParent_Done,
     /*  30734 */   // Label 502: @30734
     /*  30734 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(30801), // Rule ID 1718 //
     /*  30739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30782 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30799 */     GIR_RootConstrainSelectedInstOperands,
     /*  30800 */     // GIR_Coverage, 1718,
     /*  30800 */     GIR_EraseRootFromParent_Done,
     /*  30801 */   // Label 503: @30801
     /*  30801 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(30868), // Rule ID 1808 //
     /*  30806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30849 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30866 */     GIR_RootConstrainSelectedInstOperands,
     /*  30867 */     // GIR_Coverage, 1808,
     /*  30867 */     GIR_EraseRootFromParent_Done,
     /*  30868 */   // Label 504: @30868
     /*  30868 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(30949), // Rule ID 13095 //
     /*  30873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30900 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30903 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30912 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30932 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  30932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  30935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  30943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  30947 */     GIR_RootConstrainSelectedInstOperands,
     /*  30948 */     // GIR_Coverage, 13095,
     /*  30948 */     GIR_EraseRootFromParent_Done,
     /*  30949 */   // Label 505: @30949
     /*  30949 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31030), // Rule ID 13119 //
     /*  30954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30981 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30984 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30993 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31013 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31028 */     GIR_RootConstrainSelectedInstOperands,
     /*  31029 */     // GIR_Coverage, 13119,
     /*  31029 */     GIR_EraseRootFromParent_Done,
     /*  31030 */   // Label 506: @31030
     /*  31030 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31111), // Rule ID 1682 //
     /*  31035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31066 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31069 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31078 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31094 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  31097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31109 */     GIR_RootConstrainSelectedInstOperands,
     /*  31110 */     // GIR_Coverage, 1682,
     /*  31110 */     GIR_EraseRootFromParent_Done,
     /*  31111 */   // Label 507: @31111
     /*  31111 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31192), // Rule ID 1760 //
     /*  31116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31147 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31150 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31159 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31175 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31190 */     GIR_RootConstrainSelectedInstOperands,
     /*  31191 */     // GIR_Coverage, 1760,
     /*  31191 */     GIR_EraseRootFromParent_Done,
     /*  31192 */   // Label 508: @31192
     /*  31192 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31243), // Rule ID 13133 //
     /*  31197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31229 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31241 */     GIR_RootConstrainSelectedInstOperands,
     /*  31242 */     // GIR_Coverage, 13133,
     /*  31242 */     GIR_EraseRootFromParent_Done,
     /*  31243 */   // Label 509: @31243
     /*  31243 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31294), // Rule ID 13107 //
     /*  31248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31280 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31292 */     GIR_RootConstrainSelectedInstOperands,
     /*  31293 */     // GIR_Coverage, 13107,
     /*  31293 */     GIR_EraseRootFromParent_Done,
     /*  31294 */   // Label 510: @31294
     /*  31294 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31345), // Rule ID 13132 //
     /*  31299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31331 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31343 */     GIR_RootConstrainSelectedInstOperands,
     /*  31344 */     // GIR_Coverage, 13132,
     /*  31344 */     GIR_EraseRootFromParent_Done,
     /*  31345 */   // Label 511: @31345
     /*  31345 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(31396), // Rule ID 1798 //
     /*  31350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31382 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31394 */     GIR_RootConstrainSelectedInstOperands,
     /*  31395 */     // GIR_Coverage, 1798,
     /*  31395 */     GIR_EraseRootFromParent_Done,
     /*  31396 */   // Label 512: @31396
     /*  31396 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(31447), // Rule ID 1712 //
     /*  31401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31433 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31445 */     GIR_RootConstrainSelectedInstOperands,
     /*  31446 */     // GIR_Coverage, 1712,
     /*  31446 */     GIR_EraseRootFromParent_Done,
     /*  31447 */   // Label 513: @31447
     /*  31447 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(31498), // Rule ID 1797 //
     /*  31452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31484 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31496 */     GIR_RootConstrainSelectedInstOperands,
     /*  31497 */     // GIR_Coverage, 1797,
     /*  31497 */     GIR_EraseRootFromParent_Done,
     /*  31498 */   // Label 514: @31498
     /*  31498 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(31567), // Rule ID 13059 //
     /*  31503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31518 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31521 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31530 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31550 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31565 */     GIR_RootConstrainSelectedInstOperands,
     /*  31566 */     // GIR_Coverage, 13059,
     /*  31566 */     GIR_EraseRootFromParent_Done,
     /*  31567 */   // Label 515: @31567
     /*  31567 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(31636), // Rule ID 13071 //
     /*  31572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31587 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31590 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31619 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  31622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31634 */     GIR_RootConstrainSelectedInstOperands,
     /*  31635 */     // GIR_Coverage, 13071,
     /*  31635 */     GIR_EraseRootFromParent_Done,
     /*  31636 */   // Label 516: @31636
     /*  31636 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(31692), // Rule ID 13021 //
     /*  31641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31656 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31659 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  31664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31679 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  31682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31690 */     GIR_RootConstrainSelectedInstOperands,
     /*  31691 */     // GIR_Coverage, 13021,
     /*  31691 */     GIR_EraseRootFromParent_Done,
     /*  31692 */   // Label 517: @31692
     /*  31692 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(31748), // Rule ID 13033 //
     /*  31697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  31720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31735 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  31738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31746 */     GIR_RootConstrainSelectedInstOperands,
     /*  31747 */     // GIR_Coverage, 13033,
     /*  31747 */     GIR_EraseRootFromParent_Done,
     /*  31748 */   // Label 518: @31748
     /*  31748 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(31815), // Rule ID 13263 //
     /*  31753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31777 */     // MIs[1] imm
     /*  31777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31785 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31789 */     // MIs[2] Operand 1
     /*  31789 */     // No operand predicates
     /*  31789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31799 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  31802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31813 */     GIR_RootConstrainSelectedInstOperands,
     /*  31814 */     // GIR_Coverage, 13263,
     /*  31814 */     GIR_EraseRootFromParent_Done,
     /*  31815 */   // Label 519: @31815
     /*  31815 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(31882), // Rule ID 13284 //
     /*  31820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31844 */     // MIs[1] imm
     /*  31844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31856 */     // MIs[2] Operand 1
     /*  31856 */     // No operand predicates
     /*  31856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31866 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  31869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31880 */     GIR_RootConstrainSelectedInstOperands,
     /*  31881 */     // GIR_Coverage, 13284,
     /*  31881 */     GIR_EraseRootFromParent_Done,
     /*  31882 */   // Label 520: @31882
     /*  31882 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(31951), // Rule ID 1356 //
     /*  31887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31918 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31934 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31949 */     GIR_RootConstrainSelectedInstOperands,
     /*  31950 */     // GIR_Coverage, 1356,
     /*  31950 */     GIR_EraseRootFromParent_Done,
     /*  31951 */   // Label 521: @31951
     /*  31951 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32020), // Rule ID 1479 //
     /*  31956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31975 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31978 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32003 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  32003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  32006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32018 */     GIR_RootConstrainSelectedInstOperands,
     /*  32019 */     // GIR_Coverage, 1479,
     /*  32019 */     GIR_EraseRootFromParent_Done,
     /*  32020 */   // Label 522: @32020
     /*  32020 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32076), // Rule ID 984 //
     /*  32025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32044 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32047 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  32052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32063 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32074 */     GIR_RootConstrainSelectedInstOperands,
     /*  32075 */     // GIR_Coverage, 984,
     /*  32075 */     GIR_EraseRootFromParent_Done,
     /*  32076 */   // Label 523: @32076
     /*  32076 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32132), // Rule ID 1045 //
     /*  32081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32100 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32103 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  32108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32119 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  32122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32130 */     GIR_RootConstrainSelectedInstOperands,
     /*  32131 */     // GIR_Coverage, 1045,
     /*  32131 */     GIR_EraseRootFromParent_Done,
     /*  32132 */   // Label 524: @32132
     /*  32132 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32199), // Rule ID 2227 //
     /*  32137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32165 */     // MIs[1] imm
     /*  32165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32173 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32177 */     // MIs[2] Operand 1
     /*  32177 */     // No operand predicates
     /*  32177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32183 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  32186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32197 */     GIR_RootConstrainSelectedInstOperands,
     /*  32198 */     // GIR_Coverage, 2227,
     /*  32198 */     GIR_EraseRootFromParent_Done,
     /*  32199 */   // Label 525: @32199
     /*  32199 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(32266), // Rule ID 2286 //
     /*  32204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32232 */     // MIs[1] imm
     /*  32232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32244 */     // MIs[2] Operand 1
     /*  32244 */     // No operand predicates
     /*  32244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32250 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  32253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32264 */     GIR_RootConstrainSelectedInstOperands,
     /*  32265 */     // GIR_Coverage, 2286,
     /*  32265 */     GIR_EraseRootFromParent_Done,
     /*  32266 */   // Label 526: @32266
     /*  32266 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(32336), // Rule ID 6838 //
     /*  32271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  32283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  32309 */     // MIs[2] Rn
     /*  32309 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32314 */     // MIs[2] Rm
     /*  32314 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32321 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32334 */     GIR_RootConstrainSelectedInstOperands,
     /*  32335 */     // GIR_Coverage, 6838,
     /*  32335 */     GIR_EraseRootFromParent_Done,
     /*  32336 */   // Label 527: @32336
     /*  32336 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(32406), // Rule ID 13653 //
     /*  32341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  32353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  32379 */     // MIs[2] Rn
     /*  32379 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32384 */     // MIs[2] Rm
     /*  32384 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32391 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32404 */     GIR_RootConstrainSelectedInstOperands,
     /*  32405 */     // GIR_Coverage, 13653,
     /*  32405 */     GIR_EraseRootFromParent_Done,
     /*  32406 */   // Label 528: @32406
     /*  32406 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(32469), // Rule ID 1774 //
     /*  32411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32454 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32467 */     GIR_RootConstrainSelectedInstOperands,
     /*  32468 */     // GIR_Coverage, 1774,
     /*  32468 */     GIR_EraseRootFromParent_Done,
     /*  32469 */   // Label 529: @32469
     /*  32469 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(32532), // Rule ID 1773 //
     /*  32474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32517 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32530 */     GIR_RootConstrainSelectedInstOperands,
     /*  32531 */     // GIR_Coverage, 1773,
     /*  32531 */     GIR_EraseRootFromParent_Done,
     /*  32532 */   // Label 530: @32532
     /*  32532 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(32595), // Rule ID 1705 //
     /*  32537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32580 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  32583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32593 */     GIR_RootConstrainSelectedInstOperands,
     /*  32594 */     // GIR_Coverage, 1705,
     /*  32594 */     GIR_EraseRootFromParent_Done,
     /*  32595 */   // Label 531: @32595
     /*  32595 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(32658), // Rule ID 1772 //
     /*  32600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32643 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32656 */     GIR_RootConstrainSelectedInstOperands,
     /*  32657 */     // GIR_Coverage, 1772,
     /*  32657 */     GIR_EraseRootFromParent_Done,
     /*  32658 */   // Label 532: @32658
     /*  32658 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(32721), // Rule ID 1771 //
     /*  32663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32706 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32719 */     GIR_RootConstrainSelectedInstOperands,
     /*  32720 */     // GIR_Coverage, 1771,
     /*  32720 */     GIR_EraseRootFromParent_Done,
     /*  32721 */   // Label 533: @32721
     /*  32721 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(32782), // Rule ID 13112 //
     /*  32726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32765 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  32768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32780 */     GIR_RootConstrainSelectedInstOperands,
     /*  32781 */     // GIR_Coverage, 13112,
     /*  32781 */     GIR_EraseRootFromParent_Done,
     /*  32782 */   // Label 534: @32782
     /*  32782 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(32843), // Rule ID 13142 //
     /*  32787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32826 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  32829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32841 */     GIR_RootConstrainSelectedInstOperands,
     /*  32842 */     // GIR_Coverage, 13142,
     /*  32842 */     GIR_EraseRootFromParent_Done,
     /*  32843 */   // Label 535: @32843
     /*  32843 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(32891), // Rule ID 13131 //
     /*  32848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32878 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  32881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  32889 */     GIR_RootConstrainSelectedInstOperands,
     /*  32890 */     // GIR_Coverage, 13131,
     /*  32890 */     GIR_EraseRootFromParent_Done,
     /*  32891 */   // Label 536: @32891
     /*  32891 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(32939), // Rule ID 13020 //
     /*  32896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  32911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32926 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32937 */     GIR_RootConstrainSelectedInstOperands,
     /*  32938 */     // GIR_Coverage, 13020,
     /*  32938 */     GIR_EraseRootFromParent_Done,
     /*  32939 */   // Label 537: @32939
     /*  32939 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(32987), // Rule ID 13106 //
     /*  32944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32974 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  32977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  32985 */     GIR_RootConstrainSelectedInstOperands,
     /*  32986 */     // GIR_Coverage, 13106,
     /*  32986 */     GIR_EraseRootFromParent_Done,
     /*  32987 */   // Label 538: @32987
     /*  32987 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33035), // Rule ID 13032 //
     /*  32992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33022 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33033 */     GIR_RootConstrainSelectedInstOperands,
     /*  33034 */     // GIR_Coverage, 13032,
     /*  33034 */     GIR_EraseRootFromParent_Done,
     /*  33035 */   // Label 539: @33035
     /*  33035 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33083), // Rule ID 13130 //
     /*  33040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33070 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33081 */     GIR_RootConstrainSelectedInstOperands,
     /*  33082 */     // GIR_Coverage, 13130,
     /*  33082 */     GIR_EraseRootFromParent_Done,
     /*  33083 */   // Label 540: @33083
     /*  33083 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33144), // Rule ID 1717 //
     /*  33088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33127 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  33130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33142 */     GIR_RootConstrainSelectedInstOperands,
     /*  33143 */     // GIR_Coverage, 1717,
     /*  33143 */     GIR_EraseRootFromParent_Done,
     /*  33144 */   // Label 541: @33144
     /*  33144 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(33205), // Rule ID 1807 //
     /*  33149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33188 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  33191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33203 */     GIR_RootConstrainSelectedInstOperands,
     /*  33204 */     // GIR_Coverage, 1807,
     /*  33204 */     GIR_EraseRootFromParent_Done,
     /*  33205 */   // Label 542: @33205
     /*  33205 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(33253), // Rule ID 1796 //
     /*  33210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33240 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33251 */     GIR_RootConstrainSelectedInstOperands,
     /*  33252 */     // GIR_Coverage, 1796,
     /*  33252 */     GIR_EraseRootFromParent_Done,
     /*  33253 */   // Label 543: @33253
     /*  33253 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(33301), // Rule ID 983 //
     /*  33258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  33277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33288 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33299 */     GIR_RootConstrainSelectedInstOperands,
     /*  33300 */     // GIR_Coverage, 983,
     /*  33300 */     GIR_EraseRootFromParent_Done,
     /*  33301 */   // Label 544: @33301
     /*  33301 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(33349), // Rule ID 1711 //
     /*  33306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33336 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  33339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33347 */     GIR_RootConstrainSelectedInstOperands,
     /*  33348 */     // GIR_Coverage, 1711,
     /*  33348 */     GIR_EraseRootFromParent_Done,
     /*  33349 */   // Label 545: @33349
     /*  33349 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(33397), // Rule ID 1044 //
     /*  33354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33384 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33395 */     GIR_RootConstrainSelectedInstOperands,
     /*  33396 */     // GIR_Coverage, 1044,
     /*  33396 */     GIR_EraseRootFromParent_Done,
     /*  33397 */   // Label 546: @33397
     /*  33397 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(33445), // Rule ID 1795 //
     /*  33402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33432 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33443 */     GIR_RootConstrainSelectedInstOperands,
     /*  33444 */     // GIR_Coverage, 1795,
     /*  33444 */     GIR_EraseRootFromParent_Done,
     /*  33445 */   // Label 547: @33445
     /*  33445 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(33472), // Rule ID 1096 //
     /*  33450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33465 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  33470 */     GIR_RootConstrainSelectedInstOperands,
     /*  33471 */     // GIR_Coverage, 1096,
     /*  33471 */     GIR_Done,
     /*  33472 */   // Label 548: @33472
     /*  33472 */   GIM_Reject,
     /*  33473 */ // Label 491: @33473
     /*  33473 */ GIM_Reject,
     /*  33474 */ // Label 163: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34197),
     /*  33479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33485 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(33554), // Rule ID 13055 //
     /*  33490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33505 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33508 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33517 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33537 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33552 */     GIR_RootConstrainSelectedInstOperands,
     /*  33553 */     // GIR_Coverage, 13055,
     /*  33553 */     GIR_EraseRootFromParent_Done,
     /*  33554 */   // Label 550: @33554
     /*  33554 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(33623), // Rule ID 13067 //
     /*  33559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33574 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33577 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33606 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33621 */     GIR_RootConstrainSelectedInstOperands,
     /*  33622 */     // GIR_Coverage, 13067,
     /*  33622 */     GIR_EraseRootFromParent_Done,
     /*  33623 */   // Label 551: @33623
     /*  33623 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(33690), // Rule ID 13259 //
     /*  33628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33652 */     // MIs[1] imm
     /*  33652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33664 */     // MIs[2] Operand 1
     /*  33664 */     // No operand predicates
     /*  33664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33674 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33688 */     GIR_RootConstrainSelectedInstOperands,
     /*  33689 */     // GIR_Coverage, 13259,
     /*  33689 */     GIR_EraseRootFromParent_Done,
     /*  33690 */   // Label 552: @33690
     /*  33690 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(33757), // Rule ID 13280 //
     /*  33695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33719 */     // MIs[1] imm
     /*  33719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33727 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33731 */     // MIs[2] Operand 1
     /*  33731 */     // No operand predicates
     /*  33731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33741 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  33744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33755 */     GIR_RootConstrainSelectedInstOperands,
     /*  33756 */     // GIR_Coverage, 13280,
     /*  33756 */     GIR_EraseRootFromParent_Done,
     /*  33757 */   // Label 553: @33757
     /*  33757 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(33826), // Rule ID 1352 //
     /*  33762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33793 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33809 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33824 */     GIR_RootConstrainSelectedInstOperands,
     /*  33825 */     // GIR_Coverage, 1352,
     /*  33825 */     GIR_EraseRootFromParent_Done,
     /*  33826 */   // Label 554: @33826
     /*  33826 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(33895), // Rule ID 1475 //
     /*  33831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33850 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33853 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33862 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33878 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33893 */     GIR_RootConstrainSelectedInstOperands,
     /*  33894 */     // GIR_Coverage, 1475,
     /*  33894 */     GIR_EraseRootFromParent_Done,
     /*  33895 */   // Label 555: @33895
     /*  33895 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(33962), // Rule ID 2223 //
     /*  33900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33928 */     // MIs[1] imm
     /*  33928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33936 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33940 */     // MIs[2] Operand 1
     /*  33940 */     // No operand predicates
     /*  33940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33946 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33960 */     GIR_RootConstrainSelectedInstOperands,
     /*  33961 */     // GIR_Coverage, 2223,
     /*  33961 */     GIR_EraseRootFromParent_Done,
     /*  33962 */   // Label 556: @33962
     /*  33962 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34029), // Rule ID 2282 //
     /*  33967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33995 */     // MIs[1] imm
     /*  33995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34003 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  34007 */     // MIs[2] Operand 1
     /*  34007 */     // No operand predicates
     /*  34007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34013 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  34016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34027 */     GIR_RootConstrainSelectedInstOperands,
     /*  34028 */     // GIR_Coverage, 2282,
     /*  34028 */     GIR_EraseRootFromParent_Done,
     /*  34029 */   // Label 557: @34029
     /*  34029 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(34099), // Rule ID 6839 //
     /*  34034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34072 */     // MIs[2] Rn
     /*  34072 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34077 */     // MIs[2] Rm
     /*  34077 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34084 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34097 */     GIR_RootConstrainSelectedInstOperands,
     /*  34098 */     // GIR_Coverage, 6839,
     /*  34098 */     GIR_EraseRootFromParent_Done,
     /*  34099 */   // Label 558: @34099
     /*  34099 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(34169), // Rule ID 13654 //
     /*  34104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34142 */     // MIs[2] Rn
     /*  34142 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34147 */     // MIs[2] Rm
     /*  34147 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34154 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34167 */     GIR_RootConstrainSelectedInstOperands,
     /*  34168 */     // GIR_Coverage, 13654,
     /*  34168 */     GIR_EraseRootFromParent_Done,
     /*  34169 */   // Label 559: @34169
     /*  34169 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(34196), // Rule ID 1094 //
     /*  34174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34189 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  34189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  34194 */     GIR_RootConstrainSelectedInstOperands,
     /*  34195 */     // GIR_Coverage, 1094,
     /*  34195 */     GIR_Done,
     /*  34196 */   // Label 560: @34196
     /*  34196 */   GIM_Reject,
     /*  34197 */ // Label 549: @34197
     /*  34197 */ GIM_Reject,
     /*  34198 */ // Label 164: @34198
     /*  34198 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(34569),
     /*  34203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34213 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(34275), // Rule ID 14838 //
     /*  34218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34249 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34262 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34273 */     GIR_RootConstrainSelectedInstOperands,
     /*  34274 */     // GIR_Coverage, 14838,
     /*  34274 */     GIR_EraseRootFromParent_Done,
     /*  34275 */   // Label 562: @34275
     /*  34275 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(34337), // Rule ID 14837 //
     /*  34280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34311 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34324 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34335 */     GIR_RootConstrainSelectedInstOperands,
     /*  34336 */     // GIR_Coverage, 14837,
     /*  34336 */     GIR_EraseRootFromParent_Done,
     /*  34337 */   // Label 563: @34337
     /*  34337 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(34399), // Rule ID 14836 //
     /*  34342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34373 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34386 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34397 */     GIR_RootConstrainSelectedInstOperands,
     /*  34398 */     // GIR_Coverage, 14836,
     /*  34398 */     GIR_EraseRootFromParent_Done,
     /*  34399 */   // Label 564: @34399
     /*  34399 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(34461), // Rule ID 8734 //
     /*  34404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34435 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34448 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34459 */     GIR_RootConstrainSelectedInstOperands,
     /*  34460 */     // GIR_Coverage, 8734,
     /*  34460 */     GIR_EraseRootFromParent_Done,
     /*  34461 */   // Label 565: @34461
     /*  34461 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(34507), // Rule ID 14839 //
     /*  34466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34481 */     // MIs[1] Operand 2
     /*  34481 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34494 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34505 */     GIR_RootConstrainSelectedInstOperands,
     /*  34506 */     // GIR_Coverage, 14839,
     /*  34506 */     GIR_EraseRootFromParent_Done,
     /*  34507 */   // Label 566: @34507
     /*  34507 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34553), // Rule ID 8735 //
     /*  34512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34527 */     // MIs[1] Operand 2
     /*  34527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34540 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34551 */     GIR_RootConstrainSelectedInstOperands,
     /*  34552 */     // GIR_Coverage, 8735,
     /*  34552 */     GIR_EraseRootFromParent_Done,
     /*  34553 */   // Label 567: @34553
     /*  34553 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(34568), // Rule ID 2766 //
     /*  34558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34561 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  34566 */     GIR_RootConstrainSelectedInstOperands,
     /*  34567 */     // GIR_Coverage, 2766,
     /*  34567 */     GIR_Done,
     /*  34568 */   // Label 568: @34568
     /*  34568 */   GIM_Reject,
     /*  34569 */ // Label 561: @34569
     /*  34569 */ GIM_Reject,
     /*  34570 */ // Label 165: @34570
     /*  34570 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(34595), // Rule ID 2765 //
     /*  34575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  34581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  34584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34588 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  34588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  34593 */   GIR_RootConstrainSelectedInstOperands,
     /*  34594 */   // GIR_Coverage, 2765,
     /*  34594 */   GIR_Done,
     /*  34595 */ // Label 569: @34595
     /*  34595 */ GIM_Reject,
     /*  34596 */ // Label 166: @34596
     /*  34596 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(34621), // Rule ID 2764 //
     /*  34601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  34607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  34610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34614 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  34614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  34619 */   GIR_RootConstrainSelectedInstOperands,
     /*  34620 */   // GIR_Coverage, 2764,
     /*  34620 */   GIR_Done,
     /*  34621 */ // Label 570: @34621
     /*  34621 */ GIM_Reject,
     /*  34622 */ // Label 167: @34622
     /*  34622 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(34647), // Rule ID 2763 //
     /*  34627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  34633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  34636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34640 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  34640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  34645 */   GIR_RootConstrainSelectedInstOperands,
     /*  34646 */   // GIR_Coverage, 2763,
     /*  34646 */   GIR_Done,
     /*  34647 */ // Label 571: @34647
     /*  34647 */ GIM_Reject,
     /*  34648 */ // Label 168: @34648
     /*  34648 */ GIM_Reject,
     /*  34649 */ // Label 1: @34649
     /*  34649 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 585*/ GIMT_Encode4(47996),
     /*  34660 */ /*GILLT_s32*//*Label 572*/ GIMT_Encode4(34748),
     /*  34664 */ /*GILLT_s64*//*Label 573*/ GIMT_Encode4(35602), GIMT_Encode4(0),
     /*  34672 */ /*GILLT_v2s32*//*Label 574*/ GIMT_Encode4(38632),
     /*  34676 */ /*GILLT_v2s64*//*Label 575*/ GIMT_Encode4(40123),
     /*  34680 */ /*GILLT_v4s16*//*Label 576*/ GIMT_Encode4(42583),
     /*  34684 */ /*GILLT_v4s32*//*Label 577*/ GIMT_Encode4(44074),
     /*  34688 */ /*GILLT_v8s8*//*Label 578*/ GIMT_Encode4(46534),
     /*  34692 */ /*GILLT_v8s16*//*Label 579*/ GIMT_Encode4(46609),
     /*  34696 */ /*GILLT_v16s8*//*Label 580*/ GIMT_Encode4(47817), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34716 */ /*GILLT_nxv2s64*//*Label 581*/ GIMT_Encode4(47892), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34728 */ /*GILLT_nxv4s32*//*Label 582*/ GIMT_Encode4(47918), GIMT_Encode4(0),
     /*  34736 */ /*GILLT_nxv8s16*//*Label 583*/ GIMT_Encode4(47944), GIMT_Encode4(0),
     /*  34744 */ /*GILLT_nxv16s8*//*Label 584*/ GIMT_Encode4(47970),
     /*  34748 */ // Label 572: @34748
     /*  34748 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(35601),
     /*  34753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  34756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  34759 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(34911), // Rule ID 9781 //
     /*  34764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34795 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34798 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  34803 */     // MIs[2] pattern
     /*  34803 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34806 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34813 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34813 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34816 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34820 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  34834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34839 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  34842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  34846 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  34849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  34867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  34871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34876 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  34883 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  34886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  34900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  34910 */     // GIR_Coverage, 9781,
     /*  34910 */     GIR_EraseRootFromParent_Done,
     /*  34911 */   // Label 587: @34911
     /*  34911 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(35063), // Rule ID 9793 //
     /*  34916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34947 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34950 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  34955 */     // MIs[2] pattern
     /*  34955 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34958 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34965 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  34986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34991 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  34994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  34998 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  35023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35028 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35062 */     // GIR_Coverage, 9793,
     /*  35062 */     GIR_EraseRootFromParent_Done,
     /*  35063 */   // Label 588: @35063
     /*  35063 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(35215), // Rule ID 9805 //
     /*  35068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35099 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35102 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  35107 */     // MIs[2] pattern
     /*  35107 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35110 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35117 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35117 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35120 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35124 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35143 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35150 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  35175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35214 */     // GIR_Coverage, 9805,
     /*  35214 */     GIR_EraseRootFromParent_Done,
     /*  35215 */   // Label 589: @35215
     /*  35215 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(35367), // Rule ID 9817 //
     /*  35220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35251 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35254 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  35259 */     // MIs[2] pattern
     /*  35259 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35262 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35269 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35269 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35272 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35276 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35295 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  35327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35366 */     // GIR_Coverage, 9817,
     /*  35366 */     GIR_EraseRootFromParent_Done,
     /*  35367 */   // Label 590: @35367
     /*  35367 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(35429), // Rule ID 3895 //
     /*  35372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  35380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35408 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  35408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  35411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35421 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35427 */     GIR_RootConstrainSelectedInstOperands,
     /*  35428 */     // GIR_Coverage, 3895,
     /*  35428 */     GIR_EraseRootFromParent_Done,
     /*  35429 */   // Label 591: @35429
     /*  35429 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(35465), // Rule ID 3860 //
     /*  35434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  35449 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  35449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  35452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35454 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  35456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  35460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35463 */     GIR_RootConstrainSelectedInstOperands,
     /*  35464 */     // GIR_Coverage, 3860,
     /*  35464 */     GIR_EraseRootFromParent_Done,
     /*  35465 */   // Label 592: @35465
     /*  35465 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(35498), // Rule ID 3865 //
     /*  35470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  35485 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  35488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35496 */     GIR_RootConstrainSelectedInstOperands,
     /*  35497 */     // GIR_Coverage, 3865,
     /*  35497 */     GIR_EraseRootFromParent_Done,
     /*  35498 */   // Label 593: @35498
     /*  35498 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(35534), // Rule ID 3854 //
     /*  35503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  35518 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  35521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35532 */     GIR_RootConstrainSelectedInstOperands,
     /*  35533 */     // GIR_Coverage, 3854,
     /*  35533 */     GIR_EraseRootFromParent_Done,
     /*  35534 */   // Label 594: @35534
     /*  35534 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(35570), // Rule ID 3858 //
     /*  35539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  35554 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  35554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  35557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  35565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35568 */     GIR_RootConstrainSelectedInstOperands,
     /*  35569 */     // GIR_Coverage, 3858,
     /*  35569 */     GIR_EraseRootFromParent_Done,
     /*  35570 */   // Label 595: @35570
     /*  35570 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(35600), // Rule ID 3856 //
     /*  35575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35587 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  35587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  35592 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  35598 */     GIR_RootConstrainSelectedInstOperands,
     /*  35599 */     // GIR_Coverage, 3856,
     /*  35599 */     GIR_Done,
     /*  35600 */   // Label 596: @35600
     /*  35600 */   GIM_Reject,
     /*  35601 */ // Label 586: @35601
     /*  35601 */ GIM_Reject,
     /*  35602 */ // Label 573: @35602
     /*  35602 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(38631),
     /*  35607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  35613 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(35749), // Rule ID 5337 //
     /*  35618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35651 */     // MIs[1] Operand 2
     /*  35651 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35682 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35686 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35691 */     // MIs[3] Operand 2
     /*  35691 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35702 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35704 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35731 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35748 */     // GIR_Coverage, 5337,
     /*  35748 */     GIR_EraseRootFromParent_Done,
     /*  35749 */   // Label 598: @35749
     /*  35749 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(35885), // Rule ID 5336 //
     /*  35754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35787 */     // MIs[1] Operand 2
     /*  35787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35822 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35827 */     // MIs[3] Operand 2
     /*  35827 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35838 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35840 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35867 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35884 */     // GIR_Coverage, 5336,
     /*  35884 */     GIR_EraseRootFromParent_Done,
     /*  35885 */   // Label 599: @35885
     /*  35885 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36021), // Rule ID 5346 //
     /*  35890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35923 */     // MIs[1] Operand 2
     /*  35923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35954 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35958 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35963 */     // MIs[3] Operand 2
     /*  35963 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35976 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  35983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36020 */     // GIR_Coverage, 5346,
     /*  36020 */     GIR_EraseRootFromParent_Done,
     /*  36021 */   // Label 600: @36021
     /*  36021 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36157), // Rule ID 5335 //
     /*  36026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36059 */     // MIs[1] Operand 2
     /*  36059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36082 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36086 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  36090 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36094 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36099 */     // MIs[3] Operand 2
     /*  36099 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36112 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36139 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36156 */     // GIR_Coverage, 5335,
     /*  36156 */     GIR_EraseRootFromParent_Done,
     /*  36157 */   // Label 601: @36157
     /*  36157 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36293), // Rule ID 5334 //
     /*  36162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36195 */     // MIs[1] Operand 2
     /*  36195 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36230 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36235 */     // MIs[3] Operand 2
     /*  36235 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36248 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36292 */     // GIR_Coverage, 5334,
     /*  36292 */     GIR_EraseRootFromParent_Done,
     /*  36293 */   // Label 602: @36293
     /*  36293 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36430), // Rule ID 3912 //
     /*  36298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36339 */     // MIs[2] Operand 2
     /*  36339 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36362 */     // MIs[3] Operand 1
     /*  36362 */     // No operand predicates
     /*  36362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36364 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36376 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36395 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36428 */     GIR_RootConstrainSelectedInstOperands,
     /*  36429 */     // GIR_Coverage, 3912,
     /*  36429 */     GIR_EraseRootFromParent_Done,
     /*  36430 */   // Label 603: @36430
     /*  36430 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36529), // Rule ID 3910 //
     /*  36435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36484 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36488 */     // MIs[3] Operand 1
     /*  36488 */     // No operand predicates
     /*  36488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36490 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36502 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36527 */     GIR_RootConstrainSelectedInstOperands,
     /*  36528 */     // GIR_Coverage, 3910,
     /*  36528 */     GIR_EraseRootFromParent_Done,
     /*  36529 */   // Label 604: @36529
     /*  36529 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(36628), // Rule ID 3911 //
     /*  36534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36583 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  36587 */     // MIs[3] Operand 1
     /*  36587 */     // No operand predicates
     /*  36587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36589 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36601 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36626 */     GIR_RootConstrainSelectedInstOperands,
     /*  36627 */     // GIR_Coverage, 3911,
     /*  36627 */     GIR_EraseRootFromParent_Done,
     /*  36628 */   // Label 605: @36628
     /*  36628 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36714), // Rule ID 3905 //
     /*  36633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36686 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36693 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36712 */     GIR_RootConstrainSelectedInstOperands,
     /*  36713 */     // GIR_Coverage, 3905,
     /*  36713 */     GIR_EraseRootFromParent_Done,
     /*  36714 */   // Label 606: @36714
     /*  36714 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(36800), // Rule ID 3906 //
     /*  36719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36772 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36779 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36798 */     GIR_RootConstrainSelectedInstOperands,
     /*  36799 */     // GIR_Coverage, 3906,
     /*  36799 */     GIR_EraseRootFromParent_Done,
     /*  36800 */   // Label 607: @36800
     /*  36800 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(36933), // Rule ID 3918 //
     /*  36805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36846 */     // MIs[2] Operand 2
     /*  36846 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36869 */     // MIs[3] Operand 1
     /*  36869 */     // No operand predicates
     /*  36869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36871 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  36871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36883 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  36931 */     GIR_RootConstrainSelectedInstOperands,
     /*  36932 */     // GIR_Coverage, 3918,
     /*  36932 */     GIR_EraseRootFromParent_Done,
     /*  36933 */   // Label 608: @36933
     /*  36933 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37028), // Rule ID 3916 //
     /*  36938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36987 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36991 */     // MIs[3] Operand 1
     /*  36991 */     // No operand predicates
     /*  36991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36993 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  36993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37005 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37026 */     GIR_RootConstrainSelectedInstOperands,
     /*  37027 */     // GIR_Coverage, 3916,
     /*  37027 */     GIR_EraseRootFromParent_Done,
     /*  37028 */   // Label 609: @37028
     /*  37028 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37123), // Rule ID 3917 //
     /*  37033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37082 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  37086 */     // MIs[3] Operand 1
     /*  37086 */     // No operand predicates
     /*  37086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37088 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37100 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37121 */     GIR_RootConstrainSelectedInstOperands,
     /*  37122 */     // GIR_Coverage, 3917,
     /*  37122 */     GIR_EraseRootFromParent_Done,
     /*  37123 */   // Label 610: @37123
     /*  37123 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37205), // Rule ID 124 //
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37181 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37188 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37203 */     GIR_RootConstrainSelectedInstOperands,
     /*  37204 */     // GIR_Coverage, 124,
     /*  37204 */     GIR_EraseRootFromParent_Done,
     /*  37205 */   // Label 611: @37205
     /*  37205 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37287), // Rule ID 126 //
     /*  37210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37263 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37270 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37285 */     GIR_RootConstrainSelectedInstOperands,
     /*  37286 */     // GIR_Coverage, 126,
     /*  37286 */     GIR_EraseRootFromParent_Done,
     /*  37287 */   // Label 612: @37287
     /*  37287 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37349), // Rule ID 3896 //
     /*  37292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37328 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  37328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  37331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37347 */     GIR_RootConstrainSelectedInstOperands,
     /*  37348 */     // GIR_Coverage, 3896,
     /*  37348 */     GIR_EraseRootFromParent_Done,
     /*  37349 */   // Label 613: @37349
     /*  37349 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37407), // Rule ID 9778 //
     /*  37354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37373 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37376 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37381 */     // MIs[1] pattern
     /*  37381 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37384 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37391 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37405 */     GIR_RootConstrainSelectedInstOperands,
     /*  37406 */     // GIR_Coverage, 9778,
     /*  37406 */     GIR_EraseRootFromParent_Done,
     /*  37407 */   // Label 614: @37407
     /*  37407 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37465), // Rule ID 9790 //
     /*  37412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37431 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37434 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37439 */     // MIs[1] pattern
     /*  37439 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37442 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37449 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37463 */     GIR_RootConstrainSelectedInstOperands,
     /*  37464 */     // GIR_Coverage, 9790,
     /*  37464 */     GIR_EraseRootFromParent_Done,
     /*  37465 */   // Label 615: @37465
     /*  37465 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(37523), // Rule ID 9802 //
     /*  37470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37489 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37492 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37497 */     // MIs[1] pattern
     /*  37497 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37500 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37507 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37521 */     GIR_RootConstrainSelectedInstOperands,
     /*  37522 */     // GIR_Coverage, 9802,
     /*  37522 */     GIR_EraseRootFromParent_Done,
     /*  37523 */   // Label 616: @37523
     /*  37523 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(37581), // Rule ID 9814 //
     /*  37528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37547 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37550 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37555 */     // MIs[1] pattern
     /*  37555 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37558 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37565 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37579 */     GIR_RootConstrainSelectedInstOperands,
     /*  37580 */     // GIR_Coverage, 9814,
     /*  37580 */     GIR_EraseRootFromParent_Done,
     /*  37581 */   // Label 617: @37581
     /*  37581 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(37744), // Rule ID 5301 //
     /*  37586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  37614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37632 */     // MIs[1] Operand 2
     /*  37632 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37645 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37671 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  37703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37743 */     // GIR_Coverage, 5301,
     /*  37743 */     GIR_EraseRootFromParent_Done,
     /*  37744 */   // Label 618: @37744
     /*  37744 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(37907), // Rule ID 5298 //
     /*  37749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  37777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37795 */     // MIs[1] Operand 2
     /*  37795 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37808 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37808 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37811 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37815 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37834 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  37866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37889 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37906 */     // GIR_Coverage, 5298,
     /*  37906 */     GIR_EraseRootFromParent_Done,
     /*  37907 */   // Label 619: @37907
     /*  37907 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38057), // Rule ID 5343 //
     /*  37912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  37940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37949 */     // MIs[1] Operand 2
     /*  37949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37962 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37962 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37965 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37969 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37988 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37995 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38039 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38056 */     // GIR_Coverage, 5343,
     /*  38056 */     GIR_EraseRootFromParent_Done,
     /*  38057 */   // Label 620: @38057
     /*  38057 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38207), // Rule ID 5349 //
     /*  38062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38099 */     // MIs[1] Operand 2
     /*  38099 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38112 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38112 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38115 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38119 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38138 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38141 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38145 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  38170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38206 */     // GIR_Coverage, 5349,
     /*  38206 */     GIR_EraseRootFromParent_Done,
     /*  38207 */   // Label 621: @38207
     /*  38207 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38357), // Rule ID 5342 //
     /*  38212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38249 */     // MIs[1] Operand 2
     /*  38249 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38262 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38262 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38265 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38269 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38276 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38279 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38283 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38288 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38295 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38298 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38303 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38339 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38356 */     // GIR_Coverage, 5342,
     /*  38356 */     GIR_EraseRootFromParent_Done,
     /*  38357 */   // Label 622: @38357
     /*  38357 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38393), // Rule ID 3861 //
     /*  38362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  38377 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  38377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  38380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38382 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38391 */     GIR_RootConstrainSelectedInstOperands,
     /*  38392 */     // GIR_Coverage, 3861,
     /*  38392 */     GIR_EraseRootFromParent_Done,
     /*  38393 */   // Label 623: @38393
     /*  38393 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38426), // Rule ID 3866 //
     /*  38398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  38413 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  38416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38424 */     GIR_RootConstrainSelectedInstOperands,
     /*  38425 */     // GIR_Coverage, 3866,
     /*  38425 */     GIR_EraseRootFromParent_Done,
     /*  38426 */   // Label 624: @38426
     /*  38426 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38462), // Rule ID 3855 //
     /*  38431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  38446 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  38449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38460 */     GIR_RootConstrainSelectedInstOperands,
     /*  38461 */     // GIR_Coverage, 3855,
     /*  38461 */     GIR_EraseRootFromParent_Done,
     /*  38462 */   // Label 625: @38462
     /*  38462 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(38498), // Rule ID 3859 //
     /*  38467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  38482 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  38482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  38485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38496 */     GIR_RootConstrainSelectedInstOperands,
     /*  38497 */     // GIR_Coverage, 3859,
     /*  38497 */     GIR_EraseRootFromParent_Done,
     /*  38498 */   // Label 626: @38498
     /*  38498 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(38537), // Rule ID 1648 //
     /*  38503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38514 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38528 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  38528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38535 */     GIR_RootConstrainSelectedInstOperands,
     /*  38536 */     // GIR_Coverage, 1648,
     /*  38536 */     GIR_EraseRootFromParent_Done,
     /*  38537 */   // Label 627: @38537
     /*  38537 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(38573), // Rule ID 5184 //
     /*  38542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38550 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38556 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38564 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  38564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38571 */     GIR_RootConstrainSelectedInstOperands,
     /*  38572 */     // GIR_Coverage, 5184,
     /*  38572 */     GIR_EraseRootFromParent_Done,
     /*  38573 */   // Label 628: @38573
     /*  38573 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(38600), // Rule ID 1637 //
     /*  38578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38593 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  38593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  38598 */     GIR_RootConstrainSelectedInstOperands,
     /*  38599 */     // GIR_Coverage, 1637,
     /*  38599 */     GIR_Done,
     /*  38600 */   // Label 629: @38600
     /*  38600 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(38630), // Rule ID 3857 //
     /*  38605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38617 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  38617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  38622 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38628 */     GIR_RootConstrainSelectedInstOperands,
     /*  38629 */     // GIR_Coverage, 3857,
     /*  38629 */     GIR_Done,
     /*  38630 */   // Label 630: @38630
     /*  38630 */   GIM_Reject,
     /*  38631 */ // Label 597: @38631
     /*  38631 */ GIM_Reject,
     /*  38632 */ // Label 574: @38632
     /*  38632 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(40122),
     /*  38637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38647 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(38779), // Rule ID 5333 //
     /*  38652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38681 */     // MIs[1] Operand 2
     /*  38681 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38716 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38721 */     // MIs[3] Operand 2
     /*  38721 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38732 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38734 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38761 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38778 */     // GIR_Coverage, 5333,
     /*  38778 */     GIR_EraseRootFromParent_Done,
     /*  38779 */   // Label 632: @38779
     /*  38779 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(38911), // Rule ID 5332 //
     /*  38784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38813 */     // MIs[1] Operand 2
     /*  38813 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38840 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38844 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38848 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38853 */     // MIs[3] Operand 2
     /*  38853 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38866 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38910 */     // GIR_Coverage, 5332,
     /*  38910 */     GIR_EraseRootFromParent_Done,
     /*  38911 */   // Label 633: @38911
     /*  38911 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39043), // Rule ID 5345 //
     /*  38916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38945 */     // MIs[1] Operand 2
     /*  38945 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38976 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38980 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38985 */     // MIs[3] Operand 2
     /*  38985 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38998 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  39005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39025 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39042 */     // GIR_Coverage, 5345,
     /*  39042 */     GIR_EraseRootFromParent_Done,
     /*  39043 */   // Label 634: @39043
     /*  39043 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39175), // Rule ID 5331 //
     /*  39048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39077 */     // MIs[1] Operand 2
     /*  39077 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39108 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39112 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39117 */     // MIs[3] Operand 2
     /*  39117 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39128 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39130 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39157 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39174 */     // GIR_Coverage, 5331,
     /*  39174 */     GIR_EraseRootFromParent_Done,
     /*  39175 */   // Label 635: @39175
     /*  39175 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39307), // Rule ID 5330 //
     /*  39180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39209 */     // MIs[1] Operand 2
     /*  39209 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39236 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39240 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39244 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39249 */     // MIs[3] Operand 2
     /*  39249 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39260 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39262 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39289 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39306 */     // GIR_Coverage, 5330,
     /*  39306 */     GIR_EraseRootFromParent_Done,
     /*  39307 */   // Label 636: @39307
     /*  39307 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(39466), // Rule ID 5300 //
     /*  39312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39354 */     // MIs[1] Operand 2
     /*  39354 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39367 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39367 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39370 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39374 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39381 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39384 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39388 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39393 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39396 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39400 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39403 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  39425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39448 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39465 */     // GIR_Coverage, 5300,
     /*  39465 */     GIR_EraseRootFromParent_Done,
     /*  39466 */   // Label 637: @39466
     /*  39466 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(39625), // Rule ID 5297 //
     /*  39471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  39495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39513 */     // MIs[1] Operand 2
     /*  39513 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39526 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39526 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39529 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39533 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39552 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39555 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39559 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39562 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39567 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  39584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39624 */     // GIR_Coverage, 5297,
     /*  39624 */     GIR_EraseRootFromParent_Done,
     /*  39625 */   // Label 638: @39625
     /*  39625 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(39771), // Rule ID 5341 //
     /*  39630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39663 */     // MIs[1] Operand 2
     /*  39663 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39676 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  39734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39770 */     // GIR_Coverage, 5341,
     /*  39770 */     GIR_EraseRootFromParent_Done,
     /*  39771 */   // Label 639: @39771
     /*  39771 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(39917), // Rule ID 5348 //
     /*  39776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39809 */     // MIs[1] Operand 2
     /*  39809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39822 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39848 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39855 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  39880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39899 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39916 */     // GIR_Coverage, 5348,
     /*  39916 */     GIR_EraseRootFromParent_Done,
     /*  39917 */   // Label 640: @39917
     /*  39917 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40063), // Rule ID 5340 //
     /*  39922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39955 */     // MIs[1] Operand 2
     /*  39955 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39968 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39968 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39971 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39975 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39994 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39997 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40001 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  40022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  40026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40031 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40062 */     // GIR_Coverage, 5340,
     /*  40062 */     GIR_EraseRootFromParent_Done,
     /*  40063 */   // Label 641: @40063
     /*  40063 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40098), // Rule ID 962 //
     /*  40068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  40083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40089 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  40089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  40092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  40096 */     GIR_RootConstrainSelectedInstOperands,
     /*  40097 */     // GIR_Coverage, 962,
     /*  40097 */     GIR_EraseRootFromParent_Done,
     /*  40098 */   // Label 642: @40098
     /*  40098 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40121), // Rule ID 1469 //
     /*  40103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40114 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  40114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  40119 */     GIR_RootConstrainSelectedInstOperands,
     /*  40120 */     // GIR_Coverage, 1469,
     /*  40120 */     GIR_Done,
     /*  40121 */   // Label 643: @40121
     /*  40121 */   GIM_Reject,
     /*  40122 */ // Label 631: @40122
     /*  40122 */ GIM_Reject,
     /*  40123 */ // Label 575: @40123
     /*  40123 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(42582),
     /*  40128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  40134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40138 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40252), // Rule ID 2041 //
     /*  40143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40194 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40199 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40203 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40207 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40211 */     // MIs[4] Operand 1
     /*  40211 */     // No operand predicates
     /*  40211 */     // MIs[2] Operand 2
     /*  40211 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40231 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40250 */     GIR_RootConstrainSelectedInstOperands,
     /*  40251 */     // GIR_Coverage, 2041,
     /*  40251 */     GIR_EraseRootFromParent_Done,
     /*  40252 */   // Label 645: @40252
     /*  40252 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40366), // Rule ID 13207 //
     /*  40257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40317 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40321 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40325 */     // MIs[4] Operand 1
     /*  40325 */     // No operand predicates
     /*  40325 */     // MIs[2] Operand 2
     /*  40325 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40336 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40345 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40364 */     GIR_RootConstrainSelectedInstOperands,
     /*  40365 */     // GIR_Coverage, 13207,
     /*  40365 */     GIR_EraseRootFromParent_Done,
     /*  40366 */   // Label 646: @40366
     /*  40366 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40480), // Rule ID 2093 //
     /*  40371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40422 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40435 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40439 */     // MIs[4] Operand 1
     /*  40439 */     // No operand predicates
     /*  40439 */     // MIs[2] Operand 2
     /*  40439 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40450 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40459 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40478 */     GIR_RootConstrainSelectedInstOperands,
     /*  40479 */     // GIR_Coverage, 2093,
     /*  40479 */     GIR_EraseRootFromParent_Done,
     /*  40480 */   // Label 647: @40480
     /*  40480 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(40594), // Rule ID 13237 //
     /*  40485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40532 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40536 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40545 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40549 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40553 */     // MIs[4] Operand 1
     /*  40553 */     // No operand predicates
     /*  40553 */     // MIs[2] Operand 2
     /*  40553 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40564 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40573 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40592 */     GIR_RootConstrainSelectedInstOperands,
     /*  40593 */     // GIR_Coverage, 13237,
     /*  40593 */     GIR_EraseRootFromParent_Done,
     /*  40594 */   // Label 648: @40594
     /*  40594 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40659), // Rule ID 1848 //
     /*  40599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40642 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40657 */     GIR_RootConstrainSelectedInstOperands,
     /*  40658 */     // GIR_Coverage, 1848,
     /*  40658 */     GIR_EraseRootFromParent_Done,
     /*  40659 */   // Label 649: @40659
     /*  40659 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(40724), // Rule ID 1847 //
     /*  40664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40707 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40722 */     GIR_RootConstrainSelectedInstOperands,
     /*  40723 */     // GIR_Coverage, 1847,
     /*  40723 */     GIR_EraseRootFromParent_Done,
     /*  40724 */   // Label 650: @40724
     /*  40724 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(40789), // Rule ID 1752 //
     /*  40729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40772 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  40775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40787 */     GIR_RootConstrainSelectedInstOperands,
     /*  40788 */     // GIR_Coverage, 1752,
     /*  40788 */     GIR_EraseRootFromParent_Done,
     /*  40789 */   // Label 651: @40789
     /*  40789 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(40854), // Rule ID 1846 //
     /*  40794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40837 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40852 */     GIR_RootConstrainSelectedInstOperands,
     /*  40853 */     // GIR_Coverage, 1846,
     /*  40853 */     GIR_EraseRootFromParent_Done,
     /*  40854 */   // Label 652: @40854
     /*  40854 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(40919), // Rule ID 1845 //
     /*  40859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40902 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40917 */     GIR_RootConstrainSelectedInstOperands,
     /*  40918 */     // GIR_Coverage, 1845,
     /*  40918 */     GIR_EraseRootFromParent_Done,
     /*  40919 */   // Label 653: @40919
     /*  40919 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41030), // Rule ID 13205 //
     /*  40924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40971 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40975 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40984 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40988 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40992 */     // MIs[4] Operand 1
     /*  40992 */     // No operand predicates
     /*  40992 */     // MIs[2] Operand 2
     /*  40992 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41008 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41010 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41028 */     GIR_RootConstrainSelectedInstOperands,
     /*  41029 */     // GIR_Coverage, 13205,
     /*  41029 */     GIR_EraseRootFromParent_Done,
     /*  41030 */   // Label 654: @41030
     /*  41030 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41141), // Rule ID 2039 //
     /*  41035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41096 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41100 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41104 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41108 */     // MIs[4] Operand 1
     /*  41108 */     // No operand predicates
     /*  41108 */     // MIs[2] Operand 2
     /*  41108 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41119 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41121 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41139 */     GIR_RootConstrainSelectedInstOperands,
     /*  41140 */     // GIR_Coverage, 2039,
     /*  41140 */     GIR_EraseRootFromParent_Done,
     /*  41141 */   // Label 655: @41141
     /*  41141 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41252), // Rule ID 13235 //
     /*  41146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41193 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41210 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41214 */     // MIs[4] Operand 1
     /*  41214 */     // No operand predicates
     /*  41214 */     // MIs[2] Operand 2
     /*  41214 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41230 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41232 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41250 */     GIR_RootConstrainSelectedInstOperands,
     /*  41251 */     // GIR_Coverage, 13235,
     /*  41251 */     GIR_EraseRootFromParent_Done,
     /*  41252 */   // Label 656: @41252
     /*  41252 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41363), // Rule ID 2091 //
     /*  41257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41326 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41330 */     // MIs[4] Operand 1
     /*  41330 */     // No operand predicates
     /*  41330 */     // MIs[2] Operand 2
     /*  41330 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41341 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41343 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41361 */     GIR_RootConstrainSelectedInstOperands,
     /*  41362 */     // GIR_Coverage, 2091,
     /*  41362 */     GIR_EraseRootFromParent_Done,
     /*  41363 */   // Label 657: @41363
     /*  41363 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41426), // Rule ID 1728 //
     /*  41368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41407 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  41410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41424 */     GIR_RootConstrainSelectedInstOperands,
     /*  41425 */     // GIR_Coverage, 1728,
     /*  41425 */     GIR_EraseRootFromParent_Done,
     /*  41426 */   // Label 658: @41426
     /*  41426 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41489), // Rule ID 1818 //
     /*  41431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41470 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  41473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41487 */     GIR_RootConstrainSelectedInstOperands,
     /*  41488 */     // GIR_Coverage, 1818,
     /*  41488 */     GIR_EraseRootFromParent_Done,
     /*  41489 */   // Label 659: @41489
     /*  41489 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41577), // Rule ID 13206 //
     /*  41494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41546 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41550 */     // MIs[3] Operand 1
     /*  41550 */     // No operand predicates
     /*  41550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41557 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41575 */     GIR_RootConstrainSelectedInstOperands,
     /*  41576 */     // GIR_Coverage, 13206,
     /*  41576 */     GIR_EraseRootFromParent_Done,
     /*  41577 */   // Label 660: @41577
     /*  41577 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41665), // Rule ID 2040 //
     /*  41582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41639 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41643 */     // MIs[3] Operand 1
     /*  41643 */     // No operand predicates
     /*  41643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41645 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41663 */     GIR_RootConstrainSelectedInstOperands,
     /*  41664 */     // GIR_Coverage, 2040,
     /*  41664 */     GIR_EraseRootFromParent_Done,
     /*  41665 */   // Label 661: @41665
     /*  41665 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(41753), // Rule ID 13236 //
     /*  41670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41726 */     // MIs[3] Operand 1
     /*  41726 */     // No operand predicates
     /*  41726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41733 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41751 */     GIR_RootConstrainSelectedInstOperands,
     /*  41752 */     // GIR_Coverage, 13236,
     /*  41752 */     GIR_EraseRootFromParent_Done,
     /*  41753 */   // Label 662: @41753
     /*  41753 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(41841), // Rule ID 2092 //
     /*  41758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41819 */     // MIs[3] Operand 1
     /*  41819 */     // No operand predicates
     /*  41819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41821 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41839 */     GIR_RootConstrainSelectedInstOperands,
     /*  41840 */     // GIR_Coverage, 2092,
     /*  41840 */     GIR_EraseRootFromParent_Done,
     /*  41841 */   // Label 663: @41841
     /*  41841 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(41888), // Rule ID 1860 //
     /*  41846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41874 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41886 */     GIR_RootConstrainSelectedInstOperands,
     /*  41887 */     // GIR_Coverage, 1860,
     /*  41887 */     GIR_EraseRootFromParent_Done,
     /*  41888 */   // Label 664: @41888
     /*  41888 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(41935), // Rule ID 1758 //
     /*  41893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41921 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  41924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41933 */     GIR_RootConstrainSelectedInstOperands,
     /*  41934 */     // GIR_Coverage, 1758,
     /*  41934 */     GIR_EraseRootFromParent_Done,
     /*  41935 */   // Label 665: @41935
     /*  41935 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(41982), // Rule ID 1859 //
     /*  41940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41968 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41980 */     GIR_RootConstrainSelectedInstOperands,
     /*  41981 */     // GIR_Coverage, 1859,
     /*  41981 */     GIR_EraseRootFromParent_Done,
     /*  41982 */   // Label 666: @41982
     /*  41982 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42041), // Rule ID 1844 //
     /*  41987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42026 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42039 */     GIR_RootConstrainSelectedInstOperands,
     /*  42040 */     // GIR_Coverage, 1844,
     /*  42040 */     GIR_EraseRootFromParent_Done,
     /*  42041 */   // Label 667: @42041
     /*  42041 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42100), // Rule ID 1843 //
     /*  42046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42085 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42098 */     GIR_RootConstrainSelectedInstOperands,
     /*  42099 */     // GIR_Coverage, 1843,
     /*  42099 */     GIR_EraseRootFromParent_Done,
     /*  42100 */   // Label 668: @42100
     /*  42100 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42159), // Rule ID 1751 //
     /*  42105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42144 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  42147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42157 */     GIR_RootConstrainSelectedInstOperands,
     /*  42158 */     // GIR_Coverage, 1751,
     /*  42158 */     GIR_EraseRootFromParent_Done,
     /*  42159 */   // Label 669: @42159
     /*  42159 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42218), // Rule ID 1842 //
     /*  42164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42203 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42216 */     GIR_RootConstrainSelectedInstOperands,
     /*  42217 */     // GIR_Coverage, 1842,
     /*  42217 */     GIR_EraseRootFromParent_Done,
     /*  42218 */   // Label 670: @42218
     /*  42218 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(42277), // Rule ID 1841 //
     /*  42223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42262 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42275 */     GIR_RootConstrainSelectedInstOperands,
     /*  42276 */     // GIR_Coverage, 1841,
     /*  42276 */     GIR_EraseRootFromParent_Done,
     /*  42277 */   // Label 671: @42277
     /*  42277 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(42312), // Rule ID 964 //
     /*  42282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42289 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42295 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42303 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  42303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  42306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42310 */     GIR_RootConstrainSelectedInstOperands,
     /*  42311 */     // GIR_Coverage, 964,
     /*  42311 */     GIR_EraseRootFromParent_Done,
     /*  42312 */   // Label 672: @42312
     /*  42312 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(42369), // Rule ID 1727 //
     /*  42317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42352 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  42355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42367 */     GIR_RootConstrainSelectedInstOperands,
     /*  42368 */     // GIR_Coverage, 1727,
     /*  42368 */     GIR_EraseRootFromParent_Done,
     /*  42369 */   // Label 673: @42369
     /*  42369 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(42426), // Rule ID 1817 //
     /*  42374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  42389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42409 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  42412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42424 */     GIR_RootConstrainSelectedInstOperands,
     /*  42425 */     // GIR_Coverage, 1817,
     /*  42425 */     GIR_EraseRootFromParent_Done,
     /*  42426 */   // Label 674: @42426
     /*  42426 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(42470), // Rule ID 1858 //
     /*  42431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42457 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42468 */     GIR_RootConstrainSelectedInstOperands,
     /*  42469 */     // GIR_Coverage, 1858,
     /*  42469 */     GIR_EraseRootFromParent_Done,
     /*  42470 */   // Label 675: @42470
     /*  42470 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(42514), // Rule ID 1757 //
     /*  42475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42501 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  42504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42512 */     GIR_RootConstrainSelectedInstOperands,
     /*  42513 */     // GIR_Coverage, 1757,
     /*  42513 */     GIR_EraseRootFromParent_Done,
     /*  42514 */   // Label 676: @42514
     /*  42514 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(42558), // Rule ID 1857 //
     /*  42519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42545 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42556 */     GIR_RootConstrainSelectedInstOperands,
     /*  42557 */     // GIR_Coverage, 1857,
     /*  42557 */     GIR_EraseRootFromParent_Done,
     /*  42558 */   // Label 677: @42558
     /*  42558 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(42581), // Rule ID 1471 //
     /*  42563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42574 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  42574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  42579 */     GIR_RootConstrainSelectedInstOperands,
     /*  42580 */     // GIR_Coverage, 1471,
     /*  42580 */     GIR_Done,
     /*  42581 */   // Label 678: @42581
     /*  42581 */   GIM_Reject,
     /*  42582 */ // Label 644: @42582
     /*  42582 */ GIM_Reject,
     /*  42583 */ // Label 576: @42583
     /*  42583 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44073),
     /*  42588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42598 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(42730), // Rule ID 5329 //
     /*  42603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42632 */     // MIs[1] Operand 2
     /*  42632 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42655 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42659 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42663 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42667 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42672 */     // MIs[3] Operand 2
     /*  42672 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42683 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42685 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42712 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42729 */     // GIR_Coverage, 5329,
     /*  42729 */     GIR_EraseRootFromParent_Done,
     /*  42730 */   // Label 680: @42730
     /*  42730 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(42862), // Rule ID 5328 //
     /*  42735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42764 */     // MIs[1] Operand 2
     /*  42764 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42783 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42787 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42791 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42795 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42799 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42804 */     // MIs[3] Operand 2
     /*  42804 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42815 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42817 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42844 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42861 */     // GIR_Coverage, 5328,
     /*  42861 */     GIR_EraseRootFromParent_Done,
     /*  42862 */   // Label 681: @42862
     /*  42862 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(42994), // Rule ID 5344 //
     /*  42867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42896 */     // MIs[1] Operand 2
     /*  42896 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42923 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42927 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42931 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42936 */     // MIs[3] Operand 2
     /*  42936 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42947 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42949 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  42956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42976 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42993 */     // GIR_Coverage, 5344,
     /*  42993 */     GIR_EraseRootFromParent_Done,
     /*  42994 */   // Label 682: @42994
     /*  42994 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(43126), // Rule ID 5327 //
     /*  42999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43028 */     // MIs[1] Operand 2
     /*  43028 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43051 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43055 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43059 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43063 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43068 */     // MIs[3] Operand 2
     /*  43068 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43079 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43081 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43108 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43125 */     // GIR_Coverage, 5327,
     /*  43125 */     GIR_EraseRootFromParent_Done,
     /*  43126 */   // Label 683: @43126
     /*  43126 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(43258), // Rule ID 5326 //
     /*  43131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43160 */     // MIs[1] Operand 2
     /*  43160 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43187 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43191 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43195 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43200 */     // MIs[3] Operand 2
     /*  43200 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43211 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43213 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43240 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43257 */     // GIR_Coverage, 5326,
     /*  43257 */     GIR_EraseRootFromParent_Done,
     /*  43258 */   // Label 684: @43258
     /*  43258 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(43417), // Rule ID 5299 //
     /*  43263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43305 */     // MIs[1] Operand 2
     /*  43305 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43318 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43351 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  43376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43399 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43416 */     // GIR_Coverage, 5299,
     /*  43416 */     GIR_EraseRootFromParent_Done,
     /*  43417 */   // Label 685: @43417
     /*  43417 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(43576), // Rule ID 5296 //
     /*  43422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43464 */     // MIs[1] Operand 2
     /*  43464 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43477 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43477 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43480 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43484 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43503 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43506 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43510 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43513 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43518 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43523 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  43535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43540 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43558 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43575 */     // GIR_Coverage, 5296,
     /*  43575 */     GIR_EraseRootFromParent_Done,
     /*  43576 */   // Label 686: @43576
     /*  43576 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(43722), // Rule ID 5339 //
     /*  43581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43614 */     // MIs[1] Operand 2
     /*  43614 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43627 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43704 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43721 */     // GIR_Coverage, 5339,
     /*  43721 */     GIR_EraseRootFromParent_Done,
     /*  43722 */   // Label 687: @43722
     /*  43722 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(43868), // Rule ID 5347 //
     /*  43727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43760 */     // MIs[1] Operand 2
     /*  43760 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43773 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43776 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43780 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43799 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43806 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  43831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43836 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43867 */     // GIR_Coverage, 5347,
     /*  43867 */     GIR_EraseRootFromParent_Done,
     /*  43868 */   // Label 688: @43868
     /*  43868 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44014), // Rule ID 5338 //
     /*  43873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43906 */     // MIs[1] Operand 2
     /*  43906 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43919 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43919 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43922 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43926 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43945 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43948 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43952 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43955 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43960 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43965 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43996 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  44003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44013 */     // GIR_Coverage, 5338,
     /*  44013 */     GIR_EraseRootFromParent_Done,
     /*  44014 */   // Label 689: @44014
     /*  44014 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44049), // Rule ID 960 //
     /*  44019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44026 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44032 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44040 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  44040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  44043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44047 */     GIR_RootConstrainSelectedInstOperands,
     /*  44048 */     // GIR_Coverage, 960,
     /*  44048 */     GIR_EraseRootFromParent_Done,
     /*  44049 */   // Label 690: @44049
     /*  44049 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44072), // Rule ID 1467 //
     /*  44054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44065 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  44065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  44070 */     GIR_RootConstrainSelectedInstOperands,
     /*  44071 */     // GIR_Coverage, 1467,
     /*  44071 */     GIR_Done,
     /*  44072 */   // Label 691: @44072
     /*  44072 */   GIM_Reject,
     /*  44073 */ // Label 679: @44073
     /*  44073 */ GIM_Reject,
     /*  44074 */ // Label 577: @44074
     /*  44074 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(46533),
     /*  44079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44089 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44203), // Rule ID 2038 //
     /*  44094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44158 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44162 */     // MIs[4] Operand 1
     /*  44162 */     // No operand predicates
     /*  44162 */     // MIs[2] Operand 2
     /*  44162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44182 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44201 */     GIR_RootConstrainSelectedInstOperands,
     /*  44202 */     // GIR_Coverage, 2038,
     /*  44202 */     GIR_EraseRootFromParent_Done,
     /*  44203 */   // Label 693: @44203
     /*  44203 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44317), // Rule ID 13204 //
     /*  44208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44251 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44255 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44268 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44272 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44276 */     // MIs[4] Operand 1
     /*  44276 */     // No operand predicates
     /*  44276 */     // MIs[2] Operand 2
     /*  44276 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44287 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44296 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44315 */     GIR_RootConstrainSelectedInstOperands,
     /*  44316 */     // GIR_Coverage, 13204,
     /*  44316 */     GIR_EraseRootFromParent_Done,
     /*  44317 */   // Label 694: @44317
     /*  44317 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44431), // Rule ID 2090 //
     /*  44322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44365 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44369 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44373 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44378 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44382 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44386 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44390 */     // MIs[4] Operand 1
     /*  44390 */     // No operand predicates
     /*  44390 */     // MIs[2] Operand 2
     /*  44390 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44401 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44410 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44429 */     GIR_RootConstrainSelectedInstOperands,
     /*  44430 */     // GIR_Coverage, 2090,
     /*  44430 */     GIR_EraseRootFromParent_Done,
     /*  44431 */   // Label 695: @44431
     /*  44431 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44545), // Rule ID 13234 //
     /*  44436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44479 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44483 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44487 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44492 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44496 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44500 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44504 */     // MIs[4] Operand 1
     /*  44504 */     // No operand predicates
     /*  44504 */     // MIs[2] Operand 2
     /*  44504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44515 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44524 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44543 */     GIR_RootConstrainSelectedInstOperands,
     /*  44544 */     // GIR_Coverage, 13234,
     /*  44544 */     GIR_EraseRootFromParent_Done,
     /*  44545 */   // Label 696: @44545
     /*  44545 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44610), // Rule ID 1840 //
     /*  44550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44593 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44608 */     GIR_RootConstrainSelectedInstOperands,
     /*  44609 */     // GIR_Coverage, 1840,
     /*  44609 */     GIR_EraseRootFromParent_Done,
     /*  44610 */   // Label 697: @44610
     /*  44610 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(44675), // Rule ID 1839 //
     /*  44615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44658 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44673 */     GIR_RootConstrainSelectedInstOperands,
     /*  44674 */     // GIR_Coverage, 1839,
     /*  44674 */     GIR_EraseRootFromParent_Done,
     /*  44675 */   // Label 698: @44675
     /*  44675 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(44740), // Rule ID 1750 //
     /*  44680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44723 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  44726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44738 */     GIR_RootConstrainSelectedInstOperands,
     /*  44739 */     // GIR_Coverage, 1750,
     /*  44739 */     GIR_EraseRootFromParent_Done,
     /*  44740 */   // Label 699: @44740
     /*  44740 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(44805), // Rule ID 1838 //
     /*  44745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44788 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44803 */     GIR_RootConstrainSelectedInstOperands,
     /*  44804 */     // GIR_Coverage, 1838,
     /*  44804 */     GIR_EraseRootFromParent_Done,
     /*  44805 */   // Label 700: @44805
     /*  44805 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(44870), // Rule ID 1837 //
     /*  44810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44853 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44868 */     GIR_RootConstrainSelectedInstOperands,
     /*  44869 */     // GIR_Coverage, 1837,
     /*  44869 */     GIR_EraseRootFromParent_Done,
     /*  44870 */   // Label 701: @44870
     /*  44870 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(44981), // Rule ID 13202 //
     /*  44875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44926 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44931 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44935 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44939 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44943 */     // MIs[4] Operand 1
     /*  44943 */     // No operand predicates
     /*  44943 */     // MIs[2] Operand 2
     /*  44943 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44959 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44961 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  44964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44979 */     GIR_RootConstrainSelectedInstOperands,
     /*  44980 */     // GIR_Coverage, 13202,
     /*  44980 */     GIR_EraseRootFromParent_Done,
     /*  44981 */   // Label 702: @44981
     /*  44981 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45092), // Rule ID 2036 //
     /*  44986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45055 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45059 */     // MIs[4] Operand 1
     /*  45059 */     // No operand predicates
     /*  45059 */     // MIs[2] Operand 2
     /*  45059 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45072 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45090 */     GIR_RootConstrainSelectedInstOperands,
     /*  45091 */     // GIR_Coverage, 2036,
     /*  45091 */     GIR_EraseRootFromParent_Done,
     /*  45092 */   // Label 703: @45092
     /*  45092 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45203), // Rule ID 13232 //
     /*  45097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45144 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45148 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45153 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45157 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45161 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45165 */     // MIs[4] Operand 1
     /*  45165 */     // No operand predicates
     /*  45165 */     // MIs[2] Operand 2
     /*  45165 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45181 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45183 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45201 */     GIR_RootConstrainSelectedInstOperands,
     /*  45202 */     // GIR_Coverage, 13232,
     /*  45202 */     GIR_EraseRootFromParent_Done,
     /*  45203 */   // Label 704: @45203
     /*  45203 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45314), // Rule ID 2088 //
     /*  45208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45260 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45264 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45269 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45273 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45277 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45281 */     // MIs[4] Operand 1
     /*  45281 */     // No operand predicates
     /*  45281 */     // MIs[2] Operand 2
     /*  45281 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45292 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45294 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45312 */     GIR_RootConstrainSelectedInstOperands,
     /*  45313 */     // GIR_Coverage, 2088,
     /*  45313 */     GIR_EraseRootFromParent_Done,
     /*  45314 */   // Label 705: @45314
     /*  45314 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45377), // Rule ID 1726 //
     /*  45319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45358 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  45361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45375 */     GIR_RootConstrainSelectedInstOperands,
     /*  45376 */     // GIR_Coverage, 1726,
     /*  45376 */     GIR_EraseRootFromParent_Done,
     /*  45377 */   // Label 706: @45377
     /*  45377 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45440), // Rule ID 1816 //
     /*  45382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45421 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  45424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45438 */     GIR_RootConstrainSelectedInstOperands,
     /*  45439 */     // GIR_Coverage, 1816,
     /*  45439 */     GIR_EraseRootFromParent_Done,
     /*  45440 */   // Label 707: @45440
     /*  45440 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45528), // Rule ID 13203 //
     /*  45445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45497 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45501 */     // MIs[3] Operand 1
     /*  45501 */     // No operand predicates
     /*  45501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45508 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45526 */     GIR_RootConstrainSelectedInstOperands,
     /*  45527 */     // GIR_Coverage, 13203,
     /*  45527 */     GIR_EraseRootFromParent_Done,
     /*  45528 */   // Label 708: @45528
     /*  45528 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45616), // Rule ID 2037 //
     /*  45533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45594 */     // MIs[3] Operand 1
     /*  45594 */     // No operand predicates
     /*  45594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45596 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45614 */     GIR_RootConstrainSelectedInstOperands,
     /*  45615 */     // GIR_Coverage, 2037,
     /*  45615 */     GIR_EraseRootFromParent_Done,
     /*  45616 */   // Label 709: @45616
     /*  45616 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45704), // Rule ID 13233 //
     /*  45621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45677 */     // MIs[3] Operand 1
     /*  45677 */     // No operand predicates
     /*  45677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45684 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45702 */     GIR_RootConstrainSelectedInstOperands,
     /*  45703 */     // GIR_Coverage, 13233,
     /*  45703 */     GIR_EraseRootFromParent_Done,
     /*  45704 */   // Label 710: @45704
     /*  45704 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(45792), // Rule ID 2089 //
     /*  45709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45766 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45770 */     // MIs[3] Operand 1
     /*  45770 */     // No operand predicates
     /*  45770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45772 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45790 */     GIR_RootConstrainSelectedInstOperands,
     /*  45791 */     // GIR_Coverage, 2089,
     /*  45791 */     GIR_EraseRootFromParent_Done,
     /*  45792 */   // Label 711: @45792
     /*  45792 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(45839), // Rule ID 1856 //
     /*  45797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45825 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45837 */     GIR_RootConstrainSelectedInstOperands,
     /*  45838 */     // GIR_Coverage, 1856,
     /*  45838 */     GIR_EraseRootFromParent_Done,
     /*  45839 */   // Label 712: @45839
     /*  45839 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(45886), // Rule ID 1756 //
     /*  45844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45872 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  45875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45884 */     GIR_RootConstrainSelectedInstOperands,
     /*  45885 */     // GIR_Coverage, 1756,
     /*  45885 */     GIR_EraseRootFromParent_Done,
     /*  45886 */   // Label 713: @45886
     /*  45886 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(45933), // Rule ID 1855 //
     /*  45891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45919 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45931 */     GIR_RootConstrainSelectedInstOperands,
     /*  45932 */     // GIR_Coverage, 1855,
     /*  45932 */     GIR_EraseRootFromParent_Done,
     /*  45933 */   // Label 714: @45933
     /*  45933 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(45992), // Rule ID 1836 //
     /*  45938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45977 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  45977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  45980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45990 */     GIR_RootConstrainSelectedInstOperands,
     /*  45991 */     // GIR_Coverage, 1836,
     /*  45991 */     GIR_EraseRootFromParent_Done,
     /*  45992 */   // Label 715: @45992
     /*  45992 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46051), // Rule ID 1835 //
     /*  45997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46036 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46049 */     GIR_RootConstrainSelectedInstOperands,
     /*  46050 */     // GIR_Coverage, 1835,
     /*  46050 */     GIR_EraseRootFromParent_Done,
     /*  46051 */   // Label 716: @46051
     /*  46051 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46110), // Rule ID 1749 //
     /*  46056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46095 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  46098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46108 */     GIR_RootConstrainSelectedInstOperands,
     /*  46109 */     // GIR_Coverage, 1749,
     /*  46109 */     GIR_EraseRootFromParent_Done,
     /*  46110 */   // Label 717: @46110
     /*  46110 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46169), // Rule ID 1834 //
     /*  46115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46154 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46167 */     GIR_RootConstrainSelectedInstOperands,
     /*  46168 */     // GIR_Coverage, 1834,
     /*  46168 */     GIR_EraseRootFromParent_Done,
     /*  46169 */   // Label 718: @46169
     /*  46169 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(46228), // Rule ID 1833 //
     /*  46174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46213 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46226 */     GIR_RootConstrainSelectedInstOperands,
     /*  46227 */     // GIR_Coverage, 1833,
     /*  46227 */     GIR_EraseRootFromParent_Done,
     /*  46228 */   // Label 719: @46228
     /*  46228 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(46263), // Rule ID 963 //
     /*  46233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46240 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46246 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46254 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  46254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  46257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46261 */     GIR_RootConstrainSelectedInstOperands,
     /*  46262 */     // GIR_Coverage, 963,
     /*  46262 */     GIR_EraseRootFromParent_Done,
     /*  46263 */   // Label 720: @46263
     /*  46263 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(46320), // Rule ID 1725 //
     /*  46268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46303 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  46306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46318 */     GIR_RootConstrainSelectedInstOperands,
     /*  46319 */     // GIR_Coverage, 1725,
     /*  46319 */     GIR_EraseRootFromParent_Done,
     /*  46320 */   // Label 721: @46320
     /*  46320 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(46377), // Rule ID 1815 //
     /*  46325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46360 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  46363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46375 */     GIR_RootConstrainSelectedInstOperands,
     /*  46376 */     // GIR_Coverage, 1815,
     /*  46376 */     GIR_EraseRootFromParent_Done,
     /*  46377 */   // Label 722: @46377
     /*  46377 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(46421), // Rule ID 1854 //
     /*  46382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46408 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46419 */     GIR_RootConstrainSelectedInstOperands,
     /*  46420 */     // GIR_Coverage, 1854,
     /*  46420 */     GIR_EraseRootFromParent_Done,
     /*  46421 */   // Label 723: @46421
     /*  46421 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(46465), // Rule ID 1755 //
     /*  46426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46452 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  46455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46463 */     GIR_RootConstrainSelectedInstOperands,
     /*  46464 */     // GIR_Coverage, 1755,
     /*  46464 */     GIR_EraseRootFromParent_Done,
     /*  46465 */   // Label 724: @46465
     /*  46465 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(46509), // Rule ID 1853 //
     /*  46470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46496 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46507 */     GIR_RootConstrainSelectedInstOperands,
     /*  46508 */     // GIR_Coverage, 1853,
     /*  46508 */     GIR_EraseRootFromParent_Done,
     /*  46509 */   // Label 725: @46509
     /*  46509 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(46532), // Rule ID 1470 //
     /*  46514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46525 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  46525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  46530 */     GIR_RootConstrainSelectedInstOperands,
     /*  46531 */     // GIR_Coverage, 1470,
     /*  46531 */     GIR_Done,
     /*  46532 */   // Label 726: @46532
     /*  46532 */   GIM_Reject,
     /*  46533 */ // Label 692: @46533
     /*  46533 */ GIM_Reject,
     /*  46534 */ // Label 578: @46534
     /*  46534 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(46608),
     /*  46539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46549 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(46584), // Rule ID 958 //
     /*  46554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46561 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46567 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46575 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  46575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  46578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46582 */     GIR_RootConstrainSelectedInstOperands,
     /*  46583 */     // GIR_Coverage, 958,
     /*  46583 */     GIR_EraseRootFromParent_Done,
     /*  46584 */   // Label 728: @46584
     /*  46584 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(46607), // Rule ID 1465 //
     /*  46589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46600 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  46600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  46605 */     GIR_RootConstrainSelectedInstOperands,
     /*  46606 */     // GIR_Coverage, 1465,
     /*  46606 */     GIR_Done,
     /*  46607 */   // Label 729: @46607
     /*  46607 */   GIM_Reject,
     /*  46608 */ // Label 727: @46608
     /*  46608 */ GIM_Reject,
     /*  46609 */ // Label 579: @46609
     /*  46609 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(47816),
     /*  46614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  46620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46624 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(46689), // Rule ID 1832 //
     /*  46629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46672 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46687 */     GIR_RootConstrainSelectedInstOperands,
     /*  46688 */     // GIR_Coverage, 1832,
     /*  46688 */     GIR_EraseRootFromParent_Done,
     /*  46689 */   // Label 731: @46689
     /*  46689 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(46754), // Rule ID 1831 //
     /*  46694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46737 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46752 */     GIR_RootConstrainSelectedInstOperands,
     /*  46753 */     // GIR_Coverage, 1831,
     /*  46753 */     GIR_EraseRootFromParent_Done,
     /*  46754 */   // Label 732: @46754
     /*  46754 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(46819), // Rule ID 1748 //
     /*  46759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46802 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  46805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46817 */     GIR_RootConstrainSelectedInstOperands,
     /*  46818 */     // GIR_Coverage, 1748,
     /*  46818 */     GIR_EraseRootFromParent_Done,
     /*  46819 */   // Label 733: @46819
     /*  46819 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(46884), // Rule ID 1830 //
     /*  46824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46867 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46882 */     GIR_RootConstrainSelectedInstOperands,
     /*  46883 */     // GIR_Coverage, 1830,
     /*  46883 */     GIR_EraseRootFromParent_Done,
     /*  46884 */   // Label 734: @46884
     /*  46884 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(46949), // Rule ID 1829 //
     /*  46889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46932 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46947 */     GIR_RootConstrainSelectedInstOperands,
     /*  46948 */     // GIR_Coverage, 1829,
     /*  46948 */     GIR_EraseRootFromParent_Done,
     /*  46949 */   // Label 735: @46949
     /*  46949 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(47012), // Rule ID 1724 //
     /*  46954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46993 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  46996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47010 */     GIR_RootConstrainSelectedInstOperands,
     /*  47011 */     // GIR_Coverage, 1724,
     /*  47011 */     GIR_EraseRootFromParent_Done,
     /*  47012 */   // Label 736: @47012
     /*  47012 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(47075), // Rule ID 1814 //
     /*  47017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47056 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  47059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47073 */     GIR_RootConstrainSelectedInstOperands,
     /*  47074 */     // GIR_Coverage, 1814,
     /*  47074 */     GIR_EraseRootFromParent_Done,
     /*  47075 */   // Label 737: @47075
     /*  47075 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47122), // Rule ID 1852 //
     /*  47080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47108 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47120 */     GIR_RootConstrainSelectedInstOperands,
     /*  47121 */     // GIR_Coverage, 1852,
     /*  47121 */     GIR_EraseRootFromParent_Done,
     /*  47122 */   // Label 738: @47122
     /*  47122 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(47169), // Rule ID 1754 //
     /*  47127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47155 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  47158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47167 */     GIR_RootConstrainSelectedInstOperands,
     /*  47168 */     // GIR_Coverage, 1754,
     /*  47168 */     GIR_EraseRootFromParent_Done,
     /*  47169 */   // Label 739: @47169
     /*  47169 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(47216), // Rule ID 1851 //
     /*  47174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47202 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47214 */     GIR_RootConstrainSelectedInstOperands,
     /*  47215 */     // GIR_Coverage, 1851,
     /*  47215 */     GIR_EraseRootFromParent_Done,
     /*  47216 */   // Label 740: @47216
     /*  47216 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(47275), // Rule ID 1828 //
     /*  47221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47260 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47273 */     GIR_RootConstrainSelectedInstOperands,
     /*  47274 */     // GIR_Coverage, 1828,
     /*  47274 */     GIR_EraseRootFromParent_Done,
     /*  47275 */   // Label 741: @47275
     /*  47275 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(47334), // Rule ID 1827 //
     /*  47280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47319 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47332 */     GIR_RootConstrainSelectedInstOperands,
     /*  47333 */     // GIR_Coverage, 1827,
     /*  47333 */     GIR_EraseRootFromParent_Done,
     /*  47334 */   // Label 742: @47334
     /*  47334 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(47393), // Rule ID 1747 //
     /*  47339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47378 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  47381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47391 */     GIR_RootConstrainSelectedInstOperands,
     /*  47392 */     // GIR_Coverage, 1747,
     /*  47392 */     GIR_EraseRootFromParent_Done,
     /*  47393 */   // Label 743: @47393
     /*  47393 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47452), // Rule ID 1826 //
     /*  47398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47437 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47450 */     GIR_RootConstrainSelectedInstOperands,
     /*  47451 */     // GIR_Coverage, 1826,
     /*  47451 */     GIR_EraseRootFromParent_Done,
     /*  47452 */   // Label 744: @47452
     /*  47452 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(47511), // Rule ID 1825 //
     /*  47457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47496 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47509 */     GIR_RootConstrainSelectedInstOperands,
     /*  47510 */     // GIR_Coverage, 1825,
     /*  47510 */     GIR_EraseRootFromParent_Done,
     /*  47511 */   // Label 745: @47511
     /*  47511 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(47546), // Rule ID 961 //
     /*  47516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47537 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  47537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  47540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47544 */     GIR_RootConstrainSelectedInstOperands,
     /*  47545 */     // GIR_Coverage, 961,
     /*  47545 */     GIR_EraseRootFromParent_Done,
     /*  47546 */   // Label 746: @47546
     /*  47546 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(47603), // Rule ID 1723 //
     /*  47551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47586 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47601 */     GIR_RootConstrainSelectedInstOperands,
     /*  47602 */     // GIR_Coverage, 1723,
     /*  47602 */     GIR_EraseRootFromParent_Done,
     /*  47603 */   // Label 747: @47603
     /*  47603 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(47660), // Rule ID 1813 //
     /*  47608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47643 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47658 */     GIR_RootConstrainSelectedInstOperands,
     /*  47659 */     // GIR_Coverage, 1813,
     /*  47659 */     GIR_EraseRootFromParent_Done,
     /*  47660 */   // Label 748: @47660
     /*  47660 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(47704), // Rule ID 1850 //
     /*  47665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47691 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47702 */     GIR_RootConstrainSelectedInstOperands,
     /*  47703 */     // GIR_Coverage, 1850,
     /*  47703 */     GIR_EraseRootFromParent_Done,
     /*  47704 */   // Label 749: @47704
     /*  47704 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(47748), // Rule ID 1753 //
     /*  47709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47735 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47746 */     GIR_RootConstrainSelectedInstOperands,
     /*  47747 */     // GIR_Coverage, 1753,
     /*  47747 */     GIR_EraseRootFromParent_Done,
     /*  47748 */   // Label 750: @47748
     /*  47748 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(47792), // Rule ID 1849 //
     /*  47753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47779 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47790 */     GIR_RootConstrainSelectedInstOperands,
     /*  47791 */     // GIR_Coverage, 1849,
     /*  47791 */     GIR_EraseRootFromParent_Done,
     /*  47792 */   // Label 751: @47792
     /*  47792 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(47815), // Rule ID 1468 //
     /*  47797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47808 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  47813 */     GIR_RootConstrainSelectedInstOperands,
     /*  47814 */     // GIR_Coverage, 1468,
     /*  47814 */     GIR_Done,
     /*  47815 */   // Label 752: @47815
     /*  47815 */   GIM_Reject,
     /*  47816 */ // Label 730: @47816
     /*  47816 */ GIM_Reject,
     /*  47817 */ // Label 580: @47817
     /*  47817 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(47891),
     /*  47822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  47825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  47828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47832 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(47867), // Rule ID 959 //
     /*  47837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47844 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47850 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47858 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  47858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  47861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47865 */     GIR_RootConstrainSelectedInstOperands,
     /*  47866 */     // GIR_Coverage, 959,
     /*  47866 */     GIR_EraseRootFromParent_Done,
     /*  47867 */   // Label 754: @47867
     /*  47867 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(47890), // Rule ID 1466 //
     /*  47872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47883 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  47888 */     GIR_RootConstrainSelectedInstOperands,
     /*  47889 */     // GIR_Coverage, 1466,
     /*  47889 */     GIR_Done,
     /*  47890 */   // Label 755: @47890
     /*  47890 */   GIM_Reject,
     /*  47891 */ // Label 753: @47891
     /*  47891 */ GIM_Reject,
     /*  47892 */ // Label 581: @47892
     /*  47892 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(47917), // Rule ID 7285 //
     /*  47897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  47903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  47906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47910 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  47910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  47915 */   GIR_RootConstrainSelectedInstOperands,
     /*  47916 */   // GIR_Coverage, 7285,
     /*  47916 */   GIR_Done,
     /*  47917 */ // Label 756: @47917
     /*  47917 */ GIM_Reject,
     /*  47918 */ // Label 582: @47918
     /*  47918 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(47943), // Rule ID 7284 //
     /*  47923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  47929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  47932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47936 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  47936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  47941 */   GIR_RootConstrainSelectedInstOperands,
     /*  47942 */   // GIR_Coverage, 7284,
     /*  47942 */   GIR_Done,
     /*  47943 */ // Label 757: @47943
     /*  47943 */ GIM_Reject,
     /*  47944 */ // Label 583: @47944
     /*  47944 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(47969), // Rule ID 7283 //
     /*  47949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  47955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  47958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47962 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  47962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  47967 */   GIR_RootConstrainSelectedInstOperands,
     /*  47968 */   // GIR_Coverage, 7283,
     /*  47968 */   GIR_Done,
     /*  47969 */ // Label 758: @47969
     /*  47969 */ GIM_Reject,
     /*  47970 */ // Label 584: @47970
     /*  47970 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(47995), // Rule ID 7282 //
     /*  47975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  47981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  47984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47988 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  47988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  47993 */   GIR_RootConstrainSelectedInstOperands,
     /*  47994 */   // GIR_Coverage, 7282,
     /*  47994 */   GIR_Done,
     /*  47995 */ // Label 759: @47995
     /*  47995 */ GIM_Reject,
     /*  47996 */ // Label 585: @47996
     /*  47996 */ GIM_Reject,
     /*  47997 */ // Label 2: @47997
     /*  47997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 768*/ GIMT_Encode4(49825),
     /*  48008 */ /*GILLT_s32*//*Label 760*/ GIMT_Encode4(48048),
     /*  48012 */ /*GILLT_s64*//*Label 761*/ GIMT_Encode4(48205), GIMT_Encode4(0),
     /*  48020 */ /*GILLT_v2s32*//*Label 762*/ GIMT_Encode4(48749), GIMT_Encode4(0),
     /*  48028 */ /*GILLT_v4s16*//*Label 763*/ GIMT_Encode4(49087),
     /*  48032 */ /*GILLT_v4s32*//*Label 764*/ GIMT_Encode4(49425),
     /*  48036 */ /*GILLT_v8s8*//*Label 765*/ GIMT_Encode4(49591),
     /*  48040 */ /*GILLT_v8s16*//*Label 766*/ GIMT_Encode4(49625),
     /*  48044 */ /*GILLT_v16s8*//*Label 767*/ GIMT_Encode4(49791),
     /*  48048 */ // Label 760: @48048
     /*  48048 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(48204),
     /*  48053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48063 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(48118), // Rule ID 3897 //
     /*  48068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48084 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48099 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48116 */     GIR_RootConstrainSelectedInstOperands,
     /*  48117 */     // GIR_Coverage, 3897,
     /*  48117 */     GIR_EraseRootFromParent_Done,
     /*  48118 */   // Label 770: @48118
     /*  48118 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(48173), // Rule ID 13487 //
     /*  48123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48143 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48154 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48171 */     GIR_RootConstrainSelectedInstOperands,
     /*  48172 */     // GIR_Coverage, 13487,
     /*  48172 */     GIR_EraseRootFromParent_Done,
     /*  48173 */   // Label 771: @48173
     /*  48173 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(48203), // Rule ID 3893 //
     /*  48178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48186 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  48189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48201 */     GIR_RootConstrainSelectedInstOperands,
     /*  48202 */     // GIR_Coverage, 3893,
     /*  48202 */     GIR_EraseRootFromParent_Done,
     /*  48203 */   // Label 772: @48203
     /*  48203 */   GIM_Reject,
     /*  48204 */ // Label 769: @48204
     /*  48204 */ GIM_Reject,
     /*  48205 */ // Label 761: @48205
     /*  48205 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(48748),
     /*  48210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  48216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48220 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(48275), // Rule ID 3898 //
     /*  48225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48241 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48256 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48273 */     GIR_RootConstrainSelectedInstOperands,
     /*  48274 */     // GIR_Coverage, 3898,
     /*  48274 */     GIR_EraseRootFromParent_Done,
     /*  48275 */   // Label 774: @48275
     /*  48275 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(48330), // Rule ID 13488 //
     /*  48280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48300 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48311 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48328 */     GIR_RootConstrainSelectedInstOperands,
     /*  48329 */     // GIR_Coverage, 13488,
     /*  48329 */     GIR_EraseRootFromParent_Done,
     /*  48330 */   // Label 775: @48330
     /*  48330 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(48443), // Rule ID 3909 //
     /*  48335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  48343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48352 */     // MIs[1] Operand 2
     /*  48352 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  48363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48375 */     // MIs[2] Operand 1
     /*  48375 */     // No operand predicates
     /*  48375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48377 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48389 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48408 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  48414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  48435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48441 */     GIR_RootConstrainSelectedInstOperands,
     /*  48442 */     // GIR_Coverage, 3909,
     /*  48442 */     GIR_EraseRootFromParent_Done,
     /*  48443 */   // Label 776: @48443
     /*  48443 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(48518), // Rule ID 3907 //
     /*  48448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48473 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48477 */     // MIs[2] Operand 1
     /*  48477 */     // No operand predicates
     /*  48477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48479 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48491 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48516 */     GIR_RootConstrainSelectedInstOperands,
     /*  48517 */     // GIR_Coverage, 3907,
     /*  48517 */     GIR_EraseRootFromParent_Done,
     /*  48518 */   // Label 777: @48518
     /*  48518 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(48593), // Rule ID 3908 //
     /*  48523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  48552 */     // MIs[2] Operand 1
     /*  48552 */     // No operand predicates
     /*  48552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48554 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48566 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48591 */     GIR_RootConstrainSelectedInstOperands,
     /*  48592 */     // GIR_Coverage, 3908,
     /*  48592 */     GIR_EraseRootFromParent_Done,
     /*  48593 */   // Label 778: @48593
     /*  48593 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(48655), // Rule ID 3901 //
     /*  48598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48634 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48653 */     GIR_RootConstrainSelectedInstOperands,
     /*  48654 */     // GIR_Coverage, 3901,
     /*  48654 */     GIR_EraseRootFromParent_Done,
     /*  48655 */   // Label 779: @48655
     /*  48655 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(48717), // Rule ID 3904 //
     /*  48660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48696 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48715 */     GIR_RootConstrainSelectedInstOperands,
     /*  48716 */     // GIR_Coverage, 3904,
     /*  48716 */     GIR_EraseRootFromParent_Done,
     /*  48717 */   // Label 780: @48717
     /*  48717 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(48747), // Rule ID 3894 //
     /*  48722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48730 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  48733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48745 */     GIR_RootConstrainSelectedInstOperands,
     /*  48746 */     // GIR_Coverage, 3894,
     /*  48746 */     GIR_EraseRootFromParent_Done,
     /*  48747 */   // Label 781: @48747
     /*  48747 */   GIM_Reject,
     /*  48748 */ // Label 773: @48748
     /*  48748 */ GIM_Reject,
     /*  48749 */ // Label 762: @48749
     /*  48749 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(49086),
     /*  48754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  48757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  48760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48764 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(48850), // Rule ID 13181 //
     /*  48769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48817 */     // MIs[3] Operand 1
     /*  48817 */     // No operand predicates
     /*  48817 */     // MIs[1] Operand 2
     /*  48817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48834 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48848 */     GIR_RootConstrainSelectedInstOperands,
     /*  48849 */     // GIR_Coverage, 13181,
     /*  48849 */     GIR_EraseRootFromParent_Done,
     /*  48850 */   // Label 783: @48850
     /*  48850 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(48936), // Rule ID 2027 //
     /*  48855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48903 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48907 */     // MIs[3] Operand 1
     /*  48907 */     // No operand predicates
     /*  48907 */     // MIs[1] Operand 2
     /*  48907 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48920 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48934 */     GIR_RootConstrainSelectedInstOperands,
     /*  48935 */     // GIR_Coverage, 2027,
     /*  48935 */     GIR_EraseRootFromParent_Done,
     /*  48936 */   // Label 784: @48936
     /*  48936 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(48999), // Rule ID 13182 //
     /*  48941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48973 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48977 */     // MIs[2] Operand 1
     /*  48977 */     // No operand predicates
     /*  48977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48983 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  48994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  48997 */     GIR_RootConstrainSelectedInstOperands,
     /*  48998 */     // GIR_Coverage, 13182,
     /*  48998 */     GIR_EraseRootFromParent_Done,
     /*  48999 */   // Label 785: @48999
     /*  48999 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(49062), // Rule ID 2028 //
     /*  49004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49040 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49044 */     // MIs[2] Operand 1
     /*  49044 */     // No operand predicates
     /*  49044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49046 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49060 */     GIR_RootConstrainSelectedInstOperands,
     /*  49061 */     // GIR_Coverage, 2028,
     /*  49061 */     GIR_EraseRootFromParent_Done,
     /*  49062 */   // Label 786: @49062
     /*  49062 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(49085), // Rule ID 1345 //
     /*  49067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49078 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  49078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  49083 */     GIR_RootConstrainSelectedInstOperands,
     /*  49084 */     // GIR_Coverage, 1345,
     /*  49084 */     GIR_Done,
     /*  49085 */   // Label 787: @49085
     /*  49085 */   GIM_Reject,
     /*  49086 */ // Label 782: @49086
     /*  49086 */ GIM_Reject,
     /*  49087 */ // Label 763: @49087
     /*  49087 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(49424),
     /*  49092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49102 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(49188), // Rule ID 13178 //
     /*  49107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49151 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49155 */     // MIs[3] Operand 1
     /*  49155 */     // No operand predicates
     /*  49155 */     // MIs[1] Operand 2
     /*  49155 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49172 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49186 */     GIR_RootConstrainSelectedInstOperands,
     /*  49187 */     // GIR_Coverage, 13178,
     /*  49187 */     GIR_EraseRootFromParent_Done,
     /*  49188 */   // Label 789: @49188
     /*  49188 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(49274), // Rule ID 2024 //
     /*  49193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49245 */     // MIs[3] Operand 1
     /*  49245 */     // No operand predicates
     /*  49245 */     // MIs[1] Operand 2
     /*  49245 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49258 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49272 */     GIR_RootConstrainSelectedInstOperands,
     /*  49273 */     // GIR_Coverage, 2024,
     /*  49273 */     GIR_EraseRootFromParent_Done,
     /*  49274 */   // Label 790: @49274
     /*  49274 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(49337), // Rule ID 13179 //
     /*  49279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49311 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49315 */     // MIs[2] Operand 1
     /*  49315 */     // No operand predicates
     /*  49315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49321 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49335 */     GIR_RootConstrainSelectedInstOperands,
     /*  49336 */     // GIR_Coverage, 13179,
     /*  49336 */     GIR_EraseRootFromParent_Done,
     /*  49337 */   // Label 791: @49337
     /*  49337 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(49400), // Rule ID 2025 //
     /*  49342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49378 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49382 */     // MIs[2] Operand 1
     /*  49382 */     // No operand predicates
     /*  49382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49384 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49398 */     GIR_RootConstrainSelectedInstOperands,
     /*  49399 */     // GIR_Coverage, 2025,
     /*  49399 */     GIR_EraseRootFromParent_Done,
     /*  49400 */   // Label 792: @49400
     /*  49400 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(49423), // Rule ID 1343 //
     /*  49405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49416 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  49421 */     GIR_RootConstrainSelectedInstOperands,
     /*  49422 */     // GIR_Coverage, 1343,
     /*  49422 */     GIR_Done,
     /*  49423 */   // Label 793: @49423
     /*  49423 */   GIM_Reject,
     /*  49424 */ // Label 788: @49424
     /*  49424 */ GIM_Reject,
     /*  49425 */ // Label 764: @49425
     /*  49425 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(49590),
     /*  49430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49440 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(49503), // Rule ID 13183 //
     /*  49445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49477 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49481 */     // MIs[2] Operand 1
     /*  49481 */     // No operand predicates
     /*  49481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49487 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49501 */     GIR_RootConstrainSelectedInstOperands,
     /*  49502 */     // GIR_Coverage, 13183,
     /*  49502 */     GIR_EraseRootFromParent_Done,
     /*  49503 */   // Label 795: @49503
     /*  49503 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49566), // Rule ID 2029 //
     /*  49508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49544 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49548 */     // MIs[2] Operand 1
     /*  49548 */     // No operand predicates
     /*  49548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49550 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49564 */     GIR_RootConstrainSelectedInstOperands,
     /*  49565 */     // GIR_Coverage, 2029,
     /*  49565 */     GIR_EraseRootFromParent_Done,
     /*  49566 */   // Label 796: @49566
     /*  49566 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49589), // Rule ID 1346 //
     /*  49571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49582 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  49587 */     GIR_RootConstrainSelectedInstOperands,
     /*  49588 */     // GIR_Coverage, 1346,
     /*  49588 */     GIR_Done,
     /*  49589 */   // Label 797: @49589
     /*  49589 */   GIM_Reject,
     /*  49590 */ // Label 794: @49590
     /*  49590 */ GIM_Reject,
     /*  49591 */ // Label 765: @49591
     /*  49591 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49624), // Rule ID 1341 //
     /*  49596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49617 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  49622 */   GIR_RootConstrainSelectedInstOperands,
     /*  49623 */   // GIR_Coverage, 1341,
     /*  49623 */   GIR_Done,
     /*  49624 */ // Label 798: @49624
     /*  49624 */ GIM_Reject,
     /*  49625 */ // Label 766: @49625
     /*  49625 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49790),
     /*  49630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49640 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49703), // Rule ID 13180 //
     /*  49645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49681 */     // MIs[2] Operand 1
     /*  49681 */     // No operand predicates
     /*  49681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49687 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49701 */     GIR_RootConstrainSelectedInstOperands,
     /*  49702 */     // GIR_Coverage, 13180,
     /*  49702 */     GIR_EraseRootFromParent_Done,
     /*  49703 */   // Label 800: @49703
     /*  49703 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49766), // Rule ID 2026 //
     /*  49708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49748 */     // MIs[2] Operand 1
     /*  49748 */     // No operand predicates
     /*  49748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49750 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49764 */     GIR_RootConstrainSelectedInstOperands,
     /*  49765 */     // GIR_Coverage, 2026,
     /*  49765 */     GIR_EraseRootFromParent_Done,
     /*  49766 */   // Label 801: @49766
     /*  49766 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49789), // Rule ID 1344 //
     /*  49771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49782 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  49787 */     GIR_RootConstrainSelectedInstOperands,
     /*  49788 */     // GIR_Coverage, 1344,
     /*  49788 */     GIR_Done,
     /*  49789 */   // Label 802: @49789
     /*  49789 */   GIM_Reject,
     /*  49790 */ // Label 799: @49790
     /*  49790 */ GIM_Reject,
     /*  49791 */ // Label 767: @49791
     /*  49791 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49824), // Rule ID 1342 //
     /*  49796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  49802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49817 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  49822 */   GIR_RootConstrainSelectedInstOperands,
     /*  49823 */   // GIR_Coverage, 1342,
     /*  49823 */   GIR_Done,
     /*  49824 */ // Label 803: @49824
     /*  49824 */ GIM_Reject,
     /*  49825 */ // Label 768: @49825
     /*  49825 */ GIM_Reject,
     /*  49826 */ // Label 3: @49826
     /*  49826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 806*/ GIMT_Encode4(49907),
     /*  49837 */ /*GILLT_s32*//*Label 804*/ GIMT_Encode4(49845),
     /*  49841 */ /*GILLT_s64*//*Label 805*/ GIMT_Encode4(49876),
     /*  49845 */ // Label 804: @49845
     /*  49845 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49875), // Rule ID 117 //
     /*  49850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49868 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  49873 */   GIR_RootConstrainSelectedInstOperands,
     /*  49874 */   // GIR_Coverage, 117,
     /*  49874 */   GIR_Done,
     /*  49875 */ // Label 807: @49875
     /*  49875 */ GIM_Reject,
     /*  49876 */ // Label 805: @49876
     /*  49876 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49906), // Rule ID 118 //
     /*  49881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49899 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  49904 */   GIR_RootConstrainSelectedInstOperands,
     /*  49905 */   // GIR_Coverage, 118,
     /*  49905 */   GIR_Done,
     /*  49906 */ // Label 808: @49906
     /*  49906 */ GIM_Reject,
     /*  49907 */ // Label 806: @49907
     /*  49907 */ GIM_Reject,
     /*  49908 */ // Label 4: @49908
     /*  49908 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 811*/ GIMT_Encode4(49989),
     /*  49919 */ /*GILLT_s32*//*Label 809*/ GIMT_Encode4(49927),
     /*  49923 */ /*GILLT_s64*//*Label 810*/ GIMT_Encode4(49958),
     /*  49927 */ // Label 809: @49927
     /*  49927 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(49957), // Rule ID 115 //
     /*  49932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49950 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  49955 */   GIR_RootConstrainSelectedInstOperands,
     /*  49956 */   // GIR_Coverage, 115,
     /*  49956 */   GIR_Done,
     /*  49957 */ // Label 812: @49957
     /*  49957 */ GIM_Reject,
     /*  49958 */ // Label 810: @49958
     /*  49958 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(49988), // Rule ID 116 //
     /*  49963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49981 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  49986 */   GIR_RootConstrainSelectedInstOperands,
     /*  49987 */   // GIR_Coverage, 116,
     /*  49987 */   GIR_Done,
     /*  49988 */ // Label 813: @49988
     /*  49988 */ GIM_Reject,
     /*  49989 */ // Label 811: @49989
     /*  49989 */ GIM_Reject,
     /*  49990 */ // Label 5: @49990
     /*  49990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 832*/ GIMT_Encode4(57735),
     /*  50001 */ /*GILLT_s32*//*Label 814*/ GIMT_Encode4(50089),
     /*  50005 */ /*GILLT_s64*//*Label 815*/ GIMT_Encode4(50587), GIMT_Encode4(0),
     /*  50013 */ /*GILLT_v2s32*//*Label 816*/ GIMT_Encode4(52022),
     /*  50017 */ /*GILLT_v2s64*//*Label 817*/ GIMT_Encode4(52182),
     /*  50021 */ /*GILLT_v4s16*//*Label 818*/ GIMT_Encode4(52342),
     /*  50025 */ /*GILLT_v4s32*//*Label 819*/ GIMT_Encode4(52502),
     /*  50029 */ /*GILLT_v8s8*//*Label 820*/ GIMT_Encode4(52662),
     /*  50033 */ /*GILLT_v8s16*//*Label 821*/ GIMT_Encode4(52822),
     /*  50037 */ /*GILLT_v16s8*//*Label 822*/ GIMT_Encode4(52982),
     /*  50041 */ /*GILLT_nxv1s1*//*Label 823*/ GIMT_Encode4(53142),
     /*  50045 */ /*GILLT_nxv2s1*//*Label 824*/ GIMT_Encode4(53683), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  50057 */ /*GILLT_nxv2s64*//*Label 825*/ GIMT_Encode4(54224),
     /*  50061 */ /*GILLT_nxv4s1*//*Label 826*/ GIMT_Encode4(54696), GIMT_Encode4(0),
     /*  50069 */ /*GILLT_nxv4s32*//*Label 827*/ GIMT_Encode4(55237),
     /*  50073 */ /*GILLT_nxv8s1*//*Label 828*/ GIMT_Encode4(55709),
     /*  50077 */ /*GILLT_nxv8s16*//*Label 829*/ GIMT_Encode4(56250),
     /*  50081 */ /*GILLT_nxv16s1*//*Label 830*/ GIMT_Encode4(56722),
     /*  50085 */ /*GILLT_nxv16s8*//*Label 831*/ GIMT_Encode4(57263),
     /*  50089 */ // Label 814: @50089
     /*  50089 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(50586),
     /*  50094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50100 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(50155), // Rule ID 12940 //
     /*  50105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50125 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50142 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50153 */     GIR_RootConstrainSelectedInstOperands,
     /*  50154 */     // GIR_Coverage, 12940,
     /*  50154 */     GIR_EraseRootFromParent_Done,
     /*  50155 */   // Label 834: @50155
     /*  50155 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(50210), // Rule ID 162 //
     /*  50160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50197 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50208 */     GIR_RootConstrainSelectedInstOperands,
     /*  50209 */     // GIR_Coverage, 162,
     /*  50209 */     GIR_EraseRootFromParent_Done,
     /*  50210 */   // Label 835: @50210
     /*  50210 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(50279), // Rule ID 5590 //
     /*  50215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50252 */     // MIs[2] Operand 1
     /*  50252 */     // No operand predicates
     /*  50252 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50265 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  50265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50277 */     GIR_RootConstrainSelectedInstOperands,
     /*  50278 */     // GIR_Coverage, 5590,
     /*  50278 */     GIR_EraseRootFromParent_Done,
     /*  50279 */   // Label 836: @50279
     /*  50279 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(50348), // Rule ID 5591 //
     /*  50284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50321 */     // MIs[2] Operand 1
     /*  50321 */     // No operand predicates
     /*  50321 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50334 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  50334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50346 */     GIR_RootConstrainSelectedInstOperands,
     /*  50347 */     // GIR_Coverage, 5591,
     /*  50347 */     GIR_EraseRootFromParent_Done,
     /*  50348 */   // Label 837: @50348
     /*  50348 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(50401), // Rule ID 12938 //
     /*  50353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50388 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50399 */     GIR_RootConstrainSelectedInstOperands,
     /*  50400 */     // GIR_Coverage, 12938,
     /*  50400 */     GIR_EraseRootFromParent_Done,
     /*  50401 */   // Label 838: @50401
     /*  50401 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(50454), // Rule ID 160 //
     /*  50406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50435 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50441 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50452 */     GIR_RootConstrainSelectedInstOperands,
     /*  50453 */     // GIR_Coverage, 160,
     /*  50453 */     GIR_EraseRootFromParent_Done,
     /*  50454 */   // Label 839: @50454
     /*  50454 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(50495), // Rule ID 142 //
     /*  50459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  50463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50475 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  50479 */     // MIs[1] Operand 1
     /*  50479 */     // No operand predicates
     /*  50479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50481 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  50481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  50484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50488 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  50493 */     GIR_RootConstrainSelectedInstOperands,
     /*  50494 */     // GIR_Coverage, 142,
     /*  50494 */     GIR_EraseRootFromParent_Done,
     /*  50495 */   // Label 840: @50495
     /*  50495 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(50528), // Rule ID 12936 //
     /*  50500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50515 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50526 */     GIR_RootConstrainSelectedInstOperands,
     /*  50527 */     // GIR_Coverage, 12936,
     /*  50527 */     GIR_EraseRootFromParent_Done,
     /*  50528 */   // Label 841: @50528
     /*  50528 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(50561), // Rule ID 158 //
     /*  50533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50548 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50559 */     GIR_RootConstrainSelectedInstOperands,
     /*  50560 */     // GIR_Coverage, 158,
     /*  50560 */     GIR_EraseRootFromParent_Done,
     /*  50561 */   // Label 842: @50561
     /*  50561 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(50585), // Rule ID 156 //
     /*  50566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50578 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  50583 */     GIR_RootConstrainSelectedInstOperands,
     /*  50584 */     // GIR_Coverage, 156,
     /*  50584 */     GIR_Done,
     /*  50585 */   // Label 843: @50585
     /*  50585 */   GIM_Reject,
     /*  50586 */ // Label 833: @50586
     /*  50586 */ GIM_Reject,
     /*  50587 */ // Label 815: @50587
     /*  50587 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52021),
     /*  50592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50598 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(50653), // Rule ID 12941 //
     /*  50603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50623 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50640 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50651 */     GIR_RootConstrainSelectedInstOperands,
     /*  50652 */     // GIR_Coverage, 12941,
     /*  50652 */     GIR_EraseRootFromParent_Done,
     /*  50653 */   // Label 845: @50653
     /*  50653 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(50708), // Rule ID 163 //
     /*  50658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50682 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50695 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50706 */     GIR_RootConstrainSelectedInstOperands,
     /*  50707 */     // GIR_Coverage, 163,
     /*  50707 */     GIR_EraseRootFromParent_Done,
     /*  50708 */   // Label 846: @50708
     /*  50708 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(50821), // Rule ID 5592 //
     /*  50713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50758 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50762 */     // MIs[3] Operand 1
     /*  50762 */     // No operand predicates
     /*  50762 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50775 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  50775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50820 */     // GIR_Coverage, 5592,
     /*  50820 */     GIR_EraseRootFromParent_Done,
     /*  50821 */   // Label 847: @50821
     /*  50821 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(50934), // Rule ID 5593 //
     /*  50826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50871 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50875 */     // MIs[3] Operand 1
     /*  50875 */     // No operand predicates
     /*  50875 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50888 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  50888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50933 */     // GIR_Coverage, 5593,
     /*  50933 */     GIR_EraseRootFromParent_Done,
     /*  50934 */   // Label 848: @50934
     /*  50934 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(51033), // Rule ID 7004 //
     /*  50939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  50951 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  50954 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  50959 */     // MIs[1] addr
     /*  50959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  50963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  50968 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  50972 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50985 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  50985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  50992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51001 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51032 */     // GIR_Coverage, 7004,
     /*  51032 */     GIR_EraseRootFromParent_Done,
     /*  51033 */   // Label 849: @51033
     /*  51033 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(51132), // Rule ID 7005 //
     /*  51038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51050 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51053 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51058 */     // MIs[1] addr
     /*  51058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51067 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  51071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51084 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  51091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51100 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51131 */     // GIR_Coverage, 7005,
     /*  51131 */     GIR_EraseRootFromParent_Done,
     /*  51132 */   // Label 850: @51132
     /*  51132 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(51231), // Rule ID 7006 //
     /*  51137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51157 */     // MIs[1] addr
     /*  51157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51166 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  51170 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51183 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  51190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51199 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51230 */     // GIR_Coverage, 7006,
     /*  51230 */     GIR_EraseRootFromParent_Done,
     /*  51231 */   // Label 851: @51231
     /*  51231 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(51330), // Rule ID 7011 //
     /*  51236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51248 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51251 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51256 */     // MIs[1] addr
     /*  51256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51265 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  51269 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  51280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51282 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  51289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51298 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51329 */     // GIR_Coverage, 7011,
     /*  51329 */     GIR_EraseRootFromParent_Done,
     /*  51330 */   // Label 852: @51330
     /*  51330 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(51429), // Rule ID 7012 //
     /*  51335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51347 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51350 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51355 */     // MIs[1] addr
     /*  51355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51364 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  51368 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51381 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  51388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51397 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51428 */     // GIR_Coverage, 7012,
     /*  51428 */     GIR_EraseRootFromParent_Done,
     /*  51429 */   // Label 853: @51429
     /*  51429 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(51528), // Rule ID 7013 //
     /*  51434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51454 */     // MIs[1] addr
     /*  51454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51463 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  51467 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51480 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  51487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51496 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51527 */     // GIR_Coverage, 7013,
     /*  51527 */     GIR_EraseRootFromParent_Done,
     /*  51528 */   // Label 854: @51528
     /*  51528 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(51581), // Rule ID 12939 //
     /*  51533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51558 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51568 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51579 */     GIR_RootConstrainSelectedInstOperands,
     /*  51580 */     // GIR_Coverage, 12939,
     /*  51580 */     GIR_EraseRootFromParent_Done,
     /*  51581 */   // Label 855: @51581
     /*  51581 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(51634), // Rule ID 161 //
     /*  51586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51615 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51621 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51632 */     GIR_RootConstrainSelectedInstOperands,
     /*  51633 */     // GIR_Coverage, 161,
     /*  51633 */     GIR_EraseRootFromParent_Done,
     /*  51634 */   // Label 856: @51634
     /*  51634 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(51734), // Rule ID 3946 //
     /*  51639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51647 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51658 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  51658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51670 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  51693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51698 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51733 */     // GIR_Coverage, 3946,
     /*  51733 */     GIR_EraseRootFromParent_Done,
     /*  51734 */   // Label 857: @51734
     /*  51734 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(51775), // Rule ID 143 //
     /*  51739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51755 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  51759 */     // MIs[1] Operand 1
     /*  51759 */     // No operand predicates
     /*  51759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51761 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  51761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  51764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51768 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  51773 */     GIR_RootConstrainSelectedInstOperands,
     /*  51774 */     // GIR_Coverage, 143,
     /*  51774 */     GIR_EraseRootFromParent_Done,
     /*  51775 */   // Label 858: @51775
     /*  51775 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(51808), // Rule ID 12937 //
     /*  51780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51795 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51806 */     GIR_RootConstrainSelectedInstOperands,
     /*  51807 */     // GIR_Coverage, 12937,
     /*  51807 */     GIR_EraseRootFromParent_Done,
     /*  51808 */   // Label 859: @51808
     /*  51808 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(51841), // Rule ID 159 //
     /*  51813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51828 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51839 */     GIR_RootConstrainSelectedInstOperands,
     /*  51840 */     // GIR_Coverage, 159,
     /*  51840 */     GIR_EraseRootFromParent_Done,
     /*  51841 */   // Label 860: @51841
     /*  51841 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(51905), // Rule ID 13592 //
     /*  51846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51892 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  51899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51903 */     GIR_RootConstrainSelectedInstOperands,
     /*  51904 */     // GIR_Coverage, 13592,
     /*  51904 */     GIR_EraseRootFromParent_Done,
     /*  51905 */   // Label 861: @51905
     /*  51905 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(51969), // Rule ID 4981 //
     /*  51910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51946 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51956 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51961 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  51963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51967 */     GIR_RootConstrainSelectedInstOperands,
     /*  51968 */     // GIR_Coverage, 4981,
     /*  51968 */     GIR_EraseRootFromParent_Done,
     /*  51969 */   // Label 862: @51969
     /*  51969 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(51993), // Rule ID 157 //
     /*  51974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51986 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  51991 */     GIR_RootConstrainSelectedInstOperands,
     /*  51992 */     // GIR_Coverage, 157,
     /*  51992 */     GIR_Done,
     /*  51993 */   // Label 863: @51993
     /*  51993 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(52020), // Rule ID 2475 //
     /*  51998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52013 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  52013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52018 */     GIR_RootConstrainSelectedInstOperands,
     /*  52019 */     // GIR_Coverage, 2475,
     /*  52019 */     GIR_Done,
     /*  52020 */   // Label 864: @52020
     /*  52020 */   GIM_Reject,
     /*  52021 */ // Label 844: @52021
     /*  52021 */ GIM_Reject,
     /*  52022 */ // Label 816: @52022
     /*  52022 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(52181),
     /*  52027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52037 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(52097), // Rule ID 13591 //
     /*  52042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52070 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52084 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52089 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52095 */     GIR_RootConstrainSelectedInstOperands,
     /*  52096 */     // GIR_Coverage, 13591,
     /*  52096 */     GIR_EraseRootFromParent_Done,
     /*  52097 */   // Label 866: @52097
     /*  52097 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(52157), // Rule ID 4980 //
     /*  52102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52134 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52144 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52149 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52155 */     GIR_RootConstrainSelectedInstOperands,
     /*  52156 */     // GIR_Coverage, 4980,
     /*  52156 */     GIR_EraseRootFromParent_Done,
     /*  52157 */   // Label 867: @52157
     /*  52157 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(52180), // Rule ID 2474 //
     /*  52162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52173 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52178 */     GIR_RootConstrainSelectedInstOperands,
     /*  52179 */     // GIR_Coverage, 2474,
     /*  52179 */     GIR_Done,
     /*  52180 */   // Label 868: @52180
     /*  52180 */   GIM_Reject,
     /*  52181 */ // Label 865: @52181
     /*  52181 */ GIM_Reject,
     /*  52182 */ // Label 817: @52182
     /*  52182 */ GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(52341),
     /*  52187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52197 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(52257), // Rule ID 13595 //
     /*  52202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52230 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52244 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52249 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52255 */     GIR_RootConstrainSelectedInstOperands,
     /*  52256 */     // GIR_Coverage, 13595,
     /*  52256 */     GIR_EraseRootFromParent_Done,
     /*  52257 */   // Label 870: @52257
     /*  52257 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(52317), // Rule ID 4984 //
     /*  52262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52294 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52304 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52309 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52315 */     GIR_RootConstrainSelectedInstOperands,
     /*  52316 */     // GIR_Coverage, 4984,
     /*  52316 */     GIR_EraseRootFromParent_Done,
     /*  52317 */   // Label 871: @52317
     /*  52317 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(52340), // Rule ID 2478 //
     /*  52322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52333 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52338 */     GIR_RootConstrainSelectedInstOperands,
     /*  52339 */     // GIR_Coverage, 2478,
     /*  52339 */     GIR_Done,
     /*  52340 */   // Label 872: @52340
     /*  52340 */   GIM_Reject,
     /*  52341 */ // Label 869: @52341
     /*  52341 */ GIM_Reject,
     /*  52342 */ // Label 818: @52342
     /*  52342 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(52501),
     /*  52347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52357 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(52417), // Rule ID 13590 //
     /*  52362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52404 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52409 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52415 */     GIR_RootConstrainSelectedInstOperands,
     /*  52416 */     // GIR_Coverage, 13590,
     /*  52416 */     GIR_EraseRootFromParent_Done,
     /*  52417 */   // Label 874: @52417
     /*  52417 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(52477), // Rule ID 4979 //
     /*  52422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52454 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52464 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52469 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52475 */     GIR_RootConstrainSelectedInstOperands,
     /*  52476 */     // GIR_Coverage, 4979,
     /*  52476 */     GIR_EraseRootFromParent_Done,
     /*  52477 */   // Label 875: @52477
     /*  52477 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(52500), // Rule ID 2473 //
     /*  52482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52493 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52498 */     GIR_RootConstrainSelectedInstOperands,
     /*  52499 */     // GIR_Coverage, 2473,
     /*  52499 */     GIR_Done,
     /*  52500 */   // Label 876: @52500
     /*  52500 */   GIM_Reject,
     /*  52501 */ // Label 873: @52501
     /*  52501 */ GIM_Reject,
     /*  52502 */ // Label 819: @52502
     /*  52502 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(52661),
     /*  52507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52517 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(52577), // Rule ID 13594 //
     /*  52522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52550 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52556 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52564 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52569 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52575 */     GIR_RootConstrainSelectedInstOperands,
     /*  52576 */     // GIR_Coverage, 13594,
     /*  52576 */     GIR_EraseRootFromParent_Done,
     /*  52577 */   // Label 878: @52577
     /*  52577 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(52637), // Rule ID 4983 //
     /*  52582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52614 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52624 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52629 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52635 */     GIR_RootConstrainSelectedInstOperands,
     /*  52636 */     // GIR_Coverage, 4983,
     /*  52636 */     GIR_EraseRootFromParent_Done,
     /*  52637 */   // Label 879: @52637
     /*  52637 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(52660), // Rule ID 2477 //
     /*  52642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52653 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52658 */     GIR_RootConstrainSelectedInstOperands,
     /*  52659 */     // GIR_Coverage, 2477,
     /*  52659 */     GIR_Done,
     /*  52660 */   // Label 880: @52660
     /*  52660 */   GIM_Reject,
     /*  52661 */ // Label 877: @52661
     /*  52661 */ GIM_Reject,
     /*  52662 */ // Label 820: @52662
     /*  52662 */ GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(52821),
     /*  52667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52677 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(52737), // Rule ID 13076 //
     /*  52682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52710 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52724 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52735 */     GIR_RootConstrainSelectedInstOperands,
     /*  52736 */     // GIR_Coverage, 13076,
     /*  52736 */     GIR_EraseRootFromParent_Done,
     /*  52737 */   // Label 882: @52737
     /*  52737 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(52797), // Rule ID 1590 //
     /*  52742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52784 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52795 */     GIR_RootConstrainSelectedInstOperands,
     /*  52796 */     // GIR_Coverage, 1590,
     /*  52796 */     GIR_EraseRootFromParent_Done,
     /*  52797 */   // Label 883: @52797
     /*  52797 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(52820), // Rule ID 1588 //
     /*  52802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52813 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52818 */     GIR_RootConstrainSelectedInstOperands,
     /*  52819 */     // GIR_Coverage, 1588,
     /*  52819 */     GIR_Done,
     /*  52820 */   // Label 884: @52820
     /*  52820 */   GIM_Reject,
     /*  52821 */ // Label 881: @52821
     /*  52821 */ GIM_Reject,
     /*  52822 */ // Label 821: @52822
     /*  52822 */ GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(52981),
     /*  52827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52837 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(52897), // Rule ID 13593 //
     /*  52842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52870 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52884 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52889 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52895 */     GIR_RootConstrainSelectedInstOperands,
     /*  52896 */     // GIR_Coverage, 13593,
     /*  52896 */     GIR_EraseRootFromParent_Done,
     /*  52897 */   // Label 886: @52897
     /*  52897 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(52957), // Rule ID 4982 //
     /*  52902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52934 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52940 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52944 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52949 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52955 */     GIR_RootConstrainSelectedInstOperands,
     /*  52956 */     // GIR_Coverage, 4982,
     /*  52956 */     GIR_EraseRootFromParent_Done,
     /*  52957 */   // Label 887: @52957
     /*  52957 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(52980), // Rule ID 2476 //
     /*  52962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52973 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52978 */     GIR_RootConstrainSelectedInstOperands,
     /*  52979 */     // GIR_Coverage, 2476,
     /*  52979 */     GIR_Done,
     /*  52980 */   // Label 888: @52980
     /*  52980 */   GIM_Reject,
     /*  52981 */ // Label 885: @52981
     /*  52981 */ GIM_Reject,
     /*  52982 */ // Label 822: @52982
     /*  52982 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(53141),
     /*  52987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52997 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(53057), // Rule ID 13077 //
     /*  53002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53030 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53036 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53044 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53055 */     GIR_RootConstrainSelectedInstOperands,
     /*  53056 */     // GIR_Coverage, 13077,
     /*  53056 */     GIR_EraseRootFromParent_Done,
     /*  53057 */   // Label 890: @53057
     /*  53057 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(53117), // Rule ID 1591 //
     /*  53062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53094 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53104 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53115 */     GIR_RootConstrainSelectedInstOperands,
     /*  53116 */     // GIR_Coverage, 1591,
     /*  53116 */     GIR_EraseRootFromParent_Done,
     /*  53117 */   // Label 891: @53117
     /*  53117 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(53140), // Rule ID 1589 //
     /*  53122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53133 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  53138 */     GIR_RootConstrainSelectedInstOperands,
     /*  53139 */     // GIR_Coverage, 1589,
     /*  53139 */     GIR_Done,
     /*  53140 */   // Label 892: @53140
     /*  53140 */   GIM_Reject,
     /*  53141 */ // Label 889: @53141
     /*  53141 */ GIM_Reject,
     /*  53142 */ // Label 823: @53142
     /*  53142 */ GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(53682),
     /*  53147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53157 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(53214), // Rule ID 14793 //
     /*  53162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53199 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53212 */     GIR_RootConstrainSelectedInstOperands,
     /*  53213 */     // GIR_Coverage, 14793,
     /*  53213 */     GIR_EraseRootFromParent_Done,
     /*  53214 */   // Label 894: @53214
     /*  53214 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(53271), // Rule ID 14796 //
     /*  53219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53250 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53256 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53269 */     GIR_RootConstrainSelectedInstOperands,
     /*  53270 */     // GIR_Coverage, 14796,
     /*  53270 */     GIR_EraseRootFromParent_Done,
     /*  53271 */   // Label 895: @53271
     /*  53271 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(53328), // Rule ID 14792 //
     /*  53276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53307 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53313 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53326 */     GIR_RootConstrainSelectedInstOperands,
     /*  53327 */     // GIR_Coverage, 14792,
     /*  53327 */     GIR_EraseRootFromParent_Done,
     /*  53328 */   // Label 896: @53328
     /*  53328 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(53385), // Rule ID 14795 //
     /*  53333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53364 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53370 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53383 */     GIR_RootConstrainSelectedInstOperands,
     /*  53384 */     // GIR_Coverage, 14795,
     /*  53384 */     GIR_EraseRootFromParent_Done,
     /*  53385 */   // Label 897: @53385
     /*  53385 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(53442), // Rule ID 14791 //
     /*  53390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53421 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53427 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53440 */     GIR_RootConstrainSelectedInstOperands,
     /*  53441 */     // GIR_Coverage, 14791,
     /*  53441 */     GIR_EraseRootFromParent_Done,
     /*  53442 */   // Label 898: @53442
     /*  53442 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(53499), // Rule ID 14794 //
     /*  53447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53478 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53484 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53497 */     GIR_RootConstrainSelectedInstOperands,
     /*  53498 */     // GIR_Coverage, 14794,
     /*  53498 */     GIR_EraseRootFromParent_Done,
     /*  53499 */   // Label 899: @53499
     /*  53499 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(53556), // Rule ID 8273 //
     /*  53504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53535 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53541 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53554 */     GIR_RootConstrainSelectedInstOperands,
     /*  53555 */     // GIR_Coverage, 8273,
     /*  53555 */     GIR_EraseRootFromParent_Done,
     /*  53556 */   // Label 900: @53556
     /*  53556 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(53613), // Rule ID 8274 //
     /*  53561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53598 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53611 */     GIR_RootConstrainSelectedInstOperands,
     /*  53612 */     // GIR_Coverage, 8274,
     /*  53612 */     GIR_EraseRootFromParent_Done,
     /*  53613 */   // Label 901: @53613
     /*  53613 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(53660), // Rule ID 10525 //
     /*  53618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53629 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  53629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  53632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  53636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  53644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  53656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  53658 */     GIR_RootConstrainSelectedInstOperands,
     /*  53659 */     // GIR_Coverage, 10525,
     /*  53659 */     GIR_EraseRootFromParent_Done,
     /*  53660 */   // Label 902: @53660
     /*  53660 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(53681), // Rule ID 2739 //
     /*  53665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53668 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  53679 */     GIR_RootConstrainSelectedInstOperands,
     /*  53680 */     // GIR_Coverage, 2739,
     /*  53680 */     GIR_EraseRootFromParent_Done,
     /*  53681 */   // Label 903: @53681
     /*  53681 */   GIM_Reject,
     /*  53682 */ // Label 893: @53682
     /*  53682 */ GIM_Reject,
     /*  53683 */ // Label 824: @53683
     /*  53683 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(54223),
     /*  53688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53698 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(53755), // Rule ID 14784 //
     /*  53703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53734 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53740 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53753 */     GIR_RootConstrainSelectedInstOperands,
     /*  53754 */     // GIR_Coverage, 14784,
     /*  53754 */     GIR_EraseRootFromParent_Done,
     /*  53755 */   // Label 905: @53755
     /*  53755 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(53812), // Rule ID 14787 //
     /*  53760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53797 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53810 */     GIR_RootConstrainSelectedInstOperands,
     /*  53811 */     // GIR_Coverage, 14787,
     /*  53811 */     GIR_EraseRootFromParent_Done,
     /*  53812 */   // Label 906: @53812
     /*  53812 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(53869), // Rule ID 14783 //
     /*  53817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53848 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53854 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53867 */     GIR_RootConstrainSelectedInstOperands,
     /*  53868 */     // GIR_Coverage, 14783,
     /*  53868 */     GIR_EraseRootFromParent_Done,
     /*  53869 */   // Label 907: @53869
     /*  53869 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(53926), // Rule ID 14786 //
     /*  53874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53905 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53911 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53924 */     GIR_RootConstrainSelectedInstOperands,
     /*  53925 */     // GIR_Coverage, 14786,
     /*  53925 */     GIR_EraseRootFromParent_Done,
     /*  53926 */   // Label 908: @53926
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(53983), // Rule ID 14782 //
     /*  53931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53968 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53981 */     GIR_RootConstrainSelectedInstOperands,
     /*  53982 */     // GIR_Coverage, 14782,
     /*  53982 */     GIR_EraseRootFromParent_Done,
     /*  53983 */   // Label 909: @53983
     /*  53983 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(54040), // Rule ID 14785 //
     /*  53988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54019 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54025 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54038 */     GIR_RootConstrainSelectedInstOperands,
     /*  54039 */     // GIR_Coverage, 14785,
     /*  54039 */     GIR_EraseRootFromParent_Done,
     /*  54040 */   // Label 910: @54040
     /*  54040 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(54097), // Rule ID 8269 //
     /*  54045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54076 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54082 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54095 */     GIR_RootConstrainSelectedInstOperands,
     /*  54096 */     // GIR_Coverage, 8269,
     /*  54096 */     GIR_EraseRootFromParent_Done,
     /*  54097 */   // Label 911: @54097
     /*  54097 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(54154), // Rule ID 8270 //
     /*  54102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54133 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54139 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54152 */     GIR_RootConstrainSelectedInstOperands,
     /*  54153 */     // GIR_Coverage, 8270,
     /*  54153 */     GIR_EraseRootFromParent_Done,
     /*  54154 */   // Label 912: @54154
     /*  54154 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(54201), // Rule ID 10524 //
     /*  54159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54170 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  54170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  54173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  54177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  54185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  54197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  54199 */     GIR_RootConstrainSelectedInstOperands,
     /*  54200 */     // GIR_Coverage, 10524,
     /*  54200 */     GIR_EraseRootFromParent_Done,
     /*  54201 */   // Label 913: @54201
     /*  54201 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(54222), // Rule ID 2738 //
     /*  54206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54209 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  54220 */     GIR_RootConstrainSelectedInstOperands,
     /*  54221 */     // GIR_Coverage, 2738,
     /*  54221 */     GIR_EraseRootFromParent_Done,
     /*  54222 */   // Label 914: @54222
     /*  54222 */   GIM_Reject,
     /*  54223 */ // Label 904: @54223
     /*  54223 */ GIM_Reject,
     /*  54224 */ // Label 825: @54224
     /*  54224 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(54695),
     /*  54229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  54239 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(54294), // Rule ID 14724 //
     /*  54244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54275 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54281 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54292 */     GIR_RootConstrainSelectedInstOperands,
     /*  54293 */     // GIR_Coverage, 14724,
     /*  54293 */     GIR_EraseRootFromParent_Done,
     /*  54294 */   // Label 916: @54294
     /*  54294 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(54349), // Rule ID 14727 //
     /*  54299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54336 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54347 */     GIR_RootConstrainSelectedInstOperands,
     /*  54348 */     // GIR_Coverage, 14727,
     /*  54348 */     GIR_EraseRootFromParent_Done,
     /*  54349 */   // Label 917: @54349
     /*  54349 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(54404), // Rule ID 14723 //
     /*  54354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54385 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54391 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54402 */     GIR_RootConstrainSelectedInstOperands,
     /*  54403 */     // GIR_Coverage, 14723,
     /*  54403 */     GIR_EraseRootFromParent_Done,
     /*  54404 */   // Label 918: @54404
     /*  54404 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(54459), // Rule ID 14726 //
     /*  54409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54446 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54457 */     GIR_RootConstrainSelectedInstOperands,
     /*  54458 */     // GIR_Coverage, 14726,
     /*  54458 */     GIR_EraseRootFromParent_Done,
     /*  54459 */   // Label 919: @54459
     /*  54459 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(54514), // Rule ID 14722 //
     /*  54464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54495 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54501 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54512 */     GIR_RootConstrainSelectedInstOperands,
     /*  54513 */     // GIR_Coverage, 14722,
     /*  54513 */     GIR_EraseRootFromParent_Done,
     /*  54514 */   // Label 920: @54514
     /*  54514 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(54569), // Rule ID 14725 //
     /*  54519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54550 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54556 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54567 */     GIR_RootConstrainSelectedInstOperands,
     /*  54568 */     // GIR_Coverage, 14725,
     /*  54568 */     GIR_EraseRootFromParent_Done,
     /*  54569 */   // Label 921: @54569
     /*  54569 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(54624), // Rule ID 7322 //
     /*  54574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54611 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54622 */     GIR_RootConstrainSelectedInstOperands,
     /*  54623 */     // GIR_Coverage, 7322,
     /*  54623 */     GIR_EraseRootFromParent_Done,
     /*  54624 */   // Label 922: @54624
     /*  54624 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(54679), // Rule ID 7323 //
     /*  54629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54660 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54666 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54677 */     GIR_RootConstrainSelectedInstOperands,
     /*  54678 */     // GIR_Coverage, 7323,
     /*  54678 */     GIR_EraseRootFromParent_Done,
     /*  54679 */   // Label 923: @54679
     /*  54679 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(54694), // Rule ID 3132 //
     /*  54684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54687 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  54692 */     GIR_RootConstrainSelectedInstOperands,
     /*  54693 */     // GIR_Coverage, 3132,
     /*  54693 */     GIR_Done,
     /*  54694 */   // Label 924: @54694
     /*  54694 */   GIM_Reject,
     /*  54695 */ // Label 915: @54695
     /*  54695 */ GIM_Reject,
     /*  54696 */ // Label 826: @54696
     /*  54696 */ GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(55236),
     /*  54701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  54711 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(54768), // Rule ID 14775 //
     /*  54716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54747 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54753 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54766 */     GIR_RootConstrainSelectedInstOperands,
     /*  54767 */     // GIR_Coverage, 14775,
     /*  54767 */     GIR_EraseRootFromParent_Done,
     /*  54768 */   // Label 926: @54768
     /*  54768 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(54825), // Rule ID 14778 //
     /*  54773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54804 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54810 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54823 */     GIR_RootConstrainSelectedInstOperands,
     /*  54824 */     // GIR_Coverage, 14778,
     /*  54824 */     GIR_EraseRootFromParent_Done,
     /*  54825 */   // Label 927: @54825
     /*  54825 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(54882), // Rule ID 14774 //
     /*  54830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54861 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54867 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54880 */     GIR_RootConstrainSelectedInstOperands,
     /*  54881 */     // GIR_Coverage, 14774,
     /*  54881 */     GIR_EraseRootFromParent_Done,
     /*  54882 */   // Label 928: @54882
     /*  54882 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(54939), // Rule ID 14777 //
     /*  54887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54918 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54924 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54937 */     GIR_RootConstrainSelectedInstOperands,
     /*  54938 */     // GIR_Coverage, 14777,
     /*  54938 */     GIR_EraseRootFromParent_Done,
     /*  54939 */   // Label 929: @54939
     /*  54939 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(54996), // Rule ID 14773 //
     /*  54944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54975 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54981 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54994 */     GIR_RootConstrainSelectedInstOperands,
     /*  54995 */     // GIR_Coverage, 14773,
     /*  54995 */     GIR_EraseRootFromParent_Done,
     /*  54996 */   // Label 930: @54996
     /*  54996 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(55053), // Rule ID 14776 //
     /*  55001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55032 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55038 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55051 */     GIR_RootConstrainSelectedInstOperands,
     /*  55052 */     // GIR_Coverage, 14776,
     /*  55052 */     GIR_EraseRootFromParent_Done,
     /*  55053 */   // Label 931: @55053
     /*  55053 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(55110), // Rule ID 8265 //
     /*  55058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55095 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55108 */     GIR_RootConstrainSelectedInstOperands,
     /*  55109 */     // GIR_Coverage, 8265,
     /*  55109 */     GIR_EraseRootFromParent_Done,
     /*  55110 */   // Label 932: @55110
     /*  55110 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(55167), // Rule ID 8266 //
     /*  55115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55146 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55152 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55165 */     GIR_RootConstrainSelectedInstOperands,
     /*  55166 */     // GIR_Coverage, 8266,
     /*  55166 */     GIR_EraseRootFromParent_Done,
     /*  55167 */   // Label 933: @55167
     /*  55167 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(55214), // Rule ID 10523 //
     /*  55172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55183 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  55183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  55186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  55190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  55198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  55210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  55212 */     GIR_RootConstrainSelectedInstOperands,
     /*  55213 */     // GIR_Coverage, 10523,
     /*  55213 */     GIR_EraseRootFromParent_Done,
     /*  55214 */   // Label 934: @55214
     /*  55214 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(55235), // Rule ID 2737 //
     /*  55219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55222 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  55233 */     GIR_RootConstrainSelectedInstOperands,
     /*  55234 */     // GIR_Coverage, 2737,
     /*  55234 */     GIR_EraseRootFromParent_Done,
     /*  55235 */   // Label 935: @55235
     /*  55235 */   GIM_Reject,
     /*  55236 */ // Label 925: @55236
     /*  55236 */ GIM_Reject,
     /*  55237 */ // Label 827: @55237
     /*  55237 */ GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(55708),
     /*  55242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  55252 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(55307), // Rule ID 14715 //
     /*  55257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55294 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55305 */     GIR_RootConstrainSelectedInstOperands,
     /*  55306 */     // GIR_Coverage, 14715,
     /*  55306 */     GIR_EraseRootFromParent_Done,
     /*  55307 */   // Label 937: @55307
     /*  55307 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(55362), // Rule ID 14718 //
     /*  55312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55349 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55360 */     GIR_RootConstrainSelectedInstOperands,
     /*  55361 */     // GIR_Coverage, 14718,
     /*  55361 */     GIR_EraseRootFromParent_Done,
     /*  55362 */   // Label 938: @55362
     /*  55362 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(55417), // Rule ID 14714 //
     /*  55367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55398 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55404 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55415 */     GIR_RootConstrainSelectedInstOperands,
     /*  55416 */     // GIR_Coverage, 14714,
     /*  55416 */     GIR_EraseRootFromParent_Done,
     /*  55417 */   // Label 939: @55417
     /*  55417 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(55472), // Rule ID 14717 //
     /*  55422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55459 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55470 */     GIR_RootConstrainSelectedInstOperands,
     /*  55471 */     // GIR_Coverage, 14717,
     /*  55471 */     GIR_EraseRootFromParent_Done,
     /*  55472 */   // Label 940: @55472
     /*  55472 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(55527), // Rule ID 14713 //
     /*  55477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55508 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55514 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55525 */     GIR_RootConstrainSelectedInstOperands,
     /*  55526 */     // GIR_Coverage, 14713,
     /*  55526 */     GIR_EraseRootFromParent_Done,
     /*  55527 */   // Label 941: @55527
     /*  55527 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(55582), // Rule ID 14716 //
     /*  55532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55563 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55569 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55580 */     GIR_RootConstrainSelectedInstOperands,
     /*  55581 */     // GIR_Coverage, 14716,
     /*  55581 */     GIR_EraseRootFromParent_Done,
     /*  55582 */   // Label 942: @55582
     /*  55582 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(55637), // Rule ID 7318 //
     /*  55587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55618 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55624 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55635 */     GIR_RootConstrainSelectedInstOperands,
     /*  55636 */     // GIR_Coverage, 7318,
     /*  55636 */     GIR_EraseRootFromParent_Done,
     /*  55637 */   // Label 943: @55637
     /*  55637 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(55692), // Rule ID 7319 //
     /*  55642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55673 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55679 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55690 */     GIR_RootConstrainSelectedInstOperands,
     /*  55691 */     // GIR_Coverage, 7319,
     /*  55691 */     GIR_EraseRootFromParent_Done,
     /*  55692 */   // Label 944: @55692
     /*  55692 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(55707), // Rule ID 3131 //
     /*  55697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55700 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  55705 */     GIR_RootConstrainSelectedInstOperands,
     /*  55706 */     // GIR_Coverage, 3131,
     /*  55706 */     GIR_Done,
     /*  55707 */   // Label 945: @55707
     /*  55707 */   GIM_Reject,
     /*  55708 */ // Label 936: @55708
     /*  55708 */ GIM_Reject,
     /*  55709 */ // Label 828: @55709
     /*  55709 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(56249),
     /*  55714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55724 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(55781), // Rule ID 14766 //
     /*  55729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55760 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55766 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55779 */     GIR_RootConstrainSelectedInstOperands,
     /*  55780 */     // GIR_Coverage, 14766,
     /*  55780 */     GIR_EraseRootFromParent_Done,
     /*  55781 */   // Label 947: @55781
     /*  55781 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(55838), // Rule ID 14769 //
     /*  55786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55817 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55823 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55836 */     GIR_RootConstrainSelectedInstOperands,
     /*  55837 */     // GIR_Coverage, 14769,
     /*  55837 */     GIR_EraseRootFromParent_Done,
     /*  55838 */   // Label 948: @55838
     /*  55838 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(55895), // Rule ID 14765 //
     /*  55843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55874 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55880 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55893 */     GIR_RootConstrainSelectedInstOperands,
     /*  55894 */     // GIR_Coverage, 14765,
     /*  55894 */     GIR_EraseRootFromParent_Done,
     /*  55895 */   // Label 949: @55895
     /*  55895 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(55952), // Rule ID 14768 //
     /*  55900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55931 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55937 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55950 */     GIR_RootConstrainSelectedInstOperands,
     /*  55951 */     // GIR_Coverage, 14768,
     /*  55951 */     GIR_EraseRootFromParent_Done,
     /*  55952 */   // Label 950: @55952
     /*  55952 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(56009), // Rule ID 14764 //
     /*  55957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55994 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56007 */     GIR_RootConstrainSelectedInstOperands,
     /*  56008 */     // GIR_Coverage, 14764,
     /*  56008 */     GIR_EraseRootFromParent_Done,
     /*  56009 */   // Label 951: @56009
     /*  56009 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(56066), // Rule ID 14767 //
     /*  56014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56045 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56051 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56064 */     GIR_RootConstrainSelectedInstOperands,
     /*  56065 */     // GIR_Coverage, 14767,
     /*  56065 */     GIR_EraseRootFromParent_Done,
     /*  56066 */   // Label 952: @56066
     /*  56066 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(56123), // Rule ID 8261 //
     /*  56071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56108 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56121 */     GIR_RootConstrainSelectedInstOperands,
     /*  56122 */     // GIR_Coverage, 8261,
     /*  56122 */     GIR_EraseRootFromParent_Done,
     /*  56123 */   // Label 953: @56123
     /*  56123 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(56180), // Rule ID 8262 //
     /*  56128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56159 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56165 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56178 */     GIR_RootConstrainSelectedInstOperands,
     /*  56179 */     // GIR_Coverage, 8262,
     /*  56179 */     GIR_EraseRootFromParent_Done,
     /*  56180 */   // Label 954: @56180
     /*  56180 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(56227), // Rule ID 10522 //
     /*  56185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56196 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  56196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  56203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56225 */     GIR_RootConstrainSelectedInstOperands,
     /*  56226 */     // GIR_Coverage, 10522,
     /*  56226 */     GIR_EraseRootFromParent_Done,
     /*  56227 */   // Label 955: @56227
     /*  56227 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(56248), // Rule ID 2736 //
     /*  56232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56235 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56246 */     GIR_RootConstrainSelectedInstOperands,
     /*  56247 */     // GIR_Coverage, 2736,
     /*  56247 */     GIR_EraseRootFromParent_Done,
     /*  56248 */   // Label 956: @56248
     /*  56248 */   GIM_Reject,
     /*  56249 */ // Label 946: @56249
     /*  56249 */ GIM_Reject,
     /*  56250 */ // Label 829: @56250
     /*  56250 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(56721),
     /*  56255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56265 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(56320), // Rule ID 14706 //
     /*  56270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56301 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56307 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56318 */     GIR_RootConstrainSelectedInstOperands,
     /*  56319 */     // GIR_Coverage, 14706,
     /*  56319 */     GIR_EraseRootFromParent_Done,
     /*  56320 */   // Label 958: @56320
     /*  56320 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(56375), // Rule ID 14709 //
     /*  56325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56356 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56362 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56373 */     GIR_RootConstrainSelectedInstOperands,
     /*  56374 */     // GIR_Coverage, 14709,
     /*  56374 */     GIR_EraseRootFromParent_Done,
     /*  56375 */   // Label 959: @56375
     /*  56375 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(56430), // Rule ID 14705 //
     /*  56380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56417 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56428 */     GIR_RootConstrainSelectedInstOperands,
     /*  56429 */     // GIR_Coverage, 14705,
     /*  56429 */     GIR_EraseRootFromParent_Done,
     /*  56430 */   // Label 960: @56430
     /*  56430 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(56485), // Rule ID 14708 //
     /*  56435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56472 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56483 */     GIR_RootConstrainSelectedInstOperands,
     /*  56484 */     // GIR_Coverage, 14708,
     /*  56484 */     GIR_EraseRootFromParent_Done,
     /*  56485 */   // Label 961: @56485
     /*  56485 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(56540), // Rule ID 14704 //
     /*  56490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56527 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56538 */     GIR_RootConstrainSelectedInstOperands,
     /*  56539 */     // GIR_Coverage, 14704,
     /*  56539 */     GIR_EraseRootFromParent_Done,
     /*  56540 */   // Label 962: @56540
     /*  56540 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(56595), // Rule ID 14707 //
     /*  56545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56576 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56582 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56593 */     GIR_RootConstrainSelectedInstOperands,
     /*  56594 */     // GIR_Coverage, 14707,
     /*  56594 */     GIR_EraseRootFromParent_Done,
     /*  56595 */   // Label 963: @56595
     /*  56595 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(56650), // Rule ID 7314 //
     /*  56600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56631 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56637 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56648 */     GIR_RootConstrainSelectedInstOperands,
     /*  56649 */     // GIR_Coverage, 7314,
     /*  56649 */     GIR_EraseRootFromParent_Done,
     /*  56650 */   // Label 964: @56650
     /*  56650 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(56705), // Rule ID 7315 //
     /*  56655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56686 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56692 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56703 */     GIR_RootConstrainSelectedInstOperands,
     /*  56704 */     // GIR_Coverage, 7315,
     /*  56704 */     GIR_EraseRootFromParent_Done,
     /*  56705 */   // Label 965: @56705
     /*  56705 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(56720), // Rule ID 3130 //
     /*  56710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56713 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  56718 */     GIR_RootConstrainSelectedInstOperands,
     /*  56719 */     // GIR_Coverage, 3130,
     /*  56719 */     GIR_Done,
     /*  56720 */   // Label 966: @56720
     /*  56720 */   GIM_Reject,
     /*  56721 */ // Label 957: @56721
     /*  56721 */ GIM_Reject,
     /*  56722 */ // Label 830: @56722
     /*  56722 */ GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(57262),
     /*  56727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56737 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(56794), // Rule ID 14757 //
     /*  56742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56773 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56779 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56792 */     GIR_RootConstrainSelectedInstOperands,
     /*  56793 */     // GIR_Coverage, 14757,
     /*  56793 */     GIR_EraseRootFromParent_Done,
     /*  56794 */   // Label 968: @56794
     /*  56794 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(56851), // Rule ID 14760 //
     /*  56799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56830 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56836 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56849 */     GIR_RootConstrainSelectedInstOperands,
     /*  56850 */     // GIR_Coverage, 14760,
     /*  56850 */     GIR_EraseRootFromParent_Done,
     /*  56851 */   // Label 969: @56851
     /*  56851 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(56908), // Rule ID 14756 //
     /*  56856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56887 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56893 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56906 */     GIR_RootConstrainSelectedInstOperands,
     /*  56907 */     // GIR_Coverage, 14756,
     /*  56907 */     GIR_EraseRootFromParent_Done,
     /*  56908 */   // Label 970: @56908
     /*  56908 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(56965), // Rule ID 14759 //
     /*  56913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56944 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56950 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56963 */     GIR_RootConstrainSelectedInstOperands,
     /*  56964 */     // GIR_Coverage, 14759,
     /*  56964 */     GIR_EraseRootFromParent_Done,
     /*  56965 */   // Label 971: @56965
     /*  56965 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(57022), // Rule ID 14755 //
     /*  56970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57007 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57020 */     GIR_RootConstrainSelectedInstOperands,
     /*  57021 */     // GIR_Coverage, 14755,
     /*  57021 */     GIR_EraseRootFromParent_Done,
     /*  57022 */   // Label 972: @57022
     /*  57022 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(57079), // Rule ID 14758 //
     /*  57027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57064 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57077 */     GIR_RootConstrainSelectedInstOperands,
     /*  57078 */     // GIR_Coverage, 14758,
     /*  57078 */     GIR_EraseRootFromParent_Done,
     /*  57079 */   // Label 973: @57079
     /*  57079 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(57136), // Rule ID 8257 //
     /*  57084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57121 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57134 */     GIR_RootConstrainSelectedInstOperands,
     /*  57135 */     // GIR_Coverage, 8257,
     /*  57135 */     GIR_EraseRootFromParent_Done,
     /*  57136 */   // Label 974: @57136
     /*  57136 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(57193), // Rule ID 8258 //
     /*  57141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57178 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57191 */     GIR_RootConstrainSelectedInstOperands,
     /*  57192 */     // GIR_Coverage, 8258,
     /*  57192 */     GIR_EraseRootFromParent_Done,
     /*  57193 */   // Label 975: @57193
     /*  57193 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(57240), // Rule ID 10521 //
     /*  57198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57209 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  57209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  57216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57221 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57238 */     GIR_RootConstrainSelectedInstOperands,
     /*  57239 */     // GIR_Coverage, 10521,
     /*  57239 */     GIR_EraseRootFromParent_Done,
     /*  57240 */   // Label 976: @57240
     /*  57240 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(57261), // Rule ID 2735 //
     /*  57245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57248 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57259 */     GIR_RootConstrainSelectedInstOperands,
     /*  57260 */     // GIR_Coverage, 2735,
     /*  57260 */     GIR_EraseRootFromParent_Done,
     /*  57261 */   // Label 977: @57261
     /*  57261 */   GIM_Reject,
     /*  57262 */ // Label 967: @57262
     /*  57262 */ GIM_Reject,
     /*  57263 */ // Label 831: @57263
     /*  57263 */ GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(57734),
     /*  57268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57278 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(57333), // Rule ID 14697 //
     /*  57283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57314 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57320 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57331 */     GIR_RootConstrainSelectedInstOperands,
     /*  57332 */     // GIR_Coverage, 14697,
     /*  57332 */     GIR_EraseRootFromParent_Done,
     /*  57333 */   // Label 979: @57333
     /*  57333 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(57388), // Rule ID 14700 //
     /*  57338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57369 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57375 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57386 */     GIR_RootConstrainSelectedInstOperands,
     /*  57387 */     // GIR_Coverage, 14700,
     /*  57387 */     GIR_EraseRootFromParent_Done,
     /*  57388 */   // Label 980: @57388
     /*  57388 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(57443), // Rule ID 14696 //
     /*  57393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57430 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57441 */     GIR_RootConstrainSelectedInstOperands,
     /*  57442 */     // GIR_Coverage, 14696,
     /*  57442 */     GIR_EraseRootFromParent_Done,
     /*  57443 */   // Label 981: @57443
     /*  57443 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(57498), // Rule ID 14699 //
     /*  57448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57479 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57485 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57496 */     GIR_RootConstrainSelectedInstOperands,
     /*  57497 */     // GIR_Coverage, 14699,
     /*  57497 */     GIR_EraseRootFromParent_Done,
     /*  57498 */   // Label 982: @57498
     /*  57498 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(57553), // Rule ID 14695 //
     /*  57503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57540 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57551 */     GIR_RootConstrainSelectedInstOperands,
     /*  57552 */     // GIR_Coverage, 14695,
     /*  57552 */     GIR_EraseRootFromParent_Done,
     /*  57553 */   // Label 983: @57553
     /*  57553 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(57608), // Rule ID 14698 //
     /*  57558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57589 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57595 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57606 */     GIR_RootConstrainSelectedInstOperands,
     /*  57607 */     // GIR_Coverage, 14698,
     /*  57607 */     GIR_EraseRootFromParent_Done,
     /*  57608 */   // Label 984: @57608
     /*  57608 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(57663), // Rule ID 7310 //
     /*  57613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57644 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57650 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57661 */     GIR_RootConstrainSelectedInstOperands,
     /*  57662 */     // GIR_Coverage, 7310,
     /*  57662 */     GIR_EraseRootFromParent_Done,
     /*  57663 */   // Label 985: @57663
     /*  57663 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(57718), // Rule ID 7311 //
     /*  57668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57699 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57705 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57716 */     GIR_RootConstrainSelectedInstOperands,
     /*  57717 */     // GIR_Coverage, 7311,
     /*  57717 */     GIR_EraseRootFromParent_Done,
     /*  57718 */   // Label 986: @57718
     /*  57718 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(57733), // Rule ID 3129 //
     /*  57723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57726 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57731 */     GIR_RootConstrainSelectedInstOperands,
     /*  57732 */     // GIR_Coverage, 3129,
     /*  57732 */     GIR_Done,
     /*  57733 */   // Label 987: @57733
     /*  57733 */   GIM_Reject,
     /*  57734 */ // Label 978: @57734
     /*  57734 */ GIM_Reject,
     /*  57735 */ // Label 832: @57735
     /*  57735 */ GIM_Reject,
     /*  57736 */ // Label 6: @57736
     /*  57736 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1006*/ GIMT_Encode4(69782),
     /*  57747 */ /*GILLT_s32*//*Label 988*/ GIMT_Encode4(57835),
     /*  57751 */ /*GILLT_s64*//*Label 989*/ GIMT_Encode4(58195), GIMT_Encode4(0),
     /*  57759 */ /*GILLT_v2s32*//*Label 990*/ GIMT_Encode4(60362),
     /*  57763 */ /*GILLT_v2s64*//*Label 991*/ GIMT_Encode4(61670),
     /*  57767 */ /*GILLT_v4s16*//*Label 992*/ GIMT_Encode4(62978),
     /*  57771 */ /*GILLT_v4s32*//*Label 993*/ GIMT_Encode4(64286),
     /*  57775 */ /*GILLT_v8s8*//*Label 994*/ GIMT_Encode4(65594),
     /*  57779 */ /*GILLT_v8s16*//*Label 995*/ GIMT_Encode4(66902),
     /*  57783 */ /*GILLT_v16s8*//*Label 996*/ GIMT_Encode4(68210),
     /*  57787 */ /*GILLT_nxv1s1*//*Label 997*/ GIMT_Encode4(69518),
     /*  57791 */ /*GILLT_nxv2s1*//*Label 998*/ GIMT_Encode4(69550), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  57803 */ /*GILLT_nxv2s64*//*Label 999*/ GIMT_Encode4(69582),
     /*  57807 */ /*GILLT_nxv4s1*//*Label 1000*/ GIMT_Encode4(69608), GIMT_Encode4(0),
     /*  57815 */ /*GILLT_nxv4s32*//*Label 1001*/ GIMT_Encode4(69640),
     /*  57819 */ /*GILLT_nxv8s1*//*Label 1002*/ GIMT_Encode4(69666),
     /*  57823 */ /*GILLT_nxv8s16*//*Label 1003*/ GIMT_Encode4(69698),
     /*  57827 */ /*GILLT_nxv16s1*//*Label 1004*/ GIMT_Encode4(69724),
     /*  57831 */ /*GILLT_nxv16s8*//*Label 1005*/ GIMT_Encode4(69756),
     /*  57835 */ // Label 988: @57835
     /*  57835 */ GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(58194),
     /*  57840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57846 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(57901), // Rule ID 12960 //
     /*  57851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57888 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57899 */     GIR_RootConstrainSelectedInstOperands,
     /*  57900 */     // GIR_Coverage, 12960,
     /*  57900 */     GIR_EraseRootFromParent_Done,
     /*  57901 */   // Label 1008: @57901
     /*  57901 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(57956), // Rule ID 174 //
     /*  57906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57943 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57954 */     GIR_RootConstrainSelectedInstOperands,
     /*  57955 */     // GIR_Coverage, 174,
     /*  57955 */     GIR_EraseRootFromParent_Done,
     /*  57956 */   // Label 1009: @57956
     /*  57956 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(57997), // Rule ID 146 //
     /*  57961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  57965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57977 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  57981 */     // MIs[1] Operand 1
     /*  57981 */     // No operand predicates
     /*  57981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57983 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  57983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  57986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57990 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  57995 */     GIR_RootConstrainSelectedInstOperands,
     /*  57996 */     // GIR_Coverage, 146,
     /*  57996 */     GIR_EraseRootFromParent_Done,
     /*  57997 */   // Label 1010: @57997
     /*  57997 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(58030), // Rule ID 12962 //
     /*  58002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58017 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58028 */     GIR_RootConstrainSelectedInstOperands,
     /*  58029 */     // GIR_Coverage, 12962,
     /*  58029 */     GIR_EraseRootFromParent_Done,
     /*  58030 */   // Label 1011: @58030
     /*  58030 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(58063), // Rule ID 178 //
     /*  58035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58050 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58061 */     GIR_RootConstrainSelectedInstOperands,
     /*  58062 */     // GIR_Coverage, 178,
     /*  58062 */     GIR_EraseRootFromParent_Done,
     /*  58063 */   // Label 1012: @58063
     /*  58063 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(58116), // Rule ID 12958 //
     /*  58068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58103 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58114 */     GIR_RootConstrainSelectedInstOperands,
     /*  58115 */     // GIR_Coverage, 12958,
     /*  58115 */     GIR_EraseRootFromParent_Done,
     /*  58116 */   // Label 1013: @58116
     /*  58116 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(58169), // Rule ID 172 //
     /*  58121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58150 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58156 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58167 */     GIR_RootConstrainSelectedInstOperands,
     /*  58168 */     // GIR_Coverage, 172,
     /*  58168 */     GIR_EraseRootFromParent_Done,
     /*  58169 */   // Label 1014: @58169
     /*  58169 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(58193), // Rule ID 176 //
     /*  58174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58186 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  58191 */     GIR_RootConstrainSelectedInstOperands,
     /*  58192 */     // GIR_Coverage, 176,
     /*  58192 */     GIR_Done,
     /*  58193 */   // Label 1015: @58193
     /*  58193 */   GIM_Reject,
     /*  58194 */ // Label 1007: @58194
     /*  58194 */ GIM_Reject,
     /*  58195 */ // Label 989: @58195
     /*  58195 */ GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(60361),
     /*  58200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58206 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(58328), // Rule ID 3959 //
     /*  58211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58252 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58256 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58279 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58283 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58287 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58291 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58295 */     // MIs[4] Rn
     /*  58295 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58300 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58304 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58317 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58326 */     GIR_RootConstrainSelectedInstOperands,
     /*  58327 */     // GIR_Coverage, 3959,
     /*  58327 */     GIR_EraseRootFromParent_Done,
     /*  58328 */   // Label 1017: @58328
     /*  58328 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(58450), // Rule ID 13510 //
     /*  58333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58374 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58378 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58397 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58401 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58409 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58413 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58417 */     // MIs[4] Rn
     /*  58417 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58422 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58426 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58439 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58448 */     GIR_RootConstrainSelectedInstOperands,
     /*  58449 */     // GIR_Coverage, 13510,
     /*  58449 */     GIR_EraseRootFromParent_Done,
     /*  58450 */   // Label 1018: @58450
     /*  58450 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(58505), // Rule ID 12961 //
     /*  58455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58475 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58492 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58503 */     GIR_RootConstrainSelectedInstOperands,
     /*  58504 */     // GIR_Coverage, 12961,
     /*  58504 */     GIR_EraseRootFromParent_Done,
     /*  58505 */   // Label 1019: @58505
     /*  58505 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(58560), // Rule ID 175 //
     /*  58510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58534 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58547 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58558 */     GIR_RootConstrainSelectedInstOperands,
     /*  58559 */     // GIR_Coverage, 175,
     /*  58559 */     GIR_EraseRootFromParent_Done,
     /*  58560 */   // Label 1020: @58560
     /*  58560 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(58669), // Rule ID 13310 //
     /*  58565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58613 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58619 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58630 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58634 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58638 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58643 */     // MIs[4] LHS
     /*  58643 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58648 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58650 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58667 */     GIR_RootConstrainSelectedInstOperands,
     /*  58668 */     // GIR_Coverage, 13310,
     /*  58668 */     GIR_EraseRootFromParent_Done,
     /*  58669 */   // Label 1021: @58669
     /*  58669 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(58778), // Rule ID 13309 //
     /*  58674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58722 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58728 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58735 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58739 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58743 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58747 */     // MIs[4] LHS
     /*  58747 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58752 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58757 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58759 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  58772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58776 */     GIR_RootConstrainSelectedInstOperands,
     /*  58777 */     // GIR_Coverage, 13309,
     /*  58777 */     GIR_EraseRootFromParent_Done,
     /*  58778 */   // Label 1022: @58778
     /*  58778 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(58887), // Rule ID 13312 //
     /*  58783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58836 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58848 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58852 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58856 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58861 */     // MIs[4] LHS
     /*  58861 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58866 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58868 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  58885 */     GIR_RootConstrainSelectedInstOperands,
     /*  58886 */     // GIR_Coverage, 13312,
     /*  58886 */     GIR_EraseRootFromParent_Done,
     /*  58887 */   // Label 1023: @58887
     /*  58887 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(58996), // Rule ID 13311 //
     /*  58892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58945 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58953 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58957 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58961 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58965 */     // MIs[4] LHS
     /*  58965 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58970 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58977 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  58990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  58994 */     GIR_RootConstrainSelectedInstOperands,
     /*  58995 */     // GIR_Coverage, 13311,
     /*  58995 */     GIR_EraseRootFromParent_Done,
     /*  58996 */   // Label 1024: @58996
     /*  58996 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(59105), // Rule ID 2462 //
     /*  59001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59058 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59062 */     // MIs[3] LHS
     /*  59062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59067 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59071 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59084 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59086 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59103 */     GIR_RootConstrainSelectedInstOperands,
     /*  59104 */     // GIR_Coverage, 2462,
     /*  59104 */     GIR_EraseRootFromParent_Done,
     /*  59105 */   // Label 1025: @59105
     /*  59105 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(59214), // Rule ID 13307 //
     /*  59110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59167 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59171 */     // MIs[3] LHS
     /*  59171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59180 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59193 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59195 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59212 */     GIR_RootConstrainSelectedInstOperands,
     /*  59213 */     // GIR_Coverage, 13307,
     /*  59213 */     GIR_EraseRootFromParent_Done,
     /*  59214 */   // Label 1026: @59214
     /*  59214 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(59323), // Rule ID 13306 //
     /*  59219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59285 */     // MIs[3] LHS
     /*  59285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59294 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59304 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59321 */     GIR_RootConstrainSelectedInstOperands,
     /*  59322 */     // GIR_Coverage, 13306,
     /*  59322 */     GIR_EraseRootFromParent_Done,
     /*  59323 */   // Label 1027: @59323
     /*  59323 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(59432), // Rule ID 13308 //
     /*  59328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59390 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59394 */     // MIs[3] LHS
     /*  59394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59403 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59409 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59411 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59413 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59430 */     GIR_RootConstrainSelectedInstOperands,
     /*  59431 */     // GIR_Coverage, 13308,
     /*  59431 */     GIR_EraseRootFromParent_Done,
     /*  59432 */   // Label 1028: @59432
     /*  59432 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(59473), // Rule ID 147 //
     /*  59437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  59441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59453 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  59457 */     // MIs[1] Operand 1
     /*  59457 */     // No operand predicates
     /*  59457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59459 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  59459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  59462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59466 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  59471 */     GIR_RootConstrainSelectedInstOperands,
     /*  59472 */     // GIR_Coverage, 147,
     /*  59472 */     GIR_EraseRootFromParent_Done,
     /*  59473 */   // Label 1029: @59473
     /*  59473 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(59506), // Rule ID 12963 //
     /*  59478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59493 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59504 */     GIR_RootConstrainSelectedInstOperands,
     /*  59505 */     // GIR_Coverage, 12963,
     /*  59505 */     GIR_EraseRootFromParent_Done,
     /*  59506 */   // Label 1030: @59506
     /*  59506 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(59539), // Rule ID 179 //
     /*  59511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59526 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59537 */     GIR_RootConstrainSelectedInstOperands,
     /*  59538 */     // GIR_Coverage, 179,
     /*  59538 */     GIR_EraseRootFromParent_Done,
     /*  59539 */   // Label 1031: @59539
     /*  59539 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(59606), // Rule ID 13246 //
     /*  59544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59568 */     // MIs[1] imm
     /*  59568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59580 */     // MIs[2] Operand 1
     /*  59580 */     // No operand predicates
     /*  59580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59590 */     // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59604 */     GIR_RootConstrainSelectedInstOperands,
     /*  59605 */     // GIR_Coverage, 13246,
     /*  59605 */     GIR_EraseRootFromParent_Done,
     /*  59606 */   // Label 1032: @59606
     /*  59606 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(59673), // Rule ID 13634 //
     /*  59611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59635 */     // MIs[1] imm
     /*  59635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59647 */     // MIs[2] Operand 1
     /*  59647 */     // No operand predicates
     /*  59647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59657 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59671 */     GIR_RootConstrainSelectedInstOperands,
     /*  59672 */     // GIR_Coverage, 13634,
     /*  59672 */     GIR_EraseRootFromParent_Done,
     /*  59673 */   // Label 1033: @59673
     /*  59673 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(59740), // Rule ID 13249 //
     /*  59678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59702 */     // MIs[1] imm
     /*  59702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59710 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59714 */     // MIs[2] Operand 1
     /*  59714 */     // No operand predicates
     /*  59714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59724 */     // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59738 */     GIR_RootConstrainSelectedInstOperands,
     /*  59739 */     // GIR_Coverage, 13249,
     /*  59739 */     GIR_EraseRootFromParent_Done,
     /*  59740 */   // Label 1034: @59740
     /*  59740 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(59807), // Rule ID 13637 //
     /*  59745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59769 */     // MIs[1] imm
     /*  59769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59781 */     // MIs[2] Operand 1
     /*  59781 */     // No operand predicates
     /*  59781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59791 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59805 */     GIR_RootConstrainSelectedInstOperands,
     /*  59806 */     // GIR_Coverage, 13637,
     /*  59806 */     GIR_EraseRootFromParent_Done,
     /*  59807 */   // Label 1035: @59807
     /*  59807 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(59860), // Rule ID 12959 //
     /*  59812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  59841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59847 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  59847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  59850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  59858 */     GIR_RootConstrainSelectedInstOperands,
     /*  59859 */     // GIR_Coverage, 12959,
     /*  59859 */     GIR_EraseRootFromParent_Done,
     /*  59860 */   // Label 1036: @59860
     /*  59860 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(59927), // Rule ID 2113 //
     /*  59865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59893 */     // MIs[1] imm
     /*  59893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59905 */     // MIs[2] Operand 1
     /*  59905 */     // No operand predicates
     /*  59905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59911 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  59918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59925 */     GIR_RootConstrainSelectedInstOperands,
     /*  59926 */     // GIR_Coverage, 2113,
     /*  59926 */     GIR_EraseRootFromParent_Done,
     /*  59927 */   // Label 1037: @59927
     /*  59927 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(59994), // Rule ID 6198 //
     /*  59932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59960 */     // MIs[1] imm
     /*  59960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59968 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59972 */     // MIs[2] Operand 1
     /*  59972 */     // No operand predicates
     /*  59972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59978 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  59985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59992 */     GIR_RootConstrainSelectedInstOperands,
     /*  59993 */     // GIR_Coverage, 6198,
     /*  59993 */     GIR_EraseRootFromParent_Done,
     /*  59994 */   // Label 1038: @59994
     /*  59994 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(60061), // Rule ID 2122 //
     /*  59999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60027 */     // MIs[1] imm
     /*  60027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60039 */     // MIs[2] Operand 1
     /*  60039 */     // No operand predicates
     /*  60039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60045 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  60045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60059 */     GIR_RootConstrainSelectedInstOperands,
     /*  60060 */     // GIR_Coverage, 2122,
     /*  60060 */     GIR_EraseRootFromParent_Done,
     /*  60061 */   // Label 1039: @60061
     /*  60061 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60128), // Rule ID 6204 //
     /*  60066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60094 */     // MIs[1] imm
     /*  60094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60102 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60106 */     // MIs[2] Operand 1
     /*  60106 */     // No operand predicates
     /*  60106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60112 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  60112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60126 */     GIR_RootConstrainSelectedInstOperands,
     /*  60127 */     // GIR_Coverage, 6204,
     /*  60127 */     GIR_EraseRootFromParent_Done,
     /*  60128 */   // Label 1040: @60128
     /*  60128 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(60181), // Rule ID 173 //
     /*  60133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60162 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60168 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60179 */     GIR_RootConstrainSelectedInstOperands,
     /*  60180 */     // GIR_Coverage, 173,
     /*  60180 */     GIR_EraseRootFromParent_Done,
     /*  60181 */   // Label 1041: @60181
     /*  60181 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(60245), // Rule ID 13598 //
     /*  60186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60232 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60237 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  60239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60243 */     GIR_RootConstrainSelectedInstOperands,
     /*  60244 */     // GIR_Coverage, 13598,
     /*  60244 */     GIR_EraseRootFromParent_Done,
     /*  60245 */   // Label 1042: @60245
     /*  60245 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(60309), // Rule ID 4993 //
     /*  60250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60286 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60296 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60301 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  60303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60307 */     GIR_RootConstrainSelectedInstOperands,
     /*  60308 */     // GIR_Coverage, 4993,
     /*  60308 */     GIR_EraseRootFromParent_Done,
     /*  60309 */   // Label 1043: @60309
     /*  60309 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(60333), // Rule ID 177 //
     /*  60314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60326 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  60331 */     GIR_RootConstrainSelectedInstOperands,
     /*  60332 */     // GIR_Coverage, 177,
     /*  60332 */     GIR_Done,
     /*  60333 */   // Label 1044: @60333
     /*  60333 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(60360), // Rule ID 4999 //
     /*  60338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60353 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  60358 */     GIR_RootConstrainSelectedInstOperands,
     /*  60359 */     // GIR_Coverage, 4999,
     /*  60359 */     GIR_Done,
     /*  60360 */   // Label 1045: @60360
     /*  60360 */   GIM_Reject,
     /*  60361 */ // Label 1016: @60361
     /*  60361 */ GIM_Reject,
     /*  60362 */ // Label 990: @60362
     /*  60362 */ GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61669),
     /*  60367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60373 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(60482), // Rule ID 13303 //
     /*  60378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60426 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60443 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60447 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60451 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60456 */     // MIs[4] LHS
     /*  60456 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60461 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60463 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60480 */     GIR_RootConstrainSelectedInstOperands,
     /*  60481 */     // GIR_Coverage, 13303,
     /*  60481 */     GIR_EraseRootFromParent_Done,
     /*  60482 */   // Label 1047: @60482
     /*  60482 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(60591), // Rule ID 13302 //
     /*  60487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60535 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60552 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60556 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60560 */     // MIs[4] LHS
     /*  60560 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60565 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60570 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60572 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60589 */     GIR_RootConstrainSelectedInstOperands,
     /*  60590 */     // GIR_Coverage, 13302,
     /*  60590 */     GIR_EraseRootFromParent_Done,
     /*  60591 */   // Label 1048: @60591
     /*  60591 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(60700), // Rule ID 13305 //
     /*  60596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60649 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60655 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60657 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60661 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60665 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60669 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60674 */     // MIs[4] LHS
     /*  60674 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60679 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60681 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60698 */     GIR_RootConstrainSelectedInstOperands,
     /*  60699 */     // GIR_Coverage, 13305,
     /*  60699 */     GIR_EraseRootFromParent_Done,
     /*  60700 */   // Label 1049: @60700
     /*  60700 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(60809), // Rule ID 13304 //
     /*  60705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60758 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60770 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60774 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60778 */     // MIs[4] LHS
     /*  60778 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60783 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60788 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60790 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60807 */     GIR_RootConstrainSelectedInstOperands,
     /*  60808 */     // GIR_Coverage, 13304,
     /*  60808 */     GIR_EraseRootFromParent_Done,
     /*  60809 */   // Label 1050: @60809
     /*  60809 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(60918), // Rule ID 2461 //
     /*  60814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60875 */     // MIs[3] LHS
     /*  60875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  60880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  60884 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  60892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60897 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60899 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  60908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  60912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  60916 */     GIR_RootConstrainSelectedInstOperands,
     /*  60917 */     // GIR_Coverage, 2461,
     /*  60917 */     GIR_EraseRootFromParent_Done,
     /*  60918 */   // Label 1051: @60918
     /*  60918 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(61027), // Rule ID 13300 //
     /*  60923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60984 */     // MIs[3] LHS
     /*  60984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  60989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  60993 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61006 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61008 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61025 */     GIR_RootConstrainSelectedInstOperands,
     /*  61026 */     // GIR_Coverage, 13300,
     /*  61026 */     GIR_EraseRootFromParent_Done,
     /*  61027 */   // Label 1052: @61027
     /*  61027 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(61136), // Rule ID 13299 //
     /*  61032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61098 */     // MIs[3] LHS
     /*  61098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61103 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61107 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61115 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61117 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61134 */     GIR_RootConstrainSelectedInstOperands,
     /*  61135 */     // GIR_Coverage, 13299,
     /*  61135 */     GIR_EraseRootFromParent_Done,
     /*  61136 */   // Label 1053: @61136
     /*  61136 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(61245), // Rule ID 13301 //
     /*  61141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61203 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61207 */     // MIs[3] LHS
     /*  61207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61216 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61222 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61224 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61226 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61243 */     GIR_RootConstrainSelectedInstOperands,
     /*  61244 */     // GIR_Coverage, 13301,
     /*  61244 */     GIR_EraseRootFromParent_Done,
     /*  61245 */   // Label 1054: @61245
     /*  61245 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(61312), // Rule ID 13266 //
     /*  61250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61274 */     // MIs[1] imm
     /*  61274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61282 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61286 */     // MIs[2] Operand 1
     /*  61286 */     // No operand predicates
     /*  61286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61296 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61310 */     GIR_RootConstrainSelectedInstOperands,
     /*  61311 */     // GIR_Coverage, 13266,
     /*  61311 */     GIR_EraseRootFromParent_Done,
     /*  61312 */   // Label 1055: @61312
     /*  61312 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(61379), // Rule ID 13287 //
     /*  61317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61341 */     // MIs[1] imm
     /*  61341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61349 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61353 */     // MIs[2] Operand 1
     /*  61353 */     // No operand predicates
     /*  61353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61363 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61377 */     GIR_RootConstrainSelectedInstOperands,
     /*  61378 */     // GIR_Coverage, 13287,
     /*  61378 */     GIR_EraseRootFromParent_Done,
     /*  61379 */   // Label 1056: @61379
     /*  61379 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(61446), // Rule ID 2230 //
     /*  61384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61412 */     // MIs[1] imm
     /*  61412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61424 */     // MIs[2] Operand 1
     /*  61424 */     // No operand predicates
     /*  61424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61430 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61444 */     GIR_RootConstrainSelectedInstOperands,
     /*  61445 */     // GIR_Coverage, 2230,
     /*  61445 */     GIR_EraseRootFromParent_Done,
     /*  61446 */   // Label 1057: @61446
     /*  61446 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(61513), // Rule ID 2289 //
     /*  61451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61479 */     // MIs[1] imm
     /*  61479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61487 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61491 */     // MIs[2] Operand 1
     /*  61491 */     // No operand predicates
     /*  61491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61497 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61511 */     GIR_RootConstrainSelectedInstOperands,
     /*  61512 */     // GIR_Coverage, 2289,
     /*  61512 */     GIR_EraseRootFromParent_Done,
     /*  61513 */   // Label 1058: @61513
     /*  61513 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(61577), // Rule ID 13597 //
     /*  61518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61550 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61556 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61564 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61569 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  61571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61575 */     GIR_RootConstrainSelectedInstOperands,
     /*  61576 */     // GIR_Coverage, 13597,
     /*  61576 */     GIR_EraseRootFromParent_Done,
     /*  61577 */   // Label 1059: @61577
     /*  61577 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(61641), // Rule ID 4992 //
     /*  61582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61618 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61624 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61628 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61633 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  61635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61639 */     GIR_RootConstrainSelectedInstOperands,
     /*  61640 */     // GIR_Coverage, 4992,
     /*  61640 */     GIR_EraseRootFromParent_Done,
     /*  61641 */   // Label 1060: @61641
     /*  61641 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(61668), // Rule ID 4998 //
     /*  61646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61661 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  61666 */     GIR_RootConstrainSelectedInstOperands,
     /*  61667 */     // GIR_Coverage, 4998,
     /*  61667 */     GIR_Done,
     /*  61668 */   // Label 1061: @61668
     /*  61668 */   GIM_Reject,
     /*  61669 */ // Label 1046: @61669
     /*  61669 */ GIM_Reject,
     /*  61670 */ // Label 991: @61670
     /*  61670 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62977),
     /*  61675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61681 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(61790), // Rule ID 13331 //
     /*  61686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61734 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61751 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61755 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61759 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61764 */     // MIs[4] LHS
     /*  61764 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61769 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61771 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61788 */     GIR_RootConstrainSelectedInstOperands,
     /*  61789 */     // GIR_Coverage, 13331,
     /*  61789 */     GIR_EraseRootFromParent_Done,
     /*  61790 */   // Label 1063: @61790
     /*  61790 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(61899), // Rule ID 13330 //
     /*  61795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61843 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61864 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61868 */     // MIs[4] LHS
     /*  61868 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61873 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61878 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61880 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61897 */     GIR_RootConstrainSelectedInstOperands,
     /*  61898 */     // GIR_Coverage, 13330,
     /*  61898 */     GIR_EraseRootFromParent_Done,
     /*  61899 */   // Label 1064: @61899
     /*  61899 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62008), // Rule ID 13333 //
     /*  61904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61957 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61963 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61965 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61969 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61973 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61977 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61982 */     // MIs[4] LHS
     /*  61982 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61987 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61989 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62006 */     GIR_RootConstrainSelectedInstOperands,
     /*  62007 */     // GIR_Coverage, 13333,
     /*  62007 */     GIR_EraseRootFromParent_Done,
     /*  62008 */   // Label 1065: @62008
     /*  62008 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62117), // Rule ID 13332 //
     /*  62013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62066 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62082 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62086 */     // MIs[4] LHS
     /*  62086 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62091 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62096 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62098 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62115 */     GIR_RootConstrainSelectedInstOperands,
     /*  62116 */     // GIR_Coverage, 13332,
     /*  62116 */     GIR_EraseRootFromParent_Done,
     /*  62117 */   // Label 1066: @62117
     /*  62117 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62226), // Rule ID 2465 //
     /*  62122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62179 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62183 */     // MIs[3] LHS
     /*  62183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62188 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62192 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62205 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62207 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62224 */     GIR_RootConstrainSelectedInstOperands,
     /*  62225 */     // GIR_Coverage, 2465,
     /*  62225 */     GIR_EraseRootFromParent_Done,
     /*  62226 */   // Label 1067: @62226
     /*  62226 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(62335), // Rule ID 13328 //
     /*  62231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62288 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62292 */     // MIs[3] LHS
     /*  62292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62297 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62301 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62314 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62316 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62333 */     GIR_RootConstrainSelectedInstOperands,
     /*  62334 */     // GIR_Coverage, 13328,
     /*  62334 */     GIR_EraseRootFromParent_Done,
     /*  62335 */   // Label 1068: @62335
     /*  62335 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(62444), // Rule ID 13327 //
     /*  62340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62402 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62406 */     // MIs[3] LHS
     /*  62406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62411 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62415 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62423 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62425 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62442 */     GIR_RootConstrainSelectedInstOperands,
     /*  62443 */     // GIR_Coverage, 13327,
     /*  62443 */     GIR_EraseRootFromParent_Done,
     /*  62444 */   // Label 1069: @62444
     /*  62444 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(62553), // Rule ID 13329 //
     /*  62449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62511 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62515 */     // MIs[3] LHS
     /*  62515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62524 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62532 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62534 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62551 */     GIR_RootConstrainSelectedInstOperands,
     /*  62552 */     // GIR_Coverage, 13329,
     /*  62552 */     GIR_EraseRootFromParent_Done,
     /*  62553 */   // Label 1070: @62553
     /*  62553 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(62620), // Rule ID 13270 //
     /*  62558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62582 */     // MIs[1] imm
     /*  62582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62594 */     // MIs[2] Operand 1
     /*  62594 */     // No operand predicates
     /*  62594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62604 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62618 */     GIR_RootConstrainSelectedInstOperands,
     /*  62619 */     // GIR_Coverage, 13270,
     /*  62619 */     GIR_EraseRootFromParent_Done,
     /*  62620 */   // Label 1071: @62620
     /*  62620 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(62687), // Rule ID 13291 //
     /*  62625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62649 */     // MIs[1] imm
     /*  62649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62657 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62661 */     // MIs[2] Operand 1
     /*  62661 */     // No operand predicates
     /*  62661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62671 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62685 */     GIR_RootConstrainSelectedInstOperands,
     /*  62686 */     // GIR_Coverage, 13291,
     /*  62686 */     GIR_EraseRootFromParent_Done,
     /*  62687 */   // Label 1072: @62687
     /*  62687 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(62754), // Rule ID 2234 //
     /*  62692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62720 */     // MIs[1] imm
     /*  62720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62732 */     // MIs[2] Operand 1
     /*  62732 */     // No operand predicates
     /*  62732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62738 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62752 */     GIR_RootConstrainSelectedInstOperands,
     /*  62753 */     // GIR_Coverage, 2234,
     /*  62753 */     GIR_EraseRootFromParent_Done,
     /*  62754 */   // Label 1073: @62754
     /*  62754 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(62821), // Rule ID 2293 //
     /*  62759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62787 */     // MIs[1] imm
     /*  62787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62795 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62799 */     // MIs[2] Operand 1
     /*  62799 */     // No operand predicates
     /*  62799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62805 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62819 */     GIR_RootConstrainSelectedInstOperands,
     /*  62820 */     // GIR_Coverage, 2293,
     /*  62820 */     GIR_EraseRootFromParent_Done,
     /*  62821 */   // Label 1074: @62821
     /*  62821 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(62885), // Rule ID 13601 //
     /*  62826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62858 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62872 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62877 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62883 */     GIR_RootConstrainSelectedInstOperands,
     /*  62884 */     // GIR_Coverage, 13601,
     /*  62884 */     GIR_EraseRootFromParent_Done,
     /*  62885 */   // Label 1075: @62885
     /*  62885 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(62949), // Rule ID 4996 //
     /*  62890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62926 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62936 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62941 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62947 */     GIR_RootConstrainSelectedInstOperands,
     /*  62948 */     // GIR_Coverage, 4996,
     /*  62948 */     GIR_EraseRootFromParent_Done,
     /*  62949 */   // Label 1076: @62949
     /*  62949 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(62976), // Rule ID 5002 //
     /*  62954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62969 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  62974 */     GIR_RootConstrainSelectedInstOperands,
     /*  62975 */     // GIR_Coverage, 5002,
     /*  62975 */     GIR_Done,
     /*  62976 */   // Label 1077: @62976
     /*  62976 */   GIM_Reject,
     /*  62977 */ // Label 1062: @62977
     /*  62977 */ GIM_Reject,
     /*  62978 */ // Label 992: @62978
     /*  62978 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64285),
     /*  62983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  62986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  62989 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63098), // Rule ID 13296 //
     /*  62994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63042 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63063 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63067 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63072 */     // MIs[4] LHS
     /*  63072 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63079 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63096 */     GIR_RootConstrainSelectedInstOperands,
     /*  63097 */     // GIR_Coverage, 13296,
     /*  63097 */     GIR_EraseRootFromParent_Done,
     /*  63098 */   // Label 1079: @63098
     /*  63098 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63207), // Rule ID 13295 //
     /*  63103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63151 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63168 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63172 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63176 */     // MIs[4] LHS
     /*  63176 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63181 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63188 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63205 */     GIR_RootConstrainSelectedInstOperands,
     /*  63206 */     // GIR_Coverage, 13295,
     /*  63206 */     GIR_EraseRootFromParent_Done,
     /*  63207 */   // Label 1080: @63207
     /*  63207 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(63316), // Rule ID 13298 //
     /*  63212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63265 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63277 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63281 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63285 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63290 */     // MIs[4] LHS
     /*  63290 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63295 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63297 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63314 */     GIR_RootConstrainSelectedInstOperands,
     /*  63315 */     // GIR_Coverage, 13298,
     /*  63315 */     GIR_EraseRootFromParent_Done,
     /*  63316 */   // Label 1081: @63316
     /*  63316 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(63425), // Rule ID 13297 //
     /*  63321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63374 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63380 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63386 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63390 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63394 */     // MIs[4] LHS
     /*  63394 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63399 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63404 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63406 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63423 */     GIR_RootConstrainSelectedInstOperands,
     /*  63424 */     // GIR_Coverage, 13297,
     /*  63424 */     GIR_EraseRootFromParent_Done,
     /*  63425 */   // Label 1082: @63425
     /*  63425 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(63534), // Rule ID 2460 //
     /*  63430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63491 */     // MIs[3] LHS
     /*  63491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63500 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63506 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63513 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63515 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63532 */     GIR_RootConstrainSelectedInstOperands,
     /*  63533 */     // GIR_Coverage, 2460,
     /*  63533 */     GIR_EraseRootFromParent_Done,
     /*  63534 */   // Label 1083: @63534
     /*  63534 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(63643), // Rule ID 13293 //
     /*  63539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63596 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63600 */     // MIs[3] LHS
     /*  63600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63609 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63615 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63624 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63641 */     GIR_RootConstrainSelectedInstOperands,
     /*  63642 */     // GIR_Coverage, 13293,
     /*  63642 */     GIR_EraseRootFromParent_Done,
     /*  63643 */   // Label 1084: @63643
     /*  63643 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(63752), // Rule ID 13292 //
     /*  63648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63710 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63714 */     // MIs[3] LHS
     /*  63714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63723 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63731 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63733 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63750 */     GIR_RootConstrainSelectedInstOperands,
     /*  63751 */     // GIR_Coverage, 13292,
     /*  63751 */     GIR_EraseRootFromParent_Done,
     /*  63752 */   // Label 1085: @63752
     /*  63752 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(63861), // Rule ID 13294 //
     /*  63757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63819 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63823 */     // MIs[3] LHS
     /*  63823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63832 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63838 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63840 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63842 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63859 */     GIR_RootConstrainSelectedInstOperands,
     /*  63860 */     // GIR_Coverage, 13294,
     /*  63860 */     GIR_EraseRootFromParent_Done,
     /*  63861 */   // Label 1086: @63861
     /*  63861 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(63928), // Rule ID 13262 //
     /*  63866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63890 */     // MIs[1] imm
     /*  63890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63898 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63902 */     // MIs[2] Operand 1
     /*  63902 */     // No operand predicates
     /*  63902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63912 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  63915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63926 */     GIR_RootConstrainSelectedInstOperands,
     /*  63927 */     // GIR_Coverage, 13262,
     /*  63927 */     GIR_EraseRootFromParent_Done,
     /*  63928 */   // Label 1087: @63928
     /*  63928 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(63995), // Rule ID 13283 //
     /*  63933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63957 */     // MIs[1] imm
     /*  63957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63965 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63969 */     // MIs[2] Operand 1
     /*  63969 */     // No operand predicates
     /*  63969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63979 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  63982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63993 */     GIR_RootConstrainSelectedInstOperands,
     /*  63994 */     // GIR_Coverage, 13283,
     /*  63994 */     GIR_EraseRootFromParent_Done,
     /*  63995 */   // Label 1088: @63995
     /*  63995 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64062), // Rule ID 2226 //
     /*  64000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64028 */     // MIs[1] imm
     /*  64028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64036 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64040 */     // MIs[2] Operand 1
     /*  64040 */     // No operand predicates
     /*  64040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64046 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  64049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64060 */     GIR_RootConstrainSelectedInstOperands,
     /*  64061 */     // GIR_Coverage, 2226,
     /*  64061 */     GIR_EraseRootFromParent_Done,
     /*  64062 */   // Label 1089: @64062
     /*  64062 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64129), // Rule ID 2285 //
     /*  64067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64095 */     // MIs[1] imm
     /*  64095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64107 */     // MIs[2] Operand 1
     /*  64107 */     // No operand predicates
     /*  64107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64113 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  64116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64127 */     GIR_RootConstrainSelectedInstOperands,
     /*  64128 */     // GIR_Coverage, 2285,
     /*  64128 */     GIR_EraseRootFromParent_Done,
     /*  64129 */   // Label 1090: @64129
     /*  64129 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64193), // Rule ID 13596 //
     /*  64134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64166 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64172 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64180 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64185 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64191 */     GIR_RootConstrainSelectedInstOperands,
     /*  64192 */     // GIR_Coverage, 13596,
     /*  64192 */     GIR_EraseRootFromParent_Done,
     /*  64193 */   // Label 1091: @64193
     /*  64193 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64257), // Rule ID 4991 //
     /*  64198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64234 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64244 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64249 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64255 */     GIR_RootConstrainSelectedInstOperands,
     /*  64256 */     // GIR_Coverage, 4991,
     /*  64256 */     GIR_EraseRootFromParent_Done,
     /*  64257 */   // Label 1092: @64257
     /*  64257 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64284), // Rule ID 4997 //
     /*  64262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64277 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64282 */     GIR_RootConstrainSelectedInstOperands,
     /*  64283 */     // GIR_Coverage, 4997,
     /*  64283 */     GIR_Done,
     /*  64284 */   // Label 1093: @64284
     /*  64284 */   GIM_Reject,
     /*  64285 */ // Label 1078: @64285
     /*  64285 */ GIM_Reject,
     /*  64286 */ // Label 993: @64286
     /*  64286 */ GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65593),
     /*  64291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64297 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(64406), // Rule ID 13324 //
     /*  64302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64350 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64356 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64363 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64367 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64371 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64375 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64380 */     // MIs[4] LHS
     /*  64380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64385 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64387 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64404 */     GIR_RootConstrainSelectedInstOperands,
     /*  64405 */     // GIR_Coverage, 13324,
     /*  64405 */     GIR_EraseRootFromParent_Done,
     /*  64406 */   // Label 1095: @64406
     /*  64406 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(64515), // Rule ID 13323 //
     /*  64411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64459 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64480 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64484 */     // MIs[4] LHS
     /*  64484 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64489 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64496 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64513 */     GIR_RootConstrainSelectedInstOperands,
     /*  64514 */     // GIR_Coverage, 13323,
     /*  64514 */     GIR_EraseRootFromParent_Done,
     /*  64515 */   // Label 1096: @64515
     /*  64515 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(64624), // Rule ID 13326 //
     /*  64520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64573 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64579 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64581 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64585 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64589 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64593 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64598 */     // MIs[4] LHS
     /*  64598 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64603 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64605 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64622 */     GIR_RootConstrainSelectedInstOperands,
     /*  64623 */     // GIR_Coverage, 13326,
     /*  64623 */     GIR_EraseRootFromParent_Done,
     /*  64624 */   // Label 1097: @64624
     /*  64624 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(64733), // Rule ID 13325 //
     /*  64629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64682 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64698 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64702 */     // MIs[4] LHS
     /*  64702 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64707 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64714 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64731 */     GIR_RootConstrainSelectedInstOperands,
     /*  64732 */     // GIR_Coverage, 13325,
     /*  64732 */     GIR_EraseRootFromParent_Done,
     /*  64733 */   // Label 1098: @64733
     /*  64733 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(64842), // Rule ID 2464 //
     /*  64738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64799 */     // MIs[3] LHS
     /*  64799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64821 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64823 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64840 */     GIR_RootConstrainSelectedInstOperands,
     /*  64841 */     // GIR_Coverage, 2464,
     /*  64841 */     GIR_EraseRootFromParent_Done,
     /*  64842 */   // Label 1099: @64842
     /*  64842 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(64951), // Rule ID 13321 //
     /*  64847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64908 */     // MIs[3] LHS
     /*  64908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64913 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64917 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64923 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64930 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64932 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64949 */     GIR_RootConstrainSelectedInstOperands,
     /*  64950 */     // GIR_Coverage, 13321,
     /*  64950 */     GIR_EraseRootFromParent_Done,
     /*  64951 */   // Label 1100: @64951
     /*  64951 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65060), // Rule ID 13320 //
     /*  64956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65022 */     // MIs[3] LHS
     /*  65022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65031 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65039 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65041 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65058 */     GIR_RootConstrainSelectedInstOperands,
     /*  65059 */     // GIR_Coverage, 13320,
     /*  65059 */     GIR_EraseRootFromParent_Done,
     /*  65060 */   // Label 1101: @65060
     /*  65060 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65169), // Rule ID 13322 //
     /*  65065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65131 */     // MIs[3] LHS
     /*  65131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65140 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65146 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65148 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65150 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65167 */     GIR_RootConstrainSelectedInstOperands,
     /*  65168 */     // GIR_Coverage, 13322,
     /*  65168 */     GIR_EraseRootFromParent_Done,
     /*  65169 */   // Label 1102: @65169
     /*  65169 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65236), // Rule ID 13268 //
     /*  65174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65198 */     // MIs[1] imm
     /*  65198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65210 */     // MIs[2] Operand 1
     /*  65210 */     // No operand predicates
     /*  65210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65220 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65234 */     GIR_RootConstrainSelectedInstOperands,
     /*  65235 */     // GIR_Coverage, 13268,
     /*  65235 */     GIR_EraseRootFromParent_Done,
     /*  65236 */   // Label 1103: @65236
     /*  65236 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65303), // Rule ID 13289 //
     /*  65241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65265 */     // MIs[1] imm
     /*  65265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65277 */     // MIs[2] Operand 1
     /*  65277 */     // No operand predicates
     /*  65277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65287 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65301 */     GIR_RootConstrainSelectedInstOperands,
     /*  65302 */     // GIR_Coverage, 13289,
     /*  65302 */     GIR_EraseRootFromParent_Done,
     /*  65303 */   // Label 1104: @65303
     /*  65303 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(65370), // Rule ID 2232 //
     /*  65308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65336 */     // MIs[1] imm
     /*  65336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65344 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65348 */     // MIs[2] Operand 1
     /*  65348 */     // No operand predicates
     /*  65348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65354 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65368 */     GIR_RootConstrainSelectedInstOperands,
     /*  65369 */     // GIR_Coverage, 2232,
     /*  65369 */     GIR_EraseRootFromParent_Done,
     /*  65370 */   // Label 1105: @65370
     /*  65370 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65437), // Rule ID 2291 //
     /*  65375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65403 */     // MIs[1] imm
     /*  65403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65411 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65415 */     // MIs[2] Operand 1
     /*  65415 */     // No operand predicates
     /*  65415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65421 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65435 */     GIR_RootConstrainSelectedInstOperands,
     /*  65436 */     // GIR_Coverage, 2291,
     /*  65436 */     GIR_EraseRootFromParent_Done,
     /*  65437 */   // Label 1106: @65437
     /*  65437 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(65501), // Rule ID 13600 //
     /*  65442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65474 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65488 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65493 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65499 */     GIR_RootConstrainSelectedInstOperands,
     /*  65500 */     // GIR_Coverage, 13600,
     /*  65500 */     GIR_EraseRootFromParent_Done,
     /*  65501 */   // Label 1107: @65501
     /*  65501 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(65565), // Rule ID 4995 //
     /*  65506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65542 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65552 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65557 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65563 */     GIR_RootConstrainSelectedInstOperands,
     /*  65564 */     // GIR_Coverage, 4995,
     /*  65564 */     GIR_EraseRootFromParent_Done,
     /*  65565 */   // Label 1108: @65565
     /*  65565 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(65592), // Rule ID 5001 //
     /*  65570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65585 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65590 */     GIR_RootConstrainSelectedInstOperands,
     /*  65591 */     // GIR_Coverage, 5001,
     /*  65591 */     GIR_Done,
     /*  65592 */   // Label 1109: @65592
     /*  65592 */   GIM_Reject,
     /*  65593 */ // Label 1094: @65593
     /*  65593 */ GIM_Reject,
     /*  65594 */ // Label 994: @65594
     /*  65594 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66901),
     /*  65599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65605 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(65714), // Rule ID 13084 //
     /*  65610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65658 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65664 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65688 */     // MIs[4] Rd
     /*  65688 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65693 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65695 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65712 */     GIR_RootConstrainSelectedInstOperands,
     /*  65713 */     // GIR_Coverage, 13084,
     /*  65713 */     GIR_EraseRootFromParent_Done,
     /*  65714 */   // Label 1111: @65714
     /*  65714 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(65823), // Rule ID 13083 //
     /*  65719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65767 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65780 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65784 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65788 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65792 */     // MIs[4] Rd
     /*  65792 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65797 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65802 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65804 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  65817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65821 */     GIR_RootConstrainSelectedInstOperands,
     /*  65822 */     // GIR_Coverage, 13083,
     /*  65822 */     GIR_EraseRootFromParent_Done,
     /*  65823 */   // Label 1112: @65823
     /*  65823 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(65932), // Rule ID 13086 //
     /*  65828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65881 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65897 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65901 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65906 */     // MIs[4] Rd
     /*  65906 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65911 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65913 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  65930 */     GIR_RootConstrainSelectedInstOperands,
     /*  65931 */     // GIR_Coverage, 13086,
     /*  65931 */     GIR_EraseRootFromParent_Done,
     /*  65932 */   // Label 1113: @65932
     /*  65932 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66041), // Rule ID 13085 //
     /*  65937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65990 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65996 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66006 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66010 */     // MIs[4] Rd
     /*  66010 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66015 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66022 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  66031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  66035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66039 */     GIR_RootConstrainSelectedInstOperands,
     /*  66040 */     // GIR_Coverage, 13085,
     /*  66040 */     GIR_EraseRootFromParent_Done,
     /*  66041 */   // Label 1114: @66041
     /*  66041 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66150), // Rule ID 1598 //
     /*  66046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66107 */     // MIs[3] Rd
     /*  66107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66116 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66122 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66129 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66131 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66148 */     GIR_RootConstrainSelectedInstOperands,
     /*  66149 */     // GIR_Coverage, 1598,
     /*  66149 */     GIR_EraseRootFromParent_Done,
     /*  66150 */   // Label 1115: @66150
     /*  66150 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66259), // Rule ID 13081 //
     /*  66155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66212 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66216 */     // MIs[3] Rd
     /*  66216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66221 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66225 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66231 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66240 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66257 */     GIR_RootConstrainSelectedInstOperands,
     /*  66258 */     // GIR_Coverage, 13081,
     /*  66258 */     GIR_EraseRootFromParent_Done,
     /*  66259 */   // Label 1116: @66259
     /*  66259 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66368), // Rule ID 13080 //
     /*  66264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66330 */     // MIs[3] Rd
     /*  66330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66335 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66339 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66349 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66366 */     GIR_RootConstrainSelectedInstOperands,
     /*  66367 */     // GIR_Coverage, 13080,
     /*  66367 */     GIR_EraseRootFromParent_Done,
     /*  66368 */   // Label 1117: @66368
     /*  66368 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(66477), // Rule ID 13082 //
     /*  66373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66439 */     // MIs[3] Rd
     /*  66439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66448 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66458 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66475 */     GIR_RootConstrainSelectedInstOperands,
     /*  66476 */     // GIR_Coverage, 13082,
     /*  66476 */     GIR_EraseRootFromParent_Done,
     /*  66477 */   // Label 1118: @66477
     /*  66477 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(66544), // Rule ID 13258 //
     /*  66482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66506 */     // MIs[1] imm
     /*  66506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66518 */     // MIs[2] Operand 1
     /*  66518 */     // No operand predicates
     /*  66518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66528 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66542 */     GIR_RootConstrainSelectedInstOperands,
     /*  66543 */     // GIR_Coverage, 13258,
     /*  66543 */     GIR_EraseRootFromParent_Done,
     /*  66544 */   // Label 1119: @66544
     /*  66544 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(66611), // Rule ID 13279 //
     /*  66549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66573 */     // MIs[1] imm
     /*  66573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66585 */     // MIs[2] Operand 1
     /*  66585 */     // No operand predicates
     /*  66585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66595 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66609 */     GIR_RootConstrainSelectedInstOperands,
     /*  66610 */     // GIR_Coverage, 13279,
     /*  66610 */     GIR_EraseRootFromParent_Done,
     /*  66611 */   // Label 1120: @66611
     /*  66611 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(66678), // Rule ID 2222 //
     /*  66616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66644 */     // MIs[1] imm
     /*  66644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66656 */     // MIs[2] Operand 1
     /*  66656 */     // No operand predicates
     /*  66656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66662 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66676 */     GIR_RootConstrainSelectedInstOperands,
     /*  66677 */     // GIR_Coverage, 2222,
     /*  66677 */     GIR_EraseRootFromParent_Done,
     /*  66678 */   // Label 1121: @66678
     /*  66678 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(66745), // Rule ID 2281 //
     /*  66683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66711 */     // MIs[1] imm
     /*  66711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66719 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66723 */     // MIs[2] Operand 1
     /*  66723 */     // No operand predicates
     /*  66723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66729 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66743 */     GIR_RootConstrainSelectedInstOperands,
     /*  66744 */     // GIR_Coverage, 2281,
     /*  66744 */     GIR_EraseRootFromParent_Done,
     /*  66745 */   // Label 1122: @66745
     /*  66745 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(66809), // Rule ID 13078 //
     /*  66750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66796 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  66803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66807 */     GIR_RootConstrainSelectedInstOperands,
     /*  66808 */     // GIR_Coverage, 13078,
     /*  66808 */     GIR_EraseRootFromParent_Done,
     /*  66809 */   // Label 1123: @66809
     /*  66809 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(66873), // Rule ID 1594 //
     /*  66814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66850 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66856 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66860 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  66867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66871 */     GIR_RootConstrainSelectedInstOperands,
     /*  66872 */     // GIR_Coverage, 1594,
     /*  66872 */     GIR_EraseRootFromParent_Done,
     /*  66873 */   // Label 1124: @66873
     /*  66873 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(66900), // Rule ID 1596 //
     /*  66878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66893 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66898 */     GIR_RootConstrainSelectedInstOperands,
     /*  66899 */     // GIR_Coverage, 1596,
     /*  66899 */     GIR_Done,
     /*  66900 */   // Label 1125: @66900
     /*  66900 */   GIM_Reject,
     /*  66901 */ // Label 1110: @66901
     /*  66901 */ GIM_Reject,
     /*  66902 */ // Label 995: @66902
     /*  66902 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68209),
     /*  66907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66913 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67022), // Rule ID 13317 //
     /*  66918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66966 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66983 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66987 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66991 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66996 */     // MIs[4] LHS
     /*  66996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67003 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67020 */     GIR_RootConstrainSelectedInstOperands,
     /*  67021 */     // GIR_Coverage, 13317,
     /*  67021 */     GIR_EraseRootFromParent_Done,
     /*  67022 */   // Label 1127: @67022
     /*  67022 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67131), // Rule ID 13316 //
     /*  67027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67096 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67100 */     // MIs[4] LHS
     /*  67100 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67105 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67112 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67129 */     GIR_RootConstrainSelectedInstOperands,
     /*  67130 */     // GIR_Coverage, 13316,
     /*  67130 */     GIR_EraseRootFromParent_Done,
     /*  67131 */   // Label 1128: @67131
     /*  67131 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(67240), // Rule ID 13319 //
     /*  67136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67197 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67201 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67205 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67209 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67214 */     // MIs[4] LHS
     /*  67214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67221 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67238 */     GIR_RootConstrainSelectedInstOperands,
     /*  67239 */     // GIR_Coverage, 13319,
     /*  67239 */     GIR_EraseRootFromParent_Done,
     /*  67240 */   // Label 1129: @67240
     /*  67240 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(67349), // Rule ID 13318 //
     /*  67245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67298 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67314 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67318 */     // MIs[4] LHS
     /*  67318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67323 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67330 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67347 */     GIR_RootConstrainSelectedInstOperands,
     /*  67348 */     // GIR_Coverage, 13318,
     /*  67348 */     GIR_EraseRootFromParent_Done,
     /*  67349 */   // Label 1130: @67349
     /*  67349 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(67458), // Rule ID 2463 //
     /*  67354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67411 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67415 */     // MIs[3] LHS
     /*  67415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67424 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67439 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67456 */     GIR_RootConstrainSelectedInstOperands,
     /*  67457 */     // GIR_Coverage, 2463,
     /*  67457 */     GIR_EraseRootFromParent_Done,
     /*  67458 */   // Label 1131: @67458
     /*  67458 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(67567), // Rule ID 13314 //
     /*  67463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67524 */     // MIs[3] LHS
     /*  67524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67533 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67548 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67565 */     GIR_RootConstrainSelectedInstOperands,
     /*  67566 */     // GIR_Coverage, 13314,
     /*  67566 */     GIR_EraseRootFromParent_Done,
     /*  67567 */   // Label 1132: @67567
     /*  67567 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(67676), // Rule ID 13313 //
     /*  67572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67638 */     // MIs[3] LHS
     /*  67638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67647 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67657 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67674 */     GIR_RootConstrainSelectedInstOperands,
     /*  67675 */     // GIR_Coverage, 13313,
     /*  67675 */     GIR_EraseRootFromParent_Done,
     /*  67676 */   // Label 1133: @67676
     /*  67676 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(67785), // Rule ID 13315 //
     /*  67681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67747 */     // MIs[3] LHS
     /*  67747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67756 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67766 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67783 */     GIR_RootConstrainSelectedInstOperands,
     /*  67784 */     // GIR_Coverage, 13315,
     /*  67784 */     GIR_EraseRootFromParent_Done,
     /*  67785 */   // Label 1134: @67785
     /*  67785 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(67852), // Rule ID 13264 //
     /*  67790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67814 */     // MIs[1] imm
     /*  67814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67826 */     // MIs[2] Operand 1
     /*  67826 */     // No operand predicates
     /*  67826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67836 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67850 */     GIR_RootConstrainSelectedInstOperands,
     /*  67851 */     // GIR_Coverage, 13264,
     /*  67851 */     GIR_EraseRootFromParent_Done,
     /*  67852 */   // Label 1135: @67852
     /*  67852 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(67919), // Rule ID 13285 //
     /*  67857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67881 */     // MIs[1] imm
     /*  67881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67893 */     // MIs[2] Operand 1
     /*  67893 */     // No operand predicates
     /*  67893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67903 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  67906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67917 */     GIR_RootConstrainSelectedInstOperands,
     /*  67918 */     // GIR_Coverage, 13285,
     /*  67918 */     GIR_EraseRootFromParent_Done,
     /*  67919 */   // Label 1136: @67919
     /*  67919 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(67986), // Rule ID 2228 //
     /*  67924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67952 */     // MIs[1] imm
     /*  67952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67964 */     // MIs[2] Operand 1
     /*  67964 */     // No operand predicates
     /*  67964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67970 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67984 */     GIR_RootConstrainSelectedInstOperands,
     /*  67985 */     // GIR_Coverage, 2228,
     /*  67985 */     GIR_EraseRootFromParent_Done,
     /*  67986 */   // Label 1137: @67986
     /*  67986 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68053), // Rule ID 2287 //
     /*  67991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68019 */     // MIs[1] imm
     /*  68019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68031 */     // MIs[2] Operand 1
     /*  68031 */     // No operand predicates
     /*  68031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68037 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  68040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68051 */     GIR_RootConstrainSelectedInstOperands,
     /*  68052 */     // GIR_Coverage, 2287,
     /*  68052 */     GIR_EraseRootFromParent_Done,
     /*  68053 */   // Label 1138: @68053
     /*  68053 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68117), // Rule ID 13599 //
     /*  68058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68090 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68104 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68109 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68115 */     GIR_RootConstrainSelectedInstOperands,
     /*  68116 */     // GIR_Coverage, 13599,
     /*  68116 */     GIR_EraseRootFromParent_Done,
     /*  68117 */   // Label 1139: @68117
     /*  68117 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68181), // Rule ID 4994 //
     /*  68122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68168 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68173 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68179 */     GIR_RootConstrainSelectedInstOperands,
     /*  68180 */     // GIR_Coverage, 4994,
     /*  68180 */     GIR_EraseRootFromParent_Done,
     /*  68181 */   // Label 1140: @68181
     /*  68181 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68208), // Rule ID 5000 //
     /*  68186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68201 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68206 */     GIR_RootConstrainSelectedInstOperands,
     /*  68207 */     // GIR_Coverage, 5000,
     /*  68207 */     GIR_Done,
     /*  68208 */   // Label 1141: @68208
     /*  68208 */   GIM_Reject,
     /*  68209 */ // Label 1126: @68209
     /*  68209 */ GIM_Reject,
     /*  68210 */ // Label 996: @68210
     /*  68210 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69517),
     /*  68215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68221 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(68330), // Rule ID 13091 //
     /*  68226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68274 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68304 */     // MIs[4] Rd
     /*  68304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68311 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68328 */     GIR_RootConstrainSelectedInstOperands,
     /*  68329 */     // GIR_Coverage, 13091,
     /*  68329 */     GIR_EraseRootFromParent_Done,
     /*  68330 */   // Label 1143: @68330
     /*  68330 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(68439), // Rule ID 13090 //
     /*  68335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68408 */     // MIs[4] Rd
     /*  68408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68420 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68437 */     GIR_RootConstrainSelectedInstOperands,
     /*  68438 */     // GIR_Coverage, 13090,
     /*  68438 */     GIR_EraseRootFromParent_Done,
     /*  68439 */   // Label 1144: @68439
     /*  68439 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(68548), // Rule ID 13093 //
     /*  68444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68497 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68505 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68509 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68513 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68522 */     // MIs[4] Rd
     /*  68522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68529 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68546 */     GIR_RootConstrainSelectedInstOperands,
     /*  68547 */     // GIR_Coverage, 13093,
     /*  68547 */     GIR_EraseRootFromParent_Done,
     /*  68548 */   // Label 1145: @68548
     /*  68548 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(68657), // Rule ID 13092 //
     /*  68553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68626 */     // MIs[4] Rd
     /*  68626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68631 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68638 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68655 */     GIR_RootConstrainSelectedInstOperands,
     /*  68656 */     // GIR_Coverage, 13092,
     /*  68656 */     GIR_EraseRootFromParent_Done,
     /*  68657 */   // Label 1146: @68657
     /*  68657 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(68766), // Rule ID 1599 //
     /*  68662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68723 */     // MIs[3] Rd
     /*  68723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68747 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68764 */     GIR_RootConstrainSelectedInstOperands,
     /*  68765 */     // GIR_Coverage, 1599,
     /*  68765 */     GIR_EraseRootFromParent_Done,
     /*  68766 */   // Label 1147: @68766
     /*  68766 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(68875), // Rule ID 13088 //
     /*  68771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68832 */     // MIs[3] Rd
     /*  68832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68856 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68873 */     GIR_RootConstrainSelectedInstOperands,
     /*  68874 */     // GIR_Coverage, 13088,
     /*  68874 */     GIR_EraseRootFromParent_Done,
     /*  68875 */   // Label 1148: @68875
     /*  68875 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(68984), // Rule ID 13087 //
     /*  68880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68946 */     // MIs[3] Rd
     /*  68946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68965 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68982 */     GIR_RootConstrainSelectedInstOperands,
     /*  68983 */     // GIR_Coverage, 13087,
     /*  68983 */     GIR_EraseRootFromParent_Done,
     /*  68984 */   // Label 1149: @68984
     /*  68984 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69093), // Rule ID 13089 //
     /*  68989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69055 */     // MIs[3] Rd
     /*  69055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69074 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69091 */     GIR_RootConstrainSelectedInstOperands,
     /*  69092 */     // GIR_Coverage, 13089,
     /*  69092 */     GIR_EraseRootFromParent_Done,
     /*  69093 */   // Label 1150: @69093
     /*  69093 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69160), // Rule ID 13260 //
     /*  69098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69122 */     // MIs[1] imm
     /*  69122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69134 */     // MIs[2] Operand 1
     /*  69134 */     // No operand predicates
     /*  69134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69144 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69158 */     GIR_RootConstrainSelectedInstOperands,
     /*  69159 */     // GIR_Coverage, 13260,
     /*  69159 */     GIR_EraseRootFromParent_Done,
     /*  69160 */   // Label 1151: @69160
     /*  69160 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69227), // Rule ID 13281 //
     /*  69165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69189 */     // MIs[1] imm
     /*  69189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69201 */     // MIs[2] Operand 1
     /*  69201 */     // No operand predicates
     /*  69201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69211 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69225 */     GIR_RootConstrainSelectedInstOperands,
     /*  69226 */     // GIR_Coverage, 13281,
     /*  69226 */     GIR_EraseRootFromParent_Done,
     /*  69227 */   // Label 1152: @69227
     /*  69227 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(69294), // Rule ID 2224 //
     /*  69232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69260 */     // MIs[1] imm
     /*  69260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69272 */     // MIs[2] Operand 1
     /*  69272 */     // No operand predicates
     /*  69272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69278 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69292 */     GIR_RootConstrainSelectedInstOperands,
     /*  69293 */     // GIR_Coverage, 2224,
     /*  69293 */     GIR_EraseRootFromParent_Done,
     /*  69294 */   // Label 1153: @69294
     /*  69294 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69361), // Rule ID 2283 //
     /*  69299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69327 */     // MIs[1] imm
     /*  69327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69339 */     // MIs[2] Operand 1
     /*  69339 */     // No operand predicates
     /*  69339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69345 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69359 */     GIR_RootConstrainSelectedInstOperands,
     /*  69360 */     // GIR_Coverage, 2283,
     /*  69360 */     GIR_EraseRootFromParent_Done,
     /*  69361 */   // Label 1154: @69361
     /*  69361 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69425), // Rule ID 13079 //
     /*  69366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69412 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69423 */     GIR_RootConstrainSelectedInstOperands,
     /*  69424 */     // GIR_Coverage, 13079,
     /*  69424 */     GIR_EraseRootFromParent_Done,
     /*  69425 */   // Label 1155: @69425
     /*  69425 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(69489), // Rule ID 1595 //
     /*  69430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69476 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69487 */     GIR_RootConstrainSelectedInstOperands,
     /*  69488 */     // GIR_Coverage, 1595,
     /*  69488 */     GIR_EraseRootFromParent_Done,
     /*  69489 */   // Label 1156: @69489
     /*  69489 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(69516), // Rule ID 1597 //
     /*  69494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69509 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  69514 */     GIR_RootConstrainSelectedInstOperands,
     /*  69515 */     // GIR_Coverage, 1597,
     /*  69515 */     GIR_Done,
     /*  69516 */   // Label 1157: @69516
     /*  69516 */   GIM_Reject,
     /*  69517 */ // Label 1142: @69517
     /*  69517 */ GIM_Reject,
     /*  69518 */ // Label 997: @69518
     /*  69518 */ GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(69549), // Rule ID 8296 //
     /*  69523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  69529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  69532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69536 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  69536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69543 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69545 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69547 */   GIR_RootConstrainSelectedInstOperands,
     /*  69548 */   // GIR_Coverage, 8296,
     /*  69548 */   GIR_EraseRootFromParent_Done,
     /*  69549 */ // Label 1158: @69549
     /*  69549 */ GIM_Reject,
     /*  69550 */ // Label 998: @69550
     /*  69550 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(69581), // Rule ID 8295 //
     /*  69555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  69561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  69564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69568 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  69568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69573 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69575 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69577 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69579 */   GIR_RootConstrainSelectedInstOperands,
     /*  69580 */   // GIR_Coverage, 8295,
     /*  69580 */   GIR_EraseRootFromParent_Done,
     /*  69581 */ // Label 1159: @69581
     /*  69581 */ GIM_Reject,
     /*  69582 */ // Label 999: @69582
     /*  69582 */ GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(69607), // Rule ID 7305 //
     /*  69587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  69593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  69596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69600 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  69600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69605 */   GIR_RootConstrainSelectedInstOperands,
     /*  69606 */   // GIR_Coverage, 7305,
     /*  69606 */   GIR_Done,
     /*  69607 */ // Label 1160: @69607
     /*  69607 */ GIM_Reject,
     /*  69608 */ // Label 1000: @69608
     /*  69608 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(69639), // Rule ID 8294 //
     /*  69613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  69619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  69622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69626 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  69626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69631 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69635 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69637 */   GIR_RootConstrainSelectedInstOperands,
     /*  69638 */   // GIR_Coverage, 8294,
     /*  69638 */   GIR_EraseRootFromParent_Done,
     /*  69639 */ // Label 1161: @69639
     /*  69639 */ GIM_Reject,
     /*  69640 */ // Label 1001: @69640
     /*  69640 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(69665), // Rule ID 7304 //
     /*  69645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  69651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  69654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69658 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  69658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69663 */   GIR_RootConstrainSelectedInstOperands,
     /*  69664 */   // GIR_Coverage, 7304,
     /*  69664 */   GIR_Done,
     /*  69665 */ // Label 1162: @69665
     /*  69665 */ GIM_Reject,
     /*  69666 */ // Label 1002: @69666
     /*  69666 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(69697), // Rule ID 8293 //
     /*  69671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  69677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  69680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69684 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  69684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69689 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69691 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69693 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69695 */   GIR_RootConstrainSelectedInstOperands,
     /*  69696 */   // GIR_Coverage, 8293,
     /*  69696 */   GIR_EraseRootFromParent_Done,
     /*  69697 */ // Label 1163: @69697
     /*  69697 */ GIM_Reject,
     /*  69698 */ // Label 1003: @69698
     /*  69698 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(69723), // Rule ID 7303 //
     /*  69703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  69709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  69712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69716 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  69716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69721 */   GIR_RootConstrainSelectedInstOperands,
     /*  69722 */   // GIR_Coverage, 7303,
     /*  69722 */   GIR_Done,
     /*  69723 */ // Label 1164: @69723
     /*  69723 */ GIM_Reject,
     /*  69724 */ // Label 1004: @69724
     /*  69724 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(69755), // Rule ID 8292 //
     /*  69729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  69735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  69738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69742 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  69742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69747 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69749 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69751 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69753 */   GIR_RootConstrainSelectedInstOperands,
     /*  69754 */   // GIR_Coverage, 8292,
     /*  69754 */   GIR_EraseRootFromParent_Done,
     /*  69755 */ // Label 1165: @69755
     /*  69755 */ GIM_Reject,
     /*  69756 */ // Label 1005: @69756
     /*  69756 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(69781), // Rule ID 7302 //
     /*  69761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  69767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  69770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69774 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  69774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69779 */   GIR_RootConstrainSelectedInstOperands,
     /*  69780 */   // GIR_Coverage, 7302,
     /*  69780 */   GIR_Done,
     /*  69781 */ // Label 1166: @69781
     /*  69781 */ GIM_Reject,
     /*  69782 */ // Label 1006: @69782
     /*  69782 */ GIM_Reject,
     /*  69783 */ // Label 7: @69783
     /*  69783 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1185*/ GIMT_Encode4(75721),
     /*  69794 */ /*GILLT_s32*//*Label 1167*/ GIMT_Encode4(69882),
     /*  69798 */ /*GILLT_s64*//*Label 1168*/ GIMT_Encode4(70562), GIMT_Encode4(0),
     /*  69806 */ /*GILLT_v2s32*//*Label 1169*/ GIMT_Encode4(71305),
     /*  69810 */ /*GILLT_v2s64*//*Label 1170*/ GIMT_Encode4(71373),
     /*  69814 */ /*GILLT_v4s16*//*Label 1171*/ GIMT_Encode4(71899),
     /*  69818 */ /*GILLT_v4s32*//*Label 1172*/ GIMT_Encode4(71967),
     /*  69822 */ /*GILLT_v8s8*//*Label 1173*/ GIMT_Encode4(72493),
     /*  69826 */ /*GILLT_v8s16*//*Label 1174*/ GIMT_Encode4(72564),
     /*  69830 */ /*GILLT_v16s8*//*Label 1175*/ GIMT_Encode4(73090),
     /*  69834 */ /*GILLT_nxv1s1*//*Label 1176*/ GIMT_Encode4(73619),
     /*  69838 */ /*GILLT_nxv2s1*//*Label 1177*/ GIMT_Encode4(73669), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  69850 */ /*GILLT_nxv2s64*//*Label 1178*/ GIMT_Encode4(73719),
     /*  69854 */ /*GILLT_nxv4s1*//*Label 1179*/ GIMT_Encode4(74182), GIMT_Encode4(0),
     /*  69862 */ /*GILLT_nxv4s32*//*Label 1180*/ GIMT_Encode4(74232),
     /*  69866 */ /*GILLT_nxv8s1*//*Label 1181*/ GIMT_Encode4(74695),
     /*  69870 */ /*GILLT_nxv8s16*//*Label 1182*/ GIMT_Encode4(74745),
     /*  69874 */ /*GILLT_nxv16s1*//*Label 1183*/ GIMT_Encode4(75208),
     /*  69878 */ /*GILLT_nxv16s8*//*Label 1184*/ GIMT_Encode4(75258),
     /*  69882 */ // Label 1167: @69882
     /*  69882 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(70561),
     /*  69887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  69890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69893 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(69951), // Rule ID 12949 //
     /*  69898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69923 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  69936 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  69936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  69939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  69949 */     GIR_RootConstrainSelectedInstOperands,
     /*  69950 */     // GIR_Coverage, 12949,
     /*  69950 */     GIR_EraseRootFromParent_Done,
     /*  69951 */   // Label 1187: @69951
     /*  69951 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(70006), // Rule ID 12948 //
     /*  69956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69976 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  69993 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  69993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  69996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70004 */     GIR_RootConstrainSelectedInstOperands,
     /*  70005 */     // GIR_Coverage, 12948,
     /*  70005 */     GIR_EraseRootFromParent_Done,
     /*  70006 */   // Label 1188: @70006
     /*  70006 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(70064), // Rule ID 12946 //
     /*  70011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70049 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70062 */     GIR_RootConstrainSelectedInstOperands,
     /*  70063 */     // GIR_Coverage, 12946,
     /*  70063 */     GIR_EraseRootFromParent_Done,
     /*  70064 */   // Label 1189: @70064
     /*  70064 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(70122), // Rule ID 166 //
     /*  70069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70107 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70120 */     GIR_RootConstrainSelectedInstOperands,
     /*  70121 */     // GIR_Coverage, 166,
     /*  70121 */     GIR_EraseRootFromParent_Done,
     /*  70122 */   // Label 1190: @70122
     /*  70122 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(70180), // Rule ID 12947 //
     /*  70127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70152 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70165 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70178 */     GIR_RootConstrainSelectedInstOperands,
     /*  70179 */     // GIR_Coverage, 12947,
     /*  70179 */     GIR_EraseRootFromParent_Done,
     /*  70180 */   // Label 1191: @70180
     /*  70180 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(70235), // Rule ID 12950 //
     /*  70185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70209 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70222 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70233 */     GIR_RootConstrainSelectedInstOperands,
     /*  70234 */     // GIR_Coverage, 12950,
     /*  70234 */     GIR_EraseRootFromParent_Done,
     /*  70235 */   // Label 1192: @70235
     /*  70235 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(70276), // Rule ID 144 //
     /*  70240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  70244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70256 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  70260 */     // MIs[1] Operand 1
     /*  70260 */     // No operand predicates
     /*  70260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70262 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  70262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  70265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70269 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  70274 */     GIR_RootConstrainSelectedInstOperands,
     /*  70275 */     // GIR_Coverage, 144,
     /*  70275 */     GIR_EraseRootFromParent_Done,
     /*  70276 */   // Label 1193: @70276
     /*  70276 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(70309), // Rule ID 12956 //
     /*  70281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70296 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70307 */     GIR_RootConstrainSelectedInstOperands,
     /*  70308 */     // GIR_Coverage, 12956,
     /*  70308 */     GIR_EraseRootFromParent_Done,
     /*  70309 */   // Label 1194: @70309
     /*  70309 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(70342), // Rule ID 170 //
     /*  70314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70329 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70340 */     GIR_RootConstrainSelectedInstOperands,
     /*  70341 */     // GIR_Coverage, 170,
     /*  70341 */     GIR_EraseRootFromParent_Done,
     /*  70342 */   // Label 1195: @70342
     /*  70342 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(70395), // Rule ID 12942 //
     /*  70347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70382 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  70393 */     GIR_RootConstrainSelectedInstOperands,
     /*  70394 */     // GIR_Coverage, 12942,
     /*  70394 */     GIR_EraseRootFromParent_Done,
     /*  70395 */   // Label 1196: @70395
     /*  70395 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(70451), // Rule ID 164 //
     /*  70400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70436 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70449 */     GIR_RootConstrainSelectedInstOperands,
     /*  70450 */     // GIR_Coverage, 164,
     /*  70450 */     GIR_EraseRootFromParent_Done,
     /*  70451 */   // Label 1197: @70451
     /*  70451 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(70504), // Rule ID 12943 //
     /*  70456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70485 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70491 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  70502 */     GIR_RootConstrainSelectedInstOperands,
     /*  70503 */     // GIR_Coverage, 12943,
     /*  70503 */     GIR_EraseRootFromParent_Done,
     /*  70504 */   // Label 1198: @70504
     /*  70504 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(70536), // Rule ID 3944 //
     /*  70509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70521 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  70521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  70524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  70534 */     GIR_RootConstrainSelectedInstOperands,
     /*  70535 */     // GIR_Coverage, 3944,
     /*  70535 */     GIR_EraseRootFromParent_Done,
     /*  70536 */   // Label 1199: @70536
     /*  70536 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(70560), // Rule ID 168 //
     /*  70541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70553 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  70558 */     GIR_RootConstrainSelectedInstOperands,
     /*  70559 */     // GIR_Coverage, 168,
     /*  70559 */     GIR_Done,
     /*  70560 */   // Label 1200: @70560
     /*  70560 */   GIM_Reject,
     /*  70561 */ // Label 1186: @70561
     /*  70561 */ GIM_Reject,
     /*  70562 */ // Label 1168: @70562
     /*  70562 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(71304),
     /*  70567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  70570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  70573 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(70631), // Rule ID 12954 //
     /*  70578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70603 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70616 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70629 */     GIR_RootConstrainSelectedInstOperands,
     /*  70630 */     // GIR_Coverage, 12954,
     /*  70630 */     GIR_EraseRootFromParent_Done,
     /*  70631 */   // Label 1202: @70631
     /*  70631 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(70686), // Rule ID 12953 //
     /*  70636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70656 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70673 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70684 */     GIR_RootConstrainSelectedInstOperands,
     /*  70685 */     // GIR_Coverage, 12953,
     /*  70685 */     GIR_EraseRootFromParent_Done,
     /*  70686 */   // Label 1203: @70686
     /*  70686 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(70744), // Rule ID 12951 //
     /*  70691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70729 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70742 */     GIR_RootConstrainSelectedInstOperands,
     /*  70743 */     // GIR_Coverage, 12951,
     /*  70743 */     GIR_EraseRootFromParent_Done,
     /*  70744 */   // Label 1204: @70744
     /*  70744 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(70802), // Rule ID 167 //
     /*  70749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70787 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70800 */     GIR_RootConstrainSelectedInstOperands,
     /*  70801 */     // GIR_Coverage, 167,
     /*  70801 */     GIR_EraseRootFromParent_Done,
     /*  70802 */   // Label 1205: @70802
     /*  70802 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(70860), // Rule ID 12952 //
     /*  70807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70832 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70845 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70858 */     GIR_RootConstrainSelectedInstOperands,
     /*  70859 */     // GIR_Coverage, 12952,
     /*  70859 */     GIR_EraseRootFromParent_Done,
     /*  70860 */   // Label 1206: @70860
     /*  70860 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(70915), // Rule ID 12955 //
     /*  70865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70902 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70913 */     GIR_RootConstrainSelectedInstOperands,
     /*  70914 */     // GIR_Coverage, 12955,
     /*  70914 */     GIR_EraseRootFromParent_Done,
     /*  70915 */   // Label 1207: @70915
     /*  70915 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(70956), // Rule ID 145 //
     /*  70920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  70924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70936 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  70940 */     // MIs[1] Operand 1
     /*  70940 */     // No operand predicates
     /*  70940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70942 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  70942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  70945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70949 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  70954 */     GIR_RootConstrainSelectedInstOperands,
     /*  70955 */     // GIR_Coverage, 145,
     /*  70955 */     GIR_EraseRootFromParent_Done,
     /*  70956 */   // Label 1208: @70956
     /*  70956 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(70989), // Rule ID 12957 //
     /*  70961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70976 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  70979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70987 */     GIR_RootConstrainSelectedInstOperands,
     /*  70988 */     // GIR_Coverage, 12957,
     /*  70988 */     GIR_EraseRootFromParent_Done,
     /*  70989 */   // Label 1209: @70989
     /*  70989 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(71022), // Rule ID 171 //
     /*  70994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  71009 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  71009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  71012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71020 */     GIR_RootConstrainSelectedInstOperands,
     /*  71021 */     // GIR_Coverage, 171,
     /*  71021 */     GIR_EraseRootFromParent_Done,
     /*  71022 */   // Label 1210: @71022
     /*  71022 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(71075), // Rule ID 12944 //
     /*  71027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71062 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  71073 */     GIR_RootConstrainSelectedInstOperands,
     /*  71074 */     // GIR_Coverage, 12944,
     /*  71074 */     GIR_EraseRootFromParent_Done,
     /*  71075 */   // Label 1211: @71075
     /*  71075 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(71131), // Rule ID 165 //
     /*  71080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71116 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71129 */     GIR_RootConstrainSelectedInstOperands,
     /*  71130 */     // GIR_Coverage, 165,
     /*  71130 */     GIR_EraseRootFromParent_Done,
     /*  71131 */   // Label 1212: @71131
     /*  71131 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(71184), // Rule ID 12945 //
     /*  71136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71171 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  71182 */     GIR_RootConstrainSelectedInstOperands,
     /*  71183 */     // GIR_Coverage, 12945,
     /*  71183 */     GIR_EraseRootFromParent_Done,
     /*  71184 */   // Label 1213: @71184
     /*  71184 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(71216), // Rule ID 3945 //
     /*  71189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71201 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  71201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  71204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  71214 */     GIR_RootConstrainSelectedInstOperands,
     /*  71215 */     // GIR_Coverage, 3945,
     /*  71215 */     GIR_EraseRootFromParent_Done,
     /*  71216 */   // Label 1214: @71216
     /*  71216 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(71252), // Rule ID 4891 //
     /*  71221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71243 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  71243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71250 */     GIR_RootConstrainSelectedInstOperands,
     /*  71251 */     // GIR_Coverage, 4891,
     /*  71251 */     GIR_EraseRootFromParent_Done,
     /*  71252 */   // Label 1215: @71252
     /*  71252 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(71276), // Rule ID 169 //
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71269 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  71274 */     GIR_RootConstrainSelectedInstOperands,
     /*  71275 */     // GIR_Coverage, 169,
     /*  71275 */     GIR_Done,
     /*  71276 */   // Label 1216: @71276
     /*  71276 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(71303), // Rule ID 4987 //
     /*  71281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71296 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  71296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71301 */     GIR_RootConstrainSelectedInstOperands,
     /*  71302 */     // GIR_Coverage, 4987,
     /*  71302 */     GIR_Done,
     /*  71303 */   // Label 1217: @71303
     /*  71303 */   GIM_Reject,
     /*  71304 */ // Label 1201: @71304
     /*  71304 */ GIM_Reject,
     /*  71305 */ // Label 1169: @71305
     /*  71305 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(71372),
     /*  71310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  71313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71324 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(71352), // Rule ID 4889 //
     /*  71329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71333 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71339 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71343 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  71343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71350 */     GIR_RootConstrainSelectedInstOperands,
     /*  71351 */     // GIR_Coverage, 4889,
     /*  71351 */     GIR_EraseRootFromParent_Done,
     /*  71352 */   // Label 1219: @71352
     /*  71352 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(71371), // Rule ID 4986 //
     /*  71357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71364 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  71364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71369 */     GIR_RootConstrainSelectedInstOperands,
     /*  71370 */     // GIR_Coverage, 4986,
     /*  71370 */     GIR_Done,
     /*  71371 */   // Label 1220: @71371
     /*  71371 */   GIM_Reject,
     /*  71372 */ // Label 1218: @71372
     /*  71372 */ GIM_Reject,
     /*  71373 */ // Label 1170: @71373
     /*  71373 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(71898),
     /*  71378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71388 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(71473), // Rule ID 13479 //
     /*  71393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71456 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71471 */     GIR_RootConstrainSelectedInstOperands,
     /*  71472 */     // GIR_Coverage, 13479,
     /*  71472 */     GIR_EraseRootFromParent_Done,
     /*  71473 */   // Label 1222: @71473
     /*  71473 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(71558), // Rule ID 13478 //
     /*  71478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71541 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71556 */     GIR_RootConstrainSelectedInstOperands,
     /*  71557 */     // GIR_Coverage, 13478,
     /*  71557 */     GIR_EraseRootFromParent_Done,
     /*  71558 */   // Label 1223: @71558
     /*  71558 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(71643), // Rule ID 13477 //
     /*  71563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71611 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71617 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71626 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71641 */     GIR_RootConstrainSelectedInstOperands,
     /*  71642 */     // GIR_Coverage, 13477,
     /*  71642 */     GIR_EraseRootFromParent_Done,
     /*  71643 */   // Label 1224: @71643
     /*  71643 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(71728), // Rule ID 3772 //
     /*  71648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71711 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71726 */     GIR_RootConstrainSelectedInstOperands,
     /*  71727 */     // GIR_Coverage, 3772,
     /*  71727 */     GIR_EraseRootFromParent_Done,
     /*  71728 */   // Label 1225: @71728
     /*  71728 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(71760), // Rule ID 4892 //
     /*  71733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71747 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71751 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  71751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  71754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71758 */     GIR_RootConstrainSelectedInstOperands,
     /*  71759 */     // GIR_Coverage, 4892,
     /*  71759 */     GIR_EraseRootFromParent_Done,
     /*  71760 */   // Label 1226: @71760
     /*  71760 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(71817), // Rule ID 3768 //
     /*  71765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71800 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  71815 */     GIR_RootConstrainSelectedInstOperands,
     /*  71816 */     // GIR_Coverage, 3768,
     /*  71816 */     GIR_EraseRootFromParent_Done,
     /*  71817 */   // Label 1227: @71817
     /*  71817 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(71874), // Rule ID 13467 //
     /*  71822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71857 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  71872 */     GIR_RootConstrainSelectedInstOperands,
     /*  71873 */     // GIR_Coverage, 13467,
     /*  71873 */     GIR_EraseRootFromParent_Done,
     /*  71874 */   // Label 1228: @71874
     /*  71874 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(71897), // Rule ID 4990 //
     /*  71879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71890 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  71890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  71895 */     GIR_RootConstrainSelectedInstOperands,
     /*  71896 */     // GIR_Coverage, 4990,
     /*  71896 */     GIR_Done,
     /*  71897 */   // Label 1229: @71897
     /*  71897 */   GIM_Reject,
     /*  71898 */ // Label 1221: @71898
     /*  71898 */ GIM_Reject,
     /*  71899 */ // Label 1171: @71899
     /*  71899 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(71966),
     /*  71904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  71907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71918 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(71946), // Rule ID 4887 //
     /*  71923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71927 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71937 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  71937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71944 */     GIR_RootConstrainSelectedInstOperands,
     /*  71945 */     // GIR_Coverage, 4887,
     /*  71945 */     GIR_EraseRootFromParent_Done,
     /*  71946 */   // Label 1231: @71946
     /*  71946 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(71965), // Rule ID 4985 //
     /*  71951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71958 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  71958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71963 */     GIR_RootConstrainSelectedInstOperands,
     /*  71964 */     // GIR_Coverage, 4985,
     /*  71964 */     GIR_Done,
     /*  71965 */   // Label 1232: @71965
     /*  71965 */   GIM_Reject,
     /*  71966 */ // Label 1230: @71966
     /*  71966 */ GIM_Reject,
     /*  71967 */ // Label 1172: @71967
     /*  71967 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(72492),
     /*  71972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  71975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71982 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(72067), // Rule ID 13476 //
     /*  71987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72031 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72050 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72065 */     GIR_RootConstrainSelectedInstOperands,
     /*  72066 */     // GIR_Coverage, 13476,
     /*  72066 */     GIR_EraseRootFromParent_Done,
     /*  72067 */   // Label 1234: @72067
     /*  72067 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(72152), // Rule ID 13475 //
     /*  72072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72121 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72135 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72150 */     GIR_RootConstrainSelectedInstOperands,
     /*  72151 */     // GIR_Coverage, 13475,
     /*  72151 */     GIR_EraseRootFromParent_Done,
     /*  72152 */   // Label 1235: @72152
     /*  72152 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(72237), // Rule ID 13474 //
     /*  72157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72205 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72220 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72235 */     GIR_RootConstrainSelectedInstOperands,
     /*  72236 */     // GIR_Coverage, 13474,
     /*  72236 */     GIR_EraseRootFromParent_Done,
     /*  72237 */   // Label 1236: @72237
     /*  72237 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(72322), // Rule ID 3771 //
     /*  72242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72295 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72301 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72305 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72320 */     GIR_RootConstrainSelectedInstOperands,
     /*  72321 */     // GIR_Coverage, 3771,
     /*  72321 */     GIR_EraseRootFromParent_Done,
     /*  72322 */   // Label 1237: @72322
     /*  72322 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(72354), // Rule ID 4890 //
     /*  72327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72335 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72345 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  72345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 4890,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1238: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(72411), // Rule ID 3767 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72394 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  72409 */     GIR_RootConstrainSelectedInstOperands,
     /*  72410 */     // GIR_Coverage, 3767,
     /*  72410 */     GIR_EraseRootFromParent_Done,
     /*  72411 */   // Label 1239: @72411
     /*  72411 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(72468), // Rule ID 13466 //
     /*  72416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72451 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  72466 */     GIR_RootConstrainSelectedInstOperands,
     /*  72467 */     // GIR_Coverage, 13466,
     /*  72467 */     GIR_EraseRootFromParent_Done,
     /*  72468 */   // Label 1240: @72468
     /*  72468 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(72491), // Rule ID 4989 //
     /*  72473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72484 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  72484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  72489 */     GIR_RootConstrainSelectedInstOperands,
     /*  72490 */     // GIR_Coverage, 4989,
     /*  72490 */     GIR_Done,
     /*  72491 */   // Label 1241: @72491
     /*  72491 */   GIM_Reject,
     /*  72492 */ // Label 1233: @72492
     /*  72492 */ GIM_Reject,
     /*  72493 */ // Label 1173: @72493
     /*  72493 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(72563),
     /*  72498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  72501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  72504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72512 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(72543), // Rule ID 965 //
     /*  72517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72524 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72534 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  72534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72541 */     GIR_RootConstrainSelectedInstOperands,
     /*  72542 */     // GIR_Coverage, 965,
     /*  72542 */     GIR_EraseRootFromParent_Done,
     /*  72543 */   // Label 1243: @72543
     /*  72543 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(72562), // Rule ID 1592 //
     /*  72548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72555 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  72555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  72560 */     GIR_RootConstrainSelectedInstOperands,
     /*  72561 */     // GIR_Coverage, 1592,
     /*  72561 */     GIR_Done,
     /*  72562 */   // Label 1244: @72562
     /*  72562 */   GIM_Reject,
     /*  72563 */ // Label 1242: @72563
     /*  72563 */ GIM_Reject,
     /*  72564 */ // Label 1174: @72564
     /*  72564 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(73089),
     /*  72569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72579 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(72664), // Rule ID 13473 //
     /*  72584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72628 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72647 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72662 */     GIR_RootConstrainSelectedInstOperands,
     /*  72663 */     // GIR_Coverage, 13473,
     /*  72663 */     GIR_EraseRootFromParent_Done,
     /*  72664 */   // Label 1246: @72664
     /*  72664 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(72749), // Rule ID 13472 //
     /*  72669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72732 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72747 */     GIR_RootConstrainSelectedInstOperands,
     /*  72748 */     // GIR_Coverage, 13472,
     /*  72748 */     GIR_EraseRootFromParent_Done,
     /*  72749 */   // Label 1247: @72749
     /*  72749 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(72834), // Rule ID 13471 //
     /*  72754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72802 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72817 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72832 */     GIR_RootConstrainSelectedInstOperands,
     /*  72833 */     // GIR_Coverage, 13471,
     /*  72833 */     GIR_EraseRootFromParent_Done,
     /*  72834 */   // Label 1248: @72834
     /*  72834 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(72919), // Rule ID 3770 //
     /*  72839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72892 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72902 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72917 */     GIR_RootConstrainSelectedInstOperands,
     /*  72918 */     // GIR_Coverage, 3770,
     /*  72918 */     GIR_EraseRootFromParent_Done,
     /*  72919 */   // Label 1249: @72919
     /*  72919 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(72951), // Rule ID 4888 //
     /*  72924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72942 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  72942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72949 */     GIR_RootConstrainSelectedInstOperands,
     /*  72950 */     // GIR_Coverage, 4888,
     /*  72950 */     GIR_EraseRootFromParent_Done,
     /*  72951 */   // Label 1250: @72951
     /*  72951 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(73008), // Rule ID 3766 //
     /*  72956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72991 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73006 */     GIR_RootConstrainSelectedInstOperands,
     /*  73007 */     // GIR_Coverage, 3766,
     /*  73007 */     GIR_EraseRootFromParent_Done,
     /*  73008 */   // Label 1251: @73008
     /*  73008 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(73065), // Rule ID 13465 //
     /*  73013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  73032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73048 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73063 */     GIR_RootConstrainSelectedInstOperands,
     /*  73064 */     // GIR_Coverage, 13465,
     /*  73064 */     GIR_EraseRootFromParent_Done,
     /*  73065 */   // Label 1252: @73065
     /*  73065 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(73088), // Rule ID 4988 //
     /*  73070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73081 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  73081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73086 */     GIR_RootConstrainSelectedInstOperands,
     /*  73087 */     // GIR_Coverage, 4988,
     /*  73087 */     GIR_Done,
     /*  73088 */   // Label 1253: @73088
     /*  73088 */   GIM_Reject,
     /*  73089 */ // Label 1245: @73089
     /*  73089 */ GIM_Reject,
     /*  73090 */ // Label 1175: @73090
     /*  73090 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(73618),
     /*  73095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73105 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(73190), // Rule ID 13470 //
     /*  73110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73154 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73160 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73173 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73188 */     GIR_RootConstrainSelectedInstOperands,
     /*  73189 */     // GIR_Coverage, 13470,
     /*  73189 */     GIR_EraseRootFromParent_Done,
     /*  73190 */   // Label 1255: @73190
     /*  73190 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(73275), // Rule ID 13469 //
     /*  73195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73244 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73250 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73258 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73273 */     GIR_RootConstrainSelectedInstOperands,
     /*  73274 */     // GIR_Coverage, 13469,
     /*  73274 */     GIR_EraseRootFromParent_Done,
     /*  73275 */   // Label 1256: @73275
     /*  73275 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(73360), // Rule ID 13468 //
     /*  73280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73328 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73334 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73343 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73358 */     GIR_RootConstrainSelectedInstOperands,
     /*  73359 */     // GIR_Coverage, 13468,
     /*  73359 */     GIR_EraseRootFromParent_Done,
     /*  73360 */   // Label 1257: @73360
     /*  73360 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(73445), // Rule ID 3769 //
     /*  73365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73418 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73428 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73443 */     GIR_RootConstrainSelectedInstOperands,
     /*  73444 */     // GIR_Coverage, 3769,
     /*  73444 */     GIR_EraseRootFromParent_Done,
     /*  73445 */   // Label 1258: @73445
     /*  73445 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(73480), // Rule ID 966 //
     /*  73450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73461 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73471 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  73471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  73474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73478 */     GIR_RootConstrainSelectedInstOperands,
     /*  73479 */     // GIR_Coverage, 966,
     /*  73479 */     GIR_EraseRootFromParent_Done,
     /*  73480 */   // Label 1259: @73480
     /*  73480 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(73537), // Rule ID 3765 //
     /*  73485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73520 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73535 */     GIR_RootConstrainSelectedInstOperands,
     /*  73536 */     // GIR_Coverage, 3765,
     /*  73536 */     GIR_EraseRootFromParent_Done,
     /*  73537 */   // Label 1260: @73537
     /*  73537 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(73594), // Rule ID 13464 //
     /*  73542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73577 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73592 */     GIR_RootConstrainSelectedInstOperands,
     /*  73593 */     // GIR_Coverage, 13464,
     /*  73593 */     GIR_EraseRootFromParent_Done,
     /*  73594 */   // Label 1261: @73594
     /*  73594 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(73617), // Rule ID 1593 //
     /*  73599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73610 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73615 */     GIR_RootConstrainSelectedInstOperands,
     /*  73616 */     // GIR_Coverage, 1593,
     /*  73616 */     GIR_Done,
     /*  73617 */   // Label 1262: @73617
     /*  73617 */   GIM_Reject,
     /*  73618 */ // Label 1254: @73618
     /*  73618 */ GIM_Reject,
     /*  73619 */ // Label 1176: @73619
     /*  73619 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(73668), // Rule ID 8286 //
     /*  73624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  73630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  73633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73637 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  73637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73649 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73662 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73664 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73666 */   GIR_RootConstrainSelectedInstOperands,
     /*  73667 */   // GIR_Coverage, 8286,
     /*  73667 */   GIR_EraseRootFromParent_Done,
     /*  73668 */ // Label 1263: @73668
     /*  73668 */ GIM_Reject,
     /*  73669 */ // Label 1177: @73669
     /*  73669 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(73718), // Rule ID 8285 //
     /*  73674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  73680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  73683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73687 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  73687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73699 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73712 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73714 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73716 */   GIR_RootConstrainSelectedInstOperands,
     /*  73717 */   // GIR_Coverage, 8285,
     /*  73717 */   GIR_EraseRootFromParent_Done,
     /*  73718 */ // Label 1264: @73718
     /*  73718 */ GIM_Reject,
     /*  73719 */ // Label 1178: @73719
     /*  73719 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(74181),
     /*  73724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  73734 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(73805), // Rule ID 15322 //
     /*  73739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73778 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73788 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73803 */     GIR_RootConstrainSelectedInstOperands,
     /*  73804 */     // GIR_Coverage, 15322,
     /*  73804 */     GIR_EraseRootFromParent_Done,
     /*  73805 */   // Label 1266: @73805
     /*  73805 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(73876), // Rule ID 15321 //
     /*  73810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73859 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73874 */     GIR_RootConstrainSelectedInstOperands,
     /*  73875 */     // GIR_Coverage, 15321,
     /*  73875 */     GIR_EraseRootFromParent_Done,
     /*  73876 */   // Label 1267: @73876
     /*  73876 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(73947), // Rule ID 15320 //
     /*  73881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73920 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73926 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73930 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73945 */     GIR_RootConstrainSelectedInstOperands,
     /*  73946 */     // GIR_Coverage, 15320,
     /*  73946 */     GIR_EraseRootFromParent_Done,
     /*  73947 */   // Label 1268: @73947
     /*  73947 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(74018), // Rule ID 11668 //
     /*  73952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73991 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73997 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74001 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74016 */     GIR_RootConstrainSelectedInstOperands,
     /*  74017 */     // GIR_Coverage, 11668,
     /*  74017 */     GIR_EraseRootFromParent_Done,
     /*  74018 */   // Label 1269: @74018
     /*  74018 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(74079), // Rule ID 11692 //
     /*  74023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74042 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  74046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74050 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74060 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74077 */     GIR_RootConstrainSelectedInstOperands,
     /*  74078 */     // GIR_Coverage, 11692,
     /*  74078 */     GIR_EraseRootFromParent_Done,
     /*  74079 */   // Label 1270: @74079
     /*  74079 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(74122), // Rule ID 13431 //
     /*  74084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74105 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74120 */     GIR_RootConstrainSelectedInstOperands,
     /*  74121 */     // GIR_Coverage, 13431,
     /*  74121 */     GIR_EraseRootFromParent_Done,
     /*  74122 */   // Label 1271: @74122
     /*  74122 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(74165), // Rule ID 3140 //
     /*  74127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74148 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74163 */     GIR_RootConstrainSelectedInstOperands,
     /*  74164 */     // GIR_Coverage, 3140,
     /*  74164 */     GIR_EraseRootFromParent_Done,
     /*  74165 */   // Label 1272: @74165
     /*  74165 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(74180), // Rule ID 7309 //
     /*  74170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74173 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  74173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74178 */     GIR_RootConstrainSelectedInstOperands,
     /*  74179 */     // GIR_Coverage, 7309,
     /*  74179 */     GIR_Done,
     /*  74180 */   // Label 1273: @74180
     /*  74180 */   GIM_Reject,
     /*  74181 */ // Label 1265: @74181
     /*  74181 */ GIM_Reject,
     /*  74182 */ // Label 1179: @74182
     /*  74182 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(74231), // Rule ID 8284 //
     /*  74187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  74193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  74196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74200 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  74200 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74203 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  74207 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74212 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74227 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74229 */   GIR_RootConstrainSelectedInstOperands,
     /*  74230 */   // GIR_Coverage, 8284,
     /*  74230 */   GIR_EraseRootFromParent_Done,
     /*  74231 */ // Label 1274: @74231
     /*  74231 */ GIM_Reject,
     /*  74232 */ // Label 1180: @74232
     /*  74232 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(74694),
     /*  74237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74247 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(74318), // Rule ID 15319 //
     /*  74252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74301 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74316 */     GIR_RootConstrainSelectedInstOperands,
     /*  74317 */     // GIR_Coverage, 15319,
     /*  74317 */     GIR_EraseRootFromParent_Done,
     /*  74318 */   // Label 1276: @74318
     /*  74318 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(74389), // Rule ID 15318 //
     /*  74323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74362 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74368 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74372 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74387 */     GIR_RootConstrainSelectedInstOperands,
     /*  74388 */     // GIR_Coverage, 15318,
     /*  74388 */     GIR_EraseRootFromParent_Done,
     /*  74389 */   // Label 1277: @74389
     /*  74389 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(74460), // Rule ID 15317 //
     /*  74394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74433 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74443 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74458 */     GIR_RootConstrainSelectedInstOperands,
     /*  74459 */     // GIR_Coverage, 15317,
     /*  74459 */     GIR_EraseRootFromParent_Done,
     /*  74460 */   // Label 1278: @74460
     /*  74460 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(74531), // Rule ID 11666 //
     /*  74465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74504 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74514 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74529 */     GIR_RootConstrainSelectedInstOperands,
     /*  74530 */     // GIR_Coverage, 11666,
     /*  74530 */     GIR_EraseRootFromParent_Done,
     /*  74531 */   // Label 1279: @74531
     /*  74531 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(74592), // Rule ID 11690 //
     /*  74536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  74559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74563 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74569 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74573 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74590 */     GIR_RootConstrainSelectedInstOperands,
     /*  74591 */     // GIR_Coverage, 11690,
     /*  74591 */     GIR_EraseRootFromParent_Done,
     /*  74592 */   // Label 1280: @74592
     /*  74592 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(74635), // Rule ID 13430 //
     /*  74597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74618 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 13430,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1281: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(74678), // Rule ID 3138 //
     /*  74640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74661 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74676 */     GIR_RootConstrainSelectedInstOperands,
     /*  74677 */     // GIR_Coverage, 3138,
     /*  74677 */     GIR_EraseRootFromParent_Done,
     /*  74678 */   // Label 1282: @74678
     /*  74678 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(74693), // Rule ID 7308 //
     /*  74683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74686 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  74686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74691 */     GIR_RootConstrainSelectedInstOperands,
     /*  74692 */     // GIR_Coverage, 7308,
     /*  74692 */     GIR_Done,
     /*  74693 */   // Label 1283: @74693
     /*  74693 */   GIM_Reject,
     /*  74694 */ // Label 1275: @74694
     /*  74694 */ GIM_Reject,
     /*  74695 */ // Label 1181: @74695
     /*  74695 */ GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(74744), // Rule ID 8283 //
     /*  74700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  74706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  74709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74713 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  74713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  74720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74725 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74738 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74740 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74742 */   GIR_RootConstrainSelectedInstOperands,
     /*  74743 */   // GIR_Coverage, 8283,
     /*  74743 */   GIR_EraseRootFromParent_Done,
     /*  74744 */ // Label 1284: @74744
     /*  74744 */ GIM_Reject,
     /*  74745 */ // Label 1182: @74745
     /*  74745 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(75207),
     /*  74750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74760 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(74831), // Rule ID 15316 //
     /*  74765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74804 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74810 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74814 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74829 */     GIR_RootConstrainSelectedInstOperands,
     /*  74830 */     // GIR_Coverage, 15316,
     /*  74830 */     GIR_EraseRootFromParent_Done,
     /*  74831 */   // Label 1286: @74831
     /*  74831 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(74902), // Rule ID 15315 //
     /*  74836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74875 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74881 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74885 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74900 */     GIR_RootConstrainSelectedInstOperands,
     /*  74901 */     // GIR_Coverage, 15315,
     /*  74901 */     GIR_EraseRootFromParent_Done,
     /*  74902 */   // Label 1287: @74902
     /*  74902 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(74973), // Rule ID 15314 //
     /*  74907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74946 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74956 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74971 */     GIR_RootConstrainSelectedInstOperands,
     /*  74972 */     // GIR_Coverage, 15314,
     /*  74972 */     GIR_EraseRootFromParent_Done,
     /*  74973 */   // Label 1288: @74973
     /*  74973 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(75044), // Rule ID 11664 //
     /*  74978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75027 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75042 */     GIR_RootConstrainSelectedInstOperands,
     /*  75043 */     // GIR_Coverage, 11664,
     /*  75043 */     GIR_EraseRootFromParent_Done,
     /*  75044 */   // Label 1289: @75044
     /*  75044 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(75105), // Rule ID 11688 //
     /*  75049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  75072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75076 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75086 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75103 */     GIR_RootConstrainSelectedInstOperands,
     /*  75104 */     // GIR_Coverage, 11688,
     /*  75104 */     GIR_EraseRootFromParent_Done,
     /*  75105 */   // Label 1290: @75105
     /*  75105 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(75148), // Rule ID 13429 //
     /*  75110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75131 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75146 */     GIR_RootConstrainSelectedInstOperands,
     /*  75147 */     // GIR_Coverage, 13429,
     /*  75147 */     GIR_EraseRootFromParent_Done,
     /*  75148 */   // Label 1291: @75148
     /*  75148 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(75191), // Rule ID 3136 //
     /*  75153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75174 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75189 */     GIR_RootConstrainSelectedInstOperands,
     /*  75190 */     // GIR_Coverage, 3136,
     /*  75190 */     GIR_EraseRootFromParent_Done,
     /*  75191 */   // Label 1292: @75191
     /*  75191 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(75206), // Rule ID 7307 //
     /*  75196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75199 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  75199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75204 */     GIR_RootConstrainSelectedInstOperands,
     /*  75205 */     // GIR_Coverage, 7307,
     /*  75205 */     GIR_Done,
     /*  75206 */   // Label 1293: @75206
     /*  75206 */   GIM_Reject,
     /*  75207 */ // Label 1285: @75207
     /*  75207 */ GIM_Reject,
     /*  75208 */ // Label 1183: @75208
     /*  75208 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(75257), // Rule ID 8282 //
     /*  75213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  75219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  75222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  75226 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  75226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  75229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  75233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75238 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  75241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  75246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  75248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75251 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75253 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  75255 */   GIR_RootConstrainSelectedInstOperands,
     /*  75256 */   // GIR_Coverage, 8282,
     /*  75256 */   GIR_EraseRootFromParent_Done,
     /*  75257 */ // Label 1294: @75257
     /*  75257 */ GIM_Reject,
     /*  75258 */ // Label 1184: @75258
     /*  75258 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(75720),
     /*  75263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  75273 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(75344), // Rule ID 15313 //
     /*  75278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75327 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75342 */     GIR_RootConstrainSelectedInstOperands,
     /*  75343 */     // GIR_Coverage, 15313,
     /*  75343 */     GIR_EraseRootFromParent_Done,
     /*  75344 */   // Label 1296: @75344
     /*  75344 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(75415), // Rule ID 15312 //
     /*  75349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75388 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75398 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75413 */     GIR_RootConstrainSelectedInstOperands,
     /*  75414 */     // GIR_Coverage, 15312,
     /*  75414 */     GIR_EraseRootFromParent_Done,
     /*  75415 */   // Label 1297: @75415
     /*  75415 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(75486), // Rule ID 15311 //
     /*  75420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75459 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75469 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75484 */     GIR_RootConstrainSelectedInstOperands,
     /*  75485 */     // GIR_Coverage, 15311,
     /*  75485 */     GIR_EraseRootFromParent_Done,
     /*  75486 */   // Label 1298: @75486
     /*  75486 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(75557), // Rule ID 11662 //
     /*  75491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75540 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75555 */     GIR_RootConstrainSelectedInstOperands,
     /*  75556 */     // GIR_Coverage, 11662,
     /*  75556 */     GIR_EraseRootFromParent_Done,
     /*  75557 */   // Label 1299: @75557
     /*  75557 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(75618), // Rule ID 11686 //
     /*  75562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75581 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  75585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75589 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75599 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75616 */     GIR_RootConstrainSelectedInstOperands,
     /*  75617 */     // GIR_Coverage, 11686,
     /*  75617 */     GIR_EraseRootFromParent_Done,
     /*  75618 */   // Label 1300: @75618
     /*  75618 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(75661), // Rule ID 13428 //
     /*  75623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75644 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75659 */     GIR_RootConstrainSelectedInstOperands,
     /*  75660 */     // GIR_Coverage, 13428,
     /*  75660 */     GIR_EraseRootFromParent_Done,
     /*  75661 */   // Label 1301: @75661
     /*  75661 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(75704), // Rule ID 3134 //
     /*  75666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75687 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75702 */     GIR_RootConstrainSelectedInstOperands,
     /*  75703 */     // GIR_Coverage, 3134,
     /*  75703 */     GIR_EraseRootFromParent_Done,
     /*  75704 */   // Label 1302: @75704
     /*  75704 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(75719), // Rule ID 7306 //
     /*  75709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75712 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  75712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75717 */     GIR_RootConstrainSelectedInstOperands,
     /*  75718 */     // GIR_Coverage, 7306,
     /*  75718 */     GIR_Done,
     /*  75719 */   // Label 1303: @75719
     /*  75719 */   GIM_Reject,
     /*  75720 */ // Label 1295: @75720
     /*  75720 */ GIM_Reject,
     /*  75721 */ // Label 1185: @75721
     /*  75721 */ GIM_Reject,
     /*  75722 */ // Label 8: @75722
     /*  75722 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(83245),
     /*  75727 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  75730 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1316*/ GIMT_Encode4(83244),
     /*  75741 */   /*GILLT_v2s64*//*Label 1305*/ GIMT_Encode4(75809), GIMT_Encode4(0),
     /*  75749 */   /*GILLT_v4s32*//*Label 1306*/ GIMT_Encode4(76330), GIMT_Encode4(0),
     /*  75757 */   /*GILLT_v8s16*//*Label 1307*/ GIMT_Encode4(78742),
     /*  75761 */   /*GILLT_v16s8*//*Label 1308*/ GIMT_Encode4(81151), GIMT_Encode4(0),
     /*  75769 */   /*GILLT_nxv2s1*//*Label 1309*/ GIMT_Encode4(83062), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  75785 */   /*GILLT_nxv4s1*//*Label 1310*/ GIMT_Encode4(83088),
     /*  75789 */   /*GILLT_nxv4s16*//*Label 1311*/ GIMT_Encode4(83114),
     /*  75793 */   /*GILLT_nxv4s32*//*Label 1312*/ GIMT_Encode4(83140),
     /*  75797 */   /*GILLT_nxv8s1*//*Label 1313*/ GIMT_Encode4(83166),
     /*  75801 */   /*GILLT_nxv8s16*//*Label 1314*/ GIMT_Encode4(83192),
     /*  75805 */   /*GILLT_nxv16s1*//*Label 1315*/ GIMT_Encode4(83218),
     /*  75809 */   // Label 1305: @75809
     /*  75809 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(76329),
     /*  75814 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  75817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75828 */     GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(75890), // Rule ID 5698 //
     /*  75833 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75837 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75843 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75845 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75847 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  75847 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75850 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75854 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75859 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75863 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75865 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75868 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75870 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75876 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75879 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75884 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75889 */       // GIR_Coverage, 5698,
     /*  75889 */       GIR_EraseRootFromParent_Done,
     /*  75890 */     // Label 1318: @75890
     /*  75890 */     GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(75952), // Rule ID 5702 //
     /*  75895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75899 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75905 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75907 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75909 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  75909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75921 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75925 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75932 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75935 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75938 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75941 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75946 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75951 */       // GIR_Coverage, 5702,
     /*  75951 */       GIR_EraseRootFromParent_Done,
     /*  75952 */     // Label 1319: @75952
     /*  75952 */     GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(76010), // Rule ID 5699 //
     /*  75957 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75961 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  75965 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75967 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  75967 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  75970 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75974 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75979 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75981 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  75984 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75986 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75989 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75991 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75994 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75999 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76004 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76009 */       // GIR_Coverage, 5699,
     /*  76009 */       GIR_EraseRootFromParent_Done,
     /*  76010 */     // Label 1320: @76010
     /*  76010 */     GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(76068), // Rule ID 5703 //
     /*  76015 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76019 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  76023 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76025 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  76025 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  76028 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76032 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76037 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76039 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76042 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76044 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76047 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76052 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76057 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76062 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76067 */       // GIR_Coverage, 5703,
     /*  76067 */       GIR_EraseRootFromParent_Done,
     /*  76068 */     // Label 1321: @76068
     /*  76068 */     GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(76198), // Rule ID 5697 //
     /*  76073 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76077 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76077 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76080 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76084 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76089 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76091 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76094 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76098 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76103 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76106 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76110 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76113 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76118 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76123 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76128 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76131 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76135 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76140 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76142 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76145 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76149 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76154 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76157 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76161 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76164 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76169 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76174 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76179 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76182 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76184 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76187 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76190 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76193 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76196 */       GIR_RootConstrainSelectedInstOperands,
     /*  76197 */       // GIR_Coverage, 5697,
     /*  76197 */       GIR_EraseRootFromParent_Done,
     /*  76198 */     // Label 1322: @76198
     /*  76198 */     GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(76328), // Rule ID 5701 //
     /*  76203 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76207 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76207 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76210 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76214 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76219 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76221 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76224 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76228 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76233 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76236 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76240 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76243 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76248 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76253 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76258 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76261 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76265 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76270 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76284 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76291 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76304 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76309 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76312 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76314 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76317 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76320 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76323 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76326 */       GIR_RootConstrainSelectedInstOperands,
     /*  76327 */       // GIR_Coverage, 5701,
     /*  76327 */       GIR_EraseRootFromParent_Done,
     /*  76328 */     // Label 1323: @76328
     /*  76328 */     GIM_Reject,
     /*  76329 */   // Label 1317: @76329
     /*  76329 */   GIM_Reject,
     /*  76330 */   // Label 1306: @76330
     /*  76330 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78741),
     /*  76335 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  76338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  76341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76345 */     GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(76474), // Rule ID 5367 //
     /*  76350 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76354 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76358 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76362 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76366 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76370 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76374 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76378 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76382 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76386 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76390 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76394 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76399 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76403 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76409 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76411 */       // MIs[2] Operand 2
     /*  76411 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76422 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76424 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  76424 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76427 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76431 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76436 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76439 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76443 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76456 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76459 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76461 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76468 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76472 */       GIR_RootConstrainSelectedInstOperands,
     /*  76473 */       // GIR_Coverage, 5367,
     /*  76473 */       GIR_EraseRootFromParent_Done,
     /*  76474 */     // Label 1325: @76474
     /*  76474 */     GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(76596), // Rule ID 5363 //
     /*  76479 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76483 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76487 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76491 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76495 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76499 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76503 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76507 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76511 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76515 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76519 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76523 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76528 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76533 */       // MIs[2] Operand 2
     /*  76533 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76544 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76546 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76546 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76549 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76553 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76558 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76561 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76565 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76568 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76573 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76578 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  76581 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76583 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76586 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76590 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76594 */       GIR_RootConstrainSelectedInstOperands,
     /*  76595 */       // GIR_Coverage, 5363,
     /*  76595 */       GIR_EraseRootFromParent_Done,
     /*  76596 */     // Label 1326: @76596
     /*  76596 */     GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(76718), // Rule ID 5365 //
     /*  76601 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76605 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76609 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76613 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76617 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76621 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76625 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76629 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76633 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76637 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76641 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76645 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76650 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76655 */       // MIs[2] Operand 2
     /*  76655 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76666 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76668 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76668 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76671 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76675 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76680 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76683 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76687 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76690 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76695 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76700 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76703 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76705 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76708 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76716 */       GIR_RootConstrainSelectedInstOperands,
     /*  76717 */       // GIR_Coverage, 5365,
     /*  76717 */       GIR_EraseRootFromParent_Done,
     /*  76718 */     // Label 1327: @76718
     /*  76718 */     GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(76820), // Rule ID 5513 //
     /*  76723 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76727 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76731 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76735 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76739 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76743 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76747 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76752 */       // MIs[2] Operand 2
     /*  76752 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76763 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76767 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76771 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76775 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  76779 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76783 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76787 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76792 */       // MIs[4] Operand 2
     /*  76792 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  76803 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76805 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  76805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  76808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76810 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  76814 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  76818 */       GIR_RootConstrainSelectedInstOperands,
     /*  76819 */       // GIR_Coverage, 5513,
     /*  76819 */       GIR_EraseRootFromParent_Done,
     /*  76820 */     // Label 1328: @76820
     /*  76820 */     GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(76949), // Rule ID 6251 //
     /*  76825 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76829 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76833 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  76837 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  76840 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  76845 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76849 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  76853 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76858 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  76862 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76864 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  76864 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  76867 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  76871 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76876 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  76879 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  76881 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76884 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76888 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76893 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76895 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76898 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76902 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76907 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76910 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  76914 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76917 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76927 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76932 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  76935 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76937 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76940 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  76944 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76947 */       GIR_RootConstrainSelectedInstOperands,
     /*  76948 */       // GIR_Coverage, 6251,
     /*  76948 */       GIR_EraseRootFromParent_Done,
     /*  76949 */     // Label 1329: @76949
     /*  76949 */     GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(76991), // Rule ID 5708 //
     /*  76954 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76961 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76968 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  76968 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76971 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76973 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  76978 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76981 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  76986 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76989 */       GIR_RootConstrainSelectedInstOperands,
     /*  76990 */       // GIR_Coverage, 5708,
     /*  76990 */       GIR_EraseRootFromParent_Done,
     /*  76991 */     // Label 1330: @76991
     /*  76991 */     GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(77033), // Rule ID 5712 //
     /*  76996 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77003 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77010 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  77010 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  77013 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77015 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  77020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77023 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77028 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77031 */       GIR_RootConstrainSelectedInstOperands,
     /*  77032 */       // GIR_Coverage, 5712,
     /*  77032 */       GIR_EraseRootFromParent_Done,
     /*  77033 */     // Label 1331: @77033
     /*  77033 */     GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(77156), // Rule ID 2569 //
     /*  77038 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77041 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77045 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77049 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77053 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77056 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  77061 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77065 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  77069 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77074 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77078 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77082 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77086 */       // MIs[2] Operand 1
     /*  77086 */       // No operand predicates
     /*  77086 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77088 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77088 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77091 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77095 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77100 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77102 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77105 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77109 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77114 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77117 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77121 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77124 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77129 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77134 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77139 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  77142 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77144 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77147 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77151 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  77154 */       GIR_RootConstrainSelectedInstOperands,
     /*  77155 */       // GIR_Coverage, 2569,
     /*  77155 */       GIR_EraseRootFromParent_Done,
     /*  77156 */     // Label 1332: @77156
     /*  77156 */     GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(77279), // Rule ID 6219 //
     /*  77161 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77164 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77168 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77172 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77176 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77180 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77184 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  77188 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77192 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77197 */       // MIs[2] imm
     /*  77197 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77201 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77205 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77209 */       // MIs[3] Operand 1
     /*  77209 */       // No operand predicates
     /*  77209 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77211 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77211 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77214 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77218 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77223 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77225 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77228 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77232 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77237 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77240 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77244 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77247 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77252 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77257 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77262 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77265 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77267 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77270 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77274 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77277 */       GIR_RootConstrainSelectedInstOperands,
     /*  77278 */       // GIR_Coverage, 6219,
     /*  77278 */       GIR_EraseRootFromParent_Done,
     /*  77279 */     // Label 1333: @77279
     /*  77279 */     GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(77399), // Rule ID 6257 //
     /*  77284 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77288 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77292 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77296 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77300 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77304 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  77308 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77312 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77317 */       // MIs[2] imm
     /*  77317 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77321 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77325 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77329 */       // MIs[3] Operand 1
     /*  77329 */       // No operand predicates
     /*  77329 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77331 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  77331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77394 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77397 */       GIR_RootConstrainSelectedInstOperands,
     /*  77398 */       // GIR_Coverage, 6257,
     /*  77398 */       GIR_EraseRootFromParent_Done,
     /*  77399 */     // Label 1334: @77399
     /*  77399 */     GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(77516), // Rule ID 2492 //
     /*  77404 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77407 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77411 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77415 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77419 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77422 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  77427 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77431 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77435 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77440 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77445 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77447 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77447 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77450 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77454 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77459 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77461 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77464 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77468 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77473 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77476 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77480 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77483 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77488 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77493 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77498 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  77501 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77503 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77506 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77510 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77514 */       GIR_RootConstrainSelectedInstOperands,
     /*  77515 */       // GIR_Coverage, 2492,
     /*  77515 */       GIR_EraseRootFromParent_Done,
     /*  77516 */     // Label 1335: @77516
     /*  77516 */     GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(77633), // Rule ID 5283 //
     /*  77521 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77524 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77528 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77532 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77536 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77539 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  77544 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77548 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77552 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77557 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77562 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77564 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77564 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77567 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77571 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77576 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77578 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77581 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77585 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77590 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77593 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77597 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77600 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77605 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77610 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77615 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  77618 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77620 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77623 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77627 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77631 */       GIR_RootConstrainSelectedInstOperands,
     /*  77632 */       // GIR_Coverage, 5283,
     /*  77632 */       GIR_EraseRootFromParent_Done,
     /*  77633 */     // Label 1336: @77633
     /*  77633 */     GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(77750), // Rule ID 5286 //
     /*  77638 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77641 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77645 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77649 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77653 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77656 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  77661 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77665 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77669 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77674 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77679 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77681 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77681 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77684 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77688 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77693 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77695 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77698 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77702 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77707 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77710 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77714 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77717 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77722 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77732 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  77735 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77737 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77740 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77744 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77748 */       GIR_RootConstrainSelectedInstOperands,
     /*  77749 */       // GIR_Coverage, 5286,
     /*  77749 */       GIR_EraseRootFromParent_Done,
     /*  77750 */     // Label 1337: @77750
     /*  77750 */     GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(77867), // Rule ID 5289 //
     /*  77755 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77758 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77762 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77766 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77770 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77773 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  77778 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77782 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77786 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77791 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77796 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77798 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77798 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77801 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77805 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77810 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77812 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77815 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77819 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77824 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77827 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77831 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77834 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77839 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77844 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77849 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  77852 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77854 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77857 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77861 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77865 */       GIR_RootConstrainSelectedInstOperands,
     /*  77866 */       // GIR_Coverage, 5289,
     /*  77866 */       GIR_EraseRootFromParent_Done,
     /*  77867 */     // Label 1338: @77867
     /*  77867 */     GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(77971), // Rule ID 2488 //
     /*  77872 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77875 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77879 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77883 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77887 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  77890 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  77895 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77899 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77904 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77906 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  77906 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77909 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77913 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77918 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77920 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77923 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77927 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77932 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77935 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77939 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77942 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77947 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77952 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77957 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  77960 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77962 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77965 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77969 */       GIR_RootConstrainSelectedInstOperands,
     /*  77970 */       // GIR_Coverage, 2488,
     /*  77970 */       GIR_EraseRootFromParent_Done,
     /*  77971 */     // Label 1339: @77971
     /*  77971 */     GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(78027), // Rule ID 5446 //
     /*  77976 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77980 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77984 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77988 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77993 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77997 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78001 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78005 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78010 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78012 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  78012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  78015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  78017 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  78021 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  78025 */       GIR_RootConstrainSelectedInstOperands,
     /*  78026 */       // GIR_Coverage, 5446,
     /*  78026 */       GIR_EraseRootFromParent_Done,
     /*  78027 */     // Label 1340: @78027
     /*  78027 */     GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(78093), // Rule ID 5706 //
     /*  78032 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78036 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78040 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78046 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78048 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78050 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  78050 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78053 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78057 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78062 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78066 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78068 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78071 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78073 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78076 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78079 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78082 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78087 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78092 */       // GIR_Coverage, 5706,
     /*  78092 */       GIR_EraseRootFromParent_Done,
     /*  78093 */     // Label 1341: @78093
     /*  78093 */     GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(78159), // Rule ID 5710 //
     /*  78098 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78102 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78106 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78112 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78114 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78116 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  78116 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78119 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78123 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78128 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78132 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78134 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78137 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78139 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78142 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78145 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78148 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78153 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78158 */       // GIR_Coverage, 5710,
     /*  78158 */       GIR_EraseRootFromParent_Done,
     /*  78159 */     // Label 1342: @78159
     /*  78159 */     GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(78252), // Rule ID 4854 //
     /*  78164 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78168 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78172 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  78176 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78180 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78185 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78187 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  78187 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78190 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78194 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78199 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78201 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78204 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78208 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78213 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78216 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78220 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78223 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78228 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78233 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78238 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  78241 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78243 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78246 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78250 */       GIR_RootConstrainSelectedInstOperands,
     /*  78251 */       // GIR_Coverage, 4854,
     /*  78251 */       GIR_EraseRootFromParent_Done,
     /*  78252 */     // Label 1343: @78252
     /*  78252 */     GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(78348), // Rule ID 4901 //
     /*  78257 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  78260 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78264 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78268 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78272 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78276 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78281 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78283 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  78283 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78286 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78290 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78295 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78297 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78300 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78304 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78309 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78312 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78316 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78319 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78324 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78329 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  78337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78339 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78342 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78346 */       GIR_RootConstrainSelectedInstOperands,
     /*  78347 */       // GIR_Coverage, 4901,
     /*  78347 */       GIR_EraseRootFromParent_Done,
     /*  78348 */     // Label 1344: @78348
     /*  78348 */     GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(78410), // Rule ID 5707 //
     /*  78353 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78357 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78361 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78365 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78367 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  78367 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78370 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78374 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78379 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78381 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78384 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78386 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78389 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78391 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78394 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78399 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78404 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78409 */       // GIR_Coverage, 5707,
     /*  78409 */       GIR_EraseRootFromParent_Done,
     /*  78410 */     // Label 1345: @78410
     /*  78410 */     GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(78472), // Rule ID 5711 //
     /*  78415 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78419 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78423 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78427 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78429 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  78429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78441 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78443 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78446 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78448 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78451 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78466 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78471 */       // GIR_Coverage, 5711,
     /*  78471 */       GIR_EraseRootFromParent_Done,
     /*  78472 */     // Label 1346: @78472
     /*  78472 */     GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(78606), // Rule ID 5705 //
     /*  78477 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78481 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78485 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78485 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78488 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78492 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78497 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78499 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78502 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78506 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78511 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78514 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78518 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78521 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78526 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78531 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78536 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78539 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78543 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78548 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78550 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78553 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78557 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78562 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78565 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78569 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78572 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78577 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78582 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78587 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78590 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78592 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78595 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78598 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78601 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78604 */       GIR_RootConstrainSelectedInstOperands,
     /*  78605 */       // GIR_Coverage, 5705,
     /*  78605 */       GIR_EraseRootFromParent_Done,
     /*  78606 */     // Label 1347: @78606
     /*  78606 */     GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(78740), // Rule ID 5709 //
     /*  78611 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78615 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78619 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78619 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78622 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78626 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78631 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78633 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78636 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78640 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78645 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78648 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78652 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78655 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78660 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78665 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78670 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78673 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78677 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78682 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78684 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78687 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78691 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78696 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78699 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78703 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78716 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78721 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78724 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78726 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78729 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78732 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78735 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78738 */       GIR_RootConstrainSelectedInstOperands,
     /*  78739 */       // GIR_Coverage, 5709,
     /*  78739 */       GIR_EraseRootFromParent_Done,
     /*  78740 */     // Label 1348: @78740
     /*  78740 */     GIM_Reject,
     /*  78741 */   // Label 1324: @78741
     /*  78741 */   GIM_Reject,
     /*  78742 */   // Label 1307: @78742
     /*  78742 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(81150),
     /*  78747 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  78750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  78753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78757 */     GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(78886), // Rule ID 5361 //
     /*  78762 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78766 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78770 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78774 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78778 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78782 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78786 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78790 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78794 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78798 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78802 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78806 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78811 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78815 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78821 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78823 */       // MIs[2] Operand 2
     /*  78823 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78834 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78836 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  78836 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78839 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78843 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78848 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78851 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78855 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78858 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78863 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  78871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78876 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  78880 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  78884 */       GIR_RootConstrainSelectedInstOperands,
     /*  78885 */       // GIR_Coverage, 5361,
     /*  78885 */       GIR_EraseRootFromParent_Done,
     /*  78886 */     // Label 1350: @78886
     /*  78886 */     GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(79008), // Rule ID 5357 //
     /*  78891 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78899 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78903 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78907 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78911 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78915 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78919 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78923 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78927 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78931 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78935 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78940 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78945 */       // MIs[2] Operand 2
     /*  78945 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78956 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78958 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  78958 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78961 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78965 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78970 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78973 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78977 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78980 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78985 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78990 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  78993 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78995 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78998 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79002 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79006 */       GIR_RootConstrainSelectedInstOperands,
     /*  79007 */       // GIR_Coverage, 5357,
     /*  79007 */       GIR_EraseRootFromParent_Done,
     /*  79008 */     // Label 1351: @79008
     /*  79008 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79130), // Rule ID 5359 //
     /*  79013 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79017 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79021 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79025 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79029 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79033 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79037 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79041 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79045 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79049 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79053 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79057 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79062 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79067 */       // MIs[2] Operand 2
     /*  79067 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79078 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79080 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79080 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79083 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79087 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79092 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79095 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79099 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79102 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79107 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  79115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79117 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79120 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79124 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79128 */       GIR_RootConstrainSelectedInstOperands,
     /*  79129 */       // GIR_Coverage, 5359,
     /*  79129 */       GIR_EraseRootFromParent_Done,
     /*  79130 */     // Label 1352: @79130
     /*  79130 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79232), // Rule ID 5512 //
     /*  79135 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79139 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79143 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79147 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79151 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79155 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79159 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79164 */       // MIs[2] Operand 2
     /*  79164 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79175 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  79179 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79183 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79187 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  79191 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79195 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79199 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79204 */       // MIs[4] Operand 2
     /*  79204 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  79215 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79217 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  79217 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  79220 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  79222 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  79226 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  79230 */       GIR_RootConstrainSelectedInstOperands,
     /*  79231 */       // GIR_Coverage, 5512,
     /*  79231 */       GIR_EraseRootFromParent_Done,
     /*  79232 */     // Label 1353: @79232
     /*  79232 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79361), // Rule ID 6250 //
     /*  79237 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79241 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79245 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79249 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79252 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79257 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79261 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79265 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79270 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  79274 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79276 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  79276 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  79279 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  79283 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79288 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  79291 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  79293 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79296 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79300 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79305 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79307 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79310 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79314 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79319 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79322 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  79326 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79329 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79334 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79339 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79344 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  79347 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79349 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79352 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  79356 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79359 */       GIR_RootConstrainSelectedInstOperands,
     /*  79360 */       // GIR_Coverage, 6250,
     /*  79360 */       GIR_EraseRootFromParent_Done,
     /*  79361 */     // Label 1354: @79361
     /*  79361 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79403), // Rule ID 5716 //
     /*  79366 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79373 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79380 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  79380 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79383 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79385 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79390 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79393 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79398 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79401 */       GIR_RootConstrainSelectedInstOperands,
     /*  79402 */       // GIR_Coverage, 5716,
     /*  79402 */       GIR_EraseRootFromParent_Done,
     /*  79403 */     // Label 1355: @79403
     /*  79403 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79445), // Rule ID 5720 //
     /*  79408 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79415 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79422 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  79422 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79425 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79427 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79432 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79435 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79440 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79443 */       GIR_RootConstrainSelectedInstOperands,
     /*  79444 */       // GIR_Coverage, 5720,
     /*  79444 */       GIR_EraseRootFromParent_Done,
     /*  79445 */     // Label 1356: @79445
     /*  79445 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79568), // Rule ID 2567 //
     /*  79450 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79453 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79457 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79461 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79465 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79468 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79473 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79477 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79481 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79486 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  79490 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79494 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79498 */       // MIs[2] Operand 1
     /*  79498 */       // No operand predicates
     /*  79498 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79500 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79500 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79503 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79507 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79512 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79514 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79517 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79521 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79526 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79529 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79533 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79536 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79541 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79551 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  79554 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79556 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79559 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79563 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  79566 */       GIR_RootConstrainSelectedInstOperands,
     /*  79567 */       // GIR_Coverage, 2567,
     /*  79567 */       GIR_EraseRootFromParent_Done,
     /*  79568 */     // Label 1357: @79568
     /*  79568 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(79691), // Rule ID 6218 //
     /*  79573 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79576 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79580 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79584 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79588 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79592 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79596 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  79600 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79604 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79609 */       // MIs[2] imm
     /*  79609 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79613 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79617 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79621 */       // MIs[3] Operand 1
     /*  79621 */       // No operand predicates
     /*  79621 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79623 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79623 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79626 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79630 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79635 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79637 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79640 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79644 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79649 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79652 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79656 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79659 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79664 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79669 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79674 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79677 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79679 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79682 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79686 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79689 */       GIR_RootConstrainSelectedInstOperands,
     /*  79690 */       // GIR_Coverage, 6218,
     /*  79690 */       GIR_EraseRootFromParent_Done,
     /*  79691 */     // Label 1358: @79691
     /*  79691 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(79811), // Rule ID 6256 //
     /*  79696 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79700 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79704 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79708 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79712 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79716 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79720 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79724 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79729 */       // MIs[2] imm
     /*  79729 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79733 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79737 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79741 */       // MIs[3] Operand 1
     /*  79741 */       // No operand predicates
     /*  79741 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79743 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79743 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79746 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79750 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79757 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79760 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79764 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79769 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79772 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79776 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79779 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79784 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79789 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79794 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79797 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79799 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79802 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79806 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79809 */       GIR_RootConstrainSelectedInstOperands,
     /*  79810 */       // GIR_Coverage, 6256,
     /*  79810 */       GIR_EraseRootFromParent_Done,
     /*  79811 */     // Label 1359: @79811
     /*  79811 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(79928), // Rule ID 2491 //
     /*  79816 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79819 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79823 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79827 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79831 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79834 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  79839 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79843 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79847 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79852 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79857 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79859 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79859 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79862 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79866 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79871 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79873 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79876 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79880 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79885 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79888 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79892 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79895 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79900 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79905 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79910 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79913 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79915 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79918 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79922 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  79926 */       GIR_RootConstrainSelectedInstOperands,
     /*  79927 */       // GIR_Coverage, 2491,
     /*  79927 */       GIR_EraseRootFromParent_Done,
     /*  79928 */     // Label 1360: @79928
     /*  79928 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80045), // Rule ID 5282 //
     /*  79933 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79936 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79940 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79944 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79948 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79951 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  79956 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79960 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79964 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79969 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79974 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79976 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79976 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79979 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79983 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79988 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79990 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79993 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79997 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80002 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80005 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80009 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80012 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80017 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80022 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80027 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  80030 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80032 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80035 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80039 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80043 */       GIR_RootConstrainSelectedInstOperands,
     /*  80044 */       // GIR_Coverage, 5282,
     /*  80044 */       GIR_EraseRootFromParent_Done,
     /*  80045 */     // Label 1361: @80045
     /*  80045 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80162), // Rule ID 5285 //
     /*  80050 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80053 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80057 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80061 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80065 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80068 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  80073 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80077 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80081 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80086 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80091 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80093 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80093 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80096 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80100 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80105 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80107 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80110 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80114 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80119 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80122 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80126 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80129 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80134 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80139 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80144 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  80147 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80149 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80152 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80156 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80160 */       GIR_RootConstrainSelectedInstOperands,
     /*  80161 */       // GIR_Coverage, 5285,
     /*  80161 */       GIR_EraseRootFromParent_Done,
     /*  80162 */     // Label 1362: @80162
     /*  80162 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80279), // Rule ID 5288 //
     /*  80167 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80170 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80174 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80178 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80182 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80185 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  80190 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80194 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80198 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80203 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80208 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80210 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80210 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80213 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80217 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80222 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80224 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80227 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80231 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80236 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80239 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80243 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80246 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80251 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80256 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80261 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  80264 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80266 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80269 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80273 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80277 */       GIR_RootConstrainSelectedInstOperands,
     /*  80278 */       // GIR_Coverage, 5288,
     /*  80278 */       GIR_EraseRootFromParent_Done,
     /*  80279 */     // Label 1363: @80279
     /*  80279 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80380), // Rule ID 4848 //
     /*  80284 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80288 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80292 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80296 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  80299 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  80304 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80308 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80313 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80315 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80315 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80318 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80322 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80327 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80329 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80332 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80336 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80341 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80344 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80348 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80351 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80356 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80361 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80366 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80369 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80371 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80374 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80378 */       GIR_RootConstrainSelectedInstOperands,
     /*  80379 */       // GIR_Coverage, 4848,
     /*  80379 */       GIR_EraseRootFromParent_Done,
     /*  80380 */     // Label 1364: @80380
     /*  80380 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80436), // Rule ID 5437 //
     /*  80385 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80389 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80393 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80397 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80402 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80406 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80410 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80414 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80419 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80421 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  80421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  80424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80426 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  80430 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  80434 */       GIR_RootConstrainSelectedInstOperands,
     /*  80435 */       // GIR_Coverage, 5437,
     /*  80435 */       GIR_EraseRootFromParent_Done,
     /*  80436 */     // Label 1365: @80436
     /*  80436 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80502), // Rule ID 5714 //
     /*  80441 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80445 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80449 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80455 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80457 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80459 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  80459 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80462 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80466 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80471 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80475 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80477 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80480 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80482 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80485 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80488 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80491 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80496 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80501 */       // GIR_Coverage, 5714,
     /*  80501 */       GIR_EraseRootFromParent_Done,
     /*  80502 */     // Label 1366: @80502
     /*  80502 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80568), // Rule ID 5718 //
     /*  80507 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80511 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80515 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80521 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80523 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80525 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  80525 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80528 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80532 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80537 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80541 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80543 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80546 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80548 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80551 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80554 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80557 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80562 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80567 */       // GIR_Coverage, 5718,
     /*  80567 */       GIR_EraseRootFromParent_Done,
     /*  80568 */     // Label 1367: @80568
     /*  80568 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80661), // Rule ID 4856 //
     /*  80573 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80577 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80581 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  80585 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80589 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80594 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80596 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80596 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80599 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80603 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80608 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80610 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80613 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80617 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80622 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80625 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80629 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80642 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80647 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80650 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80652 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80655 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80659 */       GIR_RootConstrainSelectedInstOperands,
     /*  80660 */       // GIR_Coverage, 4856,
     /*  80660 */       GIR_EraseRootFromParent_Done,
     /*  80661 */     // Label 1368: @80661
     /*  80661 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(80757), // Rule ID 4900 //
     /*  80666 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80669 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80673 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80677 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80681 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80685 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80690 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80692 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  80692 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80695 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80699 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80704 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80706 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80709 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80713 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80718 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80721 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80725 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80728 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80733 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80738 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80743 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  80746 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80748 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80751 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80755 */       GIR_RootConstrainSelectedInstOperands,
     /*  80756 */       // GIR_Coverage, 4900,
     /*  80756 */       GIR_EraseRootFromParent_Done,
     /*  80757 */     // Label 1369: @80757
     /*  80757 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(80819), // Rule ID 5715 //
     /*  80762 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80766 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80770 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80774 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80776 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  80776 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80779 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80783 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80788 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80790 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80793 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80795 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80798 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80800 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80803 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80808 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80813 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80818 */       // GIR_Coverage, 5715,
     /*  80818 */       GIR_EraseRootFromParent_Done,
     /*  80819 */     // Label 1370: @80819
     /*  80819 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(80881), // Rule ID 5719 //
     /*  80824 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80828 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80832 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80836 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80838 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  80838 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80841 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80845 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80850 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80852 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80855 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80857 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80860 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80862 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80865 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80870 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80875 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80880 */       // GIR_Coverage, 5719,
     /*  80880 */       GIR_EraseRootFromParent_Done,
     /*  80881 */     // Label 1371: @80881
     /*  80881 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81015), // Rule ID 5713 //
     /*  80886 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80890 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80894 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80894 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80897 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80901 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80906 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80908 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80911 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80915 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80920 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80923 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80927 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80930 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80935 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80940 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80945 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80948 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80952 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80957 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80959 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80962 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80966 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80971 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80974 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80978 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80981 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80986 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80991 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80996 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80999 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81001 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81004 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81007 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81010 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81013 */       GIR_RootConstrainSelectedInstOperands,
     /*  81014 */       // GIR_Coverage, 5713,
     /*  81014 */       GIR_EraseRootFromParent_Done,
     /*  81015 */     // Label 1372: @81015
     /*  81015 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81149), // Rule ID 5717 //
     /*  81020 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81024 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81028 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  81028 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  81031 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81035 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81040 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  81042 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  81045 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81049 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81054 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  81057 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  81061 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  81064 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81069 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81074 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81079 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81082 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81086 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81091 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81093 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81096 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81100 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81105 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81108 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81112 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81125 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81130 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81133 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81135 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81138 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81141 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81144 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81147 */       GIR_RootConstrainSelectedInstOperands,
     /*  81148 */       // GIR_Coverage, 5717,
     /*  81148 */       GIR_EraseRootFromParent_Done,
     /*  81149 */     // Label 1373: @81149
     /*  81149 */     GIM_Reject,
     /*  81150 */   // Label 1349: @81150
     /*  81150 */   GIM_Reject,
     /*  81151 */   // Label 1308: @81151
     /*  81151 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(83061),
     /*  81156 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  81159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81166 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81295), // Rule ID 5355 //
     /*  81171 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81175 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81179 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81183 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81187 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81191 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81195 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81199 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81203 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81207 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81211 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81215 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81220 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81224 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81230 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81232 */       // MIs[2] Operand 2
     /*  81232 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81243 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81245 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  81245 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81248 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81252 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81257 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81260 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81264 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81267 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81285 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81289 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81293 */       GIR_RootConstrainSelectedInstOperands,
     /*  81294 */       // GIR_Coverage, 5355,
     /*  81294 */       GIR_EraseRootFromParent_Done,
     /*  81295 */     // Label 1375: @81295
     /*  81295 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81417), // Rule ID 5351 //
     /*  81300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81312 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81316 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81320 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81324 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81328 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81332 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  81336 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81340 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81344 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81349 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81354 */       // MIs[2] Operand 2
     /*  81354 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81365 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81367 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81367 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81370 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81374 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81379 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81382 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81386 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81389 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81394 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81399 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  81402 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81404 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81407 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81411 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81415 */       GIR_RootConstrainSelectedInstOperands,
     /*  81416 */       // GIR_Coverage, 5351,
     /*  81416 */       GIR_EraseRootFromParent_Done,
     /*  81417 */     // Label 1376: @81417
     /*  81417 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81539), // Rule ID 5353 //
     /*  81422 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81426 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81430 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81434 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81438 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81442 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81446 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81450 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81454 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  81458 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81462 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81466 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81471 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81476 */       // MIs[2] Operand 2
     /*  81476 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81487 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81489 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81489 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81492 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81496 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81501 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81504 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81508 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81511 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81516 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81521 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81524 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81526 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81529 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81533 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81537 */       GIR_RootConstrainSelectedInstOperands,
     /*  81538 */       // GIR_Coverage, 5353,
     /*  81538 */       GIR_EraseRootFromParent_Done,
     /*  81539 */     // Label 1377: @81539
     /*  81539 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81641), // Rule ID 5511 //
     /*  81544 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81548 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81552 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81556 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81560 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81564 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81568 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81573 */       // MIs[2] Operand 2
     /*  81573 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81584 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81588 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81592 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81596 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81600 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81604 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81608 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81613 */       // MIs[4] Operand 2
     /*  81613 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  81624 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81626 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  81626 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  81629 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81631 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81635 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81639 */       GIR_RootConstrainSelectedInstOperands,
     /*  81640 */       // GIR_Coverage, 5511,
     /*  81640 */       GIR_EraseRootFromParent_Done,
     /*  81641 */     // Label 1378: @81641
     /*  81641 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81770), // Rule ID 6249 //
     /*  81646 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81650 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81654 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81658 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81661 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81666 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81670 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81674 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81679 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  81683 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81685 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  81685 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  81688 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81692 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81697 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81700 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81702 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81705 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81709 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81714 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81716 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81719 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81723 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81728 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81731 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81735 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81738 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81748 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81753 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  81756 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81758 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81761 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81765 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81768 */       GIR_RootConstrainSelectedInstOperands,
     /*  81769 */       // GIR_Coverage, 6249,
     /*  81769 */       GIR_EraseRootFromParent_Done,
     /*  81770 */     // Label 1379: @81770
     /*  81770 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(81812), // Rule ID 5724 //
     /*  81775 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81782 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81789 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  81789 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81792 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81794 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81799 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81802 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81807 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81810 */       GIR_RootConstrainSelectedInstOperands,
     /*  81811 */       // GIR_Coverage, 5724,
     /*  81811 */       GIR_EraseRootFromParent_Done,
     /*  81812 */     // Label 1380: @81812
     /*  81812 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(81935), // Rule ID 2565 //
     /*  81817 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81820 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81824 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81828 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81832 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81835 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81840 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81844 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81848 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81853 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81857 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81861 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  81865 */       // MIs[2] Operand 1
     /*  81865 */       // No operand predicates
     /*  81865 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81867 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  81867 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81870 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81874 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81879 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81881 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81884 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81888 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81893 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81896 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81900 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81903 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81908 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81918 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  81921 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81923 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81926 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81930 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81933 */       GIR_RootConstrainSelectedInstOperands,
     /*  81934 */       // GIR_Coverage, 2565,
     /*  81934 */       GIR_EraseRootFromParent_Done,
     /*  81935 */     // Label 1381: @81935
     /*  81935 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82058), // Rule ID 6217 //
     /*  81940 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81943 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81947 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81951 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81955 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81959 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81963 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81967 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81971 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81976 */       // MIs[2] imm
     /*  81976 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81980 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81984 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  81988 */       // MIs[3] Operand 1
     /*  81988 */       // No operand predicates
     /*  81988 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81990 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  81990 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81993 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81997 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82002 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82004 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82007 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82011 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82016 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82019 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82023 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82026 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82031 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82036 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82046 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82049 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82053 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82056 */       GIR_RootConstrainSelectedInstOperands,
     /*  82057 */       // GIR_Coverage, 6217,
     /*  82057 */       GIR_EraseRootFromParent_Done,
     /*  82058 */     // Label 1382: @82058
     /*  82058 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82178), // Rule ID 6255 //
     /*  82063 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82067 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82071 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82075 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82079 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82083 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82087 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82091 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82096 */       // MIs[2] imm
     /*  82096 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82100 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82104 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82108 */       // MIs[3] Operand 1
     /*  82108 */       // No operand predicates
     /*  82108 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82110 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82110 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82113 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82117 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82122 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82124 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82127 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82131 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82136 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82139 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82143 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82146 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82151 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82156 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82161 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82164 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82166 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82169 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82173 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82176 */       GIR_RootConstrainSelectedInstOperands,
     /*  82177 */       // GIR_Coverage, 6255,
     /*  82177 */       GIR_EraseRootFromParent_Done,
     /*  82178 */     // Label 1383: @82178
     /*  82178 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82295), // Rule ID 2490 //
     /*  82183 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82186 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82190 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82194 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82198 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82201 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  82206 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82210 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82214 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82219 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82224 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82226 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82226 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82229 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82233 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82238 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82240 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82243 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82247 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82252 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82255 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82259 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82262 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82267 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  82280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82285 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82289 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82293 */       GIR_RootConstrainSelectedInstOperands,
     /*  82294 */       // GIR_Coverage, 2490,
     /*  82294 */       GIR_EraseRootFromParent_Done,
     /*  82295 */     // Label 1384: @82295
     /*  82295 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82412), // Rule ID 5281 //
     /*  82300 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82303 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82307 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82311 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82315 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82318 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  82323 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82327 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82331 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82336 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82341 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82343 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82343 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82346 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82350 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82355 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82357 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82360 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82364 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82369 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82372 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82376 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82379 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82384 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82389 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82394 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  82397 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82399 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82402 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82406 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82410 */       GIR_RootConstrainSelectedInstOperands,
     /*  82411 */       // GIR_Coverage, 5281,
     /*  82411 */       GIR_EraseRootFromParent_Done,
     /*  82412 */     // Label 1385: @82412
     /*  82412 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82529), // Rule ID 5284 //
     /*  82417 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82420 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82424 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82428 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82432 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82435 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  82440 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82444 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82448 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82453 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82458 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82460 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82460 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82463 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82467 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82472 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82474 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82477 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82481 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82486 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82489 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82493 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82496 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82501 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82506 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82511 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  82514 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82516 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82519 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82523 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82527 */       GIR_RootConstrainSelectedInstOperands,
     /*  82528 */       // GIR_Coverage, 5284,
     /*  82528 */       GIR_EraseRootFromParent_Done,
     /*  82529 */     // Label 1386: @82529
     /*  82529 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82646), // Rule ID 5287 //
     /*  82534 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82537 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82541 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82545 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82549 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82552 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82557 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82561 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82565 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82570 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82575 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82577 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82577 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82580 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82584 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82589 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82591 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82594 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82598 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82603 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82606 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82610 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82613 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82618 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82623 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82628 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  82631 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82633 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82636 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82640 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82644 */       GIR_RootConstrainSelectedInstOperands,
     /*  82645 */       // GIR_Coverage, 5287,
     /*  82645 */       GIR_EraseRootFromParent_Done,
     /*  82646 */     // Label 1387: @82646
     /*  82646 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82702), // Rule ID 5428 //
     /*  82651 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82655 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82659 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82663 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82668 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82672 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82676 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82680 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82685 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82687 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  82687 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  82690 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82692 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82696 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82700 */       GIR_RootConstrainSelectedInstOperands,
     /*  82701 */       // GIR_Coverage, 5428,
     /*  82701 */       GIR_EraseRootFromParent_Done,
     /*  82702 */     // Label 1388: @82702
     /*  82702 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82768), // Rule ID 5722 //
     /*  82707 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82711 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82715 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82721 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82723 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82725 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  82725 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82728 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82732 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82741 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82743 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82746 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82748 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82751 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82754 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82757 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82762 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82767 */       // GIR_Coverage, 5722,
     /*  82767 */       GIR_EraseRootFromParent_Done,
     /*  82768 */     // Label 1389: @82768
     /*  82768 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(82864), // Rule ID 4899 //
     /*  82773 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82776 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82780 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82784 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82788 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82792 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82797 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82799 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  82799 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82802 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82806 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82811 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82813 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82816 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82820 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82825 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82828 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82832 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82835 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82840 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82845 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82850 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  82853 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82855 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82858 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82862 */       GIR_RootConstrainSelectedInstOperands,
     /*  82863 */       // GIR_Coverage, 4899,
     /*  82863 */       GIR_EraseRootFromParent_Done,
     /*  82864 */     // Label 1390: @82864
     /*  82864 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(82926), // Rule ID 5723 //
     /*  82869 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82873 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82877 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82881 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82883 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  82883 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  82886 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82890 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82897 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82900 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82902 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82905 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82907 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82910 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82915 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82920 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82925 */       // GIR_Coverage, 5723,
     /*  82925 */       GIR_EraseRootFromParent_Done,
     /*  82926 */     // Label 1391: @82926
     /*  82926 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83060), // Rule ID 5721 //
     /*  82931 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82935 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82939 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82939 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82942 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82946 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82951 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82953 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82956 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82960 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82965 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82968 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82972 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82975 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82980 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82985 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82990 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82993 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82997 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83002 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83004 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83007 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83011 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83016 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83019 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83023 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83026 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83031 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83036 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83046 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83052 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83055 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83058 */       GIR_RootConstrainSelectedInstOperands,
     /*  83059 */       // GIR_Coverage, 5721,
     /*  83059 */       GIR_EraseRootFromParent_Done,
     /*  83060 */     // Label 1392: @83060
     /*  83060 */     GIM_Reject,
     /*  83061 */   // Label 1374: @83061
     /*  83061 */   GIM_Reject,
     /*  83062 */   // Label 1309: @83062
     /*  83062 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83087), // Rule ID 8913 //
     /*  83067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83070 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  83073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  83076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83080 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  83080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  83085 */     GIR_RootConstrainSelectedInstOperands,
     /*  83086 */     // GIR_Coverage, 8913,
     /*  83086 */     GIR_Done,
     /*  83087 */   // Label 1393: @83087
     /*  83087 */   GIM_Reject,
     /*  83088 */   // Label 1310: @83088
     /*  83088 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83113), // Rule ID 8914 //
     /*  83093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83096 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  83099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  83102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83106 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  83106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  83111 */     GIR_RootConstrainSelectedInstOperands,
     /*  83112 */     // GIR_Coverage, 8914,
     /*  83112 */     GIR_Done,
     /*  83113 */   // Label 1394: @83113
     /*  83113 */   GIM_Reject,
     /*  83114 */   // Label 1311: @83114
     /*  83114 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83139), // Rule ID 8917 //
     /*  83119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83122 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  83125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  83128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83132 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  83132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83137 */     GIR_RootConstrainSelectedInstOperands,
     /*  83138 */     // GIR_Coverage, 8917,
     /*  83138 */     GIR_Done,
     /*  83139 */   // Label 1395: @83139
     /*  83139 */   GIM_Reject,
     /*  83140 */   // Label 1312: @83140
     /*  83140 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83165), // Rule ID 8919 //
     /*  83145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83148 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  83151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  83154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83158 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  83158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83163 */     GIR_RootConstrainSelectedInstOperands,
     /*  83164 */     // GIR_Coverage, 8919,
     /*  83164 */     GIR_Done,
     /*  83165 */   // Label 1396: @83165
     /*  83165 */   GIM_Reject,
     /*  83166 */   // Label 1313: @83166
     /*  83166 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83191), // Rule ID 8915 //
     /*  83171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83174 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  83177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  83180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83184 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  83184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  83189 */     GIR_RootConstrainSelectedInstOperands,
     /*  83190 */     // GIR_Coverage, 8915,
     /*  83190 */     GIR_Done,
     /*  83191 */   // Label 1397: @83191
     /*  83191 */   GIM_Reject,
     /*  83192 */   // Label 1314: @83192
     /*  83192 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83217), // Rule ID 8918 //
     /*  83197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83200 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  83203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  83206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83210 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  83210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  83215 */     GIR_RootConstrainSelectedInstOperands,
     /*  83216 */     // GIR_Coverage, 8918,
     /*  83216 */     GIR_Done,
     /*  83217 */   // Label 1398: @83217
     /*  83217 */   GIM_Reject,
     /*  83218 */   // Label 1315: @83218
     /*  83218 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83243), // Rule ID 8916 //
     /*  83223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83226 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  83229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  83232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83236 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  83236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  83241 */     GIR_RootConstrainSelectedInstOperands,
     /*  83242 */     // GIR_Coverage, 8916,
     /*  83242 */     GIR_Done,
     /*  83243 */   // Label 1399: @83243
     /*  83243 */   GIM_Reject,
     /*  83244 */   // Label 1316: @83244
     /*  83244 */   GIM_Reject,
     /*  83245 */ // Label 1304: @83245
     /*  83245 */ GIM_Reject,
     /*  83246 */ // Label 9: @83246
     /*  83246 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1414*/ GIMT_Encode4(93189),
     /*  83257 */ /*GILLT_s32*//*Label 1400*/ GIMT_Encode4(83345),
     /*  83261 */ /*GILLT_s64*//*Label 1401*/ GIMT_Encode4(83726),
     /*  83265 */ /*GILLT_s128*//*Label 1402*/ GIMT_Encode4(85701),
     /*  83269 */ /*GILLT_v2s32*//*Label 1403*/ GIMT_Encode4(86347),
     /*  83273 */ /*GILLT_v2s64*//*Label 1404*/ GIMT_Encode4(87262),
     /*  83277 */ /*GILLT_v4s16*//*Label 1405*/ GIMT_Encode4(88031),
     /*  83281 */ /*GILLT_v4s32*//*Label 1406*/ GIMT_Encode4(88946),
     /*  83285 */ /*GILLT_v8s8*//*Label 1407*/ GIMT_Encode4(89791),
     /*  83289 */ /*GILLT_v8s16*//*Label 1408*/ GIMT_Encode4(90352),
     /*  83293 */ /*GILLT_v16s8*//*Label 1409*/ GIMT_Encode4(91197), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83313 */ /*GILLT_nxv2s64*//*Label 1410*/ GIMT_Encode4(91649), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83325 */ /*GILLT_nxv4s32*//*Label 1411*/ GIMT_Encode4(92098), GIMT_Encode4(0),
     /*  83333 */ /*GILLT_nxv8s16*//*Label 1412*/ GIMT_Encode4(92547), GIMT_Encode4(0),
     /*  83341 */ /*GILLT_nxv16s8*//*Label 1413*/ GIMT_Encode4(92996),
     /*  83345 */ // Label 1400: @83345
     /*  83345 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(83725),
     /*  83350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  83353 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(83423), // Rule ID 6964 //
     /*  83358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83370 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83373 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83380 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  83396 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  83396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  83399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83421 */     GIR_RootConstrainSelectedInstOperands,
     /*  83422 */     // GIR_Coverage, 6964,
     /*  83422 */     GIR_EraseRootFromParent_Done,
     /*  83423 */   // Label 1416: @83423
     /*  83423 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(83493), // Rule ID 6965 //
     /*  83428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83440 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83443 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83450 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  83466 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  83466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  83469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83491 */     GIR_RootConstrainSelectedInstOperands,
     /*  83492 */     // GIR_Coverage, 6965,
     /*  83492 */     GIR_EraseRootFromParent_Done,
     /*  83493 */   // Label 1417: @83493
     /*  83493 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(83558), // Rule ID 6966 //
     /*  83498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83510 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83513 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83520 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  83536 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  83539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83556 */     GIR_RootConstrainSelectedInstOperands,
     /*  83557 */     // GIR_Coverage, 6966,
     /*  83557 */     GIR_EraseRootFromParent_Done,
     /*  83558 */   // Label 1418: @83558
     /*  83558 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(83623), // Rule ID 6967 //
     /*  83563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83575 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83578 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83585 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  83601 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  83601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  83604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83621 */     GIR_RootConstrainSelectedInstOperands,
     /*  83622 */     // GIR_Coverage, 6967,
     /*  83622 */     GIR_EraseRootFromParent_Done,
     /*  83623 */   // Label 1419: @83623
     /*  83623 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(83676), // Rule ID 5688 //
     /*  83628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  83640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  83648 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  83652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83654 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  83654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83659 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  83665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83675 */     // GIR_Coverage, 5688,
     /*  83675 */     GIR_EraseRootFromParent_Done,
     /*  83676 */   // Label 1420: @83676
     /*  83676 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(83700), // Rule ID 6581 //
     /*  83681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83689 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  83689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83699 */     // GIR_Coverage, 6581,
     /*  83699 */     GIR_Done,
     /*  83700 */   // Label 1421: @83700
     /*  83700 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(83724), // Rule ID 6582 //
     /*  83705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83713 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  83713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83723 */     // GIR_Coverage, 6582,
     /*  83723 */     GIR_Done,
     /*  83724 */   // Label 1422: @83724
     /*  83724 */   GIM_Reject,
     /*  83725 */ // Label 1415: @83725
     /*  83725 */ GIM_Reject,
     /*  83726 */ // Label 1401: @83726
     /*  83726 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(83799), // Rule ID 6968 //
     /*  83731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83746 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83749 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83756 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83759 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83765 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  83772 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  83772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  83775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83797 */   GIR_RootConstrainSelectedInstOperands,
     /*  83798 */   // GIR_Coverage, 6968,
     /*  83798 */   GIR_EraseRootFromParent_Done,
     /*  83799 */ // Label 1423: @83799
     /*  83799 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(83872), // Rule ID 6969 //
     /*  83804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83811 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83819 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83822 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83829 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83832 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83838 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  83845 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  83845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  83848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83870 */   GIR_RootConstrainSelectedInstOperands,
     /*  83871 */   // GIR_Coverage, 6969,
     /*  83871 */   GIR_EraseRootFromParent_Done,
     /*  83872 */ // Label 1424: @83872
     /*  83872 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(83940), // Rule ID 6970 //
     /*  83877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83895 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83902 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83905 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83911 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  83918 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  83921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83938 */   GIR_RootConstrainSelectedInstOperands,
     /*  83939 */   // GIR_Coverage, 6970,
     /*  83939 */   GIR_EraseRootFromParent_Done,
     /*  83940 */ // Label 1425: @83940
     /*  83940 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(84008), // Rule ID 6971 //
     /*  83945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83960 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83963 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83970 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83973 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83979 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  83986 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  83986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  83989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  84006 */   GIR_RootConstrainSelectedInstOperands,
     /*  84007 */   // GIR_Coverage, 6971,
     /*  84007 */   GIR_EraseRootFromParent_Done,
     /*  84008 */ // Label 1426: @84008
     /*  84008 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(84064), // Rule ID 5690 //
     /*  84013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  84028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  84032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  84036 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  84040 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84042 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  84042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84047 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  84053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84063 */   // GIR_Coverage, 5690,
     /*  84063 */   GIR_EraseRootFromParent_Done,
     /*  84064 */ // Label 1427: @84064
     /*  84064 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(84094), // Rule ID 6556 //
     /*  84069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84083 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  84083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84093 */   // GIR_Coverage, 6556,
     /*  84093 */   GIR_Done,
     /*  84094 */ // Label 1428: @84094
     /*  84094 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(84124), // Rule ID 6557 //
     /*  84099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84113 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  84113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84118 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84123 */   // GIR_Coverage, 6557,
     /*  84123 */   GIR_Done,
     /*  84124 */ // Label 1429: @84124
     /*  84124 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(84154), // Rule ID 6558 //
     /*  84129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84143 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  84143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84153 */   // GIR_Coverage, 6558,
     /*  84153 */   GIR_Done,
     /*  84154 */ // Label 1430: @84154
     /*  84154 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(84184), // Rule ID 6559 //
     /*  84159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84173 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  84173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84183 */   // GIR_Coverage, 6559,
     /*  84183 */   GIR_Done,
     /*  84184 */ // Label 1431: @84184
     /*  84184 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(84214), // Rule ID 6560 //
     /*  84189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84203 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  84203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84213 */   // GIR_Coverage, 6560,
     /*  84213 */   GIR_Done,
     /*  84214 */ // Label 1432: @84214
     /*  84214 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(84244), // Rule ID 6561 //
     /*  84219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84233 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84243 */   // GIR_Coverage, 6561,
     /*  84243 */   GIR_Done,
     /*  84244 */ // Label 1433: @84244
     /*  84244 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(84294), // Rule ID 6567 //
     /*  84249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84263 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  84263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84292 */   GIR_RootConstrainSelectedInstOperands,
     /*  84293 */   // GIR_Coverage, 6567,
     /*  84293 */   GIR_EraseRootFromParent_Done,
     /*  84294 */ // Label 1434: @84294
     /*  84294 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(84344), // Rule ID 6568 //
     /*  84299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84313 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84325 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84342 */   GIR_RootConstrainSelectedInstOperands,
     /*  84343 */   // GIR_Coverage, 6568,
     /*  84343 */   GIR_EraseRootFromParent_Done,
     /*  84344 */ // Label 1435: @84344
     /*  84344 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(84394), // Rule ID 6569 //
     /*  84349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84363 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84375 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84392 */   GIR_RootConstrainSelectedInstOperands,
     /*  84393 */   // GIR_Coverage, 6569,
     /*  84393 */   GIR_EraseRootFromParent_Done,
     /*  84394 */ // Label 1436: @84394
     /*  84394 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(84444), // Rule ID 6570 //
     /*  84399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84413 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84442 */   GIR_RootConstrainSelectedInstOperands,
     /*  84443 */   // GIR_Coverage, 6570,
     /*  84443 */   GIR_EraseRootFromParent_Done,
     /*  84444 */ // Label 1437: @84444
     /*  84444 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(84494), // Rule ID 6571 //
     /*  84449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84463 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84475 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84492 */   GIR_RootConstrainSelectedInstOperands,
     /*  84493 */   // GIR_Coverage, 6571,
     /*  84493 */   GIR_EraseRootFromParent_Done,
     /*  84494 */ // Label 1438: @84494
     /*  84494 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(84521), // Rule ID 6572 //
     /*  84499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84510 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84520 */   // GIR_Coverage, 6572,
     /*  84520 */   GIR_Done,
     /*  84521 */ // Label 1439: @84521
     /*  84521 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(84548), // Rule ID 6573 //
     /*  84526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84537 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84547 */   // GIR_Coverage, 6573,
     /*  84547 */   GIR_Done,
     /*  84548 */ // Label 1440: @84548
     /*  84548 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(84575), // Rule ID 6574 //
     /*  84553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84564 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  84564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84574 */   // GIR_Coverage, 6574,
     /*  84574 */   GIR_Done,
     /*  84575 */ // Label 1441: @84575
     /*  84575 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(84602), // Rule ID 6583 //
     /*  84580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84591 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84601 */   // GIR_Coverage, 6583,
     /*  84601 */   GIR_Done,
     /*  84602 */ // Label 1442: @84602
     /*  84602 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(84629), // Rule ID 6584 //
     /*  84607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84618 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  84618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84628 */   // GIR_Coverage, 6584,
     /*  84628 */   GIR_Done,
     /*  84629 */ // Label 1443: @84629
     /*  84629 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(84656), // Rule ID 6585 //
     /*  84634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84645 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84655 */   // GIR_Coverage, 6585,
     /*  84655 */   GIR_Done,
     /*  84656 */ // Label 1444: @84656
     /*  84656 */ GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(84688), // Rule ID 6586 //
     /*  84661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84675 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84687 */   // GIR_Coverage, 6586,
     /*  84687 */   GIR_EraseRootFromParent_Done,
     /*  84688 */ // Label 1445: @84688
     /*  84688 */ GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(84720), // Rule ID 6587 //
     /*  84693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84707 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84719 */   // GIR_Coverage, 6587,
     /*  84719 */   GIR_EraseRootFromParent_Done,
     /*  84720 */ // Label 1446: @84720
     /*  84720 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(84752), // Rule ID 6588 //
     /*  84725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84739 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84751 */   // GIR_Coverage, 6588,
     /*  84751 */   GIR_EraseRootFromParent_Done,
     /*  84752 */ // Label 1447: @84752
     /*  84752 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(84784), // Rule ID 6589 //
     /*  84757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84771 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84783 */   // GIR_Coverage, 6589,
     /*  84783 */   GIR_EraseRootFromParent_Done,
     /*  84784 */ // Label 1448: @84784
     /*  84784 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(84816), // Rule ID 6590 //
     /*  84789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84803 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84815 */   // GIR_Coverage, 6590,
     /*  84815 */   GIR_EraseRootFromParent_Done,
     /*  84816 */ // Label 1449: @84816
     /*  84816 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(84842), // Rule ID 6591 //
     /*  84821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84835 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  84835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84840 */   GIR_RootConstrainSelectedInstOperands,
     /*  84841 */   // GIR_Coverage, 6591,
     /*  84841 */   GIR_Done,
     /*  84842 */ // Label 1450: @84842
     /*  84842 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(84868), // Rule ID 6592 //
     /*  84847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84861 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  84861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84866 */   GIR_RootConstrainSelectedInstOperands,
     /*  84867 */   // GIR_Coverage, 6592,
     /*  84867 */   GIR_Done,
     /*  84868 */ // Label 1451: @84868
     /*  84868 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(84894), // Rule ID 6593 //
     /*  84873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84887 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  84887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84892 */   GIR_RootConstrainSelectedInstOperands,
     /*  84893 */   // GIR_Coverage, 6593,
     /*  84893 */   GIR_Done,
     /*  84894 */ // Label 1452: @84894
     /*  84894 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(84920), // Rule ID 6594 //
     /*  84899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84913 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  84913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84918 */   GIR_RootConstrainSelectedInstOperands,
     /*  84919 */   // GIR_Coverage, 6594,
     /*  84919 */   GIR_Done,
     /*  84920 */ // Label 1453: @84920
     /*  84920 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(84946), // Rule ID 6595 //
     /*  84925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84939 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  84939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84944 */   GIR_RootConstrainSelectedInstOperands,
     /*  84945 */   // GIR_Coverage, 6595,
     /*  84945 */   GIR_Done,
     /*  84946 */ // Label 1454: @84946
     /*  84946 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(84975), // Rule ID 6596 //
     /*  84951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84962 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84974 */   // GIR_Coverage, 6596,
     /*  84974 */   GIR_EraseRootFromParent_Done,
     /*  84975 */ // Label 1455: @84975
     /*  84975 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(85004), // Rule ID 6597 //
     /*  84980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84991 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85003 */   // GIR_Coverage, 6597,
     /*  85003 */   GIR_EraseRootFromParent_Done,
     /*  85004 */ // Label 1456: @85004
     /*  85004 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(85036), // Rule ID 6651 //
     /*  85009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85023 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85026 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85028 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85035 */   // GIR_Coverage, 6651,
     /*  85035 */   GIR_EraseRootFromParent_Done,
     /*  85036 */ // Label 1457: @85036
     /*  85036 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(85068), // Rule ID 6652 //
     /*  85041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85055 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85058 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85060 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85067 */   // GIR_Coverage, 6652,
     /*  85067 */   GIR_EraseRootFromParent_Done,
     /*  85068 */ // Label 1458: @85068
     /*  85068 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(85100), // Rule ID 6653 //
     /*  85073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85087 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85090 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85092 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85099 */   // GIR_Coverage, 6653,
     /*  85099 */   GIR_EraseRootFromParent_Done,
     /*  85100 */ // Label 1459: @85100
     /*  85100 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(85132), // Rule ID 6654 //
     /*  85105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85119 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85122 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85124 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85131 */   // GIR_Coverage, 6654,
     /*  85131 */   GIR_EraseRootFromParent_Done,
     /*  85132 */ // Label 1460: @85132
     /*  85132 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(85164), // Rule ID 6655 //
     /*  85137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85151 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85163 */   // GIR_Coverage, 6655,
     /*  85163 */   GIR_EraseRootFromParent_Done,
     /*  85164 */ // Label 1461: @85164
     /*  85164 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(85190), // Rule ID 6656 //
     /*  85169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85183 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85188 */   GIR_RootConstrainSelectedInstOperands,
     /*  85189 */   // GIR_Coverage, 6656,
     /*  85189 */   GIR_Done,
     /*  85190 */ // Label 1462: @85190
     /*  85190 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(85216), // Rule ID 6657 //
     /*  85195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85209 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85214 */   GIR_RootConstrainSelectedInstOperands,
     /*  85215 */   // GIR_Coverage, 6657,
     /*  85215 */   GIR_Done,
     /*  85216 */ // Label 1463: @85216
     /*  85216 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(85242), // Rule ID 6658 //
     /*  85221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85235 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85240 */   GIR_RootConstrainSelectedInstOperands,
     /*  85241 */   // GIR_Coverage, 6658,
     /*  85241 */   GIR_Done,
     /*  85242 */ // Label 1464: @85242
     /*  85242 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(85268), // Rule ID 6659 //
     /*  85247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85261 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85266 */   GIR_RootConstrainSelectedInstOperands,
     /*  85267 */   // GIR_Coverage, 6659,
     /*  85267 */   GIR_Done,
     /*  85268 */ // Label 1465: @85268
     /*  85268 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(85294), // Rule ID 6660 //
     /*  85273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85287 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85292 */   GIR_RootConstrainSelectedInstOperands,
     /*  85293 */   // GIR_Coverage, 6660,
     /*  85293 */   GIR_Done,
     /*  85294 */ // Label 1466: @85294
     /*  85294 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(85323), // Rule ID 6661 //
     /*  85299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85310 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85313 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85315 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85322 */   // GIR_Coverage, 6661,
     /*  85322 */   GIR_EraseRootFromParent_Done,
     /*  85323 */ // Label 1467: @85323
     /*  85323 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(85352), // Rule ID 6662 //
     /*  85328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85339 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85342 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85344 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85346 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85351 */   // GIR_Coverage, 6662,
     /*  85351 */   GIR_EraseRootFromParent_Done,
     /*  85352 */ // Label 1468: @85352
     /*  85352 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(85384), // Rule ID 6663 //
     /*  85357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85371 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85374 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85383 */   // GIR_Coverage, 6663,
     /*  85383 */   GIR_EraseRootFromParent_Done,
     /*  85384 */ // Label 1469: @85384
     /*  85384 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(85416), // Rule ID 6664 //
     /*  85389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85403 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85406 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85415 */   // GIR_Coverage, 6664,
     /*  85415 */   GIR_EraseRootFromParent_Done,
     /*  85416 */ // Label 1470: @85416
     /*  85416 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(85448), // Rule ID 6665 //
     /*  85421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85435 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85447 */   // GIR_Coverage, 6665,
     /*  85447 */   GIR_EraseRootFromParent_Done,
     /*  85448 */ // Label 1471: @85448
     /*  85448 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(85480), // Rule ID 6666 //
     /*  85453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85467 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85479 */   // GIR_Coverage, 6666,
     /*  85479 */   GIR_EraseRootFromParent_Done,
     /*  85480 */ // Label 1472: @85480
     /*  85480 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(85512), // Rule ID 6667 //
     /*  85485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85499 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85511 */   // GIR_Coverage, 6667,
     /*  85511 */   GIR_EraseRootFromParent_Done,
     /*  85512 */ // Label 1473: @85512
     /*  85512 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(85538), // Rule ID 6668 //
     /*  85517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85531 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85536 */   GIR_RootConstrainSelectedInstOperands,
     /*  85537 */   // GIR_Coverage, 6668,
     /*  85537 */   GIR_Done,
     /*  85538 */ // Label 1474: @85538
     /*  85538 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(85564), // Rule ID 6669 //
     /*  85543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85557 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85562 */   GIR_RootConstrainSelectedInstOperands,
     /*  85563 */   // GIR_Coverage, 6669,
     /*  85563 */   GIR_Done,
     /*  85564 */ // Label 1475: @85564
     /*  85564 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(85590), // Rule ID 6670 //
     /*  85569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85583 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85588 */   GIR_RootConstrainSelectedInstOperands,
     /*  85589 */   // GIR_Coverage, 6670,
     /*  85589 */   GIR_Done,
     /*  85590 */ // Label 1476: @85590
     /*  85590 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(85616), // Rule ID 6671 //
     /*  85595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85609 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85614 */   GIR_RootConstrainSelectedInstOperands,
     /*  85615 */   // GIR_Coverage, 6671,
     /*  85615 */   GIR_Done,
     /*  85616 */ // Label 1477: @85616
     /*  85616 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(85642), // Rule ID 6672 //
     /*  85621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85635 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85640 */   GIR_RootConstrainSelectedInstOperands,
     /*  85641 */   // GIR_Coverage, 6672,
     /*  85641 */   GIR_Done,
     /*  85642 */ // Label 1478: @85642
     /*  85642 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(85671), // Rule ID 6673 //
     /*  85647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85658 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85661 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85663 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85670 */   // GIR_Coverage, 6673,
     /*  85670 */   GIR_EraseRootFromParent_Done,
     /*  85671 */ // Label 1479: @85671
     /*  85671 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(85700), // Rule ID 6674 //
     /*  85676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85687 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85690 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85692 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85699 */   // GIR_Coverage, 6674,
     /*  85699 */   GIR_EraseRootFromParent_Done,
     /*  85700 */ // Label 1480: @85700
     /*  85700 */ GIM_Reject,
     /*  85701 */ // Label 1402: @85701
     /*  85701 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(85733), // Rule ID 6688 //
     /*  85706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85720 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85723 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85725 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85732 */   // GIR_Coverage, 6688,
     /*  85732 */   GIR_EraseRootFromParent_Done,
     /*  85733 */ // Label 1481: @85733
     /*  85733 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(85765), // Rule ID 6689 //
     /*  85738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85752 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85755 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85764 */   // GIR_Coverage, 6689,
     /*  85764 */   GIR_EraseRootFromParent_Done,
     /*  85765 */ // Label 1482: @85765
     /*  85765 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(85797), // Rule ID 6690 //
     /*  85770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85784 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85787 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85789 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85796 */   // GIR_Coverage, 6690,
     /*  85796 */   GIR_EraseRootFromParent_Done,
     /*  85797 */ // Label 1483: @85797
     /*  85797 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(85829), // Rule ID 6691 //
     /*  85802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85816 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85819 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85821 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85828 */   // GIR_Coverage, 6691,
     /*  85828 */   GIR_EraseRootFromParent_Done,
     /*  85829 */ // Label 1484: @85829
     /*  85829 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(85861), // Rule ID 6692 //
     /*  85834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85848 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85851 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85860 */   // GIR_Coverage, 6692,
     /*  85860 */   GIR_EraseRootFromParent_Done,
     /*  85861 */ // Label 1485: @85861
     /*  85861 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(85893), // Rule ID 6693 //
     /*  85866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85880 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85883 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85885 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85892 */   // GIR_Coverage, 6693,
     /*  85892 */   GIR_EraseRootFromParent_Done,
     /*  85893 */ // Label 1486: @85893
     /*  85893 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(85925), // Rule ID 6694 //
     /*  85898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  85904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85912 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85915 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85917 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85919 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85924 */   // GIR_Coverage, 6694,
     /*  85924 */   GIR_EraseRootFromParent_Done,
     /*  85925 */ // Label 1487: @85925
     /*  85925 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(85958), // Rule ID 6695 //
     /*  85930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85944 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  85944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  85947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85949 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  85956 */   GIR_RootConstrainSelectedInstOperands,
     /*  85957 */   // GIR_Coverage, 6695,
     /*  85957 */   GIR_EraseRootFromParent_Done,
     /*  85958 */ // Label 1488: @85958
     /*  85958 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(86029), // Rule ID 6696 //
     /*  85963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85977 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  85977 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85980 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  85984 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85989 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  85993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86007 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86027 */   GIR_RootConstrainSelectedInstOperands,
     /*  86028 */   // GIR_Coverage, 6696,
     /*  86028 */   GIR_EraseRootFromParent_Done,
     /*  86029 */ // Label 1489: @86029
     /*  86029 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(86100), // Rule ID 6697 //
     /*  86034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86048 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  86048 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86051 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86055 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86060 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86098 */   GIR_RootConstrainSelectedInstOperands,
     /*  86099 */   // GIR_Coverage, 6697,
     /*  86099 */   GIR_EraseRootFromParent_Done,
     /*  86100 */ // Label 1490: @86100
     /*  86100 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(86171), // Rule ID 6698 //
     /*  86105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86119 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  86119 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86122 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86126 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86131 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86149 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86169 */   GIR_RootConstrainSelectedInstOperands,
     /*  86170 */   // GIR_Coverage, 6698,
     /*  86170 */   GIR_EraseRootFromParent_Done,
     /*  86171 */ // Label 1491: @86171
     /*  86171 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(86204), // Rule ID 6699 //
     /*  86176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  86182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86190 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  86190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86202 */   GIR_RootConstrainSelectedInstOperands,
     /*  86203 */   // GIR_Coverage, 6699,
     /*  86203 */   GIR_EraseRootFromParent_Done,
     /*  86204 */ // Label 1492: @86204
     /*  86204 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(86275), // Rule ID 6700 //
     /*  86209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  86215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86223 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  86223 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86226 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86230 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86235 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86253 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86273 */   GIR_RootConstrainSelectedInstOperands,
     /*  86274 */   // GIR_Coverage, 6700,
     /*  86274 */   GIR_EraseRootFromParent_Done,
     /*  86275 */ // Label 1493: @86275
     /*  86275 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(86346), // Rule ID 6701 //
     /*  86280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  86286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86294 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  86294 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86297 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86301 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86306 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86324 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86344 */   GIR_RootConstrainSelectedInstOperands,
     /*  86345 */   // GIR_Coverage, 6701,
     /*  86345 */   GIR_EraseRootFromParent_Done,
     /*  86346 */ // Label 1494: @86346
     /*  86346 */ GIM_Reject,
     /*  86347 */ // Label 1403: @86347
     /*  86347 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(86377), // Rule ID 6553 //
     /*  86352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86366 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86376 */   // GIR_Coverage, 6553,
     /*  86376 */   GIR_Done,
     /*  86377 */ // Label 1495: @86377
     /*  86377 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(86407), // Rule ID 6555 //
     /*  86382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86396 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86406 */   // GIR_Coverage, 6555,
     /*  86406 */   GIR_Done,
     /*  86407 */ // Label 1496: @86407
     /*  86407 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(86457), // Rule ID 6564 //
     /*  86412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86426 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86455 */   GIR_RootConstrainSelectedInstOperands,
     /*  86456 */   // GIR_Coverage, 6564,
     /*  86456 */   GIR_EraseRootFromParent_Done,
     /*  86457 */ // Label 1497: @86457
     /*  86457 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(86507), // Rule ID 6566 //
     /*  86462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86476 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86488 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86505 */   GIR_RootConstrainSelectedInstOperands,
     /*  86506 */   // GIR_Coverage, 6566,
     /*  86506 */   GIR_EraseRootFromParent_Done,
     /*  86507 */ // Label 1498: @86507
     /*  86507 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(86539), // Rule ID 6598 //
     /*  86512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86526 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86538 */   // GIR_Coverage, 6598,
     /*  86538 */   GIR_EraseRootFromParent_Done,
     /*  86539 */ // Label 1499: @86539
     /*  86539 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(86571), // Rule ID 6599 //
     /*  86544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86558 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86570 */   // GIR_Coverage, 6599,
     /*  86570 */   GIR_EraseRootFromParent_Done,
     /*  86571 */ // Label 1500: @86571
     /*  86571 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(86603), // Rule ID 6600 //
     /*  86576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86590 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86593 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86595 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86602 */   // GIR_Coverage, 6600,
     /*  86602 */   GIR_EraseRootFromParent_Done,
     /*  86603 */ // Label 1501: @86603
     /*  86603 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(86635), // Rule ID 6601 //
     /*  86608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86622 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86625 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86627 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86634 */   // GIR_Coverage, 6601,
     /*  86634 */   GIR_EraseRootFromParent_Done,
     /*  86635 */ // Label 1502: @86635
     /*  86635 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(86667), // Rule ID 6602 //
     /*  86640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86654 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86657 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86659 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86666 */   // GIR_Coverage, 6602,
     /*  86666 */   GIR_EraseRootFromParent_Done,
     /*  86667 */ // Label 1503: @86667
     /*  86667 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(86699), // Rule ID 6603 //
     /*  86672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86686 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86698 */   // GIR_Coverage, 6603,
     /*  86698 */   GIR_EraseRootFromParent_Done,
     /*  86699 */ // Label 1504: @86699
     /*  86699 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(86725), // Rule ID 6604 //
     /*  86704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86718 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  86718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86723 */   GIR_RootConstrainSelectedInstOperands,
     /*  86724 */   // GIR_Coverage, 6604,
     /*  86724 */   GIR_Done,
     /*  86725 */ // Label 1505: @86725
     /*  86725 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(86751), // Rule ID 6605 //
     /*  86730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86744 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  86744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86749 */   GIR_RootConstrainSelectedInstOperands,
     /*  86750 */   // GIR_Coverage, 6605,
     /*  86750 */   GIR_Done,
     /*  86751 */ // Label 1506: @86751
     /*  86751 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(86777), // Rule ID 6606 //
     /*  86756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86770 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  86770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  86775 */   GIR_RootConstrainSelectedInstOperands,
     /*  86776 */   // GIR_Coverage, 6606,
     /*  86776 */   GIR_Done,
     /*  86777 */ // Label 1507: @86777
     /*  86777 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(86803), // Rule ID 6607 //
     /*  86782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86796 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  86796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86801 */   GIR_RootConstrainSelectedInstOperands,
     /*  86802 */   // GIR_Coverage, 6607,
     /*  86802 */   GIR_Done,
     /*  86803 */ // Label 1508: @86803
     /*  86803 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(86829), // Rule ID 6608 //
     /*  86808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86822 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  86822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86827 */   GIR_RootConstrainSelectedInstOperands,
     /*  86828 */   // GIR_Coverage, 6608,
     /*  86828 */   GIR_Done,
     /*  86829 */ // Label 1509: @86829
     /*  86829 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(86855), // Rule ID 6609 //
     /*  86834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86848 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  86848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86853 */   GIR_RootConstrainSelectedInstOperands,
     /*  86854 */   // GIR_Coverage, 6609,
     /*  86854 */   GIR_Done,
     /*  86855 */ // Label 1510: @86855
     /*  86855 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(86884), // Rule ID 6610 //
     /*  86860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  86863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86871 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86883 */   // GIR_Coverage, 6610,
     /*  86883 */   GIR_EraseRootFromParent_Done,
     /*  86884 */ // Label 1511: @86884
     /*  86884 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(86916), // Rule ID 6675 //
     /*  86889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86903 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86915 */   // GIR_Coverage, 6675,
     /*  86915 */   GIR_EraseRootFromParent_Done,
     /*  86916 */ // Label 1512: @86916
     /*  86916 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(86948), // Rule ID 6676 //
     /*  86921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86935 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86947 */   // GIR_Coverage, 6676,
     /*  86947 */   GIR_EraseRootFromParent_Done,
     /*  86948 */ // Label 1513: @86948
     /*  86948 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(86980), // Rule ID 6677 //
     /*  86953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86967 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86979 */   // GIR_Coverage, 6677,
     /*  86979 */   GIR_EraseRootFromParent_Done,
     /*  86980 */ // Label 1514: @86980
     /*  86980 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(87012), // Rule ID 6678 //
     /*  86985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86999 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87011 */   // GIR_Coverage, 6678,
     /*  87011 */   GIR_EraseRootFromParent_Done,
     /*  87012 */ // Label 1515: @87012
     /*  87012 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(87044), // Rule ID 6679 //
     /*  87017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87031 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87043 */   // GIR_Coverage, 6679,
     /*  87043 */   GIR_EraseRootFromParent_Done,
     /*  87044 */ // Label 1516: @87044
     /*  87044 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(87076), // Rule ID 6680 //
     /*  87049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87063 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87075 */   // GIR_Coverage, 6680,
     /*  87075 */   GIR_EraseRootFromParent_Done,
     /*  87076 */ // Label 1517: @87076
     /*  87076 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(87102), // Rule ID 6681 //
     /*  87081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87095 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  87095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87100 */   GIR_RootConstrainSelectedInstOperands,
     /*  87101 */   // GIR_Coverage, 6681,
     /*  87101 */   GIR_Done,
     /*  87102 */ // Label 1518: @87102
     /*  87102 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(87128), // Rule ID 6682 //
     /*  87107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87121 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  87121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87126 */   GIR_RootConstrainSelectedInstOperands,
     /*  87127 */   // GIR_Coverage, 6682,
     /*  87127 */   GIR_Done,
     /*  87128 */ // Label 1519: @87128
     /*  87128 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(87154), // Rule ID 6683 //
     /*  87133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87147 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  87147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  87152 */   GIR_RootConstrainSelectedInstOperands,
     /*  87153 */   // GIR_Coverage, 6683,
     /*  87153 */   GIR_Done,
     /*  87154 */ // Label 1520: @87154
     /*  87154 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(87180), // Rule ID 6684 //
     /*  87159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87173 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  87173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87178 */   GIR_RootConstrainSelectedInstOperands,
     /*  87179 */   // GIR_Coverage, 6684,
     /*  87179 */   GIR_Done,
     /*  87180 */ // Label 1521: @87180
     /*  87180 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(87206), // Rule ID 6685 //
     /*  87185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87199 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  87199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87204 */   GIR_RootConstrainSelectedInstOperands,
     /*  87205 */   // GIR_Coverage, 6685,
     /*  87205 */   GIR_Done,
     /*  87206 */ // Label 1522: @87206
     /*  87206 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(87232), // Rule ID 6686 //
     /*  87211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87225 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  87225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87230 */   GIR_RootConstrainSelectedInstOperands,
     /*  87231 */   // GIR_Coverage, 6686,
     /*  87231 */   GIR_Done,
     /*  87232 */ // Label 1523: @87232
     /*  87232 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(87261), // Rule ID 6687 //
     /*  87237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87248 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87251 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87260 */   // GIR_Coverage, 6687,
     /*  87260 */   GIR_EraseRootFromParent_Done,
     /*  87261 */ // Label 1524: @87261
     /*  87261 */ GIM_Reject,
     /*  87262 */ // Label 1404: @87262
     /*  87262 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(87294), // Rule ID 6702 //
     /*  87267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87281 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87284 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87286 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87293 */   // GIR_Coverage, 6702,
     /*  87293 */   GIR_EraseRootFromParent_Done,
     /*  87294 */ // Label 1525: @87294
     /*  87294 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(87326), // Rule ID 6703 //
     /*  87299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87313 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87316 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87318 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87325 */   // GIR_Coverage, 6703,
     /*  87325 */   GIR_EraseRootFromParent_Done,
     /*  87326 */ // Label 1526: @87326
     /*  87326 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(87358), // Rule ID 6704 //
     /*  87331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87345 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87348 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87357 */   // GIR_Coverage, 6704,
     /*  87357 */   GIR_EraseRootFromParent_Done,
     /*  87358 */ // Label 1527: @87358
     /*  87358 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(87390), // Rule ID 6705 //
     /*  87363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87377 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87380 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87389 */   // GIR_Coverage, 6705,
     /*  87389 */   GIR_EraseRootFromParent_Done,
     /*  87390 */ // Label 1528: @87390
     /*  87390 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(87422), // Rule ID 6706 //
     /*  87395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87409 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87412 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87414 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87421 */   // GIR_Coverage, 6706,
     /*  87421 */   GIR_EraseRootFromParent_Done,
     /*  87422 */ // Label 1529: @87422
     /*  87422 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(87454), // Rule ID 6707 //
     /*  87427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87441 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87444 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87453 */   // GIR_Coverage, 6707,
     /*  87453 */   GIR_EraseRootFromParent_Done,
     /*  87454 */ // Label 1530: @87454
     /*  87454 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(87487), // Rule ID 6708 //
     /*  87459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87473 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87478 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87485 */   GIR_RootConstrainSelectedInstOperands,
     /*  87486 */   // GIR_Coverage, 6708,
     /*  87486 */   GIR_EraseRootFromParent_Done,
     /*  87487 */ // Label 1531: @87487
     /*  87487 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(87513), // Rule ID 6709 //
     /*  87492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87506 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  87506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87511 */   GIR_RootConstrainSelectedInstOperands,
     /*  87512 */   // GIR_Coverage, 6709,
     /*  87512 */   GIR_Done,
     /*  87513 */ // Label 1532: @87513
     /*  87513 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(87539), // Rule ID 6710 //
     /*  87518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87532 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  87532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87537 */   GIR_RootConstrainSelectedInstOperands,
     /*  87538 */   // GIR_Coverage, 6710,
     /*  87538 */   GIR_Done,
     /*  87539 */ // Label 1533: @87539
     /*  87539 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(87565), // Rule ID 6711 //
     /*  87544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87558 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  87558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87563 */   GIR_RootConstrainSelectedInstOperands,
     /*  87564 */   // GIR_Coverage, 6711,
     /*  87564 */   GIR_Done,
     /*  87565 */ // Label 1534: @87565
     /*  87565 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(87591), // Rule ID 6712 //
     /*  87570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87584 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  87584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87589 */   GIR_RootConstrainSelectedInstOperands,
     /*  87590 */   // GIR_Coverage, 6712,
     /*  87590 */   GIR_Done,
     /*  87591 */ // Label 1535: @87591
     /*  87591 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(87617), // Rule ID 6713 //
     /*  87596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87610 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  87610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87615 */   GIR_RootConstrainSelectedInstOperands,
     /*  87616 */   // GIR_Coverage, 6713,
     /*  87616 */   GIR_Done,
     /*  87617 */ // Label 1536: @87617
     /*  87617 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(87646), // Rule ID 6714 //
     /*  87622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87633 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87645 */   // GIR_Coverage, 6714,
     /*  87645 */   GIR_EraseRootFromParent_Done,
     /*  87646 */ // Label 1537: @87646
     /*  87646 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(87678), // Rule ID 6728 //
     /*  87651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87665 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87677 */   // GIR_Coverage, 6728,
     /*  87677 */   GIR_EraseRootFromParent_Done,
     /*  87678 */ // Label 1538: @87678
     /*  87678 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(87710), // Rule ID 6729 //
     /*  87683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87697 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87709 */   // GIR_Coverage, 6729,
     /*  87709 */   GIR_EraseRootFromParent_Done,
     /*  87710 */ // Label 1539: @87710
     /*  87710 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(87742), // Rule ID 6730 //
     /*  87715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87729 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87741 */   // GIR_Coverage, 6730,
     /*  87741 */   GIR_EraseRootFromParent_Done,
     /*  87742 */ // Label 1540: @87742
     /*  87742 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(87774), // Rule ID 6731 //
     /*  87747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87761 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87773 */   // GIR_Coverage, 6731,
     /*  87773 */   GIR_EraseRootFromParent_Done,
     /*  87774 */ // Label 1541: @87774
     /*  87774 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(87806), // Rule ID 6732 //
     /*  87779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87793 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87805 */   // GIR_Coverage, 6732,
     /*  87805 */   GIR_EraseRootFromParent_Done,
     /*  87806 */ // Label 1542: @87806
     /*  87806 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(87838), // Rule ID 6733 //
     /*  87811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87825 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87828 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87830 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87837 */   // GIR_Coverage, 6733,
     /*  87837 */   GIR_EraseRootFromParent_Done,
     /*  87838 */ // Label 1543: @87838
     /*  87838 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(87871), // Rule ID 6734 //
     /*  87843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87857 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87862 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87864 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87869 */   GIR_RootConstrainSelectedInstOperands,
     /*  87870 */   // GIR_Coverage, 6734,
     /*  87870 */   GIR_EraseRootFromParent_Done,
     /*  87871 */ // Label 1544: @87871
     /*  87871 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(87897), // Rule ID 6735 //
     /*  87876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87890 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  87890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87895 */   GIR_RootConstrainSelectedInstOperands,
     /*  87896 */   // GIR_Coverage, 6735,
     /*  87896 */   GIR_Done,
     /*  87897 */ // Label 1545: @87897
     /*  87897 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(87923), // Rule ID 6736 //
     /*  87902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87916 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  87916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87921 */   GIR_RootConstrainSelectedInstOperands,
     /*  87922 */   // GIR_Coverage, 6736,
     /*  87922 */   GIR_Done,
     /*  87923 */ // Label 1546: @87923
     /*  87923 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(87949), // Rule ID 6737 //
     /*  87928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87942 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  87942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87947 */   GIR_RootConstrainSelectedInstOperands,
     /*  87948 */   // GIR_Coverage, 6737,
     /*  87948 */   GIR_Done,
     /*  87949 */ // Label 1547: @87949
     /*  87949 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(87975), // Rule ID 6738 //
     /*  87954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87968 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  87968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87973 */   GIR_RootConstrainSelectedInstOperands,
     /*  87974 */   // GIR_Coverage, 6738,
     /*  87974 */   GIR_Done,
     /*  87975 */ // Label 1548: @87975
     /*  87975 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(88001), // Rule ID 6739 //
     /*  87980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87994 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  87994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87999 */   GIR_RootConstrainSelectedInstOperands,
     /*  88000 */   // GIR_Coverage, 6739,
     /*  88000 */   GIR_Done,
     /*  88001 */ // Label 1549: @88001
     /*  88001 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(88030), // Rule ID 6740 //
     /*  88006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88017 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  88017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88020 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88029 */   // GIR_Coverage, 6740,
     /*  88029 */   GIR_EraseRootFromParent_Done,
     /*  88030 */ // Label 1550: @88030
     /*  88030 */ GIM_Reject,
     /*  88031 */ // Label 1405: @88031
     /*  88031 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(88061), // Rule ID 6552 //
     /*  88036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88050 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88060 */   // GIR_Coverage, 6552,
     /*  88060 */   GIR_Done,
     /*  88061 */ // Label 1551: @88061
     /*  88061 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(88091), // Rule ID 6554 //
     /*  88066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88080 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88090 */   // GIR_Coverage, 6554,
     /*  88090 */   GIR_Done,
     /*  88091 */ // Label 1552: @88091
     /*  88091 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(88141), // Rule ID 6563 //
     /*  88096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88110 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88122 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88139 */   GIR_RootConstrainSelectedInstOperands,
     /*  88140 */   // GIR_Coverage, 6563,
     /*  88140 */   GIR_EraseRootFromParent_Done,
     /*  88141 */ // Label 1553: @88141
     /*  88141 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(88191), // Rule ID 6565 //
     /*  88146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88160 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88189 */   GIR_RootConstrainSelectedInstOperands,
     /*  88190 */   // GIR_Coverage, 6565,
     /*  88190 */   GIR_EraseRootFromParent_Done,
     /*  88191 */ // Label 1554: @88191
     /*  88191 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(88223), // Rule ID 6611 //
     /*  88196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88210 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88213 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88215 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88222 */   // GIR_Coverage, 6611,
     /*  88222 */   GIR_EraseRootFromParent_Done,
     /*  88223 */ // Label 1555: @88223
     /*  88223 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(88255), // Rule ID 6612 //
     /*  88228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88242 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88245 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88247 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88249 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88254 */   // GIR_Coverage, 6612,
     /*  88254 */   GIR_EraseRootFromParent_Done,
     /*  88255 */ // Label 1556: @88255
     /*  88255 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(88287), // Rule ID 6613 //
     /*  88260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88274 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88277 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88279 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88286 */   // GIR_Coverage, 6613,
     /*  88286 */   GIR_EraseRootFromParent_Done,
     /*  88287 */ // Label 1557: @88287
     /*  88287 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(88319), // Rule ID 6614 //
     /*  88292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88306 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88309 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88313 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88318 */   // GIR_Coverage, 6614,
     /*  88318 */   GIR_EraseRootFromParent_Done,
     /*  88319 */ // Label 1558: @88319
     /*  88319 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(88351), // Rule ID 6615 //
     /*  88324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88338 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88341 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88345 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88350 */   // GIR_Coverage, 6615,
     /*  88350 */   GIR_EraseRootFromParent_Done,
     /*  88351 */ // Label 1559: @88351
     /*  88351 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(88383), // Rule ID 6616 //
     /*  88356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88370 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88373 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88375 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88382 */   // GIR_Coverage, 6616,
     /*  88382 */   GIR_EraseRootFromParent_Done,
     /*  88383 */ // Label 1560: @88383
     /*  88383 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(88409), // Rule ID 6617 //
     /*  88388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88402 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  88402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88407 */   GIR_RootConstrainSelectedInstOperands,
     /*  88408 */   // GIR_Coverage, 6617,
     /*  88408 */   GIR_Done,
     /*  88409 */ // Label 1561: @88409
     /*  88409 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(88435), // Rule ID 6618 //
     /*  88414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88428 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  88428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88433 */   GIR_RootConstrainSelectedInstOperands,
     /*  88434 */   // GIR_Coverage, 6618,
     /*  88434 */   GIR_Done,
     /*  88435 */ // Label 1562: @88435
     /*  88435 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(88461), // Rule ID 6619 //
     /*  88440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88454 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  88454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88459 */   GIR_RootConstrainSelectedInstOperands,
     /*  88460 */   // GIR_Coverage, 6619,
     /*  88460 */   GIR_Done,
     /*  88461 */ // Label 1563: @88461
     /*  88461 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(88487), // Rule ID 6620 //
     /*  88466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88480 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  88480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88485 */   GIR_RootConstrainSelectedInstOperands,
     /*  88486 */   // GIR_Coverage, 6620,
     /*  88486 */   GIR_Done,
     /*  88487 */ // Label 1564: @88487
     /*  88487 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(88513), // Rule ID 6621 //
     /*  88492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88506 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  88506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88511 */   GIR_RootConstrainSelectedInstOperands,
     /*  88512 */   // GIR_Coverage, 6621,
     /*  88512 */   GIR_Done,
     /*  88513 */ // Label 1565: @88513
     /*  88513 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(88539), // Rule ID 6622 //
     /*  88518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88532 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  88532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88537 */   GIR_RootConstrainSelectedInstOperands,
     /*  88538 */   // GIR_Coverage, 6622,
     /*  88538 */   GIR_Done,
     /*  88539 */ // Label 1566: @88539
     /*  88539 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(88568), // Rule ID 6623 //
     /*  88544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88555 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88567 */   // GIR_Coverage, 6623,
     /*  88567 */   GIR_EraseRootFromParent_Done,
     /*  88568 */ // Label 1567: @88568
     /*  88568 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(88600), // Rule ID 6624 //
     /*  88573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88587 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88599 */   // GIR_Coverage, 6624,
     /*  88599 */   GIR_EraseRootFromParent_Done,
     /*  88600 */ // Label 1568: @88600
     /*  88600 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(88632), // Rule ID 6625 //
     /*  88605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88619 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88622 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88624 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88626 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88631 */   // GIR_Coverage, 6625,
     /*  88631 */   GIR_EraseRootFromParent_Done,
     /*  88632 */ // Label 1569: @88632
     /*  88632 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(88664), // Rule ID 6626 //
     /*  88637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88651 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88654 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88656 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88663 */   // GIR_Coverage, 6626,
     /*  88663 */   GIR_EraseRootFromParent_Done,
     /*  88664 */ // Label 1570: @88664
     /*  88664 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(88696), // Rule ID 6627 //
     /*  88669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88683 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88686 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88688 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88695 */   // GIR_Coverage, 6627,
     /*  88695 */   GIR_EraseRootFromParent_Done,
     /*  88696 */ // Label 1571: @88696
     /*  88696 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(88728), // Rule ID 6628 //
     /*  88701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88715 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88718 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88727 */   // GIR_Coverage, 6628,
     /*  88727 */   GIR_EraseRootFromParent_Done,
     /*  88728 */ // Label 1572: @88728
     /*  88728 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(88760), // Rule ID 6629 //
     /*  88733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88747 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88750 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88752 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88759 */   // GIR_Coverage, 6629,
     /*  88759 */   GIR_EraseRootFromParent_Done,
     /*  88760 */ // Label 1573: @88760
     /*  88760 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(88786), // Rule ID 6630 //
     /*  88765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88779 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  88779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88784 */   GIR_RootConstrainSelectedInstOperands,
     /*  88785 */   // GIR_Coverage, 6630,
     /*  88785 */   GIR_Done,
     /*  88786 */ // Label 1574: @88786
     /*  88786 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(88812), // Rule ID 6631 //
     /*  88791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88805 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  88805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88810 */   GIR_RootConstrainSelectedInstOperands,
     /*  88811 */   // GIR_Coverage, 6631,
     /*  88811 */   GIR_Done,
     /*  88812 */ // Label 1575: @88812
     /*  88812 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(88838), // Rule ID 6632 //
     /*  88817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88831 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  88831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88836 */   GIR_RootConstrainSelectedInstOperands,
     /*  88837 */   // GIR_Coverage, 6632,
     /*  88837 */   GIR_Done,
     /*  88838 */ // Label 1576: @88838
     /*  88838 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(88864), // Rule ID 6633 //
     /*  88843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88857 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  88857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88862 */   GIR_RootConstrainSelectedInstOperands,
     /*  88863 */   // GIR_Coverage, 6633,
     /*  88863 */   GIR_Done,
     /*  88864 */ // Label 1577: @88864
     /*  88864 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(88890), // Rule ID 6634 //
     /*  88869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88883 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  88883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88888 */   GIR_RootConstrainSelectedInstOperands,
     /*  88889 */   // GIR_Coverage, 6634,
     /*  88889 */   GIR_Done,
     /*  88890 */ // Label 1578: @88890
     /*  88890 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(88916), // Rule ID 6635 //
     /*  88895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88909 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  88909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88914 */   GIR_RootConstrainSelectedInstOperands,
     /*  88915 */   // GIR_Coverage, 6635,
     /*  88915 */   GIR_Done,
     /*  88916 */ // Label 1579: @88916
     /*  88916 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(88945), // Rule ID 6636 //
     /*  88921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88932 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88944 */   // GIR_Coverage, 6636,
     /*  88944 */   GIR_EraseRootFromParent_Done,
     /*  88945 */ // Label 1580: @88945
     /*  88945 */ GIM_Reject,
     /*  88946 */ // Label 1406: @88946
     /*  88946 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(88978), // Rule ID 6715 //
     /*  88951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  88957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88965 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  88965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88968 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88970 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88977 */   // GIR_Coverage, 6715,
     /*  88977 */   GIR_EraseRootFromParent_Done,
     /*  88978 */ // Label 1581: @88978
     /*  88978 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(89010), // Rule ID 6716 //
     /*  88983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88997 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  88997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89000 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89002 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89009 */   // GIR_Coverage, 6716,
     /*  89009 */   GIR_EraseRootFromParent_Done,
     /*  89010 */ // Label 1582: @89010
     /*  89010 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(89042), // Rule ID 6717 //
     /*  89015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89029 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89032 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89034 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89041 */   // GIR_Coverage, 6717,
     /*  89041 */   GIR_EraseRootFromParent_Done,
     /*  89042 */ // Label 1583: @89042
     /*  89042 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(89074), // Rule ID 6718 //
     /*  89047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89061 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89064 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89066 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89073 */   // GIR_Coverage, 6718,
     /*  89073 */   GIR_EraseRootFromParent_Done,
     /*  89074 */ // Label 1584: @89074
     /*  89074 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(89106), // Rule ID 6719 //
     /*  89079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89093 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89105 */   // GIR_Coverage, 6719,
     /*  89105 */   GIR_EraseRootFromParent_Done,
     /*  89106 */ // Label 1585: @89106
     /*  89106 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(89138), // Rule ID 6720 //
     /*  89111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89125 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89128 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89137 */   // GIR_Coverage, 6720,
     /*  89137 */   GIR_EraseRootFromParent_Done,
     /*  89138 */ // Label 1586: @89138
     /*  89138 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(89209), // Rule ID 6721 //
     /*  89143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89157 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89157 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89160 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89164 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89169 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89187 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89207 */   GIR_RootConstrainSelectedInstOperands,
     /*  89208 */   // GIR_Coverage, 6721,
     /*  89208 */   GIR_EraseRootFromParent_Done,
     /*  89209 */ // Label 1587: @89209
     /*  89209 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(89235), // Rule ID 6722 //
     /*  89214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89228 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  89228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89233 */   GIR_RootConstrainSelectedInstOperands,
     /*  89234 */   // GIR_Coverage, 6722,
     /*  89234 */   GIR_Done,
     /*  89235 */ // Label 1588: @89235
     /*  89235 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(89261), // Rule ID 6723 //
     /*  89240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89254 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  89254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89259 */   GIR_RootConstrainSelectedInstOperands,
     /*  89260 */   // GIR_Coverage, 6723,
     /*  89260 */   GIR_Done,
     /*  89261 */ // Label 1589: @89261
     /*  89261 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(89287), // Rule ID 6724 //
     /*  89266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89280 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  89280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89285 */   GIR_RootConstrainSelectedInstOperands,
     /*  89286 */   // GIR_Coverage, 6724,
     /*  89286 */   GIR_Done,
     /*  89287 */ // Label 1590: @89287
     /*  89287 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(89313), // Rule ID 6725 //
     /*  89292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89306 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  89306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89311 */   GIR_RootConstrainSelectedInstOperands,
     /*  89312 */   // GIR_Coverage, 6725,
     /*  89312 */   GIR_Done,
     /*  89313 */ // Label 1591: @89313
     /*  89313 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(89339), // Rule ID 6726 //
     /*  89318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89332 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  89332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89337 */   GIR_RootConstrainSelectedInstOperands,
     /*  89338 */   // GIR_Coverage, 6726,
     /*  89338 */   GIR_Done,
     /*  89339 */ // Label 1592: @89339
     /*  89339 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(89368), // Rule ID 6727 //
     /*  89344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89355 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89367 */   // GIR_Coverage, 6727,
     /*  89367 */   GIR_EraseRootFromParent_Done,
     /*  89368 */ // Label 1593: @89368
     /*  89368 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(89400), // Rule ID 6741 //
     /*  89373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89387 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89399 */   // GIR_Coverage, 6741,
     /*  89399 */   GIR_EraseRootFromParent_Done,
     /*  89400 */ // Label 1594: @89400
     /*  89400 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(89432), // Rule ID 6742 //
     /*  89405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89419 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89431 */   // GIR_Coverage, 6742,
     /*  89431 */   GIR_EraseRootFromParent_Done,
     /*  89432 */ // Label 1595: @89432
     /*  89432 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(89464), // Rule ID 6743 //
     /*  89437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89451 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89463 */   // GIR_Coverage, 6743,
     /*  89463 */   GIR_EraseRootFromParent_Done,
     /*  89464 */ // Label 1596: @89464
     /*  89464 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(89496), // Rule ID 6744 //
     /*  89469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89483 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89495 */   // GIR_Coverage, 6744,
     /*  89495 */   GIR_EraseRootFromParent_Done,
     /*  89496 */ // Label 1597: @89496
     /*  89496 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(89528), // Rule ID 6745 //
     /*  89501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89515 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89527 */   // GIR_Coverage, 6745,
     /*  89527 */   GIR_EraseRootFromParent_Done,
     /*  89528 */ // Label 1598: @89528
     /*  89528 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(89560), // Rule ID 6746 //
     /*  89533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89547 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89559 */   // GIR_Coverage, 6746,
     /*  89559 */   GIR_EraseRootFromParent_Done,
     /*  89560 */ // Label 1599: @89560
     /*  89560 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(89631), // Rule ID 6747 //
     /*  89565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89579 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89579 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89582 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89586 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89591 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89609 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89629 */   GIR_RootConstrainSelectedInstOperands,
     /*  89630 */   // GIR_Coverage, 6747,
     /*  89630 */   GIR_EraseRootFromParent_Done,
     /*  89631 */ // Label 1600: @89631
     /*  89631 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(89657), // Rule ID 6748 //
     /*  89636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89650 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  89650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89655 */   GIR_RootConstrainSelectedInstOperands,
     /*  89656 */   // GIR_Coverage, 6748,
     /*  89656 */   GIR_Done,
     /*  89657 */ // Label 1601: @89657
     /*  89657 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(89683), // Rule ID 6749 //
     /*  89662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89676 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  89676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89681 */   GIR_RootConstrainSelectedInstOperands,
     /*  89682 */   // GIR_Coverage, 6749,
     /*  89682 */   GIR_Done,
     /*  89683 */ // Label 1602: @89683
     /*  89683 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(89709), // Rule ID 6750 //
     /*  89688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89702 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  89702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89707 */   GIR_RootConstrainSelectedInstOperands,
     /*  89708 */   // GIR_Coverage, 6750,
     /*  89708 */   GIR_Done,
     /*  89709 */ // Label 1603: @89709
     /*  89709 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(89735), // Rule ID 6751 //
     /*  89714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89728 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  89728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89733 */   GIR_RootConstrainSelectedInstOperands,
     /*  89734 */   // GIR_Coverage, 6751,
     /*  89734 */   GIR_Done,
     /*  89735 */ // Label 1604: @89735
     /*  89735 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(89761), // Rule ID 6752 //
     /*  89740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89754 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  89754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89759 */   GIR_RootConstrainSelectedInstOperands,
     /*  89760 */   // GIR_Coverage, 6752,
     /*  89760 */   GIR_Done,
     /*  89761 */ // Label 1605: @89761
     /*  89761 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(89790), // Rule ID 6753 //
     /*  89766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89777 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89789 */   // GIR_Coverage, 6753,
     /*  89789 */   GIR_EraseRootFromParent_Done,
     /*  89790 */ // Label 1606: @89790
     /*  89790 */ GIM_Reject,
     /*  89791 */ // Label 1407: @89791
     /*  89791 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(89865), // Rule ID 5598 //
     /*  89796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  89811 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  89815 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  89820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89822 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  89822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  89825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  89829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89834 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  89843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  89854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  89864 */   // GIR_Coverage, 5598,
     /*  89864 */   GIR_EraseRootFromParent_Done,
     /*  89865 */ // Label 1607: @89865
     /*  89865 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(89895), // Rule ID 6551 //
     /*  89870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89884 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89894 */   // GIR_Coverage, 6551,
     /*  89894 */   GIR_Done,
     /*  89895 */ // Label 1608: @89895
     /*  89895 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(89945), // Rule ID 6562 //
     /*  89900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89914 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89926 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  89930 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89943 */   GIR_RootConstrainSelectedInstOperands,
     /*  89944 */   // GIR_Coverage, 6562,
     /*  89944 */   GIR_EraseRootFromParent_Done,
     /*  89945 */ // Label 1609: @89945
     /*  89945 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(89977), // Rule ID 6637 //
     /*  89950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89964 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  89964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89976 */   // GIR_Coverage, 6637,
     /*  89976 */   GIR_EraseRootFromParent_Done,
     /*  89977 */ // Label 1610: @89977
     /*  89977 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(90009), // Rule ID 6638 //
     /*  89982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89996 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  89996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90008 */   // GIR_Coverage, 6638,
     /*  90008 */   GIR_EraseRootFromParent_Done,
     /*  90009 */ // Label 1611: @90009
     /*  90009 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(90041), // Rule ID 6639 //
     /*  90014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90028 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90031 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90033 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90035 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90040 */   // GIR_Coverage, 6639,
     /*  90040 */   GIR_EraseRootFromParent_Done,
     /*  90041 */ // Label 1612: @90041
     /*  90041 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(90073), // Rule ID 6640 //
     /*  90046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90060 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90072 */   // GIR_Coverage, 6640,
     /*  90072 */   GIR_EraseRootFromParent_Done,
     /*  90073 */ // Label 1613: @90073
     /*  90073 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(90105), // Rule ID 6641 //
     /*  90078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90092 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90104 */   // GIR_Coverage, 6641,
     /*  90104 */   GIR_EraseRootFromParent_Done,
     /*  90105 */ // Label 1614: @90105
     /*  90105 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(90137), // Rule ID 6642 //
     /*  90110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90124 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90127 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90129 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90136 */   // GIR_Coverage, 6642,
     /*  90136 */   GIR_EraseRootFromParent_Done,
     /*  90137 */ // Label 1615: @90137
     /*  90137 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(90169), // Rule ID 6643 //
     /*  90142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90156 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90159 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90161 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90168 */   // GIR_Coverage, 6643,
     /*  90168 */   GIR_EraseRootFromParent_Done,
     /*  90169 */ // Label 1616: @90169
     /*  90169 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(90195), // Rule ID 6644 //
     /*  90174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90188 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  90188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90193 */   GIR_RootConstrainSelectedInstOperands,
     /*  90194 */   // GIR_Coverage, 6644,
     /*  90194 */   GIR_Done,
     /*  90195 */ // Label 1617: @90195
     /*  90195 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(90221), // Rule ID 6645 //
     /*  90200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90214 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  90214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90219 */   GIR_RootConstrainSelectedInstOperands,
     /*  90220 */   // GIR_Coverage, 6645,
     /*  90220 */   GIR_Done,
     /*  90221 */ // Label 1618: @90221
     /*  90221 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(90247), // Rule ID 6646 //
     /*  90226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90240 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  90240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90245 */   GIR_RootConstrainSelectedInstOperands,
     /*  90246 */   // GIR_Coverage, 6646,
     /*  90246 */   GIR_Done,
     /*  90247 */ // Label 1619: @90247
     /*  90247 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(90273), // Rule ID 6647 //
     /*  90252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90266 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  90266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90271 */   GIR_RootConstrainSelectedInstOperands,
     /*  90272 */   // GIR_Coverage, 6647,
     /*  90272 */   GIR_Done,
     /*  90273 */ // Label 1620: @90273
     /*  90273 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(90299), // Rule ID 6648 //
     /*  90278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90292 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  90292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90297 */   GIR_RootConstrainSelectedInstOperands,
     /*  90298 */   // GIR_Coverage, 6648,
     /*  90298 */   GIR_Done,
     /*  90299 */ // Label 1621: @90299
     /*  90299 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(90325), // Rule ID 6649 //
     /*  90304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90318 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  90318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90323 */   GIR_RootConstrainSelectedInstOperands,
     /*  90324 */   // GIR_Coverage, 6649,
     /*  90324 */   GIR_Done,
     /*  90325 */ // Label 1622: @90325
     /*  90325 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(90351), // Rule ID 6650 //
     /*  90330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90344 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  90344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90349 */   GIR_RootConstrainSelectedInstOperands,
     /*  90350 */   // GIR_Coverage, 6650,
     /*  90350 */   GIR_Done,
     /*  90351 */ // Label 1623: @90351
     /*  90351 */ GIM_Reject,
     /*  90352 */ // Label 1408: @90352
     /*  90352 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(90384), // Rule ID 6754 //
     /*  90357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90371 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90374 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90383 */   // GIR_Coverage, 6754,
     /*  90383 */   GIR_EraseRootFromParent_Done,
     /*  90384 */ // Label 1624: @90384
     /*  90384 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(90416), // Rule ID 6755 //
     /*  90389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90403 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90406 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90415 */   // GIR_Coverage, 6755,
     /*  90415 */   GIR_EraseRootFromParent_Done,
     /*  90416 */ // Label 1625: @90416
     /*  90416 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(90448), // Rule ID 6756 //
     /*  90421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90435 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90447 */   // GIR_Coverage, 6756,
     /*  90447 */   GIR_EraseRootFromParent_Done,
     /*  90448 */ // Label 1626: @90448
     /*  90448 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(90480), // Rule ID 6757 //
     /*  90453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90467 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90479 */   // GIR_Coverage, 6757,
     /*  90479 */   GIR_EraseRootFromParent_Done,
     /*  90480 */ // Label 1627: @90480
     /*  90480 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(90512), // Rule ID 6758 //
     /*  90485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90499 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90511 */   // GIR_Coverage, 6758,
     /*  90511 */   GIR_EraseRootFromParent_Done,
     /*  90512 */ // Label 1628: @90512
     /*  90512 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(90544), // Rule ID 6759 //
     /*  90517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90531 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90534 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90543 */   // GIR_Coverage, 6759,
     /*  90543 */   GIR_EraseRootFromParent_Done,
     /*  90544 */ // Label 1629: @90544
     /*  90544 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(90615), // Rule ID 6760 //
     /*  90549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90563 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  90563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90575 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90593 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90613 */   GIR_RootConstrainSelectedInstOperands,
     /*  90614 */   // GIR_Coverage, 6760,
     /*  90614 */   GIR_EraseRootFromParent_Done,
     /*  90615 */ // Label 1630: @90615
     /*  90615 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(90641), // Rule ID 6761 //
     /*  90620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90634 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  90634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90639 */   GIR_RootConstrainSelectedInstOperands,
     /*  90640 */   // GIR_Coverage, 6761,
     /*  90640 */   GIR_Done,
     /*  90641 */ // Label 1631: @90641
     /*  90641 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(90667), // Rule ID 6762 //
     /*  90646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90660 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  90660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90665 */   GIR_RootConstrainSelectedInstOperands,
     /*  90666 */   // GIR_Coverage, 6762,
     /*  90666 */   GIR_Done,
     /*  90667 */ // Label 1632: @90667
     /*  90667 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(90693), // Rule ID 6763 //
     /*  90672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90686 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  90686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  90691 */   GIR_RootConstrainSelectedInstOperands,
     /*  90692 */   // GIR_Coverage, 6763,
     /*  90692 */   GIR_Done,
     /*  90693 */ // Label 1633: @90693
     /*  90693 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(90719), // Rule ID 6764 //
     /*  90698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90712 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  90712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90717 */   GIR_RootConstrainSelectedInstOperands,
     /*  90718 */   // GIR_Coverage, 6764,
     /*  90718 */   GIR_Done,
     /*  90719 */ // Label 1634: @90719
     /*  90719 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(90745), // Rule ID 6765 //
     /*  90724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90738 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  90738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90743 */   GIR_RootConstrainSelectedInstOperands,
     /*  90744 */   // GIR_Coverage, 6765,
     /*  90744 */   GIR_Done,
     /*  90745 */ // Label 1635: @90745
     /*  90745 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(90774), // Rule ID 6766 //
     /*  90750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90761 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90773 */   // GIR_Coverage, 6766,
     /*  90773 */   GIR_EraseRootFromParent_Done,
     /*  90774 */ // Label 1636: @90774
     /*  90774 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(90806), // Rule ID 6767 //
     /*  90779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90793 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90805 */   // GIR_Coverage, 6767,
     /*  90805 */   GIR_EraseRootFromParent_Done,
     /*  90806 */ // Label 1637: @90806
     /*  90806 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(90838), // Rule ID 6768 //
     /*  90811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90825 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90828 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90830 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */   // GIR_Coverage, 6768,
     /*  90837 */   GIR_EraseRootFromParent_Done,
     /*  90838 */ // Label 1638: @90838
     /*  90838 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90870), // Rule ID 6769 //
     /*  90843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90857 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90860 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90862 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90869 */   // GIR_Coverage, 6769,
     /*  90869 */   GIR_EraseRootFromParent_Done,
     /*  90870 */ // Label 1639: @90870
     /*  90870 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90902), // Rule ID 6770 //
     /*  90875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90889 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90901 */   // GIR_Coverage, 6770,
     /*  90901 */   GIR_EraseRootFromParent_Done,
     /*  90902 */ // Label 1640: @90902
     /*  90902 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90934), // Rule ID 6771 //
     /*  90907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90921 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90924 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90926 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90928 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90933 */   // GIR_Coverage, 6771,
     /*  90933 */   GIR_EraseRootFromParent_Done,
     /*  90934 */ // Label 1641: @90934
     /*  90934 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90966), // Rule ID 6772 //
     /*  90939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90953 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90956 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90958 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90965 */   // GIR_Coverage, 6772,
     /*  90965 */   GIR_EraseRootFromParent_Done,
     /*  90966 */ // Label 1642: @90966
     /*  90966 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(91037), // Rule ID 6773 //
     /*  90971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90985 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  90985 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90988 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90992 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90997 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91035 */   GIR_RootConstrainSelectedInstOperands,
     /*  91036 */   // GIR_Coverage, 6773,
     /*  91036 */   GIR_EraseRootFromParent_Done,
     /*  91037 */ // Label 1643: @91037
     /*  91037 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(91063), // Rule ID 6774 //
     /*  91042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91056 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  91056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91061 */   GIR_RootConstrainSelectedInstOperands,
     /*  91062 */   // GIR_Coverage, 6774,
     /*  91062 */   GIR_Done,
     /*  91063 */ // Label 1644: @91063
     /*  91063 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(91089), // Rule ID 6775 //
     /*  91068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91082 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  91082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91087 */   GIR_RootConstrainSelectedInstOperands,
     /*  91088 */   // GIR_Coverage, 6775,
     /*  91088 */   GIR_Done,
     /*  91089 */ // Label 1645: @91089
     /*  91089 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(91115), // Rule ID 6776 //
     /*  91094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91108 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  91108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91113 */   GIR_RootConstrainSelectedInstOperands,
     /*  91114 */   // GIR_Coverage, 6776,
     /*  91114 */   GIR_Done,
     /*  91115 */ // Label 1646: @91115
     /*  91115 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(91141), // Rule ID 6777 //
     /*  91120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91134 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  91134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91139 */   GIR_RootConstrainSelectedInstOperands,
     /*  91140 */   // GIR_Coverage, 6777,
     /*  91140 */   GIR_Done,
     /*  91141 */ // Label 1647: @91141
     /*  91141 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91167), // Rule ID 6778 //
     /*  91146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91160 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  91160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91165 */   GIR_RootConstrainSelectedInstOperands,
     /*  91166 */   // GIR_Coverage, 6778,
     /*  91166 */   GIR_Done,
     /*  91167 */ // Label 1648: @91167
     /*  91167 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91196), // Rule ID 6779 //
     /*  91172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91183 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  91183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91186 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91188 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91195 */   // GIR_Coverage, 6779,
     /*  91195 */   GIR_EraseRootFromParent_Done,
     /*  91196 */ // Label 1649: @91196
     /*  91196 */ GIM_Reject,
     /*  91197 */ // Label 1409: @91197
     /*  91197 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91229), // Rule ID 6780 //
     /*  91202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91216 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91219 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91221 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91228 */   // GIR_Coverage, 6780,
     /*  91228 */   GIR_EraseRootFromParent_Done,
     /*  91229 */ // Label 1650: @91229
     /*  91229 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91261), // Rule ID 6781 //
     /*  91234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91248 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91251 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91260 */   // GIR_Coverage, 6781,
     /*  91260 */   GIR_EraseRootFromParent_Done,
     /*  91261 */ // Label 1651: @91261
     /*  91261 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91293), // Rule ID 6782 //
     /*  91266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91280 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91292 */   // GIR_Coverage, 6782,
     /*  91292 */   GIR_EraseRootFromParent_Done,
     /*  91293 */ // Label 1652: @91293
     /*  91293 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91325), // Rule ID 6783 //
     /*  91298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91312 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91315 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91324 */   // GIR_Coverage, 6783,
     /*  91324 */   GIR_EraseRootFromParent_Done,
     /*  91325 */ // Label 1653: @91325
     /*  91325 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91357), // Rule ID 6784 //
     /*  91330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91344 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91347 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91349 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91356 */   // GIR_Coverage, 6784,
     /*  91356 */   GIR_EraseRootFromParent_Done,
     /*  91357 */ // Label 1654: @91357
     /*  91357 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91389), // Rule ID 6785 //
     /*  91362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91376 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91379 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91381 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91388 */   // GIR_Coverage, 6785,
     /*  91388 */   GIR_EraseRootFromParent_Done,
     /*  91389 */ // Label 1655: @91389
     /*  91389 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91421), // Rule ID 6786 //
     /*  91394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91408 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91411 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91413 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91420 */   // GIR_Coverage, 6786,
     /*  91420 */   GIR_EraseRootFromParent_Done,
     /*  91421 */ // Label 1656: @91421
     /*  91421 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91492), // Rule ID 6787 //
     /*  91426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91440 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91440 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91443 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91447 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91452 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91470 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91490 */   GIR_RootConstrainSelectedInstOperands,
     /*  91491 */   // GIR_Coverage, 6787,
     /*  91491 */   GIR_EraseRootFromParent_Done,
     /*  91492 */ // Label 1657: @91492
     /*  91492 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91518), // Rule ID 6788 //
     /*  91497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91511 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  91511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91516 */   GIR_RootConstrainSelectedInstOperands,
     /*  91517 */   // GIR_Coverage, 6788,
     /*  91517 */   GIR_Done,
     /*  91518 */ // Label 1658: @91518
     /*  91518 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91544), // Rule ID 6789 //
     /*  91523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91537 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  91537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91542 */   GIR_RootConstrainSelectedInstOperands,
     /*  91543 */   // GIR_Coverage, 6789,
     /*  91543 */   GIR_Done,
     /*  91544 */ // Label 1659: @91544
     /*  91544 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91570), // Rule ID 6790 //
     /*  91549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91563 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  91563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91568 */   GIR_RootConstrainSelectedInstOperands,
     /*  91569 */   // GIR_Coverage, 6790,
     /*  91569 */   GIR_Done,
     /*  91570 */ // Label 1660: @91570
     /*  91570 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91596), // Rule ID 6791 //
     /*  91575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91589 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  91589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91594 */   GIR_RootConstrainSelectedInstOperands,
     /*  91595 */   // GIR_Coverage, 6791,
     /*  91595 */   GIR_Done,
     /*  91596 */ // Label 1661: @91596
     /*  91596 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91622), // Rule ID 6792 //
     /*  91601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91615 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  91615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91620 */   GIR_RootConstrainSelectedInstOperands,
     /*  91621 */   // GIR_Coverage, 6792,
     /*  91621 */   GIR_Done,
     /*  91622 */ // Label 1662: @91622
     /*  91622 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91648), // Rule ID 6793 //
     /*  91627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91641 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  91641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91646 */   GIR_RootConstrainSelectedInstOperands,
     /*  91647 */   // GIR_Coverage, 6793,
     /*  91647 */   GIR_Done,
     /*  91648 */ // Label 1663: @91648
     /*  91648 */ GIM_Reject,
     /*  91649 */ // Label 1410: @91649
     /*  91649 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91681), // Rule ID 10402 //
     /*  91654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91668 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91680 */   // GIR_Coverage, 10402,
     /*  91680 */   GIR_EraseRootFromParent_Done,
     /*  91681 */ // Label 1664: @91681
     /*  91681 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91713), // Rule ID 10403 //
     /*  91686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91700 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91703 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91712 */   // GIR_Coverage, 10403,
     /*  91712 */   GIR_EraseRootFromParent_Done,
     /*  91713 */ // Label 1665: @91713
     /*  91713 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91745), // Rule ID 10404 //
     /*  91718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91732 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91735 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91737 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91744 */   // GIR_Coverage, 10404,
     /*  91744 */   GIR_EraseRootFromParent_Done,
     /*  91745 */ // Label 1666: @91745
     /*  91745 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91777), // Rule ID 10405 //
     /*  91750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91764 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91767 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91769 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91776 */   // GIR_Coverage, 10405,
     /*  91776 */   GIR_EraseRootFromParent_Done,
     /*  91777 */ // Label 1667: @91777
     /*  91777 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91809), // Rule ID 10406 //
     /*  91782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91796 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91799 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91801 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91808 */   // GIR_Coverage, 10406,
     /*  91808 */   GIR_EraseRootFromParent_Done,
     /*  91809 */ // Label 1668: @91809
     /*  91809 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91841), // Rule ID 10407 //
     /*  91814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91828 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91831 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91840 */   // GIR_Coverage, 10407,
     /*  91840 */   GIR_EraseRootFromParent_Done,
     /*  91841 */ // Label 1669: @91841
     /*  91841 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91873), // Rule ID 10420 //
     /*  91846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91860 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91872 */   // GIR_Coverage, 10420,
     /*  91872 */   GIR_EraseRootFromParent_Done,
     /*  91873 */ // Label 1670: @91873
     /*  91873 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91905), // Rule ID 10421 //
     /*  91878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91892 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91895 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91897 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91904 */   // GIR_Coverage, 10421,
     /*  91904 */   GIR_EraseRootFromParent_Done,
     /*  91905 */ // Label 1671: @91905
     /*  91905 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91937), // Rule ID 10422 //
     /*  91910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91924 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91936 */   // GIR_Coverage, 10422,
     /*  91936 */   GIR_EraseRootFromParent_Done,
     /*  91937 */ // Label 1672: @91937
     /*  91937 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91969), // Rule ID 10423 //
     /*  91942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91956 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91968 */   // GIR_Coverage, 10423,
     /*  91968 */   GIR_EraseRootFromParent_Done,
     /*  91969 */ // Label 1673: @91969
     /*  91969 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92001), // Rule ID 10424 //
     /*  91974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91988 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92000 */   // GIR_Coverage, 10424,
     /*  92000 */   GIR_EraseRootFromParent_Done,
     /*  92001 */ // Label 1674: @92001
     /*  92001 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(92033), // Rule ID 10425 //
     /*  92006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92020 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92032 */   // GIR_Coverage, 10425,
     /*  92032 */   GIR_EraseRootFromParent_Done,
     /*  92033 */ // Label 1675: @92033
     /*  92033 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92065), // Rule ID 10430 //
     /*  92038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92052 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  92052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92064 */   // GIR_Coverage, 10430,
     /*  92064 */   GIR_EraseRootFromParent_Done,
     /*  92065 */ // Label 1676: @92065
     /*  92065 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92097), // Rule ID 10431 //
     /*  92070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92084 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92096 */   // GIR_Coverage, 10431,
     /*  92096 */   GIR_EraseRootFromParent_Done,
     /*  92097 */ // Label 1677: @92097
     /*  92097 */ GIM_Reject,
     /*  92098 */ // Label 1411: @92098
     /*  92098 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92130), // Rule ID 10396 //
     /*  92103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92117 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92120 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92122 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92129 */   // GIR_Coverage, 10396,
     /*  92129 */   GIR_EraseRootFromParent_Done,
     /*  92130 */ // Label 1678: @92130
     /*  92130 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92162), // Rule ID 10397 //
     /*  92135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92149 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92152 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92154 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92161 */   // GIR_Coverage, 10397,
     /*  92161 */   GIR_EraseRootFromParent_Done,
     /*  92162 */ // Label 1679: @92162
     /*  92162 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92194), // Rule ID 10398 //
     /*  92167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92181 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92184 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92186 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92193 */   // GIR_Coverage, 10398,
     /*  92193 */   GIR_EraseRootFromParent_Done,
     /*  92194 */ // Label 1680: @92194
     /*  92194 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92226), // Rule ID 10399 //
     /*  92199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92213 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92216 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92218 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92220 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92225 */   // GIR_Coverage, 10399,
     /*  92225 */   GIR_EraseRootFromParent_Done,
     /*  92226 */ // Label 1681: @92226
     /*  92226 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92258), // Rule ID 10400 //
     /*  92231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92245 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92248 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92250 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92257 */   // GIR_Coverage, 10400,
     /*  92257 */   GIR_EraseRootFromParent_Done,
     /*  92258 */ // Label 1682: @92258
     /*  92258 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92290), // Rule ID 10401 //
     /*  92263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92277 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92280 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92282 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92289 */   // GIR_Coverage, 10401,
     /*  92289 */   GIR_EraseRootFromParent_Done,
     /*  92290 */ // Label 1683: @92290
     /*  92290 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92322), // Rule ID 10414 //
     /*  92295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92309 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92312 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92314 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92321 */   // GIR_Coverage, 10414,
     /*  92321 */   GIR_EraseRootFromParent_Done,
     /*  92322 */ // Label 1684: @92322
     /*  92322 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92354), // Rule ID 10415 //
     /*  92327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92341 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92344 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92346 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92353 */   // GIR_Coverage, 10415,
     /*  92353 */   GIR_EraseRootFromParent_Done,
     /*  92354 */ // Label 1685: @92354
     /*  92354 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92386), // Rule ID 10416 //
     /*  92359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92373 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92376 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92378 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92380 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92385 */   // GIR_Coverage, 10416,
     /*  92385 */   GIR_EraseRootFromParent_Done,
     /*  92386 */ // Label 1686: @92386
     /*  92386 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92418), // Rule ID 10417 //
     /*  92391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92405 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92408 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92410 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92417 */   // GIR_Coverage, 10417,
     /*  92417 */   GIR_EraseRootFromParent_Done,
     /*  92418 */ // Label 1687: @92418
     /*  92418 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92450), // Rule ID 10418 //
     /*  92423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92437 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92440 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92442 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92449 */   // GIR_Coverage, 10418,
     /*  92449 */   GIR_EraseRootFromParent_Done,
     /*  92450 */ // Label 1688: @92450
     /*  92450 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92482), // Rule ID 10419 //
     /*  92455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92469 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92472 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92474 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92481 */   // GIR_Coverage, 10419,
     /*  92481 */   GIR_EraseRootFromParent_Done,
     /*  92482 */ // Label 1689: @92482
     /*  92482 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92514), // Rule ID 10428 //
     /*  92487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92501 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92504 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92506 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92513 */   // GIR_Coverage, 10428,
     /*  92513 */   GIR_EraseRootFromParent_Done,
     /*  92514 */ // Label 1690: @92514
     /*  92514 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92546), // Rule ID 10429 //
     /*  92519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92533 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92536 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92538 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92545 */   // GIR_Coverage, 10429,
     /*  92545 */   GIR_EraseRootFromParent_Done,
     /*  92546 */ // Label 1691: @92546
     /*  92546 */ GIM_Reject,
     /*  92547 */ // Label 1412: @92547
     /*  92547 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92579), // Rule ID 10390 //
     /*  92552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92566 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92569 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92571 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92573 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92578 */   // GIR_Coverage, 10390,
     /*  92578 */   GIR_EraseRootFromParent_Done,
     /*  92579 */ // Label 1692: @92579
     /*  92579 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92611), // Rule ID 10391 //
     /*  92584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92598 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92601 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92603 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92610 */   // GIR_Coverage, 10391,
     /*  92610 */   GIR_EraseRootFromParent_Done,
     /*  92611 */ // Label 1693: @92611
     /*  92611 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92643), // Rule ID 10392 //
     /*  92616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92630 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92633 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92635 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92642 */   // GIR_Coverage, 10392,
     /*  92642 */   GIR_EraseRootFromParent_Done,
     /*  92643 */ // Label 1694: @92643
     /*  92643 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92675), // Rule ID 10393 //
     /*  92648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92662 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92665 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92674 */   // GIR_Coverage, 10393,
     /*  92674 */   GIR_EraseRootFromParent_Done,
     /*  92675 */ // Label 1695: @92675
     /*  92675 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92707), // Rule ID 10394 //
     /*  92680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92694 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92697 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92699 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92706 */   // GIR_Coverage, 10394,
     /*  92706 */   GIR_EraseRootFromParent_Done,
     /*  92707 */ // Label 1696: @92707
     /*  92707 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92739), // Rule ID 10395 //
     /*  92712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92726 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92729 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92731 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92738 */   // GIR_Coverage, 10395,
     /*  92738 */   GIR_EraseRootFromParent_Done,
     /*  92739 */ // Label 1697: @92739
     /*  92739 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92771), // Rule ID 10408 //
     /*  92744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92758 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92761 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92763 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92770 */   // GIR_Coverage, 10408,
     /*  92770 */   GIR_EraseRootFromParent_Done,
     /*  92771 */ // Label 1698: @92771
     /*  92771 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92803), // Rule ID 10409 //
     /*  92776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92790 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92802 */   // GIR_Coverage, 10409,
     /*  92802 */   GIR_EraseRootFromParent_Done,
     /*  92803 */ // Label 1699: @92803
     /*  92803 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92835), // Rule ID 10410 //
     /*  92808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92822 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92834 */   // GIR_Coverage, 10410,
     /*  92834 */   GIR_EraseRootFromParent_Done,
     /*  92835 */ // Label 1700: @92835
     /*  92835 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92867), // Rule ID 10411 //
     /*  92840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92854 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92866 */   // GIR_Coverage, 10411,
     /*  92866 */   GIR_EraseRootFromParent_Done,
     /*  92867 */ // Label 1701: @92867
     /*  92867 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(92899), // Rule ID 10412 //
     /*  92872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92886 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92898 */   // GIR_Coverage, 10412,
     /*  92898 */   GIR_EraseRootFromParent_Done,
     /*  92899 */ // Label 1702: @92899
     /*  92899 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(92931), // Rule ID 10413 //
     /*  92904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92918 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92930 */   // GIR_Coverage, 10413,
     /*  92930 */   GIR_EraseRootFromParent_Done,
     /*  92931 */ // Label 1703: @92931
     /*  92931 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(92963), // Rule ID 10426 //
     /*  92936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92950 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92962 */   // GIR_Coverage, 10426,
     /*  92962 */   GIR_EraseRootFromParent_Done,
     /*  92963 */ // Label 1704: @92963
     /*  92963 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(92995), // Rule ID 10427 //
     /*  92968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92982 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92994 */   // GIR_Coverage, 10427,
     /*  92994 */   GIR_EraseRootFromParent_Done,
     /*  92995 */ // Label 1705: @92995
     /*  92995 */ GIM_Reject,
     /*  92996 */ // Label 1413: @92996
     /*  92996 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93028), // Rule ID 10384 //
     /*  93001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93015 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93018 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93020 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93027 */   // GIR_Coverage, 10384,
     /*  93027 */   GIR_EraseRootFromParent_Done,
     /*  93028 */ // Label 1706: @93028
     /*  93028 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93060), // Rule ID 10385 //
     /*  93033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93047 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93050 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93059 */   // GIR_Coverage, 10385,
     /*  93059 */   GIR_EraseRootFromParent_Done,
     /*  93060 */ // Label 1707: @93060
     /*  93060 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93092), // Rule ID 10386 //
     /*  93065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93079 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93091 */   // GIR_Coverage, 10386,
     /*  93091 */   GIR_EraseRootFromParent_Done,
     /*  93092 */ // Label 1708: @93092
     /*  93092 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93124), // Rule ID 10387 //
     /*  93097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93111 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93114 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93116 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93118 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93123 */   // GIR_Coverage, 10387,
     /*  93123 */   GIR_EraseRootFromParent_Done,
     /*  93124 */ // Label 1709: @93124
     /*  93124 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93156), // Rule ID 10388 //
     /*  93129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93143 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93146 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93148 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93155 */   // GIR_Coverage, 10388,
     /*  93155 */   GIR_EraseRootFromParent_Done,
     /*  93156 */ // Label 1710: @93156
     /*  93156 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93188), // Rule ID 10389 //
     /*  93161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93175 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93178 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93180 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93187 */   // GIR_Coverage, 10389,
     /*  93187 */   GIR_EraseRootFromParent_Done,
     /*  93188 */ // Label 1711: @93188
     /*  93188 */ GIM_Reject,
     /*  93189 */ // Label 1414: @93189
     /*  93189 */ GIM_Reject,
     /*  93190 */ // Label 10: @93190
     /*  93190 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1720*/ GIMT_Encode4(93680),
     /*  93201 */ /*GILLT_s16*//*Label 1712*/ GIMT_Encode4(93241),
     /*  93205 */ /*GILLT_s32*//*Label 1713*/ GIMT_Encode4(93272),
     /*  93209 */ /*GILLT_s64*//*Label 1714*/ GIMT_Encode4(93303), GIMT_Encode4(0),
     /*  93217 */ /*GILLT_v2s32*//*Label 1715*/ GIMT_Encode4(93334),
     /*  93221 */ /*GILLT_v2s64*//*Label 1716*/ GIMT_Encode4(93365),
     /*  93225 */ /*GILLT_v4s16*//*Label 1717*/ GIMT_Encode4(93396),
     /*  93229 */ /*GILLT_v4s32*//*Label 1718*/ GIMT_Encode4(93427), GIMT_Encode4(0),
     /*  93237 */ /*GILLT_v8s16*//*Label 1719*/ GIMT_Encode4(93458),
     /*  93241 */ // Label 1712: @93241
     /*  93241 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(93271), // Rule ID 564 //
     /*  93246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93260 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  93265 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93269 */   GIR_RootConstrainSelectedInstOperands,
     /*  93270 */   // GIR_Coverage, 564,
     /*  93270 */   GIR_Done,
     /*  93271 */ // Label 1721: @93271
     /*  93271 */ GIM_Reject,
     /*  93272 */ // Label 1713: @93272
     /*  93272 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(93302), // Rule ID 566 //
     /*  93277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93291 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  93296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93300 */   GIR_RootConstrainSelectedInstOperands,
     /*  93301 */   // GIR_Coverage, 566,
     /*  93301 */   GIR_Done,
     /*  93302 */ // Label 1722: @93302
     /*  93302 */ GIM_Reject,
     /*  93303 */ // Label 1714: @93303
     /*  93303 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(93333), // Rule ID 568 //
     /*  93308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93322 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  93327 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93331 */   GIR_RootConstrainSelectedInstOperands,
     /*  93332 */   // GIR_Coverage, 568,
     /*  93332 */   GIR_Done,
     /*  93333 */ // Label 1723: @93333
     /*  93333 */ GIM_Reject,
     /*  93334 */ // Label 1715: @93334
     /*  93334 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(93364), // Rule ID 926 //
     /*  93339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93353 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  93358 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93362 */   GIR_RootConstrainSelectedInstOperands,
     /*  93363 */   // GIR_Coverage, 926,
     /*  93363 */   GIR_Done,
     /*  93364 */ // Label 1724: @93364
     /*  93364 */ GIM_Reject,
     /*  93365 */ // Label 1716: @93365
     /*  93365 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(93395), // Rule ID 930 //
     /*  93370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93384 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  93389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93393 */   GIR_RootConstrainSelectedInstOperands,
     /*  93394 */   // GIR_Coverage, 930,
     /*  93394 */   GIR_Done,
     /*  93395 */ // Label 1725: @93395
     /*  93395 */ GIM_Reject,
     /*  93396 */ // Label 1717: @93396
     /*  93396 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(93426), // Rule ID 922 //
     /*  93401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93415 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  93420 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93424 */   GIR_RootConstrainSelectedInstOperands,
     /*  93425 */   // GIR_Coverage, 922,
     /*  93425 */   GIR_Done,
     /*  93426 */ // Label 1726: @93426
     /*  93426 */ GIM_Reject,
     /*  93427 */ // Label 1718: @93427
     /*  93427 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(93457), // Rule ID 928 //
     /*  93432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93446 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93455 */   GIR_RootConstrainSelectedInstOperands,
     /*  93456 */   // GIR_Coverage, 928,
     /*  93456 */   GIR_Done,
     /*  93457 */ // Label 1727: @93457
     /*  93457 */ GIM_Reject,
     /*  93458 */ // Label 1719: @93458
     /*  93458 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(93679),
     /*  93463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93474 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(93493), // Rule ID 924 //
     /*  93479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93482 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  93487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93491 */     GIR_RootConstrainSelectedInstOperands,
     /*  93492 */     // GIR_Coverage, 924,
     /*  93492 */     GIR_Done,
     /*  93493 */   // Label 1729: @93493
     /*  93493 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(93678), // Rule ID 6912 //
     /*  93498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  93501 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  93501 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  93504 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  93508 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93513 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  93517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  93519 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  93522 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93526 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93531 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  93534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  93536 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  93539 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93543 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93548 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  93554 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93559 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93564 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  93567 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  93571 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93576 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  93579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  93581 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  93584 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93588 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93593 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  93596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  93598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  93601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  93605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93610 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  93613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  93622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  93636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93641 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93644 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  93647 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  93650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  93668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  93676 */     GIR_RootConstrainSelectedInstOperands,
     /*  93677 */     // GIR_Coverage, 6912,
     /*  93677 */     GIR_EraseRootFromParent_Done,
     /*  93678 */   // Label 1730: @93678
     /*  93678 */   GIM_Reject,
     /*  93679 */ // Label 1728: @93679
     /*  93679 */ GIM_Reject,
     /*  93680 */ // Label 1720: @93680
     /*  93680 */ GIM_Reject,
     /*  93681 */ // Label 11: @93681
     /*  93681 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1739*/ GIMT_Encode4(94171),
     /*  93692 */ /*GILLT_s16*//*Label 1731*/ GIMT_Encode4(93732),
     /*  93696 */ /*GILLT_s32*//*Label 1732*/ GIMT_Encode4(93763),
     /*  93700 */ /*GILLT_s64*//*Label 1733*/ GIMT_Encode4(93794), GIMT_Encode4(0),
     /*  93708 */ /*GILLT_v2s32*//*Label 1734*/ GIMT_Encode4(93825),
     /*  93712 */ /*GILLT_v2s64*//*Label 1735*/ GIMT_Encode4(93856),
     /*  93716 */ /*GILLT_v4s16*//*Label 1736*/ GIMT_Encode4(93887),
     /*  93720 */ /*GILLT_v4s32*//*Label 1737*/ GIMT_Encode4(93918), GIMT_Encode4(0),
     /*  93728 */ /*GILLT_v8s16*//*Label 1738*/ GIMT_Encode4(93949),
     /*  93732 */ // Label 1731: @93732
     /*  93732 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(93762), // Rule ID 528 //
     /*  93737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93751 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  93756 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93760 */   GIR_RootConstrainSelectedInstOperands,
     /*  93761 */   // GIR_Coverage, 528,
     /*  93761 */   GIR_Done,
     /*  93762 */ // Label 1740: @93762
     /*  93762 */ GIM_Reject,
     /*  93763 */ // Label 1732: @93763
     /*  93763 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(93793), // Rule ID 530 //
     /*  93768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93782 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  93787 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93791 */   GIR_RootConstrainSelectedInstOperands,
     /*  93792 */   // GIR_Coverage, 530,
     /*  93792 */   GIR_Done,
     /*  93793 */ // Label 1741: @93793
     /*  93793 */ GIM_Reject,
     /*  93794 */ // Label 1733: @93794
     /*  93794 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(93824), // Rule ID 532 //
     /*  93799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93813 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  93818 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93822 */   GIR_RootConstrainSelectedInstOperands,
     /*  93823 */   // GIR_Coverage, 532,
     /*  93823 */   GIR_Done,
     /*  93824 */ // Label 1742: @93824
     /*  93824 */ GIM_Reject,
     /*  93825 */ // Label 1734: @93825
     /*  93825 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(93855), // Rule ID 866 //
     /*  93830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93844 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  93849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93853 */   GIR_RootConstrainSelectedInstOperands,
     /*  93854 */   // GIR_Coverage, 866,
     /*  93854 */   GIR_Done,
     /*  93855 */ // Label 1743: @93855
     /*  93855 */ GIM_Reject,
     /*  93856 */ // Label 1735: @93856
     /*  93856 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(93886), // Rule ID 870 //
     /*  93861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93875 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  93880 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93884 */   GIR_RootConstrainSelectedInstOperands,
     /*  93885 */   // GIR_Coverage, 870,
     /*  93885 */   GIR_Done,
     /*  93886 */ // Label 1744: @93886
     /*  93886 */ GIM_Reject,
     /*  93887 */ // Label 1736: @93887
     /*  93887 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(93917), // Rule ID 862 //
     /*  93892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93906 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  93911 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93915 */   GIR_RootConstrainSelectedInstOperands,
     /*  93916 */   // GIR_Coverage, 862,
     /*  93916 */   GIR_Done,
     /*  93917 */ // Label 1745: @93917
     /*  93917 */ GIM_Reject,
     /*  93918 */ // Label 1737: @93918
     /*  93918 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(93948), // Rule ID 868 //
     /*  93923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93937 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  93942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93946 */   GIR_RootConstrainSelectedInstOperands,
     /*  93947 */   // GIR_Coverage, 868,
     /*  93947 */   GIR_Done,
     /*  93948 */ // Label 1746: @93948
     /*  93948 */ GIM_Reject,
     /*  93949 */ // Label 1738: @93949
     /*  93949 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(94170),
     /*  93954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93965 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(93984), // Rule ID 864 //
     /*  93970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93973 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  93978 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93982 */     GIR_RootConstrainSelectedInstOperands,
     /*  93983 */     // GIR_Coverage, 864,
     /*  93983 */     GIR_Done,
     /*  93984 */   // Label 1748: @93984
     /*  93984 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(94169), // Rule ID 6906 //
     /*  93989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  93992 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  93992 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  93995 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  93999 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94004 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94010 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94013 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94017 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94022 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94027 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94030 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94034 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94039 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94045 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94050 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94055 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94058 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94062 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94067 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94072 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  94075 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94079 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94084 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  94087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  94089 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  94092 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  94096 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94101 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  94104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  94113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  94127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  94141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  94159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  94167 */     GIR_RootConstrainSelectedInstOperands,
     /*  94168 */     // GIR_Coverage, 6906,
     /*  94168 */     GIR_EraseRootFromParent_Done,
     /*  94169 */   // Label 1749: @94169
     /*  94169 */   GIM_Reject,
     /*  94170 */ // Label 1747: @94170
     /*  94170 */ GIM_Reject,
     /*  94171 */ // Label 1739: @94171
     /*  94171 */ GIM_Reject,
     /*  94172 */ // Label 12: @94172
     /*  94172 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1752*/ GIMT_Encode4(94439),
     /*  94183 */ /*GILLT_s32*//*Label 1750*/ GIMT_Encode4(94191),
     /*  94187 */ /*GILLT_s64*//*Label 1751*/ GIMT_Encode4(94315),
     /*  94191 */ // Label 1750: @94191
     /*  94191 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(94234), // Rule ID 4725 //
     /*  94196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94206 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94218 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  94227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94232 */   GIR_RootConstrainSelectedInstOperands,
     /*  94233 */   // GIR_Coverage, 4725,
     /*  94233 */   GIR_EraseRootFromParent_Done,
     /*  94234 */ // Label 1753: @94234
     /*  94234 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(94274), // Rule ID 4731 //
     /*  94239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94246 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94258 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  94267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94272 */   GIR_RootConstrainSelectedInstOperands,
     /*  94273 */   // GIR_Coverage, 4731,
     /*  94273 */   GIR_EraseRootFromParent_Done,
     /*  94274 */ // Label 1754: @94274
     /*  94274 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(94314), // Rule ID 4733 //
     /*  94279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94286 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  94307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94312 */   GIR_RootConstrainSelectedInstOperands,
     /*  94313 */   // GIR_Coverage, 4733,
     /*  94313 */   GIR_EraseRootFromParent_Done,
     /*  94314 */ // Label 1755: @94314
     /*  94314 */ GIM_Reject,
     /*  94315 */ // Label 1751: @94315
     /*  94315 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(94358), // Rule ID 4727 //
     /*  94320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94330 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94342 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94356 */   GIR_RootConstrainSelectedInstOperands,
     /*  94357 */   // GIR_Coverage, 4727,
     /*  94357 */   GIR_EraseRootFromParent_Done,
     /*  94358 */ // Label 1756: @94358
     /*  94358 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(94398), // Rule ID 4735 //
     /*  94363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94370 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94396 */   GIR_RootConstrainSelectedInstOperands,
     /*  94397 */   // GIR_Coverage, 4735,
     /*  94397 */   GIR_EraseRootFromParent_Done,
     /*  94398 */ // Label 1757: @94398
     /*  94398 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(94438), // Rule ID 4737 //
     /*  94403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94410 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94422 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94436 */   GIR_RootConstrainSelectedInstOperands,
     /*  94437 */   // GIR_Coverage, 4737,
     /*  94437 */   GIR_EraseRootFromParent_Done,
     /*  94438 */ // Label 1758: @94438
     /*  94438 */ GIM_Reject,
     /*  94439 */ // Label 1752: @94439
     /*  94439 */ GIM_Reject,
     /*  94440 */ // Label 13: @94440
     /*  94440 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(94589),
     /*  94445 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94448 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1763*/ GIMT_Encode4(94588),
     /*  94459 */   /*GILLT_s16*//*Label 1760*/ GIMT_Encode4(94471),
     /*  94463 */   /*GILLT_s32*//*Label 1761*/ GIMT_Encode4(94512),
     /*  94467 */   /*GILLT_s64*//*Label 1762*/ GIMT_Encode4(94550),
     /*  94471 */   // Label 1760: @94471
     /*  94471 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(94511), // Rule ID 4729 //
     /*  94476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94483 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94509 */     GIR_RootConstrainSelectedInstOperands,
     /*  94510 */     // GIR_Coverage, 4729,
     /*  94510 */     GIR_EraseRootFromParent_Done,
     /*  94511 */   // Label 1764: @94511
     /*  94511 */   GIM_Reject,
     /*  94512 */   // Label 1761: @94512
     /*  94512 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(94549), // Rule ID 4739 //
     /*  94517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94521 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94547 */     GIR_RootConstrainSelectedInstOperands,
     /*  94548 */     // GIR_Coverage, 4739,
     /*  94548 */     GIR_EraseRootFromParent_Done,
     /*  94549 */   // Label 1765: @94549
     /*  94549 */   GIM_Reject,
     /*  94550 */   // Label 1762: @94550
     /*  94550 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(94587), // Rule ID 4741 //
     /*  94555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94559 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94585 */     GIR_RootConstrainSelectedInstOperands,
     /*  94586 */     // GIR_Coverage, 4741,
     /*  94586 */     GIR_EraseRootFromParent_Done,
     /*  94587 */   // Label 1766: @94587
     /*  94587 */   GIM_Reject,
     /*  94588 */   // Label 1763: @94588
     /*  94588 */   GIM_Reject,
     /*  94589 */ // Label 1759: @94589
     /*  94589 */ GIM_Reject,
     /*  94590 */ // Label 14: @94590
     /*  94590 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1775*/ GIMT_Encode4(95080),
     /*  94601 */ /*GILLT_s16*//*Label 1767*/ GIMT_Encode4(94641),
     /*  94605 */ /*GILLT_s32*//*Label 1768*/ GIMT_Encode4(94672),
     /*  94609 */ /*GILLT_s64*//*Label 1769*/ GIMT_Encode4(94703), GIMT_Encode4(0),
     /*  94617 */ /*GILLT_v2s32*//*Label 1770*/ GIMT_Encode4(94734),
     /*  94621 */ /*GILLT_v2s64*//*Label 1771*/ GIMT_Encode4(94765),
     /*  94625 */ /*GILLT_v4s16*//*Label 1772*/ GIMT_Encode4(94796),
     /*  94629 */ /*GILLT_v4s32*//*Label 1773*/ GIMT_Encode4(94827), GIMT_Encode4(0),
     /*  94637 */ /*GILLT_v8s16*//*Label 1774*/ GIMT_Encode4(94858),
     /*  94641 */ // Label 1767: @94641
     /*  94641 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(94671), // Rule ID 546 //
     /*  94646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94660 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  94660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  94665 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94669 */   GIR_RootConstrainSelectedInstOperands,
     /*  94670 */   // GIR_Coverage, 546,
     /*  94670 */   GIR_Done,
     /*  94671 */ // Label 1776: @94671
     /*  94671 */ GIM_Reject,
     /*  94672 */ // Label 1768: @94672
     /*  94672 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(94702), // Rule ID 548 //
     /*  94677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94691 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  94691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  94696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94700 */   GIR_RootConstrainSelectedInstOperands,
     /*  94701 */   // GIR_Coverage, 548,
     /*  94701 */   GIR_Done,
     /*  94702 */ // Label 1777: @94702
     /*  94702 */ GIM_Reject,
     /*  94703 */ // Label 1769: @94703
     /*  94703 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(94733), // Rule ID 550 //
     /*  94708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94722 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  94722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  94727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94731 */   GIR_RootConstrainSelectedInstOperands,
     /*  94732 */   // GIR_Coverage, 550,
     /*  94732 */   GIR_Done,
     /*  94733 */ // Label 1778: @94733
     /*  94733 */ GIM_Reject,
     /*  94734 */ // Label 1770: @94734
     /*  94734 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(94764), // Rule ID 896 //
     /*  94739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94753 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  94753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  94758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94762 */   GIR_RootConstrainSelectedInstOperands,
     /*  94763 */   // GIR_Coverage, 896,
     /*  94763 */   GIR_Done,
     /*  94764 */ // Label 1779: @94764
     /*  94764 */ GIM_Reject,
     /*  94765 */ // Label 1771: @94765
     /*  94765 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(94795), // Rule ID 900 //
     /*  94770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94784 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  94784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  94789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94793 */   GIR_RootConstrainSelectedInstOperands,
     /*  94794 */   // GIR_Coverage, 900,
     /*  94794 */   GIR_Done,
     /*  94795 */ // Label 1780: @94795
     /*  94795 */ GIM_Reject,
     /*  94796 */ // Label 1772: @94796
     /*  94796 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(94826), // Rule ID 892 //
     /*  94801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94815 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  94815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  94820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94824 */   GIR_RootConstrainSelectedInstOperands,
     /*  94825 */   // GIR_Coverage, 892,
     /*  94825 */   GIR_Done,
     /*  94826 */ // Label 1781: @94826
     /*  94826 */ GIM_Reject,
     /*  94827 */ // Label 1773: @94827
     /*  94827 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(94857), // Rule ID 898 //
     /*  94832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94846 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  94846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94855 */   GIR_RootConstrainSelectedInstOperands,
     /*  94856 */   // GIR_Coverage, 898,
     /*  94856 */   GIR_Done,
     /*  94857 */ // Label 1782: @94857
     /*  94857 */ GIM_Reject,
     /*  94858 */ // Label 1774: @94858
     /*  94858 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(95079),
     /*  94863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94874 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(94893), // Rule ID 894 //
     /*  94879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94882 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  94882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  94887 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94891 */     GIR_RootConstrainSelectedInstOperands,
     /*  94892 */     // GIR_Coverage, 894,
     /*  94892 */     GIR_Done,
     /*  94893 */   // Label 1784: @94893
     /*  94893 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(95078), // Rule ID 6908 //
     /*  94898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94901 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94901 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94904 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94908 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94913 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94919 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94922 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94926 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94931 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94936 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94939 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94943 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94948 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94954 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94959 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94964 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94967 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94971 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94976 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94981 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  94984 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94988 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94993 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  94996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  94998 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  95001 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  95005 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95010 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  95013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  95022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  95036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95047 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  95050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  95065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  95068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  95076 */     GIR_RootConstrainSelectedInstOperands,
     /*  95077 */     // GIR_Coverage, 6908,
     /*  95077 */     GIR_EraseRootFromParent_Done,
     /*  95078 */   // Label 1785: @95078
     /*  95078 */   GIM_Reject,
     /*  95079 */ // Label 1783: @95079
     /*  95079 */ GIM_Reject,
     /*  95080 */ // Label 1775: @95080
     /*  95080 */ GIM_Reject,
     /*  95081 */ // Label 15: @95081
     /*  95081 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(95113), // Rule ID 3846 //
     /*  95086 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  95089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  95093 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  95093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  95096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95098 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  95108 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  95111 */   GIR_RootConstrainSelectedInstOperands,
     /*  95112 */   // GIR_Coverage, 3846,
     /*  95112 */   GIR_EraseRootFromParent_Done,
     /*  95113 */ // Label 1786: @95113
     /*  95113 */ GIM_Reject,
     /*  95114 */ // Label 16: @95114
     /*  95114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1807*/ GIMT_Encode4(103709),
     /*  95125 */ /*GILLT_s8*//*Label 1787*/ GIMT_Encode4(95221),
     /*  95129 */ /*GILLT_s16*//*Label 1788*/ GIMT_Encode4(95397),
     /*  95133 */ /*GILLT_s32*//*Label 1789*/ GIMT_Encode4(95573),
     /*  95137 */ /*GILLT_s64*//*Label 1790*/ GIMT_Encode4(97871),
     /*  95141 */ /*GILLT_s128*//*Label 1791*/ GIMT_Encode4(100552),
     /*  95145 */ /*GILLT_v2s32*//*Label 1792*/ GIMT_Encode4(100761),
     /*  95149 */ /*GILLT_v2s64*//*Label 1793*/ GIMT_Encode4(101139),
     /*  95153 */ /*GILLT_v4s16*//*Label 1794*/ GIMT_Encode4(101517),
     /*  95157 */ /*GILLT_v4s32*//*Label 1795*/ GIMT_Encode4(101895),
     /*  95161 */ /*GILLT_v8s8*//*Label 1796*/ GIMT_Encode4(102273),
     /*  95165 */ /*GILLT_v8s16*//*Label 1797*/ GIMT_Encode4(102481),
     /*  95169 */ /*GILLT_v16s8*//*Label 1798*/ GIMT_Encode4(102859), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  95181 */ /*GILLT_nxv2s16*//*Label 1799*/ GIMT_Encode4(103067),
     /*  95185 */ /*GILLT_nxv2s32*//*Label 1800*/ GIMT_Encode4(103131),
     /*  95189 */ /*GILLT_nxv2s64*//*Label 1801*/ GIMT_Encode4(103195), GIMT_Encode4(0),
     /*  95197 */ /*GILLT_nxv4s16*//*Label 1802*/ GIMT_Encode4(103309),
     /*  95201 */ /*GILLT_nxv4s32*//*Label 1803*/ GIMT_Encode4(103373), GIMT_Encode4(0),
     /*  95209 */ /*GILLT_nxv8s16*//*Label 1804*/ GIMT_Encode4(103487),
     /*  95213 */ /*GILLT_nxv16s1*//*Label 1805*/ GIMT_Encode4(103601),
     /*  95217 */ /*GILLT_nxv16s8*//*Label 1806*/ GIMT_Encode4(103645),
     /*  95221 */ // Label 1787: @95221
     /*  95221 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(95396),
     /*  95226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  95237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95241 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(95282), // Rule ID 237 //
     /*  95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95256 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  95259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95280 */     GIR_RootConstrainSelectedInstOperands,
     /*  95281 */     // GIR_Coverage, 237,
     /*  95281 */     GIR_EraseRootFromParent_Done,
     /*  95282 */   // Label 1809: @95282
     /*  95282 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(95323), // Rule ID 238 //
     /*  95287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95297 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  95300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95321 */     GIR_RootConstrainSelectedInstOperands,
     /*  95322 */     // GIR_Coverage, 238,
     /*  95322 */     GIR_EraseRootFromParent_Done,
     /*  95323 */   // Label 1810: @95323
     /*  95323 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(95359), // Rule ID 261 //
     /*  95328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  95338 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  95338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  95341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95357 */     GIR_RootConstrainSelectedInstOperands,
     /*  95358 */     // GIR_Coverage, 261,
     /*  95358 */     GIR_EraseRootFromParent_Done,
     /*  95359 */   // Label 1811: @95359
     /*  95359 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(95395), // Rule ID 282 //
     /*  95364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  95374 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  95377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95393 */     GIR_RootConstrainSelectedInstOperands,
     /*  95394 */     // GIR_Coverage, 282,
     /*  95394 */     GIR_EraseRootFromParent_Done,
     /*  95395 */   // Label 1812: @95395
     /*  95395 */   GIM_Reject,
     /*  95396 */ // Label 1808: @95396
     /*  95396 */ GIM_Reject,
     /*  95397 */ // Label 1788: @95397
     /*  95397 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(95572),
     /*  95402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  95413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95417 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(95458), // Rule ID 239 //
     /*  95422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95432 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  95435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95456 */     GIR_RootConstrainSelectedInstOperands,
     /*  95457 */     // GIR_Coverage, 239,
     /*  95457 */     GIR_EraseRootFromParent_Done,
     /*  95458 */   // Label 1814: @95458
     /*  95458 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(95499), // Rule ID 240 //
     /*  95463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  95473 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  95473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  95476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95497 */     GIR_RootConstrainSelectedInstOperands,
     /*  95498 */     // GIR_Coverage, 240,
     /*  95498 */     GIR_EraseRootFromParent_Done,
     /*  95499 */   // Label 1815: @95499
     /*  95499 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(95535), // Rule ID 262 //
     /*  95504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  95514 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  95514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  95517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95533 */     GIR_RootConstrainSelectedInstOperands,
     /*  95534 */     // GIR_Coverage, 262,
     /*  95534 */     GIR_EraseRootFromParent_Done,
     /*  95535 */   // Label 1816: @95535
     /*  95535 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(95571), // Rule ID 283 //
     /*  95540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  95550 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  95553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95569 */     GIR_RootConstrainSelectedInstOperands,
     /*  95570 */     // GIR_Coverage, 283,
     /*  95570 */     GIR_EraseRootFromParent_Done,
     /*  95571 */   // Label 1817: @95571
     /*  95571 */   GIM_Reject,
     /*  95572 */ // Label 1813: @95572
     /*  95572 */ GIM_Reject,
     /*  95573 */ // Label 1789: @95573
     /*  95573 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(95626), // Rule ID 233 //
     /*  95578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95600 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  95603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95624 */   GIR_RootConstrainSelectedInstOperands,
     /*  95625 */   // GIR_Coverage, 233,
     /*  95625 */   GIR_EraseRootFromParent_Done,
     /*  95626 */ // Label 1818: @95626
     /*  95626 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(95679), // Rule ID 234 //
     /*  95631 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95634 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95653 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  95656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95677 */   GIR_RootConstrainSelectedInstOperands,
     /*  95678 */   // GIR_Coverage, 234,
     /*  95678 */   GIR_EraseRootFromParent_Done,
     /*  95679 */ // Label 1819: @95679
     /*  95679 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(95735), // Rule ID 241 //
     /*  95684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95690 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95698 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95709 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  95712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95733 */   GIR_RootConstrainSelectedInstOperands,
     /*  95734 */   // GIR_Coverage, 241,
     /*  95734 */   GIR_EraseRootFromParent_Done,
     /*  95735 */ // Label 1820: @95735
     /*  95735 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(95791), // Rule ID 242 //
     /*  95740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95765 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  95768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95789 */   GIR_RootConstrainSelectedInstOperands,
     /*  95790 */   // GIR_Coverage, 242,
     /*  95790 */   GIR_EraseRootFromParent_Done,
     /*  95791 */ // Label 1821: @95791
     /*  95791 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(95851), // Rule ID 4062 //
     /*  95796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95799 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95818 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95825 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  95828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95849 */   GIR_RootConstrainSelectedInstOperands,
     /*  95850 */   // GIR_Coverage, 4062,
     /*  95850 */   GIR_EraseRootFromParent_Done,
     /*  95851 */ // Label 1822: @95851
     /*  95851 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(95911), // Rule ID 4063 //
     /*  95856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95859 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95885 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  95888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95909 */   GIR_RootConstrainSelectedInstOperands,
     /*  95910 */   // GIR_Coverage, 4063,
     /*  95910 */   GIR_EraseRootFromParent_Done,
     /*  95911 */ // Label 1823: @95911
     /*  95911 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(95971), // Rule ID 4064 //
     /*  95916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95919 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95945 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  95948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95969 */   GIR_RootConstrainSelectedInstOperands,
     /*  95970 */   // GIR_Coverage, 4064,
     /*  95970 */   GIR_EraseRootFromParent_Done,
     /*  95971 */ // Label 1824: @95971
     /*  95971 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(96031), // Rule ID 4065 //
     /*  95976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96005 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96029 */   GIR_RootConstrainSelectedInstOperands,
     /*  96030 */   // GIR_Coverage, 4065,
     /*  96030 */   GIR_EraseRootFromParent_Done,
     /*  96031 */ // Label 1825: @96031
     /*  96031 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(96091), // Rule ID 4066 //
     /*  96036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96039 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96043 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96065 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96089 */   GIR_RootConstrainSelectedInstOperands,
     /*  96090 */   // GIR_Coverage, 4066,
     /*  96090 */   GIR_EraseRootFromParent_Done,
     /*  96091 */ // Label 1826: @96091
     /*  96091 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(96151), // Rule ID 4067 //
     /*  96096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96099 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96103 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96118 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96125 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96149 */   GIR_RootConstrainSelectedInstOperands,
     /*  96150 */   // GIR_Coverage, 4067,
     /*  96150 */   GIR_EraseRootFromParent_Done,
     /*  96151 */ // Label 1827: @96151
     /*  96151 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(96199), // Rule ID 260 //
     /*  96156 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96178 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96197 */   GIR_RootConstrainSelectedInstOperands,
     /*  96198 */   // GIR_Coverage, 260,
     /*  96198 */   GIR_EraseRootFromParent_Done,
     /*  96199 */ // Label 1828: @96199
     /*  96199 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(96250), // Rule ID 263 //
     /*  96204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96210 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96229 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  96232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96248 */   GIR_RootConstrainSelectedInstOperands,
     /*  96249 */   // GIR_Coverage, 263,
     /*  96249 */   GIR_EraseRootFromParent_Done,
     /*  96250 */ // Label 1829: @96250
     /*  96250 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(96309), // Rule ID 6932 //
     /*  96255 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96258 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96265 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96276 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  96283 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15497>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  96283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  96286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96307 */   GIR_RootConstrainSelectedInstOperands,
     /*  96308 */   // GIR_Coverage, 6932,
     /*  96308 */   GIR_EraseRootFromParent_Done,
     /*  96309 */ // Label 1830: @96309
     /*  96309 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(96368), // Rule ID 6934 //
     /*  96314 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96317 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96324 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  96342 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15497>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  96342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  96345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96366 */   GIR_RootConstrainSelectedInstOperands,
     /*  96367 */   // GIR_Coverage, 6934,
     /*  96367 */   GIR_EraseRootFromParent_Done,
     /*  96368 */ // Label 1831: @96368
     /*  96368 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(96427), // Rule ID 6944 //
     /*  96373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96383 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  96401 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15506>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  96401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  96404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96421 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96425 */   GIR_RootConstrainSelectedInstOperands,
     /*  96426 */   // GIR_Coverage, 6944,
     /*  96426 */   GIR_EraseRootFromParent_Done,
     /*  96427 */ // Label 1832: @96427
     /*  96427 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(96486), // Rule ID 6946 //
     /*  96432 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96435 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96442 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96460 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15506>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96484 */   GIR_RootConstrainSelectedInstOperands,
     /*  96485 */   // GIR_Coverage, 6946,
     /*  96485 */   GIR_EraseRootFromParent_Done,
     /*  96486 */ // Label 1833: @96486
     /*  96486 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(96545), // Rule ID 6954 //
     /*  96491 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96494 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96501 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96519 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96543 */   GIR_RootConstrainSelectedInstOperands,
     /*  96544 */   // GIR_Coverage, 6954,
     /*  96544 */   GIR_EraseRootFromParent_Done,
     /*  96545 */ // Label 1834: @96545
     /*  96545 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(96604), // Rule ID 6955 //
     /*  96550 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96553 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96560 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96578 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96602 */   GIR_RootConstrainSelectedInstOperands,
     /*  96603 */   // GIR_Coverage, 6955,
     /*  96603 */   GIR_EraseRootFromParent_Done,
     /*  96604 */ // Label 1835: @96604
     /*  96604 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(96652), // Rule ID 281 //
     /*  96609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96631 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  96634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96650 */   GIR_RootConstrainSelectedInstOperands,
     /*  96651 */   // GIR_Coverage, 281,
     /*  96651 */   GIR_EraseRootFromParent_Done,
     /*  96652 */ // Label 1836: @96652
     /*  96652 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(96703), // Rule ID 284 //
     /*  96657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96671 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96675 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96682 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  96685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96697 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96701 */   GIR_RootConstrainSelectedInstOperands,
     /*  96702 */   // GIR_Coverage, 284,
     /*  96702 */   GIR_EraseRootFromParent_Done,
     /*  96703 */ // Label 1837: @96703
     /*  96703 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(96757), // Rule ID 6936 //
     /*  96708 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96711 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96718 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96725 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96729 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  96736 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15497>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  96736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  96739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96755 */   GIR_RootConstrainSelectedInstOperands,
     /*  96756 */   // GIR_Coverage, 6936,
     /*  96756 */   GIR_EraseRootFromParent_Done,
     /*  96757 */ // Label 1838: @96757
     /*  96757 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(96811), // Rule ID 6938 //
     /*  96762 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96765 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96772 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  96790 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15497>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  96793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96809 */   GIR_RootConstrainSelectedInstOperands,
     /*  96810 */   // GIR_Coverage, 6938,
     /*  96810 */   GIR_EraseRootFromParent_Done,
     /*  96811 */ // Label 1839: @96811
     /*  96811 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(96865), // Rule ID 6948 //
     /*  96816 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96826 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  96844 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15506>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  96844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  96847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96863 */   GIR_RootConstrainSelectedInstOperands,
     /*  96864 */   // GIR_Coverage, 6948,
     /*  96864 */   GIR_EraseRootFromParent_Done,
     /*  96865 */ // Label 1840: @96865
     /*  96865 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(96919), // Rule ID 6950 //
     /*  96870 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96873 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96880 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96887 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  96898 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15506>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  96901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96917 */   GIR_RootConstrainSelectedInstOperands,
     /*  96918 */   // GIR_Coverage, 6950,
     /*  96918 */   GIR_EraseRootFromParent_Done,
     /*  96919 */ // Label 1841: @96919
     /*  96919 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(96973), // Rule ID 6956 //
     /*  96924 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96927 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96934 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96952 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96971 */   GIR_RootConstrainSelectedInstOperands,
     /*  96972 */   // GIR_Coverage, 6956,
     /*  96972 */   GIR_EraseRootFromParent_Done,
     /*  96973 */ // Label 1842: @96973
     /*  96973 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(97027), // Rule ID 6957 //
     /*  96978 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96981 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96988 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96999 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97006 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15514>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  97009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97025 */   GIR_RootConstrainSelectedInstOperands,
     /*  97026 */   // GIR_Coverage, 6957,
     /*  97026 */   GIR_EraseRootFromParent_Done,
     /*  97027 */ // Label 1843: @97027
     /*  97027 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(97084), // Rule ID 7272 //
     /*  97032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97035 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97063 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15495>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /*  97066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97078 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97082 */   GIR_RootConstrainSelectedInstOperands,
     /*  97083 */   // GIR_Coverage, 7272,
     /*  97083 */   GIR_EraseRootFromParent_Done,
     /*  97084 */ // Label 1844: @97084
     /*  97084 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(97141), // Rule ID 7274 //
     /*  97089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97092 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97095 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97102 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97109 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97113 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97120 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15504>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /*  97123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97139 */   GIR_RootConstrainSelectedInstOperands,
     /*  97140 */   // GIR_Coverage, 7274,
     /*  97140 */   GIR_EraseRootFromParent_Done,
     /*  97141 */ // Label 1845: @97141
     /*  97141 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(97198), // Rule ID 7276 //
     /*  97146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97149 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97177 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15489>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /*  97180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97196 */   GIR_RootConstrainSelectedInstOperands,
     /*  97197 */   // GIR_Coverage, 7276,
     /*  97197 */   GIR_EraseRootFromParent_Done,
     /*  97198 */ // Label 1846: @97198
     /*  97198 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(97253), // Rule ID 4089 //
     /*  97203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97206 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97210 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97221 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97225 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  97232 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  97232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  97235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97251 */   GIR_RootConstrainSelectedInstOperands,
     /*  97252 */   // GIR_Coverage, 4089,
     /*  97252 */   GIR_EraseRootFromParent_Done,
     /*  97253 */ // Label 1847: @97253
     /*  97253 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(97308), // Rule ID 4090 //
     /*  97258 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97261 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97265 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97287 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97306 */   GIR_RootConstrainSelectedInstOperands,
     /*  97307 */   // GIR_Coverage, 4090,
     /*  97307 */   GIR_EraseRootFromParent_Done,
     /*  97308 */ // Label 1848: @97308
     /*  97308 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(97363), // Rule ID 4091 //
     /*  97313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97342 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97361 */   GIR_RootConstrainSelectedInstOperands,
     /*  97362 */   // GIR_Coverage, 4091,
     /*  97362 */   GIR_EraseRootFromParent_Done,
     /*  97363 */ // Label 1849: @97363
     /*  97363 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(97418), // Rule ID 4112 //
     /*  97368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97397 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  97400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97416 */   GIR_RootConstrainSelectedInstOperands,
     /*  97417 */   // GIR_Coverage, 4112,
     /*  97417 */   GIR_EraseRootFromParent_Done,
     /*  97418 */ // Label 1850: @97418
     /*  97418 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(97473), // Rule ID 4113 //
     /*  97423 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97426 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97430 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97452 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97467 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97471 */   GIR_RootConstrainSelectedInstOperands,
     /*  97472 */   // GIR_Coverage, 4113,
     /*  97472 */   GIR_EraseRootFromParent_Done,
     /*  97473 */ // Label 1851: @97473
     /*  97473 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(97528), // Rule ID 4114 //
     /*  97478 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97481 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97500 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97507 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97526 */   GIR_RootConstrainSelectedInstOperands,
     /*  97527 */   // GIR_Coverage, 4114,
     /*  97527 */   GIR_EraseRootFromParent_Done,
     /*  97528 */ // Label 1852: @97528
     /*  97528 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(97568), // Rule ID 6924 //
     /*  97533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97553 */   // MIs[0] ptr
     /*  97553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97561 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15485>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /*  97566 */   GIR_RootConstrainSelectedInstOperands,
     /*  97567 */   // GIR_Coverage, 6924,
     /*  97567 */   GIR_Done,
     /*  97568 */ // Label 1853: @97568
     /*  97568 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(97608), // Rule ID 6925 //
     /*  97573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97576 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97579 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97586 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97593 */   // MIs[0] ptr
     /*  97593 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97601 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15487>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /*  97606 */   GIR_RootConstrainSelectedInstOperands,
     /*  97607 */   // GIR_Coverage, 6925,
     /*  97607 */   GIR_Done,
     /*  97608 */ // Label 1854: @97608
     /*  97608 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(97648), // Rule ID 6926 //
     /*  97613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97616 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97619 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97633 */   // MIs[0] ptr
     /*  97633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97641 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15489>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /*  97646 */   GIR_RootConstrainSelectedInstOperands,
     /*  97647 */   // GIR_Coverage, 6926,
     /*  97647 */   GIR_Done,
     /*  97648 */ // Label 1855: @97648
     /*  97648 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(97685), // Rule ID 6928 //
     /*  97653 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97656 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97670 */   // MIs[0] ptr
     /*  97670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97678 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15493>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97683 */   GIR_RootConstrainSelectedInstOperands,
     /*  97684 */   // GIR_Coverage, 6928,
     /*  97684 */   GIR_Done,
     /*  97685 */ // Label 1856: @97685
     /*  97685 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(97722), // Rule ID 6930 //
     /*  97690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97707 */   // MIs[0] ptr
     /*  97707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97715 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15495>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97720 */   GIR_RootConstrainSelectedInstOperands,
     /*  97721 */   // GIR_Coverage, 6930,
     /*  97721 */   GIR_Done,
     /*  97722 */ // Label 1857: @97722
     /*  97722 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(97759), // Rule ID 6940 //
     /*  97727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97744 */   // MIs[0] ptr
     /*  97744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97752 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15502>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97757 */   GIR_RootConstrainSelectedInstOperands,
     /*  97758 */   // GIR_Coverage, 6940,
     /*  97758 */   GIR_Done,
     /*  97759 */ // Label 1858: @97759
     /*  97759 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(97796), // Rule ID 6942 //
     /*  97764 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97767 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97774 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97781 */   // MIs[0] ptr
     /*  97781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97789 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15504>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97794 */   GIR_RootConstrainSelectedInstOperands,
     /*  97795 */   // GIR_Coverage, 6942,
     /*  97795 */   GIR_Done,
     /*  97796 */ // Label 1859: @97796
     /*  97796 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(97833), // Rule ID 6952 //
     /*  97801 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97818 */   // MIs[0] ptr
     /*  97818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97826 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15511>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97831 */   GIR_RootConstrainSelectedInstOperands,
     /*  97832 */   // GIR_Coverage, 6952,
     /*  97832 */   GIR_Done,
     /*  97833 */ // Label 1860: @97833
     /*  97833 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(97870), // Rule ID 6953 //
     /*  97838 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97841 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97855 */   // MIs[0] ptr
     /*  97855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97863 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15489>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97868 */   GIR_RootConstrainSelectedInstOperands,
     /*  97869 */   // GIR_Coverage, 6953,
     /*  97869 */   GIR_Done,
     /*  97870 */ // Label 1861: @97870
     /*  97870 */ GIM_Reject,
     /*  97871 */ // Label 1790: @97871
     /*  97871 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(97924), // Rule ID 235 //
     /*  97876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97887 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  97898 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  97898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  97901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97922 */   GIR_RootConstrainSelectedInstOperands,
     /*  97923 */   // GIR_Coverage, 235,
     /*  97923 */   GIR_EraseRootFromParent_Done,
     /*  97924 */ // Label 1862: @97924
     /*  97924 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(97977), // Rule ID 236 //
     /*  97929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97932 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97940 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  97951 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  97951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  97954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97975 */   GIR_RootConstrainSelectedInstOperands,
     /*  97976 */   // GIR_Coverage, 236,
     /*  97976 */   GIR_EraseRootFromParent_Done,
     /*  97977 */ // Label 1863: @97977
     /*  97977 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(98033), // Rule ID 243 //
     /*  97982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98000 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98007 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98031 */   GIR_RootConstrainSelectedInstOperands,
     /*  98032 */   // GIR_Coverage, 243,
     /*  98032 */   GIR_EraseRootFromParent_Done,
     /*  98033 */ // Label 1864: @98033
     /*  98033 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(98089), // Rule ID 244 //
     /*  98038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98063 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98087 */   GIR_RootConstrainSelectedInstOperands,
     /*  98088 */   // GIR_Coverage, 244,
     /*  98088 */   GIR_EraseRootFromParent_Done,
     /*  98089 */ // Label 1865: @98089
     /*  98089 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(98142), // Rule ID 4028 //
     /*  98094 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98097 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98105 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98109 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98116 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98140 */   GIR_RootConstrainSelectedInstOperands,
     /*  98141 */   // GIR_Coverage, 4028,
     /*  98141 */   GIR_EraseRootFromParent_Done,
     /*  98142 */ // Label 1866: @98142
     /*  98142 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(98195), // Rule ID 4029 //
     /*  98147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98169 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98193 */   GIR_RootConstrainSelectedInstOperands,
     /*  98194 */   // GIR_Coverage, 4029,
     /*  98194 */   GIR_EraseRootFromParent_Done,
     /*  98195 */ // Label 1867: @98195
     /*  98195 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(98248), // Rule ID 4030 //
     /*  98200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98203 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98222 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98246 */   GIR_RootConstrainSelectedInstOperands,
     /*  98247 */   // GIR_Coverage, 4030,
     /*  98247 */   GIR_EraseRootFromParent_Done,
     /*  98248 */ // Label 1868: @98248
     /*  98248 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(98301), // Rule ID 4031 //
     /*  98253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98275 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98299 */   GIR_RootConstrainSelectedInstOperands,
     /*  98300 */   // GIR_Coverage, 4031,
     /*  98300 */   GIR_EraseRootFromParent_Done,
     /*  98301 */ // Label 1869: @98301
     /*  98301 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(98393), // Rule ID 4054 //
     /*  98306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98309 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98335 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98362 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98392 */   // GIR_Coverage, 4054,
     /*  98392 */   GIR_EraseRootFromParent_Done,
     /*  98393 */ // Label 1870: @98393
     /*  98393 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(98485), // Rule ID 4055 //
     /*  98398 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98401 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98427 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  98434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98454 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98484 */   // GIR_Coverage, 4055,
     /*  98484 */   GIR_EraseRootFromParent_Done,
     /*  98485 */ // Label 1871: @98485
     /*  98485 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(98577), // Rule ID 4056 //
     /*  98490 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98493 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98497 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98519 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  98526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98546 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98576 */   // GIR_Coverage, 4056,
     /*  98576 */   GIR_EraseRootFromParent_Done,
     /*  98577 */ // Label 1872: @98577
     /*  98577 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(98669), // Rule ID 4057 //
     /*  98582 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98585 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  98611 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98611 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98614 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  98618 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98638 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98668 */   // GIR_Coverage, 4057,
     /*  98668 */   GIR_EraseRootFromParent_Done,
     /*  98669 */ // Label 1873: @98669
     /*  98669 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(98761), // Rule ID 4058 //
     /*  98674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98703 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  98710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98730 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98760 */   // GIR_Coverage, 4058,
     /*  98760 */   GIR_EraseRootFromParent_Done,
     /*  98761 */ // Label 1874: @98761
     /*  98761 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(98853), // Rule ID 4059 //
     /*  98766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98769 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98773 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98795 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  98802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98822 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98852 */   // GIR_Coverage, 4059,
     /*  98852 */   GIR_EraseRootFromParent_Done,
     /*  98853 */ // Label 1875: @98853
     /*  98853 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(98945), // Rule ID 4060 //
     /*  98858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98861 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98887 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98914 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98944 */   // GIR_Coverage, 4060,
     /*  98944 */   GIR_EraseRootFromParent_Done,
     /*  98945 */ // Label 1876: @98945
     /*  98945 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(99037), // Rule ID 4061 //
     /*  98950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98953 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98979 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  98986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99006 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99036 */   // GIR_Coverage, 4061,
     /*  99036 */   GIR_EraseRootFromParent_Done,
     /*  99037 */ // Label 1877: @99037
     /*  99037 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(99085), // Rule ID 259 //
     /*  99042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99045 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99064 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99083 */   GIR_RootConstrainSelectedInstOperands,
     /*  99084 */   // GIR_Coverage, 259,
     /*  99084 */   GIR_EraseRootFromParent_Done,
     /*  99085 */ // Label 1878: @99085
     /*  99085 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(99136), // Rule ID 264 //
     /*  99090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99096 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99104 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99115 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99134 */   GIR_RootConstrainSelectedInstOperands,
     /*  99135 */   // GIR_Coverage, 264,
     /*  99135 */   GIR_EraseRootFromParent_Done,
     /*  99136 */ // Label 1879: @99136
     /*  99136 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(99195), // Rule ID 6960 //
     /*  99141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99151 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  99169 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  99169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  99172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99193 */   GIR_RootConstrainSelectedInstOperands,
     /*  99194 */   // GIR_Coverage, 6960,
     /*  99194 */   GIR_EraseRootFromParent_Done,
     /*  99195 */ // Label 1880: @99195
     /*  99195 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(99254), // Rule ID 6961 //
     /*  99200 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99203 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99210 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  99228 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  99228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  99231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99252 */   GIR_RootConstrainSelectedInstOperands,
     /*  99253 */   // GIR_Coverage, 6961,
     /*  99253 */   GIR_EraseRootFromParent_Done,
     /*  99254 */ // Label 1881: @99254
     /*  99254 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(99302), // Rule ID 280 //
     /*  99259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99281 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99300 */   GIR_RootConstrainSelectedInstOperands,
     /*  99301 */   // GIR_Coverage, 280,
     /*  99301 */   GIR_EraseRootFromParent_Done,
     /*  99302 */ // Label 1882: @99302
     /*  99302 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(99353), // Rule ID 285 //
     /*  99307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99332 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  99335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99351 */   GIR_RootConstrainSelectedInstOperands,
     /*  99352 */   // GIR_Coverage, 285,
     /*  99352 */   GIR_EraseRootFromParent_Done,
     /*  99353 */ // Label 1883: @99353
     /*  99353 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(99407), // Rule ID 6962 //
     /*  99358 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99368 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99375 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99379 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99386 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99405 */   GIR_RootConstrainSelectedInstOperands,
     /*  99406 */   // GIR_Coverage, 6962,
     /*  99406 */   GIR_EraseRootFromParent_Done,
     /*  99407 */ // Label 1884: @99407
     /*  99407 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(99461), // Rule ID 6963 //
     /*  99412 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99415 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99422 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99440 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15522>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99455 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99459 */   GIR_RootConstrainSelectedInstOperands,
     /*  99460 */   // GIR_Coverage, 6963,
     /*  99460 */   GIR_EraseRootFromParent_Done,
     /*  99461 */ // Label 1885: @99461
     /*  99461 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(99518), // Rule ID 7277 //
     /*  99466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99497 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15491>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /*  99500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99516 */   GIR_RootConstrainSelectedInstOperands,
     /*  99517 */   // GIR_Coverage, 7277,
     /*  99517 */   GIR_EraseRootFromParent_Done,
     /*  99518 */ // Label 1886: @99518
     /*  99518 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(99566), // Rule ID 4075 //
     /*  99523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99545 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99564 */   GIR_RootConstrainSelectedInstOperands,
     /*  99565 */   // GIR_Coverage, 4075,
     /*  99565 */   GIR_EraseRootFromParent_Done,
     /*  99566 */ // Label 1887: @99566
     /*  99566 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(99614), // Rule ID 4076 //
     /*  99571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99574 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99582 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99586 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99593 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99612 */   GIR_RootConstrainSelectedInstOperands,
     /*  99613 */   // GIR_Coverage, 4076,
     /*  99613 */   GIR_EraseRootFromParent_Done,
     /*  99614 */ // Label 1888: @99614
     /*  99614 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(99701), // Rule ID 4092 //
     /*  99619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99622 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99626 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99641 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99648 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99670 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99700 */   // GIR_Coverage, 4092,
     /*  99700 */   GIR_EraseRootFromParent_Done,
     /*  99701 */ // Label 1889: @99701
     /*  99701 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(99788), // Rule ID 4093 //
     /*  99706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99709 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99724 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99728 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99735 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  99742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99757 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99787 */   // GIR_Coverage, 4093,
     /*  99787 */   GIR_EraseRootFromParent_Done,
     /*  99788 */ // Label 1890: @99788
     /*  99788 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(99875), // Rule ID 4094 //
     /*  99793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99796 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99800 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99815 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99822 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99844 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99874 */   // GIR_Coverage, 4094,
     /*  99874 */   GIR_EraseRootFromParent_Done,
     /*  99875 */ // Label 1891: @99875
     /*  99875 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(99962), // Rule ID 4095 //
     /*  99880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99883 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99902 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99909 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99931 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99951 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99956 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99961 */   // GIR_Coverage, 4095,
     /*  99961 */   GIR_EraseRootFromParent_Done,
     /*  99962 */ // Label 1892: @99962
     /*  99962 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(100010), // Rule ID 4103 //
     /*  99967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99989 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  99992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100008 */   GIR_RootConstrainSelectedInstOperands,
     /* 100009 */   // GIR_Coverage, 4103,
     /* 100009 */   GIR_EraseRootFromParent_Done,
     /* 100010 */ // Label 1893: @100010
     /* 100010 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(100058), // Rule ID 4104 //
     /* 100015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100037 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100056 */   GIR_RootConstrainSelectedInstOperands,
     /* 100057 */   // GIR_Coverage, 4104,
     /* 100057 */   GIR_EraseRootFromParent_Done,
     /* 100058 */ // Label 1894: @100058
     /* 100058 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(100145), // Rule ID 4115 //
     /* 100063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100066 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100070 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100081 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100085 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100092 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100114 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100144 */   // GIR_Coverage, 4115,
     /* 100144 */   GIR_EraseRootFromParent_Done,
     /* 100145 */ // Label 1895: @100145
     /* 100145 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(100232), // Rule ID 4116 //
     /* 100150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100153 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100157 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100179 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100201 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100231 */   // GIR_Coverage, 4116,
     /* 100231 */   GIR_EraseRootFromParent_Done,
     /* 100232 */ // Label 1896: @100232
     /* 100232 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(100319), // Rule ID 4117 //
     /* 100237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100240 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100266 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100288 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100313 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100318 */   // GIR_Coverage, 4117,
     /* 100318 */   GIR_EraseRootFromParent_Done,
     /* 100319 */ // Label 1897: @100319
     /* 100319 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(100406), // Rule ID 4118 //
     /* 100324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100327 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100331 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100342 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100346 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100353 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100375 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100405 */   // GIR_Coverage, 4118,
     /* 100405 */   GIR_EraseRootFromParent_Done,
     /* 100406 */ // Label 1898: @100406
     /* 100406 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(100446), // Rule ID 6927 //
     /* 100411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100414 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100431 */   // MIs[0] ptr
     /* 100431 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100439 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15491>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 100444 */   GIR_RootConstrainSelectedInstOperands,
     /* 100445 */   // GIR_Coverage, 6927,
     /* 100445 */   GIR_Done,
     /* 100446 */ // Label 1899: @100446
     /* 100446 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(100483), // Rule ID 6958 //
     /* 100451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100461 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100468 */   // MIs[0] ptr
     /* 100468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100476 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15519>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100481 */   GIR_RootConstrainSelectedInstOperands,
     /* 100482 */   // GIR_Coverage, 6958,
     /* 100482 */   GIR_Done,
     /* 100483 */ // Label 1900: @100483
     /* 100483 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(100520), // Rule ID 6959 //
     /* 100488 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100491 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100498 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100505 */   // MIs[0] ptr
     /* 100505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100513 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15491>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100518 */   GIR_RootConstrainSelectedInstOperands,
     /* 100519 */   // GIR_Coverage, 6959,
     /* 100519 */   GIR_Done,
     /* 100520 */ // Label 1901: @100520
     /* 100520 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(100551), // Rule ID 6311 //
     /* 100525 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100528 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100536 */   // MIs[0] Rn
     /* 100536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100544 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 100544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 100549 */   GIR_RootConstrainSelectedInstOperands,
     /* 100550 */   // GIR_Coverage, 6311,
     /* 100550 */   GIR_Done,
     /* 100551 */ // Label 1902: @100551
     /* 100551 */ GIM_Reject,
     /* 100552 */ // Label 1791: @100552
     /* 100552 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(100760),
     /* 100557 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100560 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100572 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(100613), // Rule ID 245 //
     /* 100577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 100587 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 100587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 100590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100611 */     GIR_RootConstrainSelectedInstOperands,
     /* 100612 */     // GIR_Coverage, 245,
     /* 100612 */     GIR_EraseRootFromParent_Done,
     /* 100613 */   // Label 1904: @100613
     /* 100613 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(100654), // Rule ID 246 //
     /* 100618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 100628 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 100628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 100631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100652 */     GIR_RootConstrainSelectedInstOperands,
     /* 100653 */     // GIR_Coverage, 246,
     /* 100653 */     GIR_EraseRootFromParent_Done,
     /* 100654 */   // Label 1905: @100654
     /* 100654 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(100690), // Rule ID 265 //
     /* 100659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100669 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100688 */     GIR_RootConstrainSelectedInstOperands,
     /* 100689 */     // GIR_Coverage, 265,
     /* 100689 */     GIR_EraseRootFromParent_Done,
     /* 100690 */   // Label 1906: @100690
     /* 100690 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(100726), // Rule ID 286 //
     /* 100695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 100705 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 100708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100724 */     GIR_RootConstrainSelectedInstOperands,
     /* 100725 */     // GIR_Coverage, 286,
     /* 100725 */     GIR_EraseRootFromParent_Done,
     /* 100726 */   // Label 1907: @100726
     /* 100726 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(100759), // Rule ID 4084 //
     /* 100731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100738 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100757 */     GIR_RootConstrainSelectedInstOperands,
     /* 100758 */     // GIR_Coverage, 4084,
     /* 100758 */     GIR_EraseRootFromParent_Done,
     /* 100759 */   // Label 1908: @100759
     /* 100759 */   GIM_Reject,
     /* 100760 */ // Label 1903: @100760
     /* 100760 */ GIM_Reject,
     /* 100761 */ // Label 1792: @100761
     /* 100761 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(101138),
     /* 100766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100777 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(100822), // Rule ID 4018 //
     /* 100782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100796 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100820 */     GIR_RootConstrainSelectedInstOperands,
     /* 100821 */     // GIR_Coverage, 4018,
     /* 100821 */     GIR_EraseRootFromParent_Done,
     /* 100822 */   // Label 1910: @100822
     /* 100822 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(100867), // Rule ID 4019 //
     /* 100827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100841 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100865 */     GIR_RootConstrainSelectedInstOperands,
     /* 100866 */     // GIR_Coverage, 4019,
     /* 100866 */     GIR_EraseRootFromParent_Done,
     /* 100867 */   // Label 1911: @100867
     /* 100867 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(100912), // Rule ID 4020 //
     /* 100872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100886 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100910 */     GIR_RootConstrainSelectedInstOperands,
     /* 100911 */     // GIR_Coverage, 4020,
     /* 100911 */     GIR_EraseRootFromParent_Done,
     /* 100912 */   // Label 1912: @100912
     /* 100912 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(100957), // Rule ID 4021 //
     /* 100917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100931 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100955 */     GIR_RootConstrainSelectedInstOperands,
     /* 100956 */     // GIR_Coverage, 4021,
     /* 100956 */     GIR_EraseRootFromParent_Done,
     /* 100957 */   // Label 1913: @100957
     /* 100957 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(100997), // Rule ID 4070 //
     /* 100962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 100976 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 100976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 100979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100995 */     GIR_RootConstrainSelectedInstOperands,
     /* 100996 */     // GIR_Coverage, 4070,
     /* 100996 */     GIR_EraseRootFromParent_Done,
     /* 100997 */   // Label 1914: @100997
     /* 100997 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(101037), // Rule ID 4073 //
     /* 101002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101016 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101035 */     GIR_RootConstrainSelectedInstOperands,
     /* 101036 */     // GIR_Coverage, 4073,
     /* 101036 */     GIR_EraseRootFromParent_Done,
     /* 101037 */   // Label 1915: @101037
     /* 101037 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(101077), // Rule ID 4098 //
     /* 101042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101056 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101075 */     GIR_RootConstrainSelectedInstOperands,
     /* 101076 */     // GIR_Coverage, 4098,
     /* 101076 */     GIR_EraseRootFromParent_Done,
     /* 101077 */   // Label 1916: @101077
     /* 101077 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(101117), // Rule ID 4099 //
     /* 101082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101096 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101115 */     GIR_RootConstrainSelectedInstOperands,
     /* 101116 */     // GIR_Coverage, 4099,
     /* 101116 */     GIR_EraseRootFromParent_Done,
     /* 101117 */   // Label 1917: @101117
     /* 101117 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(101137), // Rule ID 6310 //
     /* 101122 */     // MIs[0] Rn
     /* 101122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101130 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 101135 */     GIR_RootConstrainSelectedInstOperands,
     /* 101136 */     // GIR_Coverage, 6310,
     /* 101136 */     GIR_Done,
     /* 101137 */   // Label 1918: @101137
     /* 101137 */   GIM_Reject,
     /* 101138 */ // Label 1909: @101138
     /* 101138 */ GIM_Reject,
     /* 101139 */ // Label 1793: @101139
     /* 101139 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(101516),
     /* 101144 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101155 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(101200), // Rule ID 4032 //
     /* 101160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101174 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101198 */     GIR_RootConstrainSelectedInstOperands,
     /* 101199 */     // GIR_Coverage, 4032,
     /* 101199 */     GIR_EraseRootFromParent_Done,
     /* 101200 */   // Label 1920: @101200
     /* 101200 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(101245), // Rule ID 4033 //
     /* 101205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101219 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101243 */     GIR_RootConstrainSelectedInstOperands,
     /* 101244 */     // GIR_Coverage, 4033,
     /* 101244 */     GIR_EraseRootFromParent_Done,
     /* 101245 */   // Label 1921: @101245
     /* 101245 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(101290), // Rule ID 4034 //
     /* 101250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101264 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101288 */     GIR_RootConstrainSelectedInstOperands,
     /* 101289 */     // GIR_Coverage, 4034,
     /* 101289 */     GIR_EraseRootFromParent_Done,
     /* 101290 */   // Label 1922: @101290
     /* 101290 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(101335), // Rule ID 4035 //
     /* 101295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101309 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101333 */     GIR_RootConstrainSelectedInstOperands,
     /* 101334 */     // GIR_Coverage, 4035,
     /* 101334 */     GIR_EraseRootFromParent_Done,
     /* 101335 */   // Label 1923: @101335
     /* 101335 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(101375), // Rule ID 4078 //
     /* 101340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101354 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101373 */     GIR_RootConstrainSelectedInstOperands,
     /* 101374 */     // GIR_Coverage, 4078,
     /* 101374 */     GIR_EraseRootFromParent_Done,
     /* 101375 */   // Label 1924: @101375
     /* 101375 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(101415), // Rule ID 4082 //
     /* 101380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101394 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101413 */     GIR_RootConstrainSelectedInstOperands,
     /* 101414 */     // GIR_Coverage, 4082,
     /* 101414 */     GIR_EraseRootFromParent_Done,
     /* 101415 */   // Label 1925: @101415
     /* 101415 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(101455), // Rule ID 4105 //
     /* 101420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101434 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101453 */     GIR_RootConstrainSelectedInstOperands,
     /* 101454 */     // GIR_Coverage, 4105,
     /* 101454 */     GIR_EraseRootFromParent_Done,
     /* 101455 */   // Label 1926: @101455
     /* 101455 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(101495), // Rule ID 4106 //
     /* 101460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101474 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101493 */     GIR_RootConstrainSelectedInstOperands,
     /* 101494 */     // GIR_Coverage, 4106,
     /* 101494 */     GIR_EraseRootFromParent_Done,
     /* 101495 */   // Label 1927: @101495
     /* 101495 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(101515), // Rule ID 6307 //
     /* 101500 */     // MIs[0] Rn
     /* 101500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101508 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 101513 */     GIR_RootConstrainSelectedInstOperands,
     /* 101514 */     // GIR_Coverage, 6307,
     /* 101514 */     GIR_Done,
     /* 101515 */   // Label 1928: @101515
     /* 101515 */   GIM_Reject,
     /* 101516 */ // Label 1919: @101516
     /* 101516 */ GIM_Reject,
     /* 101517 */ // Label 1794: @101517
     /* 101517 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(101894),
     /* 101522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101525 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101533 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(101578), // Rule ID 4024 //
     /* 101538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101552 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101576 */     GIR_RootConstrainSelectedInstOperands,
     /* 101577 */     // GIR_Coverage, 4024,
     /* 101577 */     GIR_EraseRootFromParent_Done,
     /* 101578 */   // Label 1930: @101578
     /* 101578 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(101623), // Rule ID 4025 //
     /* 101583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101597 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101621 */     GIR_RootConstrainSelectedInstOperands,
     /* 101622 */     // GIR_Coverage, 4025,
     /* 101622 */     GIR_EraseRootFromParent_Done,
     /* 101623 */   // Label 1931: @101623
     /* 101623 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(101668), // Rule ID 4026 //
     /* 101628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101642 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101666 */     GIR_RootConstrainSelectedInstOperands,
     /* 101667 */     // GIR_Coverage, 4026,
     /* 101667 */     GIR_EraseRootFromParent_Done,
     /* 101668 */   // Label 1932: @101668
     /* 101668 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(101713), // Rule ID 4027 //
     /* 101673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101687 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101711 */     GIR_RootConstrainSelectedInstOperands,
     /* 101712 */     // GIR_Coverage, 4027,
     /* 101712 */     GIR_EraseRootFromParent_Done,
     /* 101713 */   // Label 1933: @101713
     /* 101713 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(101753), // Rule ID 4072 //
     /* 101718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101732 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101751 */     GIR_RootConstrainSelectedInstOperands,
     /* 101752 */     // GIR_Coverage, 4072,
     /* 101752 */     GIR_EraseRootFromParent_Done,
     /* 101753 */   // Label 1934: @101753
     /* 101753 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(101793), // Rule ID 4074 //
     /* 101758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101772 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101791 */     GIR_RootConstrainSelectedInstOperands,
     /* 101792 */     // GIR_Coverage, 4074,
     /* 101792 */     GIR_EraseRootFromParent_Done,
     /* 101793 */   // Label 1935: @101793
     /* 101793 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(101833), // Rule ID 4100 //
     /* 101798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101812 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101831 */     GIR_RootConstrainSelectedInstOperands,
     /* 101832 */     // GIR_Coverage, 4100,
     /* 101832 */     GIR_EraseRootFromParent_Done,
     /* 101833 */   // Label 1936: @101833
     /* 101833 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(101873), // Rule ID 4102 //
     /* 101838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101852 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101871 */     GIR_RootConstrainSelectedInstOperands,
     /* 101872 */     // GIR_Coverage, 4102,
     /* 101872 */     GIR_EraseRootFromParent_Done,
     /* 101873 */   // Label 1937: @101873
     /* 101873 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(101893), // Rule ID 6309 //
     /* 101878 */     // MIs[0] Rn
     /* 101878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101886 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 101891 */     GIR_RootConstrainSelectedInstOperands,
     /* 101892 */     // GIR_Coverage, 6309,
     /* 101892 */     GIR_Done,
     /* 101893 */   // Label 1938: @101893
     /* 101893 */   GIM_Reject,
     /* 101894 */ // Label 1929: @101894
     /* 101894 */ GIM_Reject,
     /* 101895 */ // Label 1795: @101895
     /* 101895 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(102272),
     /* 101900 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101903 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101911 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(101956), // Rule ID 4036 //
     /* 101916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101930 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101954 */     GIR_RootConstrainSelectedInstOperands,
     /* 101955 */     // GIR_Coverage, 4036,
     /* 101955 */     GIR_EraseRootFromParent_Done,
     /* 101956 */   // Label 1940: @101956
     /* 101956 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(102001), // Rule ID 4037 //
     /* 101961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101975 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101999 */     GIR_RootConstrainSelectedInstOperands,
     /* 102000 */     // GIR_Coverage, 4037,
     /* 102000 */     GIR_EraseRootFromParent_Done,
     /* 102001 */   // Label 1941: @102001
     /* 102001 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(102046), // Rule ID 4038 //
     /* 102006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102020 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102044 */     GIR_RootConstrainSelectedInstOperands,
     /* 102045 */     // GIR_Coverage, 4038,
     /* 102045 */     GIR_EraseRootFromParent_Done,
     /* 102046 */   // Label 1942: @102046
     /* 102046 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(102091), // Rule ID 4039 //
     /* 102051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102065 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102089 */     GIR_RootConstrainSelectedInstOperands,
     /* 102090 */     // GIR_Coverage, 4039,
     /* 102090 */     GIR_EraseRootFromParent_Done,
     /* 102091 */   // Label 1943: @102091
     /* 102091 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(102131), // Rule ID 4077 //
     /* 102096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102110 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102129 */     GIR_RootConstrainSelectedInstOperands,
     /* 102130 */     // GIR_Coverage, 4077,
     /* 102130 */     GIR_EraseRootFromParent_Done,
     /* 102131 */   // Label 1944: @102131
     /* 102131 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(102171), // Rule ID 4081 //
     /* 102136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102150 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102169 */     GIR_RootConstrainSelectedInstOperands,
     /* 102170 */     // GIR_Coverage, 4081,
     /* 102170 */     GIR_EraseRootFromParent_Done,
     /* 102171 */   // Label 1945: @102171
     /* 102171 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(102211), // Rule ID 4107 //
     /* 102176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102190 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102209 */     GIR_RootConstrainSelectedInstOperands,
     /* 102210 */     // GIR_Coverage, 4107,
     /* 102210 */     GIR_EraseRootFromParent_Done,
     /* 102211 */   // Label 1946: @102211
     /* 102211 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(102251), // Rule ID 4108 //
     /* 102216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102230 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102249 */     GIR_RootConstrainSelectedInstOperands,
     /* 102250 */     // GIR_Coverage, 4108,
     /* 102250 */     GIR_EraseRootFromParent_Done,
     /* 102251 */   // Label 1947: @102251
     /* 102251 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(102271), // Rule ID 6306 //
     /* 102256 */     // MIs[0] Rn
     /* 102256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102264 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 102269 */     GIR_RootConstrainSelectedInstOperands,
     /* 102270 */     // GIR_Coverage, 6306,
     /* 102270 */     GIR_Done,
     /* 102271 */   // Label 1948: @102271
     /* 102271 */   GIM_Reject,
     /* 102272 */ // Label 1939: @102272
     /* 102272 */ GIM_Reject,
     /* 102273 */ // Label 1796: @102273
     /* 102273 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(102480),
     /* 102278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102281 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102289 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(102334), // Rule ID 4022 //
     /* 102294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102308 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102332 */     GIR_RootConstrainSelectedInstOperands,
     /* 102333 */     // GIR_Coverage, 4022,
     /* 102333 */     GIR_EraseRootFromParent_Done,
     /* 102334 */   // Label 1950: @102334
     /* 102334 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(102379), // Rule ID 4023 //
     /* 102339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102353 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102377 */     GIR_RootConstrainSelectedInstOperands,
     /* 102378 */     // GIR_Coverage, 4023,
     /* 102378 */     GIR_EraseRootFromParent_Done,
     /* 102379 */   // Label 1951: @102379
     /* 102379 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(102419), // Rule ID 4071 //
     /* 102384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102398 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102417 */     GIR_RootConstrainSelectedInstOperands,
     /* 102418 */     // GIR_Coverage, 4071,
     /* 102418 */     GIR_EraseRootFromParent_Done,
     /* 102419 */   // Label 1952: @102419
     /* 102419 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(102459), // Rule ID 4101 //
     /* 102424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102438 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102457 */     GIR_RootConstrainSelectedInstOperands,
     /* 102458 */     // GIR_Coverage, 4101,
     /* 102458 */     GIR_EraseRootFromParent_Done,
     /* 102459 */   // Label 1953: @102459
     /* 102459 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(102479), // Rule ID 6308 //
     /* 102464 */     // MIs[0] Rn
     /* 102464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102472 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 102477 */     GIR_RootConstrainSelectedInstOperands,
     /* 102478 */     // GIR_Coverage, 6308,
     /* 102478 */     GIR_Done,
     /* 102479 */   // Label 1954: @102479
     /* 102479 */   GIM_Reject,
     /* 102480 */ // Label 1949: @102480
     /* 102480 */ GIM_Reject,
     /* 102481 */ // Label 1797: @102481
     /* 102481 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(102858),
     /* 102486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102489 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102497 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(102542), // Rule ID 4040 //
     /* 102502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102516 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102540 */     GIR_RootConstrainSelectedInstOperands,
     /* 102541 */     // GIR_Coverage, 4040,
     /* 102541 */     GIR_EraseRootFromParent_Done,
     /* 102542 */   // Label 1956: @102542
     /* 102542 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(102587), // Rule ID 4041 //
     /* 102547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102561 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102585 */     GIR_RootConstrainSelectedInstOperands,
     /* 102586 */     // GIR_Coverage, 4041,
     /* 102586 */     GIR_EraseRootFromParent_Done,
     /* 102587 */   // Label 1957: @102587
     /* 102587 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(102632), // Rule ID 4042 //
     /* 102592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102606 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102630 */     GIR_RootConstrainSelectedInstOperands,
     /* 102631 */     // GIR_Coverage, 4042,
     /* 102631 */     GIR_EraseRootFromParent_Done,
     /* 102632 */   // Label 1958: @102632
     /* 102632 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(102677), // Rule ID 4043 //
     /* 102637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102651 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102675 */     GIR_RootConstrainSelectedInstOperands,
     /* 102676 */     // GIR_Coverage, 4043,
     /* 102676 */     GIR_EraseRootFromParent_Done,
     /* 102677 */   // Label 1959: @102677
     /* 102677 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(102717), // Rule ID 4080 //
     /* 102682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102696 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102715 */     GIR_RootConstrainSelectedInstOperands,
     /* 102716 */     // GIR_Coverage, 4080,
     /* 102716 */     GIR_EraseRootFromParent_Done,
     /* 102717 */   // Label 1960: @102717
     /* 102717 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(102757), // Rule ID 4083 //
     /* 102722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102736 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102755 */     GIR_RootConstrainSelectedInstOperands,
     /* 102756 */     // GIR_Coverage, 4083,
     /* 102756 */     GIR_EraseRootFromParent_Done,
     /* 102757 */   // Label 1961: @102757
     /* 102757 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(102797), // Rule ID 4109 //
     /* 102762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102776 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102795 */     GIR_RootConstrainSelectedInstOperands,
     /* 102796 */     // GIR_Coverage, 4109,
     /* 102796 */     GIR_EraseRootFromParent_Done,
     /* 102797 */   // Label 1962: @102797
     /* 102797 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(102837), // Rule ID 4111 //
     /* 102802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102816 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102835 */     GIR_RootConstrainSelectedInstOperands,
     /* 102836 */     // GIR_Coverage, 4111,
     /* 102836 */     GIR_EraseRootFromParent_Done,
     /* 102837 */   // Label 1963: @102837
     /* 102837 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(102857), // Rule ID 6305 //
     /* 102842 */     // MIs[0] Rn
     /* 102842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102850 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 102855 */     GIR_RootConstrainSelectedInstOperands,
     /* 102856 */     // GIR_Coverage, 6305,
     /* 102856 */     GIR_Done,
     /* 102857 */   // Label 1964: @102857
     /* 102857 */   GIM_Reject,
     /* 102858 */ // Label 1955: @102858
     /* 102858 */ GIM_Reject,
     /* 102859 */ // Label 1798: @102859
     /* 102859 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(103066),
     /* 102864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102875 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(102920), // Rule ID 4044 //
     /* 102880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102894 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102918 */     GIR_RootConstrainSelectedInstOperands,
     /* 102919 */     // GIR_Coverage, 4044,
     /* 102919 */     GIR_EraseRootFromParent_Done,
     /* 102920 */   // Label 1966: @102920
     /* 102920 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(102965), // Rule ID 4045 //
     /* 102925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102939 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102963 */     GIR_RootConstrainSelectedInstOperands,
     /* 102964 */     // GIR_Coverage, 4045,
     /* 102964 */     GIR_EraseRootFromParent_Done,
     /* 102965 */   // Label 1967: @102965
     /* 102965 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(103005), // Rule ID 4079 //
     /* 102970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102984 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103003 */     GIR_RootConstrainSelectedInstOperands,
     /* 103004 */     // GIR_Coverage, 4079,
     /* 103004 */     GIR_EraseRootFromParent_Done,
     /* 103005 */   // Label 1968: @103005
     /* 103005 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(103045), // Rule ID 4110 //
     /* 103010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 103024 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 103027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103043 */     GIR_RootConstrainSelectedInstOperands,
     /* 103044 */     // GIR_Coverage, 4110,
     /* 103044 */     GIR_EraseRootFromParent_Done,
     /* 103045 */   // Label 1969: @103045
     /* 103045 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(103065), // Rule ID 6304 //
     /* 103050 */     // MIs[0] Rn
     /* 103050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103058 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 103058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 103063 */     GIR_RootConstrainSelectedInstOperands,
     /* 103064 */     // GIR_Coverage, 6304,
     /* 103064 */     GIR_Done,
     /* 103065 */   // Label 1970: @103065
     /* 103065 */   GIM_Reject,
     /* 103066 */ // Label 1965: @103066
     /* 103066 */ GIM_Reject,
     /* 103067 */ // Label 1799: @103067
     /* 103067 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(103130), // Rule ID 10786 //
     /* 103072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103086 */   // MIs[0] base
     /* 103086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103094 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103094 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103097 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103101 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103106 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 103114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103119 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103128 */   GIR_RootConstrainSelectedInstOperands,
     /* 103129 */   // GIR_Coverage, 10786,
     /* 103129 */   GIR_EraseRootFromParent_Done,
     /* 103130 */ // Label 1971: @103130
     /* 103130 */ GIM_Reject,
     /* 103131 */ // Label 1800: @103131
     /* 103131 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(103194), // Rule ID 10792 //
     /* 103136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103150 */   // MIs[0] base
     /* 103150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103158 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103170 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 103178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103183 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103192 */   GIR_RootConstrainSelectedInstOperands,
     /* 103193 */   // GIR_Coverage, 10792,
     /* 103193 */   GIR_EraseRootFromParent_Done,
     /* 103194 */ // Label 1972: @103194
     /* 103194 */ GIM_Reject,
     /* 103195 */ // Label 1801: @103195
     /* 103195 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(103308),
     /* 103200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103203 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103219 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(103263), // Rule ID 10777 //
     /* 103224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103227 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103252 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103261 */     GIR_RootConstrainSelectedInstOperands,
     /* 103262 */     // GIR_Coverage, 10777,
     /* 103262 */     GIR_EraseRootFromParent_Done,
     /* 103263 */   // Label 1974: @103263
     /* 103263 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(103307), // Rule ID 10795 //
     /* 103268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103271 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103296 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103305 */     GIR_RootConstrainSelectedInstOperands,
     /* 103306 */     // GIR_Coverage, 10795,
     /* 103306 */     GIR_EraseRootFromParent_Done,
     /* 103307 */   // Label 1975: @103307
     /* 103307 */   GIM_Reject,
     /* 103308 */ // Label 1973: @103308
     /* 103308 */ GIM_Reject,
     /* 103309 */ // Label 1802: @103309
     /* 103309 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(103372), // Rule ID 10783 //
     /* 103314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103328 */   // MIs[0] base
     /* 103328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103336 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103348 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 103356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103361 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103366 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103370 */   GIR_RootConstrainSelectedInstOperands,
     /* 103371 */   // GIR_Coverage, 10783,
     /* 103371 */   GIR_EraseRootFromParent_Done,
     /* 103372 */ // Label 1976: @103372
     /* 103372 */ GIM_Reject,
     /* 103373 */ // Label 1803: @103373
     /* 103373 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(103486),
     /* 103378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103397 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(103441), // Rule ID 10765 //
     /* 103402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103405 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103430 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103439 */     GIR_RootConstrainSelectedInstOperands,
     /* 103440 */     // GIR_Coverage, 10765,
     /* 103440 */     GIR_EraseRootFromParent_Done,
     /* 103441 */   // Label 1978: @103441
     /* 103441 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(103485), // Rule ID 10789 //
     /* 103446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103449 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103474 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103483 */     GIR_RootConstrainSelectedInstOperands,
     /* 103484 */     // GIR_Coverage, 10789,
     /* 103484 */     GIR_EraseRootFromParent_Done,
     /* 103485 */   // Label 1979: @103485
     /* 103485 */   GIM_Reject,
     /* 103486 */ // Label 1977: @103486
     /* 103486 */ GIM_Reject,
     /* 103487 */ // Label 1804: @103487
     /* 103487 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(103600),
     /* 103492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103511 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(103555), // Rule ID 10744 //
     /* 103516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103519 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103544 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103553 */     GIR_RootConstrainSelectedInstOperands,
     /* 103554 */     // GIR_Coverage, 10744,
     /* 103554 */     GIR_EraseRootFromParent_Done,
     /* 103555 */   // Label 1981: @103555
     /* 103555 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(103599), // Rule ID 10780 //
     /* 103560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103563 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103588 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103597 */     GIR_RootConstrainSelectedInstOperands,
     /* 103598 */     // GIR_Coverage, 10780,
     /* 103598 */     GIR_EraseRootFromParent_Done,
     /* 103599 */   // Label 1982: @103599
     /* 103599 */   GIM_Reject,
     /* 103600 */ // Label 1980: @103600
     /* 103600 */ GIM_Reject,
     /* 103601 */ // Label 1805: @103601
     /* 103601 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(103644), // Rule ID 2419 //
     /* 103606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 103620 */   // MIs[0] base
     /* 103620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103628 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 103631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 103633 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103642 */   GIR_RootConstrainSelectedInstOperands,
     /* 103643 */   // GIR_Coverage, 2419,
     /* 103643 */   GIR_EraseRootFromParent_Done,
     /* 103644 */ // Label 1983: @103644
     /* 103644 */ GIM_Reject,
     /* 103645 */ // Label 1806: @103645
     /* 103645 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(103708), // Rule ID 10712 //
     /* 103650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103664 */   // MIs[0] base
     /* 103664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103672 */   // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 103679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103684 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 103692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103697 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103706 */   GIR_RootConstrainSelectedInstOperands,
     /* 103707 */   // GIR_Coverage, 10712,
     /* 103707 */   GIR_EraseRootFromParent_Done,
     /* 103708 */ // Label 1984: @103708
     /* 103708 */ GIM_Reject,
     /* 103709 */ // Label 1807: @103709
     /* 103709 */ GIM_Reject,
     /* 103710 */ // Label 17: @103710
     /* 103710 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1987*/ GIMT_Encode4(104759),
     /* 103721 */ /*GILLT_s32*//*Label 1985*/ GIMT_Encode4(103729),
     /* 103725 */ /*GILLT_s64*//*Label 1986*/ GIMT_Encode4(104143),
     /* 103729 */ // Label 1985: @103729
     /* 103729 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(104142),
     /* 103734 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103737 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(103790), // Rule ID 247 //
     /* 103742 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 103764 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 103764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 103767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103788 */     GIR_RootConstrainSelectedInstOperands,
     /* 103789 */     // GIR_Coverage, 247,
     /* 103789 */     GIR_EraseRootFromParent_Done,
     /* 103790 */   // Label 1989: @103790
     /* 103790 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(103843), // Rule ID 248 //
     /* 103795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 103817 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 103817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 103820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103841 */     GIR_RootConstrainSelectedInstOperands,
     /* 103842 */     // GIR_Coverage, 248,
     /* 103842 */     GIR_EraseRootFromParent_Done,
     /* 103843 */   // Label 1990: @103843
     /* 103843 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(103896), // Rule ID 251 //
     /* 103848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 103870 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 103870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 103873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103894 */     GIR_RootConstrainSelectedInstOperands,
     /* 103895 */     // GIR_Coverage, 251,
     /* 103895 */     GIR_EraseRootFromParent_Done,
     /* 103896 */   // Label 1991: @103896
     /* 103896 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(103949), // Rule ID 252 //
     /* 103901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 103923 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 103923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 103926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103947 */     GIR_RootConstrainSelectedInstOperands,
     /* 103948 */     // GIR_Coverage, 252,
     /* 103948 */     GIR_EraseRootFromParent_Done,
     /* 103949 */   // Label 1992: @103949
     /* 103949 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(103997), // Rule ID 268 //
     /* 103954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 103976 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 103976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 103979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103995 */     GIR_RootConstrainSelectedInstOperands,
     /* 103996 */     // GIR_Coverage, 268,
     /* 103996 */     GIR_EraseRootFromParent_Done,
     /* 103997 */   // Label 1993: @103997
     /* 103997 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(104045), // Rule ID 270 //
     /* 104002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104024 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 104027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104043 */     GIR_RootConstrainSelectedInstOperands,
     /* 104044 */     // GIR_Coverage, 270,
     /* 104044 */     GIR_EraseRootFromParent_Done,
     /* 104045 */   // Label 1994: @104045
     /* 104045 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(104093), // Rule ID 289 //
     /* 104050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104072 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 104075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104091 */     GIR_RootConstrainSelectedInstOperands,
     /* 104092 */     // GIR_Coverage, 289,
     /* 104092 */     GIR_EraseRootFromParent_Done,
     /* 104093 */   // Label 1995: @104093
     /* 104093 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(104141), // Rule ID 291 //
     /* 104098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104120 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 104123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104139 */     GIR_RootConstrainSelectedInstOperands,
     /* 104140 */     // GIR_Coverage, 291,
     /* 104140 */     GIR_EraseRootFromParent_Done,
     /* 104141 */   // Label 1996: @104141
     /* 104141 */   GIM_Reject,
     /* 104142 */ // Label 1988: @104142
     /* 104142 */ GIM_Reject,
     /* 104143 */ // Label 1986: @104143
     /* 104143 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(104758),
     /* 104148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104151 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(104204), // Rule ID 249 //
     /* 104156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 104178 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 104178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 104181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104202 */     GIR_RootConstrainSelectedInstOperands,
     /* 104203 */     // GIR_Coverage, 249,
     /* 104203 */     GIR_EraseRootFromParent_Done,
     /* 104204 */   // Label 1998: @104204
     /* 104204 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(104257), // Rule ID 250 //
     /* 104209 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104231 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 104234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104255 */     GIR_RootConstrainSelectedInstOperands,
     /* 104256 */     // GIR_Coverage, 250,
     /* 104256 */     GIR_EraseRootFromParent_Done,
     /* 104257 */   // Label 1999: @104257
     /* 104257 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(104310), // Rule ID 253 //
     /* 104262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104284 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 104287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104308 */     GIR_RootConstrainSelectedInstOperands,
     /* 104309 */     // GIR_Coverage, 253,
     /* 104309 */     GIR_EraseRootFromParent_Done,
     /* 104310 */   // Label 2000: @104310
     /* 104310 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(104363), // Rule ID 254 //
     /* 104315 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104337 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 104340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104361 */     GIR_RootConstrainSelectedInstOperands,
     /* 104362 */     // GIR_Coverage, 254,
     /* 104362 */     GIR_EraseRootFromParent_Done,
     /* 104363 */   // Label 2001: @104363
     /* 104363 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(104416), // Rule ID 255 //
     /* 104368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104390 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 104393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104414 */     GIR_RootConstrainSelectedInstOperands,
     /* 104415 */     // GIR_Coverage, 255,
     /* 104415 */     GIR_EraseRootFromParent_Done,
     /* 104416 */   // Label 2002: @104416
     /* 104416 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(104469), // Rule ID 256 //
     /* 104421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104443 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 104446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104467 */     GIR_RootConstrainSelectedInstOperands,
     /* 104468 */     // GIR_Coverage, 256,
     /* 104468 */     GIR_EraseRootFromParent_Done,
     /* 104469 */   // Label 2003: @104469
     /* 104469 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(104517), // Rule ID 269 //
     /* 104474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104496 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 104496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 104499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104515 */     GIR_RootConstrainSelectedInstOperands,
     /* 104516 */     // GIR_Coverage, 269,
     /* 104516 */     GIR_EraseRootFromParent_Done,
     /* 104517 */   // Label 2004: @104517
     /* 104517 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(104565), // Rule ID 271 //
     /* 104522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104544 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 104547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104563 */     GIR_RootConstrainSelectedInstOperands,
     /* 104564 */     // GIR_Coverage, 271,
     /* 104564 */     GIR_EraseRootFromParent_Done,
     /* 104565 */   // Label 2005: @104565
     /* 104565 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(104613), // Rule ID 272 //
     /* 104570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104592 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 104592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 104595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104611 */     GIR_RootConstrainSelectedInstOperands,
     /* 104612 */     // GIR_Coverage, 272,
     /* 104612 */     GIR_EraseRootFromParent_Done,
     /* 104613 */   // Label 2006: @104613
     /* 104613 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(104661), // Rule ID 290 //
     /* 104618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104640 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 104643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104659 */     GIR_RootConstrainSelectedInstOperands,
     /* 104660 */     // GIR_Coverage, 290,
     /* 104660 */     GIR_EraseRootFromParent_Done,
     /* 104661 */   // Label 2007: @104661
     /* 104661 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(104709), // Rule ID 292 //
     /* 104666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104688 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 104691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104707 */     GIR_RootConstrainSelectedInstOperands,
     /* 104708 */     // GIR_Coverage, 292,
     /* 104708 */     GIR_EraseRootFromParent_Done,
     /* 104709 */   // Label 2008: @104709
     /* 104709 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(104757), // Rule ID 293 //
     /* 104714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104736 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 104739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104755 */     GIR_RootConstrainSelectedInstOperands,
     /* 104756 */     // GIR_Coverage, 293,
     /* 104756 */     GIR_EraseRootFromParent_Done,
     /* 104757 */   // Label 2009: @104757
     /* 104757 */   GIM_Reject,
     /* 104758 */ // Label 1997: @104758
     /* 104758 */ GIM_Reject,
     /* 104759 */ // Label 1987: @104759
     /* 104759 */ GIM_Reject,
     /* 104760 */ // Label 18: @104760
     /* 104760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2012*/ GIMT_Encode4(107728),
     /* 104771 */ /*GILLT_s32*//*Label 2010*/ GIMT_Encode4(104779),
     /* 104775 */ /*GILLT_s64*//*Label 2011*/ GIMT_Encode4(106238),
     /* 104779 */ // Label 2010: @104779
     /* 104779 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(104835), // Rule ID 229 //
     /* 104784 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104809 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 104812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104829 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104833 */   GIR_RootConstrainSelectedInstOperands,
     /* 104834 */   // GIR_Coverage, 229,
     /* 104834 */   GIR_EraseRootFromParent_Done,
     /* 104835 */ // Label 2013: @104835
     /* 104835 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(104891), // Rule ID 230 //
     /* 104840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104865 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 104868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104889 */   GIR_RootConstrainSelectedInstOperands,
     /* 104890 */   // GIR_Coverage, 230,
     /* 104890 */   GIR_EraseRootFromParent_Done,
     /* 104891 */ // Label 2014: @104891
     /* 104891 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(104947), // Rule ID 231 //
     /* 104896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 104921 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 104921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 104924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104945 */   GIR_RootConstrainSelectedInstOperands,
     /* 104946 */   // GIR_Coverage, 231,
     /* 104946 */   GIR_EraseRootFromParent_Done,
     /* 104947 */ // Label 2015: @104947
     /* 104947 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(105003), // Rule ID 232 //
     /* 104952 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104955 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104977 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 104980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105001 */   GIR_RootConstrainSelectedInstOperands,
     /* 105002 */   // GIR_Coverage, 232,
     /* 105002 */   GIR_EraseRootFromParent_Done,
     /* 105003 */ // Label 2016: @105003
     /* 105003 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(105059), // Rule ID 4068 //
     /* 105008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105011 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105022 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105026 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105033 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 105033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105053 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105057 */   GIR_RootConstrainSelectedInstOperands,
     /* 105058 */   // GIR_Coverage, 4068,
     /* 105058 */   GIR_EraseRootFromParent_Done,
     /* 105059 */ // Label 2017: @105059
     /* 105059 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(105115), // Rule ID 4069 //
     /* 105064 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105067 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105089 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 105089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105113 */   GIR_RootConstrainSelectedInstOperands,
     /* 105114 */   // GIR_Coverage, 4069,
     /* 105114 */   GIR_EraseRootFromParent_Done,
     /* 105115 */ // Label 2018: @105115
     /* 105115 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(105166), // Rule ID 266 //
     /* 105120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105123 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 105145 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 105145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 105148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105164 */   GIR_RootConstrainSelectedInstOperands,
     /* 105165 */   // GIR_Coverage, 266,
     /* 105165 */   GIR_EraseRootFromParent_Done,
     /* 105166 */ // Label 2019: @105166
     /* 105166 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(105217), // Rule ID 267 //
     /* 105171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105196 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105215 */   GIR_RootConstrainSelectedInstOperands,
     /* 105216 */   // GIR_Coverage, 267,
     /* 105216 */   GIR_EraseRootFromParent_Done,
     /* 105217 */ // Label 2020: @105217
     /* 105217 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(105276), // Rule ID 6933 //
     /* 105222 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105225 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105232 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105250 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15497>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 105250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105274 */   GIR_RootConstrainSelectedInstOperands,
     /* 105275 */   // GIR_Coverage, 6933,
     /* 105275 */   GIR_EraseRootFromParent_Done,
     /* 105276 */ // Label 2021: @105276
     /* 105276 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(105335), // Rule ID 6935 //
     /* 105281 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105291 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105298 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105302 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105309 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15497>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 105309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105329 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105333 */   GIR_RootConstrainSelectedInstOperands,
     /* 105334 */   // GIR_Coverage, 6935,
     /* 105334 */   GIR_EraseRootFromParent_Done,
     /* 105335 */ // Label 2022: @105335
     /* 105335 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(105394), // Rule ID 6945 //
     /* 105340 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105343 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105350 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 105368 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15506>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 105368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 105371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105392 */   GIR_RootConstrainSelectedInstOperands,
     /* 105393 */   // GIR_Coverage, 6945,
     /* 105393 */   GIR_EraseRootFromParent_Done,
     /* 105394 */ // Label 2023: @105394
     /* 105394 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(105453), // Rule ID 6947 //
     /* 105399 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105409 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 105427 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15506>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 105427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 105430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105447 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105451 */   GIR_RootConstrainSelectedInstOperands,
     /* 105452 */   // GIR_Coverage, 6947,
     /* 105452 */   GIR_EraseRootFromParent_Done,
     /* 105453 */ // Label 2024: @105453
     /* 105453 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(105504), // Rule ID 287 //
     /* 105458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105461 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105483 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105502 */   GIR_RootConstrainSelectedInstOperands,
     /* 105503 */   // GIR_Coverage, 287,
     /* 105503 */   GIR_EraseRootFromParent_Done,
     /* 105504 */ // Label 2025: @105504
     /* 105504 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(105555), // Rule ID 288 //
     /* 105509 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105534 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105553 */   GIR_RootConstrainSelectedInstOperands,
     /* 105554 */   // GIR_Coverage, 288,
     /* 105554 */   GIR_EraseRootFromParent_Done,
     /* 105555 */ // Label 2026: @105555
     /* 105555 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(105606), // Rule ID 4087 //
     /* 105560 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105585 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105604 */   GIR_RootConstrainSelectedInstOperands,
     /* 105605 */   // GIR_Coverage, 4087,
     /* 105605 */   GIR_EraseRootFromParent_Done,
     /* 105606 */ // Label 2027: @105606
     /* 105606 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(105657), // Rule ID 4119 //
     /* 105611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105629 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105636 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105655 */   GIR_RootConstrainSelectedInstOperands,
     /* 105656 */   // GIR_Coverage, 4119,
     /* 105656 */   GIR_EraseRootFromParent_Done,
     /* 105657 */ // Label 2028: @105657
     /* 105657 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(105708), // Rule ID 4120 //
     /* 105662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105687 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105706 */   GIR_RootConstrainSelectedInstOperands,
     /* 105707 */   // GIR_Coverage, 4120,
     /* 105707 */   GIR_EraseRootFromParent_Done,
     /* 105708 */ // Label 2029: @105708
     /* 105708 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(105759), // Rule ID 4121 //
     /* 105713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105716 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105727 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105731 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105738 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105757 */   GIR_RootConstrainSelectedInstOperands,
     /* 105758 */   // GIR_Coverage, 4121,
     /* 105758 */   GIR_EraseRootFromParent_Done,
     /* 105759 */ // Label 2030: @105759
     /* 105759 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(105813), // Rule ID 6937 //
     /* 105764 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105767 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105774 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105792 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15497>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105811 */   GIR_RootConstrainSelectedInstOperands,
     /* 105812 */   // GIR_Coverage, 6937,
     /* 105812 */   GIR_EraseRootFromParent_Done,
     /* 105813 */ // Label 2031: @105813
     /* 105813 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(105867), // Rule ID 6939 //
     /* 105818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105821 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105828 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105846 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15497>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105865 */   GIR_RootConstrainSelectedInstOperands,
     /* 105866 */   // GIR_Coverage, 6939,
     /* 105866 */   GIR_EraseRootFromParent_Done,
     /* 105867 */ // Label 2032: @105867
     /* 105867 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(105921), // Rule ID 6949 //
     /* 105872 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105882 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 105900 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15506>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 105900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 105903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105919 */   GIR_RootConstrainSelectedInstOperands,
     /* 105920 */   // GIR_Coverage, 6949,
     /* 105920 */   GIR_EraseRootFromParent_Done,
     /* 105921 */ // Label 2033: @105921
     /* 105921 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(105975), // Rule ID 6951 //
     /* 105926 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105929 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105936 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105954 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15506>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105969 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105973 */   GIR_RootConstrainSelectedInstOperands,
     /* 105974 */   // GIR_Coverage, 6951,
     /* 105974 */   GIR_EraseRootFromParent_Done,
     /* 105975 */ // Label 2034: @105975
     /* 105975 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(106032), // Rule ID 7273 //
     /* 105980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 105983 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105986 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 106011 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15495>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 106014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106030 */   GIR_RootConstrainSelectedInstOperands,
     /* 106031 */   // GIR_Coverage, 7273,
     /* 106031 */   GIR_EraseRootFromParent_Done,
     /* 106032 */ // Label 2035: @106032
     /* 106032 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(106089), // Rule ID 7275 //
     /* 106037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 106040 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106043 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106061 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 106068 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15504>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 106071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106087 */   GIR_RootConstrainSelectedInstOperands,
     /* 106088 */   // GIR_Coverage, 7275,
     /* 106088 */   GIR_EraseRootFromParent_Done,
     /* 106089 */ // Label 2036: @106089
     /* 106089 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(106126), // Rule ID 6929 //
     /* 106094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106111 */   // MIs[0] ptr
     /* 106111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106119 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15493>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106124 */   GIR_RootConstrainSelectedInstOperands,
     /* 106125 */   // GIR_Coverage, 6929,
     /* 106125 */   GIR_Done,
     /* 106126 */ // Label 2037: @106126
     /* 106126 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(106163), // Rule ID 6931 //
     /* 106131 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106134 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106148 */   // MIs[0] ptr
     /* 106148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106156 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15495>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106161 */   GIR_RootConstrainSelectedInstOperands,
     /* 106162 */   // GIR_Coverage, 6931,
     /* 106162 */   GIR_Done,
     /* 106163 */ // Label 2038: @106163
     /* 106163 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(106200), // Rule ID 6941 //
     /* 106168 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106185 */   // MIs[0] ptr
     /* 106185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106193 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15502>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106198 */   GIR_RootConstrainSelectedInstOperands,
     /* 106199 */   // GIR_Coverage, 6941,
     /* 106199 */   GIR_Done,
     /* 106200 */ // Label 2039: @106200
     /* 106200 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(106237), // Rule ID 6943 //
     /* 106205 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106208 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106222 */   // MIs[0] ptr
     /* 106222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106230 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15504>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106235 */   GIR_RootConstrainSelectedInstOperands,
     /* 106236 */   // GIR_Coverage, 6943,
     /* 106236 */   GIR_Done,
     /* 106237 */ // Label 2040: @106237
     /* 106237 */ GIM_Reject,
     /* 106238 */ // Label 2011: @106238
     /* 106238 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(107727),
     /* 106243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106246 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(106331), // Rule ID 4046 //
     /* 106251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106273 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 106280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106300 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106330 */     // GIR_Coverage, 4046,
     /* 106330 */     GIR_EraseRootFromParent_Done,
     /* 106331 */   // Label 2042: @106331
     /* 106331 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(106416), // Rule ID 4047 //
     /* 106336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106358 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 106365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106385 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106415 */     // GIR_Coverage, 4047,
     /* 106415 */     GIR_EraseRootFromParent_Done,
     /* 106416 */   // Label 2043: @106416
     /* 106416 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(106501), // Rule ID 4048 //
     /* 106421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 106443 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 106450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106470 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106500 */     // GIR_Coverage, 4048,
     /* 106500 */     GIR_EraseRootFromParent_Done,
     /* 106501 */   // Label 2044: @106501
     /* 106501 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(106586), // Rule ID 4049 //
     /* 106506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 106528 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 106535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106555 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106585 */     // GIR_Coverage, 4049,
     /* 106585 */     GIR_EraseRootFromParent_Done,
     /* 106586 */   // Label 2045: @106586
     /* 106586 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(106671), // Rule ID 4050 //
     /* 106591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106613 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 106620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106640 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106670 */     // GIR_Coverage, 4050,
     /* 106670 */     GIR_EraseRootFromParent_Done,
     /* 106671 */   // Label 2046: @106671
     /* 106671 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(106756), // Rule ID 4051 //
     /* 106676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106698 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 106705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106755 */     // GIR_Coverage, 4051,
     /* 106755 */     GIR_EraseRootFromParent_Done,
     /* 106756 */   // Label 2047: @106756
     /* 106756 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(106841), // Rule ID 4052 //
     /* 106761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106783 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 106790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106840 */     // GIR_Coverage, 4052,
     /* 106840 */     GIR_EraseRootFromParent_Done,
     /* 106841 */   // Label 2048: @106841
     /* 106841 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(106926), // Rule ID 4053 //
     /* 106846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106868 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 106875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106895 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106925 */     // GIR_Coverage, 4053,
     /* 106925 */     GIR_EraseRootFromParent_Done,
     /* 106926 */   // Label 2049: @106926
     /* 106926 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(107006), // Rule ID 4085 //
     /* 106931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 106953 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 106953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 106960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106975 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107005 */     // GIR_Coverage, 4085,
     /* 107005 */     GIR_EraseRootFromParent_Done,
     /* 107006 */   // Label 2050: @107006
     /* 107006 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(107086), // Rule ID 4086 //
     /* 107011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107033 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 107040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107055 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107085 */     // GIR_Coverage, 4086,
     /* 107085 */     GIR_EraseRootFromParent_Done,
     /* 107086 */   // Label 2051: @107086
     /* 107086 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(107166), // Rule ID 4088 //
     /* 107091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107113 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 107120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107165 */     // GIR_Coverage, 4088,
     /* 107165 */     GIR_EraseRootFromParent_Done,
     /* 107166 */   // Label 2052: @107166
     /* 107166 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(107246), // Rule ID 4096 //
     /* 107171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 107193 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 107200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107245 */     // GIR_Coverage, 4096,
     /* 107245 */     GIR_EraseRootFromParent_Done,
     /* 107246 */   // Label 2053: @107246
     /* 107246 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(107326), // Rule ID 4122 //
     /* 107251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 107273 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 107280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107325 */     // GIR_Coverage, 4122,
     /* 107325 */     GIR_EraseRootFromParent_Done,
     /* 107326 */   // Label 2054: @107326
     /* 107326 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(107406), // Rule ID 4123 //
     /* 107331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107353 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107375 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107405 */     // GIR_Coverage, 4123,
     /* 107405 */     GIR_EraseRootFromParent_Done,
     /* 107406 */   // Label 2055: @107406
     /* 107406 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(107486), // Rule ID 4124 //
     /* 107411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107433 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107485 */     // GIR_Coverage, 4124,
     /* 107485 */     GIR_EraseRootFromParent_Done,
     /* 107486 */   // Label 2056: @107486
     /* 107486 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(107566), // Rule ID 4125 //
     /* 107491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107513 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107535 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107565 */     // GIR_Coverage, 4125,
     /* 107565 */     GIR_EraseRootFromParent_Done,
     /* 107566 */   // Label 2057: @107566
     /* 107566 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(107646), // Rule ID 4126 //
     /* 107571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107593 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107615 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107645 */     // GIR_Coverage, 4126,
     /* 107645 */     GIR_EraseRootFromParent_Done,
     /* 107646 */   // Label 2058: @107646
     /* 107646 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(107726), // Rule ID 4127 //
     /* 107651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107673 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107695 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107725 */     // GIR_Coverage, 4127,
     /* 107725 */     GIR_EraseRootFromParent_Done,
     /* 107726 */   // Label 2059: @107726
     /* 107726 */   GIM_Reject,
     /* 107727 */ // Label 2041: @107727
     /* 107727 */ GIM_Reject,
     /* 107728 */ // Label 2012: @107728
     /* 107728 */ GIM_Reject,
     /* 107729 */ // Label 19: @107729
     /* 107729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2080*/ GIMT_Encode4(121040),
     /* 107740 */ /*GILLT_s8*//*Label 2060*/ GIMT_Encode4(107836),
     /* 107744 */ /*GILLT_s16*//*Label 2061*/ GIMT_Encode4(108203),
     /* 107748 */ /*GILLT_s32*//*Label 2062*/ GIMT_Encode4(109342),
     /* 107752 */ /*GILLT_s64*//*Label 2063*/ GIMT_Encode4(113937),
     /* 107756 */ /*GILLT_s128*//*Label 2064*/ GIMT_Encode4(117706),
     /* 107760 */ /*GILLT_v2s32*//*Label 2065*/ GIMT_Encode4(117912),
     /* 107764 */ /*GILLT_v2s64*//*Label 2066*/ GIMT_Encode4(118318),
     /* 107768 */ /*GILLT_v4s16*//*Label 2067*/ GIMT_Encode4(118768),
     /* 107772 */ /*GILLT_v4s32*//*Label 2068*/ GIMT_Encode4(119174),
     /* 107776 */ /*GILLT_v8s8*//*Label 2069*/ GIMT_Encode4(119580),
     /* 107780 */ /*GILLT_v8s16*//*Label 2070*/ GIMT_Encode4(119800),
     /* 107784 */ /*GILLT_v16s8*//*Label 2071*/ GIMT_Encode4(120206), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 107796 */ /*GILLT_nxv2s16*//*Label 2072*/ GIMT_Encode4(120426),
     /* 107800 */ /*GILLT_nxv2s32*//*Label 2073*/ GIMT_Encode4(120486),
     /* 107804 */ /*GILLT_nxv2s64*//*Label 2074*/ GIMT_Encode4(120546), GIMT_Encode4(0),
     /* 107812 */ /*GILLT_nxv4s16*//*Label 2075*/ GIMT_Encode4(120656),
     /* 107816 */ /*GILLT_nxv4s32*//*Label 2076*/ GIMT_Encode4(120716), GIMT_Encode4(0),
     /* 107824 */ /*GILLT_nxv8s16*//*Label 2077*/ GIMT_Encode4(120826),
     /* 107828 */ /*GILLT_nxv16s1*//*Label 2078*/ GIMT_Encode4(120936),
     /* 107832 */ /*GILLT_nxv16s8*//*Label 2079*/ GIMT_Encode4(120980),
     /* 107836 */ // Label 2060: @107836
     /* 107836 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(108202),
     /* 107841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107848 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(107916), // Rule ID 12901 //
     /* 107853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 107857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 107878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 107886 */     // MIs[2] Operand 1
     /* 107886 */     // No operand predicates
     /* 107886 */     // MIs[0] Rn
     /* 107886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107896 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 107896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 107899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 107903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 107906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 107908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 107914 */     GIR_RootConstrainSelectedInstOperands,
     /* 107915 */     // GIR_Coverage, 12901,
     /* 107915 */     GIR_EraseRootFromParent_Done,
     /* 107916 */   // Label 2082: @107916
     /* 107916 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(108015), // Rule ID 12902 //
     /* 107921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 107925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 107946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 107954 */     // MIs[2] Operand 1
     /* 107954 */     // No operand predicates
     /* 107954 */     // MIs[0] Rn
     /* 107954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107964 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 107964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 107979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 107983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 107986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 107999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 108005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 108007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 108013 */     GIR_RootConstrainSelectedInstOperands,
     /* 108014 */     // GIR_Coverage, 12902,
     /* 108014 */     GIR_EraseRootFromParent_Done,
     /* 108015 */   // Label 2083: @108015
     /* 108015 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(108064), // Rule ID 303 //
     /* 108020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108038 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 108041 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108062 */     GIR_RootConstrainSelectedInstOperands,
     /* 108063 */     // GIR_Coverage, 303,
     /* 108063 */     GIR_EraseRootFromParent_Done,
     /* 108064 */   // Label 2084: @108064
     /* 108064 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(108113), // Rule ID 304 //
     /* 108069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108087 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 108090 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108111 */     GIR_RootConstrainSelectedInstOperands,
     /* 108112 */     // GIR_Coverage, 304,
     /* 108112 */     GIR_EraseRootFromParent_Done,
     /* 108113 */   // Label 2085: @108113
     /* 108113 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(108157), // Rule ID 313 //
     /* 108118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108136 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 108139 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108155 */     GIR_RootConstrainSelectedInstOperands,
     /* 108156 */     // GIR_Coverage, 313,
     /* 108156 */     GIR_EraseRootFromParent_Done,
     /* 108157 */   // Label 2086: @108157
     /* 108157 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(108201), // Rule ID 321 //
     /* 108162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108180 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 108183 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108199 */     GIR_RootConstrainSelectedInstOperands,
     /* 108200 */     // GIR_Coverage, 321,
     /* 108200 */     GIR_EraseRootFromParent_Done,
     /* 108201 */   // Label 2087: @108201
     /* 108201 */   GIM_Reject,
     /* 108202 */ // Label 2081: @108202
     /* 108202 */ GIM_Reject,
     /* 108203 */ // Label 2061: @108203
     /* 108203 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(109341),
     /* 108208 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108211 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108215 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(108314), // Rule ID 4424 //
     /* 108220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108241 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108258 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108312 */     GIR_RootConstrainSelectedInstOperands,
     /* 108313 */     // GIR_Coverage, 4424,
     /* 108313 */     GIR_EraseRootFromParent_Done,
     /* 108314 */   // Label 2089: @108314
     /* 108314 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(108413), // Rule ID 4425 //
     /* 108319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108340 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108357 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108411 */     GIR_RootConstrainSelectedInstOperands,
     /* 108412 */     // GIR_Coverage, 4425,
     /* 108412 */     GIR_EraseRootFromParent_Done,
     /* 108413 */   // Label 2090: @108413
     /* 108413 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(108512), // Rule ID 12899 //
     /* 108418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108439 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108456 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108468 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108510 */     GIR_RootConstrainSelectedInstOperands,
     /* 108511 */     // GIR_Coverage, 12899,
     /* 108511 */     GIR_EraseRootFromParent_Done,
     /* 108512 */   // Label 2091: @108512
     /* 108512 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(108611), // Rule ID 12900 //
     /* 108517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108555 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108567 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108609 */     GIR_RootConstrainSelectedInstOperands,
     /* 108610 */     // GIR_Coverage, 12900,
     /* 108610 */     GIR_EraseRootFromParent_Done,
     /* 108611 */   // Label 2092: @108611
     /* 108611 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(108705), // Rule ID 4453 //
     /* 108616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108654 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108666 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 108685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108703 */     GIR_RootConstrainSelectedInstOperands,
     /* 108704 */     // GIR_Coverage, 4453,
     /* 108704 */     GIR_EraseRootFromParent_Done,
     /* 108705 */   // Label 2093: @108705
     /* 108705 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(108799), // Rule ID 4478 //
     /* 108710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 108748 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108760 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 108779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108797 */     GIR_RootConstrainSelectedInstOperands,
     /* 108798 */     // GIR_Coverage, 4478,
     /* 108798 */     GIR_EraseRootFromParent_Done,
     /* 108799 */   // Label 2094: @108799
     /* 108799 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(108893), // Rule ID 12898 //
     /* 108804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108842 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108854 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 108873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108891 */     GIR_RootConstrainSelectedInstOperands,
     /* 108892 */     // GIR_Coverage, 12898,
     /* 108892 */     GIR_EraseRootFromParent_Done,
     /* 108893 */   // Label 2095: @108893
     /* 108893 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(108987), // Rule ID 12904 //
     /* 108898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108919 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 108936 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108948 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 108967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108985 */     GIR_RootConstrainSelectedInstOperands,
     /* 108986 */     // GIR_Coverage, 12904,
     /* 108986 */     GIR_EraseRootFromParent_Done,
     /* 108987 */   // Label 2096: @108987
     /* 108987 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(109055), // Rule ID 6371 //
     /* 108992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109021 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109025 */     // MIs[2] Operand 1
     /* 109025 */     // No operand predicates
     /* 109025 */     // MIs[0] Rn
     /* 109025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109035 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109053 */     GIR_RootConstrainSelectedInstOperands,
     /* 109054 */     // GIR_Coverage, 6371,
     /* 109054 */     GIR_EraseRootFromParent_Done,
     /* 109055 */   // Label 2097: @109055
     /* 109055 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(109154), // Rule ID 6376 //
     /* 109060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109093 */     // MIs[2] Operand 1
     /* 109093 */     // No operand predicates
     /* 109093 */     // MIs[0] Rn
     /* 109093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109103 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 109118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109122 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 109125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109152 */     GIR_RootConstrainSelectedInstOperands,
     /* 109153 */     // GIR_Coverage, 6376,
     /* 109153 */     GIR_EraseRootFromParent_Done,
     /* 109154 */   // Label 2098: @109154
     /* 109154 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(109203), // Rule ID 305 //
     /* 109159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109177 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109180 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109201 */     GIR_RootConstrainSelectedInstOperands,
     /* 109202 */     // GIR_Coverage, 305,
     /* 109202 */     GIR_EraseRootFromParent_Done,
     /* 109203 */   // Label 2099: @109203
     /* 109203 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(109252), // Rule ID 306 //
     /* 109208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109226 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109229 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109250 */     GIR_RootConstrainSelectedInstOperands,
     /* 109251 */     // GIR_Coverage, 306,
     /* 109251 */     GIR_EraseRootFromParent_Done,
     /* 109252 */   // Label 2100: @109252
     /* 109252 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(109296), // Rule ID 314 //
     /* 109257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109275 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 109278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109294 */     GIR_RootConstrainSelectedInstOperands,
     /* 109295 */     // GIR_Coverage, 314,
     /* 109295 */     GIR_EraseRootFromParent_Done,
     /* 109296 */   // Label 2101: @109296
     /* 109296 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(109340), // Rule ID 322 //
     /* 109301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109319 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109322 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109338 */     GIR_RootConstrainSelectedInstOperands,
     /* 109339 */     // GIR_Coverage, 322,
     /* 109339 */     GIR_EraseRootFromParent_Done,
     /* 109340 */   // Label 2102: @109340
     /* 109340 */   GIM_Reject,
     /* 109341 */ // Label 2088: @109341
     /* 109341 */ GIM_Reject,
     /* 109342 */ // Label 2062: @109342
     /* 109342 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(109455), // Rule ID 4422 //
     /* 109347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109350 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109361 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109365 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109369 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109377 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109382 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109392 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109399 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109411 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109453 */   GIR_RootConstrainSelectedInstOperands,
     /* 109454 */   // GIR_Coverage, 4422,
     /* 109454 */   GIR_EraseRootFromParent_Done,
     /* 109455 */ // Label 2103: @109455
     /* 109455 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(109568), // Rule ID 4423 //
     /* 109460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109463 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109467 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109482 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109490 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109495 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109512 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109524 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109561 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109566 */   GIR_RootConstrainSelectedInstOperands,
     /* 109567 */   // GIR_Coverage, 4423,
     /* 109567 */   GIR_EraseRootFromParent_Done,
     /* 109568 */ // Label 2104: @109568
     /* 109568 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(109674), // Rule ID 4426 //
     /* 109573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109580 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109588 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109592 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109596 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109601 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109618 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109630 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109641 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 109649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109672 */   GIR_RootConstrainSelectedInstOperands,
     /* 109673 */   // GIR_Coverage, 4426,
     /* 109673 */   GIR_EraseRootFromParent_Done,
     /* 109674 */ // Label 2105: @109674
     /* 109674 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(109780), // Rule ID 4427 //
     /* 109679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109686 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109690 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109694 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109698 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109702 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109707 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109717 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109724 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109736 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 109755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109778 */   GIR_RootConstrainSelectedInstOperands,
     /* 109779 */   // GIR_Coverage, 4427,
     /* 109779 */   GIR_EraseRootFromParent_Done,
     /* 109780 */ // Label 2106: @109780
     /* 109780 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(109886), // Rule ID 4428 //
     /* 109785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109788 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109800 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109804 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109808 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109813 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109830 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109842 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109853 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 109861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109884 */   GIR_RootConstrainSelectedInstOperands,
     /* 109885 */   // GIR_Coverage, 4428,
     /* 109885 */   GIR_EraseRootFromParent_Done,
     /* 109886 */ // Label 2107: @109886
     /* 109886 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(109992), // Rule ID 4429 //
     /* 109891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109910 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109914 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109919 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109936 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109948 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109954 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 109967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109990 */   GIR_RootConstrainSelectedInstOperands,
     /* 109991 */   // GIR_Coverage, 4429,
     /* 109991 */   GIR_EraseRootFromParent_Done,
     /* 109992 */ // Label 2108: @109992
     /* 109992 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(110098), // Rule ID 12906 //
     /* 109997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110004 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110012 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110016 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110020 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110025 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110042 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 110042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110054 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 110073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110096 */   GIR_RootConstrainSelectedInstOperands,
     /* 110097 */   // GIR_Coverage, 12906,
     /* 110097 */   GIR_EraseRootFromParent_Done,
     /* 110098 */ // Label 2109: @110098
     /* 110098 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(110204), // Rule ID 12907 //
     /* 110103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110118 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110122 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110126 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110131 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110148 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 110148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110160 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110166 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110171 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 110179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110202 */   GIR_RootConstrainSelectedInstOperands,
     /* 110203 */   // GIR_Coverage, 12907,
     /* 110203 */   GIR_EraseRootFromParent_Done,
     /* 110204 */ // Label 2110: @110204
     /* 110204 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(110312), // Rule ID 4452 //
     /* 110209 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110212 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110216 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110244 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110254 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110261 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110273 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 110292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110310 */   GIR_RootConstrainSelectedInstOperands,
     /* 110311 */   // GIR_Coverage, 4452,
     /* 110311 */   GIR_EraseRootFromParent_Done,
     /* 110312 */ // Label 2111: @110312
     /* 110312 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(110413), // Rule ID 4454 //
     /* 110317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110345 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110362 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110374 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110411 */   GIR_RootConstrainSelectedInstOperands,
     /* 110412 */   // GIR_Coverage, 4454,
     /* 110412 */   GIR_EraseRootFromParent_Done,
     /* 110413 */ // Label 2112: @110413
     /* 110413 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(110514), // Rule ID 4455 //
     /* 110418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110433 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110437 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110441 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110446 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110463 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110475 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110512 */   GIR_RootConstrainSelectedInstOperands,
     /* 110513 */   // GIR_Coverage, 4455,
     /* 110513 */   GIR_EraseRootFromParent_Done,
     /* 110514 */ // Label 2113: @110514
     /* 110514 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(110622), // Rule ID 4477 //
     /* 110519 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110522 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110526 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110541 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110545 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110554 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110558 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110571 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110583 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 110602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110615 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110620 */   GIR_RootConstrainSelectedInstOperands,
     /* 110621 */   // GIR_Coverage, 4477,
     /* 110621 */   GIR_EraseRootFromParent_Done,
     /* 110622 */ // Label 2114: @110622
     /* 110622 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(110723), // Rule ID 4479 //
     /* 110627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110634 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110642 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110646 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110650 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110655 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110672 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110684 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 110703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110721 */   GIR_RootConstrainSelectedInstOperands,
     /* 110722 */   // GIR_Coverage, 4479,
     /* 110722 */   GIR_EraseRootFromParent_Done,
     /* 110723 */ // Label 2115: @110723
     /* 110723 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(110824), // Rule ID 4480 //
     /* 110728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110743 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110747 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110751 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110756 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110773 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110785 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110791 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 110804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110822 */   GIR_RootConstrainSelectedInstOperands,
     /* 110823 */   // GIR_Coverage, 4480,
     /* 110823 */   GIR_EraseRootFromParent_Done,
     /* 110824 */ // Label 2116: @110824
     /* 110824 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(110925), // Rule ID 12903 //
     /* 110829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110832 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110844 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110848 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110852 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110857 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110865 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110874 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110886 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110923 */   GIR_RootConstrainSelectedInstOperands,
     /* 110924 */   // GIR_Coverage, 12903,
     /* 110924 */   GIR_EraseRootFromParent_Done,
     /* 110925 */ // Label 2117: @110925
     /* 110925 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111026), // Rule ID 12905 //
     /* 110930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110933 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110958 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110968 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 110975 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110987 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 111006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111024 */   GIR_RootConstrainSelectedInstOperands,
     /* 111025 */   // GIR_Coverage, 12905,
     /* 111025 */   GIR_EraseRootFromParent_Done,
     /* 111026 */ // Label 2118: @111026
     /* 111026 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111108), // Rule ID 6365 //
     /* 111031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111034 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111057 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111061 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111066 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111070 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111074 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111078 */   // MIs[2] Operand 1
     /* 111078 */   // No operand predicates
     /* 111078 */   // MIs[0] Rn
     /* 111078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111086 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111088 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111091 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111095 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111098 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111106 */   GIR_RootConstrainSelectedInstOperands,
     /* 111107 */   // GIR_Coverage, 6365,
     /* 111107 */   GIR_EraseRootFromParent_Done,
     /* 111108 */ // Label 2119: @111108
     /* 111108 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111190), // Rule ID 6366 //
     /* 111113 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111116 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111143 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111148 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111152 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111156 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111160 */   // MIs[2] Operand 1
     /* 111160 */   // No operand predicates
     /* 111160 */   // MIs[0] Rn
     /* 111160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111168 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111170 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111173 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111177 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111180 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111188 */   GIR_RootConstrainSelectedInstOperands,
     /* 111189 */   // GIR_Coverage, 6366,
     /* 111189 */   GIR_EraseRootFromParent_Done,
     /* 111190 */ // Label 2120: @111190
     /* 111190 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111265), // Rule ID 6367 //
     /* 111195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111198 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111210 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111218 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111223 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111227 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111231 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111235 */   // MIs[2] Operand 1
     /* 111235 */   // No operand predicates
     /* 111235 */   // MIs[0] Rn
     /* 111235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111243 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111245 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111248 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111252 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111255 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111257 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111263 */   GIR_RootConstrainSelectedInstOperands,
     /* 111264 */   // GIR_Coverage, 6367,
     /* 111264 */   GIR_EraseRootFromParent_Done,
     /* 111265 */ // Label 2121: @111265
     /* 111265 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111340), // Rule ID 6368 //
     /* 111270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111277 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111285 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111289 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111293 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111298 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111302 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111306 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111310 */   // MIs[2] Operand 1
     /* 111310 */   // No operand predicates
     /* 111310 */   // MIs[0] Rn
     /* 111310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111318 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111320 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111323 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111327 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111330 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111338 */   GIR_RootConstrainSelectedInstOperands,
     /* 111339 */   // GIR_Coverage, 6368,
     /* 111339 */   GIR_EraseRootFromParent_Done,
     /* 111340 */ // Label 2122: @111340
     /* 111340 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111453), // Rule ID 6372 //
     /* 111345 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111348 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111352 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111375 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111380 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111384 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111388 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111392 */   // MIs[2] Operand 1
     /* 111392 */   // No operand predicates
     /* 111392 */   // MIs[0] Rn
     /* 111392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111400 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111402 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111414 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111417 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111421 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111440 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111443 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111451 */   GIR_RootConstrainSelectedInstOperands,
     /* 111452 */   // GIR_Coverage, 6372,
     /* 111452 */   GIR_EraseRootFromParent_Done,
     /* 111453 */ // Label 2123: @111453
     /* 111453 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111566), // Rule ID 6373 //
     /* 111458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111461 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111465 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111480 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111484 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111488 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111493 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111497 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111501 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111505 */   // MIs[2] Operand 1
     /* 111505 */   // No operand predicates
     /* 111505 */   // MIs[0] Rn
     /* 111505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111513 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111515 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111527 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111534 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111542 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111553 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111556 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111564 */   GIR_RootConstrainSelectedInstOperands,
     /* 111565 */   // GIR_Coverage, 6373,
     /* 111565 */   GIR_EraseRootFromParent_Done,
     /* 111566 */ // Label 2124: @111566
     /* 111566 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111672), // Rule ID 6374 //
     /* 111571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111574 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111599 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111603 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111607 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111611 */   // MIs[2] Operand 1
     /* 111611 */   // No operand predicates
     /* 111611 */   // MIs[0] Rn
     /* 111611 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111619 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111621 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111633 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111640 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111643 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111648 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111659 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111662 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111670 */   GIR_RootConstrainSelectedInstOperands,
     /* 111671 */   // GIR_Coverage, 6374,
     /* 111671 */   GIR_EraseRootFromParent_Done,
     /* 111672 */ // Label 2125: @111672
     /* 111672 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111778), // Rule ID 6375 //
     /* 111677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111692 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111696 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111700 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111705 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111709 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111713 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111717 */   // MIs[2] Operand 1
     /* 111717 */   // No operand predicates
     /* 111717 */   // MIs[0] Rn
     /* 111717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111725 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111727 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111739 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111746 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111754 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111765 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111768 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111776 */   GIR_RootConstrainSelectedInstOperands,
     /* 111777 */   // GIR_Coverage, 6375,
     /* 111777 */   GIR_EraseRootFromParent_Done,
     /* 111778 */ // Label 2126: @111778
     /* 111778 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111838), // Rule ID 295 //
     /* 111783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111786 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111790 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111812 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 111812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 111815 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111836 */   GIR_RootConstrainSelectedInstOperands,
     /* 111837 */   // GIR_Coverage, 295,
     /* 111837 */   GIR_EraseRootFromParent_Done,
     /* 111838 */ // Label 2127: @111838
     /* 111838 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111898), // Rule ID 296 //
     /* 111843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111846 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111850 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111872 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 111872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 111875 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111896 */   GIR_RootConstrainSelectedInstOperands,
     /* 111897 */   // GIR_Coverage, 296,
     /* 111897 */   GIR_EraseRootFromParent_Done,
     /* 111898 */ // Label 2128: @111898
     /* 111898 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111958), // Rule ID 297 //
     /* 111903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111906 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111925 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111932 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 111932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 111935 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111956 */   GIR_RootConstrainSelectedInstOperands,
     /* 111957 */   // GIR_Coverage, 297,
     /* 111957 */   GIR_EraseRootFromParent_Done,
     /* 111958 */ // Label 2129: @111958
     /* 111958 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112018), // Rule ID 298 //
     /* 111963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111966 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111970 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 111992 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 111992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 111995 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112016 */   GIR_RootConstrainSelectedInstOperands,
     /* 112017 */   // GIR_Coverage, 298,
     /* 112017 */   GIR_EraseRootFromParent_Done,
     /* 112018 */ // Label 2130: @112018
     /* 112018 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112071), // Rule ID 299 //
     /* 112023 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112026 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112038 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112045 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 112048 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112069 */   GIR_RootConstrainSelectedInstOperands,
     /* 112070 */   // GIR_Coverage, 299,
     /* 112070 */   GIR_EraseRootFromParent_Done,
     /* 112071 */ // Label 2131: @112071
     /* 112071 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112124), // Rule ID 300 //
     /* 112076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112079 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112098 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 112101 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112122 */   GIR_RootConstrainSelectedInstOperands,
     /* 112123 */   // GIR_Coverage, 300,
     /* 112123 */   GIR_EraseRootFromParent_Done,
     /* 112124 */ // Label 2132: @112124
     /* 112124 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112180), // Rule ID 307 //
     /* 112129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112143 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112147 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112154 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112157 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112174 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112178 */   GIR_RootConstrainSelectedInstOperands,
     /* 112179 */   // GIR_Coverage, 307,
     /* 112179 */   GIR_EraseRootFromParent_Done,
     /* 112180 */ // Label 2133: @112180
     /* 112180 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112236), // Rule ID 308 //
     /* 112185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112188 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112191 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112199 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112203 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112210 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112213 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112234 */   GIR_RootConstrainSelectedInstOperands,
     /* 112235 */   // GIR_Coverage, 308,
     /* 112235 */   GIR_EraseRootFromParent_Done,
     /* 112236 */ // Label 2134: @112236
     /* 112236 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112288), // Rule ID 312 //
     /* 112241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112263 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 112266 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112286 */   GIR_RootConstrainSelectedInstOperands,
     /* 112287 */   // GIR_Coverage, 312,
     /* 112287 */   GIR_EraseRootFromParent_Done,
     /* 112288 */ // Label 2135: @112288
     /* 112288 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112339), // Rule ID 315 //
     /* 112293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112318 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 112321 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112337 */   GIR_RootConstrainSelectedInstOperands,
     /* 112338 */   // GIR_Coverage, 315,
     /* 112338 */   GIR_EraseRootFromParent_Done,
     /* 112339 */ // Label 2136: @112339
     /* 112339 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112398), // Rule ID 317 //
     /* 112344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112347 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112351 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112362 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112366 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112373 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 112376 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112392 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112396 */   GIR_RootConstrainSelectedInstOperands,
     /* 112397 */   // GIR_Coverage, 317,
     /* 112397 */   GIR_EraseRootFromParent_Done,
     /* 112398 */ // Label 2137: @112398
     /* 112398 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112457), // Rule ID 318 //
     /* 112403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112406 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112410 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112421 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112425 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112432 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 112435 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112455 */   GIR_RootConstrainSelectedInstOperands,
     /* 112456 */   // GIR_Coverage, 318,
     /* 112456 */   GIR_EraseRootFromParent_Done,
     /* 112457 */ // Label 2138: @112457
     /* 112457 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112534), // Rule ID 6992 //
     /* 112462 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112465 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112472 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112483 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112505 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112508 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112532 */   GIR_RootConstrainSelectedInstOperands,
     /* 112533 */   // GIR_Coverage, 6992,
     /* 112533 */   GIR_EraseRootFromParent_Done,
     /* 112534 */ // Label 2139: @112534
     /* 112534 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112611), // Rule ID 6993 //
     /* 112539 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112549 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112560 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112564 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112582 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112585 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112604 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112609 */   GIR_RootConstrainSelectedInstOperands,
     /* 112610 */   // GIR_Coverage, 6993,
     /* 112610 */   GIR_EraseRootFromParent_Done,
     /* 112611 */ // Label 2140: @112611
     /* 112611 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112670), // Rule ID 6973 //
     /* 112616 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112619 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112626 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112644 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15537>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 112647 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112668 */   GIR_RootConstrainSelectedInstOperands,
     /* 112669 */   // GIR_Coverage, 6973,
     /* 112669 */   GIR_EraseRootFromParent_Done,
     /* 112670 */ // Label 2141: @112670
     /* 112670 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112729), // Rule ID 6974 //
     /* 112675 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112678 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112685 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112703 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15537>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 112706 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112723 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112727 */   GIR_RootConstrainSelectedInstOperands,
     /* 112728 */   // GIR_Coverage, 6974,
     /* 112728 */   GIR_EraseRootFromParent_Done,
     /* 112729 */ // Label 2142: @112729
     /* 112729 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112788), // Rule ID 6978 //
     /* 112734 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112744 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112762 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15544>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 112765 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112786 */   GIR_RootConstrainSelectedInstOperands,
     /* 112787 */   // GIR_Coverage, 6978,
     /* 112787 */   GIR_EraseRootFromParent_Done,
     /* 112788 */ // Label 2143: @112788
     /* 112788 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112847), // Rule ID 6979 //
     /* 112793 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112796 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112803 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112821 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15544>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 112824 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112845 */   GIR_RootConstrainSelectedInstOperands,
     /* 112846 */   // GIR_Coverage, 6979,
     /* 112846 */   GIR_EraseRootFromParent_Done,
     /* 112847 */ // Label 2144: @112847
     /* 112847 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(112906), // Rule ID 6983 //
     /* 112852 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112862 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112880 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 112883 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112904 */   GIR_RootConstrainSelectedInstOperands,
     /* 112905 */   // GIR_Coverage, 6983,
     /* 112905 */   GIR_EraseRootFromParent_Done,
     /* 112906 */ // Label 2145: @112906
     /* 112906 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(112965), // Rule ID 6984 //
     /* 112911 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112914 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112921 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112939 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 112942 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112963 */   GIR_RootConstrainSelectedInstOperands,
     /* 112964 */   // GIR_Coverage, 6984,
     /* 112964 */   GIR_EraseRootFromParent_Done,
     /* 112965 */ // Label 2146: @112965
     /* 112965 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113037), // Rule ID 6994 //
     /* 112970 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112980 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112991 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112995 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113006 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113013 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113016 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113035 */   GIR_RootConstrainSelectedInstOperands,
     /* 113036 */   // GIR_Coverage, 6994,
     /* 113036 */   GIR_EraseRootFromParent_Done,
     /* 113037 */ // Label 2147: @113037
     /* 113037 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113109), // Rule ID 6995 //
     /* 113042 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113045 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113052 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113063 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113067 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113085 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113088 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113107 */   GIR_RootConstrainSelectedInstOperands,
     /* 113108 */   // GIR_Coverage, 6995,
     /* 113108 */   GIR_EraseRootFromParent_Done,
     /* 113109 */ // Label 2148: @113109
     /* 113109 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113161), // Rule ID 320 //
     /* 113114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113117 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113136 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113139 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113159 */   GIR_RootConstrainSelectedInstOperands,
     /* 113160 */   // GIR_Coverage, 320,
     /* 113160 */   GIR_EraseRootFromParent_Done,
     /* 113161 */ // Label 2149: @113161
     /* 113161 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113212), // Rule ID 323 //
     /* 113166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113172 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113191 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113194 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113210 */   GIR_RootConstrainSelectedInstOperands,
     /* 113211 */   // GIR_Coverage, 323,
     /* 113211 */   GIR_EraseRootFromParent_Done,
     /* 113212 */ // Label 2150: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113271), // Rule ID 326 //
     /* 113217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113220 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113246 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113249 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113269 */   GIR_RootConstrainSelectedInstOperands,
     /* 113270 */   // GIR_Coverage, 326,
     /* 113270 */   GIR_EraseRootFromParent_Done,
     /* 113271 */ // Label 2151: @113271
     /* 113271 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113330), // Rule ID 327 //
     /* 113276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113279 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113294 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113305 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113308 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113328 */   GIR_RootConstrainSelectedInstOperands,
     /* 113329 */   // GIR_Coverage, 327,
     /* 113329 */   GIR_EraseRootFromParent_Done,
     /* 113330 */ // Label 2152: @113330
     /* 113330 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113384), // Rule ID 6975 //
     /* 113335 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113345 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113352 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 113363 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15537>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 113363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 113366 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113382 */   GIR_RootConstrainSelectedInstOperands,
     /* 113383 */   // GIR_Coverage, 6975,
     /* 113383 */   GIR_EraseRootFromParent_Done,
     /* 113384 */ // Label 2153: @113384
     /* 113384 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113438), // Rule ID 6976 //
     /* 113389 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113399 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113417 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15537>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113420 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113436 */   GIR_RootConstrainSelectedInstOperands,
     /* 113437 */   // GIR_Coverage, 6976,
     /* 113437 */   GIR_EraseRootFromParent_Done,
     /* 113438 */ // Label 2154: @113438
     /* 113438 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113492), // Rule ID 6980 //
     /* 113443 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113453 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113471 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15544>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 113474 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113490 */   GIR_RootConstrainSelectedInstOperands,
     /* 113491 */   // GIR_Coverage, 6980,
     /* 113491 */   GIR_EraseRootFromParent_Done,
     /* 113492 */ // Label 2155: @113492
     /* 113492 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113546), // Rule ID 6981 //
     /* 113497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113507 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113525 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15544>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113528 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113544 */   GIR_RootConstrainSelectedInstOperands,
     /* 113545 */   // GIR_Coverage, 6981,
     /* 113545 */   GIR_EraseRootFromParent_Done,
     /* 113546 */ // Label 2156: @113546
     /* 113546 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113600), // Rule ID 6985 //
     /* 113551 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113554 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113561 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113579 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 113582 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113598 */   GIR_RootConstrainSelectedInstOperands,
     /* 113599 */   // GIR_Coverage, 6985,
     /* 113599 */   GIR_EraseRootFromParent_Done,
     /* 113600 */ // Label 2157: @113600
     /* 113600 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113654), // Rule ID 6986 //
     /* 113605 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113615 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113633 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15551>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113636 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113652 */   GIR_RootConstrainSelectedInstOperands,
     /* 113653 */   // GIR_Coverage, 6986,
     /* 113653 */   GIR_EraseRootFromParent_Done,
     /* 113654 */ // Label 2158: @113654
     /* 113654 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113711), // Rule ID 7278 //
     /* 113659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113662 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113672 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113690 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15535>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 113693 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113709 */   GIR_RootConstrainSelectedInstOperands,
     /* 113710 */   // GIR_Coverage, 7278,
     /* 113710 */   GIR_EraseRootFromParent_Done,
     /* 113711 */ // Label 2159: @113711
     /* 113711 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113768), // Rule ID 7279 //
     /* 113716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113729 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113747 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15542>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 113750 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113766 */   GIR_RootConstrainSelectedInstOperands,
     /* 113767 */   // GIR_Coverage, 7279,
     /* 113767 */   GIR_EraseRootFromParent_Done,
     /* 113768 */ // Label 2160: @113768
     /* 113768 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113825), // Rule ID 7280 //
     /* 113773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113776 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113779 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113786 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113804 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15549>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 113807 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113823 */   GIR_RootConstrainSelectedInstOperands,
     /* 113824 */   // GIR_Coverage, 7280,
     /* 113824 */   GIR_EraseRootFromParent_Done,
     /* 113825 */ // Label 2161: @113825
     /* 113825 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113862), // Rule ID 6972 //
     /* 113830 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113840 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113847 */   // MIs[0] ptr
     /* 113847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113855 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15535>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 113855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 113860 */   GIR_RootConstrainSelectedInstOperands,
     /* 113861 */   // GIR_Coverage, 6972,
     /* 113861 */   GIR_Done,
     /* 113862 */ // Label 2162: @113862
     /* 113862 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113899), // Rule ID 6977 //
     /* 113867 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113884 */   // MIs[0] ptr
     /* 113884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113892 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15542>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 113892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 113897 */   GIR_RootConstrainSelectedInstOperands,
     /* 113898 */   // GIR_Coverage, 6977,
     /* 113898 */   GIR_Done,
     /* 113899 */ // Label 2163: @113899
     /* 113899 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113936), // Rule ID 6982 //
     /* 113904 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113907 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113914 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113921 */   // MIs[0] ptr
     /* 113921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113929 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15549>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 113929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 113934 */   GIR_RootConstrainSelectedInstOperands,
     /* 113935 */   // GIR_Coverage, 6982,
     /* 113935 */   GIR_Done,
     /* 113936 */ // Label 2164: @113936
     /* 113936 */ GIM_Reject,
     /* 113937 */ // Label 2063: @113937
     /* 113937 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114043), // Rule ID 4430 //
     /* 113942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113945 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113957 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113961 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113965 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113970 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 113987 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 113987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 113990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113999 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114041 */   GIR_RootConstrainSelectedInstOperands,
     /* 114042 */   // GIR_Coverage, 4430,
     /* 114042 */   GIR_EraseRootFromParent_Done,
     /* 114043 */ // Label 2165: @114043
     /* 114043 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114149), // Rule ID 4431 //
     /* 114048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114051 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114063 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114071 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114076 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114086 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114093 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114105 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114147 */   GIR_RootConstrainSelectedInstOperands,
     /* 114148 */   // GIR_Coverage, 4431,
     /* 114148 */   GIR_EraseRootFromParent_Done,
     /* 114149 */ // Label 2166: @114149
     /* 114149 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114255), // Rule ID 4432 //
     /* 114154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114157 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114161 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114169 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114177 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114182 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114199 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114211 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114253 */   GIR_RootConstrainSelectedInstOperands,
     /* 114254 */   // GIR_Coverage, 4432,
     /* 114254 */   GIR_EraseRootFromParent_Done,
     /* 114255 */ // Label 2167: @114255
     /* 114255 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114361), // Rule ID 4433 //
     /* 114260 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114263 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114275 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114279 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114283 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114288 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114305 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114317 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114359 */   GIR_RootConstrainSelectedInstOperands,
     /* 114360 */   // GIR_Coverage, 4433,
     /* 114360 */   GIR_EraseRootFromParent_Done,
     /* 114361 */ // Label 2168: @114361
     /* 114361 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114462), // Rule ID 4456 //
     /* 114366 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114369 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114381 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114385 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114389 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114394 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114398 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114411 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114423 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114455 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114460 */   GIR_RootConstrainSelectedInstOperands,
     /* 114461 */   // GIR_Coverage, 4456,
     /* 114461 */   GIR_EraseRootFromParent_Done,
     /* 114462 */ // Label 2169: @114462
     /* 114462 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114563), // Rule ID 4457 //
     /* 114467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114482 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114490 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114495 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114512 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114524 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114561 */   GIR_RootConstrainSelectedInstOperands,
     /* 114562 */   // GIR_Coverage, 4457,
     /* 114562 */   GIR_EraseRootFromParent_Done,
     /* 114563 */ // Label 2170: @114563
     /* 114563 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114664), // Rule ID 4481 //
     /* 114568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114571 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114591 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114596 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114613 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114625 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114662 */   GIR_RootConstrainSelectedInstOperands,
     /* 114663 */   // GIR_Coverage, 4481,
     /* 114663 */   GIR_EraseRootFromParent_Done,
     /* 114664 */ // Label 2171: @114664
     /* 114664 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114765), // Rule ID 4482 //
     /* 114669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114688 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114692 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114697 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114714 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114726 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114763 */   GIR_RootConstrainSelectedInstOperands,
     /* 114764 */   // GIR_Coverage, 4482,
     /* 114764 */   GIR_EraseRootFromParent_Done,
     /* 114765 */ // Label 2172: @114765
     /* 114765 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114840), // Rule ID 6369 //
     /* 114770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114798 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114802 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114806 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 114810 */   // MIs[2] Operand 1
     /* 114810 */   // No operand predicates
     /* 114810 */   // MIs[0] Rn
     /* 114810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114818 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114820 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 114823 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114827 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114830 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114838 */   GIR_RootConstrainSelectedInstOperands,
     /* 114839 */   // GIR_Coverage, 6369,
     /* 114839 */   GIR_EraseRootFromParent_Done,
     /* 114840 */ // Label 2173: @114840
     /* 114840 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114915), // Rule ID 6370 //
     /* 114845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114873 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114877 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114881 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 114885 */   // MIs[2] Operand 1
     /* 114885 */   // No operand predicates
     /* 114885 */   // MIs[0] Rn
     /* 114885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114893 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114895 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 114898 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114902 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114905 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114913 */   GIR_RootConstrainSelectedInstOperands,
     /* 114914 */   // GIR_Coverage, 6370,
     /* 114914 */   GIR_EraseRootFromParent_Done,
     /* 114915 */ // Label 2174: @114915
     /* 114915 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114968), // Rule ID 301 //
     /* 114920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 114931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114935 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114942 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 114945 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114966 */   GIR_RootConstrainSelectedInstOperands,
     /* 114967 */   // GIR_Coverage, 301,
     /* 114967 */   GIR_EraseRootFromParent_Done,
     /* 114968 */ // Label 2175: @114968
     /* 114968 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(115021), // Rule ID 302 //
     /* 114973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 114984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114995 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 114998 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115019 */   GIR_RootConstrainSelectedInstOperands,
     /* 115020 */   // GIR_Coverage, 302,
     /* 115020 */   GIR_EraseRootFromParent_Done,
     /* 115021 */ // Label 2176: @115021
     /* 115021 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(115077), // Rule ID 309 //
     /* 115026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115044 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115051 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115054 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115071 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115075 */   GIR_RootConstrainSelectedInstOperands,
     /* 115076 */   // GIR_Coverage, 309,
     /* 115076 */   GIR_EraseRootFromParent_Done,
     /* 115077 */ // Label 2177: @115077
     /* 115077 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(115133), // Rule ID 310 //
     /* 115082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115088 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115107 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115110 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115131 */   GIR_RootConstrainSelectedInstOperands,
     /* 115132 */   // GIR_Coverage, 310,
     /* 115132 */   GIR_EraseRootFromParent_Done,
     /* 115133 */ // Label 2178: @115133
     /* 115133 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(115222), // Rule ID 4388 //
     /* 115138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115141 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115167 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115179 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115220 */   GIR_RootConstrainSelectedInstOperands,
     /* 115221 */   // GIR_Coverage, 4388,
     /* 115221 */   GIR_EraseRootFromParent_Done,
     /* 115222 */ // Label 2179: @115222
     /* 115222 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(115311), // Rule ID 4389 //
     /* 115227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115230 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115234 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115245 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115249 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115256 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115268 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115309 */   GIR_RootConstrainSelectedInstOperands,
     /* 115310 */   // GIR_Coverage, 4389,
     /* 115310 */   GIR_EraseRootFromParent_Done,
     /* 115311 */ // Label 2180: @115311
     /* 115311 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(115400), // Rule ID 4390 //
     /* 115316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115319 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115345 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115357 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115363 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115398 */   GIR_RootConstrainSelectedInstOperands,
     /* 115399 */   // GIR_Coverage, 4390,
     /* 115399 */   GIR_EraseRootFromParent_Done,
     /* 115400 */ // Label 2181: @115400
     /* 115400 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(115489), // Rule ID 4391 //
     /* 115405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115408 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115434 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115446 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115465 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115487 */   GIR_RootConstrainSelectedInstOperands,
     /* 115488 */   // GIR_Coverage, 4391,
     /* 115488 */   GIR_EraseRootFromParent_Done,
     /* 115489 */ // Label 2182: @115489
     /* 115489 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(115578), // Rule ID 4392 //
     /* 115494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115497 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115523 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115535 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115541 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115576 */   GIR_RootConstrainSelectedInstOperands,
     /* 115577 */   // GIR_Coverage, 4392,
     /* 115577 */   GIR_EraseRootFromParent_Done,
     /* 115578 */ // Label 2183: @115578
     /* 115578 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(115667), // Rule ID 4393 //
     /* 115583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115586 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115601 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115605 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115612 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115624 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115630 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115635 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115665 */   GIR_RootConstrainSelectedInstOperands,
     /* 115666 */   // GIR_Coverage, 4393,
     /* 115666 */   GIR_EraseRootFromParent_Done,
     /* 115667 */ // Label 2184: @115667
     /* 115667 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115720), // Rule ID 4404 //
     /* 115672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115675 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115694 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115697 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115718 */   GIR_RootConstrainSelectedInstOperands,
     /* 115719 */   // GIR_Coverage, 4404,
     /* 115719 */   GIR_EraseRootFromParent_Done,
     /* 115720 */ // Label 2185: @115720
     /* 115720 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115773), // Rule ID 4405 //
     /* 115725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115747 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115750 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115771 */   GIR_RootConstrainSelectedInstOperands,
     /* 115772 */   // GIR_Coverage, 4405,
     /* 115772 */   GIR_EraseRootFromParent_Done,
     /* 115773 */ // Label 2186: @115773
     /* 115773 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115826), // Rule ID 4406 //
     /* 115778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115781 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115800 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115803 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115824 */   GIR_RootConstrainSelectedInstOperands,
     /* 115825 */   // GIR_Coverage, 4406,
     /* 115825 */   GIR_EraseRootFromParent_Done,
     /* 115826 */ // Label 2187: @115826
     /* 115826 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115879), // Rule ID 4407 //
     /* 115831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115853 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115856 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115877 */   GIR_RootConstrainSelectedInstOperands,
     /* 115878 */   // GIR_Coverage, 4407,
     /* 115878 */   GIR_EraseRootFromParent_Done,
     /* 115879 */ // Label 2188: @115879
     /* 115879 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(115931), // Rule ID 311 //
     /* 115884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115895 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115899 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 115906 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 115906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 115909 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 115915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115929 */   GIR_RootConstrainSelectedInstOperands,
     /* 115930 */   // GIR_Coverage, 311,
     /* 115930 */   GIR_EraseRootFromParent_Done,
     /* 115931 */ // Label 2189: @115931
     /* 115931 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(115982), // Rule ID 316 //
     /* 115936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 115961 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 115961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 115964 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115980 */   GIR_RootConstrainSelectedInstOperands,
     /* 115981 */   // GIR_Coverage, 316,
     /* 115981 */   GIR_EraseRootFromParent_Done,
     /* 115982 */ // Label 2190: @115982
     /* 115982 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(116030), // Rule ID 4434 //
     /* 115987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116009 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116012 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116028 */   GIR_RootConstrainSelectedInstOperands,
     /* 116029 */   // GIR_Coverage, 4434,
     /* 116029 */   GIR_EraseRootFromParent_Done,
     /* 116030 */ // Label 2191: @116030
     /* 116030 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(116078), // Rule ID 4435 //
     /* 116035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116050 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116057 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116060 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116076 */   GIR_RootConstrainSelectedInstOperands,
     /* 116077 */   // GIR_Coverage, 4435,
     /* 116077 */   GIR_EraseRootFromParent_Done,
     /* 116078 */ // Label 2192: @116078
     /* 116078 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(116162), // Rule ID 4449 //
     /* 116083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116112 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116124 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116160 */   GIR_RootConstrainSelectedInstOperands,
     /* 116161 */   // GIR_Coverage, 4449,
     /* 116161 */   GIR_EraseRootFromParent_Done,
     /* 116162 */ // Label 2193: @116162
     /* 116162 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(116246), // Rule ID 4450 //
     /* 116167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116170 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116196 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116208 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116244 */   GIR_RootConstrainSelectedInstOperands,
     /* 116245 */   // GIR_Coverage, 4450,
     /* 116245 */   GIR_EraseRootFromParent_Done,
     /* 116246 */ // Label 2194: @116246
     /* 116246 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(116330), // Rule ID 4451 //
     /* 116251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116254 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116258 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116280 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116292 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116328 */   GIR_RootConstrainSelectedInstOperands,
     /* 116329 */   // GIR_Coverage, 4451,
     /* 116329 */   GIR_EraseRootFromParent_Done,
     /* 116330 */ // Label 2195: @116330
     /* 116330 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(116407), // Rule ID 6996 //
     /* 116335 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116345 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116356 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116378 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 116381 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116400 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116405 */   GIR_RootConstrainSelectedInstOperands,
     /* 116406 */   // GIR_Coverage, 6996,
     /* 116406 */   GIR_EraseRootFromParent_Done,
     /* 116407 */ // Label 2196: @116407
     /* 116407 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(116484), // Rule ID 6997 //
     /* 116412 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116415 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116422 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116433 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116455 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 116458 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116482 */   GIR_RootConstrainSelectedInstOperands,
     /* 116483 */   // GIR_Coverage, 6997,
     /* 116483 */   GIR_EraseRootFromParent_Done,
     /* 116484 */ // Label 2197: @116484
     /* 116484 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(116543), // Rule ID 6988 //
     /* 116489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116499 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116517 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 116520 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116541 */   GIR_RootConstrainSelectedInstOperands,
     /* 116542 */   // GIR_Coverage, 6988,
     /* 116542 */   GIR_EraseRootFromParent_Done,
     /* 116543 */ // Label 2198: @116543
     /* 116543 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(116602), // Rule ID 6989 //
     /* 116548 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116551 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116558 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116565 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116569 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116576 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 116579 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116600 */   GIR_RootConstrainSelectedInstOperands,
     /* 116601 */   // GIR_Coverage, 6989,
     /* 116601 */   GIR_EraseRootFromParent_Done,
     /* 116602 */ // Label 2199: @116602
     /* 116602 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(116674), // Rule ID 6998 //
     /* 116607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116617 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116628 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116632 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116650 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116653 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116672 */   GIR_RootConstrainSelectedInstOperands,
     /* 116673 */   // GIR_Coverage, 6998,
     /* 116673 */   GIR_EraseRootFromParent_Done,
     /* 116674 */ // Label 2200: @116674
     /* 116674 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(116746), // Rule ID 6999 //
     /* 116679 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116682 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116689 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116700 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116713 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116722 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 116725 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116744 */   GIR_RootConstrainSelectedInstOperands,
     /* 116745 */   // GIR_Coverage, 6999,
     /* 116745 */   GIR_EraseRootFromParent_Done,
     /* 116746 */ // Label 2201: @116746
     /* 116746 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(116843), // Rule ID 7270 //
     /* 116751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 116754 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116764 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116775 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116779 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 116783 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116787 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116791 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 116795 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116800 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 116804 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116808 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 116812 */   // MIs[3] Operand 1
     /* 116812 */   // No operand predicates
     /* 116812 */   // MIs[0] Rn
     /* 116812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116820 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 116822 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15556>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 116825 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 116829 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 116832 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 116841 */   GIR_RootConstrainSelectedInstOperands,
     /* 116842 */   // GIR_Coverage, 7270,
     /* 116842 */   GIR_EraseRootFromParent_Done,
     /* 116843 */ // Label 2202: @116843
     /* 116843 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(116895), // Rule ID 319 //
     /* 116848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116851 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116870 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 116873 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 116879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116893 */   GIR_RootConstrainSelectedInstOperands,
     /* 116894 */   // GIR_Coverage, 319,
     /* 116894 */   GIR_EraseRootFromParent_Done,
     /* 116895 */ // Label 2203: @116895
     /* 116895 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(116946), // Rule ID 324 //
     /* 116900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116925 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 116928 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116944 */   GIR_RootConstrainSelectedInstOperands,
     /* 116945 */   // GIR_Coverage, 324,
     /* 116945 */   GIR_EraseRootFromParent_Done,
     /* 116946 */ // Label 2204: @116946
     /* 116946 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(117000), // Rule ID 6990 //
     /* 116951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116961 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116979 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 116982 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116998 */   GIR_RootConstrainSelectedInstOperands,
     /* 116999 */   // GIR_Coverage, 6990,
     /* 116999 */   GIR_EraseRootFromParent_Done,
     /* 117000 */ // Label 2205: @117000
     /* 117000 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(117054), // Rule ID 6991 //
     /* 117005 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117008 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117015 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117022 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117026 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117033 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15558>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 117036 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117048 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117052 */   GIR_RootConstrainSelectedInstOperands,
     /* 117053 */   // GIR_Coverage, 6991,
     /* 117053 */   GIR_EraseRootFromParent_Done,
     /* 117054 */ // Label 2206: @117054
     /* 117054 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(117111), // Rule ID 7281 //
     /* 117059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117072 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117090 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15556>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 117093 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117109 */   GIR_RootConstrainSelectedInstOperands,
     /* 117110 */   // GIR_Coverage, 7281,
     /* 117110 */   GIR_EraseRootFromParent_Done,
     /* 117111 */ // Label 2207: @117111
     /* 117111 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(117159), // Rule ID 4458 //
     /* 117116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117138 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117141 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117157 */   GIR_RootConstrainSelectedInstOperands,
     /* 117158 */   // GIR_Coverage, 4458,
     /* 117158 */   GIR_EraseRootFromParent_Done,
     /* 117159 */ // Label 2208: @117159
     /* 117159 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(117207), // Rule ID 4459 //
     /* 117164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117179 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117186 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117189 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117205 */   GIR_RootConstrainSelectedInstOperands,
     /* 117206 */   // GIR_Coverage, 4459,
     /* 117206 */   GIR_EraseRootFromParent_Done,
     /* 117207 */ // Label 2209: @117207
     /* 117207 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(117291), // Rule ID 4474 //
     /* 117212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117215 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117241 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117253 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117289 */   GIR_RootConstrainSelectedInstOperands,
     /* 117290 */   // GIR_Coverage, 4474,
     /* 117290 */   GIR_EraseRootFromParent_Done,
     /* 117291 */ // Label 2210: @117291
     /* 117291 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(117375), // Rule ID 4475 //
     /* 117296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117299 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117303 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117325 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117337 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117369 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117373 */   GIR_RootConstrainSelectedInstOperands,
     /* 117374 */   // GIR_Coverage, 4475,
     /* 117374 */   GIR_EraseRootFromParent_Done,
     /* 117375 */ // Label 2211: @117375
     /* 117375 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(117459), // Rule ID 4476 //
     /* 117380 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117383 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117387 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117398 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117402 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117409 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117421 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117457 */   GIR_RootConstrainSelectedInstOperands,
     /* 117458 */   // GIR_Coverage, 4476,
     /* 117458 */   GIR_EraseRootFromParent_Done,
     /* 117459 */ // Label 2212: @117459
     /* 117459 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(117543), // Rule ID 7269 //
     /* 117464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117467 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117477 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117488 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117492 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117496 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117501 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 117505 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117509 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117513 */   // MIs[2] Operand 1
     /* 117513 */   // No operand predicates
     /* 117513 */   // MIs[0] Rn
     /* 117513 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117521 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117523 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15556>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117526 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117530 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 117533 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117541 */   GIR_RootConstrainSelectedInstOperands,
     /* 117542 */   // GIR_Coverage, 7269,
     /* 117542 */   GIR_EraseRootFromParent_Done,
     /* 117543 */ // Label 2213: @117543
     /* 117543 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(117641), // Rule ID 7271 //
     /* 117548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117551 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117554 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117561 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117572 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117581 */   // MIs[0] Rn
     /* 117581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117591 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15556>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 117591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 117598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117603 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 117606 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117610 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117613 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117632 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117639 */   GIR_RootConstrainSelectedInstOperands,
     /* 117640 */   // GIR_Coverage, 7271,
     /* 117640 */   GIR_EraseRootFromParent_Done,
     /* 117641 */ // Label 2214: @117641
     /* 117641 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(117678), // Rule ID 6987 //
     /* 117646 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117649 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117656 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117663 */   // MIs[0] ptr
     /* 117663 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117671 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15556>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 117676 */   GIR_RootConstrainSelectedInstOperands,
     /* 117677 */   // GIR_Coverage, 6987,
     /* 117677 */   GIR_Done,
     /* 117678 */ // Label 2215: @117678
     /* 117678 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(117705), // Rule ID 6319 //
     /* 117683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117686 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117690 */   // MIs[0] Rn
     /* 117690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117698 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 117698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 117703 */   GIR_RootConstrainSelectedInstOperands,
     /* 117704 */   // GIR_Coverage, 6319,
     /* 117704 */   GIR_Done,
     /* 117705 */ // Label 2216: @117705
     /* 117705 */ GIM_Reject,
     /* 117706 */ // Label 2064: @117706
     /* 117706 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(117911),
     /* 117711 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117714 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117726 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(117767), // Rule ID 4386 //
     /* 117731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 117734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 117741 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 117741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 117744 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117765 */     GIR_RootConstrainSelectedInstOperands,
     /* 117766 */     // GIR_Coverage, 4386,
     /* 117766 */     GIR_EraseRootFromParent_Done,
     /* 117767 */   // Label 2218: @117767
     /* 117767 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(117808), // Rule ID 4387 //
     /* 117772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 117775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 117782 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 117782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 117785 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117806 */     GIR_RootConstrainSelectedInstOperands,
     /* 117807 */     // GIR_Coverage, 4387,
     /* 117807 */     GIR_EraseRootFromParent_Done,
     /* 117808 */   // Label 2219: @117808
     /* 117808 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(117841), // Rule ID 4441 //
     /* 117813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 117820 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 117820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 117823 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117839 */     GIR_RootConstrainSelectedInstOperands,
     /* 117840 */     // GIR_Coverage, 4441,
     /* 117840 */     GIR_EraseRootFromParent_Done,
     /* 117841 */   // Label 2220: @117841
     /* 117841 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(117874), // Rule ID 4465 //
     /* 117846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 117853 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 117856 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117872 */     GIR_RootConstrainSelectedInstOperands,
     /* 117873 */     // GIR_Coverage, 4465,
     /* 117873 */     GIR_EraseRootFromParent_Done,
     /* 117874 */   // Label 2221: @117874
     /* 117874 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(117910), // Rule ID 325 //
     /* 117879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 117889 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 117892 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117908 */     GIR_RootConstrainSelectedInstOperands,
     /* 117909 */     // GIR_Coverage, 325,
     /* 117909 */     GIR_EraseRootFromParent_Done,
     /* 117910 */   // Label 2222: @117910
     /* 117910 */   GIM_Reject,
     /* 117911 */ // Label 2217: @117911
     /* 117911 */ GIM_Reject,
     /* 117912 */ // Label 2065: @117912
     /* 117912 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(118317),
     /* 117917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117924 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(117973), // Rule ID 4394 //
     /* 117929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 117932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117947 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117950 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117971 */     GIR_RootConstrainSelectedInstOperands,
     /* 117972 */     // GIR_Coverage, 4394,
     /* 117972 */     GIR_EraseRootFromParent_Done,
     /* 117973 */   // Label 2224: @117973
     /* 117973 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(118022), // Rule ID 4395 //
     /* 117978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 117981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 117996 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 117996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 117999 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118020 */     GIR_RootConstrainSelectedInstOperands,
     /* 118021 */     // GIR_Coverage, 4395,
     /* 118021 */     GIR_EraseRootFromParent_Done,
     /* 118022 */   // Label 2225: @118022
     /* 118022 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(118071), // Rule ID 4396 //
     /* 118027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118045 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118048 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118069 */     GIR_RootConstrainSelectedInstOperands,
     /* 118070 */     // GIR_Coverage, 4396,
     /* 118070 */     GIR_EraseRootFromParent_Done,
     /* 118071 */   // Label 2226: @118071
     /* 118071 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(118120), // Rule ID 4397 //
     /* 118076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118094 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118097 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118118 */     GIR_RootConstrainSelectedInstOperands,
     /* 118119 */     // GIR_Coverage, 4397,
     /* 118119 */     GIR_EraseRootFromParent_Done,
     /* 118120 */   // Label 2227: @118120
     /* 118120 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(118164), // Rule ID 4436 //
     /* 118125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118143 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118146 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118162 */     GIR_RootConstrainSelectedInstOperands,
     /* 118163 */     // GIR_Coverage, 4436,
     /* 118163 */     GIR_EraseRootFromParent_Done,
     /* 118164 */   // Label 2228: @118164
     /* 118164 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(118208), // Rule ID 4439 //
     /* 118169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118187 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118190 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118206 */     GIR_RootConstrainSelectedInstOperands,
     /* 118207 */     // GIR_Coverage, 4439,
     /* 118207 */     GIR_EraseRootFromParent_Done,
     /* 118208 */   // Label 2229: @118208
     /* 118208 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(118252), // Rule ID 4460 //
     /* 118213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118231 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118234 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118250 */     GIR_RootConstrainSelectedInstOperands,
     /* 118251 */     // GIR_Coverage, 4460,
     /* 118251 */     GIR_EraseRootFromParent_Done,
     /* 118252 */   // Label 2230: @118252
     /* 118252 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(118296), // Rule ID 4463 //
     /* 118257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118275 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118294 */     GIR_RootConstrainSelectedInstOperands,
     /* 118295 */     // GIR_Coverage, 4463,
     /* 118295 */     GIR_EraseRootFromParent_Done,
     /* 118296 */   // Label 2231: @118296
     /* 118296 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(118316), // Rule ID 6318 //
     /* 118301 */     // MIs[0] Rn
     /* 118301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118309 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 118314 */     GIR_RootConstrainSelectedInstOperands,
     /* 118315 */     // GIR_Coverage, 6318,
     /* 118315 */     GIR_Done,
     /* 118316 */   // Label 2232: @118316
     /* 118316 */   GIM_Reject,
     /* 118317 */ // Label 2223: @118317
     /* 118317 */ GIM_Reject,
     /* 118318 */ // Label 2066: @118318
     /* 118318 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(118767),
     /* 118323 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118326 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118330 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(118379), // Rule ID 4408 //
     /* 118335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118353 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118356 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118377 */     GIR_RootConstrainSelectedInstOperands,
     /* 118378 */     // GIR_Coverage, 4408,
     /* 118378 */     GIR_EraseRootFromParent_Done,
     /* 118379 */   // Label 2234: @118379
     /* 118379 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(118428), // Rule ID 4409 //
     /* 118384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118402 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118405 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118426 */     GIR_RootConstrainSelectedInstOperands,
     /* 118427 */     // GIR_Coverage, 4409,
     /* 118427 */     GIR_EraseRootFromParent_Done,
     /* 118428 */   // Label 2235: @118428
     /* 118428 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(118477), // Rule ID 4410 //
     /* 118433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118451 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118454 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118475 */     GIR_RootConstrainSelectedInstOperands,
     /* 118476 */     // GIR_Coverage, 4410,
     /* 118476 */     GIR_EraseRootFromParent_Done,
     /* 118477 */   // Label 2236: @118477
     /* 118477 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(118526), // Rule ID 4411 //
     /* 118482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118500 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118503 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118524 */     GIR_RootConstrainSelectedInstOperands,
     /* 118525 */     // GIR_Coverage, 4411,
     /* 118525 */     GIR_EraseRootFromParent_Done,
     /* 118526 */   // Label 2237: @118526
     /* 118526 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(118570), // Rule ID 4443 //
     /* 118531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118549 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118552 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118568 */     GIR_RootConstrainSelectedInstOperands,
     /* 118569 */     // GIR_Coverage, 4443,
     /* 118569 */     GIR_EraseRootFromParent_Done,
     /* 118570 */   // Label 2238: @118570
     /* 118570 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(118614), // Rule ID 4447 //
     /* 118575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118593 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118596 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118612 */     GIR_RootConstrainSelectedInstOperands,
     /* 118613 */     // GIR_Coverage, 4447,
     /* 118613 */     GIR_EraseRootFromParent_Done,
     /* 118614 */   // Label 2239: @118614
     /* 118614 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(118658), // Rule ID 4467 //
     /* 118619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118637 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118640 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118656 */     GIR_RootConstrainSelectedInstOperands,
     /* 118657 */     // GIR_Coverage, 4467,
     /* 118657 */     GIR_EraseRootFromParent_Done,
     /* 118658 */   // Label 2240: @118658
     /* 118658 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(118702), // Rule ID 4471 //
     /* 118663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118681 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118684 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118700 */     GIR_RootConstrainSelectedInstOperands,
     /* 118701 */     // GIR_Coverage, 4471,
     /* 118701 */     GIR_EraseRootFromParent_Done,
     /* 118702 */   // Label 2241: @118702
     /* 118702 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(118746), // Rule ID 4472 //
     /* 118707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118725 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118728 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118744 */     GIR_RootConstrainSelectedInstOperands,
     /* 118745 */     // GIR_Coverage, 4472,
     /* 118745 */     GIR_EraseRootFromParent_Done,
     /* 118746 */   // Label 2242: @118746
     /* 118746 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(118766), // Rule ID 6315 //
     /* 118751 */     // MIs[0] Rn
     /* 118751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118759 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 118764 */     GIR_RootConstrainSelectedInstOperands,
     /* 118765 */     // GIR_Coverage, 6315,
     /* 118765 */     GIR_Done,
     /* 118766 */   // Label 2243: @118766
     /* 118766 */   GIM_Reject,
     /* 118767 */ // Label 2233: @118767
     /* 118767 */ GIM_Reject,
     /* 118768 */ // Label 2067: @118768
     /* 118768 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(119173),
     /* 118773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118780 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(118829), // Rule ID 4398 //
     /* 118785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118803 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118806 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118827 */     GIR_RootConstrainSelectedInstOperands,
     /* 118828 */     // GIR_Coverage, 4398,
     /* 118828 */     GIR_EraseRootFromParent_Done,
     /* 118829 */   // Label 2245: @118829
     /* 118829 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(118878), // Rule ID 4399 //
     /* 118834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118852 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118855 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118876 */     GIR_RootConstrainSelectedInstOperands,
     /* 118877 */     // GIR_Coverage, 4399,
     /* 118877 */     GIR_EraseRootFromParent_Done,
     /* 118878 */   // Label 2246: @118878
     /* 118878 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(118927), // Rule ID 4402 //
     /* 118883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118901 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118904 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118925 */     GIR_RootConstrainSelectedInstOperands,
     /* 118926 */     // GIR_Coverage, 4402,
     /* 118926 */     GIR_EraseRootFromParent_Done,
     /* 118927 */   // Label 2247: @118927
     /* 118927 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(118976), // Rule ID 4403 //
     /* 118932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118950 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118953 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118974 */     GIR_RootConstrainSelectedInstOperands,
     /* 118975 */     // GIR_Coverage, 4403,
     /* 118975 */     GIR_EraseRootFromParent_Done,
     /* 118976 */   // Label 2248: @118976
     /* 118976 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(119020), // Rule ID 4438 //
     /* 118981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118999 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119002 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119018 */     GIR_RootConstrainSelectedInstOperands,
     /* 119019 */     // GIR_Coverage, 4438,
     /* 119019 */     GIR_EraseRootFromParent_Done,
     /* 119020 */   // Label 2249: @119020
     /* 119020 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(119064), // Rule ID 4440 //
     /* 119025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119043 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119046 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119062 */     GIR_RootConstrainSelectedInstOperands,
     /* 119063 */     // GIR_Coverage, 4440,
     /* 119063 */     GIR_EraseRootFromParent_Done,
     /* 119064 */   // Label 2250: @119064
     /* 119064 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(119108), // Rule ID 4462 //
     /* 119069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119087 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119090 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119106 */     GIR_RootConstrainSelectedInstOperands,
     /* 119107 */     // GIR_Coverage, 4462,
     /* 119107 */     GIR_EraseRootFromParent_Done,
     /* 119108 */   // Label 2251: @119108
     /* 119108 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(119152), // Rule ID 4464 //
     /* 119113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119131 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119134 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119150 */     GIR_RootConstrainSelectedInstOperands,
     /* 119151 */     // GIR_Coverage, 4464,
     /* 119151 */     GIR_EraseRootFromParent_Done,
     /* 119152 */   // Label 2252: @119152
     /* 119152 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(119172), // Rule ID 6317 //
     /* 119157 */     // MIs[0] Rn
     /* 119157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119165 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 119170 */     GIR_RootConstrainSelectedInstOperands,
     /* 119171 */     // GIR_Coverage, 6317,
     /* 119171 */     GIR_Done,
     /* 119172 */   // Label 2253: @119172
     /* 119172 */   GIM_Reject,
     /* 119173 */ // Label 2244: @119173
     /* 119173 */ GIM_Reject,
     /* 119174 */ // Label 2068: @119174
     /* 119174 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(119579),
     /* 119179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119182 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119186 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(119235), // Rule ID 4412 //
     /* 119191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119209 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119212 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119233 */     GIR_RootConstrainSelectedInstOperands,
     /* 119234 */     // GIR_Coverage, 4412,
     /* 119234 */     GIR_EraseRootFromParent_Done,
     /* 119235 */   // Label 2255: @119235
     /* 119235 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(119284), // Rule ID 4413 //
     /* 119240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119258 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119261 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119282 */     GIR_RootConstrainSelectedInstOperands,
     /* 119283 */     // GIR_Coverage, 4413,
     /* 119283 */     GIR_EraseRootFromParent_Done,
     /* 119284 */   // Label 2256: @119284
     /* 119284 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(119333), // Rule ID 4414 //
     /* 119289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119307 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119310 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119331 */     GIR_RootConstrainSelectedInstOperands,
     /* 119332 */     // GIR_Coverage, 4414,
     /* 119332 */     GIR_EraseRootFromParent_Done,
     /* 119333 */   // Label 2257: @119333
     /* 119333 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(119382), // Rule ID 4415 //
     /* 119338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119356 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119359 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119380 */     GIR_RootConstrainSelectedInstOperands,
     /* 119381 */     // GIR_Coverage, 4415,
     /* 119381 */     GIR_EraseRootFromParent_Done,
     /* 119382 */   // Label 2258: @119382
     /* 119382 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(119426), // Rule ID 4442 //
     /* 119387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119405 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119408 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119424 */     GIR_RootConstrainSelectedInstOperands,
     /* 119425 */     // GIR_Coverage, 4442,
     /* 119425 */     GIR_EraseRootFromParent_Done,
     /* 119426 */   // Label 2259: @119426
     /* 119426 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(119470), // Rule ID 4446 //
     /* 119431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119449 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119452 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119468 */     GIR_RootConstrainSelectedInstOperands,
     /* 119469 */     // GIR_Coverage, 4446,
     /* 119469 */     GIR_EraseRootFromParent_Done,
     /* 119470 */   // Label 2260: @119470
     /* 119470 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(119514), // Rule ID 4466 //
     /* 119475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119493 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119496 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119512 */     GIR_RootConstrainSelectedInstOperands,
     /* 119513 */     // GIR_Coverage, 4466,
     /* 119513 */     GIR_EraseRootFromParent_Done,
     /* 119514 */   // Label 2261: @119514
     /* 119514 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(119558), // Rule ID 4470 //
     /* 119519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119537 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119540 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119556 */     GIR_RootConstrainSelectedInstOperands,
     /* 119557 */     // GIR_Coverage, 4470,
     /* 119557 */     GIR_EraseRootFromParent_Done,
     /* 119558 */   // Label 2262: @119558
     /* 119558 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(119578), // Rule ID 6314 //
     /* 119563 */     // MIs[0] Rn
     /* 119563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119571 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 119576 */     GIR_RootConstrainSelectedInstOperands,
     /* 119577 */     // GIR_Coverage, 6314,
     /* 119577 */     GIR_Done,
     /* 119578 */   // Label 2263: @119578
     /* 119578 */   GIM_Reject,
     /* 119579 */ // Label 2254: @119579
     /* 119579 */ GIM_Reject,
     /* 119580 */ // Label 2069: @119580
     /* 119580 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(119799),
     /* 119585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119592 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(119641), // Rule ID 4400 //
     /* 119597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119615 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119618 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119639 */     GIR_RootConstrainSelectedInstOperands,
     /* 119640 */     // GIR_Coverage, 4400,
     /* 119640 */     GIR_EraseRootFromParent_Done,
     /* 119641 */   // Label 2265: @119641
     /* 119641 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(119690), // Rule ID 4401 //
     /* 119646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119664 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119667 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119688 */     GIR_RootConstrainSelectedInstOperands,
     /* 119689 */     // GIR_Coverage, 4401,
     /* 119689 */     GIR_EraseRootFromParent_Done,
     /* 119690 */   // Label 2266: @119690
     /* 119690 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(119734), // Rule ID 4437 //
     /* 119695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119713 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119716 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119732 */     GIR_RootConstrainSelectedInstOperands,
     /* 119733 */     // GIR_Coverage, 4437,
     /* 119733 */     GIR_EraseRootFromParent_Done,
     /* 119734 */   // Label 2267: @119734
     /* 119734 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(119778), // Rule ID 4461 //
     /* 119739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119757 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119760 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119776 */     GIR_RootConstrainSelectedInstOperands,
     /* 119777 */     // GIR_Coverage, 4461,
     /* 119777 */     GIR_EraseRootFromParent_Done,
     /* 119778 */   // Label 2268: @119778
     /* 119778 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(119798), // Rule ID 6316 //
     /* 119783 */     // MIs[0] Rn
     /* 119783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119791 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 119796 */     GIR_RootConstrainSelectedInstOperands,
     /* 119797 */     // GIR_Coverage, 6316,
     /* 119797 */     GIR_Done,
     /* 119798 */   // Label 2269: @119798
     /* 119798 */   GIM_Reject,
     /* 119799 */ // Label 2264: @119799
     /* 119799 */ GIM_Reject,
     /* 119800 */ // Label 2070: @119800
     /* 119800 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(120205),
     /* 119805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119812 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(119861), // Rule ID 4416 //
     /* 119817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119835 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119838 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119859 */     GIR_RootConstrainSelectedInstOperands,
     /* 119860 */     // GIR_Coverage, 4416,
     /* 119860 */     GIR_EraseRootFromParent_Done,
     /* 119861 */   // Label 2271: @119861
     /* 119861 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(119910), // Rule ID 4417 //
     /* 119866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119884 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119887 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119908 */     GIR_RootConstrainSelectedInstOperands,
     /* 119909 */     // GIR_Coverage, 4417,
     /* 119909 */     GIR_EraseRootFromParent_Done,
     /* 119910 */   // Label 2272: @119910
     /* 119910 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(119959), // Rule ID 4420 //
     /* 119915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119933 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119936 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119957 */     GIR_RootConstrainSelectedInstOperands,
     /* 119958 */     // GIR_Coverage, 4420,
     /* 119958 */     GIR_EraseRootFromParent_Done,
     /* 119959 */   // Label 2273: @119959
     /* 119959 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(120008), // Rule ID 4421 //
     /* 119964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119982 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119985 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120006 */     GIR_RootConstrainSelectedInstOperands,
     /* 120007 */     // GIR_Coverage, 4421,
     /* 120007 */     GIR_EraseRootFromParent_Done,
     /* 120008 */   // Label 2274: @120008
     /* 120008 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(120052), // Rule ID 4445 //
     /* 120013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120031 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120034 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120050 */     GIR_RootConstrainSelectedInstOperands,
     /* 120051 */     // GIR_Coverage, 4445,
     /* 120051 */     GIR_EraseRootFromParent_Done,
     /* 120052 */   // Label 2275: @120052
     /* 120052 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(120096), // Rule ID 4448 //
     /* 120057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120075 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120078 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120094 */     GIR_RootConstrainSelectedInstOperands,
     /* 120095 */     // GIR_Coverage, 4448,
     /* 120095 */     GIR_EraseRootFromParent_Done,
     /* 120096 */   // Label 2276: @120096
     /* 120096 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(120140), // Rule ID 4469 //
     /* 120101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120119 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120122 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120138 */     GIR_RootConstrainSelectedInstOperands,
     /* 120139 */     // GIR_Coverage, 4469,
     /* 120139 */     GIR_EraseRootFromParent_Done,
     /* 120140 */   // Label 2277: @120140
     /* 120140 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(120184), // Rule ID 4473 //
     /* 120145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120163 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120166 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120182 */     GIR_RootConstrainSelectedInstOperands,
     /* 120183 */     // GIR_Coverage, 4473,
     /* 120183 */     GIR_EraseRootFromParent_Done,
     /* 120184 */   // Label 2278: @120184
     /* 120184 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(120204), // Rule ID 6313 //
     /* 120189 */     // MIs[0] Rn
     /* 120189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120197 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 120202 */     GIR_RootConstrainSelectedInstOperands,
     /* 120203 */     // GIR_Coverage, 6313,
     /* 120203 */     GIR_Done,
     /* 120204 */   // Label 2279: @120204
     /* 120204 */   GIM_Reject,
     /* 120205 */ // Label 2270: @120205
     /* 120205 */ GIM_Reject,
     /* 120206 */ // Label 2071: @120206
     /* 120206 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(120425),
     /* 120211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120218 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(120267), // Rule ID 4418 //
     /* 120223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120241 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120244 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120265 */     GIR_RootConstrainSelectedInstOperands,
     /* 120266 */     // GIR_Coverage, 4418,
     /* 120266 */     GIR_EraseRootFromParent_Done,
     /* 120267 */   // Label 2281: @120267
     /* 120267 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(120316), // Rule ID 4419 //
     /* 120272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120290 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120293 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120314 */     GIR_RootConstrainSelectedInstOperands,
     /* 120315 */     // GIR_Coverage, 4419,
     /* 120315 */     GIR_EraseRootFromParent_Done,
     /* 120316 */   // Label 2282: @120316
     /* 120316 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(120360), // Rule ID 4444 //
     /* 120321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120339 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120342 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120358 */     GIR_RootConstrainSelectedInstOperands,
     /* 120359 */     // GIR_Coverage, 4444,
     /* 120359 */     GIR_EraseRootFromParent_Done,
     /* 120360 */   // Label 2283: @120360
     /* 120360 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(120404), // Rule ID 4468 //
     /* 120365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120383 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120386 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120402 */     GIR_RootConstrainSelectedInstOperands,
     /* 120403 */     // GIR_Coverage, 4468,
     /* 120403 */     GIR_EraseRootFromParent_Done,
     /* 120404 */   // Label 2284: @120404
     /* 120404 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(120424), // Rule ID 6312 //
     /* 120409 */     // MIs[0] Rn
     /* 120409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120417 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 120422 */     GIR_RootConstrainSelectedInstOperands,
     /* 120423 */     // GIR_Coverage, 6312,
     /* 120423 */     GIR_Done,
     /* 120424 */   // Label 2285: @120424
     /* 120424 */   GIM_Reject,
     /* 120425 */ // Label 2280: @120425
     /* 120425 */ GIM_Reject,
     /* 120426 */ // Label 2072: @120426
     /* 120426 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(120485), // Rule ID 10702 //
     /* 120431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120437 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120441 */   // MIs[0] base
     /* 120441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120449 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120461 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 120469 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120474 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120483 */   GIR_RootConstrainSelectedInstOperands,
     /* 120484 */   // GIR_Coverage, 10702,
     /* 120484 */   GIR_EraseRootFromParent_Done,
     /* 120485 */ // Label 2286: @120485
     /* 120485 */ GIM_Reject,
     /* 120486 */ // Label 2073: @120486
     /* 120486 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(120545), // Rule ID 10708 //
     /* 120491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120501 */   // MIs[0] base
     /* 120501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120509 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120521 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 120529 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120534 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120543 */   GIR_RootConstrainSelectedInstOperands,
     /* 120544 */   // GIR_Coverage, 10708,
     /* 120544 */   GIR_EraseRootFromParent_Done,
     /* 120545 */ // Label 2287: @120545
     /* 120545 */ GIM_Reject,
     /* 120546 */ // Label 2074: @120546
     /* 120546 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(120655),
     /* 120551 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120554 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120558 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120566 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(120610), // Rule ID 10693 //
     /* 120571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120574 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120586 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120594 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120599 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120608 */     GIR_RootConstrainSelectedInstOperands,
     /* 120609 */     // GIR_Coverage, 10693,
     /* 120609 */     GIR_EraseRootFromParent_Done,
     /* 120610 */   // Label 2289: @120610
     /* 120610 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(120654), // Rule ID 10711 //
     /* 120615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120618 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120638 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120643 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120652 */     GIR_RootConstrainSelectedInstOperands,
     /* 120653 */     // GIR_Coverage, 10711,
     /* 120653 */     GIR_EraseRootFromParent_Done,
     /* 120654 */   // Label 2290: @120654
     /* 120654 */   GIM_Reject,
     /* 120655 */ // Label 2288: @120655
     /* 120655 */ GIM_Reject,
     /* 120656 */ // Label 2075: @120656
     /* 120656 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(120715), // Rule ID 10699 //
     /* 120661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120671 */   // MIs[0] base
     /* 120671 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120679 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120691 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 120699 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120704 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120713 */   GIR_RootConstrainSelectedInstOperands,
     /* 120714 */   // GIR_Coverage, 10699,
     /* 120714 */   GIR_EraseRootFromParent_Done,
     /* 120715 */ // Label 2291: @120715
     /* 120715 */ GIM_Reject,
     /* 120716 */ // Label 2076: @120716
     /* 120716 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(120825),
     /* 120721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120736 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(120780), // Rule ID 10687 //
     /* 120741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120744 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 120764 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120769 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120778 */     GIR_RootConstrainSelectedInstOperands,
     /* 120779 */     // GIR_Coverage, 10687,
     /* 120779 */     GIR_EraseRootFromParent_Done,
     /* 120780 */   // Label 2293: @120780
     /* 120780 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(120824), // Rule ID 10705 //
     /* 120785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120788 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 120808 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120813 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120822 */     GIR_RootConstrainSelectedInstOperands,
     /* 120823 */     // GIR_Coverage, 10705,
     /* 120823 */     GIR_EraseRootFromParent_Done,
     /* 120824 */   // Label 2294: @120824
     /* 120824 */   GIM_Reject,
     /* 120825 */ // Label 2292: @120825
     /* 120825 */ GIM_Reject,
     /* 120826 */ // Label 2077: @120826
     /* 120826 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(120935),
     /* 120831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120838 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120846 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(120890), // Rule ID 10678 //
     /* 120851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120854 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 120861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 120874 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120879 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120888 */     GIR_RootConstrainSelectedInstOperands,
     /* 120889 */     // GIR_Coverage, 10678,
     /* 120889 */     GIR_EraseRootFromParent_Done,
     /* 120890 */   // Label 2296: @120890
     /* 120890 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(120934), // Rule ID 10696 //
     /* 120895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120898 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 120905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120910 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 120918 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120923 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120932 */     GIR_RootConstrainSelectedInstOperands,
     /* 120933 */     // GIR_Coverage, 10696,
     /* 120933 */     GIR_EraseRootFromParent_Done,
     /* 120934 */   // Label 2297: @120934
     /* 120934 */   GIM_Reject,
     /* 120935 */ // Label 2295: @120935
     /* 120935 */ GIM_Reject,
     /* 120936 */ // Label 2078: @120936
     /* 120936 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(120979), // Rule ID 2421 //
     /* 120941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120944 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120947 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 120955 */   // MIs[0] base
     /* 120955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120963 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 120966 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 120968 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120977 */   GIR_RootConstrainSelectedInstOperands,
     /* 120978 */   // GIR_Coverage, 2421,
     /* 120978 */   GIR_EraseRootFromParent_Done,
     /* 120979 */ // Label 2298: @120979
     /* 120979 */ GIM_Reject,
     /* 120980 */ // Label 2079: @120980
     /* 120980 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(121039), // Rule ID 10664 //
     /* 120985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120995 */   // MIs[0] base
     /* 120995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121003 */   // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 121010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121015 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 121023 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121028 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121037 */   GIR_RootConstrainSelectedInstOperands,
     /* 121038 */   // GIR_Coverage, 10664,
     /* 121038 */   GIR_EraseRootFromParent_Done,
     /* 121039 */ // Label 2299: @121039
     /* 121039 */ GIM_Reject,
     /* 121040 */ // Label 2080: @121040
     /* 121040 */ GIM_Reject,
     /* 121041 */ // Label 20: @121041
     /* 121041 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2302*/ GIMT_Encode4(122391),
     /* 121052 */ /*GILLT_s32*//*Label 2300*/ GIMT_Encode4(121060),
     /* 121056 */ /*GILLT_s64*//*Label 2301*/ GIMT_Encode4(122078),
     /* 121060 */ // Label 2300: @121060
     /* 121060 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(122077),
     /* 121065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 121071 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(121126), // Rule ID 7210 //
     /* 121076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121093 */     // MIs[0] Rn
     /* 121093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121109 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 121112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121124 */     GIR_RootConstrainSelectedInstOperands,
     /* 121125 */     // GIR_Coverage, 7210,
     /* 121125 */     GIR_EraseRootFromParent_Done,
     /* 121126 */   // Label 2304: @121126
     /* 121126 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(121181), // Rule ID 7211 //
     /* 121131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121148 */     // MIs[0] Rn
     /* 121148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121164 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 121167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121179 */     GIR_RootConstrainSelectedInstOperands,
     /* 121180 */     // GIR_Coverage, 7211,
     /* 121180 */     GIR_EraseRootFromParent_Done,
     /* 121181 */   // Label 2305: @121181
     /* 121181 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(121236), // Rule ID 7212 //
     /* 121186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121203 */     // MIs[0] Rn
     /* 121203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121219 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 121222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121234 */     GIR_RootConstrainSelectedInstOperands,
     /* 121235 */     // GIR_Coverage, 7212,
     /* 121235 */     GIR_EraseRootFromParent_Done,
     /* 121236 */   // Label 2306: @121236
     /* 121236 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(121291), // Rule ID 7213 //
     /* 121241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121244 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121251 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121258 */     // MIs[0] Rn
     /* 121258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121274 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121289 */     GIR_RootConstrainSelectedInstOperands,
     /* 121290 */     // GIR_Coverage, 7213,
     /* 121290 */     GIR_EraseRootFromParent_Done,
     /* 121291 */   // Label 2307: @121291
     /* 121291 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(121346), // Rule ID 7214 //
     /* 121296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121313 */     // MIs[0] Rn
     /* 121313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121329 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121344 */     GIR_RootConstrainSelectedInstOperands,
     /* 121345 */     // GIR_Coverage, 7214,
     /* 121345 */     GIR_EraseRootFromParent_Done,
     /* 121346 */   // Label 2308: @121346
     /* 121346 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(121401), // Rule ID 7215 //
     /* 121351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121368 */     // MIs[0] Rn
     /* 121368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121384 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 121387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121399 */     GIR_RootConstrainSelectedInstOperands,
     /* 121400 */     // GIR_Coverage, 7215,
     /* 121400 */     GIR_EraseRootFromParent_Done,
     /* 121401 */   // Label 2309: @121401
     /* 121401 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(121456), // Rule ID 7216 //
     /* 121406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121423 */     // MIs[0] Rn
     /* 121423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121439 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 121442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121454 */     GIR_RootConstrainSelectedInstOperands,
     /* 121455 */     // GIR_Coverage, 7216,
     /* 121455 */     GIR_EraseRootFromParent_Done,
     /* 121456 */   // Label 2310: @121456
     /* 121456 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(121511), // Rule ID 7217 //
     /* 121461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121464 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121471 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121478 */     // MIs[0] Rn
     /* 121478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121494 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 121497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121509 */     GIR_RootConstrainSelectedInstOperands,
     /* 121510 */     // GIR_Coverage, 7217,
     /* 121510 */     GIR_EraseRootFromParent_Done,
     /* 121511 */   // Label 2311: @121511
     /* 121511 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(121566), // Rule ID 7218 //
     /* 121516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121519 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121526 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121533 */     // MIs[0] Rn
     /* 121533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121549 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 121552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121564 */     GIR_RootConstrainSelectedInstOperands,
     /* 121565 */     // GIR_Coverage, 7218,
     /* 121565 */     GIR_EraseRootFromParent_Done,
     /* 121566 */   // Label 2312: @121566
     /* 121566 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(121621), // Rule ID 7219 //
     /* 121571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121588 */     // MIs[0] Rn
     /* 121588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121604 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 121607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121619 */     GIR_RootConstrainSelectedInstOperands,
     /* 121620 */     // GIR_Coverage, 7219,
     /* 121620 */     GIR_EraseRootFromParent_Done,
     /* 121621 */   // Label 2313: @121621
     /* 121621 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(121676), // Rule ID 7220 //
     /* 121626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121643 */     // MIs[0] Rn
     /* 121643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121659 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 121662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121674 */     GIR_RootConstrainSelectedInstOperands,
     /* 121675 */     // GIR_Coverage, 7220,
     /* 121675 */     GIR_EraseRootFromParent_Done,
     /* 121676 */   // Label 2314: @121676
     /* 121676 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(121731), // Rule ID 7221 //
     /* 121681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121698 */     // MIs[0] Rn
     /* 121698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121714 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 121717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121729 */     GIR_RootConstrainSelectedInstOperands,
     /* 121730 */     // GIR_Coverage, 7221,
     /* 121730 */     GIR_EraseRootFromParent_Done,
     /* 121731 */   // Label 2315: @121731
     /* 121731 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(121786), // Rule ID 7222 //
     /* 121736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121753 */     // MIs[0] Rn
     /* 121753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121769 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 121772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121784 */     GIR_RootConstrainSelectedInstOperands,
     /* 121785 */     // GIR_Coverage, 7222,
     /* 121785 */     GIR_EraseRootFromParent_Done,
     /* 121786 */   // Label 2316: @121786
     /* 121786 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(121841), // Rule ID 7223 //
     /* 121791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121808 */     // MIs[0] Rn
     /* 121808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121824 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 121827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121839 */     GIR_RootConstrainSelectedInstOperands,
     /* 121840 */     // GIR_Coverage, 7223,
     /* 121840 */     GIR_EraseRootFromParent_Done,
     /* 121841 */   // Label 2317: @121841
     /* 121841 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(121896), // Rule ID 7224 //
     /* 121846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121856 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121863 */     // MIs[0] Rn
     /* 121863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121879 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 121882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121894 */     GIR_RootConstrainSelectedInstOperands,
     /* 121895 */     // GIR_Coverage, 7224,
     /* 121895 */     GIR_EraseRootFromParent_Done,
     /* 121896 */   // Label 2318: @121896
     /* 121896 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(121956), // Rule ID 12830 //
     /* 121901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 121904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121915 */     // MIs[0] addr
     /* 121915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121931 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 121931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 121937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 121939 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 121944 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 121946 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 121948 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 121950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121954 */     GIR_RootConstrainSelectedInstOperands,
     /* 121955 */     // GIR_Coverage, 12830,
     /* 121955 */     GIR_EraseRootFromParent_Done,
     /* 121956 */   // Label 2319: @121956
     /* 121956 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(122016), // Rule ID 12831 //
     /* 121961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 121964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121975 */     // MIs[0] addr
     /* 121975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121991 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 121991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 121997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 121999 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122004 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122006 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122008 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122014 */     GIR_RootConstrainSelectedInstOperands,
     /* 122015 */     // GIR_Coverage, 12831,
     /* 122015 */     GIR_EraseRootFromParent_Done,
     /* 122016 */   // Label 2320: @122016
     /* 122016 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(122076), // Rule ID 12832 //
     /* 122021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122035 */     // MIs[0] addr
     /* 122035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122051 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 122057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122059 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122064 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122066 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122068 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122074 */     GIR_RootConstrainSelectedInstOperands,
     /* 122075 */     // GIR_Coverage, 12832,
     /* 122075 */     GIR_EraseRootFromParent_Done,
     /* 122076 */   // Label 2321: @122076
     /* 122076 */   GIM_Reject,
     /* 122077 */ // Label 2303: @122077
     /* 122077 */ GIM_Reject,
     /* 122078 */ // Label 2301: @122078
     /* 122078 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(122390),
     /* 122083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 122089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122096 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(122144), // Rule ID 2575 //
     /* 122101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122111 */     // MIs[0] Rn
     /* 122111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122127 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 122130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122142 */     GIR_RootConstrainSelectedInstOperands,
     /* 122143 */     // GIR_Coverage, 2575,
     /* 122143 */     GIR_EraseRootFromParent_Done,
     /* 122144 */   // Label 2323: @122144
     /* 122144 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(122192), // Rule ID 2576 //
     /* 122149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122159 */     // MIs[0] Rn
     /* 122159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122175 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 122178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122190 */     GIR_RootConstrainSelectedInstOperands,
     /* 122191 */     // GIR_Coverage, 2576,
     /* 122191 */     GIR_EraseRootFromParent_Done,
     /* 122192 */   // Label 2324: @122192
     /* 122192 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(122240), // Rule ID 2577 //
     /* 122197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122207 */     // MIs[0] Rn
     /* 122207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122223 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 122226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122238 */     GIR_RootConstrainSelectedInstOperands,
     /* 122239 */     // GIR_Coverage, 2577,
     /* 122239 */     GIR_EraseRootFromParent_Done,
     /* 122240 */   // Label 2325: @122240
     /* 122240 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(122288), // Rule ID 2578 //
     /* 122245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122255 */     // MIs[0] Rn
     /* 122255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122271 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122286 */     GIR_RootConstrainSelectedInstOperands,
     /* 122287 */     // GIR_Coverage, 2578,
     /* 122287 */     GIR_EraseRootFromParent_Done,
     /* 122288 */   // Label 2326: @122288
     /* 122288 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(122336), // Rule ID 2579 //
     /* 122293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122303 */     // MIs[0] Rn
     /* 122303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122319 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122334 */     GIR_RootConstrainSelectedInstOperands,
     /* 122335 */     // GIR_Coverage, 2579,
     /* 122335 */     GIR_EraseRootFromParent_Done,
     /* 122336 */   // Label 2327: @122336
     /* 122336 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(122389), // Rule ID 12833 //
     /* 122341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122348 */     // MIs[0] addr
     /* 122348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122364 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 122364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 122370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122372 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122377 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122379 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122381 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122387 */     GIR_RootConstrainSelectedInstOperands,
     /* 122388 */     // GIR_Coverage, 12833,
     /* 122388 */     GIR_EraseRootFromParent_Done,
     /* 122389 */   // Label 2328: @122389
     /* 122389 */   GIM_Reject,
     /* 122390 */ // Label 2322: @122390
     /* 122390 */ GIM_Reject,
     /* 122391 */ // Label 2302: @122391
     /* 122391 */ GIM_Reject,
     /* 122392 */ // Label 21: @122392
     /* 122392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2331*/ GIMT_Encode4(123383),
     /* 122403 */ /*GILLT_s32*//*Label 2329*/ GIMT_Encode4(122411),
     /* 122407 */ /*GILLT_s64*//*Label 2330*/ GIMT_Encode4(123156),
     /* 122411 */ // Label 2329: @122411
     /* 122411 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(123155),
     /* 122416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122419 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(122468), // Rule ID 7195 //
     /* 122424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122441 */     // MIs[0] Rn
     /* 122441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122453 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 122456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122466 */     GIR_RootConstrainSelectedInstOperands,
     /* 122467 */     // GIR_Coverage, 7195,
     /* 122467 */     GIR_EraseRootFromParent_Done,
     /* 122468 */   // Label 2333: @122468
     /* 122468 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(122517), // Rule ID 7196 //
     /* 122473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122490 */     // MIs[0] Rn
     /* 122490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122502 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 122505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122515 */     GIR_RootConstrainSelectedInstOperands,
     /* 122516 */     // GIR_Coverage, 7196,
     /* 122516 */     GIR_EraseRootFromParent_Done,
     /* 122517 */   // Label 2334: @122517
     /* 122517 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(122566), // Rule ID 7197 //
     /* 122522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122539 */     // MIs[0] Rn
     /* 122539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122551 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 122554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122564 */     GIR_RootConstrainSelectedInstOperands,
     /* 122565 */     // GIR_Coverage, 7197,
     /* 122565 */     GIR_EraseRootFromParent_Done,
     /* 122566 */   // Label 2335: @122566
     /* 122566 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(122615), // Rule ID 7198 //
     /* 122571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122588 */     // MIs[0] Rn
     /* 122588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122600 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 122603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122613 */     GIR_RootConstrainSelectedInstOperands,
     /* 122614 */     // GIR_Coverage, 7198,
     /* 122614 */     GIR_EraseRootFromParent_Done,
     /* 122615 */   // Label 2336: @122615
     /* 122615 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(122664), // Rule ID 7199 //
     /* 122620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122637 */     // MIs[0] Rn
     /* 122637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122649 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 122652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122662 */     GIR_RootConstrainSelectedInstOperands,
     /* 122663 */     // GIR_Coverage, 7199,
     /* 122663 */     GIR_EraseRootFromParent_Done,
     /* 122664 */   // Label 2337: @122664
     /* 122664 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(122713), // Rule ID 7200 //
     /* 122669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122686 */     // MIs[0] Rn
     /* 122686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122698 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 122701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122711 */     GIR_RootConstrainSelectedInstOperands,
     /* 122712 */     // GIR_Coverage, 7200,
     /* 122712 */     GIR_EraseRootFromParent_Done,
     /* 122713 */   // Label 2338: @122713
     /* 122713 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(122762), // Rule ID 7201 //
     /* 122718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122735 */     // MIs[0] Rn
     /* 122735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122747 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 122750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122760 */     GIR_RootConstrainSelectedInstOperands,
     /* 122761 */     // GIR_Coverage, 7201,
     /* 122761 */     GIR_EraseRootFromParent_Done,
     /* 122762 */   // Label 2339: @122762
     /* 122762 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(122811), // Rule ID 7202 //
     /* 122767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122784 */     // MIs[0] Rn
     /* 122784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122796 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 122799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122809 */     GIR_RootConstrainSelectedInstOperands,
     /* 122810 */     // GIR_Coverage, 7202,
     /* 122810 */     GIR_EraseRootFromParent_Done,
     /* 122811 */   // Label 2340: @122811
     /* 122811 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(122860), // Rule ID 7203 //
     /* 122816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122833 */     // MIs[0] Rn
     /* 122833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122845 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 122848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122858 */     GIR_RootConstrainSelectedInstOperands,
     /* 122859 */     // GIR_Coverage, 7203,
     /* 122859 */     GIR_EraseRootFromParent_Done,
     /* 122860 */   // Label 2341: @122860
     /* 122860 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(122909), // Rule ID 7204 //
     /* 122865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122882 */     // MIs[0] Rn
     /* 122882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122894 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 122897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122907 */     GIR_RootConstrainSelectedInstOperands,
     /* 122908 */     // GIR_Coverage, 7204,
     /* 122908 */     GIR_EraseRootFromParent_Done,
     /* 122909 */   // Label 2342: @122909
     /* 122909 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(122958), // Rule ID 7205 //
     /* 122914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122931 */     // MIs[0] Rn
     /* 122931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122943 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 122946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122956 */     GIR_RootConstrainSelectedInstOperands,
     /* 122957 */     // GIR_Coverage, 7205,
     /* 122957 */     GIR_EraseRootFromParent_Done,
     /* 122958 */   // Label 2343: @122958
     /* 122958 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(123007), // Rule ID 7206 //
     /* 122963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122980 */     // MIs[0] Rn
     /* 122980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122992 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 122995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123005 */     GIR_RootConstrainSelectedInstOperands,
     /* 123006 */     // GIR_Coverage, 7206,
     /* 123006 */     GIR_EraseRootFromParent_Done,
     /* 123007 */   // Label 2344: @123007
     /* 123007 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(123056), // Rule ID 7207 //
     /* 123012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123029 */     // MIs[0] Rn
     /* 123029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123041 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 123044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123054 */     GIR_RootConstrainSelectedInstOperands,
     /* 123055 */     // GIR_Coverage, 7207,
     /* 123055 */     GIR_EraseRootFromParent_Done,
     /* 123056 */   // Label 2345: @123056
     /* 123056 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(123105), // Rule ID 7208 //
     /* 123061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123078 */     // MIs[0] Rn
     /* 123078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123090 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123103 */     GIR_RootConstrainSelectedInstOperands,
     /* 123104 */     // GIR_Coverage, 7208,
     /* 123104 */     GIR_EraseRootFromParent_Done,
     /* 123105 */   // Label 2346: @123105
     /* 123105 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(123154), // Rule ID 7209 //
     /* 123110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123127 */     // MIs[0] Rn
     /* 123127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123139 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123152 */     GIR_RootConstrainSelectedInstOperands,
     /* 123153 */     // GIR_Coverage, 7209,
     /* 123153 */     GIR_EraseRootFromParent_Done,
     /* 123154 */   // Label 2347: @123154
     /* 123154 */   GIM_Reject,
     /* 123155 */ // Label 2332: @123155
     /* 123155 */ GIM_Reject,
     /* 123156 */ // Label 2330: @123156
     /* 123156 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(123382),
     /* 123161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123164 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123171 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(123213), // Rule ID 7190 //
     /* 123176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123186 */     // MIs[0] Rn
     /* 123186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123198 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 123201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123211 */     GIR_RootConstrainSelectedInstOperands,
     /* 123212 */     // GIR_Coverage, 7190,
     /* 123212 */     GIR_EraseRootFromParent_Done,
     /* 123213 */   // Label 2349: @123213
     /* 123213 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(123255), // Rule ID 7191 //
     /* 123218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123228 */     // MIs[0] Rn
     /* 123228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123240 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 123243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123253 */     GIR_RootConstrainSelectedInstOperands,
     /* 123254 */     // GIR_Coverage, 7191,
     /* 123254 */     GIR_EraseRootFromParent_Done,
     /* 123255 */   // Label 2350: @123255
     /* 123255 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(123297), // Rule ID 7192 //
     /* 123260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123270 */     // MIs[0] Rn
     /* 123270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123282 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 123285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123295 */     GIR_RootConstrainSelectedInstOperands,
     /* 123296 */     // GIR_Coverage, 7192,
     /* 123296 */     GIR_EraseRootFromParent_Done,
     /* 123297 */   // Label 2351: @123297
     /* 123297 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(123339), // Rule ID 7193 //
     /* 123302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123305 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123312 */     // MIs[0] Rn
     /* 123312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123324 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123337 */     GIR_RootConstrainSelectedInstOperands,
     /* 123338 */     // GIR_Coverage, 7193,
     /* 123338 */     GIR_EraseRootFromParent_Done,
     /* 123339 */   // Label 2352: @123339
     /* 123339 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(123381), // Rule ID 7194 //
     /* 123344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123354 */     // MIs[0] Rn
     /* 123354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123366 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123379 */     GIR_RootConstrainSelectedInstOperands,
     /* 123380 */     // GIR_Coverage, 7194,
     /* 123380 */     GIR_EraseRootFromParent_Done,
     /* 123381 */   // Label 2353: @123381
     /* 123381 */   GIM_Reject,
     /* 123382 */ // Label 2348: @123382
     /* 123382 */ GIM_Reject,
     /* 123383 */ // Label 2331: @123383
     /* 123383 */ GIM_Reject,
     /* 123384 */ // Label 22: @123384
     /* 123384 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2356*/ GIMT_Encode4(124375),
     /* 123395 */ /*GILLT_s32*//*Label 2354*/ GIMT_Encode4(123403),
     /* 123399 */ /*GILLT_s64*//*Label 2355*/ GIMT_Encode4(124148),
     /* 123403 */ // Label 2354: @123403
     /* 123403 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(124147),
     /* 123408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123411 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(123460), // Rule ID 7035 //
     /* 123416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123433 */     // MIs[0] Rn
     /* 123433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123445 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 123448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123458 */     GIR_RootConstrainSelectedInstOperands,
     /* 123459 */     // GIR_Coverage, 7035,
     /* 123459 */     GIR_EraseRootFromParent_Done,
     /* 123460 */   // Label 2358: @123460
     /* 123460 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(123509), // Rule ID 7036 //
     /* 123465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123482 */     // MIs[0] Rn
     /* 123482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123494 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 123497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123507 */     GIR_RootConstrainSelectedInstOperands,
     /* 123508 */     // GIR_Coverage, 7036,
     /* 123508 */     GIR_EraseRootFromParent_Done,
     /* 123509 */   // Label 2359: @123509
     /* 123509 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(123558), // Rule ID 7037 //
     /* 123514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123531 */     // MIs[0] Rn
     /* 123531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123543 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 123546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123556 */     GIR_RootConstrainSelectedInstOperands,
     /* 123557 */     // GIR_Coverage, 7037,
     /* 123557 */     GIR_EraseRootFromParent_Done,
     /* 123558 */   // Label 2360: @123558
     /* 123558 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(123607), // Rule ID 7038 //
     /* 123563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123580 */     // MIs[0] Rn
     /* 123580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123592 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 123595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123605 */     GIR_RootConstrainSelectedInstOperands,
     /* 123606 */     // GIR_Coverage, 7038,
     /* 123606 */     GIR_EraseRootFromParent_Done,
     /* 123607 */   // Label 2361: @123607
     /* 123607 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(123656), // Rule ID 7039 //
     /* 123612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123629 */     // MIs[0] Rn
     /* 123629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123641 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 123644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123654 */     GIR_RootConstrainSelectedInstOperands,
     /* 123655 */     // GIR_Coverage, 7039,
     /* 123655 */     GIR_EraseRootFromParent_Done,
     /* 123656 */   // Label 2362: @123656
     /* 123656 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(123705), // Rule ID 7040 //
     /* 123661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123678 */     // MIs[0] Rn
     /* 123678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123690 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 123693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123703 */     GIR_RootConstrainSelectedInstOperands,
     /* 123704 */     // GIR_Coverage, 7040,
     /* 123704 */     GIR_EraseRootFromParent_Done,
     /* 123705 */   // Label 2363: @123705
     /* 123705 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(123754), // Rule ID 7041 //
     /* 123710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123727 */     // MIs[0] Rn
     /* 123727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123739 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 123742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123752 */     GIR_RootConstrainSelectedInstOperands,
     /* 123753 */     // GIR_Coverage, 7041,
     /* 123753 */     GIR_EraseRootFromParent_Done,
     /* 123754 */   // Label 2364: @123754
     /* 123754 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(123803), // Rule ID 7042 //
     /* 123759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123776 */     // MIs[0] Rn
     /* 123776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123788 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 123791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123801 */     GIR_RootConstrainSelectedInstOperands,
     /* 123802 */     // GIR_Coverage, 7042,
     /* 123802 */     GIR_EraseRootFromParent_Done,
     /* 123803 */   // Label 2365: @123803
     /* 123803 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(123852), // Rule ID 7043 //
     /* 123808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123825 */     // MIs[0] Rn
     /* 123825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123837 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 123840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123850 */     GIR_RootConstrainSelectedInstOperands,
     /* 123851 */     // GIR_Coverage, 7043,
     /* 123851 */     GIR_EraseRootFromParent_Done,
     /* 123852 */   // Label 2366: @123852
     /* 123852 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(123901), // Rule ID 7044 //
     /* 123857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123874 */     // MIs[0] Rn
     /* 123874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123886 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 123889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123899 */     GIR_RootConstrainSelectedInstOperands,
     /* 123900 */     // GIR_Coverage, 7044,
     /* 123900 */     GIR_EraseRootFromParent_Done,
     /* 123901 */   // Label 2367: @123901
     /* 123901 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(123950), // Rule ID 7045 //
     /* 123906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123923 */     // MIs[0] Rn
     /* 123923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123935 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 123938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123948 */     GIR_RootConstrainSelectedInstOperands,
     /* 123949 */     // GIR_Coverage, 7045,
     /* 123949 */     GIR_EraseRootFromParent_Done,
     /* 123950 */   // Label 2368: @123950
     /* 123950 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(123999), // Rule ID 7046 //
     /* 123955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123972 */     // MIs[0] Rn
     /* 123972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123984 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 123987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123997 */     GIR_RootConstrainSelectedInstOperands,
     /* 123998 */     // GIR_Coverage, 7046,
     /* 123998 */     GIR_EraseRootFromParent_Done,
     /* 123999 */   // Label 2369: @123999
     /* 123999 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(124048), // Rule ID 7047 //
     /* 124004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124021 */     // MIs[0] Rn
     /* 124021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124033 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 124036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124046 */     GIR_RootConstrainSelectedInstOperands,
     /* 124047 */     // GIR_Coverage, 7047,
     /* 124047 */     GIR_EraseRootFromParent_Done,
     /* 124048 */   // Label 2370: @124048
     /* 124048 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(124097), // Rule ID 7048 //
     /* 124053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124070 */     // MIs[0] Rn
     /* 124070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124082 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124095 */     GIR_RootConstrainSelectedInstOperands,
     /* 124096 */     // GIR_Coverage, 7048,
     /* 124096 */     GIR_EraseRootFromParent_Done,
     /* 124097 */   // Label 2371: @124097
     /* 124097 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(124146), // Rule ID 7049 //
     /* 124102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124119 */     // MIs[0] Rn
     /* 124119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124131 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124144 */     GIR_RootConstrainSelectedInstOperands,
     /* 124145 */     // GIR_Coverage, 7049,
     /* 124145 */     GIR_EraseRootFromParent_Done,
     /* 124146 */   // Label 2372: @124146
     /* 124146 */   GIM_Reject,
     /* 124147 */ // Label 2357: @124147
     /* 124147 */ GIM_Reject,
     /* 124148 */ // Label 2355: @124148
     /* 124148 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(124374),
     /* 124153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 124156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124163 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(124205), // Rule ID 2570 //
     /* 124168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124178 */     // MIs[0] Rn
     /* 124178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124190 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 124193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124203 */     GIR_RootConstrainSelectedInstOperands,
     /* 124204 */     // GIR_Coverage, 2570,
     /* 124204 */     GIR_EraseRootFromParent_Done,
     /* 124205 */   // Label 2374: @124205
     /* 124205 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(124247), // Rule ID 2571 //
     /* 124210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124220 */     // MIs[0] Rn
     /* 124220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124232 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 124235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124245 */     GIR_RootConstrainSelectedInstOperands,
     /* 124246 */     // GIR_Coverage, 2571,
     /* 124246 */     GIR_EraseRootFromParent_Done,
     /* 124247 */   // Label 2375: @124247
     /* 124247 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(124289), // Rule ID 2572 //
     /* 124252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124262 */     // MIs[0] Rn
     /* 124262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124274 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 124277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124287 */     GIR_RootConstrainSelectedInstOperands,
     /* 124288 */     // GIR_Coverage, 2572,
     /* 124288 */     GIR_EraseRootFromParent_Done,
     /* 124289 */   // Label 2376: @124289
     /* 124289 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(124331), // Rule ID 2573 //
     /* 124294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124304 */     // MIs[0] Rn
     /* 124304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124316 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124329 */     GIR_RootConstrainSelectedInstOperands,
     /* 124330 */     // GIR_Coverage, 2573,
     /* 124330 */     GIR_EraseRootFromParent_Done,
     /* 124331 */   // Label 2377: @124331
     /* 124331 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(124373), // Rule ID 2574 //
     /* 124336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124346 */     // MIs[0] Rn
     /* 124346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124358 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124371 */     GIR_RootConstrainSelectedInstOperands,
     /* 124372 */     // GIR_Coverage, 2574,
     /* 124372 */     GIR_EraseRootFromParent_Done,
     /* 124373 */   // Label 2378: @124373
     /* 124373 */   GIM_Reject,
     /* 124374 */ // Label 2373: @124374
     /* 124374 */ GIM_Reject,
     /* 124375 */ // Label 2356: @124375
     /* 124375 */ GIM_Reject,
     /* 124376 */ // Label 23: @124376
     /* 124376 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2381*/ GIMT_Encode4(125867),
     /* 124387 */ /*GILLT_s32*//*Label 2379*/ GIMT_Encode4(124395),
     /* 124391 */ /*GILLT_s64*//*Label 2380*/ GIMT_Encode4(125515),
     /* 124395 */ // Label 2379: @124395
     /* 124395 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(125514),
     /* 124400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 124403 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(124477), // Rule ID 7230 //
     /* 124408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124425 */     // MIs[0] Rn
     /* 124425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124437 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124449 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 124464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124475 */     GIR_RootConstrainSelectedInstOperands,
     /* 124476 */     // GIR_Coverage, 7230,
     /* 124476 */     GIR_EraseRootFromParent_Done,
     /* 124477 */   // Label 2383: @124477
     /* 124477 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(124551), // Rule ID 7231 //
     /* 124482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124499 */     // MIs[0] Rn
     /* 124499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124511 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124523 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 124538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124549 */     GIR_RootConstrainSelectedInstOperands,
     /* 124550 */     // GIR_Coverage, 7231,
     /* 124550 */     GIR_EraseRootFromParent_Done,
     /* 124551 */   // Label 2384: @124551
     /* 124551 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(124625), // Rule ID 7232 //
     /* 124556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124573 */     // MIs[0] Rn
     /* 124573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124585 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124597 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 124612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124623 */     GIR_RootConstrainSelectedInstOperands,
     /* 124624 */     // GIR_Coverage, 7232,
     /* 124624 */     GIR_EraseRootFromParent_Done,
     /* 124625 */   // Label 2385: @124625
     /* 124625 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(124699), // Rule ID 7233 //
     /* 124630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124647 */     // MIs[0] Rn
     /* 124647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124659 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124671 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124697 */     GIR_RootConstrainSelectedInstOperands,
     /* 124698 */     // GIR_Coverage, 7233,
     /* 124698 */     GIR_EraseRootFromParent_Done,
     /* 124699 */   // Label 2386: @124699
     /* 124699 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(124773), // Rule ID 7234 //
     /* 124704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124721 */     // MIs[0] Rn
     /* 124721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124733 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124745 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124771 */     GIR_RootConstrainSelectedInstOperands,
     /* 124772 */     // GIR_Coverage, 7234,
     /* 124772 */     GIR_EraseRootFromParent_Done,
     /* 124773 */   // Label 2387: @124773
     /* 124773 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(124847), // Rule ID 7235 //
     /* 124778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124788 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124795 */     // MIs[0] Rn
     /* 124795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124807 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124819 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 124834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124845 */     GIR_RootConstrainSelectedInstOperands,
     /* 124846 */     // GIR_Coverage, 7235,
     /* 124846 */     GIR_EraseRootFromParent_Done,
     /* 124847 */   // Label 2388: @124847
     /* 124847 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(124921), // Rule ID 7236 //
     /* 124852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124869 */     // MIs[0] Rn
     /* 124869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124881 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124893 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 124908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124919 */     GIR_RootConstrainSelectedInstOperands,
     /* 124920 */     // GIR_Coverage, 7236,
     /* 124920 */     GIR_EraseRootFromParent_Done,
     /* 124921 */   // Label 2389: @124921
     /* 124921 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(124995), // Rule ID 7237 //
     /* 124926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124943 */     // MIs[0] Rn
     /* 124943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124955 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124967 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 124982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124993 */     GIR_RootConstrainSelectedInstOperands,
     /* 124994 */     // GIR_Coverage, 7237,
     /* 124994 */     GIR_EraseRootFromParent_Done,
     /* 124995 */   // Label 2390: @124995
     /* 124995 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(125069), // Rule ID 7238 //
     /* 125000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125017 */     // MIs[0] Rn
     /* 125017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125029 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125041 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125067 */     GIR_RootConstrainSelectedInstOperands,
     /* 125068 */     // GIR_Coverage, 7238,
     /* 125068 */     GIR_EraseRootFromParent_Done,
     /* 125069 */   // Label 2391: @125069
     /* 125069 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(125143), // Rule ID 7239 //
     /* 125074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125091 */     // MIs[0] Rn
     /* 125091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125103 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125115 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125141 */     GIR_RootConstrainSelectedInstOperands,
     /* 125142 */     // GIR_Coverage, 7239,
     /* 125142 */     GIR_EraseRootFromParent_Done,
     /* 125143 */   // Label 2392: @125143
     /* 125143 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(125217), // Rule ID 7240 //
     /* 125148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125151 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125165 */     // MIs[0] Rn
     /* 125165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125177 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 125204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125215 */     GIR_RootConstrainSelectedInstOperands,
     /* 125216 */     // GIR_Coverage, 7240,
     /* 125216 */     GIR_EraseRootFromParent_Done,
     /* 125217 */   // Label 2393: @125217
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(125291), // Rule ID 7241 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125225 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125232 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125239 */     // MIs[0] Rn
     /* 125239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125251 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125263 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 125278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125289 */     GIR_RootConstrainSelectedInstOperands,
     /* 125290 */     // GIR_Coverage, 7241,
     /* 125290 */     GIR_EraseRootFromParent_Done,
     /* 125291 */   // Label 2394: @125291
     /* 125291 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(125365), // Rule ID 7242 //
     /* 125296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125313 */     // MIs[0] Rn
     /* 125313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125325 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 125352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125363 */     GIR_RootConstrainSelectedInstOperands,
     /* 125364 */     // GIR_Coverage, 7242,
     /* 125364 */     GIR_EraseRootFromParent_Done,
     /* 125365 */   // Label 2395: @125365
     /* 125365 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(125439), // Rule ID 7243 //
     /* 125370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125387 */     // MIs[0] Rn
     /* 125387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125399 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125411 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125437 */     GIR_RootConstrainSelectedInstOperands,
     /* 125438 */     // GIR_Coverage, 7243,
     /* 125438 */     GIR_EraseRootFromParent_Done,
     /* 125439 */   // Label 2396: @125439
     /* 125439 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(125513), // Rule ID 7244 //
     /* 125444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125461 */     // MIs[0] Rn
     /* 125461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125473 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125485 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125511 */     GIR_RootConstrainSelectedInstOperands,
     /* 125512 */     // GIR_Coverage, 7244,
     /* 125512 */     GIR_EraseRootFromParent_Done,
     /* 125513 */   // Label 2397: @125513
     /* 125513 */   GIM_Reject,
     /* 125514 */ // Label 2382: @125514
     /* 125514 */ GIM_Reject,
     /* 125515 */ // Label 2380: @125515
     /* 125515 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(125866),
     /* 125520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 125523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 125530 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(125597), // Rule ID 7225 //
     /* 125535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125545 */     // MIs[0] Rn
     /* 125545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125557 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125569 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 125584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125595 */     GIR_RootConstrainSelectedInstOperands,
     /* 125596 */     // GIR_Coverage, 7225,
     /* 125596 */     GIR_EraseRootFromParent_Done,
     /* 125597 */   // Label 2399: @125597
     /* 125597 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(125664), // Rule ID 7226 //
     /* 125602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125612 */     // MIs[0] Rn
     /* 125612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125624 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125636 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 125651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125662 */     GIR_RootConstrainSelectedInstOperands,
     /* 125663 */     // GIR_Coverage, 7226,
     /* 125663 */     GIR_EraseRootFromParent_Done,
     /* 125664 */   // Label 2400: @125664
     /* 125664 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(125731), // Rule ID 7227 //
     /* 125669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125679 */     // MIs[0] Rn
     /* 125679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125691 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125703 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 125718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125729 */     GIR_RootConstrainSelectedInstOperands,
     /* 125730 */     // GIR_Coverage, 7227,
     /* 125730 */     GIR_EraseRootFromParent_Done,
     /* 125731 */   // Label 2401: @125731
     /* 125731 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(125798), // Rule ID 7228 //
     /* 125736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125746 */     // MIs[0] Rn
     /* 125746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125758 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125770 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 125785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125796 */     GIR_RootConstrainSelectedInstOperands,
     /* 125797 */     // GIR_Coverage, 7228,
     /* 125797 */     GIR_EraseRootFromParent_Done,
     /* 125798 */   // Label 2402: @125798
     /* 125798 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(125865), // Rule ID 7229 //
     /* 125803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125813 */     // MIs[0] Rn
     /* 125813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125825 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125837 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 125852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125863 */     GIR_RootConstrainSelectedInstOperands,
     /* 125864 */     // GIR_Coverage, 7229,
     /* 125864 */     GIR_EraseRootFromParent_Done,
     /* 125865 */   // Label 2403: @125865
     /* 125865 */   GIM_Reject,
     /* 125866 */ // Label 2398: @125866
     /* 125866 */ GIM_Reject,
     /* 125867 */ // Label 2381: @125867
     /* 125867 */ GIM_Reject,
     /* 125868 */ // Label 24: @125868
     /* 125868 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2406*/ GIMT_Encode4(127359),
     /* 125879 */ /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(125887),
     /* 125883 */ /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(127007),
     /* 125887 */ // Label 2404: @125887
     /* 125887 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(127006),
     /* 125892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125895 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(125969), // Rule ID 7250 //
     /* 125900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125917 */     // MIs[0] Rn
     /* 125917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125929 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 125936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125941 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125967 */     GIR_RootConstrainSelectedInstOperands,
     /* 125968 */     // GIR_Coverage, 7250,
     /* 125968 */     GIR_EraseRootFromParent_Done,
     /* 125969 */   // Label 2408: @125969
     /* 125969 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(126043), // Rule ID 7251 //
     /* 125974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125991 */     // MIs[0] Rn
     /* 125991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126003 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126015 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 126030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126041 */     GIR_RootConstrainSelectedInstOperands,
     /* 126042 */     // GIR_Coverage, 7251,
     /* 126042 */     GIR_EraseRootFromParent_Done,
     /* 126043 */   // Label 2409: @126043
     /* 126043 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(126117), // Rule ID 7252 //
     /* 126048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126065 */     // MIs[0] Rn
     /* 126065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126077 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126089 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 126104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126115 */     GIR_RootConstrainSelectedInstOperands,
     /* 126116 */     // GIR_Coverage, 7252,
     /* 126116 */     GIR_EraseRootFromParent_Done,
     /* 126117 */   // Label 2410: @126117
     /* 126117 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(126191), // Rule ID 7253 //
     /* 126122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126139 */     // MIs[0] Rn
     /* 126139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126151 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126163 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126189 */     GIR_RootConstrainSelectedInstOperands,
     /* 126190 */     // GIR_Coverage, 7253,
     /* 126190 */     GIR_EraseRootFromParent_Done,
     /* 126191 */   // Label 2411: @126191
     /* 126191 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(126265), // Rule ID 7254 //
     /* 126196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126213 */     // MIs[0] Rn
     /* 126213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126225 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126237 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126263 */     GIR_RootConstrainSelectedInstOperands,
     /* 126264 */     // GIR_Coverage, 7254,
     /* 126264 */     GIR_EraseRootFromParent_Done,
     /* 126265 */   // Label 2412: @126265
     /* 126265 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(126339), // Rule ID 7255 //
     /* 126270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126287 */     // MIs[0] Rn
     /* 126287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126299 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126311 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 126326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126337 */     GIR_RootConstrainSelectedInstOperands,
     /* 126338 */     // GIR_Coverage, 7255,
     /* 126338 */     GIR_EraseRootFromParent_Done,
     /* 126339 */   // Label 2413: @126339
     /* 126339 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(126413), // Rule ID 7256 //
     /* 126344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126361 */     // MIs[0] Rn
     /* 126361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126373 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126385 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 126400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126411 */     GIR_RootConstrainSelectedInstOperands,
     /* 126412 */     // GIR_Coverage, 7256,
     /* 126412 */     GIR_EraseRootFromParent_Done,
     /* 126413 */   // Label 2414: @126413
     /* 126413 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(126487), // Rule ID 7257 //
     /* 126418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126435 */     // MIs[0] Rn
     /* 126435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126447 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126459 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 126474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126485 */     GIR_RootConstrainSelectedInstOperands,
     /* 126486 */     // GIR_Coverage, 7257,
     /* 126486 */     GIR_EraseRootFromParent_Done,
     /* 126487 */   // Label 2415: @126487
     /* 126487 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(126561), // Rule ID 7258 //
     /* 126492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126509 */     // MIs[0] Rn
     /* 126509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126521 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126533 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 126548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126559 */     GIR_RootConstrainSelectedInstOperands,
     /* 126560 */     // GIR_Coverage, 7258,
     /* 126560 */     GIR_EraseRootFromParent_Done,
     /* 126561 */   // Label 2416: @126561
     /* 126561 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(126635), // Rule ID 7259 //
     /* 126566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126583 */     // MIs[0] Rn
     /* 126583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126595 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126607 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 126622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126633 */     GIR_RootConstrainSelectedInstOperands,
     /* 126634 */     // GIR_Coverage, 7259,
     /* 126634 */     GIR_EraseRootFromParent_Done,
     /* 126635 */   // Label 2417: @126635
     /* 126635 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(126709), // Rule ID 7260 //
     /* 126640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126657 */     // MIs[0] Rn
     /* 126657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126669 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126681 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126707 */     GIR_RootConstrainSelectedInstOperands,
     /* 126708 */     // GIR_Coverage, 7260,
     /* 126708 */     GIR_EraseRootFromParent_Done,
     /* 126709 */   // Label 2418: @126709
     /* 126709 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(126783), // Rule ID 7261 //
     /* 126714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126731 */     // MIs[0] Rn
     /* 126731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126743 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126755 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 126770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126781 */     GIR_RootConstrainSelectedInstOperands,
     /* 126782 */     // GIR_Coverage, 7261,
     /* 126782 */     GIR_EraseRootFromParent_Done,
     /* 126783 */   // Label 2419: @126783
     /* 126783 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(126857), // Rule ID 7262 //
     /* 126788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126805 */     // MIs[0] Rn
     /* 126805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126817 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126829 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 126844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126855 */     GIR_RootConstrainSelectedInstOperands,
     /* 126856 */     // GIR_Coverage, 7262,
     /* 126856 */     GIR_EraseRootFromParent_Done,
     /* 126857 */   // Label 2420: @126857
     /* 126857 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(126931), // Rule ID 7263 //
     /* 126862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126879 */     // MIs[0] Rn
     /* 126879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126891 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126903 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 126918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126929 */     GIR_RootConstrainSelectedInstOperands,
     /* 126930 */     // GIR_Coverage, 7263,
     /* 126930 */     GIR_EraseRootFromParent_Done,
     /* 126931 */   // Label 2421: @126931
     /* 126931 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(127005), // Rule ID 7264 //
     /* 126936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126953 */     // MIs[0] Rn
     /* 126953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126965 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126977 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 126992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127003 */     GIR_RootConstrainSelectedInstOperands,
     /* 127004 */     // GIR_Coverage, 7264,
     /* 127004 */     GIR_EraseRootFromParent_Done,
     /* 127005 */   // Label 2422: @127005
     /* 127005 */   GIM_Reject,
     /* 127006 */ // Label 2407: @127006
     /* 127006 */ GIM_Reject,
     /* 127007 */ // Label 2405: @127007
     /* 127007 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(127358),
     /* 127012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127015 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127022 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(127089), // Rule ID 7245 //
     /* 127027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127037 */     // MIs[0] Rn
     /* 127037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127049 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127061 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 127076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127087 */     GIR_RootConstrainSelectedInstOperands,
     /* 127088 */     // GIR_Coverage, 7245,
     /* 127088 */     GIR_EraseRootFromParent_Done,
     /* 127089 */   // Label 2424: @127089
     /* 127089 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(127156), // Rule ID 7246 //
     /* 127094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127104 */     // MIs[0] Rn
     /* 127104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127116 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127128 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 127143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127154 */     GIR_RootConstrainSelectedInstOperands,
     /* 127155 */     // GIR_Coverage, 7246,
     /* 127155 */     GIR_EraseRootFromParent_Done,
     /* 127156 */   // Label 2425: @127156
     /* 127156 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(127223), // Rule ID 7247 //
     /* 127161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127171 */     // MIs[0] Rn
     /* 127171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127183 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127195 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 127210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127221 */     GIR_RootConstrainSelectedInstOperands,
     /* 127222 */     // GIR_Coverage, 7247,
     /* 127222 */     GIR_EraseRootFromParent_Done,
     /* 127223 */   // Label 2426: @127223
     /* 127223 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(127290), // Rule ID 7248 //
     /* 127228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127238 */     // MIs[0] Rn
     /* 127238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127250 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127262 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127288 */     GIR_RootConstrainSelectedInstOperands,
     /* 127289 */     // GIR_Coverage, 7248,
     /* 127289 */     GIR_EraseRootFromParent_Done,
     /* 127290 */   // Label 2427: @127290
     /* 127290 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(127357), // Rule ID 7249 //
     /* 127295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127305 */     // MIs[0] Rn
     /* 127305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127317 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127329 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127355 */     GIR_RootConstrainSelectedInstOperands,
     /* 127356 */     // GIR_Coverage, 7249,
     /* 127356 */     GIR_EraseRootFromParent_Done,
     /* 127357 */   // Label 2428: @127357
     /* 127357 */   GIM_Reject,
     /* 127358 */ // Label 2423: @127358
     /* 127358 */ GIM_Reject,
     /* 127359 */ // Label 2406: @127359
     /* 127359 */ GIM_Reject,
     /* 127360 */ // Label 25: @127360
     /* 127360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2431*/ GIMT_Encode4(128351),
     /* 127371 */ /*GILLT_s32*//*Label 2429*/ GIMT_Encode4(127379),
     /* 127375 */ /*GILLT_s64*//*Label 2430*/ GIMT_Encode4(128124),
     /* 127379 */ // Label 2429: @127379
     /* 127379 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(128123),
     /* 127384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127387 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(127436), // Rule ID 7055 //
     /* 127392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127409 */     // MIs[0] Rn
     /* 127409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127421 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 127424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127434 */     GIR_RootConstrainSelectedInstOperands,
     /* 127435 */     // GIR_Coverage, 7055,
     /* 127435 */     GIR_EraseRootFromParent_Done,
     /* 127436 */   // Label 2433: @127436
     /* 127436 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(127485), // Rule ID 7056 //
     /* 127441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127458 */     // MIs[0] Rn
     /* 127458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127470 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 127473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127483 */     GIR_RootConstrainSelectedInstOperands,
     /* 127484 */     // GIR_Coverage, 7056,
     /* 127484 */     GIR_EraseRootFromParent_Done,
     /* 127485 */   // Label 2434: @127485
     /* 127485 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(127534), // Rule ID 7057 //
     /* 127490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127507 */     // MIs[0] Rn
     /* 127507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127519 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 127522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127532 */     GIR_RootConstrainSelectedInstOperands,
     /* 127533 */     // GIR_Coverage, 7057,
     /* 127533 */     GIR_EraseRootFromParent_Done,
     /* 127534 */   // Label 2435: @127534
     /* 127534 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(127583), // Rule ID 7058 //
     /* 127539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127556 */     // MIs[0] Rn
     /* 127556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127568 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 127571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127581 */     GIR_RootConstrainSelectedInstOperands,
     /* 127582 */     // GIR_Coverage, 7058,
     /* 127582 */     GIR_EraseRootFromParent_Done,
     /* 127583 */   // Label 2436: @127583
     /* 127583 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(127632), // Rule ID 7059 //
     /* 127588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127605 */     // MIs[0] Rn
     /* 127605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127617 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 127620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127630 */     GIR_RootConstrainSelectedInstOperands,
     /* 127631 */     // GIR_Coverage, 7059,
     /* 127631 */     GIR_EraseRootFromParent_Done,
     /* 127632 */   // Label 2437: @127632
     /* 127632 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(127681), // Rule ID 7060 //
     /* 127637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127654 */     // MIs[0] Rn
     /* 127654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127666 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 127669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127679 */     GIR_RootConstrainSelectedInstOperands,
     /* 127680 */     // GIR_Coverage, 7060,
     /* 127680 */     GIR_EraseRootFromParent_Done,
     /* 127681 */   // Label 2438: @127681
     /* 127681 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(127730), // Rule ID 7061 //
     /* 127686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127703 */     // MIs[0] Rn
     /* 127703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127715 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 127718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127728 */     GIR_RootConstrainSelectedInstOperands,
     /* 127729 */     // GIR_Coverage, 7061,
     /* 127729 */     GIR_EraseRootFromParent_Done,
     /* 127730 */   // Label 2439: @127730
     /* 127730 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(127779), // Rule ID 7062 //
     /* 127735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127752 */     // MIs[0] Rn
     /* 127752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127764 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 127767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127777 */     GIR_RootConstrainSelectedInstOperands,
     /* 127778 */     // GIR_Coverage, 7062,
     /* 127778 */     GIR_EraseRootFromParent_Done,
     /* 127779 */   // Label 2440: @127779
     /* 127779 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(127828), // Rule ID 7063 //
     /* 127784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127801 */     // MIs[0] Rn
     /* 127801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127813 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 127816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127826 */     GIR_RootConstrainSelectedInstOperands,
     /* 127827 */     // GIR_Coverage, 7063,
     /* 127827 */     GIR_EraseRootFromParent_Done,
     /* 127828 */   // Label 2441: @127828
     /* 127828 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(127877), // Rule ID 7064 //
     /* 127833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127850 */     // MIs[0] Rn
     /* 127850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127862 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 127865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127875 */     GIR_RootConstrainSelectedInstOperands,
     /* 127876 */     // GIR_Coverage, 7064,
     /* 127876 */     GIR_EraseRootFromParent_Done,
     /* 127877 */   // Label 2442: @127877
     /* 127877 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(127926), // Rule ID 7065 //
     /* 127882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127899 */     // MIs[0] Rn
     /* 127899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127911 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 127914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127924 */     GIR_RootConstrainSelectedInstOperands,
     /* 127925 */     // GIR_Coverage, 7065,
     /* 127925 */     GIR_EraseRootFromParent_Done,
     /* 127926 */   // Label 2443: @127926
     /* 127926 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(127975), // Rule ID 7066 //
     /* 127931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127948 */     // MIs[0] Rn
     /* 127948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127960 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 127963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127973 */     GIR_RootConstrainSelectedInstOperands,
     /* 127974 */     // GIR_Coverage, 7066,
     /* 127974 */     GIR_EraseRootFromParent_Done,
     /* 127975 */   // Label 2444: @127975
     /* 127975 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(128024), // Rule ID 7067 //
     /* 127980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127997 */     // MIs[0] Rn
     /* 127997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128009 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 128012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128022 */     GIR_RootConstrainSelectedInstOperands,
     /* 128023 */     // GIR_Coverage, 7067,
     /* 128023 */     GIR_EraseRootFromParent_Done,
     /* 128024 */   // Label 2445: @128024
     /* 128024 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(128073), // Rule ID 7068 //
     /* 128029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128046 */     // MIs[0] Rn
     /* 128046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128058 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128071 */     GIR_RootConstrainSelectedInstOperands,
     /* 128072 */     // GIR_Coverage, 7068,
     /* 128072 */     GIR_EraseRootFromParent_Done,
     /* 128073 */   // Label 2446: @128073
     /* 128073 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(128122), // Rule ID 7069 //
     /* 128078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128095 */     // MIs[0] Rn
     /* 128095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128107 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128120 */     GIR_RootConstrainSelectedInstOperands,
     /* 128121 */     // GIR_Coverage, 7069,
     /* 128121 */     GIR_EraseRootFromParent_Done,
     /* 128122 */   // Label 2447: @128122
     /* 128122 */   GIM_Reject,
     /* 128123 */ // Label 2432: @128123
     /* 128123 */ GIM_Reject,
     /* 128124 */ // Label 2430: @128124
     /* 128124 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(128350),
     /* 128129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128139 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(128181), // Rule ID 7050 //
     /* 128144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128154 */     // MIs[0] Rn
     /* 128154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128166 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 128169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128179 */     GIR_RootConstrainSelectedInstOperands,
     /* 128180 */     // GIR_Coverage, 7050,
     /* 128180 */     GIR_EraseRootFromParent_Done,
     /* 128181 */   // Label 2449: @128181
     /* 128181 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(128223), // Rule ID 7051 //
     /* 128186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128196 */     // MIs[0] Rn
     /* 128196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128208 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 128211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128221 */     GIR_RootConstrainSelectedInstOperands,
     /* 128222 */     // GIR_Coverage, 7051,
     /* 128222 */     GIR_EraseRootFromParent_Done,
     /* 128223 */   // Label 2450: @128223
     /* 128223 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(128265), // Rule ID 7052 //
     /* 128228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128238 */     // MIs[0] Rn
     /* 128238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128250 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 128253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128263 */     GIR_RootConstrainSelectedInstOperands,
     /* 128264 */     // GIR_Coverage, 7052,
     /* 128264 */     GIR_EraseRootFromParent_Done,
     /* 128265 */   // Label 2451: @128265
     /* 128265 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(128307), // Rule ID 7053 //
     /* 128270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128273 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128280 */     // MIs[0] Rn
     /* 128280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128292 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128305 */     GIR_RootConstrainSelectedInstOperands,
     /* 128306 */     // GIR_Coverage, 7053,
     /* 128306 */     GIR_EraseRootFromParent_Done,
     /* 128307 */   // Label 2452: @128307
     /* 128307 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(128349), // Rule ID 7054 //
     /* 128312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128322 */     // MIs[0] Rn
     /* 128322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128334 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128347 */     GIR_RootConstrainSelectedInstOperands,
     /* 128348 */     // GIR_Coverage, 7054,
     /* 128348 */     GIR_EraseRootFromParent_Done,
     /* 128349 */   // Label 2453: @128349
     /* 128349 */   GIM_Reject,
     /* 128350 */ // Label 2448: @128350
     /* 128350 */ GIM_Reject,
     /* 128351 */ // Label 2431: @128351
     /* 128351 */ GIM_Reject,
     /* 128352 */ // Label 26: @128352
     /* 128352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2456*/ GIMT_Encode4(129343),
     /* 128363 */ /*GILLT_s32*//*Label 2454*/ GIMT_Encode4(128371),
     /* 128367 */ /*GILLT_s64*//*Label 2455*/ GIMT_Encode4(129116),
     /* 128371 */ // Label 2454: @128371
     /* 128371 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(129115),
     /* 128376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128379 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(128428), // Rule ID 7075 //
     /* 128384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128401 */     // MIs[0] Rn
     /* 128401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128413 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 128416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128426 */     GIR_RootConstrainSelectedInstOperands,
     /* 128427 */     // GIR_Coverage, 7075,
     /* 128427 */     GIR_EraseRootFromParent_Done,
     /* 128428 */   // Label 2458: @128428
     /* 128428 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(128477), // Rule ID 7076 //
     /* 128433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128450 */     // MIs[0] Rn
     /* 128450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128462 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 128465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128475 */     GIR_RootConstrainSelectedInstOperands,
     /* 128476 */     // GIR_Coverage, 7076,
     /* 128476 */     GIR_EraseRootFromParent_Done,
     /* 128477 */   // Label 2459: @128477
     /* 128477 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(128526), // Rule ID 7077 //
     /* 128482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128499 */     // MIs[0] Rn
     /* 128499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128511 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 128514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128524 */     GIR_RootConstrainSelectedInstOperands,
     /* 128525 */     // GIR_Coverage, 7077,
     /* 128525 */     GIR_EraseRootFromParent_Done,
     /* 128526 */   // Label 2460: @128526
     /* 128526 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(128575), // Rule ID 7078 //
     /* 128531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128548 */     // MIs[0] Rn
     /* 128548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128560 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 128563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128573 */     GIR_RootConstrainSelectedInstOperands,
     /* 128574 */     // GIR_Coverage, 7078,
     /* 128574 */     GIR_EraseRootFromParent_Done,
     /* 128575 */   // Label 2461: @128575
     /* 128575 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(128624), // Rule ID 7079 //
     /* 128580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128597 */     // MIs[0] Rn
     /* 128597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128609 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 128612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128622 */     GIR_RootConstrainSelectedInstOperands,
     /* 128623 */     // GIR_Coverage, 7079,
     /* 128623 */     GIR_EraseRootFromParent_Done,
     /* 128624 */   // Label 2462: @128624
     /* 128624 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(128673), // Rule ID 7080 //
     /* 128629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128646 */     // MIs[0] Rn
     /* 128646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128658 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 128661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128671 */     GIR_RootConstrainSelectedInstOperands,
     /* 128672 */     // GIR_Coverage, 7080,
     /* 128672 */     GIR_EraseRootFromParent_Done,
     /* 128673 */   // Label 2463: @128673
     /* 128673 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(128722), // Rule ID 7081 //
     /* 128678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128695 */     // MIs[0] Rn
     /* 128695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128707 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 128710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128720 */     GIR_RootConstrainSelectedInstOperands,
     /* 128721 */     // GIR_Coverage, 7081,
     /* 128721 */     GIR_EraseRootFromParent_Done,
     /* 128722 */   // Label 2464: @128722
     /* 128722 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(128771), // Rule ID 7082 //
     /* 128727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128744 */     // MIs[0] Rn
     /* 128744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128756 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 128759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128769 */     GIR_RootConstrainSelectedInstOperands,
     /* 128770 */     // GIR_Coverage, 7082,
     /* 128770 */     GIR_EraseRootFromParent_Done,
     /* 128771 */   // Label 2465: @128771
     /* 128771 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(128820), // Rule ID 7083 //
     /* 128776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128793 */     // MIs[0] Rn
     /* 128793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128805 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 128808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128818 */     GIR_RootConstrainSelectedInstOperands,
     /* 128819 */     // GIR_Coverage, 7083,
     /* 128819 */     GIR_EraseRootFromParent_Done,
     /* 128820 */   // Label 2466: @128820
     /* 128820 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(128869), // Rule ID 7084 //
     /* 128825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128842 */     // MIs[0] Rn
     /* 128842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128854 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 128857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128867 */     GIR_RootConstrainSelectedInstOperands,
     /* 128868 */     // GIR_Coverage, 7084,
     /* 128868 */     GIR_EraseRootFromParent_Done,
     /* 128869 */   // Label 2467: @128869
     /* 128869 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(128918), // Rule ID 7085 //
     /* 128874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128891 */     // MIs[0] Rn
     /* 128891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128903 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 128906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128916 */     GIR_RootConstrainSelectedInstOperands,
     /* 128917 */     // GIR_Coverage, 7085,
     /* 128917 */     GIR_EraseRootFromParent_Done,
     /* 128918 */   // Label 2468: @128918
     /* 128918 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(128967), // Rule ID 7086 //
     /* 128923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128940 */     // MIs[0] Rn
     /* 128940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128952 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 128955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128965 */     GIR_RootConstrainSelectedInstOperands,
     /* 128966 */     // GIR_Coverage, 7086,
     /* 128966 */     GIR_EraseRootFromParent_Done,
     /* 128967 */   // Label 2469: @128967
     /* 128967 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(129016), // Rule ID 7087 //
     /* 128972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128989 */     // MIs[0] Rn
     /* 128989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129001 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 129004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129014 */     GIR_RootConstrainSelectedInstOperands,
     /* 129015 */     // GIR_Coverage, 7087,
     /* 129015 */     GIR_EraseRootFromParent_Done,
     /* 129016 */   // Label 2470: @129016
     /* 129016 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(129065), // Rule ID 7088 //
     /* 129021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129038 */     // MIs[0] Rn
     /* 129038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129050 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129063 */     GIR_RootConstrainSelectedInstOperands,
     /* 129064 */     // GIR_Coverage, 7088,
     /* 129064 */     GIR_EraseRootFromParent_Done,
     /* 129065 */   // Label 2471: @129065
     /* 129065 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(129114), // Rule ID 7089 //
     /* 129070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129087 */     // MIs[0] Rn
     /* 129087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129099 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129112 */     GIR_RootConstrainSelectedInstOperands,
     /* 129113 */     // GIR_Coverage, 7089,
     /* 129113 */     GIR_EraseRootFromParent_Done,
     /* 129114 */   // Label 2472: @129114
     /* 129114 */   GIM_Reject,
     /* 129115 */ // Label 2457: @129115
     /* 129115 */ GIM_Reject,
     /* 129116 */ // Label 2455: @129116
     /* 129116 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(129342),
     /* 129121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129124 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129131 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(129173), // Rule ID 7070 //
     /* 129136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129146 */     // MIs[0] Rn
     /* 129146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129158 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 129161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129171 */     GIR_RootConstrainSelectedInstOperands,
     /* 129172 */     // GIR_Coverage, 7070,
     /* 129172 */     GIR_EraseRootFromParent_Done,
     /* 129173 */   // Label 2474: @129173
     /* 129173 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(129215), // Rule ID 7071 //
     /* 129178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129188 */     // MIs[0] Rn
     /* 129188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129200 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 129203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129213 */     GIR_RootConstrainSelectedInstOperands,
     /* 129214 */     // GIR_Coverage, 7071,
     /* 129214 */     GIR_EraseRootFromParent_Done,
     /* 129215 */   // Label 2475: @129215
     /* 129215 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(129257), // Rule ID 7072 //
     /* 129220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129230 */     // MIs[0] Rn
     /* 129230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129242 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 129245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129255 */     GIR_RootConstrainSelectedInstOperands,
     /* 129256 */     // GIR_Coverage, 7072,
     /* 129256 */     GIR_EraseRootFromParent_Done,
     /* 129257 */   // Label 2476: @129257
     /* 129257 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(129299), // Rule ID 7073 //
     /* 129262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129265 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129272 */     // MIs[0] Rn
     /* 129272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129284 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129297 */     GIR_RootConstrainSelectedInstOperands,
     /* 129298 */     // GIR_Coverage, 7073,
     /* 129298 */     GIR_EraseRootFromParent_Done,
     /* 129299 */   // Label 2477: @129299
     /* 129299 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(129341), // Rule ID 7074 //
     /* 129304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129314 */     // MIs[0] Rn
     /* 129314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129326 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129339 */     GIR_RootConstrainSelectedInstOperands,
     /* 129340 */     // GIR_Coverage, 7074,
     /* 129340 */     GIR_EraseRootFromParent_Done,
     /* 129341 */   // Label 2478: @129341
     /* 129341 */   GIM_Reject,
     /* 129342 */ // Label 2473: @129342
     /* 129342 */ GIM_Reject,
     /* 129343 */ // Label 2456: @129343
     /* 129343 */ GIM_Reject,
     /* 129344 */ // Label 27: @129344
     /* 129344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2481*/ GIMT_Encode4(130335),
     /* 129355 */ /*GILLT_s32*//*Label 2479*/ GIMT_Encode4(129363),
     /* 129359 */ /*GILLT_s64*//*Label 2480*/ GIMT_Encode4(130108),
     /* 129363 */ // Label 2479: @129363
     /* 129363 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(130107),
     /* 129368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129371 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(129420), // Rule ID 7115 //
     /* 129376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129393 */     // MIs[0] Rn
     /* 129393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129405 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 129408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129418 */     GIR_RootConstrainSelectedInstOperands,
     /* 129419 */     // GIR_Coverage, 7115,
     /* 129419 */     GIR_EraseRootFromParent_Done,
     /* 129420 */   // Label 2483: @129420
     /* 129420 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(129469), // Rule ID 7116 //
     /* 129425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129442 */     // MIs[0] Rn
     /* 129442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129454 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 129457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129467 */     GIR_RootConstrainSelectedInstOperands,
     /* 129468 */     // GIR_Coverage, 7116,
     /* 129468 */     GIR_EraseRootFromParent_Done,
     /* 129469 */   // Label 2484: @129469
     /* 129469 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(129518), // Rule ID 7117 //
     /* 129474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129491 */     // MIs[0] Rn
     /* 129491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129503 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 129506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129516 */     GIR_RootConstrainSelectedInstOperands,
     /* 129517 */     // GIR_Coverage, 7117,
     /* 129517 */     GIR_EraseRootFromParent_Done,
     /* 129518 */   // Label 2485: @129518
     /* 129518 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(129567), // Rule ID 7118 //
     /* 129523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129540 */     // MIs[0] Rn
     /* 129540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129552 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 129555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129565 */     GIR_RootConstrainSelectedInstOperands,
     /* 129566 */     // GIR_Coverage, 7118,
     /* 129566 */     GIR_EraseRootFromParent_Done,
     /* 129567 */   // Label 2486: @129567
     /* 129567 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(129616), // Rule ID 7119 //
     /* 129572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129589 */     // MIs[0] Rn
     /* 129589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129601 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 129604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129614 */     GIR_RootConstrainSelectedInstOperands,
     /* 129615 */     // GIR_Coverage, 7119,
     /* 129615 */     GIR_EraseRootFromParent_Done,
     /* 129616 */   // Label 2487: @129616
     /* 129616 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(129665), // Rule ID 7120 //
     /* 129621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129638 */     // MIs[0] Rn
     /* 129638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129650 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 129653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129663 */     GIR_RootConstrainSelectedInstOperands,
     /* 129664 */     // GIR_Coverage, 7120,
     /* 129664 */     GIR_EraseRootFromParent_Done,
     /* 129665 */   // Label 2488: @129665
     /* 129665 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(129714), // Rule ID 7121 //
     /* 129670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129687 */     // MIs[0] Rn
     /* 129687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129699 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 129702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129712 */     GIR_RootConstrainSelectedInstOperands,
     /* 129713 */     // GIR_Coverage, 7121,
     /* 129713 */     GIR_EraseRootFromParent_Done,
     /* 129714 */   // Label 2489: @129714
     /* 129714 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(129763), // Rule ID 7122 //
     /* 129719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129736 */     // MIs[0] Rn
     /* 129736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129748 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 129751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129761 */     GIR_RootConstrainSelectedInstOperands,
     /* 129762 */     // GIR_Coverage, 7122,
     /* 129762 */     GIR_EraseRootFromParent_Done,
     /* 129763 */   // Label 2490: @129763
     /* 129763 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(129812), // Rule ID 7123 //
     /* 129768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129785 */     // MIs[0] Rn
     /* 129785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129797 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 129800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129810 */     GIR_RootConstrainSelectedInstOperands,
     /* 129811 */     // GIR_Coverage, 7123,
     /* 129811 */     GIR_EraseRootFromParent_Done,
     /* 129812 */   // Label 2491: @129812
     /* 129812 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(129861), // Rule ID 7124 //
     /* 129817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129834 */     // MIs[0] Rn
     /* 129834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129846 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 129849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129859 */     GIR_RootConstrainSelectedInstOperands,
     /* 129860 */     // GIR_Coverage, 7124,
     /* 129860 */     GIR_EraseRootFromParent_Done,
     /* 129861 */   // Label 2492: @129861
     /* 129861 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(129910), // Rule ID 7125 //
     /* 129866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129883 */     // MIs[0] Rn
     /* 129883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129895 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 129898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129908 */     GIR_RootConstrainSelectedInstOperands,
     /* 129909 */     // GIR_Coverage, 7125,
     /* 129909 */     GIR_EraseRootFromParent_Done,
     /* 129910 */   // Label 2493: @129910
     /* 129910 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(129959), // Rule ID 7126 //
     /* 129915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129932 */     // MIs[0] Rn
     /* 129932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129944 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 129947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129957 */     GIR_RootConstrainSelectedInstOperands,
     /* 129958 */     // GIR_Coverage, 7126,
     /* 129958 */     GIR_EraseRootFromParent_Done,
     /* 129959 */   // Label 2494: @129959
     /* 129959 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(130008), // Rule ID 7127 //
     /* 129964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129981 */     // MIs[0] Rn
     /* 129981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129993 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 129996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130006 */     GIR_RootConstrainSelectedInstOperands,
     /* 130007 */     // GIR_Coverage, 7127,
     /* 130007 */     GIR_EraseRootFromParent_Done,
     /* 130008 */   // Label 2495: @130008
     /* 130008 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(130057), // Rule ID 7128 //
     /* 130013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130030 */     // MIs[0] Rn
     /* 130030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130042 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130055 */     GIR_RootConstrainSelectedInstOperands,
     /* 130056 */     // GIR_Coverage, 7128,
     /* 130056 */     GIR_EraseRootFromParent_Done,
     /* 130057 */   // Label 2496: @130057
     /* 130057 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(130106), // Rule ID 7129 //
     /* 130062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130079 */     // MIs[0] Rn
     /* 130079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130091 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130104 */     GIR_RootConstrainSelectedInstOperands,
     /* 130105 */     // GIR_Coverage, 7129,
     /* 130105 */     GIR_EraseRootFromParent_Done,
     /* 130106 */   // Label 2497: @130106
     /* 130106 */   GIM_Reject,
     /* 130107 */ // Label 2482: @130107
     /* 130107 */ GIM_Reject,
     /* 130108 */ // Label 2480: @130108
     /* 130108 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(130334),
     /* 130113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130123 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(130165), // Rule ID 7110 //
     /* 130128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130138 */     // MIs[0] Rn
     /* 130138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130150 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 130153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130163 */     GIR_RootConstrainSelectedInstOperands,
     /* 130164 */     // GIR_Coverage, 7110,
     /* 130164 */     GIR_EraseRootFromParent_Done,
     /* 130165 */   // Label 2499: @130165
     /* 130165 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(130207), // Rule ID 7111 //
     /* 130170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130180 */     // MIs[0] Rn
     /* 130180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130192 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 130195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130205 */     GIR_RootConstrainSelectedInstOperands,
     /* 130206 */     // GIR_Coverage, 7111,
     /* 130206 */     GIR_EraseRootFromParent_Done,
     /* 130207 */   // Label 2500: @130207
     /* 130207 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(130249), // Rule ID 7112 //
     /* 130212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130222 */     // MIs[0] Rn
     /* 130222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130234 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 130237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130247 */     GIR_RootConstrainSelectedInstOperands,
     /* 130248 */     // GIR_Coverage, 7112,
     /* 130248 */     GIR_EraseRootFromParent_Done,
     /* 130249 */   // Label 2501: @130249
     /* 130249 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(130291), // Rule ID 7113 //
     /* 130254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130264 */     // MIs[0] Rn
     /* 130264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130276 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130289 */     GIR_RootConstrainSelectedInstOperands,
     /* 130290 */     // GIR_Coverage, 7113,
     /* 130290 */     GIR_EraseRootFromParent_Done,
     /* 130291 */   // Label 2502: @130291
     /* 130291 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(130333), // Rule ID 7114 //
     /* 130296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130306 */     // MIs[0] Rn
     /* 130306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130318 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130331 */     GIR_RootConstrainSelectedInstOperands,
     /* 130332 */     // GIR_Coverage, 7114,
     /* 130332 */     GIR_EraseRootFromParent_Done,
     /* 130333 */   // Label 2503: @130333
     /* 130333 */   GIM_Reject,
     /* 130334 */ // Label 2498: @130334
     /* 130334 */ GIM_Reject,
     /* 130335 */ // Label 2481: @130335
     /* 130335 */ GIM_Reject,
     /* 130336 */ // Label 28: @130336
     /* 130336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2506*/ GIMT_Encode4(131327),
     /* 130347 */ /*GILLT_s32*//*Label 2504*/ GIMT_Encode4(130355),
     /* 130351 */ /*GILLT_s64*//*Label 2505*/ GIMT_Encode4(131100),
     /* 130355 */ // Label 2504: @130355
     /* 130355 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(131099),
     /* 130360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130363 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(130412), // Rule ID 7135 //
     /* 130368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130385 */     // MIs[0] Rn
     /* 130385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130397 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 130400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130410 */     GIR_RootConstrainSelectedInstOperands,
     /* 130411 */     // GIR_Coverage, 7135,
     /* 130411 */     GIR_EraseRootFromParent_Done,
     /* 130412 */   // Label 2508: @130412
     /* 130412 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(130461), // Rule ID 7136 //
     /* 130417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130434 */     // MIs[0] Rn
     /* 130434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130446 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 130449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130459 */     GIR_RootConstrainSelectedInstOperands,
     /* 130460 */     // GIR_Coverage, 7136,
     /* 130460 */     GIR_EraseRootFromParent_Done,
     /* 130461 */   // Label 2509: @130461
     /* 130461 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(130510), // Rule ID 7137 //
     /* 130466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130483 */     // MIs[0] Rn
     /* 130483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130495 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 130498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130508 */     GIR_RootConstrainSelectedInstOperands,
     /* 130509 */     // GIR_Coverage, 7137,
     /* 130509 */     GIR_EraseRootFromParent_Done,
     /* 130510 */   // Label 2510: @130510
     /* 130510 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(130559), // Rule ID 7138 //
     /* 130515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130532 */     // MIs[0] Rn
     /* 130532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130544 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 130547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130557 */     GIR_RootConstrainSelectedInstOperands,
     /* 130558 */     // GIR_Coverage, 7138,
     /* 130558 */     GIR_EraseRootFromParent_Done,
     /* 130559 */   // Label 2511: @130559
     /* 130559 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(130608), // Rule ID 7139 //
     /* 130564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130581 */     // MIs[0] Rn
     /* 130581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130593 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 130596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130606 */     GIR_RootConstrainSelectedInstOperands,
     /* 130607 */     // GIR_Coverage, 7139,
     /* 130607 */     GIR_EraseRootFromParent_Done,
     /* 130608 */   // Label 2512: @130608
     /* 130608 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(130657), // Rule ID 7140 //
     /* 130613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130630 */     // MIs[0] Rn
     /* 130630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130642 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 130645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130655 */     GIR_RootConstrainSelectedInstOperands,
     /* 130656 */     // GIR_Coverage, 7140,
     /* 130656 */     GIR_EraseRootFromParent_Done,
     /* 130657 */   // Label 2513: @130657
     /* 130657 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(130706), // Rule ID 7141 //
     /* 130662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130679 */     // MIs[0] Rn
     /* 130679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130691 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 130694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130704 */     GIR_RootConstrainSelectedInstOperands,
     /* 130705 */     // GIR_Coverage, 7141,
     /* 130705 */     GIR_EraseRootFromParent_Done,
     /* 130706 */   // Label 2514: @130706
     /* 130706 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(130755), // Rule ID 7142 //
     /* 130711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130728 */     // MIs[0] Rn
     /* 130728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130740 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 130743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130753 */     GIR_RootConstrainSelectedInstOperands,
     /* 130754 */     // GIR_Coverage, 7142,
     /* 130754 */     GIR_EraseRootFromParent_Done,
     /* 130755 */   // Label 2515: @130755
     /* 130755 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(130804), // Rule ID 7143 //
     /* 130760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130777 */     // MIs[0] Rn
     /* 130777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130789 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 130792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130802 */     GIR_RootConstrainSelectedInstOperands,
     /* 130803 */     // GIR_Coverage, 7143,
     /* 130803 */     GIR_EraseRootFromParent_Done,
     /* 130804 */   // Label 2516: @130804
     /* 130804 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(130853), // Rule ID 7144 //
     /* 130809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130826 */     // MIs[0] Rn
     /* 130826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130838 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 130841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130851 */     GIR_RootConstrainSelectedInstOperands,
     /* 130852 */     // GIR_Coverage, 7144,
     /* 130852 */     GIR_EraseRootFromParent_Done,
     /* 130853 */   // Label 2517: @130853
     /* 130853 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(130902), // Rule ID 7145 //
     /* 130858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130875 */     // MIs[0] Rn
     /* 130875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130887 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 130890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130900 */     GIR_RootConstrainSelectedInstOperands,
     /* 130901 */     // GIR_Coverage, 7145,
     /* 130901 */     GIR_EraseRootFromParent_Done,
     /* 130902 */   // Label 2518: @130902
     /* 130902 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(130951), // Rule ID 7146 //
     /* 130907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130924 */     // MIs[0] Rn
     /* 130924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130936 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 130939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130949 */     GIR_RootConstrainSelectedInstOperands,
     /* 130950 */     // GIR_Coverage, 7146,
     /* 130950 */     GIR_EraseRootFromParent_Done,
     /* 130951 */   // Label 2519: @130951
     /* 130951 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(131000), // Rule ID 7147 //
     /* 130956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130973 */     // MIs[0] Rn
     /* 130973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130985 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 130988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130998 */     GIR_RootConstrainSelectedInstOperands,
     /* 130999 */     // GIR_Coverage, 7147,
     /* 130999 */     GIR_EraseRootFromParent_Done,
     /* 131000 */   // Label 2520: @131000
     /* 131000 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(131049), // Rule ID 7148 //
     /* 131005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131022 */     // MIs[0] Rn
     /* 131022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131034 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131047 */     GIR_RootConstrainSelectedInstOperands,
     /* 131048 */     // GIR_Coverage, 7148,
     /* 131048 */     GIR_EraseRootFromParent_Done,
     /* 131049 */   // Label 2521: @131049
     /* 131049 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(131098), // Rule ID 7149 //
     /* 131054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131071 */     // MIs[0] Rn
     /* 131071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131083 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131096 */     GIR_RootConstrainSelectedInstOperands,
     /* 131097 */     // GIR_Coverage, 7149,
     /* 131097 */     GIR_EraseRootFromParent_Done,
     /* 131098 */   // Label 2522: @131098
     /* 131098 */   GIM_Reject,
     /* 131099 */ // Label 2507: @131099
     /* 131099 */ GIM_Reject,
     /* 131100 */ // Label 2505: @131100
     /* 131100 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(131326),
     /* 131105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131115 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(131157), // Rule ID 7130 //
     /* 131120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131130 */     // MIs[0] Rn
     /* 131130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131142 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 131145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131155 */     GIR_RootConstrainSelectedInstOperands,
     /* 131156 */     // GIR_Coverage, 7130,
     /* 131156 */     GIR_EraseRootFromParent_Done,
     /* 131157 */   // Label 2524: @131157
     /* 131157 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(131199), // Rule ID 7131 //
     /* 131162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131172 */     // MIs[0] Rn
     /* 131172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131184 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 131187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131197 */     GIR_RootConstrainSelectedInstOperands,
     /* 131198 */     // GIR_Coverage, 7131,
     /* 131198 */     GIR_EraseRootFromParent_Done,
     /* 131199 */   // Label 2525: @131199
     /* 131199 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(131241), // Rule ID 7132 //
     /* 131204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131214 */     // MIs[0] Rn
     /* 131214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131226 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 131229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131239 */     GIR_RootConstrainSelectedInstOperands,
     /* 131240 */     // GIR_Coverage, 7132,
     /* 131240 */     GIR_EraseRootFromParent_Done,
     /* 131241 */   // Label 2526: @131241
     /* 131241 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(131283), // Rule ID 7133 //
     /* 131246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131256 */     // MIs[0] Rn
     /* 131256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131268 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131281 */     GIR_RootConstrainSelectedInstOperands,
     /* 131282 */     // GIR_Coverage, 7133,
     /* 131282 */     GIR_EraseRootFromParent_Done,
     /* 131283 */   // Label 2527: @131283
     /* 131283 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(131325), // Rule ID 7134 //
     /* 131288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131298 */     // MIs[0] Rn
     /* 131298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131310 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131323 */     GIR_RootConstrainSelectedInstOperands,
     /* 131324 */     // GIR_Coverage, 7134,
     /* 131324 */     GIR_EraseRootFromParent_Done,
     /* 131325 */   // Label 2528: @131325
     /* 131325 */   GIM_Reject,
     /* 131326 */ // Label 2523: @131326
     /* 131326 */ GIM_Reject,
     /* 131327 */ // Label 2506: @131327
     /* 131327 */ GIM_Reject,
     /* 131328 */ // Label 29: @131328
     /* 131328 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(132319),
     /* 131339 */ /*GILLT_s32*//*Label 2529*/ GIMT_Encode4(131347),
     /* 131343 */ /*GILLT_s64*//*Label 2530*/ GIMT_Encode4(132092),
     /* 131347 */ // Label 2529: @131347
     /* 131347 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(132091),
     /* 131352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131355 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(131404), // Rule ID 7155 //
     /* 131360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131377 */     // MIs[0] Rn
     /* 131377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131389 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 131392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131402 */     GIR_RootConstrainSelectedInstOperands,
     /* 131403 */     // GIR_Coverage, 7155,
     /* 131403 */     GIR_EraseRootFromParent_Done,
     /* 131404 */   // Label 2533: @131404
     /* 131404 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(131453), // Rule ID 7156 //
     /* 131409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131426 */     // MIs[0] Rn
     /* 131426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131438 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 131441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131451 */     GIR_RootConstrainSelectedInstOperands,
     /* 131452 */     // GIR_Coverage, 7156,
     /* 131452 */     GIR_EraseRootFromParent_Done,
     /* 131453 */   // Label 2534: @131453
     /* 131453 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(131502), // Rule ID 7157 //
     /* 131458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131475 */     // MIs[0] Rn
     /* 131475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131487 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 131490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131500 */     GIR_RootConstrainSelectedInstOperands,
     /* 131501 */     // GIR_Coverage, 7157,
     /* 131501 */     GIR_EraseRootFromParent_Done,
     /* 131502 */   // Label 2535: @131502
     /* 131502 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(131551), // Rule ID 7158 //
     /* 131507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131524 */     // MIs[0] Rn
     /* 131524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131536 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 131539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131549 */     GIR_RootConstrainSelectedInstOperands,
     /* 131550 */     // GIR_Coverage, 7158,
     /* 131550 */     GIR_EraseRootFromParent_Done,
     /* 131551 */   // Label 2536: @131551
     /* 131551 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(131600), // Rule ID 7159 //
     /* 131556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131573 */     // MIs[0] Rn
     /* 131573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131585 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 131588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131598 */     GIR_RootConstrainSelectedInstOperands,
     /* 131599 */     // GIR_Coverage, 7159,
     /* 131599 */     GIR_EraseRootFromParent_Done,
     /* 131600 */   // Label 2537: @131600
     /* 131600 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(131649), // Rule ID 7160 //
     /* 131605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131622 */     // MIs[0] Rn
     /* 131622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131634 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 131637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131647 */     GIR_RootConstrainSelectedInstOperands,
     /* 131648 */     // GIR_Coverage, 7160,
     /* 131648 */     GIR_EraseRootFromParent_Done,
     /* 131649 */   // Label 2538: @131649
     /* 131649 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(131698), // Rule ID 7161 //
     /* 131654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131671 */     // MIs[0] Rn
     /* 131671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131683 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 131686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131696 */     GIR_RootConstrainSelectedInstOperands,
     /* 131697 */     // GIR_Coverage, 7161,
     /* 131697 */     GIR_EraseRootFromParent_Done,
     /* 131698 */   // Label 2539: @131698
     /* 131698 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(131747), // Rule ID 7162 //
     /* 131703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131720 */     // MIs[0] Rn
     /* 131720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131732 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 131735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131745 */     GIR_RootConstrainSelectedInstOperands,
     /* 131746 */     // GIR_Coverage, 7162,
     /* 131746 */     GIR_EraseRootFromParent_Done,
     /* 131747 */   // Label 2540: @131747
     /* 131747 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(131796), // Rule ID 7163 //
     /* 131752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131769 */     // MIs[0] Rn
     /* 131769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131781 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 131784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131794 */     GIR_RootConstrainSelectedInstOperands,
     /* 131795 */     // GIR_Coverage, 7163,
     /* 131795 */     GIR_EraseRootFromParent_Done,
     /* 131796 */   // Label 2541: @131796
     /* 131796 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(131845), // Rule ID 7164 //
     /* 131801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131818 */     // MIs[0] Rn
     /* 131818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131830 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 131833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131843 */     GIR_RootConstrainSelectedInstOperands,
     /* 131844 */     // GIR_Coverage, 7164,
     /* 131844 */     GIR_EraseRootFromParent_Done,
     /* 131845 */   // Label 2542: @131845
     /* 131845 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(131894), // Rule ID 7165 //
     /* 131850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131867 */     // MIs[0] Rn
     /* 131867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131879 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 131882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131892 */     GIR_RootConstrainSelectedInstOperands,
     /* 131893 */     // GIR_Coverage, 7165,
     /* 131893 */     GIR_EraseRootFromParent_Done,
     /* 131894 */   // Label 2543: @131894
     /* 131894 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(131943), // Rule ID 7166 //
     /* 131899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131916 */     // MIs[0] Rn
     /* 131916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131928 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 131931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131941 */     GIR_RootConstrainSelectedInstOperands,
     /* 131942 */     // GIR_Coverage, 7166,
     /* 131942 */     GIR_EraseRootFromParent_Done,
     /* 131943 */   // Label 2544: @131943
     /* 131943 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(131992), // Rule ID 7167 //
     /* 131948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131965 */     // MIs[0] Rn
     /* 131965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131977 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 131980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131990 */     GIR_RootConstrainSelectedInstOperands,
     /* 131991 */     // GIR_Coverage, 7167,
     /* 131991 */     GIR_EraseRootFromParent_Done,
     /* 131992 */   // Label 2545: @131992
     /* 131992 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(132041), // Rule ID 7168 //
     /* 131997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132014 */     // MIs[0] Rn
     /* 132014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132026 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132039 */     GIR_RootConstrainSelectedInstOperands,
     /* 132040 */     // GIR_Coverage, 7168,
     /* 132040 */     GIR_EraseRootFromParent_Done,
     /* 132041 */   // Label 2546: @132041
     /* 132041 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(132090), // Rule ID 7169 //
     /* 132046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132063 */     // MIs[0] Rn
     /* 132063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132075 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132088 */     GIR_RootConstrainSelectedInstOperands,
     /* 132089 */     // GIR_Coverage, 7169,
     /* 132089 */     GIR_EraseRootFromParent_Done,
     /* 132090 */   // Label 2547: @132090
     /* 132090 */   GIM_Reject,
     /* 132091 */ // Label 2532: @132091
     /* 132091 */ GIM_Reject,
     /* 132092 */ // Label 2530: @132092
     /* 132092 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(132318),
     /* 132097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132107 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(132149), // Rule ID 7150 //
     /* 132112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132122 */     // MIs[0] Rn
     /* 132122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132134 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 132137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132147 */     GIR_RootConstrainSelectedInstOperands,
     /* 132148 */     // GIR_Coverage, 7150,
     /* 132148 */     GIR_EraseRootFromParent_Done,
     /* 132149 */   // Label 2549: @132149
     /* 132149 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(132191), // Rule ID 7151 //
     /* 132154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132164 */     // MIs[0] Rn
     /* 132164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132176 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 132179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132189 */     GIR_RootConstrainSelectedInstOperands,
     /* 132190 */     // GIR_Coverage, 7151,
     /* 132190 */     GIR_EraseRootFromParent_Done,
     /* 132191 */   // Label 2550: @132191
     /* 132191 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(132233), // Rule ID 7152 //
     /* 132196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132199 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132206 */     // MIs[0] Rn
     /* 132206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132218 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 132221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132231 */     GIR_RootConstrainSelectedInstOperands,
     /* 132232 */     // GIR_Coverage, 7152,
     /* 132232 */     GIR_EraseRootFromParent_Done,
     /* 132233 */   // Label 2551: @132233
     /* 132233 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(132275), // Rule ID 7153 //
     /* 132238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132248 */     // MIs[0] Rn
     /* 132248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132260 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132273 */     GIR_RootConstrainSelectedInstOperands,
     /* 132274 */     // GIR_Coverage, 7153,
     /* 132274 */     GIR_EraseRootFromParent_Done,
     /* 132275 */   // Label 2552: @132275
     /* 132275 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(132317), // Rule ID 7154 //
     /* 132280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132290 */     // MIs[0] Rn
     /* 132290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132302 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132315 */     GIR_RootConstrainSelectedInstOperands,
     /* 132316 */     // GIR_Coverage, 7154,
     /* 132316 */     GIR_EraseRootFromParent_Done,
     /* 132317 */   // Label 2553: @132317
     /* 132317 */   GIM_Reject,
     /* 132318 */ // Label 2548: @132318
     /* 132318 */ GIM_Reject,
     /* 132319 */ // Label 2531: @132319
     /* 132319 */ GIM_Reject,
     /* 132320 */ // Label 30: @132320
     /* 132320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2556*/ GIMT_Encode4(133311),
     /* 132331 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(132339),
     /* 132335 */ /*GILLT_s64*//*Label 2555*/ GIMT_Encode4(133084),
     /* 132339 */ // Label 2554: @132339
     /* 132339 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(133083),
     /* 132344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132347 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(132396), // Rule ID 7175 //
     /* 132352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132369 */     // MIs[0] Rn
     /* 132369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132381 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 132384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132394 */     GIR_RootConstrainSelectedInstOperands,
     /* 132395 */     // GIR_Coverage, 7175,
     /* 132395 */     GIR_EraseRootFromParent_Done,
     /* 132396 */   // Label 2558: @132396
     /* 132396 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(132445), // Rule ID 7176 //
     /* 132401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132418 */     // MIs[0] Rn
     /* 132418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132430 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 132433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132443 */     GIR_RootConstrainSelectedInstOperands,
     /* 132444 */     // GIR_Coverage, 7176,
     /* 132444 */     GIR_EraseRootFromParent_Done,
     /* 132445 */   // Label 2559: @132445
     /* 132445 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(132494), // Rule ID 7177 //
     /* 132450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132467 */     // MIs[0] Rn
     /* 132467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132479 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 132482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132492 */     GIR_RootConstrainSelectedInstOperands,
     /* 132493 */     // GIR_Coverage, 7177,
     /* 132493 */     GIR_EraseRootFromParent_Done,
     /* 132494 */   // Label 2560: @132494
     /* 132494 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(132543), // Rule ID 7178 //
     /* 132499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132516 */     // MIs[0] Rn
     /* 132516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132528 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 132531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132541 */     GIR_RootConstrainSelectedInstOperands,
     /* 132542 */     // GIR_Coverage, 7178,
     /* 132542 */     GIR_EraseRootFromParent_Done,
     /* 132543 */   // Label 2561: @132543
     /* 132543 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(132592), // Rule ID 7179 //
     /* 132548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132565 */     // MIs[0] Rn
     /* 132565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132577 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 132580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132590 */     GIR_RootConstrainSelectedInstOperands,
     /* 132591 */     // GIR_Coverage, 7179,
     /* 132591 */     GIR_EraseRootFromParent_Done,
     /* 132592 */   // Label 2562: @132592
     /* 132592 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(132641), // Rule ID 7180 //
     /* 132597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132614 */     // MIs[0] Rn
     /* 132614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132626 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 132629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132639 */     GIR_RootConstrainSelectedInstOperands,
     /* 132640 */     // GIR_Coverage, 7180,
     /* 132640 */     GIR_EraseRootFromParent_Done,
     /* 132641 */   // Label 2563: @132641
     /* 132641 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(132690), // Rule ID 7181 //
     /* 132646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132663 */     // MIs[0] Rn
     /* 132663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132675 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 132678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132688 */     GIR_RootConstrainSelectedInstOperands,
     /* 132689 */     // GIR_Coverage, 7181,
     /* 132689 */     GIR_EraseRootFromParent_Done,
     /* 132690 */   // Label 2564: @132690
     /* 132690 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(132739), // Rule ID 7182 //
     /* 132695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132712 */     // MIs[0] Rn
     /* 132712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132724 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 132727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132737 */     GIR_RootConstrainSelectedInstOperands,
     /* 132738 */     // GIR_Coverage, 7182,
     /* 132738 */     GIR_EraseRootFromParent_Done,
     /* 132739 */   // Label 2565: @132739
     /* 132739 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(132788), // Rule ID 7183 //
     /* 132744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132761 */     // MIs[0] Rn
     /* 132761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132773 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 132776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132786 */     GIR_RootConstrainSelectedInstOperands,
     /* 132787 */     // GIR_Coverage, 7183,
     /* 132787 */     GIR_EraseRootFromParent_Done,
     /* 132788 */   // Label 2566: @132788
     /* 132788 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(132837), // Rule ID 7184 //
     /* 132793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132810 */     // MIs[0] Rn
     /* 132810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132822 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 132825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132835 */     GIR_RootConstrainSelectedInstOperands,
     /* 132836 */     // GIR_Coverage, 7184,
     /* 132836 */     GIR_EraseRootFromParent_Done,
     /* 132837 */   // Label 2567: @132837
     /* 132837 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(132886), // Rule ID 7185 //
     /* 132842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132859 */     // MIs[0] Rn
     /* 132859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132871 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 132874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132884 */     GIR_RootConstrainSelectedInstOperands,
     /* 132885 */     // GIR_Coverage, 7185,
     /* 132885 */     GIR_EraseRootFromParent_Done,
     /* 132886 */   // Label 2568: @132886
     /* 132886 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(132935), // Rule ID 7186 //
     /* 132891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132894 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132908 */     // MIs[0] Rn
     /* 132908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132920 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 132923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132933 */     GIR_RootConstrainSelectedInstOperands,
     /* 132934 */     // GIR_Coverage, 7186,
     /* 132934 */     GIR_EraseRootFromParent_Done,
     /* 132935 */   // Label 2569: @132935
     /* 132935 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(132984), // Rule ID 7187 //
     /* 132940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132957 */     // MIs[0] Rn
     /* 132957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132969 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 132972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132982 */     GIR_RootConstrainSelectedInstOperands,
     /* 132983 */     // GIR_Coverage, 7187,
     /* 132983 */     GIR_EraseRootFromParent_Done,
     /* 132984 */   // Label 2570: @132984
     /* 132984 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(133033), // Rule ID 7188 //
     /* 132989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133006 */     // MIs[0] Rn
     /* 133006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133018 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133031 */     GIR_RootConstrainSelectedInstOperands,
     /* 133032 */     // GIR_Coverage, 7188,
     /* 133032 */     GIR_EraseRootFromParent_Done,
     /* 133033 */   // Label 2571: @133033
     /* 133033 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(133082), // Rule ID 7189 //
     /* 133038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133055 */     // MIs[0] Rn
     /* 133055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133067 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133080 */     GIR_RootConstrainSelectedInstOperands,
     /* 133081 */     // GIR_Coverage, 7189,
     /* 133081 */     GIR_EraseRootFromParent_Done,
     /* 133082 */   // Label 2572: @133082
     /* 133082 */   GIM_Reject,
     /* 133083 */ // Label 2557: @133083
     /* 133083 */ GIM_Reject,
     /* 133084 */ // Label 2555: @133084
     /* 133084 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(133310),
     /* 133089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133092 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133099 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(133141), // Rule ID 7170 //
     /* 133104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133114 */     // MIs[0] Rn
     /* 133114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133126 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 133129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133139 */     GIR_RootConstrainSelectedInstOperands,
     /* 133140 */     // GIR_Coverage, 7170,
     /* 133140 */     GIR_EraseRootFromParent_Done,
     /* 133141 */   // Label 2574: @133141
     /* 133141 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(133183), // Rule ID 7171 //
     /* 133146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133156 */     // MIs[0] Rn
     /* 133156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133168 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 133171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133181 */     GIR_RootConstrainSelectedInstOperands,
     /* 133182 */     // GIR_Coverage, 7171,
     /* 133182 */     GIR_EraseRootFromParent_Done,
     /* 133183 */   // Label 2575: @133183
     /* 133183 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(133225), // Rule ID 7172 //
     /* 133188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133191 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133198 */     // MIs[0] Rn
     /* 133198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133210 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 133213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133223 */     GIR_RootConstrainSelectedInstOperands,
     /* 133224 */     // GIR_Coverage, 7172,
     /* 133224 */     GIR_EraseRootFromParent_Done,
     /* 133225 */   // Label 2576: @133225
     /* 133225 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(133267), // Rule ID 7173 //
     /* 133230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133240 */     // MIs[0] Rn
     /* 133240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133252 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133265 */     GIR_RootConstrainSelectedInstOperands,
     /* 133266 */     // GIR_Coverage, 7173,
     /* 133266 */     GIR_EraseRootFromParent_Done,
     /* 133267 */   // Label 2577: @133267
     /* 133267 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(133309), // Rule ID 7174 //
     /* 133272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133282 */     // MIs[0] Rn
     /* 133282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133294 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133307 */     GIR_RootConstrainSelectedInstOperands,
     /* 133308 */     // GIR_Coverage, 7174,
     /* 133308 */     GIR_EraseRootFromParent_Done,
     /* 133309 */   // Label 2578: @133309
     /* 133309 */   GIM_Reject,
     /* 133310 */ // Label 2573: @133310
     /* 133310 */ GIM_Reject,
     /* 133311 */ // Label 2556: @133311
     /* 133311 */ GIM_Reject,
     /* 133312 */ // Label 31: @133312
     /* 133312 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(133339), // Rule ID 6922 //
     /* 133317 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133320 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 133324 */   // MIs[0] Operand 1
     /* 133324 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 133327 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 133327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 133330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 133333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133337 */   GIR_RootConstrainSelectedInstOperands,
     /* 133338 */   // GIR_Coverage, 6922,
     /* 133338 */   GIR_EraseRootFromParent_Done,
     /* 133339 */ // Label 2579: @133339
     /* 133339 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(133362), // Rule ID 6923 //
     /* 133344 */   // MIs[0] Operand 0
     /* 133344 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 133347 */   // MIs[0] Operand 1
     /* 133347 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 133350 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 133350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 133353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 133356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133360 */   GIR_RootConstrainSelectedInstOperands,
     /* 133361 */   // GIR_Coverage, 6923,
     /* 133361 */   GIR_EraseRootFromParent_Done,
     /* 133362 */ // Label 2580: @133362
     /* 133362 */ GIM_Reject,
     /* 133363 */ // Label 32: @133363
     /* 133363 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(145890),
     /* 133368 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 133371 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(133462), // Rule ID 6405 //
     /* 133376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 133379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 133384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 133387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 133402 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 133405 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 133410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133414 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 133418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133430 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 133430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 133433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 133437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 133446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 133450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 133455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133460 */     GIR_RootConstrainSelectedInstOperands,
     /* 133461 */     // GIR_Coverage, 6405,
     /* 133461 */     GIR_EraseRootFromParent_Done,
     /* 133462 */   // Label 2582: @133462
     /* 133462 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(133553), // Rule ID 6406 //
     /* 133467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 133470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 133475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 133478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 133493 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 133496 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 133501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133505 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 133509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133521 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 133521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 133524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 133528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 133537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 133541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 133546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133551 */     GIR_RootConstrainSelectedInstOperands,
     /* 133552 */     // GIR_Coverage, 6406,
     /* 133552 */     GIR_EraseRootFromParent_Done,
     /* 133553 */   // Label 2583: @133553
     /* 133553 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(133614), // Rule ID 4838 //
     /* 133558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 133563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 133566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 133569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 133581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133590 */     // MIs[1] Operand 2
     /* 133590 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 133601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133603 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 133603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 133606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 133612 */     GIR_RootConstrainSelectedInstOperands,
     /* 133613 */     // GIR_Coverage, 4838,
     /* 133613 */     GIR_EraseRootFromParent_Done,
     /* 133614 */   // Label 2584: @133614
     /* 133614 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(133654), // Rule ID 2637 //
     /* 133619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 133627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133634 */     // MIs[0] pattern
     /* 133634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133642 */     // (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 133645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133647 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133652 */     GIR_RootConstrainSelectedInstOperands,
     /* 133653 */     // GIR_Coverage, 2637,
     /* 133653 */     GIR_EraseRootFromParent_Done,
     /* 133654 */   // Label 2585: @133654
     /* 133654 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(133694), // Rule ID 9767 //
     /* 133659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 133667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133674 */     // MIs[0] pattern
     /* 133674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133682 */     // (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 133685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133687 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133692 */     GIR_RootConstrainSelectedInstOperands,
     /* 133693 */     // GIR_Coverage, 9767,
     /* 133693 */     GIR_EraseRootFromParent_Done,
     /* 133694 */   // Label 2586: @133694
     /* 133694 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(133734), // Rule ID 9770 //
     /* 133699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 133707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133714 */     // MIs[0] pattern
     /* 133714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133717 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133722 */     // (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 133725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133727 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133732 */     GIR_RootConstrainSelectedInstOperands,
     /* 133733 */     // GIR_Coverage, 9770,
     /* 133733 */     GIR_EraseRootFromParent_Done,
     /* 133734 */   // Label 2587: @133734
     /* 133734 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(133774), // Rule ID 9773 //
     /* 133739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 133747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133754 */     // MIs[0] pattern
     /* 133754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133762 */     // (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 133765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133767 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133772 */     GIR_RootConstrainSelectedInstOperands,
     /* 133773 */     // GIR_Coverage, 9773,
     /* 133773 */     GIR_EraseRootFromParent_Done,
     /* 133774 */   // Label 2588: @133774
     /* 133774 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(133813), // Rule ID 66 //
     /* 133779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 133782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 133787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133801 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 133801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 133804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 133811 */     GIR_RootConstrainSelectedInstOperands,
     /* 133812 */     // GIR_Coverage, 66,
     /* 133812 */     GIR_EraseRootFromParent_Done,
     /* 133813 */   // Label 2589: @133813
     /* 133813 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(133849), // Rule ID 346 //
     /* 133818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 133821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 133832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133840 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 133840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 133843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133847 */     GIR_RootConstrainSelectedInstOperands,
     /* 133848 */     // GIR_Coverage, 346,
     /* 133848 */     GIR_EraseRootFromParent_Done,
     /* 133849 */   // Label 2590: @133849
     /* 133849 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(133885), // Rule ID 347 //
     /* 133854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 133857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 133868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133876 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 133876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 133879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133883 */     GIR_RootConstrainSelectedInstOperands,
     /* 133884 */     // GIR_Coverage, 347,
     /* 133884 */     GIR_EraseRootFromParent_Done,
     /* 133885 */   // Label 2591: @133885
     /* 133885 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(133921), // Rule ID 348 //
     /* 133890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133912 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 133912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 133915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133919 */     GIR_RootConstrainSelectedInstOperands,
     /* 133920 */     // GIR_Coverage, 348,
     /* 133920 */     GIR_EraseRootFromParent_Done,
     /* 133921 */   // Label 2592: @133921
     /* 133921 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(133957), // Rule ID 349 //
     /* 133926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133948 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 133948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 133951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133955 */     GIR_RootConstrainSelectedInstOperands,
     /* 133956 */     // GIR_Coverage, 349,
     /* 133956 */     GIR_EraseRootFromParent_Done,
     /* 133957 */   // Label 2593: @133957
     /* 133957 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(133993), // Rule ID 350 //
     /* 133962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133984 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 133984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 133987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133991 */     GIR_RootConstrainSelectedInstOperands,
     /* 133992 */     // GIR_Coverage, 350,
     /* 133992 */     GIR_EraseRootFromParent_Done,
     /* 133993 */   // Label 2594: @133993
     /* 133993 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(134029), // Rule ID 351 //
     /* 133998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134020 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 134023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134027 */     GIR_RootConstrainSelectedInstOperands,
     /* 134028 */     // GIR_Coverage, 351,
     /* 134028 */     GIR_EraseRootFromParent_Done,
     /* 134029 */   // Label 2595: @134029
     /* 134029 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(134065), // Rule ID 352 //
     /* 134034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134056 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 134059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134063 */     GIR_RootConstrainSelectedInstOperands,
     /* 134064 */     // GIR_Coverage, 352,
     /* 134064 */     GIR_EraseRootFromParent_Done,
     /* 134065 */   // Label 2596: @134065
     /* 134065 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(134101), // Rule ID 353 //
     /* 134070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134092 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 134095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134099 */     GIR_RootConstrainSelectedInstOperands,
     /* 134100 */     // GIR_Coverage, 353,
     /* 134100 */     GIR_EraseRootFromParent_Done,
     /* 134101 */   // Label 2597: @134101
     /* 134101 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(134137), // Rule ID 354 //
     /* 134106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134128 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 134131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134135 */     GIR_RootConstrainSelectedInstOperands,
     /* 134136 */     // GIR_Coverage, 354,
     /* 134136 */     GIR_EraseRootFromParent_Done,
     /* 134137 */   // Label 2598: @134137
     /* 134137 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(134173), // Rule ID 355 //
     /* 134142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134164 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 134167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134171 */     GIR_RootConstrainSelectedInstOperands,
     /* 134172 */     // GIR_Coverage, 355,
     /* 134172 */     GIR_EraseRootFromParent_Done,
     /* 134173 */   // Label 2599: @134173
     /* 134173 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(134209), // Rule ID 356 //
     /* 134178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134200 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 134203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134207 */     GIR_RootConstrainSelectedInstOperands,
     /* 134208 */     // GIR_Coverage, 356,
     /* 134208 */     GIR_EraseRootFromParent_Done,
     /* 134209 */   // Label 2600: @134209
     /* 134209 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(134245), // Rule ID 357 //
     /* 134214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134236 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 134239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134243 */     GIR_RootConstrainSelectedInstOperands,
     /* 134244 */     // GIR_Coverage, 357,
     /* 134244 */     GIR_EraseRootFromParent_Done,
     /* 134245 */   // Label 2601: @134245
     /* 134245 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(134281), // Rule ID 358 //
     /* 134250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134272 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 134275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134279 */     GIR_RootConstrainSelectedInstOperands,
     /* 134280 */     // GIR_Coverage, 358,
     /* 134280 */     GIR_EraseRootFromParent_Done,
     /* 134281 */   // Label 2602: @134281
     /* 134281 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(134317), // Rule ID 359 //
     /* 134286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134308 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 134311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134315 */     GIR_RootConstrainSelectedInstOperands,
     /* 134316 */     // GIR_Coverage, 359,
     /* 134316 */     GIR_EraseRootFromParent_Done,
     /* 134317 */   // Label 2603: @134317
     /* 134317 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(134353), // Rule ID 360 //
     /* 134322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134344 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 134347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134351 */     GIR_RootConstrainSelectedInstOperands,
     /* 134352 */     // GIR_Coverage, 360,
     /* 134352 */     GIR_EraseRootFromParent_Done,
     /* 134353 */   // Label 2604: @134353
     /* 134353 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(134389), // Rule ID 361 //
     /* 134358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134380 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 134383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134387 */     GIR_RootConstrainSelectedInstOperands,
     /* 134388 */     // GIR_Coverage, 361,
     /* 134388 */     GIR_EraseRootFromParent_Done,
     /* 134389 */   // Label 2605: @134389
     /* 134389 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(134425), // Rule ID 362 //
     /* 134394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134416 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 134419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134423 */     GIR_RootConstrainSelectedInstOperands,
     /* 134424 */     // GIR_Coverage, 362,
     /* 134424 */     GIR_EraseRootFromParent_Done,
     /* 134425 */   // Label 2606: @134425
     /* 134425 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(134461), // Rule ID 363 //
     /* 134430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134452 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 134455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134459 */     GIR_RootConstrainSelectedInstOperands,
     /* 134460 */     // GIR_Coverage, 363,
     /* 134460 */     GIR_EraseRootFromParent_Done,
     /* 134461 */   // Label 2607: @134461
     /* 134461 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(134497), // Rule ID 364 //
     /* 134466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134488 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 134491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134495 */     GIR_RootConstrainSelectedInstOperands,
     /* 134496 */     // GIR_Coverage, 364,
     /* 134496 */     GIR_EraseRootFromParent_Done,
     /* 134497 */   // Label 2608: @134497
     /* 134497 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(134533), // Rule ID 365 //
     /* 134502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134524 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 134527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134531 */     GIR_RootConstrainSelectedInstOperands,
     /* 134532 */     // GIR_Coverage, 365,
     /* 134532 */     GIR_EraseRootFromParent_Done,
     /* 134533 */   // Label 2609: @134533
     /* 134533 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(134569), // Rule ID 366 //
     /* 134538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134560 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 134563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134567 */     GIR_RootConstrainSelectedInstOperands,
     /* 134568 */     // GIR_Coverage, 366,
     /* 134568 */     GIR_EraseRootFromParent_Done,
     /* 134569 */   // Label 2610: @134569
     /* 134569 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(134605), // Rule ID 367 //
     /* 134574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134596 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 134599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134603 */     GIR_RootConstrainSelectedInstOperands,
     /* 134604 */     // GIR_Coverage, 367,
     /* 134604 */     GIR_EraseRootFromParent_Done,
     /* 134605 */   // Label 2611: @134605
     /* 134605 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(134641), // Rule ID 368 //
     /* 134610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134632 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 134635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134639 */     GIR_RootConstrainSelectedInstOperands,
     /* 134640 */     // GIR_Coverage, 368,
     /* 134640 */     GIR_EraseRootFromParent_Done,
     /* 134641 */   // Label 2612: @134641
     /* 134641 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(134677), // Rule ID 369 //
     /* 134646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134668 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 134671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134675 */     GIR_RootConstrainSelectedInstOperands,
     /* 134676 */     // GIR_Coverage, 369,
     /* 134676 */     GIR_EraseRootFromParent_Done,
     /* 134677 */   // Label 2613: @134677
     /* 134677 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(134713), // Rule ID 370 //
     /* 134682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134704 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 134707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134711 */     GIR_RootConstrainSelectedInstOperands,
     /* 134712 */     // GIR_Coverage, 370,
     /* 134712 */     GIR_EraseRootFromParent_Done,
     /* 134713 */   // Label 2614: @134713
     /* 134713 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(134749), // Rule ID 371 //
     /* 134718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134740 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 134743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134747 */     GIR_RootConstrainSelectedInstOperands,
     /* 134748 */     // GIR_Coverage, 371,
     /* 134748 */     GIR_EraseRootFromParent_Done,
     /* 134749 */   // Label 2615: @134749
     /* 134749 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(134785), // Rule ID 372 //
     /* 134754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134776 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 134779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134783 */     GIR_RootConstrainSelectedInstOperands,
     /* 134784 */     // GIR_Coverage, 372,
     /* 134784 */     GIR_EraseRootFromParent_Done,
     /* 134785 */   // Label 2616: @134785
     /* 134785 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(134821), // Rule ID 373 //
     /* 134790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134812 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 134815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134819 */     GIR_RootConstrainSelectedInstOperands,
     /* 134820 */     // GIR_Coverage, 373,
     /* 134820 */     GIR_EraseRootFromParent_Done,
     /* 134821 */   // Label 2617: @134821
     /* 134821 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(134857), // Rule ID 374 //
     /* 134826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134848 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 134851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134855 */     GIR_RootConstrainSelectedInstOperands,
     /* 134856 */     // GIR_Coverage, 374,
     /* 134856 */     GIR_EraseRootFromParent_Done,
     /* 134857 */   // Label 2618: @134857
     /* 134857 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(134893), // Rule ID 375 //
     /* 134862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134884 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 134887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134891 */     GIR_RootConstrainSelectedInstOperands,
     /* 134892 */     // GIR_Coverage, 375,
     /* 134892 */     GIR_EraseRootFromParent_Done,
     /* 134893 */   // Label 2619: @134893
     /* 134893 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(134929), // Rule ID 376 //
     /* 134898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 134906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134920 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 134923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134927 */     GIR_RootConstrainSelectedInstOperands,
     /* 134928 */     // GIR_Coverage, 376,
     /* 134928 */     GIR_EraseRootFromParent_Done,
     /* 134929 */   // Label 2620: @134929
     /* 134929 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(134965), // Rule ID 377 //
     /* 134934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 134942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134956 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 134959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134963 */     GIR_RootConstrainSelectedInstOperands,
     /* 134964 */     // GIR_Coverage, 377,
     /* 134964 */     GIR_EraseRootFromParent_Done,
     /* 134965 */   // Label 2621: @134965
     /* 134965 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(135001), // Rule ID 378 //
     /* 134970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 134978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134992 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 134995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134999 */     GIR_RootConstrainSelectedInstOperands,
     /* 135000 */     // GIR_Coverage, 378,
     /* 135000 */     GIR_EraseRootFromParent_Done,
     /* 135001 */   // Label 2622: @135001
     /* 135001 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(135037), // Rule ID 379 //
     /* 135006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135028 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 135031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135035 */     GIR_RootConstrainSelectedInstOperands,
     /* 135036 */     // GIR_Coverage, 379,
     /* 135036 */     GIR_EraseRootFromParent_Done,
     /* 135037 */   // Label 2623: @135037
     /* 135037 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(135073), // Rule ID 380 //
     /* 135042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135064 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 135067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135071 */     GIR_RootConstrainSelectedInstOperands,
     /* 135072 */     // GIR_Coverage, 380,
     /* 135072 */     GIR_EraseRootFromParent_Done,
     /* 135073 */   // Label 2624: @135073
     /* 135073 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(135109), // Rule ID 381 //
     /* 135078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135100 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 135103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135107 */     GIR_RootConstrainSelectedInstOperands,
     /* 135108 */     // GIR_Coverage, 381,
     /* 135108 */     GIR_EraseRootFromParent_Done,
     /* 135109 */   // Label 2625: @135109
     /* 135109 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(135145), // Rule ID 382 //
     /* 135114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135136 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 135139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135143 */     GIR_RootConstrainSelectedInstOperands,
     /* 135144 */     // GIR_Coverage, 382,
     /* 135144 */     GIR_EraseRootFromParent_Done,
     /* 135145 */   // Label 2626: @135145
     /* 135145 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(135181), // Rule ID 383 //
     /* 135150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135172 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 135175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135179 */     GIR_RootConstrainSelectedInstOperands,
     /* 135180 */     // GIR_Coverage, 383,
     /* 135180 */     GIR_EraseRootFromParent_Done,
     /* 135181 */   // Label 2627: @135181
     /* 135181 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(135217), // Rule ID 384 //
     /* 135186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135208 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 135211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135215 */     GIR_RootConstrainSelectedInstOperands,
     /* 135216 */     // GIR_Coverage, 384,
     /* 135216 */     GIR_EraseRootFromParent_Done,
     /* 135217 */   // Label 2628: @135217
     /* 135217 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(135253), // Rule ID 385 //
     /* 135222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135244 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 135247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135251 */     GIR_RootConstrainSelectedInstOperands,
     /* 135252 */     // GIR_Coverage, 385,
     /* 135252 */     GIR_EraseRootFromParent_Done,
     /* 135253 */   // Label 2629: @135253
     /* 135253 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(135289), // Rule ID 386 //
     /* 135258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135280 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 135283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135287 */     GIR_RootConstrainSelectedInstOperands,
     /* 135288 */     // GIR_Coverage, 386,
     /* 135288 */     GIR_EraseRootFromParent_Done,
     /* 135289 */   // Label 2630: @135289
     /* 135289 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(135325), // Rule ID 387 //
     /* 135294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135316 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 135319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135323 */     GIR_RootConstrainSelectedInstOperands,
     /* 135324 */     // GIR_Coverage, 387,
     /* 135324 */     GIR_EraseRootFromParent_Done,
     /* 135325 */   // Label 2631: @135325
     /* 135325 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(135361), // Rule ID 388 //
     /* 135330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135352 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 135355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135359 */     GIR_RootConstrainSelectedInstOperands,
     /* 135360 */     // GIR_Coverage, 388,
     /* 135360 */     GIR_EraseRootFromParent_Done,
     /* 135361 */   // Label 2632: @135361
     /* 135361 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(135397), // Rule ID 389 //
     /* 135366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135388 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 135391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135395 */     GIR_RootConstrainSelectedInstOperands,
     /* 135396 */     // GIR_Coverage, 389,
     /* 135396 */     GIR_EraseRootFromParent_Done,
     /* 135397 */   // Label 2633: @135397
     /* 135397 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(135433), // Rule ID 390 //
     /* 135402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135424 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 135427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135431 */     GIR_RootConstrainSelectedInstOperands,
     /* 135432 */     // GIR_Coverage, 390,
     /* 135432 */     GIR_EraseRootFromParent_Done,
     /* 135433 */   // Label 2634: @135433
     /* 135433 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(135469), // Rule ID 391 //
     /* 135438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135460 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 135463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135467 */     GIR_RootConstrainSelectedInstOperands,
     /* 135468 */     // GIR_Coverage, 391,
     /* 135468 */     GIR_EraseRootFromParent_Done,
     /* 135469 */   // Label 2635: @135469
     /* 135469 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(135505), // Rule ID 392 //
     /* 135474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135496 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 135499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135503 */     GIR_RootConstrainSelectedInstOperands,
     /* 135504 */     // GIR_Coverage, 392,
     /* 135504 */     GIR_EraseRootFromParent_Done,
     /* 135505 */   // Label 2636: @135505
     /* 135505 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(135541), // Rule ID 393 //
     /* 135510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135532 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 135535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135539 */     GIR_RootConstrainSelectedInstOperands,
     /* 135540 */     // GIR_Coverage, 393,
     /* 135540 */     GIR_EraseRootFromParent_Done,
     /* 135541 */   // Label 2637: @135541
     /* 135541 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(135577), // Rule ID 575 //
     /* 135546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 135554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135568 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 135571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135575 */     GIR_RootConstrainSelectedInstOperands,
     /* 135576 */     // GIR_Coverage, 575,
     /* 135576 */     GIR_EraseRootFromParent_Done,
     /* 135577 */   // Label 2638: @135577
     /* 135577 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(135613), // Rule ID 576 //
     /* 135582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 135590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135604 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 135607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135611 */     GIR_RootConstrainSelectedInstOperands,
     /* 135612 */     // GIR_Coverage, 576,
     /* 135612 */     GIR_EraseRootFromParent_Done,
     /* 135613 */   // Label 2639: @135613
     /* 135613 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(135649), // Rule ID 577 //
     /* 135618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 135626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135640 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 135643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135647 */     GIR_RootConstrainSelectedInstOperands,
     /* 135648 */     // GIR_Coverage, 577,
     /* 135648 */     GIR_EraseRootFromParent_Done,
     /* 135649 */   // Label 2640: @135649
     /* 135649 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(135685), // Rule ID 578 //
     /* 135654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 135662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135676 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 135679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135683 */     GIR_RootConstrainSelectedInstOperands,
     /* 135684 */     // GIR_Coverage, 578,
     /* 135684 */     GIR_EraseRootFromParent_Done,
     /* 135685 */   // Label 2641: @135685
     /* 135685 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(135721), // Rule ID 579 //
     /* 135690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 135698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135712 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 135715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135719 */     GIR_RootConstrainSelectedInstOperands,
     /* 135720 */     // GIR_Coverage, 579,
     /* 135720 */     GIR_EraseRootFromParent_Done,
     /* 135721 */   // Label 2642: @135721
     /* 135721 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(135757), // Rule ID 580 //
     /* 135726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 135734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135748 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 135751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135755 */     GIR_RootConstrainSelectedInstOperands,
     /* 135756 */     // GIR_Coverage, 580,
     /* 135756 */     GIR_EraseRootFromParent_Done,
     /* 135757 */   // Label 2643: @135757
     /* 135757 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(135793), // Rule ID 581 //
     /* 135762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 135770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135784 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 135787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135791 */     GIR_RootConstrainSelectedInstOperands,
     /* 135792 */     // GIR_Coverage, 581,
     /* 135792 */     GIR_EraseRootFromParent_Done,
     /* 135793 */   // Label 2644: @135793
     /* 135793 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(135829), // Rule ID 582 //
     /* 135798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 135806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135820 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 135823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135827 */     GIR_RootConstrainSelectedInstOperands,
     /* 135828 */     // GIR_Coverage, 582,
     /* 135828 */     GIR_EraseRootFromParent_Done,
     /* 135829 */   // Label 2645: @135829
     /* 135829 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(135865), // Rule ID 710 //
     /* 135834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 135845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 135848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135856 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 135856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 135859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135863 */     GIR_RootConstrainSelectedInstOperands,
     /* 135864 */     // GIR_Coverage, 710,
     /* 135864 */     GIR_EraseRootFromParent_Done,
     /* 135865 */   // Label 2646: @135865
     /* 135865 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(135901), // Rule ID 711 //
     /* 135870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 135881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 135884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135892 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 135892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 135895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135899 */     GIR_RootConstrainSelectedInstOperands,
     /* 135900 */     // GIR_Coverage, 711,
     /* 135900 */     GIR_EraseRootFromParent_Done,
     /* 135901 */   // Label 2647: @135901
     /* 135901 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(135937), // Rule ID 712 //
     /* 135906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 135917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 135920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135928 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 135928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 135931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135935 */     GIR_RootConstrainSelectedInstOperands,
     /* 135936 */     // GIR_Coverage, 712,
     /* 135936 */     GIR_EraseRootFromParent_Done,
     /* 135937 */   // Label 2648: @135937
     /* 135937 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(135973), // Rule ID 713 //
     /* 135942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 135953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 135964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 135967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135971 */     GIR_RootConstrainSelectedInstOperands,
     /* 135972 */     // GIR_Coverage, 713,
     /* 135972 */     GIR_EraseRootFromParent_Done,
     /* 135973 */   // Label 2649: @135973
     /* 135973 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(136009), // Rule ID 714 //
     /* 135978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 135989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 135992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 136000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 136003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136007 */     GIR_RootConstrainSelectedInstOperands,
     /* 136008 */     // GIR_Coverage, 714,
     /* 136008 */     GIR_EraseRootFromParent_Done,
     /* 136009 */   // Label 2650: @136009
     /* 136009 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(136045), // Rule ID 715 //
     /* 136014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 136036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 136039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136043 */     GIR_RootConstrainSelectedInstOperands,
     /* 136044 */     // GIR_Coverage, 715,
     /* 136044 */     GIR_EraseRootFromParent_Done,
     /* 136045 */   // Label 2651: @136045
     /* 136045 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(136081), // Rule ID 789 //
     /* 136050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136072 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 136075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136079 */     GIR_RootConstrainSelectedInstOperands,
     /* 136080 */     // GIR_Coverage, 789,
     /* 136080 */     GIR_EraseRootFromParent_Done,
     /* 136081 */   // Label 2652: @136081
     /* 136081 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(136117), // Rule ID 790 //
     /* 136086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136108 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 136111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136115 */     GIR_RootConstrainSelectedInstOperands,
     /* 136116 */     // GIR_Coverage, 790,
     /* 136116 */     GIR_EraseRootFromParent_Done,
     /* 136117 */   // Label 2653: @136117
     /* 136117 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(136153), // Rule ID 791 //
     /* 136122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136144 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 136147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136151 */     GIR_RootConstrainSelectedInstOperands,
     /* 136152 */     // GIR_Coverage, 791,
     /* 136152 */     GIR_EraseRootFromParent_Done,
     /* 136153 */   // Label 2654: @136153
     /* 136153 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(136189), // Rule ID 792 //
     /* 136158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136180 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 136183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136187 */     GIR_RootConstrainSelectedInstOperands,
     /* 136188 */     // GIR_Coverage, 792,
     /* 136188 */     GIR_EraseRootFromParent_Done,
     /* 136189 */   // Label 2655: @136189
     /* 136189 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(136225), // Rule ID 793 //
     /* 136194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 136219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136223 */     GIR_RootConstrainSelectedInstOperands,
     /* 136224 */     // GIR_Coverage, 793,
     /* 136224 */     GIR_EraseRootFromParent_Done,
     /* 136225 */   // Label 2656: @136225
     /* 136225 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(136261), // Rule ID 794 //
     /* 136230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136252 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 136255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136259 */     GIR_RootConstrainSelectedInstOperands,
     /* 136260 */     // GIR_Coverage, 794,
     /* 136260 */     GIR_EraseRootFromParent_Done,
     /* 136261 */   // Label 2657: @136261
     /* 136261 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(136297), // Rule ID 795 //
     /* 136266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136288 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 136291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136295 */     GIR_RootConstrainSelectedInstOperands,
     /* 136296 */     // GIR_Coverage, 795,
     /* 136296 */     GIR_EraseRootFromParent_Done,
     /* 136297 */   // Label 2658: @136297
     /* 136297 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(136333), // Rule ID 796 //
     /* 136302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136324 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 136327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136331 */     GIR_RootConstrainSelectedInstOperands,
     /* 136332 */     // GIR_Coverage, 796,
     /* 136332 */     GIR_EraseRootFromParent_Done,
     /* 136333 */   // Label 2659: @136333
     /* 136333 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(136369), // Rule ID 797 //
     /* 136338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136360 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 136363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136367 */     GIR_RootConstrainSelectedInstOperands,
     /* 136368 */     // GIR_Coverage, 797,
     /* 136368 */     GIR_EraseRootFromParent_Done,
     /* 136369 */   // Label 2660: @136369
     /* 136369 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(136405), // Rule ID 798 //
     /* 136374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136396 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 136399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136403 */     GIR_RootConstrainSelectedInstOperands,
     /* 136404 */     // GIR_Coverage, 798,
     /* 136404 */     GIR_EraseRootFromParent_Done,
     /* 136405 */   // Label 2661: @136405
     /* 136405 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(136441), // Rule ID 799 //
     /* 136410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136432 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 136435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136439 */     GIR_RootConstrainSelectedInstOperands,
     /* 136440 */     // GIR_Coverage, 799,
     /* 136440 */     GIR_EraseRootFromParent_Done,
     /* 136441 */   // Label 2662: @136441
     /* 136441 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(136477), // Rule ID 800 //
     /* 136446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136468 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 136471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136475 */     GIR_RootConstrainSelectedInstOperands,
     /* 136476 */     // GIR_Coverage, 800,
     /* 136476 */     GIR_EraseRootFromParent_Done,
     /* 136477 */   // Label 2663: @136477
     /* 136477 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(136513), // Rule ID 801 //
     /* 136482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136504 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 136507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136511 */     GIR_RootConstrainSelectedInstOperands,
     /* 136512 */     // GIR_Coverage, 801,
     /* 136512 */     GIR_EraseRootFromParent_Done,
     /* 136513 */   // Label 2664: @136513
     /* 136513 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(136549), // Rule ID 802 //
     /* 136518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136540 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 136543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136547 */     GIR_RootConstrainSelectedInstOperands,
     /* 136548 */     // GIR_Coverage, 802,
     /* 136548 */     GIR_EraseRootFromParent_Done,
     /* 136549 */   // Label 2665: @136549
     /* 136549 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(136585), // Rule ID 803 //
     /* 136554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136576 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 136579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136583 */     GIR_RootConstrainSelectedInstOperands,
     /* 136584 */     // GIR_Coverage, 803,
     /* 136584 */     GIR_EraseRootFromParent_Done,
     /* 136585 */   // Label 2666: @136585
     /* 136585 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(136621), // Rule ID 804 //
     /* 136590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136612 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 136615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136619 */     GIR_RootConstrainSelectedInstOperands,
     /* 136620 */     // GIR_Coverage, 804,
     /* 136620 */     GIR_EraseRootFromParent_Done,
     /* 136621 */   // Label 2667: @136621
     /* 136621 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(136657), // Rule ID 805 //
     /* 136626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136648 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 136651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136655 */     GIR_RootConstrainSelectedInstOperands,
     /* 136656 */     // GIR_Coverage, 805,
     /* 136656 */     GIR_EraseRootFromParent_Done,
     /* 136657 */   // Label 2668: @136657
     /* 136657 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(136693), // Rule ID 806 //
     /* 136662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136684 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 136687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136691 */     GIR_RootConstrainSelectedInstOperands,
     /* 136692 */     // GIR_Coverage, 806,
     /* 136692 */     GIR_EraseRootFromParent_Done,
     /* 136693 */   // Label 2669: @136693
     /* 136693 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(136729), // Rule ID 807 //
     /* 136698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136720 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 136723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136727 */     GIR_RootConstrainSelectedInstOperands,
     /* 136728 */     // GIR_Coverage, 807,
     /* 136728 */     GIR_EraseRootFromParent_Done,
     /* 136729 */   // Label 2670: @136729
     /* 136729 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(136765), // Rule ID 808 //
     /* 136734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136756 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 136759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136763 */     GIR_RootConstrainSelectedInstOperands,
     /* 136764 */     // GIR_Coverage, 808,
     /* 136764 */     GIR_EraseRootFromParent_Done,
     /* 136765 */   // Label 2671: @136765
     /* 136765 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(136801), // Rule ID 809 //
     /* 136770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136792 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 136795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136799 */     GIR_RootConstrainSelectedInstOperands,
     /* 136800 */     // GIR_Coverage, 809,
     /* 136800 */     GIR_EraseRootFromParent_Done,
     /* 136801 */   // Label 2672: @136801
     /* 136801 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(136837), // Rule ID 810 //
     /* 136806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136828 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 136831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136835 */     GIR_RootConstrainSelectedInstOperands,
     /* 136836 */     // GIR_Coverage, 810,
     /* 136836 */     GIR_EraseRootFromParent_Done,
     /* 136837 */   // Label 2673: @136837
     /* 136837 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(136873), // Rule ID 811 //
     /* 136842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136864 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 136867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136871 */     GIR_RootConstrainSelectedInstOperands,
     /* 136872 */     // GIR_Coverage, 811,
     /* 136872 */     GIR_EraseRootFromParent_Done,
     /* 136873 */   // Label 2674: @136873
     /* 136873 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(136909), // Rule ID 812 //
     /* 136878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136900 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 136903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136907 */     GIR_RootConstrainSelectedInstOperands,
     /* 136908 */     // GIR_Coverage, 812,
     /* 136908 */     GIR_EraseRootFromParent_Done,
     /* 136909 */   // Label 2675: @136909
     /* 136909 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(136945), // Rule ID 813 //
     /* 136914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 136939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136943 */     GIR_RootConstrainSelectedInstOperands,
     /* 136944 */     // GIR_Coverage, 813,
     /* 136944 */     GIR_EraseRootFromParent_Done,
     /* 136945 */   // Label 2676: @136945
     /* 136945 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(136981), // Rule ID 814 //
     /* 136950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 136958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136972 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 136975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136979 */     GIR_RootConstrainSelectedInstOperands,
     /* 136980 */     // GIR_Coverage, 814,
     /* 136980 */     GIR_EraseRootFromParent_Done,
     /* 136981 */   // Label 2677: @136981
     /* 136981 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(137017), // Rule ID 815 //
     /* 136986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 136994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137008 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 137011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137015 */     GIR_RootConstrainSelectedInstOperands,
     /* 137016 */     // GIR_Coverage, 815,
     /* 137016 */     GIR_EraseRootFromParent_Done,
     /* 137017 */   // Label 2678: @137017
     /* 137017 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(137053), // Rule ID 816 //
     /* 137022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137044 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 137047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137051 */     GIR_RootConstrainSelectedInstOperands,
     /* 137052 */     // GIR_Coverage, 816,
     /* 137052 */     GIR_EraseRootFromParent_Done,
     /* 137053 */   // Label 2679: @137053
     /* 137053 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(137089), // Rule ID 817 //
     /* 137058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137080 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 137083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137087 */     GIR_RootConstrainSelectedInstOperands,
     /* 137088 */     // GIR_Coverage, 817,
     /* 137088 */     GIR_EraseRootFromParent_Done,
     /* 137089 */   // Label 2680: @137089
     /* 137089 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(137125), // Rule ID 818 //
     /* 137094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137116 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 137119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137123 */     GIR_RootConstrainSelectedInstOperands,
     /* 137124 */     // GIR_Coverage, 818,
     /* 137124 */     GIR_EraseRootFromParent_Done,
     /* 137125 */   // Label 2681: @137125
     /* 137125 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(137161), // Rule ID 819 //
     /* 137130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137152 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 137155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137159 */     GIR_RootConstrainSelectedInstOperands,
     /* 137160 */     // GIR_Coverage, 819,
     /* 137160 */     GIR_EraseRootFromParent_Done,
     /* 137161 */   // Label 2682: @137161
     /* 137161 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(137197), // Rule ID 820 //
     /* 137166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137188 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 137191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137195 */     GIR_RootConstrainSelectedInstOperands,
     /* 137196 */     // GIR_Coverage, 820,
     /* 137196 */     GIR_EraseRootFromParent_Done,
     /* 137197 */   // Label 2683: @137197
     /* 137197 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(137233), // Rule ID 821 //
     /* 137202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137224 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 137227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137231 */     GIR_RootConstrainSelectedInstOperands,
     /* 137232 */     // GIR_Coverage, 821,
     /* 137232 */     GIR_EraseRootFromParent_Done,
     /* 137233 */   // Label 2684: @137233
     /* 137233 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(137269), // Rule ID 822 //
     /* 137238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137260 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 137263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137267 */     GIR_RootConstrainSelectedInstOperands,
     /* 137268 */     // GIR_Coverage, 822,
     /* 137268 */     GIR_EraseRootFromParent_Done,
     /* 137269 */   // Label 2685: @137269
     /* 137269 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(137305), // Rule ID 823 //
     /* 137274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137296 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 137299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137303 */     GIR_RootConstrainSelectedInstOperands,
     /* 137304 */     // GIR_Coverage, 823,
     /* 137304 */     GIR_EraseRootFromParent_Done,
     /* 137305 */   // Label 2686: @137305
     /* 137305 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(137341), // Rule ID 824 //
     /* 137310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137332 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 137335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137339 */     GIR_RootConstrainSelectedInstOperands,
     /* 137340 */     // GIR_Coverage, 824,
     /* 137340 */     GIR_EraseRootFromParent_Done,
     /* 137341 */   // Label 2687: @137341
     /* 137341 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(137377), // Rule ID 825 //
     /* 137346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137368 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 137371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137375 */     GIR_RootConstrainSelectedInstOperands,
     /* 137376 */     // GIR_Coverage, 825,
     /* 137376 */     GIR_EraseRootFromParent_Done,
     /* 137377 */   // Label 2688: @137377
     /* 137377 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(137413), // Rule ID 826 //
     /* 137382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137404 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 137407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137411 */     GIR_RootConstrainSelectedInstOperands,
     /* 137412 */     // GIR_Coverage, 826,
     /* 137412 */     GIR_EraseRootFromParent_Done,
     /* 137413 */   // Label 2689: @137413
     /* 137413 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(137449), // Rule ID 827 //
     /* 137418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 137443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137447 */     GIR_RootConstrainSelectedInstOperands,
     /* 137448 */     // GIR_Coverage, 827,
     /* 137448 */     GIR_EraseRootFromParent_Done,
     /* 137449 */   // Label 2690: @137449
     /* 137449 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(137485), // Rule ID 828 //
     /* 137454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137476 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 137479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137483 */     GIR_RootConstrainSelectedInstOperands,
     /* 137484 */     // GIR_Coverage, 828,
     /* 137484 */     GIR_EraseRootFromParent_Done,
     /* 137485 */   // Label 2691: @137485
     /* 137485 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(137521), // Rule ID 829 //
     /* 137490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 137498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137512 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 137512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 137515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137519 */     GIR_RootConstrainSelectedInstOperands,
     /* 137520 */     // GIR_Coverage, 829,
     /* 137520 */     GIR_EraseRootFromParent_Done,
     /* 137521 */   // Label 2692: @137521
     /* 137521 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(137557), // Rule ID 856 //
     /* 137526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137548 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 137548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 137551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137555 */     GIR_RootConstrainSelectedInstOperands,
     /* 137556 */     // GIR_Coverage, 856,
     /* 137556 */     GIR_EraseRootFromParent_Done,
     /* 137557 */   // Label 2693: @137557
     /* 137557 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(137593), // Rule ID 857 //
     /* 137562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137584 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 137584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 137587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137591 */     GIR_RootConstrainSelectedInstOperands,
     /* 137592 */     // GIR_Coverage, 857,
     /* 137592 */     GIR_EraseRootFromParent_Done,
     /* 137593 */   // Label 2694: @137593
     /* 137593 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(137629), // Rule ID 858 //
     /* 137598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137620 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 137623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137627 */     GIR_RootConstrainSelectedInstOperands,
     /* 137628 */     // GIR_Coverage, 858,
     /* 137628 */     GIR_EraseRootFromParent_Done,
     /* 137629 */   // Label 2695: @137629
     /* 137629 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(137665), // Rule ID 859 //
     /* 137634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137656 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 137659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137663 */     GIR_RootConstrainSelectedInstOperands,
     /* 137664 */     // GIR_Coverage, 859,
     /* 137664 */     GIR_EraseRootFromParent_Done,
     /* 137665 */   // Label 2696: @137665
     /* 137665 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(137701), // Rule ID 860 //
     /* 137670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137692 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 137692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 137695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137699 */     GIR_RootConstrainSelectedInstOperands,
     /* 137700 */     // GIR_Coverage, 860,
     /* 137700 */     GIR_EraseRootFromParent_Done,
     /* 137701 */   // Label 2697: @137701
     /* 137701 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(137737), // Rule ID 931 //
     /* 137706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 137714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137728 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 137731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137735 */     GIR_RootConstrainSelectedInstOperands,
     /* 137736 */     // GIR_Coverage, 931,
     /* 137736 */     GIR_EraseRootFromParent_Done,
     /* 137737 */   // Label 2698: @137737
     /* 137737 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(137773), // Rule ID 932 //
     /* 137742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 137750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137764 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 137767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137771 */     GIR_RootConstrainSelectedInstOperands,
     /* 137772 */     // GIR_Coverage, 932,
     /* 137772 */     GIR_EraseRootFromParent_Done,
     /* 137773 */   // Label 2699: @137773
     /* 137773 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(137809), // Rule ID 933 //
     /* 137778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 137786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137800 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 137800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 137803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137807 */     GIR_RootConstrainSelectedInstOperands,
     /* 137808 */     // GIR_Coverage, 933,
     /* 137808 */     GIR_EraseRootFromParent_Done,
     /* 137809 */   // Label 2700: @137809
     /* 137809 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(137845), // Rule ID 934 //
     /* 137814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 137822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137836 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 137839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137843 */     GIR_RootConstrainSelectedInstOperands,
     /* 137844 */     // GIR_Coverage, 934,
     /* 137844 */     GIR_EraseRootFromParent_Done,
     /* 137845 */   // Label 2701: @137845
     /* 137845 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(137881), // Rule ID 935 //
     /* 137850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 137858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137872 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 137875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137879 */     GIR_RootConstrainSelectedInstOperands,
     /* 137880 */     // GIR_Coverage, 935,
     /* 137880 */     GIR_EraseRootFromParent_Done,
     /* 137881 */   // Label 2702: @137881
     /* 137881 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(137917), // Rule ID 936 //
     /* 137886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 137894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137908 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 137908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 137911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137915 */     GIR_RootConstrainSelectedInstOperands,
     /* 137916 */     // GIR_Coverage, 936,
     /* 137916 */     GIR_EraseRootFromParent_Done,
     /* 137917 */   // Label 2703: @137917
     /* 137917 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(137953), // Rule ID 937 //
     /* 137922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 137930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137944 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 137947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137951 */     GIR_RootConstrainSelectedInstOperands,
     /* 137952 */     // GIR_Coverage, 937,
     /* 137952 */     GIR_EraseRootFromParent_Done,
     /* 137953 */   // Label 2704: @137953
     /* 137953 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(137989), // Rule ID 938 //
     /* 137958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 137966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137980 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 137983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137987 */     GIR_RootConstrainSelectedInstOperands,
     /* 137988 */     // GIR_Coverage, 938,
     /* 137988 */     GIR_EraseRootFromParent_Done,
     /* 137989 */   // Label 2705: @137989
     /* 137989 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(138025), // Rule ID 939 //
     /* 137994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 138002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138016 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 138019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138023 */     GIR_RootConstrainSelectedInstOperands,
     /* 138024 */     // GIR_Coverage, 939,
     /* 138024 */     GIR_EraseRootFromParent_Done,
     /* 138025 */   // Label 2706: @138025
     /* 138025 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(138061), // Rule ID 940 //
     /* 138030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138052 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 138055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138059 */     GIR_RootConstrainSelectedInstOperands,
     /* 138060 */     // GIR_Coverage, 940,
     /* 138060 */     GIR_EraseRootFromParent_Done,
     /* 138061 */   // Label 2707: @138061
     /* 138061 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(138097), // Rule ID 941 //
     /* 138066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138088 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 138091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138095 */     GIR_RootConstrainSelectedInstOperands,
     /* 138096 */     // GIR_Coverage, 941,
     /* 138096 */     GIR_EraseRootFromParent_Done,
     /* 138097 */   // Label 2708: @138097
     /* 138097 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(138133), // Rule ID 942 //
     /* 138102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138124 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 138127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138131 */     GIR_RootConstrainSelectedInstOperands,
     /* 138132 */     // GIR_Coverage, 942,
     /* 138132 */     GIR_EraseRootFromParent_Done,
     /* 138133 */   // Label 2709: @138133
     /* 138133 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(138169), // Rule ID 943 //
     /* 138138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138160 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 138160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 138163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138167 */     GIR_RootConstrainSelectedInstOperands,
     /* 138168 */     // GIR_Coverage, 943,
     /* 138168 */     GIR_EraseRootFromParent_Done,
     /* 138169 */   // Label 2710: @138169
     /* 138169 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(138205), // Rule ID 944 //
     /* 138174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138196 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 138196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 138199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138203 */     GIR_RootConstrainSelectedInstOperands,
     /* 138204 */     // GIR_Coverage, 944,
     /* 138204 */     GIR_EraseRootFromParent_Done,
     /* 138205 */   // Label 2711: @138205
     /* 138205 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(138241), // Rule ID 945 //
     /* 138210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138232 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 138235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138239 */     GIR_RootConstrainSelectedInstOperands,
     /* 138240 */     // GIR_Coverage, 945,
     /* 138240 */     GIR_EraseRootFromParent_Done,
     /* 138241 */   // Label 2712: @138241
     /* 138241 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(138277), // Rule ID 946 //
     /* 138246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138268 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 138271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138275 */     GIR_RootConstrainSelectedInstOperands,
     /* 138276 */     // GIR_Coverage, 946,
     /* 138276 */     GIR_EraseRootFromParent_Done,
     /* 138277 */   // Label 2713: @138277
     /* 138277 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(138313), // Rule ID 947 //
     /* 138282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138304 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 138307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138311 */     GIR_RootConstrainSelectedInstOperands,
     /* 138312 */     // GIR_Coverage, 947,
     /* 138312 */     GIR_EraseRootFromParent_Done,
     /* 138313 */   // Label 2714: @138313
     /* 138313 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(138349), // Rule ID 994 //
     /* 138318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138340 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 138340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 138343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138347 */     GIR_RootConstrainSelectedInstOperands,
     /* 138348 */     // GIR_Coverage, 994,
     /* 138348 */     GIR_EraseRootFromParent_Done,
     /* 138349 */   // Label 2715: @138349
     /* 138349 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(138385), // Rule ID 996 //
     /* 138354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138376 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 138376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 138379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138383 */     GIR_RootConstrainSelectedInstOperands,
     /* 138384 */     // GIR_Coverage, 996,
     /* 138384 */     GIR_EraseRootFromParent_Done,
     /* 138385 */   // Label 2716: @138385
     /* 138385 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(138421), // Rule ID 998 //
     /* 138390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138412 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 138412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 138415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138419 */     GIR_RootConstrainSelectedInstOperands,
     /* 138420 */     // GIR_Coverage, 998,
     /* 138420 */     GIR_EraseRootFromParent_Done,
     /* 138421 */   // Label 2717: @138421
     /* 138421 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(138457), // Rule ID 1000 //
     /* 138426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 138448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 138451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138455 */     GIR_RootConstrainSelectedInstOperands,
     /* 138456 */     // GIR_Coverage, 1000,
     /* 138456 */     GIR_EraseRootFromParent_Done,
     /* 138457 */   // Label 2718: @138457
     /* 138457 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(138493), // Rule ID 1002 //
     /* 138462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138484 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 138484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 138487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138491 */     GIR_RootConstrainSelectedInstOperands,
     /* 138492 */     // GIR_Coverage, 1002,
     /* 138492 */     GIR_EraseRootFromParent_Done,
     /* 138493 */   // Label 2719: @138493
     /* 138493 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(138529), // Rule ID 1004 //
     /* 138498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138520 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 138520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 138523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138527 */     GIR_RootConstrainSelectedInstOperands,
     /* 138528 */     // GIR_Coverage, 1004,
     /* 138528 */     GIR_EraseRootFromParent_Done,
     /* 138529 */   // Label 2720: @138529
     /* 138529 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(138565), // Rule ID 1015 //
     /* 138534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 138545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138556 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 138556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 138559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138563 */     GIR_RootConstrainSelectedInstOperands,
     /* 138564 */     // GIR_Coverage, 1015,
     /* 138564 */     GIR_EraseRootFromParent_Done,
     /* 138565 */   // Label 2721: @138565
     /* 138565 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(138601), // Rule ID 1016 //
     /* 138570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138592 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 138592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 138595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138599 */     GIR_RootConstrainSelectedInstOperands,
     /* 138600 */     // GIR_Coverage, 1016,
     /* 138600 */     GIR_EraseRootFromParent_Done,
     /* 138601 */   // Label 2722: @138601
     /* 138601 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(138637), // Rule ID 1017 //
     /* 138606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138628 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 138628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 138631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138635 */     GIR_RootConstrainSelectedInstOperands,
     /* 138636 */     // GIR_Coverage, 1017,
     /* 138636 */     GIR_EraseRootFromParent_Done,
     /* 138637 */   // Label 2723: @138637
     /* 138637 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(138673), // Rule ID 1018 //
     /* 138642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 138664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 138667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138671 */     GIR_RootConstrainSelectedInstOperands,
     /* 138672 */     // GIR_Coverage, 1018,
     /* 138672 */     GIR_EraseRootFromParent_Done,
     /* 138673 */   // Label 2724: @138673
     /* 138673 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(138709), // Rule ID 1019 //
     /* 138678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138700 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 138700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 138703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138707 */     GIR_RootConstrainSelectedInstOperands,
     /* 138708 */     // GIR_Coverage, 1019,
     /* 138708 */     GIR_EraseRootFromParent_Done,
     /* 138709 */   // Label 2725: @138709
     /* 138709 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(138745), // Rule ID 1020 //
     /* 138714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 138736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 138739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138743 */     GIR_RootConstrainSelectedInstOperands,
     /* 138744 */     // GIR_Coverage, 1020,
     /* 138744 */     GIR_EraseRootFromParent_Done,
     /* 138745 */   // Label 2726: @138745
     /* 138745 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(138781), // Rule ID 1021 //
     /* 138750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138772 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 138772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 138775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138779 */     GIR_RootConstrainSelectedInstOperands,
     /* 138780 */     // GIR_Coverage, 1021,
     /* 138780 */     GIR_EraseRootFromParent_Done,
     /* 138781 */   // Label 2727: @138781
     /* 138781 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(138817), // Rule ID 1022 //
     /* 138786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 138797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138808 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 138808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 138811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138815 */     GIR_RootConstrainSelectedInstOperands,
     /* 138816 */     // GIR_Coverage, 1022,
     /* 138816 */     GIR_EraseRootFromParent_Done,
     /* 138817 */   // Label 2728: @138817
     /* 138817 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(138853), // Rule ID 1023 //
     /* 138822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138844 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 138844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 138847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138851 */     GIR_RootConstrainSelectedInstOperands,
     /* 138852 */     // GIR_Coverage, 1023,
     /* 138852 */     GIR_EraseRootFromParent_Done,
     /* 138853 */   // Label 2729: @138853
     /* 138853 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(138889), // Rule ID 1024 //
     /* 138858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138880 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 138880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 138883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138887 */     GIR_RootConstrainSelectedInstOperands,
     /* 138888 */     // GIR_Coverage, 1024,
     /* 138888 */     GIR_EraseRootFromParent_Done,
     /* 138889 */   // Label 2730: @138889
     /* 138889 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(138925), // Rule ID 1025 //
     /* 138894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138916 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 138916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 138919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138923 */     GIR_RootConstrainSelectedInstOperands,
     /* 138924 */     // GIR_Coverage, 1025,
     /* 138924 */     GIR_EraseRootFromParent_Done,
     /* 138925 */   // Label 2731: @138925
     /* 138925 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(138961), // Rule ID 1026 //
     /* 138930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138952 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 138952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 138955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138959 */     GIR_RootConstrainSelectedInstOperands,
     /* 138960 */     // GIR_Coverage, 1026,
     /* 138960 */     GIR_EraseRootFromParent_Done,
     /* 138961 */   // Label 2732: @138961
     /* 138961 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(138997), // Rule ID 1027 //
     /* 138966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 138988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 138991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138995 */     GIR_RootConstrainSelectedInstOperands,
     /* 138996 */     // GIR_Coverage, 1027,
     /* 138996 */     GIR_EraseRootFromParent_Done,
     /* 138997 */   // Label 2733: @138997
     /* 138997 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(139033), // Rule ID 1028 //
     /* 139002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139024 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 139024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 139027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139031 */     GIR_RootConstrainSelectedInstOperands,
     /* 139032 */     // GIR_Coverage, 1028,
     /* 139032 */     GIR_EraseRootFromParent_Done,
     /* 139033 */   // Label 2734: @139033
     /* 139033 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(139069), // Rule ID 1055 //
     /* 139038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 139052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139060 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 139060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 139063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139067 */     GIR_RootConstrainSelectedInstOperands,
     /* 139068 */     // GIR_Coverage, 1055,
     /* 139068 */     GIR_EraseRootFromParent_Done,
     /* 139069 */   // Label 2735: @139069
     /* 139069 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(139105), // Rule ID 1057 //
     /* 139074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139096 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 139096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 139099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139103 */     GIR_RootConstrainSelectedInstOperands,
     /* 139104 */     // GIR_Coverage, 1057,
     /* 139104 */     GIR_EraseRootFromParent_Done,
     /* 139105 */   // Label 2736: @139105
     /* 139105 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(139141), // Rule ID 1059 //
     /* 139110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139132 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 139132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 139135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139139 */     GIR_RootConstrainSelectedInstOperands,
     /* 139140 */     // GIR_Coverage, 1059,
     /* 139140 */     GIR_EraseRootFromParent_Done,
     /* 139141 */   // Label 2737: @139141
     /* 139141 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(139177), // Rule ID 1061 //
     /* 139146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139168 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 139168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 139171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139175 */     GIR_RootConstrainSelectedInstOperands,
     /* 139176 */     // GIR_Coverage, 1061,
     /* 139176 */     GIR_EraseRootFromParent_Done,
     /* 139177 */   // Label 2738: @139177
     /* 139177 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(139213), // Rule ID 1063 //
     /* 139182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139204 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 139204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 139207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139211 */     GIR_RootConstrainSelectedInstOperands,
     /* 139212 */     // GIR_Coverage, 1063,
     /* 139212 */     GIR_EraseRootFromParent_Done,
     /* 139213 */   // Label 2739: @139213
     /* 139213 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(139249), // Rule ID 1065 //
     /* 139218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139240 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 139240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 139243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139247 */     GIR_RootConstrainSelectedInstOperands,
     /* 139248 */     // GIR_Coverage, 1065,
     /* 139248 */     GIR_EraseRootFromParent_Done,
     /* 139249 */   // Label 2740: @139249
     /* 139249 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(139285), // Rule ID 1079 //
     /* 139254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 139262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139276 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 139279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139283 */     GIR_RootConstrainSelectedInstOperands,
     /* 139284 */     // GIR_Coverage, 1079,
     /* 139284 */     GIR_EraseRootFromParent_Done,
     /* 139285 */   // Label 2741: @139285
     /* 139285 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(139321), // Rule ID 1080 //
     /* 139290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 139298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 139315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139319 */     GIR_RootConstrainSelectedInstOperands,
     /* 139320 */     // GIR_Coverage, 1080,
     /* 139320 */     GIR_EraseRootFromParent_Done,
     /* 139321 */   // Label 2742: @139321
     /* 139321 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(139357), // Rule ID 1081 //
     /* 139326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 139334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 139351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139355 */     GIR_RootConstrainSelectedInstOperands,
     /* 139356 */     // GIR_Coverage, 1081,
     /* 139356 */     GIR_EraseRootFromParent_Done,
     /* 139357 */   // Label 2743: @139357
     /* 139357 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(139393), // Rule ID 1082 //
     /* 139362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 139370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 139387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139391 */     GIR_RootConstrainSelectedInstOperands,
     /* 139392 */     // GIR_Coverage, 1082,
     /* 139392 */     GIR_EraseRootFromParent_Done,
     /* 139393 */   // Label 2744: @139393
     /* 139393 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(139429), // Rule ID 1646 //
     /* 139398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 139406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139420 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 139423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139427 */     GIR_RootConstrainSelectedInstOperands,
     /* 139428 */     // GIR_Coverage, 1646,
     /* 139428 */     GIR_EraseRootFromParent_Done,
     /* 139429 */   // Label 2745: @139429
     /* 139429 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(139465), // Rule ID 1652 //
     /* 139434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139456 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 139456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 139459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139463 */     GIR_RootConstrainSelectedInstOperands,
     /* 139464 */     // GIR_Coverage, 1652,
     /* 139464 */     GIR_EraseRootFromParent_Done,
     /* 139465 */   // Label 2746: @139465
     /* 139465 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(139501), // Rule ID 1653 //
     /* 139470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139492 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 139492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 139495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139499 */     GIR_RootConstrainSelectedInstOperands,
     /* 139500 */     // GIR_Coverage, 1653,
     /* 139500 */     GIR_EraseRootFromParent_Done,
     /* 139501 */   // Label 2747: @139501
     /* 139501 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(139537), // Rule ID 1654 //
     /* 139506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139528 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 139528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 139531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139535 */     GIR_RootConstrainSelectedInstOperands,
     /* 139536 */     // GIR_Coverage, 1654,
     /* 139536 */     GIR_EraseRootFromParent_Done,
     /* 139537 */   // Label 2748: @139537
     /* 139537 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(139573), // Rule ID 1655 //
     /* 139542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139564 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 139564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 139567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139571 */     GIR_RootConstrainSelectedInstOperands,
     /* 139572 */     // GIR_Coverage, 1655,
     /* 139572 */     GIR_EraseRootFromParent_Done,
     /* 139573 */   // Label 2749: @139573
     /* 139573 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(139609), // Rule ID 1656 //
     /* 139578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 139586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139600 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 139603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139607 */     GIR_RootConstrainSelectedInstOperands,
     /* 139608 */     // GIR_Coverage, 1656,
     /* 139608 */     GIR_EraseRootFromParent_Done,
     /* 139609 */   // Label 2750: @139609
     /* 139609 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(139645), // Rule ID 1657 //
     /* 139614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 139622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139636 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 139639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139643 */     GIR_RootConstrainSelectedInstOperands,
     /* 139644 */     // GIR_Coverage, 1657,
     /* 139644 */     GIR_EraseRootFromParent_Done,
     /* 139645 */   // Label 2751: @139645
     /* 139645 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(139681), // Rule ID 1663 //
     /* 139650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 139658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139672 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 139675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139679 */     GIR_RootConstrainSelectedInstOperands,
     /* 139680 */     // GIR_Coverage, 1663,
     /* 139680 */     GIR_EraseRootFromParent_Done,
     /* 139681 */   // Label 2752: @139681
     /* 139681 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(139717), // Rule ID 1936 //
     /* 139686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 139694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139708 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 139708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 139711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139715 */     GIR_RootConstrainSelectedInstOperands,
     /* 139716 */     // GIR_Coverage, 1936,
     /* 139716 */     GIR_EraseRootFromParent_Done,
     /* 139717 */   // Label 2753: @139717
     /* 139717 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(139753), // Rule ID 1938 //
     /* 139722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 139730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139744 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 139744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 139747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139751 */     GIR_RootConstrainSelectedInstOperands,
     /* 139752 */     // GIR_Coverage, 1938,
     /* 139752 */     GIR_EraseRootFromParent_Done,
     /* 139753 */   // Label 2754: @139753
     /* 139753 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(139789), // Rule ID 1940 //
     /* 139758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 139766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139780 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 139780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 139783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139787 */     GIR_RootConstrainSelectedInstOperands,
     /* 139788 */     // GIR_Coverage, 1940,
     /* 139788 */     GIR_EraseRootFromParent_Done,
     /* 139789 */   // Label 2755: @139789
     /* 139789 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(139825), // Rule ID 1942 //
     /* 139794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 139802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139816 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 139816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 139819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139823 */     GIR_RootConstrainSelectedInstOperands,
     /* 139824 */     // GIR_Coverage, 1942,
     /* 139824 */     GIR_EraseRootFromParent_Done,
     /* 139825 */   // Label 2756: @139825
     /* 139825 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(139861), // Rule ID 1944 //
     /* 139830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 139838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139852 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 139852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 139855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139859 */     GIR_RootConstrainSelectedInstOperands,
     /* 139860 */     // GIR_Coverage, 1944,
     /* 139860 */     GIR_EraseRootFromParent_Done,
     /* 139861 */   // Label 2757: @139861
     /* 139861 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(139897), // Rule ID 1946 //
     /* 139866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 139874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139888 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 139888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 139891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139895 */     GIR_RootConstrainSelectedInstOperands,
     /* 139896 */     // GIR_Coverage, 1946,
     /* 139896 */     GIR_EraseRootFromParent_Done,
     /* 139897 */   // Label 2758: @139897
     /* 139897 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(139933), // Rule ID 1948 //
     /* 139902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 139910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139924 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 139924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 139927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139931 */     GIR_RootConstrainSelectedInstOperands,
     /* 139932 */     // GIR_Coverage, 1948,
     /* 139932 */     GIR_EraseRootFromParent_Done,
     /* 139933 */   // Label 2759: @139933
     /* 139933 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(139969), // Rule ID 1950 //
     /* 139938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 139946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139960 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 139960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 139963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139967 */     GIR_RootConstrainSelectedInstOperands,
     /* 139968 */     // GIR_Coverage, 1950,
     /* 139968 */     GIR_EraseRootFromParent_Done,
     /* 139969 */   // Label 2760: @139969
     /* 139969 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(140005), // Rule ID 1952 //
     /* 139974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 139982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139996 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 139996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 139999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140003 */     GIR_RootConstrainSelectedInstOperands,
     /* 140004 */     // GIR_Coverage, 1952,
     /* 140004 */     GIR_EraseRootFromParent_Done,
     /* 140005 */   // Label 2761: @140005
     /* 140005 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(140041), // Rule ID 1954 //
     /* 140010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140032 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 140035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140039 */     GIR_RootConstrainSelectedInstOperands,
     /* 140040 */     // GIR_Coverage, 1954,
     /* 140040 */     GIR_EraseRootFromParent_Done,
     /* 140041 */   // Label 2762: @140041
     /* 140041 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(140077), // Rule ID 1956 //
     /* 140046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140068 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 140071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140075 */     GIR_RootConstrainSelectedInstOperands,
     /* 140076 */     // GIR_Coverage, 1956,
     /* 140076 */     GIR_EraseRootFromParent_Done,
     /* 140077 */   // Label 2763: @140077
     /* 140077 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(140113), // Rule ID 1958 //
     /* 140082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140104 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 140107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140111 */     GIR_RootConstrainSelectedInstOperands,
     /* 140112 */     // GIR_Coverage, 1958,
     /* 140112 */     GIR_EraseRootFromParent_Done,
     /* 140113 */   // Label 2764: @140113
     /* 140113 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(140149), // Rule ID 2296 //
     /* 140118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 140121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 140126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140140 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 140140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 140143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140147 */     GIR_RootConstrainSelectedInstOperands,
     /* 140148 */     // GIR_Coverage, 2296,
     /* 140148 */     GIR_EraseRootFromParent_Done,
     /* 140149 */   // Label 2765: @140149
     /* 140149 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(140185), // Rule ID 2297 //
     /* 140154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 140157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 140162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140176 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 140176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 140179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140183 */     GIR_RootConstrainSelectedInstOperands,
     /* 140184 */     // GIR_Coverage, 2297,
     /* 140184 */     GIR_EraseRootFromParent_Done,
     /* 140185 */   // Label 2766: @140185
     /* 140185 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(140221), // Rule ID 2305 //
     /* 140190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 140193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 140198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140212 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 140212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 140215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140219 */     GIR_RootConstrainSelectedInstOperands,
     /* 140220 */     // GIR_Coverage, 2305,
     /* 140220 */     GIR_EraseRootFromParent_Done,
     /* 140221 */   // Label 2767: @140221
     /* 140221 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(140257), // Rule ID 2506 //
     /* 140226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 140234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140248 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 140248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 140251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140255 */     GIR_RootConstrainSelectedInstOperands,
     /* 140256 */     // GIR_Coverage, 2506,
     /* 140256 */     GIR_EraseRootFromParent_Done,
     /* 140257 */   // Label 2768: @140257
     /* 140257 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(140296), // Rule ID 3528 //
     /* 140262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 140273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 140276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 140284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 140287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140294 */     GIR_RootConstrainSelectedInstOperands,
     /* 140295 */     // GIR_Coverage, 3528,
     /* 140295 */     GIR_EraseRootFromParent_Done,
     /* 140296 */   // Label 2769: @140296
     /* 140296 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(140335), // Rule ID 3529 //
     /* 140301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 140312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 140315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140323 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 140323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 140326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140333 */     GIR_RootConstrainSelectedInstOperands,
     /* 140334 */     // GIR_Coverage, 3529,
     /* 140334 */     GIR_EraseRootFromParent_Done,
     /* 140335 */   // Label 2770: @140335
     /* 140335 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(140374), // Rule ID 3530 //
     /* 140340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 140351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 140354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 140362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 140365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140372 */     GIR_RootConstrainSelectedInstOperands,
     /* 140373 */     // GIR_Coverage, 3530,
     /* 140373 */     GIR_EraseRootFromParent_Done,
     /* 140374 */   // Label 2771: @140374
     /* 140374 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(140413), // Rule ID 3531 //
     /* 140379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 140390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 140393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140401 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 140401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 140404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140411 */     GIR_RootConstrainSelectedInstOperands,
     /* 140412 */     // GIR_Coverage, 3531,
     /* 140412 */     GIR_EraseRootFromParent_Done,
     /* 140413 */   // Label 2772: @140413
     /* 140413 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(140469), // Rule ID 3535 //
     /* 140418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 140429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 140432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140440 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1535:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 140440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 140457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140467 */     GIR_RootConstrainSelectedInstOperands,
     /* 140468 */     // GIR_Coverage, 3535,
     /* 140468 */     GIR_EraseRootFromParent_Done,
     /* 140469 */   // Label 2773: @140469
     /* 140469 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(140525), // Rule ID 3536 //
     /* 140474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 140485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 140488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1535:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 140496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 140513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140523 */     GIR_RootConstrainSelectedInstOperands,
     /* 140524 */     // GIR_Coverage, 3536,
     /* 140524 */     GIR_EraseRootFromParent_Done,
     /* 140525 */   // Label 2774: @140525
     /* 140525 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(140581), // Rule ID 3537 //
     /* 140530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 140541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 140544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1535:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 140552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 140569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140579 */     GIR_RootConstrainSelectedInstOperands,
     /* 140580 */     // GIR_Coverage, 3537,
     /* 140580 */     GIR_EraseRootFromParent_Done,
     /* 140581 */   // Label 2775: @140581
     /* 140581 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(140637), // Rule ID 3538 //
     /* 140586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 140597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 140600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1535:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 140608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 140625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140635 */     GIR_RootConstrainSelectedInstOperands,
     /* 140636 */     // GIR_Coverage, 3538,
     /* 140636 */     GIR_EraseRootFromParent_Done,
     /* 140637 */   // Label 2776: @140637
     /* 140637 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(140670), // Rule ID 3951 //
     /* 140642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 140647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140661 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 140661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 140664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140668 */     GIR_RootConstrainSelectedInstOperands,
     /* 140669 */     // GIR_Coverage, 3951,
     /* 140669 */     GIR_EraseRootFromParent_Done,
     /* 140670 */   // Label 2777: @140670
     /* 140670 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(140735), // Rule ID 3952 //
     /* 140675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 140680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140694 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 140694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 140701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 140710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 140724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140734 */     // GIR_Coverage, 3952,
     /* 140734 */     GIR_EraseRootFromParent_Done,
     /* 140735 */   // Label 2778: @140735
     /* 140735 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(140768), // Rule ID 4720 //
     /* 140740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 140745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140759 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 140762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140766 */     GIR_RootConstrainSelectedInstOperands,
     /* 140767 */     // GIR_Coverage, 4720,
     /* 140767 */     GIR_EraseRootFromParent_Done,
     /* 140768 */   // Label 2779: @140768
     /* 140768 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(140801), // Rule ID 4721 //
     /* 140773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 140778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140792 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 140795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140799 */     GIR_RootConstrainSelectedInstOperands,
     /* 140800 */     // GIR_Coverage, 4721,
     /* 140800 */     GIR_EraseRootFromParent_Done,
     /* 140801 */   // Label 2780: @140801
     /* 140801 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(140834), // Rule ID 4722 //
     /* 140806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 140811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140825 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 140828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140832 */     GIR_RootConstrainSelectedInstOperands,
     /* 140833 */     // GIR_Coverage, 4722,
     /* 140833 */     GIR_EraseRootFromParent_Done,
     /* 140834 */   // Label 2781: @140834
     /* 140834 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(140867), // Rule ID 4723 //
     /* 140839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 140844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140858 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 140861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140865 */     GIR_RootConstrainSelectedInstOperands,
     /* 140866 */     // GIR_Coverage, 4723,
     /* 140866 */     GIR_EraseRootFromParent_Done,
     /* 140867 */   // Label 2782: @140867
     /* 140867 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(140900), // Rule ID 4837 //
     /* 140872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 140877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140891 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 140891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 140894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140898 */     GIR_RootConstrainSelectedInstOperands,
     /* 140899 */     // GIR_Coverage, 4837,
     /* 140899 */     GIR_EraseRootFromParent_Done,
     /* 140900 */   // Label 2783: @140900
     /* 140900 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(140933), // Rule ID 4847 //
     /* 140905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 140910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 140913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140924 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 140924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 140927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140931 */     GIR_RootConstrainSelectedInstOperands,
     /* 140932 */     // GIR_Coverage, 4847,
     /* 140932 */     GIR_EraseRootFromParent_Done,
     /* 140933 */   // Label 2784: @140933
     /* 140933 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(140969), // Rule ID 5185 //
     /* 140938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 140946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140960 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 140960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 140963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140967 */     GIR_RootConstrainSelectedInstOperands,
     /* 140968 */     // GIR_Coverage, 5185,
     /* 140968 */     GIR_EraseRootFromParent_Done,
     /* 140969 */   // Label 2785: @140969
     /* 140969 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(141002), // Rule ID 5188 //
     /* 140974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140993 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 140996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141000 */     GIR_RootConstrainSelectedInstOperands,
     /* 141001 */     // GIR_Coverage, 5188,
     /* 141001 */     GIR_EraseRootFromParent_Done,
     /* 141002 */   // Label 2786: @141002
     /* 141002 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(141035), // Rule ID 5189 //
     /* 141007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141026 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 141029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141033 */     GIR_RootConstrainSelectedInstOperands,
     /* 141034 */     // GIR_Coverage, 5189,
     /* 141034 */     GIR_EraseRootFromParent_Done,
     /* 141035 */   // Label 2787: @141035
     /* 141035 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(141068), // Rule ID 5190 //
     /* 141040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141059 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 141062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141066 */     GIR_RootConstrainSelectedInstOperands,
     /* 141067 */     // GIR_Coverage, 5190,
     /* 141067 */     GIR_EraseRootFromParent_Done,
     /* 141068 */   // Label 2788: @141068
     /* 141068 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(141101), // Rule ID 5191 //
     /* 141073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141092 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 141095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141099 */     GIR_RootConstrainSelectedInstOperands,
     /* 141100 */     // GIR_Coverage, 5191,
     /* 141100 */     GIR_EraseRootFromParent_Done,
     /* 141101 */   // Label 2789: @141101
     /* 141101 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(141134), // Rule ID 5192 //
     /* 141106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141125 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 141128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141132 */     GIR_RootConstrainSelectedInstOperands,
     /* 141133 */     // GIR_Coverage, 5192,
     /* 141133 */     GIR_EraseRootFromParent_Done,
     /* 141134 */   // Label 2790: @141134
     /* 141134 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(141167), // Rule ID 5193 //
     /* 141139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141158 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 141161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141165 */     GIR_RootConstrainSelectedInstOperands,
     /* 141166 */     // GIR_Coverage, 5193,
     /* 141166 */     GIR_EraseRootFromParent_Done,
     /* 141167 */   // Label 2791: @141167
     /* 141167 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(141200), // Rule ID 5194 //
     /* 141172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141191 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 141194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141198 */     GIR_RootConstrainSelectedInstOperands,
     /* 141199 */     // GIR_Coverage, 5194,
     /* 141199 */     GIR_EraseRootFromParent_Done,
     /* 141200 */   // Label 2792: @141200
     /* 141200 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(141233), // Rule ID 5195 //
     /* 141205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141224 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 141227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141231 */     GIR_RootConstrainSelectedInstOperands,
     /* 141232 */     // GIR_Coverage, 5195,
     /* 141232 */     GIR_EraseRootFromParent_Done,
     /* 141233 */   // Label 2793: @141233
     /* 141233 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(141266), // Rule ID 5196 //
     /* 141238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 141243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141257 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 141260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141264 */     GIR_RootConstrainSelectedInstOperands,
     /* 141265 */     // GIR_Coverage, 5196,
     /* 141265 */     GIR_EraseRootFromParent_Done,
     /* 141266 */   // Label 2794: @141266
     /* 141266 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(141299), // Rule ID 5197 //
     /* 141271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 141276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141290 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 141293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141297 */     GIR_RootConstrainSelectedInstOperands,
     /* 141298 */     // GIR_Coverage, 5197,
     /* 141298 */     GIR_EraseRootFromParent_Done,
     /* 141299 */   // Label 2795: @141299
     /* 141299 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(141332), // Rule ID 5198 //
     /* 141304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141323 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 141326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141330 */     GIR_RootConstrainSelectedInstOperands,
     /* 141331 */     // GIR_Coverage, 5198,
     /* 141331 */     GIR_EraseRootFromParent_Done,
     /* 141332 */   // Label 2796: @141332
     /* 141332 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(141365), // Rule ID 5199 //
     /* 141337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141356 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 141359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141363 */     GIR_RootConstrainSelectedInstOperands,
     /* 141364 */     // GIR_Coverage, 5199,
     /* 141364 */     GIR_EraseRootFromParent_Done,
     /* 141365 */   // Label 2797: @141365
     /* 141365 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(141398), // Rule ID 5200 //
     /* 141370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141389 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 141392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141396 */     GIR_RootConstrainSelectedInstOperands,
     /* 141397 */     // GIR_Coverage, 5200,
     /* 141397 */     GIR_EraseRootFromParent_Done,
     /* 141398 */   // Label 2798: @141398
     /* 141398 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(141431), // Rule ID 5201 //
     /* 141403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141422 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 141425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141429 */     GIR_RootConstrainSelectedInstOperands,
     /* 141430 */     // GIR_Coverage, 5201,
     /* 141430 */     GIR_EraseRootFromParent_Done,
     /* 141431 */   // Label 2799: @141431
     /* 141431 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(141464), // Rule ID 5213 //
     /* 141436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141455 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 141458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141462 */     GIR_RootConstrainSelectedInstOperands,
     /* 141463 */     // GIR_Coverage, 5213,
     /* 141463 */     GIR_EraseRootFromParent_Done,
     /* 141464 */   // Label 2800: @141464
     /* 141464 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(141497), // Rule ID 5214 //
     /* 141469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141488 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 141491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141495 */     GIR_RootConstrainSelectedInstOperands,
     /* 141496 */     // GIR_Coverage, 5214,
     /* 141496 */     GIR_EraseRootFromParent_Done,
     /* 141497 */   // Label 2801: @141497
     /* 141497 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(141530), // Rule ID 5215 //
     /* 141502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141521 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 141524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141528 */     GIR_RootConstrainSelectedInstOperands,
     /* 141529 */     // GIR_Coverage, 5215,
     /* 141529 */     GIR_EraseRootFromParent_Done,
     /* 141530 */   // Label 2802: @141530
     /* 141530 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(141563), // Rule ID 5216 //
     /* 141535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141554 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 141557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141561 */     GIR_RootConstrainSelectedInstOperands,
     /* 141562 */     // GIR_Coverage, 5216,
     /* 141562 */     GIR_EraseRootFromParent_Done,
     /* 141563 */   // Label 2803: @141563
     /* 141563 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(141596), // Rule ID 5217 //
     /* 141568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141587 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 141590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141594 */     GIR_RootConstrainSelectedInstOperands,
     /* 141595 */     // GIR_Coverage, 5217,
     /* 141595 */     GIR_EraseRootFromParent_Done,
     /* 141596 */   // Label 2804: @141596
     /* 141596 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(141629), // Rule ID 5218 //
     /* 141601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141620 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 141623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141627 */     GIR_RootConstrainSelectedInstOperands,
     /* 141628 */     // GIR_Coverage, 5218,
     /* 141628 */     GIR_EraseRootFromParent_Done,
     /* 141629 */   // Label 2805: @141629
     /* 141629 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(141662), // Rule ID 5219 //
     /* 141634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141653 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 141656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141660 */     GIR_RootConstrainSelectedInstOperands,
     /* 141661 */     // GIR_Coverage, 5219,
     /* 141661 */     GIR_EraseRootFromParent_Done,
     /* 141662 */   // Label 2806: @141662
     /* 141662 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(141695), // Rule ID 5543 //
     /* 141667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 141672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141686 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 141689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141693 */     GIR_RootConstrainSelectedInstOperands,
     /* 141694 */     // GIR_Coverage, 5543,
     /* 141694 */     GIR_EraseRootFromParent_Done,
     /* 141695 */   // Label 2807: @141695
     /* 141695 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(141780), // Rule ID 5544 //
     /* 141700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 141705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141719 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 141719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 141722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 141726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 141735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 141739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141753 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 141760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 141773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141778 */     GIR_RootConstrainSelectedInstOperands,
     /* 141779 */     // GIR_Coverage, 5544,
     /* 141779 */     GIR_EraseRootFromParent_Done,
     /* 141780 */   // Label 2808: @141780
     /* 141780 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(141813), // Rule ID 5545 //
     /* 141785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 141790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141804 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 141804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 141807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141811 */     GIR_RootConstrainSelectedInstOperands,
     /* 141812 */     // GIR_Coverage, 5545,
     /* 141812 */     GIR_EraseRootFromParent_Done,
     /* 141813 */   // Label 2809: @141813
     /* 141813 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(141846), // Rule ID 5547 //
     /* 141818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 141823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141837 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 141840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141844 */     GIR_RootConstrainSelectedInstOperands,
     /* 141845 */     // GIR_Coverage, 5547,
     /* 141845 */     GIR_EraseRootFromParent_Done,
     /* 141846 */   // Label 2810: @141846
     /* 141846 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(141879), // Rule ID 5549 //
     /* 141851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 141856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141870 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 141870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 141873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141877 */     GIR_RootConstrainSelectedInstOperands,
     /* 141878 */     // GIR_Coverage, 5549,
     /* 141878 */     GIR_EraseRootFromParent_Done,
     /* 141879 */   // Label 2811: @141879
     /* 141879 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(141912), // Rule ID 5551 //
     /* 141884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 141889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141903 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 141906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141910 */     GIR_RootConstrainSelectedInstOperands,
     /* 141911 */     // GIR_Coverage, 5551,
     /* 141911 */     GIR_EraseRootFromParent_Done,
     /* 141912 */   // Label 2812: @141912
     /* 141912 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(141945), // Rule ID 5553 //
     /* 141917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 141922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141936 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 141936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 141939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141943 */     GIR_RootConstrainSelectedInstOperands,
     /* 141944 */     // GIR_Coverage, 5553,
     /* 141944 */     GIR_EraseRootFromParent_Done,
     /* 141945 */   // Label 2813: @141945
     /* 141945 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(141978), // Rule ID 5555 //
     /* 141950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 141955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141969 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 141972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141976 */     GIR_RootConstrainSelectedInstOperands,
     /* 141977 */     // GIR_Coverage, 5555,
     /* 141977 */     GIR_EraseRootFromParent_Done,
     /* 141978 */   // Label 2814: @141978
     /* 141978 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(142011), // Rule ID 5557 //
     /* 141983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 141988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142002 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 142005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142009 */     GIR_RootConstrainSelectedInstOperands,
     /* 142010 */     // GIR_Coverage, 5557,
     /* 142010 */     GIR_EraseRootFromParent_Done,
     /* 142011 */   // Label 2815: @142011
     /* 142011 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(142044), // Rule ID 5559 //
     /* 142016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142035 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 142038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142042 */     GIR_RootConstrainSelectedInstOperands,
     /* 142043 */     // GIR_Coverage, 5559,
     /* 142043 */     GIR_EraseRootFromParent_Done,
     /* 142044 */   // Label 2816: @142044
     /* 142044 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(142077), // Rule ID 5561 //
     /* 142049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142068 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 142071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142075 */     GIR_RootConstrainSelectedInstOperands,
     /* 142076 */     // GIR_Coverage, 5561,
     /* 142076 */     GIR_EraseRootFromParent_Done,
     /* 142077 */   // Label 2817: @142077
     /* 142077 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(142110), // Rule ID 12837 //
     /* 142082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142101 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 142104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142108 */     GIR_RootConstrainSelectedInstOperands,
     /* 142109 */     // GIR_Coverage, 12837,
     /* 142109 */     GIR_EraseRootFromParent_Done,
     /* 142110 */   // Label 2818: @142110
     /* 142110 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(142143), // Rule ID 12839 //
     /* 142115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142134 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 142137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142141 */     GIR_RootConstrainSelectedInstOperands,
     /* 142142 */     // GIR_Coverage, 12839,
     /* 142142 */     GIR_EraseRootFromParent_Done,
     /* 142143 */   // Label 2819: @142143
     /* 142143 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(142176), // Rule ID 12841 //
     /* 142148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142167 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 142170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142174 */     GIR_RootConstrainSelectedInstOperands,
     /* 142175 */     // GIR_Coverage, 12841,
     /* 142175 */     GIR_EraseRootFromParent_Done,
     /* 142176 */   // Label 2820: @142176
     /* 142176 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(142209), // Rule ID 12843 //
     /* 142181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142200 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 142203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142207 */     GIR_RootConstrainSelectedInstOperands,
     /* 142208 */     // GIR_Coverage, 12843,
     /* 142208 */     GIR_EraseRootFromParent_Done,
     /* 142209 */   // Label 2821: @142209
     /* 142209 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(142324), // Rule ID 12844 //
     /* 142214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142233 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142233 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142236 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 142240 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142245 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142280 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 142286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142306 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142323 */     // GIR_Coverage, 12844,
     /* 142323 */     GIR_EraseRootFromParent_Done,
     /* 142324 */   // Label 2822: @142324
     /* 142324 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(142357), // Rule ID 12846 //
     /* 142329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142348 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 142351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142355 */     GIR_RootConstrainSelectedInstOperands,
     /* 142356 */     // GIR_Coverage, 12846,
     /* 142356 */     GIR_EraseRootFromParent_Done,
     /* 142357 */   // Label 2823: @142357
     /* 142357 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(142390), // Rule ID 12848 //
     /* 142362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142381 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 142384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142388 */     GIR_RootConstrainSelectedInstOperands,
     /* 142389 */     // GIR_Coverage, 12848,
     /* 142389 */     GIR_EraseRootFromParent_Done,
     /* 142390 */   // Label 2824: @142390
     /* 142390 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(142423), // Rule ID 12850 //
     /* 142395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142414 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 142417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142421 */     GIR_RootConstrainSelectedInstOperands,
     /* 142422 */     // GIR_Coverage, 12850,
     /* 142422 */     GIR_EraseRootFromParent_Done,
     /* 142423 */   // Label 2825: @142423
     /* 142423 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(142456), // Rule ID 12852 //
     /* 142428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142447 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 142450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142454 */     GIR_RootConstrainSelectedInstOperands,
     /* 142455 */     // GIR_Coverage, 12852,
     /* 142455 */     GIR_EraseRootFromParent_Done,
     /* 142456 */   // Label 2826: @142456
     /* 142456 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(142571), // Rule ID 12853 //
     /* 142461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142480 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 142487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142492 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142524 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 142533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142570 */     // GIR_Coverage, 12853,
     /* 142570 */     GIR_EraseRootFromParent_Done,
     /* 142571 */   // Label 2827: @142571
     /* 142571 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(142690), // Rule ID 12854 //
     /* 142576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142595 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142595 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142598 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 142602 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142607 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142611 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142649 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 142652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142672 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142689 */     // GIR_Coverage, 12854,
     /* 142689 */     GIR_EraseRootFromParent_Done,
     /* 142690 */   // Label 2828: @142690
     /* 142690 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(142805), // Rule ID 12855 //
     /* 142695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142714 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 142714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 142721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142726 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 142735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 142749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142758 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142761 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142764 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 142767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 142794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142804 */     // GIR_Coverage, 12855,
     /* 142804 */     GIR_EraseRootFromParent_Done,
     /* 142805 */   // Label 2829: @142805
     /* 142805 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(142924), // Rule ID 12856 //
     /* 142810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142829 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 142836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142841 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142845 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142877 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142883 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 142886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142906 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142923 */     // GIR_Coverage, 12856,
     /* 142923 */     GIR_EraseRootFromParent_Done,
     /* 142924 */   // Label 2830: @142924
     /* 142924 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(143039), // Rule ID 12857 //
     /* 142929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142948 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 142948 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142951 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 142955 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142960 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 142969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 142983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142992 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142995 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 143028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143038 */     // GIR_Coverage, 12857,
     /* 143038 */     GIR_EraseRootFromParent_Done,
     /* 143039 */   // Label 2831: @143039
     /* 143039 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(143072), // Rule ID 12859 //
     /* 143044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143063 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 143066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143070 */     GIR_RootConstrainSelectedInstOperands,
     /* 143071 */     // GIR_Coverage, 12859,
     /* 143071 */     GIR_EraseRootFromParent_Done,
     /* 143072 */   // Label 2832: @143072
     /* 143072 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(143105), // Rule ID 12861 //
     /* 143077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143096 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 143099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143103 */     GIR_RootConstrainSelectedInstOperands,
     /* 143104 */     // GIR_Coverage, 12861,
     /* 143104 */     GIR_EraseRootFromParent_Done,
     /* 143105 */   // Label 2833: @143105
     /* 143105 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(143138), // Rule ID 12863 //
     /* 143110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143129 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 143132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143136 */     GIR_RootConstrainSelectedInstOperands,
     /* 143137 */     // GIR_Coverage, 12863,
     /* 143137 */     GIR_EraseRootFromParent_Done,
     /* 143138 */   // Label 2834: @143138
     /* 143138 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(143171), // Rule ID 12865 //
     /* 143143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143162 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 143165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143169 */     GIR_RootConstrainSelectedInstOperands,
     /* 143170 */     // GIR_Coverage, 12865,
     /* 143170 */     GIR_EraseRootFromParent_Done,
     /* 143171 */   // Label 2835: @143171
     /* 143171 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(143286), // Rule ID 12866 //
     /* 143176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143195 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143195 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143198 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 143202 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143207 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143239 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143245 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143268 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143285 */     // GIR_Coverage, 12866,
     /* 143285 */     GIR_EraseRootFromParent_Done,
     /* 143286 */   // Label 2836: @143286
     /* 143286 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(143405), // Rule ID 12867 //
     /* 143291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143310 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 143317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143322 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143326 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143358 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143364 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143387 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143404 */     // GIR_Coverage, 12867,
     /* 143404 */     GIR_EraseRootFromParent_Done,
     /* 143405 */   // Label 2837: @143405
     /* 143405 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(143438), // Rule ID 12869 //
     /* 143410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143429 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 143432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143436 */     GIR_RootConstrainSelectedInstOperands,
     /* 143437 */     // GIR_Coverage, 12869,
     /* 143437 */     GIR_EraseRootFromParent_Done,
     /* 143438 */   // Label 2838: @143438
     /* 143438 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(143471), // Rule ID 12871 //
     /* 143443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143462 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 143465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143469 */     GIR_RootConstrainSelectedInstOperands,
     /* 143470 */     // GIR_Coverage, 12871,
     /* 143470 */     GIR_EraseRootFromParent_Done,
     /* 143471 */   // Label 2839: @143471
     /* 143471 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(143504), // Rule ID 12873 //
     /* 143476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143495 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 143498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143502 */     GIR_RootConstrainSelectedInstOperands,
     /* 143503 */     // GIR_Coverage, 12873,
     /* 143503 */     GIR_EraseRootFromParent_Done,
     /* 143504 */   // Label 2840: @143504
     /* 143504 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(143537), // Rule ID 12875 //
     /* 143509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143528 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 143531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143535 */     GIR_RootConstrainSelectedInstOperands,
     /* 143536 */     // GIR_Coverage, 12875,
     /* 143536 */     GIR_EraseRootFromParent_Done,
     /* 143537 */   // Label 2841: @143537
     /* 143537 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(143652), // Rule ID 12876 //
     /* 143542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143561 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 143568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143573 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143634 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143651 */     // GIR_Coverage, 12876,
     /* 143651 */     GIR_EraseRootFromParent_Done,
     /* 143652 */   // Label 2842: @143652
     /* 143652 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(143771), // Rule ID 12877 //
     /* 143657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143676 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 143683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143688 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143692 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143730 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143770 */     // GIR_Coverage, 12877,
     /* 143770 */     GIR_EraseRootFromParent_Done,
     /* 143771 */   // Label 2843: @143771
     /* 143771 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(143804), // Rule ID 12879 //
     /* 143776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143795 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 143798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143802 */     GIR_RootConstrainSelectedInstOperands,
     /* 143803 */     // GIR_Coverage, 12879,
     /* 143803 */     GIR_EraseRootFromParent_Done,
     /* 143804 */   // Label 2844: @143804
     /* 143804 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(143837), // Rule ID 12881 //
     /* 143809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143828 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 143831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143835 */     GIR_RootConstrainSelectedInstOperands,
     /* 143836 */     // GIR_Coverage, 12881,
     /* 143836 */     GIR_EraseRootFromParent_Done,
     /* 143837 */   // Label 2845: @143837
     /* 143837 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(143870), // Rule ID 12883 //
     /* 143842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143861 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 143864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143868 */     GIR_RootConstrainSelectedInstOperands,
     /* 143869 */     // GIR_Coverage, 12883,
     /* 143869 */     GIR_EraseRootFromParent_Done,
     /* 143870 */   // Label 2846: @143870
     /* 143870 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(143903), // Rule ID 12885 //
     /* 143875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143894 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 143897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143901 */     GIR_RootConstrainSelectedInstOperands,
     /* 143902 */     // GIR_Coverage, 12885,
     /* 143902 */     GIR_EraseRootFromParent_Done,
     /* 143903 */   // Label 2847: @143903
     /* 143903 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(144018), // Rule ID 12886 //
     /* 143908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143927 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 143934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143939 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143945 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143948 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143952 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143971 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144000 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144017 */     // GIR_Coverage, 12886,
     /* 144017 */     GIR_EraseRootFromParent_Done,
     /* 144018 */   // Label 2848: @144018
     /* 144018 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(144137), // Rule ID 12887 //
     /* 144023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144042 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 144049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144054 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144058 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144119 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144136 */     // GIR_Coverage, 12887,
     /* 144136 */     GIR_EraseRootFromParent_Done,
     /* 144137 */   // Label 2849: @144137
     /* 144137 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(144170), // Rule ID 12889 //
     /* 144142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144161 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 144164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144168 */     GIR_RootConstrainSelectedInstOperands,
     /* 144169 */     // GIR_Coverage, 12889,
     /* 144169 */     GIR_EraseRootFromParent_Done,
     /* 144170 */   // Label 2850: @144170
     /* 144170 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(144203), // Rule ID 12891 //
     /* 144175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144194 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 144197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144201 */     GIR_RootConstrainSelectedInstOperands,
     /* 144202 */     // GIR_Coverage, 12891,
     /* 144202 */     GIR_EraseRootFromParent_Done,
     /* 144203 */   // Label 2851: @144203
     /* 144203 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(144236), // Rule ID 12893 //
     /* 144208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144227 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 144230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144234 */     GIR_RootConstrainSelectedInstOperands,
     /* 144235 */     // GIR_Coverage, 12893,
     /* 144235 */     GIR_EraseRootFromParent_Done,
     /* 144236 */   // Label 2852: @144236
     /* 144236 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(144269), // Rule ID 12895 //
     /* 144241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144260 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 144263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144267 */     GIR_RootConstrainSelectedInstOperands,
     /* 144268 */     // GIR_Coverage, 12895,
     /* 144268 */     GIR_EraseRootFromParent_Done,
     /* 144269 */   // Label 2853: @144269
     /* 144269 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(144384), // Rule ID 12896 //
     /* 144274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144293 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144293 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144296 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 144300 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144305 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144337 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144340 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 144346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144366 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144383 */     // GIR_Coverage, 12896,
     /* 144383 */     GIR_EraseRootFromParent_Done,
     /* 144384 */   // Label 2854: @144384
     /* 144384 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(144503), // Rule ID 12897 //
     /* 144389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144408 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144408 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144411 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 144415 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144420 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144424 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144485 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144502 */     // GIR_Coverage, 12897,
     /* 144502 */     GIR_EraseRootFromParent_Done,
     /* 144503 */   // Label 2855: @144503
     /* 144503 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(144535), // Rule ID 2384 //
     /* 144508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 144516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1575:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 144529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144533 */     GIR_RootConstrainSelectedInstOperands,
     /* 144534 */     // GIR_Coverage, 2384,
     /* 144534 */     GIR_EraseRootFromParent_Done,
     /* 144535 */   // Label 2856: @144535
     /* 144535 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(144567), // Rule ID 2385 //
     /* 144540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 144548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144558 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 144561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144565 */     GIR_RootConstrainSelectedInstOperands,
     /* 144566 */     // GIR_Coverage, 2385,
     /* 144566 */     GIR_EraseRootFromParent_Done,
     /* 144567 */   // Label 2857: @144567
     /* 144567 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(144599), // Rule ID 2386 //
     /* 144572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 144580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1577:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 144593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144597 */     GIR_RootConstrainSelectedInstOperands,
     /* 144598 */     // GIR_Coverage, 2386,
     /* 144598 */     GIR_EraseRootFromParent_Done,
     /* 144599 */   // Label 2858: @144599
     /* 144599 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(144631), // Rule ID 3079 //
     /* 144604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 144607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 144612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 144615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 144618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 144622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 144625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144629 */     GIR_RootConstrainSelectedInstOperands,
     /* 144630 */     // GIR_Coverage, 3079,
     /* 144630 */     GIR_EraseRootFromParent_Done,
     /* 144631 */   // Label 2859: @144631
     /* 144631 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(144663), // Rule ID 3080 //
     /* 144636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 144639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 144644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 144647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 144650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 144654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 144657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144661 */     GIR_RootConstrainSelectedInstOperands,
     /* 144662 */     // GIR_Coverage, 3080,
     /* 144662 */     GIR_EraseRootFromParent_Done,
     /* 144663 */   // Label 2860: @144663
     /* 144663 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(144695), // Rule ID 3081 //
     /* 144668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 144671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 144676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 144679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 144682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 144686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 144689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144693 */     GIR_RootConstrainSelectedInstOperands,
     /* 144694 */     // GIR_Coverage, 3081,
     /* 144694 */     GIR_EraseRootFromParent_Done,
     /* 144695 */   // Label 2861: @144695
     /* 144695 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(144727), // Rule ID 3329 //
     /* 144700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 144708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 144711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1567:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 144718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 144721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144725 */     GIR_RootConstrainSelectedInstOperands,
     /* 144726 */     // GIR_Coverage, 3329,
     /* 144726 */     GIR_EraseRootFromParent_Done,
     /* 144727 */   // Label 2862: @144727
     /* 144727 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(144759), // Rule ID 3330 //
     /* 144732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 144740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 144743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 144746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1567:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 144750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 144753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144757 */     GIR_RootConstrainSelectedInstOperands,
     /* 144758 */     // GIR_Coverage, 3330,
     /* 144758 */     GIR_EraseRootFromParent_Done,
     /* 144759 */   // Label 2863: @144759
     /* 144759 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(144791), // Rule ID 3331 //
     /* 144764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 144772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 144775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 144778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1567:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 144782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 144785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144789 */     GIR_RootConstrainSelectedInstOperands,
     /* 144790 */     // GIR_Coverage, 3331,
     /* 144790 */     GIR_EraseRootFromParent_Done,
     /* 144791 */   // Label 2864: @144791
     /* 144791 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(144823), // Rule ID 3410 //
     /* 144796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 144799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 144804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 144807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 144810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144814 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1328:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 144814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 144817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144821 */     GIR_RootConstrainSelectedInstOperands,
     /* 144822 */     // GIR_Coverage, 3410,
     /* 144822 */     GIR_EraseRootFromParent_Done,
     /* 144823 */   // Label 2865: @144823
     /* 144823 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(144855), // Rule ID 3411 //
     /* 144828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 144831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 144836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 144839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 144842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144846 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1328:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 144846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 144849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144853 */     GIR_RootConstrainSelectedInstOperands,
     /* 144854 */     // GIR_Coverage, 3411,
     /* 144854 */     GIR_EraseRootFromParent_Done,
     /* 144855 */   // Label 2866: @144855
     /* 144855 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(144887), // Rule ID 3412 //
     /* 144860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 144863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 144868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 144871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 144874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144878 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1328:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 144878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 144881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144885 */     GIR_RootConstrainSelectedInstOperands,
     /* 144886 */     // GIR_Coverage, 3412,
     /* 144886 */     GIR_EraseRootFromParent_Done,
     /* 144887 */   // Label 2867: @144887
     /* 144887 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(144919), // Rule ID 3438 //
     /* 144892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 144895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 144900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 144903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 144906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144910 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1167:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 144910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 144913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 144915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144917 */     GIR_RootConstrainSelectedInstOperands,
     /* 144918 */     // GIR_Coverage, 3438,
     /* 144918 */     GIR_EraseRootFromParent_Done,
     /* 144919 */   // Label 2868: @144919
     /* 144919 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(144951), // Rule ID 4565 //
     /* 144924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 144927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 144932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 144938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144942 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 144942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 144945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144949 */     GIR_RootConstrainSelectedInstOperands,
     /* 144950 */     // GIR_Coverage, 4565,
     /* 144950 */     GIR_EraseRootFromParent_Done,
     /* 144951 */   // Label 2869: @144951
     /* 144951 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(144983), // Rule ID 4566 //
     /* 144956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 144959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 144964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 144970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144974 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 144974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 144977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144981 */     GIR_RootConstrainSelectedInstOperands,
     /* 144982 */     // GIR_Coverage, 4566,
     /* 144982 */     GIR_EraseRootFromParent_Done,
     /* 144983 */   // Label 2870: @144983
     /* 144983 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(145012), // Rule ID 4567 //
     /* 144988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 144993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145003 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 145003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 145006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145010 */     GIR_RootConstrainSelectedInstOperands,
     /* 145011 */     // GIR_Coverage, 4567,
     /* 145011 */     GIR_EraseRootFromParent_Done,
     /* 145012 */   // Label 2871: @145012
     /* 145012 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(145041), // Rule ID 4568 //
     /* 145017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145032 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 145032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 145035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145039 */     GIR_RootConstrainSelectedInstOperands,
     /* 145040 */     // GIR_Coverage, 4568,
     /* 145040 */     GIR_EraseRootFromParent_Done,
     /* 145041 */   // Label 2872: @145041
     /* 145041 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(145070), // Rule ID 4569 //
     /* 145046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145061 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 145061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 145064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145068 */     GIR_RootConstrainSelectedInstOperands,
     /* 145069 */     // GIR_Coverage, 4569,
     /* 145069 */     GIR_EraseRootFromParent_Done,
     /* 145070 */   // Label 2873: @145070
     /* 145070 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(145099), // Rule ID 4570 //
     /* 145075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145090 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 145090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 145093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145097 */     GIR_RootConstrainSelectedInstOperands,
     /* 145098 */     // GIR_Coverage, 4570,
     /* 145098 */     GIR_EraseRootFromParent_Done,
     /* 145099 */   // Label 2874: @145099
     /* 145099 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(145131), // Rule ID 4577 //
     /* 145104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145122 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 145122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 145125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145129 */     GIR_RootConstrainSelectedInstOperands,
     /* 145130 */     // GIR_Coverage, 4577,
     /* 145130 */     GIR_EraseRootFromParent_Done,
     /* 145131 */   // Label 2875: @145131
     /* 145131 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(145163), // Rule ID 4578 //
     /* 145136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145154 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 145154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 145157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145161 */     GIR_RootConstrainSelectedInstOperands,
     /* 145162 */     // GIR_Coverage, 4578,
     /* 145162 */     GIR_EraseRootFromParent_Done,
     /* 145163 */   // Label 2876: @145163
     /* 145163 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(145192), // Rule ID 4579 //
     /* 145168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145183 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 145183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 145186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145190 */     GIR_RootConstrainSelectedInstOperands,
     /* 145191 */     // GIR_Coverage, 4579,
     /* 145191 */     GIR_EraseRootFromParent_Done,
     /* 145192 */   // Label 2877: @145192
     /* 145192 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(145221), // Rule ID 4580 //
     /* 145197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145212 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 145212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 145215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145219 */     GIR_RootConstrainSelectedInstOperands,
     /* 145220 */     // GIR_Coverage, 4580,
     /* 145220 */     GIR_EraseRootFromParent_Done,
     /* 145221 */   // Label 2878: @145221
     /* 145221 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(145250), // Rule ID 4581 //
     /* 145226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145241 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 145241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 145244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145248 */     GIR_RootConstrainSelectedInstOperands,
     /* 145249 */     // GIR_Coverage, 4581,
     /* 145249 */     GIR_EraseRootFromParent_Done,
     /* 145250 */   // Label 2879: @145250
     /* 145250 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(145279), // Rule ID 4582 //
     /* 145255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145270 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 145270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 145273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145277 */     GIR_RootConstrainSelectedInstOperands,
     /* 145278 */     // GIR_Coverage, 4582,
     /* 145278 */     GIR_EraseRootFromParent_Done,
     /* 145279 */   // Label 2880: @145279
     /* 145279 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(145308), // Rule ID 4877 //
     /* 145284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145299 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 145299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 145302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145306 */     GIR_RootConstrainSelectedInstOperands,
     /* 145307 */     // GIR_Coverage, 4877,
     /* 145307 */     GIR_EraseRootFromParent_Done,
     /* 145308 */   // Label 2881: @145308
     /* 145308 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(145337), // Rule ID 4878 //
     /* 145313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145328 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 145328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 145331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145335 */     GIR_RootConstrainSelectedInstOperands,
     /* 145336 */     // GIR_Coverage, 4878,
     /* 145336 */     GIR_EraseRootFromParent_Done,
     /* 145337 */   // Label 2882: @145337
     /* 145337 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(145366), // Rule ID 4879 //
     /* 145342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145357 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 145357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 145360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145364 */     GIR_RootConstrainSelectedInstOperands,
     /* 145365 */     // GIR_Coverage, 4879,
     /* 145365 */     GIR_EraseRootFromParent_Done,
     /* 145366 */   // Label 2883: @145366
     /* 145366 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(145395), // Rule ID 4880 //
     /* 145371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145386 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 145386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 145389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145393 */     GIR_RootConstrainSelectedInstOperands,
     /* 145394 */     // GIR_Coverage, 4880,
     /* 145394 */     GIR_EraseRootFromParent_Done,
     /* 145395 */   // Label 2884: @145395
     /* 145395 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(145424), // Rule ID 4881 //
     /* 145400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145415 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 145415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 145418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145422 */     GIR_RootConstrainSelectedInstOperands,
     /* 145423 */     // GIR_Coverage, 4881,
     /* 145423 */     GIR_EraseRootFromParent_Done,
     /* 145424 */   // Label 2885: @145424
     /* 145424 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(145453), // Rule ID 4882 //
     /* 145429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145444 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 145444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 145447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145451 */     GIR_RootConstrainSelectedInstOperands,
     /* 145452 */     // GIR_Coverage, 4882,
     /* 145452 */     GIR_EraseRootFromParent_Done,
     /* 145453 */   // Label 2886: @145453
     /* 145453 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(145482), // Rule ID 4883 //
     /* 145458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145473 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 145473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 145476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145480 */     GIR_RootConstrainSelectedInstOperands,
     /* 145481 */     // GIR_Coverage, 4883,
     /* 145481 */     GIR_EraseRootFromParent_Done,
     /* 145482 */   // Label 2887: @145482
     /* 145482 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(145511), // Rule ID 4884 //
     /* 145487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145502 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 145502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 145505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145509 */     GIR_RootConstrainSelectedInstOperands,
     /* 145510 */     // GIR_Coverage, 4884,
     /* 145510 */     GIR_EraseRootFromParent_Done,
     /* 145511 */   // Label 2888: @145511
     /* 145511 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(145540), // Rule ID 4885 //
     /* 145516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145531 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 145531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 145534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145538 */     GIR_RootConstrainSelectedInstOperands,
     /* 145539 */     // GIR_Coverage, 4885,
     /* 145539 */     GIR_EraseRootFromParent_Done,
     /* 145540 */   // Label 2889: @145540
     /* 145540 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(145569), // Rule ID 4886 //
     /* 145545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145560 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 145560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 145563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145567 */     GIR_RootConstrainSelectedInstOperands,
     /* 145568 */     // GIR_Coverage, 4886,
     /* 145568 */     GIR_EraseRootFromParent_Done,
     /* 145569 */   // Label 2890: @145569
     /* 145569 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(145601), // Rule ID 8245 //
     /* 145574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 145582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 145585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 145588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1566:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 145592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 145595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145599 */     GIR_RootConstrainSelectedInstOperands,
     /* 145600 */     // GIR_Coverage, 8245,
     /* 145600 */     GIR_EraseRootFromParent_Done,
     /* 145601 */   // Label 2891: @145601
     /* 145601 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(145633), // Rule ID 8246 //
     /* 145606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 145614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 145617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 145620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145624 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1566:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 145624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 145627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145631 */     GIR_RootConstrainSelectedInstOperands,
     /* 145632 */     // GIR_Coverage, 8246,
     /* 145632 */     GIR_EraseRootFromParent_Done,
     /* 145633 */   // Label 2892: @145633
     /* 145633 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(145665), // Rule ID 8247 //
     /* 145638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 145646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 145649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 145652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1566:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 145656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 145659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145663 */     GIR_RootConstrainSelectedInstOperands,
     /* 145664 */     // GIR_Coverage, 8247,
     /* 145664 */     GIR_EraseRootFromParent_Done,
     /* 145665 */   // Label 2893: @145665
     /* 145665 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(145697), // Rule ID 11608 //
     /* 145670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 145678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 145688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 145691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145695 */     GIR_RootConstrainSelectedInstOperands,
     /* 145696 */     // GIR_Coverage, 11608,
     /* 145696 */     GIR_EraseRootFromParent_Done,
     /* 145697 */   // Label 2894: @145697
     /* 145697 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(145729), // Rule ID 11609 //
     /* 145702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 145710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 145720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 145723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145727 */     GIR_RootConstrainSelectedInstOperands,
     /* 145728 */     // GIR_Coverage, 11609,
     /* 145728 */     GIR_EraseRootFromParent_Done,
     /* 145729 */   // Label 2895: @145729
     /* 145729 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(145761), // Rule ID 11610 //
     /* 145734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 145742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 145752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 145755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145759 */     GIR_RootConstrainSelectedInstOperands,
     /* 145760 */     // GIR_Coverage, 11610,
     /* 145760 */     GIR_EraseRootFromParent_Done,
     /* 145761 */   // Label 2896: @145761
     /* 145761 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(145793), // Rule ID 11611 //
     /* 145766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 145774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 145784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 145787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145791 */     GIR_RootConstrainSelectedInstOperands,
     /* 145792 */     // GIR_Coverage, 11611,
     /* 145792 */     GIR_EraseRootFromParent_Done,
     /* 145793 */   // Label 2897: @145793
     /* 145793 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(145825), // Rule ID 11612 //
     /* 145798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 145806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 145816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 145819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145823 */     GIR_RootConstrainSelectedInstOperands,
     /* 145824 */     // GIR_Coverage, 11612,
     /* 145824 */     GIR_EraseRootFromParent_Done,
     /* 145825 */   // Label 2898: @145825
     /* 145825 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(145857), // Rule ID 11613 //
     /* 145830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 145838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 145848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 145851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145855 */     GIR_RootConstrainSelectedInstOperands,
     /* 145856 */     // GIR_Coverage, 11613,
     /* 145856 */     GIR_EraseRootFromParent_Done,
     /* 145857 */   // Label 2899: @145857
     /* 145857 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(145889), // Rule ID 11768 //
     /* 145862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 145865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 145870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 145876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145880 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 145880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 145883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 145885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145887 */     GIR_RootConstrainSelectedInstOperands,
     /* 145888 */     // GIR_Coverage, 11768,
     /* 145888 */     GIR_EraseRootFromParent_Done,
     /* 145889 */   // Label 2900: @145889
     /* 145889 */   GIM_Reject,
     /* 145890 */ // Label 2581: @145890
     /* 145890 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(192201),
     /* 145895 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 145898 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(146082), // Rule ID 2559 //
     /* 145903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 145911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 145920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 145932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 145936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 145940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 145948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 145952 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 145955 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 145960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145964 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 145968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 145977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 145981 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145985 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 145989 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 145993 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145997 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 146001 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 146010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146014 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146018 */     // MIs[5] Operand 1
     /* 146018 */     // No operand predicates
     /* 146018 */     // MIs[3] Operand 2
     /* 146018 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 146029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 146033 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 146035 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 146035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 146038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 146053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 146066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 146077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 146080 */     GIR_RootConstrainSelectedInstOperands,
     /* 146081 */     // GIR_Coverage, 2559,
     /* 146081 */     GIR_EraseRootFromParent_Done,
     /* 146082 */   // Label 2902: @146082
     /* 146082 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(146266), // Rule ID 6167 //
     /* 146087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 146104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 146120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 146132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146136 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 146139 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146148 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 146161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 146173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146177 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146181 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 146185 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146190 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 146194 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146198 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146202 */     // MIs[5] Operand 1
     /* 146202 */     // No operand predicates
     /* 146202 */     // MIs[3] Operand 2
     /* 146202 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 146213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 146217 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 146219 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 146219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 146222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146231 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 146237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 146250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 146261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 146264 */     GIR_RootConstrainSelectedInstOperands,
     /* 146265 */     // GIR_Coverage, 6167,
     /* 146265 */     GIR_EraseRootFromParent_Done,
     /* 146266 */   // Label 2903: @146266
     /* 146266 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(146406), // Rule ID 2050 //
     /* 146271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146304 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146307 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146344 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146348 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146357 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146361 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146365 */     // MIs[4] Operand 1
     /* 146365 */     // No operand predicates
     /* 146365 */     // MIs[2] Operand 2
     /* 146365 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 146376 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 146385 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 146388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146404 */     GIR_RootConstrainSelectedInstOperands,
     /* 146405 */     // GIR_Coverage, 2050,
     /* 146405 */     GIR_EraseRootFromParent_Done,
     /* 146406 */   // Label 2904: @146406
     /* 146406 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(146546), // Rule ID 2057 //
     /* 146411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146480 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146484 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146488 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146493 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146497 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146501 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146505 */     // MIs[4] Operand 1
     /* 146505 */     // No operand predicates
     /* 146505 */     // MIs[2] Operand 2
     /* 146505 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 146516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 146525 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 146528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146544 */     GIR_RootConstrainSelectedInstOperands,
     /* 146545 */     // GIR_Coverage, 2057,
     /* 146545 */     GIR_EraseRootFromParent_Done,
     /* 146546 */   // Label 2905: @146546
     /* 146546 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(146686), // Rule ID 2053 //
     /* 146551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 146568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146584 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146587 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 146600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 146620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146624 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146628 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146633 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146637 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146641 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 146645 */     // MIs[4] Operand 1
     /* 146645 */     // No operand predicates
     /* 146645 */     // MIs[2] Operand 2
     /* 146645 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 146656 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 146665 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 146668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146684 */     GIR_RootConstrainSelectedInstOperands,
     /* 146685 */     // GIR_Coverage, 2053,
     /* 146685 */     GIR_EraseRootFromParent_Done,
     /* 146686 */   // Label 2906: @146686
     /* 146686 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(146826), // Rule ID 2060 //
     /* 146691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 146708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 146740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 146760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146781 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 146785 */     // MIs[4] Operand 1
     /* 146785 */     // No operand predicates
     /* 146785 */     // MIs[2] Operand 2
     /* 146785 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 146796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 146805 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 146808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146824 */     GIR_RootConstrainSelectedInstOperands,
     /* 146825 */     // GIR_Coverage, 2060,
     /* 146825 */     GIR_EraseRootFromParent_Done,
     /* 146826 */   // Label 2907: @146826
     /* 146826 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(146963), // Rule ID 2048 //
     /* 146831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146864 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146867 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146876 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146905 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146909 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146913 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146918 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146922 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146926 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146930 */     // MIs[4] Operand 1
     /* 146930 */     // No operand predicates
     /* 146930 */     // MIs[2] Operand 2
     /* 146930 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 146941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146943 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 146946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 146954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146961 */     GIR_RootConstrainSelectedInstOperands,
     /* 146962 */     // GIR_Coverage, 2048,
     /* 146962 */     GIR_EraseRootFromParent_Done,
     /* 146963 */   // Label 2908: @146963
     /* 146963 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147100), // Rule ID 2055 //
     /* 146968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147001 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147004 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147013 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147042 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147046 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147050 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147063 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147067 */     // MIs[4] Operand 1
     /* 147067 */     // No operand predicates
     /* 147067 */     // MIs[2] Operand 2
     /* 147067 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147078 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147080 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 147083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147098 */     GIR_RootConstrainSelectedInstOperands,
     /* 147099 */     // GIR_Coverage, 2055,
     /* 147099 */     GIR_EraseRootFromParent_Done,
     /* 147100 */   // Label 2909: @147100
     /* 147100 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147237), // Rule ID 2051 //
     /* 147105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147138 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147141 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147150 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147200 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147204 */     // MIs[4] Operand 1
     /* 147204 */     // No operand predicates
     /* 147204 */     // MIs[2] Operand 2
     /* 147204 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147215 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147217 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 147220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 2051,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 2910: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147374), // Rule ID 2058 //
     /* 147242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147333 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147337 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147341 */     // MIs[4] Operand 1
     /* 147341 */     // No operand predicates
     /* 147341 */     // MIs[2] Operand 2
     /* 147341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147354 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 147357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147372 */     GIR_RootConstrainSelectedInstOperands,
     /* 147373 */     // GIR_Coverage, 2058,
     /* 147373 */     GIR_EraseRootFromParent_Done,
     /* 147374 */   // Label 2911: @147374
     /* 147374 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147535), // Rule ID 2560 //
     /* 147379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 147396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 147412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147428 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 147431 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147440 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 147453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147461 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147465 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147478 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147482 */     // MIs[4] Operand 1
     /* 147482 */     // No operand predicates
     /* 147482 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 147486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147488 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 147488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 147491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 147506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 147519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147533 */     GIR_RootConstrainSelectedInstOperands,
     /* 147534 */     // GIR_Coverage, 2560,
     /* 147534 */     GIR_EraseRootFromParent_Done,
     /* 147535 */   // Label 2912: @147535
     /* 147535 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147696), // Rule ID 6168 //
     /* 147540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 147557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 147573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147589 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 147592 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147601 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 147614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147626 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147631 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147635 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147639 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147643 */     // MIs[4] Operand 1
     /* 147643 */     // No operand predicates
     /* 147643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 147647 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147649 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 147649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 147652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 147667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 147680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147694 */     GIR_RootConstrainSelectedInstOperands,
     /* 147695 */     // GIR_Coverage, 6168,
     /* 147695 */     GIR_EraseRootFromParent_Done,
     /* 147696 */   // Label 2913: @147696
     /* 147696 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147806), // Rule ID 2078 //
     /* 147701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 147750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 147759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147767 */     // MIs[3] Operand 1
     /* 147767 */     // No operand predicates
     /* 147767 */     // MIs[1] Operand 2
     /* 147767 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 147778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 147780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 147787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 147790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 147801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 147804 */     GIR_RootConstrainSelectedInstOperands,
     /* 147805 */     // GIR_Coverage, 2078,
     /* 147805 */     GIR_EraseRootFromParent_Done,
     /* 147806 */   // Label 2914: @147806
     /* 147806 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147916), // Rule ID 2081 //
     /* 147811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 147860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 147869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147873 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147877 */     // MIs[3] Operand 1
     /* 147877 */     // No operand predicates
     /* 147877 */     // MIs[1] Operand 2
     /* 147877 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 147888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 147890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 147897 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 147900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 147911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 147914 */     GIR_RootConstrainSelectedInstOperands,
     /* 147915 */     // GIR_Coverage, 2081,
     /* 147915 */     GIR_EraseRootFromParent_Done,
     /* 147916 */   // Label 2915: @147916
     /* 147916 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(148005), // Rule ID 1736 //
     /* 147921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 147938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147954 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147957 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147966 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 147979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 147986 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 147986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 147989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148003 */     GIR_RootConstrainSelectedInstOperands,
     /* 148004 */     // GIR_Coverage, 1736,
     /* 148004 */     GIR_EraseRootFromParent_Done,
     /* 148005 */   // Label 2916: @148005
     /* 148005 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(148094), // Rule ID 1738 //
     /* 148010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 148027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148075 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 148075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 148078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148092 */     GIR_RootConstrainSelectedInstOperands,
     /* 148093 */     // GIR_Coverage, 1738,
     /* 148093 */     GIR_EraseRootFromParent_Done,
     /* 148094 */   // Label 2917: @148094
     /* 148094 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(148183), // Rule ID 1740 //
     /* 148099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 148116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148132 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148135 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 148164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 148167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148181 */     GIR_RootConstrainSelectedInstOperands,
     /* 148182 */     // GIR_Coverage, 1740,
     /* 148182 */     GIR_EraseRootFromParent_Done,
     /* 148183 */   // Label 2918: @148183
     /* 148183 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(148272), // Rule ID 1742 //
     /* 148188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 148205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148221 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148224 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148233 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148253 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 148253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 148256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148270 */     GIR_RootConstrainSelectedInstOperands,
     /* 148271 */     // GIR_Coverage, 1742,
     /* 148271 */     GIR_EraseRootFromParent_Done,
     /* 148272 */   // Label 2919: @148272
     /* 148272 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(148394), // Rule ID 6827 //
     /* 148277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 148285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148312 */     // MIs[1] Operand 2
     /* 148312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148331 */     // MIs[2] Rn
     /* 148331 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148336 */     // MIs[2] Operand 2
     /* 148336 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 148347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148349 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 148349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 148356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148376 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148393 */     // GIR_Coverage, 6827,
     /* 148393 */     GIR_EraseRootFromParent_Done,
     /* 148394 */   // Label 2920: @148394
     /* 148394 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148516), // Rule ID 6829 //
     /* 148399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 148407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148434 */     // MIs[1] Operand 2
     /* 148434 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148453 */     // MIs[2] Rn
     /* 148453 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148458 */     // MIs[2] Operand 2
     /* 148458 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 148469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148471 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 148471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 148478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148498 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148515 */     // GIR_Coverage, 6829,
     /* 148515 */     GIR_EraseRootFromParent_Done,
     /* 148516 */   // Label 2921: @148516
     /* 148516 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148638), // Rule ID 6831 //
     /* 148521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 148529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 148535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 148551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148556 */     // MIs[1] Operand 2
     /* 148556 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148575 */     // MIs[2] Rn
     /* 148575 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148580 */     // MIs[2] Operand 2
     /* 148580 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 148591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148593 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 148593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 148600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148620 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148637 */     // GIR_Coverage, 6831,
     /* 148637 */     GIR_EraseRootFromParent_Done,
     /* 148638 */   // Label 2922: @148638
     /* 148638 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148760), // Rule ID 6833 //
     /* 148643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 148648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 148651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148678 */     // MIs[1] Operand 2
     /* 148678 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148697 */     // MIs[2] Rn
     /* 148697 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148702 */     // MIs[2] Operand 2
     /* 148702 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 148713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148715 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 148715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 148722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148759 */     // GIR_Coverage, 6833,
     /* 148759 */     GIR_EraseRootFromParent_Done,
     /* 148760 */   // Label 2923: @148760
     /* 148760 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148882), // Rule ID 6835 //
     /* 148765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 148770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 148773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148800 */     // MIs[1] Operand 2
     /* 148800 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148819 */     // MIs[2] Rn
     /* 148819 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148824 */     // MIs[2] Operand 2
     /* 148824 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 148835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 148837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 148844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148864 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148881 */     // GIR_Coverage, 6835,
     /* 148881 */     GIR_EraseRootFromParent_Done,
     /* 148882 */   // Label 2924: @148882
     /* 148882 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(149065), // Rule ID 2558 //
     /* 148887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 148904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 148920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148936 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 148939 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148948 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 148966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148968 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 148968 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 148971 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148975 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148994 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 148997 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 149001 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 149004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149031 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 149050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149063 */     GIR_RootConstrainSelectedInstOperands,
     /* 149064 */     // GIR_Coverage, 2558,
     /* 149064 */     GIR_EraseRootFromParent_Done,
     /* 149065 */   // Label 2925: @149065
     /* 149065 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(149248), // Rule ID 6166 //
     /* 149070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 149078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149119 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 149122 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149131 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149151 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 149151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 149154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149177 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 149180 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 149184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 149187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149214 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 149233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149246 */     GIR_RootConstrainSelectedInstOperands,
     /* 149247 */     // GIR_Coverage, 6166,
     /* 149247 */     GIR_EraseRootFromParent_Done,
     /* 149248 */   // Label 2926: @149248
     /* 149248 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(149352), // Rule ID 13148 //
     /* 149253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 149264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 149294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 149307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149315 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149319 */     // MIs[3] Operand 1
     /* 149319 */     // No operand predicates
     /* 149319 */     // MIs[1] Operand 2
     /* 149319 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149336 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 149339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 149343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149350 */     GIR_RootConstrainSelectedInstOperands,
     /* 149351 */     // GIR_Coverage, 13148,
     /* 149351 */     GIR_EraseRootFromParent_Done,
     /* 149352 */   // Label 2927: @149352
     /* 149352 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(149456), // Rule ID 13151 //
     /* 149357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 149368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149419 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149423 */     // MIs[3] Operand 1
     /* 149423 */     // No operand predicates
     /* 149423 */     // MIs[1] Operand 2
     /* 149423 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149440 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 149443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 149447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149454 */     GIR_RootConstrainSelectedInstOperands,
     /* 149455 */     // GIR_Coverage, 13151,
     /* 149455 */     GIR_EraseRootFromParent_Done,
     /* 149456 */   // Label 2928: @149456
     /* 149456 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(149587), // Rule ID 2515 //
     /* 149461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 149478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149536 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149540 */     // MIs[3] Operand 1
     /* 149540 */     // No operand predicates
     /* 149540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149542 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 149542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 149573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149585 */     GIR_RootConstrainSelectedInstOperands,
     /* 149586 */     // GIR_Coverage, 2515,
     /* 149586 */     GIR_EraseRootFromParent_Done,
     /* 149587 */   // Label 2929: @149587
     /* 149587 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(149718), // Rule ID 2516 //
     /* 149592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149634 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149667 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149671 */     // MIs[3] Operand 1
     /* 149671 */     // No operand predicates
     /* 149671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149673 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 149673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149685 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 149691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 149704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149716 */     GIR_RootConstrainSelectedInstOperands,
     /* 149717 */     // GIR_Coverage, 2516,
     /* 149717 */     GIR_EraseRootFromParent_Done,
     /* 149718 */   // Label 2930: @149718
     /* 149718 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(149849), // Rule ID 2517 //
     /* 149723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 149740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149765 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 149802 */     // MIs[3] Operand 1
     /* 149802 */     // No operand predicates
     /* 149802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149804 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 149804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 149822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 149835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149847 */     GIR_RootConstrainSelectedInstOperands,
     /* 149848 */     // GIR_Coverage, 2517,
     /* 149848 */     GIR_EraseRootFromParent_Done,
     /* 149849 */   // Label 2931: @149849
     /* 149849 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(149980), // Rule ID 13334 //
     /* 149854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 149871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 149900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149908 */     // MIs[2] Operand 1
     /* 149908 */     // No operand predicates
     /* 149908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 149912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149924 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149929 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 149933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149935 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 149935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 149966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 149975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 149978 */     GIR_RootConstrainSelectedInstOperands,
     /* 149979 */     // GIR_Coverage, 13334,
     /* 149979 */     GIR_EraseRootFromParent_Done,
     /* 149980 */   // Label 2932: @149980
     /* 149980 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(150111), // Rule ID 13335 //
     /* 149985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 150002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150039 */     // MIs[2] Operand 1
     /* 150039 */     // No operand predicates
     /* 150039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150060 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150066 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 150066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 150084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 150097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150109 */     GIR_RootConstrainSelectedInstOperands,
     /* 150110 */     // GIR_Coverage, 13335,
     /* 150110 */     GIR_EraseRootFromParent_Done,
     /* 150111 */   // Label 2933: @150111
     /* 150111 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(150242), // Rule ID 13336 //
     /* 150116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 150170 */     // MIs[2] Operand 1
     /* 150170 */     // No operand predicates
     /* 150170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150182 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150191 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150197 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 150197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150209 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 150215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 150228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150240 */     GIR_RootConstrainSelectedInstOperands,
     /* 150241 */     // GIR_Coverage, 13336,
     /* 150241 */     GIR_EraseRootFromParent_Done,
     /* 150242 */   // Label 2934: @150242
     /* 150242 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(150356), // Rule ID 2049 //
     /* 150247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150280 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150283 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150292 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150330 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150334 */     // MIs[3] Operand 1
     /* 150334 */     // No operand predicates
     /* 150334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150336 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 150339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150354 */     GIR_RootConstrainSelectedInstOperands,
     /* 150355 */     // GIR_Coverage, 2049,
     /* 150355 */     GIR_EraseRootFromParent_Done,
     /* 150356 */   // Label 2935: @150356
     /* 150356 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(150470), // Rule ID 2056 //
     /* 150361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150394 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150397 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150406 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150444 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150448 */     // MIs[3] Operand 1
     /* 150448 */     // No operand predicates
     /* 150448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150450 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 150453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150468 */     GIR_RootConstrainSelectedInstOperands,
     /* 150469 */     // GIR_Coverage, 2056,
     /* 150469 */     GIR_EraseRootFromParent_Done,
     /* 150470 */   // Label 2936: @150470
     /* 150470 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(150584), // Rule ID 2052 //
     /* 150475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150508 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150511 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 150537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150558 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150562 */     // MIs[3] Operand 1
     /* 150562 */     // No operand predicates
     /* 150562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150564 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 150567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150582 */     GIR_RootConstrainSelectedInstOperands,
     /* 150583 */     // GIR_Coverage, 2052,
     /* 150583 */     GIR_EraseRootFromParent_Done,
     /* 150584 */   // Label 2937: @150584
     /* 150584 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(150698), // Rule ID 2059 //
     /* 150589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150622 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150625 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150634 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 150651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150672 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150676 */     // MIs[3] Operand 1
     /* 150676 */     // No operand predicates
     /* 150676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150678 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 150681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150696 */     GIR_RootConstrainSelectedInstOperands,
     /* 150697 */     // GIR_Coverage, 2059,
     /* 150697 */     GIR_EraseRootFromParent_Done,
     /* 150698 */   // Label 2938: @150698
     /* 150698 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(150812), // Rule ID 2054 //
     /* 150703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150736 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150739 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 150744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150748 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150790 */     // MIs[3] Operand 1
     /* 150790 */     // No operand predicates
     /* 150790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150792 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 150795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150810 */     GIR_RootConstrainSelectedInstOperands,
     /* 150811 */     // GIR_Coverage, 2054,
     /* 150811 */     GIR_EraseRootFromParent_Done,
     /* 150812 */   // Label 2939: @150812
     /* 150812 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(150926), // Rule ID 2061 //
     /* 150817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150850 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150853 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 150858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150862 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150900 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150904 */     // MIs[3] Operand 1
     /* 150904 */     // No operand predicates
     /* 150904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150906 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 150909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150924 */     GIR_RootConstrainSelectedInstOperands,
     /* 150925 */     // GIR_Coverage, 2061,
     /* 150925 */     GIR_EraseRootFromParent_Done,
     /* 150926 */   // Label 2940: @150926
     /* 150926 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(151030), // Rule ID 1980 //
     /* 150931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 150934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 150942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 150972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151001 */     // MIs[3] Operand 1
     /* 151001 */     // No operand predicates
     /* 151001 */     // MIs[1] Operand 2
     /* 151001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151014 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 151017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151028 */     GIR_RootConstrainSelectedInstOperands,
     /* 151029 */     // GIR_Coverage, 1980,
     /* 151029 */     GIR_EraseRootFromParent_Done,
     /* 151030 */   // Label 2941: @151030
     /* 151030 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(151134), // Rule ID 2010 //
     /* 151035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 151043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151105 */     // MIs[3] Operand 1
     /* 151105 */     // No operand predicates
     /* 151105 */     // MIs[1] Operand 2
     /* 151105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151118 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 151121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151132 */     GIR_RootConstrainSelectedInstOperands,
     /* 151133 */     // GIR_Coverage, 2010,
     /* 151133 */     GIR_EraseRootFromParent_Done,
     /* 151134 */   // Label 2942: @151134
     /* 151134 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(151238), // Rule ID 2017 //
     /* 151139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 151147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151205 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151209 */     // MIs[3] Operand 1
     /* 151209 */     // No operand predicates
     /* 151209 */     // MIs[1] Operand 2
     /* 151209 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151222 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 151225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151236 */     GIR_RootConstrainSelectedInstOperands,
     /* 151237 */     // GIR_Coverage, 2017,
     /* 151237 */     GIR_EraseRootFromParent_Done,
     /* 151238 */   // Label 2943: @151238
     /* 151238 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(151342), // Rule ID 2076 //
     /* 151243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151313 */     // MIs[3] Operand 1
     /* 151313 */     // No operand predicates
     /* 151313 */     // MIs[1] Operand 2
     /* 151313 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151326 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 151329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151340 */     GIR_RootConstrainSelectedInstOperands,
     /* 151341 */     // GIR_Coverage, 2076,
     /* 151341 */     GIR_EraseRootFromParent_Done,
     /* 151342 */   // Label 2944: @151342
     /* 151342 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(151446), // Rule ID 1983 //
     /* 151347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151413 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151417 */     // MIs[3] Operand 1
     /* 151417 */     // No operand predicates
     /* 151417 */     // MIs[1] Operand 2
     /* 151417 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151430 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 151433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151444 */     GIR_RootConstrainSelectedInstOperands,
     /* 151445 */     // GIR_Coverage, 1983,
     /* 151445 */     GIR_EraseRootFromParent_Done,
     /* 151446 */   // Label 2945: @151446
     /* 151446 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(151550), // Rule ID 2013 //
     /* 151451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 151459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151517 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151521 */     // MIs[3] Operand 1
     /* 151521 */     // No operand predicates
     /* 151521 */     // MIs[1] Operand 2
     /* 151521 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151534 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 151537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151548 */     GIR_RootConstrainSelectedInstOperands,
     /* 151549 */     // GIR_Coverage, 2013,
     /* 151549 */     GIR_EraseRootFromParent_Done,
     /* 151550 */   // Label 2946: @151550
     /* 151550 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(151654), // Rule ID 2020 //
     /* 151555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 151563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151625 */     // MIs[3] Operand 1
     /* 151625 */     // No operand predicates
     /* 151625 */     // MIs[1] Operand 2
     /* 151625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151638 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 151641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151652 */     GIR_RootConstrainSelectedInstOperands,
     /* 151653 */     // GIR_Coverage, 2020,
     /* 151653 */     GIR_EraseRootFromParent_Done,
     /* 151654 */   // Label 2947: @151654
     /* 151654 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(151758), // Rule ID 2079 //
     /* 151659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151725 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151729 */     // MIs[3] Operand 1
     /* 151729 */     // No operand predicates
     /* 151729 */     // MIs[1] Operand 2
     /* 151729 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151742 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 151745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151756 */     GIR_RootConstrainSelectedInstOperands,
     /* 151757 */     // GIR_Coverage, 2079,
     /* 151757 */     GIR_EraseRootFromParent_Done,
     /* 151758 */   // Label 2948: @151758
     /* 151758 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(151815), // Rule ID 1744 //
     /* 151763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 151791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 151798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 151798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 151801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 151808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 151813 */     GIR_RootConstrainSelectedInstOperands,
     /* 151814 */     // GIR_Coverage, 1744,
     /* 151814 */     GIR_EraseRootFromParent_Done,
     /* 151815 */   // Label 2949: @151815
     /* 151815 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(151872), // Rule ID 1746 //
     /* 151820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 151848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 151855 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 151855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 151858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 151865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 151870 */     GIR_RootConstrainSelectedInstOperands,
     /* 151871 */     // GIR_Coverage, 1746,
     /* 151871 */     GIR_EraseRootFromParent_Done,
     /* 151872 */   // Label 2950: @151872
     /* 151872 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(151982), // Rule ID 6185 //
     /* 151877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 151882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 151903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 151907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151916 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 151927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 151931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151935 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 151939 */     // MIs[2] Operand 1
     /* 151939 */     // No operand predicates
     /* 151939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151941 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 151941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 151944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151953 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 151959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 151972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 151980 */     GIR_RootConstrainSelectedInstOperands,
     /* 151981 */     // GIR_Coverage, 6185,
     /* 151981 */     GIR_EraseRootFromParent_Done,
     /* 151982 */   // Label 2951: @151982
     /* 151982 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(152079), // Rule ID 13602 //
     /* 151987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 151990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152039 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 152039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152051 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 152057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 152070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152077 */     GIR_RootConstrainSelectedInstOperands,
     /* 152078 */     // GIR_Coverage, 13602,
     /* 152078 */     GIR_EraseRootFromParent_Done,
     /* 152079 */   // Label 2952: @152079
     /* 152079 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(152176), // Rule ID 13603 //
     /* 152084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152136 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 152136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152148 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 152154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 152167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152174 */     GIR_RootConstrainSelectedInstOperands,
     /* 152175 */     // GIR_Coverage, 13603,
     /* 152175 */     GIR_EraseRootFromParent_Done,
     /* 152176 */   // Label 2953: @152176
     /* 152176 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(152273), // Rule ID 13604 //
     /* 152181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152233 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 152233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152245 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 152251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 152264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152271 */     GIR_RootConstrainSelectedInstOperands,
     /* 152272 */     // GIR_Coverage, 13604,
     /* 152272 */     GIR_EraseRootFromParent_Done,
     /* 152273 */   // Label 2954: @152273
     /* 152273 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(152356), // Rule ID 1735 //
     /* 152278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152311 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152314 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152339 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 152339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 152342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152354 */     GIR_RootConstrainSelectedInstOperands,
     /* 152355 */     // GIR_Coverage, 1735,
     /* 152355 */     GIR_EraseRootFromParent_Done,
     /* 152356 */   // Label 2955: @152356
     /* 152356 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(152439), // Rule ID 1737 //
     /* 152361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152394 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152397 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152406 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152422 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 152422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 152425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152437 */     GIR_RootConstrainSelectedInstOperands,
     /* 152438 */     // GIR_Coverage, 1737,
     /* 152438 */     GIR_EraseRootFromParent_Done,
     /* 152439 */   // Label 2956: @152439
     /* 152439 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(152522), // Rule ID 1739 //
     /* 152444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152489 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152505 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 152505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 152508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152520 */     GIR_RootConstrainSelectedInstOperands,
     /* 152521 */     // GIR_Coverage, 1739,
     /* 152521 */     GIR_EraseRootFromParent_Done,
     /* 152522 */   // Label 2957: @152522
     /* 152522 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(152605), // Rule ID 1741 //
     /* 152527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152560 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152563 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152588 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 152588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 152591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152603 */     GIR_RootConstrainSelectedInstOperands,
     /* 152604 */     // GIR_Coverage, 1741,
     /* 152604 */     GIR_EraseRootFromParent_Done,
     /* 152605 */   // Label 2958: @152605
     /* 152605 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(152685), // Rule ID 5174 //
     /* 152610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152640 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152643 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 152648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 152652 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 152656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152668 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 152668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 152671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152683 */     GIR_RootConstrainSelectedInstOperands,
     /* 152684 */     // GIR_Coverage, 5174,
     /* 152684 */     GIR_EraseRootFromParent_Done,
     /* 152685 */   // Label 2959: @152685
     /* 152685 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(152765), // Rule ID 5175 //
     /* 152690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152720 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152723 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 152728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 152732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 152736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152748 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 152748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 152751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152763 */     GIR_RootConstrainSelectedInstOperands,
     /* 152764 */     // GIR_Coverage, 5175,
     /* 152764 */     GIR_EraseRootFromParent_Done,
     /* 152765 */   // Label 2960: @152765
     /* 152765 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(152862), // Rule ID 5171 //
     /* 152770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 152773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152816 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152822 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 152822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152834 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 152840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 152853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152860 */     GIR_RootConstrainSelectedInstOperands,
     /* 152861 */     // GIR_Coverage, 5171,
     /* 152861 */     GIR_EraseRootFromParent_Done,
     /* 152862 */   // Label 2961: @152862
     /* 152862 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(152959), // Rule ID 5172 //
     /* 152867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152919 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 152919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152931 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 152937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 152950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152957 */     GIR_RootConstrainSelectedInstOperands,
     /* 152958 */     // GIR_Coverage, 5172,
     /* 152958 */     GIR_EraseRootFromParent_Done,
     /* 152959 */   // Label 2962: @152959
     /* 152959 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(153056), // Rule ID 5173 //
     /* 152964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153016 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 153016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 153019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153028 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 153034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 153047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153054 */     GIR_RootConstrainSelectedInstOperands,
     /* 153055 */     // GIR_Coverage, 5173,
     /* 153055 */     GIR_EraseRootFromParent_Done,
     /* 153056 */   // Label 2963: @153056
     /* 153056 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(153137), // Rule ID 13149 //
     /* 153061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153111 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153115 */     // MIs[2] Operand 1
     /* 153115 */     // No operand predicates
     /* 153115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153121 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 153124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153135 */     GIR_RootConstrainSelectedInstOperands,
     /* 153136 */     // GIR_Coverage, 13149,
     /* 153136 */     GIR_EraseRootFromParent_Done,
     /* 153137 */   // Label 2964: @153137
     /* 153137 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(153218), // Rule ID 13150 //
     /* 153142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 153159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153196 */     // MIs[2] Operand 1
     /* 153196 */     // No operand predicates
     /* 153196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153202 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 153205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153216 */     GIR_RootConstrainSelectedInstOperands,
     /* 153217 */     // GIR_Coverage, 13150,
     /* 153217 */     GIR_EraseRootFromParent_Done,
     /* 153218 */   // Label 2965: @153218
     /* 153218 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(153299), // Rule ID 13152 //
     /* 153223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153277 */     // MIs[2] Operand 1
     /* 153277 */     // No operand predicates
     /* 153277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153283 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 153286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153297 */     GIR_RootConstrainSelectedInstOperands,
     /* 153298 */     // GIR_Coverage, 13152,
     /* 153298 */     GIR_EraseRootFromParent_Done,
     /* 153299 */   // Label 2966: @153299
     /* 153299 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(153380), // Rule ID 13153 //
     /* 153304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153358 */     // MIs[2] Operand 1
     /* 153358 */     // No operand predicates
     /* 153358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153364 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 153367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153378 */     GIR_RootConstrainSelectedInstOperands,
     /* 153379 */     // GIR_Coverage, 13153,
     /* 153379 */     GIR_EraseRootFromParent_Done,
     /* 153380 */   // Label 2967: @153380
     /* 153380 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(153461), // Rule ID 13154 //
     /* 153385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 153414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153435 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 153439 */     // MIs[2] Operand 1
     /* 153439 */     // No operand predicates
     /* 153439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153445 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 153448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153459 */     GIR_RootConstrainSelectedInstOperands,
     /* 153460 */     // GIR_Coverage, 13154,
     /* 153460 */     GIR_EraseRootFromParent_Done,
     /* 153461 */   // Label 2968: @153461
     /* 153461 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(153542), // Rule ID 13155 //
     /* 153466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 153477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 153483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153516 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153520 */     // MIs[2] Operand 1
     /* 153520 */     // No operand predicates
     /* 153520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153526 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 153529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153540 */     GIR_RootConstrainSelectedInstOperands,
     /* 153541 */     // GIR_Coverage, 13155,
     /* 153541 */     GIR_EraseRootFromParent_Done,
     /* 153542 */   // Label 2969: @153542
     /* 153542 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(153623), // Rule ID 13156 //
     /* 153547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153601 */     // MIs[2] Operand 1
     /* 153601 */     // No operand predicates
     /* 153601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153607 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 153610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153621 */     GIR_RootConstrainSelectedInstOperands,
     /* 153622 */     // GIR_Coverage, 13156,
     /* 153622 */     GIR_EraseRootFromParent_Done,
     /* 153623 */   // Label 2970: @153623
     /* 153623 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(153704), // Rule ID 13157 //
     /* 153628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153678 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 153682 */     // MIs[2] Operand 1
     /* 153682 */     // No operand predicates
     /* 153682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153688 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 153691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153702 */     GIR_RootConstrainSelectedInstOperands,
     /* 153703 */     // GIR_Coverage, 13157,
     /* 153703 */     GIR_EraseRootFromParent_Done,
     /* 153704 */   // Label 2971: @153704
     /* 153704 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(153810), // Rule ID 6182 //
     /* 153709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 153714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 153717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 153735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153744 */     // MIs[1] Operand 2
     /* 153744 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 153755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 153759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 153767 */     // MIs[2] Operand 1
     /* 153767 */     // No operand predicates
     /* 153767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153769 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 153769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153781 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 153800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 153808 */     GIR_RootConstrainSelectedInstOperands,
     /* 153809 */     // GIR_Coverage, 6182,
     /* 153809 */     GIR_EraseRootFromParent_Done,
     /* 153810 */   // Label 2972: @153810
     /* 153810 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(153891), // Rule ID 1981 //
     /* 153815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153869 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153873 */     // MIs[2] Operand 1
     /* 153873 */     // No operand predicates
     /* 153873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153875 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 153878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153889 */     GIR_RootConstrainSelectedInstOperands,
     /* 153890 */     // GIR_Coverage, 1981,
     /* 153890 */     GIR_EraseRootFromParent_Done,
     /* 153891 */   // Label 2973: @153891
     /* 153891 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(153972), // Rule ID 1982 //
     /* 153896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 153913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153954 */     // MIs[2] Operand 1
     /* 153954 */     // No operand predicates
     /* 153954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153956 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 153959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153970 */     GIR_RootConstrainSelectedInstOperands,
     /* 153971 */     // GIR_Coverage, 1982,
     /* 153971 */     GIR_EraseRootFromParent_Done,
     /* 153972 */   // Label 2974: @153972
     /* 153972 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(154053), // Rule ID 2011 //
     /* 153977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 153985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154035 */     // MIs[2] Operand 1
     /* 154035 */     // No operand predicates
     /* 154035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154037 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 154040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154051 */     GIR_RootConstrainSelectedInstOperands,
     /* 154052 */     // GIR_Coverage, 2011,
     /* 154052 */     GIR_EraseRootFromParent_Done,
     /* 154053 */   // Label 2975: @154053
     /* 154053 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(154134), // Rule ID 2012 //
     /* 154058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154116 */     // MIs[2] Operand 1
     /* 154116 */     // No operand predicates
     /* 154116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154118 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 154121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154132 */     GIR_RootConstrainSelectedInstOperands,
     /* 154133 */     // GIR_Coverage, 2012,
     /* 154133 */     GIR_EraseRootFromParent_Done,
     /* 154134 */   // Label 2976: @154134
     /* 154134 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(154215), // Rule ID 2018 //
     /* 154139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154197 */     // MIs[2] Operand 1
     /* 154197 */     // No operand predicates
     /* 154197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154199 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 154202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154213 */     GIR_RootConstrainSelectedInstOperands,
     /* 154214 */     // GIR_Coverage, 2018,
     /* 154214 */     GIR_EraseRootFromParent_Done,
     /* 154215 */   // Label 2977: @154215
     /* 154215 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(154296), // Rule ID 2019 //
     /* 154220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154274 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154278 */     // MIs[2] Operand 1
     /* 154278 */     // No operand predicates
     /* 154278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 154283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154294 */     GIR_RootConstrainSelectedInstOperands,
     /* 154295 */     // GIR_Coverage, 2019,
     /* 154295 */     GIR_EraseRootFromParent_Done,
     /* 154296 */   // Label 2978: @154296
     /* 154296 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(154377), // Rule ID 2077 //
     /* 154301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154359 */     // MIs[2] Operand 1
     /* 154359 */     // No operand predicates
     /* 154359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154361 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 154364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154375 */     GIR_RootConstrainSelectedInstOperands,
     /* 154376 */     // GIR_Coverage, 2077,
     /* 154376 */     GIR_EraseRootFromParent_Done,
     /* 154377 */   // Label 2979: @154377
     /* 154377 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(154458), // Rule ID 1984 //
     /* 154382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154440 */     // MIs[2] Operand 1
     /* 154440 */     // No operand predicates
     /* 154440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154442 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 154445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154456 */     GIR_RootConstrainSelectedInstOperands,
     /* 154457 */     // GIR_Coverage, 1984,
     /* 154457 */     GIR_EraseRootFromParent_Done,
     /* 154458 */   // Label 2980: @154458
     /* 154458 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(154539), // Rule ID 1985 //
     /* 154463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154517 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154521 */     // MIs[2] Operand 1
     /* 154521 */     // No operand predicates
     /* 154521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154523 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 154526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154537 */     GIR_RootConstrainSelectedInstOperands,
     /* 154538 */     // GIR_Coverage, 1985,
     /* 154538 */     GIR_EraseRootFromParent_Done,
     /* 154539 */   // Label 2981: @154539
     /* 154539 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(154620), // Rule ID 2014 //
     /* 154544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154602 */     // MIs[2] Operand 1
     /* 154602 */     // No operand predicates
     /* 154602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154604 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 154607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154618 */     GIR_RootConstrainSelectedInstOperands,
     /* 154619 */     // GIR_Coverage, 2014,
     /* 154619 */     GIR_EraseRootFromParent_Done,
     /* 154620 */   // Label 2982: @154620
     /* 154620 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(154701), // Rule ID 2015 //
     /* 154625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154683 */     // MIs[2] Operand 1
     /* 154683 */     // No operand predicates
     /* 154683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154685 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 154688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154699 */     GIR_RootConstrainSelectedInstOperands,
     /* 154700 */     // GIR_Coverage, 2015,
     /* 154700 */     GIR_EraseRootFromParent_Done,
     /* 154701 */   // Label 2983: @154701
     /* 154701 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(154782), // Rule ID 2021 //
     /* 154706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154760 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154764 */     // MIs[2] Operand 1
     /* 154764 */     // No operand predicates
     /* 154764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154766 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 154769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154780 */     GIR_RootConstrainSelectedInstOperands,
     /* 154781 */     // GIR_Coverage, 2021,
     /* 154781 */     GIR_EraseRootFromParent_Done,
     /* 154782 */   // Label 2984: @154782
     /* 154782 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(154863), // Rule ID 2022 //
     /* 154787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154845 */     // MIs[2] Operand 1
     /* 154845 */     // No operand predicates
     /* 154845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154847 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 154850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154861 */     GIR_RootConstrainSelectedInstOperands,
     /* 154862 */     // GIR_Coverage, 2022,
     /* 154862 */     GIR_EraseRootFromParent_Done,
     /* 154863 */   // Label 2985: @154863
     /* 154863 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(154944), // Rule ID 2080 //
     /* 154868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154926 */     // MIs[2] Operand 1
     /* 154926 */     // No operand predicates
     /* 154926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 154931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154942 */     GIR_RootConstrainSelectedInstOperands,
     /* 154943 */     // GIR_Coverage, 2080,
     /* 154943 */     GIR_EraseRootFromParent_Done,
     /* 154944 */   // Label 2986: @154944
     /* 154944 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(155025), // Rule ID 1986 //
     /* 154949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 154982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 154986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155003 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155007 */     // MIs[2] Operand 1
     /* 155007 */     // No operand predicates
     /* 155007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155009 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 155012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155023 */     GIR_RootConstrainSelectedInstOperands,
     /* 155024 */     // GIR_Coverage, 1986,
     /* 155024 */     GIR_EraseRootFromParent_Done,
     /* 155025 */   // Label 2987: @155025
     /* 155025 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(155106), // Rule ID 1987 //
     /* 155030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155088 */     // MIs[2] Operand 1
     /* 155088 */     // No operand predicates
     /* 155088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155090 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155104 */     GIR_RootConstrainSelectedInstOperands,
     /* 155105 */     // GIR_Coverage, 1987,
     /* 155105 */     GIR_EraseRootFromParent_Done,
     /* 155106 */   // Label 2988: @155106
     /* 155106 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(155187), // Rule ID 1988 //
     /* 155111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155165 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155169 */     // MIs[2] Operand 1
     /* 155169 */     // No operand predicates
     /* 155169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155171 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155185 */     GIR_RootConstrainSelectedInstOperands,
     /* 155186 */     // GIR_Coverage, 1988,
     /* 155186 */     GIR_EraseRootFromParent_Done,
     /* 155187 */   // Label 2989: @155187
     /* 155187 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(155268), // Rule ID 1989 //
     /* 155192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155250 */     // MIs[2] Operand 1
     /* 155250 */     // No operand predicates
     /* 155250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155252 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155266 */     GIR_RootConstrainSelectedInstOperands,
     /* 155267 */     // GIR_Coverage, 1989,
     /* 155267 */     GIR_EraseRootFromParent_Done,
     /* 155268 */   // Label 2990: @155268
     /* 155268 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(155349), // Rule ID 2016 //
     /* 155273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 155281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155331 */     // MIs[2] Operand 1
     /* 155331 */     // No operand predicates
     /* 155331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155333 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 155336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155347 */     GIR_RootConstrainSelectedInstOperands,
     /* 155348 */     // GIR_Coverage, 2016,
     /* 155348 */     GIR_EraseRootFromParent_Done,
     /* 155349 */   // Label 2991: @155349
     /* 155349 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(155430), // Rule ID 2023 //
     /* 155354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 155362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155412 */     // MIs[2] Operand 1
     /* 155412 */     // No operand predicates
     /* 155412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155414 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 155417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155428 */     GIR_RootConstrainSelectedInstOperands,
     /* 155429 */     // GIR_Coverage, 2023,
     /* 155429 */     GIR_EraseRootFromParent_Done,
     /* 155430 */   // Label 2992: @155430
     /* 155430 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(155508), // Rule ID 6169 //
     /* 155435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 155440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155490 */     // MIs[2] Operand 1
     /* 155490 */     // No operand predicates
     /* 155490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155492 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 155495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 155503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155506 */     GIR_RootConstrainSelectedInstOperands,
     /* 155507 */     // GIR_Coverage, 6169,
     /* 155507 */     GIR_EraseRootFromParent_Done,
     /* 155508 */   // Label 2993: @155508
     /* 155508 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(155568), // Rule ID 6243 //
     /* 155513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 155521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 155524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 155539 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 155539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 155542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 155559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 155563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155566 */     GIR_RootConstrainSelectedInstOperands,
     /* 155567 */     // GIR_Coverage, 6243,
     /* 155567 */     GIR_EraseRootFromParent_Done,
     /* 155568 */   // Label 2994: @155568
     /* 155568 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(155628), // Rule ID 6244 //
     /* 155573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 155599 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 155599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 155602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 155619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 155623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155626 */     GIR_RootConstrainSelectedInstOperands,
     /* 155627 */     // GIR_Coverage, 6244,
     /* 155627 */     GIR_EraseRootFromParent_Done,
     /* 155628 */   // Label 2995: @155628
     /* 155628 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(155688), // Rule ID 6245 //
     /* 155633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 155659 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 155659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 155662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 155679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 155683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155686 */     GIR_RootConstrainSelectedInstOperands,
     /* 155687 */     // GIR_Coverage, 6245,
     /* 155687 */     GIR_EraseRootFromParent_Done,
     /* 155688 */   // Label 2996: @155688
     /* 155688 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(155735), // Rule ID 3839 //
     /* 155693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155715 */     // MIs[0] Operand 3
     /* 155715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 155726 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 155729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155733 */     GIR_RootConstrainSelectedInstOperands,
     /* 155734 */     // GIR_Coverage, 3839,
     /* 155734 */     GIR_EraseRootFromParent_Done,
     /* 155735 */   // Label 2997: @155735
     /* 155735 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(155782), // Rule ID 3840 //
     /* 155740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155762 */     // MIs[0] Operand 3
     /* 155762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 155773 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 155776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155780 */     GIR_RootConstrainSelectedInstOperands,
     /* 155781 */     // GIR_Coverage, 3840,
     /* 155781 */     GIR_EraseRootFromParent_Done,
     /* 155782 */   // Label 2998: @155782
     /* 155782 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(155829), // Rule ID 3841 //
     /* 155787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155809 */     // MIs[0] Operand 3
     /* 155809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 155820 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 155823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155827 */     GIR_RootConstrainSelectedInstOperands,
     /* 155828 */     // GIR_Coverage, 3841,
     /* 155828 */     GIR_EraseRootFromParent_Done,
     /* 155829 */   // Label 2999: @155829
     /* 155829 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(155876), // Rule ID 3842 //
     /* 155834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155856 */     // MIs[0] Operand 3
     /* 155856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 155867 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 155870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155874 */     GIR_RootConstrainSelectedInstOperands,
     /* 155875 */     // GIR_Coverage, 3842,
     /* 155875 */     GIR_EraseRootFromParent_Done,
     /* 155876 */   // Label 3000: @155876
     /* 155876 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(155922), // Rule ID 3524 //
     /* 155881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 155884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 155889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 155892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 155895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 155899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 155903 */     // MIs[0] Idx
     /* 155903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 155906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 155911 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 155911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 155914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 155916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 155918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 155920 */     GIR_RootConstrainSelectedInstOperands,
     /* 155921 */     // GIR_Coverage, 3524,
     /* 155921 */     GIR_EraseRootFromParent_Done,
     /* 155922 */   // Label 3001: @155922
     /* 155922 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(155968), // Rule ID 3525 //
     /* 155927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 155930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 155935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 155938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 155941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 155945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 155949 */     // MIs[0] Idx
     /* 155949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 155952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 155957 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 155957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 155960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 155962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 155964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 155966 */     GIR_RootConstrainSelectedInstOperands,
     /* 155967 */     // GIR_Coverage, 3525,
     /* 155967 */     GIR_EraseRootFromParent_Done,
     /* 155968 */   // Label 3002: @155968
     /* 155968 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(156014), // Rule ID 3526 //
     /* 155973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 155976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 155981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 155984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 155987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 155991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 155995 */     // MIs[0] Idx
     /* 155995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 155998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 156003 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 156003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 156006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156012 */     GIR_RootConstrainSelectedInstOperands,
     /* 156013 */     // GIR_Coverage, 3526,
     /* 156013 */     GIR_EraseRootFromParent_Done,
     /* 156014 */   // Label 3003: @156014
     /* 156014 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(156060), // Rule ID 3527 //
     /* 156019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 156022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 156027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 156030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 156033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156041 */     // MIs[0] Idx
     /* 156041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 156049 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 156049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 156052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156058 */     GIR_RootConstrainSelectedInstOperands,
     /* 156059 */     // GIR_Coverage, 3527,
     /* 156059 */     GIR_EraseRootFromParent_Done,
     /* 156060 */   // Label 3004: @156060
     /* 156060 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(156116), // Rule ID 2101 //
     /* 156065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 156073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156102 */     // MIs[1] Operand 1
     /* 156102 */     // No operand predicates
     /* 156102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156104 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 156107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156114 */     GIR_RootConstrainSelectedInstOperands,
     /* 156115 */     // GIR_Coverage, 2101,
     /* 156115 */     GIR_EraseRootFromParent_Done,
     /* 156116 */   // Label 3005: @156116
     /* 156116 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(156172), // Rule ID 2102 //
     /* 156121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 156129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156158 */     // MIs[1] Operand 1
     /* 156158 */     // No operand predicates
     /* 156158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156160 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156170 */     GIR_RootConstrainSelectedInstOperands,
     /* 156171 */     // GIR_Coverage, 2102,
     /* 156171 */     GIR_EraseRootFromParent_Done,
     /* 156172 */   // Label 3006: @156172
     /* 156172 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(156228), // Rule ID 2107 //
     /* 156177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 156185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156214 */     // MIs[1] Operand 1
     /* 156214 */     // No operand predicates
     /* 156214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156216 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 156219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156226 */     GIR_RootConstrainSelectedInstOperands,
     /* 156227 */     // GIR_Coverage, 2107,
     /* 156227 */     GIR_EraseRootFromParent_Done,
     /* 156228 */   // Label 3007: @156228
     /* 156228 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(156284), // Rule ID 2108 //
     /* 156233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 156241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156270 */     // MIs[1] Operand 1
     /* 156270 */     // No operand predicates
     /* 156270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156272 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 156275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156282 */     GIR_RootConstrainSelectedInstOperands,
     /* 156283 */     // GIR_Coverage, 2108,
     /* 156283 */     GIR_EraseRootFromParent_Done,
     /* 156284 */   // Label 3008: @156284
     /* 156284 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(156340), // Rule ID 2114 //
     /* 156289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 156297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156326 */     // MIs[1] Operand 1
     /* 156326 */     // No operand predicates
     /* 156326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156328 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 156331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156338 */     GIR_RootConstrainSelectedInstOperands,
     /* 156339 */     // GIR_Coverage, 2114,
     /* 156339 */     GIR_EraseRootFromParent_Done,
     /* 156340 */   // Label 3009: @156340
     /* 156340 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(156396), // Rule ID 2117 //
     /* 156345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 156353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156382 */     // MIs[1] Operand 1
     /* 156382 */     // No operand predicates
     /* 156382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156384 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 156387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156394 */     GIR_RootConstrainSelectedInstOperands,
     /* 156395 */     // GIR_Coverage, 2117,
     /* 156395 */     GIR_EraseRootFromParent_Done,
     /* 156396 */   // Label 3010: @156396
     /* 156396 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(156452), // Rule ID 2139 //
     /* 156401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 156412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 156415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 156438 */     // MIs[1] Operand 1
     /* 156438 */     // No operand predicates
     /* 156438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156440 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 156443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156450 */     GIR_RootConstrainSelectedInstOperands,
     /* 156451 */     // GIR_Coverage, 2139,
     /* 156451 */     GIR_EraseRootFromParent_Done,
     /* 156452 */   // Label 3011: @156452
     /* 156452 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(156508), // Rule ID 2141 //
     /* 156457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 156494 */     // MIs[1] Operand 1
     /* 156494 */     // No operand predicates
     /* 156494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156496 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 156499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156506 */     GIR_RootConstrainSelectedInstOperands,
     /* 156507 */     // GIR_Coverage, 2141,
     /* 156507 */     GIR_EraseRootFromParent_Done,
     /* 156508 */   // Label 3012: @156508
     /* 156508 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(156564), // Rule ID 2143 //
     /* 156513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 156550 */     // MIs[1] Operand 1
     /* 156550 */     // No operand predicates
     /* 156550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156562 */     GIR_RootConstrainSelectedInstOperands,
     /* 156563 */     // GIR_Coverage, 2143,
     /* 156563 */     GIR_EraseRootFromParent_Done,
     /* 156564 */   // Label 3013: @156564
     /* 156564 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(156617), // Rule ID 6170 //
     /* 156569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 156574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156603 */     // MIs[1] Operand 1
     /* 156603 */     // No operand predicates
     /* 156603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156605 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 156605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 156608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156615 */     GIR_RootConstrainSelectedInstOperands,
     /* 156616 */     // GIR_Coverage, 6170,
     /* 156616 */     GIR_EraseRootFromParent_Done,
     /* 156617 */   // Label 3014: @156617
     /* 156617 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(156670), // Rule ID 6171 //
     /* 156622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 156627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156656 */     // MIs[1] Operand 1
     /* 156656 */     // No operand predicates
     /* 156656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156658 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 156658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 156661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156668 */     GIR_RootConstrainSelectedInstOperands,
     /* 156669 */     // GIR_Coverage, 6171,
     /* 156669 */     GIR_EraseRootFromParent_Done,
     /* 156670 */   // Label 3015: @156670
     /* 156670 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(156723), // Rule ID 6172 //
     /* 156675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 156680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156709 */     // MIs[1] Operand 1
     /* 156709 */     // No operand predicates
     /* 156709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156711 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 156714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156721 */     GIR_RootConstrainSelectedInstOperands,
     /* 156722 */     // GIR_Coverage, 6172,
     /* 156722 */     GIR_EraseRootFromParent_Done,
     /* 156723 */   // Label 3016: @156723
     /* 156723 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(156776), // Rule ID 6173 //
     /* 156728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 156733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156762 */     // MIs[1] Operand 1
     /* 156762 */     // No operand predicates
     /* 156762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156764 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 156767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156774 */     GIR_RootConstrainSelectedInstOperands,
     /* 156775 */     // GIR_Coverage, 6173,
     /* 156775 */     GIR_EraseRootFromParent_Done,
     /* 156776 */   // Label 3017: @156776
     /* 156776 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(156829), // Rule ID 6174 //
     /* 156781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 156786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156815 */     // MIs[1] Operand 1
     /* 156815 */     // No operand predicates
     /* 156815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156817 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 156820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156827 */     GIR_RootConstrainSelectedInstOperands,
     /* 156828 */     // GIR_Coverage, 6174,
     /* 156828 */     GIR_EraseRootFromParent_Done,
     /* 156829 */   // Label 3018: @156829
     /* 156829 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(156882), // Rule ID 6175 //
     /* 156834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 156839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156868 */     // MIs[1] Operand 1
     /* 156868 */     // No operand predicates
     /* 156868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156870 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 156873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156880 */     GIR_RootConstrainSelectedInstOperands,
     /* 156881 */     // GIR_Coverage, 6175,
     /* 156881 */     GIR_EraseRootFromParent_Done,
     /* 156882 */   // Label 3019: @156882
     /* 156882 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(156935), // Rule ID 6176 //
     /* 156887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 156892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156921 */     // MIs[1] Operand 1
     /* 156921 */     // No operand predicates
     /* 156921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156923 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 156923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 156926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156933 */     GIR_RootConstrainSelectedInstOperands,
     /* 156934 */     // GIR_Coverage, 6176,
     /* 156934 */     GIR_EraseRootFromParent_Done,
     /* 156935 */   // Label 3020: @156935
     /* 156935 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(156988), // Rule ID 6177 //
     /* 156940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 156945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156974 */     // MIs[1] Operand 1
     /* 156974 */     // No operand predicates
     /* 156974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156976 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 156979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156986 */     GIR_RootConstrainSelectedInstOperands,
     /* 156987 */     // GIR_Coverage, 6177,
     /* 156987 */     GIR_EraseRootFromParent_Done,
     /* 156988 */   // Label 3021: @156988
     /* 156988 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(157041), // Rule ID 6178 //
     /* 156993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 156998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157027 */     // MIs[1] Operand 1
     /* 157027 */     // No operand predicates
     /* 157027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157029 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 157032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157039 */     GIR_RootConstrainSelectedInstOperands,
     /* 157040 */     // GIR_Coverage, 6178,
     /* 157040 */     GIR_EraseRootFromParent_Done,
     /* 157041 */   // Label 3022: @157041
     /* 157041 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(157094), // Rule ID 6179 //
     /* 157046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157080 */     // MIs[1] Operand 1
     /* 157080 */     // No operand predicates
     /* 157080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157082 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 157085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157092 */     GIR_RootConstrainSelectedInstOperands,
     /* 157093 */     // GIR_Coverage, 6179,
     /* 157093 */     GIR_EraseRootFromParent_Done,
     /* 157094 */   // Label 3023: @157094
     /* 157094 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(157147), // Rule ID 6180 //
     /* 157099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157133 */     // MIs[1] Operand 1
     /* 157133 */     // No operand predicates
     /* 157133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157135 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 157138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157145 */     GIR_RootConstrainSelectedInstOperands,
     /* 157146 */     // GIR_Coverage, 6180,
     /* 157146 */     GIR_EraseRootFromParent_Done,
     /* 157147 */   // Label 3024: @157147
     /* 157147 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(157200), // Rule ID 6181 //
     /* 157152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157186 */     // MIs[1] Operand 1
     /* 157186 */     // No operand predicates
     /* 157186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157188 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 157188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 157191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157198 */     GIR_RootConstrainSelectedInstOperands,
     /* 157199 */     // GIR_Coverage, 6181,
     /* 157199 */     GIR_EraseRootFromParent_Done,
     /* 157200 */   // Label 3025: @157200
     /* 157200 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(157282), // Rule ID 6183 //
     /* 157205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157239 */     // MIs[1] Operand 1
     /* 157239 */     // No operand predicates
     /* 157239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157241 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157253 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 157272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157280 */     GIR_RootConstrainSelectedInstOperands,
     /* 157281 */     // GIR_Coverage, 6183,
     /* 157281 */     GIR_EraseRootFromParent_Done,
     /* 157282 */   // Label 3026: @157282
     /* 157282 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(157364), // Rule ID 6184 //
     /* 157287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157321 */     // MIs[1] Operand 1
     /* 157321 */     // No operand predicates
     /* 157321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157323 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 157354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157362 */     GIR_RootConstrainSelectedInstOperands,
     /* 157363 */     // GIR_Coverage, 6184,
     /* 157363 */     GIR_EraseRootFromParent_Done,
     /* 157364 */   // Label 3027: @157364
     /* 157364 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(157446), // Rule ID 6186 //
     /* 157369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157403 */     // MIs[1] Operand 1
     /* 157403 */     // No operand predicates
     /* 157403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157405 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157444 */     GIR_RootConstrainSelectedInstOperands,
     /* 157445 */     // GIR_Coverage, 6186,
     /* 157445 */     GIR_EraseRootFromParent_Done,
     /* 157446 */   // Label 3028: @157446
     /* 157446 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(157528), // Rule ID 6187 //
     /* 157451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157485 */     // MIs[1] Operand 1
     /* 157485 */     // No operand predicates
     /* 157485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157487 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157499 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157526 */     GIR_RootConstrainSelectedInstOperands,
     /* 157527 */     // GIR_Coverage, 6187,
     /* 157527 */     GIR_EraseRootFromParent_Done,
     /* 157528 */   // Label 3029: @157528
     /* 157528 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(157634), // Rule ID 6188 //
     /* 157533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157567 */     // MIs[1] Operand 1
     /* 157567 */     // No operand predicates
     /* 157567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157569 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 157569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 157576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157633 */     // GIR_Coverage, 6188,
     /* 157633 */     GIR_EraseRootFromParent_Done,
     /* 157634 */   // Label 3030: @157634
     /* 157634 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(157740), // Rule ID 6189 //
     /* 157639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157673 */     // MIs[1] Operand 1
     /* 157673 */     // No operand predicates
     /* 157673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157675 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 157675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 157682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 157699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157739 */     // GIR_Coverage, 6189,
     /* 157739 */     GIR_EraseRootFromParent_Done,
     /* 157740 */   // Label 3031: @157740
     /* 157740 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(157846), // Rule ID 6190 //
     /* 157745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157779 */     // MIs[1] Operand 1
     /* 157779 */     // No operand predicates
     /* 157779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157781 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 157781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 157788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157845 */     // GIR_Coverage, 6190,
     /* 157845 */     GIR_EraseRootFromParent_Done,
     /* 157846 */   // Label 3032: @157846
     /* 157846 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(157952), // Rule ID 6191 //
     /* 157851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157885 */     // MIs[1] Operand 1
     /* 157885 */     // No operand predicates
     /* 157885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157887 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 157887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 157894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 157911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157951 */     // GIR_Coverage, 6191,
     /* 157951 */     GIR_EraseRootFromParent_Done,
     /* 157952 */   // Label 3033: @157952
     /* 157952 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(158007), // Rule ID 6888 //
     /* 157957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 157962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 157991 */     // MIs[1] Operand 1
     /* 157991 */     // No operand predicates
     /* 157991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157993 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 157993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 157996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 157998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158000 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 158005 */     GIR_RootConstrainSelectedInstOperands,
     /* 158006 */     // GIR_Coverage, 6888,
     /* 158006 */     GIR_EraseRootFromParent_Done,
     /* 158007 */   // Label 3034: @158007
     /* 158007 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(158049), // Rule ID 3031 //
     /* 158012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158030 */     // MIs[0] Op2
     /* 158030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 158038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 158038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 158041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158047 */     GIR_RootConstrainSelectedInstOperands,
     /* 158048 */     // GIR_Coverage, 3031,
     /* 158048 */     GIR_EraseRootFromParent_Done,
     /* 158049 */   // Label 3035: @158049
     /* 158049 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(158091), // Rule ID 3032 //
     /* 158054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158072 */     // MIs[0] Op2
     /* 158072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 158080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 158080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 158083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158089 */     GIR_RootConstrainSelectedInstOperands,
     /* 158090 */     // GIR_Coverage, 3032,
     /* 158090 */     GIR_EraseRootFromParent_Done,
     /* 158091 */   // Label 3036: @158091
     /* 158091 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(158133), // Rule ID 3033 //
     /* 158096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158114 */     // MIs[0] Op2
     /* 158114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 158122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 158122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 158125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158131 */     GIR_RootConstrainSelectedInstOperands,
     /* 158132 */     // GIR_Coverage, 3033,
     /* 158132 */     GIR_EraseRootFromParent_Done,
     /* 158133 */   // Label 3037: @158133
     /* 158133 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(158175), // Rule ID 3067 //
     /* 158138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158156 */     // MIs[0] Op2
     /* 158156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 158167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158173 */     GIR_RootConstrainSelectedInstOperands,
     /* 158174 */     // GIR_Coverage, 3067,
     /* 158174 */     GIR_EraseRootFromParent_Done,
     /* 158175 */   // Label 3038: @158175
     /* 158175 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(158217), // Rule ID 3068 //
     /* 158180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158198 */     // MIs[0] Op2
     /* 158198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 158209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158215 */     GIR_RootConstrainSelectedInstOperands,
     /* 158216 */     // GIR_Coverage, 3068,
     /* 158216 */     GIR_EraseRootFromParent_Done,
     /* 158217 */   // Label 3039: @158217
     /* 158217 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(158259), // Rule ID 3069 //
     /* 158222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158240 */     // MIs[0] Op2
     /* 158240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 158251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158257 */     GIR_RootConstrainSelectedInstOperands,
     /* 158258 */     // GIR_Coverage, 3069,
     /* 158258 */     GIR_EraseRootFromParent_Done,
     /* 158259 */   // Label 3040: @158259
     /* 158259 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(158301), // Rule ID 3510 //
     /* 158264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158282 */     // MIs[0] Op2
     /* 158282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 158290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 158290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 158293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158299 */     GIR_RootConstrainSelectedInstOperands,
     /* 158300 */     // GIR_Coverage, 3510,
     /* 158300 */     GIR_EraseRootFromParent_Done,
     /* 158301 */   // Label 3041: @158301
     /* 158301 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(158343), // Rule ID 3511 //
     /* 158306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158324 */     // MIs[0] Op2
     /* 158324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 158332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 158332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 158335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158341 */     GIR_RootConstrainSelectedInstOperands,
     /* 158342 */     // GIR_Coverage, 3511,
     /* 158342 */     GIR_EraseRootFromParent_Done,
     /* 158343 */   // Label 3042: @158343
     /* 158343 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(158385), // Rule ID 3512 //
     /* 158348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158366 */     // MIs[0] Op2
     /* 158366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 158374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 158374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 158377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158383 */     GIR_RootConstrainSelectedInstOperands,
     /* 158384 */     // GIR_Coverage, 3512,
     /* 158384 */     GIR_EraseRootFromParent_Done,
     /* 158385 */   // Label 3043: @158385
     /* 158385 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(158427), // Rule ID 3513 //
     /* 158390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158408 */     // MIs[0] Op2
     /* 158408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 158416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 158416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 158419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158425 */     GIR_RootConstrainSelectedInstOperands,
     /* 158426 */     // GIR_Coverage, 3513,
     /* 158426 */     GIR_EraseRootFromParent_Done,
     /* 158427 */   // Label 3044: @158427
     /* 158427 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(158469), // Rule ID 3514 //
     /* 158432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158450 */     // MIs[0] Op2
     /* 158450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 158458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1251:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 158458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 158461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158467 */     GIR_RootConstrainSelectedInstOperands,
     /* 158468 */     // GIR_Coverage, 3514,
     /* 158468 */     GIR_EraseRootFromParent_Done,
     /* 158469 */   // Label 3045: @158469
     /* 158469 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(158511), // Rule ID 3515 //
     /* 158474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158492 */     // MIs[0] Op2
     /* 158492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 158500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1251:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 158500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 158503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158509 */     GIR_RootConstrainSelectedInstOperands,
     /* 158510 */     // GIR_Coverage, 3515,
     /* 158510 */     GIR_EraseRootFromParent_Done,
     /* 158511 */   // Label 3046: @158511
     /* 158511 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(158553), // Rule ID 3516 //
     /* 158516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158534 */     // MIs[0] Op2
     /* 158534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 158542 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1251:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 158542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 158545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158551 */     GIR_RootConstrainSelectedInstOperands,
     /* 158552 */     // GIR_Coverage, 3516,
     /* 158552 */     GIR_EraseRootFromParent_Done,
     /* 158553 */   // Label 3047: @158553
     /* 158553 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(158595), // Rule ID 11545 //
     /* 158558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 158566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158576 */     // MIs[0] Op2
     /* 158576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 158587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158593 */     GIR_RootConstrainSelectedInstOperands,
     /* 158594 */     // GIR_Coverage, 11545,
     /* 158594 */     GIR_EraseRootFromParent_Done,
     /* 158595 */   // Label 3048: @158595
     /* 158595 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(158637), // Rule ID 11546 //
     /* 158600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 158608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158618 */     // MIs[0] Op2
     /* 158618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 158629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158635 */     GIR_RootConstrainSelectedInstOperands,
     /* 158636 */     // GIR_Coverage, 11546,
     /* 158636 */     GIR_EraseRootFromParent_Done,
     /* 158637 */   // Label 3049: @158637
     /* 158637 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(158679), // Rule ID 11547 //
     /* 158642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 158650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158660 */     // MIs[0] Op2
     /* 158660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 158671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158677 */     GIR_RootConstrainSelectedInstOperands,
     /* 158678 */     // GIR_Coverage, 11547,
     /* 158678 */     GIR_EraseRootFromParent_Done,
     /* 158679 */   // Label 3050: @158679
     /* 158679 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(158721), // Rule ID 11548 //
     /* 158684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 158692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158702 */     // MIs[0] Op2
     /* 158702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1624:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 158713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158719 */     GIR_RootConstrainSelectedInstOperands,
     /* 158720 */     // GIR_Coverage, 11548,
     /* 158720 */     GIR_EraseRootFromParent_Done,
     /* 158721 */   // Label 3051: @158721
     /* 158721 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(158763), // Rule ID 11549 //
     /* 158726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 158734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158744 */     // MIs[0] Op2
     /* 158744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 158755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158761 */     GIR_RootConstrainSelectedInstOperands,
     /* 158762 */     // GIR_Coverage, 11549,
     /* 158762 */     GIR_EraseRootFromParent_Done,
     /* 158763 */   // Label 3052: @158763
     /* 158763 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(158805), // Rule ID 11550 //
     /* 158768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 158776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158786 */     // MIs[0] Op2
     /* 158786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 158797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158803 */     GIR_RootConstrainSelectedInstOperands,
     /* 158804 */     // GIR_Coverage, 11550,
     /* 158804 */     GIR_EraseRootFromParent_Done,
     /* 158805 */   // Label 3053: @158805
     /* 158805 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(158847), // Rule ID 11552 //
     /* 158810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 158818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158828 */     // MIs[0] Op2
     /* 158828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 158839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158845 */     GIR_RootConstrainSelectedInstOperands,
     /* 158846 */     // GIR_Coverage, 11552,
     /* 158846 */     GIR_EraseRootFromParent_Done,
     /* 158847 */   // Label 3054: @158847
     /* 158847 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(158889), // Rule ID 11554 //
     /* 158852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 158860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158870 */     // MIs[0] Op2
     /* 158870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 158881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158887 */     GIR_RootConstrainSelectedInstOperands,
     /* 158888 */     // GIR_Coverage, 11554,
     /* 158888 */     GIR_EraseRootFromParent_Done,
     /* 158889 */   // Label 3055: @158889
     /* 158889 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(158931), // Rule ID 11556 //
     /* 158894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 158902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158912 */     // MIs[0] Op2
     /* 158912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1582:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 158923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158929 */     GIR_RootConstrainSelectedInstOperands,
     /* 158930 */     // GIR_Coverage, 11556,
     /* 158930 */     GIR_EraseRootFromParent_Done,
     /* 158931 */   // Label 3056: @158931
     /* 158931 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(158973), // Rule ID 11557 //
     /* 158936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 158944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158954 */     // MIs[0] Op2
     /* 158954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158962 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 158965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158971 */     GIR_RootConstrainSelectedInstOperands,
     /* 158972 */     // GIR_Coverage, 11557,
     /* 158972 */     GIR_EraseRootFromParent_Done,
     /* 158973 */   // Label 3057: @158973
     /* 158973 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(159015), // Rule ID 11558 //
     /* 158978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 158986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158996 */     // MIs[0] Op2
     /* 158996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 159007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159013 */     GIR_RootConstrainSelectedInstOperands,
     /* 159014 */     // GIR_Coverage, 11558,
     /* 159014 */     GIR_EraseRootFromParent_Done,
     /* 159015 */   // Label 3058: @159015
     /* 159015 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(159057), // Rule ID 11559 //
     /* 159020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 159028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159038 */     // MIs[0] Op2
     /* 159038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 159049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159055 */     GIR_RootConstrainSelectedInstOperands,
     /* 159056 */     // GIR_Coverage, 11559,
     /* 159056 */     GIR_EraseRootFromParent_Done,
     /* 159057 */   // Label 3059: @159057
     /* 159057 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(159099), // Rule ID 11560 //
     /* 159062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159080 */     // MIs[0] Op2
     /* 159080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1739:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 159091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159097 */     GIR_RootConstrainSelectedInstOperands,
     /* 159098 */     // GIR_Coverage, 11560,
     /* 159098 */     GIR_EraseRootFromParent_Done,
     /* 159099 */   // Label 3060: @159099
     /* 159099 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(159141), // Rule ID 11561 //
     /* 159104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159122 */     // MIs[0] Op2
     /* 159122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1739:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 159133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159139 */     GIR_RootConstrainSelectedInstOperands,
     /* 159140 */     // GIR_Coverage, 11561,
     /* 159140 */     GIR_EraseRootFromParent_Done,
     /* 159141 */   // Label 3061: @159141
     /* 159141 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(159183), // Rule ID 11562 //
     /* 159146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159164 */     // MIs[0] Op2
     /* 159164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1739:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 159175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159181 */     GIR_RootConstrainSelectedInstOperands,
     /* 159182 */     // GIR_Coverage, 11562,
     /* 159182 */     GIR_EraseRootFromParent_Done,
     /* 159183 */   // Label 3062: @159183
     /* 159183 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(159225), // Rule ID 11563 //
     /* 159188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159206 */     // MIs[0] Op2
     /* 159206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1944:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 159217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159223 */     GIR_RootConstrainSelectedInstOperands,
     /* 159224 */     // GIR_Coverage, 11563,
     /* 159224 */     GIR_EraseRootFromParent_Done,
     /* 159225 */   // Label 3063: @159225
     /* 159225 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(159267), // Rule ID 11564 //
     /* 159230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159248 */     // MIs[0] Op2
     /* 159248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 159259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159265 */     GIR_RootConstrainSelectedInstOperands,
     /* 159266 */     // GIR_Coverage, 11564,
     /* 159266 */     GIR_EraseRootFromParent_Done,
     /* 159267 */   // Label 3064: @159267
     /* 159267 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(159309), // Rule ID 11565 //
     /* 159272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159290 */     // MIs[0] Op2
     /* 159290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 159301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159307 */     GIR_RootConstrainSelectedInstOperands,
     /* 159308 */     // GIR_Coverage, 11565,
     /* 159308 */     GIR_EraseRootFromParent_Done,
     /* 159309 */   // Label 3065: @159309
     /* 159309 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(159351), // Rule ID 11566 //
     /* 159314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159332 */     // MIs[0] Op2
     /* 159332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 159343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159349 */     GIR_RootConstrainSelectedInstOperands,
     /* 159350 */     // GIR_Coverage, 11566,
     /* 159350 */     GIR_EraseRootFromParent_Done,
     /* 159351 */   // Label 3066: @159351
     /* 159351 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(159393), // Rule ID 11567 //
     /* 159356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159374 */     // MIs[0] Op2
     /* 159374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 159385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159391 */     GIR_RootConstrainSelectedInstOperands,
     /* 159392 */     // GIR_Coverage, 11567,
     /* 159392 */     GIR_EraseRootFromParent_Done,
     /* 159393 */   // Label 3067: @159393
     /* 159393 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(159435), // Rule ID 11568 //
     /* 159398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159416 */     // MIs[0] Op2
     /* 159416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 159427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159433 */     GIR_RootConstrainSelectedInstOperands,
     /* 159434 */     // GIR_Coverage, 11568,
     /* 159434 */     GIR_EraseRootFromParent_Done,
     /* 159435 */   // Label 3068: @159435
     /* 159435 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(159477), // Rule ID 11626 //
     /* 159440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159458 */     // MIs[0] Op2
     /* 159458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 159469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159475 */     GIR_RootConstrainSelectedInstOperands,
     /* 159476 */     // GIR_Coverage, 11626,
     /* 159476 */     GIR_EraseRootFromParent_Done,
     /* 159477 */   // Label 3069: @159477
     /* 159477 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(159519), // Rule ID 11627 //
     /* 159482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159500 */     // MIs[0] Op2
     /* 159500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 159511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159517 */     GIR_RootConstrainSelectedInstOperands,
     /* 159518 */     // GIR_Coverage, 11627,
     /* 159518 */     GIR_EraseRootFromParent_Done,
     /* 159519 */   // Label 3070: @159519
     /* 159519 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(159561), // Rule ID 11628 //
     /* 159524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159542 */     // MIs[0] Op2
     /* 159542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159545 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 159553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159559 */     GIR_RootConstrainSelectedInstOperands,
     /* 159560 */     // GIR_Coverage, 11628,
     /* 159560 */     GIR_EraseRootFromParent_Done,
     /* 159561 */   // Label 3071: @159561
     /* 159561 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(159603), // Rule ID 11629 //
     /* 159566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 159574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159584 */     // MIs[0] Op2
     /* 159584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 159595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159601 */     GIR_RootConstrainSelectedInstOperands,
     /* 159602 */     // GIR_Coverage, 11629,
     /* 159602 */     GIR_EraseRootFromParent_Done,
     /* 159603 */   // Label 3072: @159603
     /* 159603 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(159645), // Rule ID 11630 //
     /* 159608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 159616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159626 */     // MIs[0] Op2
     /* 159626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 159637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159643 */     GIR_RootConstrainSelectedInstOperands,
     /* 159644 */     // GIR_Coverage, 11630,
     /* 159644 */     GIR_EraseRootFromParent_Done,
     /* 159645 */   // Label 3073: @159645
     /* 159645 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(159687), // Rule ID 11631 //
     /* 159650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 159658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159668 */     // MIs[0] Op2
     /* 159668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 159679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159685 */     GIR_RootConstrainSelectedInstOperands,
     /* 159686 */     // GIR_Coverage, 11631,
     /* 159686 */     GIR_EraseRootFromParent_Done,
     /* 159687 */   // Label 3074: @159687
     /* 159687 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(159729), // Rule ID 11632 //
     /* 159692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 159700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159710 */     // MIs[0] Op2
     /* 159710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1965:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 159721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159727 */     GIR_RootConstrainSelectedInstOperands,
     /* 159728 */     // GIR_Coverage, 11632,
     /* 159728 */     GIR_EraseRootFromParent_Done,
     /* 159729 */   // Label 3075: @159729
     /* 159729 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(159771), // Rule ID 11633 //
     /* 159734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 159742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159752 */     // MIs[0] Op2
     /* 159752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 159763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159769 */     GIR_RootConstrainSelectedInstOperands,
     /* 159770 */     // GIR_Coverage, 11633,
     /* 159770 */     GIR_EraseRootFromParent_Done,
     /* 159771 */   // Label 3076: @159771
     /* 159771 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(159813), // Rule ID 11634 //
     /* 159776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 159784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159794 */     // MIs[0] Op2
     /* 159794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 159805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159811 */     GIR_RootConstrainSelectedInstOperands,
     /* 159812 */     // GIR_Coverage, 11634,
     /* 159812 */     GIR_EraseRootFromParent_Done,
     /* 159813 */   // Label 3077: @159813
     /* 159813 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159865), // Rule ID 2123 //
     /* 159818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159851 */     // MIs[1] Operand 1
     /* 159851 */     // No operand predicates
     /* 159851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159853 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 159856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159863 */     GIR_RootConstrainSelectedInstOperands,
     /* 159864 */     // GIR_Coverage, 2123,
     /* 159864 */     GIR_EraseRootFromParent_Done,
     /* 159865 */   // Label 3078: @159865
     /* 159865 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159917), // Rule ID 2124 //
     /* 159870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159903 */     // MIs[1] Operand 1
     /* 159903 */     // No operand predicates
     /* 159903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159905 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 159908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159915 */     GIR_RootConstrainSelectedInstOperands,
     /* 159916 */     // GIR_Coverage, 2124,
     /* 159916 */     GIR_EraseRootFromParent_Done,
     /* 159917 */   // Label 3079: @159917
     /* 159917 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159969), // Rule ID 2125 //
     /* 159922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159955 */     // MIs[1] Operand 1
     /* 159955 */     // No operand predicates
     /* 159955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159957 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 159960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159967 */     GIR_RootConstrainSelectedInstOperands,
     /* 159968 */     // GIR_Coverage, 2125,
     /* 159968 */     GIR_EraseRootFromParent_Done,
     /* 159969 */   // Label 3080: @159969
     /* 159969 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(160021), // Rule ID 2126 //
     /* 159974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160007 */     // MIs[1] Operand 1
     /* 160007 */     // No operand predicates
     /* 160007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 160012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160019 */     GIR_RootConstrainSelectedInstOperands,
     /* 160020 */     // GIR_Coverage, 2126,
     /* 160020 */     GIR_EraseRootFromParent_Done,
     /* 160021 */   // Label 3081: @160021
     /* 160021 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(160073), // Rule ID 2127 //
     /* 160026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160059 */     // MIs[1] Operand 1
     /* 160059 */     // No operand predicates
     /* 160059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160061 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 160064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160071 */     GIR_RootConstrainSelectedInstOperands,
     /* 160072 */     // GIR_Coverage, 2127,
     /* 160072 */     GIR_EraseRootFromParent_Done,
     /* 160073 */   // Label 3082: @160073
     /* 160073 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(160125), // Rule ID 2128 //
     /* 160078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160111 */     // MIs[1] Operand 1
     /* 160111 */     // No operand predicates
     /* 160111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160113 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 160116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160123 */     GIR_RootConstrainSelectedInstOperands,
     /* 160124 */     // GIR_Coverage, 2128,
     /* 160124 */     GIR_EraseRootFromParent_Done,
     /* 160125 */   // Label 3083: @160125
     /* 160125 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(160177), // Rule ID 2129 //
     /* 160130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160163 */     // MIs[1] Operand 1
     /* 160163 */     // No operand predicates
     /* 160163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160165 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 160168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160175 */     GIR_RootConstrainSelectedInstOperands,
     /* 160176 */     // GIR_Coverage, 2129,
     /* 160176 */     GIR_EraseRootFromParent_Done,
     /* 160177 */   // Label 3084: @160177
     /* 160177 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(160229), // Rule ID 2130 //
     /* 160182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160215 */     // MIs[1] Operand 1
     /* 160215 */     // No operand predicates
     /* 160215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160217 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 160220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160227 */     GIR_RootConstrainSelectedInstOperands,
     /* 160228 */     // GIR_Coverage, 2130,
     /* 160228 */     GIR_EraseRootFromParent_Done,
     /* 160229 */   // Label 3085: @160229
     /* 160229 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(160281), // Rule ID 2131 //
     /* 160234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160267 */     // MIs[1] Operand 1
     /* 160267 */     // No operand predicates
     /* 160267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160269 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 160272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160279 */     GIR_RootConstrainSelectedInstOperands,
     /* 160280 */     // GIR_Coverage, 2131,
     /* 160280 */     GIR_EraseRootFromParent_Done,
     /* 160281 */   // Label 3086: @160281
     /* 160281 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(160333), // Rule ID 2132 //
     /* 160286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160319 */     // MIs[1] Operand 1
     /* 160319 */     // No operand predicates
     /* 160319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160321 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 160324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160331 */     GIR_RootConstrainSelectedInstOperands,
     /* 160332 */     // GIR_Coverage, 2132,
     /* 160332 */     GIR_EraseRootFromParent_Done,
     /* 160333 */   // Label 3087: @160333
     /* 160333 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(160385), // Rule ID 2133 //
     /* 160338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160371 */     // MIs[1] Operand 1
     /* 160371 */     // No operand predicates
     /* 160371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160373 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 160376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160383 */     GIR_RootConstrainSelectedInstOperands,
     /* 160384 */     // GIR_Coverage, 2133,
     /* 160384 */     GIR_EraseRootFromParent_Done,
     /* 160385 */   // Label 3088: @160385
     /* 160385 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(160437), // Rule ID 2134 //
     /* 160390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160423 */     // MIs[1] Operand 1
     /* 160423 */     // No operand predicates
     /* 160423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160425 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 160428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160435 */     GIR_RootConstrainSelectedInstOperands,
     /* 160436 */     // GIR_Coverage, 2134,
     /* 160436 */     GIR_EraseRootFromParent_Done,
     /* 160437 */   // Label 3089: @160437
     /* 160437 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160489), // Rule ID 2135 //
     /* 160442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160475 */     // MIs[1] Operand 1
     /* 160475 */     // No operand predicates
     /* 160475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160477 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 160480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160487 */     GIR_RootConstrainSelectedInstOperands,
     /* 160488 */     // GIR_Coverage, 2135,
     /* 160488 */     GIR_EraseRootFromParent_Done,
     /* 160489 */   // Label 3090: @160489
     /* 160489 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160541), // Rule ID 2136 //
     /* 160494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160527 */     // MIs[1] Operand 1
     /* 160527 */     // No operand predicates
     /* 160527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160529 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 160532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160539 */     GIR_RootConstrainSelectedInstOperands,
     /* 160540 */     // GIR_Coverage, 2136,
     /* 160540 */     GIR_EraseRootFromParent_Done,
     /* 160541 */   // Label 3091: @160541
     /* 160541 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160593), // Rule ID 2137 //
     /* 160546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160579 */     // MIs[1] Operand 1
     /* 160579 */     // No operand predicates
     /* 160579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160581 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 160584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160591 */     GIR_RootConstrainSelectedInstOperands,
     /* 160592 */     // GIR_Coverage, 2137,
     /* 160592 */     GIR_EraseRootFromParent_Done,
     /* 160593 */   // Label 3092: @160593
     /* 160593 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160645), // Rule ID 2235 //
     /* 160598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160631 */     // MIs[1] Operand 1
     /* 160631 */     // No operand predicates
     /* 160631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160633 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 160636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160643 */     GIR_RootConstrainSelectedInstOperands,
     /* 160644 */     // GIR_Coverage, 2235,
     /* 160644 */     GIR_EraseRootFromParent_Done,
     /* 160645 */   // Label 3093: @160645
     /* 160645 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160697), // Rule ID 2236 //
     /* 160650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160683 */     // MIs[1] Operand 1
     /* 160683 */     // No operand predicates
     /* 160683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160685 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 160688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160695 */     GIR_RootConstrainSelectedInstOperands,
     /* 160696 */     // GIR_Coverage, 2236,
     /* 160696 */     GIR_EraseRootFromParent_Done,
     /* 160697 */   // Label 3094: @160697
     /* 160697 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160749), // Rule ID 2237 //
     /* 160702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160735 */     // MIs[1] Operand 1
     /* 160735 */     // No operand predicates
     /* 160735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160737 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 160740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160747 */     GIR_RootConstrainSelectedInstOperands,
     /* 160748 */     // GIR_Coverage, 2237,
     /* 160748 */     GIR_EraseRootFromParent_Done,
     /* 160749 */   // Label 3095: @160749
     /* 160749 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160801), // Rule ID 2238 //
     /* 160754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160787 */     // MIs[1] Operand 1
     /* 160787 */     // No operand predicates
     /* 160787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160789 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 160792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160799 */     GIR_RootConstrainSelectedInstOperands,
     /* 160800 */     // GIR_Coverage, 2238,
     /* 160800 */     GIR_EraseRootFromParent_Done,
     /* 160801 */   // Label 3096: @160801
     /* 160801 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160853), // Rule ID 2239 //
     /* 160806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160839 */     // MIs[1] Operand 1
     /* 160839 */     // No operand predicates
     /* 160839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160841 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 160844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160851 */     GIR_RootConstrainSelectedInstOperands,
     /* 160852 */     // GIR_Coverage, 2239,
     /* 160852 */     GIR_EraseRootFromParent_Done,
     /* 160853 */   // Label 3097: @160853
     /* 160853 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160898), // Rule ID 63 //
     /* 160858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 160861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 160866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 160887 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 160887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 160890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 160896 */     GIR_RootConstrainSelectedInstOperands,
     /* 160897 */     // GIR_Coverage, 63,
     /* 160897 */     GIR_EraseRootFromParent_Done,
     /* 160898 */   // Label 3098: @160898
     /* 160898 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160943), // Rule ID 129 //
     /* 160903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 160906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 160911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160932 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 160932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 160935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 160941 */     GIR_RootConstrainSelectedInstOperands,
     /* 160942 */     // GIR_Coverage, 129,
     /* 160942 */     GIR_EraseRootFromParent_Done,
     /* 160943 */   // Label 3099: @160943
     /* 160943 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160988), // Rule ID 130 //
     /* 160948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 160951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 160956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160977 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 160977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 160980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 160986 */     GIR_RootConstrainSelectedInstOperands,
     /* 160987 */     // GIR_Coverage, 130,
     /* 160987 */     GIR_EraseRootFromParent_Done,
     /* 160988 */   // Label 3100: @160988
     /* 160988 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(161033), // Rule ID 131 //
     /* 160993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 160996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 161001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161022 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 161025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161031 */     GIR_RootConstrainSelectedInstOperands,
     /* 161032 */     // GIR_Coverage, 131,
     /* 161032 */     GIR_EraseRootFromParent_Done,
     /* 161033 */   // Label 3101: @161033
     /* 161033 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(161078), // Rule ID 132 //
     /* 161038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 161046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161067 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 161067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 161070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161076 */     GIR_RootConstrainSelectedInstOperands,
     /* 161077 */     // GIR_Coverage, 132,
     /* 161077 */     GIR_EraseRootFromParent_Done,
     /* 161078 */   // Label 3102: @161078
     /* 161078 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161123), // Rule ID 133 //
     /* 161083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 161091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161112 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 161115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161121 */     GIR_RootConstrainSelectedInstOperands,
     /* 161122 */     // GIR_Coverage, 133,
     /* 161122 */     GIR_EraseRootFromParent_Done,
     /* 161123 */   // Label 3103: @161123
     /* 161123 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161168), // Rule ID 134 //
     /* 161128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 161136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161157 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 161160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161166 */     GIR_RootConstrainSelectedInstOperands,
     /* 161167 */     // GIR_Coverage, 134,
     /* 161167 */     GIR_EraseRootFromParent_Done,
     /* 161168 */   // Label 3104: @161168
     /* 161168 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161213), // Rule ID 135 //
     /* 161173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 161181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161202 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 161205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161211 */     GIR_RootConstrainSelectedInstOperands,
     /* 161212 */     // GIR_Coverage, 135,
     /* 161212 */     GIR_EraseRootFromParent_Done,
     /* 161213 */   // Label 3105: @161213
     /* 161213 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161258), // Rule ID 136 //
     /* 161218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 161226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161247 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 161247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 161250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161256 */     GIR_RootConstrainSelectedInstOperands,
     /* 161257 */     // GIR_Coverage, 136,
     /* 161257 */     GIR_EraseRootFromParent_Done,
     /* 161258 */   // Label 3106: @161258
     /* 161258 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161303), // Rule ID 1035 //
     /* 161263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161292 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 161292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 161295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161301 */     GIR_RootConstrainSelectedInstOperands,
     /* 161302 */     // GIR_Coverage, 1035,
     /* 161302 */     GIR_EraseRootFromParent_Done,
     /* 161303 */   // Label 3107: @161303
     /* 161303 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161348), // Rule ID 1036 //
     /* 161308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161337 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 161337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 161340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161346 */     GIR_RootConstrainSelectedInstOperands,
     /* 161347 */     // GIR_Coverage, 1036,
     /* 161347 */     GIR_EraseRootFromParent_Done,
     /* 161348 */   // Label 3108: @161348
     /* 161348 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161393), // Rule ID 1037 //
     /* 161353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161382 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 161382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 161385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161391 */     GIR_RootConstrainSelectedInstOperands,
     /* 161392 */     // GIR_Coverage, 1037,
     /* 161392 */     GIR_EraseRootFromParent_Done,
     /* 161393 */   // Label 3109: @161393
     /* 161393 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161438), // Rule ID 1038 //
     /* 161398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161427 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 161427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 161430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161436 */     GIR_RootConstrainSelectedInstOperands,
     /* 161437 */     // GIR_Coverage, 1038,
     /* 161437 */     GIR_EraseRootFromParent_Done,
     /* 161438 */   // Label 3110: @161438
     /* 161438 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161483), // Rule ID 1039 //
     /* 161443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161472 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 161472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 161475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161481 */     GIR_RootConstrainSelectedInstOperands,
     /* 161482 */     // GIR_Coverage, 1039,
     /* 161482 */     GIR_EraseRootFromParent_Done,
     /* 161483 */   // Label 3111: @161483
     /* 161483 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161528), // Rule ID 1040 //
     /* 161488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161517 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 161517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 161520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161526 */     GIR_RootConstrainSelectedInstOperands,
     /* 161527 */     // GIR_Coverage, 1040,
     /* 161527 */     GIR_EraseRootFromParent_Done,
     /* 161528 */   // Label 3112: @161528
     /* 161528 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161573), // Rule ID 1041 //
     /* 161533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161562 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 161562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 161565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161571 */     GIR_RootConstrainSelectedInstOperands,
     /* 161572 */     // GIR_Coverage, 1041,
     /* 161572 */     GIR_EraseRootFromParent_Done,
     /* 161573 */   // Label 3113: @161573
     /* 161573 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161618), // Rule ID 1083 //
     /* 161578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161607 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 161607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 161610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161616 */     GIR_RootConstrainSelectedInstOperands,
     /* 161617 */     // GIR_Coverage, 1083,
     /* 161617 */     GIR_EraseRootFromParent_Done,
     /* 161618 */   // Label 3114: @161618
     /* 161618 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161663), // Rule ID 1084 //
     /* 161623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161652 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 161652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 161655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161661 */     GIR_RootConstrainSelectedInstOperands,
     /* 161662 */     // GIR_Coverage, 1084,
     /* 161662 */     GIR_EraseRootFromParent_Done,
     /* 161663 */   // Label 3115: @161663
     /* 161663 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(161708), // Rule ID 1085 //
     /* 161668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161697 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 161697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 161700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161706 */     GIR_RootConstrainSelectedInstOperands,
     /* 161707 */     // GIR_Coverage, 1085,
     /* 161707 */     GIR_EraseRootFromParent_Done,
     /* 161708 */   // Label 3116: @161708
     /* 161708 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(161753), // Rule ID 1086 //
     /* 161713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161742 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 161742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 161745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161751 */     GIR_RootConstrainSelectedInstOperands,
     /* 161752 */     // GIR_Coverage, 1086,
     /* 161752 */     GIR_EraseRootFromParent_Done,
     /* 161753 */   // Label 3117: @161753
     /* 161753 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(161798), // Rule ID 1087 //
     /* 161758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161787 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 161787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 161790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161796 */     GIR_RootConstrainSelectedInstOperands,
     /* 161797 */     // GIR_Coverage, 1087,
     /* 161797 */     GIR_EraseRootFromParent_Done,
     /* 161798 */   // Label 3118: @161798
     /* 161798 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(161843), // Rule ID 1088 //
     /* 161803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161832 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 161832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 161835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161841 */     GIR_RootConstrainSelectedInstOperands,
     /* 161842 */     // GIR_Coverage, 1088,
     /* 161842 */     GIR_EraseRootFromParent_Done,
     /* 161843 */   // Label 3119: @161843
     /* 161843 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(161888), // Rule ID 1089 //
     /* 161848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161877 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 161877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 161880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161886 */     GIR_RootConstrainSelectedInstOperands,
     /* 161887 */     // GIR_Coverage, 1089,
     /* 161887 */     GIR_EraseRootFromParent_Done,
     /* 161888 */   // Label 3120: @161888
     /* 161888 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(161933), // Rule ID 1101 //
     /* 161893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 161901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161922 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 161922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 161925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161931 */     GIR_RootConstrainSelectedInstOperands,
     /* 161932 */     // GIR_Coverage, 1101,
     /* 161932 */     GIR_EraseRootFromParent_Done,
     /* 161933 */   // Label 3121: @161933
     /* 161933 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(161978), // Rule ID 1103 //
     /* 161938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 161946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161967 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 161967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 161970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161976 */     GIR_RootConstrainSelectedInstOperands,
     /* 161977 */     // GIR_Coverage, 1103,
     /* 161977 */     GIR_EraseRootFromParent_Done,
     /* 161978 */   // Label 3122: @161978
     /* 161978 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162023), // Rule ID 1105 //
     /* 161983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 161991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162012 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 162012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 162015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162021 */     GIR_RootConstrainSelectedInstOperands,
     /* 162022 */     // GIR_Coverage, 1105,
     /* 162022 */     GIR_EraseRootFromParent_Done,
     /* 162023 */   // Label 3123: @162023
     /* 162023 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162068), // Rule ID 1107 //
     /* 162028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162057 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 162057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 162060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162066 */     GIR_RootConstrainSelectedInstOperands,
     /* 162067 */     // GIR_Coverage, 1107,
     /* 162067 */     GIR_EraseRootFromParent_Done,
     /* 162068 */   // Label 3124: @162068
     /* 162068 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162113), // Rule ID 1109 //
     /* 162073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162102 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 162102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 162105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162111 */     GIR_RootConstrainSelectedInstOperands,
     /* 162112 */     // GIR_Coverage, 1109,
     /* 162112 */     GIR_EraseRootFromParent_Done,
     /* 162113 */   // Label 3125: @162113
     /* 162113 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162158), // Rule ID 1111 //
     /* 162118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162147 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 162147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 162150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162156 */     GIR_RootConstrainSelectedInstOperands,
     /* 162157 */     // GIR_Coverage, 1111,
     /* 162157 */     GIR_EraseRootFromParent_Done,
     /* 162158 */   // Label 3126: @162158
     /* 162158 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162203), // Rule ID 1113 //
     /* 162163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162192 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 162192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 162195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162201 */     GIR_RootConstrainSelectedInstOperands,
     /* 162202 */     // GIR_Coverage, 1113,
     /* 162202 */     GIR_EraseRootFromParent_Done,
     /* 162203 */   // Label 3127: @162203
     /* 162203 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162248), // Rule ID 1156 //
     /* 162208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162237 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 162240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162246 */     GIR_RootConstrainSelectedInstOperands,
     /* 162247 */     // GIR_Coverage, 1156,
     /* 162247 */     GIR_EraseRootFromParent_Done,
     /* 162248 */   // Label 3128: @162248
     /* 162248 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162293), // Rule ID 1157 //
     /* 162253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162282 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 162285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162291 */     GIR_RootConstrainSelectedInstOperands,
     /* 162292 */     // GIR_Coverage, 1157,
     /* 162292 */     GIR_EraseRootFromParent_Done,
     /* 162293 */   // Label 3129: @162293
     /* 162293 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162338), // Rule ID 1158 //
     /* 162298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162327 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 162330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162336 */     GIR_RootConstrainSelectedInstOperands,
     /* 162337 */     // GIR_Coverage, 1158,
     /* 162337 */     GIR_EraseRootFromParent_Done,
     /* 162338 */   // Label 3130: @162338
     /* 162338 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162383), // Rule ID 1159 //
     /* 162343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162372 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 162375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162381 */     GIR_RootConstrainSelectedInstOperands,
     /* 162382 */     // GIR_Coverage, 1159,
     /* 162382 */     GIR_EraseRootFromParent_Done,
     /* 162383 */   // Label 3131: @162383
     /* 162383 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162428), // Rule ID 1160 //
     /* 162388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162417 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 162420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162426 */     GIR_RootConstrainSelectedInstOperands,
     /* 162427 */     // GIR_Coverage, 1160,
     /* 162427 */     GIR_EraseRootFromParent_Done,
     /* 162428 */   // Label 3132: @162428
     /* 162428 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162473), // Rule ID 1162 //
     /* 162433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162462 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 162465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162471 */     GIR_RootConstrainSelectedInstOperands,
     /* 162472 */     // GIR_Coverage, 1162,
     /* 162472 */     GIR_EraseRootFromParent_Done,
     /* 162473 */   // Label 3133: @162473
     /* 162473 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162518), // Rule ID 1164 //
     /* 162478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162507 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 162510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162516 */     GIR_RootConstrainSelectedInstOperands,
     /* 162517 */     // GIR_Coverage, 1164,
     /* 162517 */     GIR_EraseRootFromParent_Done,
     /* 162518 */   // Label 3134: @162518
     /* 162518 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162563), // Rule ID 1166 //
     /* 162523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 162555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162561 */     GIR_RootConstrainSelectedInstOperands,
     /* 162562 */     // GIR_Coverage, 1166,
     /* 162562 */     GIR_EraseRootFromParent_Done,
     /* 162563 */   // Label 3135: @162563
     /* 162563 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(162608), // Rule ID 1168 //
     /* 162568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 162600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162606 */     GIR_RootConstrainSelectedInstOperands,
     /* 162607 */     // GIR_Coverage, 1168,
     /* 162607 */     GIR_EraseRootFromParent_Done,
     /* 162608 */   // Label 3136: @162608
     /* 162608 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(162653), // Rule ID 1170 //
     /* 162613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 162645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162651 */     GIR_RootConstrainSelectedInstOperands,
     /* 162652 */     // GIR_Coverage, 1170,
     /* 162652 */     GIR_EraseRootFromParent_Done,
     /* 162653 */   // Label 3137: @162653
     /* 162653 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(162698), // Rule ID 1172 //
     /* 162658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162687 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 162690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162696 */     GIR_RootConstrainSelectedInstOperands,
     /* 162697 */     // GIR_Coverage, 1172,
     /* 162697 */     GIR_EraseRootFromParent_Done,
     /* 162698 */   // Label 3138: @162698
     /* 162698 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(162743), // Rule ID 1174 //
     /* 162703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162732 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 162735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162741 */     GIR_RootConstrainSelectedInstOperands,
     /* 162742 */     // GIR_Coverage, 1174,
     /* 162742 */     GIR_EraseRootFromParent_Done,
     /* 162743 */   // Label 3139: @162743
     /* 162743 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(162788), // Rule ID 1176 //
     /* 162748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162777 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 162780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162786 */     GIR_RootConstrainSelectedInstOperands,
     /* 162787 */     // GIR_Coverage, 1176,
     /* 162787 */     GIR_EraseRootFromParent_Done,
     /* 162788 */   // Label 3140: @162788
     /* 162788 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(162833), // Rule ID 1178 //
     /* 162793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162822 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 162825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162831 */     GIR_RootConstrainSelectedInstOperands,
     /* 162832 */     // GIR_Coverage, 1178,
     /* 162832 */     GIR_EraseRootFromParent_Done,
     /* 162833 */   // Label 3141: @162833
     /* 162833 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(162878), // Rule ID 1180 //
     /* 162838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162867 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 162870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162876 */     GIR_RootConstrainSelectedInstOperands,
     /* 162877 */     // GIR_Coverage, 1180,
     /* 162877 */     GIR_EraseRootFromParent_Done,
     /* 162878 */   // Label 3142: @162878
     /* 162878 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(162923), // Rule ID 1182 //
     /* 162883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 162891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162912 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 162915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162921 */     GIR_RootConstrainSelectedInstOperands,
     /* 162922 */     // GIR_Coverage, 1182,
     /* 162922 */     GIR_EraseRootFromParent_Done,
     /* 162923 */   // Label 3143: @162923
     /* 162923 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(162968), // Rule ID 1184 //
     /* 162928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 162936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162957 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 162960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162966 */     GIR_RootConstrainSelectedInstOperands,
     /* 162967 */     // GIR_Coverage, 1184,
     /* 162967 */     GIR_EraseRootFromParent_Done,
     /* 162968 */   // Label 3144: @162968
     /* 162968 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163013), // Rule ID 1186 //
     /* 162973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 162981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163002 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 163005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163011 */     GIR_RootConstrainSelectedInstOperands,
     /* 163012 */     // GIR_Coverage, 1186,
     /* 163012 */     GIR_EraseRootFromParent_Done,
     /* 163013 */   // Label 3145: @163013
     /* 163013 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163058), // Rule ID 1188 //
     /* 163018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163047 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 163050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163056 */     GIR_RootConstrainSelectedInstOperands,
     /* 163057 */     // GIR_Coverage, 1188,
     /* 163057 */     GIR_EraseRootFromParent_Done,
     /* 163058 */   // Label 3146: @163058
     /* 163058 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163103), // Rule ID 1190 //
     /* 163063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 163095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163101 */     GIR_RootConstrainSelectedInstOperands,
     /* 163102 */     // GIR_Coverage, 1190,
     /* 163102 */     GIR_EraseRootFromParent_Done,
     /* 163103 */   // Label 3147: @163103
     /* 163103 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163148), // Rule ID 1226 //
     /* 163108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163137 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 163140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163146 */     GIR_RootConstrainSelectedInstOperands,
     /* 163147 */     // GIR_Coverage, 1226,
     /* 163147 */     GIR_EraseRootFromParent_Done,
     /* 163148 */   // Label 3148: @163148
     /* 163148 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163193), // Rule ID 1227 //
     /* 163153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163182 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 163185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163191 */     GIR_RootConstrainSelectedInstOperands,
     /* 163192 */     // GIR_Coverage, 1227,
     /* 163192 */     GIR_EraseRootFromParent_Done,
     /* 163193 */   // Label 3149: @163193
     /* 163193 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163238), // Rule ID 1228 //
     /* 163198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163227 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 163230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163236 */     GIR_RootConstrainSelectedInstOperands,
     /* 163237 */     // GIR_Coverage, 1228,
     /* 163237 */     GIR_EraseRootFromParent_Done,
     /* 163238 */   // Label 3150: @163238
     /* 163238 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163283), // Rule ID 1229 //
     /* 163243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163272 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 163275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163281 */     GIR_RootConstrainSelectedInstOperands,
     /* 163282 */     // GIR_Coverage, 1229,
     /* 163282 */     GIR_EraseRootFromParent_Done,
     /* 163283 */   // Label 3151: @163283
     /* 163283 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163328), // Rule ID 1230 //
     /* 163288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163317 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 163320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163326 */     GIR_RootConstrainSelectedInstOperands,
     /* 163327 */     // GIR_Coverage, 1230,
     /* 163327 */     GIR_EraseRootFromParent_Done,
     /* 163328 */   // Label 3152: @163328
     /* 163328 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(163373), // Rule ID 1241 //
     /* 163333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163362 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 163365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163371 */     GIR_RootConstrainSelectedInstOperands,
     /* 163372 */     // GIR_Coverage, 1241,
     /* 163372 */     GIR_EraseRootFromParent_Done,
     /* 163373 */   // Label 3153: @163373
     /* 163373 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(163418), // Rule ID 1242 //
     /* 163378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163407 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 163410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163416 */     GIR_RootConstrainSelectedInstOperands,
     /* 163417 */     // GIR_Coverage, 1242,
     /* 163417 */     GIR_EraseRootFromParent_Done,
     /* 163418 */   // Label 3154: @163418
     /* 163418 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(163463), // Rule ID 1243 //
     /* 163423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 163455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163461 */     GIR_RootConstrainSelectedInstOperands,
     /* 163462 */     // GIR_Coverage, 1243,
     /* 163462 */     GIR_EraseRootFromParent_Done,
     /* 163463 */   // Label 3155: @163463
     /* 163463 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(163508), // Rule ID 1244 //
     /* 163468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163497 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 163500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163506 */     GIR_RootConstrainSelectedInstOperands,
     /* 163507 */     // GIR_Coverage, 1244,
     /* 163507 */     GIR_EraseRootFromParent_Done,
     /* 163508 */   // Label 3156: @163508
     /* 163508 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(163553), // Rule ID 1245 //
     /* 163513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163542 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 163545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163551 */     GIR_RootConstrainSelectedInstOperands,
     /* 163552 */     // GIR_Coverage, 1245,
     /* 163552 */     GIR_EraseRootFromParent_Done,
     /* 163553 */   // Label 3157: @163553
     /* 163553 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(163598), // Rule ID 1256 //
     /* 163558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163587 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 163590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163596 */     GIR_RootConstrainSelectedInstOperands,
     /* 163597 */     // GIR_Coverage, 1256,
     /* 163597 */     GIR_EraseRootFromParent_Done,
     /* 163598 */   // Label 3158: @163598
     /* 163598 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(163643), // Rule ID 1257 //
     /* 163603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163632 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 163635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163641 */     GIR_RootConstrainSelectedInstOperands,
     /* 163642 */     // GIR_Coverage, 1257,
     /* 163642 */     GIR_EraseRootFromParent_Done,
     /* 163643 */   // Label 3159: @163643
     /* 163643 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(163688), // Rule ID 1258 //
     /* 163648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163677 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 163680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163686 */     GIR_RootConstrainSelectedInstOperands,
     /* 163687 */     // GIR_Coverage, 1258,
     /* 163687 */     GIR_EraseRootFromParent_Done,
     /* 163688 */   // Label 3160: @163688
     /* 163688 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(163733), // Rule ID 1259 //
     /* 163693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163722 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 163725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163731 */     GIR_RootConstrainSelectedInstOperands,
     /* 163732 */     // GIR_Coverage, 1259,
     /* 163732 */     GIR_EraseRootFromParent_Done,
     /* 163733 */   // Label 3161: @163733
     /* 163733 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(163778), // Rule ID 1260 //
     /* 163738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163767 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 163770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163776 */     GIR_RootConstrainSelectedInstOperands,
     /* 163777 */     // GIR_Coverage, 1260,
     /* 163777 */     GIR_EraseRootFromParent_Done,
     /* 163778 */   // Label 3162: @163778
     /* 163778 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(163823), // Rule ID 1271 //
     /* 163783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163812 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 163815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163821 */     GIR_RootConstrainSelectedInstOperands,
     /* 163822 */     // GIR_Coverage, 1271,
     /* 163822 */     GIR_EraseRootFromParent_Done,
     /* 163823 */   // Label 3163: @163823
     /* 163823 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(163868), // Rule ID 1272 //
     /* 163828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163857 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 163860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163866 */     GIR_RootConstrainSelectedInstOperands,
     /* 163867 */     // GIR_Coverage, 1272,
     /* 163867 */     GIR_EraseRootFromParent_Done,
     /* 163868 */   // Label 3164: @163868
     /* 163868 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(163913), // Rule ID 1273 //
     /* 163873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163902 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 163905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163911 */     GIR_RootConstrainSelectedInstOperands,
     /* 163912 */     // GIR_Coverage, 1273,
     /* 163912 */     GIR_EraseRootFromParent_Done,
     /* 163913 */   // Label 3165: @163913
     /* 163913 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(163958), // Rule ID 1274 //
     /* 163918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163947 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 163950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163956 */     GIR_RootConstrainSelectedInstOperands,
     /* 163957 */     // GIR_Coverage, 1274,
     /* 163957 */     GIR_EraseRootFromParent_Done,
     /* 163958 */   // Label 3166: @163958
     /* 163958 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164003), // Rule ID 1275 //
     /* 163963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163992 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 163995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164001 */     GIR_RootConstrainSelectedInstOperands,
     /* 164002 */     // GIR_Coverage, 1275,
     /* 164002 */     GIR_EraseRootFromParent_Done,
     /* 164003 */   // Label 3167: @164003
     /* 164003 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164048), // Rule ID 1306 //
     /* 164008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164037 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 164040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164046 */     GIR_RootConstrainSelectedInstOperands,
     /* 164047 */     // GIR_Coverage, 1306,
     /* 164047 */     GIR_EraseRootFromParent_Done,
     /* 164048 */   // Label 3168: @164048
     /* 164048 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164093), // Rule ID 1307 //
     /* 164053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164082 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 164085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164091 */     GIR_RootConstrainSelectedInstOperands,
     /* 164092 */     // GIR_Coverage, 1307,
     /* 164092 */     GIR_EraseRootFromParent_Done,
     /* 164093 */   // Label 3169: @164093
     /* 164093 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164138), // Rule ID 1308 //
     /* 164098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164127 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 164130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164136 */     GIR_RootConstrainSelectedInstOperands,
     /* 164137 */     // GIR_Coverage, 1308,
     /* 164137 */     GIR_EraseRootFromParent_Done,
     /* 164138 */   // Label 3170: @164138
     /* 164138 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(164183), // Rule ID 1309 //
     /* 164143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164172 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 164175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164181 */     GIR_RootConstrainSelectedInstOperands,
     /* 164182 */     // GIR_Coverage, 1309,
     /* 164182 */     GIR_EraseRootFromParent_Done,
     /* 164183 */   // Label 3171: @164183
     /* 164183 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(164228), // Rule ID 1310 //
     /* 164188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164217 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 164220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164226 */     GIR_RootConstrainSelectedInstOperands,
     /* 164227 */     // GIR_Coverage, 1310,
     /* 164227 */     GIR_EraseRootFromParent_Done,
     /* 164228 */   // Label 3172: @164228
     /* 164228 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(164273), // Rule ID 1321 //
     /* 164233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164262 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 164265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164271 */     GIR_RootConstrainSelectedInstOperands,
     /* 164272 */     // GIR_Coverage, 1321,
     /* 164272 */     GIR_EraseRootFromParent_Done,
     /* 164273 */   // Label 3173: @164273
     /* 164273 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(164318), // Rule ID 1322 //
     /* 164278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164307 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 164310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164316 */     GIR_RootConstrainSelectedInstOperands,
     /* 164317 */     // GIR_Coverage, 1322,
     /* 164317 */     GIR_EraseRootFromParent_Done,
     /* 164318 */   // Label 3174: @164318
     /* 164318 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(164363), // Rule ID 1323 //
     /* 164323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 164355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164361 */     GIR_RootConstrainSelectedInstOperands,
     /* 164362 */     // GIR_Coverage, 1323,
     /* 164362 */     GIR_EraseRootFromParent_Done,
     /* 164363 */   // Label 3175: @164363
     /* 164363 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(164408), // Rule ID 1324 //
     /* 164368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164397 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 164400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164406 */     GIR_RootConstrainSelectedInstOperands,
     /* 164407 */     // GIR_Coverage, 1324,
     /* 164407 */     GIR_EraseRootFromParent_Done,
     /* 164408 */   // Label 3176: @164408
     /* 164408 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(164453), // Rule ID 1325 //
     /* 164413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164442 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 164445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164451 */     GIR_RootConstrainSelectedInstOperands,
     /* 164452 */     // GIR_Coverage, 1325,
     /* 164452 */     GIR_EraseRootFromParent_Done,
     /* 164453 */   // Label 3177: @164453
     /* 164453 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(164498), // Rule ID 1326 //
     /* 164458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164487 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 164490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164496 */     GIR_RootConstrainSelectedInstOperands,
     /* 164497 */     // GIR_Coverage, 1326,
     /* 164497 */     GIR_EraseRootFromParent_Done,
     /* 164498 */   // Label 3178: @164498
     /* 164498 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(164543), // Rule ID 1327 //
     /* 164503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164532 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 164535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164541 */     GIR_RootConstrainSelectedInstOperands,
     /* 164542 */     // GIR_Coverage, 1327,
     /* 164542 */     GIR_EraseRootFromParent_Done,
     /* 164543 */   // Label 3179: @164543
     /* 164543 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(164588), // Rule ID 1328 //
     /* 164548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164577 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 164580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164586 */     GIR_RootConstrainSelectedInstOperands,
     /* 164587 */     // GIR_Coverage, 1328,
     /* 164587 */     GIR_EraseRootFromParent_Done,
     /* 164588 */   // Label 3180: @164588
     /* 164588 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(164633), // Rule ID 1329 //
     /* 164593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164622 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 164625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164631 */     GIR_RootConstrainSelectedInstOperands,
     /* 164632 */     // GIR_Coverage, 1329,
     /* 164632 */     GIR_EraseRootFromParent_Done,
     /* 164633 */   // Label 3181: @164633
     /* 164633 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(164678), // Rule ID 1330 //
     /* 164638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164667 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 164670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164676 */     GIR_RootConstrainSelectedInstOperands,
     /* 164677 */     // GIR_Coverage, 1330,
     /* 164677 */     GIR_EraseRootFromParent_Done,
     /* 164678 */   // Label 3182: @164678
     /* 164678 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(164723), // Rule ID 1347 //
     /* 164683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 164691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 164700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164712 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 164712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 164715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164721 */     GIR_RootConstrainSelectedInstOperands,
     /* 164722 */     // GIR_Coverage, 1347,
     /* 164722 */     GIR_EraseRootFromParent_Done,
     /* 164723 */   // Label 3183: @164723
     /* 164723 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(164768), // Rule ID 1348 //
     /* 164728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 164736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 164745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164757 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 164757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 164760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164766 */     GIR_RootConstrainSelectedInstOperands,
     /* 164767 */     // GIR_Coverage, 1348,
     /* 164767 */     GIR_EraseRootFromParent_Done,
     /* 164768 */   // Label 3184: @164768
     /* 164768 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(164813), // Rule ID 1362 //
     /* 164773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 164790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164802 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 164802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 164805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164811 */     GIR_RootConstrainSelectedInstOperands,
     /* 164812 */     // GIR_Coverage, 1362,
     /* 164812 */     GIR_EraseRootFromParent_Done,
     /* 164813 */   // Label 3185: @164813
     /* 164813 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(164858), // Rule ID 1364 //
     /* 164818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 164835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164847 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 164847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 164850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164856 */     GIR_RootConstrainSelectedInstOperands,
     /* 164857 */     // GIR_Coverage, 1364,
     /* 164857 */     GIR_EraseRootFromParent_Done,
     /* 164858 */   // Label 3186: @164858
     /* 164858 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(164903), // Rule ID 1366 //
     /* 164863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164892 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 164892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164901 */     GIR_RootConstrainSelectedInstOperands,
     /* 164902 */     // GIR_Coverage, 1366,
     /* 164902 */     GIR_EraseRootFromParent_Done,
     /* 164903 */   // Label 3187: @164903
     /* 164903 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(164948), // Rule ID 1368 //
     /* 164908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 164937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 164940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164946 */     GIR_RootConstrainSelectedInstOperands,
     /* 164947 */     // GIR_Coverage, 1368,
     /* 164947 */     GIR_EraseRootFromParent_Done,
     /* 164948 */   // Label 3188: @164948
     /* 164948 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(164993), // Rule ID 1370 //
     /* 164953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164982 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 164982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 164985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164991 */     GIR_RootConstrainSelectedInstOperands,
     /* 164992 */     // GIR_Coverage, 1370,
     /* 164992 */     GIR_EraseRootFromParent_Done,
     /* 164993 */   // Label 3189: @164993
     /* 164993 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165038), // Rule ID 1372 //
     /* 164998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165027 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 165030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165036 */     GIR_RootConstrainSelectedInstOperands,
     /* 165037 */     // GIR_Coverage, 1372,
     /* 165037 */     GIR_EraseRootFromParent_Done,
     /* 165038 */   // Label 3190: @165038
     /* 165038 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165083), // Rule ID 1379 //
     /* 165043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165072 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 165075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165081 */     GIR_RootConstrainSelectedInstOperands,
     /* 165082 */     // GIR_Coverage, 1379,
     /* 165082 */     GIR_EraseRootFromParent_Done,
     /* 165083 */   // Label 3191: @165083
     /* 165083 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165128), // Rule ID 1380 //
     /* 165088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165117 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 165120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165126 */     GIR_RootConstrainSelectedInstOperands,
     /* 165127 */     // GIR_Coverage, 1380,
     /* 165127 */     GIR_EraseRootFromParent_Done,
     /* 165128 */   // Label 3192: @165128
     /* 165128 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165173), // Rule ID 1381 //
     /* 165133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165162 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 165165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165171 */     GIR_RootConstrainSelectedInstOperands,
     /* 165172 */     // GIR_Coverage, 1381,
     /* 165172 */     GIR_EraseRootFromParent_Done,
     /* 165173 */   // Label 3193: @165173
     /* 165173 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(165218), // Rule ID 1382 //
     /* 165178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 165210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165216 */     GIR_RootConstrainSelectedInstOperands,
     /* 165217 */     // GIR_Coverage, 1382,
     /* 165217 */     GIR_EraseRootFromParent_Done,
     /* 165218 */   // Label 3194: @165218
     /* 165218 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(165263), // Rule ID 1383 //
     /* 165223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 165255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165261 */     GIR_RootConstrainSelectedInstOperands,
     /* 165262 */     // GIR_Coverage, 1383,
     /* 165262 */     GIR_EraseRootFromParent_Done,
     /* 165263 */   // Label 3195: @165263
     /* 165263 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(165308), // Rule ID 1384 //
     /* 165268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 165300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165306 */     GIR_RootConstrainSelectedInstOperands,
     /* 165307 */     // GIR_Coverage, 1384,
     /* 165307 */     GIR_EraseRootFromParent_Done,
     /* 165308 */   // Label 3196: @165308
     /* 165308 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(165353), // Rule ID 1385 //
     /* 165313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165342 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 165345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165351 */     GIR_RootConstrainSelectedInstOperands,
     /* 165352 */     // GIR_Coverage, 1385,
     /* 165352 */     GIR_EraseRootFromParent_Done,
     /* 165353 */   // Label 3197: @165353
     /* 165353 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(165398), // Rule ID 1386 //
     /* 165358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165387 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 165390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165396 */     GIR_RootConstrainSelectedInstOperands,
     /* 165397 */     // GIR_Coverage, 1386,
     /* 165397 */     GIR_EraseRootFromParent_Done,
     /* 165398 */   // Label 3198: @165398
     /* 165398 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(165443), // Rule ID 1387 //
     /* 165403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 165435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165441 */     GIR_RootConstrainSelectedInstOperands,
     /* 165442 */     // GIR_Coverage, 1387,
     /* 165442 */     GIR_EraseRootFromParent_Done,
     /* 165443 */   // Label 3199: @165443
     /* 165443 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(165488), // Rule ID 1388 //
     /* 165448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165477 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 165480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165486 */     GIR_RootConstrainSelectedInstOperands,
     /* 165487 */     // GIR_Coverage, 1388,
     /* 165487 */     GIR_EraseRootFromParent_Done,
     /* 165488 */   // Label 3200: @165488
     /* 165488 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(165533), // Rule ID 1389 //
     /* 165493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165522 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 165525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165531 */     GIR_RootConstrainSelectedInstOperands,
     /* 165532 */     // GIR_Coverage, 1389,
     /* 165532 */     GIR_EraseRootFromParent_Done,
     /* 165533 */   // Label 3201: @165533
     /* 165533 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(165578), // Rule ID 1390 //
     /* 165538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165567 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 165570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165576 */     GIR_RootConstrainSelectedInstOperands,
     /* 165577 */     // GIR_Coverage, 1390,
     /* 165577 */     GIR_EraseRootFromParent_Done,
     /* 165578 */   // Label 3202: @165578
     /* 165578 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(165623), // Rule ID 1397 //
     /* 165583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165612 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 165615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165621 */     GIR_RootConstrainSelectedInstOperands,
     /* 165622 */     // GIR_Coverage, 1397,
     /* 165622 */     GIR_EraseRootFromParent_Done,
     /* 165623 */   // Label 3203: @165623
     /* 165623 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(165668), // Rule ID 1398 //
     /* 165628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165657 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 165660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165666 */     GIR_RootConstrainSelectedInstOperands,
     /* 165667 */     // GIR_Coverage, 1398,
     /* 165667 */     GIR_EraseRootFromParent_Done,
     /* 165668 */   // Label 3204: @165668
     /* 165668 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(165713), // Rule ID 1399 //
     /* 165673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165702 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 165705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165711 */     GIR_RootConstrainSelectedInstOperands,
     /* 165712 */     // GIR_Coverage, 1399,
     /* 165712 */     GIR_EraseRootFromParent_Done,
     /* 165713 */   // Label 3205: @165713
     /* 165713 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(165758), // Rule ID 1400 //
     /* 165718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165747 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 165750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165756 */     GIR_RootConstrainSelectedInstOperands,
     /* 165757 */     // GIR_Coverage, 1400,
     /* 165757 */     GIR_EraseRootFromParent_Done,
     /* 165758 */   // Label 3206: @165758
     /* 165758 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(165803), // Rule ID 1401 //
     /* 165763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165792 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 165795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165801 */     GIR_RootConstrainSelectedInstOperands,
     /* 165802 */     // GIR_Coverage, 1401,
     /* 165802 */     GIR_EraseRootFromParent_Done,
     /* 165803 */   // Label 3207: @165803
     /* 165803 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(165848), // Rule ID 1402 //
     /* 165808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165837 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 165840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165846 */     GIR_RootConstrainSelectedInstOperands,
     /* 165847 */     // GIR_Coverage, 1402,
     /* 165847 */     GIR_EraseRootFromParent_Done,
     /* 165848 */   // Label 3208: @165848
     /* 165848 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(165893), // Rule ID 1409 //
     /* 165853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165882 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 165885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165891 */     GIR_RootConstrainSelectedInstOperands,
     /* 165892 */     // GIR_Coverage, 1409,
     /* 165892 */     GIR_EraseRootFromParent_Done,
     /* 165893 */   // Label 3209: @165893
     /* 165893 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(165938), // Rule ID 1410 //
     /* 165898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165927 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 165930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165936 */     GIR_RootConstrainSelectedInstOperands,
     /* 165937 */     // GIR_Coverage, 1410,
     /* 165937 */     GIR_EraseRootFromParent_Done,
     /* 165938 */   // Label 3210: @165938
     /* 165938 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(165983), // Rule ID 1411 //
     /* 165943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165972 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 165975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165981 */     GIR_RootConstrainSelectedInstOperands,
     /* 165982 */     // GIR_Coverage, 1411,
     /* 165982 */     GIR_EraseRootFromParent_Done,
     /* 165983 */   // Label 3211: @165983
     /* 165983 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(166028), // Rule ID 1412 //
     /* 165988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166017 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 166020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166026 */     GIR_RootConstrainSelectedInstOperands,
     /* 166027 */     // GIR_Coverage, 1412,
     /* 166027 */     GIR_EraseRootFromParent_Done,
     /* 166028 */   // Label 3212: @166028
     /* 166028 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(166073), // Rule ID 1413 //
     /* 166033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166062 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 166065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166071 */     GIR_RootConstrainSelectedInstOperands,
     /* 166072 */     // GIR_Coverage, 1413,
     /* 166072 */     GIR_EraseRootFromParent_Done,
     /* 166073 */   // Label 3213: @166073
     /* 166073 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(166118), // Rule ID 1414 //
     /* 166078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166107 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 166110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166116 */     GIR_RootConstrainSelectedInstOperands,
     /* 166117 */     // GIR_Coverage, 1414,
     /* 166117 */     GIR_EraseRootFromParent_Done,
     /* 166118 */   // Label 3214: @166118
     /* 166118 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(166163), // Rule ID 1415 //
     /* 166123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166152 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 166152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 166155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166161 */     GIR_RootConstrainSelectedInstOperands,
     /* 166162 */     // GIR_Coverage, 1415,
     /* 166162 */     GIR_EraseRootFromParent_Done,
     /* 166163 */   // Label 3215: @166163
     /* 166163 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(166208), // Rule ID 1416 //
     /* 166168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166197 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 166200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166206 */     GIR_RootConstrainSelectedInstOperands,
     /* 166207 */     // GIR_Coverage, 1416,
     /* 166207 */     GIR_EraseRootFromParent_Done,
     /* 166208 */   // Label 3216: @166208
     /* 166208 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(166253), // Rule ID 1417 //
     /* 166213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166242 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 166245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166251 */     GIR_RootConstrainSelectedInstOperands,
     /* 166252 */     // GIR_Coverage, 1417,
     /* 166252 */     GIR_EraseRootFromParent_Done,
     /* 166253 */   // Label 3217: @166253
     /* 166253 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(166298), // Rule ID 1418 //
     /* 166258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166287 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 166290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166296 */     GIR_RootConstrainSelectedInstOperands,
     /* 166297 */     // GIR_Coverage, 1418,
     /* 166297 */     GIR_EraseRootFromParent_Done,
     /* 166298 */   // Label 3218: @166298
     /* 166298 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(166343), // Rule ID 1419 //
     /* 166303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166332 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 166335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166341 */     GIR_RootConstrainSelectedInstOperands,
     /* 166342 */     // GIR_Coverage, 1419,
     /* 166342 */     GIR_EraseRootFromParent_Done,
     /* 166343 */   // Label 3219: @166343
     /* 166343 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(166388), // Rule ID 1420 //
     /* 166348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166377 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 166380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166386 */     GIR_RootConstrainSelectedInstOperands,
     /* 166387 */     // GIR_Coverage, 1420,
     /* 166387 */     GIR_EraseRootFromParent_Done,
     /* 166388 */   // Label 3220: @166388
     /* 166388 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(166433), // Rule ID 1421 //
     /* 166393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166422 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 166425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166431 */     GIR_RootConstrainSelectedInstOperands,
     /* 166432 */     // GIR_Coverage, 1421,
     /* 166432 */     GIR_EraseRootFromParent_Done,
     /* 166433 */   // Label 3221: @166433
     /* 166433 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(166478), // Rule ID 1422 //
     /* 166438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166467 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 166470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166476 */     GIR_RootConstrainSelectedInstOperands,
     /* 166477 */     // GIR_Coverage, 1422,
     /* 166477 */     GIR_EraseRootFromParent_Done,
     /* 166478 */   // Label 3222: @166478
     /* 166478 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(166523), // Rule ID 1423 //
     /* 166483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166512 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 166515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166521 */     GIR_RootConstrainSelectedInstOperands,
     /* 166522 */     // GIR_Coverage, 1423,
     /* 166522 */     GIR_EraseRootFromParent_Done,
     /* 166523 */   // Label 3223: @166523
     /* 166523 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(166568), // Rule ID 1424 //
     /* 166528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166557 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 166557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 166560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166566 */     GIR_RootConstrainSelectedInstOperands,
     /* 166567 */     // GIR_Coverage, 1424,
     /* 166567 */     GIR_EraseRootFromParent_Done,
     /* 166568 */   // Label 3224: @166568
     /* 166568 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(166613), // Rule ID 1425 //
     /* 166573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166602 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 166602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 166605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166611 */     GIR_RootConstrainSelectedInstOperands,
     /* 166612 */     // GIR_Coverage, 1425,
     /* 166612 */     GIR_EraseRootFromParent_Done,
     /* 166613 */   // Label 3225: @166613
     /* 166613 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(166658), // Rule ID 1426 //
     /* 166618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166647 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 166650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166656 */     GIR_RootConstrainSelectedInstOperands,
     /* 166657 */     // GIR_Coverage, 1426,
     /* 166657 */     GIR_EraseRootFromParent_Done,
     /* 166658 */   // Label 3226: @166658
     /* 166658 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(166703), // Rule ID 1427 //
     /* 166663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166692 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 166695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166701 */     GIR_RootConstrainSelectedInstOperands,
     /* 166702 */     // GIR_Coverage, 1427,
     /* 166702 */     GIR_EraseRootFromParent_Done,
     /* 166703 */   // Label 3227: @166703
     /* 166703 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(166748), // Rule ID 1428 //
     /* 166708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166737 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 166740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166746 */     GIR_RootConstrainSelectedInstOperands,
     /* 166747 */     // GIR_Coverage, 1428,
     /* 166747 */     GIR_EraseRootFromParent_Done,
     /* 166748 */   // Label 3228: @166748
     /* 166748 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(166793), // Rule ID 1429 //
     /* 166753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166782 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 166785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166791 */     GIR_RootConstrainSelectedInstOperands,
     /* 166792 */     // GIR_Coverage, 1429,
     /* 166792 */     GIR_EraseRootFromParent_Done,
     /* 166793 */   // Label 3229: @166793
     /* 166793 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(166838), // Rule ID 1430 //
     /* 166798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166827 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 166827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 166830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166836 */     GIR_RootConstrainSelectedInstOperands,
     /* 166837 */     // GIR_Coverage, 1430,
     /* 166837 */     GIR_EraseRootFromParent_Done,
     /* 166838 */   // Label 3230: @166838
     /* 166838 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(166883), // Rule ID 1431 //
     /* 166843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166872 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 166872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 166875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166881 */     GIR_RootConstrainSelectedInstOperands,
     /* 166882 */     // GIR_Coverage, 1431,
     /* 166882 */     GIR_EraseRootFromParent_Done,
     /* 166883 */   // Label 3231: @166883
     /* 166883 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(166928), // Rule ID 1432 //
     /* 166888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166917 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 166917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 166920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166926 */     GIR_RootConstrainSelectedInstOperands,
     /* 166927 */     // GIR_Coverage, 1432,
     /* 166927 */     GIR_EraseRootFromParent_Done,
     /* 166928 */   // Label 3232: @166928
     /* 166928 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(166973), // Rule ID 1433 //
     /* 166933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166962 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 166965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166971 */     GIR_RootConstrainSelectedInstOperands,
     /* 166972 */     // GIR_Coverage, 1433,
     /* 166972 */     GIR_EraseRootFromParent_Done,
     /* 166973 */   // Label 3233: @166973
     /* 166973 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167018), // Rule ID 1434 //
     /* 166978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167007 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 167010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167016 */     GIR_RootConstrainSelectedInstOperands,
     /* 167017 */     // GIR_Coverage, 1434,
     /* 167017 */     GIR_EraseRootFromParent_Done,
     /* 167018 */   // Label 3234: @167018
     /* 167018 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(167063), // Rule ID 1435 //
     /* 167023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167052 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 167055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167061 */     GIR_RootConstrainSelectedInstOperands,
     /* 167062 */     // GIR_Coverage, 1435,
     /* 167062 */     GIR_EraseRootFromParent_Done,
     /* 167063 */   // Label 3235: @167063
     /* 167063 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(167108), // Rule ID 1436 //
     /* 167068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167097 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 167100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167106 */     GIR_RootConstrainSelectedInstOperands,
     /* 167107 */     // GIR_Coverage, 1436,
     /* 167107 */     GIR_EraseRootFromParent_Done,
     /* 167108 */   // Label 3236: @167108
     /* 167108 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(167153), // Rule ID 1437 //
     /* 167113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167142 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 167145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167151 */     GIR_RootConstrainSelectedInstOperands,
     /* 167152 */     // GIR_Coverage, 1437,
     /* 167152 */     GIR_EraseRootFromParent_Done,
     /* 167153 */   // Label 3237: @167153
     /* 167153 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(167198), // Rule ID 1438 //
     /* 167158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167187 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 167190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167196 */     GIR_RootConstrainSelectedInstOperands,
     /* 167197 */     // GIR_Coverage, 1438,
     /* 167197 */     GIR_EraseRootFromParent_Done,
     /* 167198 */   // Label 3238: @167198
     /* 167198 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(167243), // Rule ID 1439 //
     /* 167203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167232 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 167235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167241 */     GIR_RootConstrainSelectedInstOperands,
     /* 167242 */     // GIR_Coverage, 1439,
     /* 167242 */     GIR_EraseRootFromParent_Done,
     /* 167243 */   // Label 3239: @167243
     /* 167243 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(167288), // Rule ID 1440 //
     /* 167248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167277 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 167280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167286 */     GIR_RootConstrainSelectedInstOperands,
     /* 167287 */     // GIR_Coverage, 1440,
     /* 167287 */     GIR_EraseRootFromParent_Done,
     /* 167288 */   // Label 3240: @167288
     /* 167288 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(167333), // Rule ID 1441 //
     /* 167293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167322 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 167325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167331 */     GIR_RootConstrainSelectedInstOperands,
     /* 167332 */     // GIR_Coverage, 1441,
     /* 167332 */     GIR_EraseRootFromParent_Done,
     /* 167333 */   // Label 3241: @167333
     /* 167333 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(167378), // Rule ID 1442 //
     /* 167338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167367 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 167370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167376 */     GIR_RootConstrainSelectedInstOperands,
     /* 167377 */     // GIR_Coverage, 1442,
     /* 167377 */     GIR_EraseRootFromParent_Done,
     /* 167378 */   // Label 3242: @167378
     /* 167378 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(167423), // Rule ID 1443 //
     /* 167383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167412 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 167415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167421 */     GIR_RootConstrainSelectedInstOperands,
     /* 167422 */     // GIR_Coverage, 1443,
     /* 167422 */     GIR_EraseRootFromParent_Done,
     /* 167423 */   // Label 3243: @167423
     /* 167423 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(167468), // Rule ID 1444 //
     /* 167428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167457 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 167460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167466 */     GIR_RootConstrainSelectedInstOperands,
     /* 167467 */     // GIR_Coverage, 1444,
     /* 167467 */     GIR_EraseRootFromParent_Done,
     /* 167468 */   // Label 3244: @167468
     /* 167468 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(167513), // Rule ID 1451 //
     /* 167473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167502 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 167505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167511 */     GIR_RootConstrainSelectedInstOperands,
     /* 167512 */     // GIR_Coverage, 1451,
     /* 167512 */     GIR_EraseRootFromParent_Done,
     /* 167513 */   // Label 3245: @167513
     /* 167513 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(167558), // Rule ID 1452 //
     /* 167518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167547 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 167550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167556 */     GIR_RootConstrainSelectedInstOperands,
     /* 167557 */     // GIR_Coverage, 1452,
     /* 167557 */     GIR_EraseRootFromParent_Done,
     /* 167558 */   // Label 3246: @167558
     /* 167558 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(167603), // Rule ID 1453 //
     /* 167563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167592 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 167595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167601 */     GIR_RootConstrainSelectedInstOperands,
     /* 167602 */     // GIR_Coverage, 1453,
     /* 167602 */     GIR_EraseRootFromParent_Done,
     /* 167603 */   // Label 3247: @167603
     /* 167603 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(167648), // Rule ID 1454 //
     /* 167608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167637 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 167640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167646 */     GIR_RootConstrainSelectedInstOperands,
     /* 167647 */     // GIR_Coverage, 1454,
     /* 167647 */     GIR_EraseRootFromParent_Done,
     /* 167648 */   // Label 3248: @167648
     /* 167648 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(167693), // Rule ID 1455 //
     /* 167653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167682 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 167685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167691 */     GIR_RootConstrainSelectedInstOperands,
     /* 167692 */     // GIR_Coverage, 1455,
     /* 167692 */     GIR_EraseRootFromParent_Done,
     /* 167693 */   // Label 3249: @167693
     /* 167693 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(167738), // Rule ID 1456 //
     /* 167698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167727 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 167730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167736 */     GIR_RootConstrainSelectedInstOperands,
     /* 167737 */     // GIR_Coverage, 1456,
     /* 167737 */     GIR_EraseRootFromParent_Done,
     /* 167738 */   // Label 3250: @167738
     /* 167738 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(167783), // Rule ID 1457 //
     /* 167743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167772 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 167775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167781 */     GIR_RootConstrainSelectedInstOperands,
     /* 167782 */     // GIR_Coverage, 1457,
     /* 167782 */     GIR_EraseRootFromParent_Done,
     /* 167783 */   // Label 3251: @167783
     /* 167783 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(167828), // Rule ID 1458 //
     /* 167788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167817 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 167820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167826 */     GIR_RootConstrainSelectedInstOperands,
     /* 167827 */     // GIR_Coverage, 1458,
     /* 167827 */     GIR_EraseRootFromParent_Done,
     /* 167828 */   // Label 3252: @167828
     /* 167828 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(167873), // Rule ID 1459 //
     /* 167833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167862 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 167865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167871 */     GIR_RootConstrainSelectedInstOperands,
     /* 167872 */     // GIR_Coverage, 1459,
     /* 167872 */     GIR_EraseRootFromParent_Done,
     /* 167873 */   // Label 3253: @167873
     /* 167873 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(167918), // Rule ID 1460 //
     /* 167878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167907 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 167910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167916 */     GIR_RootConstrainSelectedInstOperands,
     /* 167917 */     // GIR_Coverage, 1460,
     /* 167917 */     GIR_EraseRootFromParent_Done,
     /* 167918 */   // Label 3254: @167918
     /* 167918 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(167963), // Rule ID 1461 //
     /* 167923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 167955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167961 */     GIR_RootConstrainSelectedInstOperands,
     /* 167962 */     // GIR_Coverage, 1461,
     /* 167962 */     GIR_EraseRootFromParent_Done,
     /* 167963 */   // Label 3255: @167963
     /* 167963 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(168008), // Rule ID 1462 //
     /* 167968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167997 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 168000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168006 */     GIR_RootConstrainSelectedInstOperands,
     /* 168007 */     // GIR_Coverage, 1462,
     /* 168007 */     GIR_EraseRootFromParent_Done,
     /* 168008 */   // Label 3256: @168008
     /* 168008 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(168053), // Rule ID 1463 //
     /* 168013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 168045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168051 */     GIR_RootConstrainSelectedInstOperands,
     /* 168052 */     // GIR_Coverage, 1463,
     /* 168052 */     GIR_EraseRootFromParent_Done,
     /* 168053 */   // Label 3257: @168053
     /* 168053 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(168098), // Rule ID 1464 //
     /* 168058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168087 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 168090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168096 */     GIR_RootConstrainSelectedInstOperands,
     /* 168097 */     // GIR_Coverage, 1464,
     /* 168097 */     GIR_EraseRootFromParent_Done,
     /* 168098 */   // Label 3258: @168098
     /* 168098 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(168143), // Rule ID 1485 //
     /* 168103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168132 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 168135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168141 */     GIR_RootConstrainSelectedInstOperands,
     /* 168142 */     // GIR_Coverage, 1485,
     /* 168142 */     GIR_EraseRootFromParent_Done,
     /* 168143 */   // Label 3259: @168143
     /* 168143 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(168188), // Rule ID 1487 //
     /* 168148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168177 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 168180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168186 */     GIR_RootConstrainSelectedInstOperands,
     /* 168187 */     // GIR_Coverage, 1487,
     /* 168187 */     GIR_EraseRootFromParent_Done,
     /* 168188 */   // Label 3260: @168188
     /* 168188 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(168233), // Rule ID 1489 //
     /* 168193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168222 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 168225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168231 */     GIR_RootConstrainSelectedInstOperands,
     /* 168232 */     // GIR_Coverage, 1489,
     /* 168232 */     GIR_EraseRootFromParent_Done,
     /* 168233 */   // Label 3261: @168233
     /* 168233 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(168278), // Rule ID 1491 //
     /* 168238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168267 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 168270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168276 */     GIR_RootConstrainSelectedInstOperands,
     /* 168277 */     // GIR_Coverage, 1491,
     /* 168277 */     GIR_EraseRootFromParent_Done,
     /* 168278 */   // Label 3262: @168278
     /* 168278 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(168323), // Rule ID 1493 //
     /* 168283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168312 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 168315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168321 */     GIR_RootConstrainSelectedInstOperands,
     /* 168322 */     // GIR_Coverage, 1493,
     /* 168322 */     GIR_EraseRootFromParent_Done,
     /* 168323 */   // Label 3263: @168323
     /* 168323 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(168368), // Rule ID 1495 //
     /* 168328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168357 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 168360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168366 */     GIR_RootConstrainSelectedInstOperands,
     /* 168367 */     // GIR_Coverage, 1495,
     /* 168367 */     GIR_EraseRootFromParent_Done,
     /* 168368 */   // Label 3264: @168368
     /* 168368 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(168413), // Rule ID 1502 //
     /* 168373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168402 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 168405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168411 */     GIR_RootConstrainSelectedInstOperands,
     /* 168412 */     // GIR_Coverage, 1502,
     /* 168412 */     GIR_EraseRootFromParent_Done,
     /* 168413 */   // Label 3265: @168413
     /* 168413 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(168458), // Rule ID 1503 //
     /* 168418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168447 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 168450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168456 */     GIR_RootConstrainSelectedInstOperands,
     /* 168457 */     // GIR_Coverage, 1503,
     /* 168457 */     GIR_EraseRootFromParent_Done,
     /* 168458 */   // Label 3266: @168458
     /* 168458 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(168503), // Rule ID 1504 //
     /* 168463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168492 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 168495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168501 */     GIR_RootConstrainSelectedInstOperands,
     /* 168502 */     // GIR_Coverage, 1504,
     /* 168502 */     GIR_EraseRootFromParent_Done,
     /* 168503 */   // Label 3267: @168503
     /* 168503 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(168548), // Rule ID 1505 //
     /* 168508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168537 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 168540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168546 */     GIR_RootConstrainSelectedInstOperands,
     /* 168547 */     // GIR_Coverage, 1505,
     /* 168547 */     GIR_EraseRootFromParent_Done,
     /* 168548 */   // Label 3268: @168548
     /* 168548 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(168593), // Rule ID 1506 //
     /* 168553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168582 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 168585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168591 */     GIR_RootConstrainSelectedInstOperands,
     /* 168592 */     // GIR_Coverage, 1506,
     /* 168592 */     GIR_EraseRootFromParent_Done,
     /* 168593 */   // Label 3269: @168593
     /* 168593 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(168638), // Rule ID 1507 //
     /* 168598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168627 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 168630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168636 */     GIR_RootConstrainSelectedInstOperands,
     /* 168637 */     // GIR_Coverage, 1507,
     /* 168637 */     GIR_EraseRootFromParent_Done,
     /* 168638 */   // Label 3270: @168638
     /* 168638 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(168683), // Rule ID 1508 //
     /* 168643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168672 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 168675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168681 */     GIR_RootConstrainSelectedInstOperands,
     /* 168682 */     // GIR_Coverage, 1508,
     /* 168682 */     GIR_EraseRootFromParent_Done,
     /* 168683 */   // Label 3271: @168683
     /* 168683 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(168728), // Rule ID 1509 //
     /* 168688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168717 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 168720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168726 */     GIR_RootConstrainSelectedInstOperands,
     /* 168727 */     // GIR_Coverage, 1509,
     /* 168727 */     GIR_EraseRootFromParent_Done,
     /* 168728 */   // Label 3272: @168728
     /* 168728 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(168773), // Rule ID 1510 //
     /* 168733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168762 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 168765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168771 */     GIR_RootConstrainSelectedInstOperands,
     /* 168772 */     // GIR_Coverage, 1510,
     /* 168772 */     GIR_EraseRootFromParent_Done,
     /* 168773 */   // Label 3273: @168773
     /* 168773 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(168818), // Rule ID 1511 //
     /* 168778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168807 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 168810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168816 */     GIR_RootConstrainSelectedInstOperands,
     /* 168817 */     // GIR_Coverage, 1511,
     /* 168817 */     GIR_EraseRootFromParent_Done,
     /* 168818 */   // Label 3274: @168818
     /* 168818 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(168863), // Rule ID 1512 //
     /* 168823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168852 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 168855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168861 */     GIR_RootConstrainSelectedInstOperands,
     /* 168862 */     // GIR_Coverage, 1512,
     /* 168862 */     GIR_EraseRootFromParent_Done,
     /* 168863 */   // Label 3275: @168863
     /* 168863 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(168908), // Rule ID 1513 //
     /* 168868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168897 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 168900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168906 */     GIR_RootConstrainSelectedInstOperands,
     /* 168907 */     // GIR_Coverage, 1513,
     /* 168907 */     GIR_EraseRootFromParent_Done,
     /* 168908 */   // Label 3276: @168908
     /* 168908 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(168953), // Rule ID 1520 //
     /* 168913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 168921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168942 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 168945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168951 */     GIR_RootConstrainSelectedInstOperands,
     /* 168952 */     // GIR_Coverage, 1520,
     /* 168952 */     GIR_EraseRootFromParent_Done,
     /* 168953 */   // Label 3277: @168953
     /* 168953 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(168998), // Rule ID 1521 //
     /* 168958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 168966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168987 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 168990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168996 */     GIR_RootConstrainSelectedInstOperands,
     /* 168997 */     // GIR_Coverage, 1521,
     /* 168997 */     GIR_EraseRootFromParent_Done,
     /* 168998 */   // Label 3278: @168998
     /* 168998 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(169043), // Rule ID 1522 //
     /* 169003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169032 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 169035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169041 */     GIR_RootConstrainSelectedInstOperands,
     /* 169042 */     // GIR_Coverage, 1522,
     /* 169042 */     GIR_EraseRootFromParent_Done,
     /* 169043 */   // Label 3279: @169043
     /* 169043 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(169088), // Rule ID 1523 //
     /* 169048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169077 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 169080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169086 */     GIR_RootConstrainSelectedInstOperands,
     /* 169087 */     // GIR_Coverage, 1523,
     /* 169087 */     GIR_EraseRootFromParent_Done,
     /* 169088 */   // Label 3280: @169088
     /* 169088 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(169133), // Rule ID 1524 //
     /* 169093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169122 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 169125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169131 */     GIR_RootConstrainSelectedInstOperands,
     /* 169132 */     // GIR_Coverage, 1524,
     /* 169132 */     GIR_EraseRootFromParent_Done,
     /* 169133 */   // Label 3281: @169133
     /* 169133 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(169178), // Rule ID 1525 //
     /* 169138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169167 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 169170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169176 */     GIR_RootConstrainSelectedInstOperands,
     /* 169177 */     // GIR_Coverage, 1525,
     /* 169177 */     GIR_EraseRootFromParent_Done,
     /* 169178 */   // Label 3282: @169178
     /* 169178 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(169223), // Rule ID 1532 //
     /* 169183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169212 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 169215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169221 */     GIR_RootConstrainSelectedInstOperands,
     /* 169222 */     // GIR_Coverage, 1532,
     /* 169222 */     GIR_EraseRootFromParent_Done,
     /* 169223 */   // Label 3283: @169223
     /* 169223 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(169268), // Rule ID 1533 //
     /* 169228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169257 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 169260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169266 */     GIR_RootConstrainSelectedInstOperands,
     /* 169267 */     // GIR_Coverage, 1533,
     /* 169267 */     GIR_EraseRootFromParent_Done,
     /* 169268 */   // Label 3284: @169268
     /* 169268 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(169313), // Rule ID 1534 //
     /* 169273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169302 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 169305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169311 */     GIR_RootConstrainSelectedInstOperands,
     /* 169312 */     // GIR_Coverage, 1534,
     /* 169312 */     GIR_EraseRootFromParent_Done,
     /* 169313 */   // Label 3285: @169313
     /* 169313 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(169358), // Rule ID 1535 //
     /* 169318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169347 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 169350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169356 */     GIR_RootConstrainSelectedInstOperands,
     /* 169357 */     // GIR_Coverage, 1535,
     /* 169357 */     GIR_EraseRootFromParent_Done,
     /* 169358 */   // Label 3286: @169358
     /* 169358 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(169403), // Rule ID 1536 //
     /* 169363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169392 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 169395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169401 */     GIR_RootConstrainSelectedInstOperands,
     /* 169402 */     // GIR_Coverage, 1536,
     /* 169402 */     GIR_EraseRootFromParent_Done,
     /* 169403 */   // Label 3287: @169403
     /* 169403 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(169448), // Rule ID 1537 //
     /* 169408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169437 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 169440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169446 */     GIR_RootConstrainSelectedInstOperands,
     /* 169447 */     // GIR_Coverage, 1537,
     /* 169447 */     GIR_EraseRootFromParent_Done,
     /* 169448 */   // Label 3288: @169448
     /* 169448 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(169493), // Rule ID 1538 //
     /* 169453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169482 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 169485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169491 */     GIR_RootConstrainSelectedInstOperands,
     /* 169492 */     // GIR_Coverage, 1538,
     /* 169492 */     GIR_EraseRootFromParent_Done,
     /* 169493 */   // Label 3289: @169493
     /* 169493 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(169538), // Rule ID 1539 //
     /* 169498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169527 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 169530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169536 */     GIR_RootConstrainSelectedInstOperands,
     /* 169537 */     // GIR_Coverage, 1539,
     /* 169537 */     GIR_EraseRootFromParent_Done,
     /* 169538 */   // Label 3290: @169538
     /* 169538 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(169583), // Rule ID 1540 //
     /* 169543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169572 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 169575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169581 */     GIR_RootConstrainSelectedInstOperands,
     /* 169582 */     // GIR_Coverage, 1540,
     /* 169582 */     GIR_EraseRootFromParent_Done,
     /* 169583 */   // Label 3291: @169583
     /* 169583 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(169628), // Rule ID 1541 //
     /* 169588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169617 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 169620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169626 */     GIR_RootConstrainSelectedInstOperands,
     /* 169627 */     // GIR_Coverage, 1541,
     /* 169627 */     GIR_EraseRootFromParent_Done,
     /* 169628 */   // Label 3292: @169628
     /* 169628 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(169673), // Rule ID 1542 //
     /* 169633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169662 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 169665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169671 */     GIR_RootConstrainSelectedInstOperands,
     /* 169672 */     // GIR_Coverage, 1542,
     /* 169672 */     GIR_EraseRootFromParent_Done,
     /* 169673 */   // Label 3293: @169673
     /* 169673 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(169718), // Rule ID 1543 //
     /* 169678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169707 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 169710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169716 */     GIR_RootConstrainSelectedInstOperands,
     /* 169717 */     // GIR_Coverage, 1543,
     /* 169717 */     GIR_EraseRootFromParent_Done,
     /* 169718 */   // Label 3294: @169718
     /* 169718 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(169763), // Rule ID 1544 //
     /* 169723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 169755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169761 */     GIR_RootConstrainSelectedInstOperands,
     /* 169762 */     // GIR_Coverage, 1544,
     /* 169762 */     GIR_EraseRootFromParent_Done,
     /* 169763 */   // Label 3295: @169763
     /* 169763 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(169808), // Rule ID 1545 //
     /* 169768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169797 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 169800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169806 */     GIR_RootConstrainSelectedInstOperands,
     /* 169807 */     // GIR_Coverage, 1545,
     /* 169807 */     GIR_EraseRootFromParent_Done,
     /* 169808 */   // Label 3296: @169808
     /* 169808 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(169853), // Rule ID 1546 //
     /* 169813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169842 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 169845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169851 */     GIR_RootConstrainSelectedInstOperands,
     /* 169852 */     // GIR_Coverage, 1546,
     /* 169852 */     GIR_EraseRootFromParent_Done,
     /* 169853 */   // Label 3297: @169853
     /* 169853 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(169898), // Rule ID 1547 //
     /* 169858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169887 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 169890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169896 */     GIR_RootConstrainSelectedInstOperands,
     /* 169897 */     // GIR_Coverage, 1547,
     /* 169897 */     GIR_EraseRootFromParent_Done,
     /* 169898 */   // Label 3298: @169898
     /* 169898 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(169943), // Rule ID 1548 //
     /* 169903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169932 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 169935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169941 */     GIR_RootConstrainSelectedInstOperands,
     /* 169942 */     // GIR_Coverage, 1548,
     /* 169942 */     GIR_EraseRootFromParent_Done,
     /* 169943 */   // Label 3299: @169943
     /* 169943 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(169988), // Rule ID 1549 //
     /* 169948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169977 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 169980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169986 */     GIR_RootConstrainSelectedInstOperands,
     /* 169987 */     // GIR_Coverage, 1549,
     /* 169987 */     GIR_EraseRootFromParent_Done,
     /* 169988 */   // Label 3300: @169988
     /* 169988 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(170033), // Rule ID 1550 //
     /* 169993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170022 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 170025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170031 */     GIR_RootConstrainSelectedInstOperands,
     /* 170032 */     // GIR_Coverage, 1550,
     /* 170032 */     GIR_EraseRootFromParent_Done,
     /* 170033 */   // Label 3301: @170033
     /* 170033 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(170078), // Rule ID 1551 //
     /* 170038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170067 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 170070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170076 */     GIR_RootConstrainSelectedInstOperands,
     /* 170077 */     // GIR_Coverage, 1551,
     /* 170077 */     GIR_EraseRootFromParent_Done,
     /* 170078 */   // Label 3302: @170078
     /* 170078 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(170123), // Rule ID 1552 //
     /* 170083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170112 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 170115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170121 */     GIR_RootConstrainSelectedInstOperands,
     /* 170122 */     // GIR_Coverage, 1552,
     /* 170122 */     GIR_EraseRootFromParent_Done,
     /* 170123 */   // Label 3303: @170123
     /* 170123 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(170168), // Rule ID 1553 //
     /* 170128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170157 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 170160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170166 */     GIR_RootConstrainSelectedInstOperands,
     /* 170167 */     // GIR_Coverage, 1553,
     /* 170167 */     GIR_EraseRootFromParent_Done,
     /* 170168 */   // Label 3304: @170168
     /* 170168 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(170213), // Rule ID 1554 //
     /* 170173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170202 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 170205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170211 */     GIR_RootConstrainSelectedInstOperands,
     /* 170212 */     // GIR_Coverage, 1554,
     /* 170212 */     GIR_EraseRootFromParent_Done,
     /* 170213 */   // Label 3305: @170213
     /* 170213 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(170258), // Rule ID 1555 //
     /* 170218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170247 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 170250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170256 */     GIR_RootConstrainSelectedInstOperands,
     /* 170257 */     // GIR_Coverage, 1555,
     /* 170257 */     GIR_EraseRootFromParent_Done,
     /* 170258 */   // Label 3306: @170258
     /* 170258 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(170303), // Rule ID 1556 //
     /* 170263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170292 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 170295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170301 */     GIR_RootConstrainSelectedInstOperands,
     /* 170302 */     // GIR_Coverage, 1556,
     /* 170302 */     GIR_EraseRootFromParent_Done,
     /* 170303 */   // Label 3307: @170303
     /* 170303 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(170348), // Rule ID 1557 //
     /* 170308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170337 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 170340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170346 */     GIR_RootConstrainSelectedInstOperands,
     /* 170347 */     // GIR_Coverage, 1557,
     /* 170347 */     GIR_EraseRootFromParent_Done,
     /* 170348 */   // Label 3308: @170348
     /* 170348 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(170393), // Rule ID 1558 //
     /* 170353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170382 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 170385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170391 */     GIR_RootConstrainSelectedInstOperands,
     /* 170392 */     // GIR_Coverage, 1558,
     /* 170392 */     GIR_EraseRootFromParent_Done,
     /* 170393 */   // Label 3309: @170393
     /* 170393 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(170438), // Rule ID 1559 //
     /* 170398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170427 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 170430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170436 */     GIR_RootConstrainSelectedInstOperands,
     /* 170437 */     // GIR_Coverage, 1559,
     /* 170437 */     GIR_EraseRootFromParent_Done,
     /* 170438 */   // Label 3310: @170438
     /* 170438 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(170483), // Rule ID 1566 //
     /* 170443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170472 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 170475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170481 */     GIR_RootConstrainSelectedInstOperands,
     /* 170482 */     // GIR_Coverage, 1566,
     /* 170482 */     GIR_EraseRootFromParent_Done,
     /* 170483 */   // Label 3311: @170483
     /* 170483 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(170528), // Rule ID 1567 //
     /* 170488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170517 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 170520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170526 */     GIR_RootConstrainSelectedInstOperands,
     /* 170527 */     // GIR_Coverage, 1567,
     /* 170527 */     GIR_EraseRootFromParent_Done,
     /* 170528 */   // Label 3312: @170528
     /* 170528 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(170573), // Rule ID 1568 //
     /* 170533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170562 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 170565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170571 */     GIR_RootConstrainSelectedInstOperands,
     /* 170572 */     // GIR_Coverage, 1568,
     /* 170572 */     GIR_EraseRootFromParent_Done,
     /* 170573 */   // Label 3313: @170573
     /* 170573 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(170618), // Rule ID 1569 //
     /* 170578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170607 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 170610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170616 */     GIR_RootConstrainSelectedInstOperands,
     /* 170617 */     // GIR_Coverage, 1569,
     /* 170617 */     GIR_EraseRootFromParent_Done,
     /* 170618 */   // Label 3314: @170618
     /* 170618 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(170663), // Rule ID 1570 //
     /* 170623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170652 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 170655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170661 */     GIR_RootConstrainSelectedInstOperands,
     /* 170662 */     // GIR_Coverage, 1570,
     /* 170662 */     GIR_EraseRootFromParent_Done,
     /* 170663 */   // Label 3315: @170663
     /* 170663 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(170708), // Rule ID 1571 //
     /* 170668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170697 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 170700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170706 */     GIR_RootConstrainSelectedInstOperands,
     /* 170707 */     // GIR_Coverage, 1571,
     /* 170707 */     GIR_EraseRootFromParent_Done,
     /* 170708 */   // Label 3316: @170708
     /* 170708 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(170753), // Rule ID 1572 //
     /* 170713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170742 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 170745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170751 */     GIR_RootConstrainSelectedInstOperands,
     /* 170752 */     // GIR_Coverage, 1572,
     /* 170752 */     GIR_EraseRootFromParent_Done,
     /* 170753 */   // Label 3317: @170753
     /* 170753 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(170798), // Rule ID 1573 //
     /* 170758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170787 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 170790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170796 */     GIR_RootConstrainSelectedInstOperands,
     /* 170797 */     // GIR_Coverage, 1573,
     /* 170797 */     GIR_EraseRootFromParent_Done,
     /* 170798 */   // Label 3318: @170798
     /* 170798 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(170843), // Rule ID 1574 //
     /* 170803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170832 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 170835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170841 */     GIR_RootConstrainSelectedInstOperands,
     /* 170842 */     // GIR_Coverage, 1574,
     /* 170842 */     GIR_EraseRootFromParent_Done,
     /* 170843 */   // Label 3319: @170843
     /* 170843 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(170888), // Rule ID 1575 //
     /* 170848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170877 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 170880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170886 */     GIR_RootConstrainSelectedInstOperands,
     /* 170887 */     // GIR_Coverage, 1575,
     /* 170887 */     GIR_EraseRootFromParent_Done,
     /* 170888 */   // Label 3320: @170888
     /* 170888 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(170933), // Rule ID 1576 //
     /* 170893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170922 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 170925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170931 */     GIR_RootConstrainSelectedInstOperands,
     /* 170932 */     // GIR_Coverage, 1576,
     /* 170932 */     GIR_EraseRootFromParent_Done,
     /* 170933 */   // Label 3321: @170933
     /* 170933 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(170978), // Rule ID 1577 //
     /* 170938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170967 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 170970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170976 */     GIR_RootConstrainSelectedInstOperands,
     /* 170977 */     // GIR_Coverage, 1577,
     /* 170977 */     GIR_EraseRootFromParent_Done,
     /* 170978 */   // Label 3322: @170978
     /* 170978 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(171023), // Rule ID 1578 //
     /* 170983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 171015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171021 */     GIR_RootConstrainSelectedInstOperands,
     /* 171022 */     // GIR_Coverage, 1578,
     /* 171022 */     GIR_EraseRootFromParent_Done,
     /* 171023 */   // Label 3323: @171023
     /* 171023 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(171068), // Rule ID 1579 //
     /* 171028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171057 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 171057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 171060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171066 */     GIR_RootConstrainSelectedInstOperands,
     /* 171067 */     // GIR_Coverage, 1579,
     /* 171067 */     GIR_EraseRootFromParent_Done,
     /* 171068 */   // Label 3324: @171068
     /* 171068 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(171113), // Rule ID 1607 //
     /* 171073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171102 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 171105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171111 */     GIR_RootConstrainSelectedInstOperands,
     /* 171112 */     // GIR_Coverage, 1607,
     /* 171112 */     GIR_EraseRootFromParent_Done,
     /* 171113 */   // Label 3325: @171113
     /* 171113 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(171158), // Rule ID 1608 //
     /* 171118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171147 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 171150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171156 */     GIR_RootConstrainSelectedInstOperands,
     /* 171157 */     // GIR_Coverage, 1608,
     /* 171157 */     GIR_EraseRootFromParent_Done,
     /* 171158 */   // Label 3326: @171158
     /* 171158 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(171203), // Rule ID 1609 //
     /* 171163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171192 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 171195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171201 */     GIR_RootConstrainSelectedInstOperands,
     /* 171202 */     // GIR_Coverage, 1609,
     /* 171202 */     GIR_EraseRootFromParent_Done,
     /* 171203 */   // Label 3327: @171203
     /* 171203 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(171248), // Rule ID 1610 //
     /* 171208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171237 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 171240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171246 */     GIR_RootConstrainSelectedInstOperands,
     /* 171247 */     // GIR_Coverage, 1610,
     /* 171247 */     GIR_EraseRootFromParent_Done,
     /* 171248 */   // Label 3328: @171248
     /* 171248 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(171293), // Rule ID 1611 //
     /* 171253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171282 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 171285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171291 */     GIR_RootConstrainSelectedInstOperands,
     /* 171292 */     // GIR_Coverage, 1611,
     /* 171292 */     GIR_EraseRootFromParent_Done,
     /* 171293 */   // Label 3329: @171293
     /* 171293 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(171338), // Rule ID 1612 //
     /* 171298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171327 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 171330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171336 */     GIR_RootConstrainSelectedInstOperands,
     /* 171337 */     // GIR_Coverage, 1612,
     /* 171337 */     GIR_EraseRootFromParent_Done,
     /* 171338 */   // Label 3330: @171338
     /* 171338 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(171383), // Rule ID 1613 //
     /* 171343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171372 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 171375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171381 */     GIR_RootConstrainSelectedInstOperands,
     /* 171382 */     // GIR_Coverage, 1613,
     /* 171382 */     GIR_EraseRootFromParent_Done,
     /* 171383 */   // Label 3331: @171383
     /* 171383 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(171428), // Rule ID 1620 //
     /* 171388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171417 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 171420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171426 */     GIR_RootConstrainSelectedInstOperands,
     /* 171427 */     // GIR_Coverage, 1620,
     /* 171427 */     GIR_EraseRootFromParent_Done,
     /* 171428 */   // Label 3332: @171428
     /* 171428 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(171473), // Rule ID 1621 //
     /* 171433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171462 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 171465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171471 */     GIR_RootConstrainSelectedInstOperands,
     /* 171472 */     // GIR_Coverage, 1621,
     /* 171472 */     GIR_EraseRootFromParent_Done,
     /* 171473 */   // Label 3333: @171473
     /* 171473 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(171518), // Rule ID 1622 //
     /* 171478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171507 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 171510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171516 */     GIR_RootConstrainSelectedInstOperands,
     /* 171517 */     // GIR_Coverage, 1622,
     /* 171517 */     GIR_EraseRootFromParent_Done,
     /* 171518 */   // Label 3334: @171518
     /* 171518 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(171563), // Rule ID 1623 //
     /* 171523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171552 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 171555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171561 */     GIR_RootConstrainSelectedInstOperands,
     /* 171562 */     // GIR_Coverage, 1623,
     /* 171562 */     GIR_EraseRootFromParent_Done,
     /* 171563 */   // Label 3335: @171563
     /* 171563 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(171608), // Rule ID 1624 //
     /* 171568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171597 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 171600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171606 */     GIR_RootConstrainSelectedInstOperands,
     /* 171607 */     // GIR_Coverage, 1624,
     /* 171607 */     GIR_EraseRootFromParent_Done,
     /* 171608 */   // Label 3336: @171608
     /* 171608 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(171653), // Rule ID 1625 //
     /* 171613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171642 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 171645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171651 */     GIR_RootConstrainSelectedInstOperands,
     /* 171652 */     // GIR_Coverage, 1625,
     /* 171652 */     GIR_EraseRootFromParent_Done,
     /* 171653 */   // Label 3337: @171653
     /* 171653 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(171698), // Rule ID 1626 //
     /* 171658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171687 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 171690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171696 */     GIR_RootConstrainSelectedInstOperands,
     /* 171697 */     // GIR_Coverage, 1626,
     /* 171697 */     GIR_EraseRootFromParent_Done,
     /* 171698 */   // Label 3338: @171698
     /* 171698 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(171743), // Rule ID 1627 //
     /* 171703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171732 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 171735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171741 */     GIR_RootConstrainSelectedInstOperands,
     /* 171742 */     // GIR_Coverage, 1627,
     /* 171742 */     GIR_EraseRootFromParent_Done,
     /* 171743 */   // Label 3339: @171743
     /* 171743 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(171788), // Rule ID 1628 //
     /* 171748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171777 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 171780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171786 */     GIR_RootConstrainSelectedInstOperands,
     /* 171787 */     // GIR_Coverage, 1628,
     /* 171787 */     GIR_EraseRootFromParent_Done,
     /* 171788 */   // Label 3340: @171788
     /* 171788 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(171833), // Rule ID 1629 //
     /* 171793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171822 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 171822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 171825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171831 */     GIR_RootConstrainSelectedInstOperands,
     /* 171832 */     // GIR_Coverage, 1629,
     /* 171832 */     GIR_EraseRootFromParent_Done,
     /* 171833 */   // Label 3341: @171833
     /* 171833 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(171878), // Rule ID 1630 //
     /* 171838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 171846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171867 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 171867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 171870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171876 */     GIR_RootConstrainSelectedInstOperands,
     /* 171877 */     // GIR_Coverage, 1630,
     /* 171877 */     GIR_EraseRootFromParent_Done,
     /* 171878 */   // Label 3342: @171878
     /* 171878 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(171923), // Rule ID 1631 //
     /* 171883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 171891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171912 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 171912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 171915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171921 */     GIR_RootConstrainSelectedInstOperands,
     /* 171922 */     // GIR_Coverage, 1631,
     /* 171922 */     GIR_EraseRootFromParent_Done,
     /* 171923 */   // Label 3343: @171923
     /* 171923 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(171968), // Rule ID 1632 //
     /* 171928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 171936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171957 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 171957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 171960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171966 */     GIR_RootConstrainSelectedInstOperands,
     /* 171967 */     // GIR_Coverage, 1632,
     /* 171967 */     GIR_EraseRootFromParent_Done,
     /* 171968 */   // Label 3344: @171968
     /* 171968 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(172013), // Rule ID 1633 //
     /* 171973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 171981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172002 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 172005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172011 */     GIR_RootConstrainSelectedInstOperands,
     /* 172012 */     // GIR_Coverage, 1633,
     /* 172012 */     GIR_EraseRootFromParent_Done,
     /* 172013 */   // Label 3345: @172013
     /* 172013 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(172058), // Rule ID 1634 //
     /* 172018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172047 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 172050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172056 */     GIR_RootConstrainSelectedInstOperands,
     /* 172057 */     // GIR_Coverage, 1634,
     /* 172057 */     GIR_EraseRootFromParent_Done,
     /* 172058 */   // Label 3346: @172058
     /* 172058 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(172103), // Rule ID 1635 //
     /* 172063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 172071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172092 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 172095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172101 */     GIR_RootConstrainSelectedInstOperands,
     /* 172102 */     // GIR_Coverage, 1635,
     /* 172102 */     GIR_EraseRootFromParent_Done,
     /* 172103 */   // Label 3347: @172103
     /* 172103 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(172148), // Rule ID 1636 //
     /* 172108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 172116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172137 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 172140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172146 */     GIR_RootConstrainSelectedInstOperands,
     /* 172147 */     // GIR_Coverage, 1636,
     /* 172147 */     GIR_EraseRootFromParent_Done,
     /* 172148 */   // Label 3348: @172148
     /* 172148 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(172193), // Rule ID 1638 //
     /* 172153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 172161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172182 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 172185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172191 */     GIR_RootConstrainSelectedInstOperands,
     /* 172192 */     // GIR_Coverage, 1638,
     /* 172192 */     GIR_EraseRootFromParent_Done,
     /* 172193 */   // Label 3349: @172193
     /* 172193 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(172238), // Rule ID 1639 //
     /* 172198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172227 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 172230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172236 */     GIR_RootConstrainSelectedInstOperands,
     /* 172237 */     // GIR_Coverage, 1639,
     /* 172237 */     GIR_EraseRootFromParent_Done,
     /* 172238 */   // Label 3350: @172238
     /* 172238 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(172283), // Rule ID 1640 //
     /* 172243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172272 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 172275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172281 */     GIR_RootConstrainSelectedInstOperands,
     /* 172282 */     // GIR_Coverage, 1640,
     /* 172282 */     GIR_EraseRootFromParent_Done,
     /* 172283 */   // Label 3351: @172283
     /* 172283 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(172328), // Rule ID 1641 //
     /* 172288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172317 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 172320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172326 */     GIR_RootConstrainSelectedInstOperands,
     /* 172327 */     // GIR_Coverage, 1641,
     /* 172327 */     GIR_EraseRootFromParent_Done,
     /* 172328 */   // Label 3352: @172328
     /* 172328 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(172373), // Rule ID 1642 //
     /* 172333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 172341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172362 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 172365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172371 */     GIR_RootConstrainSelectedInstOperands,
     /* 172372 */     // GIR_Coverage, 1642,
     /* 172372 */     GIR_EraseRootFromParent_Done,
     /* 172373 */   // Label 3353: @172373
     /* 172373 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(172418), // Rule ID 1643 //
     /* 172378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 172386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172407 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 172410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172416 */     GIR_RootConstrainSelectedInstOperands,
     /* 172417 */     // GIR_Coverage, 1643,
     /* 172417 */     GIR_EraseRootFromParent_Done,
     /* 172418 */   // Label 3354: @172418
     /* 172418 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(172463), // Rule ID 1644 //
     /* 172423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 172431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172452 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 172452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 172455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172461 */     GIR_RootConstrainSelectedInstOperands,
     /* 172462 */     // GIR_Coverage, 1644,
     /* 172462 */     GIR_EraseRootFromParent_Done,
     /* 172463 */   // Label 3355: @172463
     /* 172463 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(172508), // Rule ID 1658 //
     /* 172468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 172476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172497 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 172497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 172500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172506 */     GIR_RootConstrainSelectedInstOperands,
     /* 172507 */     // GIR_Coverage, 1658,
     /* 172507 */     GIR_EraseRootFromParent_Done,
     /* 172508 */   // Label 3356: @172508
     /* 172508 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(172553), // Rule ID 1659 //
     /* 172513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 172521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172542 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 172542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 172545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172551 */     GIR_RootConstrainSelectedInstOperands,
     /* 172552 */     // GIR_Coverage, 1659,
     /* 172552 */     GIR_EraseRootFromParent_Done,
     /* 172553 */   // Label 3357: @172553
     /* 172553 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(172598), // Rule ID 1664 //
     /* 172558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 172566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172587 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 172587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 172590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172596 */     GIR_RootConstrainSelectedInstOperands,
     /* 172597 */     // GIR_Coverage, 1664,
     /* 172597 */     GIR_EraseRootFromParent_Done,
     /* 172598 */   // Label 3358: @172598
     /* 172598 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(172643), // Rule ID 1665 //
     /* 172603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 172611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172632 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 172632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 172635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172641 */     GIR_RootConstrainSelectedInstOperands,
     /* 172642 */     // GIR_Coverage, 1665,
     /* 172642 */     GIR_EraseRootFromParent_Done,
     /* 172643 */   // Label 3359: @172643
     /* 172643 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(172688), // Rule ID 1666 //
     /* 172648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 172656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172677 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 172680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172686 */     GIR_RootConstrainSelectedInstOperands,
     /* 172687 */     // GIR_Coverage, 1666,
     /* 172687 */     GIR_EraseRootFromParent_Done,
     /* 172688 */   // Label 3360: @172688
     /* 172688 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(172733), // Rule ID 1667 //
     /* 172693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 172701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172722 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 172725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172731 */     GIR_RootConstrainSelectedInstOperands,
     /* 172732 */     // GIR_Coverage, 1667,
     /* 172732 */     GIR_EraseRootFromParent_Done,
     /* 172733 */   // Label 3361: @172733
     /* 172733 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(172778), // Rule ID 1668 //
     /* 172738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 172746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172767 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 172770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172776 */     GIR_RootConstrainSelectedInstOperands,
     /* 172777 */     // GIR_Coverage, 1668,
     /* 172777 */     GIR_EraseRootFromParent_Done,
     /* 172778 */   // Label 3362: @172778
     /* 172778 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(172823), // Rule ID 1669 //
     /* 172783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 172791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172812 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 172815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172821 */     GIR_RootConstrainSelectedInstOperands,
     /* 172822 */     // GIR_Coverage, 1669,
     /* 172822 */     GIR_EraseRootFromParent_Done,
     /* 172823 */   // Label 3363: @172823
     /* 172823 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(172868), // Rule ID 1670 //
     /* 172828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 172836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172857 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 172860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172866 */     GIR_RootConstrainSelectedInstOperands,
     /* 172867 */     // GIR_Coverage, 1670,
     /* 172867 */     GIR_EraseRootFromParent_Done,
     /* 172868 */   // Label 3364: @172868
     /* 172868 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(172913), // Rule ID 1671 //
     /* 172873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 172881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172902 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 172905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172911 */     GIR_RootConstrainSelectedInstOperands,
     /* 172912 */     // GIR_Coverage, 1671,
     /* 172912 */     GIR_EraseRootFromParent_Done,
     /* 172913 */   // Label 3365: @172913
     /* 172913 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(172958), // Rule ID 1672 //
     /* 172918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 172926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172947 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 172950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172956 */     GIR_RootConstrainSelectedInstOperands,
     /* 172957 */     // GIR_Coverage, 1672,
     /* 172957 */     GIR_EraseRootFromParent_Done,
     /* 172958 */   // Label 3366: @172958
     /* 172958 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(173003), // Rule ID 1673 //
     /* 172963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 172971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172992 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 172995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173001 */     GIR_RootConstrainSelectedInstOperands,
     /* 173002 */     // GIR_Coverage, 1673,
     /* 173002 */     GIR_EraseRootFromParent_Done,
     /* 173003 */   // Label 3367: @173003
     /* 173003 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(173048), // Rule ID 1674 //
     /* 173008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 173016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173037 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 173040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173046 */     GIR_RootConstrainSelectedInstOperands,
     /* 173047 */     // GIR_Coverage, 1674,
     /* 173047 */     GIR_EraseRootFromParent_Done,
     /* 173048 */   // Label 3368: @173048
     /* 173048 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(173093), // Rule ID 1675 //
     /* 173053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173082 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 173085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173091 */     GIR_RootConstrainSelectedInstOperands,
     /* 173092 */     // GIR_Coverage, 1675,
     /* 173092 */     GIR_EraseRootFromParent_Done,
     /* 173093 */   // Label 3369: @173093
     /* 173093 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(173138), // Rule ID 1676 //
     /* 173098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173127 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 173130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173136 */     GIR_RootConstrainSelectedInstOperands,
     /* 173137 */     // GIR_Coverage, 1676,
     /* 173137 */     GIR_EraseRootFromParent_Done,
     /* 173138 */   // Label 3370: @173138
     /* 173138 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(173183), // Rule ID 1677 //
     /* 173143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173172 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 173175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173181 */     GIR_RootConstrainSelectedInstOperands,
     /* 173182 */     // GIR_Coverage, 1677,
     /* 173182 */     GIR_EraseRootFromParent_Done,
     /* 173183 */   // Label 3371: @173183
     /* 173183 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(173228), // Rule ID 1743 //
     /* 173188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173217 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 173220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173226 */     GIR_RootConstrainSelectedInstOperands,
     /* 173227 */     // GIR_Coverage, 1743,
     /* 173227 */     GIR_EraseRootFromParent_Done,
     /* 173228 */   // Label 3372: @173228
     /* 173228 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(173273), // Rule ID 1745 //
     /* 173233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173262 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 173265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173271 */     GIR_RootConstrainSelectedInstOperands,
     /* 173272 */     // GIR_Coverage, 1745,
     /* 173272 */     GIR_EraseRootFromParent_Done,
     /* 173273 */   // Label 3373: @173273
     /* 173273 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(173318), // Rule ID 2294 //
     /* 173278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 173281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 173286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173307 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 173307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 173310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173316 */     GIR_RootConstrainSelectedInstOperands,
     /* 173317 */     // GIR_Coverage, 2294,
     /* 173317 */     GIR_EraseRootFromParent_Done,
     /* 173318 */   // Label 3374: @173318
     /* 173318 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(173363), // Rule ID 2295 //
     /* 173323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 173326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 173331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173352 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 173352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 173355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173361 */     GIR_RootConstrainSelectedInstOperands,
     /* 173362 */     // GIR_Coverage, 2295,
     /* 173362 */     GIR_EraseRootFromParent_Done,
     /* 173363 */   // Label 3375: @173363
     /* 173363 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(173408), // Rule ID 2306 //
     /* 173368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 173371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 173376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173397 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 173397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 173400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173406 */     GIR_RootConstrainSelectedInstOperands,
     /* 173407 */     // GIR_Coverage, 2306,
     /* 173407 */     GIR_EraseRootFromParent_Done,
     /* 173408 */   // Label 3376: @173408
     /* 173408 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(173453), // Rule ID 2307 //
     /* 173413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 173416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 173421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173442 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 173442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 173445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173451 */     GIR_RootConstrainSelectedInstOperands,
     /* 173452 */     // GIR_Coverage, 2307,
     /* 173452 */     GIR_EraseRootFromParent_Done,
     /* 173453 */   // Label 3377: @173453
     /* 173453 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(173498), // Rule ID 2330 //
     /* 173458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173487 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 173490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173496 */     GIR_RootConstrainSelectedInstOperands,
     /* 173497 */     // GIR_Coverage, 2330,
     /* 173497 */     GIR_EraseRootFromParent_Done,
     /* 173498 */   // Label 3378: @173498
     /* 173498 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(173543), // Rule ID 2331 //
     /* 173503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173532 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 173535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173541 */     GIR_RootConstrainSelectedInstOperands,
     /* 173542 */     // GIR_Coverage, 2331,
     /* 173542 */     GIR_EraseRootFromParent_Done,
     /* 173543 */   // Label 3379: @173543
     /* 173543 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(173588), // Rule ID 2332 //
     /* 173548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173577 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 173580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173586 */     GIR_RootConstrainSelectedInstOperands,
     /* 173587 */     // GIR_Coverage, 2332,
     /* 173587 */     GIR_EraseRootFromParent_Done,
     /* 173588 */   // Label 3380: @173588
     /* 173588 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(173633), // Rule ID 2333 //
     /* 173593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173622 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 173625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173631 */     GIR_RootConstrainSelectedInstOperands,
     /* 173632 */     // GIR_Coverage, 2333,
     /* 173632 */     GIR_EraseRootFromParent_Done,
     /* 173633 */   // Label 3381: @173633
     /* 173633 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(173678), // Rule ID 2334 //
     /* 173638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173667 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 173670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173676 */     GIR_RootConstrainSelectedInstOperands,
     /* 173677 */     // GIR_Coverage, 2334,
     /* 173677 */     GIR_EraseRootFromParent_Done,
     /* 173678 */   // Label 3382: @173678
     /* 173678 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(173723), // Rule ID 2335 //
     /* 173683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173712 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 173712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 173715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173721 */     GIR_RootConstrainSelectedInstOperands,
     /* 173722 */     // GIR_Coverage, 2335,
     /* 173722 */     GIR_EraseRootFromParent_Done,
     /* 173723 */   // Label 3383: @173723
     /* 173723 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(173768), // Rule ID 2338 //
     /* 173728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173757 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 173757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 173760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173766 */     GIR_RootConstrainSelectedInstOperands,
     /* 173767 */     // GIR_Coverage, 2338,
     /* 173767 */     GIR_EraseRootFromParent_Done,
     /* 173768 */   // Label 3384: @173768
     /* 173768 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(173813), // Rule ID 2341 //
     /* 173773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173802 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 173802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 173805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173811 */     GIR_RootConstrainSelectedInstOperands,
     /* 173812 */     // GIR_Coverage, 2341,
     /* 173812 */     GIR_EraseRootFromParent_Done,
     /* 173813 */   // Label 3385: @173813
     /* 173813 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(173858), // Rule ID 2344 //
     /* 173818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173847 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 173847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 173850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173856 */     GIR_RootConstrainSelectedInstOperands,
     /* 173857 */     // GIR_Coverage, 2344,
     /* 173857 */     GIR_EraseRootFromParent_Done,
     /* 173858 */   // Label 3386: @173858
     /* 173858 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(173903), // Rule ID 2347 //
     /* 173863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173892 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 173892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 173895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173901 */     GIR_RootConstrainSelectedInstOperands,
     /* 173902 */     // GIR_Coverage, 2347,
     /* 173902 */     GIR_EraseRootFromParent_Done,
     /* 173903 */   // Label 3387: @173903
     /* 173903 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(173948), // Rule ID 2350 //
     /* 173908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 173916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173937 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 173937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 173940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173946 */     GIR_RootConstrainSelectedInstOperands,
     /* 173947 */     // GIR_Coverage, 2350,
     /* 173947 */     GIR_EraseRootFromParent_Done,
     /* 173948 */   // Label 3388: @173948
     /* 173948 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(173993), // Rule ID 2353 //
     /* 173953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 173961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173982 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 173982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 173985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173991 */     GIR_RootConstrainSelectedInstOperands,
     /* 173992 */     // GIR_Coverage, 2353,
     /* 173992 */     GIR_EraseRootFromParent_Done,
     /* 173993 */   // Label 3389: @173993
     /* 173993 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(174038), // Rule ID 2356 //
     /* 173998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174027 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 174027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 174030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174036 */     GIR_RootConstrainSelectedInstOperands,
     /* 174037 */     // GIR_Coverage, 2356,
     /* 174037 */     GIR_EraseRootFromParent_Done,
     /* 174038 */   // Label 3390: @174038
     /* 174038 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(174083), // Rule ID 2359 //
     /* 174043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174072 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 174072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 174075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174081 */     GIR_RootConstrainSelectedInstOperands,
     /* 174082 */     // GIR_Coverage, 2359,
     /* 174082 */     GIR_EraseRootFromParent_Done,
     /* 174083 */   // Label 3391: @174083
     /* 174083 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(174128), // Rule ID 2362 //
     /* 174088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174117 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 174117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 174120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174126 */     GIR_RootConstrainSelectedInstOperands,
     /* 174127 */     // GIR_Coverage, 2362,
     /* 174127 */     GIR_EraseRootFromParent_Done,
     /* 174128 */   // Label 3392: @174128
     /* 174128 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(174173), // Rule ID 2499 //
     /* 174133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174162 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 174162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 174165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174171 */     GIR_RootConstrainSelectedInstOperands,
     /* 174172 */     // GIR_Coverage, 2499,
     /* 174172 */     GIR_EraseRootFromParent_Done,
     /* 174173 */   // Label 3393: @174173
     /* 174173 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(174218), // Rule ID 2500 //
     /* 174178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174207 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 174207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 174210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174216 */     GIR_RootConstrainSelectedInstOperands,
     /* 174217 */     // GIR_Coverage, 2500,
     /* 174217 */     GIR_EraseRootFromParent_Done,
     /* 174218 */   // Label 3394: @174218
     /* 174218 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(174263), // Rule ID 2501 //
     /* 174223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 174231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174252 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 174252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 174255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174261 */     GIR_RootConstrainSelectedInstOperands,
     /* 174262 */     // GIR_Coverage, 2501,
     /* 174262 */     GIR_EraseRootFromParent_Done,
     /* 174263 */   // Label 3395: @174263
     /* 174263 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(174308), // Rule ID 2502 //
     /* 174268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 174276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174297 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 174297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 174300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174306 */     GIR_RootConstrainSelectedInstOperands,
     /* 174307 */     // GIR_Coverage, 2502,
     /* 174307 */     GIR_EraseRootFromParent_Done,
     /* 174308 */   // Label 3396: @174308
     /* 174308 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(174353), // Rule ID 2507 //
     /* 174313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 174321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174342 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 174342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 174345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 174351 */     GIR_RootConstrainSelectedInstOperands,
     /* 174352 */     // GIR_Coverage, 2507,
     /* 174352 */     GIR_EraseRootFromParent_Done,
     /* 174353 */   // Label 3397: @174353
     /* 174353 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(174398), // Rule ID 2620 //
     /* 174358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 174375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174387 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 174390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174396 */     GIR_RootConstrainSelectedInstOperands,
     /* 174397 */     // GIR_Coverage, 2620,
     /* 174397 */     GIR_EraseRootFromParent_Done,
     /* 174398 */   // Label 3398: @174398
     /* 174398 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(174443), // Rule ID 2621 //
     /* 174403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 174420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174432 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 174435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174441 */     GIR_RootConstrainSelectedInstOperands,
     /* 174442 */     // GIR_Coverage, 2621,
     /* 174442 */     GIR_EraseRootFromParent_Done,
     /* 174443 */   // Label 3399: @174443
     /* 174443 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(174488), // Rule ID 2622 //
     /* 174448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 174465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174477 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 174480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174486 */     GIR_RootConstrainSelectedInstOperands,
     /* 174487 */     // GIR_Coverage, 2622,
     /* 174487 */     GIR_EraseRootFromParent_Done,
     /* 174488 */   // Label 3400: @174488
     /* 174488 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(174533), // Rule ID 2623 //
     /* 174493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 174510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174522 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 174525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174531 */     GIR_RootConstrainSelectedInstOperands,
     /* 174532 */     // GIR_Coverage, 2623,
     /* 174532 */     GIR_EraseRootFromParent_Done,
     /* 174533 */   // Label 3401: @174533
     /* 174533 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(174578), // Rule ID 2624 //
     /* 174538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 174555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174567 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 174570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174576 */     GIR_RootConstrainSelectedInstOperands,
     /* 174577 */     // GIR_Coverage, 2624,
     /* 174577 */     GIR_EraseRootFromParent_Done,
     /* 174578 */   // Label 3402: @174578
     /* 174578 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(174623), // Rule ID 2625 //
     /* 174583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 174600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174612 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 174615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174621 */     GIR_RootConstrainSelectedInstOperands,
     /* 174622 */     // GIR_Coverage, 2625,
     /* 174622 */     GIR_EraseRootFromParent_Done,
     /* 174623 */   // Label 3403: @174623
     /* 174623 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(174668), // Rule ID 2626 //
     /* 174628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 174645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174657 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 174660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174666 */     GIR_RootConstrainSelectedInstOperands,
     /* 174667 */     // GIR_Coverage, 2626,
     /* 174667 */     GIR_EraseRootFromParent_Done,
     /* 174668 */   // Label 3404: @174668
     /* 174668 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(174713), // Rule ID 2627 //
     /* 174673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 174690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174702 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 174705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174711 */     GIR_RootConstrainSelectedInstOperands,
     /* 174712 */     // GIR_Coverage, 2627,
     /* 174712 */     GIR_EraseRootFromParent_Done,
     /* 174713 */   // Label 3405: @174713
     /* 174713 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(174758), // Rule ID 3757 //
     /* 174718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 174721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 174726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174747 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 174747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 174750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 174752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174756 */     GIR_RootConstrainSelectedInstOperands,
     /* 174757 */     // GIR_Coverage, 3757,
     /* 174757 */     GIR_EraseRootFromParent_Done,
     /* 174758 */   // Label 3406: @174758
     /* 174758 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(174803), // Rule ID 3785 //
     /* 174763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 174766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 174771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174792 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 174792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 174795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 174797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174801 */     GIR_RootConstrainSelectedInstOperands,
     /* 174802 */     // GIR_Coverage, 3785,
     /* 174802 */     GIR_EraseRootFromParent_Done,
     /* 174803 */   // Label 3407: @174803
     /* 174803 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(174848), // Rule ID 3795 //
     /* 174808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 174811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 174816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174837 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 174837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 174840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 174842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174846 */     GIR_RootConstrainSelectedInstOperands,
     /* 174847 */     // GIR_Coverage, 3795,
     /* 174847 */     GIR_EraseRootFromParent_Done,
     /* 174848 */   // Label 3408: @174848
     /* 174848 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(174893), // Rule ID 3796 //
     /* 174853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 174856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 174861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 174882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 174885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 174887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174891 */     GIR_RootConstrainSelectedInstOperands,
     /* 174892 */     // GIR_Coverage, 3796,
     /* 174892 */     GIR_EraseRootFromParent_Done,
     /* 174893 */   // Label 3409: @174893
     /* 174893 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(174941), // Rule ID 3797 //
     /* 174898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 174901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 174906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174927 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 174927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 174930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174939 */     GIR_RootConstrainSelectedInstOperands,
     /* 174940 */     // GIR_Coverage, 3797,
     /* 174940 */     GIR_EraseRootFromParent_Done,
     /* 174941 */   // Label 3410: @174941
     /* 174941 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(174989), // Rule ID 3798 //
     /* 174946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 174949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 174954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174975 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 174975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 174978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 174987 */     GIR_RootConstrainSelectedInstOperands,
     /* 174988 */     // GIR_Coverage, 3798,
     /* 174988 */     GIR_EraseRootFromParent_Done,
     /* 174989 */   // Label 3411: @174989
     /* 174989 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(175037), // Rule ID 3799 //
     /* 174994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 174997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175023 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 175023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 175026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175035 */     GIR_RootConstrainSelectedInstOperands,
     /* 175036 */     // GIR_Coverage, 3799,
     /* 175036 */     GIR_EraseRootFromParent_Done,
     /* 175037 */   // Label 3412: @175037
     /* 175037 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(175085), // Rule ID 3800 //
     /* 175042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175071 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 175071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 175074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175083 */     GIR_RootConstrainSelectedInstOperands,
     /* 175084 */     // GIR_Coverage, 3800,
     /* 175084 */     GIR_EraseRootFromParent_Done,
     /* 175085 */   // Label 3413: @175085
     /* 175085 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(175133), // Rule ID 3801 //
     /* 175090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175119 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 175119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 175122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175131 */     GIR_RootConstrainSelectedInstOperands,
     /* 175132 */     // GIR_Coverage, 3801,
     /* 175132 */     GIR_EraseRootFromParent_Done,
     /* 175133 */   // Label 3414: @175133
     /* 175133 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(175181), // Rule ID 3802 //
     /* 175138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175167 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 175167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 175170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175179 */     GIR_RootConstrainSelectedInstOperands,
     /* 175180 */     // GIR_Coverage, 3802,
     /* 175180 */     GIR_EraseRootFromParent_Done,
     /* 175181 */   // Label 3415: @175181
     /* 175181 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(175229), // Rule ID 3803 //
     /* 175186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175215 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 175215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 175218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175227 */     GIR_RootConstrainSelectedInstOperands,
     /* 175228 */     // GIR_Coverage, 3803,
     /* 175228 */     GIR_EraseRootFromParent_Done,
     /* 175229 */   // Label 3416: @175229
     /* 175229 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(175277), // Rule ID 3804 //
     /* 175234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175263 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 175263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 175266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175275 */     GIR_RootConstrainSelectedInstOperands,
     /* 175276 */     // GIR_Coverage, 3804,
     /* 175276 */     GIR_EraseRootFromParent_Done,
     /* 175277 */   // Label 3417: @175277
     /* 175277 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(175325), // Rule ID 3805 //
     /* 175282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175311 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 175311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 175314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175323 */     GIR_RootConstrainSelectedInstOperands,
     /* 175324 */     // GIR_Coverage, 3805,
     /* 175324 */     GIR_EraseRootFromParent_Done,
     /* 175325 */   // Label 3418: @175325
     /* 175325 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(175373), // Rule ID 3806 //
     /* 175330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175359 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 175359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 175362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175371 */     GIR_RootConstrainSelectedInstOperands,
     /* 175372 */     // GIR_Coverage, 3806,
     /* 175372 */     GIR_EraseRootFromParent_Done,
     /* 175373 */   // Label 3419: @175373
     /* 175373 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(175415), // Rule ID 3871 //
     /* 175378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 175383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175404 */     // (intrinsic_wo_chain:{ *:[i32] } 2075:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 175404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 175407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175413 */     GIR_RootConstrainSelectedInstOperands,
     /* 175414 */     // GIR_Coverage, 3871,
     /* 175414 */     GIR_EraseRootFromParent_Done,
     /* 175415 */   // Label 3420: @175415
     /* 175415 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(175457), // Rule ID 3872 //
     /* 175420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 175425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175446 */     // (intrinsic_wo_chain:{ *:[i64] } 2075:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 175446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 175449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175455 */     GIR_RootConstrainSelectedInstOperands,
     /* 175456 */     // GIR_Coverage, 3872,
     /* 175456 */     GIR_EraseRootFromParent_Done,
     /* 175457 */   // Label 3421: @175457
     /* 175457 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(175499), // Rule ID 3873 //
     /* 175462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 175467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175488 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 175488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 175491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175497 */     GIR_RootConstrainSelectedInstOperands,
     /* 175498 */     // GIR_Coverage, 3873,
     /* 175498 */     GIR_EraseRootFromParent_Done,
     /* 175499 */   // Label 3422: @175499
     /* 175499 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(175541), // Rule ID 3874 //
     /* 175504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 175509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175530 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 175530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 175533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175539 */     GIR_RootConstrainSelectedInstOperands,
     /* 175540 */     // GIR_Coverage, 3874,
     /* 175540 */     GIR_EraseRootFromParent_Done,
     /* 175541 */   // Label 3423: @175541
     /* 175541 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(175583), // Rule ID 5144 //
     /* 175546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 175551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175572 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 175575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175581 */     GIR_RootConstrainSelectedInstOperands,
     /* 175582 */     // GIR_Coverage, 5144,
     /* 175582 */     GIR_EraseRootFromParent_Done,
     /* 175583 */   // Label 3424: @175583
     /* 175583 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(175628), // Rule ID 5148 //
     /* 175588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 175596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175617 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 175620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175626 */     GIR_RootConstrainSelectedInstOperands,
     /* 175627 */     // GIR_Coverage, 5148,
     /* 175627 */     GIR_EraseRootFromParent_Done,
     /* 175628 */   // Label 3425: @175628
     /* 175628 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(175673), // Rule ID 5152 //
     /* 175633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175662 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 175665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175671 */     GIR_RootConstrainSelectedInstOperands,
     /* 175672 */     // GIR_Coverage, 5152,
     /* 175672 */     GIR_EraseRootFromParent_Done,
     /* 175673 */   // Label 3426: @175673
     /* 175673 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(175718), // Rule ID 5153 //
     /* 175678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 175686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175707 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 175710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175716 */     GIR_RootConstrainSelectedInstOperands,
     /* 175717 */     // GIR_Coverage, 5153,
     /* 175717 */     GIR_EraseRootFromParent_Done,
     /* 175718 */   // Label 3427: @175718
     /* 175718 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(175763), // Rule ID 5154 //
     /* 175723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 175731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175752 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 175755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175761 */     GIR_RootConstrainSelectedInstOperands,
     /* 175762 */     // GIR_Coverage, 5154,
     /* 175762 */     GIR_EraseRootFromParent_Done,
     /* 175763 */   // Label 3428: @175763
     /* 175763 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(175808), // Rule ID 5155 //
     /* 175768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175797 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 175797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 175800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175806 */     GIR_RootConstrainSelectedInstOperands,
     /* 175807 */     // GIR_Coverage, 5155,
     /* 175807 */     GIR_EraseRootFromParent_Done,
     /* 175808 */   // Label 3429: @175808
     /* 175808 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(175853), // Rule ID 5156 //
     /* 175813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175842 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 175842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 175845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175851 */     GIR_RootConstrainSelectedInstOperands,
     /* 175852 */     // GIR_Coverage, 5156,
     /* 175852 */     GIR_EraseRootFromParent_Done,
     /* 175853 */   // Label 3430: @175853
     /* 175853 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(175898), // Rule ID 5157 //
     /* 175858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175887 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 175887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 175890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175896 */     GIR_RootConstrainSelectedInstOperands,
     /* 175897 */     // GIR_Coverage, 5157,
     /* 175897 */     GIR_EraseRootFromParent_Done,
     /* 175898 */   // Label 3431: @175898
     /* 175898 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(175943), // Rule ID 5158 //
     /* 175903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175932 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 175932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 175935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175941 */     GIR_RootConstrainSelectedInstOperands,
     /* 175942 */     // GIR_Coverage, 5158,
     /* 175942 */     GIR_EraseRootFromParent_Done,
     /* 175943 */   // Label 3432: @175943
     /* 175943 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(175988), // Rule ID 5159 //
     /* 175948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175977 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 175977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 175980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175986 */     GIR_RootConstrainSelectedInstOperands,
     /* 175987 */     // GIR_Coverage, 5159,
     /* 175987 */     GIR_EraseRootFromParent_Done,
     /* 175988 */   // Label 3433: @175988
     /* 175988 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(176033), // Rule ID 5160 //
     /* 175993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176022 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 176025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176031 */     GIR_RootConstrainSelectedInstOperands,
     /* 176032 */     // GIR_Coverage, 5160,
     /* 176032 */     GIR_EraseRootFromParent_Done,
     /* 176033 */   // Label 3434: @176033
     /* 176033 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(176078), // Rule ID 5161 //
     /* 176038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176067 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 176070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176076 */     GIR_RootConstrainSelectedInstOperands,
     /* 176077 */     // GIR_Coverage, 5161,
     /* 176077 */     GIR_EraseRootFromParent_Done,
     /* 176078 */   // Label 3435: @176078
     /* 176078 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(176123), // Rule ID 5162 //
     /* 176083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176112 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 176115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176121 */     GIR_RootConstrainSelectedInstOperands,
     /* 176122 */     // GIR_Coverage, 5162,
     /* 176122 */     GIR_EraseRootFromParent_Done,
     /* 176123 */   // Label 3436: @176123
     /* 176123 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(176168), // Rule ID 5163 //
     /* 176128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176157 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 176160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176166 */     GIR_RootConstrainSelectedInstOperands,
     /* 176167 */     // GIR_Coverage, 5163,
     /* 176167 */     GIR_EraseRootFromParent_Done,
     /* 176168 */   // Label 3437: @176168
     /* 176168 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(176213), // Rule ID 5164 //
     /* 176173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176202 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 176205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176211 */     GIR_RootConstrainSelectedInstOperands,
     /* 176212 */     // GIR_Coverage, 5164,
     /* 176212 */     GIR_EraseRootFromParent_Done,
     /* 176213 */   // Label 3438: @176213
     /* 176213 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(176258), // Rule ID 5165 //
     /* 176218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176247 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 176250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176256 */     GIR_RootConstrainSelectedInstOperands,
     /* 176257 */     // GIR_Coverage, 5165,
     /* 176257 */     GIR_EraseRootFromParent_Done,
     /* 176258 */   // Label 3439: @176258
     /* 176258 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(176303), // Rule ID 5166 //
     /* 176263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176292 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 176295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176301 */     GIR_RootConstrainSelectedInstOperands,
     /* 176302 */     // GIR_Coverage, 5166,
     /* 176302 */     GIR_EraseRootFromParent_Done,
     /* 176303 */   // Label 3440: @176303
     /* 176303 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(176348), // Rule ID 5167 //
     /* 176308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176337 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 176340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176346 */     GIR_RootConstrainSelectedInstOperands,
     /* 176347 */     // GIR_Coverage, 5167,
     /* 176347 */     GIR_EraseRootFromParent_Done,
     /* 176348 */   // Label 3441: @176348
     /* 176348 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(176393), // Rule ID 5168 //
     /* 176353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176382 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 176385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176391 */     GIR_RootConstrainSelectedInstOperands,
     /* 176392 */     // GIR_Coverage, 5168,
     /* 176392 */     GIR_EraseRootFromParent_Done,
     /* 176393 */   // Label 3442: @176393
     /* 176393 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(176438), // Rule ID 5186 //
     /* 176398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 176406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176427 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 176427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 176430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176436 */     GIR_RootConstrainSelectedInstOperands,
     /* 176437 */     // GIR_Coverage, 5186,
     /* 176437 */     GIR_EraseRootFromParent_Done,
     /* 176438 */   // Label 3443: @176438
     /* 176438 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(176480), // Rule ID 5514 //
     /* 176443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 176448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176469 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 176469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 176472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 176474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 176478 */     GIR_RootConstrainSelectedInstOperands,
     /* 176479 */     // GIR_Coverage, 5514,
     /* 176479 */     GIR_EraseRootFromParent_Done,
     /* 176480 */   // Label 3444: @176480
     /* 176480 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(176522), // Rule ID 5515 //
     /* 176485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 176490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176511 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 176511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 176514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 176516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 176518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176520 */     GIR_RootConstrainSelectedInstOperands,
     /* 176521 */     // GIR_Coverage, 5515,
     /* 176521 */     GIR_EraseRootFromParent_Done,
     /* 176522 */   // Label 3445: @176522
     /* 176522 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(176619), // Rule ID 6192 //
     /* 176527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 176532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176553 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 176553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 176556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 176560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176565 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 176569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 176573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 176575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 176592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 176600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 176603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176618 */     // GIR_Coverage, 6192,
     /* 176618 */     GIR_EraseRootFromParent_Done,
     /* 176619 */   // Label 3446: @176619
     /* 176619 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(176716), // Rule ID 6193 //
     /* 176624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 176629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176650 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 176650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 176653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 176657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 176666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 176670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 176672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 176689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 176697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 176700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176715 */     // GIR_Coverage, 6193,
     /* 176715 */     GIR_EraseRootFromParent_Done,
     /* 176716 */   // Label 3447: @176716
     /* 176716 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(176758), // Rule ID 6846 //
     /* 176721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176747 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 176750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176756 */     GIR_RootConstrainSelectedInstOperands,
     /* 176757 */     // GIR_Coverage, 6846,
     /* 176757 */     GIR_EraseRootFromParent_Done,
     /* 176758 */   // Label 3448: @176758
     /* 176758 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(176800), // Rule ID 6847 //
     /* 176763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176789 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 176792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176798 */     GIR_RootConstrainSelectedInstOperands,
     /* 176799 */     // GIR_Coverage, 6847,
     /* 176799 */     GIR_EraseRootFromParent_Done,
     /* 176800 */   // Label 3449: @176800
     /* 176800 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(176842), // Rule ID 6848 //
     /* 176805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176831 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 176834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176840 */     GIR_RootConstrainSelectedInstOperands,
     /* 176841 */     // GIR_Coverage, 6848,
     /* 176841 */     GIR_EraseRootFromParent_Done,
     /* 176842 */   // Label 3450: @176842
     /* 176842 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(176884), // Rule ID 6849 //
     /* 176847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176873 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 176876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176882 */     GIR_RootConstrainSelectedInstOperands,
     /* 176883 */     // GIR_Coverage, 6849,
     /* 176883 */     GIR_EraseRootFromParent_Done,
     /* 176884 */   // Label 3451: @176884
     /* 176884 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(176932), // Rule ID 6889 //
     /* 176889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 176894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176915 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 176915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 176918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 176927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 176930 */     GIR_RootConstrainSelectedInstOperands,
     /* 176931 */     // GIR_Coverage, 6889,
     /* 176931 */     GIR_EraseRootFromParent_Done,
     /* 176932 */   // Label 3452: @176932
     /* 176932 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(176977), // Rule ID 9867 //
     /* 176937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 176940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 176945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 176954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 176966 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 176966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 176969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 176971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 176973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176975 */     GIR_RootConstrainSelectedInstOperands,
     /* 176976 */     // GIR_Coverage, 9867,
     /* 176976 */     GIR_EraseRootFromParent_Done,
     /* 176977 */   // Label 3453: @176977
     /* 176977 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177022), // Rule ID 9868 //
     /* 176982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 176985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 176990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 176999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177011 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 177014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177020 */     GIR_RootConstrainSelectedInstOperands,
     /* 177021 */     // GIR_Coverage, 9868,
     /* 177021 */     GIR_EraseRootFromParent_Done,
     /* 177022 */   // Label 3454: @177022
     /* 177022 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(177067), // Rule ID 9869 //
     /* 177027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177056 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 177059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177065 */     GIR_RootConstrainSelectedInstOperands,
     /* 177066 */     // GIR_Coverage, 9869,
     /* 177066 */     GIR_EraseRootFromParent_Done,
     /* 177067 */   // Label 3455: @177067
     /* 177067 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(177112), // Rule ID 9870 //
     /* 177072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177101 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 177104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177110 */     GIR_RootConstrainSelectedInstOperands,
     /* 177111 */     // GIR_Coverage, 9870,
     /* 177111 */     GIR_EraseRootFromParent_Done,
     /* 177112 */   // Label 3456: @177112
     /* 177112 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(177157), // Rule ID 9879 //
     /* 177117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177146 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 177149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177155 */     GIR_RootConstrainSelectedInstOperands,
     /* 177156 */     // GIR_Coverage, 9879,
     /* 177156 */     GIR_EraseRootFromParent_Done,
     /* 177157 */   // Label 3457: @177157
     /* 177157 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(177202), // Rule ID 9880 //
     /* 177162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177191 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 177194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177200 */     GIR_RootConstrainSelectedInstOperands,
     /* 177201 */     // GIR_Coverage, 9880,
     /* 177201 */     GIR_EraseRootFromParent_Done,
     /* 177202 */   // Label 3458: @177202
     /* 177202 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(177247), // Rule ID 9881 //
     /* 177207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177236 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 177239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177245 */     GIR_RootConstrainSelectedInstOperands,
     /* 177246 */     // GIR_Coverage, 9881,
     /* 177246 */     GIR_EraseRootFromParent_Done,
     /* 177247 */   // Label 3459: @177247
     /* 177247 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(177292), // Rule ID 9882 //
     /* 177252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177281 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 177284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177290 */     GIR_RootConstrainSelectedInstOperands,
     /* 177291 */     // GIR_Coverage, 9882,
     /* 177291 */     GIR_EraseRootFromParent_Done,
     /* 177292 */   // Label 3460: @177292
     /* 177292 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(177337), // Rule ID 9883 //
     /* 177297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177326 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 177329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177335 */     GIR_RootConstrainSelectedInstOperands,
     /* 177336 */     // GIR_Coverage, 9883,
     /* 177336 */     GIR_EraseRootFromParent_Done,
     /* 177337 */   // Label 3461: @177337
     /* 177337 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(177382), // Rule ID 9884 //
     /* 177342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177371 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 177374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177380 */     GIR_RootConstrainSelectedInstOperands,
     /* 177381 */     // GIR_Coverage, 9884,
     /* 177381 */     GIR_EraseRootFromParent_Done,
     /* 177382 */   // Label 3462: @177382
     /* 177382 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(177427), // Rule ID 9885 //
     /* 177387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177416 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 177419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177425 */     GIR_RootConstrainSelectedInstOperands,
     /* 177426 */     // GIR_Coverage, 9885,
     /* 177426 */     GIR_EraseRootFromParent_Done,
     /* 177427 */   // Label 3463: @177427
     /* 177427 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(177472), // Rule ID 9886 //
     /* 177432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177461 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 177464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177470 */     GIR_RootConstrainSelectedInstOperands,
     /* 177471 */     // GIR_Coverage, 9886,
     /* 177471 */     GIR_EraseRootFromParent_Done,
     /* 177472 */   // Label 3464: @177472
     /* 177472 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(177517), // Rule ID 9887 //
     /* 177477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177506 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 177509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177515 */     GIR_RootConstrainSelectedInstOperands,
     /* 177516 */     // GIR_Coverage, 9887,
     /* 177516 */     GIR_EraseRootFromParent_Done,
     /* 177517 */   // Label 3465: @177517
     /* 177517 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(177562), // Rule ID 9888 //
     /* 177522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177551 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 177554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177560 */     GIR_RootConstrainSelectedInstOperands,
     /* 177561 */     // GIR_Coverage, 9888,
     /* 177561 */     GIR_EraseRootFromParent_Done,
     /* 177562 */   // Label 3466: @177562
     /* 177562 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(177607), // Rule ID 9889 //
     /* 177567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177596 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 177599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177605 */     GIR_RootConstrainSelectedInstOperands,
     /* 177606 */     // GIR_Coverage, 9889,
     /* 177606 */     GIR_EraseRootFromParent_Done,
     /* 177607 */   // Label 3467: @177607
     /* 177607 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(177652), // Rule ID 9890 //
     /* 177612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177641 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 177644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177650 */     GIR_RootConstrainSelectedInstOperands,
     /* 177651 */     // GIR_Coverage, 9890,
     /* 177651 */     GIR_EraseRootFromParent_Done,
     /* 177652 */   // Label 3468: @177652
     /* 177652 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(177698), // Rule ID 138 //
     /* 177657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 177660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 177665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177675 */     // MIs[0] Rn
     /* 177675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 177679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 177683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177687 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 177687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 177690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177696 */     GIR_RootConstrainSelectedInstOperands,
     /* 177697 */     // GIR_Coverage, 138,
     /* 177697 */     GIR_EraseRootFromParent_Done,
     /* 177698 */   // Label 3469: @177698
     /* 177698 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(177745), // Rule ID 139 //
     /* 177703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 177706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 177711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177718 */     // MIs[0] Rn
     /* 177718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 177722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 177726 */     // MIs[0] Rm
     /* 177726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 177730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 177734 */     // (intrinsic_wo_chain:{ *:[i64] } 1148:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 177734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 177737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177743 */     GIR_RootConstrainSelectedInstOperands,
     /* 177744 */     // GIR_Coverage, 139,
     /* 177744 */     GIR_EraseRootFromParent_Done,
     /* 177745 */   // Label 3470: @177745
     /* 177745 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(177782), // Rule ID 2390 //
     /* 177750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 177758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177771 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 177774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177780 */     GIR_RootConstrainSelectedInstOperands,
     /* 177781 */     // GIR_Coverage, 2390,
     /* 177781 */     GIR_EraseRootFromParent_Done,
     /* 177782 */   // Label 3471: @177782
     /* 177782 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(177819), // Rule ID 2391 //
     /* 177787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 177795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177808 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 177811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177817 */     GIR_RootConstrainSelectedInstOperands,
     /* 177818 */     // GIR_Coverage, 2391,
     /* 177818 */     GIR_EraseRootFromParent_Done,
     /* 177819 */   // Label 3472: @177819
     /* 177819 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(177856), // Rule ID 2392 //
     /* 177824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 177832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177845 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2059:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 177848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177854 */     GIR_RootConstrainSelectedInstOperands,
     /* 177855 */     // GIR_Coverage, 2392,
     /* 177855 */     GIR_EraseRootFromParent_Done,
     /* 177856 */   // Label 3473: @177856
     /* 177856 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(177893), // Rule ID 2394 //
     /* 177861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 177869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2062:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 177885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177891 */     GIR_RootConstrainSelectedInstOperands,
     /* 177892 */     // GIR_Coverage, 2394,
     /* 177892 */     GIR_EraseRootFromParent_Done,
     /* 177893 */   // Label 3474: @177893
     /* 177893 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(177930), // Rule ID 2395 //
     /* 177898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 177906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 177922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177928 */     GIR_RootConstrainSelectedInstOperands,
     /* 177929 */     // GIR_Coverage, 2395,
     /* 177929 */     GIR_EraseRootFromParent_Done,
     /* 177930 */   // Label 3475: @177930
     /* 177930 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(177967), // Rule ID 2396 //
     /* 177935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 177943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 177959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177965 */     GIR_RootConstrainSelectedInstOperands,
     /* 177966 */     // GIR_Coverage, 2396,
     /* 177966 */     GIR_EraseRootFromParent_Done,
     /* 177967 */   // Label 3476: @177967
     /* 177967 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(178004), // Rule ID 2398 //
     /* 177972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 177980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177993 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1983:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 177996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178002 */     GIR_RootConstrainSelectedInstOperands,
     /* 178003 */     // GIR_Coverage, 2398,
     /* 178003 */     GIR_EraseRootFromParent_Done,
     /* 178004 */   // Label 3477: @178004
     /* 178004 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(178041), // Rule ID 2399 //
     /* 178009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 178017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1984:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 178033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178039 */     GIR_RootConstrainSelectedInstOperands,
     /* 178040 */     // GIR_Coverage, 2399,
     /* 178040 */     GIR_EraseRootFromParent_Done,
     /* 178041 */   // Label 3478: @178041
     /* 178041 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(178078), // Rule ID 2400 //
     /* 178046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 178054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178067 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 178070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178076 */     GIR_RootConstrainSelectedInstOperands,
     /* 178077 */     // GIR_Coverage, 2400,
     /* 178077 */     GIR_EraseRootFromParent_Done,
     /* 178078 */   // Label 3479: @178078
     /* 178078 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(178115), // Rule ID 2402 //
     /* 178083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 178091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 178107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178113 */     GIR_RootConstrainSelectedInstOperands,
     /* 178114 */     // GIR_Coverage, 2402,
     /* 178114 */     GIR_EraseRootFromParent_Done,
     /* 178115 */   // Label 3480: @178115
     /* 178115 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(178152), // Rule ID 2403 //
     /* 178120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 178128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178141 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 178144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178150 */     GIR_RootConstrainSelectedInstOperands,
     /* 178151 */     // GIR_Coverage, 2403,
     /* 178151 */     GIR_EraseRootFromParent_Done,
     /* 178152 */   // Label 3481: @178152
     /* 178152 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(178189), // Rule ID 2404 //
     /* 178157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 178165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178178 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 178181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178187 */     GIR_RootConstrainSelectedInstOperands,
     /* 178188 */     // GIR_Coverage, 2404,
     /* 178188 */     GIR_EraseRootFromParent_Done,
     /* 178189 */   // Label 3482: @178189
     /* 178189 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(178226), // Rule ID 2406 //
     /* 178194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 178202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178215 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 178218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178224 */     GIR_RootConstrainSelectedInstOperands,
     /* 178225 */     // GIR_Coverage, 2406,
     /* 178225 */     GIR_EraseRootFromParent_Done,
     /* 178226 */   // Label 3483: @178226
     /* 178226 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(178263), // Rule ID 2407 //
     /* 178231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 178239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 178255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178261 */     GIR_RootConstrainSelectedInstOperands,
     /* 178262 */     // GIR_Coverage, 2407,
     /* 178262 */     GIR_EraseRootFromParent_Done,
     /* 178263 */   // Label 3484: @178263
     /* 178263 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(178300), // Rule ID 2408 //
     /* 178268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 178276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178289 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1829:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 178292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178298 */     GIR_RootConstrainSelectedInstOperands,
     /* 178299 */     // GIR_Coverage, 2408,
     /* 178299 */     GIR_EraseRootFromParent_Done,
     /* 178300 */   // Label 3485: @178300
     /* 178300 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(178337), // Rule ID 2410 //
     /* 178305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 178313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178326 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1832:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 178329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178335 */     GIR_RootConstrainSelectedInstOperands,
     /* 178336 */     // GIR_Coverage, 2410,
     /* 178336 */     GIR_EraseRootFromParent_Done,
     /* 178337 */   // Label 3486: @178337
     /* 178337 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(178374), // Rule ID 2411 //
     /* 178342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 178350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178363 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 178366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178372 */     GIR_RootConstrainSelectedInstOperands,
     /* 178373 */     // GIR_Coverage, 2411,
     /* 178373 */     GIR_EraseRootFromParent_Done,
     /* 178374 */   // Label 3487: @178374
     /* 178374 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(178411), // Rule ID 2412 //
     /* 178379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 178387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1834:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 178403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178409 */     GIR_RootConstrainSelectedInstOperands,
     /* 178410 */     // GIR_Coverage, 2412,
     /* 178410 */     GIR_EraseRootFromParent_Done,
     /* 178411 */   // Label 3488: @178411
     /* 178411 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(178448), // Rule ID 2413 //
     /* 178416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 178419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 178424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 178427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 178430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 178433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1452:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 178437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 178440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 178444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 178446 */     GIR_RootConstrainSelectedInstOperands,
     /* 178447 */     // GIR_Coverage, 2413,
     /* 178447 */     GIR_EraseRootFromParent_Done,
     /* 178448 */   // Label 3489: @178448
     /* 178448 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(178488), // Rule ID 2607 //
     /* 178453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 178461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 178477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178486 */     GIR_RootConstrainSelectedInstOperands,
     /* 178487 */     // GIR_Coverage, 2607,
     /* 178487 */     GIR_EraseRootFromParent_Done,
     /* 178488 */   // Label 3490: @178488
     /* 178488 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(178528), // Rule ID 2608 //
     /* 178493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1539:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 178517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178526 */     GIR_RootConstrainSelectedInstOperands,
     /* 178527 */     // GIR_Coverage, 2608,
     /* 178527 */     GIR_EraseRootFromParent_Done,
     /* 178528 */   // Label 3491: @178528
     /* 178528 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(178568), // Rule ID 2609 //
     /* 178533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 178544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 178547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178554 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 178557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178566 */     GIR_RootConstrainSelectedInstOperands,
     /* 178567 */     // GIR_Coverage, 2609,
     /* 178567 */     GIR_EraseRootFromParent_Done,
     /* 178568 */   // Label 3492: @178568
     /* 178568 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(178608), // Rule ID 2610 //
     /* 178573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 178584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 178587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178594 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 178594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 178597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178606 */     GIR_RootConstrainSelectedInstOperands,
     /* 178607 */     // GIR_Coverage, 2610,
     /* 178607 */     GIR_EraseRootFromParent_Done,
     /* 178608 */   // Label 3493: @178608
     /* 178608 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(178648), // Rule ID 2611 //
     /* 178613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 178624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 178627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 178634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 178637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178646 */     GIR_RootConstrainSelectedInstOperands,
     /* 178647 */     // GIR_Coverage, 2611,
     /* 178647 */     GIR_EraseRootFromParent_Done,
     /* 178648 */   // Label 3494: @178648
     /* 178648 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(178685), // Rule ID 2628 //
     /* 178653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 178661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 178664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 178667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 178677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 178679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178683 */     GIR_RootConstrainSelectedInstOperands,
     /* 178684 */     // GIR_Coverage, 2628,
     /* 178684 */     GIR_EraseRootFromParent_Done,
     /* 178685 */   // Label 3495: @178685
     /* 178685 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(178722), // Rule ID 2629 //
     /* 178690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 178698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 178701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 178704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 178711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 178714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 178716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178720 */     GIR_RootConstrainSelectedInstOperands,
     /* 178721 */     // GIR_Coverage, 2629,
     /* 178721 */     GIR_EraseRootFromParent_Done,
     /* 178722 */   // Label 3496: @178722
     /* 178722 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(178759), // Rule ID 2630 //
     /* 178727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 178735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 178738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 178741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1719:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 178748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 178751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 178753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178757 */     GIR_RootConstrainSelectedInstOperands,
     /* 178758 */     // GIR_Coverage, 2630,
     /* 178758 */     GIR_EraseRootFromParent_Done,
     /* 178759 */   // Label 3497: @178759
     /* 178759 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(178796), // Rule ID 2631 //
     /* 178764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178785 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 178788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178794 */     GIR_RootConstrainSelectedInstOperands,
     /* 178795 */     // GIR_Coverage, 2631,
     /* 178795 */     GIR_EraseRootFromParent_Done,
     /* 178796 */   // Label 3498: @178796
     /* 178796 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(178833), // Rule ID 2632 //
     /* 178801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 178815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178822 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 178825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178831 */     GIR_RootConstrainSelectedInstOperands,
     /* 178832 */     // GIR_Coverage, 2632,
     /* 178832 */     GIR_EraseRootFromParent_Done,
     /* 178833 */   // Label 3499: @178833
     /* 178833 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(178870), // Rule ID 2633 //
     /* 178838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 178852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178859 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 178859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 178862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178868 */     GIR_RootConstrainSelectedInstOperands,
     /* 178869 */     // GIR_Coverage, 2633,
     /* 178869 */     GIR_EraseRootFromParent_Done,
     /* 178870 */   // Label 3500: @178870
     /* 178870 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(178907), // Rule ID 2634 //
     /* 178875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 178889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178896 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 178896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 178899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178905 */     GIR_RootConstrainSelectedInstOperands,
     /* 178906 */     // GIR_Coverage, 2634,
     /* 178906 */     GIR_EraseRootFromParent_Done,
     /* 178907 */   // Label 3501: @178907
     /* 178907 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(178944), // Rule ID 2812 //
     /* 178912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 178915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 178920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 178923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 178926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 178929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178933 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 178933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 178936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178942 */     GIR_RootConstrainSelectedInstOperands,
     /* 178943 */     // GIR_Coverage, 2812,
     /* 178943 */     GIR_EraseRootFromParent_Done,
     /* 178944 */   // Label 3502: @178944
     /* 178944 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(178981), // Rule ID 2813 //
     /* 178949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 178952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 178957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 178960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 178963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 178966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178970 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 178970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 178973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178979 */     GIR_RootConstrainSelectedInstOperands,
     /* 178980 */     // GIR_Coverage, 2813,
     /* 178980 */     GIR_EraseRootFromParent_Done,
     /* 178981 */   // Label 3503: @178981
     /* 178981 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(179018), // Rule ID 2814 //
     /* 178986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 178989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 178994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 178997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179007 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 179010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179016 */     GIR_RootConstrainSelectedInstOperands,
     /* 179017 */     // GIR_Coverage, 2814,
     /* 179017 */     GIR_EraseRootFromParent_Done,
     /* 179018 */   // Label 3504: @179018
     /* 179018 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(179055), // Rule ID 2985 //
     /* 179023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1701:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 179047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179053 */     GIR_RootConstrainSelectedInstOperands,
     /* 179054 */     // GIR_Coverage, 2985,
     /* 179054 */     GIR_EraseRootFromParent_Done,
     /* 179055 */   // Label 3505: @179055
     /* 179055 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(179092), // Rule ID 2986 //
     /* 179060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1701:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 179084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179090 */     GIR_RootConstrainSelectedInstOperands,
     /* 179091 */     // GIR_Coverage, 2986,
     /* 179091 */     GIR_EraseRootFromParent_Done,
     /* 179092 */   // Label 3506: @179092
     /* 179092 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(179129), // Rule ID 2987 //
     /* 179097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 179121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179127 */     GIR_RootConstrainSelectedInstOperands,
     /* 179128 */     // GIR_Coverage, 2987,
     /* 179128 */     GIR_EraseRootFromParent_Done,
     /* 179129 */   // Label 3507: @179129
     /* 179129 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(179166), // Rule ID 2988 //
     /* 179134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 179158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179164 */     GIR_RootConstrainSelectedInstOperands,
     /* 179165 */     // GIR_Coverage, 2988,
     /* 179165 */     GIR_EraseRootFromParent_Done,
     /* 179166 */   // Label 3508: @179166
     /* 179166 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(179203), // Rule ID 2989 //
     /* 179171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 179179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1536:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 179195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179201 */     GIR_RootConstrainSelectedInstOperands,
     /* 179202 */     // GIR_Coverage, 2989,
     /* 179202 */     GIR_EraseRootFromParent_Done,
     /* 179203 */   // Label 3509: @179203
     /* 179203 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(179240), // Rule ID 3011 //
     /* 179208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1594:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 179232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179238 */     GIR_RootConstrainSelectedInstOperands,
     /* 179239 */     // GIR_Coverage, 3011,
     /* 179239 */     GIR_EraseRootFromParent_Done,
     /* 179240 */   // Label 3510: @179240
     /* 179240 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(179277), // Rule ID 3012 //
     /* 179245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1594:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 179269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179275 */     GIR_RootConstrainSelectedInstOperands,
     /* 179276 */     // GIR_Coverage, 3012,
     /* 179276 */     GIR_EraseRootFromParent_Done,
     /* 179277 */   // Label 3511: @179277
     /* 179277 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(179314), // Rule ID 3013 //
     /* 179282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 179306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179312 */     GIR_RootConstrainSelectedInstOperands,
     /* 179313 */     // GIR_Coverage, 3013,
     /* 179313 */     GIR_EraseRootFromParent_Done,
     /* 179314 */   // Label 3512: @179314
     /* 179314 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(179351), // Rule ID 3017 //
     /* 179319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 179322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1537:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 179343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179349 */     GIR_RootConstrainSelectedInstOperands,
     /* 179350 */     // GIR_Coverage, 3017,
     /* 179350 */     GIR_EraseRootFromParent_Done,
     /* 179351 */   // Label 3513: @179351
     /* 179351 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(179388), // Rule ID 3018 //
     /* 179356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179377 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1537:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 179380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179386 */     GIR_RootConstrainSelectedInstOperands,
     /* 179387 */     // GIR_Coverage, 3018,
     /* 179387 */     GIR_EraseRootFromParent_Done,
     /* 179388 */   // Label 3514: @179388
     /* 179388 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(179425), // Rule ID 3019 //
     /* 179393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1537:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 179417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179423 */     GIR_RootConstrainSelectedInstOperands,
     /* 179424 */     // GIR_Coverage, 3019,
     /* 179424 */     GIR_EraseRootFromParent_Done,
     /* 179425 */   // Label 3515: @179425
     /* 179425 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(179462), // Rule ID 3020 //
     /* 179430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179451 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1179:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 179454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179460 */     GIR_RootConstrainSelectedInstOperands,
     /* 179461 */     // GIR_Coverage, 3020,
     /* 179461 */     GIR_EraseRootFromParent_Done,
     /* 179462 */   // Label 3516: @179462
     /* 179462 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(179499), // Rule ID 3021 //
     /* 179467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1179:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 179491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179497 */     GIR_RootConstrainSelectedInstOperands,
     /* 179498 */     // GIR_Coverage, 3021,
     /* 179498 */     GIR_EraseRootFromParent_Done,
     /* 179499 */   // Label 3517: @179499
     /* 179499 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(179536), // Rule ID 3022 //
     /* 179504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179525 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1179:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 179528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179534 */     GIR_RootConstrainSelectedInstOperands,
     /* 179535 */     // GIR_Coverage, 3022,
     /* 179535 */     GIR_EraseRootFromParent_Done,
     /* 179536 */   // Label 3518: @179536
     /* 179536 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(179573), // Rule ID 3023 //
     /* 179541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1179:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 179565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179571 */     GIR_RootConstrainSelectedInstOperands,
     /* 179572 */     // GIR_Coverage, 3023,
     /* 179572 */     GIR_EraseRootFromParent_Done,
     /* 179573 */   // Label 3519: @179573
     /* 179573 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(179610), // Rule ID 3024 //
     /* 179578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 179586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 179602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179608 */     GIR_RootConstrainSelectedInstOperands,
     /* 179609 */     // GIR_Coverage, 3024,
     /* 179609 */     GIR_EraseRootFromParent_Done,
     /* 179610 */   // Label 3520: @179610
     /* 179610 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(179647), // Rule ID 3025 //
     /* 179615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 179623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 179639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179645 */     GIR_RootConstrainSelectedInstOperands,
     /* 179646 */     // GIR_Coverage, 3025,
     /* 179646 */     GIR_EraseRootFromParent_Done,
     /* 179647 */   // Label 3521: @179647
     /* 179647 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(179684), // Rule ID 3026 //
     /* 179652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 179660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 179676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179682 */     GIR_RootConstrainSelectedInstOperands,
     /* 179683 */     // GIR_Coverage, 3026,
     /* 179683 */     GIR_EraseRootFromParent_Done,
     /* 179684 */   // Label 3522: @179684
     /* 179684 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(179721), // Rule ID 3073 //
     /* 179689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 179697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1156:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 179713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179719 */     GIR_RootConstrainSelectedInstOperands,
     /* 179720 */     // GIR_Coverage, 3073,
     /* 179720 */     GIR_EraseRootFromParent_Done,
     /* 179721 */   // Label 3523: @179721
     /* 179721 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(179758), // Rule ID 3074 //
     /* 179726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 179734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179747 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1156:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 179750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179756 */     GIR_RootConstrainSelectedInstOperands,
     /* 179757 */     // GIR_Coverage, 3074,
     /* 179757 */     GIR_EraseRootFromParent_Done,
     /* 179758 */   // Label 3524: @179758
     /* 179758 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(179795), // Rule ID 3075 //
     /* 179763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 179771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1156:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 179787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179793 */     GIR_RootConstrainSelectedInstOperands,
     /* 179794 */     // GIR_Coverage, 3075,
     /* 179794 */     GIR_EraseRootFromParent_Done,
     /* 179795 */   // Label 3525: @179795
     /* 179795 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(179832), // Rule ID 3082 //
     /* 179800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 179808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179821 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1758:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 179824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179830 */     GIR_RootConstrainSelectedInstOperands,
     /* 179831 */     // GIR_Coverage, 3082,
     /* 179831 */     GIR_EraseRootFromParent_Done,
     /* 179832 */   // Label 3526: @179832
     /* 179832 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(179869), // Rule ID 3083 //
     /* 179837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 179845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1758:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 179861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179867 */     GIR_RootConstrainSelectedInstOperands,
     /* 179868 */     // GIR_Coverage, 3083,
     /* 179868 */     GIR_EraseRootFromParent_Done,
     /* 179869 */   // Label 3527: @179869
     /* 179869 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(179906), // Rule ID 3084 //
     /* 179874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 179882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 179898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179904 */     GIR_RootConstrainSelectedInstOperands,
     /* 179905 */     // GIR_Coverage, 3084,
     /* 179905 */     GIR_EraseRootFromParent_Done,
     /* 179906 */   // Label 3528: @179906
     /* 179906 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(179946), // Rule ID 3182 //
     /* 179911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 179919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 179922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 179932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 179935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 179944 */     GIR_RootConstrainSelectedInstOperands,
     /* 179945 */     // GIR_Coverage, 3182,
     /* 179945 */     GIR_EraseRootFromParent_Done,
     /* 179946 */   // Label 3529: @179946
     /* 179946 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(179986), // Rule ID 3183 //
     /* 179951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 179959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 179962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 179972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 179975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 179984 */     GIR_RootConstrainSelectedInstOperands,
     /* 179985 */     // GIR_Coverage, 3183,
     /* 179985 */     GIR_EraseRootFromParent_Done,
     /* 179986 */   // Label 3530: @179986
     /* 179986 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(180026), // Rule ID 3184 //
     /* 179991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 179999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 180015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180024 */     GIR_RootConstrainSelectedInstOperands,
     /* 180025 */     // GIR_Coverage, 3184,
     /* 180025 */     GIR_EraseRootFromParent_Done,
     /* 180026 */   // Label 3531: @180026
     /* 180026 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(180066), // Rule ID 3185 //
     /* 180031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180052 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 180055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180064 */     GIR_RootConstrainSelectedInstOperands,
     /* 180065 */     // GIR_Coverage, 3185,
     /* 180065 */     GIR_EraseRootFromParent_Done,
     /* 180066 */   // Label 3532: @180066
     /* 180066 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(180106), // Rule ID 3190 //
     /* 180071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 180095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180104 */     GIR_RootConstrainSelectedInstOperands,
     /* 180105 */     // GIR_Coverage, 3190,
     /* 180105 */     GIR_EraseRootFromParent_Done,
     /* 180106 */   // Label 3533: @180106
     /* 180106 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(180146), // Rule ID 3191 //
     /* 180111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 180135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180144 */     GIR_RootConstrainSelectedInstOperands,
     /* 180145 */     // GIR_Coverage, 3191,
     /* 180145 */     GIR_EraseRootFromParent_Done,
     /* 180146 */   // Label 3534: @180146
     /* 180146 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(180186), // Rule ID 3192 //
     /* 180151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 180175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180184 */     GIR_RootConstrainSelectedInstOperands,
     /* 180185 */     // GIR_Coverage, 3192,
     /* 180185 */     GIR_EraseRootFromParent_Done,
     /* 180186 */   // Label 3535: @180186
     /* 180186 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(180226), // Rule ID 3193 //
     /* 180191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 180215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180224 */     GIR_RootConstrainSelectedInstOperands,
     /* 180225 */     // GIR_Coverage, 3193,
     /* 180225 */     GIR_EraseRootFromParent_Done,
     /* 180226 */   // Label 3536: @180226
     /* 180226 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(180263), // Rule ID 3382 //
     /* 180231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 180255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180261 */     GIR_RootConstrainSelectedInstOperands,
     /* 180262 */     // GIR_Coverage, 3382,
     /* 180262 */     GIR_EraseRootFromParent_Done,
     /* 180263 */   // Label 3537: @180263
     /* 180263 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(180300), // Rule ID 3383 //
     /* 180268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180289 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 180292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180298 */     GIR_RootConstrainSelectedInstOperands,
     /* 180299 */     // GIR_Coverage, 3383,
     /* 180299 */     GIR_EraseRootFromParent_Done,
     /* 180300 */   // Label 3538: @180300
     /* 180300 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(180337), // Rule ID 3384 //
     /* 180305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 180329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180335 */     GIR_RootConstrainSelectedInstOperands,
     /* 180336 */     // GIR_Coverage, 3384,
     /* 180336 */     GIR_EraseRootFromParent_Done,
     /* 180337 */   // Label 3539: @180337
     /* 180337 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(180374), // Rule ID 3385 //
     /* 180342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180363 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 180366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180372 */     GIR_RootConstrainSelectedInstOperands,
     /* 180373 */     // GIR_Coverage, 3385,
     /* 180373 */     GIR_EraseRootFromParent_Done,
     /* 180374 */   // Label 3540: @180374
     /* 180374 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(180411), // Rule ID 3407 //
     /* 180379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 180403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180409 */     GIR_RootConstrainSelectedInstOperands,
     /* 180410 */     // GIR_Coverage, 3407,
     /* 180410 */     GIR_EraseRootFromParent_Done,
     /* 180411 */   // Label 3541: @180411
     /* 180411 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(180448), // Rule ID 3408 //
     /* 180416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 180440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180446 */     GIR_RootConstrainSelectedInstOperands,
     /* 180447 */     // GIR_Coverage, 3408,
     /* 180447 */     GIR_EraseRootFromParent_Done,
     /* 180448 */   // Label 3542: @180448
     /* 180448 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(180485), // Rule ID 3409 //
     /* 180453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 180477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180483 */     GIR_RootConstrainSelectedInstOperands,
     /* 180484 */     // GIR_Coverage, 3409,
     /* 180484 */     GIR_EraseRootFromParent_Done,
     /* 180485 */   // Label 3543: @180485
     /* 180485 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(180522), // Rule ID 3431 //
     /* 180490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 180498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180511 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1200:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 180511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 180514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180520 */     GIR_RootConstrainSelectedInstOperands,
     /* 180521 */     // GIR_Coverage, 3431,
     /* 180521 */     GIR_EraseRootFromParent_Done,
     /* 180522 */   // Label 3544: @180522
     /* 180522 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(180559), // Rule ID 3436 //
     /* 180527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 180530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 180535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1630:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 180551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180557 */     GIR_RootConstrainSelectedInstOperands,
     /* 180558 */     // GIR_Coverage, 3436,
     /* 180558 */     GIR_EraseRootFromParent_Done,
     /* 180559 */   // Label 3545: @180559
     /* 180559 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(180596), // Rule ID 3437 //
     /* 180564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 180567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 180572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180585 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1165:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 180585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 180588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 180590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180594 */     GIR_RootConstrainSelectedInstOperands,
     /* 180595 */     // GIR_Coverage, 3437,
     /* 180595 */     GIR_EraseRootFromParent_Done,
     /* 180596 */   // Label 3546: @180596
     /* 180596 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(180633), // Rule ID 3446 //
     /* 180601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 180622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180631 */     GIR_RootConstrainSelectedInstOperands,
     /* 180632 */     // GIR_Coverage, 3446,
     /* 180632 */     GIR_EraseRootFromParent_Done,
     /* 180633 */   // Label 3547: @180633
     /* 180633 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(180670), // Rule ID 3447 //
     /* 180638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180668 */     GIR_RootConstrainSelectedInstOperands,
     /* 180669 */     // GIR_Coverage, 3447,
     /* 180669 */     GIR_EraseRootFromParent_Done,
     /* 180670 */   // Label 3548: @180670
     /* 180670 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(180707), // Rule ID 3448 //
     /* 180675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180696 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2060:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 180696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180705 */     GIR_RootConstrainSelectedInstOperands,
     /* 180706 */     // GIR_Coverage, 3448,
     /* 180706 */     GIR_EraseRootFromParent_Done,
     /* 180707 */   // Label 3549: @180707
     /* 180707 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(180744), // Rule ID 3449 //
     /* 180712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180742 */     GIR_RootConstrainSelectedInstOperands,
     /* 180743 */     // GIR_Coverage, 3449,
     /* 180743 */     GIR_EraseRootFromParent_Done,
     /* 180744 */   // Label 3550: @180744
     /* 180744 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(180781), // Rule ID 3450 //
     /* 180749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180770 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2060:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180779 */     GIR_RootConstrainSelectedInstOperands,
     /* 180780 */     // GIR_Coverage, 3450,
     /* 180780 */     GIR_EraseRootFromParent_Done,
     /* 180781 */   // Label 3551: @180781
     /* 180781 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(180818), // Rule ID 3451 //
     /* 180786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180816 */     GIR_RootConstrainSelectedInstOperands,
     /* 180817 */     // GIR_Coverage, 3451,
     /* 180817 */     GIR_EraseRootFromParent_Done,
     /* 180818 */   // Label 3552: @180818
     /* 180818 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(180855), // Rule ID 3452 //
     /* 180823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180844 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2060:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180853 */     GIR_RootConstrainSelectedInstOperands,
     /* 180854 */     // GIR_Coverage, 3452,
     /* 180854 */     GIR_EraseRootFromParent_Done,
     /* 180855 */   // Label 3553: @180855
     /* 180855 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(180892), // Rule ID 3507 //
     /* 180860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 180868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 180874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180881 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1273:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 180881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 180884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180890 */     GIR_RootConstrainSelectedInstOperands,
     /* 180891 */     // GIR_Coverage, 3507,
     /* 180891 */     GIR_EraseRootFromParent_Done,
     /* 180892 */   // Label 3554: @180892
     /* 180892 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(180929), // Rule ID 3508 //
     /* 180897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 180905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180918 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1273:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 180921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180927 */     GIR_RootConstrainSelectedInstOperands,
     /* 180928 */     // GIR_Coverage, 3508,
     /* 180928 */     GIR_EraseRootFromParent_Done,
     /* 180929 */   // Label 3555: @180929
     /* 180929 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(180966), // Rule ID 3509 //
     /* 180934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 180942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180955 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1273:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 180958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180964 */     GIR_RootConstrainSelectedInstOperands,
     /* 180965 */     // GIR_Coverage, 3509,
     /* 180965 */     GIR_EraseRootFromParent_Done,
     /* 180966 */   // Label 3556: @180966
     /* 180966 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(181003), // Rule ID 3539 //
     /* 180971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 180979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 180982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180992 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1524:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 180992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 180995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181001 */     GIR_RootConstrainSelectedInstOperands,
     /* 181002 */     // GIR_Coverage, 3539,
     /* 181002 */     GIR_EraseRootFromParent_Done,
     /* 181003 */   // Label 3557: @181003
     /* 181003 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(181040), // Rule ID 3540 //
     /* 181008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 181022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181029 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1524:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 181032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181038 */     GIR_RootConstrainSelectedInstOperands,
     /* 181039 */     // GIR_Coverage, 3540,
     /* 181039 */     GIR_EraseRootFromParent_Done,
     /* 181040 */   // Label 3558: @181040
     /* 181040 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(181077), // Rule ID 3541 //
     /* 181045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 181059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1524:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 181069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181075 */     GIR_RootConstrainSelectedInstOperands,
     /* 181076 */     // GIR_Coverage, 3541,
     /* 181076 */     GIR_EraseRootFromParent_Done,
     /* 181077 */   // Label 3559: @181077
     /* 181077 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(181114), // Rule ID 3542 //
     /* 181082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 181096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181103 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1524:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 181106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181112 */     GIR_RootConstrainSelectedInstOperands,
     /* 181113 */     // GIR_Coverage, 3542,
     /* 181113 */     GIR_EraseRootFromParent_Done,
     /* 181114 */   // Label 3560: @181114
     /* 181114 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(181151), // Rule ID 3543 //
     /* 181119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 181143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181149 */     GIR_RootConstrainSelectedInstOperands,
     /* 181150 */     // GIR_Coverage, 3543,
     /* 181150 */     GIR_EraseRootFromParent_Done,
     /* 181151 */   // Label 3561: @181151
     /* 181151 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(181188), // Rule ID 3544 //
     /* 181156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 181180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181186 */     GIR_RootConstrainSelectedInstOperands,
     /* 181187 */     // GIR_Coverage, 3544,
     /* 181187 */     GIR_EraseRootFromParent_Done,
     /* 181188 */   // Label 3562: @181188
     /* 181188 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(181225), // Rule ID 3545 //
     /* 181193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 181217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181223 */     GIR_RootConstrainSelectedInstOperands,
     /* 181224 */     // GIR_Coverage, 3545,
     /* 181224 */     GIR_EraseRootFromParent_Done,
     /* 181225 */   // Label 3563: @181225
     /* 181225 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(181262), // Rule ID 3546 //
     /* 181230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 181254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181260 */     GIR_RootConstrainSelectedInstOperands,
     /* 181261 */     // GIR_Coverage, 3546,
     /* 181261 */     GIR_EraseRootFromParent_Done,
     /* 181262 */   // Label 3564: @181262
     /* 181262 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(181299), // Rule ID 3547 //
     /* 181267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181288 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2068:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 181288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 181291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181297 */     GIR_RootConstrainSelectedInstOperands,
     /* 181298 */     // GIR_Coverage, 3547,
     /* 181298 */     GIR_EraseRootFromParent_Done,
     /* 181299 */   // Label 3565: @181299
     /* 181299 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(181336), // Rule ID 3548 //
     /* 181304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181325 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2068:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 181325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 181328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181334 */     GIR_RootConstrainSelectedInstOperands,
     /* 181335 */     // GIR_Coverage, 3548,
     /* 181335 */     GIR_EraseRootFromParent_Done,
     /* 181336 */   // Label 3566: @181336
     /* 181336 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(181373), // Rule ID 3549 //
     /* 181341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181362 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2068:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 181362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 181365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181371 */     GIR_RootConstrainSelectedInstOperands,
     /* 181372 */     // GIR_Coverage, 3549,
     /* 181372 */     GIR_EraseRootFromParent_Done,
     /* 181373 */   // Label 3567: @181373
     /* 181373 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(181410), // Rule ID 3550 //
     /* 181378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1823:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 181402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181408 */     GIR_RootConstrainSelectedInstOperands,
     /* 181409 */     // GIR_Coverage, 3550,
     /* 181409 */     GIR_EraseRootFromParent_Done,
     /* 181410 */   // Label 3568: @181410
     /* 181410 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(181447), // Rule ID 3551 //
     /* 181415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 181439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181445 */     GIR_RootConstrainSelectedInstOperands,
     /* 181446 */     // GIR_Coverage, 3551,
     /* 181446 */     GIR_EraseRootFromParent_Done,
     /* 181447 */   // Label 3569: @181447
     /* 181447 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(181484), // Rule ID 3552 //
     /* 181452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181473 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 181476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181482 */     GIR_RootConstrainSelectedInstOperands,
     /* 181483 */     // GIR_Coverage, 3552,
     /* 181483 */     GIR_EraseRootFromParent_Done,
     /* 181484 */   // Label 3570: @181484
     /* 181484 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(181521), // Rule ID 3553 //
     /* 181489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 181513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181519 */     GIR_RootConstrainSelectedInstOperands,
     /* 181520 */     // GIR_Coverage, 3553,
     /* 181520 */     GIR_EraseRootFromParent_Done,
     /* 181521 */   // Label 3571: @181521
     /* 181521 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(181558), // Rule ID 3554 //
     /* 181526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181547 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1823:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 181550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181556 */     GIR_RootConstrainSelectedInstOperands,
     /* 181557 */     // GIR_Coverage, 3554,
     /* 181557 */     GIR_EraseRootFromParent_Done,
     /* 181558 */   // Label 3572: @181558
     /* 181558 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(181595), // Rule ID 3555 //
     /* 181563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181584 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1823:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 181587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181593 */     GIR_RootConstrainSelectedInstOperands,
     /* 181594 */     // GIR_Coverage, 3555,
     /* 181594 */     GIR_EraseRootFromParent_Done,
     /* 181595 */   // Label 3573: @181595
     /* 181595 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(181632), // Rule ID 3556 //
     /* 181600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181621 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1823:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 181624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181630 */     GIR_RootConstrainSelectedInstOperands,
     /* 181631 */     // GIR_Coverage, 3556,
     /* 181631 */     GIR_EraseRootFromParent_Done,
     /* 181632 */   // Label 3574: @181632
     /* 181632 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(181669), // Rule ID 8250 //
     /* 181637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 181645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181658 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1202:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 181658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 181661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181667 */     GIR_RootConstrainSelectedInstOperands,
     /* 181668 */     // GIR_Coverage, 8250,
     /* 181668 */     GIR_EraseRootFromParent_Done,
     /* 181669 */   // Label 3575: @181669
     /* 181669 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(181706), // Rule ID 8726 //
     /* 181674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 181682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181695 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1160:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 181698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181704 */     GIR_RootConstrainSelectedInstOperands,
     /* 181705 */     // GIR_Coverage, 8726,
     /* 181705 */     GIR_EraseRootFromParent_Done,
     /* 181706 */   // Label 3576: @181706
     /* 181706 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(181743), // Rule ID 8727 //
     /* 181711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 181719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 181735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181741 */     GIR_RootConstrainSelectedInstOperands,
     /* 181742 */     // GIR_Coverage, 8727,
     /* 181742 */     GIR_EraseRootFromParent_Done,
     /* 181743 */   // Label 3577: @181743
     /* 181743 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(181780), // Rule ID 8728 //
     /* 181748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 181756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181778 */     GIR_RootConstrainSelectedInstOperands,
     /* 181779 */     // GIR_Coverage, 8728,
     /* 181779 */     GIR_EraseRootFromParent_Done,
     /* 181780 */   // Label 3578: @181780
     /* 181780 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(181817), // Rule ID 8729 //
     /* 181785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 181793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 181809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181815 */     GIR_RootConstrainSelectedInstOperands,
     /* 181816 */     // GIR_Coverage, 8729,
     /* 181816 */     GIR_EraseRootFromParent_Done,
     /* 181817 */   // Label 3579: @181817
     /* 181817 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(181854), // Rule ID 8730 //
     /* 181822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 181830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1160:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 181846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181852 */     GIR_RootConstrainSelectedInstOperands,
     /* 181853 */     // GIR_Coverage, 8730,
     /* 181853 */     GIR_EraseRootFromParent_Done,
     /* 181854 */   // Label 3580: @181854
     /* 181854 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(181891), // Rule ID 8731 //
     /* 181859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 181867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 181883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181889 */     GIR_RootConstrainSelectedInstOperands,
     /* 181890 */     // GIR_Coverage, 8731,
     /* 181890 */     GIR_EraseRootFromParent_Done,
     /* 181891 */   // Label 3581: @181891
     /* 181891 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(181928), // Rule ID 8732 //
     /* 181896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 181904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181917 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 181920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181926 */     GIR_RootConstrainSelectedInstOperands,
     /* 181927 */     // GIR_Coverage, 8732,
     /* 181927 */     GIR_EraseRootFromParent_Done,
     /* 181928 */   // Label 3582: @181928
     /* 181928 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(181965), // Rule ID 8733 //
     /* 181933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 181941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 181957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181963 */     GIR_RootConstrainSelectedInstOperands,
     /* 181964 */     // GIR_Coverage, 8733,
     /* 181964 */     GIR_EraseRootFromParent_Done,
     /* 181965 */   // Label 3583: @181965
     /* 181965 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(182005), // Rule ID 9733 //
     /* 181970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 181978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181991 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 181991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 181994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182003 */     GIR_RootConstrainSelectedInstOperands,
     /* 182004 */     // GIR_Coverage, 9733,
     /* 182004 */     GIR_EraseRootFromParent_Done,
     /* 182005 */   // Label 3584: @182005
     /* 182005 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(182045), // Rule ID 9734 //
     /* 182010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182031 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 182034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182043 */     GIR_RootConstrainSelectedInstOperands,
     /* 182044 */     // GIR_Coverage, 9734,
     /* 182044 */     GIR_EraseRootFromParent_Done,
     /* 182045 */   // Label 3585: @182045
     /* 182045 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(182085), // Rule ID 9735 //
     /* 182050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182071 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 182074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182083 */     GIR_RootConstrainSelectedInstOperands,
     /* 182084 */     // GIR_Coverage, 9735,
     /* 182084 */     GIR_EraseRootFromParent_Done,
     /* 182085 */   // Label 3586: @182085
     /* 182085 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(182125), // Rule ID 9736 //
     /* 182090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182111 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 182114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182123 */     GIR_RootConstrainSelectedInstOperands,
     /* 182124 */     // GIR_Coverage, 9736,
     /* 182124 */     GIR_EraseRootFromParent_Done,
     /* 182125 */   // Label 3587: @182125
     /* 182125 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(182165), // Rule ID 9737 //
     /* 182130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182151 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 182154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182163 */     GIR_RootConstrainSelectedInstOperands,
     /* 182164 */     // GIR_Coverage, 9737,
     /* 182164 */     GIR_EraseRootFromParent_Done,
     /* 182165 */   // Label 3588: @182165
     /* 182165 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(182205), // Rule ID 9738 //
     /* 182170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182191 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 182194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182203 */     GIR_RootConstrainSelectedInstOperands,
     /* 182204 */     // GIR_Coverage, 9738,
     /* 182204 */     GIR_EraseRootFromParent_Done,
     /* 182205 */   // Label 3589: @182205
     /* 182205 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(182245), // Rule ID 9739 //
     /* 182210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182231 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 182234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182243 */     GIR_RootConstrainSelectedInstOperands,
     /* 182244 */     // GIR_Coverage, 9739,
     /* 182244 */     GIR_EraseRootFromParent_Done,
     /* 182245 */   // Label 3590: @182245
     /* 182245 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(182285), // Rule ID 9740 //
     /* 182250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182271 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 182274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182283 */     GIR_RootConstrainSelectedInstOperands,
     /* 182284 */     // GIR_Coverage, 9740,
     /* 182284 */     GIR_EraseRootFromParent_Done,
     /* 182285 */   // Label 3591: @182285
     /* 182285 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(182325), // Rule ID 9745 //
     /* 182290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182311 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 182314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182323 */     GIR_RootConstrainSelectedInstOperands,
     /* 182324 */     // GIR_Coverage, 9745,
     /* 182324 */     GIR_EraseRootFromParent_Done,
     /* 182325 */   // Label 3592: @182325
     /* 182325 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(182365), // Rule ID 9746 //
     /* 182330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182351 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 182354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182363 */     GIR_RootConstrainSelectedInstOperands,
     /* 182364 */     // GIR_Coverage, 9746,
     /* 182364 */     GIR_EraseRootFromParent_Done,
     /* 182365 */   // Label 3593: @182365
     /* 182365 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(182405), // Rule ID 9747 //
     /* 182370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182391 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 182394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182403 */     GIR_RootConstrainSelectedInstOperands,
     /* 182404 */     // GIR_Coverage, 9747,
     /* 182404 */     GIR_EraseRootFromParent_Done,
     /* 182405 */   // Label 3594: @182405
     /* 182405 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(182445), // Rule ID 9748 //
     /* 182410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 182434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182443 */     GIR_RootConstrainSelectedInstOperands,
     /* 182444 */     // GIR_Coverage, 9748,
     /* 182444 */     GIR_EraseRootFromParent_Done,
     /* 182445 */   // Label 3595: @182445
     /* 182445 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(182485), // Rule ID 9749 //
     /* 182450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182471 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 182474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182483 */     GIR_RootConstrainSelectedInstOperands,
     /* 182484 */     // GIR_Coverage, 9749,
     /* 182484 */     GIR_EraseRootFromParent_Done,
     /* 182485 */   // Label 3596: @182485
     /* 182485 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(182525), // Rule ID 9750 //
     /* 182490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182511 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 182514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182523 */     GIR_RootConstrainSelectedInstOperands,
     /* 182524 */     // GIR_Coverage, 9750,
     /* 182524 */     GIR_EraseRootFromParent_Done,
     /* 182525 */   // Label 3597: @182525
     /* 182525 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(182565), // Rule ID 9751 //
     /* 182530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182551 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 182554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182563 */     GIR_RootConstrainSelectedInstOperands,
     /* 182564 */     // GIR_Coverage, 9751,
     /* 182564 */     GIR_EraseRootFromParent_Done,
     /* 182565 */   // Label 3598: @182565
     /* 182565 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(182605), // Rule ID 9752 //
     /* 182570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182591 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 182594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182603 */     GIR_RootConstrainSelectedInstOperands,
     /* 182604 */     // GIR_Coverage, 9752,
     /* 182604 */     GIR_EraseRootFromParent_Done,
     /* 182605 */   // Label 3599: @182605
     /* 182605 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(182645), // Rule ID 9753 //
     /* 182610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182631 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 182634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182643 */     GIR_RootConstrainSelectedInstOperands,
     /* 182644 */     // GIR_Coverage, 9753,
     /* 182644 */     GIR_EraseRootFromParent_Done,
     /* 182645 */   // Label 3600: @182645
     /* 182645 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(182685), // Rule ID 9754 //
     /* 182650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 182674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182683 */     GIR_RootConstrainSelectedInstOperands,
     /* 182684 */     // GIR_Coverage, 9754,
     /* 182684 */     GIR_EraseRootFromParent_Done,
     /* 182685 */   // Label 3601: @182685
     /* 182685 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(182725), // Rule ID 9755 //
     /* 182690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182711 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 182714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182723 */     GIR_RootConstrainSelectedInstOperands,
     /* 182724 */     // GIR_Coverage, 9755,
     /* 182724 */     GIR_EraseRootFromParent_Done,
     /* 182725 */   // Label 3602: @182725
     /* 182725 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(182765), // Rule ID 9756 //
     /* 182730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182751 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 182754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182763 */     GIR_RootConstrainSelectedInstOperands,
     /* 182764 */     // GIR_Coverage, 9756,
     /* 182764 */     GIR_EraseRootFromParent_Done,
     /* 182765 */   // Label 3603: @182765
     /* 182765 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(182805), // Rule ID 9761 //
     /* 182770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 182794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182803 */     GIR_RootConstrainSelectedInstOperands,
     /* 182804 */     // GIR_Coverage, 9761,
     /* 182804 */     GIR_EraseRootFromParent_Done,
     /* 182805 */   // Label 3604: @182805
     /* 182805 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(182845), // Rule ID 9762 //
     /* 182810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 182834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182843 */     GIR_RootConstrainSelectedInstOperands,
     /* 182844 */     // GIR_Coverage, 9762,
     /* 182844 */     GIR_EraseRootFromParent_Done,
     /* 182845 */   // Label 3605: @182845
     /* 182845 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(182885), // Rule ID 9763 //
     /* 182850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182871 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 182874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182883 */     GIR_RootConstrainSelectedInstOperands,
     /* 182884 */     // GIR_Coverage, 9763,
     /* 182884 */     GIR_EraseRootFromParent_Done,
     /* 182885 */   // Label 3606: @182885
     /* 182885 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(182925), // Rule ID 9764 //
     /* 182890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 182914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182923 */     GIR_RootConstrainSelectedInstOperands,
     /* 182924 */     // GIR_Coverage, 9764,
     /* 182924 */     GIR_EraseRootFromParent_Done,
     /* 182925 */   // Label 3607: @182925
     /* 182925 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(182962), // Rule ID 9923 //
     /* 182930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 182938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182951 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 182951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 182954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 182956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182960 */     GIR_RootConstrainSelectedInstOperands,
     /* 182961 */     // GIR_Coverage, 9923,
     /* 182961 */     GIR_EraseRootFromParent_Done,
     /* 182962 */   // Label 3608: @182962
     /* 182962 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(182999), // Rule ID 9924 //
     /* 182967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 182975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 182988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 182991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 182993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182997 */     GIR_RootConstrainSelectedInstOperands,
     /* 182998 */     // GIR_Coverage, 9924,
     /* 182998 */     GIR_EraseRootFromParent_Done,
     /* 182999 */   // Label 3609: @182999
     /* 182999 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(183036), // Rule ID 9925 //
     /* 183004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 183012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 183028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183034 */     GIR_RootConstrainSelectedInstOperands,
     /* 183035 */     // GIR_Coverage, 9925,
     /* 183035 */     GIR_EraseRootFromParent_Done,
     /* 183036 */   // Label 3610: @183036
     /* 183036 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(183073), // Rule ID 9926 //
     /* 183041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 183065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183071 */     GIR_RootConstrainSelectedInstOperands,
     /* 183072 */     // GIR_Coverage, 9926,
     /* 183072 */     GIR_EraseRootFromParent_Done,
     /* 183073 */   // Label 3611: @183073
     /* 183073 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(183110), // Rule ID 9927 //
     /* 183078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 183102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183108 */     GIR_RootConstrainSelectedInstOperands,
     /* 183109 */     // GIR_Coverage, 9927,
     /* 183109 */     GIR_EraseRootFromParent_Done,
     /* 183110 */   // Label 3612: @183110
     /* 183110 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(183147), // Rule ID 9928 //
     /* 183115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 183139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183145 */     GIR_RootConstrainSelectedInstOperands,
     /* 183146 */     // GIR_Coverage, 9928,
     /* 183146 */     GIR_EraseRootFromParent_Done,
     /* 183147 */   // Label 3613: @183147
     /* 183147 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(183184), // Rule ID 9929 //
     /* 183152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 183176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183182 */     GIR_RootConstrainSelectedInstOperands,
     /* 183183 */     // GIR_Coverage, 9929,
     /* 183183 */     GIR_EraseRootFromParent_Done,
     /* 183184 */   // Label 3614: @183184
     /* 183184 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(183221), // Rule ID 9930 //
     /* 183189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 183213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183219 */     GIR_RootConstrainSelectedInstOperands,
     /* 183220 */     // GIR_Coverage, 9930,
     /* 183220 */     GIR_EraseRootFromParent_Done,
     /* 183221 */   // Label 3615: @183221
     /* 183221 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(183258), // Rule ID 9931 //
     /* 183226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 183250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183256 */     GIR_RootConstrainSelectedInstOperands,
     /* 183257 */     // GIR_Coverage, 9931,
     /* 183257 */     GIR_EraseRootFromParent_Done,
     /* 183258 */   // Label 3616: @183258
     /* 183258 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(183295), // Rule ID 11071 //
     /* 183263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183293 */     GIR_RootConstrainSelectedInstOperands,
     /* 183294 */     // GIR_Coverage, 11071,
     /* 183294 */     GIR_EraseRootFromParent_Done,
     /* 183295 */   // Label 3617: @183295
     /* 183295 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(183332), // Rule ID 11072 //
     /* 183300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183330 */     GIR_RootConstrainSelectedInstOperands,
     /* 183331 */     // GIR_Coverage, 11072,
     /* 183331 */     GIR_EraseRootFromParent_Done,
     /* 183332 */   // Label 3618: @183332
     /* 183332 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(183369), // Rule ID 11073 //
     /* 183337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183358 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2065:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183367 */     GIR_RootConstrainSelectedInstOperands,
     /* 183368 */     // GIR_Coverage, 11073,
     /* 183368 */     GIR_EraseRootFromParent_Done,
     /* 183369 */   // Label 3619: @183369
     /* 183369 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(183406), // Rule ID 11074 //
     /* 183374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183404 */     GIR_RootConstrainSelectedInstOperands,
     /* 183405 */     // GIR_Coverage, 11074,
     /* 183405 */     GIR_EraseRootFromParent_Done,
     /* 183406 */   // Label 3620: @183406
     /* 183406 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(183443), // Rule ID 11075 //
     /* 183411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183432 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2065:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183441 */     GIR_RootConstrainSelectedInstOperands,
     /* 183442 */     // GIR_Coverage, 11075,
     /* 183442 */     GIR_EraseRootFromParent_Done,
     /* 183443 */   // Label 3621: @183443
     /* 183443 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(183480), // Rule ID 11076 //
     /* 183448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183478 */     GIR_RootConstrainSelectedInstOperands,
     /* 183479 */     // GIR_Coverage, 11076,
     /* 183479 */     GIR_EraseRootFromParent_Done,
     /* 183480 */   // Label 3622: @183480
     /* 183480 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(183517), // Rule ID 11077 //
     /* 183485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183506 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2065:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183515 */     GIR_RootConstrainSelectedInstOperands,
     /* 183516 */     // GIR_Coverage, 11077,
     /* 183516 */     GIR_EraseRootFromParent_Done,
     /* 183517 */   // Label 3623: @183517
     /* 183517 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(183554), // Rule ID 11078 //
     /* 183522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1986:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183552 */     GIR_RootConstrainSelectedInstOperands,
     /* 183553 */     // GIR_Coverage, 11078,
     /* 183553 */     GIR_EraseRootFromParent_Done,
     /* 183554 */   // Label 3624: @183554
     /* 183554 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(183591), // Rule ID 11079 //
     /* 183559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1986:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183589 */     GIR_RootConstrainSelectedInstOperands,
     /* 183590 */     // GIR_Coverage, 11079,
     /* 183590 */     GIR_EraseRootFromParent_Done,
     /* 183591 */   // Label 3625: @183591
     /* 183591 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(183628), // Rule ID 11080 //
     /* 183596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183617 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1986:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183626 */     GIR_RootConstrainSelectedInstOperands,
     /* 183627 */     // GIR_Coverage, 11080,
     /* 183627 */     GIR_EraseRootFromParent_Done,
     /* 183628 */   // Label 3626: @183628
     /* 183628 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(183665), // Rule ID 11081 //
     /* 183633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183663 */     GIR_RootConstrainSelectedInstOperands,
     /* 183664 */     // GIR_Coverage, 11081,
     /* 183664 */     GIR_EraseRootFromParent_Done,
     /* 183665 */   // Label 3627: @183665
     /* 183665 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(183702), // Rule ID 11082 //
     /* 183670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183691 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1986:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183700 */     GIR_RootConstrainSelectedInstOperands,
     /* 183701 */     // GIR_Coverage, 11082,
     /* 183701 */     GIR_EraseRootFromParent_Done,
     /* 183702 */   // Label 3628: @183702
     /* 183702 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(183739), // Rule ID 11083 //
     /* 183707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183737 */     GIR_RootConstrainSelectedInstOperands,
     /* 183738 */     // GIR_Coverage, 11083,
     /* 183738 */     GIR_EraseRootFromParent_Done,
     /* 183739 */   // Label 3629: @183739
     /* 183739 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(183776), // Rule ID 11084 //
     /* 183744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183765 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1986:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183774 */     GIR_RootConstrainSelectedInstOperands,
     /* 183775 */     // GIR_Coverage, 11084,
     /* 183775 */     GIR_EraseRootFromParent_Done,
     /* 183776 */   // Label 3630: @183776
     /* 183776 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(183813), // Rule ID 11085 //
     /* 183781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1991:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183811 */     GIR_RootConstrainSelectedInstOperands,
     /* 183812 */     // GIR_Coverage, 11085,
     /* 183812 */     GIR_EraseRootFromParent_Done,
     /* 183813 */   // Label 3631: @183813
     /* 183813 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(183850), // Rule ID 11086 //
     /* 183818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183848 */     GIR_RootConstrainSelectedInstOperands,
     /* 183849 */     // GIR_Coverage, 11086,
     /* 183849 */     GIR_EraseRootFromParent_Done,
     /* 183850 */   // Label 3632: @183850
     /* 183850 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(183887), // Rule ID 11087 //
     /* 183855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183876 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1991:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183885 */     GIR_RootConstrainSelectedInstOperands,
     /* 183886 */     // GIR_Coverage, 11087,
     /* 183886 */     GIR_EraseRootFromParent_Done,
     /* 183887 */   // Label 3633: @183887
     /* 183887 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(183924), // Rule ID 11088 //
     /* 183892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183922 */     GIR_RootConstrainSelectedInstOperands,
     /* 183923 */     // GIR_Coverage, 11088,
     /* 183923 */     GIR_EraseRootFromParent_Done,
     /* 183924 */   // Label 3634: @183924
     /* 183924 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(183961), // Rule ID 11089 //
     /* 183929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183950 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1991:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183959 */     GIR_RootConstrainSelectedInstOperands,
     /* 183960 */     // GIR_Coverage, 11089,
     /* 183960 */     GIR_EraseRootFromParent_Done,
     /* 183961 */   // Label 3635: @183961
     /* 183961 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(183998), // Rule ID 11090 //
     /* 183966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183996 */     GIR_RootConstrainSelectedInstOperands,
     /* 183997 */     // GIR_Coverage, 11090,
     /* 183997 */     GIR_EraseRootFromParent_Done,
     /* 183998 */   // Label 3636: @183998
     /* 183998 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(184035), // Rule ID 11091 //
     /* 184003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1991:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184033 */     GIR_RootConstrainSelectedInstOperands,
     /* 184034 */     // GIR_Coverage, 11091,
     /* 184034 */     GIR_EraseRootFromParent_Done,
     /* 184035 */   // Label 3637: @184035
     /* 184035 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(184072), // Rule ID 11092 //
     /* 184040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184061 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184070 */     GIR_RootConstrainSelectedInstOperands,
     /* 184071 */     // GIR_Coverage, 11092,
     /* 184071 */     GIR_EraseRootFromParent_Done,
     /* 184072 */   // Label 3638: @184072
     /* 184072 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(184109), // Rule ID 11093 //
     /* 184077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184107 */     GIR_RootConstrainSelectedInstOperands,
     /* 184108 */     // GIR_Coverage, 11093,
     /* 184108 */     GIR_EraseRootFromParent_Done,
     /* 184109 */   // Label 3639: @184109
     /* 184109 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(184146), // Rule ID 11094 //
     /* 184114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184135 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1830:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184144 */     GIR_RootConstrainSelectedInstOperands,
     /* 184145 */     // GIR_Coverage, 11094,
     /* 184145 */     GIR_EraseRootFromParent_Done,
     /* 184146 */   // Label 3640: @184146
     /* 184146 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(184183), // Rule ID 11095 //
     /* 184151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184181 */     GIR_RootConstrainSelectedInstOperands,
     /* 184182 */     // GIR_Coverage, 11095,
     /* 184182 */     GIR_EraseRootFromParent_Done,
     /* 184183 */   // Label 3641: @184183
     /* 184183 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(184220), // Rule ID 11096 //
     /* 184188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184209 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1830:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184218 */     GIR_RootConstrainSelectedInstOperands,
     /* 184219 */     // GIR_Coverage, 11096,
     /* 184219 */     GIR_EraseRootFromParent_Done,
     /* 184220 */   // Label 3642: @184220
     /* 184220 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(184257), // Rule ID 11097 //
     /* 184225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184255 */     GIR_RootConstrainSelectedInstOperands,
     /* 184256 */     // GIR_Coverage, 11097,
     /* 184256 */     GIR_EraseRootFromParent_Done,
     /* 184257 */   // Label 3643: @184257
     /* 184257 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(184294), // Rule ID 11098 //
     /* 184262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184283 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1830:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184292 */     GIR_RootConstrainSelectedInstOperands,
     /* 184293 */     // GIR_Coverage, 11098,
     /* 184293 */     GIR_EraseRootFromParent_Done,
     /* 184294 */   // Label 3644: @184294
     /* 184294 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(184331), // Rule ID 11099 //
     /* 184299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184329 */     GIR_RootConstrainSelectedInstOperands,
     /* 184330 */     // GIR_Coverage, 11099,
     /* 184330 */     GIR_EraseRootFromParent_Done,
     /* 184331 */   // Label 3645: @184331
     /* 184331 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(184368), // Rule ID 11100 //
     /* 184336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184366 */     GIR_RootConstrainSelectedInstOperands,
     /* 184367 */     // GIR_Coverage, 11100,
     /* 184367 */     GIR_EraseRootFromParent_Done,
     /* 184368 */   // Label 3646: @184368
     /* 184368 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(184405), // Rule ID 11101 //
     /* 184373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184394 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1835:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184403 */     GIR_RootConstrainSelectedInstOperands,
     /* 184404 */     // GIR_Coverage, 11101,
     /* 184404 */     GIR_EraseRootFromParent_Done,
     /* 184405 */   // Label 3647: @184405
     /* 184405 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(184442), // Rule ID 11102 //
     /* 184410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184440 */     GIR_RootConstrainSelectedInstOperands,
     /* 184441 */     // GIR_Coverage, 11102,
     /* 184441 */     GIR_EraseRootFromParent_Done,
     /* 184442 */   // Label 3648: @184442
     /* 184442 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(184479), // Rule ID 11103 //
     /* 184447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184468 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1835:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184477 */     GIR_RootConstrainSelectedInstOperands,
     /* 184478 */     // GIR_Coverage, 11103,
     /* 184478 */     GIR_EraseRootFromParent_Done,
     /* 184479 */   // Label 3649: @184479
     /* 184479 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(184516), // Rule ID 11104 //
     /* 184484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184514 */     GIR_RootConstrainSelectedInstOperands,
     /* 184515 */     // GIR_Coverage, 11104,
     /* 184515 */     GIR_EraseRootFromParent_Done,
     /* 184516 */   // Label 3650: @184516
     /* 184516 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(184553), // Rule ID 11105 //
     /* 184521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184542 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1835:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184551 */     GIR_RootConstrainSelectedInstOperands,
     /* 184552 */     // GIR_Coverage, 11105,
     /* 184552 */     GIR_EraseRootFromParent_Done,
     /* 184553 */   // Label 3651: @184553
     /* 184553 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(184590), // Rule ID 11125 //
     /* 184558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184579 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 184582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184588 */     GIR_RootConstrainSelectedInstOperands,
     /* 184589 */     // GIR_Coverage, 11125,
     /* 184589 */     GIR_EraseRootFromParent_Done,
     /* 184590 */   // Label 3652: @184590
     /* 184590 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(184627), // Rule ID 11126 //
     /* 184595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 184619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184625 */     GIR_RootConstrainSelectedInstOperands,
     /* 184626 */     // GIR_Coverage, 11126,
     /* 184626 */     GIR_EraseRootFromParent_Done,
     /* 184627 */   // Label 3653: @184627
     /* 184627 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(184664), // Rule ID 11127 //
     /* 184632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184653 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 184656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184662 */     GIR_RootConstrainSelectedInstOperands,
     /* 184663 */     // GIR_Coverage, 11127,
     /* 184663 */     GIR_EraseRootFromParent_Done,
     /* 184664 */   // Label 3654: @184664
     /* 184664 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(184701), // Rule ID 11128 //
     /* 184669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 184693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184699 */     GIR_RootConstrainSelectedInstOperands,
     /* 184700 */     // GIR_Coverage, 11128,
     /* 184700 */     GIR_EraseRootFromParent_Done,
     /* 184701 */   // Label 3655: @184701
     /* 184701 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(184738), // Rule ID 11416 //
     /* 184706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 184714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184727 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 184730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184736 */     GIR_RootConstrainSelectedInstOperands,
     /* 184737 */     // GIR_Coverage, 11416,
     /* 184737 */     GIR_EraseRootFromParent_Done,
     /* 184738 */   // Label 3656: @184738
     /* 184738 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(184775), // Rule ID 11417 //
     /* 184743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 184751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 184767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184773 */     GIR_RootConstrainSelectedInstOperands,
     /* 184774 */     // GIR_Coverage, 11417,
     /* 184774 */     GIR_EraseRootFromParent_Done,
     /* 184775 */   // Label 3657: @184775
     /* 184775 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(184812), // Rule ID 11418 //
     /* 184780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 184788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1596:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 184804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184810 */     GIR_RootConstrainSelectedInstOperands,
     /* 184811 */     // GIR_Coverage, 11418,
     /* 184811 */     GIR_EraseRootFromParent_Done,
     /* 184812 */   // Label 3658: @184812
     /* 184812 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(184849), // Rule ID 11419 //
     /* 184817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 184825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 184841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184847 */     GIR_RootConstrainSelectedInstOperands,
     /* 184848 */     // GIR_Coverage, 11419,
     /* 184848 */     GIR_EraseRootFromParent_Done,
     /* 184849 */   // Label 3659: @184849
     /* 184849 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(184886), // Rule ID 11420 //
     /* 184854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 184862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 184878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184884 */     GIR_RootConstrainSelectedInstOperands,
     /* 184885 */     // GIR_Coverage, 11420,
     /* 184885 */     GIR_EraseRootFromParent_Done,
     /* 184886 */   // Label 3660: @184886
     /* 184886 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(184923), // Rule ID 11421 //
     /* 184891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 184899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 184915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184921 */     GIR_RootConstrainSelectedInstOperands,
     /* 184922 */     // GIR_Coverage, 11421,
     /* 184922 */     GIR_EraseRootFromParent_Done,
     /* 184923 */   // Label 3661: @184923
     /* 184923 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(184960), // Rule ID 11422 //
     /* 184928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 184936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 184952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184958 */     GIR_RootConstrainSelectedInstOperands,
     /* 184959 */     // GIR_Coverage, 11422,
     /* 184959 */     GIR_EraseRootFromParent_Done,
     /* 184960 */   // Label 3662: @184960
     /* 184960 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(184997), // Rule ID 11423 //
     /* 184965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 184973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 184989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184995 */     GIR_RootConstrainSelectedInstOperands,
     /* 184996 */     // GIR_Coverage, 11423,
     /* 184996 */     GIR_EraseRootFromParent_Done,
     /* 184997 */   // Label 3663: @184997
     /* 184997 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(185034), // Rule ID 11424 //
     /* 185002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 185010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 185026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185032 */     GIR_RootConstrainSelectedInstOperands,
     /* 185033 */     // GIR_Coverage, 11424,
     /* 185033 */     GIR_EraseRootFromParent_Done,
     /* 185034 */   // Label 3664: @185034
     /* 185034 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(185071), // Rule ID 11425 //
     /* 185039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 185063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185069 */     GIR_RootConstrainSelectedInstOperands,
     /* 185070 */     // GIR_Coverage, 11425,
     /* 185070 */     GIR_EraseRootFromParent_Done,
     /* 185071 */   // Label 3665: @185071
     /* 185071 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(185108), // Rule ID 11426 //
     /* 185076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185097 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 185100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185106 */     GIR_RootConstrainSelectedInstOperands,
     /* 185107 */     // GIR_Coverage, 11426,
     /* 185107 */     GIR_EraseRootFromParent_Done,
     /* 185108 */   // Label 3666: @185108
     /* 185108 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(185145), // Rule ID 11427 //
     /* 185113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 185137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185143 */     GIR_RootConstrainSelectedInstOperands,
     /* 185144 */     // GIR_Coverage, 11427,
     /* 185144 */     GIR_EraseRootFromParent_Done,
     /* 185145 */   // Label 3667: @185145
     /* 185145 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(185182), // Rule ID 11428 //
     /* 185150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1775:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 185174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185180 */     GIR_RootConstrainSelectedInstOperands,
     /* 185181 */     // GIR_Coverage, 11428,
     /* 185181 */     GIR_EraseRootFromParent_Done,
     /* 185182 */   // Label 3668: @185182
     /* 185182 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(185219), // Rule ID 11429 //
     /* 185187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 185211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185217 */     GIR_RootConstrainSelectedInstOperands,
     /* 185218 */     // GIR_Coverage, 11429,
     /* 185218 */     GIR_EraseRootFromParent_Done,
     /* 185219 */   // Label 3669: @185219
     /* 185219 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(185256), // Rule ID 11430 //
     /* 185224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185245 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 185248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185254 */     GIR_RootConstrainSelectedInstOperands,
     /* 185255 */     // GIR_Coverage, 11430,
     /* 185255 */     GIR_EraseRootFromParent_Done,
     /* 185256 */   // Label 3670: @185256
     /* 185256 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(185293), // Rule ID 11431 //
     /* 185261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 185285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185291 */     GIR_RootConstrainSelectedInstOperands,
     /* 185292 */     // GIR_Coverage, 11431,
     /* 185292 */     GIR_EraseRootFromParent_Done,
     /* 185293 */   // Label 3671: @185293
     /* 185293 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(185330), // Rule ID 11432 //
     /* 185298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 185322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185328 */     GIR_RootConstrainSelectedInstOperands,
     /* 185329 */     // GIR_Coverage, 11432,
     /* 185329 */     GIR_EraseRootFromParent_Done,
     /* 185330 */   // Label 3672: @185330
     /* 185330 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(185367), // Rule ID 11433 //
     /* 185335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 185359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185365 */     GIR_RootConstrainSelectedInstOperands,
     /* 185366 */     // GIR_Coverage, 11433,
     /* 185366 */     GIR_EraseRootFromParent_Done,
     /* 185367 */   // Label 3673: @185367
     /* 185367 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(185404), // Rule ID 11434 //
     /* 185372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 185396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185402 */     GIR_RootConstrainSelectedInstOperands,
     /* 185403 */     // GIR_Coverage, 11434,
     /* 185403 */     GIR_EraseRootFromParent_Done,
     /* 185404 */   // Label 3674: @185404
     /* 185404 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(185441), // Rule ID 11435 //
     /* 185409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 185433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185439 */     GIR_RootConstrainSelectedInstOperands,
     /* 185440 */     // GIR_Coverage, 11435,
     /* 185440 */     GIR_EraseRootFromParent_Done,
     /* 185441 */   // Label 3675: @185441
     /* 185441 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(185478), // Rule ID 11436 //
     /* 185446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 185470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185476 */     GIR_RootConstrainSelectedInstOperands,
     /* 185477 */     // GIR_Coverage, 11436,
     /* 185477 */     GIR_EraseRootFromParent_Done,
     /* 185478 */   // Label 3676: @185478
     /* 185478 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(185515), // Rule ID 11437 //
     /* 185483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 185507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185513 */     GIR_RootConstrainSelectedInstOperands,
     /* 185514 */     // GIR_Coverage, 11437,
     /* 185514 */     GIR_EraseRootFromParent_Done,
     /* 185515 */   // Label 3677: @185515
     /* 185515 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(185552), // Rule ID 11438 //
     /* 185520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 185544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185550 */     GIR_RootConstrainSelectedInstOperands,
     /* 185551 */     // GIR_Coverage, 11438,
     /* 185551 */     GIR_EraseRootFromParent_Done,
     /* 185552 */   // Label 3678: @185552
     /* 185552 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(185589), // Rule ID 11439 //
     /* 185557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 185581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185587 */     GIR_RootConstrainSelectedInstOperands,
     /* 185588 */     // GIR_Coverage, 11439,
     /* 185588 */     GIR_EraseRootFromParent_Done,
     /* 185589 */   // Label 3679: @185589
     /* 185589 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(185626), // Rule ID 11440 //
     /* 185594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 185602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 185618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185624 */     GIR_RootConstrainSelectedInstOperands,
     /* 185625 */     // GIR_Coverage, 11440,
     /* 185625 */     GIR_EraseRootFromParent_Done,
     /* 185626 */   // Label 3680: @185626
     /* 185626 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(185663), // Rule ID 11441 //
     /* 185631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 185639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 185655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185661 */     GIR_RootConstrainSelectedInstOperands,
     /* 185662 */     // GIR_Coverage, 11441,
     /* 185662 */     GIR_EraseRootFromParent_Done,
     /* 185663 */   // Label 3681: @185663
     /* 185663 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(185700), // Rule ID 11442 //
     /* 185668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 185676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 185692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185698 */     GIR_RootConstrainSelectedInstOperands,
     /* 185699 */     // GIR_Coverage, 11442,
     /* 185699 */     GIR_EraseRootFromParent_Done,
     /* 185700 */   // Label 3682: @185700
     /* 185700 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(185737), // Rule ID 11443 //
     /* 185705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 185713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 185729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185735 */     GIR_RootConstrainSelectedInstOperands,
     /* 185736 */     // GIR_Coverage, 11443,
     /* 185736 */     GIR_EraseRootFromParent_Done,
     /* 185737 */   // Label 3683: @185737
     /* 185737 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(185774), // Rule ID 11444 //
     /* 185742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 185750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185763 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 185766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185772 */     GIR_RootConstrainSelectedInstOperands,
     /* 185773 */     // GIR_Coverage, 11444,
     /* 185773 */     GIR_EraseRootFromParent_Done,
     /* 185774 */   // Label 3684: @185774
     /* 185774 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(185811), // Rule ID 11445 //
     /* 185779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 185787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 185803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185809 */     GIR_RootConstrainSelectedInstOperands,
     /* 185810 */     // GIR_Coverage, 11445,
     /* 185810 */     GIR_EraseRootFromParent_Done,
     /* 185811 */   // Label 3685: @185811
     /* 185811 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(185848), // Rule ID 11446 //
     /* 185816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 185824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185837 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 185840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185846 */     GIR_RootConstrainSelectedInstOperands,
     /* 185847 */     // GIR_Coverage, 11446,
     /* 185847 */     GIR_EraseRootFromParent_Done,
     /* 185848 */   // Label 3686: @185848
     /* 185848 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(185885), // Rule ID 11447 //
     /* 185853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 185861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 185877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185883 */     GIR_RootConstrainSelectedInstOperands,
     /* 185884 */     // GIR_Coverage, 11447,
     /* 185884 */     GIR_EraseRootFromParent_Done,
     /* 185885 */   // Label 3687: @185885
     /* 185885 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(185922), // Rule ID 11448 //
     /* 185890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 185898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 185914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185920 */     GIR_RootConstrainSelectedInstOperands,
     /* 185921 */     // GIR_Coverage, 11448,
     /* 185921 */     GIR_EraseRootFromParent_Done,
     /* 185922 */   // Label 3688: @185922
     /* 185922 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(185959), // Rule ID 11458 //
     /* 185927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 185935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1777:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 185951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185957 */     GIR_RootConstrainSelectedInstOperands,
     /* 185958 */     // GIR_Coverage, 11458,
     /* 185958 */     GIR_EraseRootFromParent_Done,
     /* 185959 */   // Label 3689: @185959
     /* 185959 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(185996), // Rule ID 11459 //
     /* 185964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 185972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 185988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185994 */     GIR_RootConstrainSelectedInstOperands,
     /* 185995 */     // GIR_Coverage, 11459,
     /* 185995 */     GIR_EraseRootFromParent_Done,
     /* 185996 */   // Label 3690: @185996
     /* 185996 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(186033), // Rule ID 11460 //
     /* 186001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 186009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 186025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186031 */     GIR_RootConstrainSelectedInstOperands,
     /* 186032 */     // GIR_Coverage, 11460,
     /* 186032 */     GIR_EraseRootFromParent_Done,
     /* 186033 */   // Label 3691: @186033
     /* 186033 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(186070), // Rule ID 11461 //
     /* 186038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 186062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186068 */     GIR_RootConstrainSelectedInstOperands,
     /* 186069 */     // GIR_Coverage, 11461,
     /* 186069 */     GIR_EraseRootFromParent_Done,
     /* 186070 */   // Label 3692: @186070
     /* 186070 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(186107), // Rule ID 11462 //
     /* 186075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 186099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186105 */     GIR_RootConstrainSelectedInstOperands,
     /* 186106 */     // GIR_Coverage, 11462,
     /* 186106 */     GIR_EraseRootFromParent_Done,
     /* 186107 */   // Label 3693: @186107
     /* 186107 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(186144), // Rule ID 11463 //
     /* 186112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 186136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186142 */     GIR_RootConstrainSelectedInstOperands,
     /* 186143 */     // GIR_Coverage, 11463,
     /* 186143 */     GIR_EraseRootFromParent_Done,
     /* 186144 */   // Label 3694: @186144
     /* 186144 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(186181), // Rule ID 11464 //
     /* 186149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 186173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186179 */     GIR_RootConstrainSelectedInstOperands,
     /* 186180 */     // GIR_Coverage, 11464,
     /* 186180 */     GIR_EraseRootFromParent_Done,
     /* 186181 */   // Label 3695: @186181
     /* 186181 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(186218), // Rule ID 11465 //
     /* 186186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 186210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186216 */     GIR_RootConstrainSelectedInstOperands,
     /* 186217 */     // GIR_Coverage, 11465,
     /* 186217 */     GIR_EraseRootFromParent_Done,
     /* 186218 */   // Label 3696: @186218
     /* 186218 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(186255), // Rule ID 11466 //
     /* 186223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 186247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186253 */     GIR_RootConstrainSelectedInstOperands,
     /* 186254 */     // GIR_Coverage, 11466,
     /* 186254 */     GIR_EraseRootFromParent_Done,
     /* 186255 */   // Label 3697: @186255
     /* 186255 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(186292), // Rule ID 11467 //
     /* 186260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 186284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186290 */     GIR_RootConstrainSelectedInstOperands,
     /* 186291 */     // GIR_Coverage, 11467,
     /* 186291 */     GIR_EraseRootFromParent_Done,
     /* 186292 */   // Label 3698: @186292
     /* 186292 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(186329), // Rule ID 11468 //
     /* 186297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 186321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186327 */     GIR_RootConstrainSelectedInstOperands,
     /* 186328 */     // GIR_Coverage, 11468,
     /* 186328 */     GIR_EraseRootFromParent_Done,
     /* 186329 */   // Label 3699: @186329
     /* 186329 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(186366), // Rule ID 11469 //
     /* 186334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 186358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186364 */     GIR_RootConstrainSelectedInstOperands,
     /* 186365 */     // GIR_Coverage, 11469,
     /* 186365 */     GIR_EraseRootFromParent_Done,
     /* 186366 */   // Label 3700: @186366
     /* 186366 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(186403), // Rule ID 11470 //
     /* 186371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 186395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186401 */     GIR_RootConstrainSelectedInstOperands,
     /* 186402 */     // GIR_Coverage, 11470,
     /* 186402 */     GIR_EraseRootFromParent_Done,
     /* 186403 */   // Label 3701: @186403
     /* 186403 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(186440), // Rule ID 11471 //
     /* 186408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 186432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186438 */     GIR_RootConstrainSelectedInstOperands,
     /* 186439 */     // GIR_Coverage, 11471,
     /* 186439 */     GIR_EraseRootFromParent_Done,
     /* 186440 */   // Label 3702: @186440
     /* 186440 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(186477), // Rule ID 11472 //
     /* 186445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 186469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186475 */     GIR_RootConstrainSelectedInstOperands,
     /* 186476 */     // GIR_Coverage, 11472,
     /* 186476 */     GIR_EraseRootFromParent_Done,
     /* 186477 */   // Label 3703: @186477
     /* 186477 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(186514), // Rule ID 11473 //
     /* 186482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186503 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1709:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 186506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186512 */     GIR_RootConstrainSelectedInstOperands,
     /* 186513 */     // GIR_Coverage, 11473,
     /* 186513 */     GIR_EraseRootFromParent_Done,
     /* 186514 */   // Label 3704: @186514
     /* 186514 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(186551), // Rule ID 11474 //
     /* 186519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 186543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186549 */     GIR_RootConstrainSelectedInstOperands,
     /* 186550 */     // GIR_Coverage, 11474,
     /* 186550 */     GIR_EraseRootFromParent_Done,
     /* 186551 */   // Label 3705: @186551
     /* 186551 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(186588), // Rule ID 11475 //
     /* 186556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 186580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186586 */     GIR_RootConstrainSelectedInstOperands,
     /* 186587 */     // GIR_Coverage, 11475,
     /* 186587 */     GIR_EraseRootFromParent_Done,
     /* 186588 */   // Label 3706: @186588
     /* 186588 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(186625), // Rule ID 11476 //
     /* 186593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 186601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1660:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 186617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186623 */     GIR_RootConstrainSelectedInstOperands,
     /* 186624 */     // GIR_Coverage, 11476,
     /* 186624 */     GIR_EraseRootFromParent_Done,
     /* 186625 */   // Label 3707: @186625
     /* 186625 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(186662), // Rule ID 11477 //
     /* 186630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 186638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186651 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1660:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 186654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186660 */     GIR_RootConstrainSelectedInstOperands,
     /* 186661 */     // GIR_Coverage, 11477,
     /* 186661 */     GIR_EraseRootFromParent_Done,
     /* 186662 */   // Label 3708: @186662
     /* 186662 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(186699), // Rule ID 11478 //
     /* 186667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 186675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1660:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 186691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186697 */     GIR_RootConstrainSelectedInstOperands,
     /* 186698 */     // GIR_Coverage, 11478,
     /* 186698 */     GIR_EraseRootFromParent_Done,
     /* 186699 */   // Label 3709: @186699
     /* 186699 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(186736), // Rule ID 11479 //
     /* 186704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 186712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 186728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186734 */     GIR_RootConstrainSelectedInstOperands,
     /* 186735 */     // GIR_Coverage, 11479,
     /* 186735 */     GIR_EraseRootFromParent_Done,
     /* 186736 */   // Label 3710: @186736
     /* 186736 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(186773), // Rule ID 11480 //
     /* 186741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 186749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 186765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186771 */     GIR_RootConstrainSelectedInstOperands,
     /* 186772 */     // GIR_Coverage, 11480,
     /* 186772 */     GIR_EraseRootFromParent_Done,
     /* 186773 */   // Label 3711: @186773
     /* 186773 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(186810), // Rule ID 11481 //
     /* 186778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 186786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 186802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186808 */     GIR_RootConstrainSelectedInstOperands,
     /* 186809 */     // GIR_Coverage, 11481,
     /* 186809 */     GIR_EraseRootFromParent_Done,
     /* 186810 */   // Label 3712: @186810
     /* 186810 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(186847), // Rule ID 11482 //
     /* 186815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 186823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1898:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 186839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186845 */     GIR_RootConstrainSelectedInstOperands,
     /* 186846 */     // GIR_Coverage, 11482,
     /* 186846 */     GIR_EraseRootFromParent_Done,
     /* 186847 */   // Label 3713: @186847
     /* 186847 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(186884), // Rule ID 11483 //
     /* 186852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 186860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1898:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 186876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186882 */     GIR_RootConstrainSelectedInstOperands,
     /* 186883 */     // GIR_Coverage, 11483,
     /* 186883 */     GIR_EraseRootFromParent_Done,
     /* 186884 */   // Label 3714: @186884
     /* 186884 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(186921), // Rule ID 11484 //
     /* 186889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 186897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1898:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 186913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186919 */     GIR_RootConstrainSelectedInstOperands,
     /* 186920 */     // GIR_Coverage, 11484,
     /* 186920 */     GIR_EraseRootFromParent_Done,
     /* 186921 */   // Label 3715: @186921
     /* 186921 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(186958), // Rule ID 11485 //
     /* 186926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 186934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1900:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 186950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186956 */     GIR_RootConstrainSelectedInstOperands,
     /* 186957 */     // GIR_Coverage, 11485,
     /* 186957 */     GIR_EraseRootFromParent_Done,
     /* 186958 */   // Label 3716: @186958
     /* 186958 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(186995), // Rule ID 11486 //
     /* 186963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 186971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1900:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 186987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186993 */     GIR_RootConstrainSelectedInstOperands,
     /* 186994 */     // GIR_Coverage, 11486,
     /* 186994 */     GIR_EraseRootFromParent_Done,
     /* 186995 */   // Label 3717: @186995
     /* 186995 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(187032), // Rule ID 11487 //
     /* 187000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 187008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1900:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 187024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187030 */     GIR_RootConstrainSelectedInstOperands,
     /* 187031 */     // GIR_Coverage, 11487,
     /* 187031 */     GIR_EraseRootFromParent_Done,
     /* 187032 */   // Label 3718: @187032
     /* 187032 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(187069), // Rule ID 11488 //
     /* 187037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 187045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1538:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 187061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187067 */     GIR_RootConstrainSelectedInstOperands,
     /* 187068 */     // GIR_Coverage, 11488,
     /* 187068 */     GIR_EraseRootFromParent_Done,
     /* 187069 */   // Label 3719: @187069
     /* 187069 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(187106), // Rule ID 11489 //
     /* 187074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 187082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1538:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 187098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187104 */     GIR_RootConstrainSelectedInstOperands,
     /* 187105 */     // GIR_Coverage, 11489,
     /* 187105 */     GIR_EraseRootFromParent_Done,
     /* 187106 */   // Label 3720: @187106
     /* 187106 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(187143), // Rule ID 11590 //
     /* 187111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1568:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 187135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187141 */     GIR_RootConstrainSelectedInstOperands,
     /* 187142 */     // GIR_Coverage, 11590,
     /* 187142 */     GIR_EraseRootFromParent_Done,
     /* 187143 */   // Label 3721: @187143
     /* 187143 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(187180), // Rule ID 11591 //
     /* 187148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1568:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 187172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187178 */     GIR_RootConstrainSelectedInstOperands,
     /* 187179 */     // GIR_Coverage, 11591,
     /* 187179 */     GIR_EraseRootFromParent_Done,
     /* 187180 */   // Label 3722: @187180
     /* 187180 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(187217), // Rule ID 11592 //
     /* 187185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 187209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187215 */     GIR_RootConstrainSelectedInstOperands,
     /* 187216 */     // GIR_Coverage, 11592,
     /* 187216 */     GIR_EraseRootFromParent_Done,
     /* 187217 */   // Label 3723: @187217
     /* 187217 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(187254), // Rule ID 11593 //
     /* 187222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187243 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 187246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187252 */     GIR_RootConstrainSelectedInstOperands,
     /* 187253 */     // GIR_Coverage, 11593,
     /* 187253 */     GIR_EraseRootFromParent_Done,
     /* 187254 */   // Label 3724: @187254
     /* 187254 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(187291), // Rule ID 11594 //
     /* 187259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 187283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187289 */     GIR_RootConstrainSelectedInstOperands,
     /* 187290 */     // GIR_Coverage, 11594,
     /* 187290 */     GIR_EraseRootFromParent_Done,
     /* 187291 */   // Label 3725: @187291
     /* 187291 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(187328), // Rule ID 11595 //
     /* 187296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 187320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187326 */     GIR_RootConstrainSelectedInstOperands,
     /* 187327 */     // GIR_Coverage, 11595,
     /* 187327 */     GIR_EraseRootFromParent_Done,
     /* 187328 */   // Label 3726: @187328
     /* 187328 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(187365), // Rule ID 11596 //
     /* 187333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1584:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 187357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187363 */     GIR_RootConstrainSelectedInstOperands,
     /* 187364 */     // GIR_Coverage, 11596,
     /* 187364 */     GIR_EraseRootFromParent_Done,
     /* 187365 */   // Label 3727: @187365
     /* 187365 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(187402), // Rule ID 11597 //
     /* 187370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1584:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 187394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187400 */     GIR_RootConstrainSelectedInstOperands,
     /* 187401 */     // GIR_Coverage, 11597,
     /* 187401 */     GIR_EraseRootFromParent_Done,
     /* 187402 */   // Label 3728: @187402
     /* 187402 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(187439), // Rule ID 11598 //
     /* 187407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1584:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 187431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187437 */     GIR_RootConstrainSelectedInstOperands,
     /* 187438 */     // GIR_Coverage, 11598,
     /* 187438 */     GIR_EraseRootFromParent_Done,
     /* 187439 */   // Label 3729: @187439
     /* 187439 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(187476), // Rule ID 11614 //
     /* 187444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1951:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 187468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187474 */     GIR_RootConstrainSelectedInstOperands,
     /* 187475 */     // GIR_Coverage, 11614,
     /* 187475 */     GIR_EraseRootFromParent_Done,
     /* 187476 */   // Label 3730: @187476
     /* 187476 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(187513), // Rule ID 11615 //
     /* 187481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1951:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 187505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187511 */     GIR_RootConstrainSelectedInstOperands,
     /* 187512 */     // GIR_Coverage, 11615,
     /* 187512 */     GIR_EraseRootFromParent_Done,
     /* 187513 */   // Label 3731: @187513
     /* 187513 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(187550), // Rule ID 11616 //
     /* 187518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1951:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 187542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187548 */     GIR_RootConstrainSelectedInstOperands,
     /* 187549 */     // GIR_Coverage, 11616,
     /* 187549 */     GIR_EraseRootFromParent_Done,
     /* 187550 */   // Label 3732: @187550
     /* 187550 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(187587), // Rule ID 11617 //
     /* 187555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 187563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 187579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187585 */     GIR_RootConstrainSelectedInstOperands,
     /* 187586 */     // GIR_Coverage, 11617,
     /* 187586 */     GIR_EraseRootFromParent_Done,
     /* 187587 */   // Label 3733: @187587
     /* 187587 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(187624), // Rule ID 11618 //
     /* 187592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 187600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 187616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187622 */     GIR_RootConstrainSelectedInstOperands,
     /* 187623 */     // GIR_Coverage, 11618,
     /* 187623 */     GIR_EraseRootFromParent_Done,
     /* 187624 */   // Label 3734: @187624
     /* 187624 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(187661), // Rule ID 11619 //
     /* 187629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 187637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 187653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187659 */     GIR_RootConstrainSelectedInstOperands,
     /* 187660 */     // GIR_Coverage, 11619,
     /* 187660 */     GIR_EraseRootFromParent_Done,
     /* 187661 */   // Label 3735: @187661
     /* 187661 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(187698), // Rule ID 11635 //
     /* 187666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 187674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187687 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 187690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187696 */     GIR_RootConstrainSelectedInstOperands,
     /* 187697 */     // GIR_Coverage, 11635,
     /* 187697 */     GIR_EraseRootFromParent_Done,
     /* 187698 */   // Label 3736: @187698
     /* 187698 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(187735), // Rule ID 11636 //
     /* 187703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 187711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 187727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187733 */     GIR_RootConstrainSelectedInstOperands,
     /* 187734 */     // GIR_Coverage, 11636,
     /* 187734 */     GIR_EraseRootFromParent_Done,
     /* 187735 */   // Label 3737: @187735
     /* 187735 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(187772), // Rule ID 11637 //
     /* 187740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 187748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 187764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187770 */     GIR_RootConstrainSelectedInstOperands,
     /* 187771 */     // GIR_Coverage, 11637,
     /* 187771 */     GIR_EraseRootFromParent_Done,
     /* 187772 */   // Label 3738: @187772
     /* 187772 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(187809), // Rule ID 11638 //
     /* 187777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 187785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 187801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187807 */     GIR_RootConstrainSelectedInstOperands,
     /* 187808 */     // GIR_Coverage, 11638,
     /* 187808 */     GIR_EraseRootFromParent_Done,
     /* 187809 */   // Label 3739: @187809
     /* 187809 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(187846), // Rule ID 11639 //
     /* 187814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 187822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 187838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187844 */     GIR_RootConstrainSelectedInstOperands,
     /* 187845 */     // GIR_Coverage, 11639,
     /* 187845 */     GIR_EraseRootFromParent_Done,
     /* 187846 */   // Label 3740: @187846
     /* 187846 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(187883), // Rule ID 11640 //
     /* 187851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 187859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 187875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187881 */     GIR_RootConstrainSelectedInstOperands,
     /* 187882 */     // GIR_Coverage, 11640,
     /* 187882 */     GIR_EraseRootFromParent_Done,
     /* 187883 */   // Label 3741: @187883
     /* 187883 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(187923), // Rule ID 11715 //
     /* 187888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 187896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187909 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 187912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187921 */     GIR_RootConstrainSelectedInstOperands,
     /* 187922 */     // GIR_Coverage, 11715,
     /* 187922 */     GIR_EraseRootFromParent_Done,
     /* 187923 */   // Label 3742: @187923
     /* 187923 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(187963), // Rule ID 11716 //
     /* 187928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 187936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187949 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 187952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187961 */     GIR_RootConstrainSelectedInstOperands,
     /* 187962 */     // GIR_Coverage, 11716,
     /* 187962 */     GIR_EraseRootFromParent_Done,
     /* 187963 */   // Label 3743: @187963
     /* 187963 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(188003), // Rule ID 11717 //
     /* 187968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 187976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187989 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 187992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188001 */     GIR_RootConstrainSelectedInstOperands,
     /* 188002 */     // GIR_Coverage, 11717,
     /* 188002 */     GIR_EraseRootFromParent_Done,
     /* 188003 */   // Label 3744: @188003
     /* 188003 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(188043), // Rule ID 11718 //
     /* 188008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188029 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 188032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188041 */     GIR_RootConstrainSelectedInstOperands,
     /* 188042 */     // GIR_Coverage, 11718,
     /* 188042 */     GIR_EraseRootFromParent_Done,
     /* 188043 */   // Label 3745: @188043
     /* 188043 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(188083), // Rule ID 11719 //
     /* 188048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188069 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 188072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188081 */     GIR_RootConstrainSelectedInstOperands,
     /* 188082 */     // GIR_Coverage, 11719,
     /* 188082 */     GIR_EraseRootFromParent_Done,
     /* 188083 */   // Label 3746: @188083
     /* 188083 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(188123), // Rule ID 11720 //
     /* 188088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188109 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 188112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188121 */     GIR_RootConstrainSelectedInstOperands,
     /* 188122 */     // GIR_Coverage, 11720,
     /* 188122 */     GIR_EraseRootFromParent_Done,
     /* 188123 */   // Label 3747: @188123
     /* 188123 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(188163), // Rule ID 11721 //
     /* 188128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188149 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 188152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188161 */     GIR_RootConstrainSelectedInstOperands,
     /* 188162 */     // GIR_Coverage, 11721,
     /* 188162 */     GIR_EraseRootFromParent_Done,
     /* 188163 */   // Label 3748: @188163
     /* 188163 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(188203), // Rule ID 11722 //
     /* 188168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188189 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 188192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188201 */     GIR_RootConstrainSelectedInstOperands,
     /* 188202 */     // GIR_Coverage, 11722,
     /* 188202 */     GIR_EraseRootFromParent_Done,
     /* 188203 */   // Label 3749: @188203
     /* 188203 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(188243), // Rule ID 11727 //
     /* 188208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188229 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 188232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188241 */     GIR_RootConstrainSelectedInstOperands,
     /* 188242 */     // GIR_Coverage, 11727,
     /* 188242 */     GIR_EraseRootFromParent_Done,
     /* 188243 */   // Label 3750: @188243
     /* 188243 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(188283), // Rule ID 11728 //
     /* 188248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188269 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 188272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188281 */     GIR_RootConstrainSelectedInstOperands,
     /* 188282 */     // GIR_Coverage, 11728,
     /* 188282 */     GIR_EraseRootFromParent_Done,
     /* 188283 */   // Label 3751: @188283
     /* 188283 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(188323), // Rule ID 11729 //
     /* 188288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188309 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 188312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188321 */     GIR_RootConstrainSelectedInstOperands,
     /* 188322 */     // GIR_Coverage, 11729,
     /* 188322 */     GIR_EraseRootFromParent_Done,
     /* 188323 */   // Label 3752: @188323
     /* 188323 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(188363), // Rule ID 11730 //
     /* 188328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188349 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 188352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188361 */     GIR_RootConstrainSelectedInstOperands,
     /* 188362 */     // GIR_Coverage, 11730,
     /* 188362 */     GIR_EraseRootFromParent_Done,
     /* 188363 */   // Label 3753: @188363
     /* 188363 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(188403), // Rule ID 11731 //
     /* 188368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188389 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 188392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188401 */     GIR_RootConstrainSelectedInstOperands,
     /* 188402 */     // GIR_Coverage, 11731,
     /* 188402 */     GIR_EraseRootFromParent_Done,
     /* 188403 */   // Label 3754: @188403
     /* 188403 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(188443), // Rule ID 11732 //
     /* 188408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188429 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 188432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188441 */     GIR_RootConstrainSelectedInstOperands,
     /* 188442 */     // GIR_Coverage, 11732,
     /* 188442 */     GIR_EraseRootFromParent_Done,
     /* 188443 */   // Label 3755: @188443
     /* 188443 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(188483), // Rule ID 11733 //
     /* 188448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188469 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 188472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188481 */     GIR_RootConstrainSelectedInstOperands,
     /* 188482 */     // GIR_Coverage, 11733,
     /* 188482 */     GIR_EraseRootFromParent_Done,
     /* 188483 */   // Label 3756: @188483
     /* 188483 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(188523), // Rule ID 11734 //
     /* 188488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 188512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188521 */     GIR_RootConstrainSelectedInstOperands,
     /* 188522 */     // GIR_Coverage, 11734,
     /* 188522 */     GIR_EraseRootFromParent_Done,
     /* 188523 */   // Label 3757: @188523
     /* 188523 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(188563), // Rule ID 11739 //
     /* 188528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 188552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188561 */     GIR_RootConstrainSelectedInstOperands,
     /* 188562 */     // GIR_Coverage, 11739,
     /* 188562 */     GIR_EraseRootFromParent_Done,
     /* 188563 */   // Label 3758: @188563
     /* 188563 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(188603), // Rule ID 11740 //
     /* 188568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188589 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 188592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188601 */     GIR_RootConstrainSelectedInstOperands,
     /* 188602 */     // GIR_Coverage, 11740,
     /* 188602 */     GIR_EraseRootFromParent_Done,
     /* 188603 */   // Label 3759: @188603
     /* 188603 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(188643), // Rule ID 11741 //
     /* 188608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188629 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 188632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188641 */     GIR_RootConstrainSelectedInstOperands,
     /* 188642 */     // GIR_Coverage, 11741,
     /* 188642 */     GIR_EraseRootFromParent_Done,
     /* 188643 */   // Label 3760: @188643
     /* 188643 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(188683), // Rule ID 11742 //
     /* 188648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188669 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 188672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188681 */     GIR_RootConstrainSelectedInstOperands,
     /* 188682 */     // GIR_Coverage, 11742,
     /* 188682 */     GIR_EraseRootFromParent_Done,
     /* 188683 */   // Label 3761: @188683
     /* 188683 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(188723), // Rule ID 11743 //
     /* 188688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188709 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 188712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188721 */     GIR_RootConstrainSelectedInstOperands,
     /* 188722 */     // GIR_Coverage, 11743,
     /* 188722 */     GIR_EraseRootFromParent_Done,
     /* 188723 */   // Label 3762: @188723
     /* 188723 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(188763), // Rule ID 11744 //
     /* 188728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188749 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 188752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188761 */     GIR_RootConstrainSelectedInstOperands,
     /* 188762 */     // GIR_Coverage, 11744,
     /* 188762 */     GIR_EraseRootFromParent_Done,
     /* 188763 */   // Label 3763: @188763
     /* 188763 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(188803), // Rule ID 11745 //
     /* 188768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188789 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 188792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188801 */     GIR_RootConstrainSelectedInstOperands,
     /* 188802 */     // GIR_Coverage, 11745,
     /* 188802 */     GIR_EraseRootFromParent_Done,
     /* 188803 */   // Label 3764: @188803
     /* 188803 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(188843), // Rule ID 11746 //
     /* 188808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188829 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 188832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188841 */     GIR_RootConstrainSelectedInstOperands,
     /* 188842 */     // GIR_Coverage, 11746,
     /* 188842 */     GIR_EraseRootFromParent_Done,
     /* 188843 */   // Label 3765: @188843
     /* 188843 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(188883), // Rule ID 11751 //
     /* 188848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188869 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 188872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188881 */     GIR_RootConstrainSelectedInstOperands,
     /* 188882 */     // GIR_Coverage, 11751,
     /* 188882 */     GIR_EraseRootFromParent_Done,
     /* 188883 */   // Label 3766: @188883
     /* 188883 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(188923), // Rule ID 11752 //
     /* 188888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 188912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188921 */     GIR_RootConstrainSelectedInstOperands,
     /* 188922 */     // GIR_Coverage, 11752,
     /* 188922 */     GIR_EraseRootFromParent_Done,
     /* 188923 */   // Label 3767: @188923
     /* 188923 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(188963), // Rule ID 11753 //
     /* 188928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 188952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188961 */     GIR_RootConstrainSelectedInstOperands,
     /* 188962 */     // GIR_Coverage, 11753,
     /* 188962 */     GIR_EraseRootFromParent_Done,
     /* 188963 */   // Label 3768: @188963
     /* 188963 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(189003), // Rule ID 11754 //
     /* 188968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188989 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 188992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189001 */     GIR_RootConstrainSelectedInstOperands,
     /* 189002 */     // GIR_Coverage, 11754,
     /* 189002 */     GIR_EraseRootFromParent_Done,
     /* 189003 */   // Label 3769: @189003
     /* 189003 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(189043), // Rule ID 11755 //
     /* 189008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189029 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 189032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189041 */     GIR_RootConstrainSelectedInstOperands,
     /* 189042 */     // GIR_Coverage, 11755,
     /* 189042 */     GIR_EraseRootFromParent_Done,
     /* 189043 */   // Label 3770: @189043
     /* 189043 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(189083), // Rule ID 11756 //
     /* 189048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189069 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 189072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189081 */     GIR_RootConstrainSelectedInstOperands,
     /* 189082 */     // GIR_Coverage, 11756,
     /* 189082 */     GIR_EraseRootFromParent_Done,
     /* 189083 */   // Label 3771: @189083
     /* 189083 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(189123), // Rule ID 11757 //
     /* 189088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189109 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 189112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189121 */     GIR_RootConstrainSelectedInstOperands,
     /* 189122 */     // GIR_Coverage, 11757,
     /* 189122 */     GIR_EraseRootFromParent_Done,
     /* 189123 */   // Label 3772: @189123
     /* 189123 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(189163), // Rule ID 11758 //
     /* 189128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189149 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 189152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189161 */     GIR_RootConstrainSelectedInstOperands,
     /* 189162 */     // GIR_Coverage, 11758,
     /* 189162 */     GIR_EraseRootFromParent_Done,
     /* 189163 */   // Label 3773: @189163
     /* 189163 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(189200), // Rule ID 11767 //
     /* 189168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 189176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189189 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 189192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189198 */     GIR_RootConstrainSelectedInstOperands,
     /* 189199 */     // GIR_Coverage, 11767,
     /* 189199 */     GIR_EraseRootFromParent_Done,
     /* 189200 */   // Label 3774: @189200
     /* 189200 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(189237), // Rule ID 11769 //
     /* 189205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 189213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1538:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 189229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189235 */     GIR_RootConstrainSelectedInstOperands,
     /* 189236 */     // GIR_Coverage, 11769,
     /* 189236 */     GIR_EraseRootFromParent_Done,
     /* 189237 */   // Label 3775: @189237
     /* 189237 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(189274), // Rule ID 11770 //
     /* 189242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 189245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 189250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 189266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189272 */     GIR_RootConstrainSelectedInstOperands,
     /* 189273 */     // GIR_Coverage, 11770,
     /* 189273 */     GIR_EraseRootFromParent_Done,
     /* 189274 */   // Label 3776: @189274
     /* 189274 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(189311), // Rule ID 11771 //
     /* 189279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 189282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 189287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1570:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 189303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189309 */     GIR_RootConstrainSelectedInstOperands,
     /* 189310 */     // GIR_Coverage, 11771,
     /* 189310 */     GIR_EraseRootFromParent_Done,
     /* 189311 */   // Label 3777: @189311
     /* 189311 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(189348), // Rule ID 11772 //
     /* 189316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189337 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1178:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 189340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189346 */     GIR_RootConstrainSelectedInstOperands,
     /* 189347 */     // GIR_Coverage, 11772,
     /* 189347 */     GIR_EraseRootFromParent_Done,
     /* 189348 */   // Label 3778: @189348
     /* 189348 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(189385), // Rule ID 11773 //
     /* 189353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1178:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 189377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189383 */     GIR_RootConstrainSelectedInstOperands,
     /* 189384 */     // GIR_Coverage, 11773,
     /* 189384 */     GIR_EraseRootFromParent_Done,
     /* 189385 */   // Label 3779: @189385
     /* 189385 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(189422), // Rule ID 11774 //
     /* 189390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1178:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 189414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189420 */     GIR_RootConstrainSelectedInstOperands,
     /* 189421 */     // GIR_Coverage, 11774,
     /* 189421 */     GIR_EraseRootFromParent_Done,
     /* 189422 */   // Label 3780: @189422
     /* 189422 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(189459), // Rule ID 11775 //
     /* 189427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1178:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 189451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189457 */     GIR_RootConstrainSelectedInstOperands,
     /* 189458 */     // GIR_Coverage, 11775,
     /* 189458 */     GIR_EraseRootFromParent_Done,
     /* 189459 */   // Label 3781: @189459
     /* 189459 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(189496), // Rule ID 11776 //
     /* 189464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189485 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1195:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 189488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189494 */     GIR_RootConstrainSelectedInstOperands,
     /* 189495 */     // GIR_Coverage, 11776,
     /* 189495 */     GIR_EraseRootFromParent_Done,
     /* 189496 */   // Label 3782: @189496
     /* 189496 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(189533), // Rule ID 11777 //
     /* 189501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1195:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 189525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189531 */     GIR_RootConstrainSelectedInstOperands,
     /* 189532 */     // GIR_Coverage, 11777,
     /* 189532 */     GIR_EraseRootFromParent_Done,
     /* 189533 */   // Label 3783: @189533
     /* 189533 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(189570), // Rule ID 11778 //
     /* 189538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1195:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 189562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189568 */     GIR_RootConstrainSelectedInstOperands,
     /* 189569 */     // GIR_Coverage, 11778,
     /* 189569 */     GIR_EraseRootFromParent_Done,
     /* 189570 */   // Label 3784: @189570
     /* 189570 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(189607), // Rule ID 11779 //
     /* 189575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1195:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 189599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189605 */     GIR_RootConstrainSelectedInstOperands,
     /* 189606 */     // GIR_Coverage, 11779,
     /* 189606 */     GIR_EraseRootFromParent_Done,
     /* 189607 */   // Label 3785: @189607
     /* 189607 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(189644), // Rule ID 11892 //
     /* 189612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 189620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189633 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 189636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189642 */     GIR_RootConstrainSelectedInstOperands,
     /* 189643 */     // GIR_Coverage, 11892,
     /* 189643 */     GIR_EraseRootFromParent_Done,
     /* 189644 */   // Label 3786: @189644
     /* 189644 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(189681), // Rule ID 11893 //
     /* 189649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 189657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189670 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 189673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189679 */     GIR_RootConstrainSelectedInstOperands,
     /* 189680 */     // GIR_Coverage, 11893,
     /* 189680 */     GIR_EraseRootFromParent_Done,
     /* 189681 */   // Label 3787: @189681
     /* 189681 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(189718), // Rule ID 11894 //
     /* 189686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 189694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189707 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 189710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189716 */     GIR_RootConstrainSelectedInstOperands,
     /* 189717 */     // GIR_Coverage, 11894,
     /* 189717 */     GIR_EraseRootFromParent_Done,
     /* 189718 */   // Label 3788: @189718
     /* 189718 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(189755), // Rule ID 11895 //
     /* 189723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 189731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189744 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 189747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189753 */     GIR_RootConstrainSelectedInstOperands,
     /* 189754 */     // GIR_Coverage, 11895,
     /* 189754 */     GIR_EraseRootFromParent_Done,
     /* 189755 */   // Label 3789: @189755
     /* 189755 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(189792), // Rule ID 11896 //
     /* 189760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 189768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189781 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 189784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189790 */     GIR_RootConstrainSelectedInstOperands,
     /* 189791 */     // GIR_Coverage, 11896,
     /* 189791 */     GIR_EraseRootFromParent_Done,
     /* 189792 */   // Label 3790: @189792
     /* 189792 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(189829), // Rule ID 11897 //
     /* 189797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 189805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189818 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 189821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189827 */     GIR_RootConstrainSelectedInstOperands,
     /* 189828 */     // GIR_Coverage, 11897,
     /* 189828 */     GIR_EraseRootFromParent_Done,
     /* 189829 */   // Label 3791: @189829
     /* 189829 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(189866), // Rule ID 11898 //
     /* 189834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 189842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189855 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 189858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189864 */     GIR_RootConstrainSelectedInstOperands,
     /* 189865 */     // GIR_Coverage, 11898,
     /* 189865 */     GIR_EraseRootFromParent_Done,
     /* 189866 */   // Label 3792: @189866
     /* 189866 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(189903), // Rule ID 11899 //
     /* 189871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 189879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189892 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 189895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189901 */     GIR_RootConstrainSelectedInstOperands,
     /* 189902 */     // GIR_Coverage, 11899,
     /* 189902 */     GIR_EraseRootFromParent_Done,
     /* 189903 */   // Label 3793: @189903
     /* 189903 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(189940), // Rule ID 11900 //
     /* 189908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 189916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189929 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 189932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189938 */     GIR_RootConstrainSelectedInstOperands,
     /* 189939 */     // GIR_Coverage, 11900,
     /* 189939 */     GIR_EraseRootFromParent_Done,
     /* 189940 */   // Label 3794: @189940
     /* 189940 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(189977), // Rule ID 11901 //
     /* 189945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 189953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189966 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 189969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189975 */     GIR_RootConstrainSelectedInstOperands,
     /* 189976 */     // GIR_Coverage, 11901,
     /* 189976 */     GIR_EraseRootFromParent_Done,
     /* 189977 */   // Label 3795: @189977
     /* 189977 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(190014), // Rule ID 11902 //
     /* 189982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 189990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190003 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 190006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190012 */     GIR_RootConstrainSelectedInstOperands,
     /* 190013 */     // GIR_Coverage, 11902,
     /* 190013 */     GIR_EraseRootFromParent_Done,
     /* 190014 */   // Label 3796: @190014
     /* 190014 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(190051), // Rule ID 11903 //
     /* 190019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 190027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190040 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 190043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190049 */     GIR_RootConstrainSelectedInstOperands,
     /* 190050 */     // GIR_Coverage, 11903,
     /* 190050 */     GIR_EraseRootFromParent_Done,
     /* 190051 */   // Label 3797: @190051
     /* 190051 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(190088), // Rule ID 11904 //
     /* 190056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190077 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 190080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190086 */     GIR_RootConstrainSelectedInstOperands,
     /* 190087 */     // GIR_Coverage, 11904,
     /* 190087 */     GIR_EraseRootFromParent_Done,
     /* 190088 */   // Label 3798: @190088
     /* 190088 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(190125), // Rule ID 11905 //
     /* 190093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190114 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 190117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190123 */     GIR_RootConstrainSelectedInstOperands,
     /* 190124 */     // GIR_Coverage, 11905,
     /* 190124 */     GIR_EraseRootFromParent_Done,
     /* 190125 */   // Label 3799: @190125
     /* 190125 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(190162), // Rule ID 11906 //
     /* 190130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190151 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 190154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190160 */     GIR_RootConstrainSelectedInstOperands,
     /* 190161 */     // GIR_Coverage, 11906,
     /* 190161 */     GIR_EraseRootFromParent_Done,
     /* 190162 */   // Label 3800: @190162
     /* 190162 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(190199), // Rule ID 11907 //
     /* 190167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190188 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 190191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190197 */     GIR_RootConstrainSelectedInstOperands,
     /* 190198 */     // GIR_Coverage, 11907,
     /* 190198 */     GIR_EraseRootFromParent_Done,
     /* 190199 */   // Label 3801: @190199
     /* 190199 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(190236), // Rule ID 11908 //
     /* 190204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190225 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1171:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 190228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190234 */     GIR_RootConstrainSelectedInstOperands,
     /* 190235 */     // GIR_Coverage, 11908,
     /* 190235 */     GIR_EraseRootFromParent_Done,
     /* 190236 */   // Label 3802: @190236
     /* 190236 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(190273), // Rule ID 11909 //
     /* 190241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190262 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1171:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 190265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190271 */     GIR_RootConstrainSelectedInstOperands,
     /* 190272 */     // GIR_Coverage, 11909,
     /* 190272 */     GIR_EraseRootFromParent_Done,
     /* 190273 */   // Label 3803: @190273
     /* 190273 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(190310), // Rule ID 11910 //
     /* 190278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190299 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1171:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 190302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190308 */     GIR_RootConstrainSelectedInstOperands,
     /* 190309 */     // GIR_Coverage, 11910,
     /* 190309 */     GIR_EraseRootFromParent_Done,
     /* 190310 */   // Label 3804: @190310
     /* 190310 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(190347), // Rule ID 11911 //
     /* 190315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190336 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1171:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 190339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190345 */     GIR_RootConstrainSelectedInstOperands,
     /* 190346 */     // GIR_Coverage, 11911,
     /* 190346 */     GIR_EraseRootFromParent_Done,
     /* 190347 */   // Label 3805: @190347
     /* 190347 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(190384), // Rule ID 11912 //
     /* 190352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190373 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 190376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190382 */     GIR_RootConstrainSelectedInstOperands,
     /* 190383 */     // GIR_Coverage, 11912,
     /* 190383 */     GIR_EraseRootFromParent_Done,
     /* 190384 */   // Label 3806: @190384
     /* 190384 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(190421), // Rule ID 11913 //
     /* 190389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190410 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1159:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 190413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190419 */     GIR_RootConstrainSelectedInstOperands,
     /* 190420 */     // GIR_Coverage, 11913,
     /* 190420 */     GIR_EraseRootFromParent_Done,
     /* 190421 */   // Label 3807: @190421
     /* 190421 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(190458), // Rule ID 11914 //
     /* 190426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190447 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1159:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 190450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190456 */     GIR_RootConstrainSelectedInstOperands,
     /* 190457 */     // GIR_Coverage, 11914,
     /* 190457 */     GIR_EraseRootFromParent_Done,
     /* 190458 */   // Label 3808: @190458
     /* 190458 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(190495), // Rule ID 11915 //
     /* 190463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190484 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1159:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 190487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190493 */     GIR_RootConstrainSelectedInstOperands,
     /* 190494 */     // GIR_Coverage, 11915,
     /* 190494 */     GIR_EraseRootFromParent_Done,
     /* 190495 */   // Label 3809: @190495
     /* 190495 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(190532), // Rule ID 11916 //
     /* 190500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190521 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1638:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 190524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190530 */     GIR_RootConstrainSelectedInstOperands,
     /* 190531 */     // GIR_Coverage, 11916,
     /* 190531 */     GIR_EraseRootFromParent_Done,
     /* 190532 */   // Label 3810: @190532
     /* 190532 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(190569), // Rule ID 11917 //
     /* 190537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190558 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1638:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 190561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190567 */     GIR_RootConstrainSelectedInstOperands,
     /* 190568 */     // GIR_Coverage, 11917,
     /* 190568 */     GIR_EraseRootFromParent_Done,
     /* 190569 */   // Label 3811: @190569
     /* 190569 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(190606), // Rule ID 11918 //
     /* 190574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190595 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1638:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 190598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190604 */     GIR_RootConstrainSelectedInstOperands,
     /* 190605 */     // GIR_Coverage, 11918,
     /* 190605 */     GIR_EraseRootFromParent_Done,
     /* 190606 */   // Label 3812: @190606
     /* 190606 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(190643), // Rule ID 11919 //
     /* 190611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190632 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1638:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 190635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190641 */     GIR_RootConstrainSelectedInstOperands,
     /* 190642 */     // GIR_Coverage, 11919,
     /* 190642 */     GIR_EraseRootFromParent_Done,
     /* 190643 */   // Label 3813: @190643
     /* 190643 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(190680), // Rule ID 11920 //
     /* 190648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190669 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1876:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 190672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190678 */     GIR_RootConstrainSelectedInstOperands,
     /* 190679 */     // GIR_Coverage, 11920,
     /* 190679 */     GIR_EraseRootFromParent_Done,
     /* 190680 */   // Label 3814: @190680
     /* 190680 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(190717), // Rule ID 11921 //
     /* 190685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190706 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1876:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 190709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190715 */     GIR_RootConstrainSelectedInstOperands,
     /* 190716 */     // GIR_Coverage, 11921,
     /* 190716 */     GIR_EraseRootFromParent_Done,
     /* 190717 */   // Label 3815: @190717
     /* 190717 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(190754), // Rule ID 11922 //
     /* 190722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190743 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1876:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 190746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190752 */     GIR_RootConstrainSelectedInstOperands,
     /* 190753 */     // GIR_Coverage, 11922,
     /* 190753 */     GIR_EraseRootFromParent_Done,
     /* 190754 */   // Label 3816: @190754
     /* 190754 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(190791), // Rule ID 11923 //
     /* 190759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1876:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 190783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190789 */     GIR_RootConstrainSelectedInstOperands,
     /* 190790 */     // GIR_Coverage, 11923,
     /* 190790 */     GIR_EraseRootFromParent_Done,
     /* 190791 */   // Label 3817: @190791
     /* 190791 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(190828), // Rule ID 11924 //
     /* 190796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190817 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 190820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190826 */     GIR_RootConstrainSelectedInstOperands,
     /* 190827 */     // GIR_Coverage, 11924,
     /* 190827 */     GIR_EraseRootFromParent_Done,
     /* 190828 */   // Label 3818: @190828
     /* 190828 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(190865), // Rule ID 11925 //
     /* 190833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190854 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 190857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190863 */     GIR_RootConstrainSelectedInstOperands,
     /* 190864 */     // GIR_Coverage, 11925,
     /* 190864 */     GIR_EraseRootFromParent_Done,
     /* 190865 */   // Label 3819: @190865
     /* 190865 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(190902), // Rule ID 11926 //
     /* 190870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 190894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190900 */     GIR_RootConstrainSelectedInstOperands,
     /* 190901 */     // GIR_Coverage, 11926,
     /* 190901 */     GIR_EraseRootFromParent_Done,
     /* 190902 */   // Label 3820: @190902
     /* 190902 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(190939), // Rule ID 11927 //
     /* 190907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1647:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 190931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190937 */     GIR_RootConstrainSelectedInstOperands,
     /* 190938 */     // GIR_Coverage, 11927,
     /* 190938 */     GIR_EraseRootFromParent_Done,
     /* 190939 */   // Label 3821: @190939
     /* 190939 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(190976), // Rule ID 11928 //
     /* 190944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 190952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190965 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1885:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 190968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190974 */     GIR_RootConstrainSelectedInstOperands,
     /* 190975 */     // GIR_Coverage, 11928,
     /* 190975 */     GIR_EraseRootFromParent_Done,
     /* 190976 */   // Label 3822: @190976
     /* 190976 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(191013), // Rule ID 11929 //
     /* 190981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 190989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191002 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1885:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 191005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191011 */     GIR_RootConstrainSelectedInstOperands,
     /* 191012 */     // GIR_Coverage, 11929,
     /* 191012 */     GIR_EraseRootFromParent_Done,
     /* 191013 */   // Label 3823: @191013
     /* 191013 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(191050), // Rule ID 11930 //
     /* 191018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 191032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1885:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 191042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191048 */     GIR_RootConstrainSelectedInstOperands,
     /* 191049 */     // GIR_Coverage, 11930,
     /* 191049 */     GIR_EraseRootFromParent_Done,
     /* 191050 */   // Label 3824: @191050
     /* 191050 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(191087), // Rule ID 11931 //
     /* 191055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 191069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191076 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1885:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 191079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191085 */     GIR_RootConstrainSelectedInstOperands,
     /* 191086 */     // GIR_Coverage, 11931,
     /* 191086 */     GIR_EraseRootFromParent_Done,
     /* 191087 */   // Label 3825: @191087
     /* 191087 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(191124), // Rule ID 11932 //
     /* 191092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 191116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191122 */     GIR_RootConstrainSelectedInstOperands,
     /* 191123 */     // GIR_Coverage, 11932,
     /* 191123 */     GIR_EraseRootFromParent_Done,
     /* 191124 */   // Label 3826: @191124
     /* 191124 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(191161), // Rule ID 11933 //
     /* 191129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 191153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191159 */     GIR_RootConstrainSelectedInstOperands,
     /* 191160 */     // GIR_Coverage, 11933,
     /* 191160 */     GIR_EraseRootFromParent_Done,
     /* 191161 */   // Label 3827: @191161
     /* 191161 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(191198), // Rule ID 11934 //
     /* 191166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 191190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191196 */     GIR_RootConstrainSelectedInstOperands,
     /* 191197 */     // GIR_Coverage, 11934,
     /* 191197 */     GIR_EraseRootFromParent_Done,
     /* 191198 */   // Label 3828: @191198
     /* 191198 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(191235), // Rule ID 11935 //
     /* 191203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 191227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191233 */     GIR_RootConstrainSelectedInstOperands,
     /* 191234 */     // GIR_Coverage, 11935,
     /* 191234 */     GIR_EraseRootFromParent_Done,
     /* 191235 */   // Label 3829: @191235
     /* 191235 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(191272), // Rule ID 11936 //
     /* 191240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191261 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2069:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 191264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191270 */     GIR_RootConstrainSelectedInstOperands,
     /* 191271 */     // GIR_Coverage, 11936,
     /* 191271 */     GIR_EraseRootFromParent_Done,
     /* 191272 */   // Label 3830: @191272
     /* 191272 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(191309), // Rule ID 11937 //
     /* 191277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191298 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2069:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 191301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191307 */     GIR_RootConstrainSelectedInstOperands,
     /* 191308 */     // GIR_Coverage, 11937,
     /* 191308 */     GIR_EraseRootFromParent_Done,
     /* 191309 */   // Label 3831: @191309
     /* 191309 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(191346), // Rule ID 11938 //
     /* 191314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191335 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2069:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 191338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191344 */     GIR_RootConstrainSelectedInstOperands,
     /* 191345 */     // GIR_Coverage, 11938,
     /* 191345 */     GIR_EraseRootFromParent_Done,
     /* 191346 */   // Label 3832: @191346
     /* 191346 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(191383), // Rule ID 11939 //
     /* 191351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191372 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 191375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191381 */     GIR_RootConstrainSelectedInstOperands,
     /* 191382 */     // GIR_Coverage, 11939,
     /* 191382 */     GIR_EraseRootFromParent_Done,
     /* 191383 */   // Label 3833: @191383
     /* 191383 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(191420), // Rule ID 11940 //
     /* 191388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 191412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191418 */     GIR_RootConstrainSelectedInstOperands,
     /* 191419 */     // GIR_Coverage, 11940,
     /* 191419 */     GIR_EraseRootFromParent_Done,
     /* 191420 */   // Label 3834: @191420
     /* 191420 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(191457), // Rule ID 11941 //
     /* 191425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 191449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191455 */     GIR_RootConstrainSelectedInstOperands,
     /* 191456 */     // GIR_Coverage, 11941,
     /* 191456 */     GIR_EraseRootFromParent_Done,
     /* 191457 */   // Label 3835: @191457
     /* 191457 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(191494), // Rule ID 11942 //
     /* 191462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 191486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191492 */     GIR_RootConstrainSelectedInstOperands,
     /* 191493 */     // GIR_Coverage, 11942,
     /* 191493 */     GIR_EraseRootFromParent_Done,
     /* 191494 */   // Label 3836: @191494
     /* 191494 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(191531), // Rule ID 11943 //
     /* 191499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1994:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 191523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191529 */     GIR_RootConstrainSelectedInstOperands,
     /* 191530 */     // GIR_Coverage, 11943,
     /* 191530 */     GIR_EraseRootFromParent_Done,
     /* 191531 */   // Label 3837: @191531
     /* 191531 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(191568), // Rule ID 11944 //
     /* 191536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191557 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1994:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 191560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191566 */     GIR_RootConstrainSelectedInstOperands,
     /* 191567 */     // GIR_Coverage, 11944,
     /* 191567 */     GIR_EraseRootFromParent_Done,
     /* 191568 */   // Label 3838: @191568
     /* 191568 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(191605), // Rule ID 11945 //
     /* 191573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1994:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 191597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191603 */     GIR_RootConstrainSelectedInstOperands,
     /* 191604 */     // GIR_Coverage, 11945,
     /* 191604 */     GIR_EraseRootFromParent_Done,
     /* 191605 */   // Label 3839: @191605
     /* 191605 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(191642), // Rule ID 11946 //
     /* 191610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1995:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 191634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191640 */     GIR_RootConstrainSelectedInstOperands,
     /* 191641 */     // GIR_Coverage, 11946,
     /* 191641 */     GIR_EraseRootFromParent_Done,
     /* 191642 */   // Label 3840: @191642
     /* 191642 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(191679), // Rule ID 11947 //
     /* 191647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 191671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191677 */     GIR_RootConstrainSelectedInstOperands,
     /* 191678 */     // GIR_Coverage, 11947,
     /* 191678 */     GIR_EraseRootFromParent_Done,
     /* 191679 */   // Label 3841: @191679
     /* 191679 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(191716), // Rule ID 11948 //
     /* 191684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191705 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 191708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191714 */     GIR_RootConstrainSelectedInstOperands,
     /* 191715 */     // GIR_Coverage, 11948,
     /* 191715 */     GIR_EraseRootFromParent_Done,
     /* 191716 */   // Label 3842: @191716
     /* 191716 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(191753), // Rule ID 11949 //
     /* 191721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 191745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191751 */     GIR_RootConstrainSelectedInstOperands,
     /* 191752 */     // GIR_Coverage, 11949,
     /* 191752 */     GIR_EraseRootFromParent_Done,
     /* 191753 */   // Label 3843: @191753
     /* 191753 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(191790), // Rule ID 11950 //
     /* 191758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191779 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1995:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 191782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191788 */     GIR_RootConstrainSelectedInstOperands,
     /* 191789 */     // GIR_Coverage, 11950,
     /* 191789 */     GIR_EraseRootFromParent_Done,
     /* 191790 */   // Label 3844: @191790
     /* 191790 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(191827), // Rule ID 11951 //
     /* 191795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191816 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1995:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 191819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191825 */     GIR_RootConstrainSelectedInstOperands,
     /* 191826 */     // GIR_Coverage, 11951,
     /* 191826 */     GIR_EraseRootFromParent_Done,
     /* 191827 */   // Label 3845: @191827
     /* 191827 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(191864), // Rule ID 11952 //
     /* 191832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1995:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 191856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191862 */     GIR_RootConstrainSelectedInstOperands,
     /* 191863 */     // GIR_Coverage, 11952,
     /* 191863 */     GIR_EraseRootFromParent_Done,
     /* 191864 */   // Label 3846: @191864
     /* 191864 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(191906), // Rule ID 3198 //
     /* 191869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 191877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191884 */     // MIs[0] Op1
     /* 191884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 191888 */     // MIs[0] Op2
     /* 191888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 191892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2048:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 191895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191904 */     GIR_RootConstrainSelectedInstOperands,
     /* 191905 */     // GIR_Coverage, 3198,
     /* 191905 */     GIR_EraseRootFromParent_Done,
     /* 191906 */   // Label 3847: @191906
     /* 191906 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(191948), // Rule ID 3199 //
     /* 191911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 191919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191926 */     // MIs[0] Op1
     /* 191926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 191930 */     // MIs[0] Op2
     /* 191930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 191934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2050:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 191937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191946 */     GIR_RootConstrainSelectedInstOperands,
     /* 191947 */     // GIR_Coverage, 3199,
     /* 191947 */     GIR_EraseRootFromParent_Done,
     /* 191948 */   // Label 3848: @191948
     /* 191948 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(191990), // Rule ID 3200 //
     /* 191953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 191961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191968 */     // MIs[0] Op1
     /* 191968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 191972 */     // MIs[0] Op2
     /* 191972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 191976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2051:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 191979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191988 */     GIR_RootConstrainSelectedInstOperands,
     /* 191989 */     // GIR_Coverage, 3200,
     /* 191989 */     GIR_EraseRootFromParent_Done,
     /* 191990 */   // Label 3849: @191990
     /* 191990 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(192032), // Rule ID 3201 //
     /* 191995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 192003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 192006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192010 */     // MIs[0] Op1
     /* 192010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192014 */     // MIs[0] Op2
     /* 192014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192018 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2049:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 192021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192030 */     GIR_RootConstrainSelectedInstOperands,
     /* 192031 */     // GIR_Coverage, 3201,
     /* 192031 */     GIR_EraseRootFromParent_Done,
     /* 192032 */   // Label 3850: @192032
     /* 192032 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(192074), // Rule ID 11763 //
     /* 192037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 192045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 192048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192052 */     // MIs[0] Op1
     /* 192052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192056 */     // MIs[0] Op2
     /* 192056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2044:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 192063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192072 */     GIR_RootConstrainSelectedInstOperands,
     /* 192073 */     // GIR_Coverage, 11763,
     /* 192073 */     GIR_EraseRootFromParent_Done,
     /* 192074 */   // Label 3851: @192074
     /* 192074 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(192116), // Rule ID 11764 //
     /* 192079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 192087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 192090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192094 */     // MIs[0] Op1
     /* 192094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192098 */     // MIs[0] Op2
     /* 192098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192102 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2046:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 192105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192114 */     GIR_RootConstrainSelectedInstOperands,
     /* 192115 */     // GIR_Coverage, 11764,
     /* 192115 */     GIR_EraseRootFromParent_Done,
     /* 192116 */   // Label 3852: @192116
     /* 192116 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(192158), // Rule ID 11765 //
     /* 192121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 192129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 192132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192136 */     // MIs[0] Op1
     /* 192136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192140 */     // MIs[0] Op2
     /* 192140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2047:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 192147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192156 */     GIR_RootConstrainSelectedInstOperands,
     /* 192157 */     // GIR_Coverage, 11765,
     /* 192157 */     GIR_EraseRootFromParent_Done,
     /* 192158 */   // Label 3853: @192158
     /* 192158 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(192200), // Rule ID 11766 //
     /* 192163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 192171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 192174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192178 */     // MIs[0] Op1
     /* 192178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192182 */     // MIs[0] Op2
     /* 192182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192186 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2045:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 192189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192198 */     GIR_RootConstrainSelectedInstOperands,
     /* 192199 */     // GIR_Coverage, 11766,
     /* 192199 */     GIR_EraseRootFromParent_Done,
     /* 192200 */   // Label 3854: @192200
     /* 192200 */   GIM_Reject,
     /* 192201 */ // Label 2901: @192201
     /* 192201 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(235984),
     /* 192206 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 192209 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(192322), // Rule ID 2062 //
     /* 192214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 192222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 192266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 192279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192287 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 192291 */     // MIs[3] Operand 1
     /* 192291 */     // No operand predicates
     /* 192291 */     // MIs[1] Operand 2
     /* 192291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192304 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 192307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192320 */     GIR_RootConstrainSelectedInstOperands,
     /* 192321 */     // GIR_Coverage, 2062,
     /* 192321 */     GIR_EraseRootFromParent_Done,
     /* 192322 */   // Label 3856: @192322
     /* 192322 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(192435), // Rule ID 2069 //
     /* 192327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 192335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 192379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 192392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192400 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 192404 */     // MIs[3] Operand 1
     /* 192404 */     // No operand predicates
     /* 192404 */     // MIs[1] Operand 2
     /* 192404 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192417 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 192420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192433 */     GIR_RootConstrainSelectedInstOperands,
     /* 192434 */     // GIR_Coverage, 2069,
     /* 192434 */     GIR_EraseRootFromParent_Done,
     /* 192435 */   // Label 3857: @192435
     /* 192435 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(192548), // Rule ID 2065 //
     /* 192440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 192448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 192460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 192517 */     // MIs[3] Operand 1
     /* 192517 */     // No operand predicates
     /* 192517 */     // MIs[1] Operand 2
     /* 192517 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192530 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 192533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192546 */     GIR_RootConstrainSelectedInstOperands,
     /* 192547 */     // GIR_Coverage, 2065,
     /* 192547 */     GIR_EraseRootFromParent_Done,
     /* 192548 */   // Label 3858: @192548
     /* 192548 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(192661), // Rule ID 2072 //
     /* 192553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 192561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 192573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192626 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 192630 */     // MIs[3] Operand 1
     /* 192630 */     // No operand predicates
     /* 192630 */     // MIs[1] Operand 2
     /* 192630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192643 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 192646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192659 */     GIR_RootConstrainSelectedInstOperands,
     /* 192660 */     // GIR_Coverage, 2072,
     /* 192660 */     GIR_EraseRootFromParent_Done,
     /* 192661 */   // Label 3859: @192661
     /* 192661 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(192766), // Rule ID 3811 //
     /* 192666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 192674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 192706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 192710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192739 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 192743 */     // MIs[3] Operand 1
     /* 192743 */     // No operand predicates
     /* 192743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192745 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 192745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 192748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192764 */     GIR_RootConstrainSelectedInstOperands,
     /* 192765 */     // GIR_Coverage, 3811,
     /* 192765 */     GIR_EraseRootFromParent_Done,
     /* 192766 */   // Label 3860: @192766
     /* 192766 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(192871), // Rule ID 3812 //
     /* 192771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 192779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 192811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 192815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192844 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 192848 */     // MIs[3] Operand 1
     /* 192848 */     // No operand predicates
     /* 192848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192850 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 192850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 192853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192869 */     GIR_RootConstrainSelectedInstOperands,
     /* 192870 */     // GIR_Coverage, 3812,
     /* 192870 */     GIR_EraseRootFromParent_Done,
     /* 192871 */   // Label 3861: @192871
     /* 192871 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(192976), // Rule ID 3813 //
     /* 192876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 192884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 192916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 192920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 192953 */     // MIs[3] Operand 1
     /* 192953 */     // No operand predicates
     /* 192953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192955 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 192955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 192958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 192974 */     GIR_RootConstrainSelectedInstOperands,
     /* 192975 */     // GIR_Coverage, 3813,
     /* 192975 */     GIR_EraseRootFromParent_Done,
     /* 192976 */   // Label 3862: @192976
     /* 192976 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(193081), // Rule ID 3814 //
     /* 192981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 192989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 193001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 193025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193054 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193058 */     // MIs[3] Operand 1
     /* 193058 */     // No operand predicates
     /* 193058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193060 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 193063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193079 */     GIR_RootConstrainSelectedInstOperands,
     /* 193080 */     // GIR_Coverage, 3814,
     /* 193080 */     GIR_EraseRootFromParent_Done,
     /* 193081 */   // Label 3863: @193081
     /* 193081 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(193186), // Rule ID 3819 //
     /* 193086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193159 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193163 */     // MIs[3] Operand 1
     /* 193163 */     // No operand predicates
     /* 193163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193165 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 193165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193184 */     GIR_RootConstrainSelectedInstOperands,
     /* 193185 */     // GIR_Coverage, 3819,
     /* 193185 */     GIR_EraseRootFromParent_Done,
     /* 193186 */   // Label 3864: @193186
     /* 193186 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(193291), // Rule ID 3820 //
     /* 193191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 193199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193264 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193268 */     // MIs[3] Operand 1
     /* 193268 */     // No operand predicates
     /* 193268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193270 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 193270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193289 */     GIR_RootConstrainSelectedInstOperands,
     /* 193290 */     // GIR_Coverage, 3820,
     /* 193290 */     GIR_EraseRootFromParent_Done,
     /* 193291 */   // Label 3865: @193291
     /* 193291 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(193396), // Rule ID 3821 //
     /* 193296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 193304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193373 */     // MIs[3] Operand 1
     /* 193373 */     // No operand predicates
     /* 193373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193375 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 193375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 193394 */     GIR_RootConstrainSelectedInstOperands,
     /* 193395 */     // GIR_Coverage, 3821,
     /* 193395 */     GIR_EraseRootFromParent_Done,
     /* 193396 */   // Label 3866: @193396
     /* 193396 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(193501), // Rule ID 3822 //
     /* 193401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193478 */     // MIs[3] Operand 1
     /* 193478 */     // No operand predicates
     /* 193478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193480 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193499 */     GIR_RootConstrainSelectedInstOperands,
     /* 193500 */     // GIR_Coverage, 3822,
     /* 193500 */     GIR_EraseRootFromParent_Done,
     /* 193501 */   // Label 3867: @193501
     /* 193501 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(193606), // Rule ID 3835 //
     /* 193506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193583 */     // MIs[3] Operand 1
     /* 193583 */     // No operand predicates
     /* 193583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193585 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 193585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193604 */     GIR_RootConstrainSelectedInstOperands,
     /* 193605 */     // GIR_Coverage, 3835,
     /* 193605 */     GIR_EraseRootFromParent_Done,
     /* 193606 */   // Label 3868: @193606
     /* 193606 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(193711), // Rule ID 3836 //
     /* 193611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 193619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193684 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193688 */     // MIs[3] Operand 1
     /* 193688 */     // No operand predicates
     /* 193688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193690 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 193690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193709 */     GIR_RootConstrainSelectedInstOperands,
     /* 193710 */     // GIR_Coverage, 3836,
     /* 193710 */     GIR_EraseRootFromParent_Done,
     /* 193711 */   // Label 3869: @193711
     /* 193711 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(193816), // Rule ID 3837 //
     /* 193716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 193724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193789 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193793 */     // MIs[3] Operand 1
     /* 193793 */     // No operand predicates
     /* 193793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193795 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 193795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 193814 */     GIR_RootConstrainSelectedInstOperands,
     /* 193815 */     // GIR_Coverage, 3837,
     /* 193815 */     GIR_EraseRootFromParent_Done,
     /* 193816 */   // Label 3870: @193816
     /* 193816 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(193921), // Rule ID 3838 //
     /* 193821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193894 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193898 */     // MIs[3] Operand 1
     /* 193898 */     // No operand predicates
     /* 193898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193900 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193919 */     GIR_RootConstrainSelectedInstOperands,
     /* 193920 */     // GIR_Coverage, 3838,
     /* 193920 */     GIR_EraseRootFromParent_Done,
     /* 193921 */   // Label 3871: @193921
     /* 193921 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(193975), // Rule ID 59 //
     /* 193926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 193929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 193934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 193943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 193947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 193951 */     // MIs[0] Operand 3
     /* 193951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 193962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 193966 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 193966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 193969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193973 */     GIR_RootConstrainSelectedInstOperands,
     /* 193974 */     // GIR_Coverage, 59,
     /* 193974 */     GIR_EraseRootFromParent_Done,
     /* 193975 */   // Label 3872: @193975
     /* 193975 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194029), // Rule ID 60 //
     /* 193980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 193983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 193988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 193997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194005 */     // MIs[0] Operand 3
     /* 194005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 194016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194020 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 194023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194027 */     GIR_RootConstrainSelectedInstOperands,
     /* 194028 */     // GIR_Coverage, 60,
     /* 194028 */     GIR_EraseRootFromParent_Done,
     /* 194029 */   // Label 3873: @194029
     /* 194029 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194083), // Rule ID 61 //
     /* 194034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194059 */     // MIs[0] Operand 3
     /* 194059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 194070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194074 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 194077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194081 */     GIR_RootConstrainSelectedInstOperands,
     /* 194082 */     // GIR_Coverage, 61,
     /* 194082 */     GIR_EraseRootFromParent_Done,
     /* 194083 */   // Label 3874: @194083
     /* 194083 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194137), // Rule ID 62 //
     /* 194088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194113 */     // MIs[0] Operand 3
     /* 194113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 194124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194128 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 194131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194135 */     GIR_RootConstrainSelectedInstOperands,
     /* 194136 */     // GIR_Coverage, 62,
     /* 194136 */     GIR_EraseRootFromParent_Done,
     /* 194137 */   // Label 3875: @194137
     /* 194137 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194193), // Rule ID 2638 //
     /* 194142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 194150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194164 */     // MIs[0] pattern
     /* 194164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194172 */     // MIs[0] imm4
     /* 194172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1716:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 194183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 194185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 194187 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194189 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194191 */     GIR_RootConstrainSelectedInstOperands,
     /* 194192 */     // GIR_Coverage, 2638,
     /* 194192 */     GIR_EraseRootFromParent_Done,
     /* 194193 */   // Label 3876: @194193
     /* 194193 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(194249), // Rule ID 2647 //
     /* 194198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 194206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194220 */     // MIs[0] pattern
     /* 194220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194228 */     // MIs[0] imm4
     /* 194228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194236 */     // (intrinsic_wo_chain:{ *:[i32] } 1922:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 194239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194243 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194245 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194247 */     GIR_RootConstrainSelectedInstOperands,
     /* 194248 */     // GIR_Coverage, 2647,
     /* 194248 */     GIR_EraseRootFromParent_Done,
     /* 194249 */   // Label 3877: @194249
     /* 194249 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(194305), // Rule ID 2648 //
     /* 194254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 194262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194276 */     // MIs[0] pattern
     /* 194276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194284 */     // MIs[0] imm4
     /* 194284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194292 */     // (intrinsic_wo_chain:{ *:[i64] } 1712:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 194295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194299 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194301 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194303 */     GIR_RootConstrainSelectedInstOperands,
     /* 194304 */     // GIR_Coverage, 2648,
     /* 194304 */     GIR_EraseRootFromParent_Done,
     /* 194305 */   // Label 3878: @194305
     /* 194305 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(194361), // Rule ID 9822 //
     /* 194310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 194318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194332 */     // MIs[0] pattern
     /* 194332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194340 */     // MIs[0] imm4
     /* 194340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194348 */     // (intrinsic_wo_chain:{ *:[i32] } 1908:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 194351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194355 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194357 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194359 */     GIR_RootConstrainSelectedInstOperands,
     /* 194360 */     // GIR_Coverage, 9822,
     /* 194360 */     GIR_EraseRootFromParent_Done,
     /* 194361 */   // Label 3879: @194361
     /* 194361 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(194417), // Rule ID 9823 //
     /* 194366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 194374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194388 */     // MIs[0] pattern
     /* 194388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194396 */     // MIs[0] imm4
     /* 194396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194404 */     // (intrinsic_wo_chain:{ *:[i64] } 1923:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 194407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194411 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194413 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194415 */     GIR_RootConstrainSelectedInstOperands,
     /* 194416 */     // GIR_Coverage, 9823,
     /* 194416 */     GIR_EraseRootFromParent_Done,
     /* 194417 */   // Label 3880: @194417
     /* 194417 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(194473), // Rule ID 9824 //
     /* 194422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 194430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194444 */     // MIs[0] pattern
     /* 194444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194452 */     // MIs[0] imm4
     /* 194452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194460 */     // (intrinsic_wo_chain:{ *:[i64] } 1678:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 194463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194467 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194469 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194471 */     GIR_RootConstrainSelectedInstOperands,
     /* 194472 */     // GIR_Coverage, 9824,
     /* 194472 */     GIR_EraseRootFromParent_Done,
     /* 194473 */   // Label 3881: @194473
     /* 194473 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(194529), // Rule ID 9825 //
     /* 194478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 194486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194500 */     // MIs[0] pattern
     /* 194500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194508 */     // MIs[0] imm4
     /* 194508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194516 */     // (intrinsic_wo_chain:{ *:[i64] } 1909:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 194519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194523 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194525 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194527 */     GIR_RootConstrainSelectedInstOperands,
     /* 194528 */     // GIR_Coverage, 9825,
     /* 194528 */     GIR_EraseRootFromParent_Done,
     /* 194529 */   // Label 3882: @194529
     /* 194529 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(194585), // Rule ID 9828 //
     /* 194534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 194542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194556 */     // MIs[0] pattern
     /* 194556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194564 */     // MIs[0] imm4
     /* 194564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194572 */     // (intrinsic_wo_chain:{ *:[i32] } 1928:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194579 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194581 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194583 */     GIR_RootConstrainSelectedInstOperands,
     /* 194584 */     // GIR_Coverage, 9828,
     /* 194584 */     GIR_EraseRootFromParent_Done,
     /* 194585 */   // Label 3883: @194585
     /* 194585 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(194641), // Rule ID 9831 //
     /* 194590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 194598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194612 */     // MIs[0] pattern
     /* 194612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194620 */     // MIs[0] imm4
     /* 194620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194628 */     // (intrinsic_wo_chain:{ *:[i32] } 1914:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 194631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194635 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194637 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194639 */     GIR_RootConstrainSelectedInstOperands,
     /* 194640 */     // GIR_Coverage, 9831,
     /* 194640 */     GIR_EraseRootFromParent_Done,
     /* 194641 */   // Label 3884: @194641
     /* 194641 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(194697), // Rule ID 9832 //
     /* 194646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 194654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194668 */     // MIs[0] pattern
     /* 194668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194676 */     // MIs[0] imm4
     /* 194676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194684 */     // (intrinsic_wo_chain:{ *:[i64] } 1718:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 194687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194691 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194693 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194695 */     GIR_RootConstrainSelectedInstOperands,
     /* 194696 */     // GIR_Coverage, 9832,
     /* 194696 */     GIR_EraseRootFromParent_Done,
     /* 194697 */   // Label 3885: @194697
     /* 194697 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(194753), // Rule ID 9833 //
     /* 194702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 194710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194724 */     // MIs[0] pattern
     /* 194724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194732 */     // MIs[0] imm4
     /* 194732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194740 */     // (intrinsic_wo_chain:{ *:[i64] } 1929:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 194743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194747 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194749 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194751 */     GIR_RootConstrainSelectedInstOperands,
     /* 194752 */     // GIR_Coverage, 9833,
     /* 194752 */     GIR_EraseRootFromParent_Done,
     /* 194753 */   // Label 3886: @194753
     /* 194753 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(194809), // Rule ID 9834 //
     /* 194758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 194766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194780 */     // MIs[0] pattern
     /* 194780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194788 */     // MIs[0] imm4
     /* 194788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194796 */     // (intrinsic_wo_chain:{ *:[i64] } 1684:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 194799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194803 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194805 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194807 */     GIR_RootConstrainSelectedInstOperands,
     /* 194808 */     // GIR_Coverage, 9834,
     /* 194808 */     GIR_EraseRootFromParent_Done,
     /* 194809 */   // Label 3887: @194809
     /* 194809 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(194865), // Rule ID 9835 //
     /* 194814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 194822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194836 */     // MIs[0] pattern
     /* 194836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194844 */     // MIs[0] imm4
     /* 194844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194852 */     // (intrinsic_wo_chain:{ *:[i64] } 1915:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 194855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194859 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194861 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194863 */     GIR_RootConstrainSelectedInstOperands,
     /* 194864 */     // GIR_Coverage, 9835,
     /* 194864 */     GIR_EraseRootFromParent_Done,
     /* 194865 */   // Label 3888: @194865
     /* 194865 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(194921), // Rule ID 9838 //
     /* 194870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 194878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194892 */     // MIs[0] pattern
     /* 194892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194900 */     // MIs[0] imm4
     /* 194900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194908 */     // (intrinsic_wo_chain:{ *:[i32] } 1934:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 194911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194915 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194917 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194919 */     GIR_RootConstrainSelectedInstOperands,
     /* 194920 */     // GIR_Coverage, 9838,
     /* 194920 */     GIR_EraseRootFromParent_Done,
     /* 194921 */   // Label 3889: @194921
     /* 194921 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(194977), // Rule ID 9841 //
     /* 194926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 194934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194948 */     // MIs[0] pattern
     /* 194948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194956 */     // MIs[0] imm4
     /* 194956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194964 */     // (intrinsic_wo_chain:{ *:[i32] } 1920:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 194967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194971 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194973 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194975 */     GIR_RootConstrainSelectedInstOperands,
     /* 194976 */     // GIR_Coverage, 9841,
     /* 194976 */     GIR_EraseRootFromParent_Done,
     /* 194977 */   // Label 3890: @194977
     /* 194977 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195033), // Rule ID 9842 //
     /* 194982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 194990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195004 */     // MIs[0] pattern
     /* 195004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195012 */     // MIs[0] imm4
     /* 195012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195020 */     // (intrinsic_wo_chain:{ *:[i64] } 1724:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 195023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195027 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195029 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195031 */     GIR_RootConstrainSelectedInstOperands,
     /* 195032 */     // GIR_Coverage, 9842,
     /* 195032 */     GIR_EraseRootFromParent_Done,
     /* 195033 */   // Label 3891: @195033
     /* 195033 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195089), // Rule ID 9843 //
     /* 195038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 195046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195060 */     // MIs[0] pattern
     /* 195060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195068 */     // MIs[0] imm4
     /* 195068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195076 */     // (intrinsic_wo_chain:{ *:[i64] } 1935:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 195079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195083 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195085 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195087 */     GIR_RootConstrainSelectedInstOperands,
     /* 195088 */     // GIR_Coverage, 9843,
     /* 195088 */     GIR_EraseRootFromParent_Done,
     /* 195089 */   // Label 3892: @195089
     /* 195089 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195145), // Rule ID 9844 //
     /* 195094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 195102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195116 */     // MIs[0] pattern
     /* 195116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195124 */     // MIs[0] imm4
     /* 195124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195132 */     // (intrinsic_wo_chain:{ *:[i64] } 1690:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 195135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195139 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195141 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195143 */     GIR_RootConstrainSelectedInstOperands,
     /* 195144 */     // GIR_Coverage, 9844,
     /* 195144 */     GIR_EraseRootFromParent_Done,
     /* 195145 */   // Label 3893: @195145
     /* 195145 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195201), // Rule ID 9845 //
     /* 195150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 195158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195172 */     // MIs[0] pattern
     /* 195172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195180 */     // MIs[0] imm4
     /* 195180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195188 */     // (intrinsic_wo_chain:{ *:[i64] } 1921:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 195191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195195 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195197 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195199 */     GIR_RootConstrainSelectedInstOperands,
     /* 195200 */     // GIR_Coverage, 9845,
     /* 195200 */     GIR_EraseRootFromParent_Done,
     /* 195201 */   // Label 3894: @195201
     /* 195201 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195257), // Rule ID 9848 //
     /* 195206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 195214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195228 */     // MIs[0] pattern
     /* 195228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195236 */     // MIs[0] imm4
     /* 195236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195244 */     // (intrinsic_wo_chain:{ *:[i32] } 1925:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 195247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195251 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195253 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195255 */     GIR_RootConstrainSelectedInstOperands,
     /* 195256 */     // GIR_Coverage, 9848,
     /* 195256 */     GIR_EraseRootFromParent_Done,
     /* 195257 */   // Label 3895: @195257
     /* 195257 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195313), // Rule ID 9851 //
     /* 195262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 195270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195284 */     // MIs[0] pattern
     /* 195284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195292 */     // MIs[0] imm4
     /* 195292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195300 */     // (intrinsic_wo_chain:{ *:[i32] } 1911:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 195303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195307 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195309 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195311 */     GIR_RootConstrainSelectedInstOperands,
     /* 195312 */     // GIR_Coverage, 9851,
     /* 195312 */     GIR_EraseRootFromParent_Done,
     /* 195313 */   // Label 3896: @195313
     /* 195313 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195369), // Rule ID 9852 //
     /* 195318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 195326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195340 */     // MIs[0] pattern
     /* 195340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195348 */     // MIs[0] imm4
     /* 195348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195356 */     // (intrinsic_wo_chain:{ *:[i64] } 1715:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 195359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195363 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195365 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195367 */     GIR_RootConstrainSelectedInstOperands,
     /* 195368 */     // GIR_Coverage, 9852,
     /* 195368 */     GIR_EraseRootFromParent_Done,
     /* 195369 */   // Label 3897: @195369
     /* 195369 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195425), // Rule ID 9853 //
     /* 195374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 195382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195396 */     // MIs[0] pattern
     /* 195396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195404 */     // MIs[0] imm4
     /* 195404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195412 */     // (intrinsic_wo_chain:{ *:[i64] } 1926:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 195415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195419 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195421 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195423 */     GIR_RootConstrainSelectedInstOperands,
     /* 195424 */     // GIR_Coverage, 9853,
     /* 195424 */     GIR_EraseRootFromParent_Done,
     /* 195425 */   // Label 3898: @195425
     /* 195425 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195481), // Rule ID 9854 //
     /* 195430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 195438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195452 */     // MIs[0] pattern
     /* 195452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195460 */     // MIs[0] imm4
     /* 195460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195468 */     // (intrinsic_wo_chain:{ *:[i64] } 1681:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 195471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195475 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195477 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195479 */     GIR_RootConstrainSelectedInstOperands,
     /* 195480 */     // GIR_Coverage, 9854,
     /* 195480 */     GIR_EraseRootFromParent_Done,
     /* 195481 */   // Label 3899: @195481
     /* 195481 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195537), // Rule ID 9855 //
     /* 195486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 195494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195508 */     // MIs[0] pattern
     /* 195508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195516 */     // MIs[0] imm4
     /* 195516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195524 */     // (intrinsic_wo_chain:{ *:[i64] } 1912:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 195527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195531 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195533 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195535 */     GIR_RootConstrainSelectedInstOperands,
     /* 195536 */     // GIR_Coverage, 9855,
     /* 195536 */     GIR_EraseRootFromParent_Done,
     /* 195537 */   // Label 3900: @195537
     /* 195537 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195593), // Rule ID 9856 //
     /* 195542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 195550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195564 */     // MIs[0] pattern
     /* 195564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195572 */     // MIs[0] imm4
     /* 195572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 195583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195587 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195589 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195591 */     GIR_RootConstrainSelectedInstOperands,
     /* 195592 */     // GIR_Coverage, 9856,
     /* 195592 */     GIR_EraseRootFromParent_Done,
     /* 195593 */   // Label 3901: @195593
     /* 195593 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195649), // Rule ID 9857 //
     /* 195598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 195606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195620 */     // MIs[0] pattern
     /* 195620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195628 */     // MIs[0] imm4
     /* 195628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 195639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195643 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195645 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195647 */     GIR_RootConstrainSelectedInstOperands,
     /* 195648 */     // GIR_Coverage, 9857,
     /* 195648 */     GIR_EraseRootFromParent_Done,
     /* 195649 */   // Label 3902: @195649
     /* 195649 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195705), // Rule ID 9858 //
     /* 195654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 195662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195676 */     // MIs[0] pattern
     /* 195676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195684 */     // MIs[0] imm4
     /* 195684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 195695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195699 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195701 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195703 */     GIR_RootConstrainSelectedInstOperands,
     /* 195704 */     // GIR_Coverage, 9858,
     /* 195704 */     GIR_EraseRootFromParent_Done,
     /* 195705 */   // Label 3903: @195705
     /* 195705 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(195761), // Rule ID 9859 //
     /* 195710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 195718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195732 */     // MIs[0] pattern
     /* 195732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195740 */     // MIs[0] imm4
     /* 195740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 195751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195755 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195757 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195759 */     GIR_RootConstrainSelectedInstOperands,
     /* 195760 */     // GIR_Coverage, 9859,
     /* 195760 */     GIR_EraseRootFromParent_Done,
     /* 195761 */   // Label 3904: @195761
     /* 195761 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(195817), // Rule ID 9860 //
     /* 195766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 195774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195788 */     // MIs[0] pattern
     /* 195788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195796 */     // MIs[0] imm4
     /* 195796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 195807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195811 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195813 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195815 */     GIR_RootConstrainSelectedInstOperands,
     /* 195816 */     // GIR_Coverage, 9860,
     /* 195816 */     GIR_EraseRootFromParent_Done,
     /* 195817 */   // Label 3905: @195817
     /* 195817 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(195873), // Rule ID 9861 //
     /* 195822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 195830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195844 */     // MIs[0] pattern
     /* 195844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195852 */     // MIs[0] imm4
     /* 195852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 195863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195867 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195869 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195871 */     GIR_RootConstrainSelectedInstOperands,
     /* 195872 */     // GIR_Coverage, 9861,
     /* 195872 */     GIR_EraseRootFromParent_Done,
     /* 195873 */   // Label 3906: @195873
     /* 195873 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(195929), // Rule ID 9862 //
     /* 195878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 195886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195900 */     // MIs[0] pattern
     /* 195900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195908 */     // MIs[0] imm4
     /* 195908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 195919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195923 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195925 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195927 */     GIR_RootConstrainSelectedInstOperands,
     /* 195928 */     // GIR_Coverage, 9862,
     /* 195928 */     GIR_EraseRootFromParent_Done,
     /* 195929 */   // Label 3907: @195929
     /* 195929 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(195985), // Rule ID 9863 //
     /* 195934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 195942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195956 */     // MIs[0] pattern
     /* 195956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195964 */     // MIs[0] imm4
     /* 195964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 195975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195979 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195981 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195983 */     GIR_RootConstrainSelectedInstOperands,
     /* 195984 */     // GIR_Coverage, 9863,
     /* 195984 */     GIR_EraseRootFromParent_Done,
     /* 195985 */   // Label 3908: @195985
     /* 195985 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196041), // Rule ID 9864 //
     /* 195990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 195998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196012 */     // MIs[0] pattern
     /* 196012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196020 */     // MIs[0] imm4
     /* 196020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 196031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196035 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196037 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196039 */     GIR_RootConstrainSelectedInstOperands,
     /* 196040 */     // GIR_Coverage, 9864,
     /* 196040 */     GIR_EraseRootFromParent_Done,
     /* 196041 */   // Label 3909: @196041
     /* 196041 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196097), // Rule ID 9865 //
     /* 196046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 196054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196068 */     // MIs[0] pattern
     /* 196068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196076 */     // MIs[0] imm4
     /* 196076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1679:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 196087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196091 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196093 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196095 */     GIR_RootConstrainSelectedInstOperands,
     /* 196096 */     // GIR_Coverage, 9865,
     /* 196096 */     GIR_EraseRootFromParent_Done,
     /* 196097 */   // Label 3910: @196097
     /* 196097 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196153), // Rule ID 9866 //
     /* 196102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 196110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196124 */     // MIs[0] pattern
     /* 196124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196132 */     // MIs[0] imm4
     /* 196132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 196143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196147 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196149 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196151 */     GIR_RootConstrainSelectedInstOperands,
     /* 196152 */     // GIR_Coverage, 9866,
     /* 196152 */     GIR_EraseRootFromParent_Done,
     /* 196153 */   // Label 3911: @196153
     /* 196153 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196243), // Rule ID 47 //
     /* 196158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 196166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196223 */     // MIs[2] Operand 1
     /* 196223 */     // No operand predicates
     /* 196223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196225 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 196228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196241 */     GIR_RootConstrainSelectedInstOperands,
     /* 196242 */     // GIR_Coverage, 47,
     /* 196242 */     GIR_EraseRootFromParent_Done,
     /* 196243 */   // Label 3912: @196243
     /* 196243 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196333), // Rule ID 48 //
     /* 196248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 196256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196309 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196313 */     // MIs[2] Operand 1
     /* 196313 */     // No operand predicates
     /* 196313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196315 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 196318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196331 */     GIR_RootConstrainSelectedInstOperands,
     /* 196332 */     // GIR_Coverage, 48,
     /* 196332 */     GIR_EraseRootFromParent_Done,
     /* 196333 */   // Label 3913: @196333
     /* 196333 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196423), // Rule ID 49 //
     /* 196338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 196346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196399 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196403 */     // MIs[2] Operand 1
     /* 196403 */     // No operand predicates
     /* 196403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196405 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 196408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196421 */     GIR_RootConstrainSelectedInstOperands,
     /* 196422 */     // GIR_Coverage, 49,
     /* 196422 */     GIR_EraseRootFromParent_Done,
     /* 196423 */   // Label 3914: @196423
     /* 196423 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196513), // Rule ID 50 //
     /* 196428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 196436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196489 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196493 */     // MIs[2] Operand 1
     /* 196493 */     // No operand predicates
     /* 196493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196495 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 196498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196511 */     GIR_RootConstrainSelectedInstOperands,
     /* 196512 */     // GIR_Coverage, 50,
     /* 196512 */     GIR_EraseRootFromParent_Done,
     /* 196513 */   // Label 3915: @196513
     /* 196513 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196603), // Rule ID 51 //
     /* 196518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 196526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196583 */     // MIs[2] Operand 1
     /* 196583 */     // No operand predicates
     /* 196583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196585 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 196588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196601 */     GIR_RootConstrainSelectedInstOperands,
     /* 196602 */     // GIR_Coverage, 51,
     /* 196602 */     GIR_EraseRootFromParent_Done,
     /* 196603 */   // Label 3916: @196603
     /* 196603 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196693), // Rule ID 52 //
     /* 196608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 196616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196669 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196673 */     // MIs[2] Operand 1
     /* 196673 */     // No operand predicates
     /* 196673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196675 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 196678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196691 */     GIR_RootConstrainSelectedInstOperands,
     /* 196692 */     // GIR_Coverage, 52,
     /* 196692 */     GIR_EraseRootFromParent_Done,
     /* 196693 */   // Label 3917: @196693
     /* 196693 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196783), // Rule ID 53 //
     /* 196698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 196706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196763 */     // MIs[2] Operand 1
     /* 196763 */     // No operand predicates
     /* 196763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196765 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 196768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196781 */     GIR_RootConstrainSelectedInstOperands,
     /* 196782 */     // GIR_Coverage, 53,
     /* 196782 */     GIR_EraseRootFromParent_Done,
     /* 196783 */   // Label 3918: @196783
     /* 196783 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196873), // Rule ID 54 //
     /* 196788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 196796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196853 */     // MIs[2] Operand 1
     /* 196853 */     // No operand predicates
     /* 196853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196855 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 196858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196871 */     GIR_RootConstrainSelectedInstOperands,
     /* 196872 */     // GIR_Coverage, 54,
     /* 196872 */     GIR_EraseRootFromParent_Done,
     /* 196873 */   // Label 3919: @196873
     /* 196873 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196963), // Rule ID 2063 //
     /* 196878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 196881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 196886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196939 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196943 */     // MIs[2] Operand 1
     /* 196943 */     // No operand predicates
     /* 196943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196945 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 196948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196961 */     GIR_RootConstrainSelectedInstOperands,
     /* 196962 */     // GIR_Coverage, 2063,
     /* 196962 */     GIR_EraseRootFromParent_Done,
     /* 196963 */   // Label 3920: @196963
     /* 196963 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(197053), // Rule ID 2064 //
     /* 196968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 196971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 196976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197029 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197033 */     // MIs[2] Operand 1
     /* 197033 */     // No operand predicates
     /* 197033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197035 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 197038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197051 */     GIR_RootConstrainSelectedInstOperands,
     /* 197052 */     // GIR_Coverage, 2064,
     /* 197052 */     GIR_EraseRootFromParent_Done,
     /* 197053 */   // Label 3921: @197053
     /* 197053 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197143), // Rule ID 2070 //
     /* 197058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197123 */     // MIs[2] Operand 1
     /* 197123 */     // No operand predicates
     /* 197123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197125 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 197128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197141 */     GIR_RootConstrainSelectedInstOperands,
     /* 197142 */     // GIR_Coverage, 2070,
     /* 197142 */     GIR_EraseRootFromParent_Done,
     /* 197143 */   // Label 3922: @197143
     /* 197143 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197233), // Rule ID 2071 //
     /* 197148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197213 */     // MIs[2] Operand 1
     /* 197213 */     // No operand predicates
     /* 197213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197215 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 197218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197231 */     GIR_RootConstrainSelectedInstOperands,
     /* 197232 */     // GIR_Coverage, 2071,
     /* 197232 */     GIR_EraseRootFromParent_Done,
     /* 197233 */   // Label 3923: @197233
     /* 197233 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197323), // Rule ID 2066 //
     /* 197238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197299 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197303 */     // MIs[2] Operand 1
     /* 197303 */     // No operand predicates
     /* 197303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197305 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 197308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197321 */     GIR_RootConstrainSelectedInstOperands,
     /* 197322 */     // GIR_Coverage, 2066,
     /* 197322 */     GIR_EraseRootFromParent_Done,
     /* 197323 */   // Label 3924: @197323
     /* 197323 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(197413), // Rule ID 2067 //
     /* 197328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 197348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197393 */     // MIs[2] Operand 1
     /* 197393 */     // No operand predicates
     /* 197393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197395 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 197398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197411 */     GIR_RootConstrainSelectedInstOperands,
     /* 197412 */     // GIR_Coverage, 2067,
     /* 197412 */     GIR_EraseRootFromParent_Done,
     /* 197413 */   // Label 3925: @197413
     /* 197413 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(197503), // Rule ID 2073 //
     /* 197418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197479 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197483 */     // MIs[2] Operand 1
     /* 197483 */     // No operand predicates
     /* 197483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197485 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 197488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197501 */     GIR_RootConstrainSelectedInstOperands,
     /* 197502 */     // GIR_Coverage, 2073,
     /* 197502 */     GIR_EraseRootFromParent_Done,
     /* 197503 */   // Label 3926: @197503
     /* 197503 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(197593), // Rule ID 2074 //
     /* 197508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 197528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197569 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197573 */     // MIs[2] Operand 1
     /* 197573 */     // No operand predicates
     /* 197573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197575 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 197578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197591 */     GIR_RootConstrainSelectedInstOperands,
     /* 197592 */     // GIR_Coverage, 2074,
     /* 197592 */     GIR_EraseRootFromParent_Done,
     /* 197593 */   // Label 3927: @197593
     /* 197593 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(197683), // Rule ID 2068 //
     /* 197598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 197618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 197638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197663 */     // MIs[2] Operand 1
     /* 197663 */     // No operand predicates
     /* 197663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197665 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 197668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197681 */     GIR_RootConstrainSelectedInstOperands,
     /* 197682 */     // GIR_Coverage, 2068,
     /* 197682 */     GIR_EraseRootFromParent_Done,
     /* 197683 */   // Label 3928: @197683
     /* 197683 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(197773), // Rule ID 2075 //
     /* 197688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 197708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 197728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197753 */     // MIs[2] Operand 1
     /* 197753 */     // No operand predicates
     /* 197753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197755 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 197758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197771 */     GIR_RootConstrainSelectedInstOperands,
     /* 197772 */     // GIR_Coverage, 2075,
     /* 197772 */     GIR_EraseRootFromParent_Done,
     /* 197773 */   // Label 3929: @197773
     /* 197773 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197850), // Rule ID 2767 //
     /* 197778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 197786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 197798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 197806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 197818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 197822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 197830 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 197834 */     // MIs[2] Operand 1
     /* 197834 */     // No operand predicates
     /* 197834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197836 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 197836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 197839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 197843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 197845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197848 */     GIR_RootConstrainSelectedInstOperands,
     /* 197849 */     // GIR_Coverage, 2767,
     /* 197849 */     GIR_EraseRootFromParent_Done,
     /* 197850 */   // Label 3930: @197850
     /* 197850 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197927), // Rule ID 2768 //
     /* 197855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 197863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 197875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 197883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 197895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 197899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 197907 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 197911 */     // MIs[2] Operand 1
     /* 197911 */     // No operand predicates
     /* 197911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197913 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 197913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 197916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 197920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 197922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197925 */     GIR_RootConstrainSelectedInstOperands,
     /* 197926 */     // GIR_Coverage, 2768,
     /* 197926 */     GIR_EraseRootFromParent_Done,
     /* 197927 */   // Label 3931: @197927
     /* 197927 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(198004), // Rule ID 2769 //
     /* 197932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 197940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 197952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 197960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 197972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 197976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 197984 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 197988 */     // MIs[2] Operand 1
     /* 197988 */     // No operand predicates
     /* 197988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197990 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 197990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 197993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 197997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 197999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198002 */     GIR_RootConstrainSelectedInstOperands,
     /* 198003 */     // GIR_Coverage, 2769,
     /* 198003 */     GIR_EraseRootFromParent_Done,
     /* 198004 */   // Label 3932: @198004
     /* 198004 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(198081), // Rule ID 2770 //
     /* 198009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198061 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198065 */     // MIs[2] Operand 1
     /* 198065 */     // No operand predicates
     /* 198065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198067 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 198070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198079 */     GIR_RootConstrainSelectedInstOperands,
     /* 198080 */     // GIR_Coverage, 2770,
     /* 198080 */     GIR_EraseRootFromParent_Done,
     /* 198081 */   // Label 3933: @198081
     /* 198081 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(198158), // Rule ID 2771 //
     /* 198086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198138 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198142 */     // MIs[2] Operand 1
     /* 198142 */     // No operand predicates
     /* 198142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198144 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 198144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 198147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198156 */     GIR_RootConstrainSelectedInstOperands,
     /* 198157 */     // GIR_Coverage, 2771,
     /* 198157 */     GIR_EraseRootFromParent_Done,
     /* 198158 */   // Label 3934: @198158
     /* 198158 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(198235), // Rule ID 2772 //
     /* 198163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198215 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198219 */     // MIs[2] Operand 1
     /* 198219 */     // No operand predicates
     /* 198219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198221 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 198221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 198224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198233 */     GIR_RootConstrainSelectedInstOperands,
     /* 198234 */     // GIR_Coverage, 2772,
     /* 198234 */     GIR_EraseRootFromParent_Done,
     /* 198235 */   // Label 3935: @198235
     /* 198235 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(198312), // Rule ID 7709 //
     /* 198240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198292 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198296 */     // MIs[2] Operand 1
     /* 198296 */     // No operand predicates
     /* 198296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198298 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 198298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 198301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198310 */     GIR_RootConstrainSelectedInstOperands,
     /* 198311 */     // GIR_Coverage, 7709,
     /* 198311 */     GIR_EraseRootFromParent_Done,
     /* 198312 */   // Label 3936: @198312
     /* 198312 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(198389), // Rule ID 7710 //
     /* 198317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198369 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198373 */     // MIs[2] Operand 1
     /* 198373 */     // No operand predicates
     /* 198373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198375 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 198375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 198378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198387 */     GIR_RootConstrainSelectedInstOperands,
     /* 198388 */     // GIR_Coverage, 7710,
     /* 198388 */     GIR_EraseRootFromParent_Done,
     /* 198389 */   // Label 3937: @198389
     /* 198389 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(198466), // Rule ID 7711 //
     /* 198394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198446 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198450 */     // MIs[2] Operand 1
     /* 198450 */     // No operand predicates
     /* 198450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 198455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198464 */     GIR_RootConstrainSelectedInstOperands,
     /* 198465 */     // GIR_Coverage, 7711,
     /* 198465 */     GIR_EraseRootFromParent_Done,
     /* 198466 */   // Label 3938: @198466
     /* 198466 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(198543), // Rule ID 7712 //
     /* 198471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198523 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198527 */     // MIs[2] Operand 1
     /* 198527 */     // No operand predicates
     /* 198527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 198532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198541 */     GIR_RootConstrainSelectedInstOperands,
     /* 198542 */     // GIR_Coverage, 7712,
     /* 198542 */     GIR_EraseRootFromParent_Done,
     /* 198543 */   // Label 3939: @198543
     /* 198543 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(198620), // Rule ID 7713 //
     /* 198548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198600 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198604 */     // MIs[2] Operand 1
     /* 198604 */     // No operand predicates
     /* 198604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198606 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 198606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 198609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198618 */     GIR_RootConstrainSelectedInstOperands,
     /* 198619 */     // GIR_Coverage, 7713,
     /* 198619 */     GIR_EraseRootFromParent_Done,
     /* 198620 */   // Label 3940: @198620
     /* 198620 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(198697), // Rule ID 7714 //
     /* 198625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198677 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198681 */     // MIs[2] Operand 1
     /* 198681 */     // No operand predicates
     /* 198681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198683 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 198683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 198686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198695 */     GIR_RootConstrainSelectedInstOperands,
     /* 198696 */     // GIR_Coverage, 7714,
     /* 198696 */     GIR_EraseRootFromParent_Done,
     /* 198697 */   // Label 3941: @198697
     /* 198697 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198774), // Rule ID 7715 //
     /* 198702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198754 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198758 */     // MIs[2] Operand 1
     /* 198758 */     // No operand predicates
     /* 198758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198760 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 198760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 198763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198772 */     GIR_RootConstrainSelectedInstOperands,
     /* 198773 */     // GIR_Coverage, 7715,
     /* 198773 */     GIR_EraseRootFromParent_Done,
     /* 198774 */   // Label 3942: @198774
     /* 198774 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198851), // Rule ID 7716 //
     /* 198779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198831 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 198835 */     // MIs[2] Operand 1
     /* 198835 */     // No operand predicates
     /* 198835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198837 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 198837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 198840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198849 */     GIR_RootConstrainSelectedInstOperands,
     /* 198850 */     // GIR_Coverage, 7716,
     /* 198850 */     GIR_EraseRootFromParent_Done,
     /* 198851 */   // Label 3943: @198851
     /* 198851 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(198928), // Rule ID 7717 //
     /* 198856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198908 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198912 */     // MIs[2] Operand 1
     /* 198912 */     // No operand predicates
     /* 198912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198914 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 198917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198926 */     GIR_RootConstrainSelectedInstOperands,
     /* 198927 */     // GIR_Coverage, 7717,
     /* 198927 */     GIR_EraseRootFromParent_Done,
     /* 198928 */   // Label 3944: @198928
     /* 198928 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(199005), // Rule ID 7718 //
     /* 198933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198985 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 198989 */     // MIs[2] Operand 1
     /* 198989 */     // No operand predicates
     /* 198989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 198994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199003 */     GIR_RootConstrainSelectedInstOperands,
     /* 199004 */     // GIR_Coverage, 7718,
     /* 199004 */     GIR_EraseRootFromParent_Done,
     /* 199005 */   // Label 3945: @199005
     /* 199005 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(199082), // Rule ID 7719 //
     /* 199010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199062 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199066 */     // MIs[2] Operand 1
     /* 199066 */     // No operand predicates
     /* 199066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199068 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 199071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199080 */     GIR_RootConstrainSelectedInstOperands,
     /* 199081 */     // GIR_Coverage, 7719,
     /* 199081 */     GIR_EraseRootFromParent_Done,
     /* 199082 */   // Label 3946: @199082
     /* 199082 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(199159), // Rule ID 7720 //
     /* 199087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199139 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 199143 */     // MIs[2] Operand 1
     /* 199143 */     // No operand predicates
     /* 199143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199145 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 199145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 199148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199157 */     GIR_RootConstrainSelectedInstOperands,
     /* 199158 */     // GIR_Coverage, 7720,
     /* 199158 */     GIR_EraseRootFromParent_Done,
     /* 199159 */   // Label 3947: @199159
     /* 199159 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(199236), // Rule ID 7721 //
     /* 199164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199216 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199220 */     // MIs[2] Operand 1
     /* 199220 */     // No operand predicates
     /* 199220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199222 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 199222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 199225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199234 */     GIR_RootConstrainSelectedInstOperands,
     /* 199235 */     // GIR_Coverage, 7721,
     /* 199235 */     GIR_EraseRootFromParent_Done,
     /* 199236 */   // Label 3948: @199236
     /* 199236 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(199313), // Rule ID 7722 //
     /* 199241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199293 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199297 */     // MIs[2] Operand 1
     /* 199297 */     // No operand predicates
     /* 199297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199299 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 199299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 199302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199311 */     GIR_RootConstrainSelectedInstOperands,
     /* 199312 */     // GIR_Coverage, 7722,
     /* 199312 */     GIR_EraseRootFromParent_Done,
     /* 199313 */   // Label 3949: @199313
     /* 199313 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(199390), // Rule ID 7723 //
     /* 199318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199370 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199374 */     // MIs[2] Operand 1
     /* 199374 */     // No operand predicates
     /* 199374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 199376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 199379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199388 */     GIR_RootConstrainSelectedInstOperands,
     /* 199389 */     // GIR_Coverage, 7723,
     /* 199389 */     GIR_EraseRootFromParent_Done,
     /* 199390 */   // Label 3950: @199390
     /* 199390 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(199467), // Rule ID 7724 //
     /* 199395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199447 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199451 */     // MIs[2] Operand 1
     /* 199451 */     // No operand predicates
     /* 199451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199453 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 199456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199465 */     GIR_RootConstrainSelectedInstOperands,
     /* 199466 */     // GIR_Coverage, 7724,
     /* 199466 */     GIR_EraseRootFromParent_Done,
     /* 199467 */   // Label 3951: @199467
     /* 199467 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(199544), // Rule ID 7725 //
     /* 199472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199524 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199528 */     // MIs[2] Operand 1
     /* 199528 */     // No operand predicates
     /* 199528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199530 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 199533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199542 */     GIR_RootConstrainSelectedInstOperands,
     /* 199543 */     // GIR_Coverage, 7725,
     /* 199543 */     GIR_EraseRootFromParent_Done,
     /* 199544 */   // Label 3952: @199544
     /* 199544 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(199621), // Rule ID 7726 //
     /* 199549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199601 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199605 */     // MIs[2] Operand 1
     /* 199605 */     // No operand predicates
     /* 199605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199607 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 199607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 199610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199619 */     GIR_RootConstrainSelectedInstOperands,
     /* 199620 */     // GIR_Coverage, 7726,
     /* 199620 */     GIR_EraseRootFromParent_Done,
     /* 199621 */   // Label 3953: @199621
     /* 199621 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199698), // Rule ID 7727 //
     /* 199626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199678 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 199682 */     // MIs[2] Operand 1
     /* 199682 */     // No operand predicates
     /* 199682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199684 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 199684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 199687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199696 */     GIR_RootConstrainSelectedInstOperands,
     /* 199697 */     // GIR_Coverage, 7727,
     /* 199697 */     GIR_EraseRootFromParent_Done,
     /* 199698 */   // Label 3954: @199698
     /* 199698 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199775), // Rule ID 7728 //
     /* 199703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199755 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199759 */     // MIs[2] Operand 1
     /* 199759 */     // No operand predicates
     /* 199759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199761 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 199761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 199764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199773 */     GIR_RootConstrainSelectedInstOperands,
     /* 199774 */     // GIR_Coverage, 7728,
     /* 199774 */     GIR_EraseRootFromParent_Done,
     /* 199775 */   // Label 3955: @199775
     /* 199775 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199852), // Rule ID 7729 //
     /* 199780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199832 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 199836 */     // MIs[2] Operand 1
     /* 199836 */     // No operand predicates
     /* 199836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199838 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 199838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 199841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199850 */     GIR_RootConstrainSelectedInstOperands,
     /* 199851 */     // GIR_Coverage, 7729,
     /* 199851 */     GIR_EraseRootFromParent_Done,
     /* 199852 */   // Label 3956: @199852
     /* 199852 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199929), // Rule ID 7730 //
     /* 199857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199909 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199913 */     // MIs[2] Operand 1
     /* 199913 */     // No operand predicates
     /* 199913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199915 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 199918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199927 */     GIR_RootConstrainSelectedInstOperands,
     /* 199928 */     // GIR_Coverage, 7730,
     /* 199928 */     GIR_EraseRootFromParent_Done,
     /* 199929 */   // Label 3957: @199929
     /* 199929 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(200006), // Rule ID 7731 //
     /* 199934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199986 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 199990 */     // MIs[2] Operand 1
     /* 199990 */     // No operand predicates
     /* 199990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199992 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 199995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200004 */     GIR_RootConstrainSelectedInstOperands,
     /* 200005 */     // GIR_Coverage, 7731,
     /* 200005 */     GIR_EraseRootFromParent_Done,
     /* 200006 */   // Label 3958: @200006
     /* 200006 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(200083), // Rule ID 7732 //
     /* 200011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200063 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200067 */     // MIs[2] Operand 1
     /* 200067 */     // No operand predicates
     /* 200067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200069 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 200072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200081 */     GIR_RootConstrainSelectedInstOperands,
     /* 200082 */     // GIR_Coverage, 7732,
     /* 200082 */     GIR_EraseRootFromParent_Done,
     /* 200083 */   // Label 3959: @200083
     /* 200083 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(200160), // Rule ID 7733 //
     /* 200088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200140 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200144 */     // MIs[2] Operand 1
     /* 200144 */     // No operand predicates
     /* 200144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200146 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 200149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200158 */     GIR_RootConstrainSelectedInstOperands,
     /* 200159 */     // GIR_Coverage, 7733,
     /* 200159 */     GIR_EraseRootFromParent_Done,
     /* 200160 */   // Label 3960: @200160
     /* 200160 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(200237), // Rule ID 7734 //
     /* 200165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200217 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200221 */     // MIs[2] Operand 1
     /* 200221 */     // No operand predicates
     /* 200221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200223 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 200226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200235 */     GIR_RootConstrainSelectedInstOperands,
     /* 200236 */     // GIR_Coverage, 7734,
     /* 200236 */     GIR_EraseRootFromParent_Done,
     /* 200237 */   // Label 3961: @200237
     /* 200237 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(200314), // Rule ID 7735 //
     /* 200242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200294 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200298 */     // MIs[2] Operand 1
     /* 200298 */     // No operand predicates
     /* 200298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200300 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 200303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200312 */     GIR_RootConstrainSelectedInstOperands,
     /* 200313 */     // GIR_Coverage, 7735,
     /* 200313 */     GIR_EraseRootFromParent_Done,
     /* 200314 */   // Label 3962: @200314
     /* 200314 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(200391), // Rule ID 7736 //
     /* 200319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200371 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200375 */     // MIs[2] Operand 1
     /* 200375 */     // No operand predicates
     /* 200375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200377 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 200380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200389 */     GIR_RootConstrainSelectedInstOperands,
     /* 200390 */     // GIR_Coverage, 7736,
     /* 200390 */     GIR_EraseRootFromParent_Done,
     /* 200391 */   // Label 3963: @200391
     /* 200391 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(200468), // Rule ID 7737 //
     /* 200396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200448 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200452 */     // MIs[2] Operand 1
     /* 200452 */     // No operand predicates
     /* 200452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200454 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 200457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200466 */     GIR_RootConstrainSelectedInstOperands,
     /* 200467 */     // GIR_Coverage, 7737,
     /* 200467 */     GIR_EraseRootFromParent_Done,
     /* 200468 */   // Label 3964: @200468
     /* 200468 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(200545), // Rule ID 7738 //
     /* 200473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200525 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200529 */     // MIs[2] Operand 1
     /* 200529 */     // No operand predicates
     /* 200529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200531 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 200534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200543 */     GIR_RootConstrainSelectedInstOperands,
     /* 200544 */     // GIR_Coverage, 7738,
     /* 200544 */     GIR_EraseRootFromParent_Done,
     /* 200545 */   // Label 3965: @200545
     /* 200545 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(200622), // Rule ID 7739 //
     /* 200550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200602 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200606 */     // MIs[2] Operand 1
     /* 200606 */     // No operand predicates
     /* 200606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200608 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 200611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200620 */     GIR_RootConstrainSelectedInstOperands,
     /* 200621 */     // GIR_Coverage, 7739,
     /* 200621 */     GIR_EraseRootFromParent_Done,
     /* 200622 */   // Label 3966: @200622
     /* 200622 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(200699), // Rule ID 7740 //
     /* 200627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200679 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200683 */     // MIs[2] Operand 1
     /* 200683 */     // No operand predicates
     /* 200683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200685 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 200688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200697 */     GIR_RootConstrainSelectedInstOperands,
     /* 200698 */     // GIR_Coverage, 7740,
     /* 200698 */     GIR_EraseRootFromParent_Done,
     /* 200699 */   // Label 3967: @200699
     /* 200699 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(200776), // Rule ID 7741 //
     /* 200704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200756 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200760 */     // MIs[2] Operand 1
     /* 200760 */     // No operand predicates
     /* 200760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200762 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 200765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200774 */     GIR_RootConstrainSelectedInstOperands,
     /* 200775 */     // GIR_Coverage, 7741,
     /* 200775 */     GIR_EraseRootFromParent_Done,
     /* 200776 */   // Label 3968: @200776
     /* 200776 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(200853), // Rule ID 7742 //
     /* 200781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200833 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200837 */     // MIs[2] Operand 1
     /* 200837 */     // No operand predicates
     /* 200837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200839 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 200842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200851 */     GIR_RootConstrainSelectedInstOperands,
     /* 200852 */     // GIR_Coverage, 7742,
     /* 200852 */     GIR_EraseRootFromParent_Done,
     /* 200853 */   // Label 3969: @200853
     /* 200853 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(200930), // Rule ID 7743 //
     /* 200858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200910 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200914 */     // MIs[2] Operand 1
     /* 200914 */     // No operand predicates
     /* 200914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 200919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200928 */     GIR_RootConstrainSelectedInstOperands,
     /* 200929 */     // GIR_Coverage, 7743,
     /* 200929 */     GIR_EraseRootFromParent_Done,
     /* 200930 */   // Label 3970: @200930
     /* 200930 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(201007), // Rule ID 7744 //
     /* 200935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200987 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200991 */     // MIs[2] Operand 1
     /* 200991 */     // No operand predicates
     /* 200991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200993 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 200996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201005 */     GIR_RootConstrainSelectedInstOperands,
     /* 201006 */     // GIR_Coverage, 7744,
     /* 201006 */     GIR_EraseRootFromParent_Done,
     /* 201007 */   // Label 3971: @201007
     /* 201007 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(201084), // Rule ID 7745 //
     /* 201012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201064 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201068 */     // MIs[2] Operand 1
     /* 201068 */     // No operand predicates
     /* 201068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201070 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 201070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 201073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201082 */     GIR_RootConstrainSelectedInstOperands,
     /* 201083 */     // GIR_Coverage, 7745,
     /* 201083 */     GIR_EraseRootFromParent_Done,
     /* 201084 */   // Label 3972: @201084
     /* 201084 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(201161), // Rule ID 7746 //
     /* 201089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201141 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201145 */     // MIs[2] Operand 1
     /* 201145 */     // No operand predicates
     /* 201145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201147 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 201147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 201150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201159 */     GIR_RootConstrainSelectedInstOperands,
     /* 201160 */     // GIR_Coverage, 7746,
     /* 201160 */     GIR_EraseRootFromParent_Done,
     /* 201161 */   // Label 3973: @201161
     /* 201161 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(201238), // Rule ID 7747 //
     /* 201166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201218 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201222 */     // MIs[2] Operand 1
     /* 201222 */     // No operand predicates
     /* 201222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 201227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201236 */     GIR_RootConstrainSelectedInstOperands,
     /* 201237 */     // GIR_Coverage, 7747,
     /* 201237 */     GIR_EraseRootFromParent_Done,
     /* 201238 */   // Label 3974: @201238
     /* 201238 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(201315), // Rule ID 7748 //
     /* 201243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201295 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201299 */     // MIs[2] Operand 1
     /* 201299 */     // No operand predicates
     /* 201299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201301 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 201301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 201304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201313 */     GIR_RootConstrainSelectedInstOperands,
     /* 201314 */     // GIR_Coverage, 7748,
     /* 201314 */     GIR_EraseRootFromParent_Done,
     /* 201315 */   // Label 3975: @201315
     /* 201315 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(201392), // Rule ID 7749 //
     /* 201320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201372 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201376 */     // MIs[2] Operand 1
     /* 201376 */     // No operand predicates
     /* 201376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201378 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 201378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 201381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201390 */     GIR_RootConstrainSelectedInstOperands,
     /* 201391 */     // GIR_Coverage, 7749,
     /* 201391 */     GIR_EraseRootFromParent_Done,
     /* 201392 */   // Label 3976: @201392
     /* 201392 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(201469), // Rule ID 7750 //
     /* 201397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201449 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201453 */     // MIs[2] Operand 1
     /* 201453 */     // No operand predicates
     /* 201453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201455 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 201458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201467 */     GIR_RootConstrainSelectedInstOperands,
     /* 201468 */     // GIR_Coverage, 7750,
     /* 201468 */     GIR_EraseRootFromParent_Done,
     /* 201469 */   // Label 3977: @201469
     /* 201469 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(201525), // Rule ID 55 //
     /* 201474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201499 */     // MIs[0] Operand 3
     /* 201499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 201510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201514 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 201517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201523 */     GIR_RootConstrainSelectedInstOperands,
     /* 201524 */     // GIR_Coverage, 55,
     /* 201524 */     GIR_EraseRootFromParent_Done,
     /* 201525 */   // Label 3978: @201525
     /* 201525 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(201581), // Rule ID 56 //
     /* 201530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201555 */     // MIs[0] Operand 3
     /* 201555 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 201566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201570 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 201573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201579 */     GIR_RootConstrainSelectedInstOperands,
     /* 201580 */     // GIR_Coverage, 56,
     /* 201580 */     GIR_EraseRootFromParent_Done,
     /* 201581 */   // Label 3979: @201581
     /* 201581 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(201637), // Rule ID 57 //
     /* 201586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201611 */     // MIs[0] Operand 3
     /* 201611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 201622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201626 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 201629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201635 */     GIR_RootConstrainSelectedInstOperands,
     /* 201636 */     // GIR_Coverage, 57,
     /* 201636 */     GIR_EraseRootFromParent_Done,
     /* 201637 */   // Label 3980: @201637
     /* 201637 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(201693), // Rule ID 58 //
     /* 201642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201667 */     // MIs[0] Operand 3
     /* 201667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 201678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201682 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 201685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201691 */     GIR_RootConstrainSelectedInstOperands,
     /* 201692 */     // GIR_Coverage, 58,
     /* 201692 */     GIR_EraseRootFromParent_Done,
     /* 201693 */   // Label 3981: @201693
     /* 201693 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(201748), // Rule ID 2785 //
     /* 201698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 201706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201727 */     // MIs[0] imm
     /* 201727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 201735 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 201735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 201738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 201744 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 201746 */     GIR_RootConstrainSelectedInstOperands,
     /* 201747 */     // GIR_Coverage, 2785,
     /* 201747 */     GIR_EraseRootFromParent_Done,
     /* 201748 */   // Label 3982: @201748
     /* 201748 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(201803), // Rule ID 2786 //
     /* 201753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 201761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201782 */     // MIs[0] imm
     /* 201782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 201790 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 201790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 201793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 201799 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 201801 */     GIR_RootConstrainSelectedInstOperands,
     /* 201802 */     // GIR_Coverage, 2786,
     /* 201802 */     GIR_EraseRootFromParent_Done,
     /* 201803 */   // Label 3983: @201803
     /* 201803 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(201858), // Rule ID 2787 //
     /* 201808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 201816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201837 */     // MIs[0] imm
     /* 201837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 201845 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 201845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 201848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 201854 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 201856 */     GIR_RootConstrainSelectedInstOperands,
     /* 201857 */     // GIR_Coverage, 2787,
     /* 201857 */     GIR_EraseRootFromParent_Done,
     /* 201858 */   // Label 3984: @201858
     /* 201858 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(201913), // Rule ID 3532 //
     /* 201863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 201866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 201871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201892 */     // MIs[0] Idx
     /* 201892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 201900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 201900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 201903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 201907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 201909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 201911 */     GIR_RootConstrainSelectedInstOperands,
     /* 201912 */     // GIR_Coverage, 3532,
     /* 201912 */     GIR_EraseRootFromParent_Done,
     /* 201913 */   // Label 3985: @201913
     /* 201913 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(201968), // Rule ID 3533 //
     /* 201918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 201921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 201926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201947 */     // MIs[0] Idx
     /* 201947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 201955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 201955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 201958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 201962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 201964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 201966 */     GIR_RootConstrainSelectedInstOperands,
     /* 201967 */     // GIR_Coverage, 3533,
     /* 201967 */     GIR_EraseRootFromParent_Done,
     /* 201968 */   // Label 3986: @201968
     /* 201968 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(202023), // Rule ID 3534 //
     /* 201973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 201976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 201981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202002 */     // MIs[0] Idx
     /* 202002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 202010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 202010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 202013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 202017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 202019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 202021 */     GIR_RootConstrainSelectedInstOperands,
     /* 202022 */     // GIR_Coverage, 3534,
     /* 202022 */     GIR_EraseRootFromParent_Done,
     /* 202023 */   // Label 3987: @202023
     /* 202023 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(202078), // Rule ID 3786 //
     /* 202028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 202031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 202036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 202039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 202042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 202045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202057 */     // MIs[0] imm
     /* 202057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 202065 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 202065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 202068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 202072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 202074 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 202076 */     GIR_RootConstrainSelectedInstOperands,
     /* 202077 */     // GIR_Coverage, 3786,
     /* 202077 */     GIR_EraseRootFromParent_Done,
     /* 202078 */   // Label 3988: @202078
     /* 202078 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(202125), // Rule ID 2839 //
     /* 202083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202104 */     // MIs[0] idx
     /* 202104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202112 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 202112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 202115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202121 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202123 */     GIR_RootConstrainSelectedInstOperands,
     /* 202124 */     // GIR_Coverage, 2839,
     /* 202124 */     GIR_EraseRootFromParent_Done,
     /* 202125 */   // Label 3989: @202125
     /* 202125 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(202172), // Rule ID 2840 //
     /* 202130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202151 */     // MIs[0] idx
     /* 202151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 202159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 202162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202168 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202170 */     GIR_RootConstrainSelectedInstOperands,
     /* 202171 */     // GIR_Coverage, 2840,
     /* 202171 */     GIR_EraseRootFromParent_Done,
     /* 202172 */   // Label 3990: @202172
     /* 202172 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(202219), // Rule ID 2841 //
     /* 202177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202198 */     // MIs[0] idx
     /* 202198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 202206 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 202206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 202209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202215 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202217 */     GIR_RootConstrainSelectedInstOperands,
     /* 202218 */     // GIR_Coverage, 2841,
     /* 202218 */     GIR_EraseRootFromParent_Done,
     /* 202219 */   // Label 3991: @202219
     /* 202219 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(202266), // Rule ID 2990 //
     /* 202224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202245 */     // MIs[0] Op3
     /* 202245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1515:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 202253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 202256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202264 */     GIR_RootConstrainSelectedInstOperands,
     /* 202265 */     // GIR_Coverage, 2990,
     /* 202265 */     GIR_EraseRootFromParent_Done,
     /* 202266 */   // Label 3992: @202266
     /* 202266 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(202313), // Rule ID 2991 //
     /* 202271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202292 */     // MIs[0] Op3
     /* 202292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1515:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 202300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 202303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202311 */     GIR_RootConstrainSelectedInstOperands,
     /* 202312 */     // GIR_Coverage, 2991,
     /* 202312 */     GIR_EraseRootFromParent_Done,
     /* 202313 */   // Label 3993: @202313
     /* 202313 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(202360), // Rule ID 2992 //
     /* 202318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202339 */     // MIs[0] Op3
     /* 202339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 202347 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1515:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 202347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 202350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202358 */     GIR_RootConstrainSelectedInstOperands,
     /* 202359 */     // GIR_Coverage, 2992,
     /* 202359 */     GIR_EraseRootFromParent_Done,
     /* 202360 */   // Label 3994: @202360
     /* 202360 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(202407), // Rule ID 2993 //
     /* 202365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 202373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202386 */     // MIs[0] Op3
     /* 202386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1661:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 202394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 202397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202405 */     GIR_RootConstrainSelectedInstOperands,
     /* 202406 */     // GIR_Coverage, 2993,
     /* 202406 */     GIR_EraseRootFromParent_Done,
     /* 202407 */   // Label 3995: @202407
     /* 202407 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(202454), // Rule ID 2994 //
     /* 202412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 202420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202433 */     // MIs[0] Op3
     /* 202433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1661:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 202441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 202444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202452 */     GIR_RootConstrainSelectedInstOperands,
     /* 202453 */     // GIR_Coverage, 2994,
     /* 202453 */     GIR_EraseRootFromParent_Done,
     /* 202454 */   // Label 3996: @202454
     /* 202454 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(202501), // Rule ID 3042 //
     /* 202459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202480 */     // MIs[0] Op3
     /* 202480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1772:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 202491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202499 */     GIR_RootConstrainSelectedInstOperands,
     /* 202500 */     // GIR_Coverage, 3042,
     /* 202500 */     GIR_EraseRootFromParent_Done,
     /* 202501 */   // Label 3997: @202501
     /* 202501 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(202548), // Rule ID 3044 //
     /* 202506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202527 */     // MIs[0] Op3
     /* 202527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202535 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1772:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 202538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202546 */     GIR_RootConstrainSelectedInstOperands,
     /* 202547 */     // GIR_Coverage, 3044,
     /* 202547 */     GIR_EraseRootFromParent_Done,
     /* 202548 */   // Label 3998: @202548
     /* 202548 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(202595), // Rule ID 3046 //
     /* 202553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202574 */     // MIs[0] Op3
     /* 202574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 202582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 202582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 202585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202593 */     GIR_RootConstrainSelectedInstOperands,
     /* 202594 */     // GIR_Coverage, 3046,
     /* 202594 */     GIR_EraseRootFromParent_Done,
     /* 202595 */   // Label 3999: @202595
     /* 202595 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(202642), // Rule ID 3048 //
     /* 202600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202621 */     // MIs[0] Op3
     /* 202621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 202629 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 202629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 202632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202640 */     GIR_RootConstrainSelectedInstOperands,
     /* 202641 */     // GIR_Coverage, 3048,
     /* 202641 */     GIR_EraseRootFromParent_Done,
     /* 202642 */   // Label 4000: @202642
     /* 202642 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(202689), // Rule ID 3070 //
     /* 202647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 202655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202668 */     // MIs[0] Op3
     /* 202668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 202679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202687 */     GIR_RootConstrainSelectedInstOperands,
     /* 202688 */     // GIR_Coverage, 3070,
     /* 202688 */     GIR_EraseRootFromParent_Done,
     /* 202689 */   // Label 4001: @202689
     /* 202689 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(202736), // Rule ID 3071 //
     /* 202694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 202702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202715 */     // MIs[0] Op3
     /* 202715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 202726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202734 */     GIR_RootConstrainSelectedInstOperands,
     /* 202735 */     // GIR_Coverage, 3071,
     /* 202735 */     GIR_EraseRootFromParent_Done,
     /* 202736 */   // Label 4002: @202736
     /* 202736 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(202783), // Rule ID 3072 //
     /* 202741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 202749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202762 */     // MIs[0] Op3
     /* 202762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 202770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 202770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 202773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202781 */     GIR_RootConstrainSelectedInstOperands,
     /* 202782 */     // GIR_Coverage, 3072,
     /* 202782 */     GIR_EraseRootFromParent_Done,
     /* 202783 */   // Label 4003: @202783
     /* 202783 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(202830), // Rule ID 3141 //
     /* 202788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202809 */     // MIs[0] Op3
     /* 202809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202817 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 202820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202828 */     GIR_RootConstrainSelectedInstOperands,
     /* 202829 */     // GIR_Coverage, 3141,
     /* 202829 */     GIR_EraseRootFromParent_Done,
     /* 202830 */   // Label 4004: @202830
     /* 202830 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(202877), // Rule ID 3142 //
     /* 202835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202856 */     // MIs[0] Op3
     /* 202856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 202867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202875 */     GIR_RootConstrainSelectedInstOperands,
     /* 202876 */     // GIR_Coverage, 3142,
     /* 202876 */     GIR_EraseRootFromParent_Done,
     /* 202877 */   // Label 4005: @202877
     /* 202877 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(202924), // Rule ID 3143 //
     /* 202882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202903 */     // MIs[0] Op3
     /* 202903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 202911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 202911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 202914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202922 */     GIR_RootConstrainSelectedInstOperands,
     /* 202923 */     // GIR_Coverage, 3143,
     /* 202923 */     GIR_EraseRootFromParent_Done,
     /* 202924 */   // Label 4006: @202924
     /* 202924 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(202971), // Rule ID 3144 //
     /* 202929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202950 */     // MIs[0] Op3
     /* 202950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 202958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 202958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 202961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202969 */     GIR_RootConstrainSelectedInstOperands,
     /* 202970 */     // GIR_Coverage, 3144,
     /* 202970 */     GIR_EraseRootFromParent_Done,
     /* 202971 */   // Label 4007: @202971
     /* 202971 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(203018), // Rule ID 3517 //
     /* 202976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 202984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202997 */     // MIs[0] Op3
     /* 202997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 203005 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1263:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 203005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 203008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203016 */     GIR_RootConstrainSelectedInstOperands,
     /* 203017 */     // GIR_Coverage, 3517,
     /* 203017 */     GIR_EraseRootFromParent_Done,
     /* 203018 */   // Label 4008: @203018
     /* 203018 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(203065), // Rule ID 3565 //
     /* 203023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203044 */     // MIs[0] Op3
     /* 203044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1502:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 203055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203063 */     GIR_RootConstrainSelectedInstOperands,
     /* 203064 */     // GIR_Coverage, 3565,
     /* 203064 */     GIR_EraseRootFromParent_Done,
     /* 203065 */   // Label 4009: @203065
     /* 203065 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(203112), // Rule ID 3566 //
     /* 203070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203091 */     // MIs[0] Op3
     /* 203091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 203099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1502:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 203099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 203102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203110 */     GIR_RootConstrainSelectedInstOperands,
     /* 203111 */     // GIR_Coverage, 3566,
     /* 203111 */     GIR_EraseRootFromParent_Done,
     /* 203112 */   // Label 4010: @203112
     /* 203112 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(203159), // Rule ID 3567 //
     /* 203117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203138 */     // MIs[0] Op3
     /* 203138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 203146 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 203146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 203149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203157 */     GIR_RootConstrainSelectedInstOperands,
     /* 203158 */     // GIR_Coverage, 3567,
     /* 203158 */     GIR_EraseRootFromParent_Done,
     /* 203159 */   // Label 4011: @203159
     /* 203159 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(203206), // Rule ID 3568 //
     /* 203164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203185 */     // MIs[0] Op3
     /* 203185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 203193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 203193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 203196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203204 */     GIR_RootConstrainSelectedInstOperands,
     /* 203205 */     // GIR_Coverage, 3568,
     /* 203205 */     GIR_EraseRootFromParent_Done,
     /* 203206 */   // Label 4012: @203206
     /* 203206 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(203253), // Rule ID 3569 //
     /* 203211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203232 */     // MIs[0] Op3
     /* 203232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1503:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 203243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203251 */     GIR_RootConstrainSelectedInstOperands,
     /* 203252 */     // GIR_Coverage, 3569,
     /* 203252 */     GIR_EraseRootFromParent_Done,
     /* 203253 */   // Label 4013: @203253
     /* 203253 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(203300), // Rule ID 3570 //
     /* 203258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203279 */     // MIs[0] Op3
     /* 203279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203287 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 203290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203298 */     GIR_RootConstrainSelectedInstOperands,
     /* 203299 */     // GIR_Coverage, 3570,
     /* 203299 */     GIR_EraseRootFromParent_Done,
     /* 203300 */   // Label 4014: @203300
     /* 203300 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(203347), // Rule ID 11119 //
     /* 203305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203326 */     // MIs[0] Op3
     /* 203326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1702:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 203337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203345 */     GIR_RootConstrainSelectedInstOperands,
     /* 203346 */     // GIR_Coverage, 11119,
     /* 203346 */     GIR_EraseRootFromParent_Done,
     /* 203347 */   // Label 4015: @203347
     /* 203347 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(203394), // Rule ID 11120 //
     /* 203352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203373 */     // MIs[0] Op3
     /* 203373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 203384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203392 */     GIR_RootConstrainSelectedInstOperands,
     /* 203393 */     // GIR_Coverage, 11120,
     /* 203393 */     GIR_EraseRootFromParent_Done,
     /* 203394 */   // Label 4016: @203394
     /* 203394 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(203441), // Rule ID 11121 //
     /* 203399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203420 */     // MIs[0] Op3
     /* 203420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 203428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 203428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 203431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203439 */     GIR_RootConstrainSelectedInstOperands,
     /* 203440 */     // GIR_Coverage, 11121,
     /* 203440 */     GIR_EraseRootFromParent_Done,
     /* 203441 */   // Label 4017: @203441
     /* 203441 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(203488), // Rule ID 11122 //
     /* 203446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203467 */     // MIs[0] Op3
     /* 203467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203486 */     GIR_RootConstrainSelectedInstOperands,
     /* 203487 */     // GIR_Coverage, 11122,
     /* 203487 */     GIR_EraseRootFromParent_Done,
     /* 203488 */   // Label 4018: @203488
     /* 203488 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(203535), // Rule ID 11123 //
     /* 203493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203514 */     // MIs[0] Op3
     /* 203514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 203525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203533 */     GIR_RootConstrainSelectedInstOperands,
     /* 203534 */     // GIR_Coverage, 11123,
     /* 203534 */     GIR_EraseRootFromParent_Done,
     /* 203535 */   // Label 4019: @203535
     /* 203535 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(203582), // Rule ID 11124 //
     /* 203540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203561 */     // MIs[0] Op3
     /* 203561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 203569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 203569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 203572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203580 */     GIR_RootConstrainSelectedInstOperands,
     /* 203581 */     // GIR_Coverage, 11124,
     /* 203581 */     GIR_EraseRootFromParent_Done,
     /* 203582 */   // Label 4020: @203582
     /* 203582 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(203629), // Rule ID 11147 //
     /* 203587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 203595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203608 */     // MIs[0] Op3
     /* 203608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 203619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203627 */     GIR_RootConstrainSelectedInstOperands,
     /* 203628 */     // GIR_Coverage, 11147,
     /* 203628 */     GIR_EraseRootFromParent_Done,
     /* 203629 */   // Label 4021: @203629
     /* 203629 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(203676), // Rule ID 11148 //
     /* 203634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 203642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203655 */     // MIs[0] Op3
     /* 203655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203663 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 203666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203674 */     GIR_RootConstrainSelectedInstOperands,
     /* 203675 */     // GIR_Coverage, 11148,
     /* 203675 */     GIR_EraseRootFromParent_Done,
     /* 203676 */   // Label 4022: @203676
     /* 203676 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(203723), // Rule ID 11149 //
     /* 203681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 203689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203702 */     // MIs[0] Op3
     /* 203702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1899:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 203713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203721 */     GIR_RootConstrainSelectedInstOperands,
     /* 203722 */     // GIR_Coverage, 11149,
     /* 203722 */     GIR_EraseRootFromParent_Done,
     /* 203723 */   // Label 4023: @203723
     /* 203723 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(203770), // Rule ID 11150 //
     /* 203728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 203736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203749 */     // MIs[0] Op3
     /* 203749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1899:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 203760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203768 */     GIR_RootConstrainSelectedInstOperands,
     /* 203769 */     // GIR_Coverage, 11150,
     /* 203769 */     GIR_EraseRootFromParent_Done,
     /* 203770 */   // Label 4024: @203770
     /* 203770 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(203817), // Rule ID 11151 //
     /* 203775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 203783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203796 */     // MIs[0] Op3
     /* 203796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1901:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 203807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203815 */     GIR_RootConstrainSelectedInstOperands,
     /* 203816 */     // GIR_Coverage, 11151,
     /* 203816 */     GIR_EraseRootFromParent_Done,
     /* 203817 */   // Label 4025: @203817
     /* 203817 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(203864), // Rule ID 11152 //
     /* 203822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 203830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203843 */     // MIs[0] Op3
     /* 203843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1901:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 203854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203862 */     GIR_RootConstrainSelectedInstOperands,
     /* 203863 */     // GIR_Coverage, 11152,
     /* 203863 */     GIR_EraseRootFromParent_Done,
     /* 203864 */   // Label 4026: @203864
     /* 203864 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(203911), // Rule ID 11153 //
     /* 203869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 203877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203890 */     // MIs[0] Op3
     /* 203890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 203901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203909 */     GIR_RootConstrainSelectedInstOperands,
     /* 203910 */     // GIR_Coverage, 11153,
     /* 203910 */     GIR_EraseRootFromParent_Done,
     /* 203911 */   // Label 4027: @203911
     /* 203911 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(203958), // Rule ID 11154 //
     /* 203916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 203924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203937 */     // MIs[0] Op3
     /* 203937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 203948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203956 */     GIR_RootConstrainSelectedInstOperands,
     /* 203957 */     // GIR_Coverage, 11154,
     /* 203957 */     GIR_EraseRootFromParent_Done,
     /* 203958 */   // Label 4028: @203958
     /* 203958 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(204005), // Rule ID 11155 //
     /* 203963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 203971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203984 */     // MIs[0] Op3
     /* 203984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 203995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204003 */     GIR_RootConstrainSelectedInstOperands,
     /* 204004 */     // GIR_Coverage, 11155,
     /* 204004 */     GIR_EraseRootFromParent_Done,
     /* 204005 */   // Label 4029: @204005
     /* 204005 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(204052), // Rule ID 11156 //
     /* 204010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 204018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204031 */     // MIs[0] Op3
     /* 204031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 204042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204050 */     GIR_RootConstrainSelectedInstOperands,
     /* 204051 */     // GIR_Coverage, 11156,
     /* 204051 */     GIR_EraseRootFromParent_Done,
     /* 204052 */   // Label 4030: @204052
     /* 204052 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(204099), // Rule ID 11400 //
     /* 204057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204078 */     // MIs[0] Op3
     /* 204078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1768:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 204089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204097 */     GIR_RootConstrainSelectedInstOperands,
     /* 204098 */     // GIR_Coverage, 11400,
     /* 204098 */     GIR_EraseRootFromParent_Done,
     /* 204099 */   // Label 4031: @204099
     /* 204099 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(204146), // Rule ID 11401 //
     /* 204104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204125 */     // MIs[0] Op3
     /* 204125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204133 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1768:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 204136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204144 */     GIR_RootConstrainSelectedInstOperands,
     /* 204145 */     // GIR_Coverage, 11401,
     /* 204145 */     GIR_EraseRootFromParent_Done,
     /* 204146 */   // Label 4032: @204146
     /* 204146 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(204193), // Rule ID 11402 //
     /* 204151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204172 */     // MIs[0] Op3
     /* 204172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 204183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204191 */     GIR_RootConstrainSelectedInstOperands,
     /* 204192 */     // GIR_Coverage, 11402,
     /* 204192 */     GIR_EraseRootFromParent_Done,
     /* 204193 */   // Label 4033: @204193
     /* 204193 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(204240), // Rule ID 11403 //
     /* 204198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204219 */     // MIs[0] Op3
     /* 204219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1768:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 204230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204238 */     GIR_RootConstrainSelectedInstOperands,
     /* 204239 */     // GIR_Coverage, 11403,
     /* 204239 */     GIR_EraseRootFromParent_Done,
     /* 204240 */   // Label 4034: @204240
     /* 204240 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(204287), // Rule ID 11404 //
     /* 204245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204266 */     // MIs[0] Op3
     /* 204266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1959:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 204277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204285 */     GIR_RootConstrainSelectedInstOperands,
     /* 204286 */     // GIR_Coverage, 11404,
     /* 204286 */     GIR_EraseRootFromParent_Done,
     /* 204287 */   // Label 4035: @204287
     /* 204287 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(204334), // Rule ID 11406 //
     /* 204292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204313 */     // MIs[0] Op3
     /* 204313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1959:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 204324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204332 */     GIR_RootConstrainSelectedInstOperands,
     /* 204333 */     // GIR_Coverage, 11406,
     /* 204333 */     GIR_EraseRootFromParent_Done,
     /* 204334 */   // Label 4036: @204334
     /* 204334 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(204381), // Rule ID 11408 //
     /* 204339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204360 */     // MIs[0] Op3
     /* 204360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 204371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204379 */     GIR_RootConstrainSelectedInstOperands,
     /* 204380 */     // GIR_Coverage, 11408,
     /* 204380 */     GIR_EraseRootFromParent_Done,
     /* 204381 */   // Label 4037: @204381
     /* 204381 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(204428), // Rule ID 11410 //
     /* 204386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204407 */     // MIs[0] Op3
     /* 204407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1959:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 204418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204426 */     GIR_RootConstrainSelectedInstOperands,
     /* 204427 */     // GIR_Coverage, 11410,
     /* 204427 */     GIR_EraseRootFromParent_Done,
     /* 204428 */   // Label 4038: @204428
     /* 204428 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(204475), // Rule ID 11412 //
     /* 204433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204454 */     // MIs[0] Op3
     /* 204454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 204462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 204462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 204465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204473 */     GIR_RootConstrainSelectedInstOperands,
     /* 204474 */     // GIR_Coverage, 11412,
     /* 204474 */     GIR_EraseRootFromParent_Done,
     /* 204475 */   // Label 4039: @204475
     /* 204475 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(204522), // Rule ID 11413 //
     /* 204480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204501 */     // MIs[0] Op3
     /* 204501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 204509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 204509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 204512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204520 */     GIR_RootConstrainSelectedInstOperands,
     /* 204521 */     // GIR_Coverage, 11413,
     /* 204521 */     GIR_EraseRootFromParent_Done,
     /* 204522 */   // Label 4040: @204522
     /* 204522 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(204569), // Rule ID 11414 //
     /* 204527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204548 */     // MIs[0] Op3
     /* 204548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 204556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 204556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 204559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204567 */     GIR_RootConstrainSelectedInstOperands,
     /* 204568 */     // GIR_Coverage, 11414,
     /* 204568 */     GIR_EraseRootFromParent_Done,
     /* 204569 */   // Label 4041: @204569
     /* 204569 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(204616), // Rule ID 11415 //
     /* 204574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204595 */     // MIs[0] Op3
     /* 204595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 204603 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 204603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 204606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204614 */     GIR_RootConstrainSelectedInstOperands,
     /* 204615 */     // GIR_Coverage, 11415,
     /* 204615 */     GIR_EraseRootFromParent_Done,
     /* 204616 */   // Label 4042: @204616
     /* 204616 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(204663), // Rule ID 11490 //
     /* 204621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204642 */     // MIs[0] Op3
     /* 204642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 204653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204661 */     GIR_RootConstrainSelectedInstOperands,
     /* 204662 */     // GIR_Coverage, 11490,
     /* 204662 */     GIR_EraseRootFromParent_Done,
     /* 204663 */   // Label 4043: @204663
     /* 204663 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(204710), // Rule ID 11492 //
     /* 204668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204689 */     // MIs[0] Op3
     /* 204689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204697 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 204700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204708 */     GIR_RootConstrainSelectedInstOperands,
     /* 204709 */     // GIR_Coverage, 11492,
     /* 204709 */     GIR_EraseRootFromParent_Done,
     /* 204710 */   // Label 4044: @204710
     /* 204710 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(204757), // Rule ID 11494 //
     /* 204715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204736 */     // MIs[0] Op3
     /* 204736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 204747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204755 */     GIR_RootConstrainSelectedInstOperands,
     /* 204756 */     // GIR_Coverage, 11494,
     /* 204756 */     GIR_EraseRootFromParent_Done,
     /* 204757 */   // Label 4045: @204757
     /* 204757 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(204804), // Rule ID 11496 //
     /* 204762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204783 */     // MIs[0] Op3
     /* 204783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 204794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204802 */     GIR_RootConstrainSelectedInstOperands,
     /* 204803 */     // GIR_Coverage, 11496,
     /* 204803 */     GIR_EraseRootFromParent_Done,
     /* 204804 */   // Label 4046: @204804
     /* 204804 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204851), // Rule ID 11498 //
     /* 204809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204830 */     // MIs[0] Op3
     /* 204830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 204841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204849 */     GIR_RootConstrainSelectedInstOperands,
     /* 204850 */     // GIR_Coverage, 11498,
     /* 204850 */     GIR_EraseRootFromParent_Done,
     /* 204851 */   // Label 4047: @204851
     /* 204851 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204898), // Rule ID 11499 //
     /* 204856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204877 */     // MIs[0] Op3
     /* 204877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 204888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204896 */     GIR_RootConstrainSelectedInstOperands,
     /* 204897 */     // GIR_Coverage, 11499,
     /* 204897 */     GIR_EraseRootFromParent_Done,
     /* 204898 */   // Label 4048: @204898
     /* 204898 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204945), // Rule ID 11500 //
     /* 204903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204924 */     // MIs[0] Op3
     /* 204924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 204935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204943 */     GIR_RootConstrainSelectedInstOperands,
     /* 204944 */     // GIR_Coverage, 11500,
     /* 204944 */     GIR_EraseRootFromParent_Done,
     /* 204945 */   // Label 4049: @204945
     /* 204945 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204992), // Rule ID 11501 //
     /* 204950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204971 */     // MIs[0] Op3
     /* 204971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 204982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204990 */     GIR_RootConstrainSelectedInstOperands,
     /* 204991 */     // GIR_Coverage, 11501,
     /* 204991 */     GIR_EraseRootFromParent_Done,
     /* 204992 */   // Label 4050: @204992
     /* 204992 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(205039), // Rule ID 11506 //
     /* 204997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205018 */     // MIs[0] Op3
     /* 205018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 205029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205037 */     GIR_RootConstrainSelectedInstOperands,
     /* 205038 */     // GIR_Coverage, 11506,
     /* 205038 */     GIR_EraseRootFromParent_Done,
     /* 205039 */   // Label 4051: @205039
     /* 205039 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(205086), // Rule ID 11507 //
     /* 205044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205065 */     // MIs[0] Op3
     /* 205065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 205076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205084 */     GIR_RootConstrainSelectedInstOperands,
     /* 205085 */     // GIR_Coverage, 11507,
     /* 205085 */     GIR_EraseRootFromParent_Done,
     /* 205086 */   // Label 4052: @205086
     /* 205086 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(205133), // Rule ID 11508 //
     /* 205091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205112 */     // MIs[0] Op3
     /* 205112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 205123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205131 */     GIR_RootConstrainSelectedInstOperands,
     /* 205132 */     // GIR_Coverage, 11508,
     /* 205132 */     GIR_EraseRootFromParent_Done,
     /* 205133 */   // Label 4053: @205133
     /* 205133 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(205180), // Rule ID 11509 //
     /* 205138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205159 */     // MIs[0] Op3
     /* 205159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205167 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 205170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205178 */     GIR_RootConstrainSelectedInstOperands,
     /* 205179 */     // GIR_Coverage, 11509,
     /* 205179 */     GIR_EraseRootFromParent_Done,
     /* 205180 */   // Label 4054: @205180
     /* 205180 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(205227), // Rule ID 11569 //
     /* 205185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205206 */     // MIs[0] Op3
     /* 205206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 205217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205225 */     GIR_RootConstrainSelectedInstOperands,
     /* 205226 */     // GIR_Coverage, 11569,
     /* 205226 */     GIR_EraseRootFromParent_Done,
     /* 205227 */   // Label 4055: @205227
     /* 205227 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(205274), // Rule ID 11570 //
     /* 205232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205253 */     // MIs[0] Op3
     /* 205253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 205264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205272 */     GIR_RootConstrainSelectedInstOperands,
     /* 205273 */     // GIR_Coverage, 11570,
     /* 205273 */     GIR_EraseRootFromParent_Done,
     /* 205274 */   // Label 4056: @205274
     /* 205274 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205321), // Rule ID 11571 //
     /* 205279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205300 */     // MIs[0] Op3
     /* 205300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 205311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205319 */     GIR_RootConstrainSelectedInstOperands,
     /* 205320 */     // GIR_Coverage, 11571,
     /* 205320 */     GIR_EraseRootFromParent_Done,
     /* 205321 */   // Label 4057: @205321
     /* 205321 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205368), // Rule ID 11572 //
     /* 205326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205347 */     // MIs[0] Op3
     /* 205347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1625:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 205358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205366 */     GIR_RootConstrainSelectedInstOperands,
     /* 205367 */     // GIR_Coverage, 11572,
     /* 205367 */     GIR_EraseRootFromParent_Done,
     /* 205368 */   // Label 4058: @205368
     /* 205368 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205415), // Rule ID 11573 //
     /* 205373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205394 */     // MIs[0] Op3
     /* 205394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1625:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 205405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205413 */     GIR_RootConstrainSelectedInstOperands,
     /* 205414 */     // GIR_Coverage, 11573,
     /* 205414 */     GIR_EraseRootFromParent_Done,
     /* 205415 */   // Label 4059: @205415
     /* 205415 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205462), // Rule ID 11574 //
     /* 205420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205441 */     // MIs[0] Op3
     /* 205441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1625:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 205452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205460 */     GIR_RootConstrainSelectedInstOperands,
     /* 205461 */     // GIR_Coverage, 11574,
     /* 205461 */     GIR_EraseRootFromParent_Done,
     /* 205462 */   // Label 4060: @205462
     /* 205462 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205509), // Rule ID 11575 //
     /* 205467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205488 */     // MIs[0] Op3
     /* 205488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 205499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205507 */     GIR_RootConstrainSelectedInstOperands,
     /* 205508 */     // GIR_Coverage, 11575,
     /* 205508 */     GIR_EraseRootFromParent_Done,
     /* 205509 */   // Label 4061: @205509
     /* 205509 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205556), // Rule ID 11576 //
     /* 205514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205535 */     // MIs[0] Op3
     /* 205535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 205546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205554 */     GIR_RootConstrainSelectedInstOperands,
     /* 205555 */     // GIR_Coverage, 11576,
     /* 205555 */     GIR_EraseRootFromParent_Done,
     /* 205556 */   // Label 4062: @205556
     /* 205556 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205603), // Rule ID 11577 //
     /* 205561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205582 */     // MIs[0] Op3
     /* 205582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1583:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 205593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205601 */     GIR_RootConstrainSelectedInstOperands,
     /* 205602 */     // GIR_Coverage, 11577,
     /* 205602 */     GIR_EraseRootFromParent_Done,
     /* 205603 */   // Label 4063: @205603
     /* 205603 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205650), // Rule ID 11578 //
     /* 205608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 205616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205629 */     // MIs[0] Op3
     /* 205629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205637 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 205640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205648 */     GIR_RootConstrainSelectedInstOperands,
     /* 205649 */     // GIR_Coverage, 11578,
     /* 205649 */     GIR_EraseRootFromParent_Done,
     /* 205650 */   // Label 4064: @205650
     /* 205650 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205697), // Rule ID 11579 //
     /* 205655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 205663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205676 */     // MIs[0] Op3
     /* 205676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 205687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205695 */     GIR_RootConstrainSelectedInstOperands,
     /* 205696 */     // GIR_Coverage, 11579,
     /* 205696 */     GIR_EraseRootFromParent_Done,
     /* 205697 */   // Label 4065: @205697
     /* 205697 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205744), // Rule ID 11580 //
     /* 205702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 205710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205723 */     // MIs[0] Op3
     /* 205723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 205734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205742 */     GIR_RootConstrainSelectedInstOperands,
     /* 205743 */     // GIR_Coverage, 11580,
     /* 205743 */     GIR_EraseRootFromParent_Done,
     /* 205744 */   // Label 4066: @205744
     /* 205744 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205791), // Rule ID 11581 //
     /* 205749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 205757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205770 */     // MIs[0] Op3
     /* 205770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205778 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 205781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205789 */     GIR_RootConstrainSelectedInstOperands,
     /* 205790 */     // GIR_Coverage, 11581,
     /* 205790 */     GIR_EraseRootFromParent_Done,
     /* 205791 */   // Label 4067: @205791
     /* 205791 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205838), // Rule ID 11582 //
     /* 205796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 205804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205817 */     // MIs[0] Op3
     /* 205817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205820 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 205828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205836 */     GIR_RootConstrainSelectedInstOperands,
     /* 205837 */     // GIR_Coverage, 11582,
     /* 205837 */     GIR_EraseRootFromParent_Done,
     /* 205838 */   // Label 4068: @205838
     /* 205838 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205885), // Rule ID 11583 //
     /* 205843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 205851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205864 */     // MIs[0] Op3
     /* 205864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 205875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205883 */     GIR_RootConstrainSelectedInstOperands,
     /* 205884 */     // GIR_Coverage, 11583,
     /* 205884 */     GIR_EraseRootFromParent_Done,
     /* 205885 */   // Label 4069: @205885
     /* 205885 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205932), // Rule ID 11584 //
     /* 205890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 205898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205911 */     // MIs[0] Op3
     /* 205911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 205922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205930 */     GIR_RootConstrainSelectedInstOperands,
     /* 205931 */     // GIR_Coverage, 11584,
     /* 205931 */     GIR_EraseRootFromParent_Done,
     /* 205932 */   // Label 4070: @205932
     /* 205932 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205979), // Rule ID 11585 //
     /* 205937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 205945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205958 */     // MIs[0] Op3
     /* 205958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 205969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205977 */     GIR_RootConstrainSelectedInstOperands,
     /* 205978 */     // GIR_Coverage, 11585,
     /* 205978 */     GIR_EraseRootFromParent_Done,
     /* 205979 */   // Label 4071: @205979
     /* 205979 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(206026), // Rule ID 11586 //
     /* 205984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 205992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206005 */     // MIs[0] Op3
     /* 206005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 206016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206024 */     GIR_RootConstrainSelectedInstOperands,
     /* 206025 */     // GIR_Coverage, 11586,
     /* 206025 */     GIR_EraseRootFromParent_Done,
     /* 206026 */   // Label 4072: @206026
     /* 206026 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206073), // Rule ID 11587 //
     /* 206031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206052 */     // MIs[0] Op3
     /* 206052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206060 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 206063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206071 */     GIR_RootConstrainSelectedInstOperands,
     /* 206072 */     // GIR_Coverage, 11587,
     /* 206072 */     GIR_EraseRootFromParent_Done,
     /* 206073 */   // Label 4073: @206073
     /* 206073 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206120), // Rule ID 11588 //
     /* 206078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206099 */     // MIs[0] Op3
     /* 206099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 206110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206118 */     GIR_RootConstrainSelectedInstOperands,
     /* 206119 */     // GIR_Coverage, 11588,
     /* 206119 */     GIR_EraseRootFromParent_Done,
     /* 206120 */   // Label 4074: @206120
     /* 206120 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206167), // Rule ID 11589 //
     /* 206125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206146 */     // MIs[0] Op3
     /* 206146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 206157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206165 */     GIR_RootConstrainSelectedInstOperands,
     /* 206166 */     // GIR_Coverage, 11589,
     /* 206166 */     GIR_EraseRootFromParent_Done,
     /* 206167 */   // Label 4075: @206167
     /* 206167 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206234), // Rule ID 2590 //
     /* 206172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 206180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 206223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206232 */     GIR_RootConstrainSelectedInstOperands,
     /* 206233 */     // GIR_Coverage, 2590,
     /* 206233 */     GIR_EraseRootFromParent_Done,
     /* 206234 */   // Label 4076: @206234
     /* 206234 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206301), // Rule ID 7548 //
     /* 206239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206273 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 206290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206299 */     GIR_RootConstrainSelectedInstOperands,
     /* 206300 */     // GIR_Coverage, 7548,
     /* 206300 */     GIR_EraseRootFromParent_Done,
     /* 206301 */   // Label 4077: @206301
     /* 206301 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206368), // Rule ID 7550 //
     /* 206306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 206357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206366 */     GIR_RootConstrainSelectedInstOperands,
     /* 206367 */     // GIR_Coverage, 7550,
     /* 206367 */     GIR_EraseRootFromParent_Done,
     /* 206368 */   // Label 4078: @206368
     /* 206368 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206435), // Rule ID 7552 //
     /* 206373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 206424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206433 */     GIR_RootConstrainSelectedInstOperands,
     /* 206434 */     // GIR_Coverage, 7552,
     /* 206434 */     GIR_EraseRootFromParent_Done,
     /* 206435 */   // Label 4079: @206435
     /* 206435 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206502), // Rule ID 7554 //
     /* 206440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 206491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206500 */     GIR_RootConstrainSelectedInstOperands,
     /* 206501 */     // GIR_Coverage, 7554,
     /* 206501 */     GIR_EraseRootFromParent_Done,
     /* 206502 */   // Label 4080: @206502
     /* 206502 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206569), // Rule ID 7584 //
     /* 206507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 206558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206567 */     GIR_RootConstrainSelectedInstOperands,
     /* 206568 */     // GIR_Coverage, 7584,
     /* 206568 */     GIR_EraseRootFromParent_Done,
     /* 206569 */   // Label 4081: @206569
     /* 206569 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206636), // Rule ID 7586 //
     /* 206574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 206625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206634 */     GIR_RootConstrainSelectedInstOperands,
     /* 206635 */     // GIR_Coverage, 7586,
     /* 206635 */     GIR_EraseRootFromParent_Done,
     /* 206636 */   // Label 4082: @206636
     /* 206636 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206703), // Rule ID 7588 //
     /* 206641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 206692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206701 */     GIR_RootConstrainSelectedInstOperands,
     /* 206702 */     // GIR_Coverage, 7588,
     /* 206702 */     GIR_EraseRootFromParent_Done,
     /* 206703 */   // Label 4083: @206703
     /* 206703 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206770), // Rule ID 7590 //
     /* 206708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 206759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206768 */     GIR_RootConstrainSelectedInstOperands,
     /* 206769 */     // GIR_Coverage, 7590,
     /* 206769 */     GIR_EraseRootFromParent_Done,
     /* 206770 */   // Label 4084: @206770
     /* 206770 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206837), // Rule ID 7596 //
     /* 206775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 206826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206835 */     GIR_RootConstrainSelectedInstOperands,
     /* 206836 */     // GIR_Coverage, 7596,
     /* 206836 */     GIR_EraseRootFromParent_Done,
     /* 206837 */   // Label 4085: @206837
     /* 206837 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206904), // Rule ID 7598 //
     /* 206842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 206893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206902 */     GIR_RootConstrainSelectedInstOperands,
     /* 206903 */     // GIR_Coverage, 7598,
     /* 206903 */     GIR_EraseRootFromParent_Done,
     /* 206904 */   // Label 4086: @206904
     /* 206904 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(206971), // Rule ID 7600 //
     /* 206909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 206960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206969 */     GIR_RootConstrainSelectedInstOperands,
     /* 206970 */     // GIR_Coverage, 7600,
     /* 206970 */     GIR_EraseRootFromParent_Done,
     /* 206971 */   // Label 4087: @206971
     /* 206971 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207038), // Rule ID 7602 //
     /* 206976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 207027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207036 */     GIR_RootConstrainSelectedInstOperands,
     /* 207037 */     // GIR_Coverage, 7602,
     /* 207037 */     GIR_EraseRootFromParent_Done,
     /* 207038 */   // Label 4088: @207038
     /* 207038 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207105), // Rule ID 11282 //
     /* 207043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 207051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 207094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207103 */     GIR_RootConstrainSelectedInstOperands,
     /* 207104 */     // GIR_Coverage, 11282,
     /* 207104 */     GIR_EraseRootFromParent_Done,
     /* 207105 */   // Label 4089: @207105
     /* 207105 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207172), // Rule ID 11284 //
     /* 207110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 207161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207170 */     GIR_RootConstrainSelectedInstOperands,
     /* 207171 */     // GIR_Coverage, 11284,
     /* 207171 */     GIR_EraseRootFromParent_Done,
     /* 207172 */   // Label 4090: @207172
     /* 207172 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207239), // Rule ID 11286 //
     /* 207177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 207228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207237 */     GIR_RootConstrainSelectedInstOperands,
     /* 207238 */     // GIR_Coverage, 11286,
     /* 207238 */     GIR_EraseRootFromParent_Done,
     /* 207239 */   // Label 4091: @207239
     /* 207239 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207306), // Rule ID 11288 //
     /* 207244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 207295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207304 */     GIR_RootConstrainSelectedInstOperands,
     /* 207305 */     // GIR_Coverage, 11288,
     /* 207305 */     GIR_EraseRootFromParent_Done,
     /* 207306 */   // Label 4092: @207306
     /* 207306 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207373), // Rule ID 11290 //
     /* 207311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 207362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207371 */     GIR_RootConstrainSelectedInstOperands,
     /* 207372 */     // GIR_Coverage, 11290,
     /* 207372 */     GIR_EraseRootFromParent_Done,
     /* 207373 */   // Label 4093: @207373
     /* 207373 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207440), // Rule ID 11296 //
     /* 207378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 207429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207438 */     GIR_RootConstrainSelectedInstOperands,
     /* 207439 */     // GIR_Coverage, 11296,
     /* 207439 */     GIR_EraseRootFromParent_Done,
     /* 207440 */   // Label 4094: @207440
     /* 207440 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207507), // Rule ID 11298 //
     /* 207445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 207496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207505 */     GIR_RootConstrainSelectedInstOperands,
     /* 207506 */     // GIR_Coverage, 11298,
     /* 207506 */     GIR_EraseRootFromParent_Done,
     /* 207507 */   // Label 4095: @207507
     /* 207507 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207574), // Rule ID 11300 //
     /* 207512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 207563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207572 */     GIR_RootConstrainSelectedInstOperands,
     /* 207573 */     // GIR_Coverage, 11300,
     /* 207573 */     GIR_EraseRootFromParent_Done,
     /* 207574 */   // Label 4096: @207574
     /* 207574 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207641), // Rule ID 11302 //
     /* 207579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 207630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207639 */     GIR_RootConstrainSelectedInstOperands,
     /* 207640 */     // GIR_Coverage, 11302,
     /* 207640 */     GIR_EraseRootFromParent_Done,
     /* 207641 */   // Label 4097: @207641
     /* 207641 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207695), // Rule ID 30 //
     /* 207646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 207649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 207654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 207663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 207666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207682 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 207682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 207685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207693 */     GIR_RootConstrainSelectedInstOperands,
     /* 207694 */     // GIR_Coverage, 30,
     /* 207694 */     GIR_EraseRootFromParent_Done,
     /* 207695 */   // Label 4098: @207695
     /* 207695 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207749), // Rule ID 31 //
     /* 207700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 207703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 207708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 207717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 207720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 207736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 207739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207747 */     GIR_RootConstrainSelectedInstOperands,
     /* 207748 */     // GIR_Coverage, 31,
     /* 207748 */     GIR_EraseRootFromParent_Done,
     /* 207749 */   // Label 4099: @207749
     /* 207749 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207803), // Rule ID 32 //
     /* 207754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 207757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 207762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 207771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 207774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207790 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 207790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 207793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207801 */     GIR_RootConstrainSelectedInstOperands,
     /* 207802 */     // GIR_Coverage, 32,
     /* 207802 */     GIR_EraseRootFromParent_Done,
     /* 207803 */   // Label 4100: @207803
     /* 207803 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207857), // Rule ID 39 //
     /* 207808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 207816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 207819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 207822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 207825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 207828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207844 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 207844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 207847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207855 */     GIR_RootConstrainSelectedInstOperands,
     /* 207856 */     // GIR_Coverage, 39,
     /* 207856 */     GIR_EraseRootFromParent_Done,
     /* 207857 */   // Label 4101: @207857
     /* 207857 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207911), // Rule ID 40 //
     /* 207862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 207870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 207879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 207882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207898 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 207898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 207901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207909 */     GIR_RootConstrainSelectedInstOperands,
     /* 207910 */     // GIR_Coverage, 40,
     /* 207910 */     GIR_EraseRootFromParent_Done,
     /* 207911 */   // Label 4102: @207911
     /* 207911 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207965), // Rule ID 41 //
     /* 207916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 207924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 207927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 207930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 207933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 207936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207952 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 207952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 207955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207963 */     GIR_RootConstrainSelectedInstOperands,
     /* 207964 */     // GIR_Coverage, 41,
     /* 207964 */     GIR_EraseRootFromParent_Done,
     /* 207965 */   // Label 4103: @207965
     /* 207965 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208019), // Rule ID 42 //
     /* 207970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 207978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 207987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 207990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 208009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208017 */     GIR_RootConstrainSelectedInstOperands,
     /* 208018 */     // GIR_Coverage, 42,
     /* 208018 */     GIR_EraseRootFromParent_Done,
     /* 208019 */   // Label 4104: @208019
     /* 208019 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208073), // Rule ID 43 //
     /* 208024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 208032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208060 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 208063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208071 */     GIR_RootConstrainSelectedInstOperands,
     /* 208072 */     // GIR_Coverage, 43,
     /* 208072 */     GIR_EraseRootFromParent_Done,
     /* 208073 */   // Label 4105: @208073
     /* 208073 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(208127), // Rule ID 44 //
     /* 208078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 208086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208114 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 208117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208125 */     GIR_RootConstrainSelectedInstOperands,
     /* 208126 */     // GIR_Coverage, 44,
     /* 208126 */     GIR_EraseRootFromParent_Done,
     /* 208127 */   // Label 4106: @208127
     /* 208127 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208181), // Rule ID 45 //
     /* 208132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 208140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208168 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 208171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208179 */     GIR_RootConstrainSelectedInstOperands,
     /* 208180 */     // GIR_Coverage, 45,
     /* 208180 */     GIR_EraseRootFromParent_Done,
     /* 208181 */   // Label 4107: @208181
     /* 208181 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208235), // Rule ID 46 //
     /* 208186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 208194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208222 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 208225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208233 */     GIR_RootConstrainSelectedInstOperands,
     /* 208234 */     // GIR_Coverage, 46,
     /* 208234 */     GIR_EraseRootFromParent_Done,
     /* 208235 */   // Label 4108: @208235
     /* 208235 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208289), // Rule ID 1580 //
     /* 208240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 208251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 208254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208276 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 208276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 208279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208287 */     GIR_RootConstrainSelectedInstOperands,
     /* 208288 */     // GIR_Coverage, 1580,
     /* 208288 */     GIR_EraseRootFromParent_Done,
     /* 208289 */   // Label 4109: @208289
     /* 208289 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208343), // Rule ID 1581 //
     /* 208294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 208305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 208308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208330 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 208330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 208333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208341 */     GIR_RootConstrainSelectedInstOperands,
     /* 208342 */     // GIR_Coverage, 1581,
     /* 208342 */     GIR_EraseRootFromParent_Done,
     /* 208343 */   // Label 4110: @208343
     /* 208343 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208397), // Rule ID 1582 //
     /* 208348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 208365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 208368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208384 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 208384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 208387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208395 */     GIR_RootConstrainSelectedInstOperands,
     /* 208396 */     // GIR_Coverage, 1582,
     /* 208396 */     GIR_EraseRootFromParent_Done,
     /* 208397 */   // Label 4111: @208397
     /* 208397 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208451), // Rule ID 1583 //
     /* 208402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208438 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 208441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208449 */     GIR_RootConstrainSelectedInstOperands,
     /* 208450 */     // GIR_Coverage, 1583,
     /* 208450 */     GIR_EraseRootFromParent_Done,
     /* 208451 */   // Label 4112: @208451
     /* 208451 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208505), // Rule ID 1584 //
     /* 208456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 208467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 208470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208492 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 208492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 208495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208503 */     GIR_RootConstrainSelectedInstOperands,
     /* 208504 */     // GIR_Coverage, 1584,
     /* 208504 */     GIR_EraseRootFromParent_Done,
     /* 208505 */   // Label 4113: @208505
     /* 208505 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208559), // Rule ID 1585 //
     /* 208510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 208521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 208524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208546 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 208546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 208549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208557 */     GIR_RootConstrainSelectedInstOperands,
     /* 208558 */     // GIR_Coverage, 1585,
     /* 208558 */     GIR_EraseRootFromParent_Done,
     /* 208559 */   // Label 4114: @208559
     /* 208559 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208613), // Rule ID 1586 //
     /* 208564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 208581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 208584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208600 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 208600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 208603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208611 */     GIR_RootConstrainSelectedInstOperands,
     /* 208612 */     // GIR_Coverage, 1586,
     /* 208612 */     GIR_EraseRootFromParent_Done,
     /* 208613 */   // Label 4115: @208613
     /* 208613 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208667), // Rule ID 1587 //
     /* 208618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208654 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 208657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208665 */     GIR_RootConstrainSelectedInstOperands,
     /* 208666 */     // GIR_Coverage, 1587,
     /* 208666 */     GIR_EraseRootFromParent_Done,
     /* 208667 */   // Label 4116: @208667
     /* 208667 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208721), // Rule ID 2298 //
     /* 208672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 208680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 208704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208708 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 208711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208719 */     GIR_RootConstrainSelectedInstOperands,
     /* 208720 */     // GIR_Coverage, 2298,
     /* 208720 */     GIR_EraseRootFromParent_Done,
     /* 208721 */   // Label 4117: @208721
     /* 208721 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208775), // Rule ID 2299 //
     /* 208726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 208734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 208758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208762 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 208765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208773 */     GIR_RootConstrainSelectedInstOperands,
     /* 208774 */     // GIR_Coverage, 2299,
     /* 208774 */     GIR_EraseRootFromParent_Done,
     /* 208775 */   // Label 4118: @208775
     /* 208775 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208829), // Rule ID 2300 //
     /* 208780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 208788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 208812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 208819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208827 */     GIR_RootConstrainSelectedInstOperands,
     /* 208828 */     // GIR_Coverage, 2300,
     /* 208828 */     GIR_EraseRootFromParent_Done,
     /* 208829 */   // Label 4119: @208829
     /* 208829 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208883), // Rule ID 2301 //
     /* 208834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 208842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208870 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 208873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208881 */     GIR_RootConstrainSelectedInstOperands,
     /* 208882 */     // GIR_Coverage, 2301,
     /* 208882 */     GIR_EraseRootFromParent_Done,
     /* 208883 */   // Label 4120: @208883
     /* 208883 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208937), // Rule ID 2302 //
     /* 208888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 208896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 208927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208935 */     GIR_RootConstrainSelectedInstOperands,
     /* 208936 */     // GIR_Coverage, 2302,
     /* 208936 */     GIR_EraseRootFromParent_Done,
     /* 208937 */   // Label 4121: @208937
     /* 208937 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(208991), // Rule ID 2303 //
     /* 208942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 208950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 208981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208989 */     GIR_RootConstrainSelectedInstOperands,
     /* 208990 */     // GIR_Coverage, 2303,
     /* 208990 */     GIR_EraseRootFromParent_Done,
     /* 208991 */   // Label 4122: @208991
     /* 208991 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209045), // Rule ID 2304 //
     /* 208996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 209004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209032 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 209035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209043 */     GIR_RootConstrainSelectedInstOperands,
     /* 209044 */     // GIR_Coverage, 2304,
     /* 209044 */     GIR_EraseRootFromParent_Done,
     /* 209045 */   // Label 4123: @209045
     /* 209045 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209102), // Rule ID 3608 //
     /* 209050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209086 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 209089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209095 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209100 */     GIR_RootConstrainSelectedInstOperands,
     /* 209101 */     // GIR_Coverage, 3608,
     /* 209101 */     GIR_EraseRootFromParent_Done,
     /* 209102 */   // Label 4124: @209102
     /* 209102 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209159), // Rule ID 3609 //
     /* 209107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 209124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209143 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 209146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209152 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209157 */     GIR_RootConstrainSelectedInstOperands,
     /* 209158 */     // GIR_Coverage, 3609,
     /* 209158 */     GIR_EraseRootFromParent_Done,
     /* 209159 */   // Label 4125: @209159
     /* 209159 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209216), // Rule ID 3610 //
     /* 209164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 209203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209209 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209214 */     GIR_RootConstrainSelectedInstOperands,
     /* 209215 */     // GIR_Coverage, 3610,
     /* 209215 */     GIR_EraseRootFromParent_Done,
     /* 209216 */   // Label 4126: @209216
     /* 209216 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209273), // Rule ID 3611 //
     /* 209221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209257 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 209260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209266 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209271 */     GIR_RootConstrainSelectedInstOperands,
     /* 209272 */     // GIR_Coverage, 3611,
     /* 209272 */     GIR_EraseRootFromParent_Done,
     /* 209273 */   // Label 4127: @209273
     /* 209273 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209327), // Rule ID 3758 //
     /* 209278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 209286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209314 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 209317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209325 */     GIR_RootConstrainSelectedInstOperands,
     /* 209326 */     // GIR_Coverage, 3758,
     /* 209326 */     GIR_EraseRootFromParent_Done,
     /* 209327 */   // Label 4128: @209327
     /* 209327 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209381), // Rule ID 3759 //
     /* 209332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 209340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209368 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 209371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209379 */     GIR_RootConstrainSelectedInstOperands,
     /* 209380 */     // GIR_Coverage, 3759,
     /* 209380 */     GIR_EraseRootFromParent_Done,
     /* 209381 */   // Label 4129: @209381
     /* 209381 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209435), // Rule ID 3760 //
     /* 209386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 209394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209422 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 209425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209433 */     GIR_RootConstrainSelectedInstOperands,
     /* 209434 */     // GIR_Coverage, 3760,
     /* 209434 */     GIR_EraseRootFromParent_Done,
     /* 209435 */   // Label 4130: @209435
     /* 209435 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209489), // Rule ID 3761 //
     /* 209440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209476 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209487 */     GIR_RootConstrainSelectedInstOperands,
     /* 209488 */     // GIR_Coverage, 3761,
     /* 209488 */     GIR_EraseRootFromParent_Done,
     /* 209489 */   // Label 4131: @209489
     /* 209489 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209543), // Rule ID 3762 //
     /* 209494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209530 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209541 */     GIR_RootConstrainSelectedInstOperands,
     /* 209542 */     // GIR_Coverage, 3762,
     /* 209542 */     GIR_EraseRootFromParent_Done,
     /* 209543 */   // Label 4132: @209543
     /* 209543 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209597), // Rule ID 3763 //
     /* 209548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 209584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209595 */     GIR_RootConstrainSelectedInstOperands,
     /* 209596 */     // GIR_Coverage, 3763,
     /* 209596 */     GIR_EraseRootFromParent_Done,
     /* 209597 */   // Label 4133: @209597
     /* 209597 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209651), // Rule ID 3764 //
     /* 209602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209638 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209649 */     GIR_RootConstrainSelectedInstOperands,
     /* 209650 */     // GIR_Coverage, 3764,
     /* 209650 */     GIR_EraseRootFromParent_Done,
     /* 209651 */   // Label 4134: @209651
     /* 209651 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209705), // Rule ID 3773 //
     /* 209656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209692 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209703 */     GIR_RootConstrainSelectedInstOperands,
     /* 209704 */     // GIR_Coverage, 3773,
     /* 209704 */     GIR_EraseRootFromParent_Done,
     /* 209705 */   // Label 4135: @209705
     /* 209705 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209759), // Rule ID 3774 //
     /* 209710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209746 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209757 */     GIR_RootConstrainSelectedInstOperands,
     /* 209758 */     // GIR_Coverage, 3774,
     /* 209758 */     GIR_EraseRootFromParent_Done,
     /* 209759 */   // Label 4136: @209759
     /* 209759 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209813), // Rule ID 3775 //
     /* 209764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209800 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 209800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209811 */     GIR_RootConstrainSelectedInstOperands,
     /* 209812 */     // GIR_Coverage, 3775,
     /* 209812 */     GIR_EraseRootFromParent_Done,
     /* 209813 */   // Label 4137: @209813
     /* 209813 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209867), // Rule ID 3776 //
     /* 209818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209854 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209865 */     GIR_RootConstrainSelectedInstOperands,
     /* 209866 */     // GIR_Coverage, 3776,
     /* 209866 */     GIR_EraseRootFromParent_Done,
     /* 209867 */   // Label 4138: @209867
     /* 209867 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209921), // Rule ID 3777 //
     /* 209872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 209880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209908 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209919 */     GIR_RootConstrainSelectedInstOperands,
     /* 209920 */     // GIR_Coverage, 3777,
     /* 209920 */     GIR_EraseRootFromParent_Done,
     /* 209921 */   // Label 4139: @209921
     /* 209921 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209975), // Rule ID 3778 //
     /* 209926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 209934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209973 */     GIR_RootConstrainSelectedInstOperands,
     /* 209974 */     // GIR_Coverage, 3778,
     /* 209974 */     GIR_EraseRootFromParent_Done,
     /* 209975 */   // Label 4140: @209975
     /* 209975 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(210029), // Rule ID 3779 //
     /* 209980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 209988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210016 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210027 */     GIR_RootConstrainSelectedInstOperands,
     /* 210028 */     // GIR_Coverage, 3779,
     /* 210028 */     GIR_EraseRootFromParent_Done,
     /* 210029 */   // Label 4141: @210029
     /* 210029 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210083), // Rule ID 3780 //
     /* 210034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210070 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210081 */     GIR_RootConstrainSelectedInstOperands,
     /* 210082 */     // GIR_Coverage, 3780,
     /* 210082 */     GIR_EraseRootFromParent_Done,
     /* 210083 */   // Label 4142: @210083
     /* 210083 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210137), // Rule ID 3781 //
     /* 210088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 210099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 210102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210124 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 210124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210135 */     GIR_RootConstrainSelectedInstOperands,
     /* 210136 */     // GIR_Coverage, 3781,
     /* 210136 */     GIR_EraseRootFromParent_Done,
     /* 210137 */   // Label 4143: @210137
     /* 210137 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210191), // Rule ID 3782 //
     /* 210142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210178 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 210178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210189 */     GIR_RootConstrainSelectedInstOperands,
     /* 210190 */     // GIR_Coverage, 3782,
     /* 210190 */     GIR_EraseRootFromParent_Done,
     /* 210191 */   // Label 4144: @210191
     /* 210191 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210245), // Rule ID 3783 //
     /* 210196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210232 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210243 */     GIR_RootConstrainSelectedInstOperands,
     /* 210244 */     // GIR_Coverage, 3783,
     /* 210244 */     GIR_EraseRootFromParent_Done,
     /* 210245 */   // Label 4145: @210245
     /* 210245 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210299), // Rule ID 3784 //
     /* 210250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210286 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210297 */     GIR_RootConstrainSelectedInstOperands,
     /* 210298 */     // GIR_Coverage, 3784,
     /* 210298 */     GIR_EraseRootFromParent_Done,
     /* 210299 */   // Label 4146: @210299
     /* 210299 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210353), // Rule ID 3788 //
     /* 210304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 210312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210340 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 210340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 210343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 210347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 210349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 210351 */     GIR_RootConstrainSelectedInstOperands,
     /* 210352 */     // GIR_Coverage, 3788,
     /* 210352 */     GIR_EraseRootFromParent_Done,
     /* 210353 */   // Label 4147: @210353
     /* 210353 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210407), // Rule ID 3789 //
     /* 210358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 210366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210394 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 210397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 210399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210405 */     GIR_RootConstrainSelectedInstOperands,
     /* 210406 */     // GIR_Coverage, 3789,
     /* 210406 */     GIR_EraseRootFromParent_Done,
     /* 210407 */   // Label 4148: @210407
     /* 210407 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210461), // Rule ID 3790 //
     /* 210412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 210420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 210451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 210453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210459 */     GIR_RootConstrainSelectedInstOperands,
     /* 210460 */     // GIR_Coverage, 3790,
     /* 210460 */     GIR_EraseRootFromParent_Done,
     /* 210461 */   // Label 4149: @210461
     /* 210461 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210518), // Rule ID 3807 //
     /* 210466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210502 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 210502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210516 */     GIR_RootConstrainSelectedInstOperands,
     /* 210517 */     // GIR_Coverage, 3807,
     /* 210517 */     GIR_EraseRootFromParent_Done,
     /* 210518 */   // Label 4150: @210518
     /* 210518 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210575), // Rule ID 3808 //
     /* 210523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 210531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210559 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 210559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210573 */     GIR_RootConstrainSelectedInstOperands,
     /* 210574 */     // GIR_Coverage, 3808,
     /* 210574 */     GIR_EraseRootFromParent_Done,
     /* 210575 */   // Label 4151: @210575
     /* 210575 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210632), // Rule ID 3809 //
     /* 210580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 210588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210616 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 210616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 210630 */     GIR_RootConstrainSelectedInstOperands,
     /* 210631 */     // GIR_Coverage, 3809,
     /* 210631 */     GIR_EraseRootFromParent_Done,
     /* 210632 */   // Label 4152: @210632
     /* 210632 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210689), // Rule ID 3810 //
     /* 210637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 210645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210673 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 210673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 210687 */     GIR_RootConstrainSelectedInstOperands,
     /* 210688 */     // GIR_Coverage, 3810,
     /* 210688 */     GIR_EraseRootFromParent_Done,
     /* 210689 */   // Label 4153: @210689
     /* 210689 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210746), // Rule ID 3815 //
     /* 210694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210730 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 210730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210744 */     GIR_RootConstrainSelectedInstOperands,
     /* 210745 */     // GIR_Coverage, 3815,
     /* 210745 */     GIR_EraseRootFromParent_Done,
     /* 210746 */   // Label 4154: @210746
     /* 210746 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210803), // Rule ID 3816 //
     /* 210751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 210759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210787 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 210787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210801 */     GIR_RootConstrainSelectedInstOperands,
     /* 210802 */     // GIR_Coverage, 3816,
     /* 210802 */     GIR_EraseRootFromParent_Done,
     /* 210803 */   // Label 4155: @210803
     /* 210803 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210860), // Rule ID 3817 //
     /* 210808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 210816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210844 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 210844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 210858 */     GIR_RootConstrainSelectedInstOperands,
     /* 210859 */     // GIR_Coverage, 3817,
     /* 210859 */     GIR_EraseRootFromParent_Done,
     /* 210860 */   // Label 4156: @210860
     /* 210860 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210917), // Rule ID 3818 //
     /* 210865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 210873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210901 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 210901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 210915 */     GIR_RootConstrainSelectedInstOperands,
     /* 210916 */     // GIR_Coverage, 3818,
     /* 210916 */     GIR_EraseRootFromParent_Done,
     /* 210917 */   // Label 4157: @210917
     /* 210917 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210974), // Rule ID 3823 //
     /* 210922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 210925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 210939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 210942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210958 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 210958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 210961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210972 */     GIR_RootConstrainSelectedInstOperands,
     /* 210973 */     // GIR_Coverage, 3823,
     /* 210973 */     GIR_EraseRootFromParent_Done,
     /* 210974 */   // Label 4158: @210974
     /* 210974 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(211031), // Rule ID 3824 //
     /* 210979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 210982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 210987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 210996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 210999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211015 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 211015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211029 */     GIR_RootConstrainSelectedInstOperands,
     /* 211030 */     // GIR_Coverage, 3824,
     /* 211030 */     GIR_EraseRootFromParent_Done,
     /* 211031 */   // Label 4159: @211031
     /* 211031 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(211088), // Rule ID 3825 //
     /* 211036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211072 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 211072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211086 */     GIR_RootConstrainSelectedInstOperands,
     /* 211087 */     // GIR_Coverage, 3825,
     /* 211087 */     GIR_EraseRootFromParent_Done,
     /* 211088 */   // Label 4160: @211088
     /* 211088 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(211145), // Rule ID 3826 //
     /* 211093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211129 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 211129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211143 */     GIR_RootConstrainSelectedInstOperands,
     /* 211144 */     // GIR_Coverage, 3826,
     /* 211144 */     GIR_EraseRootFromParent_Done,
     /* 211145 */   // Label 4161: @211145
     /* 211145 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211202), // Rule ID 3827 //
     /* 211150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211186 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 211186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211200 */     GIR_RootConstrainSelectedInstOperands,
     /* 211201 */     // GIR_Coverage, 3827,
     /* 211201 */     GIR_EraseRootFromParent_Done,
     /* 211202 */   // Label 4162: @211202
     /* 211202 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211259), // Rule ID 3828 //
     /* 211207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211243 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 211243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211257 */     GIR_RootConstrainSelectedInstOperands,
     /* 211258 */     // GIR_Coverage, 3828,
     /* 211258 */     GIR_EraseRootFromParent_Done,
     /* 211259 */   // Label 4163: @211259
     /* 211259 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211316), // Rule ID 3829 //
     /* 211264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211300 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 211300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211314 */     GIR_RootConstrainSelectedInstOperands,
     /* 211315 */     // GIR_Coverage, 3829,
     /* 211315 */     GIR_EraseRootFromParent_Done,
     /* 211316 */   // Label 4164: @211316
     /* 211316 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211373), // Rule ID 3830 //
     /* 211321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211357 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 211357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211371 */     GIR_RootConstrainSelectedInstOperands,
     /* 211372 */     // GIR_Coverage, 3830,
     /* 211372 */     GIR_EraseRootFromParent_Done,
     /* 211373 */   // Label 4165: @211373
     /* 211373 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211430), // Rule ID 3831 //
     /* 211378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211414 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 211414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211428 */     GIR_RootConstrainSelectedInstOperands,
     /* 211429 */     // GIR_Coverage, 3831,
     /* 211429 */     GIR_EraseRootFromParent_Done,
     /* 211430 */   // Label 4166: @211430
     /* 211430 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211487), // Rule ID 3832 //
     /* 211435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211471 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 211471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211485 */     GIR_RootConstrainSelectedInstOperands,
     /* 211486 */     // GIR_Coverage, 3832,
     /* 211486 */     GIR_EraseRootFromParent_Done,
     /* 211487 */   // Label 4167: @211487
     /* 211487 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211544), // Rule ID 3833 //
     /* 211492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211528 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 211528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211542 */     GIR_RootConstrainSelectedInstOperands,
     /* 211543 */     // GIR_Coverage, 3833,
     /* 211543 */     GIR_EraseRootFromParent_Done,
     /* 211544 */   // Label 4168: @211544
     /* 211544 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211601), // Rule ID 3834 //
     /* 211549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211585 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 211585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211599 */     GIR_RootConstrainSelectedInstOperands,
     /* 211600 */     // GIR_Coverage, 3834,
     /* 211600 */     GIR_EraseRootFromParent_Done,
     /* 211601 */   // Label 4169: @211601
     /* 211601 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211655), // Rule ID 5169 //
     /* 211606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 211609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 211614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 211617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211642 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 211642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 211645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211653 */     GIR_RootConstrainSelectedInstOperands,
     /* 211654 */     // GIR_Coverage, 5169,
     /* 211654 */     GIR_EraseRootFromParent_Done,
     /* 211655 */   // Label 4170: @211655
     /* 211655 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211709), // Rule ID 5170 //
     /* 211660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 211663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 211668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 211671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211696 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 211696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 211699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211707 */     GIR_RootConstrainSelectedInstOperands,
     /* 211708 */     // GIR_Coverage, 5170,
     /* 211708 */     GIR_EraseRootFromParent_Done,
     /* 211709 */   // Label 4171: @211709
     /* 211709 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211760), // Rule ID 5516 //
     /* 211714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 211719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 211722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 211725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 211728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 211731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211747 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 211747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 211750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 211758 */     GIR_RootConstrainSelectedInstOperands,
     /* 211759 */     // GIR_Coverage, 5516,
     /* 211759 */     GIR_EraseRootFromParent_Done,
     /* 211760 */   // Label 4172: @211760
     /* 211760 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211811), // Rule ID 5517 //
     /* 211765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 211770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 211773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 211776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 211779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 211782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211798 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 211798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 211801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 211807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 211809 */     GIR_RootConstrainSelectedInstOperands,
     /* 211810 */     // GIR_Coverage, 5517,
     /* 211810 */     GIR_EraseRootFromParent_Done,
     /* 211811 */   // Label 4173: @211811
     /* 211811 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211853), // Rule ID 2685 //
     /* 211816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 211836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 211840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 211843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211851 */     GIR_RootConstrainSelectedInstOperands,
     /* 211852 */     // GIR_Coverage, 2685,
     /* 211852 */     GIR_EraseRootFromParent_Done,
     /* 211853 */   // Label 4174: @211853
     /* 211853 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211895), // Rule ID 2686 //
     /* 211858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 211878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 211882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 211885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211893 */     GIR_RootConstrainSelectedInstOperands,
     /* 211894 */     // GIR_Coverage, 2686,
     /* 211894 */     GIR_EraseRootFromParent_Done,
     /* 211895 */   // Label 4175: @211895
     /* 211895 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211937), // Rule ID 2687 //
     /* 211900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 211920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 211924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 211927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211935 */     GIR_RootConstrainSelectedInstOperands,
     /* 211936 */     // GIR_Coverage, 2687,
     /* 211936 */     GIR_EraseRootFromParent_Done,
     /* 211937 */   // Label 4176: @211937
     /* 211937 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211979), // Rule ID 2688 //
     /* 211942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 211962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 211966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 211969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211977 */     GIR_RootConstrainSelectedInstOperands,
     /* 211978 */     // GIR_Coverage, 2688,
     /* 211978 */     GIR_EraseRootFromParent_Done,
     /* 211979 */   // Label 4177: @211979
     /* 211979 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(212021), // Rule ID 2689 //
     /* 211984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212008 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1824:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 212011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212019 */     GIR_RootConstrainSelectedInstOperands,
     /* 212020 */     // GIR_Coverage, 2689,
     /* 212020 */     GIR_EraseRootFromParent_Done,
     /* 212021 */   // Label 4178: @212021
     /* 212021 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(212063), // Rule ID 2690 //
     /* 212026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1824:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 212053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212061 */     GIR_RootConstrainSelectedInstOperands,
     /* 212062 */     // GIR_Coverage, 2690,
     /* 212062 */     GIR_EraseRootFromParent_Done,
     /* 212063 */   // Label 4179: @212063
     /* 212063 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(212105), // Rule ID 2691 //
     /* 212068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212092 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1824:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 212095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212103 */     GIR_RootConstrainSelectedInstOperands,
     /* 212104 */     // GIR_Coverage, 2691,
     /* 212104 */     GIR_EraseRootFromParent_Done,
     /* 212105 */   // Label 4180: @212105
     /* 212105 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(212147), // Rule ID 2730 //
     /* 212110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 212130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212134 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1170:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 212134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212145 */     GIR_RootConstrainSelectedInstOperands,
     /* 212146 */     // GIR_Coverage, 2730,
     /* 212146 */     GIR_EraseRootFromParent_Done,
     /* 212147 */   // Label 4181: @212147
     /* 212147 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(212189), // Rule ID 2731 //
     /* 212152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 212172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1170:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 212176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212187 */     GIR_RootConstrainSelectedInstOperands,
     /* 212188 */     // GIR_Coverage, 2731,
     /* 212188 */     GIR_EraseRootFromParent_Done,
     /* 212189 */   // Label 4182: @212189
     /* 212189 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(212231), // Rule ID 2732 //
     /* 212194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 212214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1170:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 212218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212229 */     GIR_RootConstrainSelectedInstOperands,
     /* 212230 */     // GIR_Coverage, 2732,
     /* 212230 */     GIR_EraseRootFromParent_Done,
     /* 212231 */   // Label 4183: @212231
     /* 212231 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212273), // Rule ID 2733 //
     /* 212236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 212256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212260 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1170:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 212260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212271 */     GIR_RootConstrainSelectedInstOperands,
     /* 212272 */     // GIR_Coverage, 2733,
     /* 212272 */     GIR_EraseRootFromParent_Done,
     /* 212273 */   // Label 4184: @212273
     /* 212273 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212315), // Rule ID 2734 //
     /* 212278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 212289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 212292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 212295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 212298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1170:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 212302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212313 */     GIR_RootConstrainSelectedInstOperands,
     /* 212314 */     // GIR_Coverage, 2734,
     /* 212314 */     GIR_EraseRootFromParent_Done,
     /* 212315 */   // Label 4185: @212315
     /* 212315 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212357), // Rule ID 2773 //
     /* 212320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212344 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 212347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212355 */     GIR_RootConstrainSelectedInstOperands,
     /* 212356 */     // GIR_Coverage, 2773,
     /* 212356 */     GIR_EraseRootFromParent_Done,
     /* 212357 */   // Label 4186: @212357
     /* 212357 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212399), // Rule ID 2775 //
     /* 212362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212386 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 212389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212397 */     GIR_RootConstrainSelectedInstOperands,
     /* 212398 */     // GIR_Coverage, 2775,
     /* 212398 */     GIR_EraseRootFromParent_Done,
     /* 212399 */   // Label 4187: @212399
     /* 212399 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212441), // Rule ID 2777 //
     /* 212404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212428 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 212431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212439 */     GIR_RootConstrainSelectedInstOperands,
     /* 212440 */     // GIR_Coverage, 2777,
     /* 212440 */     GIR_EraseRootFromParent_Done,
     /* 212441 */   // Label 4188: @212441
     /* 212441 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212483), // Rule ID 2779 //
     /* 212446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212470 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 212473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212481 */     GIR_RootConstrainSelectedInstOperands,
     /* 212482 */     // GIR_Coverage, 2779,
     /* 212482 */     GIR_EraseRootFromParent_Done,
     /* 212483 */   // Label 4189: @212483
     /* 212483 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212525), // Rule ID 2780 //
     /* 212488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212512 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 212515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212523 */     GIR_RootConstrainSelectedInstOperands,
     /* 212524 */     // GIR_Coverage, 2780,
     /* 212524 */     GIR_EraseRootFromParent_Done,
     /* 212525 */   // Label 4190: @212525
     /* 212525 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212567), // Rule ID 2781 //
     /* 212530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212554 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 212557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212565 */     GIR_RootConstrainSelectedInstOperands,
     /* 212566 */     // GIR_Coverage, 2781,
     /* 212566 */     GIR_EraseRootFromParent_Done,
     /* 212567 */   // Label 4191: @212567
     /* 212567 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212609), // Rule ID 2850 //
     /* 212572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 212580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212596 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 212599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212607 */     GIR_RootConstrainSelectedInstOperands,
     /* 212608 */     // GIR_Coverage, 2850,
     /* 212608 */     GIR_EraseRootFromParent_Done,
     /* 212609 */   // Label 4192: @212609
     /* 212609 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212651), // Rule ID 2851 //
     /* 212614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 212622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212638 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 212641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212649 */     GIR_RootConstrainSelectedInstOperands,
     /* 212650 */     // GIR_Coverage, 2851,
     /* 212650 */     GIR_EraseRootFromParent_Done,
     /* 212651 */   // Label 4193: @212651
     /* 212651 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212693), // Rule ID 2852 //
     /* 212656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 212664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1301:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 212683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212691 */     GIR_RootConstrainSelectedInstOperands,
     /* 212692 */     // GIR_Coverage, 2852,
     /* 212692 */     GIR_EraseRootFromParent_Done,
     /* 212693 */   // Label 4194: @212693
     /* 212693 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212735), // Rule ID 2853 //
     /* 212698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 212706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1302:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 212725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212733 */     GIR_RootConstrainSelectedInstOperands,
     /* 212734 */     // GIR_Coverage, 2853,
     /* 212734 */     GIR_EraseRootFromParent_Done,
     /* 212735 */   // Label 4195: @212735
     /* 212735 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212777), // Rule ID 2854 //
     /* 212740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 212748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 212767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212775 */     GIR_RootConstrainSelectedInstOperands,
     /* 212776 */     // GIR_Coverage, 2854,
     /* 212776 */     GIR_EraseRootFromParent_Done,
     /* 212777 */   // Label 4196: @212777
     /* 212777 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212819), // Rule ID 2855 //
     /* 212782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 212790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212806 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 212809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212817 */     GIR_RootConstrainSelectedInstOperands,
     /* 212818 */     // GIR_Coverage, 2855,
     /* 212818 */     GIR_EraseRootFromParent_Done,
     /* 212819 */   // Label 4197: @212819
     /* 212819 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212861), // Rule ID 2856 //
     /* 212824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 212832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212848 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 212851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212859 */     GIR_RootConstrainSelectedInstOperands,
     /* 212860 */     // GIR_Coverage, 2856,
     /* 212860 */     GIR_EraseRootFromParent_Done,
     /* 212861 */   // Label 4198: @212861
     /* 212861 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212903), // Rule ID 2857 //
     /* 212866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 212874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212890 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 212893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212901 */     GIR_RootConstrainSelectedInstOperands,
     /* 212902 */     // GIR_Coverage, 2857,
     /* 212902 */     GIR_EraseRootFromParent_Done,
     /* 212903 */   // Label 4199: @212903
     /* 212903 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212945), // Rule ID 2868 //
     /* 212908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 212916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212932 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 212935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212943 */     GIR_RootConstrainSelectedInstOperands,
     /* 212944 */     // GIR_Coverage, 2868,
     /* 212944 */     GIR_EraseRootFromParent_Done,
     /* 212945 */   // Label 4200: @212945
     /* 212945 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212987), // Rule ID 2870 //
     /* 212950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 212958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212974 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 212977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212985 */     GIR_RootConstrainSelectedInstOperands,
     /* 212986 */     // GIR_Coverage, 2870,
     /* 212986 */     GIR_EraseRootFromParent_Done,
     /* 212987 */   // Label 4201: @212987
     /* 212987 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213029), // Rule ID 2878 //
     /* 212992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1329:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 213016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 213019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213027 */     GIR_RootConstrainSelectedInstOperands,
     /* 213028 */     // GIR_Coverage, 2878,
     /* 213028 */     GIR_EraseRootFromParent_Done,
     /* 213029 */   // Label 4202: @213029
     /* 213029 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213071), // Rule ID 2879 //
     /* 213034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1329:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 213061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213069 */     GIR_RootConstrainSelectedInstOperands,
     /* 213070 */     // GIR_Coverage, 2879,
     /* 213070 */     GIR_EraseRootFromParent_Done,
     /* 213071 */   // Label 4203: @213071
     /* 213071 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213113), // Rule ID 2880 //
     /* 213076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1329:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 213103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213111 */     GIR_RootConstrainSelectedInstOperands,
     /* 213112 */     // GIR_Coverage, 2880,
     /* 213112 */     GIR_EraseRootFromParent_Done,
     /* 213113 */   // Label 4204: @213113
     /* 213113 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213155), // Rule ID 2884 //
     /* 213118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 213126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213142 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1307:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 213145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213153 */     GIR_RootConstrainSelectedInstOperands,
     /* 213154 */     // GIR_Coverage, 2884,
     /* 213154 */     GIR_EraseRootFromParent_Done,
     /* 213155 */   // Label 4205: @213155
     /* 213155 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213197), // Rule ID 2929 //
     /* 213160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 213168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 213187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213195 */     GIR_RootConstrainSelectedInstOperands,
     /* 213196 */     // GIR_Coverage, 2929,
     /* 213196 */     GIR_EraseRootFromParent_Done,
     /* 213197 */   // Label 4206: @213197
     /* 213197 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213239), // Rule ID 2930 //
     /* 213202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 213210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 213229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213237 */     GIR_RootConstrainSelectedInstOperands,
     /* 213238 */     // GIR_Coverage, 2930,
     /* 213238 */     GIR_EraseRootFromParent_Done,
     /* 213239 */   // Label 4207: @213239
     /* 213239 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213281), // Rule ID 2959 //
     /* 213244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 213271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213279 */     GIR_RootConstrainSelectedInstOperands,
     /* 213280 */     // GIR_Coverage, 2959,
     /* 213280 */     GIR_EraseRootFromParent_Done,
     /* 213281 */   // Label 4208: @213281
     /* 213281 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213323), // Rule ID 2960 //
     /* 213286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 213313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213321 */     GIR_RootConstrainSelectedInstOperands,
     /* 213322 */     // GIR_Coverage, 2960,
     /* 213322 */     GIR_EraseRootFromParent_Done,
     /* 213323 */   // Label 4209: @213323
     /* 213323 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213365), // Rule ID 2961 //
     /* 213328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 213355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213363 */     GIR_RootConstrainSelectedInstOperands,
     /* 213364 */     // GIR_Coverage, 2961,
     /* 213364 */     GIR_EraseRootFromParent_Done,
     /* 213365 */   // Label 4210: @213365
     /* 213365 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213407), // Rule ID 2962 //
     /* 213370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 213397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213405 */     GIR_RootConstrainSelectedInstOperands,
     /* 213406 */     // GIR_Coverage, 2962,
     /* 213406 */     GIR_EraseRootFromParent_Done,
     /* 213407 */   // Label 4211: @213407
     /* 213407 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213449), // Rule ID 2963 //
     /* 213412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 213439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213447 */     GIR_RootConstrainSelectedInstOperands,
     /* 213448 */     // GIR_Coverage, 2963,
     /* 213448 */     GIR_EraseRootFromParent_Done,
     /* 213449 */   // Label 4212: @213449
     /* 213449 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213491), // Rule ID 2964 //
     /* 213454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 213481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213489 */     GIR_RootConstrainSelectedInstOperands,
     /* 213490 */     // GIR_Coverage, 2964,
     /* 213490 */     GIR_EraseRootFromParent_Done,
     /* 213491 */   // Label 4213: @213491
     /* 213491 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213533), // Rule ID 2965 //
     /* 213496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213520 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1649:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 213523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213531 */     GIR_RootConstrainSelectedInstOperands,
     /* 213532 */     // GIR_Coverage, 2965,
     /* 213532 */     GIR_EraseRootFromParent_Done,
     /* 213533 */   // Label 4214: @213533
     /* 213533 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213575), // Rule ID 2995 //
     /* 213538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 213565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213573 */     GIR_RootConstrainSelectedInstOperands,
     /* 213574 */     // GIR_Coverage, 2995,
     /* 213574 */     GIR_EraseRootFromParent_Done,
     /* 213575 */   // Label 4215: @213575
     /* 213575 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213617), // Rule ID 2997 //
     /* 213580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 213607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213615 */     GIR_RootConstrainSelectedInstOperands,
     /* 213616 */     // GIR_Coverage, 2997,
     /* 213616 */     GIR_EraseRootFromParent_Done,
     /* 213617 */   // Label 4216: @213617
     /* 213617 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213659), // Rule ID 2999 //
     /* 213622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 213649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213657 */     GIR_RootConstrainSelectedInstOperands,
     /* 213658 */     // GIR_Coverage, 2999,
     /* 213658 */     GIR_EraseRootFromParent_Done,
     /* 213659 */   // Label 4217: @213659
     /* 213659 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213701), // Rule ID 3001 //
     /* 213664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 213691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213699 */     GIR_RootConstrainSelectedInstOperands,
     /* 213700 */     // GIR_Coverage, 3001,
     /* 213700 */     GIR_EraseRootFromParent_Done,
     /* 213701 */   // Label 4218: @213701
     /* 213701 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213743), // Rule ID 3003 //
     /* 213706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 213714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 213733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213741 */     GIR_RootConstrainSelectedInstOperands,
     /* 213742 */     // GIR_Coverage, 3003,
     /* 213742 */     GIR_EraseRootFromParent_Done,
     /* 213743 */   // Label 4219: @213743
     /* 213743 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213785), // Rule ID 3004 //
     /* 213748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 213756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 213775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213783 */     GIR_RootConstrainSelectedInstOperands,
     /* 213784 */     // GIR_Coverage, 3004,
     /* 213784 */     GIR_EraseRootFromParent_Done,
     /* 213785 */   // Label 4220: @213785
     /* 213785 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213827), // Rule ID 3005 //
     /* 213790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 213798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 213817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213825 */     GIR_RootConstrainSelectedInstOperands,
     /* 213826 */     // GIR_Coverage, 3005,
     /* 213826 */     GIR_EraseRootFromParent_Done,
     /* 213827 */   // Label 4221: @213827
     /* 213827 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213869), // Rule ID 3006 //
     /* 213832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 213840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 213859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213867 */     GIR_RootConstrainSelectedInstOperands,
     /* 213868 */     // GIR_Coverage, 3006,
     /* 213868 */     GIR_EraseRootFromParent_Done,
     /* 213869 */   // Label 4222: @213869
     /* 213869 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(213911), // Rule ID 3007 //
     /* 213874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 213901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213909 */     GIR_RootConstrainSelectedInstOperands,
     /* 213910 */     // GIR_Coverage, 3007,
     /* 213910 */     GIR_EraseRootFromParent_Done,
     /* 213911 */   // Label 4223: @213911
     /* 213911 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(213953), // Rule ID 3008 //
     /* 213916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 213943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213951 */     GIR_RootConstrainSelectedInstOperands,
     /* 213952 */     // GIR_Coverage, 3008,
     /* 213952 */     GIR_EraseRootFromParent_Done,
     /* 213953 */   // Label 4224: @213953
     /* 213953 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(213995), // Rule ID 3009 //
     /* 213958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 213985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213993 */     GIR_RootConstrainSelectedInstOperands,
     /* 213994 */     // GIR_Coverage, 3009,
     /* 213994 */     GIR_EraseRootFromParent_Done,
     /* 213995 */   // Label 4225: @213995
     /* 213995 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214037), // Rule ID 3010 //
     /* 214000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 214027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214035 */     GIR_RootConstrainSelectedInstOperands,
     /* 214036 */     // GIR_Coverage, 3010,
     /* 214036 */     GIR_EraseRootFromParent_Done,
     /* 214037 */   // Label 4226: @214037
     /* 214037 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214079), // Rule ID 3027 //
     /* 214042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 214069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214077 */     GIR_RootConstrainSelectedInstOperands,
     /* 214078 */     // GIR_Coverage, 3027,
     /* 214078 */     GIR_EraseRootFromParent_Done,
     /* 214079 */   // Label 4227: @214079
     /* 214079 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214121), // Rule ID 3028 //
     /* 214084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 214111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214119 */     GIR_RootConstrainSelectedInstOperands,
     /* 214120 */     // GIR_Coverage, 3028,
     /* 214120 */     GIR_EraseRootFromParent_Done,
     /* 214121 */   // Label 4228: @214121
     /* 214121 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214163), // Rule ID 3029 //
     /* 214126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 214153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214161 */     GIR_RootConstrainSelectedInstOperands,
     /* 214162 */     // GIR_Coverage, 3029,
     /* 214162 */     GIR_EraseRootFromParent_Done,
     /* 214163 */   // Label 4229: @214163
     /* 214163 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214205), // Rule ID 3030 //
     /* 214168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 214195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214203 */     GIR_RootConstrainSelectedInstOperands,
     /* 214204 */     // GIR_Coverage, 3030,
     /* 214204 */     GIR_EraseRootFromParent_Done,
     /* 214205 */   // Label 4230: @214205
     /* 214205 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214247), // Rule ID 3054 //
     /* 214210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1586:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 214237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214245 */     GIR_RootConstrainSelectedInstOperands,
     /* 214246 */     // GIR_Coverage, 3054,
     /* 214246 */     GIR_EraseRootFromParent_Done,
     /* 214247 */   // Label 4231: @214247
     /* 214247 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214289), // Rule ID 3056 //
     /* 214252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1586:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 214279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214287 */     GIR_RootConstrainSelectedInstOperands,
     /* 214288 */     // GIR_Coverage, 3056,
     /* 214288 */     GIR_EraseRootFromParent_Done,
     /* 214289 */   // Label 4232: @214289
     /* 214289 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214331), // Rule ID 3058 //
     /* 214294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1586:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 214321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214329 */     GIR_RootConstrainSelectedInstOperands,
     /* 214330 */     // GIR_Coverage, 3058,
     /* 214330 */     GIR_EraseRootFromParent_Done,
     /* 214331 */   // Label 4233: @214331
     /* 214331 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214373), // Rule ID 3060 //
     /* 214336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1586:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 214363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214371 */     GIR_RootConstrainSelectedInstOperands,
     /* 214372 */     // GIR_Coverage, 3060,
     /* 214372 */     GIR_EraseRootFromParent_Done,
     /* 214373 */   // Label 4234: @214373
     /* 214373 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214415), // Rule ID 3062 //
     /* 214378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 214405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214413 */     GIR_RootConstrainSelectedInstOperands,
     /* 214414 */     // GIR_Coverage, 3062,
     /* 214414 */     GIR_EraseRootFromParent_Done,
     /* 214415 */   // Label 4235: @214415
     /* 214415 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214457), // Rule ID 3063 //
     /* 214420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 214447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214455 */     GIR_RootConstrainSelectedInstOperands,
     /* 214456 */     // GIR_Coverage, 3063,
     /* 214456 */     GIR_EraseRootFromParent_Done,
     /* 214457 */   // Label 4236: @214457
     /* 214457 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214499), // Rule ID 3064 //
     /* 214462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 214489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214497 */     GIR_RootConstrainSelectedInstOperands,
     /* 214498 */     // GIR_Coverage, 3064,
     /* 214498 */     GIR_EraseRootFromParent_Done,
     /* 214499 */   // Label 4237: @214499
     /* 214499 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(214541), // Rule ID 3065 //
     /* 214504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 214512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1150:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 214531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214539 */     GIR_RootConstrainSelectedInstOperands,
     /* 214540 */     // GIR_Coverage, 3065,
     /* 214540 */     GIR_EraseRootFromParent_Done,
     /* 214541 */   // Label 4238: @214541
     /* 214541 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(214583), // Rule ID 3066 //
     /* 214546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 214554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1150:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 214573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214581 */     GIR_RootConstrainSelectedInstOperands,
     /* 214582 */     // GIR_Coverage, 3066,
     /* 214582 */     GIR_EraseRootFromParent_Done,
     /* 214583 */   // Label 4239: @214583
     /* 214583 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(214625), // Rule ID 3076 //
     /* 214588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 214596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 214615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214623 */     GIR_RootConstrainSelectedInstOperands,
     /* 214624 */     // GIR_Coverage, 3076,
     /* 214624 */     GIR_EraseRootFromParent_Done,
     /* 214625 */   // Label 4240: @214625
     /* 214625 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(214667), // Rule ID 3077 //
     /* 214630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 214638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 214657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214665 */     GIR_RootConstrainSelectedInstOperands,
     /* 214666 */     // GIR_Coverage, 3077,
     /* 214666 */     GIR_EraseRootFromParent_Done,
     /* 214667 */   // Label 4241: @214667
     /* 214667 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(214709), // Rule ID 3078 //
     /* 214672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 214680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 214699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214707 */     GIR_RootConstrainSelectedInstOperands,
     /* 214708 */     // GIR_Coverage, 3078,
     /* 214708 */     GIR_EraseRootFromParent_Done,
     /* 214709 */   // Label 4242: @214709
     /* 214709 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(214751), // Rule ID 3095 //
     /* 214714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214738 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 214741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214749 */     GIR_RootConstrainSelectedInstOperands,
     /* 214750 */     // GIR_Coverage, 3095,
     /* 214750 */     GIR_EraseRootFromParent_Done,
     /* 214751 */   // Label 4243: @214751
     /* 214751 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(214793), // Rule ID 3096 //
     /* 214756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 214783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214791 */     GIR_RootConstrainSelectedInstOperands,
     /* 214792 */     // GIR_Coverage, 3096,
     /* 214792 */     GIR_EraseRootFromParent_Done,
     /* 214793 */   // Label 4244: @214793
     /* 214793 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(214835), // Rule ID 3097 //
     /* 214798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 214825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214833 */     GIR_RootConstrainSelectedInstOperands,
     /* 214834 */     // GIR_Coverage, 3097,
     /* 214834 */     GIR_EraseRootFromParent_Done,
     /* 214835 */   // Label 4245: @214835
     /* 214835 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(214877), // Rule ID 3098 //
     /* 214840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 214867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214875 */     GIR_RootConstrainSelectedInstOperands,
     /* 214876 */     // GIR_Coverage, 3098,
     /* 214876 */     GIR_EraseRootFromParent_Done,
     /* 214877 */   // Label 4246: @214877
     /* 214877 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(214919), // Rule ID 3133 //
     /* 214882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 214890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 214909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214917 */     GIR_RootConstrainSelectedInstOperands,
     /* 214918 */     // GIR_Coverage, 3133,
     /* 214918 */     GIR_EraseRootFromParent_Done,
     /* 214919 */   // Label 4247: @214919
     /* 214919 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(214961), // Rule ID 3135 //
     /* 214924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 214932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 214951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214959 */     GIR_RootConstrainSelectedInstOperands,
     /* 214960 */     // GIR_Coverage, 3135,
     /* 214960 */     GIR_EraseRootFromParent_Done,
     /* 214961 */   // Label 4248: @214961
     /* 214961 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215003), // Rule ID 3137 //
     /* 214966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 214974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 214993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215001 */     GIR_RootConstrainSelectedInstOperands,
     /* 215002 */     // GIR_Coverage, 3137,
     /* 215002 */     GIR_EraseRootFromParent_Done,
     /* 215003 */   // Label 4249: @215003
     /* 215003 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215045), // Rule ID 3139 //
     /* 215008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 215016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215043 */     GIR_RootConstrainSelectedInstOperands,
     /* 215044 */     // GIR_Coverage, 3139,
     /* 215044 */     GIR_EraseRootFromParent_Done,
     /* 215045 */   // Label 4250: @215045
     /* 215045 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215090), // Rule ID 3172 //
     /* 215050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1221:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 215077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215088 */     GIR_RootConstrainSelectedInstOperands,
     /* 215089 */     // GIR_Coverage, 3172,
     /* 215089 */     GIR_EraseRootFromParent_Done,
     /* 215090 */   // Label 4251: @215090
     /* 215090 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215135), // Rule ID 3173 //
     /* 215095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215119 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1221:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 215122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215133 */     GIR_RootConstrainSelectedInstOperands,
     /* 215134 */     // GIR_Coverage, 3173,
     /* 215134 */     GIR_EraseRootFromParent_Done,
     /* 215135 */   // Label 4252: @215135
     /* 215135 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215180), // Rule ID 3174 //
     /* 215140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1221:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 215167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215178 */     GIR_RootConstrainSelectedInstOperands,
     /* 215179 */     // GIR_Coverage, 3174,
     /* 215179 */     GIR_EraseRootFromParent_Done,
     /* 215180 */   // Label 4253: @215180
     /* 215180 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215225), // Rule ID 3175 //
     /* 215185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215209 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1223:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 215212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215223 */     GIR_RootConstrainSelectedInstOperands,
     /* 215224 */     // GIR_Coverage, 3175,
     /* 215224 */     GIR_EraseRootFromParent_Done,
     /* 215225 */   // Label 4254: @215225
     /* 215225 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215270), // Rule ID 3176 //
     /* 215230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1223:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 215257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215268 */     GIR_RootConstrainSelectedInstOperands,
     /* 215269 */     // GIR_Coverage, 3176,
     /* 215269 */     GIR_EraseRootFromParent_Done,
     /* 215270 */   // Label 4255: @215270
     /* 215270 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(215315), // Rule ID 3177 //
     /* 215275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215299 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1223:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 215302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215313 */     GIR_RootConstrainSelectedInstOperands,
     /* 215314 */     // GIR_Coverage, 3177,
     /* 215314 */     GIR_EraseRootFromParent_Done,
     /* 215315 */   // Label 4256: @215315
     /* 215315 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(215357), // Rule ID 3232 //
     /* 215320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 215347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215355 */     GIR_RootConstrainSelectedInstOperands,
     /* 215356 */     // GIR_Coverage, 3232,
     /* 215356 */     GIR_EraseRootFromParent_Done,
     /* 215357 */   // Label 4257: @215357
     /* 215357 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(215399), // Rule ID 3233 //
     /* 215362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215386 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 215389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215397 */     GIR_RootConstrainSelectedInstOperands,
     /* 215398 */     // GIR_Coverage, 3233,
     /* 215398 */     GIR_EraseRootFromParent_Done,
     /* 215399 */   // Label 4258: @215399
     /* 215399 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(215441), // Rule ID 3234 //
     /* 215404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 215431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215439 */     GIR_RootConstrainSelectedInstOperands,
     /* 215440 */     // GIR_Coverage, 3234,
     /* 215440 */     GIR_EraseRootFromParent_Done,
     /* 215441 */   // Label 4259: @215441
     /* 215441 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(215483), // Rule ID 3286 //
     /* 215446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1173:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 215473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215481 */     GIR_RootConstrainSelectedInstOperands,
     /* 215482 */     // GIR_Coverage, 3286,
     /* 215482 */     GIR_EraseRootFromParent_Done,
     /* 215483 */   // Label 4260: @215483
     /* 215483 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(215525), // Rule ID 3287 //
     /* 215488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1173:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 215515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215523 */     GIR_RootConstrainSelectedInstOperands,
     /* 215524 */     // GIR_Coverage, 3287,
     /* 215524 */     GIR_EraseRootFromParent_Done,
     /* 215525 */   // Label 4261: @215525
     /* 215525 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(215567), // Rule ID 3288 //
     /* 215530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1173:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 215557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215565 */     GIR_RootConstrainSelectedInstOperands,
     /* 215566 */     // GIR_Coverage, 3288,
     /* 215566 */     GIR_EraseRootFromParent_Done,
     /* 215567 */   // Label 4262: @215567
     /* 215567 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(215609), // Rule ID 3289 //
     /* 215572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1173:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 215599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215607 */     GIR_RootConstrainSelectedInstOperands,
     /* 215608 */     // GIR_Coverage, 3289,
     /* 215608 */     GIR_EraseRootFromParent_Done,
     /* 215609 */   // Label 4263: @215609
     /* 215609 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(215651), // Rule ID 3298 //
     /* 215614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 215622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1175:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 215641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215649 */     GIR_RootConstrainSelectedInstOperands,
     /* 215650 */     // GIR_Coverage, 3298,
     /* 215650 */     GIR_EraseRootFromParent_Done,
     /* 215651 */   // Label 4264: @215651
     /* 215651 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(215693), // Rule ID 3299 //
     /* 215656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 215664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1175:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 215683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215691 */     GIR_RootConstrainSelectedInstOperands,
     /* 215692 */     // GIR_Coverage, 3299,
     /* 215692 */     GIR_EraseRootFromParent_Done,
     /* 215693 */   // Label 4265: @215693
     /* 215693 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(215735), // Rule ID 3300 //
     /* 215698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 215706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1175:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 215725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215733 */     GIR_RootConstrainSelectedInstOperands,
     /* 215734 */     // GIR_Coverage, 3300,
     /* 215734 */     GIR_EraseRootFromParent_Done,
     /* 215735 */   // Label 4266: @215735
     /* 215735 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(215777), // Rule ID 3339 //
     /* 215740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1212:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 215767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215775 */     GIR_RootConstrainSelectedInstOperands,
     /* 215776 */     // GIR_Coverage, 3339,
     /* 215776 */     GIR_EraseRootFromParent_Done,
     /* 215777 */   // Label 4267: @215777
     /* 215777 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(215819), // Rule ID 3340 //
     /* 215782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 215809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215817 */     GIR_RootConstrainSelectedInstOperands,
     /* 215818 */     // GIR_Coverage, 3340,
     /* 215818 */     GIR_EraseRootFromParent_Done,
     /* 215819 */   // Label 4268: @215819
     /* 215819 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(215861), // Rule ID 3341 //
     /* 215824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 215851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215859 */     GIR_RootConstrainSelectedInstOperands,
     /* 215860 */     // GIR_Coverage, 3341,
     /* 215860 */     GIR_EraseRootFromParent_Done,
     /* 215861 */   // Label 4269: @215861
     /* 215861 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(215903), // Rule ID 3342 //
     /* 215866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 215893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215901 */     GIR_RootConstrainSelectedInstOperands,
     /* 215902 */     // GIR_Coverage, 3342,
     /* 215902 */     GIR_EraseRootFromParent_Done,
     /* 215903 */   // Label 4270: @215903
     /* 215903 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(215945), // Rule ID 3343 //
     /* 215908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 215935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215943 */     GIR_RootConstrainSelectedInstOperands,
     /* 215944 */     // GIR_Coverage, 3343,
     /* 215944 */     GIR_EraseRootFromParent_Done,
     /* 215945 */   // Label 4271: @215945
     /* 215945 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(215987), // Rule ID 3344 //
     /* 215950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215974 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 215977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215985 */     GIR_RootConstrainSelectedInstOperands,
     /* 215986 */     // GIR_Coverage, 3344,
     /* 215986 */     GIR_EraseRootFromParent_Done,
     /* 215987 */   // Label 4272: @215987
     /* 215987 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(216029), // Rule ID 3345 //
     /* 215992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 216016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 216019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216027 */     GIR_RootConstrainSelectedInstOperands,
     /* 216028 */     // GIR_Coverage, 3345,
     /* 216028 */     GIR_EraseRootFromParent_Done,
     /* 216029 */   // Label 4273: @216029
     /* 216029 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(216071), // Rule ID 3428 //
     /* 216034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 216042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1204:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 216061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216069 */     GIR_RootConstrainSelectedInstOperands,
     /* 216070 */     // GIR_Coverage, 3428,
     /* 216070 */     GIR_EraseRootFromParent_Done,
     /* 216071 */   // Label 4274: @216071
     /* 216071 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(216113), // Rule ID 3429 //
     /* 216076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 216084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1203:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 216103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 216105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216111 */     GIR_RootConstrainSelectedInstOperands,
     /* 216112 */     // GIR_Coverage, 3429,
     /* 216112 */     GIR_EraseRootFromParent_Done,
     /* 216113 */   // Label 4275: @216113
     /* 216113 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(216155), // Rule ID 3430 //
     /* 216118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 216126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1199:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 216145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216153 */     GIR_RootConstrainSelectedInstOperands,
     /* 216154 */     // GIR_Coverage, 3430,
     /* 216154 */     GIR_EraseRootFromParent_Done,
     /* 216155 */   // Label 4276: @216155
     /* 216155 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(216200), // Rule ID 3432 //
     /* 216160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 216168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1506:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 216187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 216198 */     GIR_RootConstrainSelectedInstOperands,
     /* 216199 */     // GIR_Coverage, 3432,
     /* 216199 */     GIR_EraseRootFromParent_Done,
     /* 216200 */   // Label 4277: @216200
     /* 216200 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(216245), // Rule ID 3433 //
     /* 216205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 216213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 216216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216229 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1506:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 216232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 216243 */     GIR_RootConstrainSelectedInstOperands,
     /* 216244 */     // GIR_Coverage, 3433,
     /* 216244 */     GIR_EraseRootFromParent_Done,
     /* 216245 */   // Label 4278: @216245
     /* 216245 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(216287), // Rule ID 3434 //
     /* 216250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 216258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 216277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216285 */     GIR_RootConstrainSelectedInstOperands,
     /* 216286 */     // GIR_Coverage, 3434,
     /* 216286 */     GIR_EraseRootFromParent_Done,
     /* 216287 */   // Label 4279: @216287
     /* 216287 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(216329), // Rule ID 3435 //
     /* 216292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 216300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 216319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216327 */     GIR_RootConstrainSelectedInstOperands,
     /* 216328 */     // GIR_Coverage, 3435,
     /* 216328 */     GIR_EraseRootFromParent_Done,
     /* 216329 */   // Label 4280: @216329
     /* 216329 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(216371), // Rule ID 3440 //
     /* 216334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 216337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 216342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1657:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 216361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216369 */     GIR_RootConstrainSelectedInstOperands,
     /* 216370 */     // GIR_Coverage, 3440,
     /* 216370 */     GIR_EraseRootFromParent_Done,
     /* 216371 */   // Label 4281: @216371
     /* 216371 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(216413), // Rule ID 3479 //
     /* 216376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1280:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 216400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 216403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216411 */     GIR_RootConstrainSelectedInstOperands,
     /* 216412 */     // GIR_Coverage, 3479,
     /* 216412 */     GIR_EraseRootFromParent_Done,
     /* 216413 */   // Label 4282: @216413
     /* 216413 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(216455), // Rule ID 3481 //
     /* 216418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216442 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1280:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 216442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 216445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216453 */     GIR_RootConstrainSelectedInstOperands,
     /* 216454 */     // GIR_Coverage, 3481,
     /* 216454 */     GIR_EraseRootFromParent_Done,
     /* 216455 */   // Label 4283: @216455
     /* 216455 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(216497), // Rule ID 3483 //
     /* 216460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1280:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 216484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 216487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216495 */     GIR_RootConstrainSelectedInstOperands,
     /* 216496 */     // GIR_Coverage, 3483,
     /* 216496 */     GIR_EraseRootFromParent_Done,
     /* 216497 */   // Label 4284: @216497
     /* 216497 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(216539), // Rule ID 3485 //
     /* 216502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 216510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 216529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216537 */     GIR_RootConstrainSelectedInstOperands,
     /* 216538 */     // GIR_Coverage, 3485,
     /* 216538 */     GIR_EraseRootFromParent_Done,
     /* 216539 */   // Label 4285: @216539
     /* 216539 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(216581), // Rule ID 3600 //
     /* 216544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216568 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 216571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216579 */     GIR_RootConstrainSelectedInstOperands,
     /* 216580 */     // GIR_Coverage, 3600,
     /* 216580 */     GIR_EraseRootFromParent_Done,
     /* 216581 */   // Label 4286: @216581
     /* 216581 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(216623), // Rule ID 3602 //
     /* 216586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216610 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 216613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216621 */     GIR_RootConstrainSelectedInstOperands,
     /* 216622 */     // GIR_Coverage, 3602,
     /* 216622 */     GIR_EraseRootFromParent_Done,
     /* 216623 */   // Label 4287: @216623
     /* 216623 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(216665), // Rule ID 3604 //
     /* 216628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 216655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216663 */     GIR_RootConstrainSelectedInstOperands,
     /* 216664 */     // GIR_Coverage, 3604,
     /* 216664 */     GIR_EraseRootFromParent_Done,
     /* 216665 */   // Label 4288: @216665
     /* 216665 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(216707), // Rule ID 3606 //
     /* 216670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 216697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216705 */     GIR_RootConstrainSelectedInstOperands,
     /* 216706 */     // GIR_Coverage, 3606,
     /* 216706 */     GIR_EraseRootFromParent_Done,
     /* 216707 */   // Label 4289: @216707
     /* 216707 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(216749), // Rule ID 7334 //
     /* 216712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216736 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 216739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216747 */     GIR_RootConstrainSelectedInstOperands,
     /* 216748 */     // GIR_Coverage, 7334,
     /* 216748 */     GIR_EraseRootFromParent_Done,
     /* 216749 */   // Label 4290: @216749
     /* 216749 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(216791), // Rule ID 7336 //
     /* 216754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 216781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216789 */     GIR_RootConstrainSelectedInstOperands,
     /* 216790 */     // GIR_Coverage, 7336,
     /* 216790 */     GIR_EraseRootFromParent_Done,
     /* 216791 */   // Label 4291: @216791
     /* 216791 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(216833), // Rule ID 7338 //
     /* 216796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 216823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216831 */     GIR_RootConstrainSelectedInstOperands,
     /* 216832 */     // GIR_Coverage, 7338,
     /* 216832 */     GIR_EraseRootFromParent_Done,
     /* 216833 */   // Label 4292: @216833
     /* 216833 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(216875), // Rule ID 7340 //
     /* 216838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 216865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216873 */     GIR_RootConstrainSelectedInstOperands,
     /* 216874 */     // GIR_Coverage, 7340,
     /* 216874 */     GIR_EraseRootFromParent_Done,
     /* 216875 */   // Label 4293: @216875
     /* 216875 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(216917), // Rule ID 7358 //
     /* 216880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 216888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1196:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 216907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216915 */     GIR_RootConstrainSelectedInstOperands,
     /* 216916 */     // GIR_Coverage, 7358,
     /* 216916 */     GIR_EraseRootFromParent_Done,
     /* 216917 */   // Label 4294: @216917
     /* 216917 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(216959), // Rule ID 7359 //
     /* 216922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 216930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1196:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 216949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216957 */     GIR_RootConstrainSelectedInstOperands,
     /* 216958 */     // GIR_Coverage, 7359,
     /* 216958 */     GIR_EraseRootFromParent_Done,
     /* 216959 */   // Label 4295: @216959
     /* 216959 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(217001), // Rule ID 7360 //
     /* 216964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 216972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1196:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 216991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216999 */     GIR_RootConstrainSelectedInstOperands,
     /* 217000 */     // GIR_Coverage, 7360,
     /* 217000 */     GIR_EraseRootFromParent_Done,
     /* 217001 */   // Label 4296: @217001
     /* 217001 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(217043), // Rule ID 7361 //
     /* 217006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 217014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1196:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 217033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217041 */     GIR_RootConstrainSelectedInstOperands,
     /* 217042 */     // GIR_Coverage, 7361,
     /* 217042 */     GIR_EraseRootFromParent_Done,
     /* 217043 */   // Label 4297: @217043
     /* 217043 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(217085), // Rule ID 7474 //
     /* 217048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1658:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 217075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217083 */     GIR_RootConstrainSelectedInstOperands,
     /* 217084 */     // GIR_Coverage, 7474,
     /* 217084 */     GIR_EraseRootFromParent_Done,
     /* 217085 */   // Label 4298: @217085
     /* 217085 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(217127), // Rule ID 7475 //
     /* 217090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1658:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 217117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217125 */     GIR_RootConstrainSelectedInstOperands,
     /* 217126 */     // GIR_Coverage, 7475,
     /* 217126 */     GIR_EraseRootFromParent_Done,
     /* 217127 */   // Label 4299: @217127
     /* 217127 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(217169), // Rule ID 7476 //
     /* 217132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1658:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 217159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217167 */     GIR_RootConstrainSelectedInstOperands,
     /* 217168 */     // GIR_Coverage, 7476,
     /* 217168 */     GIR_EraseRootFromParent_Done,
     /* 217169 */   // Label 4300: @217169
     /* 217169 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(217211), // Rule ID 7477 //
     /* 217174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1658:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 217201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217209 */     GIR_RootConstrainSelectedInstOperands,
     /* 217210 */     // GIR_Coverage, 7477,
     /* 217210 */     GIR_EraseRootFromParent_Done,
     /* 217211 */   // Label 4301: @217211
     /* 217211 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(217253), // Rule ID 7478 //
     /* 217216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1896:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 217243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217251 */     GIR_RootConstrainSelectedInstOperands,
     /* 217252 */     // GIR_Coverage, 7478,
     /* 217252 */     GIR_EraseRootFromParent_Done,
     /* 217253 */   // Label 4302: @217253
     /* 217253 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(217295), // Rule ID 7479 //
     /* 217258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1896:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 217285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217293 */     GIR_RootConstrainSelectedInstOperands,
     /* 217294 */     // GIR_Coverage, 7479,
     /* 217294 */     GIR_EraseRootFromParent_Done,
     /* 217295 */   // Label 4303: @217295
     /* 217295 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(217337), // Rule ID 7480 //
     /* 217300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1896:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 217327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217335 */     GIR_RootConstrainSelectedInstOperands,
     /* 217336 */     // GIR_Coverage, 7480,
     /* 217336 */     GIR_EraseRootFromParent_Done,
     /* 217337 */   // Label 4304: @217337
     /* 217337 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(217379), // Rule ID 7481 //
     /* 217342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1896:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 217369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217377 */     GIR_RootConstrainSelectedInstOperands,
     /* 217378 */     // GIR_Coverage, 7481,
     /* 217378 */     GIR_EraseRootFromParent_Done,
     /* 217379 */   // Label 4305: @217379
     /* 217379 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(217421), // Rule ID 7490 //
     /* 217384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 217392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 217411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217419 */     GIR_RootConstrainSelectedInstOperands,
     /* 217420 */     // GIR_Coverage, 7490,
     /* 217420 */     GIR_EraseRootFromParent_Done,
     /* 217421 */   // Label 4306: @217421
     /* 217421 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(217463), // Rule ID 7491 //
     /* 217426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 217434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1859:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 217453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217461 */     GIR_RootConstrainSelectedInstOperands,
     /* 217462 */     // GIR_Coverage, 7491,
     /* 217462 */     GIR_EraseRootFromParent_Done,
     /* 217463 */   // Label 4307: @217463
     /* 217463 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(217505), // Rule ID 7492 //
     /* 217468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 217476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 217495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217503 */     GIR_RootConstrainSelectedInstOperands,
     /* 217504 */     // GIR_Coverage, 7492,
     /* 217504 */     GIR_EraseRootFromParent_Done,
     /* 217505 */   // Label 4308: @217505
     /* 217505 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(217547), // Rule ID 7493 //
     /* 217510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 217518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 217537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217545 */     GIR_RootConstrainSelectedInstOperands,
     /* 217546 */     // GIR_Coverage, 7493,
     /* 217546 */     GIR_EraseRootFromParent_Done,
     /* 217547 */   // Label 4309: @217547
     /* 217547 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(217589), // Rule ID 7494 //
     /* 217552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 217560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 217579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217587 */     GIR_RootConstrainSelectedInstOperands,
     /* 217588 */     // GIR_Coverage, 7494,
     /* 217588 */     GIR_EraseRootFromParent_Done,
     /* 217589 */   // Label 4310: @217589
     /* 217589 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(217631), // Rule ID 7495 //
     /* 217594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 217602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 217621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217629 */     GIR_RootConstrainSelectedInstOperands,
     /* 217630 */     // GIR_Coverage, 7495,
     /* 217630 */     GIR_EraseRootFromParent_Done,
     /* 217631 */   // Label 4311: @217631
     /* 217631 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(217673), // Rule ID 7580 //
     /* 217636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 217663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217671 */     GIR_RootConstrainSelectedInstOperands,
     /* 217672 */     // GIR_Coverage, 7580,
     /* 217672 */     GIR_EraseRootFromParent_Done,
     /* 217673 */   // Label 4312: @217673
     /* 217673 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(217715), // Rule ID 7581 //
     /* 217678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 217705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217713 */     GIR_RootConstrainSelectedInstOperands,
     /* 217714 */     // GIR_Coverage, 7581,
     /* 217714 */     GIR_EraseRootFromParent_Done,
     /* 217715 */   // Label 4313: @217715
     /* 217715 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(217757), // Rule ID 7582 //
     /* 217720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 217747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217755 */     GIR_RootConstrainSelectedInstOperands,
     /* 217756 */     // GIR_Coverage, 7582,
     /* 217756 */     GIR_EraseRootFromParent_Done,
     /* 217757 */   // Label 4314: @217757
     /* 217757 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(217799), // Rule ID 7583 //
     /* 217762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 217789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217797 */     GIR_RootConstrainSelectedInstOperands,
     /* 217798 */     // GIR_Coverage, 7583,
     /* 217798 */     GIR_EraseRootFromParent_Done,
     /* 217799 */   // Label 4315: @217799
     /* 217799 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(217841), // Rule ID 7592 //
     /* 217804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 217831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217839 */     GIR_RootConstrainSelectedInstOperands,
     /* 217840 */     // GIR_Coverage, 7592,
     /* 217840 */     GIR_EraseRootFromParent_Done,
     /* 217841 */   // Label 4316: @217841
     /* 217841 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(217883), // Rule ID 7593 //
     /* 217846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 217873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217881 */     GIR_RootConstrainSelectedInstOperands,
     /* 217882 */     // GIR_Coverage, 7593,
     /* 217882 */     GIR_EraseRootFromParent_Done,
     /* 217883 */   // Label 4317: @217883
     /* 217883 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(217925), // Rule ID 7594 //
     /* 217888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 217915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217923 */     GIR_RootConstrainSelectedInstOperands,
     /* 217924 */     // GIR_Coverage, 7594,
     /* 217924 */     GIR_EraseRootFromParent_Done,
     /* 217925 */   // Label 4318: @217925
     /* 217925 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(217967), // Rule ID 7595 //
     /* 217930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 217957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217965 */     GIR_RootConstrainSelectedInstOperands,
     /* 217966 */     // GIR_Coverage, 7595,
     /* 217966 */     GIR_EraseRootFromParent_Done,
     /* 217967 */   // Label 4319: @217967
     /* 217967 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(218009), // Rule ID 7674 //
     /* 217972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 217980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 217999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218007 */     GIR_RootConstrainSelectedInstOperands,
     /* 218008 */     // GIR_Coverage, 7674,
     /* 218008 */     GIR_EraseRootFromParent_Done,
     /* 218009 */   // Label 4320: @218009
     /* 218009 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(218051), // Rule ID 7675 //
     /* 218014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 218041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218049 */     GIR_RootConstrainSelectedInstOperands,
     /* 218050 */     // GIR_Coverage, 7675,
     /* 218050 */     GIR_EraseRootFromParent_Done,
     /* 218051 */   // Label 4321: @218051
     /* 218051 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(218093), // Rule ID 7676 //
     /* 218056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 218083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218091 */     GIR_RootConstrainSelectedInstOperands,
     /* 218092 */     // GIR_Coverage, 7676,
     /* 218092 */     GIR_EraseRootFromParent_Done,
     /* 218093 */   // Label 4322: @218093
     /* 218093 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(218135), // Rule ID 7677 //
     /* 218098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218133 */     GIR_RootConstrainSelectedInstOperands,
     /* 218134 */     // GIR_Coverage, 7677,
     /* 218134 */     GIR_EraseRootFromParent_Done,
     /* 218135 */   // Label 4323: @218135
     /* 218135 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(218177), // Rule ID 7678 //
     /* 218140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 218167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218175 */     GIR_RootConstrainSelectedInstOperands,
     /* 218176 */     // GIR_Coverage, 7678,
     /* 218176 */     GIR_EraseRootFromParent_Done,
     /* 218177 */   // Label 4324: @218177
     /* 218177 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(218219), // Rule ID 7679 //
     /* 218182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 218209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218217 */     GIR_RootConstrainSelectedInstOperands,
     /* 218218 */     // GIR_Coverage, 7679,
     /* 218218 */     GIR_EraseRootFromParent_Done,
     /* 218219 */   // Label 4325: @218219
     /* 218219 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(218261), // Rule ID 7680 //
     /* 218224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 218251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218259 */     GIR_RootConstrainSelectedInstOperands,
     /* 218260 */     // GIR_Coverage, 7680,
     /* 218260 */     GIR_EraseRootFromParent_Done,
     /* 218261 */   // Label 4326: @218261
     /* 218261 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(218303), // Rule ID 7681 //
     /* 218266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1839:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 218293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218301 */     GIR_RootConstrainSelectedInstOperands,
     /* 218302 */     // GIR_Coverage, 7681,
     /* 218302 */     GIR_EraseRootFromParent_Done,
     /* 218303 */   // Label 4327: @218303
     /* 218303 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(218345), // Rule ID 7877 //
     /* 218308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 218335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218343 */     GIR_RootConstrainSelectedInstOperands,
     /* 218344 */     // GIR_Coverage, 7877,
     /* 218344 */     GIR_EraseRootFromParent_Done,
     /* 218345 */   // Label 4328: @218345
     /* 218345 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(218387), // Rule ID 7879 //
     /* 218350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 218377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218385 */     GIR_RootConstrainSelectedInstOperands,
     /* 218386 */     // GIR_Coverage, 7879,
     /* 218386 */     GIR_EraseRootFromParent_Done,
     /* 218387 */   // Label 4329: @218387
     /* 218387 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(218429), // Rule ID 7881 //
     /* 218392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218416 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 218419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218427 */     GIR_RootConstrainSelectedInstOperands,
     /* 218428 */     // GIR_Coverage, 7881,
     /* 218428 */     GIR_EraseRootFromParent_Done,
     /* 218429 */   // Label 4330: @218429
     /* 218429 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(218471), // Rule ID 7889 //
     /* 218434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 218461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218469 */     GIR_RootConstrainSelectedInstOperands,
     /* 218470 */     // GIR_Coverage, 7889,
     /* 218470 */     GIR_EraseRootFromParent_Done,
     /* 218471 */   // Label 4331: @218471
     /* 218471 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(218513), // Rule ID 7891 //
     /* 218476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 218503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218511 */     GIR_RootConstrainSelectedInstOperands,
     /* 218512 */     // GIR_Coverage, 7891,
     /* 218512 */     GIR_EraseRootFromParent_Done,
     /* 218513 */   // Label 4332: @218513
     /* 218513 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(218555), // Rule ID 7893 //
     /* 218518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218542 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 218545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218553 */     GIR_RootConstrainSelectedInstOperands,
     /* 218554 */     // GIR_Coverage, 7893,
     /* 218554 */     GIR_EraseRootFromParent_Done,
     /* 218555 */   // Label 4333: @218555
     /* 218555 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(218597), // Rule ID 7931 //
     /* 218560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 218568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218584 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 218587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218595 */     GIR_RootConstrainSelectedInstOperands,
     /* 218596 */     // GIR_Coverage, 7931,
     /* 218596 */     GIR_EraseRootFromParent_Done,
     /* 218597 */   // Label 4334: @218597
     /* 218597 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(218639), // Rule ID 7932 //
     /* 218602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 218610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218626 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 218629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218637 */     GIR_RootConstrainSelectedInstOperands,
     /* 218638 */     // GIR_Coverage, 7932,
     /* 218638 */     GIR_EraseRootFromParent_Done,
     /* 218639 */   // Label 4335: @218639
     /* 218639 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(218681), // Rule ID 7933 //
     /* 218644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 218652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218668 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 218671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218679 */     GIR_RootConstrainSelectedInstOperands,
     /* 218680 */     // GIR_Coverage, 7933,
     /* 218680 */     GIR_EraseRootFromParent_Done,
     /* 218681 */   // Label 4336: @218681
     /* 218681 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(218723), // Rule ID 7934 //
     /* 218686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 218694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218710 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 218713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218721 */     GIR_RootConstrainSelectedInstOperands,
     /* 218722 */     // GIR_Coverage, 7934,
     /* 218722 */     GIR_EraseRootFromParent_Done,
     /* 218723 */   // Label 4337: @218723
     /* 218723 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(218765), // Rule ID 7935 //
     /* 218728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 218736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 218755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218763 */     GIR_RootConstrainSelectedInstOperands,
     /* 218764 */     // GIR_Coverage, 7935,
     /* 218764 */     GIR_EraseRootFromParent_Done,
     /* 218765 */   // Label 4338: @218765
     /* 218765 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(218807), // Rule ID 7936 //
     /* 218770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 218778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218794 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1386:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 218797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218805 */     GIR_RootConstrainSelectedInstOperands,
     /* 218806 */     // GIR_Coverage, 7936,
     /* 218806 */     GIR_EraseRootFromParent_Done,
     /* 218807 */   // Label 4339: @218807
     /* 218807 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(218849), // Rule ID 7937 //
     /* 218812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 218820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218836 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 218839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218847 */     GIR_RootConstrainSelectedInstOperands,
     /* 218848 */     // GIR_Coverage, 7937,
     /* 218848 */     GIR_EraseRootFromParent_Done,
     /* 218849 */   // Label 4340: @218849
     /* 218849 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(218891), // Rule ID 7938 //
     /* 218854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 218862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 218881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218889 */     GIR_RootConstrainSelectedInstOperands,
     /* 218890 */     // GIR_Coverage, 7938,
     /* 218890 */     GIR_EraseRootFromParent_Done,
     /* 218891 */   // Label 4341: @218891
     /* 218891 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(218933), // Rule ID 7939 //
     /* 218896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 218904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218920 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1325:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 218923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218931 */     GIR_RootConstrainSelectedInstOperands,
     /* 218932 */     // GIR_Coverage, 7939,
     /* 218932 */     GIR_EraseRootFromParent_Done,
     /* 218933 */   // Label 4342: @218933
     /* 218933 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(218975), // Rule ID 7940 //
     /* 218938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 218946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 218965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218973 */     GIR_RootConstrainSelectedInstOperands,
     /* 218974 */     // GIR_Coverage, 7940,
     /* 218974 */     GIR_EraseRootFromParent_Done,
     /* 218975 */   // Label 4343: @218975
     /* 218975 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(219017), // Rule ID 7941 //
     /* 218980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 218988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 219007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219015 */     GIR_RootConstrainSelectedInstOperands,
     /* 219016 */     // GIR_Coverage, 7941,
     /* 219016 */     GIR_EraseRootFromParent_Done,
     /* 219017 */   // Label 4344: @219017
     /* 219017 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(219059), // Rule ID 7942 //
     /* 219022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 219030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219046 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 219049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219057 */     GIR_RootConstrainSelectedInstOperands,
     /* 219058 */     // GIR_Coverage, 7942,
     /* 219058 */     GIR_EraseRootFromParent_Done,
     /* 219059 */   // Label 4345: @219059
     /* 219059 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(219101), // Rule ID 7979 //
     /* 219064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219088 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219099 */     GIR_RootConstrainSelectedInstOperands,
     /* 219100 */     // GIR_Coverage, 7979,
     /* 219100 */     GIR_EraseRootFromParent_Done,
     /* 219101 */   // Label 4346: @219101
     /* 219101 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(219143), // Rule ID 7981 //
     /* 219106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 219117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 219123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 219126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219130 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 219130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219141 */     GIR_RootConstrainSelectedInstOperands,
     /* 219142 */     // GIR_Coverage, 7981,
     /* 219142 */     GIR_EraseRootFromParent_Done,
     /* 219143 */   // Label 4347: @219143
     /* 219143 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(219185), // Rule ID 7983 //
     /* 219148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 219159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 219165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 219168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219172 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 219172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219183 */     GIR_RootConstrainSelectedInstOperands,
     /* 219184 */     // GIR_Coverage, 7983,
     /* 219184 */     GIR_EraseRootFromParent_Done,
     /* 219185 */   // Label 4348: @219185
     /* 219185 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(219227), // Rule ID 7985 //
     /* 219190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219214 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 219217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219225 */     GIR_RootConstrainSelectedInstOperands,
     /* 219226 */     // GIR_Coverage, 7985,
     /* 219226 */     GIR_EraseRootFromParent_Done,
     /* 219227 */   // Label 4349: @219227
     /* 219227 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(219269), // Rule ID 7987 //
     /* 219232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 219243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 219249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 219252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219256 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 219256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 219259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219267 */     GIR_RootConstrainSelectedInstOperands,
     /* 219268 */     // GIR_Coverage, 7987,
     /* 219268 */     GIR_EraseRootFromParent_Done,
     /* 219269 */   // Label 4350: @219269
     /* 219269 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(219311), // Rule ID 7989 //
     /* 219274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219298 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 219301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219309 */     GIR_RootConstrainSelectedInstOperands,
     /* 219310 */     // GIR_Coverage, 7989,
     /* 219310 */     GIR_EraseRootFromParent_Done,
     /* 219311 */   // Label 4351: @219311
     /* 219311 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(219353), // Rule ID 7991 //
     /* 219316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219340 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219351 */     GIR_RootConstrainSelectedInstOperands,
     /* 219352 */     // GIR_Coverage, 7991,
     /* 219352 */     GIR_EraseRootFromParent_Done,
     /* 219353 */   // Label 4352: @219353
     /* 219353 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(219395), // Rule ID 7992 //
     /* 219358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 219369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 219375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 219378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 219382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219393 */     GIR_RootConstrainSelectedInstOperands,
     /* 219394 */     // GIR_Coverage, 7992,
     /* 219394 */     GIR_EraseRootFromParent_Done,
     /* 219395 */   // Label 4353: @219395
     /* 219395 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(219437), // Rule ID 7993 //
     /* 219400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 219411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 219417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 219420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 219424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219435 */     GIR_RootConstrainSelectedInstOperands,
     /* 219436 */     // GIR_Coverage, 7993,
     /* 219436 */     GIR_EraseRootFromParent_Done,
     /* 219437 */   // Label 4354: @219437
     /* 219437 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(219479), // Rule ID 7994 //
     /* 219442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219466 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 219469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219477 */     GIR_RootConstrainSelectedInstOperands,
     /* 219478 */     // GIR_Coverage, 7994,
     /* 219478 */     GIR_EraseRootFromParent_Done,
     /* 219479 */   // Label 4355: @219479
     /* 219479 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(219521), // Rule ID 7995 //
     /* 219484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 219495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 219501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 219504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219508 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 219508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 219511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219519 */     GIR_RootConstrainSelectedInstOperands,
     /* 219520 */     // GIR_Coverage, 7995,
     /* 219520 */     GIR_EraseRootFromParent_Done,
     /* 219521 */   // Label 4356: @219521
     /* 219521 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(219563), // Rule ID 7996 //
     /* 219526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219550 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 219553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219561 */     GIR_RootConstrainSelectedInstOperands,
     /* 219562 */     // GIR_Coverage, 7996,
     /* 219562 */     GIR_EraseRootFromParent_Done,
     /* 219563 */   // Label 4357: @219563
     /* 219563 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(219605), // Rule ID 8249 //
     /* 219568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 219576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 219592 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1205:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 219595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219603 */     GIR_RootConstrainSelectedInstOperands,
     /* 219604 */     // GIR_Coverage, 8249,
     /* 219604 */     GIR_EraseRootFromParent_Done,
     /* 219605 */   // Label 4358: @219605
     /* 219605 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(219647), // Rule ID 8251 //
     /* 219610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 219618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 219634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1201:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 219637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219645 */     GIR_RootConstrainSelectedInstOperands,
     /* 219646 */     // GIR_Coverage, 8251,
     /* 219646 */     GIR_EraseRootFromParent_Done,
     /* 219647 */   // Label 4359: @219647
     /* 219647 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(219689), // Rule ID 8252 //
     /* 219652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1198:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219687 */     GIR_RootConstrainSelectedInstOperands,
     /* 219688 */     // GIR_Coverage, 8252,
     /* 219688 */     GIR_EraseRootFromParent_Done,
     /* 219689 */   // Label 4360: @219689
     /* 219689 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(219731), // Rule ID 8253 //
     /* 219694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 219705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 219714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1198:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 219718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219729 */     GIR_RootConstrainSelectedInstOperands,
     /* 219730 */     // GIR_Coverage, 8253,
     /* 219730 */     GIR_EraseRootFromParent_Done,
     /* 219731 */   // Label 4361: @219731
     /* 219731 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(219773), // Rule ID 8254 //
     /* 219736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 219747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 219756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1198:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 219760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219771 */     GIR_RootConstrainSelectedInstOperands,
     /* 219772 */     // GIR_Coverage, 8254,
     /* 219772 */     GIR_EraseRootFromParent_Done,
     /* 219773 */   // Label 4362: @219773
     /* 219773 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(219815), // Rule ID 8255 //
     /* 219778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 219789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 219798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1198:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 219802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219813 */     GIR_RootConstrainSelectedInstOperands,
     /* 219814 */     // GIR_Coverage, 8255,
     /* 219814 */     GIR_EraseRootFromParent_Done,
     /* 219815 */   // Label 4363: @219815
     /* 219815 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(219857), // Rule ID 8256 //
     /* 219820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 219831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 219834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 219837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 219840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219844 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1198:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 219844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219855 */     GIR_RootConstrainSelectedInstOperands,
     /* 219856 */     // GIR_Coverage, 8256,
     /* 219856 */     GIR_EraseRootFromParent_Done,
     /* 219857 */   // Label 4364: @219857
     /* 219857 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(219899), // Rule ID 8277 //
     /* 219862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219886 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1256:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 219889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219897 */     GIR_RootConstrainSelectedInstOperands,
     /* 219898 */     // GIR_Coverage, 8277,
     /* 219898 */     GIR_EraseRootFromParent_Done,
     /* 219899 */   // Label 4365: @219899
     /* 219899 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(219941), // Rule ID 8278 //
     /* 219904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 219915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 219924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219928 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1256:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 219928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 219931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219939 */     GIR_RootConstrainSelectedInstOperands,
     /* 219940 */     // GIR_Coverage, 8278,
     /* 219940 */     GIR_EraseRootFromParent_Done,
     /* 219941 */   // Label 4366: @219941
     /* 219941 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(219983), // Rule ID 8279 //
     /* 219946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 219957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 219966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1256:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 219970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 219973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219981 */     GIR_RootConstrainSelectedInstOperands,
     /* 219982 */     // GIR_Coverage, 8279,
     /* 219982 */     GIR_EraseRootFromParent_Done,
     /* 219983 */   // Label 4367: @219983
     /* 219983 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(220025), // Rule ID 8280 //
     /* 219988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 219999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1256:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220023 */     GIR_RootConstrainSelectedInstOperands,
     /* 220024 */     // GIR_Coverage, 8280,
     /* 220024 */     GIR_EraseRootFromParent_Done,
     /* 220025 */   // Label 4368: @220025
     /* 220025 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(220067), // Rule ID 8281 //
     /* 220030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1256:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220065 */     GIR_RootConstrainSelectedInstOperands,
     /* 220066 */     // GIR_Coverage, 8281,
     /* 220066 */     GIR_EraseRootFromParent_Done,
     /* 220067 */   // Label 4369: @220067
     /* 220067 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(220109), // Rule ID 8297 //
     /* 220072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220096 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1527:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220107 */     GIR_RootConstrainSelectedInstOperands,
     /* 220108 */     // GIR_Coverage, 8297,
     /* 220108 */     GIR_EraseRootFromParent_Done,
     /* 220109 */   // Label 4370: @220109
     /* 220109 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(220151), // Rule ID 8298 //
     /* 220114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220138 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220149 */     GIR_RootConstrainSelectedInstOperands,
     /* 220150 */     // GIR_Coverage, 8298,
     /* 220150 */     GIR_EraseRootFromParent_Done,
     /* 220151 */   // Label 4371: @220151
     /* 220151 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(220193), // Rule ID 8299 //
     /* 220156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220191 */     GIR_RootConstrainSelectedInstOperands,
     /* 220192 */     // GIR_Coverage, 8299,
     /* 220192 */     GIR_EraseRootFromParent_Done,
     /* 220193 */   // Label 4372: @220193
     /* 220193 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(220235), // Rule ID 8300 //
     /* 220198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220222 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220233 */     GIR_RootConstrainSelectedInstOperands,
     /* 220234 */     // GIR_Coverage, 8300,
     /* 220234 */     GIR_EraseRootFromParent_Done,
     /* 220235 */   // Label 4373: @220235
     /* 220235 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(220277), // Rule ID 8301 //
     /* 220240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1527:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220275 */     GIR_RootConstrainSelectedInstOperands,
     /* 220276 */     // GIR_Coverage, 8301,
     /* 220276 */     GIR_EraseRootFromParent_Done,
     /* 220277 */   // Label 4374: @220277
     /* 220277 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(220319), // Rule ID 8302 //
     /* 220282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220306 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1523:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220317 */     GIR_RootConstrainSelectedInstOperands,
     /* 220318 */     // GIR_Coverage, 8302,
     /* 220318 */     GIR_EraseRootFromParent_Done,
     /* 220319 */   // Label 4375: @220319
     /* 220319 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(220361), // Rule ID 8303 //
     /* 220324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220359 */     GIR_RootConstrainSelectedInstOperands,
     /* 220360 */     // GIR_Coverage, 8303,
     /* 220360 */     GIR_EraseRootFromParent_Done,
     /* 220361 */   // Label 4376: @220361
     /* 220361 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(220403), // Rule ID 8304 //
     /* 220366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220401 */     GIR_RootConstrainSelectedInstOperands,
     /* 220402 */     // GIR_Coverage, 8304,
     /* 220402 */     GIR_EraseRootFromParent_Done,
     /* 220403 */   // Label 4377: @220403
     /* 220403 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(220445), // Rule ID 8305 //
     /* 220408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220443 */     GIR_RootConstrainSelectedInstOperands,
     /* 220444 */     // GIR_Coverage, 8305,
     /* 220444 */     GIR_EraseRootFromParent_Done,
     /* 220445 */   // Label 4378: @220445
     /* 220445 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(220487), // Rule ID 8306 //
     /* 220450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220474 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1523:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220485 */     GIR_RootConstrainSelectedInstOperands,
     /* 220486 */     // GIR_Coverage, 8306,
     /* 220486 */     GIR_EraseRootFromParent_Done,
     /* 220487 */   // Label 4379: @220487
     /* 220487 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(220529), // Rule ID 8307 //
     /* 220492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220516 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1521:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220527 */     GIR_RootConstrainSelectedInstOperands,
     /* 220528 */     // GIR_Coverage, 8307,
     /* 220528 */     GIR_EraseRootFromParent_Done,
     /* 220529 */   // Label 4380: @220529
     /* 220529 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(220571), // Rule ID 8308 //
     /* 220534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1521:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220569 */     GIR_RootConstrainSelectedInstOperands,
     /* 220570 */     // GIR_Coverage, 8308,
     /* 220570 */     GIR_EraseRootFromParent_Done,
     /* 220571 */   // Label 4381: @220571
     /* 220571 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(220613), // Rule ID 8309 //
     /* 220576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1521:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220611 */     GIR_RootConstrainSelectedInstOperands,
     /* 220612 */     // GIR_Coverage, 8309,
     /* 220612 */     GIR_EraseRootFromParent_Done,
     /* 220613 */   // Label 4382: @220613
     /* 220613 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(220655), // Rule ID 8310 //
     /* 220618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1521:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220653 */     GIR_RootConstrainSelectedInstOperands,
     /* 220654 */     // GIR_Coverage, 8310,
     /* 220654 */     GIR_EraseRootFromParent_Done,
     /* 220655 */   // Label 4383: @220655
     /* 220655 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(220697), // Rule ID 8311 //
     /* 220660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220684 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1521:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220695 */     GIR_RootConstrainSelectedInstOperands,
     /* 220696 */     // GIR_Coverage, 8311,
     /* 220696 */     GIR_EraseRootFromParent_Done,
     /* 220697 */   // Label 4384: @220697
     /* 220697 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(220739), // Rule ID 8312 //
     /* 220702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1517:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220737 */     GIR_RootConstrainSelectedInstOperands,
     /* 220738 */     // GIR_Coverage, 8312,
     /* 220738 */     GIR_EraseRootFromParent_Done,
     /* 220739 */   // Label 4385: @220739
     /* 220739 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(220781), // Rule ID 8313 //
     /* 220744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1517:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220779 */     GIR_RootConstrainSelectedInstOperands,
     /* 220780 */     // GIR_Coverage, 8313,
     /* 220780 */     GIR_EraseRootFromParent_Done,
     /* 220781 */   // Label 4386: @220781
     /* 220781 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(220823), // Rule ID 8314 //
     /* 220786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1517:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220821 */     GIR_RootConstrainSelectedInstOperands,
     /* 220822 */     // GIR_Coverage, 8314,
     /* 220822 */     GIR_EraseRootFromParent_Done,
     /* 220823 */   // Label 4387: @220823
     /* 220823 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(220865), // Rule ID 8315 //
     /* 220828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220852 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1517:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220863 */     GIR_RootConstrainSelectedInstOperands,
     /* 220864 */     // GIR_Coverage, 8315,
     /* 220864 */     GIR_EraseRootFromParent_Done,
     /* 220865 */   // Label 4388: @220865
     /* 220865 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(220907), // Rule ID 8316 //
     /* 220870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1517:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220905 */     GIR_RootConstrainSelectedInstOperands,
     /* 220906 */     // GIR_Coverage, 8316,
     /* 220906 */     GIR_EraseRootFromParent_Done,
     /* 220907 */   // Label 4389: @220907
     /* 220907 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(220949), // Rule ID 8324 //
     /* 220912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 220920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1214:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 220939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220947 */     GIR_RootConstrainSelectedInstOperands,
     /* 220948 */     // GIR_Coverage, 8324,
     /* 220948 */     GIR_EraseRootFromParent_Done,
     /* 220949 */   // Label 4390: @220949
     /* 220949 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(220991), // Rule ID 8325 //
     /* 220954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 220962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 220981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220989 */     GIR_RootConstrainSelectedInstOperands,
     /* 220990 */     // GIR_Coverage, 8325,
     /* 220990 */     GIR_EraseRootFromParent_Done,
     /* 220991 */   // Label 4391: @220991
     /* 220991 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(221033), // Rule ID 8326 //
     /* 220996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 221023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221031 */     GIR_RootConstrainSelectedInstOperands,
     /* 221032 */     // GIR_Coverage, 8326,
     /* 221032 */     GIR_EraseRootFromParent_Done,
     /* 221033 */   // Label 4392: @221033
     /* 221033 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(221075), // Rule ID 8327 //
     /* 221038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 221065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221073 */     GIR_RootConstrainSelectedInstOperands,
     /* 221074 */     // GIR_Coverage, 8327,
     /* 221074 */     GIR_EraseRootFromParent_Done,
     /* 221075 */   // Label 4393: @221075
     /* 221075 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(221117), // Rule ID 8328 //
     /* 221080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221104 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 221107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221115 */     GIR_RootConstrainSelectedInstOperands,
     /* 221116 */     // GIR_Coverage, 8328,
     /* 221116 */     GIR_EraseRootFromParent_Done,
     /* 221117 */   // Label 4394: @221117
     /* 221117 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(221159), // Rule ID 8329 //
     /* 221122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 221149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221157 */     GIR_RootConstrainSelectedInstOperands,
     /* 221158 */     // GIR_Coverage, 8329,
     /* 221158 */     GIR_EraseRootFromParent_Done,
     /* 221159 */   // Label 4395: @221159
     /* 221159 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(221201), // Rule ID 8330 //
     /* 221164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221188 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 221191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221199 */     GIR_RootConstrainSelectedInstOperands,
     /* 221200 */     // GIR_Coverage, 8330,
     /* 221200 */     GIR_EraseRootFromParent_Done,
     /* 221201 */   // Label 4396: @221201
     /* 221201 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(221246), // Rule ID 9026 //
     /* 221206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221230 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1235:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 221233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221244 */     GIR_RootConstrainSelectedInstOperands,
     /* 221245 */     // GIR_Coverage, 9026,
     /* 221245 */     GIR_EraseRootFromParent_Done,
     /* 221246 */   // Label 4397: @221246
     /* 221246 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(221291), // Rule ID 9027 //
     /* 221251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221275 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1235:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 221278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221289 */     GIR_RootConstrainSelectedInstOperands,
     /* 221290 */     // GIR_Coverage, 9027,
     /* 221290 */     GIR_EraseRootFromParent_Done,
     /* 221291 */   // Label 4398: @221291
     /* 221291 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(221336), // Rule ID 9028 //
     /* 221296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1235:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 221323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221334 */     GIR_RootConstrainSelectedInstOperands,
     /* 221335 */     // GIR_Coverage, 9028,
     /* 221335 */     GIR_EraseRootFromParent_Done,
     /* 221336 */   // Label 4399: @221336
     /* 221336 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(221381), // Rule ID 9029 //
     /* 221341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221365 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1225:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 221368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221379 */     GIR_RootConstrainSelectedInstOperands,
     /* 221380 */     // GIR_Coverage, 9029,
     /* 221380 */     GIR_EraseRootFromParent_Done,
     /* 221381 */   // Label 4400: @221381
     /* 221381 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(221426), // Rule ID 9030 //
     /* 221386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1225:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 221413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221424 */     GIR_RootConstrainSelectedInstOperands,
     /* 221425 */     // GIR_Coverage, 9030,
     /* 221425 */     GIR_EraseRootFromParent_Done,
     /* 221426 */   // Label 4401: @221426
     /* 221426 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(221471), // Rule ID 9031 //
     /* 221431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221455 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1225:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 221458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221469 */     GIR_RootConstrainSelectedInstOperands,
     /* 221470 */     // GIR_Coverage, 9031,
     /* 221470 */     GIR_EraseRootFromParent_Done,
     /* 221471 */   // Label 4402: @221471
     /* 221471 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(221516), // Rule ID 9032 //
     /* 221476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1233:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 221503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221514 */     GIR_RootConstrainSelectedInstOperands,
     /* 221515 */     // GIR_Coverage, 9032,
     /* 221515 */     GIR_EraseRootFromParent_Done,
     /* 221516 */   // Label 4403: @221516
     /* 221516 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(221561), // Rule ID 9033 //
     /* 221521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221545 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1233:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 221548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221559 */     GIR_RootConstrainSelectedInstOperands,
     /* 221560 */     // GIR_Coverage, 9033,
     /* 221560 */     GIR_EraseRootFromParent_Done,
     /* 221561 */   // Label 4404: @221561
     /* 221561 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(221606), // Rule ID 9034 //
     /* 221566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221590 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1233:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 221593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221604 */     GIR_RootConstrainSelectedInstOperands,
     /* 221605 */     // GIR_Coverage, 9034,
     /* 221605 */     GIR_EraseRootFromParent_Done,
     /* 221606 */   // Label 4405: @221606
     /* 221606 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(221651), // Rule ID 9035 //
     /* 221611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 221619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1230:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 221638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221649 */     GIR_RootConstrainSelectedInstOperands,
     /* 221650 */     // GIR_Coverage, 9035,
     /* 221650 */     GIR_EraseRootFromParent_Done,
     /* 221651 */   // Label 4406: @221651
     /* 221651 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(221696), // Rule ID 9036 //
     /* 221656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 221664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1230:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 221683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221694 */     GIR_RootConstrainSelectedInstOperands,
     /* 221695 */     // GIR_Coverage, 9036,
     /* 221695 */     GIR_EraseRootFromParent_Done,
     /* 221696 */   // Label 4407: @221696
     /* 221696 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(221741), // Rule ID 9037 //
     /* 221701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 221709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1230:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 221728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221739 */     GIR_RootConstrainSelectedInstOperands,
     /* 221740 */     // GIR_Coverage, 9037,
     /* 221740 */     GIR_EraseRootFromParent_Done,
     /* 221741 */   // Label 4408: @221741
     /* 221741 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(221786), // Rule ID 9038 //
     /* 221746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 221754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1229:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 221773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221784 */     GIR_RootConstrainSelectedInstOperands,
     /* 221785 */     // GIR_Coverage, 9038,
     /* 221785 */     GIR_EraseRootFromParent_Done,
     /* 221786 */   // Label 4409: @221786
     /* 221786 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(221831), // Rule ID 9039 //
     /* 221791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 221799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221815 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1229:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 221818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221829 */     GIR_RootConstrainSelectedInstOperands,
     /* 221830 */     // GIR_Coverage, 9039,
     /* 221830 */     GIR_EraseRootFromParent_Done,
     /* 221831 */   // Label 4410: @221831
     /* 221831 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(221876), // Rule ID 9040 //
     /* 221836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 221844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1229:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 221863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221874 */     GIR_RootConstrainSelectedInstOperands,
     /* 221875 */     // GIR_Coverage, 9040,
     /* 221875 */     GIR_EraseRootFromParent_Done,
     /* 221876 */   // Label 4411: @221876
     /* 221876 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(221921), // Rule ID 9041 //
     /* 221881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 221889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221905 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1227:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 221908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221919 */     GIR_RootConstrainSelectedInstOperands,
     /* 221920 */     // GIR_Coverage, 9041,
     /* 221920 */     GIR_EraseRootFromParent_Done,
     /* 221921 */   // Label 4412: @221921
     /* 221921 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(221966), // Rule ID 9042 //
     /* 221926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 221934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1227:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 221953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221964 */     GIR_RootConstrainSelectedInstOperands,
     /* 221965 */     // GIR_Coverage, 9042,
     /* 221965 */     GIR_EraseRootFromParent_Done,
     /* 221966 */   // Label 4413: @221966
     /* 221966 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(222011), // Rule ID 9043 //
     /* 221971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 221979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221995 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1227:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 221998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222009 */     GIR_RootConstrainSelectedInstOperands,
     /* 222010 */     // GIR_Coverage, 9043,
     /* 222010 */     GIR_EraseRootFromParent_Done,
     /* 222011 */   // Label 4414: @222011
     /* 222011 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(222056), // Rule ID 9044 //
     /* 222016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1231:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 222043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222054 */     GIR_RootConstrainSelectedInstOperands,
     /* 222055 */     // GIR_Coverage, 9044,
     /* 222055 */     GIR_EraseRootFromParent_Done,
     /* 222056 */   // Label 4415: @222056
     /* 222056 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(222101), // Rule ID 9045 //
     /* 222061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222085 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1231:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 222088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222099 */     GIR_RootConstrainSelectedInstOperands,
     /* 222100 */     // GIR_Coverage, 9045,
     /* 222100 */     GIR_EraseRootFromParent_Done,
     /* 222101 */   // Label 4416: @222101
     /* 222101 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(222146), // Rule ID 9046 //
     /* 222106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1231:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 222133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222144 */     GIR_RootConstrainSelectedInstOperands,
     /* 222145 */     // GIR_Coverage, 9046,
     /* 222145 */     GIR_EraseRootFromParent_Done,
     /* 222146 */   // Label 4417: @222146
     /* 222146 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(222191), // Rule ID 9047 //
     /* 222151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1232:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 222178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222189 */     GIR_RootConstrainSelectedInstOperands,
     /* 222190 */     // GIR_Coverage, 9047,
     /* 222190 */     GIR_EraseRootFromParent_Done,
     /* 222191 */   // Label 4418: @222191
     /* 222191 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(222236), // Rule ID 9048 //
     /* 222196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1232:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 222223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222234 */     GIR_RootConstrainSelectedInstOperands,
     /* 222235 */     // GIR_Coverage, 9048,
     /* 222235 */     GIR_EraseRootFromParent_Done,
     /* 222236 */   // Label 4419: @222236
     /* 222236 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(222281), // Rule ID 9049 //
     /* 222241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222265 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1232:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 222268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222279 */     GIR_RootConstrainSelectedInstOperands,
     /* 222280 */     // GIR_Coverage, 9049,
     /* 222280 */     GIR_EraseRootFromParent_Done,
     /* 222281 */   // Label 4420: @222281
     /* 222281 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(222323), // Rule ID 9446 //
     /* 222286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1268:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 222313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222321 */     GIR_RootConstrainSelectedInstOperands,
     /* 222322 */     // GIR_Coverage, 9446,
     /* 222322 */     GIR_EraseRootFromParent_Done,
     /* 222323 */   // Label 4421: @222323
     /* 222323 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(222365), // Rule ID 9447 //
     /* 222328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1268:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 222355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222363 */     GIR_RootConstrainSelectedInstOperands,
     /* 222364 */     // GIR_Coverage, 9447,
     /* 222364 */     GIR_EraseRootFromParent_Done,
     /* 222365 */   // Label 4422: @222365
     /* 222365 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(222407), // Rule ID 9448 //
     /* 222370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1268:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 222397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222405 */     GIR_RootConstrainSelectedInstOperands,
     /* 222406 */     // GIR_Coverage, 9448,
     /* 222406 */     GIR_EraseRootFromParent_Done,
     /* 222407 */   // Label 4423: @222407
     /* 222407 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(222449), // Rule ID 9986 //
     /* 222412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222436 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1499:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 222439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222447 */     GIR_RootConstrainSelectedInstOperands,
     /* 222448 */     // GIR_Coverage, 9986,
     /* 222448 */     GIR_EraseRootFromParent_Done,
     /* 222449 */   // Label 4424: @222449
     /* 222449 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(222491), // Rule ID 9987 //
     /* 222454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1499:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 222481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222489 */     GIR_RootConstrainSelectedInstOperands,
     /* 222490 */     // GIR_Coverage, 9987,
     /* 222490 */     GIR_EraseRootFromParent_Done,
     /* 222491 */   // Label 4425: @222491
     /* 222491 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(222533), // Rule ID 9988 //
     /* 222496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1499:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 222523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222531 */     GIR_RootConstrainSelectedInstOperands,
     /* 222532 */     // GIR_Coverage, 9988,
     /* 222532 */     GIR_EraseRootFromParent_Done,
     /* 222533 */   // Label 4426: @222533
     /* 222533 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222575), // Rule ID 9989 //
     /* 222538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1499:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 222565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222573 */     GIR_RootConstrainSelectedInstOperands,
     /* 222574 */     // GIR_Coverage, 9989,
     /* 222574 */     GIR_EraseRootFromParent_Done,
     /* 222575 */   // Label 4427: @222575
     /* 222575 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222617), // Rule ID 9990 //
     /* 222580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1496:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 222607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222615 */     GIR_RootConstrainSelectedInstOperands,
     /* 222616 */     // GIR_Coverage, 9990,
     /* 222616 */     GIR_EraseRootFromParent_Done,
     /* 222617 */   // Label 4428: @222617
     /* 222617 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222659), // Rule ID 9991 //
     /* 222622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 222649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222657 */     GIR_RootConstrainSelectedInstOperands,
     /* 222658 */     // GIR_Coverage, 9991,
     /* 222658 */     GIR_EraseRootFromParent_Done,
     /* 222659 */   // Label 4429: @222659
     /* 222659 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222701), // Rule ID 9992 //
     /* 222664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 222691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222699 */     GIR_RootConstrainSelectedInstOperands,
     /* 222700 */     // GIR_Coverage, 9992,
     /* 222700 */     GIR_EraseRootFromParent_Done,
     /* 222701 */   // Label 4430: @222701
     /* 222701 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222743), // Rule ID 9993 //
     /* 222706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 222733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222741 */     GIR_RootConstrainSelectedInstOperands,
     /* 222742 */     // GIR_Coverage, 9993,
     /* 222742 */     GIR_EraseRootFromParent_Done,
     /* 222743 */   // Label 4431: @222743
     /* 222743 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222785), // Rule ID 10006 //
     /* 222748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 222756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1501:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 222775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222783 */     GIR_RootConstrainSelectedInstOperands,
     /* 222784 */     // GIR_Coverage, 10006,
     /* 222784 */     GIR_EraseRootFromParent_Done,
     /* 222785 */   // Label 4432: @222785
     /* 222785 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222827), // Rule ID 10007 //
     /* 222790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 222798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1501:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 222817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222825 */     GIR_RootConstrainSelectedInstOperands,
     /* 222826 */     // GIR_Coverage, 10007,
     /* 222826 */     GIR_EraseRootFromParent_Done,
     /* 222827 */   // Label 4433: @222827
     /* 222827 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222869), // Rule ID 10008 //
     /* 222832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 222840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1501:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 222859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222867 */     GIR_RootConstrainSelectedInstOperands,
     /* 222868 */     // GIR_Coverage, 10008,
     /* 222868 */     GIR_EraseRootFromParent_Done,
     /* 222869 */   // Label 4434: @222869
     /* 222869 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222911), // Rule ID 10009 //
     /* 222874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 222882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1498:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 222901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222909 */     GIR_RootConstrainSelectedInstOperands,
     /* 222910 */     // GIR_Coverage, 10009,
     /* 222910 */     GIR_EraseRootFromParent_Done,
     /* 222911 */   // Label 4435: @222911
     /* 222911 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222953), // Rule ID 10010 //
     /* 222916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 222924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 222943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222951 */     GIR_RootConstrainSelectedInstOperands,
     /* 222952 */     // GIR_Coverage, 10010,
     /* 222952 */     GIR_EraseRootFromParent_Done,
     /* 222953 */   // Label 4436: @222953
     /* 222953 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(222995), // Rule ID 10011 //
     /* 222958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 222966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 222985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222993 */     GIR_RootConstrainSelectedInstOperands,
     /* 222994 */     // GIR_Coverage, 10011,
     /* 222994 */     GIR_EraseRootFromParent_Done,
     /* 222995 */   // Label 4437: @222995
     /* 222995 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(223037), // Rule ID 10038 //
     /* 223000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 223008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223024 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1293:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 223027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223035 */     GIR_RootConstrainSelectedInstOperands,
     /* 223036 */     // GIR_Coverage, 10038,
     /* 223036 */     GIR_EraseRootFromParent_Done,
     /* 223037 */   // Label 4438: @223037
     /* 223037 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(223079), // Rule ID 10042 //
     /* 223042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 223050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223066 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1296:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 223069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223077 */     GIR_RootConstrainSelectedInstOperands,
     /* 223078 */     // GIR_Coverage, 10042,
     /* 223078 */     GIR_EraseRootFromParent_Done,
     /* 223079 */   // Label 4439: @223079
     /* 223079 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(223121), // Rule ID 10046 //
     /* 223084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 223092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223108 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1295:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 223111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223119 */     GIR_RootConstrainSelectedInstOperands,
     /* 223120 */     // GIR_Coverage, 10046,
     /* 223120 */     GIR_EraseRootFromParent_Done,
     /* 223121 */   // Label 4440: @223121
     /* 223121 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223163), // Rule ID 10050 //
     /* 223126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 223134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223150 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1297:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 223153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223161 */     GIR_RootConstrainSelectedInstOperands,
     /* 223162 */     // GIR_Coverage, 10050,
     /* 223162 */     GIR_EraseRootFromParent_Done,
     /* 223163 */   // Label 4441: @223163
     /* 223163 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223205), // Rule ID 10054 //
     /* 223168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 223176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223192 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1609:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 223195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223203 */     GIR_RootConstrainSelectedInstOperands,
     /* 223204 */     // GIR_Coverage, 10054,
     /* 223204 */     GIR_EraseRootFromParent_Done,
     /* 223205 */   // Label 4442: @223205
     /* 223205 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223247), // Rule ID 10055 //
     /* 223210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 223218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223234 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1856:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 223237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223245 */     GIR_RootConstrainSelectedInstOperands,
     /* 223246 */     // GIR_Coverage, 10055,
     /* 223246 */     GIR_EraseRootFromParent_Done,
     /* 223247 */   // Label 4443: @223247
     /* 223247 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223289), // Rule ID 10056 //
     /* 223252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 223260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223276 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1853:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 223279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223287 */     GIR_RootConstrainSelectedInstOperands,
     /* 223288 */     // GIR_Coverage, 10056,
     /* 223288 */     GIR_EraseRootFromParent_Done,
     /* 223289 */   // Label 4444: @223289
     /* 223289 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223331), // Rule ID 10060 //
     /* 223294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 223302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223318 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1608:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 223321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223329 */     GIR_RootConstrainSelectedInstOperands,
     /* 223330 */     // GIR_Coverage, 10060,
     /* 223330 */     GIR_EraseRootFromParent_Done,
     /* 223331 */   // Label 4445: @223331
     /* 223331 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223373), // Rule ID 10064 //
     /* 223336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 223344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 223363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223371 */     GIR_RootConstrainSelectedInstOperands,
     /* 223372 */     // GIR_Coverage, 10064,
     /* 223372 */     GIR_EraseRootFromParent_Done,
     /* 223373 */   // Label 4446: @223373
     /* 223373 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223415), // Rule ID 10068 //
     /* 223378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 223386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223402 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 223405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223413 */     GIR_RootConstrainSelectedInstOperands,
     /* 223414 */     // GIR_Coverage, 10068,
     /* 223414 */     GIR_EraseRootFromParent_Done,
     /* 223415 */   // Label 4447: @223415
     /* 223415 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223457), // Rule ID 10072 //
     /* 223420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 223428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1855:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 223447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223455 */     GIR_RootConstrainSelectedInstOperands,
     /* 223456 */     // GIR_Coverage, 10072,
     /* 223456 */     GIR_EraseRootFromParent_Done,
     /* 223457 */   // Label 4448: @223457
     /* 223457 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223499), // Rule ID 10076 //
     /* 223462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 223470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223486 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1854:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 223489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223497 */     GIR_RootConstrainSelectedInstOperands,
     /* 223498 */     // GIR_Coverage, 10076,
     /* 223498 */     GIR_EraseRootFromParent_Done,
     /* 223499 */   // Label 4449: @223499
     /* 223499 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223541), // Rule ID 10086 //
     /* 223504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 223512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1311:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 223531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223539 */     GIR_RootConstrainSelectedInstOperands,
     /* 223540 */     // GIR_Coverage, 10086,
     /* 223540 */     GIR_EraseRootFromParent_Done,
     /* 223541 */   // Label 4450: @223541
     /* 223541 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223583), // Rule ID 10087 //
     /* 223546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 223554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 223573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223581 */     GIR_RootConstrainSelectedInstOperands,
     /* 223582 */     // GIR_Coverage, 10087,
     /* 223582 */     GIR_EraseRootFromParent_Done,
     /* 223583 */   // Label 4451: @223583
     /* 223583 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223625), // Rule ID 10088 //
     /* 223588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 223596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223612 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 223615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223623 */     GIR_RootConstrainSelectedInstOperands,
     /* 223624 */     // GIR_Coverage, 10088,
     /* 223624 */     GIR_EraseRootFromParent_Done,
     /* 223625 */   // Label 4452: @223625
     /* 223625 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223667), // Rule ID 10092 //
     /* 223630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 223638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 223657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223665 */     GIR_RootConstrainSelectedInstOperands,
     /* 223666 */     // GIR_Coverage, 10092,
     /* 223666 */     GIR_EraseRootFromParent_Done,
     /* 223667 */   // Label 4453: @223667
     /* 223667 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(223709), // Rule ID 10096 //
     /* 223672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 223680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1312:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 223699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223707 */     GIR_RootConstrainSelectedInstOperands,
     /* 223708 */     // GIR_Coverage, 10096,
     /* 223708 */     GIR_EraseRootFromParent_Done,
     /* 223709 */   // Label 4454: @223709
     /* 223709 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(223751), // Rule ID 10100 //
     /* 223714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 223722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 223741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223749 */     GIR_RootConstrainSelectedInstOperands,
     /* 223750 */     // GIR_Coverage, 10100,
     /* 223750 */     GIR_EraseRootFromParent_Done,
     /* 223751 */   // Label 4455: @223751
     /* 223751 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(223793), // Rule ID 10104 //
     /* 223756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 223764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1319:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 223783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223791 */     GIR_RootConstrainSelectedInstOperands,
     /* 223792 */     // GIR_Coverage, 10104,
     /* 223792 */     GIR_EraseRootFromParent_Done,
     /* 223793 */   // Label 4456: @223793
     /* 223793 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(223835), // Rule ID 10108 //
     /* 223798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 223806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 223825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223833 */     GIR_RootConstrainSelectedInstOperands,
     /* 223834 */     // GIR_Coverage, 10108,
     /* 223834 */     GIR_EraseRootFromParent_Done,
     /* 223835 */   // Label 4457: @223835
     /* 223835 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(223877), // Rule ID 11057 //
     /* 223840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 223843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 223848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1895:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 223867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223875 */     GIR_RootConstrainSelectedInstOperands,
     /* 223876 */     // GIR_Coverage, 11057,
     /* 223876 */     GIR_EraseRootFromParent_Done,
     /* 223877 */   // Label 4458: @223877
     /* 223877 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(223919), // Rule ID 11058 //
     /* 223882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 223885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 223890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 223909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223917 */     GIR_RootConstrainSelectedInstOperands,
     /* 223918 */     // GIR_Coverage, 11058,
     /* 223918 */     GIR_EraseRootFromParent_Done,
     /* 223919 */   // Label 4459: @223919
     /* 223919 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(223961), // Rule ID 11060 //
     /* 223924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 223927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 223932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223948 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 223951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223959 */     GIR_RootConstrainSelectedInstOperands,
     /* 223960 */     // GIR_Coverage, 11060,
     /* 223960 */     GIR_EraseRootFromParent_Done,
     /* 223961 */   // Label 4460: @223961
     /* 223961 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224003), // Rule ID 11061 //
     /* 223966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 223969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 223974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223990 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 223993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224001 */     GIR_RootConstrainSelectedInstOperands,
     /* 224002 */     // GIR_Coverage, 11061,
     /* 224002 */     GIR_EraseRootFromParent_Done,
     /* 224003 */   // Label 4461: @224003
     /* 224003 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224045), // Rule ID 11115 //
     /* 224008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 224035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224043 */     GIR_RootConstrainSelectedInstOperands,
     /* 224044 */     // GIR_Coverage, 11115,
     /* 224044 */     GIR_EraseRootFromParent_Done,
     /* 224045 */   // Label 4462: @224045
     /* 224045 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224087), // Rule ID 11116 //
     /* 224050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 224077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224085 */     GIR_RootConstrainSelectedInstOperands,
     /* 224086 */     // GIR_Coverage, 11116,
     /* 224086 */     GIR_EraseRootFromParent_Done,
     /* 224087 */   // Label 4463: @224087
     /* 224087 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224129), // Rule ID 11117 //
     /* 224092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 224119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224127 */     GIR_RootConstrainSelectedInstOperands,
     /* 224128 */     // GIR_Coverage, 11117,
     /* 224128 */     GIR_EraseRootFromParent_Done,
     /* 224129 */   // Label 4464: @224129
     /* 224129 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224171), // Rule ID 11118 //
     /* 224134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 224161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224169 */     GIR_RootConstrainSelectedInstOperands,
     /* 224170 */     // GIR_Coverage, 11118,
     /* 224170 */     GIR_EraseRootFromParent_Done,
     /* 224171 */   // Label 4465: @224171
     /* 224171 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224213), // Rule ID 11171 //
     /* 224176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224200 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1651:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 224203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224211 */     GIR_RootConstrainSelectedInstOperands,
     /* 224212 */     // GIR_Coverage, 11171,
     /* 224212 */     GIR_EraseRootFromParent_Done,
     /* 224213 */   // Label 4466: @224213
     /* 224213 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(224255), // Rule ID 11172 //
     /* 224218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1651:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 224245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224253 */     GIR_RootConstrainSelectedInstOperands,
     /* 224254 */     // GIR_Coverage, 11172,
     /* 224254 */     GIR_EraseRootFromParent_Done,
     /* 224255 */   // Label 4467: @224255
     /* 224255 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(224297), // Rule ID 11173 //
     /* 224260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1651:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 224287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224295 */     GIR_RootConstrainSelectedInstOperands,
     /* 224296 */     // GIR_Coverage, 11173,
     /* 224296 */     GIR_EraseRootFromParent_Done,
     /* 224297 */   // Label 4468: @224297
     /* 224297 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(224339), // Rule ID 11174 //
     /* 224302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1887:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 224329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224337 */     GIR_RootConstrainSelectedInstOperands,
     /* 224338 */     // GIR_Coverage, 11174,
     /* 224338 */     GIR_EraseRootFromParent_Done,
     /* 224339 */   // Label 4469: @224339
     /* 224339 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(224381), // Rule ID 11175 //
     /* 224344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1887:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 224371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224379 */     GIR_RootConstrainSelectedInstOperands,
     /* 224380 */     // GIR_Coverage, 11175,
     /* 224380 */     GIR_EraseRootFromParent_Done,
     /* 224381 */   // Label 4470: @224381
     /* 224381 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(224423), // Rule ID 11176 //
     /* 224386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1887:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 224413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224421 */     GIR_RootConstrainSelectedInstOperands,
     /* 224422 */     // GIR_Coverage, 11176,
     /* 224422 */     GIR_EraseRootFromParent_Done,
     /* 224423 */   // Label 4471: @224423
     /* 224423 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(224465), // Rule ID 11177 //
     /* 224428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 224455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224463 */     GIR_RootConstrainSelectedInstOperands,
     /* 224464 */     // GIR_Coverage, 11177,
     /* 224464 */     GIR_EraseRootFromParent_Done,
     /* 224465 */   // Label 4472: @224465
     /* 224465 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(224507), // Rule ID 11178 //
     /* 224470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 224497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224505 */     GIR_RootConstrainSelectedInstOperands,
     /* 224506 */     // GIR_Coverage, 11178,
     /* 224506 */     GIR_EraseRootFromParent_Done,
     /* 224507 */   // Label 4473: @224507
     /* 224507 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(224549), // Rule ID 11179 //
     /* 224512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 224539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224547 */     GIR_RootConstrainSelectedInstOperands,
     /* 224548 */     // GIR_Coverage, 11179,
     /* 224548 */     GIR_EraseRootFromParent_Done,
     /* 224549 */   // Label 4474: @224549
     /* 224549 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(224591), // Rule ID 11180 //
     /* 224554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 224562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1653:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 224581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224589 */     GIR_RootConstrainSelectedInstOperands,
     /* 224590 */     // GIR_Coverage, 11180,
     /* 224590 */     GIR_EraseRootFromParent_Done,
     /* 224591 */   // Label 4475: @224591
     /* 224591 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(224633), // Rule ID 11181 //
     /* 224596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 224604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1653:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 224623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224631 */     GIR_RootConstrainSelectedInstOperands,
     /* 224632 */     // GIR_Coverage, 11181,
     /* 224632 */     GIR_EraseRootFromParent_Done,
     /* 224633 */   // Label 4476: @224633
     /* 224633 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(224675), // Rule ID 11182 //
     /* 224638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 224646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1653:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 224665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224673 */     GIR_RootConstrainSelectedInstOperands,
     /* 224674 */     // GIR_Coverage, 11182,
     /* 224674 */     GIR_EraseRootFromParent_Done,
     /* 224675 */   // Label 4477: @224675
     /* 224675 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(224717), // Rule ID 11183 //
     /* 224680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 224688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1655:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 224707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224715 */     GIR_RootConstrainSelectedInstOperands,
     /* 224716 */     // GIR_Coverage, 11183,
     /* 224716 */     GIR_EraseRootFromParent_Done,
     /* 224717 */   // Label 4478: @224717
     /* 224717 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(224759), // Rule ID 11184 //
     /* 224722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 224730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1655:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 224749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224757 */     GIR_RootConstrainSelectedInstOperands,
     /* 224758 */     // GIR_Coverage, 11184,
     /* 224758 */     GIR_EraseRootFromParent_Done,
     /* 224759 */   // Label 4479: @224759
     /* 224759 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(224801), // Rule ID 11185 //
     /* 224764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 224772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1655:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 224791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224799 */     GIR_RootConstrainSelectedInstOperands,
     /* 224800 */     // GIR_Coverage, 11185,
     /* 224800 */     GIR_EraseRootFromParent_Done,
     /* 224801 */   // Label 4480: @224801
     /* 224801 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(224843), // Rule ID 11186 //
     /* 224806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 224814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 224833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224841 */     GIR_RootConstrainSelectedInstOperands,
     /* 224842 */     // GIR_Coverage, 11186,
     /* 224842 */     GIR_EraseRootFromParent_Done,
     /* 224843 */   // Label 4481: @224843
     /* 224843 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(224885), // Rule ID 11187 //
     /* 224848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 224856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 224875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224883 */     GIR_RootConstrainSelectedInstOperands,
     /* 224884 */     // GIR_Coverage, 11187,
     /* 224884 */     GIR_EraseRootFromParent_Done,
     /* 224885 */   // Label 4482: @224885
     /* 224885 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(224927), // Rule ID 11188 //
     /* 224890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 224898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 224917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224925 */     GIR_RootConstrainSelectedInstOperands,
     /* 224926 */     // GIR_Coverage, 11188,
     /* 224926 */     GIR_EraseRootFromParent_Done,
     /* 224927 */   // Label 4483: @224927
     /* 224927 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(224969), // Rule ID 11189 //
     /* 224932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 224940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1893:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 224959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224967 */     GIR_RootConstrainSelectedInstOperands,
     /* 224968 */     // GIR_Coverage, 11189,
     /* 224968 */     GIR_EraseRootFromParent_Done,
     /* 224969 */   // Label 4484: @224969
     /* 224969 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(225011), // Rule ID 11190 //
     /* 224974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 224982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1893:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 225001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225009 */     GIR_RootConstrainSelectedInstOperands,
     /* 225010 */     // GIR_Coverage, 11190,
     /* 225010 */     GIR_EraseRootFromParent_Done,
     /* 225011 */   // Label 4485: @225011
     /* 225011 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(225053), // Rule ID 11191 //
     /* 225016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 225024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1893:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 225043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225051 */     GIR_RootConstrainSelectedInstOperands,
     /* 225052 */     // GIR_Coverage, 11191,
     /* 225052 */     GIR_EraseRootFromParent_Done,
     /* 225053 */   // Label 4486: @225053
     /* 225053 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(225095), // Rule ID 11200 //
     /* 225058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 225085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225093 */     GIR_RootConstrainSelectedInstOperands,
     /* 225094 */     // GIR_Coverage, 11200,
     /* 225094 */     GIR_EraseRootFromParent_Done,
     /* 225095 */   // Label 4487: @225095
     /* 225095 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(225137), // Rule ID 11201 //
     /* 225100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 225127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225135 */     GIR_RootConstrainSelectedInstOperands,
     /* 225136 */     // GIR_Coverage, 11201,
     /* 225136 */     GIR_EraseRootFromParent_Done,
     /* 225137 */   // Label 4488: @225137
     /* 225137 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(225179), // Rule ID 11202 //
     /* 225142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 225169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225177 */     GIR_RootConstrainSelectedInstOperands,
     /* 225178 */     // GIR_Coverage, 11202,
     /* 225178 */     GIR_EraseRootFromParent_Done,
     /* 225179 */   // Label 4489: @225179
     /* 225179 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(225221), // Rule ID 11203 //
     /* 225184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 225211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225219 */     GIR_RootConstrainSelectedInstOperands,
     /* 225220 */     // GIR_Coverage, 11203,
     /* 225220 */     GIR_EraseRootFromParent_Done,
     /* 225221 */   // Label 4490: @225221
     /* 225221 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(225263), // Rule ID 11204 //
     /* 225226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 225253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225261 */     GIR_RootConstrainSelectedInstOperands,
     /* 225262 */     // GIR_Coverage, 11204,
     /* 225262 */     GIR_EraseRootFromParent_Done,
     /* 225263 */   // Label 4491: @225263
     /* 225263 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(225305), // Rule ID 11205 //
     /* 225268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 225295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225303 */     GIR_RootConstrainSelectedInstOperands,
     /* 225304 */     // GIR_Coverage, 11205,
     /* 225304 */     GIR_EraseRootFromParent_Done,
     /* 225305 */   // Label 4492: @225305
     /* 225305 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(225347), // Rule ID 11206 //
     /* 225310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 225337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225345 */     GIR_RootConstrainSelectedInstOperands,
     /* 225346 */     // GIR_Coverage, 11206,
     /* 225346 */     GIR_EraseRootFromParent_Done,
     /* 225347 */   // Label 4493: @225347
     /* 225347 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(225389), // Rule ID 11207 //
     /* 225352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 225379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225387 */     GIR_RootConstrainSelectedInstOperands,
     /* 225388 */     // GIR_Coverage, 11207,
     /* 225388 */     GIR_EraseRootFromParent_Done,
     /* 225389 */   // Label 4494: @225389
     /* 225389 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(225431), // Rule ID 11208 //
     /* 225394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 225421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225429 */     GIR_RootConstrainSelectedInstOperands,
     /* 225430 */     // GIR_Coverage, 11208,
     /* 225430 */     GIR_EraseRootFromParent_Done,
     /* 225431 */   // Label 4495: @225431
     /* 225431 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(225473), // Rule ID 11209 //
     /* 225436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 225463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225471 */     GIR_RootConstrainSelectedInstOperands,
     /* 225472 */     // GIR_Coverage, 11209,
     /* 225472 */     GIR_EraseRootFromParent_Done,
     /* 225473 */   // Label 4496: @225473
     /* 225473 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(225515), // Rule ID 11210 //
     /* 225478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 225505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225513 */     GIR_RootConstrainSelectedInstOperands,
     /* 225514 */     // GIR_Coverage, 11210,
     /* 225514 */     GIR_EraseRootFromParent_Done,
     /* 225515 */   // Label 4497: @225515
     /* 225515 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(225557), // Rule ID 11211 //
     /* 225520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 225547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225555 */     GIR_RootConstrainSelectedInstOperands,
     /* 225556 */     // GIR_Coverage, 11211,
     /* 225556 */     GIR_EraseRootFromParent_Done,
     /* 225557 */   // Label 4498: @225557
     /* 225557 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(225599), // Rule ID 11212 //
     /* 225562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 225570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 225589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225597 */     GIR_RootConstrainSelectedInstOperands,
     /* 225598 */     // GIR_Coverage, 11212,
     /* 225598 */     GIR_EraseRootFromParent_Done,
     /* 225599 */   // Label 4499: @225599
     /* 225599 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(225641), // Rule ID 11213 //
     /* 225604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 225612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 225631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225639 */     GIR_RootConstrainSelectedInstOperands,
     /* 225640 */     // GIR_Coverage, 11213,
     /* 225640 */     GIR_EraseRootFromParent_Done,
     /* 225641 */   // Label 4500: @225641
     /* 225641 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(225683), // Rule ID 11214 //
     /* 225646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 225654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 225673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225681 */     GIR_RootConstrainSelectedInstOperands,
     /* 225682 */     // GIR_Coverage, 11214,
     /* 225682 */     GIR_EraseRootFromParent_Done,
     /* 225683 */   // Label 4501: @225683
     /* 225683 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(225725), // Rule ID 11215 //
     /* 225688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 225696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 225715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225723 */     GIR_RootConstrainSelectedInstOperands,
     /* 225724 */     // GIR_Coverage, 11215,
     /* 225724 */     GIR_EraseRootFromParent_Done,
     /* 225725 */   // Label 4502: @225725
     /* 225725 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(225767), // Rule ID 11216 //
     /* 225730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 225738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 225757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225765 */     GIR_RootConstrainSelectedInstOperands,
     /* 225766 */     // GIR_Coverage, 11216,
     /* 225766 */     GIR_EraseRootFromParent_Done,
     /* 225767 */   // Label 4503: @225767
     /* 225767 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(225809), // Rule ID 11217 //
     /* 225772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 225780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 225799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225807 */     GIR_RootConstrainSelectedInstOperands,
     /* 225808 */     // GIR_Coverage, 11217,
     /* 225808 */     GIR_EraseRootFromParent_Done,
     /* 225809 */   // Label 4504: @225809
     /* 225809 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(225851), // Rule ID 11218 //
     /* 225814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 225841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225849 */     GIR_RootConstrainSelectedInstOperands,
     /* 225850 */     // GIR_Coverage, 11218,
     /* 225850 */     GIR_EraseRootFromParent_Done,
     /* 225851 */   // Label 4505: @225851
     /* 225851 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(225893), // Rule ID 11220 //
     /* 225856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 225883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225891 */     GIR_RootConstrainSelectedInstOperands,
     /* 225892 */     // GIR_Coverage, 11220,
     /* 225892 */     GIR_EraseRootFromParent_Done,
     /* 225893 */   // Label 4506: @225893
     /* 225893 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(225935), // Rule ID 11222 //
     /* 225898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 225925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225933 */     GIR_RootConstrainSelectedInstOperands,
     /* 225934 */     // GIR_Coverage, 11222,
     /* 225934 */     GIR_EraseRootFromParent_Done,
     /* 225935 */   // Label 4507: @225935
     /* 225935 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(225977), // Rule ID 11224 //
     /* 225940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 225967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225975 */     GIR_RootConstrainSelectedInstOperands,
     /* 225976 */     // GIR_Coverage, 11224,
     /* 225976 */     GIR_EraseRootFromParent_Done,
     /* 225977 */   // Label 4508: @225977
     /* 225977 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(226019), // Rule ID 11226 //
     /* 225982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 225990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 226009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226017 */     GIR_RootConstrainSelectedInstOperands,
     /* 226018 */     // GIR_Coverage, 11226,
     /* 226018 */     GIR_EraseRootFromParent_Done,
     /* 226019 */   // Label 4509: @226019
     /* 226019 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(226061), // Rule ID 11227 //
     /* 226024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 226051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226059 */     GIR_RootConstrainSelectedInstOperands,
     /* 226060 */     // GIR_Coverage, 11227,
     /* 226060 */     GIR_EraseRootFromParent_Done,
     /* 226061 */   // Label 4510: @226061
     /* 226061 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(226103), // Rule ID 11228 //
     /* 226066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 226093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226101 */     GIR_RootConstrainSelectedInstOperands,
     /* 226102 */     // GIR_Coverage, 11228,
     /* 226102 */     GIR_EraseRootFromParent_Done,
     /* 226103 */   // Label 4511: @226103
     /* 226103 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(226145), // Rule ID 11229 //
     /* 226108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 226135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226143 */     GIR_RootConstrainSelectedInstOperands,
     /* 226144 */     // GIR_Coverage, 11229,
     /* 226144 */     GIR_EraseRootFromParent_Done,
     /* 226145 */   // Label 4512: @226145
     /* 226145 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(226187), // Rule ID 11230 //
     /* 226150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 226177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226185 */     GIR_RootConstrainSelectedInstOperands,
     /* 226186 */     // GIR_Coverage, 11230,
     /* 226186 */     GIR_EraseRootFromParent_Done,
     /* 226187 */   // Label 4513: @226187
     /* 226187 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(226229), // Rule ID 11231 //
     /* 226192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 226219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226227 */     GIR_RootConstrainSelectedInstOperands,
     /* 226228 */     // GIR_Coverage, 11231,
     /* 226228 */     GIR_EraseRootFromParent_Done,
     /* 226229 */   // Label 4514: @226229
     /* 226229 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(226271), // Rule ID 11232 //
     /* 226234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 226261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226269 */     GIR_RootConstrainSelectedInstOperands,
     /* 226270 */     // GIR_Coverage, 11232,
     /* 226270 */     GIR_EraseRootFromParent_Done,
     /* 226271 */   // Label 4515: @226271
     /* 226271 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(226313), // Rule ID 11233 //
     /* 226276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 226303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226311 */     GIR_RootConstrainSelectedInstOperands,
     /* 226312 */     // GIR_Coverage, 11233,
     /* 226312 */     GIR_EraseRootFromParent_Done,
     /* 226313 */   // Label 4516: @226313
     /* 226313 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(226355), // Rule ID 11234 //
     /* 226318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1761:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 226345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226353 */     GIR_RootConstrainSelectedInstOperands,
     /* 226354 */     // GIR_Coverage, 11234,
     /* 226354 */     GIR_EraseRootFromParent_Done,
     /* 226355 */   // Label 4517: @226355
     /* 226355 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(226397), // Rule ID 11236 //
     /* 226360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 226387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226395 */     GIR_RootConstrainSelectedInstOperands,
     /* 226396 */     // GIR_Coverage, 11236,
     /* 226396 */     GIR_EraseRootFromParent_Done,
     /* 226397 */   // Label 4518: @226397
     /* 226397 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(226439), // Rule ID 11238 //
     /* 226402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 226429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226437 */     GIR_RootConstrainSelectedInstOperands,
     /* 226438 */     // GIR_Coverage, 11238,
     /* 226438 */     GIR_EraseRootFromParent_Done,
     /* 226439 */   // Label 4519: @226439
     /* 226439 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(226481), // Rule ID 11240 //
     /* 226444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 226471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226479 */     GIR_RootConstrainSelectedInstOperands,
     /* 226480 */     // GIR_Coverage, 11240,
     /* 226480 */     GIR_EraseRootFromParent_Done,
     /* 226481 */   // Label 4520: @226481
     /* 226481 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(226523), // Rule ID 11242 //
     /* 226486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226510 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 226513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226521 */     GIR_RootConstrainSelectedInstOperands,
     /* 226522 */     // GIR_Coverage, 11242,
     /* 226522 */     GIR_EraseRootFromParent_Done,
     /* 226523 */   // Label 4521: @226523
     /* 226523 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(226565), // Rule ID 11244 //
     /* 226528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 226555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226563 */     GIR_RootConstrainSelectedInstOperands,
     /* 226564 */     // GIR_Coverage, 11244,
     /* 226564 */     GIR_EraseRootFromParent_Done,
     /* 226565 */   // Label 4522: @226565
     /* 226565 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(226607), // Rule ID 11246 //
     /* 226570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 226597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226605 */     GIR_RootConstrainSelectedInstOperands,
     /* 226606 */     // GIR_Coverage, 11246,
     /* 226606 */     GIR_EraseRootFromParent_Done,
     /* 226607 */   // Label 4523: @226607
     /* 226607 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(226649), // Rule ID 11248 //
     /* 226612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 226639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226647 */     GIR_RootConstrainSelectedInstOperands,
     /* 226648 */     // GIR_Coverage, 11248,
     /* 226648 */     GIR_EraseRootFromParent_Done,
     /* 226649 */   // Label 4524: @226649
     /* 226649 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(226691), // Rule ID 11250 //
     /* 226654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 226681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226689 */     GIR_RootConstrainSelectedInstOperands,
     /* 226690 */     // GIR_Coverage, 11250,
     /* 226690 */     GIR_EraseRootFromParent_Done,
     /* 226691 */   // Label 4525: @226691
     /* 226691 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(226733), // Rule ID 11251 //
     /* 226696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 226723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226731 */     GIR_RootConstrainSelectedInstOperands,
     /* 226732 */     // GIR_Coverage, 11251,
     /* 226732 */     GIR_EraseRootFromParent_Done,
     /* 226733 */   // Label 4526: @226733
     /* 226733 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(226775), // Rule ID 11252 //
     /* 226738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 226765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226773 */     GIR_RootConstrainSelectedInstOperands,
     /* 226774 */     // GIR_Coverage, 11252,
     /* 226774 */     GIR_EraseRootFromParent_Done,
     /* 226775 */   // Label 4527: @226775
     /* 226775 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(226817), // Rule ID 11253 //
     /* 226780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 226807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226815 */     GIR_RootConstrainSelectedInstOperands,
     /* 226816 */     // GIR_Coverage, 11253,
     /* 226816 */     GIR_EraseRootFromParent_Done,
     /* 226817 */   // Label 4528: @226817
     /* 226817 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(226859), // Rule ID 11254 //
     /* 226822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1868:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 226849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226857 */     GIR_RootConstrainSelectedInstOperands,
     /* 226858 */     // GIR_Coverage, 11254,
     /* 226858 */     GIR_EraseRootFromParent_Done,
     /* 226859 */   // Label 4529: @226859
     /* 226859 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(226901), // Rule ID 11255 //
     /* 226864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226888 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 226891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226899 */     GIR_RootConstrainSelectedInstOperands,
     /* 226900 */     // GIR_Coverage, 11255,
     /* 226900 */     GIR_EraseRootFromParent_Done,
     /* 226901 */   // Label 4530: @226901
     /* 226901 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(226943), // Rule ID 11256 //
     /* 226906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 226933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226941 */     GIR_RootConstrainSelectedInstOperands,
     /* 226942 */     // GIR_Coverage, 11256,
     /* 226942 */     GIR_EraseRootFromParent_Done,
     /* 226943 */   // Label 4531: @226943
     /* 226943 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(226985), // Rule ID 11257 //
     /* 226948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 226975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226983 */     GIR_RootConstrainSelectedInstOperands,
     /* 226984 */     // GIR_Coverage, 11257,
     /* 226984 */     GIR_EraseRootFromParent_Done,
     /* 226985 */   // Label 4532: @226985
     /* 226985 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(227027), // Rule ID 11258 //
     /* 226990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 226998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 227017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227025 */     GIR_RootConstrainSelectedInstOperands,
     /* 227026 */     // GIR_Coverage, 11258,
     /* 227026 */     GIR_EraseRootFromParent_Done,
     /* 227027 */   // Label 4533: @227027
     /* 227027 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(227069), // Rule ID 11259 //
     /* 227032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 227059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227067 */     GIR_RootConstrainSelectedInstOperands,
     /* 227068 */     // GIR_Coverage, 11259,
     /* 227068 */     GIR_EraseRootFromParent_Done,
     /* 227069 */   // Label 4534: @227069
     /* 227069 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(227111), // Rule ID 11260 //
     /* 227074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 227101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227109 */     GIR_RootConstrainSelectedInstOperands,
     /* 227110 */     // GIR_Coverage, 11260,
     /* 227110 */     GIR_EraseRootFromParent_Done,
     /* 227111 */   // Label 4535: @227111
     /* 227111 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(227153), // Rule ID 11261 //
     /* 227116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 227143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227151 */     GIR_RootConstrainSelectedInstOperands,
     /* 227152 */     // GIR_Coverage, 11261,
     /* 227152 */     GIR_EraseRootFromParent_Done,
     /* 227153 */   // Label 4536: @227153
     /* 227153 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(227195), // Rule ID 11262 //
     /* 227158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1158:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 227185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227193 */     GIR_RootConstrainSelectedInstOperands,
     /* 227194 */     // GIR_Coverage, 11262,
     /* 227194 */     GIR_EraseRootFromParent_Done,
     /* 227195 */   // Label 4537: @227195
     /* 227195 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(227237), // Rule ID 11263 //
     /* 227200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1158:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 227227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227235 */     GIR_RootConstrainSelectedInstOperands,
     /* 227236 */     // GIR_Coverage, 11263,
     /* 227236 */     GIR_EraseRootFromParent_Done,
     /* 227237 */   // Label 4538: @227237
     /* 227237 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(227279), // Rule ID 11264 //
     /* 227242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1158:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 227269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227277 */     GIR_RootConstrainSelectedInstOperands,
     /* 227278 */     // GIR_Coverage, 11264,
     /* 227278 */     GIR_EraseRootFromParent_Done,
     /* 227279 */   // Label 4539: @227279
     /* 227279 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(227321), // Rule ID 11265 //
     /* 227284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227308 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 227311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227319 */     GIR_RootConstrainSelectedInstOperands,
     /* 227320 */     // GIR_Coverage, 11265,
     /* 227320 */     GIR_EraseRootFromParent_Done,
     /* 227321 */   // Label 4540: @227321
     /* 227321 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(227363), // Rule ID 11266 //
     /* 227326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1637:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 227353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227361 */     GIR_RootConstrainSelectedInstOperands,
     /* 227362 */     // GIR_Coverage, 11266,
     /* 227362 */     GIR_EraseRootFromParent_Done,
     /* 227363 */   // Label 4541: @227363
     /* 227363 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(227405), // Rule ID 11267 //
     /* 227368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1637:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 227395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227403 */     GIR_RootConstrainSelectedInstOperands,
     /* 227404 */     // GIR_Coverage, 11267,
     /* 227404 */     GIR_EraseRootFromParent_Done,
     /* 227405 */   // Label 4542: @227405
     /* 227405 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(227447), // Rule ID 11268 //
     /* 227410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1637:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 227437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227445 */     GIR_RootConstrainSelectedInstOperands,
     /* 227446 */     // GIR_Coverage, 11268,
     /* 227446 */     GIR_EraseRootFromParent_Done,
     /* 227447 */   // Label 4543: @227447
     /* 227447 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(227489), // Rule ID 11269 //
     /* 227452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1875:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 227479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227487 */     GIR_RootConstrainSelectedInstOperands,
     /* 227488 */     // GIR_Coverage, 11269,
     /* 227488 */     GIR_EraseRootFromParent_Done,
     /* 227489 */   // Label 4544: @227489
     /* 227489 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(227531), // Rule ID 11270 //
     /* 227494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 227521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227529 */     GIR_RootConstrainSelectedInstOperands,
     /* 227530 */     // GIR_Coverage, 11270,
     /* 227530 */     GIR_EraseRootFromParent_Done,
     /* 227531 */   // Label 4545: @227531
     /* 227531 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(227573), // Rule ID 11271 //
     /* 227536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 227563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227571 */     GIR_RootConstrainSelectedInstOperands,
     /* 227572 */     // GIR_Coverage, 11271,
     /* 227572 */     GIR_EraseRootFromParent_Done,
     /* 227573 */   // Label 4546: @227573
     /* 227573 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(227615), // Rule ID 11272 //
     /* 227578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 227605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227613 */     GIR_RootConstrainSelectedInstOperands,
     /* 227614 */     // GIR_Coverage, 11272,
     /* 227614 */     GIR_EraseRootFromParent_Done,
     /* 227615 */   // Label 4547: @227615
     /* 227615 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(227657), // Rule ID 11273 //
     /* 227620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 227647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227655 */     GIR_RootConstrainSelectedInstOperands,
     /* 227656 */     // GIR_Coverage, 11273,
     /* 227656 */     GIR_EraseRootFromParent_Done,
     /* 227657 */   // Label 4548: @227657
     /* 227657 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(227699), // Rule ID 11274 //
     /* 227662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 227689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227697 */     GIR_RootConstrainSelectedInstOperands,
     /* 227698 */     // GIR_Coverage, 11274,
     /* 227698 */     GIR_EraseRootFromParent_Done,
     /* 227699 */   // Label 4549: @227699
     /* 227699 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(227741), // Rule ID 11275 //
     /* 227704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 227731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227739 */     GIR_RootConstrainSelectedInstOperands,
     /* 227740 */     // GIR_Coverage, 11275,
     /* 227740 */     GIR_EraseRootFromParent_Done,
     /* 227741 */   // Label 4550: @227741
     /* 227741 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(227783), // Rule ID 11276 //
     /* 227746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1646:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 227773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227781 */     GIR_RootConstrainSelectedInstOperands,
     /* 227782 */     // GIR_Coverage, 11276,
     /* 227782 */     GIR_EraseRootFromParent_Done,
     /* 227783 */   // Label 4551: @227783
     /* 227783 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(227825), // Rule ID 11277 //
     /* 227788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1884:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 227815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227823 */     GIR_RootConstrainSelectedInstOperands,
     /* 227824 */     // GIR_Coverage, 11277,
     /* 227824 */     GIR_EraseRootFromParent_Done,
     /* 227825 */   // Label 4552: @227825
     /* 227825 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(227867), // Rule ID 11278 //
     /* 227830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1884:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 227857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227865 */     GIR_RootConstrainSelectedInstOperands,
     /* 227866 */     // GIR_Coverage, 11278,
     /* 227866 */     GIR_EraseRootFromParent_Done,
     /* 227867 */   // Label 4553: @227867
     /* 227867 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(227909), // Rule ID 11279 //
     /* 227872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1884:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 227899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227907 */     GIR_RootConstrainSelectedInstOperands,
     /* 227908 */     // GIR_Coverage, 11279,
     /* 227908 */     GIR_EraseRootFromParent_Done,
     /* 227909 */   // Label 4554: @227909
     /* 227909 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(227951), // Rule ID 11280 //
     /* 227914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1884:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 227941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227949 */     GIR_RootConstrainSelectedInstOperands,
     /* 227950 */     // GIR_Coverage, 11280,
     /* 227950 */     GIR_EraseRootFromParent_Done,
     /* 227951 */   // Label 4555: @227951
     /* 227951 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(227993), // Rule ID 11281 //
     /* 227956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 227964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 227983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227991 */     GIR_RootConstrainSelectedInstOperands,
     /* 227992 */     // GIR_Coverage, 11281,
     /* 227992 */     GIR_EraseRootFromParent_Done,
     /* 227993 */   // Label 4556: @227993
     /* 227993 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(228035), // Rule ID 11292 //
     /* 227998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 228025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228033 */     GIR_RootConstrainSelectedInstOperands,
     /* 228034 */     // GIR_Coverage, 11292,
     /* 228034 */     GIR_EraseRootFromParent_Done,
     /* 228035 */   // Label 4557: @228035
     /* 228035 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(228077), // Rule ID 11293 //
     /* 228040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 228067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228075 */     GIR_RootConstrainSelectedInstOperands,
     /* 228076 */     // GIR_Coverage, 11293,
     /* 228076 */     GIR_EraseRootFromParent_Done,
     /* 228077 */   // Label 4558: @228077
     /* 228077 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(228119), // Rule ID 11294 //
     /* 228082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 228109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228117 */     GIR_RootConstrainSelectedInstOperands,
     /* 228118 */     // GIR_Coverage, 11294,
     /* 228118 */     GIR_EraseRootFromParent_Done,
     /* 228119 */   // Label 4559: @228119
     /* 228119 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(228161), // Rule ID 11295 //
     /* 228124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 228151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228159 */     GIR_RootConstrainSelectedInstOperands,
     /* 228160 */     // GIR_Coverage, 11295,
     /* 228160 */     GIR_EraseRootFromParent_Done,
     /* 228161 */   // Label 4560: @228161
     /* 228161 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(228203), // Rule ID 11304 //
     /* 228166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 228193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228201 */     GIR_RootConstrainSelectedInstOperands,
     /* 228202 */     // GIR_Coverage, 11304,
     /* 228202 */     GIR_EraseRootFromParent_Done,
     /* 228203 */   // Label 4561: @228203
     /* 228203 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(228245), // Rule ID 11305 //
     /* 228208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 228235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228243 */     GIR_RootConstrainSelectedInstOperands,
     /* 228244 */     // GIR_Coverage, 11305,
     /* 228244 */     GIR_EraseRootFromParent_Done,
     /* 228245 */   // Label 4562: @228245
     /* 228245 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(228287), // Rule ID 11306 //
     /* 228250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 228277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228285 */     GIR_RootConstrainSelectedInstOperands,
     /* 228286 */     // GIR_Coverage, 11306,
     /* 228286 */     GIR_EraseRootFromParent_Done,
     /* 228287 */   // Label 4563: @228287
     /* 228287 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(228329), // Rule ID 11307 //
     /* 228292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 228319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228327 */     GIR_RootConstrainSelectedInstOperands,
     /* 228328 */     // GIR_Coverage, 11307,
     /* 228328 */     GIR_EraseRootFromParent_Done,
     /* 228329 */   // Label 4564: @228329
     /* 228329 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(228371), // Rule ID 11308 //
     /* 228334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1902:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 228361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228369 */     GIR_RootConstrainSelectedInstOperands,
     /* 228370 */     // GIR_Coverage, 11308,
     /* 228370 */     GIR_EraseRootFromParent_Done,
     /* 228371 */   // Label 4565: @228371
     /* 228371 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(228413), // Rule ID 11309 //
     /* 228376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1902:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 228403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228411 */     GIR_RootConstrainSelectedInstOperands,
     /* 228412 */     // GIR_Coverage, 11309,
     /* 228412 */     GIR_EraseRootFromParent_Done,
     /* 228413 */   // Label 4566: @228413
     /* 228413 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(228455), // Rule ID 11310 //
     /* 228418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1902:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 228445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228453 */     GIR_RootConstrainSelectedInstOperands,
     /* 228454 */     // GIR_Coverage, 11310,
     /* 228454 */     GIR_EraseRootFromParent_Done,
     /* 228455 */   // Label 4567: @228455
     /* 228455 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(228497), // Rule ID 11311 //
     /* 228460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1902:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 228487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228495 */     GIR_RootConstrainSelectedInstOperands,
     /* 228496 */     // GIR_Coverage, 11311,
     /* 228496 */     GIR_EraseRootFromParent_Done,
     /* 228497 */   // Label 4568: @228497
     /* 228497 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(228539), // Rule ID 11312 //
     /* 228502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1753:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 228529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228537 */     GIR_RootConstrainSelectedInstOperands,
     /* 228538 */     // GIR_Coverage, 11312,
     /* 228538 */     GIR_EraseRootFromParent_Done,
     /* 228539 */   // Label 4569: @228539
     /* 228539 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(228581), // Rule ID 11313 //
     /* 228544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 228571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228579 */     GIR_RootConstrainSelectedInstOperands,
     /* 228580 */     // GIR_Coverage, 11313,
     /* 228580 */     GIR_EraseRootFromParent_Done,
     /* 228581 */   // Label 4570: @228581
     /* 228581 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(228623), // Rule ID 11314 //
     /* 228586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 228613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228621 */     GIR_RootConstrainSelectedInstOperands,
     /* 228622 */     // GIR_Coverage, 11314,
     /* 228622 */     GIR_EraseRootFromParent_Done,
     /* 228623 */   // Label 4571: @228623
     /* 228623 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(228665), // Rule ID 11315 //
     /* 228628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 228655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228663 */     GIR_RootConstrainSelectedInstOperands,
     /* 228664 */     // GIR_Coverage, 11315,
     /* 228664 */     GIR_EraseRootFromParent_Done,
     /* 228665 */   // Label 4572: @228665
     /* 228665 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(228707), // Rule ID 11316 //
     /* 228670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 228697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228705 */     GIR_RootConstrainSelectedInstOperands,
     /* 228706 */     // GIR_Coverage, 11316,
     /* 228706 */     GIR_EraseRootFromParent_Done,
     /* 228707 */   // Label 4573: @228707
     /* 228707 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(228749), // Rule ID 11317 //
     /* 228712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 228739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228747 */     GIR_RootConstrainSelectedInstOperands,
     /* 228748 */     // GIR_Coverage, 11317,
     /* 228748 */     GIR_EraseRootFromParent_Done,
     /* 228749 */   // Label 4574: @228749
     /* 228749 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(228791), // Rule ID 11318 //
     /* 228754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 228781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228789 */     GIR_RootConstrainSelectedInstOperands,
     /* 228790 */     // GIR_Coverage, 11318,
     /* 228790 */     GIR_EraseRootFromParent_Done,
     /* 228791 */   // Label 4575: @228791
     /* 228791 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(228833), // Rule ID 11319 //
     /* 228796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 228823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228831 */     GIR_RootConstrainSelectedInstOperands,
     /* 228832 */     // GIR_Coverage, 11319,
     /* 228832 */     GIR_EraseRootFromParent_Done,
     /* 228833 */   // Label 4576: @228833
     /* 228833 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(228875), // Rule ID 11320 //
     /* 228838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228862 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1817:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 228865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228873 */     GIR_RootConstrainSelectedInstOperands,
     /* 228874 */     // GIR_Coverage, 11320,
     /* 228874 */     GIR_EraseRootFromParent_Done,
     /* 228875 */   // Label 4577: @228875
     /* 228875 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(228917), // Rule ID 11321 //
     /* 228880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 228907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228915 */     GIR_RootConstrainSelectedInstOperands,
     /* 228916 */     // GIR_Coverage, 11321,
     /* 228916 */     GIR_EraseRootFromParent_Done,
     /* 228917 */   // Label 4578: @228917
     /* 228917 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(228959), // Rule ID 11322 //
     /* 228922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 228949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228957 */     GIR_RootConstrainSelectedInstOperands,
     /* 228958 */     // GIR_Coverage, 11322,
     /* 228958 */     GIR_EraseRootFromParent_Done,
     /* 228959 */   // Label 4579: @228959
     /* 228959 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(229001), // Rule ID 11323 //
     /* 228964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 228991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228999 */     GIR_RootConstrainSelectedInstOperands,
     /* 229000 */     // GIR_Coverage, 11323,
     /* 229000 */     GIR_EraseRootFromParent_Done,
     /* 229001 */   // Label 4580: @229001
     /* 229001 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(229043), // Rule ID 11324 //
     /* 229006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 229033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229041 */     GIR_RootConstrainSelectedInstOperands,
     /* 229042 */     // GIR_Coverage, 11324,
     /* 229042 */     GIR_EraseRootFromParent_Done,
     /* 229043 */   // Label 4581: @229043
     /* 229043 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(229085), // Rule ID 11325 //
     /* 229048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 229075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229083 */     GIR_RootConstrainSelectedInstOperands,
     /* 229084 */     // GIR_Coverage, 11325,
     /* 229084 */     GIR_EraseRootFromParent_Done,
     /* 229085 */   // Label 4582: @229085
     /* 229085 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(229127), // Rule ID 11326 //
     /* 229090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 229117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229125 */     GIR_RootConstrainSelectedInstOperands,
     /* 229126 */     // GIR_Coverage, 11326,
     /* 229126 */     GIR_EraseRootFromParent_Done,
     /* 229127 */   // Label 4583: @229127
     /* 229127 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(229169), // Rule ID 11327 //
     /* 229132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 229159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229167 */     GIR_RootConstrainSelectedInstOperands,
     /* 229168 */     // GIR_Coverage, 11327,
     /* 229168 */     GIR_EraseRootFromParent_Done,
     /* 229169 */   // Label 4584: @229169
     /* 229169 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(229211), // Rule ID 11328 //
     /* 229174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1756:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 229201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229209 */     GIR_RootConstrainSelectedInstOperands,
     /* 229210 */     // GIR_Coverage, 11328,
     /* 229210 */     GIR_EraseRootFromParent_Done,
     /* 229211 */   // Label 4585: @229211
     /* 229211 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(229253), // Rule ID 11329 //
     /* 229216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 229243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229251 */     GIR_RootConstrainSelectedInstOperands,
     /* 229252 */     // GIR_Coverage, 11329,
     /* 229252 */     GIR_EraseRootFromParent_Done,
     /* 229253 */   // Label 4586: @229253
     /* 229253 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(229295), // Rule ID 11330 //
     /* 229258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 229285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229293 */     GIR_RootConstrainSelectedInstOperands,
     /* 229294 */     // GIR_Coverage, 11330,
     /* 229294 */     GIR_EraseRootFromParent_Done,
     /* 229295 */   // Label 4587: @229295
     /* 229295 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(229337), // Rule ID 11331 //
     /* 229300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 229327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229335 */     GIR_RootConstrainSelectedInstOperands,
     /* 229336 */     // GIR_Coverage, 11331,
     /* 229336 */     GIR_EraseRootFromParent_Done,
     /* 229337 */   // Label 4588: @229337
     /* 229337 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(229379), // Rule ID 11332 //
     /* 229342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229366 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1949:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 229369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229377 */     GIR_RootConstrainSelectedInstOperands,
     /* 229378 */     // GIR_Coverage, 11332,
     /* 229378 */     GIR_EraseRootFromParent_Done,
     /* 229379 */   // Label 4589: @229379
     /* 229379 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(229421), // Rule ID 11333 //
     /* 229384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229408 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 229411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229419 */     GIR_RootConstrainSelectedInstOperands,
     /* 229420 */     // GIR_Coverage, 11333,
     /* 229420 */     GIR_EraseRootFromParent_Done,
     /* 229421 */   // Label 4590: @229421
     /* 229421 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(229463), // Rule ID 11334 //
     /* 229426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 229453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229461 */     GIR_RootConstrainSelectedInstOperands,
     /* 229462 */     // GIR_Coverage, 11334,
     /* 229462 */     GIR_EraseRootFromParent_Done,
     /* 229463 */   // Label 4591: @229463
     /* 229463 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(229505), // Rule ID 11335 //
     /* 229468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 229495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229503 */     GIR_RootConstrainSelectedInstOperands,
     /* 229504 */     // GIR_Coverage, 11335,
     /* 229504 */     GIR_EraseRootFromParent_Done,
     /* 229505 */   // Label 4592: @229505
     /* 229505 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(229547), // Rule ID 11336 //
     /* 229510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1763:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 229537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229545 */     GIR_RootConstrainSelectedInstOperands,
     /* 229546 */     // GIR_Coverage, 11336,
     /* 229546 */     GIR_EraseRootFromParent_Done,
     /* 229547 */   // Label 4593: @229547
     /* 229547 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(229589), // Rule ID 11337 //
     /* 229552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 229579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229587 */     GIR_RootConstrainSelectedInstOperands,
     /* 229588 */     // GIR_Coverage, 11337,
     /* 229588 */     GIR_EraseRootFromParent_Done,
     /* 229589 */   // Label 4594: @229589
     /* 229589 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(229631), // Rule ID 11338 //
     /* 229594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 229621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229629 */     GIR_RootConstrainSelectedInstOperands,
     /* 229630 */     // GIR_Coverage, 11338,
     /* 229630 */     GIR_EraseRootFromParent_Done,
     /* 229631 */   // Label 4595: @229631
     /* 229631 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(229673), // Rule ID 11339 //
     /* 229636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 229663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229671 */     GIR_RootConstrainSelectedInstOperands,
     /* 229672 */     // GIR_Coverage, 11339,
     /* 229672 */     GIR_EraseRootFromParent_Done,
     /* 229673 */   // Label 4596: @229673
     /* 229673 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(229715), // Rule ID 11340 //
     /* 229678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1954:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 229705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229713 */     GIR_RootConstrainSelectedInstOperands,
     /* 229714 */     // GIR_Coverage, 11340,
     /* 229714 */     GIR_EraseRootFromParent_Done,
     /* 229715 */   // Label 4597: @229715
     /* 229715 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(229757), // Rule ID 11341 //
     /* 229720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1954:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 229747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229755 */     GIR_RootConstrainSelectedInstOperands,
     /* 229756 */     // GIR_Coverage, 11341,
     /* 229756 */     GIR_EraseRootFromParent_Done,
     /* 229757 */   // Label 4598: @229757
     /* 229757 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(229799), // Rule ID 11342 //
     /* 229762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1954:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 229789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229797 */     GIR_RootConstrainSelectedInstOperands,
     /* 229798 */     // GIR_Coverage, 11342,
     /* 229798 */     GIR_EraseRootFromParent_Done,
     /* 229799 */   // Label 4599: @229799
     /* 229799 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(229841), // Rule ID 11343 //
     /* 229804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1954:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 229831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229839 */     GIR_RootConstrainSelectedInstOperands,
     /* 229840 */     // GIR_Coverage, 11343,
     /* 229840 */     GIR_EraseRootFromParent_Done,
     /* 229841 */   // Label 4600: @229841
     /* 229841 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(229883), // Rule ID 11344 //
     /* 229846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 229873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229881 */     GIR_RootConstrainSelectedInstOperands,
     /* 229882 */     // GIR_Coverage, 11344,
     /* 229882 */     GIR_EraseRootFromParent_Done,
     /* 229883 */   // Label 4601: @229883
     /* 229883 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(229925), // Rule ID 11345 //
     /* 229888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229912 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 229915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229923 */     GIR_RootConstrainSelectedInstOperands,
     /* 229924 */     // GIR_Coverage, 11345,
     /* 229924 */     GIR_EraseRootFromParent_Done,
     /* 229925 */   // Label 4602: @229925
     /* 229925 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(229967), // Rule ID 11346 //
     /* 229930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 229957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229965 */     GIR_RootConstrainSelectedInstOperands,
     /* 229966 */     // GIR_Coverage, 11346,
     /* 229966 */     GIR_EraseRootFromParent_Done,
     /* 229967 */   // Label 4603: @229967
     /* 229967 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(230009), // Rule ID 11347 //
     /* 229972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 229999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230007 */     GIR_RootConstrainSelectedInstOperands,
     /* 230008 */     // GIR_Coverage, 11347,
     /* 230008 */     GIR_EraseRootFromParent_Done,
     /* 230009 */   // Label 4604: @230009
     /* 230009 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(230051), // Rule ID 11348 //
     /* 230014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 230041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230049 */     GIR_RootConstrainSelectedInstOperands,
     /* 230050 */     // GIR_Coverage, 11348,
     /* 230050 */     GIR_EraseRootFromParent_Done,
     /* 230051 */   // Label 4605: @230051
     /* 230051 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(230093), // Rule ID 11349 //
     /* 230056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 230083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230091 */     GIR_RootConstrainSelectedInstOperands,
     /* 230092 */     // GIR_Coverage, 11349,
     /* 230092 */     GIR_EraseRootFromParent_Done,
     /* 230093 */   // Label 4606: @230093
     /* 230093 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(230135), // Rule ID 11350 //
     /* 230098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 230125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230133 */     GIR_RootConstrainSelectedInstOperands,
     /* 230134 */     // GIR_Coverage, 11350,
     /* 230134 */     GIR_EraseRootFromParent_Done,
     /* 230135 */   // Label 4607: @230135
     /* 230135 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(230177), // Rule ID 11351 //
     /* 230140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 230167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230175 */     GIR_RootConstrainSelectedInstOperands,
     /* 230176 */     // GIR_Coverage, 11351,
     /* 230176 */     GIR_EraseRootFromParent_Done,
     /* 230177 */   // Label 4608: @230177
     /* 230177 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(230219), // Rule ID 11352 //
     /* 230182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1734:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 230209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230217 */     GIR_RootConstrainSelectedInstOperands,
     /* 230218 */     // GIR_Coverage, 11352,
     /* 230218 */     GIR_EraseRootFromParent_Done,
     /* 230219 */   // Label 4609: @230219
     /* 230219 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(230261), // Rule ID 11353 //
     /* 230224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1734:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 230251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230259 */     GIR_RootConstrainSelectedInstOperands,
     /* 230260 */     // GIR_Coverage, 11353,
     /* 230260 */     GIR_EraseRootFromParent_Done,
     /* 230261 */   // Label 4610: @230261
     /* 230261 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(230303), // Rule ID 11354 //
     /* 230266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 230293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230301 */     GIR_RootConstrainSelectedInstOperands,
     /* 230302 */     // GIR_Coverage, 11354,
     /* 230302 */     GIR_EraseRootFromParent_Done,
     /* 230303 */   // Label 4611: @230303
     /* 230303 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(230345), // Rule ID 11355 //
     /* 230308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 230335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230343 */     GIR_RootConstrainSelectedInstOperands,
     /* 230344 */     // GIR_Coverage, 11355,
     /* 230344 */     GIR_EraseRootFromParent_Done,
     /* 230345 */   // Label 4612: @230345
     /* 230345 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(230387), // Rule ID 11356 //
     /* 230350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 230377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230385 */     GIR_RootConstrainSelectedInstOperands,
     /* 230386 */     // GIR_Coverage, 11356,
     /* 230386 */     GIR_EraseRootFromParent_Done,
     /* 230387 */   // Label 4613: @230387
     /* 230387 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(230429), // Rule ID 11357 //
     /* 230392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 230419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230427 */     GIR_RootConstrainSelectedInstOperands,
     /* 230428 */     // GIR_Coverage, 11357,
     /* 230428 */     GIR_EraseRootFromParent_Done,
     /* 230429 */   // Label 4614: @230429
     /* 230429 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(230471), // Rule ID 11358 //
     /* 230434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 230461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230469 */     GIR_RootConstrainSelectedInstOperands,
     /* 230470 */     // GIR_Coverage, 11358,
     /* 230470 */     GIR_EraseRootFromParent_Done,
     /* 230471 */   // Label 4615: @230471
     /* 230471 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(230513), // Rule ID 11359 //
     /* 230476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 230503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230511 */     GIR_RootConstrainSelectedInstOperands,
     /* 230512 */     // GIR_Coverage, 11359,
     /* 230512 */     GIR_EraseRootFromParent_Done,
     /* 230513 */   // Label 4616: @230513
     /* 230513 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(230555), // Rule ID 11522 //
     /* 230518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 230545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230553 */     GIR_RootConstrainSelectedInstOperands,
     /* 230554 */     // GIR_Coverage, 11522,
     /* 230554 */     GIR_EraseRootFromParent_Done,
     /* 230555 */   // Label 4617: @230555
     /* 230555 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(230597), // Rule ID 11524 //
     /* 230560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 230587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230595 */     GIR_RootConstrainSelectedInstOperands,
     /* 230596 */     // GIR_Coverage, 11524,
     /* 230596 */     GIR_EraseRootFromParent_Done,
     /* 230597 */   // Label 4618: @230597
     /* 230597 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(230639), // Rule ID 11526 //
     /* 230602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 230629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230637 */     GIR_RootConstrainSelectedInstOperands,
     /* 230638 */     // GIR_Coverage, 11526,
     /* 230638 */     GIR_EraseRootFromParent_Done,
     /* 230639 */   // Label 4619: @230639
     /* 230639 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(230681), // Rule ID 11528 //
     /* 230644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 230671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230679 */     GIR_RootConstrainSelectedInstOperands,
     /* 230680 */     // GIR_Coverage, 11528,
     /* 230680 */     GIR_EraseRootFromParent_Done,
     /* 230681 */   // Label 4620: @230681
     /* 230681 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(230723), // Rule ID 11530 //
     /* 230686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 230694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 230713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230721 */     GIR_RootConstrainSelectedInstOperands,
     /* 230722 */     // GIR_Coverage, 11530,
     /* 230722 */     GIR_EraseRootFromParent_Done,
     /* 230723 */   // Label 4621: @230723
     /* 230723 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(230765), // Rule ID 11531 //
     /* 230728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 230736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 230755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230763 */     GIR_RootConstrainSelectedInstOperands,
     /* 230764 */     // GIR_Coverage, 11531,
     /* 230764 */     GIR_EraseRootFromParent_Done,
     /* 230765 */   // Label 4622: @230765
     /* 230765 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(230807), // Rule ID 11532 //
     /* 230770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 230778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 230797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230805 */     GIR_RootConstrainSelectedInstOperands,
     /* 230806 */     // GIR_Coverage, 11532,
     /* 230806 */     GIR_EraseRootFromParent_Done,
     /* 230807 */   // Label 4623: @230807
     /* 230807 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(230849), // Rule ID 11533 //
     /* 230812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 230820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 230839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230847 */     GIR_RootConstrainSelectedInstOperands,
     /* 230848 */     // GIR_Coverage, 11533,
     /* 230848 */     GIR_EraseRootFromParent_Done,
     /* 230849 */   // Label 4624: @230849
     /* 230849 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(230891), // Rule ID 11534 //
     /* 230854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 230862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 230881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230889 */     GIR_RootConstrainSelectedInstOperands,
     /* 230890 */     // GIR_Coverage, 11534,
     /* 230890 */     GIR_EraseRootFromParent_Done,
     /* 230891 */   // Label 4625: @230891
     /* 230891 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(230933), // Rule ID 11535 //
     /* 230896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 230904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 230923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230931 */     GIR_RootConstrainSelectedInstOperands,
     /* 230932 */     // GIR_Coverage, 11535,
     /* 230932 */     GIR_EraseRootFromParent_Done,
     /* 230933 */   // Label 4626: @230933
     /* 230933 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(230975), // Rule ID 11536 //
     /* 230938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 230946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 230965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230973 */     GIR_RootConstrainSelectedInstOperands,
     /* 230974 */     // GIR_Coverage, 11536,
     /* 230974 */     GIR_EraseRootFromParent_Done,
     /* 230975 */   // Label 4627: @230975
     /* 230975 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(231017), // Rule ID 11537 //
     /* 230980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 230988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 231007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231015 */     GIR_RootConstrainSelectedInstOperands,
     /* 231016 */     // GIR_Coverage, 11537,
     /* 231016 */     GIR_EraseRootFromParent_Done,
     /* 231017 */   // Label 4628: @231017
     /* 231017 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(231059), // Rule ID 11538 //
     /* 231022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 231030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 231049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231057 */     GIR_RootConstrainSelectedInstOperands,
     /* 231058 */     // GIR_Coverage, 11538,
     /* 231058 */     GIR_EraseRootFromParent_Done,
     /* 231059 */   // Label 4629: @231059
     /* 231059 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(231101), // Rule ID 11539 //
     /* 231064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 231072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1151:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 231091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231099 */     GIR_RootConstrainSelectedInstOperands,
     /* 231100 */     // GIR_Coverage, 11539,
     /* 231100 */     GIR_EraseRootFromParent_Done,
     /* 231101 */   // Label 4630: @231101
     /* 231101 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(231143), // Rule ID 11540 //
     /* 231106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 231114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1151:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 231133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231141 */     GIR_RootConstrainSelectedInstOperands,
     /* 231142 */     // GIR_Coverage, 11540,
     /* 231142 */     GIR_EraseRootFromParent_Done,
     /* 231143 */   // Label 4631: @231143
     /* 231143 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(231185), // Rule ID 11541 //
     /* 231148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 231156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 231175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231183 */     GIR_RootConstrainSelectedInstOperands,
     /* 231184 */     // GIR_Coverage, 11541,
     /* 231184 */     GIR_EraseRootFromParent_Done,
     /* 231185 */   // Label 4632: @231185
     /* 231185 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(231227), // Rule ID 11542 //
     /* 231190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 231198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 231217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231225 */     GIR_RootConstrainSelectedInstOperands,
     /* 231226 */     // GIR_Coverage, 11542,
     /* 231226 */     GIR_EraseRootFromParent_Done,
     /* 231227 */   // Label 4633: @231227
     /* 231227 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(231269), // Rule ID 11543 //
     /* 231232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 231240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 231259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231267 */     GIR_RootConstrainSelectedInstOperands,
     /* 231268 */     // GIR_Coverage, 11543,
     /* 231268 */     GIR_EraseRootFromParent_Done,
     /* 231269 */   // Label 4634: @231269
     /* 231269 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(231311), // Rule ID 11544 //
     /* 231274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 231282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 231301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231309 */     GIR_RootConstrainSelectedInstOperands,
     /* 231310 */     // GIR_Coverage, 11544,
     /* 231310 */     GIR_EraseRootFromParent_Done,
     /* 231311 */   // Label 4635: @231311
     /* 231311 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(231353), // Rule ID 11599 //
     /* 231316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1569:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 231343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231351 */     GIR_RootConstrainSelectedInstOperands,
     /* 231352 */     // GIR_Coverage, 11599,
     /* 231352 */     GIR_EraseRootFromParent_Done,
     /* 231353 */   // Label 4636: @231353
     /* 231353 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(231395), // Rule ID 11600 //
     /* 231358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1569:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 231385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231393 */     GIR_RootConstrainSelectedInstOperands,
     /* 231394 */     // GIR_Coverage, 11600,
     /* 231394 */     GIR_EraseRootFromParent_Done,
     /* 231395 */   // Label 4637: @231395
     /* 231395 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(231437), // Rule ID 11601 //
     /* 231400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1569:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 231427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231435 */     GIR_RootConstrainSelectedInstOperands,
     /* 231436 */     // GIR_Coverage, 11601,
     /* 231436 */     GIR_EraseRootFromParent_Done,
     /* 231437 */   // Label 4638: @231437
     /* 231437 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(231479), // Rule ID 11602 //
     /* 231442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 231469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231477 */     GIR_RootConstrainSelectedInstOperands,
     /* 231478 */     // GIR_Coverage, 11602,
     /* 231478 */     GIR_EraseRootFromParent_Done,
     /* 231479 */   // Label 4639: @231479
     /* 231479 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(231521), // Rule ID 11603 //
     /* 231484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 231511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231519 */     GIR_RootConstrainSelectedInstOperands,
     /* 231520 */     // GIR_Coverage, 11603,
     /* 231520 */     GIR_EraseRootFromParent_Done,
     /* 231521 */   // Label 4640: @231521
     /* 231521 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(231563), // Rule ID 11604 //
     /* 231526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 231553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231561 */     GIR_RootConstrainSelectedInstOperands,
     /* 231562 */     // GIR_Coverage, 11604,
     /* 231562 */     GIR_EraseRootFromParent_Done,
     /* 231563 */   // Label 4641: @231563
     /* 231563 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(231605), // Rule ID 11605 //
     /* 231568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 231576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 231595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231603 */     GIR_RootConstrainSelectedInstOperands,
     /* 231604 */     // GIR_Coverage, 11605,
     /* 231604 */     GIR_EraseRootFromParent_Done,
     /* 231605 */   // Label 4642: @231605
     /* 231605 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(231647), // Rule ID 11606 //
     /* 231610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 231618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 231637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231645 */     GIR_RootConstrainSelectedInstOperands,
     /* 231646 */     // GIR_Coverage, 11606,
     /* 231646 */     GIR_EraseRootFromParent_Done,
     /* 231647 */   // Label 4643: @231647
     /* 231647 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(231689), // Rule ID 11607 //
     /* 231652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 231660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 231679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231687 */     GIR_RootConstrainSelectedInstOperands,
     /* 231688 */     // GIR_Coverage, 11607,
     /* 231688 */     GIR_EraseRootFromParent_Done,
     /* 231689 */   // Label 4644: @231689
     /* 231689 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(231734), // Rule ID 11620 //
     /* 231694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 231697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 231702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 231705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1520:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 231721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 231732 */     GIR_RootConstrainSelectedInstOperands,
     /* 231733 */     // GIR_Coverage, 11620,
     /* 231733 */     GIR_EraseRootFromParent_Done,
     /* 231734 */   // Label 4645: @231734
     /* 231734 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(231779), // Rule ID 11621 //
     /* 231739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 231742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 231747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 231750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231763 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1520:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 231766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 231777 */     GIR_RootConstrainSelectedInstOperands,
     /* 231778 */     // GIR_Coverage, 11621,
     /* 231778 */     GIR_EraseRootFromParent_Done,
     /* 231779 */   // Label 4646: @231779
     /* 231779 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(231821), // Rule ID 11622 //
     /* 231784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 231811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231819 */     GIR_RootConstrainSelectedInstOperands,
     /* 231820 */     // GIR_Coverage, 11622,
     /* 231820 */     GIR_EraseRootFromParent_Done,
     /* 231821 */   // Label 4647: @231821
     /* 231821 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(231863), // Rule ID 11623 //
     /* 231826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 231853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231861 */     GIR_RootConstrainSelectedInstOperands,
     /* 231862 */     // GIR_Coverage, 11623,
     /* 231862 */     GIR_EraseRootFromParent_Done,
     /* 231863 */   // Label 4648: @231863
     /* 231863 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(231905), // Rule ID 11624 //
     /* 231868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 231895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231903 */     GIR_RootConstrainSelectedInstOperands,
     /* 231904 */     // GIR_Coverage, 11624,
     /* 231904 */     GIR_EraseRootFromParent_Done,
     /* 231905 */   // Label 4649: @231905
     /* 231905 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(231947), // Rule ID 11625 //
     /* 231910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 231937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231945 */     GIR_RootConstrainSelectedInstOperands,
     /* 231946 */     // GIR_Coverage, 11625,
     /* 231946 */     GIR_EraseRootFromParent_Done,
     /* 231947 */   // Label 4650: @231947
     /* 231947 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(231989), // Rule ID 11641 //
     /* 231952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 231960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1343:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 231976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 231979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231987 */     GIR_RootConstrainSelectedInstOperands,
     /* 231988 */     // GIR_Coverage, 11641,
     /* 231988 */     GIR_EraseRootFromParent_Done,
     /* 231989 */   // Label 4651: @231989
     /* 231989 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(232031), // Rule ID 11642 //
     /* 231994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232018 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1343:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 232021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232029 */     GIR_RootConstrainSelectedInstOperands,
     /* 232030 */     // GIR_Coverage, 11642,
     /* 232030 */     GIR_EraseRootFromParent_Done,
     /* 232031 */   // Label 4652: @232031
     /* 232031 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(232073), // Rule ID 11643 //
     /* 232036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1343:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 232063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232071 */     GIR_RootConstrainSelectedInstOperands,
     /* 232072 */     // GIR_Coverage, 11643,
     /* 232072 */     GIR_EraseRootFromParent_Done,
     /* 232073 */   // Label 4653: @232073
     /* 232073 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(232115), // Rule ID 11644 //
     /* 232078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232102 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 232105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232113 */     GIR_RootConstrainSelectedInstOperands,
     /* 232114 */     // GIR_Coverage, 11644,
     /* 232114 */     GIR_EraseRootFromParent_Done,
     /* 232115 */   // Label 4654: @232115
     /* 232115 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(232157), // Rule ID 11645 //
     /* 232120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 232147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232155 */     GIR_RootConstrainSelectedInstOperands,
     /* 232156 */     // GIR_Coverage, 11645,
     /* 232156 */     GIR_EraseRootFromParent_Done,
     /* 232157 */   // Label 4655: @232157
     /* 232157 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(232199), // Rule ID 11646 //
     /* 232162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 232189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232197 */     GIR_RootConstrainSelectedInstOperands,
     /* 232198 */     // GIR_Coverage, 11646,
     /* 232198 */     GIR_EraseRootFromParent_Done,
     /* 232199 */   // Label 4656: @232199
     /* 232199 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(232241), // Rule ID 11647 //
     /* 232204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232228 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1346:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 232231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232239 */     GIR_RootConstrainSelectedInstOperands,
     /* 232240 */     // GIR_Coverage, 11647,
     /* 232240 */     GIR_EraseRootFromParent_Done,
     /* 232241 */   // Label 4657: @232241
     /* 232241 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(232283), // Rule ID 11648 //
     /* 232246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232270 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1346:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 232273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232281 */     GIR_RootConstrainSelectedInstOperands,
     /* 232282 */     // GIR_Coverage, 11648,
     /* 232282 */     GIR_EraseRootFromParent_Done,
     /* 232283 */   // Label 4658: @232283
     /* 232283 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(232325), // Rule ID 11649 //
     /* 232288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232312 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1346:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 232315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232323 */     GIR_RootConstrainSelectedInstOperands,
     /* 232324 */     // GIR_Coverage, 11649,
     /* 232324 */     GIR_EraseRootFromParent_Done,
     /* 232325 */   // Label 4659: @232325
     /* 232325 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(232367), // Rule ID 11650 //
     /* 232330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232354 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 232357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232365 */     GIR_RootConstrainSelectedInstOperands,
     /* 232366 */     // GIR_Coverage, 11650,
     /* 232366 */     GIR_EraseRootFromParent_Done,
     /* 232367 */   // Label 4660: @232367
     /* 232367 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(232409), // Rule ID 11651 //
     /* 232372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232396 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 232399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232407 */     GIR_RootConstrainSelectedInstOperands,
     /* 232408 */     // GIR_Coverage, 11651,
     /* 232408 */     GIR_EraseRootFromParent_Done,
     /* 232409 */   // Label 4661: @232409
     /* 232409 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(232451), // Rule ID 11652 //
     /* 232414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232438 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 232441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232449 */     GIR_RootConstrainSelectedInstOperands,
     /* 232450 */     // GIR_Coverage, 11652,
     /* 232450 */     GIR_EraseRootFromParent_Done,
     /* 232451 */   // Label 4662: @232451
     /* 232451 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(232493), // Rule ID 11657 //
     /* 232456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 232464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232480 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 232483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232491 */     GIR_RootConstrainSelectedInstOperands,
     /* 232492 */     // GIR_Coverage, 11657,
     /* 232492 */     GIR_EraseRootFromParent_Done,
     /* 232493 */   // Label 4663: @232493
     /* 232493 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(232535), // Rule ID 11658 //
     /* 232498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 232506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232522 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 232525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232533 */     GIR_RootConstrainSelectedInstOperands,
     /* 232534 */     // GIR_Coverage, 11658,
     /* 232534 */     GIR_EraseRootFromParent_Done,
     /* 232535 */   // Label 4664: @232535
     /* 232535 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(232577), // Rule ID 11659 //
     /* 232540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 232548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232564 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 232567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232575 */     GIR_RootConstrainSelectedInstOperands,
     /* 232576 */     // GIR_Coverage, 11659,
     /* 232576 */     GIR_EraseRootFromParent_Done,
     /* 232577 */   // Label 4665: @232577
     /* 232577 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(232619), // Rule ID 11660 //
     /* 232582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 232590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232606 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 232609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232617 */     GIR_RootConstrainSelectedInstOperands,
     /* 232618 */     // GIR_Coverage, 11660,
     /* 232618 */     GIR_EraseRootFromParent_Done,
     /* 232619 */   // Label 4666: @232619
     /* 232619 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(232661), // Rule ID 11661 //
     /* 232624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1177:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232659 */     GIR_RootConstrainSelectedInstOperands,
     /* 232660 */     // GIR_Coverage, 11661,
     /* 232660 */     GIR_EraseRootFromParent_Done,
     /* 232661 */   // Label 4667: @232661
     /* 232661 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(232703), // Rule ID 11663 //
     /* 232666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1177:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232701 */     GIR_RootConstrainSelectedInstOperands,
     /* 232702 */     // GIR_Coverage, 11663,
     /* 232702 */     GIR_EraseRootFromParent_Done,
     /* 232703 */   // Label 4668: @232703
     /* 232703 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(232745), // Rule ID 11665 //
     /* 232708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1177:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232743 */     GIR_RootConstrainSelectedInstOperands,
     /* 232744 */     // GIR_Coverage, 11665,
     /* 232744 */     GIR_EraseRootFromParent_Done,
     /* 232745 */   // Label 4669: @232745
     /* 232745 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(232787), // Rule ID 11667 //
     /* 232750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1177:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232785 */     GIR_RootConstrainSelectedInstOperands,
     /* 232786 */     // GIR_Coverage, 11667,
     /* 232786 */     GIR_EraseRootFromParent_Done,
     /* 232787 */   // Label 4670: @232787
     /* 232787 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(232829), // Rule ID 11669 //
     /* 232792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232816 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1206:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232827 */     GIR_RootConstrainSelectedInstOperands,
     /* 232828 */     // GIR_Coverage, 11669,
     /* 232828 */     GIR_EraseRootFromParent_Done,
     /* 232829 */   // Label 4671: @232829
     /* 232829 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(232871), // Rule ID 11671 //
     /* 232834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1206:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232869 */     GIR_RootConstrainSelectedInstOperands,
     /* 232870 */     // GIR_Coverage, 11671,
     /* 232870 */     GIR_EraseRootFromParent_Done,
     /* 232871 */   // Label 4672: @232871
     /* 232871 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(232913), // Rule ID 11673 //
     /* 232876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1206:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232911 */     GIR_RootConstrainSelectedInstOperands,
     /* 232912 */     // GIR_Coverage, 11673,
     /* 232912 */     GIR_EraseRootFromParent_Done,
     /* 232913 */   // Label 4673: @232913
     /* 232913 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(232955), // Rule ID 11675 //
     /* 232918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1206:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232953 */     GIR_RootConstrainSelectedInstOperands,
     /* 232954 */     // GIR_Coverage, 11675,
     /* 232954 */     GIR_EraseRootFromParent_Done,
     /* 232955 */   // Label 4674: @232955
     /* 232955 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(232997), // Rule ID 11677 //
     /* 232960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 232968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232984 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1207:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 232987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232995 */     GIR_RootConstrainSelectedInstOperands,
     /* 232996 */     // GIR_Coverage, 11677,
     /* 232996 */     GIR_EraseRootFromParent_Done,
     /* 232997 */   // Label 4675: @232997
     /* 232997 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(233039), // Rule ID 11678 //
     /* 233002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1207:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233037 */     GIR_RootConstrainSelectedInstOperands,
     /* 233038 */     // GIR_Coverage, 11678,
     /* 233038 */     GIR_EraseRootFromParent_Done,
     /* 233039 */   // Label 4676: @233039
     /* 233039 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(233081), // Rule ID 11679 //
     /* 233044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1207:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233079 */     GIR_RootConstrainSelectedInstOperands,
     /* 233080 */     // GIR_Coverage, 11679,
     /* 233080 */     GIR_EraseRootFromParent_Done,
     /* 233081 */   // Label 4677: @233081
     /* 233081 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(233123), // Rule ID 11680 //
     /* 233086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1207:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233121 */     GIR_RootConstrainSelectedInstOperands,
     /* 233122 */     // GIR_Coverage, 11680,
     /* 233122 */     GIR_EraseRootFromParent_Done,
     /* 233123 */   // Label 4678: @233123
     /* 233123 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(233165), // Rule ID 11681 //
     /* 233128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1208:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233163 */     GIR_RootConstrainSelectedInstOperands,
     /* 233164 */     // GIR_Coverage, 11681,
     /* 233164 */     GIR_EraseRootFromParent_Done,
     /* 233165 */   // Label 4679: @233165
     /* 233165 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(233207), // Rule ID 11682 //
     /* 233170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1208:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233205 */     GIR_RootConstrainSelectedInstOperands,
     /* 233206 */     // GIR_Coverage, 11682,
     /* 233206 */     GIR_EraseRootFromParent_Done,
     /* 233207 */   // Label 4680: @233207
     /* 233207 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(233249), // Rule ID 11683 //
     /* 233212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1208:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233247 */     GIR_RootConstrainSelectedInstOperands,
     /* 233248 */     // GIR_Coverage, 11683,
     /* 233248 */     GIR_EraseRootFromParent_Done,
     /* 233249 */   // Label 4681: @233249
     /* 233249 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(233291), // Rule ID 11684 //
     /* 233254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1208:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233289 */     GIR_RootConstrainSelectedInstOperands,
     /* 233290 */     // GIR_Coverage, 11684,
     /* 233290 */     GIR_EraseRootFromParent_Done,
     /* 233291 */   // Label 4682: @233291
     /* 233291 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(233333), // Rule ID 11685 //
     /* 233296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1518:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233331 */     GIR_RootConstrainSelectedInstOperands,
     /* 233332 */     // GIR_Coverage, 11685,
     /* 233332 */     GIR_EraseRootFromParent_Done,
     /* 233333 */   // Label 4683: @233333
     /* 233333 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(233375), // Rule ID 11687 //
     /* 233338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1518:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233373 */     GIR_RootConstrainSelectedInstOperands,
     /* 233374 */     // GIR_Coverage, 11687,
     /* 233374 */     GIR_EraseRootFromParent_Done,
     /* 233375 */   // Label 4684: @233375
     /* 233375 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(233417), // Rule ID 11689 //
     /* 233380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1518:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233415 */     GIR_RootConstrainSelectedInstOperands,
     /* 233416 */     // GIR_Coverage, 11689,
     /* 233416 */     GIR_EraseRootFromParent_Done,
     /* 233417 */   // Label 4685: @233417
     /* 233417 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(233459), // Rule ID 11691 //
     /* 233422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1518:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233457 */     GIR_RootConstrainSelectedInstOperands,
     /* 233458 */     // GIR_Coverage, 11691,
     /* 233458 */     GIR_EraseRootFromParent_Done,
     /* 233459 */   // Label 4686: @233459
     /* 233459 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(233501), // Rule ID 11780 //
     /* 233464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 233491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233499 */     GIR_RootConstrainSelectedInstOperands,
     /* 233500 */     // GIR_Coverage, 11780,
     /* 233500 */     GIR_EraseRootFromParent_Done,
     /* 233501 */   // Label 4687: @233501
     /* 233501 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(233543), // Rule ID 11782 //
     /* 233506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 233533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233541 */     GIR_RootConstrainSelectedInstOperands,
     /* 233542 */     // GIR_Coverage, 11782,
     /* 233542 */     GIR_EraseRootFromParent_Done,
     /* 233543 */   // Label 4688: @233543
     /* 233543 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(233585), // Rule ID 11784 //
     /* 233548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 233575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233583 */     GIR_RootConstrainSelectedInstOperands,
     /* 233584 */     // GIR_Coverage, 11784,
     /* 233584 */     GIR_EraseRootFromParent_Done,
     /* 233585 */   // Label 4689: @233585
     /* 233585 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(233627), // Rule ID 11786 //
     /* 233590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 233617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233625 */     GIR_RootConstrainSelectedInstOperands,
     /* 233626 */     // GIR_Coverage, 11786,
     /* 233626 */     GIR_EraseRootFromParent_Done,
     /* 233627 */   // Label 4690: @233627
     /* 233627 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(233669), // Rule ID 11788 //
     /* 233632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 233635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 233640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233656 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 233656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 233659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233667 */     GIR_RootConstrainSelectedInstOperands,
     /* 233668 */     // GIR_Coverage, 11788,
     /* 233668 */     GIR_EraseRootFromParent_Done,
     /* 233669 */   // Label 4691: @233669
     /* 233669 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(233711), // Rule ID 11790 //
     /* 233674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 233677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 233682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 233701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233709 */     GIR_RootConstrainSelectedInstOperands,
     /* 233710 */     // GIR_Coverage, 11790,
     /* 233710 */     GIR_EraseRootFromParent_Done,
     /* 233711 */   // Label 4692: @233711
     /* 233711 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(233753), // Rule ID 11953 //
     /* 233716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 233743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233751 */     GIR_RootConstrainSelectedInstOperands,
     /* 233752 */     // GIR_Coverage, 11953,
     /* 233752 */     GIR_EraseRootFromParent_Done,
     /* 233753 */   // Label 4693: @233753
     /* 233753 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(233795), // Rule ID 11954 //
     /* 233758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 233785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233793 */     GIR_RootConstrainSelectedInstOperands,
     /* 233794 */     // GIR_Coverage, 11954,
     /* 233794 */     GIR_EraseRootFromParent_Done,
     /* 233795 */   // Label 4694: @233795
     /* 233795 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(233837), // Rule ID 11955 //
     /* 233800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 233827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233835 */     GIR_RootConstrainSelectedInstOperands,
     /* 233836 */     // GIR_Coverage, 11955,
     /* 233836 */     GIR_EraseRootFromParent_Done,
     /* 233837 */   // Label 4695: @233837
     /* 233837 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(233879), // Rule ID 11956 //
     /* 233842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 233869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233877 */     GIR_RootConstrainSelectedInstOperands,
     /* 233878 */     // GIR_Coverage, 11956,
     /* 233878 */     GIR_EraseRootFromParent_Done,
     /* 233879 */   // Label 4696: @233879
     /* 233879 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(233921), // Rule ID 11957 //
     /* 233884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233908 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1825:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 233911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233919 */     GIR_RootConstrainSelectedInstOperands,
     /* 233920 */     // GIR_Coverage, 11957,
     /* 233920 */     GIR_EraseRootFromParent_Done,
     /* 233921 */   // Label 4697: @233921
     /* 233921 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(233963), // Rule ID 11958 //
     /* 233926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233950 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1825:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 233953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233961 */     GIR_RootConstrainSelectedInstOperands,
     /* 233962 */     // GIR_Coverage, 11958,
     /* 233962 */     GIR_EraseRootFromParent_Done,
     /* 233963 */   // Label 4698: @233963
     /* 233963 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(234005), // Rule ID 11959 //
     /* 233968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233992 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1825:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 233995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234003 */     GIR_RootConstrainSelectedInstOperands,
     /* 234004 */     // GIR_Coverage, 11959,
     /* 234004 */     GIR_EraseRootFromParent_Done,
     /* 234005 */   // Label 4699: @234005
     /* 234005 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(234047), // Rule ID 12304 //
     /* 234010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234034 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 234037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234045 */     GIR_RootConstrainSelectedInstOperands,
     /* 234046 */     // GIR_Coverage, 12304,
     /* 234046 */     GIR_EraseRootFromParent_Done,
     /* 234047 */   // Label 4700: @234047
     /* 234047 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(234089), // Rule ID 12305 //
     /* 234052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 234079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234087 */     GIR_RootConstrainSelectedInstOperands,
     /* 234088 */     // GIR_Coverage, 12305,
     /* 234088 */     GIR_EraseRootFromParent_Done,
     /* 234089 */   // Label 4701: @234089
     /* 234089 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(234131), // Rule ID 12306 //
     /* 234094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234118 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 234121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234129 */     GIR_RootConstrainSelectedInstOperands,
     /* 234130 */     // GIR_Coverage, 12306,
     /* 234130 */     GIR_EraseRootFromParent_Done,
     /* 234131 */   // Label 4702: @234131
     /* 234131 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(234173), // Rule ID 12307 //
     /* 234136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234160 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 234163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234171 */     GIR_RootConstrainSelectedInstOperands,
     /* 234172 */     // GIR_Coverage, 12307,
     /* 234172 */     GIR_EraseRootFromParent_Done,
     /* 234173 */   // Label 4703: @234173
     /* 234173 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(234215), // Rule ID 12308 //
     /* 234178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234202 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 234205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234213 */     GIR_RootConstrainSelectedInstOperands,
     /* 234214 */     // GIR_Coverage, 12308,
     /* 234214 */     GIR_EraseRootFromParent_Done,
     /* 234215 */   // Label 4704: @234215
     /* 234215 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(234257), // Rule ID 12309 //
     /* 234220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234244 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 234247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234255 */     GIR_RootConstrainSelectedInstOperands,
     /* 234256 */     // GIR_Coverage, 12309,
     /* 234256 */     GIR_EraseRootFromParent_Done,
     /* 234257 */   // Label 4705: @234257
     /* 234257 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(234299), // Rule ID 12310 //
     /* 234262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234286 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234297 */     GIR_RootConstrainSelectedInstOperands,
     /* 234298 */     // GIR_Coverage, 12310,
     /* 234298 */     GIR_EraseRootFromParent_Done,
     /* 234299 */   // Label 4706: @234299
     /* 234299 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(234341), // Rule ID 12313 //
     /* 234304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 234315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 234321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 234324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234328 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 234328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234339 */     GIR_RootConstrainSelectedInstOperands,
     /* 234340 */     // GIR_Coverage, 12313,
     /* 234340 */     GIR_EraseRootFromParent_Done,
     /* 234341 */   // Label 4707: @234341
     /* 234341 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(234383), // Rule ID 12316 //
     /* 234346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 234357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 234363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 234366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234370 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 234370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234381 */     GIR_RootConstrainSelectedInstOperands,
     /* 234382 */     // GIR_Coverage, 12316,
     /* 234382 */     GIR_EraseRootFromParent_Done,
     /* 234383 */   // Label 4708: @234383
     /* 234383 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(234425), // Rule ID 12319 //
     /* 234388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234412 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 234415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234423 */     GIR_RootConstrainSelectedInstOperands,
     /* 234424 */     // GIR_Coverage, 12319,
     /* 234424 */     GIR_EraseRootFromParent_Done,
     /* 234425 */   // Label 4709: @234425
     /* 234425 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(234467), // Rule ID 12322 //
     /* 234430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 234441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 234447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 234450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 234454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 234457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234465 */     GIR_RootConstrainSelectedInstOperands,
     /* 234466 */     // GIR_Coverage, 12322,
     /* 234466 */     GIR_EraseRootFromParent_Done,
     /* 234467 */   // Label 4710: @234467
     /* 234467 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(234509), // Rule ID 12325 //
     /* 234472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 234499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234507 */     GIR_RootConstrainSelectedInstOperands,
     /* 234508 */     // GIR_Coverage, 12325,
     /* 234508 */     GIR_EraseRootFromParent_Done,
     /* 234509 */   // Label 4711: @234509
     /* 234509 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(234551), // Rule ID 12328 //
     /* 234514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234538 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234549 */     GIR_RootConstrainSelectedInstOperands,
     /* 234550 */     // GIR_Coverage, 12328,
     /* 234550 */     GIR_EraseRootFromParent_Done,
     /* 234551 */   // Label 4712: @234551
     /* 234551 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(234593), // Rule ID 12331 //
     /* 234556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 234567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 234573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 234576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234580 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 234580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234591 */     GIR_RootConstrainSelectedInstOperands,
     /* 234592 */     // GIR_Coverage, 12331,
     /* 234592 */     GIR_EraseRootFromParent_Done,
     /* 234593 */   // Label 4713: @234593
     /* 234593 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(234635), // Rule ID 12334 //
     /* 234598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 234609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 234615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 234618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 234622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234633 */     GIR_RootConstrainSelectedInstOperands,
     /* 234634 */     // GIR_Coverage, 12334,
     /* 234634 */     GIR_EraseRootFromParent_Done,
     /* 234635 */   // Label 4714: @234635
     /* 234635 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(234677), // Rule ID 12337 //
     /* 234640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234664 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 234667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234675 */     GIR_RootConstrainSelectedInstOperands,
     /* 234676 */     // GIR_Coverage, 12337,
     /* 234676 */     GIR_EraseRootFromParent_Done,
     /* 234677 */   // Label 4715: @234677
     /* 234677 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(234719), // Rule ID 12340 //
     /* 234682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 234693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 234699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 234702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234706 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 234706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 234709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234717 */     GIR_RootConstrainSelectedInstOperands,
     /* 234718 */     // GIR_Coverage, 12340,
     /* 234718 */     GIR_EraseRootFromParent_Done,
     /* 234719 */   // Label 4716: @234719
     /* 234719 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(234761), // Rule ID 12343 //
     /* 234724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234748 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 234751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234759 */     GIR_RootConstrainSelectedInstOperands,
     /* 234760 */     // GIR_Coverage, 12343,
     /* 234760 */     GIR_EraseRootFromParent_Done,
     /* 234761 */   // Label 4717: @234761
     /* 234761 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(234904), // Rule ID 5518 //
     /* 234766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 234769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 234774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 234777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 234780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 234783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234787 */     // MIs[0] idx
     /* 234787 */     // No operand predicates
     /* 234787 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 234787 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 234790 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234794 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 234801 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 234804 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 234808 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234813 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 234816 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 234820 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 234823 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234828 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234833 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 234841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 234852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 234855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 234859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234864 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 234867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 234871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 234874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 234892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 234894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 234900 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234902 */     GIR_RootConstrainSelectedInstOperands,
     /* 234903 */     // GIR_Coverage, 5518,
     /* 234903 */     GIR_EraseRootFromParent_Done,
     /* 234904 */   // Label 4718: @234904
     /* 234904 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(234995), // Rule ID 5519 //
     /* 234909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 234912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 234917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 234920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 234923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 234926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234930 */     // MIs[0] idx
     /* 234930 */     // No operand predicates
     /* 234930 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 234930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 234933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 234944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 234947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 234951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234956 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 234959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 234963 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 234966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 234984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 234986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 234991 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234993 */     GIR_RootConstrainSelectedInstOperands,
     /* 234994 */     // GIR_Coverage, 5519,
     /* 234994 */     GIR_EraseRootFromParent_Done,
     /* 234995 */   // Label 4719: @234995
     /* 234995 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(235086), // Rule ID 5520 //
     /* 235000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235021 */     // MIs[0] idx
     /* 235021 */     // No operand predicates
     /* 235021 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235082 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235084 */     GIR_RootConstrainSelectedInstOperands,
     /* 235085 */     // GIR_Coverage, 5520,
     /* 235085 */     GIR_EraseRootFromParent_Done,
     /* 235086 */   // Label 4720: @235086
     /* 235086 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(235125), // Rule ID 5521 //
     /* 235091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235112 */     // MIs[0] idx
     /* 235112 */     // No operand predicates
     /* 235112 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235121 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235123 */     GIR_RootConstrainSelectedInstOperands,
     /* 235124 */     // GIR_Coverage, 5521,
     /* 235124 */     GIR_EraseRootFromParent_Done,
     /* 235125 */   // Label 4721: @235125
     /* 235125 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(235268), // Rule ID 5522 //
     /* 235130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235151 */     // MIs[0] idx
     /* 235151 */     // No operand predicates
     /* 235151 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235151 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235154 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235158 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235165 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235168 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235172 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235177 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235180 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235184 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235187 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235192 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235197 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235228 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 235264 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235266 */     GIR_RootConstrainSelectedInstOperands,
     /* 235267 */     // GIR_Coverage, 5522,
     /* 235267 */     GIR_EraseRootFromParent_Done,
     /* 235268 */   // Label 4722: @235268
     /* 235268 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(235359), // Rule ID 5523 //
     /* 235273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235294 */     // MIs[0] idx
     /* 235294 */     // No operand predicates
     /* 235294 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235320 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235355 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235357 */     GIR_RootConstrainSelectedInstOperands,
     /* 235358 */     // GIR_Coverage, 5523,
     /* 235358 */     GIR_EraseRootFromParent_Done,
     /* 235359 */   // Label 4723: @235359
     /* 235359 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(235450), // Rule ID 5524 //
     /* 235364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235385 */     // MIs[0] idx
     /* 235385 */     // No operand predicates
     /* 235385 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235446 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235448 */     GIR_RootConstrainSelectedInstOperands,
     /* 235449 */     // GIR_Coverage, 5524,
     /* 235449 */     GIR_EraseRootFromParent_Done,
     /* 235450 */   // Label 4724: @235450
     /* 235450 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(235489), // Rule ID 5525 //
     /* 235455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235476 */     // MIs[0] idx
     /* 235476 */     // No operand predicates
     /* 235476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235485 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235487 */     GIR_RootConstrainSelectedInstOperands,
     /* 235488 */     // GIR_Coverage, 5525,
     /* 235488 */     GIR_EraseRootFromParent_Done,
     /* 235489 */   // Label 4725: @235489
     /* 235489 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(235632), // Rule ID 5526 //
     /* 235494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235515 */     // MIs[0] idx
     /* 235515 */     // No operand predicates
     /* 235515 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235515 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235518 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235522 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235529 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235532 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235536 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235541 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235544 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235548 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235551 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235556 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235561 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 235628 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235630 */     GIR_RootConstrainSelectedInstOperands,
     /* 235631 */     // GIR_Coverage, 5526,
     /* 235631 */     GIR_EraseRootFromParent_Done,
     /* 235632 */   // Label 4726: @235632
     /* 235632 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(235723), // Rule ID 5527 //
     /* 235637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235658 */     // MIs[0] idx
     /* 235658 */     // No operand predicates
     /* 235658 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235719 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235721 */     GIR_RootConstrainSelectedInstOperands,
     /* 235722 */     // GIR_Coverage, 5527,
     /* 235722 */     GIR_EraseRootFromParent_Done,
     /* 235723 */   // Label 4727: @235723
     /* 235723 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(235814), // Rule ID 5528 //
     /* 235728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235749 */     // MIs[0] idx
     /* 235749 */     // No operand predicates
     /* 235749 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235749 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235752 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235756 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235810 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235812 */     GIR_RootConstrainSelectedInstOperands,
     /* 235813 */     // GIR_Coverage, 5528,
     /* 235813 */     GIR_EraseRootFromParent_Done,
     /* 235814 */   // Label 4728: @235814
     /* 235814 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(235853), // Rule ID 5529 //
     /* 235819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235840 */     // MIs[0] idx
     /* 235840 */     // No operand predicates
     /* 235840 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235849 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235851 */     GIR_RootConstrainSelectedInstOperands,
     /* 235852 */     // GIR_Coverage, 5529,
     /* 235852 */     GIR_EraseRootFromParent_Done,
     /* 235853 */   // Label 4729: @235853
     /* 235853 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(235892), // Rule ID 5530 //
     /* 235858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 235866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235879 */     // MIs[0] idx
     /* 235879 */     // No operand predicates
     /* 235879 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 235879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 235882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235888 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235890 */     GIR_RootConstrainSelectedInstOperands,
     /* 235891 */     // GIR_Coverage, 5530,
     /* 235891 */     GIR_EraseRootFromParent_Done,
     /* 235892 */   // Label 4730: @235892
     /* 235892 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(235983), // Rule ID 5531 //
     /* 235897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 235905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235918 */     // MIs[0] idx
     /* 235918 */     // No operand predicates
     /* 235918 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 235918 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235921 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235925 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235944 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235951 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 235972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235979 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235981 */     GIR_RootConstrainSelectedInstOperands,
     /* 235982 */     // GIR_Coverage, 5531,
     /* 235982 */     GIR_EraseRootFromParent_Done,
     /* 235983 */   // Label 4731: @235983
     /* 235983 */   GIM_Reject,
     /* 235984 */ // Label 3855: @235984
     /* 235984 */ GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(243095),
     /* 235989 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 235992 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236039), // Rule ID 2951 //
     /* 235997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 236020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1509:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 236024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 236027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236035 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236037 */     GIR_RootConstrainSelectedInstOperands,
     /* 236038 */     // GIR_Coverage, 2951,
     /* 236038 */     GIR_EraseRootFromParent_Done,
     /* 236039 */   // Label 4733: @236039
     /* 236039 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236086), // Rule ID 2953 //
     /* 236044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 236067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1509:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 236071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 236074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236082 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236084 */     GIR_RootConstrainSelectedInstOperands,
     /* 236085 */     // GIR_Coverage, 2953,
     /* 236085 */     GIR_EraseRootFromParent_Done,
     /* 236086 */   // Label 4734: @236086
     /* 236086 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(236133), // Rule ID 2955 //
     /* 236091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 236114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1509:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 236118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 236121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236129 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236131 */     GIR_RootConstrainSelectedInstOperands,
     /* 236132 */     // GIR_Coverage, 2955,
     /* 236132 */     GIR_EraseRootFromParent_Done,
     /* 236133 */   // Label 4735: @236133
     /* 236133 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(236180), // Rule ID 2957 //
     /* 236138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 236161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1509:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 236165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 236168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236176 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236178 */     GIR_RootConstrainSelectedInstOperands,
     /* 236179 */     // GIR_Coverage, 2957,
     /* 236179 */     GIR_EraseRootFromParent_Done,
     /* 236180 */   // Label 4736: @236180
     /* 236180 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(236227), // Rule ID 7430 //
     /* 236185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 236208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1512:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 236212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 236215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236223 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236225 */     GIR_RootConstrainSelectedInstOperands,
     /* 236226 */     // GIR_Coverage, 7430,
     /* 236226 */     GIR_EraseRootFromParent_Done,
     /* 236227 */   // Label 4737: @236227
     /* 236227 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(236274), // Rule ID 7432 //
     /* 236232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 236255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1512:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 236259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 236262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236270 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236272 */     GIR_RootConstrainSelectedInstOperands,
     /* 236273 */     // GIR_Coverage, 7432,
     /* 236273 */     GIR_EraseRootFromParent_Done,
     /* 236274 */   // Label 4738: @236274
     /* 236274 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(236321), // Rule ID 7434 //
     /* 236279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 236302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1512:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 236306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 236309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236317 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236319 */     GIR_RootConstrainSelectedInstOperands,
     /* 236320 */     // GIR_Coverage, 7434,
     /* 236320 */     GIR_EraseRootFromParent_Done,
     /* 236321 */   // Label 4739: @236321
     /* 236321 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(236368), // Rule ID 7436 //
     /* 236326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 236349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1512:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 236353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 236356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236364 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236366 */     GIR_RootConstrainSelectedInstOperands,
     /* 236367 */     // GIR_Coverage, 7436,
     /* 236367 */     GIR_EraseRootFromParent_Done,
     /* 236368 */   // Label 4740: @236368
     /* 236368 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(236448), // Rule ID 5638 //
     /* 236373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 236381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 236384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 236390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 236413 */     // MIs[1] Operand 1
     /* 236413 */     // No operand predicates
     /* 236413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236425 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 236429 */     // MIs[2] Operand 1
     /* 236429 */     // No operand predicates
     /* 236429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236431 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 236431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 236434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236446 */     GIR_RootConstrainSelectedInstOperands,
     /* 236447 */     // GIR_Coverage, 5638,
     /* 236447 */     GIR_EraseRootFromParent_Done,
     /* 236448 */   // Label 4741: @236448
     /* 236448 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(236528), // Rule ID 5639 //
     /* 236453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 236493 */     // MIs[1] Operand 1
     /* 236493 */     // No operand predicates
     /* 236493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 236509 */     // MIs[2] Operand 1
     /* 236509 */     // No operand predicates
     /* 236509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236511 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 236511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 236514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236526 */     GIR_RootConstrainSelectedInstOperands,
     /* 236527 */     // GIR_Coverage, 5639,
     /* 236527 */     GIR_EraseRootFromParent_Done,
     /* 236528 */   // Label 4742: @236528
     /* 236528 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(236608), // Rule ID 5640 //
     /* 236533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 236573 */     // MIs[1] Operand 1
     /* 236573 */     // No operand predicates
     /* 236573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236585 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 236589 */     // MIs[2] Operand 1
     /* 236589 */     // No operand predicates
     /* 236589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 236591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 236594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236606 */     GIR_RootConstrainSelectedInstOperands,
     /* 236607 */     // GIR_Coverage, 5640,
     /* 236607 */     GIR_EraseRootFromParent_Done,
     /* 236608 */   // Label 4743: @236608
     /* 236608 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(236688), // Rule ID 5641 //
     /* 236613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 236621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 236624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 236630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 236653 */     // MIs[1] Operand 1
     /* 236653 */     // No operand predicates
     /* 236653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 236669 */     // MIs[2] Operand 1
     /* 236669 */     // No operand predicates
     /* 236669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236671 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 236671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 236674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236686 */     GIR_RootConstrainSelectedInstOperands,
     /* 236687 */     // GIR_Coverage, 5641,
     /* 236687 */     GIR_EraseRootFromParent_Done,
     /* 236688 */   // Label 4744: @236688
     /* 236688 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(236752), // Rule ID 3791 //
     /* 236693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 236701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236729 */     // MIs[0] imm
     /* 236729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236737 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 236740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236748 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236750 */     GIR_RootConstrainSelectedInstOperands,
     /* 236751 */     // GIR_Coverage, 3791,
     /* 236751 */     GIR_EraseRootFromParent_Done,
     /* 236752 */   // Label 4745: @236752
     /* 236752 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(236816), // Rule ID 3792 //
     /* 236757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 236765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236793 */     // MIs[0] imm
     /* 236793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236801 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 236804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236812 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236814 */     GIR_RootConstrainSelectedInstOperands,
     /* 236815 */     // GIR_Coverage, 3792,
     /* 236815 */     GIR_EraseRootFromParent_Done,
     /* 236816 */   // Label 4746: @236816
     /* 236816 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(236880), // Rule ID 3793 //
     /* 236821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 236829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236857 */     // MIs[0] imm
     /* 236857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236865 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 236868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236876 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236878 */     GIR_RootConstrainSelectedInstOperands,
     /* 236879 */     // GIR_Coverage, 3793,
     /* 236879 */     GIR_EraseRootFromParent_Done,
     /* 236880 */   // Label 4747: @236880
     /* 236880 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(236944), // Rule ID 3794 //
     /* 236885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 236893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236921 */     // MIs[0] imm
     /* 236921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236929 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 236932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236940 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236942 */     GIR_RootConstrainSelectedInstOperands,
     /* 236943 */     // GIR_Coverage, 3794,
     /* 236943 */     GIR_EraseRootFromParent_Done,
     /* 236944 */   // Label 4748: @236944
     /* 236944 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(236996), // Rule ID 2836 //
     /* 236949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 236957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236973 */     // MIs[0] idx
     /* 236973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 236981 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 236981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 236984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236992 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 236994 */     GIR_RootConstrainSelectedInstOperands,
     /* 236995 */     // GIR_Coverage, 2836,
     /* 236995 */     GIR_EraseRootFromParent_Done,
     /* 236996 */   // Label 4749: @236996
     /* 236996 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237048), // Rule ID 2837 //
     /* 237001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237025 */     // MIs[0] idx
     /* 237025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237033 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 237036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237044 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237046 */     GIR_RootConstrainSelectedInstOperands,
     /* 237047 */     // GIR_Coverage, 2837,
     /* 237047 */     GIR_EraseRootFromParent_Done,
     /* 237048 */   // Label 4750: @237048
     /* 237048 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237100), // Rule ID 2838 //
     /* 237053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237077 */     // MIs[0] idx
     /* 237077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237085 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 237085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 237088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237096 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237098 */     GIR_RootConstrainSelectedInstOperands,
     /* 237099 */     // GIR_Coverage, 2838,
     /* 237099 */     GIR_EraseRootFromParent_Done,
     /* 237100 */   // Label 4751: @237100
     /* 237100 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237152), // Rule ID 2966 //
     /* 237105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237129 */     // MIs[0] Op4
     /* 237129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237137 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1508:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 237140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237148 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237150 */     GIR_RootConstrainSelectedInstOperands,
     /* 237151 */     // GIR_Coverage, 2966,
     /* 237151 */     GIR_EraseRootFromParent_Done,
     /* 237152 */   // Label 4752: @237152
     /* 237152 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237204), // Rule ID 2967 //
     /* 237157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237181 */     // MIs[0] Op4
     /* 237181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1508:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 237192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237200 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237202 */     GIR_RootConstrainSelectedInstOperands,
     /* 237203 */     // GIR_Coverage, 2967,
     /* 237203 */     GIR_EraseRootFromParent_Done,
     /* 237204 */   // Label 4753: @237204
     /* 237204 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237256), // Rule ID 2968 //
     /* 237209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237233 */     // MIs[0] Op4
     /* 237233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237241 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1508:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 237244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237252 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237254 */     GIR_RootConstrainSelectedInstOperands,
     /* 237255 */     // GIR_Coverage, 2968,
     /* 237255 */     GIR_EraseRootFromParent_Done,
     /* 237256 */   // Label 4754: @237256
     /* 237256 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237308), // Rule ID 2969 //
     /* 237261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 237269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237285 */     // MIs[0] Op4
     /* 237285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1650:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 237296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237304 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237306 */     GIR_RootConstrainSelectedInstOperands,
     /* 237307 */     // GIR_Coverage, 2969,
     /* 237307 */     GIR_EraseRootFromParent_Done,
     /* 237308 */   // Label 4755: @237308
     /* 237308 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237360), // Rule ID 2970 //
     /* 237313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 237321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237337 */     // MIs[0] Op4
     /* 237337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 237348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237356 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237358 */     GIR_RootConstrainSelectedInstOperands,
     /* 237359 */     // GIR_Coverage, 2970,
     /* 237359 */     GIR_EraseRootFromParent_Done,
     /* 237360 */   // Label 4756: @237360
     /* 237360 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237412), // Rule ID 2973 //
     /* 237365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 237373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237389 */     // MIs[0] Op4
     /* 237389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 237400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237408 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237410 */     GIR_RootConstrainSelectedInstOperands,
     /* 237411 */     // GIR_Coverage, 2973,
     /* 237411 */     GIR_EraseRootFromParent_Done,
     /* 237412 */   // Label 4757: @237412
     /* 237412 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237464), // Rule ID 2974 //
     /* 237417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 237425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237441 */     // MIs[0] Op4
     /* 237441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 237452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237460 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237462 */     GIR_RootConstrainSelectedInstOperands,
     /* 237463 */     // GIR_Coverage, 2974,
     /* 237463 */     GIR_EraseRootFromParent_Done,
     /* 237464 */   // Label 4758: @237464
     /* 237464 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237516), // Rule ID 3442 //
     /* 237469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 237472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 237477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237493 */     // MIs[0] Op4
     /* 237493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 237504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237512 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237514 */     GIR_RootConstrainSelectedInstOperands,
     /* 237515 */     // GIR_Coverage, 3442,
     /* 237515 */     GIR_EraseRootFromParent_Done,
     /* 237516 */   // Label 4759: @237516
     /* 237516 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237568), // Rule ID 3486 //
     /* 237521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 237524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 237529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237545 */     // MIs[0] Op4
     /* 237545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 237556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237564 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237566 */     GIR_RootConstrainSelectedInstOperands,
     /* 237567 */     // GIR_Coverage, 3486,
     /* 237567 */     GIR_EraseRootFromParent_Done,
     /* 237568 */   // Label 4760: @237568
     /* 237568 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(237620), // Rule ID 7500 //
     /* 237573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 237581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237597 */     // MIs[0] Op4
     /* 237597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 237608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237618 */     GIR_RootConstrainSelectedInstOperands,
     /* 237619 */     // GIR_Coverage, 7500,
     /* 237619 */     GIR_EraseRootFromParent_Done,
     /* 237620 */   // Label 4761: @237620
     /* 237620 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(237672), // Rule ID 7501 //
     /* 237625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 237633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237649 */     // MIs[0] Op4
     /* 237649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 237660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237668 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237670 */     GIR_RootConstrainSelectedInstOperands,
     /* 237671 */     // GIR_Coverage, 7501,
     /* 237671 */     GIR_EraseRootFromParent_Done,
     /* 237672 */   // Label 4762: @237672
     /* 237672 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(237724), // Rule ID 8141 //
     /* 237677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 237685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237701 */     // MIs[0] idx
     /* 237701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237709 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1375:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 237709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 237712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237720 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237722 */     GIR_RootConstrainSelectedInstOperands,
     /* 237723 */     // GIR_Coverage, 8141,
     /* 237723 */     GIR_EraseRootFromParent_Done,
     /* 237724 */   // Label 4763: @237724
     /* 237724 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(237776), // Rule ID 8142 //
     /* 237729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 237737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237753 */     // MIs[0] idx
     /* 237753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237761 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 237764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237772 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237774 */     GIR_RootConstrainSelectedInstOperands,
     /* 237775 */     // GIR_Coverage, 8142,
     /* 237775 */     GIR_EraseRootFromParent_Done,
     /* 237776 */   // Label 4764: @237776
     /* 237776 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(237828), // Rule ID 8143 //
     /* 237781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 237789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237805 */     // MIs[0] idx
     /* 237805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1375:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 237813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 237816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237824 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237826 */     GIR_RootConstrainSelectedInstOperands,
     /* 237827 */     // GIR_Coverage, 8143,
     /* 237827 */     GIR_EraseRootFromParent_Done,
     /* 237828 */   // Label 4765: @237828
     /* 237828 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(237880), // Rule ID 11059 //
     /* 237833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 237836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 237841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237857 */     // MIs[0] Op4
     /* 237857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 237868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237878 */     GIR_RootConstrainSelectedInstOperands,
     /* 237879 */     // GIR_Coverage, 11059,
     /* 237879 */     GIR_EraseRootFromParent_Done,
     /* 237880 */   // Label 4766: @237880
     /* 237880 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(237932), // Rule ID 11106 //
     /* 237885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 237893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237909 */     // MIs[0] Op4
     /* 237909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1511:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 237920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237930 */     GIR_RootConstrainSelectedInstOperands,
     /* 237931 */     // GIR_Coverage, 11106,
     /* 237931 */     GIR_EraseRootFromParent_Done,
     /* 237932 */   // Label 4767: @237932
     /* 237932 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(237984), // Rule ID 11107 //
     /* 237937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 237945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237961 */     // MIs[0] Op4
     /* 237961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1511:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 237972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237980 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237982 */     GIR_RootConstrainSelectedInstOperands,
     /* 237983 */     // GIR_Coverage, 11107,
     /* 237983 */     GIR_EraseRootFromParent_Done,
     /* 237984 */   // Label 4768: @237984
     /* 237984 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238036), // Rule ID 11108 //
     /* 237989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 237997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238013 */     // MIs[0] Op4
     /* 238013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1511:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 238024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238032 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238034 */     GIR_RootConstrainSelectedInstOperands,
     /* 238035 */     // GIR_Coverage, 11108,
     /* 238035 */     GIR_EraseRootFromParent_Done,
     /* 238036 */   // Label 4769: @238036
     /* 238036 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238088), // Rule ID 11109 //
     /* 238041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238065 */     // MIs[0] Op4
     /* 238065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 238076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238084 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238086 */     GIR_RootConstrainSelectedInstOperands,
     /* 238087 */     // GIR_Coverage, 11109,
     /* 238087 */     GIR_EraseRootFromParent_Done,
     /* 238088 */   // Label 4770: @238088
     /* 238088 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238140), // Rule ID 11110 //
     /* 238093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238117 */     // MIs[0] Op4
     /* 238117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 238128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238136 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238138 */     GIR_RootConstrainSelectedInstOperands,
     /* 238139 */     // GIR_Coverage, 11110,
     /* 238139 */     GIR_EraseRootFromParent_Done,
     /* 238140 */   // Label 4771: @238140
     /* 238140 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238192), // Rule ID 11111 //
     /* 238145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238169 */     // MIs[0] Op4
     /* 238169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 238180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238188 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238190 */     GIR_RootConstrainSelectedInstOperands,
     /* 238191 */     // GIR_Coverage, 11111,
     /* 238191 */     GIR_EraseRootFromParent_Done,
     /* 238192 */   // Label 4772: @238192
     /* 238192 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238244), // Rule ID 11112 //
     /* 238197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238221 */     // MIs[0] Op4
     /* 238221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 238232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238240 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238242 */     GIR_RootConstrainSelectedInstOperands,
     /* 238243 */     // GIR_Coverage, 11112,
     /* 238243 */     GIR_EraseRootFromParent_Done,
     /* 238244 */   // Label 4773: @238244
     /* 238244 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238296), // Rule ID 11113 //
     /* 238249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238273 */     // MIs[0] Op4
     /* 238273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238281 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 238284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238292 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238294 */     GIR_RootConstrainSelectedInstOperands,
     /* 238295 */     // GIR_Coverage, 11113,
     /* 238295 */     GIR_EraseRootFromParent_Done,
     /* 238296 */   // Label 4774: @238296
     /* 238296 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238348), // Rule ID 11114 //
     /* 238301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238325 */     // MIs[0] Op4
     /* 238325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 238336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238344 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238346 */     GIR_RootConstrainSelectedInstOperands,
     /* 238347 */     // GIR_Coverage, 11114,
     /* 238347 */     GIR_EraseRootFromParent_Done,
     /* 238348 */   // Label 4775: @238348
     /* 238348 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238400), // Rule ID 11157 //
     /* 238353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 238361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238377 */     // MIs[0] Op4
     /* 238377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238385 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1652:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238396 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238398 */     GIR_RootConstrainSelectedInstOperands,
     /* 238399 */     // GIR_Coverage, 11157,
     /* 238399 */     GIR_EraseRootFromParent_Done,
     /* 238400 */   // Label 4776: @238400
     /* 238400 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238452), // Rule ID 11158 //
     /* 238405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 238413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238429 */     // MIs[0] Op4
     /* 238429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1652:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 238440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238448 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238450 */     GIR_RootConstrainSelectedInstOperands,
     /* 238451 */     // GIR_Coverage, 11158,
     /* 238451 */     GIR_EraseRootFromParent_Done,
     /* 238452 */   // Label 4777: @238452
     /* 238452 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238504), // Rule ID 11159 //
     /* 238457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 238465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238481 */     // MIs[0] Op4
     /* 238481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1888:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 238492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238500 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238502 */     GIR_RootConstrainSelectedInstOperands,
     /* 238503 */     // GIR_Coverage, 11159,
     /* 238503 */     GIR_EraseRootFromParent_Done,
     /* 238504 */   // Label 4778: @238504
     /* 238504 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238556), // Rule ID 11160 //
     /* 238509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 238517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238533 */     // MIs[0] Op4
     /* 238533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1888:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238552 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238554 */     GIR_RootConstrainSelectedInstOperands,
     /* 238555 */     // GIR_Coverage, 11160,
     /* 238555 */     GIR_EraseRootFromParent_Done,
     /* 238556 */   // Label 4779: @238556
     /* 238556 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238608), // Rule ID 11161 //
     /* 238561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 238569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238585 */     // MIs[0] Op4
     /* 238585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 238596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238604 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238606 */     GIR_RootConstrainSelectedInstOperands,
     /* 238607 */     // GIR_Coverage, 11161,
     /* 238607 */     GIR_EraseRootFromParent_Done,
     /* 238608 */   // Label 4780: @238608
     /* 238608 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238660), // Rule ID 11162 //
     /* 238613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 238621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238637 */     // MIs[0] Op4
     /* 238637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238645 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1890:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 238648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238656 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238658 */     GIR_RootConstrainSelectedInstOperands,
     /* 238659 */     // GIR_Coverage, 11162,
     /* 238659 */     GIR_EraseRootFromParent_Done,
     /* 238660 */   // Label 4781: @238660
     /* 238660 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238712), // Rule ID 11163 //
     /* 238665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 238673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238689 */     // MIs[0] Op4
     /* 238689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1654:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 238700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238708 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238710 */     GIR_RootConstrainSelectedInstOperands,
     /* 238711 */     // GIR_Coverage, 11163,
     /* 238711 */     GIR_EraseRootFromParent_Done,
     /* 238712 */   // Label 4782: @238712
     /* 238712 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238764), // Rule ID 11164 //
     /* 238717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 238725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238741 */     // MIs[0] Op4
     /* 238741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238749 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1654:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 238752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238760 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238762 */     GIR_RootConstrainSelectedInstOperands,
     /* 238763 */     // GIR_Coverage, 11164,
     /* 238763 */     GIR_EraseRootFromParent_Done,
     /* 238764 */   // Label 4783: @238764
     /* 238764 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(238816), // Rule ID 11165 //
     /* 238769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 238777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238793 */     // MIs[0] Op4
     /* 238793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1656:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238812 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238814 */     GIR_RootConstrainSelectedInstOperands,
     /* 238815 */     // GIR_Coverage, 11165,
     /* 238815 */     GIR_EraseRootFromParent_Done,
     /* 238816 */   // Label 4784: @238816
     /* 238816 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(238868), // Rule ID 11166 //
     /* 238821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 238829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238845 */     // MIs[0] Op4
     /* 238845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238853 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1656:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 238856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238866 */     GIR_RootConstrainSelectedInstOperands,
     /* 238867 */     // GIR_Coverage, 11166,
     /* 238867 */     GIR_EraseRootFromParent_Done,
     /* 238868 */   // Label 4785: @238868
     /* 238868 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(238920), // Rule ID 11167 //
     /* 238873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 238881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238897 */     // MIs[0] Op4
     /* 238897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 238908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238916 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238918 */     GIR_RootConstrainSelectedInstOperands,
     /* 238919 */     // GIR_Coverage, 11167,
     /* 238919 */     GIR_EraseRootFromParent_Done,
     /* 238920 */   // Label 4786: @238920
     /* 238920 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(238972), // Rule ID 11168 //
     /* 238925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 238933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238949 */     // MIs[0] Op4
     /* 238949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238957 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1892:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 238960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238968 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238970 */     GIR_RootConstrainSelectedInstOperands,
     /* 238971 */     // GIR_Coverage, 11168,
     /* 238971 */     GIR_EraseRootFromParent_Done,
     /* 238972 */   // Label 4787: @238972
     /* 238972 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239024), // Rule ID 11169 //
     /* 238977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 238985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239001 */     // MIs[0] Op4
     /* 239001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1894:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 239012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239020 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239022 */     GIR_RootConstrainSelectedInstOperands,
     /* 239023 */     // GIR_Coverage, 11169,
     /* 239023 */     GIR_EraseRootFromParent_Done,
     /* 239024 */   // Label 4788: @239024
     /* 239024 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239076), // Rule ID 11170 //
     /* 239029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 239037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239053 */     // MIs[0] Op4
     /* 239053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1894:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 239064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239072 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239074 */     GIR_RootConstrainSelectedInstOperands,
     /* 239075 */     // GIR_Coverage, 11170,
     /* 239075 */     GIR_EraseRootFromParent_Done,
     /* 239076 */   // Label 4789: @239076
     /* 239076 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239128), // Rule ID 11192 //
     /* 239081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 239089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239105 */     // MIs[0] Op4
     /* 239105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239113 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 239116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239124 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239126 */     GIR_RootConstrainSelectedInstOperands,
     /* 239127 */     // GIR_Coverage, 11192,
     /* 239127 */     GIR_EraseRootFromParent_Done,
     /* 239128 */   // Label 4790: @239128
     /* 239128 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239180), // Rule ID 11193 //
     /* 239133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 239141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239157 */     // MIs[0] Op4
     /* 239157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239160 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 239168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239176 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239178 */     GIR_RootConstrainSelectedInstOperands,
     /* 239179 */     // GIR_Coverage, 11193,
     /* 239179 */     GIR_EraseRootFromParent_Done,
     /* 239180 */   // Label 4791: @239180
     /* 239180 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239232), // Rule ID 11194 //
     /* 239185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 239193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239209 */     // MIs[0] Op4
     /* 239209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239217 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 239220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239228 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239230 */     GIR_RootConstrainSelectedInstOperands,
     /* 239231 */     // GIR_Coverage, 11194,
     /* 239231 */     GIR_EraseRootFromParent_Done,
     /* 239232 */   // Label 4792: @239232
     /* 239232 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239284), // Rule ID 11195 //
     /* 239237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 239245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239261 */     // MIs[0] Op4
     /* 239261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 239272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239280 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239282 */     GIR_RootConstrainSelectedInstOperands,
     /* 239283 */     // GIR_Coverage, 11195,
     /* 239283 */     GIR_EraseRootFromParent_Done,
     /* 239284 */   // Label 4793: @239284
     /* 239284 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239336), // Rule ID 11196 //
     /* 239289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 239297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239313 */     // MIs[0] Op4
     /* 239313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 239324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239332 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239334 */     GIR_RootConstrainSelectedInstOperands,
     /* 239335 */     // GIR_Coverage, 11196,
     /* 239335 */     GIR_EraseRootFromParent_Done,
     /* 239336 */   // Label 4794: @239336
     /* 239336 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239388), // Rule ID 11197 //
     /* 239341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 239349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239365 */     // MIs[0] Op4
     /* 239365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 239376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239384 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239386 */     GIR_RootConstrainSelectedInstOperands,
     /* 239387 */     // GIR_Coverage, 11197,
     /* 239387 */     GIR_EraseRootFromParent_Done,
     /* 239388 */   // Label 4795: @239388
     /* 239388 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239440), // Rule ID 11198 //
     /* 239393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 239401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239417 */     // MIs[0] Op4
     /* 239417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 239428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239436 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239438 */     GIR_RootConstrainSelectedInstOperands,
     /* 239439 */     // GIR_Coverage, 11198,
     /* 239439 */     GIR_EraseRootFromParent_Done,
     /* 239440 */   // Label 4796: @239440
     /* 239440 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239492), // Rule ID 11199 //
     /* 239445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 239453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239469 */     // MIs[0] Op4
     /* 239469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 239480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239488 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239490 */     GIR_RootConstrainSelectedInstOperands,
     /* 239491 */     // GIR_Coverage, 11199,
     /* 239491 */     GIR_EraseRootFromParent_Done,
     /* 239492 */   // Label 4797: @239492
     /* 239492 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239544), // Rule ID 11653 //
     /* 239497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 239505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239521 */     // MIs[0] Op4
     /* 239521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 239532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239540 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239542 */     GIR_RootConstrainSelectedInstOperands,
     /* 239543 */     // GIR_Coverage, 11653,
     /* 239543 */     GIR_EraseRootFromParent_Done,
     /* 239544 */   // Label 4798: @239544
     /* 239544 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239596), // Rule ID 11654 //
     /* 239549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 239557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239573 */     // MIs[0] Op4
     /* 239573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239581 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 239584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239592 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239594 */     GIR_RootConstrainSelectedInstOperands,
     /* 239595 */     // GIR_Coverage, 11654,
     /* 239595 */     GIR_EraseRootFromParent_Done,
     /* 239596 */   // Label 4799: @239596
     /* 239596 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239648), // Rule ID 11655 //
     /* 239601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 239609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239625 */     // MIs[0] Op4
     /* 239625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239633 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 239636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239646 */     GIR_RootConstrainSelectedInstOperands,
     /* 239647 */     // GIR_Coverage, 11655,
     /* 239647 */     GIR_EraseRootFromParent_Done,
     /* 239648 */   // Label 4800: @239648
     /* 239648 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239700), // Rule ID 11656 //
     /* 239653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 239661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239677 */     // MIs[0] Op4
     /* 239677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239685 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 239688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239696 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239698 */     GIR_RootConstrainSelectedInstOperands,
     /* 239699 */     // GIR_Coverage, 11656,
     /* 239699 */     GIR_EraseRootFromParent_Done,
     /* 239700 */   // Label 4801: @239700
     /* 239700 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239752), // Rule ID 11789 //
     /* 239705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 239713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239729 */     // MIs[0] Op4
     /* 239729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239737 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1326:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 239740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239748 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239750 */     GIR_RootConstrainSelectedInstOperands,
     /* 239751 */     // GIR_Coverage, 11789,
     /* 239751 */     GIR_EraseRootFromParent_Done,
     /* 239752 */   // Label 4802: @239752
     /* 239752 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239804), // Rule ID 11791 //
     /* 239757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 239765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239781 */     // MIs[0] Op4
     /* 239781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239789 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 239792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239800 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239802 */     GIR_RootConstrainSelectedInstOperands,
     /* 239803 */     // GIR_Coverage, 11791,
     /* 239803 */     GIR_EraseRootFromParent_Done,
     /* 239804 */   // Label 4803: @239804
     /* 239804 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239851), // Rule ID 2815 //
     /* 239809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 239832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239836 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 239836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 239839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239847 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239849 */     GIR_RootConstrainSelectedInstOperands,
     /* 239850 */     // GIR_Coverage, 2815,
     /* 239850 */     GIR_EraseRootFromParent_Done,
     /* 239851 */   // Label 4804: @239851
     /* 239851 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239898), // Rule ID 2818 //
     /* 239856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 239867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 239873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 239876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 239879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239883 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 239883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 239886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239896 */     GIR_RootConstrainSelectedInstOperands,
     /* 239897 */     // GIR_Coverage, 2818,
     /* 239897 */     GIR_EraseRootFromParent_Done,
     /* 239898 */   // Label 4805: @239898
     /* 239898 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239945), // Rule ID 2821 //
     /* 239903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 239914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 239920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 239923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 239926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239930 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 239930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 239933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239941 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239943 */     GIR_RootConstrainSelectedInstOperands,
     /* 239944 */     // GIR_Coverage, 2821,
     /* 239944 */     GIR_EraseRootFromParent_Done,
     /* 239945 */   // Label 4806: @239945
     /* 239945 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(239992), // Rule ID 2824 //
     /* 239950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 239973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239977 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 239977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239988 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239990 */     GIR_RootConstrainSelectedInstOperands,
     /* 239991 */     // GIR_Coverage, 2824,
     /* 239991 */     GIR_EraseRootFromParent_Done,
     /* 239992 */   // Label 4807: @239992
     /* 239992 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240039), // Rule ID 2827 //
     /* 239997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 240020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 240024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 240027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240035 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240037 */     GIR_RootConstrainSelectedInstOperands,
     /* 240038 */     // GIR_Coverage, 2827,
     /* 240038 */     GIR_EraseRootFromParent_Done,
     /* 240039 */   // Label 4808: @240039
     /* 240039 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240086), // Rule ID 2830 //
     /* 240044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240071 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 240071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 240074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240082 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240084 */     GIR_RootConstrainSelectedInstOperands,
     /* 240085 */     // GIR_Coverage, 2830,
     /* 240085 */     GIR_EraseRootFromParent_Done,
     /* 240086 */   // Label 4809: @240086
     /* 240086 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240133), // Rule ID 2833 //
     /* 240091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 240118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 240121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240129 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240131 */     GIR_RootConstrainSelectedInstOperands,
     /* 240132 */     // GIR_Coverage, 2833,
     /* 240132 */     GIR_EraseRootFromParent_Done,
     /* 240133 */   // Label 4810: @240133
     /* 240133 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240180), // Rule ID 2834 //
     /* 240138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240165 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 240165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 240168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240176 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240178 */     GIR_RootConstrainSelectedInstOperands,
     /* 240179 */     // GIR_Coverage, 2834,
     /* 240179 */     GIR_EraseRootFromParent_Done,
     /* 240180 */   // Label 4811: @240180
     /* 240180 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240227), // Rule ID 2835 //
     /* 240185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240212 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1330:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 240212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 240215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240223 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240225 */     GIR_RootConstrainSelectedInstOperands,
     /* 240226 */     // GIR_Coverage, 2835,
     /* 240226 */     GIR_EraseRootFromParent_Done,
     /* 240227 */   // Label 4812: @240227
     /* 240227 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240274), // Rule ID 2931 //
     /* 240232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1505:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 240262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240270 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240272 */     GIR_RootConstrainSelectedInstOperands,
     /* 240273 */     // GIR_Coverage, 2931,
     /* 240273 */     GIR_EraseRootFromParent_Done,
     /* 240274 */   // Label 4813: @240274
     /* 240274 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240321), // Rule ID 2934 //
     /* 240279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1505:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 240309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240317 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240319 */     GIR_RootConstrainSelectedInstOperands,
     /* 240320 */     // GIR_Coverage, 2934,
     /* 240320 */     GIR_EraseRootFromParent_Done,
     /* 240321 */   // Label 4814: @240321
     /* 240321 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240368), // Rule ID 2937 //
     /* 240326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1505:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 240356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240364 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240366 */     GIR_RootConstrainSelectedInstOperands,
     /* 240367 */     // GIR_Coverage, 2937,
     /* 240367 */     GIR_EraseRootFromParent_Done,
     /* 240368 */   // Label 4815: @240368
     /* 240368 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240415), // Rule ID 2940 //
     /* 240373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1505:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 240403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240413 */     GIR_RootConstrainSelectedInstOperands,
     /* 240414 */     // GIR_Coverage, 2940,
     /* 240414 */     GIR_EraseRootFromParent_Done,
     /* 240415 */   // Label 4816: @240415
     /* 240415 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240462), // Rule ID 2943 //
     /* 240420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240447 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1507:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 240450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240458 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240460 */     GIR_RootConstrainSelectedInstOperands,
     /* 240461 */     // GIR_Coverage, 2943,
     /* 240461 */     GIR_EraseRootFromParent_Done,
     /* 240462 */   // Label 4817: @240462
     /* 240462 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240509), // Rule ID 2945 //
     /* 240467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1507:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 240497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240505 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240507 */     GIR_RootConstrainSelectedInstOperands,
     /* 240508 */     // GIR_Coverage, 2945,
     /* 240508 */     GIR_EraseRootFromParent_Done,
     /* 240509 */   // Label 4818: @240509
     /* 240509 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240556), // Rule ID 2947 //
     /* 240514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1507:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 240544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240552 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240554 */     GIR_RootConstrainSelectedInstOperands,
     /* 240555 */     // GIR_Coverage, 2947,
     /* 240555 */     GIR_EraseRootFromParent_Done,
     /* 240556 */   // Label 4819: @240556
     /* 240556 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240603), // Rule ID 2949 //
     /* 240561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1507:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 240591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240601 */     GIR_RootConstrainSelectedInstOperands,
     /* 240602 */     // GIR_Coverage, 2949,
     /* 240602 */     GIR_EraseRootFromParent_Done,
     /* 240603 */   // Label 4820: @240603
     /* 240603 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240650), // Rule ID 7410 //
     /* 240608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240635 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1513:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 240638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240646 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240648 */     GIR_RootConstrainSelectedInstOperands,
     /* 240649 */     // GIR_Coverage, 7410,
     /* 240649 */     GIR_EraseRootFromParent_Done,
     /* 240650 */   // Label 4821: @240650
     /* 240650 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240697), // Rule ID 7413 //
     /* 240655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1513:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 240685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240695 */     GIR_RootConstrainSelectedInstOperands,
     /* 240696 */     // GIR_Coverage, 7413,
     /* 240696 */     GIR_EraseRootFromParent_Done,
     /* 240697 */   // Label 4822: @240697
     /* 240697 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240744), // Rule ID 7416 //
     /* 240702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1513:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 240732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240740 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240742 */     GIR_RootConstrainSelectedInstOperands,
     /* 240743 */     // GIR_Coverage, 7416,
     /* 240743 */     GIR_EraseRootFromParent_Done,
     /* 240744 */   // Label 4823: @240744
     /* 240744 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240791), // Rule ID 7419 //
     /* 240749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1513:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 240779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240789 */     GIR_RootConstrainSelectedInstOperands,
     /* 240790 */     // GIR_Coverage, 7419,
     /* 240790 */     GIR_EraseRootFromParent_Done,
     /* 240791 */   // Label 4824: @240791
     /* 240791 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240838), // Rule ID 7422 //
     /* 240796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1510:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 240826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240836 */     GIR_RootConstrainSelectedInstOperands,
     /* 240837 */     // GIR_Coverage, 7422,
     /* 240837 */     GIR_EraseRootFromParent_Done,
     /* 240838 */   // Label 4825: @240838
     /* 240838 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240885), // Rule ID 7424 //
     /* 240843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1510:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 240873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240883 */     GIR_RootConstrainSelectedInstOperands,
     /* 240884 */     // GIR_Coverage, 7424,
     /* 240884 */     GIR_EraseRootFromParent_Done,
     /* 240885 */   // Label 4826: @240885
     /* 240885 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240932), // Rule ID 7426 //
     /* 240890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1510:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 240920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240930 */     GIR_RootConstrainSelectedInstOperands,
     /* 240931 */     // GIR_Coverage, 7426,
     /* 240931 */     GIR_EraseRootFromParent_Done,
     /* 240932 */   // Label 4827: @240932
     /* 240932 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240979), // Rule ID 7428 //
     /* 240937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1510:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 240967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240977 */     GIR_RootConstrainSelectedInstOperands,
     /* 240978 */     // GIR_Coverage, 7428,
     /* 240978 */     GIR_EraseRootFromParent_Done,
     /* 240979 */   // Label 4828: @240979
     /* 240979 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241026), // Rule ID 8054 //
     /* 240984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 240992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241011 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241024 */     GIR_RootConstrainSelectedInstOperands,
     /* 241025 */     // GIR_Coverage, 8054,
     /* 241025 */     GIR_EraseRootFromParent_Done,
     /* 241026 */   // Label 4829: @241026
     /* 241026 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241073), // Rule ID 8057 //
     /* 241031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241058 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241071 */     GIR_RootConstrainSelectedInstOperands,
     /* 241072 */     // GIR_Coverage, 8057,
     /* 241072 */     GIR_EraseRootFromParent_Done,
     /* 241073 */   // Label 4830: @241073
     /* 241073 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241120), // Rule ID 8060 //
     /* 241078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241105 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241118 */     GIR_RootConstrainSelectedInstOperands,
     /* 241119 */     // GIR_Coverage, 8060,
     /* 241119 */     GIR_EraseRootFromParent_Done,
     /* 241120 */   // Label 4831: @241120
     /* 241120 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241167), // Rule ID 8063 //
     /* 241125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241152 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 241155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241165 */     GIR_RootConstrainSelectedInstOperands,
     /* 241166 */     // GIR_Coverage, 8063,
     /* 241166 */     GIR_EraseRootFromParent_Done,
     /* 241167 */   // Label 4832: @241167
     /* 241167 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241214), // Rule ID 8066 //
     /* 241172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241199 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 241202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241212 */     GIR_RootConstrainSelectedInstOperands,
     /* 241213 */     // GIR_Coverage, 8066,
     /* 241213 */     GIR_EraseRootFromParent_Done,
     /* 241214 */   // Label 4833: @241214
     /* 241214 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241261), // Rule ID 8069 //
     /* 241219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241246 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 241249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241259 */     GIR_RootConstrainSelectedInstOperands,
     /* 241260 */     // GIR_Coverage, 8069,
     /* 241260 */     GIR_EraseRootFromParent_Done,
     /* 241261 */   // Label 4834: @241261
     /* 241261 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241308), // Rule ID 8072 //
     /* 241266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241293 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1390:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241304 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241306 */     GIR_RootConstrainSelectedInstOperands,
     /* 241307 */     // GIR_Coverage, 8072,
     /* 241307 */     GIR_EraseRootFromParent_Done,
     /* 241308 */   // Label 4835: @241308
     /* 241308 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241355), // Rule ID 8073 //
     /* 241313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241340 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241353 */     GIR_RootConstrainSelectedInstOperands,
     /* 241354 */     // GIR_Coverage, 8073,
     /* 241354 */     GIR_EraseRootFromParent_Done,
     /* 241355 */   // Label 4836: @241355
     /* 241355 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241402), // Rule ID 8074 //
     /* 241360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241387 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241398 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241400 */     GIR_RootConstrainSelectedInstOperands,
     /* 241401 */     // GIR_Coverage, 8074,
     /* 241401 */     GIR_EraseRootFromParent_Done,
     /* 241402 */   // Label 4837: @241402
     /* 241402 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241449), // Rule ID 8075 //
     /* 241407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 241437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241447 */     GIR_RootConstrainSelectedInstOperands,
     /* 241448 */     // GIR_Coverage, 8075,
     /* 241448 */     GIR_EraseRootFromParent_Done,
     /* 241449 */   // Label 4838: @241449
     /* 241449 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241496), // Rule ID 8076 //
     /* 241454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241481 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 241484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241492 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241494 */     GIR_RootConstrainSelectedInstOperands,
     /* 241495 */     // GIR_Coverage, 8076,
     /* 241495 */     GIR_EraseRootFromParent_Done,
     /* 241496 */   // Label 4839: @241496
     /* 241496 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241543), // Rule ID 8077 //
     /* 241501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241528 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 241531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241541 */     GIR_RootConstrainSelectedInstOperands,
     /* 241542 */     // GIR_Coverage, 8077,
     /* 241542 */     GIR_EraseRootFromParent_Done,
     /* 241543 */   // Label 4840: @241543
     /* 241543 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241590), // Rule ID 8078 //
     /* 241548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241575 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1392:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 241578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241588 */     GIR_RootConstrainSelectedInstOperands,
     /* 241589 */     // GIR_Coverage, 8078,
     /* 241589 */     GIR_EraseRootFromParent_Done,
     /* 241590 */   // Label 4841: @241590
     /* 241590 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241637), // Rule ID 8079 //
     /* 241595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 241625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241635 */     GIR_RootConstrainSelectedInstOperands,
     /* 241636 */     // GIR_Coverage, 8079,
     /* 241636 */     GIR_EraseRootFromParent_Done,
     /* 241637 */   // Label 4842: @241637
     /* 241637 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241684), // Rule ID 8080 //
     /* 241642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241669 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 241672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241680 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241682 */     GIR_RootConstrainSelectedInstOperands,
     /* 241683 */     // GIR_Coverage, 8080,
     /* 241683 */     GIR_EraseRootFromParent_Done,
     /* 241684 */   // Label 4843: @241684
     /* 241684 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241731), // Rule ID 8081 //
     /* 241689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241716 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 241719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241727 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241729 */     GIR_RootConstrainSelectedInstOperands,
     /* 241730 */     // GIR_Coverage, 8081,
     /* 241730 */     GIR_EraseRootFromParent_Done,
     /* 241731 */   // Label 4844: @241731
     /* 241731 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241778), // Rule ID 8082 //
     /* 241736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241763 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 241766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241774 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241776 */     GIR_RootConstrainSelectedInstOperands,
     /* 241777 */     // GIR_Coverage, 8082,
     /* 241777 */     GIR_EraseRootFromParent_Done,
     /* 241778 */   // Label 4845: @241778
     /* 241778 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241825), // Rule ID 8083 //
     /* 241783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 241813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241821 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241823 */     GIR_RootConstrainSelectedInstOperands,
     /* 241824 */     // GIR_Coverage, 8083,
     /* 241824 */     GIR_EraseRootFromParent_Done,
     /* 241825 */   // Label 4846: @241825
     /* 241825 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241872), // Rule ID 8084 //
     /* 241830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 241838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241857 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 241860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241868 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241870 */     GIR_RootConstrainSelectedInstOperands,
     /* 241871 */     // GIR_Coverage, 8084,
     /* 241871 */     GIR_EraseRootFromParent_Done,
     /* 241872 */   // Label 4847: @241872
     /* 241872 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241919), // Rule ID 8085 //
     /* 241877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 241885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 241907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241915 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241917 */     GIR_RootConstrainSelectedInstOperands,
     /* 241918 */     // GIR_Coverage, 8085,
     /* 241918 */     GIR_EraseRootFromParent_Done,
     /* 241919 */   // Label 4848: @241919
     /* 241919 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241966), // Rule ID 8086 //
     /* 241924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 241932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241951 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 241954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241964 */     GIR_RootConstrainSelectedInstOperands,
     /* 241965 */     // GIR_Coverage, 8086,
     /* 241965 */     GIR_EraseRootFromParent_Done,
     /* 241966 */   // Label 4849: @241966
     /* 241966 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242013), // Rule ID 8087 //
     /* 241971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 241979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241998 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1389:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 242001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242009 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242011 */     GIR_RootConstrainSelectedInstOperands,
     /* 242012 */     // GIR_Coverage, 8087,
     /* 242012 */     GIR_EraseRootFromParent_Done,
     /* 242013 */   // Label 4850: @242013
     /* 242013 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(242060), // Rule ID 8088 //
     /* 242018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242045 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 242048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242056 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242058 */     GIR_RootConstrainSelectedInstOperands,
     /* 242059 */     // GIR_Coverage, 8088,
     /* 242059 */     GIR_EraseRootFromParent_Done,
     /* 242060 */   // Label 4851: @242060
     /* 242060 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242107), // Rule ID 8089 //
     /* 242065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242092 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1389:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 242095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242103 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242105 */     GIR_RootConstrainSelectedInstOperands,
     /* 242106 */     // GIR_Coverage, 8089,
     /* 242106 */     GIR_EraseRootFromParent_Done,
     /* 242107 */   // Label 4852: @242107
     /* 242107 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242154), // Rule ID 8090 //
     /* 242112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242139 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 242142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242150 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242152 */     GIR_RootConstrainSelectedInstOperands,
     /* 242153 */     // GIR_Coverage, 8090,
     /* 242153 */     GIR_EraseRootFromParent_Done,
     /* 242154 */   // Label 4853: @242154
     /* 242154 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242201), // Rule ID 8091 //
     /* 242159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242186 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1394:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 242189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242197 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242199 */     GIR_RootConstrainSelectedInstOperands,
     /* 242200 */     // GIR_Coverage, 8091,
     /* 242200 */     GIR_EraseRootFromParent_Done,
     /* 242201 */   // Label 4854: @242201
     /* 242201 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242248), // Rule ID 8092 //
     /* 242206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242233 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1394:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 242236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242246 */     GIR_RootConstrainSelectedInstOperands,
     /* 242247 */     // GIR_Coverage, 8092,
     /* 242247 */     GIR_EraseRootFromParent_Done,
     /* 242248 */   // Label 4855: @242248
     /* 242248 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242295), // Rule ID 8093 //
     /* 242253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242291 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242293 */     GIR_RootConstrainSelectedInstOperands,
     /* 242294 */     // GIR_Coverage, 8093,
     /* 242294 */     GIR_EraseRootFromParent_Done,
     /* 242295 */   // Label 4856: @242295
     /* 242295 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242342), // Rule ID 8096 //
     /* 242300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242340 */     GIR_RootConstrainSelectedInstOperands,
     /* 242341 */     // GIR_Coverage, 8096,
     /* 242341 */     GIR_EraseRootFromParent_Done,
     /* 242342 */   // Label 4857: @242342
     /* 242342 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242389), // Rule ID 8099 //
     /* 242347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242387 */     GIR_RootConstrainSelectedInstOperands,
     /* 242388 */     // GIR_Coverage, 8099,
     /* 242388 */     GIR_EraseRootFromParent_Done,
     /* 242389 */   // Label 4858: @242389
     /* 242389 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242436), // Rule ID 8102 //
     /* 242394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 242424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242432 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242434 */     GIR_RootConstrainSelectedInstOperands,
     /* 242435 */     // GIR_Coverage, 8102,
     /* 242435 */     GIR_EraseRootFromParent_Done,
     /* 242436 */   // Label 4859: @242436
     /* 242436 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242483), // Rule ID 8105 //
     /* 242441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 242471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242481 */     GIR_RootConstrainSelectedInstOperands,
     /* 242482 */     // GIR_Coverage, 8105,
     /* 242482 */     GIR_EraseRootFromParent_Done,
     /* 242483 */   // Label 4860: @242483
     /* 242483 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242530), // Rule ID 8108 //
     /* 242488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242515 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 242518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242528 */     GIR_RootConstrainSelectedInstOperands,
     /* 242529 */     // GIR_Coverage, 8108,
     /* 242529 */     GIR_EraseRootFromParent_Done,
     /* 242530 */   // Label 4861: @242530
     /* 242530 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242577), // Rule ID 8111 //
     /* 242535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242562 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1391:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 242565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242575 */     GIR_RootConstrainSelectedInstOperands,
     /* 242576 */     // GIR_Coverage, 8111,
     /* 242576 */     GIR_EraseRootFromParent_Done,
     /* 242577 */   // Label 4862: @242577
     /* 242577 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242624), // Rule ID 8114 //
     /* 242582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242609 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 242612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242622 */     GIR_RootConstrainSelectedInstOperands,
     /* 242623 */     // GIR_Coverage, 8114,
     /* 242623 */     GIR_EraseRootFromParent_Done,
     /* 242624 */   // Label 4863: @242624
     /* 242624 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242671), // Rule ID 8117 //
     /* 242629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242656 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 242659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242669 */     GIR_RootConstrainSelectedInstOperands,
     /* 242670 */     // GIR_Coverage, 8117,
     /* 242670 */     GIR_EraseRootFromParent_Done,
     /* 242671 */   // Label 4864: @242671
     /* 242671 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242718), // Rule ID 8120 //
     /* 242676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 242706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242716 */     GIR_RootConstrainSelectedInstOperands,
     /* 242717 */     // GIR_Coverage, 8120,
     /* 242717 */     GIR_EraseRootFromParent_Done,
     /* 242718 */   // Label 4865: @242718
     /* 242718 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242765), // Rule ID 8123 //
     /* 242723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242750 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 242753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242763 */     GIR_RootConstrainSelectedInstOperands,
     /* 242764 */     // GIR_Coverage, 8123,
     /* 242764 */     GIR_EraseRootFromParent_Done,
     /* 242765 */   // Label 4866: @242765
     /* 242765 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242812), // Rule ID 8126 //
     /* 242770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242797 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 242800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242808 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242810 */     GIR_RootConstrainSelectedInstOperands,
     /* 242811 */     // GIR_Coverage, 8126,
     /* 242811 */     GIR_EraseRootFromParent_Done,
     /* 242812 */   // Label 4867: @242812
     /* 242812 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242859), // Rule ID 8129 //
     /* 242817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 242847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242855 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242857 */     GIR_RootConstrainSelectedInstOperands,
     /* 242858 */     // GIR_Coverage, 8129,
     /* 242858 */     GIR_EraseRootFromParent_Done,
     /* 242859 */   // Label 4868: @242859
     /* 242859 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242906), // Rule ID 8131 //
     /* 242864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242891 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 242894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242904 */     GIR_RootConstrainSelectedInstOperands,
     /* 242905 */     // GIR_Coverage, 8131,
     /* 242905 */     GIR_EraseRootFromParent_Done,
     /* 242906 */   // Label 4869: @242906
     /* 242906 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(242953), // Rule ID 8133 //
     /* 242911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242938 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 242941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242951 */     GIR_RootConstrainSelectedInstOperands,
     /* 242952 */     // GIR_Coverage, 8133,
     /* 242952 */     GIR_EraseRootFromParent_Done,
     /* 242953 */   // Label 4870: @242953
     /* 242953 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243000), // Rule ID 8135 //
     /* 242958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242985 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 242988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242998 */     GIR_RootConstrainSelectedInstOperands,
     /* 242999 */     // GIR_Coverage, 8135,
     /* 242999 */     GIR_EraseRootFromParent_Done,
     /* 243000 */   // Label 4871: @243000
     /* 243000 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243047), // Rule ID 8137 //
     /* 243005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 243028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 243032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 243035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243043 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243045 */     GIR_RootConstrainSelectedInstOperands,
     /* 243046 */     // GIR_Coverage, 8137,
     /* 243046 */     GIR_EraseRootFromParent_Done,
     /* 243047 */   // Label 4872: @243047
     /* 243047 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243094), // Rule ID 8139 //
     /* 243052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 243079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 243082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243090 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243092 */     GIR_RootConstrainSelectedInstOperands,
     /* 243093 */     // GIR_Coverage, 8139,
     /* 243093 */     GIR_EraseRootFromParent_Done,
     /* 243094 */   // Label 4873: @243094
     /* 243094 */   GIM_Reject,
     /* 243095 */ // Label 4732: @243095
     /* 243095 */ GIM_Reject,
     /* 243096 */ // Label 33: @243096
     /* 243096 */ GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243174),
     /* 243101 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 243104 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243126), // Rule ID 78 //
     /* 243109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 243117 */     // (intrinsic_void 2072:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 243117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 243120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243124 */     GIR_RootConstrainSelectedInstOperands,
     /* 243125 */     // GIR_Coverage, 78,
     /* 243125 */     GIR_EraseRootFromParent_Done,
     /* 243126 */   // Label 4875: @243126
     /* 243126 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243151), // Rule ID 2377 //
     /* 243131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 243139 */     // (intrinsic_void 1622:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 243139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 243142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 243145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243149 */     GIR_RootConstrainSelectedInstOperands,
     /* 243150 */     // GIR_Coverage, 2377,
     /* 243150 */     GIR_EraseRootFromParent_Done,
     /* 243151 */   // Label 4876: @243151
     /* 243151 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243173), // Rule ID 7034 //
     /* 243156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 243161 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 243161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 243164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 243167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243171 */     GIR_RootConstrainSelectedInstOperands,
     /* 243172 */     // GIR_Coverage, 7034,
     /* 243172 */     GIR_EraseRootFromParent_Done,
     /* 243173 */   // Label 4877: @243173
     /* 243173 */   GIM_Reject,
     /* 243174 */ // Label 4874: @243174
     /* 243174 */ GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243774),
     /* 243179 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 243182 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243214), // Rule ID 79 //
     /* 243187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 243195 */     // MIs[0] imm
     /* 243195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 243203 */     // (intrinsic_void 2071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 243203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 243206 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243212 */     GIR_RootConstrainSelectedInstOperands,
     /* 243213 */     // GIR_Coverage, 79,
     /* 243213 */     GIR_EraseRootFromParent_Done,
     /* 243214 */   // Label 4879: @243214
     /* 243214 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243239), // Rule ID 227 //
     /* 243219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 243224 */     // MIs[0] imm
     /* 243224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 243232 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 243232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 243235 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243237 */     GIR_RootConstrainSelectedInstOperands,
     /* 243238 */     // GIR_Coverage, 227,
     /* 243238 */     GIR_EraseRootFromParent_Done,
     /* 243239 */   // Label 4880: @243239
     /* 243239 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243264), // Rule ID 228 //
     /* 243244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 243249 */     // MIs[0] imm
     /* 243249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 243257 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 243257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 243260 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243262 */     GIR_RootConstrainSelectedInstOperands,
     /* 243263 */     // GIR_Coverage, 228,
     /* 243263 */     GIR_EraseRootFromParent_Done,
     /* 243264 */   // Label 4881: @243264
     /* 243264 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243296), // Rule ID 3592 //
     /* 243269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 243277 */     // MIs[0] imm
     /* 243277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 243285 */     // (intrinsic_void 1128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 243285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 243288 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243294 */     GIR_RootConstrainSelectedInstOperands,
     /* 243295 */     // GIR_Coverage, 3592,
     /* 243295 */     GIR_EraseRootFromParent_Done,
     /* 243296 */   // Label 4882: @243296
     /* 243296 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243336), // Rule ID 16 //
     /* 243301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 243306 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 243321 */     // MIs[1] Operand 1
     /* 243321 */     // No operand predicates
     /* 243321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243323 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 243323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 243326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 243329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243334 */     GIR_RootConstrainSelectedInstOperands,
     /* 243335 */     // GIR_Coverage, 16,
     /* 243335 */     GIR_EraseRootFromParent_Done,
     /* 243336 */   // Label 4883: @243336
     /* 243336 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243376), // Rule ID 17 //
     /* 243341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 243346 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243361 */     // MIs[1] Operand 1
     /* 243361 */     // No operand predicates
     /* 243361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243363 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 243363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 243366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243374 */     GIR_RootConstrainSelectedInstOperands,
     /* 243375 */     // GIR_Coverage, 17,
     /* 243375 */     GIR_EraseRootFromParent_Done,
     /* 243376 */   // Label 4884: @243376
     /* 243376 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243416), // Rule ID 18 //
     /* 243381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 243386 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243401 */     // MIs[1] Operand 1
     /* 243401 */     // No operand predicates
     /* 243401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243403 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 243403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 243406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243414 */     GIR_RootConstrainSelectedInstOperands,
     /* 243415 */     // GIR_Coverage, 18,
     /* 243415 */     GIR_EraseRootFromParent_Done,
     /* 243416 */   // Label 4885: @243416
     /* 243416 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243456), // Rule ID 19 //
     /* 243421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 243426 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243441 */     // MIs[1] Operand 1
     /* 243441 */     // No operand predicates
     /* 243441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243443 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 243443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 243446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243454 */     GIR_RootConstrainSelectedInstOperands,
     /* 243455 */     // GIR_Coverage, 19,
     /* 243455 */     GIR_EraseRootFromParent_Done,
     /* 243456 */   // Label 4886: @243456
     /* 243456 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243480), // Rule ID 72 //
     /* 243461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 243466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243473 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 243473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 243476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243478 */     GIR_RootConstrainSelectedInstOperands,
     /* 243479 */     // GIR_Coverage, 72,
     /* 243479 */     GIR_EraseRootFromParent_Done,
     /* 243480 */   // Label 4887: @243480
     /* 243480 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243504), // Rule ID 74 //
     /* 243485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 243490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243497 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 243497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 243500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243502 */     GIR_RootConstrainSelectedInstOperands,
     /* 243503 */     // GIR_Coverage, 74,
     /* 243503 */     GIR_EraseRootFromParent_Done,
     /* 243504 */   // Label 4888: @243504
     /* 243504 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243535), // Rule ID 77 //
     /* 243509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 243517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243524 */     // (intrinsic_w_chain:{ *:[i64] } 2073:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 243524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 243527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243533 */     GIR_RootConstrainSelectedInstOperands,
     /* 243534 */     // GIR_Coverage, 77,
     /* 243534 */     GIR_EraseRootFromParent_Done,
     /* 243535 */   // Label 4889: @243535
     /* 243535 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(243562), // Rule ID 80 //
     /* 243540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 243548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243555 */     // (intrinsic_w_chain:{ *:[i64] } 2074:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 243555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 243558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243560 */     GIR_RootConstrainSelectedInstOperands,
     /* 243561 */     // GIR_Coverage, 80,
     /* 243561 */     GIR_EraseRootFromParent_Done,
     /* 243562 */   // Label 4890: @243562
     /* 243562 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(243593), // Rule ID 2376 //
     /* 243567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 243575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243582 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1572:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 243582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 243585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243591 */     GIR_RootConstrainSelectedInstOperands,
     /* 243592 */     // GIR_Coverage, 2376,
     /* 243592 */     GIR_EraseRootFromParent_Done,
     /* 243593 */   // Label 4891: @243593
     /* 243593 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(243633), // Rule ID 12498 //
     /* 243598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 243606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243613 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 243613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 243616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243618 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 243628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243631 */     GIR_RootConstrainSelectedInstOperands,
     /* 243632 */     // GIR_Coverage, 12498,
     /* 243632 */     GIR_EraseRootFromParent_Done,
     /* 243633 */   // Label 4892: @243633
     /* 243633 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(243667), // Rule ID 2378 //
     /* 243638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 243646 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 243649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243653 */     // (intrinsic_void 2052:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 243653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 243656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 243658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 243661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243665 */     GIR_RootConstrainSelectedInstOperands,
     /* 243666 */     // GIR_Coverage, 2378,
     /* 243666 */     GIR_EraseRootFromParent_Done,
     /* 243667 */   // Label 4893: @243667
     /* 243667 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(243690), // Rule ID 73 //
     /* 243672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 243677 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243680 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 243680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 243683 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 243688 */     GIR_RootConstrainSelectedInstOperands,
     /* 243689 */     // GIR_Coverage, 73,
     /* 243689 */     GIR_EraseRootFromParent_Done,
     /* 243690 */   // Label 4894: @243690
     /* 243690 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(243713), // Rule ID 75 //
     /* 243695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 243700 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243703 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 243703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 243706 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 243711 */     GIR_RootConstrainSelectedInstOperands,
     /* 243712 */     // GIR_Coverage, 75,
     /* 243712 */     GIR_EraseRootFromParent_Done,
     /* 243713 */   // Label 4895: @243713
     /* 243713 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(243740), // Rule ID 76 //
     /* 243718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 243723 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243726 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 243726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 243729 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 243734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243738 */     GIR_RootConstrainSelectedInstOperands,
     /* 243739 */     // GIR_Coverage, 76,
     /* 243739 */     GIR_EraseRootFromParent_Done,
     /* 243740 */   // Label 4896: @243740
     /* 243740 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(243773), // Rule ID 12497 //
     /* 243745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 243753 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243756 */     // (intrinsic_void 940:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 243756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 243759 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 243769 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243771 */     GIR_RootConstrainSelectedInstOperands,
     /* 243772 */     // GIR_Coverage, 12497,
     /* 243772 */     GIR_EraseRootFromParent_Done,
     /* 243773 */   // Label 4897: @243773
     /* 243773 */   GIM_Reject,
     /* 243774 */ // Label 4878: @243774
     /* 243774 */ GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244745),
     /* 243779 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 243782 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(243858), // Rule ID 7000 //
     /* 243787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 243792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243799 */     // MIs[0] addr
     /* 243799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 243803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 243807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 243811 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 243811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 243814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 243818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 243827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 243833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 243836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 243847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 243857 */     // GIR_Coverage, 7000,
     /* 243857 */     GIR_EraseRootFromParent_Done,
     /* 243858 */   // Label 4899: @243858
     /* 243858 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(243934), // Rule ID 7001 //
     /* 243863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 243868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243875 */     // MIs[0] addr
     /* 243875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 243879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 243883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 243887 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 243887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 243890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 243894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 243903 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 243909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 243912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 243923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 243933 */     // GIR_Coverage, 7001,
     /* 243933 */     GIR_EraseRootFromParent_Done,
     /* 243934 */   // Label 4900: @243934
     /* 243934 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244010), // Rule ID 7002 //
     /* 243939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 243944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243951 */     // MIs[0] addr
     /* 243951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 243955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 243959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 243963 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 243963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 243966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 243970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 243979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 243985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 243988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 243999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244009 */     // GIR_Coverage, 7002,
     /* 244009 */     GIR_EraseRootFromParent_Done,
     /* 244010 */   // Label 4901: @244010
     /* 244010 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(244052), // Rule ID 7003 //
     /* 244015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 244020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244027 */     // MIs[0] addr
     /* 244027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 244039 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 244039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 244042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244044 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 244046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244050 */     GIR_RootConstrainSelectedInstOperands,
     /* 244051 */     // GIR_Coverage, 7003,
     /* 244051 */     GIR_EraseRootFromParent_Done,
     /* 244052 */   // Label 4902: @244052
     /* 244052 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(244128), // Rule ID 7007 //
     /* 244057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244069 */     // MIs[0] addr
     /* 244069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 244081 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 244088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244097 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244127 */     // GIR_Coverage, 7007,
     /* 244127 */     GIR_EraseRootFromParent_Done,
     /* 244128 */   // Label 4903: @244128
     /* 244128 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(244204), // Rule ID 7008 //
     /* 244133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244145 */     // MIs[0] addr
     /* 244145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 244157 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 244164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244173 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244203 */     // GIR_Coverage, 7008,
     /* 244203 */     GIR_EraseRootFromParent_Done,
     /* 244204 */   // Label 4904: @244204
     /* 244204 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(244280), // Rule ID 7009 //
     /* 244209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244221 */     // MIs[0] addr
     /* 244221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 244233 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 244240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244249 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244279 */     // GIR_Coverage, 7009,
     /* 244279 */     GIR_EraseRootFromParent_Done,
     /* 244280 */   // Label 4905: @244280
     /* 244280 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(244322), // Rule ID 7010 //
     /* 244285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244297 */     // MIs[0] addr
     /* 244297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 244309 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 244309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 244312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244314 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 244316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244320 */     GIR_RootConstrainSelectedInstOperands,
     /* 244321 */     // GIR_Coverage, 7010,
     /* 244321 */     GIR_EraseRootFromParent_Done,
     /* 244322 */   // Label 4906: @244322
     /* 244322 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(244362), // Rule ID 20 //
     /* 244327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 244330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 244335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244349 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 244349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 244352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 244356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244360 */     GIR_RootConstrainSelectedInstOperands,
     /* 244361 */     // GIR_Coverage, 20,
     /* 244361 */     GIR_EraseRootFromParent_Done,
     /* 244362 */   // Label 4907: @244362
     /* 244362 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(244402), // Rule ID 2375 //
     /* 244367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 244370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 244375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244389 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1573:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 244389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 244392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 244396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244400 */     GIR_RootConstrainSelectedInstOperands,
     /* 244401 */     // GIR_Coverage, 2375,
     /* 244401 */     GIR_EraseRootFromParent_Done,
     /* 244402 */   // Label 4908: @244402
     /* 244402 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(244442), // Rule ID 2486 //
     /* 244407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 244415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 244421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244429 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 244429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 244432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244440 */     GIR_RootConstrainSelectedInstOperands,
     /* 244441 */     // GIR_Coverage, 2486,
     /* 244441 */     GIR_EraseRootFromParent_Done,
     /* 244442 */   // Label 4909: @244442
     /* 244442 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(244482), // Rule ID 2487 //
     /* 244447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 244455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244469 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 244469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 244472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244480 */     GIR_RootConstrainSelectedInstOperands,
     /* 244481 */     // GIR_Coverage, 2487,
     /* 244481 */     GIR_EraseRootFromParent_Done,
     /* 244482 */   // Label 4910: @244482
     /* 244482 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(244522), // Rule ID 6893 //
     /* 244487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 244495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 244501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244509 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 244509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 244512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244520 */     GIR_RootConstrainSelectedInstOperands,
     /* 244521 */     // GIR_Coverage, 6893,
     /* 244521 */     GIR_EraseRootFromParent_Done,
     /* 244522 */   // Label 4911: @244522
     /* 244522 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(244562), // Rule ID 6894 //
     /* 244527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 244535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244549 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 244549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 244552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244560 */     GIR_RootConstrainSelectedInstOperands,
     /* 244561 */     // GIR_Coverage, 6894,
     /* 244561 */     GIR_EraseRootFromParent_Done,
     /* 244562 */   // Label 4912: @244562
     /* 244562 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(244598), // Rule ID 3557 //
     /* 244567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 244575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244585 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 244588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244596 */     GIR_RootConstrainSelectedInstOperands,
     /* 244597 */     // GIR_Coverage, 3557,
     /* 244597 */     GIR_EraseRootFromParent_Done,
     /* 244598 */   // Label 4913: @244598
     /* 244598 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(244636), // Rule ID 3943 //
     /* 244603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 244606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 244611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244621 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 244621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 244624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 244632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 244634 */     GIR_RootConstrainSelectedInstOperands,
     /* 244635 */     // GIR_Coverage, 3943,
     /* 244635 */     GIR_EraseRootFromParent_Done,
     /* 244636 */   // Label 4914: @244636
     /* 244636 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(244672), // Rule ID 12300 //
     /* 244641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 244649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244659 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 244662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244670 */     GIR_RootConstrainSelectedInstOperands,
     /* 244671 */     // GIR_Coverage, 12300,
     /* 244671 */     GIR_EraseRootFromParent_Done,
     /* 244672 */   // Label 4915: @244672
     /* 244672 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(244708), // Rule ID 12301 //
     /* 244677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 244685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244695 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 244698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244706 */     GIR_RootConstrainSelectedInstOperands,
     /* 244707 */     // GIR_Coverage, 12301,
     /* 244707 */     GIR_EraseRootFromParent_Done,
     /* 244708 */   // Label 4916: @244708
     /* 244708 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(244744), // Rule ID 12302 //
     /* 244713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 244721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244731 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1404:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 244734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244742 */     GIR_RootConstrainSelectedInstOperands,
     /* 244743 */     // GIR_Coverage, 12302,
     /* 244743 */     GIR_EraseRootFromParent_Done,
     /* 244744 */   // Label 4917: @244744
     /* 244744 */   GIM_Reject,
     /* 244745 */ // Label 4898: @244745
     /* 244745 */ GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(247653),
     /* 244750 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 244753 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(244850), // Rule ID 7018 //
     /* 244758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 244763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 244781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 244785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 244789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 244793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 244797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 244801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244806 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 244817 */     // MIs[0] addr
     /* 244817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 244821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 244829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 244831 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 244831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 244834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 244836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 244840 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 244842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 244848 */     GIR_RootConstrainSelectedInstOperands,
     /* 244849 */     // GIR_Coverage, 7018,
     /* 244849 */     GIR_EraseRootFromParent_Done,
     /* 244850 */   // Label 4919: @244850
     /* 244850 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(244947), // Rule ID 7019 //
     /* 244855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 244860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 244878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 244882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 244886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 244890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 244894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 244898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244903 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 244914 */     // MIs[0] addr
     /* 244914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 244918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 244926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 244928 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 244928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 244931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 244933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 244937 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 244939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 244945 */     GIR_RootConstrainSelectedInstOperands,
     /* 244946 */     // GIR_Coverage, 7019,
     /* 244946 */     GIR_EraseRootFromParent_Done,
     /* 244947 */   // Label 4920: @244947
     /* 244947 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(245044), // Rule ID 7028 //
     /* 244952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 244957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 244975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 244979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 244983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 244987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 244991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 244995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245000 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 245011 */     // MIs[0] addr
     /* 245011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 245023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245025 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 245028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245034 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245042 */     GIR_RootConstrainSelectedInstOperands,
     /* 245043 */     // GIR_Coverage, 7028,
     /* 245043 */     GIR_EraseRootFromParent_Done,
     /* 245044 */   // Label 4921: @245044
     /* 245044 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(245141), // Rule ID 7029 //
     /* 245049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 245080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245097 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 245108 */     // MIs[0] addr
     /* 245108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 245120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245122 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 245125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245131 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245139 */     GIR_RootConstrainSelectedInstOperands,
     /* 245140 */     // GIR_Coverage, 7029,
     /* 245140 */     GIR_EraseRootFromParent_Done,
     /* 245141 */   // Label 4922: @245141
     /* 245141 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(245252), // Rule ID 7021 //
     /* 245146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245182 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 245193 */     // MIs[0] addr
     /* 245193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 245205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245207 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245219 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 245238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245243 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245250 */     GIR_RootConstrainSelectedInstOperands,
     /* 245251 */     // GIR_Coverage, 7021,
     /* 245251 */     GIR_EraseRootFromParent_Done,
     /* 245252 */   // Label 4923: @245252
     /* 245252 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(245363), // Rule ID 7022 //
     /* 245257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245293 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 245304 */     // MIs[0] addr
     /* 245304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 245316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245318 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245330 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 245349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245354 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245361 */     GIR_RootConstrainSelectedInstOperands,
     /* 245362 */     // GIR_Coverage, 7022,
     /* 245362 */     GIR_EraseRootFromParent_Done,
     /* 245363 */   // Label 4924: @245363
     /* 245363 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(245474), // Rule ID 7023 //
     /* 245368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245404 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 245415 */     // MIs[0] addr
     /* 245415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 245427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245429 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245441 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 245460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245465 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245472 */     GIR_RootConstrainSelectedInstOperands,
     /* 245473 */     // GIR_Coverage, 7023,
     /* 245473 */     GIR_EraseRootFromParent_Done,
     /* 245474 */   // Label 4925: @245474
     /* 245474 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(245585), // Rule ID 7031 //
     /* 245479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245515 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 245526 */     // MIs[0] addr
     /* 245526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 245538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245540 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245552 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 245571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245576 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245583 */     GIR_RootConstrainSelectedInstOperands,
     /* 245584 */     // GIR_Coverage, 7031,
     /* 245584 */     GIR_EraseRootFromParent_Done,
     /* 245585 */   // Label 4926: @245585
     /* 245585 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(245696), // Rule ID 7032 //
     /* 245590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245626 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 245637 */     // MIs[0] addr
     /* 245637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 245649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245651 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 245682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245687 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245694 */     GIR_RootConstrainSelectedInstOperands,
     /* 245695 */     // GIR_Coverage, 7032,
     /* 245695 */     GIR_EraseRootFromParent_Done,
     /* 245696 */   // Label 4927: @245696
     /* 245696 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(245807), // Rule ID 7033 //
     /* 245701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245737 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 245748 */     // MIs[0] addr
     /* 245748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 245760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245762 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245774 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 245793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245798 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245805 */     GIR_RootConstrainSelectedInstOperands,
     /* 245806 */     // GIR_Coverage, 7033,
     /* 245806 */     GIR_EraseRootFromParent_Done,
     /* 245807 */   // Label 4928: @245807
     /* 245807 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(245858), // Rule ID 70 //
     /* 245812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 245817 */     // MIs[0] ptr
     /* 245817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 245825 */     // MIs[0] accessinfo
     /* 245825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245828 */     // MIs[0] fixed_shadow
     /* 245828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 245831 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 245831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 245834 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 245836 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 245838 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 245840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 245843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 245846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 245849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 245852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245856 */     GIR_RootConstrainSelectedInstOperands,
     /* 245857 */     // GIR_Coverage, 70,
     /* 245857 */     GIR_EraseRootFromParent_Done,
     /* 245858 */   // Label 4929: @245858
     /* 245858 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(245909), // Rule ID 71 //
     /* 245863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 245868 */     // MIs[0] ptr
     /* 245868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 245876 */     // MIs[0] accessinfo
     /* 245876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245879 */     // MIs[0] fixed_shadow
     /* 245879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 245882 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 245882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 245885 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 245887 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 245889 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 245891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 245894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 245897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 245900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 245903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245907 */     GIR_RootConstrainSelectedInstOperands,
     /* 245908 */     // GIR_Coverage, 71,
     /* 245908 */     GIR_EraseRootFromParent_Done,
     /* 245909 */   // Label 4930: @245909
     /* 245909 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(245978), // Rule ID 7020 //
     /* 245914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245946 */     // MIs[0] addr
     /* 245946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 245958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245960 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 245963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 245969 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245976 */     GIR_RootConstrainSelectedInstOperands,
     /* 245977 */     // GIR_Coverage, 7020,
     /* 245977 */     GIR_EraseRootFromParent_Done,
     /* 245978 */   // Label 4931: @245978
     /* 245978 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246047), // Rule ID 7030 //
     /* 245983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 246006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 246010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246015 */     // MIs[0] addr
     /* 246015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 246027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246029 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 246029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 246032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 246038 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246045 */     GIR_RootConstrainSelectedInstOperands,
     /* 246046 */     // GIR_Coverage, 7030,
     /* 246046 */     GIR_EraseRootFromParent_Done,
     /* 246047 */   // Label 4932: @246047
     /* 246047 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246101), // Rule ID 8693 //
     /* 246052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246060 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 246063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246067 */     // MIs[0] base
     /* 246067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246075 */     // MIs[0] prfop
     /* 246075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246083 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 246086 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246088 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246090 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246099 */     GIR_RootConstrainSelectedInstOperands,
     /* 246100 */     // GIR_Coverage, 8693,
     /* 246100 */     GIR_EraseRootFromParent_Done,
     /* 246101 */   // Label 4933: @246101
     /* 246101 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246155), // Rule ID 8696 //
     /* 246106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246114 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 246117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246121 */     // MIs[0] base
     /* 246121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246129 */     // MIs[0] prfop
     /* 246129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246137 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 246140 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246142 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246144 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246153 */     GIR_RootConstrainSelectedInstOperands,
     /* 246154 */     // GIR_Coverage, 8696,
     /* 246154 */     GIR_EraseRootFromParent_Done,
     /* 246155 */   // Label 4934: @246155
     /* 246155 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246209), // Rule ID 8699 //
     /* 246160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246168 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 246171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246175 */     // MIs[0] base
     /* 246175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246183 */     // MIs[0] prfop
     /* 246183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246191 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 246194 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246196 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246198 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246207 */     GIR_RootConstrainSelectedInstOperands,
     /* 246208 */     // GIR_Coverage, 8699,
     /* 246208 */     GIR_EraseRootFromParent_Done,
     /* 246209 */   // Label 4935: @246209
     /* 246209 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246263), // Rule ID 8702 //
     /* 246214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246222 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 246225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246229 */     // MIs[0] base
     /* 246229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246237 */     // MIs[0] prfop
     /* 246237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246245 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 246248 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246250 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246252 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246261 */     GIR_RootConstrainSelectedInstOperands,
     /* 246262 */     // GIR_Coverage, 8702,
     /* 246262 */     GIR_EraseRootFromParent_Done,
     /* 246263 */   // Label 4936: @246263
     /* 246263 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246317), // Rule ID 15 //
     /* 246268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 246273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 246294 */     // MIs[1] Operand 1
     /* 246294 */     // No operand predicates
     /* 246294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246300 */     // (intrinsic_w_chain:{ *:[i64] } 1138:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 246300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 246303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 246305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 246308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 246310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246315 */     GIR_RootConstrainSelectedInstOperands,
     /* 246316 */     // GIR_Coverage, 15,
     /* 246316 */     GIR_EraseRootFromParent_Done,
     /* 246317 */   // Label 4937: @246317
     /* 246317 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246385), // Rule ID 68 //
     /* 246322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 246327 */     // MIs[0] Operand 1
     /* 246327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 246335 */     // MIs[0] ptr
     /* 246335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246343 */     // MIs[0] accessinfo
     /* 246343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246346 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 246346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246350 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 246360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 246363 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 246365 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 246367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246383 */     GIR_RootConstrainSelectedInstOperands,
     /* 246384 */     // GIR_Coverage, 68,
     /* 246384 */     GIR_EraseRootFromParent_Done,
     /* 246385 */   // Label 4938: @246385
     /* 246385 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246453), // Rule ID 69 //
     /* 246390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 246395 */     // MIs[0] Operand 1
     /* 246395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 246403 */     // MIs[0] ptr
     /* 246403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246411 */     // MIs[0] accessinfo
     /* 246411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246414 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 246414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246418 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 246428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 246431 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 246433 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 246435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246451 */     GIR_RootConstrainSelectedInstOperands,
     /* 246452 */     // GIR_Coverage, 69,
     /* 246452 */     GIR_EraseRootFromParent_Done,
     /* 246453 */   // Label 4939: @246453
     /* 246453 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246533), // Rule ID 7014 //
     /* 246458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246477 */     // MIs[0] addr
     /* 246477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 246489 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246501 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 246520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246525 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246531 */     GIR_RootConstrainSelectedInstOperands,
     /* 246532 */     // GIR_Coverage, 7014,
     /* 246532 */     GIR_EraseRootFromParent_Done,
     /* 246533 */   // Label 4940: @246533
     /* 246533 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246613), // Rule ID 7015 //
     /* 246538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246557 */     // MIs[0] addr
     /* 246557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 246569 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246581 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 246600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246605 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246611 */     GIR_RootConstrainSelectedInstOperands,
     /* 246612 */     // GIR_Coverage, 7015,
     /* 246612 */     GIR_EraseRootFromParent_Done,
     /* 246613 */   // Label 4941: @246613
     /* 246613 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246693), // Rule ID 7016 //
     /* 246618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246637 */     // MIs[0] addr
     /* 246637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 246649 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 246680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246685 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246691 */     GIR_RootConstrainSelectedInstOperands,
     /* 246692 */     // GIR_Coverage, 7016,
     /* 246692 */     GIR_EraseRootFromParent_Done,
     /* 246693 */   // Label 4942: @246693
     /* 246693 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(246744), // Rule ID 7017 //
     /* 246698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246717 */     // MIs[0] addr
     /* 246717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 246729 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 246729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 246732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246734 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 246736 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246742 */     GIR_RootConstrainSelectedInstOperands,
     /* 246743 */     // GIR_Coverage, 7017,
     /* 246743 */     GIR_EraseRootFromParent_Done,
     /* 246744 */   // Label 4943: @246744
     /* 246744 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(246824), // Rule ID 7024 //
     /* 246749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246768 */     // MIs[0] addr
     /* 246768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 246780 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246792 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 246811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246816 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246822 */     GIR_RootConstrainSelectedInstOperands,
     /* 246823 */     // GIR_Coverage, 7024,
     /* 246823 */     GIR_EraseRootFromParent_Done,
     /* 246824 */   // Label 4944: @246824
     /* 246824 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(246904), // Rule ID 7025 //
     /* 246829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246848 */     // MIs[0] addr
     /* 246848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 246860 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246872 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 246891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246896 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246902 */     GIR_RootConstrainSelectedInstOperands,
     /* 246903 */     // GIR_Coverage, 7025,
     /* 246903 */     GIR_EraseRootFromParent_Done,
     /* 246904 */   // Label 4945: @246904
     /* 246904 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(246984), // Rule ID 7026 //
     /* 246909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246928 */     // MIs[0] addr
     /* 246928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 246940 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 246971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246976 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246982 */     GIR_RootConstrainSelectedInstOperands,
     /* 246983 */     // GIR_Coverage, 7026,
     /* 246983 */     GIR_EraseRootFromParent_Done,
     /* 246984 */   // Label 4946: @246984
     /* 246984 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247035), // Rule ID 7027 //
     /* 246989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247008 */     // MIs[0] addr
     /* 247008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 247020 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 247023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247025 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 247027 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247033 */     GIR_RootConstrainSelectedInstOperands,
     /* 247034 */     // GIR_Coverage, 7027,
     /* 247034 */     GIR_EraseRootFromParent_Done,
     /* 247035 */   // Label 4947: @247035
     /* 247035 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247084), // Rule ID 2479 //
     /* 247040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 247051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 247054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 247057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247069 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 247069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 247072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247082 */     GIR_RootConstrainSelectedInstOperands,
     /* 247083 */     // GIR_Coverage, 2479,
     /* 247083 */     GIR_EraseRootFromParent_Done,
     /* 247084 */   // Label 4948: @247084
     /* 247084 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247133), // Rule ID 2480 //
     /* 247089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 247100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 247103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 247106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247118 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 247118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 247121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247131 */     GIR_RootConstrainSelectedInstOperands,
     /* 247132 */     // GIR_Coverage, 2480,
     /* 247132 */     GIR_EraseRootFromParent_Done,
     /* 247133 */   // Label 4949: @247133
     /* 247133 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247182), // Rule ID 2481 //
     /* 247138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 247149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 247152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 247155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247167 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 247167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 247170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247180 */     GIR_RootConstrainSelectedInstOperands,
     /* 247181 */     // GIR_Coverage, 2481,
     /* 247181 */     GIR_EraseRootFromParent_Done,
     /* 247182 */   // Label 4950: @247182
     /* 247182 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247235), // Rule ID 8579 //
     /* 247187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 247195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247209 */     // MIs[0] base
     /* 247209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247217 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 247220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247224 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247233 */     GIR_RootConstrainSelectedInstOperands,
     /* 247234 */     // GIR_Coverage, 8579,
     /* 247234 */     GIR_EraseRootFromParent_Done,
     /* 247235 */   // Label 4951: @247235
     /* 247235 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247288), // Rule ID 8582 //
     /* 247240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 247248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247262 */     // MIs[0] base
     /* 247262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247270 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 247273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247277 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247286 */     GIR_RootConstrainSelectedInstOperands,
     /* 247287 */     // GIR_Coverage, 8582,
     /* 247287 */     GIR_EraseRootFromParent_Done,
     /* 247288 */   // Label 4952: @247288
     /* 247288 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247341), // Rule ID 8591 //
     /* 247293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 247301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247315 */     // MIs[0] base
     /* 247315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247323 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 247326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247330 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247339 */     GIR_RootConstrainSelectedInstOperands,
     /* 247340 */     // GIR_Coverage, 8591,
     /* 247340 */     GIR_EraseRootFromParent_Done,
     /* 247341 */   // Label 4953: @247341
     /* 247341 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247394), // Rule ID 8594 //
     /* 247346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 247354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247368 */     // MIs[0] base
     /* 247368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247376 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 247379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247383 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247392 */     GIR_RootConstrainSelectedInstOperands,
     /* 247393 */     // GIR_Coverage, 8594,
     /* 247393 */     GIR_EraseRootFromParent_Done,
     /* 247394 */   // Label 4954: @247394
     /* 247394 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247440), // Rule ID 137 //
     /* 247399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 247402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 247407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247417 */     // MIs[0] Rn
     /* 247417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 247421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247429 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 247429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 247432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247438 */     GIR_RootConstrainSelectedInstOperands,
     /* 247439 */     // GIR_Coverage, 137,
     /* 247439 */     GIR_EraseRootFromParent_Done,
     /* 247440 */   // Label 4955: @247440
     /* 247440 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247493), // Rule ID 8585 //
     /* 247445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 247453 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 247456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247467 */     // MIs[0] base
     /* 247467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247475 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 247478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247482 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247491 */     GIR_RootConstrainSelectedInstOperands,
     /* 247492 */     // GIR_Coverage, 8585,
     /* 247492 */     GIR_EraseRootFromParent_Done,
     /* 247493 */   // Label 4956: @247493
     /* 247493 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247546), // Rule ID 8588 //
     /* 247498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 247506 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 247509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247520 */     // MIs[0] base
     /* 247520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247528 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 247531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247544 */     GIR_RootConstrainSelectedInstOperands,
     /* 247545 */     // GIR_Coverage, 8588,
     /* 247545 */     GIR_EraseRootFromParent_Done,
     /* 247546 */   // Label 4957: @247546
     /* 247546 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247599), // Rule ID 8597 //
     /* 247551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 247559 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 247562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247573 */     // MIs[0] base
     /* 247573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247581 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 247584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247588 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247597 */     GIR_RootConstrainSelectedInstOperands,
     /* 247598 */     // GIR_Coverage, 8597,
     /* 247598 */     GIR_EraseRootFromParent_Done,
     /* 247599 */   // Label 4958: @247599
     /* 247599 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247652), // Rule ID 8600 //
     /* 247604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 247612 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 247615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247626 */     // MIs[0] base
     /* 247626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247634 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 247637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247641 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247650 */     GIR_RootConstrainSelectedInstOperands,
     /* 247651 */     // GIR_Coverage, 8600,
     /* 247651 */     GIR_EraseRootFromParent_Done,
     /* 247652 */   // Label 4959: @247652
     /* 247652 */   GIM_Reject,
     /* 247653 */ // Label 4918: @247653
     /* 247653 */ GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(250358),
     /* 247658 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 247661 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247732), // Rule ID 3393 //
     /* 247666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 247669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 247674 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 247677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 247695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 247699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 247703 */     // MIs[1] Operand 1
     /* 247703 */     // No operand predicates
     /* 247703 */     // MIs[0] prfop
     /* 247703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 247706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 247711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247713 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 247713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 247716 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 247718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 247720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 247722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 247725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 247730 */     GIR_RootConstrainSelectedInstOperands,
     /* 247731 */     // GIR_Coverage, 3393,
     /* 247731 */     GIR_EraseRootFromParent_Done,
     /* 247732 */   // Label 4961: @247732
     /* 247732 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247803), // Rule ID 3406 //
     /* 247737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 247740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 247745 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 247748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 247766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 247770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 247774 */     // MIs[1] Operand 1
     /* 247774 */     // No operand predicates
     /* 247774 */     // MIs[0] prfop
     /* 247774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 247777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 247782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247784 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 247784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 247787 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 247789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 247791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 247793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 247796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 247801 */     GIR_RootConstrainSelectedInstOperands,
     /* 247802 */     // GIR_Coverage, 3406,
     /* 247802 */     GIR_EraseRootFromParent_Done,
     /* 247803 */   // Label 4962: @247803
     /* 247803 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(247862), // Rule ID 3581 //
     /* 247808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 247811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 247816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247825 */     // MIs[0] tile
     /* 247825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 247833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247845 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 247845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 247848 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 247850 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 247852 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 247854 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 247856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247860 */     GIR_RootConstrainSelectedInstOperands,
     /* 247861 */     // GIR_Coverage, 3581,
     /* 247861 */     GIR_EraseRootFromParent_Done,
     /* 247862 */   // Label 4963: @247862
     /* 247862 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(247921), // Rule ID 3582 //
     /* 247867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 247870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 247875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247884 */     // MIs[0] tile
     /* 247884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 247892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247904 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 247904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 247907 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 247909 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 247911 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 247915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247919 */     GIR_RootConstrainSelectedInstOperands,
     /* 247920 */     // GIR_Coverage, 3582,
     /* 247920 */     GIR_EraseRootFromParent_Done,
     /* 247921 */   // Label 4964: @247921
     /* 247921 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(247980), // Rule ID 12360 //
     /* 247926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 247929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 247934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247943 */     // MIs[0] tile
     /* 247943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 247951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247963 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 247963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 247966 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 247968 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 247970 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 247972 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 247974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247978 */     GIR_RootConstrainSelectedInstOperands,
     /* 247979 */     // GIR_Coverage, 12360,
     /* 247979 */     GIR_EraseRootFromParent_Done,
     /* 247980 */   // Label 4965: @247980
     /* 247980 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248039), // Rule ID 12361 //
     /* 247985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 247988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 247993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248002 */     // MIs[0] tile
     /* 248002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 248010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248022 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 248022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 248025 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 248027 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 248029 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 248031 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 248033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248037 */     GIR_RootConstrainSelectedInstOperands,
     /* 248038 */     // GIR_Coverage, 12361,
     /* 248038 */     GIR_EraseRootFromParent_Done,
     /* 248039 */   // Label 4966: @248039
     /* 248039 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248099), // Rule ID 3391 //
     /* 248044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 248052 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248062 */     // MIs[0] Rn
     /* 248062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248074 */     // MIs[0] prfop
     /* 248074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248082 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 248082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248097 */     GIR_RootConstrainSelectedInstOperands,
     /* 248098 */     // GIR_Coverage, 3391,
     /* 248098 */     GIR_EraseRootFromParent_Done,
     /* 248099 */   // Label 4967: @248099
     /* 248099 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248159), // Rule ID 3392 //
     /* 248104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 248112 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248122 */     // MIs[0] Rn
     /* 248122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248134 */     // MIs[0] prfop
     /* 248134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248142 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 248142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 248145 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248157 */     GIR_RootConstrainSelectedInstOperands,
     /* 248158 */     // GIR_Coverage, 3392,
     /* 248158 */     GIR_EraseRootFromParent_Done,
     /* 248159 */   // Label 4968: @248159
     /* 248159 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248219), // Rule ID 3403 //
     /* 248164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 248172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248182 */     // MIs[0] Rn
     /* 248182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248194 */     // MIs[0] prfop
     /* 248194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248202 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 248202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248217 */     GIR_RootConstrainSelectedInstOperands,
     /* 248218 */     // GIR_Coverage, 3403,
     /* 248218 */     GIR_EraseRootFromParent_Done,
     /* 248219 */   // Label 4969: @248219
     /* 248219 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248279), // Rule ID 3404 //
     /* 248224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 248232 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248242 */     // MIs[0] Rn
     /* 248242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248254 */     // MIs[0] prfop
     /* 248254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248262 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 248262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 248265 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248277 */     GIR_RootConstrainSelectedInstOperands,
     /* 248278 */     // GIR_Coverage, 3404,
     /* 248278 */     GIR_EraseRootFromParent_Done,
     /* 248279 */   // Label 4970: @248279
     /* 248279 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248339), // Rule ID 3405 //
     /* 248284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 248292 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248302 */     // MIs[0] Rn
     /* 248302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248314 */     // MIs[0] prfop
     /* 248314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248322 */     // (intrinsic_void 1541:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 248322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 248325 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248337 */     GIR_RootConstrainSelectedInstOperands,
     /* 248338 */     // GIR_Coverage, 3405,
     /* 248338 */     GIR_EraseRootFromParent_Done,
     /* 248339 */   // Label 4971: @248339
     /* 248339 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248399), // Rule ID 8705 //
     /* 248344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 248352 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248362 */     // MIs[0] Rn
     /* 248362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248374 */     // MIs[0] prfop
     /* 248374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248382 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 248382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 248385 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248397 */     GIR_RootConstrainSelectedInstOperands,
     /* 248398 */     // GIR_Coverage, 8705,
     /* 248398 */     GIR_EraseRootFromParent_Done,
     /* 248399 */   // Label 4972: @248399
     /* 248399 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248459), // Rule ID 8706 //
     /* 248404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 248412 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248422 */     // MIs[0] Rn
     /* 248422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248434 */     // MIs[0] prfop
     /* 248434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248442 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 248442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 248445 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248457 */     GIR_RootConstrainSelectedInstOperands,
     /* 248458 */     // GIR_Coverage, 8706,
     /* 248458 */     GIR_EraseRootFromParent_Done,
     /* 248459 */   // Label 4973: @248459
     /* 248459 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248519), // Rule ID 8707 //
     /* 248464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 248472 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248482 */     // MIs[0] Rn
     /* 248482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248494 */     // MIs[0] prfop
     /* 248494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248502 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 248502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 248505 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248517 */     GIR_RootConstrainSelectedInstOperands,
     /* 248518 */     // GIR_Coverage, 8707,
     /* 248518 */     GIR_EraseRootFromParent_Done,
     /* 248519 */   // Label 4974: @248519
     /* 248519 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248579), // Rule ID 8708 //
     /* 248524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 248532 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248542 */     // MIs[0] Rn
     /* 248542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248554 */     // MIs[0] prfop
     /* 248554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248562 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 248562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 248565 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248577 */     GIR_RootConstrainSelectedInstOperands,
     /* 248578 */     // GIR_Coverage, 8708,
     /* 248578 */     GIR_EraseRootFromParent_Done,
     /* 248579 */   // Label 4975: @248579
     /* 248579 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248639), // Rule ID 8709 //
     /* 248584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 248592 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248602 */     // MIs[0] Rn
     /* 248602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248614 */     // MIs[0] prfop
     /* 248614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248622 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 248622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 248625 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248637 */     GIR_RootConstrainSelectedInstOperands,
     /* 248638 */     // GIR_Coverage, 8709,
     /* 248638 */     GIR_EraseRootFromParent_Done,
     /* 248639 */   // Label 4976: @248639
     /* 248639 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248699), // Rule ID 8710 //
     /* 248644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 248652 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248662 */     // MIs[0] Rn
     /* 248662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248674 */     // MIs[0] prfop
     /* 248674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248682 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 248682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 248685 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248697 */     GIR_RootConstrainSelectedInstOperands,
     /* 248698 */     // GIR_Coverage, 8710,
     /* 248698 */     GIR_EraseRootFromParent_Done,
     /* 248699 */   // Label 4977: @248699
     /* 248699 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248759), // Rule ID 8711 //
     /* 248704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 248712 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248722 */     // MIs[0] Rn
     /* 248722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248734 */     // MIs[0] prfop
     /* 248734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248742 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 248742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 248745 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248757 */     GIR_RootConstrainSelectedInstOperands,
     /* 248758 */     // GIR_Coverage, 8711,
     /* 248758 */     GIR_EraseRootFromParent_Done,
     /* 248759 */   // Label 4978: @248759
     /* 248759 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248819), // Rule ID 8712 //
     /* 248764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 248772 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248782 */     // MIs[0] Rn
     /* 248782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248794 */     // MIs[0] prfop
     /* 248794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248802 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 248802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 248805 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248817 */     GIR_RootConstrainSelectedInstOperands,
     /* 248818 */     // GIR_Coverage, 8712,
     /* 248818 */     GIR_EraseRootFromParent_Done,
     /* 248819 */   // Label 4979: @248819
     /* 248819 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248879), // Rule ID 8713 //
     /* 248824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 248832 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248842 */     // MIs[0] Rn
     /* 248842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248854 */     // MIs[0] prfop
     /* 248854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248862 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 248862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 248865 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248877 */     GIR_RootConstrainSelectedInstOperands,
     /* 248878 */     // GIR_Coverage, 8713,
     /* 248878 */     GIR_EraseRootFromParent_Done,
     /* 248879 */   // Label 4980: @248879
     /* 248879 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248939), // Rule ID 8714 //
     /* 248884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 248892 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248902 */     // MIs[0] Rn
     /* 248902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248914 */     // MIs[0] prfop
     /* 248914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248922 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 248922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 248925 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248937 */     GIR_RootConstrainSelectedInstOperands,
     /* 248938 */     // GIR_Coverage, 8714,
     /* 248938 */     GIR_EraseRootFromParent_Done,
     /* 248939 */   // Label 4981: @248939
     /* 248939 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248999), // Rule ID 8715 //
     /* 248944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 248952 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248962 */     // MIs[0] Rn
     /* 248962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248974 */     // MIs[0] prfop
     /* 248974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248982 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 248982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 248985 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248997 */     GIR_RootConstrainSelectedInstOperands,
     /* 248998 */     // GIR_Coverage, 8715,
     /* 248998 */     GIR_EraseRootFromParent_Done,
     /* 248999 */   // Label 4982: @248999
     /* 248999 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249059), // Rule ID 8716 //
     /* 249004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 249012 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249022 */     // MIs[0] Rn
     /* 249022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249034 */     // MIs[0] prfop
     /* 249034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249042 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 249042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 249045 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249057 */     GIR_RootConstrainSelectedInstOperands,
     /* 249058 */     // GIR_Coverage, 8716,
     /* 249058 */     GIR_EraseRootFromParent_Done,
     /* 249059 */   // Label 4983: @249059
     /* 249059 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249119), // Rule ID 8717 //
     /* 249064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 249072 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249082 */     // MIs[0] Rn
     /* 249082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249094 */     // MIs[0] prfop
     /* 249094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249102 */     // (intrinsic_void 1549:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 249102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 249105 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249117 */     GIR_RootConstrainSelectedInstOperands,
     /* 249118 */     // GIR_Coverage, 8717,
     /* 249118 */     GIR_EraseRootFromParent_Done,
     /* 249119 */   // Label 4984: @249119
     /* 249119 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249179), // Rule ID 8718 //
     /* 249124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 249132 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249142 */     // MIs[0] Rn
     /* 249142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249154 */     // MIs[0] prfop
     /* 249154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249162 */     // (intrinsic_void 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 249162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 249165 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249177 */     GIR_RootConstrainSelectedInstOperands,
     /* 249178 */     // GIR_Coverage, 8718,
     /* 249178 */     GIR_EraseRootFromParent_Done,
     /* 249179 */   // Label 4985: @249179
     /* 249179 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249239), // Rule ID 8719 //
     /* 249184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 249192 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249202 */     // MIs[0] Rn
     /* 249202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249214 */     // MIs[0] prfop
     /* 249214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249222 */     // (intrinsic_void 1545:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 249222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 249225 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249237 */     GIR_RootConstrainSelectedInstOperands,
     /* 249238 */     // GIR_Coverage, 8719,
     /* 249238 */     GIR_EraseRootFromParent_Done,
     /* 249239 */   // Label 4986: @249239
     /* 249239 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249297), // Rule ID 2365 //
     /* 249244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 249252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249280 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 249283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249295 */     GIR_RootConstrainSelectedInstOperands,
     /* 249296 */     // GIR_Coverage, 2365,
     /* 249296 */     GIR_EraseRootFromParent_Done,
     /* 249297 */   // Label 4987: @249297
     /* 249297 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249355), // Rule ID 2366 //
     /* 249302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 249310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249338 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 249341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249353 */     GIR_RootConstrainSelectedInstOperands,
     /* 249354 */     // GIR_Coverage, 2366,
     /* 249354 */     GIR_EraseRootFromParent_Done,
     /* 249355 */   // Label 4988: @249355
     /* 249355 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249413), // Rule ID 2367 //
     /* 249360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 249368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249396 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 249399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249411 */     GIR_RootConstrainSelectedInstOperands,
     /* 249412 */     // GIR_Coverage, 2367,
     /* 249412 */     GIR_EraseRootFromParent_Done,
     /* 249413 */   // Label 4989: @249413
     /* 249413 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249471), // Rule ID 2368 //
     /* 249418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 249426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249454 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 249457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249469 */     GIR_RootConstrainSelectedInstOperands,
     /* 249470 */     // GIR_Coverage, 2368,
     /* 249470 */     GIR_EraseRootFromParent_Done,
     /* 249471 */   // Label 4990: @249471
     /* 249471 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249529), // Rule ID 2369 //
     /* 249476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 249484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249512 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 249515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249527 */     GIR_RootConstrainSelectedInstOperands,
     /* 249528 */     // GIR_Coverage, 2369,
     /* 249528 */     GIR_EraseRootFromParent_Done,
     /* 249529 */   // Label 4991: @249529
     /* 249529 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249587), // Rule ID 2370 //
     /* 249534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 249542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249570 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 249573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249585 */     GIR_RootConstrainSelectedInstOperands,
     /* 249586 */     // GIR_Coverage, 2370,
     /* 249586 */     GIR_EraseRootFromParent_Done,
     /* 249587 */   // Label 4992: @249587
     /* 249587 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249645), // Rule ID 2371 //
     /* 249592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 249595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 249600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 249603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 249606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 249609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 249612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249628 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 249628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 249631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249643 */     GIR_RootConstrainSelectedInstOperands,
     /* 249644 */     // GIR_Coverage, 2371,
     /* 249644 */     GIR_EraseRootFromParent_Done,
     /* 249645 */   // Label 4993: @249645
     /* 249645 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249703), // Rule ID 2372 //
     /* 249650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 249653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 249658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249686 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 249689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249701 */     GIR_RootConstrainSelectedInstOperands,
     /* 249702 */     // GIR_Coverage, 2372,
     /* 249702 */     GIR_EraseRootFromParent_Done,
     /* 249703 */   // Label 4994: @249703
     /* 249703 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249761), // Rule ID 2373 //
     /* 249708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 249711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 249716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 249719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 249722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 249725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 249728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249744 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 249744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 249747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249759 */     GIR_RootConstrainSelectedInstOperands,
     /* 249760 */     // GIR_Coverage, 2373,
     /* 249760 */     GIR_EraseRootFromParent_Done,
     /* 249761 */   // Label 4995: @249761
     /* 249761 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249819), // Rule ID 2374 //
     /* 249766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 249769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 249774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249802 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 249805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249817 */     GIR_RootConstrainSelectedInstOperands,
     /* 249818 */     // GIR_Coverage, 2374,
     /* 249818 */     GIR_EraseRootFromParent_Done,
     /* 249819 */   // Label 4996: @249819
     /* 249819 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249877), // Rule ID 2482 //
     /* 249824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 249832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 249835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 249838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 249841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 249844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249860 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 249860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 249863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249865 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 249867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249875 */     GIR_RootConstrainSelectedInstOperands,
     /* 249876 */     // GIR_Coverage, 2482,
     /* 249876 */     GIR_EraseRootFromParent_Done,
     /* 249877 */   // Label 4997: @249877
     /* 249877 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249933), // Rule ID 12834 //
     /* 249882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 249887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 249896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249908 */     // MIs[0] addr
     /* 249908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 249912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249916 */     // (intrinsic_w_chain:{ *:[i32] } 1144:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 249916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 249919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249921 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 249923 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 249925 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 249927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249931 */     GIR_RootConstrainSelectedInstOperands,
     /* 249932 */     // GIR_Coverage, 12834,
     /* 249932 */     GIR_EraseRootFromParent_Done,
     /* 249933 */   // Label 4998: @249933
     /* 249933 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249989), // Rule ID 12835 //
     /* 249938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 249943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 249952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249964 */     // MIs[0] addr
     /* 249964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 249968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249972 */     // (intrinsic_w_chain:{ *:[i32] } 1146:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 249972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 249975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249977 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 249979 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 249981 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 249983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249987 */     GIR_RootConstrainSelectedInstOperands,
     /* 249988 */     // GIR_Coverage, 12835,
     /* 249988 */     GIR_EraseRootFromParent_Done,
     /* 249989 */   // Label 4999: @249989
     /* 249989 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(250035), // Rule ID 3439 //
     /* 249994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 249997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 250002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250018 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 250021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250033 */     GIR_RootConstrainSelectedInstOperands,
     /* 250034 */     // GIR_Coverage, 3439,
     /* 250034 */     GIR_EraseRootFromParent_Done,
     /* 250035 */   // Label 5000: @250035
     /* 250035 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(250081), // Rule ID 3561 //
     /* 250040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 250048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250064 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 250067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250079 */     GIR_RootConstrainSelectedInstOperands,
     /* 250080 */     // GIR_Coverage, 3561,
     /* 250080 */     GIR_EraseRootFromParent_Done,
     /* 250081 */   // Label 5001: @250081
     /* 250081 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(250127), // Rule ID 12347 //
     /* 250086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 250094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250110 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 250113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250125 */     GIR_RootConstrainSelectedInstOperands,
     /* 250126 */     // GIR_Coverage, 12347,
     /* 250126 */     GIR_EraseRootFromParent_Done,
     /* 250127 */   // Label 5002: @250127
     /* 250127 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(250173), // Rule ID 12351 //
     /* 250132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 250140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250156 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1413:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 250159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250171 */     GIR_RootConstrainSelectedInstOperands,
     /* 250172 */     // GIR_Coverage, 12351,
     /* 250172 */     GIR_EraseRootFromParent_Done,
     /* 250173 */   // Label 5003: @250173
     /* 250173 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(250219), // Rule ID 12352 //
     /* 250178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 250186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250202 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1415:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 250205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250217 */     GIR_RootConstrainSelectedInstOperands,
     /* 250218 */     // GIR_Coverage, 12352,
     /* 250218 */     GIR_EraseRootFromParent_Done,
     /* 250219 */   // Label 5004: @250219
     /* 250219 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(250265), // Rule ID 12353 //
     /* 250224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 250232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250248 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 250251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250263 */     GIR_RootConstrainSelectedInstOperands,
     /* 250264 */     // GIR_Coverage, 12353,
     /* 250264 */     GIR_EraseRootFromParent_Done,
     /* 250265 */   // Label 5005: @250265
     /* 250265 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(250311), // Rule ID 12354 //
     /* 250270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 250278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250294 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 250297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250309 */     GIR_RootConstrainSelectedInstOperands,
     /* 250310 */     // GIR_Coverage, 12354,
     /* 250310 */     GIR_EraseRootFromParent_Done,
     /* 250311 */   // Label 5006: @250311
     /* 250311 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250357), // Rule ID 12355 //
     /* 250316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 250319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 250324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250340 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 250343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250355 */     GIR_RootConstrainSelectedInstOperands,
     /* 250356 */     // GIR_Coverage, 12355,
     /* 250356 */     GIR_EraseRootFromParent_Done,
     /* 250357 */   // Label 5007: @250357
     /* 250357 */   GIM_Reject,
     /* 250358 */ // Label 4960: @250358
     /* 250358 */ GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(253351),
     /* 250363 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 250366 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250434), // Rule ID 2509 //
     /* 250371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 250379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250407 */     // MIs[0] Idx
     /* 250407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250415 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 250418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250426 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250432 */     GIR_RootConstrainSelectedInstOperands,
     /* 250433 */     // GIR_Coverage, 2509,
     /* 250433 */     GIR_EraseRootFromParent_Done,
     /* 250434 */   // Label 5009: @250434
     /* 250434 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250502), // Rule ID 2510 //
     /* 250439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 250447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250475 */     // MIs[0] Idx
     /* 250475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250483 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 250486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250494 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250500 */     GIR_RootConstrainSelectedInstOperands,
     /* 250501 */     // GIR_Coverage, 2510,
     /* 250501 */     GIR_EraseRootFromParent_Done,
     /* 250502 */   // Label 5010: @250502
     /* 250502 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250570), // Rule ID 2511 //
     /* 250507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 250515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 250518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 250521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250543 */     // MIs[0] Idx
     /* 250543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 250551 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 250554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250562 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250568 */     GIR_RootConstrainSelectedInstOperands,
     /* 250569 */     // GIR_Coverage, 2511,
     /* 250569 */     GIR_EraseRootFromParent_Done,
     /* 250570 */   // Label 5011: @250570
     /* 250570 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250638), // Rule ID 2512 //
     /* 250575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 250583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250611 */     // MIs[0] Idx
     /* 250611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 250619 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 250622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250630 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250636 */     GIR_RootConstrainSelectedInstOperands,
     /* 250637 */     // GIR_Coverage, 2512,
     /* 250637 */     GIR_EraseRootFromParent_Done,
     /* 250638 */   // Label 5012: @250638
     /* 250638 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250706), // Rule ID 2513 //
     /* 250643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 250646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 250651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 250654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 250657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 250679 */     // MIs[0] Idx
     /* 250679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 250687 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 250690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250698 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250704 */     GIR_RootConstrainSelectedInstOperands,
     /* 250705 */     // GIR_Coverage, 2513,
     /* 250705 */     GIR_EraseRootFromParent_Done,
     /* 250706 */   // Label 5013: @250706
     /* 250706 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250774), // Rule ID 2514 //
     /* 250711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 250714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 250719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 250747 */     // MIs[0] Idx
     /* 250747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 250755 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 250758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250766 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250772 */     GIR_RootConstrainSelectedInstOperands,
     /* 250773 */     // GIR_Coverage, 2514,
     /* 250773 */     GIR_EraseRootFromParent_Done,
     /* 250774 */   // Label 5014: @250774
     /* 250774 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250842), // Rule ID 6895 //
     /* 250779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 250787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250815 */     // MIs[0] Idx
     /* 250815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250823 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 250826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250840 */     GIR_RootConstrainSelectedInstOperands,
     /* 250841 */     // GIR_Coverage, 6895,
     /* 250841 */     GIR_EraseRootFromParent_Done,
     /* 250842 */   // Label 5015: @250842
     /* 250842 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250910), // Rule ID 6896 //
     /* 250847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 250855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250883 */     // MIs[0] Idx
     /* 250883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250891 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 250894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250908 */     GIR_RootConstrainSelectedInstOperands,
     /* 250909 */     // GIR_Coverage, 6896,
     /* 250909 */     GIR_EraseRootFromParent_Done,
     /* 250910 */   // Label 5016: @250910
     /* 250910 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250978), // Rule ID 6897 //
     /* 250915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 250923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250951 */     // MIs[0] Idx
     /* 250951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250959 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 250962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250970 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250976 */     GIR_RootConstrainSelectedInstOperands,
     /* 250977 */     // GIR_Coverage, 6897,
     /* 250977 */     GIR_EraseRootFromParent_Done,
     /* 250978 */   // Label 5017: @250978
     /* 250978 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(251046), // Rule ID 6898 //
     /* 250983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 250991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 251019 */     // MIs[0] Idx
     /* 251019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 251027 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 251030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251038 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251044 */     GIR_RootConstrainSelectedInstOperands,
     /* 251045 */     // GIR_Coverage, 6898,
     /* 251045 */     GIR_EraseRootFromParent_Done,
     /* 251046 */   // Label 5018: @251046
     /* 251046 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(251106), // Rule ID 3573 //
     /* 251051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251071 */     // MIs[0] tile
     /* 251071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251087 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 251087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 251090 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251098 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251104 */     GIR_RootConstrainSelectedInstOperands,
     /* 251105 */     // GIR_Coverage, 3573,
     /* 251105 */     GIR_EraseRootFromParent_Done,
     /* 251106 */   // Label 5019: @251106
     /* 251106 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(251166), // Rule ID 3574 //
     /* 251111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 251114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 251119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251131 */     // MIs[0] tile
     /* 251131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251147 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 251150 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251158 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251164 */     GIR_RootConstrainSelectedInstOperands,
     /* 251165 */     // GIR_Coverage, 3574,
     /* 251165 */     GIR_EraseRootFromParent_Done,
     /* 251166 */   // Label 5020: @251166
     /* 251166 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(251226), // Rule ID 3575 //
     /* 251171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 251174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251191 */     // MIs[0] tile
     /* 251191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251207 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 251207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 251210 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251218 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251224 */     GIR_RootConstrainSelectedInstOperands,
     /* 251225 */     // GIR_Coverage, 3575,
     /* 251225 */     GIR_EraseRootFromParent_Done,
     /* 251226 */   // Label 5021: @251226
     /* 251226 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(251286), // Rule ID 3576 //
     /* 251231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 251234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 251239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251251 */     // MIs[0] tile
     /* 251251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251267 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 251270 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251278 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251284 */     GIR_RootConstrainSelectedInstOperands,
     /* 251285 */     // GIR_Coverage, 3576,
     /* 251285 */     GIR_EraseRootFromParent_Done,
     /* 251286 */   // Label 5022: @251286
     /* 251286 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(251346), // Rule ID 3577 //
     /* 251291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 251294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251311 */     // MIs[0] tile
     /* 251311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251327 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 251330 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251344 */     GIR_RootConstrainSelectedInstOperands,
     /* 251345 */     // GIR_Coverage, 3577,
     /* 251345 */     GIR_EraseRootFromParent_Done,
     /* 251346 */   // Label 5023: @251346
     /* 251346 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(251406), // Rule ID 3578 //
     /* 251351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 251359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251371 */     // MIs[0] tile
     /* 251371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251387 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 251390 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251398 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251404 */     GIR_RootConstrainSelectedInstOperands,
     /* 251405 */     // GIR_Coverage, 3578,
     /* 251405 */     GIR_EraseRootFromParent_Done,
     /* 251406 */   // Label 5024: @251406
     /* 251406 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(251466), // Rule ID 3579 //
     /* 251411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 251414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 251419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251431 */     // MIs[0] tile
     /* 251431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251447 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 251450 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251458 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251464 */     GIR_RootConstrainSelectedInstOperands,
     /* 251465 */     // GIR_Coverage, 3579,
     /* 251465 */     GIR_EraseRootFromParent_Done,
     /* 251466 */   // Label 5025: @251466
     /* 251466 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(251526), // Rule ID 3580 //
     /* 251471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 251479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251491 */     // MIs[0] tile
     /* 251491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251507 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 251510 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251518 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251524 */     GIR_RootConstrainSelectedInstOperands,
     /* 251525 */     // GIR_Coverage, 3580,
     /* 251525 */     GIR_EraseRootFromParent_Done,
     /* 251526 */   // Label 5026: @251526
     /* 251526 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251586), // Rule ID 3662 //
     /* 251531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 251534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 251539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251551 */     // MIs[0] tile
     /* 251551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251567 */     // (intrinsic_void 990:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 251570 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251578 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251584 */     GIR_RootConstrainSelectedInstOperands,
     /* 251585 */     // GIR_Coverage, 3662,
     /* 251585 */     GIR_EraseRootFromParent_Done,
     /* 251586 */   // Label 5027: @251586
     /* 251586 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251646), // Rule ID 3663 //
     /* 251591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 251594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 251599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251611 */     // MIs[0] tile
     /* 251611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251627 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 251627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 251630 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251638 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251644 */     GIR_RootConstrainSelectedInstOperands,
     /* 251645 */     // GIR_Coverage, 3663,
     /* 251645 */     GIR_EraseRootFromParent_Done,
     /* 251646 */   // Label 5028: @251646
     /* 251646 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251706), // Rule ID 12362 //
     /* 251651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 251659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251671 */     // MIs[0] tile
     /* 251671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251687 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 251687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 251690 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251698 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251704 */     GIR_RootConstrainSelectedInstOperands,
     /* 251705 */     // GIR_Coverage, 12362,
     /* 251705 */     GIR_EraseRootFromParent_Done,
     /* 251706 */   // Label 5029: @251706
     /* 251706 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251766), // Rule ID 12363 //
     /* 251711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 251714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 251719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251731 */     // MIs[0] tile
     /* 251731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251747 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 251747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 251750 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251758 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251764 */     GIR_RootConstrainSelectedInstOperands,
     /* 251765 */     // GIR_Coverage, 12363,
     /* 251765 */     GIR_EraseRootFromParent_Done,
     /* 251766 */   // Label 5030: @251766
     /* 251766 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251826), // Rule ID 12364 //
     /* 251771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 251779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251791 */     // MIs[0] tile
     /* 251791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251807 */     // (intrinsic_void 907:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 251810 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251818 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251824 */     GIR_RootConstrainSelectedInstOperands,
     /* 251825 */     // GIR_Coverage, 12364,
     /* 251825 */     GIR_EraseRootFromParent_Done,
     /* 251826 */   // Label 5031: @251826
     /* 251826 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251886), // Rule ID 12365 //
     /* 251831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 251839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251851 */     // MIs[0] tile
     /* 251851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251867 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 251870 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251878 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251884 */     GIR_RootConstrainSelectedInstOperands,
     /* 251885 */     // GIR_Coverage, 12365,
     /* 251885 */     GIR_EraseRootFromParent_Done,
     /* 251886 */   // Label 5032: @251886
     /* 251886 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251946), // Rule ID 12366 //
     /* 251891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 251899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251911 */     // MIs[0] tile
     /* 251911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251927 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 251930 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251938 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251944 */     GIR_RootConstrainSelectedInstOperands,
     /* 251945 */     // GIR_Coverage, 12366,
     /* 251945 */     GIR_EraseRootFromParent_Done,
     /* 251946 */   // Label 5033: @251946
     /* 251946 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(252006), // Rule ID 12367 //
     /* 251951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 251959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251971 */     // MIs[0] tile
     /* 251971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251987 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 251990 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251998 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252004 */     GIR_RootConstrainSelectedInstOperands,
     /* 252005 */     // GIR_Coverage, 12367,
     /* 252005 */     GIR_EraseRootFromParent_Done,
     /* 252006 */   // Label 5034: @252006
     /* 252006 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(252066), // Rule ID 12368 //
     /* 252011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 252019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252031 */     // MIs[0] tile
     /* 252031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252047 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 252050 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252058 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252064 */     GIR_RootConstrainSelectedInstOperands,
     /* 252065 */     // GIR_Coverage, 12368,
     /* 252065 */     GIR_EraseRootFromParent_Done,
     /* 252066 */   // Label 5035: @252066
     /* 252066 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(252126), // Rule ID 12369 //
     /* 252071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 252079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252091 */     // MIs[0] tile
     /* 252091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252107 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 252110 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252118 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252124 */     GIR_RootConstrainSelectedInstOperands,
     /* 252125 */     // GIR_Coverage, 12369,
     /* 252125 */     GIR_EraseRootFromParent_Done,
     /* 252126 */   // Label 5036: @252126
     /* 252126 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(252186), // Rule ID 12370 //
     /* 252131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 252139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252151 */     // MIs[0] tile
     /* 252151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252167 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 252170 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252178 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252184 */     GIR_RootConstrainSelectedInstOperands,
     /* 252185 */     // GIR_Coverage, 12370,
     /* 252185 */     GIR_EraseRootFromParent_Done,
     /* 252186 */   // Label 5037: @252186
     /* 252186 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(252246), // Rule ID 12371 //
     /* 252191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 252199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252211 */     // MIs[0] tile
     /* 252211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252227 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 252230 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252238 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252244 */     GIR_RootConstrainSelectedInstOperands,
     /* 252245 */     // GIR_Coverage, 12371,
     /* 252245 */     GIR_EraseRootFromParent_Done,
     /* 252246 */   // Label 5038: @252246
     /* 252246 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(252306), // Rule ID 12372 //
     /* 252251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 252259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252271 */     // MIs[0] tile
     /* 252271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252287 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 252290 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252298 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252304 */     GIR_RootConstrainSelectedInstOperands,
     /* 252305 */     // GIR_Coverage, 12372,
     /* 252305 */     GIR_EraseRootFromParent_Done,
     /* 252306 */   // Label 5039: @252306
     /* 252306 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(252366), // Rule ID 12373 //
     /* 252311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 252319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252331 */     // MIs[0] tile
     /* 252331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252347 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 252350 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252358 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252364 */     GIR_RootConstrainSelectedInstOperands,
     /* 252365 */     // GIR_Coverage, 12373,
     /* 252365 */     GIR_EraseRootFromParent_Done,
     /* 252366 */   // Label 5040: @252366
     /* 252366 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(252426), // Rule ID 12374 //
     /* 252371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 252379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252391 */     // MIs[0] tile
     /* 252391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252407 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 252410 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252418 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252424 */     GIR_RootConstrainSelectedInstOperands,
     /* 252425 */     // GIR_Coverage, 12374,
     /* 252425 */     GIR_EraseRootFromParent_Done,
     /* 252426 */   // Label 5041: @252426
     /* 252426 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(252486), // Rule ID 12375 //
     /* 252431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 252439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252451 */     // MIs[0] tile
     /* 252451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252467 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 252470 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252478 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252484 */     GIR_RootConstrainSelectedInstOperands,
     /* 252485 */     // GIR_Coverage, 12375,
     /* 252485 */     GIR_EraseRootFromParent_Done,
     /* 252486 */   // Label 5042: @252486
     /* 252486 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252546), // Rule ID 12376 //
     /* 252491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 252499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252511 */     // MIs[0] tile
     /* 252511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252527 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 252530 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252538 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252544 */     GIR_RootConstrainSelectedInstOperands,
     /* 252545 */     // GIR_Coverage, 12376,
     /* 252545 */     GIR_EraseRootFromParent_Done,
     /* 252546 */   // Label 5043: @252546
     /* 252546 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(252606), // Rule ID 12377 //
     /* 252551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 252559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252571 */     // MIs[0] tile
     /* 252571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252587 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 252590 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252598 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252604 */     GIR_RootConstrainSelectedInstOperands,
     /* 252605 */     // GIR_Coverage, 12377,
     /* 252605 */     GIR_EraseRootFromParent_Done,
     /* 252606 */   // Label 5044: @252606
     /* 252606 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252666), // Rule ID 12378 //
     /* 252611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 252619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252631 */     // MIs[0] tile
     /* 252631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252647 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 252650 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252658 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252664 */     GIR_RootConstrainSelectedInstOperands,
     /* 252665 */     // GIR_Coverage, 12378,
     /* 252665 */     GIR_EraseRootFromParent_Done,
     /* 252666 */   // Label 5045: @252666
     /* 252666 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252726), // Rule ID 12675 //
     /* 252671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 252679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 252685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 252691 */     // MIs[0] tile
     /* 252691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252707 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 252707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 252710 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252718 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252724 */     GIR_RootConstrainSelectedInstOperands,
     /* 252725 */     // GIR_Coverage, 12675,
     /* 252725 */     GIR_EraseRootFromParent_Done,
     /* 252726 */   // Label 5046: @252726
     /* 252726 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252786), // Rule ID 12676 //
     /* 252731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 252739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252751 */     // MIs[0] tile
     /* 252751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252767 */     // (intrinsic_void 992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 252770 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252778 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252784 */     GIR_RootConstrainSelectedInstOperands,
     /* 252785 */     // GIR_Coverage, 12676,
     /* 252785 */     GIR_EraseRootFromParent_Done,
     /* 252786 */   // Label 5047: @252786
     /* 252786 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252846), // Rule ID 12677 //
     /* 252791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 252799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252811 */     // MIs[0] tile
     /* 252811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252827 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 252830 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252838 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252844 */     GIR_RootConstrainSelectedInstOperands,
     /* 252845 */     // GIR_Coverage, 12677,
     /* 252845 */     GIR_EraseRootFromParent_Done,
     /* 252846 */   // Label 5048: @252846
     /* 252846 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252906), // Rule ID 12678 //
     /* 252851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 252859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252871 */     // MIs[0] tile
     /* 252871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252887 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 252890 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252904 */     GIR_RootConstrainSelectedInstOperands,
     /* 252905 */     // GIR_Coverage, 12678,
     /* 252905 */     GIR_EraseRootFromParent_Done,
     /* 252906 */   // Label 5049: @252906
     /* 252906 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252966), // Rule ID 12789 //
     /* 252911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 252914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 252919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252931 */     // MIs[0] tile
     /* 252931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252947 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 252950 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252964 */     GIR_RootConstrainSelectedInstOperands,
     /* 252965 */     // GIR_Coverage, 12789,
     /* 252965 */     GIR_EraseRootFromParent_Done,
     /* 252966 */   // Label 5050: @252966
     /* 252966 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(253014), // Rule ID 3560 //
     /* 252971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 252979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252995 */     // MIs[0] Op4
     /* 252995 */     // No operand predicates
     /* 252995 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1412:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 252995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 252998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253006 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253012 */     GIR_RootConstrainSelectedInstOperands,
     /* 253013 */     // GIR_Coverage, 3560,
     /* 253013 */     GIR_EraseRootFromParent_Done,
     /* 253014 */   // Label 5051: @253014
     /* 253014 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(253062), // Rule ID 3562 //
     /* 253019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 253027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253043 */     // MIs[0] Op4
     /* 253043 */     // No operand predicates
     /* 253043 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1414:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 253046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253054 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253060 */     GIR_RootConstrainSelectedInstOperands,
     /* 253061 */     // GIR_Coverage, 3562,
     /* 253061 */     GIR_EraseRootFromParent_Done,
     /* 253062 */   // Label 5052: @253062
     /* 253062 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(253110), // Rule ID 3563 //
     /* 253067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 253070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 253075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253091 */     // MIs[0] Op4
     /* 253091 */     // No operand predicates
     /* 253091 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 253094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253102 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253108 */     GIR_RootConstrainSelectedInstOperands,
     /* 253109 */     // GIR_Coverage, 3563,
     /* 253109 */     GIR_EraseRootFromParent_Done,
     /* 253110 */   // Label 5053: @253110
     /* 253110 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(253158), // Rule ID 3564 //
     /* 253115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 253118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 253123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253139 */     // MIs[0] Op4
     /* 253139 */     // No operand predicates
     /* 253139 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 253142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253150 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253156 */     GIR_RootConstrainSelectedInstOperands,
     /* 253157 */     // GIR_Coverage, 3564,
     /* 253157 */     GIR_EraseRootFromParent_Done,
     /* 253158 */   // Label 5054: @253158
     /* 253158 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(253206), // Rule ID 12346 //
     /* 253163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 253171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253187 */     // MIs[0] Op4
     /* 253187 */     // No operand predicates
     /* 253187 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 253190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253198 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253204 */     GIR_RootConstrainSelectedInstOperands,
     /* 253205 */     // GIR_Coverage, 12346,
     /* 253205 */     GIR_EraseRootFromParent_Done,
     /* 253206 */   // Label 5055: @253206
     /* 253206 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(253254), // Rule ID 12348 //
     /* 253211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 253219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253235 */     // MIs[0] Op4
     /* 253235 */     // No operand predicates
     /* 253235 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1416:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 253238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253246 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253252 */     GIR_RootConstrainSelectedInstOperands,
     /* 253253 */     // GIR_Coverage, 12348,
     /* 253253 */     GIR_EraseRootFromParent_Done,
     /* 253254 */   // Label 5056: @253254
     /* 253254 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(253302), // Rule ID 12349 //
     /* 253259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 253267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253283 */     // MIs[0] Op4
     /* 253283 */     // No operand predicates
     /* 253283 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1418:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 253286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253294 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253300 */     GIR_RootConstrainSelectedInstOperands,
     /* 253301 */     // GIR_Coverage, 12349,
     /* 253301 */     GIR_EraseRootFromParent_Done,
     /* 253302 */   // Label 5057: @253302
     /* 253302 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(253350), // Rule ID 12350 //
     /* 253307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 253315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253331 */     // MIs[0] Op4
     /* 253331 */     // No operand predicates
     /* 253331 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 253334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253342 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253348 */     GIR_RootConstrainSelectedInstOperands,
     /* 253349 */     // GIR_Coverage, 12350,
     /* 253349 */     GIR_EraseRootFromParent_Done,
     /* 253350 */   // Label 5058: @253350
     /* 253350 */   GIM_Reject,
     /* 253351 */ // Label 5008: @253351
     /* 253351 */ GIM_Reject,
     /* 253352 */ // Label 34: @253352
     /* 253352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5063*/ GIMT_Encode4(253641),
     /* 253363 */ /*GILLT_s64*//*Label 5059*/ GIMT_Encode4(253395), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 253375 */ /*GILLT_v2s64*//*Label 5060*/ GIMT_Encode4(253455), GIMT_Encode4(0),
     /* 253383 */ /*GILLT_v4s32*//*Label 5061*/ GIMT_Encode4(253517), GIMT_Encode4(0),
     /* 253391 */ /*GILLT_v8s16*//*Label 5062*/ GIMT_Encode4(253579),
     /* 253395 */ // Label 5059: @253395
     /* 253395 */ GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(253454), // Rule ID 6407 //
     /* 253400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 253403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253411 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 253411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 253414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 253418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 253425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 253428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253433 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 253435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 253438 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253453 */   // GIR_Coverage, 6407,
     /* 253453 */   GIR_EraseRootFromParent_Done,
     /* 253454 */ // Label 5064: @253454
     /* 253454 */ GIM_Reject,
     /* 253455 */ // Label 5060: @253455
     /* 253455 */ GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(253516),
     /* 253460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 253463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253467 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(253494), // Rule ID 6279 //
     /* 253472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 253479 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 253479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 253482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253492 */     GIR_RootConstrainSelectedInstOperands,
     /* 253493 */     // GIR_Coverage, 6279,
     /* 253493 */     GIR_EraseRootFromParent_Done,
     /* 253494 */   // Label 5066: @253494
     /* 253494 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(253515), // Rule ID 6272 //
     /* 253499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253503 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 253503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 253506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253513 */     GIR_RootConstrainSelectedInstOperands,
     /* 253514 */     // GIR_Coverage, 6272,
     /* 253514 */     GIR_EraseRootFromParent_Done,
     /* 253515 */   // Label 5067: @253515
     /* 253515 */   GIM_Reject,
     /* 253516 */ // Label 5065: @253516
     /* 253516 */ GIM_Reject,
     /* 253517 */ // Label 5061: @253517
     /* 253517 */ GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253578),
     /* 253522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 253525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253529 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253556), // Rule ID 6276 //
     /* 253534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 253541 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 253541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 253544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253554 */     GIR_RootConstrainSelectedInstOperands,
     /* 253555 */     // GIR_Coverage, 6276,
     /* 253555 */     GIR_EraseRootFromParent_Done,
     /* 253556 */   // Label 5069: @253556
     /* 253556 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253577), // Rule ID 6269 //
     /* 253561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253565 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 253565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 253568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253575 */     GIR_RootConstrainSelectedInstOperands,
     /* 253576 */     // GIR_Coverage, 6269,
     /* 253576 */     GIR_EraseRootFromParent_Done,
     /* 253577 */   // Label 5070: @253577
     /* 253577 */   GIM_Reject,
     /* 253578 */ // Label 5068: @253578
     /* 253578 */ GIM_Reject,
     /* 253579 */ // Label 5062: @253579
     /* 253579 */ GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253640),
     /* 253584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 253587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253591 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253618), // Rule ID 6273 //
     /* 253596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 253603 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 253603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 253606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253616 */     GIR_RootConstrainSelectedInstOperands,
     /* 253617 */     // GIR_Coverage, 6273,
     /* 253617 */     GIR_EraseRootFromParent_Done,
     /* 253618 */   // Label 5072: @253618
     /* 253618 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253639), // Rule ID 6266 //
     /* 253623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253627 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 253627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 253630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253637 */     GIR_RootConstrainSelectedInstOperands,
     /* 253638 */     // GIR_Coverage, 6266,
     /* 253638 */     GIR_EraseRootFromParent_Done,
     /* 253639 */   // Label 5073: @253639
     /* 253639 */   GIM_Reject,
     /* 253640 */ // Label 5071: @253640
     /* 253640 */ GIM_Reject,
     /* 253641 */ // Label 5063: @253641
     /* 253641 */ GIM_Reject,
     /* 253642 */ // Label 35: @253642
     /* 253642 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5078*/ GIMT_Encode4(255078),
     /* 253653 */ /*GILLT_s32*//*Label 5074*/ GIMT_Encode4(253685), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 253665 */ /*GILLT_v2s32*//*Label 5075*/ GIMT_Encode4(253724), GIMT_Encode4(0),
     /* 253673 */ /*GILLT_v4s16*//*Label 5076*/ GIMT_Encode4(254080), GIMT_Encode4(0),
     /* 253681 */ /*GILLT_v8s8*//*Label 5077*/ GIMT_Encode4(254579),
     /* 253685 */ // Label 5074: @253685
     /* 253685 */ GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253723), // Rule ID 6428 //
     /* 253690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 253693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 253697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253701 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 253701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253706 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 253712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 253717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253722 */   // GIR_Coverage, 6428,
     /* 253722 */   GIR_EraseRootFromParent_Done,
     /* 253723 */ // Label 5079: @253723
     /* 253723 */ GIM_Reject,
     /* 253724 */ // Label 5075: @253724
     /* 253724 */ GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(254079),
     /* 253729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253736 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253814), // Rule ID 5366 //
     /* 253741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 253749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 253761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 253769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 253778 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 253784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 253786 */     // MIs[1] Operand 2
     /* 253786 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 253797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 253799 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 253799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 253802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 253808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 253812 */     GIR_RootConstrainSelectedInstOperands,
     /* 253813 */     // GIR_Coverage, 5366,
     /* 253813 */     GIR_EraseRootFromParent_Done,
     /* 253814 */   // Label 5081: @253814
     /* 253814 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253885), // Rule ID 5362 //
     /* 253819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 253827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 253839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 253847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253857 */     // MIs[1] Operand 2
     /* 253857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 253868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253870 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 253870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 253873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 253879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 253883 */     GIR_RootConstrainSelectedInstOperands,
     /* 253884 */     // GIR_Coverage, 5362,
     /* 253884 */     GIR_EraseRootFromParent_Done,
     /* 253885 */   // Label 5082: @253885
     /* 253885 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253956), // Rule ID 5364 //
     /* 253890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 253898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 253910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 253918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253928 */     // MIs[1] Operand 2
     /* 253928 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 253939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253941 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 253941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 253944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 253950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 253954 */     GIR_RootConstrainSelectedInstOperands,
     /* 253955 */     // GIR_Coverage, 5364,
     /* 253955 */     GIR_EraseRootFromParent_Done,
     /* 253956 */   // Label 5083: @253956
     /* 253956 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(254009), // Rule ID 2153 //
     /* 253961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 253964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 253972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253981 */     // MIs[1] imm
     /* 253981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 253985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 253989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 253993 */     // MIs[2] Operand 1
     /* 253993 */     // No operand predicates
     /* 253993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253995 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 253995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 253998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254007 */     GIR_RootConstrainSelectedInstOperands,
     /* 254008 */     // GIR_Coverage, 2153,
     /* 254008 */     GIR_EraseRootFromParent_Done,
     /* 254009 */   // Label 5084: @254009
     /* 254009 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(254059), // Rule ID 6254 //
     /* 254014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254031 */     // MIs[1] imm
     /* 254031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 254043 */     // MIs[2] Operand 1
     /* 254043 */     // No operand predicates
     /* 254043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254045 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 254045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 254048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254057 */     GIR_RootConstrainSelectedInstOperands,
     /* 254058 */     // GIR_Coverage, 6254,
     /* 254058 */     GIR_EraseRootFromParent_Done,
     /* 254059 */   // Label 5085: @254059
     /* 254059 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(254078), // Rule ID 1092 //
     /* 254064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254071 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 254071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 254076 */     GIR_RootConstrainSelectedInstOperands,
     /* 254077 */     // GIR_Coverage, 1092,
     /* 254077 */     GIR_Done,
     /* 254078 */   // Label 5086: @254078
     /* 254078 */   GIM_Reject,
     /* 254079 */ // Label 5080: @254079
     /* 254079 */ GIM_Reject,
     /* 254080 */ // Label 5076: @254080
     /* 254080 */ GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(254578),
     /* 254085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254092 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(254170), // Rule ID 5360 //
     /* 254097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 254117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 254134 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 254140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 254142 */     // MIs[1] Operand 2
     /* 254142 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254155 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 254155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 254158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254168 */     GIR_RootConstrainSelectedInstOperands,
     /* 254169 */     // GIR_Coverage, 5360,
     /* 254169 */     GIR_EraseRootFromParent_Done,
     /* 254170 */   // Label 5088: @254170
     /* 254170 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254241), // Rule ID 5356 //
     /* 254175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 254195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254213 */     // MIs[1] Operand 2
     /* 254213 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254226 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 254226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 254229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254239 */     GIR_RootConstrainSelectedInstOperands,
     /* 254240 */     // GIR_Coverage, 5356,
     /* 254240 */     GIR_EraseRootFromParent_Done,
     /* 254241 */   // Label 5089: @254241
     /* 254241 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254312), // Rule ID 5358 //
     /* 254246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 254266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254284 */     // MIs[1] Operand 2
     /* 254284 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254297 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 254297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 254300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254310 */     GIR_RootConstrainSelectedInstOperands,
     /* 254311 */     // GIR_Coverage, 5358,
     /* 254311 */     GIR_EraseRootFromParent_Done,
     /* 254312 */   // Label 5090: @254312
     /* 254312 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254404), // Rule ID 5482 //
     /* 254317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254325 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 254332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 254336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 254357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254361 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254372 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 254372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 254375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 254379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 254388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 254392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 254394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 254397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254402 */     GIR_RootConstrainSelectedInstOperands,
     /* 254403 */     // GIR_Coverage, 5482,
     /* 254403 */     GIR_EraseRootFromParent_Done,
     /* 254404 */   // Label 5091: @254404
     /* 254404 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254457), // Rule ID 2152 //
     /* 254409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 254420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254429 */     // MIs[1] imm
     /* 254429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 254441 */     // MIs[2] Operand 1
     /* 254441 */     // No operand predicates
     /* 254441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254443 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 254446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254455 */     GIR_RootConstrainSelectedInstOperands,
     /* 254456 */     // GIR_Coverage, 2152,
     /* 254456 */     GIR_EraseRootFromParent_Done,
     /* 254457 */   // Label 5092: @254457
     /* 254457 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254507), // Rule ID 6253 //
     /* 254462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254479 */     // MIs[1] imm
     /* 254479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254487 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 254491 */     // MIs[2] Operand 1
     /* 254491 */     // No operand predicates
     /* 254491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254493 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 254493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 254496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254505 */     GIR_RootConstrainSelectedInstOperands,
     /* 254506 */     // GIR_Coverage, 6253,
     /* 254506 */     GIR_EraseRootFromParent_Done,
     /* 254507 */   // Label 5093: @254507
     /* 254507 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254558), // Rule ID 5510 //
     /* 254512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254520 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 254527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 254531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254543 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 254543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 254546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 254552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 254556 */     GIR_RootConstrainSelectedInstOperands,
     /* 254557 */     // GIR_Coverage, 5510,
     /* 254557 */     GIR_EraseRootFromParent_Done,
     /* 254558 */   // Label 5094: @254558
     /* 254558 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254577), // Rule ID 1091 //
     /* 254563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254570 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 254570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 254575 */     GIR_RootConstrainSelectedInstOperands,
     /* 254576 */     // GIR_Coverage, 1091,
     /* 254576 */     GIR_Done,
     /* 254577 */   // Label 5095: @254577
     /* 254577 */   GIM_Reject,
     /* 254578 */ // Label 5087: @254578
     /* 254578 */ GIM_Reject,
     /* 254579 */ // Label 5077: @254579
     /* 254579 */ GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(255077),
     /* 254584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254591 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254669), // Rule ID 5354 //
     /* 254596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 254616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 254633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 254639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 254641 */     // MIs[1] Operand 2
     /* 254641 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 254652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254654 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 254654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 254657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254667 */     GIR_RootConstrainSelectedInstOperands,
     /* 254668 */     // GIR_Coverage, 5354,
     /* 254668 */     GIR_EraseRootFromParent_Done,
     /* 254669 */   // Label 5097: @254669
     /* 254669 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254740), // Rule ID 5350 //
     /* 254674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 254694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254712 */     // MIs[1] Operand 2
     /* 254712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 254723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254725 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 254725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 254728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254738 */     GIR_RootConstrainSelectedInstOperands,
     /* 254739 */     // GIR_Coverage, 5350,
     /* 254739 */     GIR_EraseRootFromParent_Done,
     /* 254740 */   // Label 5098: @254740
     /* 254740 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254811), // Rule ID 5352 //
     /* 254745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 254765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254783 */     // MIs[1] Operand 2
     /* 254783 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 254794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254796 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 254796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 254799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254809 */     GIR_RootConstrainSelectedInstOperands,
     /* 254810 */     // GIR_Coverage, 5352,
     /* 254810 */     GIR_EraseRootFromParent_Done,
     /* 254811 */   // Label 5099: @254811
     /* 254811 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254903), // Rule ID 5455 //
     /* 254816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254824 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 254831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 254856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254864 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254871 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 254871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 254874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 254878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 254887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 254891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 254893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 254896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254901 */     GIR_RootConstrainSelectedInstOperands,
     /* 254902 */     // GIR_Coverage, 5455,
     /* 254902 */     GIR_EraseRootFromParent_Done,
     /* 254903 */   // Label 5100: @254903
     /* 254903 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254956), // Rule ID 2151 //
     /* 254908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 254919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254928 */     // MIs[1] imm
     /* 254928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254936 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 254940 */     // MIs[2] Operand 1
     /* 254940 */     // No operand predicates
     /* 254940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254942 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 254945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254954 */     GIR_RootConstrainSelectedInstOperands,
     /* 254955 */     // GIR_Coverage, 2151,
     /* 254955 */     GIR_EraseRootFromParent_Done,
     /* 254956 */   // Label 5101: @254956
     /* 254956 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(255006), // Rule ID 6252 //
     /* 254961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254978 */     // MIs[1] imm
     /* 254978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254986 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 254990 */     // MIs[2] Operand 1
     /* 254990 */     // No operand predicates
     /* 254990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254992 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 254992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 254995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 255001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 255004 */     GIR_RootConstrainSelectedInstOperands,
     /* 255005 */     // GIR_Coverage, 6252,
     /* 255005 */     GIR_EraseRootFromParent_Done,
     /* 255006 */   // Label 5102: @255006
     /* 255006 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(255057), // Rule ID 5509 //
     /* 255011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 255019 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 255026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255042 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 255042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 255045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 255051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 255055 */     GIR_RootConstrainSelectedInstOperands,
     /* 255056 */     // GIR_Coverage, 5509,
     /* 255056 */     GIR_EraseRootFromParent_Done,
     /* 255057 */   // Label 5103: @255057
     /* 255057 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(255076), // Rule ID 1090 //
     /* 255062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255069 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 255069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 255074 */     GIR_RootConstrainSelectedInstOperands,
     /* 255075 */     // GIR_Coverage, 1090,
     /* 255075 */     GIR_Done,
     /* 255076 */   // Label 5104: @255076
     /* 255076 */   GIM_Reject,
     /* 255077 */ // Label 5096: @255077
     /* 255077 */ GIM_Reject,
     /* 255078 */ // Label 5078: @255078
     /* 255078 */ GIM_Reject,
     /* 255079 */ // Label 36: @255079
     /* 255079 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5107*/ GIMT_Encode4(255198),
     /* 255090 */ /*GILLT_s32*//*Label 5105*/ GIMT_Encode4(255098),
     /* 255094 */ /*GILLT_s64*//*Label 5106*/ GIMT_Encode4(255118),
     /* 255098 */ // Label 5105: @255098
     /* 255098 */ GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255117), // Rule ID 81 //
     /* 255103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255107 */   // MIs[0] Operand 1
     /* 255107 */   // No operand predicates
     /* 255107 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 255107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 255110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255112 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 255115 */   GIR_RootConstrainSelectedInstOperands,
     /* 255116 */   // GIR_Coverage, 81,
     /* 255116 */   GIR_EraseRootFromParent_Done,
     /* 255117 */ // Label 5108: @255117
     /* 255117 */ GIM_Reject,
     /* 255118 */ // Label 5106: @255118
     /* 255118 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255178), // Rule ID 3847 //
     /* 255123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 255126 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 255130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255134 */   // MIs[0] Operand 1
     /* 255134 */   // No operand predicates
     /* 255134 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 255134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 255137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 255141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255146 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 255151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 255156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 255167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255177 */   // GIR_Coverage, 3847,
     /* 255177 */   GIR_EraseRootFromParent_Done,
     /* 255178 */ // Label 5109: @255178
     /* 255178 */ GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255197), // Rule ID 82 //
     /* 255183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255187 */   // MIs[0] Operand 1
     /* 255187 */   // No operand predicates
     /* 255187 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 255187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 255190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255192 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 255195 */   GIR_RootConstrainSelectedInstOperands,
     /* 255196 */   // GIR_Coverage, 82,
     /* 255196 */   GIR_EraseRootFromParent_Done,
     /* 255197 */ // Label 5110: @255197
     /* 255197 */ GIM_Reject,
     /* 255198 */ // Label 5107: @255198
     /* 255198 */ GIM_Reject,
     /* 255199 */ // Label 37: @255199
     /* 255199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5114*/ GIMT_Encode4(255439),
     /* 255210 */ /*GILLT_s16*//*Label 5111*/ GIMT_Encode4(255222),
     /* 255214 */ /*GILLT_s32*//*Label 5112*/ GIMT_Encode4(255274),
     /* 255218 */ /*GILLT_s64*//*Label 5113*/ GIMT_Encode4(255387),
     /* 255222 */ // Label 5111: @255222
     /* 255222 */ GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255245), // Rule ID 506 //
     /* 255227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255230 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255238 */   // MIs[0] Operand 1
     /* 255238 */   // No operand predicates
     /* 255238 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 255238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 255241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255243 */   GIR_RootConstrainSelectedInstOperands,
     /* 255244 */   // GIR_Coverage, 506,
     /* 255244 */   GIR_EraseRootFromParent_Done,
     /* 255245 */ // Label 5115: @255245
     /* 255245 */ GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255273), // Rule ID 688 //
     /* 255250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 255253 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 255257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255261 */   // MIs[0] Operand 1
     /* 255261 */   // No operand predicates
     /* 255261 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 255261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 255264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255266 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 255271 */   GIR_RootConstrainSelectedInstOperands,
     /* 255272 */   // GIR_Coverage, 688,
     /* 255272 */   GIR_EraseRootFromParent_Done,
     /* 255273 */ // Label 5116: @255273
     /* 255273 */ GIM_Reject,
     /* 255274 */ // Label 5112: @255274
     /* 255274 */ GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255297), // Rule ID 507 //
     /* 255279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255282 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255290 */   // MIs[0] Operand 1
     /* 255290 */   // No operand predicates
     /* 255290 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 255290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 255293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255295 */   GIR_RootConstrainSelectedInstOperands,
     /* 255296 */   // GIR_Coverage, 507,
     /* 255296 */   GIR_EraseRootFromParent_Done,
     /* 255297 */ // Label 5117: @255297
     /* 255297 */ GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255325), // Rule ID 689 //
     /* 255302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255305 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 255309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255313 */   // MIs[0] Operand 1
     /* 255313 */   // No operand predicates
     /* 255313 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 255313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 255316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255318 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 255323 */   GIR_RootConstrainSelectedInstOperands,
     /* 255324 */   // GIR_Coverage, 689,
     /* 255324 */   GIR_EraseRootFromParent_Done,
     /* 255325 */ // Label 5118: @255325
     /* 255325 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255386), // Rule ID 5933 //
     /* 255330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255333 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 255337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255341 */   // MIs[0] Operand 1
     /* 255341 */   // No operand predicates
     /* 255341 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 255341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 255344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 255348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255353 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 255358 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 255361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 255366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255368 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 255375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255380 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255385 */   // GIR_Coverage, 5933,
     /* 255385 */   GIR_EraseRootFromParent_Done,
     /* 255386 */ // Label 5119: @255386
     /* 255386 */ GIM_Reject,
     /* 255387 */ // Label 5113: @255387
     /* 255387 */ GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255410), // Rule ID 508 //
     /* 255392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255395 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255403 */   // MIs[0] Operand 1
     /* 255403 */   // No operand predicates
     /* 255403 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 255403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 255406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255408 */   GIR_RootConstrainSelectedInstOperands,
     /* 255409 */   // GIR_Coverage, 508,
     /* 255409 */   GIR_EraseRootFromParent_Done,
     /* 255410 */ // Label 5120: @255410
     /* 255410 */ GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255438), // Rule ID 690 //
     /* 255415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255418 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 255422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255426 */   // MIs[0] Operand 1
     /* 255426 */   // No operand predicates
     /* 255426 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 255426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 255429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255431 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 255436 */   GIR_RootConstrainSelectedInstOperands,
     /* 255437 */   // GIR_Coverage, 690,
     /* 255437 */   GIR_EraseRootFromParent_Done,
     /* 255438 */ // Label 5121: @255438
     /* 255438 */ GIM_Reject,
     /* 255439 */ // Label 5114: @255439
     /* 255439 */ GIM_Reject,
     /* 255440 */ // Label 38: @255440
     /* 255440 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5127*/ GIMT_Encode4(257337),
     /* 255451 */ /*GILLT_s32*//*Label 5122*/ GIMT_Encode4(255487),
     /* 255455 */ /*GILLT_s64*//*Label 5123*/ GIMT_Encode4(256928), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 255467 */ /*GILLT_v2s64*//*Label 5124*/ GIMT_Encode4(257151), GIMT_Encode4(0),
     /* 255475 */ /*GILLT_v4s32*//*Label 5125*/ GIMT_Encode4(257213), GIMT_Encode4(0),
     /* 255483 */ /*GILLT_v8s16*//*Label 5126*/ GIMT_Encode4(257275),
     /* 255487 */ // Label 5122: @255487
     /* 255487 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(255607), // Rule ID 12836 //
     /* 255492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255499 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255507 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255510 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255515 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 255519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255526 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255526 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 255529 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 255533 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255538 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255544 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255547 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255551 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255570 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255573 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255576 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 255579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 255594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 255597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255605 */   GIR_RootConstrainSelectedInstOperands,
     /* 255606 */   // GIR_Coverage, 12836,
     /* 255606 */   GIR_EraseRootFromParent_Done,
     /* 255607 */ // Label 5128: @255607
     /* 255607 */ GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(255727), // Rule ID 12838 //
     /* 255612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255619 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255627 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255630 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 255639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255646 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255646 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 255649 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 255653 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255658 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255693 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255696 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 255699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255704 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 255714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 255717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255725 */   GIR_RootConstrainSelectedInstOperands,
     /* 255726 */   // GIR_Coverage, 12838,
     /* 255726 */   GIR_EraseRootFromParent_Done,
     /* 255727 */ // Label 5129: @255727
     /* 255727 */ GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(255847), // Rule ID 12840 //
     /* 255732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 255735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255739 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255747 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255750 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255755 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255759 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255766 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255766 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 255769 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 255773 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255778 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255784 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255787 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255791 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255810 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255813 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255816 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 255819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 255837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255845 */   GIR_RootConstrainSelectedInstOperands,
     /* 255846 */   // GIR_Coverage, 12840,
     /* 255846 */   GIR_EraseRootFromParent_Done,
     /* 255847 */ // Label 5130: @255847
     /* 255847 */ GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(255967), // Rule ID 12842 //
     /* 255852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 255855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255859 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255867 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255870 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255875 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255879 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255886 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255886 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 255889 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 255893 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255898 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255904 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255907 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255911 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255930 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255933 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255936 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 255939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255949 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 255957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255965 */   GIR_RootConstrainSelectedInstOperands,
     /* 255966 */   // GIR_Coverage, 12842,
     /* 255966 */   GIR_EraseRootFromParent_Done,
     /* 255967 */ // Label 5131: @255967
     /* 255967 */ GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256087), // Rule ID 12858 //
     /* 255972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255979 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255987 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255990 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 255995 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 255999 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256006 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256006 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256009 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 256013 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256018 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256024 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256027 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256031 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256050 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256053 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256056 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256085 */   GIR_RootConstrainSelectedInstOperands,
     /* 256086 */   // GIR_Coverage, 12858,
     /* 256086 */   GIR_EraseRootFromParent_Done,
     /* 256087 */ // Label 5132: @256087
     /* 256087 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256207), // Rule ID 12860 //
     /* 256092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256099 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256107 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256110 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256119 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256126 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256126 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256129 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 256133 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256138 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256170 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256173 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256176 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256179 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256184 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256189 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256205 */   GIR_RootConstrainSelectedInstOperands,
     /* 256206 */   // GIR_Coverage, 12860,
     /* 256206 */   GIR_EraseRootFromParent_Done,
     /* 256207 */ // Label 5133: @256207
     /* 256207 */ GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256327), // Rule ID 12862 //
     /* 256212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256219 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256227 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256230 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256246 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256246 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256249 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 256253 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256258 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256264 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256267 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256271 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256290 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256293 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256296 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256299 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256304 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256325 */   GIR_RootConstrainSelectedInstOperands,
     /* 256326 */   // GIR_Coverage, 12862,
     /* 256326 */   GIR_EraseRootFromParent_Done,
     /* 256327 */ // Label 5134: @256327
     /* 256327 */ GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256447), // Rule ID 12864 //
     /* 256332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256339 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256347 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256350 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256355 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256359 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256364 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256366 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256366 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256369 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 256373 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256378 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256384 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256387 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256391 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256410 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256413 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256416 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256445 */   GIR_RootConstrainSelectedInstOperands,
     /* 256446 */   // GIR_Coverage, 12864,
     /* 256446 */   GIR_EraseRootFromParent_Done,
     /* 256447 */ // Label 5135: @256447
     /* 256447 */ GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256567), // Rule ID 12868 //
     /* 256452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256459 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256467 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256470 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256479 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256486 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256486 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256489 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 256493 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256498 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256504 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256507 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256511 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256530 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256533 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256536 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256549 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256565 */   GIR_RootConstrainSelectedInstOperands,
     /* 256566 */   // GIR_Coverage, 12868,
     /* 256566 */   GIR_EraseRootFromParent_Done,
     /* 256567 */ // Label 5136: @256567
     /* 256567 */ GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256687), // Rule ID 12870 //
     /* 256572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256579 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256587 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256590 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256599 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256606 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256606 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256609 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 256613 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256618 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256624 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256627 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256631 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256650 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256653 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256656 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256669 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256685 */   GIR_RootConstrainSelectedInstOperands,
     /* 256686 */   // GIR_Coverage, 12870,
     /* 256686 */   GIR_EraseRootFromParent_Done,
     /* 256687 */ // Label 5137: @256687
     /* 256687 */ GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256807), // Rule ID 12872 //
     /* 256692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256699 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256703 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256707 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256710 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256719 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256724 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256726 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256726 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256729 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 256733 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256738 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256744 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256747 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256751 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256770 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256773 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256776 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256805 */   GIR_RootConstrainSelectedInstOperands,
     /* 256806 */   // GIR_Coverage, 12872,
     /* 256806 */   GIR_EraseRootFromParent_Done,
     /* 256807 */ // Label 5138: @256807
     /* 256807 */ GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256927), // Rule ID 12874 //
     /* 256812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256819 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256827 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256830 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256835 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256839 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256844 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256846 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256846 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256849 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 256853 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256858 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256864 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256867 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256871 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256890 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256893 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256896 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256904 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256925 */   GIR_RootConstrainSelectedInstOperands,
     /* 256926 */   // GIR_Coverage, 12874,
     /* 256926 */   GIR_EraseRootFromParent_Done,
     /* 256927 */ // Label 5139: @256927
     /* 256927 */ GIM_Reject,
     /* 256928 */ // Label 5123: @256928
     /* 256928 */ GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257150),
     /* 256933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 256936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256940 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(256994), // Rule ID 5587 //
     /* 256945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 256953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 256961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 256970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256974 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 256978 */     // MIs[2] Operand 1
     /* 256978 */     // No operand predicates
     /* 256978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256980 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 256980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 256983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 256989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 256992 */     GIR_RootConstrainSelectedInstOperands,
     /* 256993 */     // GIR_Coverage, 5587,
     /* 256993 */     GIR_EraseRootFromParent_Done,
     /* 256994 */   // Label 5141: @256994
     /* 256994 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257073), // Rule ID 11034 //
     /* 256999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257030 */     // MIs[2] Operand 1
     /* 257030 */     // No operand predicates
     /* 257030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257032 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 257032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 257035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257044 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 257063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257071 */     GIR_RootConstrainSelectedInstOperands,
     /* 257072 */     // GIR_Coverage, 11034,
     /* 257072 */     GIR_EraseRootFromParent_Done,
     /* 257073 */   // Label 5142: @257073
     /* 257073 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257149), // Rule ID 6409 //
     /* 257078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257082 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 257082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 257085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 257099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257108 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 257115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 257118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 257136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 257147 */     GIR_RootConstrainSelectedInstOperands,
     /* 257148 */     // GIR_Coverage, 6409,
     /* 257148 */     GIR_EraseRootFromParent_Done,
     /* 257149 */   // Label 5143: @257149
     /* 257149 */   GIM_Reject,
     /* 257150 */ // Label 5140: @257150
     /* 257150 */ GIM_Reject,
     /* 257151 */ // Label 5124: @257151
     /* 257151 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257212),
     /* 257156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 257159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257163 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257190), // Rule ID 6281 //
     /* 257168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 257175 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 257175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257188 */     GIR_RootConstrainSelectedInstOperands,
     /* 257189 */     // GIR_Coverage, 6281,
     /* 257189 */     GIR_EraseRootFromParent_Done,
     /* 257190 */   // Label 5145: @257190
     /* 257190 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257211), // Rule ID 6270 //
     /* 257195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257199 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 257199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 257202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257209 */     GIR_RootConstrainSelectedInstOperands,
     /* 257210 */     // GIR_Coverage, 6270,
     /* 257210 */     GIR_EraseRootFromParent_Done,
     /* 257211 */   // Label 5146: @257211
     /* 257211 */   GIM_Reject,
     /* 257212 */ // Label 5144: @257212
     /* 257212 */ GIM_Reject,
     /* 257213 */ // Label 5125: @257213
     /* 257213 */ GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257274),
     /* 257218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 257221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257225 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257252), // Rule ID 6278 //
     /* 257230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 257237 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 257237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 257240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257250 */     GIR_RootConstrainSelectedInstOperands,
     /* 257251 */     // GIR_Coverage, 6278,
     /* 257251 */     GIR_EraseRootFromParent_Done,
     /* 257252 */   // Label 5148: @257252
     /* 257252 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257273), // Rule ID 6267 //
     /* 257257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257261 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 257261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 257264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257271 */     GIR_RootConstrainSelectedInstOperands,
     /* 257272 */     // GIR_Coverage, 6267,
     /* 257272 */     GIR_EraseRootFromParent_Done,
     /* 257273 */   // Label 5149: @257273
     /* 257273 */   GIM_Reject,
     /* 257274 */ // Label 5147: @257274
     /* 257274 */ GIM_Reject,
     /* 257275 */ // Label 5126: @257275
     /* 257275 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257336),
     /* 257280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 257283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257287 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257314), // Rule ID 6275 //
     /* 257292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 257299 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 257299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 257302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257312 */     GIR_RootConstrainSelectedInstOperands,
     /* 257313 */     // GIR_Coverage, 6275,
     /* 257313 */     GIR_EraseRootFromParent_Done,
     /* 257314 */   // Label 5151: @257314
     /* 257314 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257335), // Rule ID 6264 //
     /* 257319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257323 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 257323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 257326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257333 */     GIR_RootConstrainSelectedInstOperands,
     /* 257334 */     // GIR_Coverage, 6264,
     /* 257334 */     GIR_EraseRootFromParent_Done,
     /* 257335 */   // Label 5152: @257335
     /* 257335 */   GIM_Reject,
     /* 257336 */ // Label 5150: @257336
     /* 257336 */ GIM_Reject,
     /* 257337 */ // Label 5127: @257337
     /* 257337 */ GIM_Reject,
     /* 257338 */ // Label 39: @257338
     /* 257338 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5158*/ GIMT_Encode4(258991),
     /* 257349 */ /*GILLT_s32*//*Label 5153*/ GIMT_Encode4(257429),
     /* 257353 */ /*GILLT_s64*//*Label 5154*/ GIMT_Encode4(257923), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 257405 */ /*GILLT_nxv2s64*//*Label 5155*/ GIMT_Encode4(258565), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 257417 */ /*GILLT_nxv4s32*//*Label 5156*/ GIMT_Encode4(258774), GIMT_Encode4(0),
     /* 257425 */ /*GILLT_nxv8s16*//*Label 5157*/ GIMT_Encode4(258918),
     /* 257429 */ // Label 5153: @257429
     /* 257429 */ GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(257922),
     /* 257434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 257437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257441 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(257506), // Rule ID 5582 //
     /* 257446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 257458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257479 */     // MIs[2] Operand 1
     /* 257479 */     // No operand predicates
     /* 257479 */     // MIs[0] Operand 2
     /* 257479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257492 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 257492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257504 */     GIR_RootConstrainSelectedInstOperands,
     /* 257505 */     // GIR_Coverage, 5582,
     /* 257505 */     GIR_EraseRootFromParent_Done,
     /* 257506 */   // Label 5160: @257506
     /* 257506 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(257571), // Rule ID 5584 //
     /* 257511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257544 */     // MIs[2] Operand 1
     /* 257544 */     // No operand predicates
     /* 257544 */     // MIs[0] Operand 2
     /* 257544 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257557 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 257557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257569 */     GIR_RootConstrainSelectedInstOperands,
     /* 257570 */     // GIR_Coverage, 5584,
     /* 257570 */     GIR_EraseRootFromParent_Done,
     /* 257571 */   // Label 5161: @257571
     /* 257571 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(257636), // Rule ID 5586 //
     /* 257576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257609 */     // MIs[2] Operand 1
     /* 257609 */     // No operand predicates
     /* 257609 */     // MIs[0] Operand 2
     /* 257609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257622 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 257622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257634 */     GIR_RootConstrainSelectedInstOperands,
     /* 257635 */     // GIR_Coverage, 5586,
     /* 257635 */     GIR_EraseRootFromParent_Done,
     /* 257636 */   // Label 5162: @257636
     /* 257636 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(257726), // Rule ID 11030 //
     /* 257641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 257656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257672 */     // MIs[2] Operand 1
     /* 257672 */     // No operand predicates
     /* 257672 */     // MIs[0] Operand 2
     /* 257672 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257685 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 257685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 257688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257697 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257724 */     GIR_RootConstrainSelectedInstOperands,
     /* 257725 */     // GIR_Coverage, 11030,
     /* 257725 */     GIR_EraseRootFromParent_Done,
     /* 257726 */   // Label 5163: @257726
     /* 257726 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(257816), // Rule ID 11032 //
     /* 257731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 257746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257762 */     // MIs[2] Operand 1
     /* 257762 */     // No operand predicates
     /* 257762 */     // MIs[0] Operand 2
     /* 257762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257775 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 257775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 257778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257787 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257814 */     GIR_RootConstrainSelectedInstOperands,
     /* 257815 */     // GIR_Coverage, 11032,
     /* 257815 */     GIR_EraseRootFromParent_Done,
     /* 257816 */   // Label 5164: @257816
     /* 257816 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(257851), // Rule ID 6414 //
     /* 257821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257825 */     // MIs[0] Operand 2
     /* 257825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257836 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 257836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 257839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257841 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 257843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 257849 */     GIR_RootConstrainSelectedInstOperands,
     /* 257850 */     // GIR_Coverage, 6414,
     /* 257850 */     GIR_EraseRootFromParent_Done,
     /* 257851 */   // Label 5165: @257851
     /* 257851 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(257886), // Rule ID 6415 //
     /* 257856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257860 */     // MIs[0] Operand 2
     /* 257860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257871 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 257871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 257874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257876 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 257878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 257884 */     GIR_RootConstrainSelectedInstOperands,
     /* 257885 */     // GIR_Coverage, 6415,
     /* 257885 */     GIR_EraseRootFromParent_Done,
     /* 257886 */   // Label 5166: @257886
     /* 257886 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(257921), // Rule ID 6416 //
     /* 257891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257895 */     // MIs[0] Operand 2
     /* 257895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 257906 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 257906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 257909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257911 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 257913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257919 */     GIR_RootConstrainSelectedInstOperands,
     /* 257920 */     // GIR_Coverage, 6416,
     /* 257920 */     GIR_EraseRootFromParent_Done,
     /* 257921 */   // Label 5167: @257921
     /* 257921 */   GIM_Reject,
     /* 257922 */ // Label 5159: @257922
     /* 257922 */ GIM_Reject,
     /* 257923 */ // Label 5154: @257923
     /* 257923 */ GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258564),
     /* 257928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 257931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257935 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258012), // Rule ID 5588 //
     /* 257940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 257948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 257952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 257956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 257964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 257968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 257977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257985 */     // MIs[3] Operand 1
     /* 257985 */     // No operand predicates
     /* 257985 */     // MIs[0] Operand 2
     /* 257985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 257998 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 257998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 258007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 258010 */     GIR_RootConstrainSelectedInstOperands,
     /* 258011 */     // GIR_Coverage, 5588,
     /* 258011 */     GIR_EraseRootFromParent_Done,
     /* 258012 */   // Label 5169: @258012
     /* 258012 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258089), // Rule ID 5589 //
     /* 258017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258062 */     // MIs[3] Operand 1
     /* 258062 */     // No operand predicates
     /* 258062 */     // MIs[0] Operand 2
     /* 258062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258075 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 258084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 258087 */     GIR_RootConstrainSelectedInstOperands,
     /* 258088 */     // GIR_Coverage, 5589,
     /* 258088 */     GIR_EraseRootFromParent_Done,
     /* 258089 */   // Label 5170: @258089
     /* 258089 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258191), // Rule ID 11031 //
     /* 258094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 258121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258137 */     // MIs[3] Operand 1
     /* 258137 */     // No operand predicates
     /* 258137 */     // MIs[0] Operand 2
     /* 258137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258150 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 258150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258162 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 258189 */     GIR_RootConstrainSelectedInstOperands,
     /* 258190 */     // GIR_Coverage, 11031,
     /* 258190 */     GIR_EraseRootFromParent_Done,
     /* 258191 */   // Label 5171: @258191
     /* 258191 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258293), // Rule ID 11033 //
     /* 258196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 258223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258235 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258239 */     // MIs[3] Operand 1
     /* 258239 */     // No operand predicates
     /* 258239 */     // MIs[0] Operand 2
     /* 258239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258252 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 258252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 258255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258264 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 258291 */     GIR_RootConstrainSelectedInstOperands,
     /* 258292 */     // GIR_Coverage, 11033,
     /* 258292 */     GIR_EraseRootFromParent_Done,
     /* 258293 */   // Label 5172: @258293
     /* 258293 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258358), // Rule ID 5583 //
     /* 258298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 258310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258331 */     // MIs[2] Operand 1
     /* 258331 */     // No operand predicates
     /* 258331 */     // MIs[0] Operand 2
     /* 258331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258344 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 258344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258356 */     GIR_RootConstrainSelectedInstOperands,
     /* 258357 */     // GIR_Coverage, 5583,
     /* 258357 */     GIR_EraseRootFromParent_Done,
     /* 258358 */   // Label 5173: @258358
     /* 258358 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258423), // Rule ID 5585 //
     /* 258363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258396 */     // MIs[2] Operand 1
     /* 258396 */     // No operand predicates
     /* 258396 */     // MIs[0] Operand 2
     /* 258396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258409 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258421 */     GIR_RootConstrainSelectedInstOperands,
     /* 258422 */     // GIR_Coverage, 5585,
     /* 258422 */     GIR_EraseRootFromParent_Done,
     /* 258423 */   // Label 5174: @258423
     /* 258423 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258458), // Rule ID 6410 //
     /* 258428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258432 */     // MIs[0] Operand 2
     /* 258432 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 258443 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 258443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 258456 */     GIR_RootConstrainSelectedInstOperands,
     /* 258457 */     // GIR_Coverage, 6410,
     /* 258457 */     GIR_EraseRootFromParent_Done,
     /* 258458 */   // Label 5175: @258458
     /* 258458 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(258493), // Rule ID 6411 //
     /* 258463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258467 */     // MIs[0] Operand 2
     /* 258467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258478 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 258478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 258491 */     GIR_RootConstrainSelectedInstOperands,
     /* 258492 */     // GIR_Coverage, 6411,
     /* 258492 */     GIR_EraseRootFromParent_Done,
     /* 258493 */   // Label 5176: @258493
     /* 258493 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(258528), // Rule ID 6412 //
     /* 258498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258502 */     // MIs[0] Operand 2
     /* 258502 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258513 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 258513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 258526 */     GIR_RootConstrainSelectedInstOperands,
     /* 258527 */     // GIR_Coverage, 6412,
     /* 258527 */     GIR_EraseRootFromParent_Done,
     /* 258528 */   // Label 5177: @258528
     /* 258528 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(258563), // Rule ID 6413 //
     /* 258533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258537 */     // MIs[0] Operand 2
     /* 258537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 258548 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 258548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258561 */     GIR_RootConstrainSelectedInstOperands,
     /* 258562 */     // GIR_Coverage, 6413,
     /* 258562 */     GIR_EraseRootFromParent_Done,
     /* 258563 */   // Label 5178: @258563
     /* 258563 */   GIM_Reject,
     /* 258564 */ // Label 5168: @258564
     /* 258564 */ GIM_Reject,
     /* 258565 */ // Label 5155: @258565
     /* 258565 */ GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(258773),
     /* 258570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 258573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258577 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(258642), // Rule ID 10342 //
     /* 258582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258585 */     // MIs[0] Operand 2
     /* 258585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 258596 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 258596 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258599 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 258603 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258608 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 258630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258640 */     GIR_RootConstrainSelectedInstOperands,
     /* 258641 */     // GIR_Coverage, 10342,
     /* 258641 */     GIR_EraseRootFromParent_Done,
     /* 258642 */   // Label 5180: @258642
     /* 258642 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(258707), // Rule ID 10343 //
     /* 258647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258650 */     // MIs[0] Operand 2
     /* 258650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258661 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 258661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 258668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258673 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 258695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258705 */     GIR_RootConstrainSelectedInstOperands,
     /* 258706 */     // GIR_Coverage, 10343,
     /* 258706 */     GIR_EraseRootFromParent_Done,
     /* 258707 */   // Label 5181: @258707
     /* 258707 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(258772), // Rule ID 10344 //
     /* 258712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258715 */     // MIs[0] Operand 2
     /* 258715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258726 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 258726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 258733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258738 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 258760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258770 */     GIR_RootConstrainSelectedInstOperands,
     /* 258771 */     // GIR_Coverage, 10344,
     /* 258771 */     GIR_EraseRootFromParent_Done,
     /* 258772 */   // Label 5182: @258772
     /* 258772 */   GIM_Reject,
     /* 258773 */ // Label 5179: @258773
     /* 258773 */ GIM_Reject,
     /* 258774 */ // Label 5156: @258774
     /* 258774 */ GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(258917),
     /* 258779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 258782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258786 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(258851), // Rule ID 10345 //
     /* 258791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258794 */     // MIs[0] Operand 2
     /* 258794 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258805 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 258805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 258812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258817 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 258839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258849 */     GIR_RootConstrainSelectedInstOperands,
     /* 258850 */     // GIR_Coverage, 10345,
     /* 258850 */     GIR_EraseRootFromParent_Done,
     /* 258851 */   // Label 5184: @258851
     /* 258851 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(258916), // Rule ID 10346 //
     /* 258856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258859 */     // MIs[0] Operand 2
     /* 258859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258870 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 258870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 258877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258882 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 258904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258914 */     GIR_RootConstrainSelectedInstOperands,
     /* 258915 */     // GIR_Coverage, 10346,
     /* 258915 */     GIR_EraseRootFromParent_Done,
     /* 258916 */   // Label 5185: @258916
     /* 258916 */   GIM_Reject,
     /* 258917 */ // Label 5183: @258917
     /* 258917 */ GIM_Reject,
     /* 258918 */ // Label 5157: @258918
     /* 258918 */ GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(258990), // Rule ID 10347 //
     /* 258923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 258929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258933 */   // MIs[0] Operand 2
     /* 258933 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258944 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 258944 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258947 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 258951 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258956 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 258978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258986 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258988 */   GIR_RootConstrainSelectedInstOperands,
     /* 258989 */   // GIR_Coverage, 10347,
     /* 258989 */   GIR_EraseRootFromParent_Done,
     /* 258990 */ // Label 5186: @258990
     /* 258990 */ GIM_Reject,
     /* 258991 */ // Label 5158: @258991
     /* 258991 */ GIM_Reject,
     /* 258992 */ // Label 40: @258992
     /* 258992 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5191*/ GIMT_Encode4(261770),
     /* 259003 */ /*GILLT_s32*//*Label 5187*/ GIMT_Encode4(259039), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 259019 */ /*GILLT_v2s64*//*Label 5188*/ GIMT_Encode4(260840), GIMT_Encode4(0),
     /* 259027 */ /*GILLT_v4s32*//*Label 5189*/ GIMT_Encode4(261150), GIMT_Encode4(0),
     /* 259035 */ /*GILLT_v8s16*//*Label 5190*/ GIMT_Encode4(261460),
     /* 259039 */ // Label 5187: @259039
     /* 259039 */ GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(259189), // Rule ID 12845 //
     /* 259044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259051 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259059 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259062 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259071 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259078 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259078 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259081 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 259085 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259090 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259096 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259099 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259103 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259110 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259113 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259117 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259122 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259125 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259128 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259131 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259136 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259141 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259158 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259188 */   // GIR_Coverage, 12845,
     /* 259188 */   GIR_EraseRootFromParent_Done,
     /* 259189 */ // Label 5192: @259189
     /* 259189 */ GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(259339), // Rule ID 12847 //
     /* 259194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259201 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259209 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259212 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259217 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259221 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259228 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259228 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259231 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 259235 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259240 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259246 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259249 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259253 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259260 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259263 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259267 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259272 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259275 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259278 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259281 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259286 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259291 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259296 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259299 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259303 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259308 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259338 */   // GIR_Coverage, 12847,
     /* 259338 */   GIR_EraseRootFromParent_Done,
     /* 259339 */ // Label 5193: @259339
     /* 259339 */ GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(259489), // Rule ID 12849 //
     /* 259344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259351 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259359 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259362 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259367 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259371 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259378 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259378 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259381 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 259385 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259390 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259396 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259399 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259403 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259410 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259413 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259417 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259422 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259425 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259428 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 259431 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259436 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259441 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259458 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259465 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259488 */   // GIR_Coverage, 12849,
     /* 259488 */   GIR_EraseRootFromParent_Done,
     /* 259489 */ // Label 5194: @259489
     /* 259489 */ GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(259639), // Rule ID 12851 //
     /* 259494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259501 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259509 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259512 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259517 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259528 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259528 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259531 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 259535 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259540 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259546 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259549 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259553 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259560 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259563 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259567 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259572 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259575 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259578 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 259581 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259586 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259591 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259608 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259638 */   // GIR_Coverage, 12851,
     /* 259638 */   GIR_EraseRootFromParent_Done,
     /* 259639 */ // Label 5195: @259639
     /* 259639 */ GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(259789), // Rule ID 12878 //
     /* 259644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259651 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259659 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259662 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 259667 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259671 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259678 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259678 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259681 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 259685 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259690 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259696 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259699 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259703 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259710 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259713 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259717 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259722 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259725 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259728 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259731 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259736 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259741 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259758 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259770 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259788 */   // GIR_Coverage, 12878,
     /* 259788 */   GIR_EraseRootFromParent_Done,
     /* 259789 */ // Label 5196: @259789
     /* 259789 */ GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(259939), // Rule ID 12880 //
     /* 259794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259801 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259809 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259812 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 259817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259828 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259828 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259831 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 259835 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259840 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259846 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259849 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259853 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259860 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259863 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259867 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259872 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259875 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259878 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259881 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259886 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259891 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259908 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259938 */   // GIR_Coverage, 12880,
     /* 259938 */   GIR_EraseRootFromParent_Done,
     /* 259939 */ // Label 5197: @259939
     /* 259939 */ GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260089), // Rule ID 12882 //
     /* 259944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259951 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259955 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259959 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259962 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 259967 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259971 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259978 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259978 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259981 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 259985 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259990 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259996 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259999 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260003 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260022 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260025 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260028 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260031 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260036 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260041 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260058 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260088 */   // GIR_Coverage, 12882,
     /* 260088 */   GIR_EraseRootFromParent_Done,
     /* 260089 */ // Label 5198: @260089
     /* 260089 */ GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260239), // Rule ID 12884 //
     /* 260094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260101 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260105 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260109 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260112 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 260117 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260121 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260126 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260128 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260128 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260131 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 260135 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260140 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260146 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260149 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260153 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260160 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260163 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260167 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260172 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260175 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260178 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260181 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260186 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260191 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260208 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260238 */   // GIR_Coverage, 12884,
     /* 260238 */   GIR_EraseRootFromParent_Done,
     /* 260239 */ // Label 5199: @260239
     /* 260239 */ GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260389), // Rule ID 12888 //
     /* 260244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260251 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260259 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260262 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 260271 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260278 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260278 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260281 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 260285 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260290 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260296 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260299 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260303 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260322 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260325 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260328 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260331 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260336 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260341 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260358 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260388 */   // GIR_Coverage, 12888,
     /* 260388 */   GIR_EraseRootFromParent_Done,
     /* 260389 */ // Label 5200: @260389
     /* 260389 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260539), // Rule ID 12890 //
     /* 260394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260401 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260409 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260412 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260421 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260426 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260428 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260428 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260431 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 260435 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260440 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260446 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260449 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260453 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260460 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260463 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260467 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260472 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260475 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260478 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260481 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260486 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260491 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260508 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260538 */   // GIR_Coverage, 12890,
     /* 260538 */   GIR_EraseRootFromParent_Done,
     /* 260539 */ // Label 5201: @260539
     /* 260539 */ GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260689), // Rule ID 12892 //
     /* 260544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260551 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260559 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260562 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260567 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260571 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260576 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260578 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260578 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260581 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 260585 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260590 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260596 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260599 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260603 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260610 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260613 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260617 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260622 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260625 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260628 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260631 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260636 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260641 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260658 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260665 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260670 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260688 */   // GIR_Coverage, 12892,
     /* 260688 */   GIR_EraseRootFromParent_Done,
     /* 260689 */ // Label 5202: @260689
     /* 260689 */ GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(260839), // Rule ID 12894 //
     /* 260694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260701 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260709 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260712 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260717 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260721 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260728 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260728 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260731 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 260735 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260740 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260746 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260749 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260753 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260772 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260775 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260778 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260781 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260786 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260791 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260808 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260815 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260820 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260833 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260838 */   // GIR_Coverage, 12894,
     /* 260838 */   GIR_EraseRootFromParent_Done,
     /* 260839 */ // Label 5203: @260839
     /* 260839 */ GIM_Reject,
     /* 260840 */ // Label 5188: @260840
     /* 260840 */ GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(261149),
     /* 260845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260852 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260917), // Rule ID 702 //
     /* 260857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260868 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 260871 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 260876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 260884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260900 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 260900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 260903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 260915 */     GIR_RootConstrainSelectedInstOperands,
     /* 260916 */     // GIR_Coverage, 702,
     /* 260916 */     GIR_EraseRootFromParent_Done,
     /* 260917 */   // Label 5205: @260917
     /* 260917 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260982), // Rule ID 1704 //
     /* 260922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260933 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 260936 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 260941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260945 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 260949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260965 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 260965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 260968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 260980 */     GIR_RootConstrainSelectedInstOperands,
     /* 260981 */     // GIR_Coverage, 1704,
     /* 260981 */     GIR_EraseRootFromParent_Done,
     /* 260982 */   // Label 5206: @260982
     /* 260982 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(261041), // Rule ID 700 //
     /* 260987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260998 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261001 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261026 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 261026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 261029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261039 */     GIR_RootConstrainSelectedInstOperands,
     /* 261040 */     // GIR_Coverage, 700,
     /* 261040 */     GIR_EraseRootFromParent_Done,
     /* 261041 */   // Label 5207: @261041
     /* 261041 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(261100), // Rule ID 1702 //
     /* 261046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261057 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261060 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261069 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261085 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 261085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 261088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261098 */     GIR_RootConstrainSelectedInstOperands,
     /* 261099 */     // GIR_Coverage, 1702,
     /* 261099 */     GIR_EraseRootFromParent_Done,
     /* 261100 */   // Label 5208: @261100
     /* 261100 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(261127), // Rule ID 6280 //
     /* 261105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261112 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 261112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 261115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261125 */     GIR_RootConstrainSelectedInstOperands,
     /* 261126 */     // GIR_Coverage, 6280,
     /* 261126 */     GIR_EraseRootFromParent_Done,
     /* 261127 */   // Label 5209: @261127
     /* 261127 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(261148), // Rule ID 6271 //
     /* 261132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261136 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 261136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 261139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261146 */     GIR_RootConstrainSelectedInstOperands,
     /* 261147 */     // GIR_Coverage, 6271,
     /* 261147 */     GIR_EraseRootFromParent_Done,
     /* 261148 */   // Label 5210: @261148
     /* 261148 */   GIM_Reject,
     /* 261149 */ // Label 5204: @261149
     /* 261149 */ GIM_Reject,
     /* 261150 */ // Label 5189: @261150
     /* 261150 */ GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(261459),
     /* 261155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261162 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(261227), // Rule ID 698 //
     /* 261167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261178 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261181 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261190 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261210 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 261213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261225 */     GIR_RootConstrainSelectedInstOperands,
     /* 261226 */     // GIR_Coverage, 698,
     /* 261226 */     GIR_EraseRootFromParent_Done,
     /* 261227 */   // Label 5212: @261227
     /* 261227 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(261292), // Rule ID 1700 //
     /* 261232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261243 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261246 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261255 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261275 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 261278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261290 */     GIR_RootConstrainSelectedInstOperands,
     /* 261291 */     // GIR_Coverage, 1700,
     /* 261291 */     GIR_EraseRootFromParent_Done,
     /* 261292 */   // Label 5213: @261292
     /* 261292 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(261351), // Rule ID 696 //
     /* 261297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261336 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 261336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 261339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261349 */     GIR_RootConstrainSelectedInstOperands,
     /* 261350 */     // GIR_Coverage, 696,
     /* 261350 */     GIR_EraseRootFromParent_Done,
     /* 261351 */   // Label 5214: @261351
     /* 261351 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(261410), // Rule ID 1698 //
     /* 261356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261367 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261370 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261379 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261395 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 261395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 261398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261408 */     GIR_RootConstrainSelectedInstOperands,
     /* 261409 */     // GIR_Coverage, 1698,
     /* 261409 */     GIR_EraseRootFromParent_Done,
     /* 261410 */   // Label 5215: @261410
     /* 261410 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(261437), // Rule ID 6277 //
     /* 261415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261422 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 261422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 261425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261435 */     GIR_RootConstrainSelectedInstOperands,
     /* 261436 */     // GIR_Coverage, 6277,
     /* 261436 */     GIR_EraseRootFromParent_Done,
     /* 261437 */   // Label 5216: @261437
     /* 261437 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261458), // Rule ID 6268 //
     /* 261442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261446 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 261446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 261449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261456 */     GIR_RootConstrainSelectedInstOperands,
     /* 261457 */     // GIR_Coverage, 6268,
     /* 261457 */     GIR_EraseRootFromParent_Done,
     /* 261458 */   // Label 5217: @261458
     /* 261458 */   GIM_Reject,
     /* 261459 */ // Label 5211: @261459
     /* 261459 */ GIM_Reject,
     /* 261460 */ // Label 5190: @261460
     /* 261460 */ GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261769),
     /* 261465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 261468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261472 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261537), // Rule ID 694 //
     /* 261477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261488 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261491 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261520 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 261520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 261523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261535 */     GIR_RootConstrainSelectedInstOperands,
     /* 261536 */     // GIR_Coverage, 694,
     /* 261536 */     GIR_EraseRootFromParent_Done,
     /* 261537 */   // Label 5219: @261537
     /* 261537 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261602), // Rule ID 1696 //
     /* 261542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261553 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261556 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261565 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261585 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 261585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 261588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261600 */     GIR_RootConstrainSelectedInstOperands,
     /* 261601 */     // GIR_Coverage, 1696,
     /* 261601 */     GIR_EraseRootFromParent_Done,
     /* 261602 */   // Label 5220: @261602
     /* 261602 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261661), // Rule ID 692 //
     /* 261607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261618 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261621 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261630 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261646 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 261646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 261649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261659 */     GIR_RootConstrainSelectedInstOperands,
     /* 261660 */     // GIR_Coverage, 692,
     /* 261660 */     GIR_EraseRootFromParent_Done,
     /* 261661 */   // Label 5221: @261661
     /* 261661 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261720), // Rule ID 1694 //
     /* 261666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261677 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261680 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261689 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261705 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 261705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 261708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261718 */     GIR_RootConstrainSelectedInstOperands,
     /* 261719 */     // GIR_Coverage, 1694,
     /* 261719 */     GIR_EraseRootFromParent_Done,
     /* 261720 */   // Label 5222: @261720
     /* 261720 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261747), // Rule ID 6274 //
     /* 261725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261732 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 261732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 261735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261745 */     GIR_RootConstrainSelectedInstOperands,
     /* 261746 */     // GIR_Coverage, 6274,
     /* 261746 */     GIR_EraseRootFromParent_Done,
     /* 261747 */   // Label 5223: @261747
     /* 261747 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261768), // Rule ID 6265 //
     /* 261752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261756 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 261756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 261759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261766 */     GIR_RootConstrainSelectedInstOperands,
     /* 261767 */     // GIR_Coverage, 6265,
     /* 261767 */     GIR_EraseRootFromParent_Done,
     /* 261768 */   // Label 5224: @261768
     /* 261768 */   GIM_Reject,
     /* 261769 */ // Label 5218: @261769
     /* 261769 */ GIM_Reject,
     /* 261770 */ // Label 5191: @261770
     /* 261770 */ GIM_Reject,
     /* 261771 */ // Label 41: @261771
     /* 261771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5230*/ GIMT_Encode4(262550),
     /* 261782 */ /*GILLT_s32*//*Label 5225*/ GIMT_Encode4(261818),
     /* 261786 */ /*GILLT_s64*//*Label 5226*/ GIMT_Encode4(261950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261798 */ /*GILLT_v2s64*//*Label 5227*/ GIMT_Encode4(262123), GIMT_Encode4(0),
     /* 261806 */ /*GILLT_v4s32*//*Label 5228*/ GIMT_Encode4(262268), GIMT_Encode4(0),
     /* 261814 */ /*GILLT_v8s16*//*Label 5229*/ GIMT_Encode4(262409),
     /* 261818 */ // Label 5225: @261818
     /* 261818 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261949),
     /* 261823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 261826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 261829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261837 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261874), // Rule ID 3877 //
     /* 261842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 261850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261861 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 261861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 261864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 261872 */     GIR_RootConstrainSelectedInstOperands,
     /* 261873 */     // GIR_Coverage, 3877,
     /* 261873 */     GIR_EraseRootFromParent_Done,
     /* 261874 */   // Label 5232: @261874
     /* 261874 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261911), // Rule ID 3878 //
     /* 261879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 261887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261898 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 261898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 261901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 261909 */     GIR_RootConstrainSelectedInstOperands,
     /* 261910 */     // GIR_Coverage, 3878,
     /* 261910 */     GIR_EraseRootFromParent_Done,
     /* 261911 */   // Label 5233: @261911
     /* 261911 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261948), // Rule ID 3876 //
     /* 261916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 261924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261935 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 261935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 261938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 261946 */     GIR_RootConstrainSelectedInstOperands,
     /* 261947 */     // GIR_Coverage, 3876,
     /* 261947 */     GIR_EraseRootFromParent_Done,
     /* 261948 */   // Label 5234: @261948
     /* 261948 */   GIM_Reject,
     /* 261949 */ // Label 5231: @261949
     /* 261949 */ GIM_Reject,
     /* 261950 */ // Label 5226: @261950
     /* 261950 */ GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(262122),
     /* 261955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 261958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 261961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261969 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262037), // Rule ID 3879 //
     /* 261974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 261982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261993 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 261993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 261996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262035 */     GIR_RootConstrainSelectedInstOperands,
     /* 262036 */     // GIR_Coverage, 3879,
     /* 262036 */     GIR_EraseRootFromParent_Done,
     /* 262037 */   // Label 5236: @262037
     /* 262037 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262105), // Rule ID 3880 //
     /* 262042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262061 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262103 */     GIR_RootConstrainSelectedInstOperands,
     /* 262104 */     // GIR_Coverage, 3880,
     /* 262104 */     GIR_EraseRootFromParent_Done,
     /* 262105 */   // Label 5237: @262105
     /* 262105 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262121), // Rule ID 120 //
     /* 262110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262114 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 262114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262119 */     GIR_RootConstrainSelectedInstOperands,
     /* 262120 */     // GIR_Coverage, 120,
     /* 262120 */     GIR_Done,
     /* 262121 */   // Label 5238: @262121
     /* 262121 */   GIM_Reject,
     /* 262122 */ // Label 5235: @262122
     /* 262122 */ GIM_Reject,
     /* 262123 */ // Label 5227: @262123
     /* 262123 */ GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262267),
     /* 262128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 262134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262138 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262202), // Rule ID 6263 //
     /* 262143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 262172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262184 */     // MIs[3] Operand 1
     /* 262184 */     // No operand predicates
     /* 262184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262186 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 262186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 262189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262195 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 262200 */     GIR_RootConstrainSelectedInstOperands,
     /* 262201 */     // GIR_Coverage, 6263,
     /* 262201 */     GIR_EraseRootFromParent_Done,
     /* 262202 */   // Label 5240: @262202
     /* 262202 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(262266), // Rule ID 6260 //
     /* 262207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 262236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262244 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262248 */     // MIs[3] Operand 1
     /* 262248 */     // No operand predicates
     /* 262248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262250 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 262250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 262253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262259 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 262264 */     GIR_RootConstrainSelectedInstOperands,
     /* 262265 */     // GIR_Coverage, 6260,
     /* 262265 */     GIR_EraseRootFromParent_Done,
     /* 262266 */   // Label 5241: @262266
     /* 262266 */   GIM_Reject,
     /* 262267 */ // Label 5239: @262267
     /* 262267 */ GIM_Reject,
     /* 262268 */ // Label 5228: @262268
     /* 262268 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262408),
     /* 262273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 262279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262283 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262345), // Rule ID 6262 //
     /* 262288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262325 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 262329 */     // MIs[3] Operand 1
     /* 262329 */     // No operand predicates
     /* 262329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262331 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 262331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 262334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262343 */     GIR_RootConstrainSelectedInstOperands,
     /* 262344 */     // GIR_Coverage, 6262,
     /* 262344 */     GIR_EraseRootFromParent_Done,
     /* 262345 */   // Label 5243: @262345
     /* 262345 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262407), // Rule ID 6259 //
     /* 262350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262387 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 262391 */     // MIs[3] Operand 1
     /* 262391 */     // No operand predicates
     /* 262391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262393 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 262393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 262396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262405 */     GIR_RootConstrainSelectedInstOperands,
     /* 262406 */     // GIR_Coverage, 6259,
     /* 262406 */     GIR_EraseRootFromParent_Done,
     /* 262407 */   // Label 5244: @262407
     /* 262407 */   GIM_Reject,
     /* 262408 */ // Label 5242: @262408
     /* 262408 */ GIM_Reject,
     /* 262409 */ // Label 5229: @262409
     /* 262409 */ GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262549),
     /* 262414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262424 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262486), // Rule ID 6261 //
     /* 262429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 262441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 262470 */     // MIs[3] Operand 1
     /* 262470 */     // No operand predicates
     /* 262470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262472 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 262472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 262475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262484 */     GIR_RootConstrainSelectedInstOperands,
     /* 262485 */     // GIR_Coverage, 6261,
     /* 262485 */     GIR_EraseRootFromParent_Done,
     /* 262486 */   // Label 5246: @262486
     /* 262486 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262548), // Rule ID 6258 //
     /* 262491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 262503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262528 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 262532 */     // MIs[3] Operand 1
     /* 262532 */     // No operand predicates
     /* 262532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262534 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 262534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 262537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262546 */     GIR_RootConstrainSelectedInstOperands,
     /* 262547 */     // GIR_Coverage, 6258,
     /* 262547 */     GIR_EraseRootFromParent_Done,
     /* 262548 */   // Label 5247: @262548
     /* 262548 */   GIM_Reject,
     /* 262549 */ // Label 5245: @262549
     /* 262549 */ GIM_Reject,
     /* 262550 */ // Label 5230: @262550
     /* 262550 */ GIM_Reject,
     /* 262551 */ // Label 42: @262551
     /* 262551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5250*/ GIMT_Encode4(262943),
     /* 262562 */ /*GILLT_s32*//*Label 5248*/ GIMT_Encode4(262570),
     /* 262566 */ /*GILLT_s64*//*Label 5249*/ GIMT_Encode4(262736),
     /* 262570 */ // Label 5248: @262570
     /* 262570 */ GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(262735),
     /* 262575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 262578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262589 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262623), // Rule ID 3966 //
     /* 262594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262606 */     // MIs[1] Operand 1
     /* 262606 */     // No operand predicates
     /* 262606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262608 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 262608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 262611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 262618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 262621 */     GIR_RootConstrainSelectedInstOperands,
     /* 262622 */     // GIR_Coverage, 3966,
     /* 262622 */     GIR_EraseRootFromParent_Done,
     /* 262623 */   // Label 5252: @262623
     /* 262623 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262660), // Rule ID 3883 //
     /* 262628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 262636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262647 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 262650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262658 */     GIR_RootConstrainSelectedInstOperands,
     /* 262659 */     // GIR_Coverage, 3883,
     /* 262659 */     GIR_EraseRootFromParent_Done,
     /* 262660 */   // Label 5253: @262660
     /* 262660 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262697), // Rule ID 3884 //
     /* 262665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262684 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 262687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262695 */     GIR_RootConstrainSelectedInstOperands,
     /* 262696 */     // GIR_Coverage, 3884,
     /* 262696 */     GIR_EraseRootFromParent_Done,
     /* 262697 */   // Label 5254: @262697
     /* 262697 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(262734), // Rule ID 3882 //
     /* 262702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262721 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 262724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262732 */     GIR_RootConstrainSelectedInstOperands,
     /* 262733 */     // GIR_Coverage, 3882,
     /* 262733 */     GIR_EraseRootFromParent_Done,
     /* 262734 */   // Label 5255: @262734
     /* 262734 */   GIM_Reject,
     /* 262735 */ // Label 5251: @262735
     /* 262735 */ GIM_Reject,
     /* 262736 */ // Label 5249: @262736
     /* 262736 */ GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(262942),
     /* 262741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 262744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262755 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(262789), // Rule ID 3967 //
     /* 262760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 262772 */     // MIs[1] Operand 1
     /* 262772 */     // No operand predicates
     /* 262772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262774 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 262774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 262777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 262784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 262787 */     GIR_RootConstrainSelectedInstOperands,
     /* 262788 */     // GIR_Coverage, 3967,
     /* 262788 */     GIR_EraseRootFromParent_Done,
     /* 262789 */   // Label 5257: @262789
     /* 262789 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(262857), // Rule ID 3885 //
     /* 262794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262813 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 262848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262855 */     GIR_RootConstrainSelectedInstOperands,
     /* 262856 */     // GIR_Coverage, 3885,
     /* 262856 */     GIR_EraseRootFromParent_Done,
     /* 262857 */   // Label 5258: @262857
     /* 262857 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(262925), // Rule ID 3886 //
     /* 262862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262881 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 262916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262923 */     GIR_RootConstrainSelectedInstOperands,
     /* 262924 */     // GIR_Coverage, 3886,
     /* 262924 */     GIR_EraseRootFromParent_Done,
     /* 262925 */   // Label 5259: @262925
     /* 262925 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262941), // Rule ID 121 //
     /* 262930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262934 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 262934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 262939 */     GIR_RootConstrainSelectedInstOperands,
     /* 262940 */     // GIR_Coverage, 121,
     /* 262940 */     GIR_Done,
     /* 262941 */   // Label 5260: @262941
     /* 262941 */   GIM_Reject,
     /* 262942 */ // Label 5256: @262942
     /* 262942 */ GIM_Reject,
     /* 262943 */ // Label 5250: @262943
     /* 262943 */ GIM_Reject,
     /* 262944 */ // Label 43: @262944
     /* 262944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5263*/ GIMT_Encode4(263719),
     /* 262955 */ /*GILLT_s32*//*Label 5261*/ GIMT_Encode4(262963),
     /* 262959 */ /*GILLT_s64*//*Label 5262*/ GIMT_Encode4(263269),
     /* 262963 */ // Label 5261: @262963
     /* 262963 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(263268),
     /* 262968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 262971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262978 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(263042), // Rule ID 6423 //
     /* 262983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 262991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263000 */     // MIs[1] Operand 2
     /* 263000 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 263023 */     // MIs[2] Operand 1
     /* 263023 */     // No operand predicates
     /* 263023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263025 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 263025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 263040 */     GIR_RootConstrainSelectedInstOperands,
     /* 263041 */     // GIR_Coverage, 6423,
     /* 263041 */     GIR_EraseRootFromParent_Done,
     /* 263042 */   // Label 5265: @263042
     /* 263042 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(263106), // Rule ID 6425 //
     /* 263047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263064 */     // MIs[1] Operand 2
     /* 263064 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 263087 */     // MIs[2] Operand 1
     /* 263087 */     // No operand predicates
     /* 263087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263089 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 263089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 263104 */     GIR_RootConstrainSelectedInstOperands,
     /* 263105 */     // GIR_Coverage, 6425,
     /* 263105 */     GIR_EraseRootFromParent_Done,
     /* 263106 */   // Label 5266: @263106
     /* 263106 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(263144), // Rule ID 3964 //
     /* 263111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263127 */     // MIs[1] Operand 1
     /* 263127 */     // No operand predicates
     /* 263127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263129 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263142 */     GIR_RootConstrainSelectedInstOperands,
     /* 263143 */     // GIR_Coverage, 3964,
     /* 263143 */     GIR_EraseRootFromParent_Done,
     /* 263144 */   // Label 5267: @263144
     /* 263144 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(263185), // Rule ID 2426 //
     /* 263149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 263161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263172 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263183 */     GIR_RootConstrainSelectedInstOperands,
     /* 263184 */     // GIR_Coverage, 2426,
     /* 263184 */     GIR_EraseRootFromParent_Done,
     /* 263185 */   // Label 5268: @263185
     /* 263185 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(263226), // Rule ID 2427 //
     /* 263190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263213 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263224 */     GIR_RootConstrainSelectedInstOperands,
     /* 263225 */     // GIR_Coverage, 2427,
     /* 263225 */     GIR_EraseRootFromParent_Done,
     /* 263226 */   // Label 5269: @263226
     /* 263226 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263267), // Rule ID 2425 //
     /* 263231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263254 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263265 */     GIR_RootConstrainSelectedInstOperands,
     /* 263266 */     // GIR_Coverage, 2425,
     /* 263266 */     GIR_EraseRootFromParent_Done,
     /* 263267 */   // Label 5270: @263267
     /* 263267 */   GIM_Reject,
     /* 263268 */ // Label 5264: @263268
     /* 263268 */ GIM_Reject,
     /* 263269 */ // Label 5262: @263269
     /* 263269 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(263718),
     /* 263274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263284 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(263348), // Rule ID 6424 //
     /* 263289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 263301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263306 */     // MIs[1] Operand 2
     /* 263306 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 263329 */     // MIs[2] Operand 1
     /* 263329 */     // No operand predicates
     /* 263329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263331 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 263331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 263346 */     GIR_RootConstrainSelectedInstOperands,
     /* 263347 */     // GIR_Coverage, 6424,
     /* 263347 */     GIR_EraseRootFromParent_Done,
     /* 263348 */   // Label 5272: @263348
     /* 263348 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(263412), // Rule ID 6426 //
     /* 263353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 263365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263370 */     // MIs[1] Operand 2
     /* 263370 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 263393 */     // MIs[2] Operand 1
     /* 263393 */     // No operand predicates
     /* 263393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263395 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 263395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 263410 */     GIR_RootConstrainSelectedInstOperands,
     /* 263411 */     // GIR_Coverage, 6426,
     /* 263411 */     GIR_EraseRootFromParent_Done,
     /* 263412 */   // Label 5273: @263412
     /* 263412 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263515), // Rule ID 6427 //
     /* 263417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263446 */     // MIs[2] Operand 1
     /* 263446 */     // No operand predicates
     /* 263446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263448 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263448 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 263451 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263455 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263474 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263481 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263513 */     GIR_RootConstrainSelectedInstOperands,
     /* 263514 */     // GIR_Coverage, 6427,
     /* 263514 */     GIR_EraseRootFromParent_Done,
     /* 263515 */   // Label 5274: @263515
     /* 263515 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263553), // Rule ID 3965 //
     /* 263520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 263536 */     // MIs[1] Operand 1
     /* 263536 */     // No operand predicates
     /* 263536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263538 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 263538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 263551 */     GIR_RootConstrainSelectedInstOperands,
     /* 263552 */     // GIR_Coverage, 3965,
     /* 263552 */     GIR_EraseRootFromParent_Done,
     /* 263553 */   // Label 5275: @263553
     /* 263553 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263625), // Rule ID 2428 //
     /* 263558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263581 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 263581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263593 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 263596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 263616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263623 */     GIR_RootConstrainSelectedInstOperands,
     /* 263624 */     // GIR_Coverage, 2428,
     /* 263624 */     GIR_EraseRootFromParent_Done,
     /* 263625 */   // Label 5276: @263625
     /* 263625 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263697), // Rule ID 2429 //
     /* 263630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263653 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 263653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 263668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263672 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 263688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263695 */     GIR_RootConstrainSelectedInstOperands,
     /* 263696 */     // GIR_Coverage, 2429,
     /* 263696 */     GIR_EraseRootFromParent_Done,
     /* 263697 */   // Label 5277: @263697
     /* 263697 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263717), // Rule ID 119 //
     /* 263702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263710 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 263710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 263715 */     GIR_RootConstrainSelectedInstOperands,
     /* 263716 */     // GIR_Coverage, 119,
     /* 263716 */     GIR_Done,
     /* 263717 */   // Label 5278: @263717
     /* 263717 */   GIM_Reject,
     /* 263718 */ // Label 5271: @263718
     /* 263718 */ GIM_Reject,
     /* 263719 */ // Label 5263: @263719
     /* 263719 */ GIM_Reject,
     /* 263720 */ // Label 44: @263720
     /* 263720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5281*/ GIMT_Encode4(263849),
     /* 263731 */ /*GILLT_s32*//*Label 5279*/ GIMT_Encode4(263739),
     /* 263735 */ /*GILLT_s64*//*Label 5280*/ GIMT_Encode4(263794),
     /* 263739 */ // Label 5279: @263739
     /* 263739 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263793), // Rule ID 188 //
     /* 263744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 263750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 263769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263773 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263777 */   // MIs[1] Operand 1
     /* 263777 */   // No operand predicates
     /* 263777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263779 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 263779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 263782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263784 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263786 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 263788 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263791 */   GIR_RootConstrainSelectedInstOperands,
     /* 263792 */   // GIR_Coverage, 188,
     /* 263792 */   GIR_EraseRootFromParent_Done,
     /* 263793 */ // Label 5282: @263793
     /* 263793 */ GIM_Reject,
     /* 263794 */ // Label 5280: @263794
     /* 263794 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263848), // Rule ID 189 //
     /* 263799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 263824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263828 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 263832 */   // MIs[1] Operand 1
     /* 263832 */   // No operand predicates
     /* 263832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263834 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 263834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 263837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263839 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263841 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 263843 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263846 */   GIR_RootConstrainSelectedInstOperands,
     /* 263847 */   // GIR_Coverage, 189,
     /* 263847 */   GIR_EraseRootFromParent_Done,
     /* 263848 */ // Label 5283: @263848
     /* 263848 */ GIM_Reject,
     /* 263849 */ // Label 5281: @263849
     /* 263849 */ GIM_Reject,
     /* 263850 */ // Label 45: @263850
     /* 263850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5286*/ GIMT_Encode4(264342),
     /* 263861 */ /*GILLT_s32*//*Label 5284*/ GIMT_Encode4(263869),
     /* 263865 */ /*GILLT_s64*//*Label 5285*/ GIMT_Encode4(264085),
     /* 263869 */ // Label 5284: @263869
     /* 263869 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264084),
     /* 263874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263884 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(263923), // Rule ID 184 //
     /* 263889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 263897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 263910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263912 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 263912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 263915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263921 */     GIR_RootConstrainSelectedInstOperands,
     /* 263922 */     // GIR_Coverage, 184,
     /* 263922 */     GIR_EraseRootFromParent_Done,
     /* 263923 */   // Label 5288: @263923
     /* 263923 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(263960), // Rule ID 3960 //
     /* 263928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263944 */     // MIs[1] Operand 1
     /* 263944 */     // No operand predicates
     /* 263944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263946 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 263946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 263949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263958 */     GIR_RootConstrainSelectedInstOperands,
     /* 263959 */     // GIR_Coverage, 3960,
     /* 263959 */     GIR_EraseRootFromParent_Done,
     /* 263960 */   // Label 5289: @263960
     /* 263960 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264001), // Rule ID 3889 //
     /* 263965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 263977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263988 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 263991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263999 */     GIR_RootConstrainSelectedInstOperands,
     /* 264000 */     // GIR_Coverage, 3889,
     /* 264000 */     GIR_EraseRootFromParent_Done,
     /* 264001 */   // Label 5290: @264001
     /* 264001 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264042), // Rule ID 3890 //
     /* 264006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264029 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264040 */     GIR_RootConstrainSelectedInstOperands,
     /* 264041 */     // GIR_Coverage, 3890,
     /* 264041 */     GIR_EraseRootFromParent_Done,
     /* 264042 */   // Label 5291: @264042
     /* 264042 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264083), // Rule ID 3888 //
     /* 264047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264070 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264081 */     GIR_RootConstrainSelectedInstOperands,
     /* 264082 */     // GIR_Coverage, 3888,
     /* 264082 */     GIR_EraseRootFromParent_Done,
     /* 264083 */   // Label 5292: @264083
     /* 264083 */   GIM_Reject,
     /* 264084 */ // Label 5287: @264084
     /* 264084 */ GIM_Reject,
     /* 264085 */ // Label 5285: @264085
     /* 264085 */ GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264341),
     /* 264090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264100 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264139), // Rule ID 187 //
     /* 264105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 264113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 264117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 264126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264128 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 264128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 264131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264137 */     GIR_RootConstrainSelectedInstOperands,
     /* 264138 */     // GIR_Coverage, 187,
     /* 264138 */     GIR_EraseRootFromParent_Done,
     /* 264139 */   // Label 5294: @264139
     /* 264139 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264176), // Rule ID 3961 //
     /* 264144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 264160 */     // MIs[1] Operand 1
     /* 264160 */     // No operand predicates
     /* 264160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264162 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 264162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 264165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264174 */     GIR_RootConstrainSelectedInstOperands,
     /* 264175 */     // GIR_Coverage, 3961,
     /* 264175 */     GIR_EraseRootFromParent_Done,
     /* 264176 */   // Label 5295: @264176
     /* 264176 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264248), // Rule ID 3891 //
     /* 264181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264204 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264246 */     GIR_RootConstrainSelectedInstOperands,
     /* 264247 */     // GIR_Coverage, 3891,
     /* 264247 */     GIR_EraseRootFromParent_Done,
     /* 264248 */   // Label 5296: @264248
     /* 264248 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(264320), // Rule ID 3892 //
     /* 264253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264276 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264295 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264318 */     GIR_RootConstrainSelectedInstOperands,
     /* 264319 */     // GIR_Coverage, 3892,
     /* 264319 */     GIR_EraseRootFromParent_Done,
     /* 264320 */   // Label 5297: @264320
     /* 264320 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264340), // Rule ID 122 //
     /* 264325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264333 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 264333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264338 */     GIR_RootConstrainSelectedInstOperands,
     /* 264339 */     // GIR_Coverage, 122,
     /* 264339 */     GIR_Done,
     /* 264340 */   // Label 5298: @264340
     /* 264340 */   GIM_Reject,
     /* 264341 */ // Label 5293: @264341
     /* 264341 */ GIM_Reject,
     /* 264342 */ // Label 5286: @264342
     /* 264342 */ GIM_Reject,
     /* 264343 */ // Label 46: @264343
     /* 264343 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5306*/ GIMT_Encode4(268918),
     /* 264354 */ /*GILLT_v2s32*//*Label 5299*/ GIMT_Encode4(264382),
     /* 264358 */ /*GILLT_v2s64*//*Label 5300*/ GIMT_Encode4(265030),
     /* 264362 */ /*GILLT_v4s16*//*Label 5301*/ GIMT_Encode4(265678),
     /* 264366 */ /*GILLT_v4s32*//*Label 5302*/ GIMT_Encode4(266326),
     /* 264370 */ /*GILLT_v8s8*//*Label 5303*/ GIMT_Encode4(266974),
     /* 264374 */ /*GILLT_v8s16*//*Label 5304*/ GIMT_Encode4(267622),
     /* 264378 */ /*GILLT_v16s8*//*Label 5305*/ GIMT_Encode4(268270),
     /* 264382 */ // Label 5299: @264382
     /* 264382 */ GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(265029),
     /* 264387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264397 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(264434), // Rule ID 5113 //
     /* 264402 */     // MIs[0] Operand 1
     /* 264402 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264425 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 264428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264432 */     GIR_RootConstrainSelectedInstOperands,
     /* 264433 */     // GIR_Coverage, 5113,
     /* 264433 */     GIR_EraseRootFromParent_Done,
     /* 264434 */   // Label 5308: @264434
     /* 264434 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(264471), // Rule ID 5120 //
     /* 264439 */     // MIs[0] Operand 1
     /* 264439 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264448 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264454 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264462 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 264465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264469 */     GIR_RootConstrainSelectedInstOperands,
     /* 264470 */     // GIR_Coverage, 5120,
     /* 264470 */     GIR_EraseRootFromParent_Done,
     /* 264471 */   // Label 5309: @264471
     /* 264471 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(264508), // Rule ID 5127 //
     /* 264476 */     // MIs[0] Operand 1
     /* 264476 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264485 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264491 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264499 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 264502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264506 */     GIR_RootConstrainSelectedInstOperands,
     /* 264507 */     // GIR_Coverage, 5127,
     /* 264507 */     GIR_EraseRootFromParent_Done,
     /* 264508 */   // Label 5310: @264508
     /* 264508 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(264545), // Rule ID 5134 //
     /* 264513 */     // MIs[0] Operand 1
     /* 264513 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264522 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264528 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264536 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 264539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264543 */     GIR_RootConstrainSelectedInstOperands,
     /* 264544 */     // GIR_Coverage, 5134,
     /* 264544 */     GIR_EraseRootFromParent_Done,
     /* 264545 */   // Label 5311: @264545
     /* 264545 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(264582), // Rule ID 5141 //
     /* 264550 */     // MIs[0] Operand 1
     /* 264550 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264565 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264573 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 264576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264580 */     GIR_RootConstrainSelectedInstOperands,
     /* 264581 */     // GIR_Coverage, 5141,
     /* 264581 */     GIR_EraseRootFromParent_Done,
     /* 264582 */   // Label 5312: @264582
     /* 264582 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(264619), // Rule ID 5078 //
     /* 264587 */     // MIs[0] Operand 1
     /* 264587 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264600 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264606 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264610 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 264613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264617 */     GIR_RootConstrainSelectedInstOperands,
     /* 264618 */     // GIR_Coverage, 5078,
     /* 264618 */     GIR_EraseRootFromParent_Done,
     /* 264619 */   // Label 5313: @264619
     /* 264619 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(264656), // Rule ID 5085 //
     /* 264624 */     // MIs[0] Operand 1
     /* 264624 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264647 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 264650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264654 */     GIR_RootConstrainSelectedInstOperands,
     /* 264655 */     // GIR_Coverage, 5085,
     /* 264655 */     GIR_EraseRootFromParent_Done,
     /* 264656 */   // Label 5314: @264656
     /* 264656 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(264693), // Rule ID 5092 //
     /* 264661 */     // MIs[0] Operand 1
     /* 264661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264674 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264680 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264684 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 264687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264691 */     GIR_RootConstrainSelectedInstOperands,
     /* 264692 */     // GIR_Coverage, 5092,
     /* 264692 */     GIR_EraseRootFromParent_Done,
     /* 264693 */   // Label 5315: @264693
     /* 264693 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(264730), // Rule ID 5099 //
     /* 264698 */     // MIs[0] Operand 1
     /* 264698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264721 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 264724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264728 */     GIR_RootConstrainSelectedInstOperands,
     /* 264729 */     // GIR_Coverage, 5099,
     /* 264729 */     GIR_EraseRootFromParent_Done,
     /* 264730 */   // Label 5316: @264730
     /* 264730 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(264767), // Rule ID 5106 //
     /* 264735 */     // MIs[0] Operand 1
     /* 264735 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264758 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 264761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264765 */     GIR_RootConstrainSelectedInstOperands,
     /* 264766 */     // GIR_Coverage, 5106,
     /* 264766 */     GIR_EraseRootFromParent_Done,
     /* 264767 */   // Label 5317: @264767
     /* 264767 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(264796), // Rule ID 5015 //
     /* 264772 */     // MIs[0] Operand 1
     /* 264772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264785 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 264788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264794 */     GIR_RootConstrainSelectedInstOperands,
     /* 264795 */     // GIR_Coverage, 5015,
     /* 264795 */     GIR_EraseRootFromParent_Done,
     /* 264796 */   // Label 5318: @264796
     /* 264796 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(264825), // Rule ID 5022 //
     /* 264801 */     // MIs[0] Operand 1
     /* 264801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264814 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 264817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264823 */     GIR_RootConstrainSelectedInstOperands,
     /* 264824 */     // GIR_Coverage, 5022,
     /* 264824 */     GIR_EraseRootFromParent_Done,
     /* 264825 */   // Label 5319: @264825
     /* 264825 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(264854), // Rule ID 5029 //
     /* 264830 */     // MIs[0] Operand 1
     /* 264830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264843 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 264846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264852 */     GIR_RootConstrainSelectedInstOperands,
     /* 264853 */     // GIR_Coverage, 5029,
     /* 264853 */     GIR_EraseRootFromParent_Done,
     /* 264854 */   // Label 5320: @264854
     /* 264854 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(264883), // Rule ID 5036 //
     /* 264859 */     // MIs[0] Operand 1
     /* 264859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 264864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264872 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 264875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264881 */     GIR_RootConstrainSelectedInstOperands,
     /* 264882 */     // GIR_Coverage, 5036,
     /* 264882 */     GIR_EraseRootFromParent_Done,
     /* 264883 */   // Label 5321: @264883
     /* 264883 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(264912), // Rule ID 5043 //
     /* 264888 */     // MIs[0] Operand 1
     /* 264888 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 264893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264901 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 264904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264910 */     GIR_RootConstrainSelectedInstOperands,
     /* 264911 */     // GIR_Coverage, 5043,
     /* 264911 */     GIR_EraseRootFromParent_Done,
     /* 264912 */   // Label 5322: @264912
     /* 264912 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(264941), // Rule ID 5050 //
     /* 264917 */     // MIs[0] Operand 1
     /* 264917 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264930 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 264930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 264933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264939 */     GIR_RootConstrainSelectedInstOperands,
     /* 264940 */     // GIR_Coverage, 5050,
     /* 264940 */     GIR_EraseRootFromParent_Done,
     /* 264941 */   // Label 5323: @264941
     /* 264941 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(264970), // Rule ID 5057 //
     /* 264946 */     // MIs[0] Operand 1
     /* 264946 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264959 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 264959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 264962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264968 */     GIR_RootConstrainSelectedInstOperands,
     /* 264969 */     // GIR_Coverage, 5057,
     /* 264969 */     GIR_EraseRootFromParent_Done,
     /* 264970 */   // Label 5324: @264970
     /* 264970 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(264999), // Rule ID 5064 //
     /* 264975 */     // MIs[0] Operand 1
     /* 264975 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 264980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264988 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 264988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 264991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264997 */     GIR_RootConstrainSelectedInstOperands,
     /* 264998 */     // GIR_Coverage, 5064,
     /* 264998 */     GIR_EraseRootFromParent_Done,
     /* 264999 */   // Label 5325: @264999
     /* 264999 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265028), // Rule ID 5071 //
     /* 265004 */     // MIs[0] Operand 1
     /* 265004 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 265009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265017 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 265020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265026 */     GIR_RootConstrainSelectedInstOperands,
     /* 265027 */     // GIR_Coverage, 5071,
     /* 265027 */     GIR_EraseRootFromParent_Done,
     /* 265028 */   // Label 5326: @265028
     /* 265028 */   GIM_Reject,
     /* 265029 */ // Label 5307: @265029
     /* 265029 */ GIM_Reject,
     /* 265030 */ // Label 5300: @265030
     /* 265030 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(265677),
     /* 265035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 265038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 265041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265045 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(265082), // Rule ID 5115 //
     /* 265050 */     // MIs[0] Operand 1
     /* 265050 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265059 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265065 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265073 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 265076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265080 */     GIR_RootConstrainSelectedInstOperands,
     /* 265081 */     // GIR_Coverage, 5115,
     /* 265081 */     GIR_EraseRootFromParent_Done,
     /* 265082 */   // Label 5328: @265082
     /* 265082 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(265119), // Rule ID 5122 //
     /* 265087 */     // MIs[0] Operand 1
     /* 265087 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265096 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265102 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265110 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 265113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265117 */     GIR_RootConstrainSelectedInstOperands,
     /* 265118 */     // GIR_Coverage, 5122,
     /* 265118 */     GIR_EraseRootFromParent_Done,
     /* 265119 */   // Label 5329: @265119
     /* 265119 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(265156), // Rule ID 5129 //
     /* 265124 */     // MIs[0] Operand 1
     /* 265124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265133 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265139 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265147 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 265150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265154 */     GIR_RootConstrainSelectedInstOperands,
     /* 265155 */     // GIR_Coverage, 5129,
     /* 265155 */     GIR_EraseRootFromParent_Done,
     /* 265156 */   // Label 5330: @265156
     /* 265156 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(265193), // Rule ID 5136 //
     /* 265161 */     // MIs[0] Operand 1
     /* 265161 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265176 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265184 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 265187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265191 */     GIR_RootConstrainSelectedInstOperands,
     /* 265192 */     // GIR_Coverage, 5136,
     /* 265192 */     GIR_EraseRootFromParent_Done,
     /* 265193 */   // Label 5331: @265193
     /* 265193 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(265230), // Rule ID 5143 //
     /* 265198 */     // MIs[0] Operand 1
     /* 265198 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265207 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265213 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265221 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 265224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265228 */     GIR_RootConstrainSelectedInstOperands,
     /* 265229 */     // GIR_Coverage, 5143,
     /* 265229 */     GIR_EraseRootFromParent_Done,
     /* 265230 */   // Label 5332: @265230
     /* 265230 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(265267), // Rule ID 5080 //
     /* 265235 */     // MIs[0] Operand 1
     /* 265235 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265258 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 265261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265265 */     GIR_RootConstrainSelectedInstOperands,
     /* 265266 */     // GIR_Coverage, 5080,
     /* 265266 */     GIR_EraseRootFromParent_Done,
     /* 265267 */   // Label 5333: @265267
     /* 265267 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(265304), // Rule ID 5087 //
     /* 265272 */     // MIs[0] Operand 1
     /* 265272 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265295 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 265298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265302 */     GIR_RootConstrainSelectedInstOperands,
     /* 265303 */     // GIR_Coverage, 5087,
     /* 265303 */     GIR_EraseRootFromParent_Done,
     /* 265304 */   // Label 5334: @265304
     /* 265304 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(265341), // Rule ID 5094 //
     /* 265309 */     // MIs[0] Operand 1
     /* 265309 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265322 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265328 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265332 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 265335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265339 */     GIR_RootConstrainSelectedInstOperands,
     /* 265340 */     // GIR_Coverage, 5094,
     /* 265340 */     GIR_EraseRootFromParent_Done,
     /* 265341 */   // Label 5335: @265341
     /* 265341 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(265378), // Rule ID 5101 //
     /* 265346 */     // MIs[0] Operand 1
     /* 265346 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265359 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265365 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265369 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 265372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265376 */     GIR_RootConstrainSelectedInstOperands,
     /* 265377 */     // GIR_Coverage, 5101,
     /* 265377 */     GIR_EraseRootFromParent_Done,
     /* 265378 */   // Label 5336: @265378
     /* 265378 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(265415), // Rule ID 5108 //
     /* 265383 */     // MIs[0] Operand 1
     /* 265383 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265402 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265406 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 265409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265413 */     GIR_RootConstrainSelectedInstOperands,
     /* 265414 */     // GIR_Coverage, 5108,
     /* 265414 */     GIR_EraseRootFromParent_Done,
     /* 265415 */   // Label 5337: @265415
     /* 265415 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(265444), // Rule ID 5017 //
     /* 265420 */     // MIs[0] Operand 1
     /* 265420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265433 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 265436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265442 */     GIR_RootConstrainSelectedInstOperands,
     /* 265443 */     // GIR_Coverage, 5017,
     /* 265443 */     GIR_EraseRootFromParent_Done,
     /* 265444 */   // Label 5338: @265444
     /* 265444 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(265473), // Rule ID 5024 //
     /* 265449 */     // MIs[0] Operand 1
     /* 265449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265462 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 265465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265471 */     GIR_RootConstrainSelectedInstOperands,
     /* 265472 */     // GIR_Coverage, 5024,
     /* 265472 */     GIR_EraseRootFromParent_Done,
     /* 265473 */   // Label 5339: @265473
     /* 265473 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(265502), // Rule ID 5031 //
     /* 265478 */     // MIs[0] Operand 1
     /* 265478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265491 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 265494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265500 */     GIR_RootConstrainSelectedInstOperands,
     /* 265501 */     // GIR_Coverage, 5031,
     /* 265501 */     GIR_EraseRootFromParent_Done,
     /* 265502 */   // Label 5340: @265502
     /* 265502 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(265531), // Rule ID 5038 //
     /* 265507 */     // MIs[0] Operand 1
     /* 265507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 265512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265520 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 265523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265529 */     GIR_RootConstrainSelectedInstOperands,
     /* 265530 */     // GIR_Coverage, 5038,
     /* 265530 */     GIR_EraseRootFromParent_Done,
     /* 265531 */   // Label 5341: @265531
     /* 265531 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(265560), // Rule ID 5045 //
     /* 265536 */     // MIs[0] Operand 1
     /* 265536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 265541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265549 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 265552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265558 */     GIR_RootConstrainSelectedInstOperands,
     /* 265559 */     // GIR_Coverage, 5045,
     /* 265559 */     GIR_EraseRootFromParent_Done,
     /* 265560 */   // Label 5342: @265560
     /* 265560 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(265589), // Rule ID 5052 //
     /* 265565 */     // MIs[0] Operand 1
     /* 265565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265578 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 265581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265587 */     GIR_RootConstrainSelectedInstOperands,
     /* 265588 */     // GIR_Coverage, 5052,
     /* 265588 */     GIR_EraseRootFromParent_Done,
     /* 265589 */   // Label 5343: @265589
     /* 265589 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(265618), // Rule ID 5059 //
     /* 265594 */     // MIs[0] Operand 1
     /* 265594 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265607 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 265610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265616 */     GIR_RootConstrainSelectedInstOperands,
     /* 265617 */     // GIR_Coverage, 5059,
     /* 265617 */     GIR_EraseRootFromParent_Done,
     /* 265618 */   // Label 5344: @265618
     /* 265618 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(265647), // Rule ID 5066 //
     /* 265623 */     // MIs[0] Operand 1
     /* 265623 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 265628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265636 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 265639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265645 */     GIR_RootConstrainSelectedInstOperands,
     /* 265646 */     // GIR_Coverage, 5066,
     /* 265646 */     GIR_EraseRootFromParent_Done,
     /* 265647 */   // Label 5345: @265647
     /* 265647 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(265676), // Rule ID 5073 //
     /* 265652 */     // MIs[0] Operand 1
     /* 265652 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 265657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265665 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 265668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265674 */     GIR_RootConstrainSelectedInstOperands,
     /* 265675 */     // GIR_Coverage, 5073,
     /* 265675 */     GIR_EraseRootFromParent_Done,
     /* 265676 */   // Label 5346: @265676
     /* 265676 */   GIM_Reject,
     /* 265677 */ // Label 5327: @265677
     /* 265677 */ GIM_Reject,
     /* 265678 */ // Label 5301: @265678
     /* 265678 */ GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(266325),
     /* 265683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265686 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265693 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(265730), // Rule ID 5111 //
     /* 265698 */     // MIs[0] Operand 1
     /* 265698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265721 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 265724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265728 */     GIR_RootConstrainSelectedInstOperands,
     /* 265729 */     // GIR_Coverage, 5111,
     /* 265729 */     GIR_EraseRootFromParent_Done,
     /* 265730 */   // Label 5348: @265730
     /* 265730 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(265767), // Rule ID 5118 //
     /* 265735 */     // MIs[0] Operand 1
     /* 265735 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265758 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 265761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265765 */     GIR_RootConstrainSelectedInstOperands,
     /* 265766 */     // GIR_Coverage, 5118,
     /* 265766 */     GIR_EraseRootFromParent_Done,
     /* 265767 */   // Label 5349: @265767
     /* 265767 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(265804), // Rule ID 5125 //
     /* 265772 */     // MIs[0] Operand 1
     /* 265772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265781 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265787 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265795 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 265798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265802 */     GIR_RootConstrainSelectedInstOperands,
     /* 265803 */     // GIR_Coverage, 5125,
     /* 265803 */     GIR_EraseRootFromParent_Done,
     /* 265804 */   // Label 5350: @265804
     /* 265804 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(265841), // Rule ID 5132 //
     /* 265809 */     // MIs[0] Operand 1
     /* 265809 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265818 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265824 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265832 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 265835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265839 */     GIR_RootConstrainSelectedInstOperands,
     /* 265840 */     // GIR_Coverage, 5132,
     /* 265840 */     GIR_EraseRootFromParent_Done,
     /* 265841 */   // Label 5351: @265841
     /* 265841 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(265878), // Rule ID 5139 //
     /* 265846 */     // MIs[0] Operand 1
     /* 265846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265869 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 265872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265876 */     GIR_RootConstrainSelectedInstOperands,
     /* 265877 */     // GIR_Coverage, 5139,
     /* 265877 */     GIR_EraseRootFromParent_Done,
     /* 265878 */   // Label 5352: @265878
     /* 265878 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(265915), // Rule ID 5076 //
     /* 265883 */     // MIs[0] Operand 1
     /* 265883 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265896 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265902 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265906 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 265909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265913 */     GIR_RootConstrainSelectedInstOperands,
     /* 265914 */     // GIR_Coverage, 5076,
     /* 265914 */     GIR_EraseRootFromParent_Done,
     /* 265915 */   // Label 5353: @265915
     /* 265915 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(265952), // Rule ID 5083 //
     /* 265920 */     // MIs[0] Operand 1
     /* 265920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265933 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265939 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265943 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 265946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265950 */     GIR_RootConstrainSelectedInstOperands,
     /* 265951 */     // GIR_Coverage, 5083,
     /* 265951 */     GIR_EraseRootFromParent_Done,
     /* 265952 */   // Label 5354: @265952
     /* 265952 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(265989), // Rule ID 5090 //
     /* 265957 */     // MIs[0] Operand 1
     /* 265957 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265970 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265976 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265980 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 265983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265987 */     GIR_RootConstrainSelectedInstOperands,
     /* 265988 */     // GIR_Coverage, 5090,
     /* 265988 */     GIR_EraseRootFromParent_Done,
     /* 265989 */   // Label 5355: @265989
     /* 265989 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(266026), // Rule ID 5097 //
     /* 265994 */     // MIs[0] Operand 1
     /* 265994 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266007 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266013 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266017 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 266020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266024 */     GIR_RootConstrainSelectedInstOperands,
     /* 266025 */     // GIR_Coverage, 5097,
     /* 266025 */     GIR_EraseRootFromParent_Done,
     /* 266026 */   // Label 5356: @266026
     /* 266026 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(266063), // Rule ID 5104 //
     /* 266031 */     // MIs[0] Operand 1
     /* 266031 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266054 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 266057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266061 */     GIR_RootConstrainSelectedInstOperands,
     /* 266062 */     // GIR_Coverage, 5104,
     /* 266062 */     GIR_EraseRootFromParent_Done,
     /* 266063 */   // Label 5357: @266063
     /* 266063 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(266092), // Rule ID 5013 //
     /* 266068 */     // MIs[0] Operand 1
     /* 266068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266081 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 266084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266090 */     GIR_RootConstrainSelectedInstOperands,
     /* 266091 */     // GIR_Coverage, 5013,
     /* 266091 */     GIR_EraseRootFromParent_Done,
     /* 266092 */   // Label 5358: @266092
     /* 266092 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(266121), // Rule ID 5020 //
     /* 266097 */     // MIs[0] Operand 1
     /* 266097 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266110 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 266113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266119 */     GIR_RootConstrainSelectedInstOperands,
     /* 266120 */     // GIR_Coverage, 5020,
     /* 266120 */     GIR_EraseRootFromParent_Done,
     /* 266121 */   // Label 5359: @266121
     /* 266121 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(266150), // Rule ID 5027 //
     /* 266126 */     // MIs[0] Operand 1
     /* 266126 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266139 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 266142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266148 */     GIR_RootConstrainSelectedInstOperands,
     /* 266149 */     // GIR_Coverage, 5027,
     /* 266149 */     GIR_EraseRootFromParent_Done,
     /* 266150 */   // Label 5360: @266150
     /* 266150 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(266179), // Rule ID 5034 //
     /* 266155 */     // MIs[0] Operand 1
     /* 266155 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 266160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266168 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 266171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266177 */     GIR_RootConstrainSelectedInstOperands,
     /* 266178 */     // GIR_Coverage, 5034,
     /* 266178 */     GIR_EraseRootFromParent_Done,
     /* 266179 */   // Label 5361: @266179
     /* 266179 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(266208), // Rule ID 5041 //
     /* 266184 */     // MIs[0] Operand 1
     /* 266184 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 266189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266197 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 266200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266206 */     GIR_RootConstrainSelectedInstOperands,
     /* 266207 */     // GIR_Coverage, 5041,
     /* 266207 */     GIR_EraseRootFromParent_Done,
     /* 266208 */   // Label 5362: @266208
     /* 266208 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(266237), // Rule ID 5048 //
     /* 266213 */     // MIs[0] Operand 1
     /* 266213 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266226 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 266229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266235 */     GIR_RootConstrainSelectedInstOperands,
     /* 266236 */     // GIR_Coverage, 5048,
     /* 266236 */     GIR_EraseRootFromParent_Done,
     /* 266237 */   // Label 5363: @266237
     /* 266237 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(266266), // Rule ID 5055 //
     /* 266242 */     // MIs[0] Operand 1
     /* 266242 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266255 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 266258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266264 */     GIR_RootConstrainSelectedInstOperands,
     /* 266265 */     // GIR_Coverage, 5055,
     /* 266265 */     GIR_EraseRootFromParent_Done,
     /* 266266 */   // Label 5364: @266266
     /* 266266 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(266295), // Rule ID 5062 //
     /* 266271 */     // MIs[0] Operand 1
     /* 266271 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 266276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266284 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 266287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266293 */     GIR_RootConstrainSelectedInstOperands,
     /* 266294 */     // GIR_Coverage, 5062,
     /* 266294 */     GIR_EraseRootFromParent_Done,
     /* 266295 */   // Label 5365: @266295
     /* 266295 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(266324), // Rule ID 5069 //
     /* 266300 */     // MIs[0] Operand 1
     /* 266300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 266305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266313 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 266316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266322 */     GIR_RootConstrainSelectedInstOperands,
     /* 266323 */     // GIR_Coverage, 5069,
     /* 266323 */     GIR_EraseRootFromParent_Done,
     /* 266324 */   // Label 5366: @266324
     /* 266324 */   GIM_Reject,
     /* 266325 */ // Label 5347: @266325
     /* 266325 */ GIM_Reject,
     /* 266326 */ // Label 5302: @266326
     /* 266326 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(266973),
     /* 266331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266334 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266341 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(266378), // Rule ID 5114 //
     /* 266346 */     // MIs[0] Operand 1
     /* 266346 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266369 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 266372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266376 */     GIR_RootConstrainSelectedInstOperands,
     /* 266377 */     // GIR_Coverage, 5114,
     /* 266377 */     GIR_EraseRootFromParent_Done,
     /* 266378 */   // Label 5368: @266378
     /* 266378 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(266415), // Rule ID 5121 //
     /* 266383 */     // MIs[0] Operand 1
     /* 266383 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266406 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 266409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266413 */     GIR_RootConstrainSelectedInstOperands,
     /* 266414 */     // GIR_Coverage, 5121,
     /* 266414 */     GIR_EraseRootFromParent_Done,
     /* 266415 */   // Label 5369: @266415
     /* 266415 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(266452), // Rule ID 5128 //
     /* 266420 */     // MIs[0] Operand 1
     /* 266420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266429 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266435 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266443 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 266446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266450 */     GIR_RootConstrainSelectedInstOperands,
     /* 266451 */     // GIR_Coverage, 5128,
     /* 266451 */     GIR_EraseRootFromParent_Done,
     /* 266452 */   // Label 5370: @266452
     /* 266452 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(266489), // Rule ID 5135 //
     /* 266457 */     // MIs[0] Operand 1
     /* 266457 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266466 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266472 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266480 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 266483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266487 */     GIR_RootConstrainSelectedInstOperands,
     /* 266488 */     // GIR_Coverage, 5135,
     /* 266488 */     GIR_EraseRootFromParent_Done,
     /* 266489 */   // Label 5371: @266489
     /* 266489 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(266526), // Rule ID 5142 //
     /* 266494 */     // MIs[0] Operand 1
     /* 266494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266517 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 266520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266524 */     GIR_RootConstrainSelectedInstOperands,
     /* 266525 */     // GIR_Coverage, 5142,
     /* 266525 */     GIR_EraseRootFromParent_Done,
     /* 266526 */   // Label 5372: @266526
     /* 266526 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(266563), // Rule ID 5079 //
     /* 266531 */     // MIs[0] Operand 1
     /* 266531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266554 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 266557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266561 */     GIR_RootConstrainSelectedInstOperands,
     /* 266562 */     // GIR_Coverage, 5079,
     /* 266562 */     GIR_EraseRootFromParent_Done,
     /* 266563 */   // Label 5373: @266563
     /* 266563 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(266600), // Rule ID 5086 //
     /* 266568 */     // MIs[0] Operand 1
     /* 266568 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266581 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266587 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266591 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 266594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266598 */     GIR_RootConstrainSelectedInstOperands,
     /* 266599 */     // GIR_Coverage, 5086,
     /* 266599 */     GIR_EraseRootFromParent_Done,
     /* 266600 */   // Label 5374: @266600
     /* 266600 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(266637), // Rule ID 5093 //
     /* 266605 */     // MIs[0] Operand 1
     /* 266605 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266628 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 266631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266635 */     GIR_RootConstrainSelectedInstOperands,
     /* 266636 */     // GIR_Coverage, 5093,
     /* 266636 */     GIR_EraseRootFromParent_Done,
     /* 266637 */   // Label 5375: @266637
     /* 266637 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(266674), // Rule ID 5100 //
     /* 266642 */     // MIs[0] Operand 1
     /* 266642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266665 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 266668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266672 */     GIR_RootConstrainSelectedInstOperands,
     /* 266673 */     // GIR_Coverage, 5100,
     /* 266673 */     GIR_EraseRootFromParent_Done,
     /* 266674 */   // Label 5376: @266674
     /* 266674 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(266711), // Rule ID 5107 //
     /* 266679 */     // MIs[0] Operand 1
     /* 266679 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266702 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 266705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266709 */     GIR_RootConstrainSelectedInstOperands,
     /* 266710 */     // GIR_Coverage, 5107,
     /* 266710 */     GIR_EraseRootFromParent_Done,
     /* 266711 */   // Label 5377: @266711
     /* 266711 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(266740), // Rule ID 5016 //
     /* 266716 */     // MIs[0] Operand 1
     /* 266716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266729 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 266732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266738 */     GIR_RootConstrainSelectedInstOperands,
     /* 266739 */     // GIR_Coverage, 5016,
     /* 266739 */     GIR_EraseRootFromParent_Done,
     /* 266740 */   // Label 5378: @266740
     /* 266740 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(266769), // Rule ID 5023 //
     /* 266745 */     // MIs[0] Operand 1
     /* 266745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266758 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 266761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266767 */     GIR_RootConstrainSelectedInstOperands,
     /* 266768 */     // GIR_Coverage, 5023,
     /* 266768 */     GIR_EraseRootFromParent_Done,
     /* 266769 */   // Label 5379: @266769
     /* 266769 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(266798), // Rule ID 5030 //
     /* 266774 */     // MIs[0] Operand 1
     /* 266774 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266787 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 266790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266796 */     GIR_RootConstrainSelectedInstOperands,
     /* 266797 */     // GIR_Coverage, 5030,
     /* 266797 */     GIR_EraseRootFromParent_Done,
     /* 266798 */   // Label 5380: @266798
     /* 266798 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(266827), // Rule ID 5037 //
     /* 266803 */     // MIs[0] Operand 1
     /* 266803 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 266808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266816 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 266819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266825 */     GIR_RootConstrainSelectedInstOperands,
     /* 266826 */     // GIR_Coverage, 5037,
     /* 266826 */     GIR_EraseRootFromParent_Done,
     /* 266827 */   // Label 5381: @266827
     /* 266827 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(266856), // Rule ID 5044 //
     /* 266832 */     // MIs[0] Operand 1
     /* 266832 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 266837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266845 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 266848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266854 */     GIR_RootConstrainSelectedInstOperands,
     /* 266855 */     // GIR_Coverage, 5044,
     /* 266855 */     GIR_EraseRootFromParent_Done,
     /* 266856 */   // Label 5382: @266856
     /* 266856 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(266885), // Rule ID 5051 //
     /* 266861 */     // MIs[0] Operand 1
     /* 266861 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266874 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 266877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266883 */     GIR_RootConstrainSelectedInstOperands,
     /* 266884 */     // GIR_Coverage, 5051,
     /* 266884 */     GIR_EraseRootFromParent_Done,
     /* 266885 */   // Label 5383: @266885
     /* 266885 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(266914), // Rule ID 5058 //
     /* 266890 */     // MIs[0] Operand 1
     /* 266890 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266903 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 266906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266912 */     GIR_RootConstrainSelectedInstOperands,
     /* 266913 */     // GIR_Coverage, 5058,
     /* 266913 */     GIR_EraseRootFromParent_Done,
     /* 266914 */   // Label 5384: @266914
     /* 266914 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(266943), // Rule ID 5065 //
     /* 266919 */     // MIs[0] Operand 1
     /* 266919 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 266924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266932 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 266935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266941 */     GIR_RootConstrainSelectedInstOperands,
     /* 266942 */     // GIR_Coverage, 5065,
     /* 266942 */     GIR_EraseRootFromParent_Done,
     /* 266943 */   // Label 5385: @266943
     /* 266943 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(266972), // Rule ID 5072 //
     /* 266948 */     // MIs[0] Operand 1
     /* 266948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 266953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266961 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 266964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266970 */     GIR_RootConstrainSelectedInstOperands,
     /* 266971 */     // GIR_Coverage, 5072,
     /* 266971 */     GIR_EraseRootFromParent_Done,
     /* 266972 */   // Label 5386: @266972
     /* 266972 */   GIM_Reject,
     /* 266973 */ // Label 5367: @266973
     /* 266973 */ GIM_Reject,
     /* 266974 */ // Label 5303: @266974
     /* 266974 */ GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(267621),
     /* 266979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 266985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266989 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(267026), // Rule ID 5109 //
     /* 266994 */     // MIs[0] Operand 1
     /* 266994 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267003 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267009 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267017 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 267020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267024 */     GIR_RootConstrainSelectedInstOperands,
     /* 267025 */     // GIR_Coverage, 5109,
     /* 267025 */     GIR_EraseRootFromParent_Done,
     /* 267026 */   // Label 5388: @267026
     /* 267026 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(267063), // Rule ID 5116 //
     /* 267031 */     // MIs[0] Operand 1
     /* 267031 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267054 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 267057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267061 */     GIR_RootConstrainSelectedInstOperands,
     /* 267062 */     // GIR_Coverage, 5116,
     /* 267062 */     GIR_EraseRootFromParent_Done,
     /* 267063 */   // Label 5389: @267063
     /* 267063 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(267100), // Rule ID 5123 //
     /* 267068 */     // MIs[0] Operand 1
     /* 267068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267077 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267083 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267091 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 267094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267098 */     GIR_RootConstrainSelectedInstOperands,
     /* 267099 */     // GIR_Coverage, 5123,
     /* 267099 */     GIR_EraseRootFromParent_Done,
     /* 267100 */   // Label 5390: @267100
     /* 267100 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(267137), // Rule ID 5130 //
     /* 267105 */     // MIs[0] Operand 1
     /* 267105 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267114 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267120 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267128 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 267131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267135 */     GIR_RootConstrainSelectedInstOperands,
     /* 267136 */     // GIR_Coverage, 5130,
     /* 267136 */     GIR_EraseRootFromParent_Done,
     /* 267137 */   // Label 5391: @267137
     /* 267137 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(267174), // Rule ID 5137 //
     /* 267142 */     // MIs[0] Operand 1
     /* 267142 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267157 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267165 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 267168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267172 */     GIR_RootConstrainSelectedInstOperands,
     /* 267173 */     // GIR_Coverage, 5137,
     /* 267173 */     GIR_EraseRootFromParent_Done,
     /* 267174 */   // Label 5392: @267174
     /* 267174 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(267211), // Rule ID 5074 //
     /* 267179 */     // MIs[0] Operand 1
     /* 267179 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267198 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267202 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 267205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267209 */     GIR_RootConstrainSelectedInstOperands,
     /* 267210 */     // GIR_Coverage, 5074,
     /* 267210 */     GIR_EraseRootFromParent_Done,
     /* 267211 */   // Label 5393: @267211
     /* 267211 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(267248), // Rule ID 5081 //
     /* 267216 */     // MIs[0] Operand 1
     /* 267216 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267229 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267235 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267239 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 267242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267246 */     GIR_RootConstrainSelectedInstOperands,
     /* 267247 */     // GIR_Coverage, 5081,
     /* 267247 */     GIR_EraseRootFromParent_Done,
     /* 267248 */   // Label 5394: @267248
     /* 267248 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(267285), // Rule ID 5088 //
     /* 267253 */     // MIs[0] Operand 1
     /* 267253 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267266 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267272 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267276 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 267279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267283 */     GIR_RootConstrainSelectedInstOperands,
     /* 267284 */     // GIR_Coverage, 5088,
     /* 267284 */     GIR_EraseRootFromParent_Done,
     /* 267285 */   // Label 5395: @267285
     /* 267285 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(267322), // Rule ID 5095 //
     /* 267290 */     // MIs[0] Operand 1
     /* 267290 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267303 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267309 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267313 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 267316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267320 */     GIR_RootConstrainSelectedInstOperands,
     /* 267321 */     // GIR_Coverage, 5095,
     /* 267321 */     GIR_EraseRootFromParent_Done,
     /* 267322 */   // Label 5396: @267322
     /* 267322 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(267359), // Rule ID 5102 //
     /* 267327 */     // MIs[0] Operand 1
     /* 267327 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267340 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267346 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267350 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 267353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267357 */     GIR_RootConstrainSelectedInstOperands,
     /* 267358 */     // GIR_Coverage, 5102,
     /* 267358 */     GIR_EraseRootFromParent_Done,
     /* 267359 */   // Label 5397: @267359
     /* 267359 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(267388), // Rule ID 5011 //
     /* 267364 */     // MIs[0] Operand 1
     /* 267364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267377 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 267380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267386 */     GIR_RootConstrainSelectedInstOperands,
     /* 267387 */     // GIR_Coverage, 5011,
     /* 267387 */     GIR_EraseRootFromParent_Done,
     /* 267388 */   // Label 5398: @267388
     /* 267388 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(267417), // Rule ID 5018 //
     /* 267393 */     // MIs[0] Operand 1
     /* 267393 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267406 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 267409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267415 */     GIR_RootConstrainSelectedInstOperands,
     /* 267416 */     // GIR_Coverage, 5018,
     /* 267416 */     GIR_EraseRootFromParent_Done,
     /* 267417 */   // Label 5399: @267417
     /* 267417 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(267446), // Rule ID 5025 //
     /* 267422 */     // MIs[0] Operand 1
     /* 267422 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267435 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 267438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267444 */     GIR_RootConstrainSelectedInstOperands,
     /* 267445 */     // GIR_Coverage, 5025,
     /* 267445 */     GIR_EraseRootFromParent_Done,
     /* 267446 */   // Label 5400: @267446
     /* 267446 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(267475), // Rule ID 5032 //
     /* 267451 */     // MIs[0] Operand 1
     /* 267451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 267456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267464 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 267467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267473 */     GIR_RootConstrainSelectedInstOperands,
     /* 267474 */     // GIR_Coverage, 5032,
     /* 267474 */     GIR_EraseRootFromParent_Done,
     /* 267475 */   // Label 5401: @267475
     /* 267475 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(267504), // Rule ID 5039 //
     /* 267480 */     // MIs[0] Operand 1
     /* 267480 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 267485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267493 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 267496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267502 */     GIR_RootConstrainSelectedInstOperands,
     /* 267503 */     // GIR_Coverage, 5039,
     /* 267503 */     GIR_EraseRootFromParent_Done,
     /* 267504 */   // Label 5402: @267504
     /* 267504 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(267533), // Rule ID 5046 //
     /* 267509 */     // MIs[0] Operand 1
     /* 267509 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267522 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 267525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267531 */     GIR_RootConstrainSelectedInstOperands,
     /* 267532 */     // GIR_Coverage, 5046,
     /* 267532 */     GIR_EraseRootFromParent_Done,
     /* 267533 */   // Label 5403: @267533
     /* 267533 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(267562), // Rule ID 5053 //
     /* 267538 */     // MIs[0] Operand 1
     /* 267538 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267551 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 267554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267560 */     GIR_RootConstrainSelectedInstOperands,
     /* 267561 */     // GIR_Coverage, 5053,
     /* 267561 */     GIR_EraseRootFromParent_Done,
     /* 267562 */   // Label 5404: @267562
     /* 267562 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(267591), // Rule ID 5060 //
     /* 267567 */     // MIs[0] Operand 1
     /* 267567 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 267572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267580 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 267583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267589 */     GIR_RootConstrainSelectedInstOperands,
     /* 267590 */     // GIR_Coverage, 5060,
     /* 267590 */     GIR_EraseRootFromParent_Done,
     /* 267591 */   // Label 5405: @267591
     /* 267591 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(267620), // Rule ID 5067 //
     /* 267596 */     // MIs[0] Operand 1
     /* 267596 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 267601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267609 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 267612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267618 */     GIR_RootConstrainSelectedInstOperands,
     /* 267619 */     // GIR_Coverage, 5067,
     /* 267619 */     GIR_EraseRootFromParent_Done,
     /* 267620 */   // Label 5406: @267620
     /* 267620 */   GIM_Reject,
     /* 267621 */ // Label 5387: @267621
     /* 267621 */ GIM_Reject,
     /* 267622 */ // Label 5304: @267622
     /* 267622 */ GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(268269),
     /* 267627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 267633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267637 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(267674), // Rule ID 5112 //
     /* 267642 */     // MIs[0] Operand 1
     /* 267642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267665 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 267668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267672 */     GIR_RootConstrainSelectedInstOperands,
     /* 267673 */     // GIR_Coverage, 5112,
     /* 267673 */     GIR_EraseRootFromParent_Done,
     /* 267674 */   // Label 5408: @267674
     /* 267674 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(267711), // Rule ID 5119 //
     /* 267679 */     // MIs[0] Operand 1
     /* 267679 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267688 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267694 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267702 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 267705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267709 */     GIR_RootConstrainSelectedInstOperands,
     /* 267710 */     // GIR_Coverage, 5119,
     /* 267710 */     GIR_EraseRootFromParent_Done,
     /* 267711 */   // Label 5409: @267711
     /* 267711 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(267748), // Rule ID 5126 //
     /* 267716 */     // MIs[0] Operand 1
     /* 267716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267725 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267731 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267739 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 267742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267746 */     GIR_RootConstrainSelectedInstOperands,
     /* 267747 */     // GIR_Coverage, 5126,
     /* 267747 */     GIR_EraseRootFromParent_Done,
     /* 267748 */   // Label 5410: @267748
     /* 267748 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(267785), // Rule ID 5133 //
     /* 267753 */     // MIs[0] Operand 1
     /* 267753 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267762 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267768 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267776 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 267779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267783 */     GIR_RootConstrainSelectedInstOperands,
     /* 267784 */     // GIR_Coverage, 5133,
     /* 267784 */     GIR_EraseRootFromParent_Done,
     /* 267785 */   // Label 5411: @267785
     /* 267785 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(267822), // Rule ID 5140 //
     /* 267790 */     // MIs[0] Operand 1
     /* 267790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267813 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 267816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267820 */     GIR_RootConstrainSelectedInstOperands,
     /* 267821 */     // GIR_Coverage, 5140,
     /* 267821 */     GIR_EraseRootFromParent_Done,
     /* 267822 */   // Label 5412: @267822
     /* 267822 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(267859), // Rule ID 5077 //
     /* 267827 */     // MIs[0] Operand 1
     /* 267827 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267850 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 267853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267857 */     GIR_RootConstrainSelectedInstOperands,
     /* 267858 */     // GIR_Coverage, 5077,
     /* 267858 */     GIR_EraseRootFromParent_Done,
     /* 267859 */   // Label 5413: @267859
     /* 267859 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(267896), // Rule ID 5084 //
     /* 267864 */     // MIs[0] Operand 1
     /* 267864 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267877 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267883 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267887 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 267890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267894 */     GIR_RootConstrainSelectedInstOperands,
     /* 267895 */     // GIR_Coverage, 5084,
     /* 267895 */     GIR_EraseRootFromParent_Done,
     /* 267896 */   // Label 5414: @267896
     /* 267896 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(267933), // Rule ID 5091 //
     /* 267901 */     // MIs[0] Operand 1
     /* 267901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267924 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 267927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267931 */     GIR_RootConstrainSelectedInstOperands,
     /* 267932 */     // GIR_Coverage, 5091,
     /* 267932 */     GIR_EraseRootFromParent_Done,
     /* 267933 */   // Label 5415: @267933
     /* 267933 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(267970), // Rule ID 5098 //
     /* 267938 */     // MIs[0] Operand 1
     /* 267938 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267961 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 267964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267968 */     GIR_RootConstrainSelectedInstOperands,
     /* 267969 */     // GIR_Coverage, 5098,
     /* 267969 */     GIR_EraseRootFromParent_Done,
     /* 267970 */   // Label 5416: @267970
     /* 267970 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(268007), // Rule ID 5105 //
     /* 267975 */     // MIs[0] Operand 1
     /* 267975 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267994 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267998 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 268001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268005 */     GIR_RootConstrainSelectedInstOperands,
     /* 268006 */     // GIR_Coverage, 5105,
     /* 268006 */     GIR_EraseRootFromParent_Done,
     /* 268007 */   // Label 5417: @268007
     /* 268007 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(268036), // Rule ID 5014 //
     /* 268012 */     // MIs[0] Operand 1
     /* 268012 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268025 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 268028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268034 */     GIR_RootConstrainSelectedInstOperands,
     /* 268035 */     // GIR_Coverage, 5014,
     /* 268035 */     GIR_EraseRootFromParent_Done,
     /* 268036 */   // Label 5418: @268036
     /* 268036 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(268065), // Rule ID 5021 //
     /* 268041 */     // MIs[0] Operand 1
     /* 268041 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268054 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 268057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268063 */     GIR_RootConstrainSelectedInstOperands,
     /* 268064 */     // GIR_Coverage, 5021,
     /* 268064 */     GIR_EraseRootFromParent_Done,
     /* 268065 */   // Label 5419: @268065
     /* 268065 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(268094), // Rule ID 5028 //
     /* 268070 */     // MIs[0] Operand 1
     /* 268070 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268083 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 268086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268092 */     GIR_RootConstrainSelectedInstOperands,
     /* 268093 */     // GIR_Coverage, 5028,
     /* 268093 */     GIR_EraseRootFromParent_Done,
     /* 268094 */   // Label 5420: @268094
     /* 268094 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(268123), // Rule ID 5035 //
     /* 268099 */     // MIs[0] Operand 1
     /* 268099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268112 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 268115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268121 */     GIR_RootConstrainSelectedInstOperands,
     /* 268122 */     // GIR_Coverage, 5035,
     /* 268122 */     GIR_EraseRootFromParent_Done,
     /* 268123 */   // Label 5421: @268123
     /* 268123 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(268152), // Rule ID 5042 //
     /* 268128 */     // MIs[0] Operand 1
     /* 268128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268141 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 268144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268150 */     GIR_RootConstrainSelectedInstOperands,
     /* 268151 */     // GIR_Coverage, 5042,
     /* 268151 */     GIR_EraseRootFromParent_Done,
     /* 268152 */   // Label 5422: @268152
     /* 268152 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(268181), // Rule ID 5049 //
     /* 268157 */     // MIs[0] Operand 1
     /* 268157 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268170 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 268173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268179 */     GIR_RootConstrainSelectedInstOperands,
     /* 268180 */     // GIR_Coverage, 5049,
     /* 268180 */     GIR_EraseRootFromParent_Done,
     /* 268181 */   // Label 5423: @268181
     /* 268181 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(268210), // Rule ID 5056 //
     /* 268186 */     // MIs[0] Operand 1
     /* 268186 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268199 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 268202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268208 */     GIR_RootConstrainSelectedInstOperands,
     /* 268209 */     // GIR_Coverage, 5056,
     /* 268209 */     GIR_EraseRootFromParent_Done,
     /* 268210 */   // Label 5424: @268210
     /* 268210 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(268239), // Rule ID 5063 //
     /* 268215 */     // MIs[0] Operand 1
     /* 268215 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268228 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 268231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268237 */     GIR_RootConstrainSelectedInstOperands,
     /* 268238 */     // GIR_Coverage, 5063,
     /* 268238 */     GIR_EraseRootFromParent_Done,
     /* 268239 */   // Label 5425: @268239
     /* 268239 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(268268), // Rule ID 5070 //
     /* 268244 */     // MIs[0] Operand 1
     /* 268244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268257 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 268260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268266 */     GIR_RootConstrainSelectedInstOperands,
     /* 268267 */     // GIR_Coverage, 5070,
     /* 268267 */     GIR_EraseRootFromParent_Done,
     /* 268268 */   // Label 5426: @268268
     /* 268268 */   GIM_Reject,
     /* 268269 */ // Label 5407: @268269
     /* 268269 */ GIM_Reject,
     /* 268270 */ // Label 5305: @268270
     /* 268270 */ GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(268917),
     /* 268275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 268281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268285 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(268322), // Rule ID 5110 //
     /* 268290 */     // MIs[0] Operand 1
     /* 268290 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268299 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268305 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268313 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 268316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268320 */     GIR_RootConstrainSelectedInstOperands,
     /* 268321 */     // GIR_Coverage, 5110,
     /* 268321 */     GIR_EraseRootFromParent_Done,
     /* 268322 */   // Label 5428: @268322
     /* 268322 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(268359), // Rule ID 5117 //
     /* 268327 */     // MIs[0] Operand 1
     /* 268327 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268350 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 268353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268357 */     GIR_RootConstrainSelectedInstOperands,
     /* 268358 */     // GIR_Coverage, 5117,
     /* 268358 */     GIR_EraseRootFromParent_Done,
     /* 268359 */   // Label 5429: @268359
     /* 268359 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(268396), // Rule ID 5124 //
     /* 268364 */     // MIs[0] Operand 1
     /* 268364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268373 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268379 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268387 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 268390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268394 */     GIR_RootConstrainSelectedInstOperands,
     /* 268395 */     // GIR_Coverage, 5124,
     /* 268395 */     GIR_EraseRootFromParent_Done,
     /* 268396 */   // Label 5430: @268396
     /* 268396 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(268433), // Rule ID 5131 //
     /* 268401 */     // MIs[0] Operand 1
     /* 268401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268410 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268416 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268424 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 268427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268431 */     GIR_RootConstrainSelectedInstOperands,
     /* 268432 */     // GIR_Coverage, 5131,
     /* 268432 */     GIR_EraseRootFromParent_Done,
     /* 268433 */   // Label 5431: @268433
     /* 268433 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(268470), // Rule ID 5138 //
     /* 268438 */     // MIs[0] Operand 1
     /* 268438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268453 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268461 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 268464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268468 */     GIR_RootConstrainSelectedInstOperands,
     /* 268469 */     // GIR_Coverage, 5138,
     /* 268469 */     GIR_EraseRootFromParent_Done,
     /* 268470 */   // Label 5432: @268470
     /* 268470 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(268507), // Rule ID 5075 //
     /* 268475 */     // MIs[0] Operand 1
     /* 268475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268488 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268494 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268498 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 268501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268505 */     GIR_RootConstrainSelectedInstOperands,
     /* 268506 */     // GIR_Coverage, 5075,
     /* 268506 */     GIR_EraseRootFromParent_Done,
     /* 268507 */   // Label 5433: @268507
     /* 268507 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(268544), // Rule ID 5082 //
     /* 268512 */     // MIs[0] Operand 1
     /* 268512 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268525 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268531 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268535 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 268538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268542 */     GIR_RootConstrainSelectedInstOperands,
     /* 268543 */     // GIR_Coverage, 5082,
     /* 268543 */     GIR_EraseRootFromParent_Done,
     /* 268544 */   // Label 5434: @268544
     /* 268544 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(268581), // Rule ID 5089 //
     /* 268549 */     // MIs[0] Operand 1
     /* 268549 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268572 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 268575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268579 */     GIR_RootConstrainSelectedInstOperands,
     /* 268580 */     // GIR_Coverage, 5089,
     /* 268580 */     GIR_EraseRootFromParent_Done,
     /* 268581 */   // Label 5435: @268581
     /* 268581 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(268618), // Rule ID 5096 //
     /* 268586 */     // MIs[0] Operand 1
     /* 268586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268609 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 268612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268616 */     GIR_RootConstrainSelectedInstOperands,
     /* 268617 */     // GIR_Coverage, 5096,
     /* 268617 */     GIR_EraseRootFromParent_Done,
     /* 268618 */   // Label 5436: @268618
     /* 268618 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(268655), // Rule ID 5103 //
     /* 268623 */     // MIs[0] Operand 1
     /* 268623 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268646 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 268649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268653 */     GIR_RootConstrainSelectedInstOperands,
     /* 268654 */     // GIR_Coverage, 5103,
     /* 268654 */     GIR_EraseRootFromParent_Done,
     /* 268655 */   // Label 5437: @268655
     /* 268655 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(268684), // Rule ID 5012 //
     /* 268660 */     // MIs[0] Operand 1
     /* 268660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268673 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 268676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268682 */     GIR_RootConstrainSelectedInstOperands,
     /* 268683 */     // GIR_Coverage, 5012,
     /* 268683 */     GIR_EraseRootFromParent_Done,
     /* 268684 */   // Label 5438: @268684
     /* 268684 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(268713), // Rule ID 5019 //
     /* 268689 */     // MIs[0] Operand 1
     /* 268689 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268702 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 268705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268711 */     GIR_RootConstrainSelectedInstOperands,
     /* 268712 */     // GIR_Coverage, 5019,
     /* 268712 */     GIR_EraseRootFromParent_Done,
     /* 268713 */   // Label 5439: @268713
     /* 268713 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(268742), // Rule ID 5026 //
     /* 268718 */     // MIs[0] Operand 1
     /* 268718 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268731 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 268734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268740 */     GIR_RootConstrainSelectedInstOperands,
     /* 268741 */     // GIR_Coverage, 5026,
     /* 268741 */     GIR_EraseRootFromParent_Done,
     /* 268742 */   // Label 5440: @268742
     /* 268742 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(268771), // Rule ID 5033 //
     /* 268747 */     // MIs[0] Operand 1
     /* 268747 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268760 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 268763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268769 */     GIR_RootConstrainSelectedInstOperands,
     /* 268770 */     // GIR_Coverage, 5033,
     /* 268770 */     GIR_EraseRootFromParent_Done,
     /* 268771 */   // Label 5441: @268771
     /* 268771 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(268800), // Rule ID 5040 //
     /* 268776 */     // MIs[0] Operand 1
     /* 268776 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268789 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 268792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268798 */     GIR_RootConstrainSelectedInstOperands,
     /* 268799 */     // GIR_Coverage, 5040,
     /* 268799 */     GIR_EraseRootFromParent_Done,
     /* 268800 */   // Label 5442: @268800
     /* 268800 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(268829), // Rule ID 5047 //
     /* 268805 */     // MIs[0] Operand 1
     /* 268805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268818 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 268821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268827 */     GIR_RootConstrainSelectedInstOperands,
     /* 268828 */     // GIR_Coverage, 5047,
     /* 268828 */     GIR_EraseRootFromParent_Done,
     /* 268829 */   // Label 5443: @268829
     /* 268829 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(268858), // Rule ID 5054 //
     /* 268834 */     // MIs[0] Operand 1
     /* 268834 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268847 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 268850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268856 */     GIR_RootConstrainSelectedInstOperands,
     /* 268857 */     // GIR_Coverage, 5054,
     /* 268857 */     GIR_EraseRootFromParent_Done,
     /* 268858 */   // Label 5444: @268858
     /* 268858 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(268887), // Rule ID 5061 //
     /* 268863 */     // MIs[0] Operand 1
     /* 268863 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268876 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 268879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268885 */     GIR_RootConstrainSelectedInstOperands,
     /* 268886 */     // GIR_Coverage, 5061,
     /* 268886 */     GIR_EraseRootFromParent_Done,
     /* 268887 */   // Label 5445: @268887
     /* 268887 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(268916), // Rule ID 5068 //
     /* 268892 */     // MIs[0] Operand 1
     /* 268892 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268905 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 268908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268914 */     GIR_RootConstrainSelectedInstOperands,
     /* 268915 */     // GIR_Coverage, 5068,
     /* 268915 */     GIR_EraseRootFromParent_Done,
     /* 268916 */   // Label 5446: @268916
     /* 268916 */   GIM_Reject,
     /* 268917 */ // Label 5427: @268917
     /* 268917 */ GIM_Reject,
     /* 268918 */ // Label 5306: @268918
     /* 268918 */ GIM_Reject,
     /* 268919 */ // Label 47: @268919
     /* 268919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5459*/ GIMT_Encode4(269624),
     /* 268930 */ /*GILLT_nxv1s1*//*Label 5447*/ GIMT_Encode4(268978),
     /* 268934 */ /*GILLT_nxv2s1*//*Label 5448*/ GIMT_Encode4(269007),
     /* 268938 */ /*GILLT_nxv2s16*//*Label 5449*/ GIMT_Encode4(269036),
     /* 268942 */ /*GILLT_nxv2s32*//*Label 5450*/ GIMT_Encode4(269065),
     /* 268946 */ /*GILLT_nxv2s64*//*Label 5451*/ GIMT_Encode4(269094),
     /* 268950 */ /*GILLT_nxv4s1*//*Label 5452*/ GIMT_Encode4(269203),
     /* 268954 */ /*GILLT_nxv4s16*//*Label 5453*/ GIMT_Encode4(269232),
     /* 268958 */ /*GILLT_nxv4s32*//*Label 5454*/ GIMT_Encode4(269261),
     /* 268962 */ /*GILLT_nxv8s1*//*Label 5455*/ GIMT_Encode4(269370),
     /* 268966 */ /*GILLT_nxv8s16*//*Label 5456*/ GIMT_Encode4(269399),
     /* 268970 */ /*GILLT_nxv16s1*//*Label 5457*/ GIMT_Encode4(269508),
     /* 268974 */ /*GILLT_nxv16s8*//*Label 5458*/ GIMT_Encode4(269537),
     /* 268978 */ // Label 5447: @268978
     /* 268978 */ GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(269006), // Rule ID 8291 //
     /* 268983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 268989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 268992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 268995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 268999 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 268999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269004 */   GIR_RootConstrainSelectedInstOperands,
     /* 269005 */   // GIR_Coverage, 8291,
     /* 269005 */   GIR_Done,
     /* 269006 */ // Label 5460: @269006
     /* 269006 */ GIM_Reject,
     /* 269007 */ // Label 5448: @269007
     /* 269007 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(269035), // Rule ID 8290 //
     /* 269012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 269021 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 269024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269028 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 269028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269033 */   GIR_RootConstrainSelectedInstOperands,
     /* 269034 */   // GIR_Coverage, 8290,
     /* 269034 */   GIR_Done,
     /* 269035 */ // Label 5461: @269035
     /* 269035 */ GIM_Reject,
     /* 269036 */ // Label 5449: @269036
     /* 269036 */ GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(269064), // Rule ID 2727 //
     /* 269041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 269050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 269053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269057 */   // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 269057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269062 */   GIR_RootConstrainSelectedInstOperands,
     /* 269063 */   // GIR_Coverage, 2727,
     /* 269063 */   GIR_Done,
     /* 269064 */ // Label 5462: @269064
     /* 269064 */ GIM_Reject,
     /* 269065 */ // Label 5450: @269065
     /* 269065 */ GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(269093), // Rule ID 2728 //
     /* 269070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 269079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 269082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269086 */   // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 269086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269091 */   GIR_RootConstrainSelectedInstOperands,
     /* 269092 */   // GIR_Coverage, 2728,
     /* 269092 */   GIR_Done,
     /* 269093 */ // Label 5463: @269093
     /* 269093 */ GIM_Reject,
     /* 269094 */ // Label 5451: @269094
     /* 269094 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(269202),
     /* 269099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269105 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(269157), // Rule ID 7341 //
     /* 269110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 269129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269133 */     // MIs[0] Op2
     /* 269133 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269140 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 269140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 269143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269155 */     GIR_RootConstrainSelectedInstOperands,
     /* 269156 */     // GIR_Coverage, 7341,
     /* 269156 */     GIR_EraseRootFromParent_Done,
     /* 269157 */   // Label 5465: @269157
     /* 269157 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(269179), // Rule ID 2723 //
     /* 269162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269172 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 269172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269177 */     GIR_RootConstrainSelectedInstOperands,
     /* 269178 */     // GIR_Coverage, 2723,
     /* 269178 */     GIR_Done,
     /* 269179 */   // Label 5466: @269179
     /* 269179 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(269201), // Rule ID 2729 //
     /* 269184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269194 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 269194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269199 */     GIR_RootConstrainSelectedInstOperands,
     /* 269200 */     // GIR_Coverage, 2729,
     /* 269200 */     GIR_Done,
     /* 269201 */   // Label 5467: @269201
     /* 269201 */   GIM_Reject,
     /* 269202 */ // Label 5464: @269202
     /* 269202 */ GIM_Reject,
     /* 269203 */ // Label 5452: @269203
     /* 269203 */ GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(269231), // Rule ID 8289 //
     /* 269208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 269217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 269220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269224 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 269224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269229 */   GIR_RootConstrainSelectedInstOperands,
     /* 269230 */   // GIR_Coverage, 8289,
     /* 269230 */   GIR_Done,
     /* 269231 */ // Label 5468: @269231
     /* 269231 */ GIM_Reject,
     /* 269232 */ // Label 5453: @269232
     /* 269232 */ GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(269260), // Rule ID 2725 //
     /* 269237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 269246 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 269249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269253 */   // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 269253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269258 */   GIR_RootConstrainSelectedInstOperands,
     /* 269259 */   // GIR_Coverage, 2725,
     /* 269259 */   GIR_Done,
     /* 269260 */ // Label 5469: @269260
     /* 269260 */ GIM_Reject,
     /* 269261 */ // Label 5454: @269261
     /* 269261 */ GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(269369),
     /* 269266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269272 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(269324), // Rule ID 7339 //
     /* 269277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269300 */     // MIs[0] Op2
     /* 269300 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269307 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 269307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 269310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269322 */     GIR_RootConstrainSelectedInstOperands,
     /* 269323 */     // GIR_Coverage, 7339,
     /* 269323 */     GIR_EraseRootFromParent_Done,
     /* 269324 */   // Label 5471: @269324
     /* 269324 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(269346), // Rule ID 2722 //
     /* 269329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269339 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 269339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269344 */     GIR_RootConstrainSelectedInstOperands,
     /* 269345 */     // GIR_Coverage, 2722,
     /* 269345 */     GIR_Done,
     /* 269346 */   // Label 5472: @269346
     /* 269346 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(269368), // Rule ID 2726 //
     /* 269351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269361 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 269361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269366 */     GIR_RootConstrainSelectedInstOperands,
     /* 269367 */     // GIR_Coverage, 2726,
     /* 269367 */     GIR_Done,
     /* 269368 */   // Label 5473: @269368
     /* 269368 */   GIM_Reject,
     /* 269369 */ // Label 5470: @269369
     /* 269369 */ GIM_Reject,
     /* 269370 */ // Label 5455: @269370
     /* 269370 */ GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(269398), // Rule ID 8288 //
     /* 269375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 269384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 269387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269391 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 269391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269396 */   GIR_RootConstrainSelectedInstOperands,
     /* 269397 */   // GIR_Coverage, 8288,
     /* 269397 */   GIR_Done,
     /* 269398 */ // Label 5474: @269398
     /* 269398 */ GIM_Reject,
     /* 269399 */ // Label 5456: @269399
     /* 269399 */ GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(269507),
     /* 269404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269410 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(269462), // Rule ID 7337 //
     /* 269415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 269434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269438 */     // MIs[0] Op2
     /* 269438 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269445 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 269445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 269448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269460 */     GIR_RootConstrainSelectedInstOperands,
     /* 269461 */     // GIR_Coverage, 7337,
     /* 269461 */     GIR_EraseRootFromParent_Done,
     /* 269462 */   // Label 5476: @269462
     /* 269462 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(269484), // Rule ID 2721 //
     /* 269467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269477 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 269477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 269482 */     GIR_RootConstrainSelectedInstOperands,
     /* 269483 */     // GIR_Coverage, 2721,
     /* 269483 */     GIR_Done,
     /* 269484 */   // Label 5477: @269484
     /* 269484 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(269506), // Rule ID 2724 //
     /* 269489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269499 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 269499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 269504 */     GIR_RootConstrainSelectedInstOperands,
     /* 269505 */     // GIR_Coverage, 2724,
     /* 269505 */     GIR_Done,
     /* 269506 */   // Label 5478: @269506
     /* 269506 */   GIM_Reject,
     /* 269507 */ // Label 5475: @269507
     /* 269507 */ GIM_Reject,
     /* 269508 */ // Label 5457: @269508
     /* 269508 */ GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(269536), // Rule ID 8287 //
     /* 269513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 269522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 269525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269529 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 269529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269534 */   GIR_RootConstrainSelectedInstOperands,
     /* 269535 */   // GIR_Coverage, 8287,
     /* 269535 */   GIR_Done,
     /* 269536 */ // Label 5479: @269536
     /* 269536 */ GIM_Reject,
     /* 269537 */ // Label 5458: @269537
     /* 269537 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(269623),
     /* 269542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269548 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(269600), // Rule ID 7335 //
     /* 269553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 269572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269576 */     // MIs[0] Op2
     /* 269576 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269583 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 269583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 269586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269598 */     GIR_RootConstrainSelectedInstOperands,
     /* 269599 */     // GIR_Coverage, 7335,
     /* 269599 */     GIR_EraseRootFromParent_Done,
     /* 269600 */   // Label 5481: @269600
     /* 269600 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(269622), // Rule ID 2720 //
     /* 269605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269615 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 269615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 269620 */     GIR_RootConstrainSelectedInstOperands,
     /* 269621 */     // GIR_Coverage, 2720,
     /* 269621 */     GIR_Done,
     /* 269622 */   // Label 5482: @269622
     /* 269622 */   GIM_Reject,
     /* 269623 */ // Label 5480: @269623
     /* 269623 */ GIM_Reject,
     /* 269624 */ // Label 5459: @269624
     /* 269624 */ GIM_Reject,
     /* 269625 */ // Label 48: @269625
     /* 269625 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5487*/ GIMT_Encode4(270108),
     /* 269636 */ /*GILLT_s64*//*Label 5483*/ GIMT_Encode4(269672), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 269656 */ /*GILLT_v4s32*//*Label 5484*/ GIMT_Encode4(269703), GIMT_Encode4(0),
     /* 269664 */ /*GILLT_v8s16*//*Label 5485*/ GIMT_Encode4(269838),
     /* 269668 */ /*GILLT_v16s8*//*Label 5486*/ GIMT_Encode4(269973),
     /* 269672 */ // Label 5483: @269672
     /* 269672 */ GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(269702), // Rule ID 128 //
     /* 269677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269695 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 269700 */   GIR_RootConstrainSelectedInstOperands,
     /* 269701 */   // GIR_Coverage, 128,
     /* 269701 */   GIR_Done,
     /* 269702 */ // Label 5488: @269702
     /* 269702 */ GIM_Reject,
     /* 269703 */ // Label 5484: @269703
     /* 269703 */ GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(269837), // Rule ID 6437 //
     /* 269708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 269711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269726 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 269726 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 269729 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 269733 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269738 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 269742 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 269746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269748 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 269751 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269755 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269760 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 269766 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269771 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269776 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 269779 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269783 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269788 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 269794 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269799 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 269807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 269811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269816 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 269819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 269822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 269827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 269835 */   GIR_RootConstrainSelectedInstOperands,
     /* 269836 */   // GIR_Coverage, 6437,
     /* 269836 */   GIR_EraseRootFromParent_Done,
     /* 269837 */ // Label 5489: @269837
     /* 269837 */ GIM_Reject,
     /* 269838 */ // Label 5485: @269838
     /* 269838 */ GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(269972), // Rule ID 6436 //
     /* 269843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 269846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269861 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 269861 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 269864 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 269868 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269873 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 269877 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 269881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269883 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 269886 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269890 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269895 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 269901 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269906 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269911 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 269914 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269918 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269923 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 269929 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269934 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 269942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 269946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269951 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 269954 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 269957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 269962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 269970 */   GIR_RootConstrainSelectedInstOperands,
     /* 269971 */   // GIR_Coverage, 6436,
     /* 269971 */   GIR_EraseRootFromParent_Done,
     /* 269972 */ // Label 5490: @269972
     /* 269972 */ GIM_Reject,
     /* 269973 */ // Label 5486: @269973
     /* 269973 */ GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(270107), // Rule ID 6435 //
     /* 269978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 269981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269996 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 269996 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 269999 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 270003 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270008 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270012 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270018 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270021 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270025 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270030 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270036 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270041 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270058 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270064 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270069 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 270081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270086 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 270097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270105 */   GIR_RootConstrainSelectedInstOperands,
     /* 270106 */   // GIR_Coverage, 6435,
     /* 270106 */   GIR_EraseRootFromParent_Done,
     /* 270107 */ // Label 5491: @270107
     /* 270107 */ GIM_Reject,
     /* 270108 */ // Label 5487: @270108
     /* 270108 */ GIM_Reject,
     /* 270109 */ // Label 49: @270109
     /* 270109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5496*/ GIMT_Encode4(270592),
     /* 270120 */ /*GILLT_s64*//*Label 5492*/ GIMT_Encode4(270156), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270140 */ /*GILLT_v4s32*//*Label 5493*/ GIMT_Encode4(270187), GIMT_Encode4(0),
     /* 270148 */ /*GILLT_v8s16*//*Label 5494*/ GIMT_Encode4(270322),
     /* 270152 */ /*GILLT_v16s8*//*Label 5495*/ GIMT_Encode4(270457),
     /* 270156 */ // Label 5492: @270156
     /* 270156 */ GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(270186), // Rule ID 127 //
     /* 270161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270179 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 270184 */   GIR_RootConstrainSelectedInstOperands,
     /* 270185 */   // GIR_Coverage, 127,
     /* 270185 */   GIR_Done,
     /* 270186 */ // Label 5497: @270186
     /* 270186 */ GIM_Reject,
     /* 270187 */ // Label 5493: @270187
     /* 270187 */ GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(270321), // Rule ID 6434 //
     /* 270192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270210 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 270210 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270213 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 270217 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270222 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270226 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270232 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270235 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270239 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270244 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270250 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270255 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270260 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270263 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270267 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270272 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270278 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270283 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 270295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270300 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270303 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 270311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270319 */   GIR_RootConstrainSelectedInstOperands,
     /* 270320 */   // GIR_Coverage, 6434,
     /* 270320 */   GIR_EraseRootFromParent_Done,
     /* 270321 */ // Label 5498: @270321
     /* 270321 */ GIM_Reject,
     /* 270322 */ // Label 5494: @270322
     /* 270322 */ GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(270456), // Rule ID 6433 //
     /* 270327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270345 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 270345 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270348 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 270352 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270357 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270361 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270367 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270370 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270374 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270379 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270385 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270390 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270395 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270398 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270402 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270407 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270413 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270418 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 270430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270435 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270438 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 270446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270454 */   GIR_RootConstrainSelectedInstOperands,
     /* 270455 */   // GIR_Coverage, 6433,
     /* 270455 */   GIR_EraseRootFromParent_Done,
     /* 270456 */ // Label 5499: @270456
     /* 270456 */ GIM_Reject,
     /* 270457 */ // Label 5495: @270457
     /* 270457 */ GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(270591), // Rule ID 6432 //
     /* 270462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 270465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270480 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 270480 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270483 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 270487 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270492 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270496 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270502 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270505 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270509 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270514 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270520 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270525 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270530 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270533 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270537 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270542 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270548 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270553 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 270565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270570 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270573 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 270581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270589 */   GIR_RootConstrainSelectedInstOperands,
     /* 270590 */   // GIR_Coverage, 6432,
     /* 270590 */   GIR_EraseRootFromParent_Done,
     /* 270591 */ // Label 5500: @270591
     /* 270591 */ GIM_Reject,
     /* 270592 */ // Label 5496: @270592
     /* 270592 */ GIM_Reject,
     /* 270593 */ // Label 50: @270593
     /* 270593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5512*/ GIMT_Encode4(271022),
     /* 270604 */ /*GILLT_v2s32*//*Label 5501*/ GIMT_Encode4(270680),
     /* 270608 */ /*GILLT_v2s64*//*Label 5502*/ GIMT_Encode4(270714),
     /* 270612 */ /*GILLT_v4s16*//*Label 5503*/ GIMT_Encode4(270748),
     /* 270616 */ /*GILLT_v4s32*//*Label 5504*/ GIMT_Encode4(270782),
     /* 270620 */ /*GILLT_v8s8*//*Label 5505*/ GIMT_Encode4(270816),
     /* 270624 */ /*GILLT_v8s16*//*Label 5506*/ GIMT_Encode4(270850),
     /* 270628 */ /*GILLT_v16s8*//*Label 5507*/ GIMT_Encode4(270884), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270648 */ /*GILLT_nxv2s64*//*Label 5508*/ GIMT_Encode4(270918), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270660 */ /*GILLT_nxv4s32*//*Label 5509*/ GIMT_Encode4(270944), GIMT_Encode4(0),
     /* 270668 */ /*GILLT_nxv8s16*//*Label 5510*/ GIMT_Encode4(270970), GIMT_Encode4(0),
     /* 270676 */ /*GILLT_nxv16s8*//*Label 5511*/ GIMT_Encode4(270996),
     /* 270680 */ // Label 5501: @270680
     /* 270680 */ GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(270713), // Rule ID 4960 //
     /* 270685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 270691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270706 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 270706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 270711 */   GIR_RootConstrainSelectedInstOperands,
     /* 270712 */   // GIR_Coverage, 4960,
     /* 270712 */   GIR_Done,
     /* 270713 */ // Label 5513: @270713
     /* 270713 */ GIM_Reject,
     /* 270714 */ // Label 5502: @270714
     /* 270714 */ GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(270747), // Rule ID 4964 //
     /* 270719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 270725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 270728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270740 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 270740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 270745 */   GIR_RootConstrainSelectedInstOperands,
     /* 270746 */   // GIR_Coverage, 4964,
     /* 270746 */   GIR_Done,
     /* 270747 */ // Label 5514: @270747
     /* 270747 */ GIM_Reject,
     /* 270748 */ // Label 5503: @270748
     /* 270748 */ GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(270781), // Rule ID 4959 //
     /* 270753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270774 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 270774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 270779 */   GIR_RootConstrainSelectedInstOperands,
     /* 270780 */   // GIR_Coverage, 4959,
     /* 270780 */   GIR_Done,
     /* 270781 */ // Label 5515: @270781
     /* 270781 */ GIM_Reject,
     /* 270782 */ // Label 5504: @270782
     /* 270782 */ GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(270815), // Rule ID 4963 //
     /* 270787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270808 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 270808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 270813 */   GIR_RootConstrainSelectedInstOperands,
     /* 270814 */   // GIR_Coverage, 4963,
     /* 270814 */   GIR_Done,
     /* 270815 */ // Label 5516: @270815
     /* 270815 */ GIM_Reject,
     /* 270816 */ // Label 5505: @270816
     /* 270816 */ GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(270849), // Rule ID 4958 //
     /* 270821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 270827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 270830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270842 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 270842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 270847 */   GIR_RootConstrainSelectedInstOperands,
     /* 270848 */   // GIR_Coverage, 4958,
     /* 270848 */   GIR_Done,
     /* 270849 */ // Label 5517: @270849
     /* 270849 */ GIM_Reject,
     /* 270850 */ // Label 5506: @270850
     /* 270850 */ GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(270883), // Rule ID 4962 //
     /* 270855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270876 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 270876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 270881 */   GIR_RootConstrainSelectedInstOperands,
     /* 270882 */   // GIR_Coverage, 4962,
     /* 270882 */   GIR_Done,
     /* 270883 */ // Label 5518: @270883
     /* 270883 */ GIM_Reject,
     /* 270884 */ // Label 5507: @270884
     /* 270884 */ GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(270917), // Rule ID 4961 //
     /* 270889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 270895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270910 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 270910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 270915 */   GIR_RootConstrainSelectedInstOperands,
     /* 270916 */   // GIR_Coverage, 4961,
     /* 270916 */   GIR_Done,
     /* 270917 */ // Label 5519: @270917
     /* 270917 */ GIM_Reject,
     /* 270918 */ // Label 5508: @270918
     /* 270918 */ GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(270943), // Rule ID 7293 //
     /* 270923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 270929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 270932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270936 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 270936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 270941 */   GIR_RootConstrainSelectedInstOperands,
     /* 270942 */   // GIR_Coverage, 7293,
     /* 270942 */   GIR_Done,
     /* 270943 */ // Label 5520: @270943
     /* 270943 */ GIM_Reject,
     /* 270944 */ // Label 5509: @270944
     /* 270944 */ GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(270969), // Rule ID 7292 //
     /* 270949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 270955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 270958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270962 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 270962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 270967 */   GIR_RootConstrainSelectedInstOperands,
     /* 270968 */   // GIR_Coverage, 7292,
     /* 270968 */   GIR_Done,
     /* 270969 */ // Label 5521: @270969
     /* 270969 */ GIM_Reject,
     /* 270970 */ // Label 5510: @270970
     /* 270970 */ GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(270995), // Rule ID 7291 //
     /* 270975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 270981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 270984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270988 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 270988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 270993 */   GIR_RootConstrainSelectedInstOperands,
     /* 270994 */   // GIR_Coverage, 7291,
     /* 270994 */   GIR_Done,
     /* 270995 */ // Label 5522: @270995
     /* 270995 */ GIM_Reject,
     /* 270996 */ // Label 5511: @270996
     /* 270996 */ GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(271021), // Rule ID 7290 //
     /* 271001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271014 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 271019 */   GIR_RootConstrainSelectedInstOperands,
     /* 271020 */   // GIR_Coverage, 7290,
     /* 271020 */   GIR_Done,
     /* 271021 */ // Label 5523: @271021
     /* 271021 */ GIM_Reject,
     /* 271022 */ // Label 5512: @271022
     /* 271022 */ GIM_Reject,
     /* 271023 */ // Label 51: @271023
     /* 271023 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5535*/ GIMT_Encode4(271452),
     /* 271034 */ /*GILLT_v2s32*//*Label 5524*/ GIMT_Encode4(271110),
     /* 271038 */ /*GILLT_v2s64*//*Label 5525*/ GIMT_Encode4(271144),
     /* 271042 */ /*GILLT_v4s16*//*Label 5526*/ GIMT_Encode4(271178),
     /* 271046 */ /*GILLT_v4s32*//*Label 5527*/ GIMT_Encode4(271212),
     /* 271050 */ /*GILLT_v8s8*//*Label 5528*/ GIMT_Encode4(271246),
     /* 271054 */ /*GILLT_v8s16*//*Label 5529*/ GIMT_Encode4(271280),
     /* 271058 */ /*GILLT_v16s8*//*Label 5530*/ GIMT_Encode4(271314), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271078 */ /*GILLT_nxv2s64*//*Label 5531*/ GIMT_Encode4(271348), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271090 */ /*GILLT_nxv4s32*//*Label 5532*/ GIMT_Encode4(271374), GIMT_Encode4(0),
     /* 271098 */ /*GILLT_nxv8s16*//*Label 5533*/ GIMT_Encode4(271400), GIMT_Encode4(0),
     /* 271106 */ /*GILLT_nxv16s8*//*Label 5534*/ GIMT_Encode4(271426),
     /* 271110 */ // Label 5524: @271110
     /* 271110 */ GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(271143), // Rule ID 2468 //
     /* 271115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271136 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 271141 */   GIR_RootConstrainSelectedInstOperands,
     /* 271142 */   // GIR_Coverage, 2468,
     /* 271142 */   GIR_Done,
     /* 271143 */ // Label 5536: @271143
     /* 271143 */ GIM_Reject,
     /* 271144 */ // Label 5525: @271144
     /* 271144 */ GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(271177), // Rule ID 2472 //
     /* 271149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271170 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 271170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 271175 */   GIR_RootConstrainSelectedInstOperands,
     /* 271176 */   // GIR_Coverage, 2472,
     /* 271176 */   GIR_Done,
     /* 271177 */ // Label 5537: @271177
     /* 271177 */ GIM_Reject,
     /* 271178 */ // Label 5526: @271178
     /* 271178 */ GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(271211), // Rule ID 2467 //
     /* 271183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 271189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271204 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 271204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 271209 */   GIR_RootConstrainSelectedInstOperands,
     /* 271210 */   // GIR_Coverage, 2467,
     /* 271210 */   GIR_Done,
     /* 271211 */ // Label 5538: @271211
     /* 271211 */ GIM_Reject,
     /* 271212 */ // Label 5527: @271212
     /* 271212 */ GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(271245), // Rule ID 2471 //
     /* 271217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 271223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271238 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 271238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 271243 */   GIR_RootConstrainSelectedInstOperands,
     /* 271244 */   // GIR_Coverage, 2471,
     /* 271244 */   GIR_Done,
     /* 271245 */ // Label 5539: @271245
     /* 271245 */ GIM_Reject,
     /* 271246 */ // Label 5528: @271246
     /* 271246 */ GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(271279), // Rule ID 2466 //
     /* 271251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271272 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 271272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 271277 */   GIR_RootConstrainSelectedInstOperands,
     /* 271278 */   // GIR_Coverage, 2466,
     /* 271278 */   GIR_Done,
     /* 271279 */ // Label 5540: @271279
     /* 271279 */ GIM_Reject,
     /* 271280 */ // Label 5529: @271280
     /* 271280 */ GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(271313), // Rule ID 2470 //
     /* 271285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 271291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271306 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 271306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 271311 */   GIR_RootConstrainSelectedInstOperands,
     /* 271312 */   // GIR_Coverage, 2470,
     /* 271312 */   GIR_Done,
     /* 271313 */ // Label 5541: @271313
     /* 271313 */ GIM_Reject,
     /* 271314 */ // Label 5530: @271314
     /* 271314 */ GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(271347), // Rule ID 2469 //
     /* 271319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 271325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 271328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271340 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 271340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 271345 */   GIR_RootConstrainSelectedInstOperands,
     /* 271346 */   // GIR_Coverage, 2469,
     /* 271346 */   GIR_Done,
     /* 271347 */ // Label 5542: @271347
     /* 271347 */ GIM_Reject,
     /* 271348 */ // Label 5531: @271348
     /* 271348 */ GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(271373), // Rule ID 7289 //
     /* 271353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271366 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 271366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 271371 */   GIR_RootConstrainSelectedInstOperands,
     /* 271372 */   // GIR_Coverage, 7289,
     /* 271372 */   GIR_Done,
     /* 271373 */ // Label 5543: @271373
     /* 271373 */ GIM_Reject,
     /* 271374 */ // Label 5532: @271374
     /* 271374 */ GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(271399), // Rule ID 7288 //
     /* 271379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271392 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 271392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 271397 */   GIR_RootConstrainSelectedInstOperands,
     /* 271398 */   // GIR_Coverage, 7288,
     /* 271398 */   GIR_Done,
     /* 271399 */ // Label 5544: @271399
     /* 271399 */ GIM_Reject,
     /* 271400 */ // Label 5533: @271400
     /* 271400 */ GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(271425), // Rule ID 7287 //
     /* 271405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 271411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271418 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 271423 */   GIR_RootConstrainSelectedInstOperands,
     /* 271424 */   // GIR_Coverage, 7287,
     /* 271424 */   GIR_Done,
     /* 271425 */ // Label 5545: @271425
     /* 271425 */ GIM_Reject,
     /* 271426 */ // Label 5534: @271426
     /* 271426 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(271451), // Rule ID 7286 //
     /* 271431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271444 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 271449 */   GIR_RootConstrainSelectedInstOperands,
     /* 271450 */   // GIR_Coverage, 7286,
     /* 271450 */   GIR_Done,
     /* 271451 */ // Label 5546: @271451
     /* 271451 */ GIM_Reject,
     /* 271452 */ // Label 5535: @271452
     /* 271452 */ GIM_Reject,
     /* 271453 */ // Label 52: @271453
     /* 271453 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5558*/ GIMT_Encode4(271882),
     /* 271464 */ /*GILLT_v2s32*//*Label 5547*/ GIMT_Encode4(271540),
     /* 271468 */ /*GILLT_v2s64*//*Label 5548*/ GIMT_Encode4(271574),
     /* 271472 */ /*GILLT_v4s16*//*Label 5549*/ GIMT_Encode4(271608),
     /* 271476 */ /*GILLT_v4s32*//*Label 5550*/ GIMT_Encode4(271642),
     /* 271480 */ /*GILLT_v8s8*//*Label 5551*/ GIMT_Encode4(271676),
     /* 271484 */ /*GILLT_v8s16*//*Label 5552*/ GIMT_Encode4(271710),
     /* 271488 */ /*GILLT_v16s8*//*Label 5553*/ GIMT_Encode4(271744), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271508 */ /*GILLT_nxv2s64*//*Label 5554*/ GIMT_Encode4(271778), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271520 */ /*GILLT_nxv4s32*//*Label 5555*/ GIMT_Encode4(271804), GIMT_Encode4(0),
     /* 271528 */ /*GILLT_nxv8s16*//*Label 5556*/ GIMT_Encode4(271830), GIMT_Encode4(0),
     /* 271536 */ /*GILLT_nxv16s8*//*Label 5557*/ GIMT_Encode4(271856),
     /* 271540 */ // Label 5547: @271540
     /* 271540 */ GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(271573), // Rule ID 4974 //
     /* 271545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271566 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 271571 */   GIR_RootConstrainSelectedInstOperands,
     /* 271572 */   // GIR_Coverage, 4974,
     /* 271572 */   GIR_Done,
     /* 271573 */ // Label 5559: @271573
     /* 271573 */ GIM_Reject,
     /* 271574 */ // Label 5548: @271574
     /* 271574 */ GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(271607), // Rule ID 4978 //
     /* 271579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271600 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 271600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 271605 */   GIR_RootConstrainSelectedInstOperands,
     /* 271606 */   // GIR_Coverage, 4978,
     /* 271606 */   GIR_Done,
     /* 271607 */ // Label 5560: @271607
     /* 271607 */ GIM_Reject,
     /* 271608 */ // Label 5549: @271608
     /* 271608 */ GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(271641), // Rule ID 4973 //
     /* 271613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 271619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271634 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 271634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 271639 */   GIR_RootConstrainSelectedInstOperands,
     /* 271640 */   // GIR_Coverage, 4973,
     /* 271640 */   GIR_Done,
     /* 271641 */ // Label 5561: @271641
     /* 271641 */ GIM_Reject,
     /* 271642 */ // Label 5550: @271642
     /* 271642 */ GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(271675), // Rule ID 4977 //
     /* 271647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 271653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271668 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 271668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 271673 */   GIR_RootConstrainSelectedInstOperands,
     /* 271674 */   // GIR_Coverage, 4977,
     /* 271674 */   GIR_Done,
     /* 271675 */ // Label 5562: @271675
     /* 271675 */ GIM_Reject,
     /* 271676 */ // Label 5551: @271676
     /* 271676 */ GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(271709), // Rule ID 4972 //
     /* 271681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271702 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 271702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 271707 */   GIR_RootConstrainSelectedInstOperands,
     /* 271708 */   // GIR_Coverage, 4972,
     /* 271708 */   GIR_Done,
     /* 271709 */ // Label 5563: @271709
     /* 271709 */ GIM_Reject,
     /* 271710 */ // Label 5552: @271710
     /* 271710 */ GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(271743), // Rule ID 4976 //
     /* 271715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 271721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271736 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 271736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 271741 */   GIR_RootConstrainSelectedInstOperands,
     /* 271742 */   // GIR_Coverage, 4976,
     /* 271742 */   GIR_Done,
     /* 271743 */ // Label 5564: @271743
     /* 271743 */ GIM_Reject,
     /* 271744 */ // Label 5553: @271744
     /* 271744 */ GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(271777), // Rule ID 4975 //
     /* 271749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 271755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 271758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271770 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 271770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 271775 */   GIR_RootConstrainSelectedInstOperands,
     /* 271776 */   // GIR_Coverage, 4975,
     /* 271776 */   GIR_Done,
     /* 271777 */ // Label 5565: @271777
     /* 271777 */ GIM_Reject,
     /* 271778 */ // Label 5554: @271778
     /* 271778 */ GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(271803), // Rule ID 7301 //
     /* 271783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271796 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 271796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 271801 */   GIR_RootConstrainSelectedInstOperands,
     /* 271802 */   // GIR_Coverage, 7301,
     /* 271802 */   GIR_Done,
     /* 271803 */ // Label 5566: @271803
     /* 271803 */ GIM_Reject,
     /* 271804 */ // Label 5555: @271804
     /* 271804 */ GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(271829), // Rule ID 7300 //
     /* 271809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271822 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 271822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 271827 */   GIR_RootConstrainSelectedInstOperands,
     /* 271828 */   // GIR_Coverage, 7300,
     /* 271828 */   GIR_Done,
     /* 271829 */ // Label 5567: @271829
     /* 271829 */ GIM_Reject,
     /* 271830 */ // Label 5556: @271830
     /* 271830 */ GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(271855), // Rule ID 7299 //
     /* 271835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 271841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271848 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 271853 */   GIR_RootConstrainSelectedInstOperands,
     /* 271854 */   // GIR_Coverage, 7299,
     /* 271854 */   GIR_Done,
     /* 271855 */ // Label 5568: @271855
     /* 271855 */ GIM_Reject,
     /* 271856 */ // Label 5557: @271856
     /* 271856 */ GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(271881), // Rule ID 7298 //
     /* 271861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271874 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 271879 */   GIR_RootConstrainSelectedInstOperands,
     /* 271880 */   // GIR_Coverage, 7298,
     /* 271880 */   GIR_Done,
     /* 271881 */ // Label 5569: @271881
     /* 271881 */ GIM_Reject,
     /* 271882 */ // Label 5558: @271882
     /* 271882 */ GIM_Reject,
     /* 271883 */ // Label 53: @271883
     /* 271883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5581*/ GIMT_Encode4(272312),
     /* 271894 */ /*GILLT_v2s32*//*Label 5570*/ GIMT_Encode4(271970),
     /* 271898 */ /*GILLT_v2s64*//*Label 5571*/ GIMT_Encode4(272004),
     /* 271902 */ /*GILLT_v4s16*//*Label 5572*/ GIMT_Encode4(272038),
     /* 271906 */ /*GILLT_v4s32*//*Label 5573*/ GIMT_Encode4(272072),
     /* 271910 */ /*GILLT_v8s8*//*Label 5574*/ GIMT_Encode4(272106),
     /* 271914 */ /*GILLT_v8s16*//*Label 5575*/ GIMT_Encode4(272140),
     /* 271918 */ /*GILLT_v16s8*//*Label 5576*/ GIMT_Encode4(272174), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271938 */ /*GILLT_nxv2s64*//*Label 5577*/ GIMT_Encode4(272208), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271950 */ /*GILLT_nxv4s32*//*Label 5578*/ GIMT_Encode4(272234), GIMT_Encode4(0),
     /* 271958 */ /*GILLT_nxv8s16*//*Label 5579*/ GIMT_Encode4(272260), GIMT_Encode4(0),
     /* 271966 */ /*GILLT_nxv16s8*//*Label 5580*/ GIMT_Encode4(272286),
     /* 271970 */ // Label 5570: @271970
     /* 271970 */ GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(272003), // Rule ID 4967 //
     /* 271975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271996 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 272001 */   GIR_RootConstrainSelectedInstOperands,
     /* 272002 */   // GIR_Coverage, 4967,
     /* 272002 */   GIR_Done,
     /* 272003 */ // Label 5582: @272003
     /* 272003 */ GIM_Reject,
     /* 272004 */ // Label 5571: @272004
     /* 272004 */ GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(272037), // Rule ID 4971 //
     /* 272009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 272015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 272018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272030 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 272030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 272035 */   GIR_RootConstrainSelectedInstOperands,
     /* 272036 */   // GIR_Coverage, 4971,
     /* 272036 */   GIR_Done,
     /* 272037 */ // Label 5583: @272037
     /* 272037 */ GIM_Reject,
     /* 272038 */ // Label 5572: @272038
     /* 272038 */ GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(272071), // Rule ID 4966 //
     /* 272043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272064 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 272064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 272069 */   GIR_RootConstrainSelectedInstOperands,
     /* 272070 */   // GIR_Coverage, 4966,
     /* 272070 */   GIR_Done,
     /* 272071 */ // Label 5584: @272071
     /* 272071 */ GIM_Reject,
     /* 272072 */ // Label 5573: @272072
     /* 272072 */ GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(272105), // Rule ID 4970 //
     /* 272077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272098 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 272098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 272103 */   GIR_RootConstrainSelectedInstOperands,
     /* 272104 */   // GIR_Coverage, 4970,
     /* 272104 */   GIR_Done,
     /* 272105 */ // Label 5585: @272105
     /* 272105 */ GIM_Reject,
     /* 272106 */ // Label 5574: @272106
     /* 272106 */ GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(272139), // Rule ID 4965 //
     /* 272111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 272120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272132 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 272132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 272137 */   GIR_RootConstrainSelectedInstOperands,
     /* 272138 */   // GIR_Coverage, 4965,
     /* 272138 */   GIR_Done,
     /* 272139 */ // Label 5586: @272139
     /* 272139 */ GIM_Reject,
     /* 272140 */ // Label 5575: @272140
     /* 272140 */ GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(272173), // Rule ID 4969 //
     /* 272145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272166 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 272166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 272171 */   GIR_RootConstrainSelectedInstOperands,
     /* 272172 */   // GIR_Coverage, 4969,
     /* 272172 */   GIR_Done,
     /* 272173 */ // Label 5587: @272173
     /* 272173 */ GIM_Reject,
     /* 272174 */ // Label 5576: @272174
     /* 272174 */ GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(272207), // Rule ID 4968 //
     /* 272179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 272185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272200 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 272200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 272205 */   GIR_RootConstrainSelectedInstOperands,
     /* 272206 */   // GIR_Coverage, 4968,
     /* 272206 */   GIR_Done,
     /* 272207 */ // Label 5588: @272207
     /* 272207 */ GIM_Reject,
     /* 272208 */ // Label 5577: @272208
     /* 272208 */ GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(272233), // Rule ID 7297 //
     /* 272213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 272219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272226 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 272226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 272231 */   GIR_RootConstrainSelectedInstOperands,
     /* 272232 */   // GIR_Coverage, 7297,
     /* 272232 */   GIR_Done,
     /* 272233 */ // Label 5589: @272233
     /* 272233 */ GIM_Reject,
     /* 272234 */ // Label 5578: @272234
     /* 272234 */ GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(272259), // Rule ID 7296 //
     /* 272239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 272245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272252 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 272252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 272257 */   GIR_RootConstrainSelectedInstOperands,
     /* 272258 */   // GIR_Coverage, 7296,
     /* 272258 */   GIR_Done,
     /* 272259 */ // Label 5590: @272259
     /* 272259 */ GIM_Reject,
     /* 272260 */ // Label 5579: @272260
     /* 272260 */ GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(272285), // Rule ID 7295 //
     /* 272265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 272271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272278 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 272278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 272283 */   GIR_RootConstrainSelectedInstOperands,
     /* 272284 */   // GIR_Coverage, 7295,
     /* 272284 */   GIR_Done,
     /* 272285 */ // Label 5591: @272285
     /* 272285 */ GIM_Reject,
     /* 272286 */ // Label 5580: @272286
     /* 272286 */ GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(272311), // Rule ID 7294 //
     /* 272291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 272297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 272300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272304 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 272304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 272309 */   GIR_RootConstrainSelectedInstOperands,
     /* 272310 */   // GIR_Coverage, 7294,
     /* 272310 */   GIR_Done,
     /* 272311 */ // Label 5592: @272311
     /* 272311 */ GIM_Reject,
     /* 272312 */ // Label 5581: @272312
     /* 272312 */ GIM_Reject,
     /* 272313 */ // Label 54: @272313
     /* 272313 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5604*/ GIMT_Encode4(274110),
     /* 272324 */ /*GILLT_s16*//*Label 5593*/ GIMT_Encode4(272408),
     /* 272328 */ /*GILLT_s32*//*Label 5594*/ GIMT_Encode4(272634),
     /* 272332 */ /*GILLT_s64*//*Label 5595*/ GIMT_Encode4(272988), GIMT_Encode4(0),
     /* 272340 */ /*GILLT_v2s32*//*Label 5596*/ GIMT_Encode4(273160),
     /* 272344 */ /*GILLT_v2s64*//*Label 5597*/ GIMT_Encode4(273198),
     /* 272348 */ /*GILLT_v4s16*//*Label 5598*/ GIMT_Encode4(273374),
     /* 272352 */ /*GILLT_v4s32*//*Label 5599*/ GIMT_Encode4(273412), GIMT_Encode4(0),
     /* 272360 */ /*GILLT_v8s16*//*Label 5600*/ GIMT_Encode4(273588), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272384 */ /*GILLT_nxv2s64*//*Label 5601*/ GIMT_Encode4(274032), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272396 */ /*GILLT_nxv4s32*//*Label 5602*/ GIMT_Encode4(274058), GIMT_Encode4(0),
     /* 272404 */ /*GILLT_nxv8s16*//*Label 5603*/ GIMT_Encode4(274084),
     /* 272408 */ // Label 5593: @272408
     /* 272408 */ GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(272633),
     /* 272413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 272416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 272419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272423 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(272514), // Rule ID 6825 //
     /* 272428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272465 */     // MIs[2] Rn
     /* 272465 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272470 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272476 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 272476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272488 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 272507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272512 */     GIR_RootConstrainSelectedInstOperands,
     /* 272513 */     // GIR_Coverage, 6825,
     /* 272513 */     GIR_EraseRootFromParent_Done,
     /* 272514 */   // Label 5606: @272514
     /* 272514 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(272605), // Rule ID 13650 //
     /* 272519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272540 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272556 */     // MIs[2] Rn
     /* 272556 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272561 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 272565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272567 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 272567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 272598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272603 */     GIR_RootConstrainSelectedInstOperands,
     /* 272604 */     // GIR_Coverage, 13650,
     /* 272604 */     GIR_EraseRootFromParent_Done,
     /* 272605 */   // Label 5607: @272605
     /* 272605 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(272632), // Rule ID 584 //
     /* 272610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 272613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272621 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 272621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 272626 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 272630 */     GIR_RootConstrainSelectedInstOperands,
     /* 272631 */     // GIR_Coverage, 584,
     /* 272631 */     GIR_Done,
     /* 272632 */   // Label 5608: @272632
     /* 272632 */   GIM_Reject,
     /* 272633 */ // Label 5605: @272633
     /* 272633 */ GIM_Reject,
     /* 272634 */ // Label 5594: @272634
     /* 272634 */ GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(272987),
     /* 272639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 272645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 272649 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(272740), // Rule ID 6823 //
     /* 272654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272691 */     // MIs[2] Rn
     /* 272691 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272696 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272702 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 272702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272714 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272738 */     GIR_RootConstrainSelectedInstOperands,
     /* 272739 */     // GIR_Coverage, 6823,
     /* 272739 */     GIR_EraseRootFromParent_Done,
     /* 272740 */   // Label 5610: @272740
     /* 272740 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(272804), // Rule ID 12821 //
     /* 272745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272766 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272782 */     // MIs[2] Rn
     /* 272782 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272787 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272793 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 272793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272802 */     GIR_RootConstrainSelectedInstOperands,
     /* 272803 */     // GIR_Coverage, 12821,
     /* 272803 */     GIR_EraseRootFromParent_Done,
     /* 272804 */   // Label 5611: @272804
     /* 272804 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(272895), // Rule ID 13648 //
     /* 272809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272846 */     // MIs[2] Rn
     /* 272846 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272851 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 272855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272857 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 272857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272869 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272893 */     GIR_RootConstrainSelectedInstOperands,
     /* 272894 */     // GIR_Coverage, 13648,
     /* 272894 */     GIR_EraseRootFromParent_Done,
     /* 272895 */   // Label 5612: @272895
     /* 272895 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(272959), // Rule ID 15323 //
     /* 272900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272921 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272937 */     // MIs[2] Rn
     /* 272937 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272942 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 272946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272948 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 272948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272957 */     GIR_RootConstrainSelectedInstOperands,
     /* 272958 */     // GIR_Coverage, 15323,
     /* 272958 */     GIR_EraseRootFromParent_Done,
     /* 272959 */   // Label 5613: @272959
     /* 272959 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(272986), // Rule ID 586 //
     /* 272964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 272967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 272971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 272975 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 272975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 272980 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 272984 */     GIR_RootConstrainSelectedInstOperands,
     /* 272985 */     // GIR_Coverage, 586,
     /* 272985 */     GIR_Done,
     /* 272986 */   // Label 5614: @272986
     /* 272986 */   GIM_Reject,
     /* 272987 */ // Label 5609: @272987
     /* 272987 */ GIM_Reject,
     /* 272988 */ // Label 5595: @272988
     /* 272988 */ GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(273159),
     /* 272993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 272996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273003 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(273067), // Rule ID 6821 //
     /* 273008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 273033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273045 */     // MIs[2] Rn
     /* 273045 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273050 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 273054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273056 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 273056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 273059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273065 */     GIR_RootConstrainSelectedInstOperands,
     /* 273066 */     // GIR_Coverage, 6821,
     /* 273066 */     GIR_EraseRootFromParent_Done,
     /* 273067 */   // Label 5616: @273067
     /* 273067 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(273131), // Rule ID 13646 //
     /* 273072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 273097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273109 */     // MIs[2] Rn
     /* 273109 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 273118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273120 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 273120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 273123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273129 */     GIR_RootConstrainSelectedInstOperands,
     /* 273130 */     // GIR_Coverage, 13646,
     /* 273130 */     GIR_EraseRootFromParent_Done,
     /* 273131 */   // Label 5617: @273131
     /* 273131 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(273158), // Rule ID 588 //
     /* 273136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 273139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273147 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 273147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 273152 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273156 */     GIR_RootConstrainSelectedInstOperands,
     /* 273157 */     // GIR_Coverage, 588,
     /* 273157 */     GIR_Done,
     /* 273158 */   // Label 5618: @273158
     /* 273158 */   GIM_Reject,
     /* 273159 */ // Label 5615: @273159
     /* 273159 */ GIM_Reject,
     /* 273160 */ // Label 5596: @273160
     /* 273160 */ GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(273197), // Rule ID 1196 //
     /* 273165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 273171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273186 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 273186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 273191 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273195 */   GIR_RootConstrainSelectedInstOperands,
     /* 273196 */   // GIR_Coverage, 1196,
     /* 273196 */   GIR_Done,
     /* 273197 */ // Label 5619: @273197
     /* 273197 */ GIM_Reject,
     /* 273198 */ // Label 5597: @273198
     /* 273198 */ GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(273373),
     /* 273203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273213 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(273279), // Rule ID 6843 //
     /* 273218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 273226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 273252 */     // MIs[2] Rn
     /* 273252 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273257 */     // MIs[2] Rm
     /* 273257 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273264 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 273264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 273267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273277 */     GIR_RootConstrainSelectedInstOperands,
     /* 273278 */     // GIR_Coverage, 6843,
     /* 273278 */     GIR_EraseRootFromParent_Done,
     /* 273279 */   // Label 5621: @273279
     /* 273279 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(273345), // Rule ID 13658 //
     /* 273284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 273292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 273318 */     // MIs[2] Rn
     /* 273318 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273323 */     // MIs[2] Rm
     /* 273323 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273330 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 273330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 273333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273343 */     GIR_RootConstrainSelectedInstOperands,
     /* 273344 */     // GIR_Coverage, 13658,
     /* 273344 */     GIR_EraseRootFromParent_Done,
     /* 273345 */   // Label 5622: @273345
     /* 273345 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(273372), // Rule ID 1200 //
     /* 273350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273361 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 273361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 273366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273370 */     GIR_RootConstrainSelectedInstOperands,
     /* 273371 */     // GIR_Coverage, 1200,
     /* 273371 */     GIR_Done,
     /* 273372 */   // Label 5623: @273372
     /* 273372 */   GIM_Reject,
     /* 273373 */ // Label 5620: @273373
     /* 273373 */ GIM_Reject,
     /* 273374 */ // Label 5598: @273374
     /* 273374 */ GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(273411), // Rule ID 1192 //
     /* 273379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 273382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 273385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273400 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 273400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 273405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273409 */   GIR_RootConstrainSelectedInstOperands,
     /* 273410 */   // GIR_Coverage, 1192,
     /* 273410 */   GIR_Done,
     /* 273411 */ // Label 5624: @273411
     /* 273411 */ GIM_Reject,
     /* 273412 */ // Label 5599: @273412
     /* 273412 */ GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(273587),
     /* 273417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273427 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(273493), // Rule ID 6844 //
     /* 273432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 273440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 273466 */     // MIs[2] Rn
     /* 273466 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273471 */     // MIs[2] Rm
     /* 273471 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273478 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 273478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 273481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273491 */     GIR_RootConstrainSelectedInstOperands,
     /* 273492 */     // GIR_Coverage, 6844,
     /* 273492 */     GIR_EraseRootFromParent_Done,
     /* 273493 */   // Label 5626: @273493
     /* 273493 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(273559), // Rule ID 13659 //
     /* 273498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 273506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 273532 */     // MIs[2] Rn
     /* 273532 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273537 */     // MIs[2] Rm
     /* 273537 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273544 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 273544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 273547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273557 */     GIR_RootConstrainSelectedInstOperands,
     /* 273558 */     // GIR_Coverage, 13659,
     /* 273558 */     GIR_EraseRootFromParent_Done,
     /* 273559 */   // Label 5627: @273559
     /* 273559 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(273586), // Rule ID 1198 //
     /* 273564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273575 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 273580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273584 */     GIR_RootConstrainSelectedInstOperands,
     /* 273585 */     // GIR_Coverage, 1198,
     /* 273585 */     GIR_Done,
     /* 273586 */   // Label 5628: @273586
     /* 273586 */   GIM_Reject,
     /* 273587 */ // Label 5625: @273587
     /* 273587 */ GIM_Reject,
     /* 273588 */ // Label 5600: @273588
     /* 273588 */ GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(274031),
     /* 273593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273603 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(273672), // Rule ID 6845 //
     /* 273608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 273611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 273619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 273645 */     // MIs[2] Rn
     /* 273645 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273650 */     // MIs[2] Rm
     /* 273650 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273657 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 273657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 273660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273670 */     GIR_RootConstrainSelectedInstOperands,
     /* 273671 */     // GIR_Coverage, 6845,
     /* 273671 */     GIR_EraseRootFromParent_Done,
     /* 273672 */   // Label 5630: @273672
     /* 273672 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(273741), // Rule ID 13660 //
     /* 273677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 273680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 273688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 273714 */     // MIs[2] Rn
     /* 273714 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273719 */     // MIs[2] Rm
     /* 273719 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273726 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 273726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 273729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273739 */     GIR_RootConstrainSelectedInstOperands,
     /* 273740 */     // GIR_Coverage, 13660,
     /* 273740 */     GIR_EraseRootFromParent_Done,
     /* 273741 */   // Label 5631: @273741
     /* 273741 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(273768), // Rule ID 1194 //
     /* 273746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 273749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273757 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 273757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 273762 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273766 */     GIR_RootConstrainSelectedInstOperands,
     /* 273767 */     // GIR_Coverage, 1194,
     /* 273767 */     GIR_Done,
     /* 273768 */   // Label 5632: @273768
     /* 273768 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(274030), // Rule ID 6914 //
     /* 273773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 273776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273784 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 273784 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 273787 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 273791 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273796 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 273800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 273802 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 273805 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 273809 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273814 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 273818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 273820 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 273823 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 273827 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273832 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 273835 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 273838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 273840 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 273843 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273847 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273852 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 273858 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273863 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273868 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 273871 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 273875 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273880 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 273883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 273885 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 273888 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273892 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273897 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273903 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273908 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273913 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 273916 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 273920 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273925 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 273928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 273930 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 273933 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 273937 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273942 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 273945 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 273948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 273950 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 273953 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 273957 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273962 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 273965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 273967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 273970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 273974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 273981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 273984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 273988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273993 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 273996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 273999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 274002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 274020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 274028 */     GIR_RootConstrainSelectedInstOperands,
     /* 274029 */     // GIR_Coverage, 6914,
     /* 274029 */     GIR_EraseRootFromParent_Done,
     /* 274030 */   // Label 5633: @274030
     /* 274030 */   GIM_Reject,
     /* 274031 */ // Label 5629: @274031
     /* 274031 */ GIM_Reject,
     /* 274032 */ // Label 5601: @274032
     /* 274032 */ GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(274057), // Rule ID 2810 //
     /* 274037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274050 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 274050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 274055 */   GIR_RootConstrainSelectedInstOperands,
     /* 274056 */   // GIR_Coverage, 2810,
     /* 274056 */   GIR_Done,
     /* 274057 */ // Label 5634: @274057
     /* 274057 */ GIM_Reject,
     /* 274058 */ // Label 5602: @274058
     /* 274058 */ GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(274083), // Rule ID 2808 //
     /* 274063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274076 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 274076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 274081 */   GIR_RootConstrainSelectedInstOperands,
     /* 274082 */   // GIR_Coverage, 2808,
     /* 274082 */   GIR_Done,
     /* 274083 */ // Label 5635: @274083
     /* 274083 */ GIM_Reject,
     /* 274084 */ // Label 5603: @274084
     /* 274084 */ GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(274109), // Rule ID 2806 //
     /* 274089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274102 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 274102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 274107 */   GIR_RootConstrainSelectedInstOperands,
     /* 274108 */   // GIR_Coverage, 2806,
     /* 274108 */   GIR_Done,
     /* 274109 */ // Label 5636: @274109
     /* 274109 */ GIM_Reject,
     /* 274110 */ // Label 5604: @274110
     /* 274110 */ GIM_Reject,
     /* 274111 */ // Label 55: @274111
     /* 274111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5648*/ GIMT_Encode4(274848),
     /* 274122 */ /*GILLT_s16*//*Label 5637*/ GIMT_Encode4(274206),
     /* 274126 */ /*GILLT_s32*//*Label 5638*/ GIMT_Encode4(274244),
     /* 274130 */ /*GILLT_s64*//*Label 5639*/ GIMT_Encode4(274282), GIMT_Encode4(0),
     /* 274138 */ /*GILLT_v2s32*//*Label 5640*/ GIMT_Encode4(274320),
     /* 274142 */ /*GILLT_v2s64*//*Label 5641*/ GIMT_Encode4(274358),
     /* 274146 */ /*GILLT_v4s16*//*Label 5642*/ GIMT_Encode4(274396),
     /* 274150 */ /*GILLT_v4s32*//*Label 5643*/ GIMT_Encode4(274434), GIMT_Encode4(0),
     /* 274158 */ /*GILLT_v8s16*//*Label 5644*/ GIMT_Encode4(274472), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274182 */ /*GILLT_nxv2s64*//*Label 5645*/ GIMT_Encode4(274770), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274194 */ /*GILLT_nxv4s32*//*Label 5646*/ GIMT_Encode4(274796), GIMT_Encode4(0),
     /* 274202 */ /*GILLT_nxv8s16*//*Label 5647*/ GIMT_Encode4(274822),
     /* 274206 */ // Label 5637: @274206
     /* 274206 */ GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(274243), // Rule ID 632 //
     /* 274211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 274214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 274220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274232 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 274232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 274237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274241 */   GIR_RootConstrainSelectedInstOperands,
     /* 274242 */   // GIR_Coverage, 632,
     /* 274242 */   GIR_Done,
     /* 274243 */ // Label 5649: @274243
     /* 274243 */ GIM_Reject,
     /* 274244 */ // Label 5638: @274244
     /* 274244 */ GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(274281), // Rule ID 634 //
     /* 274249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 274252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 274255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 274258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274270 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 274270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 274275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274279 */   GIR_RootConstrainSelectedInstOperands,
     /* 274280 */   // GIR_Coverage, 634,
     /* 274280 */   GIR_Done,
     /* 274281 */ // Label 5650: @274281
     /* 274281 */ GIM_Reject,
     /* 274282 */ // Label 5639: @274282
     /* 274282 */ GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(274319), // Rule ID 636 //
     /* 274287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 274290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 274293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274308 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 274308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 274313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274317 */   GIR_RootConstrainSelectedInstOperands,
     /* 274318 */   // GIR_Coverage, 636,
     /* 274318 */   GIR_Done,
     /* 274319 */ // Label 5651: @274319
     /* 274319 */ GIM_Reject,
     /* 274320 */ // Label 5640: @274320
     /* 274320 */ GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(274357), // Rule ID 1336 //
     /* 274325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 274331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274346 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 274346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 274351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274355 */   GIR_RootConstrainSelectedInstOperands,
     /* 274356 */   // GIR_Coverage, 1336,
     /* 274356 */   GIR_Done,
     /* 274357 */ // Label 5652: @274357
     /* 274357 */ GIM_Reject,
     /* 274358 */ // Label 5641: @274358
     /* 274358 */ GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(274395), // Rule ID 1340 //
     /* 274363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 274369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274384 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 274384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 274389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274393 */   GIR_RootConstrainSelectedInstOperands,
     /* 274394 */   // GIR_Coverage, 1340,
     /* 274394 */   GIR_Done,
     /* 274395 */ // Label 5653: @274395
     /* 274395 */ GIM_Reject,
     /* 274396 */ // Label 5642: @274396
     /* 274396 */ GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(274433), // Rule ID 1332 //
     /* 274401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 274407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274422 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 274422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 274427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274431 */   GIR_RootConstrainSelectedInstOperands,
     /* 274432 */   // GIR_Coverage, 1332,
     /* 274432 */   GIR_Done,
     /* 274433 */ // Label 5654: @274433
     /* 274433 */ GIM_Reject,
     /* 274434 */ // Label 5643: @274434
     /* 274434 */ GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(274471), // Rule ID 1338 //
     /* 274439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 274445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274460 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 274460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274469 */   GIR_RootConstrainSelectedInstOperands,
     /* 274470 */   // GIR_Coverage, 1338,
     /* 274470 */   GIR_Done,
     /* 274471 */ // Label 5655: @274471
     /* 274471 */ GIM_Reject,
     /* 274472 */ // Label 5644: @274472
     /* 274472 */ GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(274769),
     /* 274477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274495 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(274514), // Rule ID 1334 //
     /* 274500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274503 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 274503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 274508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274512 */     GIR_RootConstrainSelectedInstOperands,
     /* 274513 */     // GIR_Coverage, 1334,
     /* 274513 */     GIR_Done,
     /* 274514 */   // Label 5657: @274514
     /* 274514 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(274768), // Rule ID 6920 //
     /* 274519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 274522 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 274522 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 274525 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274529 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274534 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 274538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 274540 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 274543 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274547 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274552 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 274556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 274558 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 274561 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274565 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274570 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 274573 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 274576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 274578 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 274581 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274585 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274590 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 274596 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274601 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274606 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 274609 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 274613 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274618 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 274621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 274623 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 274626 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274630 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274635 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 274641 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274646 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274651 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 274654 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 274658 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274663 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 274666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 274668 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 274671 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274675 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274680 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 274683 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 274686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 274688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 274691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 274695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274700 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 274703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 274705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 274708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 274712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 274719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 274722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 274726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 274734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 274737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 274740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 274758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 274766 */     GIR_RootConstrainSelectedInstOperands,
     /* 274767 */     // GIR_Coverage, 6920,
     /* 274767 */     GIR_EraseRootFromParent_Done,
     /* 274768 */   // Label 5658: @274768
     /* 274768 */   GIM_Reject,
     /* 274769 */ // Label 5656: @274769
     /* 274769 */ GIM_Reject,
     /* 274770 */ // Label 5645: @274770
     /* 274770 */ GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(274795), // Rule ID 8040 //
     /* 274775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274788 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 274788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 274793 */   GIR_RootConstrainSelectedInstOperands,
     /* 274794 */   // GIR_Coverage, 8040,
     /* 274794 */   GIR_Done,
     /* 274795 */ // Label 5659: @274795
     /* 274795 */ GIM_Reject,
     /* 274796 */ // Label 5646: @274796
     /* 274796 */ GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(274821), // Rule ID 8038 //
     /* 274801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274814 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 274814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 274819 */   GIR_RootConstrainSelectedInstOperands,
     /* 274820 */   // GIR_Coverage, 8038,
     /* 274820 */   GIR_Done,
     /* 274821 */ // Label 5660: @274821
     /* 274821 */ GIM_Reject,
     /* 274822 */ // Label 5647: @274822
     /* 274822 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(274847), // Rule ID 8036 //
     /* 274827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274840 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 274840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 274845 */   GIR_RootConstrainSelectedInstOperands,
     /* 274846 */   // GIR_Coverage, 8036,
     /* 274846 */   GIR_Done,
     /* 274847 */ // Label 5661: @274847
     /* 274847 */ GIM_Reject,
     /* 274848 */ // Label 5648: @274848
     /* 274848 */ GIM_Reject,
     /* 274849 */ // Label 56: @274849
     /* 274849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5673*/ GIMT_Encode4(278944),
     /* 274860 */ /*GILLT_s16*//*Label 5662*/ GIMT_Encode4(274944),
     /* 274864 */ /*GILLT_s32*//*Label 5663*/ GIMT_Encode4(275586),
     /* 274868 */ /*GILLT_s64*//*Label 5664*/ GIMT_Encode4(276216), GIMT_Encode4(0),
     /* 274876 */ /*GILLT_v2s32*//*Label 5665*/ GIMT_Encode4(276846),
     /* 274880 */ /*GILLT_v2s64*//*Label 5666*/ GIMT_Encode4(277376),
     /* 274884 */ /*GILLT_v4s16*//*Label 5667*/ GIMT_Encode4(277734),
     /* 274888 */ /*GILLT_v4s32*//*Label 5668*/ GIMT_Encode4(278076), GIMT_Encode4(0),
     /* 274896 */ /*GILLT_v8s16*//*Label 5669*/ GIMT_Encode4(278434), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274920 */ /*GILLT_nxv2s64*//*Label 5670*/ GIMT_Encode4(278866), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274932 */ /*GILLT_nxv4s32*//*Label 5671*/ GIMT_Encode4(278892), GIMT_Encode4(0),
     /* 274940 */ /*GILLT_nxv8s16*//*Label 5672*/ GIMT_Encode4(278918),
     /* 274944 */ // Label 5662: @274944
     /* 274944 */ GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(275585),
     /* 274949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 274955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274959 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(275072), // Rule ID 6147 //
     /* 274964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 274971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 274975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 274983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 274992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 274996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 275017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275021 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275025 */     // MIs[3] Operand 1
     /* 275025 */     // No operand predicates
     /* 275025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275027 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 275027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 275045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 275067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 275070 */     GIR_RootConstrainSelectedInstOperands,
     /* 275071 */     // GIR_Coverage, 6147,
     /* 275071 */     GIR_EraseRootFromParent_Done,
     /* 275072 */   // Label 5675: @275072
     /* 275072 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(275185), // Rule ID 13621 //
     /* 275077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275109 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275113 */     // MIs[2] Operand 1
     /* 275113 */     // No operand predicates
     /* 275113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 275117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275121 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275125 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 275129 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275134 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 275138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275140 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 275140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275152 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 275158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275183 */     GIR_RootConstrainSelectedInstOperands,
     /* 275184 */     // GIR_Coverage, 13621,
     /* 275184 */     GIR_EraseRootFromParent_Done,
     /* 275185 */   // Label 5676: @275185
     /* 275185 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(275264), // Rule ID 13558 //
     /* 275190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275224 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 275224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275236 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 275242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275262 */     GIR_RootConstrainSelectedInstOperands,
     /* 275263 */     // GIR_Coverage, 13558,
     /* 275263 */     GIR_EraseRootFromParent_Done,
     /* 275264 */   // Label 5677: @275264
     /* 275264 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(275343), // Rule ID 4743 //
     /* 275269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275297 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275303 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 275303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275315 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 275321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275341 */     GIR_RootConstrainSelectedInstOperands,
     /* 275342 */     // GIR_Coverage, 4743,
     /* 275342 */     GIR_EraseRootFromParent_Done,
     /* 275343 */   // Label 5678: @275343
     /* 275343 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(275406), // Rule ID 13173 //
     /* 275348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275384 */     // MIs[2] Operand 1
     /* 275384 */     // No operand predicates
     /* 275384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275390 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 275390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275404 */     GIR_RootConstrainSelectedInstOperands,
     /* 275405 */     // GIR_Coverage, 13173,
     /* 275405 */     GIR_EraseRootFromParent_Done,
     /* 275406 */   // Label 5679: @275406
     /* 275406 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(275469), // Rule ID 2005 //
     /* 275411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275451 */     // MIs[2] Operand 1
     /* 275451 */     // No operand predicates
     /* 275451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275453 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 275453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275467 */     GIR_RootConstrainSelectedInstOperands,
     /* 275468 */     // GIR_Coverage, 2005,
     /* 275468 */     GIR_EraseRootFromParent_Done,
     /* 275469 */   // Label 5680: @275469
     /* 275469 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(275513), // Rule ID 4748 //
     /* 275474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 275485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275500 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 275500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 275503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 275509 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 275511 */     GIR_RootConstrainSelectedInstOperands,
     /* 275512 */     // GIR_Coverage, 4748,
     /* 275512 */     GIR_EraseRootFromParent_Done,
     /* 275513 */   // Label 5681: @275513
     /* 275513 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(275557), // Rule ID 13563 //
     /* 275518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 275533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275544 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 275544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 275547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 275553 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 275555 */     GIR_RootConstrainSelectedInstOperands,
     /* 275556 */     // GIR_Coverage, 13563,
     /* 275556 */     GIR_EraseRootFromParent_Done,
     /* 275557 */   // Label 5682: @275557
     /* 275557 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(275584), // Rule ID 620 //
     /* 275562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275573 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 275573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275578 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 275582 */     GIR_RootConstrainSelectedInstOperands,
     /* 275583 */     // GIR_Coverage, 620,
     /* 275583 */     GIR_Done,
     /* 275584 */   // Label 5683: @275584
     /* 275584 */   GIM_Reject,
     /* 275585 */ // Label 5674: @275585
     /* 275585 */ GIM_Reject,
     /* 275586 */ // Label 5663: @275586
     /* 275586 */ GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(276215),
     /* 275591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 275597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275601 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(275714), // Rule ID 6149 //
     /* 275606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 275659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 275667 */     // MIs[3] Operand 1
     /* 275667 */     // No operand predicates
     /* 275667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275669 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 275669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 275687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 275700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 275709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 275712 */     GIR_RootConstrainSelectedInstOperands,
     /* 275713 */     // GIR_Coverage, 6149,
     /* 275713 */     GIR_EraseRootFromParent_Done,
     /* 275714 */   // Label 5685: @275714
     /* 275714 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(275827), // Rule ID 13623 //
     /* 275719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275751 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 275755 */     // MIs[2] Operand 1
     /* 275755 */     // No operand predicates
     /* 275755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 275759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275767 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 275771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275776 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 275780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275782 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 275782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275794 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 275800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 275813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275825 */     GIR_RootConstrainSelectedInstOperands,
     /* 275826 */     // GIR_Coverage, 13623,
     /* 275826 */     GIR_EraseRootFromParent_Done,
     /* 275827 */   // Label 5686: @275827
     /* 275827 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(275903), // Rule ID 13560 //
     /* 275832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275853 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275863 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 275863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 275881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 275894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275901 */     GIR_RootConstrainSelectedInstOperands,
     /* 275902 */     // GIR_Coverage, 13560,
     /* 275902 */     GIR_EraseRootFromParent_Done,
     /* 275903 */   // Label 5687: @275903
     /* 275903 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(275979), // Rule ID 4745 //
     /* 275908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275939 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 275939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 275957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 275970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275977 */     GIR_RootConstrainSelectedInstOperands,
     /* 275978 */     // GIR_Coverage, 4745,
     /* 275978 */     GIR_EraseRootFromParent_Done,
     /* 275979 */   // Label 5688: @275979
     /* 275979 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(276042), // Rule ID 13175 //
     /* 275984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276020 */     // MIs[2] Operand 1
     /* 276020 */     // No operand predicates
     /* 276020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276026 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276040 */     GIR_RootConstrainSelectedInstOperands,
     /* 276041 */     // GIR_Coverage, 13175,
     /* 276041 */     GIR_EraseRootFromParent_Done,
     /* 276042 */   // Label 5689: @276042
     /* 276042 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(276105), // Rule ID 2007 //
     /* 276047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276087 */     // MIs[2] Operand 1
     /* 276087 */     // No operand predicates
     /* 276087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276089 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276103 */     GIR_RootConstrainSelectedInstOperands,
     /* 276104 */     // GIR_Coverage, 2007,
     /* 276104 */     GIR_EraseRootFromParent_Done,
     /* 276105 */   // Label 5690: @276105
     /* 276105 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(276146), // Rule ID 4749 //
     /* 276110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 276122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276133 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 276133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 276136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276142 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 276144 */     GIR_RootConstrainSelectedInstOperands,
     /* 276145 */     // GIR_Coverage, 4749,
     /* 276145 */     GIR_EraseRootFromParent_Done,
     /* 276146 */   // Label 5691: @276146
     /* 276146 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(276187), // Rule ID 13564 //
     /* 276151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 276167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276174 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 276174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 276177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276183 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 276185 */     GIR_RootConstrainSelectedInstOperands,
     /* 276186 */     // GIR_Coverage, 13564,
     /* 276186 */     GIR_EraseRootFromParent_Done,
     /* 276187 */   // Label 5692: @276187
     /* 276187 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(276214), // Rule ID 622 //
     /* 276192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 276195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276203 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 276203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 276208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276212 */     GIR_RootConstrainSelectedInstOperands,
     /* 276213 */     // GIR_Coverage, 622,
     /* 276213 */     GIR_Done,
     /* 276214 */   // Label 5693: @276214
     /* 276214 */   GIM_Reject,
     /* 276215 */ // Label 5684: @276215
     /* 276215 */ GIM_Reject,
     /* 276216 */ // Label 5664: @276216
     /* 276216 */ GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(276845),
     /* 276221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 276224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276231 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(276344), // Rule ID 6151 //
     /* 276236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276297 */     // MIs[3] Operand 1
     /* 276297 */     // No operand predicates
     /* 276297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276299 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 276299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276311 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 276339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 276342 */     GIR_RootConstrainSelectedInstOperands,
     /* 276343 */     // GIR_Coverage, 6151,
     /* 276343 */     GIR_EraseRootFromParent_Done,
     /* 276344 */   // Label 5695: @276344
     /* 276344 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(276457), // Rule ID 13625 //
     /* 276349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276381 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276385 */     // MIs[2] Operand 1
     /* 276385 */     // No operand predicates
     /* 276385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 276389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 276401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276406 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 276410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276412 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 276412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276455 */     GIR_RootConstrainSelectedInstOperands,
     /* 276456 */     // GIR_Coverage, 13625,
     /* 276456 */     GIR_EraseRootFromParent_Done,
     /* 276457 */   // Label 5696: @276457
     /* 276457 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(276533), // Rule ID 13562 //
     /* 276462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276483 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276493 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 276493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276505 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276531 */     GIR_RootConstrainSelectedInstOperands,
     /* 276532 */     // GIR_Coverage, 13562,
     /* 276532 */     GIR_EraseRootFromParent_Done,
     /* 276533 */   // Label 5697: @276533
     /* 276533 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(276609), // Rule ID 4747 //
     /* 276538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276563 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276569 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 276569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276581 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276607 */     GIR_RootConstrainSelectedInstOperands,
     /* 276608 */     // GIR_Coverage, 4747,
     /* 276608 */     GIR_EraseRootFromParent_Done,
     /* 276609 */   // Label 5698: @276609
     /* 276609 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(276672), // Rule ID 13177 //
     /* 276614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276650 */     // MIs[2] Operand 1
     /* 276650 */     // No operand predicates
     /* 276650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276656 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276670 */     GIR_RootConstrainSelectedInstOperands,
     /* 276671 */     // GIR_Coverage, 13177,
     /* 276671 */     GIR_EraseRootFromParent_Done,
     /* 276672 */   // Label 5699: @276672
     /* 276672 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(276735), // Rule ID 2009 //
     /* 276677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276713 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276717 */     // MIs[2] Operand 1
     /* 276717 */     // No operand predicates
     /* 276717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276719 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276733 */     GIR_RootConstrainSelectedInstOperands,
     /* 276734 */     // GIR_Coverage, 2009,
     /* 276734 */     GIR_EraseRootFromParent_Done,
     /* 276735 */   // Label 5700: @276735
     /* 276735 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(276776), // Rule ID 4750 //
     /* 276740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 276752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276763 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 276763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 276766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276772 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 276774 */     GIR_RootConstrainSelectedInstOperands,
     /* 276775 */     // GIR_Coverage, 4750,
     /* 276775 */     GIR_EraseRootFromParent_Done,
     /* 276776 */   // Label 5701: @276776
     /* 276776 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(276817), // Rule ID 13565 //
     /* 276781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 276797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276804 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 276804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 276807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276813 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 276815 */     GIR_RootConstrainSelectedInstOperands,
     /* 276816 */     // GIR_Coverage, 13565,
     /* 276816 */     GIR_EraseRootFromParent_Done,
     /* 276817 */   // Label 5702: @276817
     /* 276817 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(276844), // Rule ID 624 //
     /* 276822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 276825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276833 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 276833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276838 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276842 */     GIR_RootConstrainSelectedInstOperands,
     /* 276843 */     // GIR_Coverage, 624,
     /* 276843 */     GIR_Done,
     /* 276844 */   // Label 5703: @276844
     /* 276844 */   GIM_Reject,
     /* 276845 */ // Label 5694: @276845
     /* 276845 */ GIM_Reject,
     /* 276846 */ // Label 5665: @276846
     /* 276846 */ GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(277375),
     /* 276851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 276854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276861 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(276947), // Rule ID 13166 //
     /* 276866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 276877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 276889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276914 */     // MIs[3] Operand 1
     /* 276914 */     // No operand predicates
     /* 276914 */     // MIs[1] Operand 2
     /* 276914 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 276925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276931 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 276934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 276942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 276945 */     GIR_RootConstrainSelectedInstOperands,
     /* 276946 */     // GIR_Coverage, 13166,
     /* 276946 */     GIR_EraseRootFromParent_Done,
     /* 276947 */   // Label 5705: @276947
     /* 276947 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(277033), // Rule ID 1998 //
     /* 276952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 276967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 276979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277000 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277004 */     // MIs[3] Operand 1
     /* 277004 */     // No operand predicates
     /* 277004 */     // MIs[1] Operand 2
     /* 277004 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277017 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277031 */     GIR_RootConstrainSelectedInstOperands,
     /* 277032 */     // GIR_Coverage, 1998,
     /* 277032 */     GIR_EraseRootFromParent_Done,
     /* 277033 */   // Label 5706: @277033
     /* 277033 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(277096), // Rule ID 13167 //
     /* 277038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277074 */     // MIs[2] Operand 1
     /* 277074 */     // No operand predicates
     /* 277074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277080 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277094 */     GIR_RootConstrainSelectedInstOperands,
     /* 277095 */     // GIR_Coverage, 13167,
     /* 277095 */     GIR_EraseRootFromParent_Done,
     /* 277096 */   // Label 5707: @277096
     /* 277096 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(277159), // Rule ID 1999 //
     /* 277101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277141 */     // MIs[2] Operand 1
     /* 277141 */     // No operand predicates
     /* 277141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277143 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277157 */     GIR_RootConstrainSelectedInstOperands,
     /* 277158 */     // GIR_Coverage, 1999,
     /* 277158 */     GIR_EraseRootFromParent_Done,
     /* 277159 */   // Label 5708: @277159
     /* 277159 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(277253), // Rule ID 13627 //
     /* 277164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 277176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277187 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 277223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277251 */     GIR_RootConstrainSelectedInstOperands,
     /* 277252 */     // GIR_Coverage, 13627,
     /* 277252 */     GIR_EraseRootFromParent_Done,
     /* 277253 */   // Label 5709: @277253
     /* 277253 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(277347), // Rule ID 6153 //
     /* 277258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 277274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277281 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 277317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277345 */     GIR_RootConstrainSelectedInstOperands,
     /* 277346 */     // GIR_Coverage, 6153,
     /* 277346 */     GIR_EraseRootFromParent_Done,
     /* 277347 */   // Label 5710: @277347
     /* 277347 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(277374), // Rule ID 1316 //
     /* 277352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277363 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 277363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 277368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277372 */     GIR_RootConstrainSelectedInstOperands,
     /* 277373 */     // GIR_Coverage, 1316,
     /* 277373 */     GIR_Done,
     /* 277374 */   // Label 5711: @277374
     /* 277374 */   GIM_Reject,
     /* 277375 */ // Label 5704: @277375
     /* 277375 */ GIM_Reject,
     /* 277376 */ // Label 5666: @277376
     /* 277376 */ GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(277733),
     /* 277381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277391 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(277454), // Rule ID 13171 //
     /* 277396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 277407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277428 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277432 */     // MIs[2] Operand 1
     /* 277432 */     // No operand predicates
     /* 277432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277438 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277452 */     GIR_RootConstrainSelectedInstOperands,
     /* 277453 */     // GIR_Coverage, 13171,
     /* 277453 */     GIR_EraseRootFromParent_Done,
     /* 277454 */   // Label 5713: @277454
     /* 277454 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(277517), // Rule ID 2003 //
     /* 277459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 277474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277495 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277499 */     // MIs[2] Operand 1
     /* 277499 */     // No operand predicates
     /* 277499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277501 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277515 */     GIR_RootConstrainSelectedInstOperands,
     /* 277516 */     // GIR_Coverage, 2003,
     /* 277516 */     GIR_EraseRootFromParent_Done,
     /* 277517 */   // Label 5714: @277517
     /* 277517 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(277611), // Rule ID 13631 //
     /* 277522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277545 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277545 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277548 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277552 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277571 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277578 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 277581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277609 */     GIR_RootConstrainSelectedInstOperands,
     /* 277610 */     // GIR_Coverage, 13631,
     /* 277610 */     GIR_EraseRootFromParent_Done,
     /* 277611 */   // Label 5715: @277611
     /* 277611 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(277705), // Rule ID 6157 //
     /* 277616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277639 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277639 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277642 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277646 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277672 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 277675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277703 */     GIR_RootConstrainSelectedInstOperands,
     /* 277704 */     // GIR_Coverage, 6157,
     /* 277704 */     GIR_EraseRootFromParent_Done,
     /* 277705 */   // Label 5716: @277705
     /* 277705 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(277732), // Rule ID 1320 //
     /* 277710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277721 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 277721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 277726 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277730 */     GIR_RootConstrainSelectedInstOperands,
     /* 277731 */     // GIR_Coverage, 1320,
     /* 277731 */     GIR_Done,
     /* 277732 */   // Label 5717: @277732
     /* 277732 */   GIM_Reject,
     /* 277733 */ // Label 5712: @277733
     /* 277733 */ GIM_Reject,
     /* 277734 */ // Label 5667: @277734
     /* 277734 */ GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(278075),
     /* 277739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277749 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(277835), // Rule ID 13160 //
     /* 277754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 277765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 277777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 277790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277802 */     // MIs[3] Operand 1
     /* 277802 */     // No operand predicates
     /* 277802 */     // MIs[1] Operand 2
     /* 277802 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277819 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 277822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277833 */     GIR_RootConstrainSelectedInstOperands,
     /* 277834 */     // GIR_Coverage, 13160,
     /* 277834 */     GIR_EraseRootFromParent_Done,
     /* 277835 */   // Label 5719: @277835
     /* 277835 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(277921), // Rule ID 1992 //
     /* 277840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 277855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 277867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 277880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277888 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277892 */     // MIs[3] Operand 1
     /* 277892 */     // No operand predicates
     /* 277892 */     // MIs[1] Operand 2
     /* 277892 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277905 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 277908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277919 */     GIR_RootConstrainSelectedInstOperands,
     /* 277920 */     // GIR_Coverage, 1992,
     /* 277920 */     GIR_EraseRootFromParent_Done,
     /* 277921 */   // Label 5720: @277921
     /* 277921 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(277984), // Rule ID 13161 //
     /* 277926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 277937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 277950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277962 */     // MIs[2] Operand 1
     /* 277962 */     // No operand predicates
     /* 277962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277968 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 277971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277982 */     GIR_RootConstrainSelectedInstOperands,
     /* 277983 */     // GIR_Coverage, 13161,
     /* 277983 */     GIR_EraseRootFromParent_Done,
     /* 277984 */   // Label 5721: @277984
     /* 277984 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(278047), // Rule ID 1993 //
     /* 277989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278029 */     // MIs[2] Operand 1
     /* 278029 */     // No operand predicates
     /* 278029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278031 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 278034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278045 */     GIR_RootConstrainSelectedInstOperands,
     /* 278046 */     // GIR_Coverage, 1993,
     /* 278046 */     GIR_EraseRootFromParent_Done,
     /* 278047 */   // Label 5722: @278047
     /* 278047 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(278074), // Rule ID 1312 //
     /* 278052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278063 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 278063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 278068 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278072 */     GIR_RootConstrainSelectedInstOperands,
     /* 278073 */     // GIR_Coverage, 1312,
     /* 278073 */     GIR_Done,
     /* 278074 */   // Label 5723: @278074
     /* 278074 */   GIM_Reject,
     /* 278075 */ // Label 5718: @278075
     /* 278075 */ GIM_Reject,
     /* 278076 */ // Label 5668: @278076
     /* 278076 */ GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(278433),
     /* 278081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278091 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(278154), // Rule ID 13169 //
     /* 278096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 278107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278128 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278132 */     // MIs[2] Operand 1
     /* 278132 */     // No operand predicates
     /* 278132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278138 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278152 */     GIR_RootConstrainSelectedInstOperands,
     /* 278153 */     // GIR_Coverage, 13169,
     /* 278153 */     GIR_EraseRootFromParent_Done,
     /* 278154 */   // Label 5725: @278154
     /* 278154 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(278217), // Rule ID 2001 //
     /* 278159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 278174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278199 */     // MIs[2] Operand 1
     /* 278199 */     // No operand predicates
     /* 278199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278201 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278215 */     GIR_RootConstrainSelectedInstOperands,
     /* 278216 */     // GIR_Coverage, 2001,
     /* 278216 */     GIR_EraseRootFromParent_Done,
     /* 278217 */   // Label 5726: @278217
     /* 278217 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(278311), // Rule ID 13629 //
     /* 278222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 278234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278245 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278271 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 278281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278309 */     GIR_RootConstrainSelectedInstOperands,
     /* 278310 */     // GIR_Coverage, 13629,
     /* 278310 */     GIR_EraseRootFromParent_Done,
     /* 278311 */   // Label 5727: @278311
     /* 278311 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(278405), // Rule ID 6155 //
     /* 278316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 278332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278339 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 278375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278403 */     GIR_RootConstrainSelectedInstOperands,
     /* 278404 */     // GIR_Coverage, 6155,
     /* 278404 */     GIR_EraseRootFromParent_Done,
     /* 278405 */   // Label 5728: @278405
     /* 278405 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(278432), // Rule ID 1318 //
     /* 278410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278421 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 278421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278426 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278430 */     GIR_RootConstrainSelectedInstOperands,
     /* 278431 */     // GIR_Coverage, 1318,
     /* 278431 */     GIR_Done,
     /* 278432 */   // Label 5729: @278432
     /* 278432 */   GIM_Reject,
     /* 278433 */ // Label 5724: @278433
     /* 278433 */ GIM_Reject,
     /* 278434 */ // Label 5669: @278434
     /* 278434 */ GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(278865),
     /* 278439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278449 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(278512), // Rule ID 13163 //
     /* 278454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278490 */     // MIs[2] Operand 1
     /* 278490 */     // No operand predicates
     /* 278490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278496 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 278499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278510 */     GIR_RootConstrainSelectedInstOperands,
     /* 278511 */     // GIR_Coverage, 13163,
     /* 278511 */     GIR_EraseRootFromParent_Done,
     /* 278512 */   // Label 5731: @278512
     /* 278512 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(278575), // Rule ID 1995 //
     /* 278517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278553 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278557 */     // MIs[2] Operand 1
     /* 278557 */     // No operand predicates
     /* 278557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278559 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 278562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278573 */     GIR_RootConstrainSelectedInstOperands,
     /* 278574 */     // GIR_Coverage, 1995,
     /* 278574 */     GIR_EraseRootFromParent_Done,
     /* 278575 */   // Label 5732: @278575
     /* 278575 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(278602), // Rule ID 1314 //
     /* 278580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278591 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 278591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 278596 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278600 */     GIR_RootConstrainSelectedInstOperands,
     /* 278601 */     // GIR_Coverage, 1314,
     /* 278601 */     GIR_Done,
     /* 278602 */   // Label 5733: @278602
     /* 278602 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(278864), // Rule ID 6918 //
     /* 278607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 278610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278618 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 278618 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 278621 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 278625 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278630 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 278634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 278636 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 278639 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 278643 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278648 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 278652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 278654 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 278657 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278661 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278666 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 278669 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 278672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 278674 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 278677 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278681 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278686 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 278692 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278697 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278702 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 278705 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 278709 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278714 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 278717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 278719 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 278722 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278726 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278731 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 278737 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278742 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278747 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 278750 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 278754 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278759 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 278762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 278764 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 278767 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278771 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278776 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 278779 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 278782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 278784 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 278787 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 278791 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278796 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 278799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 278804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 278836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 278854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 278862 */     GIR_RootConstrainSelectedInstOperands,
     /* 278863 */     // GIR_Coverage, 6918,
     /* 278863 */     GIR_EraseRootFromParent_Done,
     /* 278864 */   // Label 5734: @278864
     /* 278864 */   GIM_Reject,
     /* 278865 */ // Label 5730: @278865
     /* 278865 */ GIM_Reject,
     /* 278866 */ // Label 5670: @278866
     /* 278866 */ GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(278891), // Rule ID 8046 //
     /* 278871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 278877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 278880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278884 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 278884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 278889 */   GIR_RootConstrainSelectedInstOperands,
     /* 278890 */   // GIR_Coverage, 8046,
     /* 278890 */   GIR_Done,
     /* 278891 */ // Label 5735: @278891
     /* 278891 */ GIM_Reject,
     /* 278892 */ // Label 5671: @278892
     /* 278892 */ GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(278917), // Rule ID 8044 //
     /* 278897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 278903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 278906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278910 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 278910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 278915 */   GIR_RootConstrainSelectedInstOperands,
     /* 278916 */   // GIR_Coverage, 8044,
     /* 278916 */   GIR_Done,
     /* 278917 */ // Label 5736: @278917
     /* 278917 */ GIM_Reject,
     /* 278918 */ // Label 5672: @278918
     /* 278918 */ GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(278943), // Rule ID 8042 //
     /* 278923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 278929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 278932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278936 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 278936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 278941 */   GIR_RootConstrainSelectedInstOperands,
     /* 278942 */   // GIR_Coverage, 8042,
     /* 278942 */   GIR_Done,
     /* 278943 */ // Label 5737: @278943
     /* 278943 */ GIM_Reject,
     /* 278944 */ // Label 5673: @278944
     /* 278944 */ GIM_Reject,
     /* 278945 */ // Label 57: @278945
     /* 278945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5746*/ GIMT_Encode4(295217),
     /* 278956 */ /*GILLT_s16*//*Label 5738*/ GIMT_Encode4(278996),
     /* 278960 */ /*GILLT_s32*//*Label 5739*/ GIMT_Encode4(282000),
     /* 278964 */ /*GILLT_s64*//*Label 5740*/ GIMT_Encode4(285148), GIMT_Encode4(0),
     /* 278972 */ /*GILLT_v2s32*//*Label 5741*/ GIMT_Encode4(288296),
     /* 278976 */ /*GILLT_v2s64*//*Label 5742*/ GIMT_Encode4(289817),
     /* 278980 */ /*GILLT_v4s16*//*Label 5743*/ GIMT_Encode4(291338),
     /* 278984 */ /*GILLT_v4s32*//*Label 5744*/ GIMT_Encode4(292517), GIMT_Encode4(0),
     /* 278992 */ /*GILLT_v8s16*//*Label 5745*/ GIMT_Encode4(294038),
     /* 278996 */ // Label 5738: @278996
     /* 278996 */ GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(281999),
     /* 279001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 279007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 279010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279014 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(279164), // Rule ID 4805 //
     /* 279019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279068 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 279076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 279084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279091 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279103 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 279150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 279162 */     GIR_RootConstrainSelectedInstOperands,
     /* 279163 */     // GIR_Coverage, 4805,
     /* 279163 */     GIR_EraseRootFromParent_Done,
     /* 279164 */   // Label 5748: @279164
     /* 279164 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(279311), // Rule ID 4769 //
     /* 279169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 279213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279217 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279221 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279225 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279230 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279240 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279252 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 279299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 279309 */     GIR_RootConstrainSelectedInstOperands,
     /* 279310 */     // GIR_Coverage, 4769,
     /* 279310 */     GIR_EraseRootFromParent_Done,
     /* 279311 */   // Label 5749: @279311
     /* 279311 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(279458), // Rule ID 13571 //
     /* 279316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279372 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279377 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279387 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279399 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279427 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 279446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 279456 */     GIR_RootConstrainSelectedInstOperands,
     /* 279457 */     // GIR_Coverage, 13571,
     /* 279457 */     GIR_EraseRootFromParent_Done,
     /* 279458 */   // Label 5750: @279458
     /* 279458 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(279589), // Rule ID 5985 //
     /* 279463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 279507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279511 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279515 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 279528 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279532 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279536 */     // MIs[4] Operand 1
     /* 279536 */     // No operand predicates
     /* 279536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279542 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 279584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 279587 */     GIR_RootConstrainSelectedInstOperands,
     /* 279588 */     // GIR_Coverage, 5985,
     /* 279588 */     GIR_EraseRootFromParent_Done,
     /* 279589 */   // Label 5751: @279589
     /* 279589 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(279720), // Rule ID 6017 //
     /* 279594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279630 */     // MIs[2] Operand 1
     /* 279630 */     // No operand predicates
     /* 279630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 279642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 279646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279650 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279654 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 279658 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279663 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 279667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279671 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279673 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279685 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279718 */     GIR_RootConstrainSelectedInstOperands,
     /* 279719 */     // GIR_Coverage, 6017,
     /* 279719 */     GIR_EraseRootFromParent_Done,
     /* 279720 */   // Label 5752: @279720
     /* 279720 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(279851), // Rule ID 6081 //
     /* 279725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279761 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 279790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279798 */     // MIs[4] Operand 1
     /* 279798 */     // No operand predicates
     /* 279798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279802 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279804 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 279846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 279849 */     GIR_RootConstrainSelectedInstOperands,
     /* 279850 */     // GIR_Coverage, 6081,
     /* 279850 */     GIR_EraseRootFromParent_Done,
     /* 279851 */   // Label 5753: @279851
     /* 279851 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(279982), // Rule ID 6049 //
     /* 279856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279900 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279904 */     // MIs[3] Operand 1
     /* 279904 */     // No operand predicates
     /* 279904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 279908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279916 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 279920 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279925 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 279929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279933 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279935 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 279977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 279980 */     GIR_RootConstrainSelectedInstOperands,
     /* 279981 */     // GIR_Coverage, 6049,
     /* 279981 */     GIR_EraseRootFromParent_Done,
     /* 279982 */   // Label 5754: @279982
     /* 279982 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(280117), // Rule ID 2447 //
     /* 279987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280036 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280046 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280058 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280064 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280069 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 280105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280115 */     GIR_RootConstrainSelectedInstOperands,
     /* 280116 */     // GIR_Coverage, 2447,
     /* 280116 */     GIR_EraseRootFromParent_Done,
     /* 280117 */   // Label 5755: @280117
     /* 280117 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(280236), // Rule ID 5953 //
     /* 280122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280183 */     // MIs[3] Operand 1
     /* 280183 */     // No operand predicates
     /* 280183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280189 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 280220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280234 */     GIR_RootConstrainSelectedInstOperands,
     /* 280235 */     // GIR_Coverage, 5953,
     /* 280235 */     GIR_EraseRootFromParent_Done,
     /* 280236 */   // Label 5756: @280236
     /* 280236 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(280355), // Rule ID 2529 //
     /* 280241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280277 */     // MIs[2] Operand 1
     /* 280277 */     // No operand predicates
     /* 280277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 280281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 280293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 280302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280308 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280320 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 280339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280353 */     GIR_RootConstrainSelectedInstOperands,
     /* 280354 */     // GIR_Coverage, 2529,
     /* 280354 */     GIR_EraseRootFromParent_Done,
     /* 280355 */   // Label 5757: @280355
     /* 280355 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(280455), // Rule ID 4767 //
     /* 280360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280411 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280453 */     GIR_RootConstrainSelectedInstOperands,
     /* 280454 */     // GIR_Coverage, 4767,
     /* 280454 */     GIR_EraseRootFromParent_Done,
     /* 280455 */   // Label 5758: @280455
     /* 280455 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(280555), // Rule ID 4803 //
     /* 280460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 280496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280511 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280523 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 280542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 280549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 280553 */     GIR_RootConstrainSelectedInstOperands,
     /* 280554 */     // GIR_Coverage, 4803,
     /* 280554 */     GIR_EraseRootFromParent_Done,
     /* 280555 */   // Label 5759: @280555
     /* 280555 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(280652), // Rule ID 13567 //
     /* 280560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280610 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280650 */     GIR_RootConstrainSelectedInstOperands,
     /* 280651 */     // GIR_Coverage, 13567,
     /* 280651 */     GIR_EraseRootFromParent_Done,
     /* 280652 */   // Label 5760: @280652
     /* 280652 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(280752), // Rule ID 13569 //
     /* 280657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280698 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280708 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280750 */     GIR_RootConstrainSelectedInstOperands,
     /* 280751 */     // GIR_Coverage, 13569,
     /* 280751 */     GIR_EraseRootFromParent_Done,
     /* 280752 */   // Label 5761: @280752
     /* 280752 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(280852), // Rule ID 4801 //
     /* 280757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 280793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280808 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 280839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 280850 */     GIR_RootConstrainSelectedInstOperands,
     /* 280851 */     // GIR_Coverage, 4801,
     /* 280851 */     GIR_EraseRootFromParent_Done,
     /* 280852 */   // Label 5762: @280852
     /* 280852 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(280949), // Rule ID 4765 //
     /* 280857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280907 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280919 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280947 */     GIR_RootConstrainSelectedInstOperands,
     /* 280948 */     // GIR_Coverage, 4765,
     /* 280948 */     GIR_EraseRootFromParent_Done,
     /* 280949 */   // Label 5763: @280949
     /* 280949 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(281033), // Rule ID 6015 //
     /* 280954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280986 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280990 */     // MIs[2] Operand 1
     /* 280990 */     // No operand predicates
     /* 280990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 280994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 281002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281013 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 281024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281031 */     GIR_RootConstrainSelectedInstOperands,
     /* 281032 */     // GIR_Coverage, 6015,
     /* 281032 */     GIR_EraseRootFromParent_Done,
     /* 281033 */   // Label 5764: @281033
     /* 281033 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(281114), // Rule ID 6047 //
     /* 281038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281082 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281086 */     // MIs[3] Operand 1
     /* 281086 */     // No operand predicates
     /* 281086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281096 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281112 */     GIR_RootConstrainSelectedInstOperands,
     /* 281113 */     // GIR_Coverage, 6047,
     /* 281113 */     GIR_EraseRootFromParent_Done,
     /* 281114 */   // Label 5765: @281114
     /* 281114 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(281198), // Rule ID 6079 //
     /* 281119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281168 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281172 */     // MIs[3] Operand 1
     /* 281172 */     // No operand predicates
     /* 281172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281178 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281196 */     GIR_RootConstrainSelectedInstOperands,
     /* 281197 */     // GIR_Coverage, 6079,
     /* 281197 */     GIR_EraseRootFromParent_Done,
     /* 281198 */   // Label 5766: @281198
     /* 281198 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(281279), // Rule ID 5983 //
     /* 281203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281251 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281255 */     // MIs[3] Operand 1
     /* 281255 */     // No operand predicates
     /* 281255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281261 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281277 */     GIR_RootConstrainSelectedInstOperands,
     /* 281278 */     // GIR_Coverage, 5983,
     /* 281278 */     GIR_EraseRootFromParent_Done,
     /* 281279 */   // Label 5767: @281279
     /* 281279 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(281364), // Rule ID 2445 //
     /* 281284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281308 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281322 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 281340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281362 */     GIR_RootConstrainSelectedInstOperands,
     /* 281363 */     // GIR_Coverage, 2445,
     /* 281363 */     GIR_EraseRootFromParent_Done,
     /* 281364 */   // Label 5768: @281364
     /* 281364 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(281449), // Rule ID 2443 //
     /* 281369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281397 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281407 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 281425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281447 */     GIR_RootConstrainSelectedInstOperands,
     /* 281448 */     // GIR_Coverage, 2443,
     /* 281448 */     GIR_EraseRootFromParent_Done,
     /* 281449 */   // Label 5769: @281449
     /* 281449 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(281518), // Rule ID 2527 //
     /* 281454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281490 */     // MIs[2] Operand 1
     /* 281490 */     // No operand predicates
     /* 281490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281500 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 281503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281516 */     GIR_RootConstrainSelectedInstOperands,
     /* 281517 */     // GIR_Coverage, 2527,
     /* 281517 */     GIR_EraseRootFromParent_Done,
     /* 281518 */   // Label 5770: @281518
     /* 281518 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(281587), // Rule ID 5951 //
     /* 281523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281563 */     // MIs[2] Operand 1
     /* 281563 */     // No operand predicates
     /* 281563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281569 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 281572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281585 */     GIR_RootConstrainSelectedInstOperands,
     /* 281586 */     // GIR_Coverage, 5951,
     /* 281586 */     GIR_EraseRootFromParent_Done,
     /* 281587 */   // Label 5771: @281587
     /* 281587 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(281652), // Rule ID 4821 //
     /* 281592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 281620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281635 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 281638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 281650 */     GIR_RootConstrainSelectedInstOperands,
     /* 281651 */     // GIR_Coverage, 4821,
     /* 281651 */     GIR_EraseRootFromParent_Done,
     /* 281652 */   // Label 5772: @281652
     /* 281652 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(281717), // Rule ID 13587 //
     /* 281657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 281685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281700 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 281703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 281711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 281715 */     GIR_RootConstrainSelectedInstOperands,
     /* 281716 */     // GIR_Coverage, 13587,
     /* 281716 */     GIR_EraseRootFromParent_Done,
     /* 281717 */   // Label 5773: @281717
     /* 281717 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(281767), // Rule ID 4818 //
     /* 281722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281752 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281765 */     GIR_RootConstrainSelectedInstOperands,
     /* 281766 */     // GIR_Coverage, 4818,
     /* 281766 */     GIR_EraseRootFromParent_Done,
     /* 281767 */   // Label 5774: @281767
     /* 281767 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(281817), // Rule ID 13013 //
     /* 281772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281802 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281815 */     GIR_RootConstrainSelectedInstOperands,
     /* 281816 */     // GIR_Coverage, 13013,
     /* 281816 */     GIR_EraseRootFromParent_Done,
     /* 281817 */   // Label 5775: @281817
     /* 281817 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(281867), // Rule ID 644 //
     /* 281822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281852 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281865 */     GIR_RootConstrainSelectedInstOperands,
     /* 281866 */     // GIR_Coverage, 644,
     /* 281866 */     GIR_EraseRootFromParent_Done,
     /* 281867 */   // Label 5776: @281867
     /* 281867 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(281917), // Rule ID 13584 //
     /* 281872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281902 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 281913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281915 */     GIR_RootConstrainSelectedInstOperands,
     /* 281916 */     // GIR_Coverage, 13584,
     /* 281916 */     GIR_EraseRootFromParent_Done,
     /* 281917 */   // Label 5777: @281917
     /* 281917 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(281967), // Rule ID 656 //
     /* 281922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281952 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 281955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 281965 */     GIR_RootConstrainSelectedInstOperands,
     /* 281966 */     // GIR_Coverage, 656,
     /* 281966 */     GIR_EraseRootFromParent_Done,
     /* 281967 */   // Label 5778: @281967
     /* 281967 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(281998), // Rule ID 638 //
     /* 281972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281987 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281992 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281996 */     GIR_RootConstrainSelectedInstOperands,
     /* 281997 */     // GIR_Coverage, 638,
     /* 281997 */     GIR_Done,
     /* 281998 */   // Label 5779: @281998
     /* 281998 */   GIM_Reject,
     /* 281999 */ // Label 5747: @281999
     /* 281999 */ GIM_Reject,
     /* 282000 */ // Label 5739: @282000
     /* 282000 */ GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(285147),
     /* 282005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 282014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282018 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(282168), // Rule ID 4811 //
     /* 282023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282047 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282072 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 282080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 282088 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282095 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282107 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282113 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282135 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 282154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 282166 */     GIR_RootConstrainSelectedInstOperands,
     /* 282167 */     // GIR_Coverage, 4811,
     /* 282167 */     GIR_EraseRootFromParent_Done,
     /* 282168 */   // Label 5781: @282168
     /* 282168 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(282315), // Rule ID 4775 //
     /* 282173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282197 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 282213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282221 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282225 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282229 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282234 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282244 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282256 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282284 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 282303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282313 */     GIR_RootConstrainSelectedInstOperands,
     /* 282314 */     // GIR_Coverage, 4775,
     /* 282314 */     GIR_EraseRootFromParent_Done,
     /* 282315 */   // Label 5782: @282315
     /* 282315 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(282462), // Rule ID 13577 //
     /* 282320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282356 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282376 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282381 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282391 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282403 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282414 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 282450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282460 */     GIR_RootConstrainSelectedInstOperands,
     /* 282461 */     // GIR_Coverage, 13577,
     /* 282461 */     GIR_EraseRootFromParent_Done,
     /* 282462 */   // Label 5783: @282462
     /* 282462 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(282593), // Rule ID 6001 //
     /* 282467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 282507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282515 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282519 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282523 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282532 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282536 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282540 */     // MIs[4] Operand 1
     /* 282540 */     // No operand predicates
     /* 282540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282544 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282546 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282558 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 282588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 282591 */     GIR_RootConstrainSelectedInstOperands,
     /* 282592 */     // GIR_Coverage, 6001,
     /* 282592 */     GIR_EraseRootFromParent_Done,
     /* 282593 */   // Label 5784: @282593
     /* 282593 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(282724), // Rule ID 6033 //
     /* 282598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282634 */     // MIs[2] Operand 1
     /* 282634 */     // No operand predicates
     /* 282634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 282646 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 282650 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282654 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282658 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 282662 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282667 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 282671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282675 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282677 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282722 */     GIR_RootConstrainSelectedInstOperands,
     /* 282723 */     // GIR_Coverage, 6033,
     /* 282723 */     GIR_EraseRootFromParent_Done,
     /* 282724 */   // Label 5785: @282724
     /* 282724 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(282855), // Rule ID 6097 //
     /* 282729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282765 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282777 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282781 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282794 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282798 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282802 */     // MIs[4] Operand 1
     /* 282802 */     // No operand predicates
     /* 282802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282806 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282808 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 282850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 282853 */     GIR_RootConstrainSelectedInstOperands,
     /* 282854 */     // GIR_Coverage, 6097,
     /* 282854 */     GIR_EraseRootFromParent_Done,
     /* 282855 */   // Label 5786: @282855
     /* 282855 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(282986), // Rule ID 6065 //
     /* 282860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282904 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282908 */     // MIs[3] Operand 1
     /* 282908 */     // No operand predicates
     /* 282908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 282912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282916 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282920 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 282924 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282929 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 282933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282939 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 282981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282984 */     GIR_RootConstrainSelectedInstOperands,
     /* 282985 */     // GIR_Coverage, 6065,
     /* 282985 */     GIR_EraseRootFromParent_Done,
     /* 282986 */   // Label 5787: @282986
     /* 282986 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(283121), // Rule ID 2453 //
     /* 282991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283040 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283050 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 283053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283062 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283068 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283090 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 283109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283119 */     GIR_RootConstrainSelectedInstOperands,
     /* 283120 */     // GIR_Coverage, 2453,
     /* 283120 */     GIR_EraseRootFromParent_Done,
     /* 283121 */   // Label 5788: @283121
     /* 283121 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(283240), // Rule ID 5969 //
     /* 283126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283150 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283183 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283187 */     // MIs[3] Operand 1
     /* 283187 */     // No operand predicates
     /* 283187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283193 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283205 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 283224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283238 */     GIR_RootConstrainSelectedInstOperands,
     /* 283239 */     // GIR_Coverage, 5969,
     /* 283239 */     GIR_EraseRootFromParent_Done,
     /* 283240 */   // Label 5789: @283240
     /* 283240 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(283359), // Rule ID 2545 //
     /* 283245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283277 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283281 */     // MIs[2] Operand 1
     /* 283281 */     // No operand predicates
     /* 283281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283293 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 283297 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283302 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 283306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283312 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283324 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 283343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283357 */     GIR_RootConstrainSelectedInstOperands,
     /* 283358 */     // GIR_Coverage, 2545,
     /* 283358 */     GIR_EraseRootFromParent_Done,
     /* 283359 */   // Label 5790: @283359
     /* 283359 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(283459), // Rule ID 4773 //
     /* 283364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283415 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283427 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283457 */     GIR_RootConstrainSelectedInstOperands,
     /* 283458 */     // GIR_Coverage, 4773,
     /* 283458 */     GIR_EraseRootFromParent_Done,
     /* 283459 */   // Label 5791: @283459
     /* 283459 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(283559), // Rule ID 4809 //
     /* 283464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283488 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283515 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283527 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 283546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 283553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 283557 */     GIR_RootConstrainSelectedInstOperands,
     /* 283558 */     // GIR_Coverage, 4809,
     /* 283558 */     GIR_EraseRootFromParent_Done,
     /* 283559 */   // Label 5792: @283559
     /* 283559 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(283656), // Rule ID 13573 //
     /* 283564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283614 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283626 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283654 */     GIR_RootConstrainSelectedInstOperands,
     /* 283655 */     // GIR_Coverage, 13573,
     /* 283655 */     GIR_EraseRootFromParent_Done,
     /* 283656 */   // Label 5793: @283656
     /* 283656 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(283756), // Rule ID 13575 //
     /* 283661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283712 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283724 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283754 */     GIR_RootConstrainSelectedInstOperands,
     /* 283755 */     // GIR_Coverage, 13575,
     /* 283755 */     GIR_EraseRootFromParent_Done,
     /* 283756 */   // Label 5794: @283756
     /* 283756 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(283856), // Rule ID 4807 //
     /* 283761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283789 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283812 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283824 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 283843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 283854 */     GIR_RootConstrainSelectedInstOperands,
     /* 283855 */     // GIR_Coverage, 4807,
     /* 283855 */     GIR_EraseRootFromParent_Done,
     /* 283856 */   // Label 5795: @283856
     /* 283856 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(283953), // Rule ID 4771 //
     /* 283861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283901 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283911 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283951 */     GIR_RootConstrainSelectedInstOperands,
     /* 283952 */     // GIR_Coverage, 4771,
     /* 283952 */     GIR_EraseRootFromParent_Done,
     /* 283953 */   // Label 5796: @283953
     /* 283953 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(284031), // Rule ID 6119 //
     /* 283958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 283995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283999 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284003 */     // MIs[3] Operand 1
     /* 284003 */     // No operand predicates
     /* 284003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284013 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284029 */     GIR_RootConstrainSelectedInstOperands,
     /* 284030 */     // GIR_Coverage, 6119,
     /* 284030 */     GIR_EraseRootFromParent_Done,
     /* 284031 */   // Label 5797: @284031
     /* 284031 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(284115), // Rule ID 6031 //
     /* 284036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284072 */     // MIs[2] Operand 1
     /* 284072 */     // No operand predicates
     /* 284072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 284076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 284084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284095 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 284106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284113 */     GIR_RootConstrainSelectedInstOperands,
     /* 284114 */     // GIR_Coverage, 6031,
     /* 284114 */     GIR_EraseRootFromParent_Done,
     /* 284115 */   // Label 5798: @284115
     /* 284115 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(284196), // Rule ID 6063 //
     /* 284120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284164 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284168 */     // MIs[3] Operand 1
     /* 284168 */     // No operand predicates
     /* 284168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284178 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284194 */     GIR_RootConstrainSelectedInstOperands,
     /* 284195 */     // GIR_Coverage, 6063,
     /* 284195 */     GIR_EraseRootFromParent_Done,
     /* 284196 */   // Label 5799: @284196
     /* 284196 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(284280), // Rule ID 6095 //
     /* 284201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284250 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284254 */     // MIs[3] Operand 1
     /* 284254 */     // No operand predicates
     /* 284254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284260 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284278 */     GIR_RootConstrainSelectedInstOperands,
     /* 284279 */     // GIR_Coverage, 6095,
     /* 284279 */     GIR_EraseRootFromParent_Done,
     /* 284280 */   // Label 5800: @284280
     /* 284280 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(284358), // Rule ID 6141 //
     /* 284285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 284326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284330 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284334 */     // MIs[3] Operand 1
     /* 284334 */     // No operand predicates
     /* 284334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284340 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284356 */     GIR_RootConstrainSelectedInstOperands,
     /* 284357 */     // GIR_Coverage, 6141,
     /* 284357 */     GIR_EraseRootFromParent_Done,
     /* 284358 */   // Label 5801: @284358
     /* 284358 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(284439), // Rule ID 5999 //
     /* 284363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284411 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284415 */     // MIs[3] Operand 1
     /* 284415 */     // No operand predicates
     /* 284415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284421 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284437 */     GIR_RootConstrainSelectedInstOperands,
     /* 284438 */     // GIR_Coverage, 5999,
     /* 284438 */     GIR_EraseRootFromParent_Done,
     /* 284439 */   // Label 5802: @284439
     /* 284439 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(284524), // Rule ID 2451 //
     /* 284444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284468 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284482 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284494 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 284500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 284513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284522 */     GIR_RootConstrainSelectedInstOperands,
     /* 284523 */     // GIR_Coverage, 2451,
     /* 284523 */     GIR_EraseRootFromParent_Done,
     /* 284524 */   // Label 5803: @284524
     /* 284524 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(284609), // Rule ID 2449 //
     /* 284529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284557 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284567 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 284567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 284585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 284598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284607 */     GIR_RootConstrainSelectedInstOperands,
     /* 284608 */     // GIR_Coverage, 2449,
     /* 284608 */     GIR_EraseRootFromParent_Done,
     /* 284609 */   // Label 5804: @284609
     /* 284609 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(284678), // Rule ID 2543 //
     /* 284614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284650 */     // MIs[2] Operand 1
     /* 284650 */     // No operand predicates
     /* 284650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284660 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 284663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284676 */     GIR_RootConstrainSelectedInstOperands,
     /* 284677 */     // GIR_Coverage, 2543,
     /* 284677 */     GIR_EraseRootFromParent_Done,
     /* 284678 */   // Label 5805: @284678
     /* 284678 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(284747), // Rule ID 5967 //
     /* 284683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284719 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284723 */     // MIs[2] Operand 1
     /* 284723 */     // No operand predicates
     /* 284723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284729 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 284732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284745 */     GIR_RootConstrainSelectedInstOperands,
     /* 284746 */     // GIR_Coverage, 5967,
     /* 284746 */     GIR_EraseRootFromParent_Done,
     /* 284747 */   // Label 5806: @284747
     /* 284747 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(284809), // Rule ID 4822 //
     /* 284752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284792 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 284795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284807 */     GIR_RootConstrainSelectedInstOperands,
     /* 284808 */     // GIR_Coverage, 4822,
     /* 284808 */     GIR_EraseRootFromParent_Done,
     /* 284809 */   // Label 5807: @284809
     /* 284809 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(284871), // Rule ID 13588 //
     /* 284814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284854 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 284857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 284865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284869 */     GIR_RootConstrainSelectedInstOperands,
     /* 284870 */     // GIR_Coverage, 13588,
     /* 284870 */     GIR_EraseRootFromParent_Done,
     /* 284871 */   // Label 5808: @284871
     /* 284871 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(284918), // Rule ID 4819 //
     /* 284876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284903 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284916 */     GIR_RootConstrainSelectedInstOperands,
     /* 284917 */     // GIR_Coverage, 4819,
     /* 284917 */     GIR_EraseRootFromParent_Done,
     /* 284918 */   // Label 5809: @284918
     /* 284918 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(284968), // Rule ID 13015 //
     /* 284923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284953 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284966 */     GIR_RootConstrainSelectedInstOperands,
     /* 284967 */     // GIR_Coverage, 13015,
     /* 284967 */     GIR_EraseRootFromParent_Done,
     /* 284968 */   // Label 5810: @284968
     /* 284968 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(285018), // Rule ID 646 //
     /* 284973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285003 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285016 */     GIR_RootConstrainSelectedInstOperands,
     /* 285017 */     // GIR_Coverage, 646,
     /* 285017 */     GIR_EraseRootFromParent_Done,
     /* 285018 */   // Label 5811: @285018
     /* 285018 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(285065), // Rule ID 13585 //
     /* 285023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285050 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 285061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285063 */     GIR_RootConstrainSelectedInstOperands,
     /* 285064 */     // GIR_Coverage, 13585,
     /* 285064 */     GIR_EraseRootFromParent_Done,
     /* 285065 */   // Label 5812: @285065
     /* 285065 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(285115), // Rule ID 658 //
     /* 285070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 285085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285100 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 285103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 285109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 285113 */     GIR_RootConstrainSelectedInstOperands,
     /* 285114 */     // GIR_Coverage, 658,
     /* 285114 */     GIR_EraseRootFromParent_Done,
     /* 285115 */   // Label 5813: @285115
     /* 285115 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(285146), // Rule ID 640 //
     /* 285120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285135 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 285140 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285144 */     GIR_RootConstrainSelectedInstOperands,
     /* 285145 */     // GIR_Coverage, 640,
     /* 285145 */     GIR_Done,
     /* 285146 */   // Label 5814: @285146
     /* 285146 */   GIM_Reject,
     /* 285147 */ // Label 5780: @285147
     /* 285147 */ GIM_Reject,
     /* 285148 */ // Label 5740: @285148
     /* 285148 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(288295),
     /* 285153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 285162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285166 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(285316), // Rule ID 4817 //
     /* 285171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285220 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 285228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 285236 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285243 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285255 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285266 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285283 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 285302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 285314 */     GIR_RootConstrainSelectedInstOperands,
     /* 285315 */     // GIR_Coverage, 4817,
     /* 285315 */     GIR_EraseRootFromParent_Done,
     /* 285316 */   // Label 5816: @285316
     /* 285316 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(285463), // Rule ID 4781 //
     /* 285321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285345 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 285361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285373 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285382 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285392 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285392 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285395 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285399 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285404 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 285451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285461 */     GIR_RootConstrainSelectedInstOperands,
     /* 285462 */     // GIR_Coverage, 4781,
     /* 285462 */     GIR_EraseRootFromParent_Done,
     /* 285463 */   // Label 5817: @285463
     /* 285463 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(285610), // Rule ID 13583 //
     /* 285468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285504 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285529 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285539 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285551 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285562 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 285598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285608 */     GIR_RootConstrainSelectedInstOperands,
     /* 285609 */     // GIR_Coverage, 13583,
     /* 285609 */     GIR_EraseRootFromParent_Done,
     /* 285610 */   // Label 5818: @285610
     /* 285610 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(285741), // Rule ID 6005 //
     /* 285615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 285655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 285680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285684 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 285688 */     // MIs[4] Operand 1
     /* 285688 */     // No operand predicates
     /* 285688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285692 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285694 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 285694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285706 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 285725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 285736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 285739 */     GIR_RootConstrainSelectedInstOperands,
     /* 285740 */     // GIR_Coverage, 6005,
     /* 285740 */     GIR_EraseRootFromParent_Done,
     /* 285741 */   // Label 5819: @285741
     /* 285741 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(285872), // Rule ID 6037 //
     /* 285746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285778 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 285782 */     // MIs[2] Operand 1
     /* 285782 */     // No operand predicates
     /* 285782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 285794 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 285798 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285802 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285806 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 285810 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285815 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 285819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285823 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285825 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 285825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285837 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 285856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285870 */     GIR_RootConstrainSelectedInstOperands,
     /* 285871 */     // GIR_Coverage, 6037,
     /* 285871 */     GIR_EraseRootFromParent_Done,
     /* 285872 */   // Label 5820: @285872
     /* 285872 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(286003), // Rule ID 6101 //
     /* 285877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285913 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 285942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 285950 */     // MIs[4] Operand 1
     /* 285950 */     // No operand predicates
     /* 285950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285954 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285956 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 285956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285968 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 285987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 285998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 286001 */     GIR_RootConstrainSelectedInstOperands,
     /* 286002 */     // GIR_Coverage, 6101,
     /* 286002 */     GIR_EraseRootFromParent_Done,
     /* 286003 */   // Label 5821: @286003
     /* 286003 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(286134), // Rule ID 6069 //
     /* 286008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286052 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286056 */     // MIs[3] Operand 1
     /* 286056 */     // No operand predicates
     /* 286056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 286060 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286064 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286068 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 286072 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286077 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 286081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286087 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286132 */     GIR_RootConstrainSelectedInstOperands,
     /* 286133 */     // GIR_Coverage, 6069,
     /* 286133 */     GIR_EraseRootFromParent_Done,
     /* 286134 */   // Label 5822: @286134
     /* 286134 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(286269), // Rule ID 2459 //
     /* 286139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286163 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286188 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286198 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 286201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286210 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286221 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286238 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 286257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286267 */     GIR_RootConstrainSelectedInstOperands,
     /* 286268 */     // GIR_Coverage, 2459,
     /* 286268 */     GIR_EraseRootFromParent_Done,
     /* 286269 */   // Label 5823: @286269
     /* 286269 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(286388), // Rule ID 5973 //
     /* 286274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286298 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286335 */     // MIs[3] Operand 1
     /* 286335 */     // No operand predicates
     /* 286335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286341 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286353 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 286372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286386 */     GIR_RootConstrainSelectedInstOperands,
     /* 286387 */     // GIR_Coverage, 5973,
     /* 286387 */     GIR_EraseRootFromParent_Done,
     /* 286388 */   // Label 5824: @286388
     /* 286388 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(286507), // Rule ID 2549 //
     /* 286393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286425 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286429 */     // MIs[2] Operand 1
     /* 286429 */     // No operand predicates
     /* 286429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286437 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286441 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286445 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286450 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286460 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286472 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 286491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286505 */     GIR_RootConstrainSelectedInstOperands,
     /* 286506 */     // GIR_Coverage, 2549,
     /* 286506 */     GIR_EraseRootFromParent_Done,
     /* 286507 */   // Label 5825: @286507
     /* 286507 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(286607), // Rule ID 4779 //
     /* 286512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286536 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286563 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 286563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286575 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286605 */     GIR_RootConstrainSelectedInstOperands,
     /* 286606 */     // GIR_Coverage, 4779,
     /* 286606 */     GIR_EraseRootFromParent_Done,
     /* 286607 */   // Label 5826: @286607
     /* 286607 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(286707), // Rule ID 4815 //
     /* 286612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286636 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 286648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286663 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 286663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 286694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 286705 */     GIR_RootConstrainSelectedInstOperands,
     /* 286706 */     // GIR_Coverage, 4815,
     /* 286706 */     GIR_EraseRootFromParent_Done,
     /* 286707 */   // Label 5827: @286707
     /* 286707 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(286804), // Rule ID 13579 //
     /* 286712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286748 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286762 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286774 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286802 */     GIR_RootConstrainSelectedInstOperands,
     /* 286803 */     // GIR_Coverage, 13579,
     /* 286803 */     GIR_EraseRootFromParent_Done,
     /* 286804 */   // Label 5828: @286804
     /* 286804 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(286904), // Rule ID 13581 //
     /* 286809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286850 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286860 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 286860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286872 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286902 */     GIR_RootConstrainSelectedInstOperands,
     /* 286903 */     // GIR_Coverage, 13581,
     /* 286903 */     GIR_EraseRootFromParent_Done,
     /* 286904 */   // Label 5829: @286904
     /* 286904 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(287004), // Rule ID 4813 //
     /* 286909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 286945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286960 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 286991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287002 */     GIR_RootConstrainSelectedInstOperands,
     /* 287003 */     // GIR_Coverage, 4813,
     /* 287003 */     GIR_EraseRootFromParent_Done,
     /* 287004 */   // Label 5830: @287004
     /* 287004 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(287101), // Rule ID 4777 //
     /* 287009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287049 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287059 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287071 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 287090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287099 */     GIR_RootConstrainSelectedInstOperands,
     /* 287100 */     // GIR_Coverage, 4777,
     /* 287100 */     GIR_EraseRootFromParent_Done,
     /* 287101 */   // Label 5831: @287101
     /* 287101 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(287179), // Rule ID 6123 //
     /* 287106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287147 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287151 */     // MIs[3] Operand 1
     /* 287151 */     // No operand predicates
     /* 287151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287161 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287177 */     GIR_RootConstrainSelectedInstOperands,
     /* 287178 */     // GIR_Coverage, 6123,
     /* 287178 */     GIR_EraseRootFromParent_Done,
     /* 287179 */   // Label 5832: @287179
     /* 287179 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(287263), // Rule ID 6035 //
     /* 287184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287220 */     // MIs[2] Operand 1
     /* 287220 */     // No operand predicates
     /* 287220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 287232 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287243 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 287254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287261 */     GIR_RootConstrainSelectedInstOperands,
     /* 287262 */     // GIR_Coverage, 6035,
     /* 287262 */     GIR_EraseRootFromParent_Done,
     /* 287263 */   // Label 5833: @287263
     /* 287263 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(287344), // Rule ID 6067 //
     /* 287268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287312 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287316 */     // MIs[3] Operand 1
     /* 287316 */     // No operand predicates
     /* 287316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287326 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287342 */     GIR_RootConstrainSelectedInstOperands,
     /* 287343 */     // GIR_Coverage, 6067,
     /* 287343 */     GIR_EraseRootFromParent_Done,
     /* 287344 */   // Label 5834: @287344
     /* 287344 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(287428), // Rule ID 6099 //
     /* 287349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287398 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287402 */     // MIs[3] Operand 1
     /* 287402 */     // No operand predicates
     /* 287402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287408 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287426 */     GIR_RootConstrainSelectedInstOperands,
     /* 287427 */     // GIR_Coverage, 6099,
     /* 287427 */     GIR_EraseRootFromParent_Done,
     /* 287428 */   // Label 5835: @287428
     /* 287428 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(287506), // Rule ID 6145 //
     /* 287433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287482 */     // MIs[3] Operand 1
     /* 287482 */     // No operand predicates
     /* 287482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287488 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287504 */     GIR_RootConstrainSelectedInstOperands,
     /* 287505 */     // GIR_Coverage, 6145,
     /* 287505 */     GIR_EraseRootFromParent_Done,
     /* 287506 */   // Label 5836: @287506
     /* 287506 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(287587), // Rule ID 6003 //
     /* 287511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287559 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287563 */     // MIs[3] Operand 1
     /* 287563 */     // No operand predicates
     /* 287563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287569 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287585 */     GIR_RootConstrainSelectedInstOperands,
     /* 287586 */     // GIR_Coverage, 6003,
     /* 287586 */     GIR_EraseRootFromParent_Done,
     /* 287587 */   // Label 5837: @287587
     /* 287587 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(287672), // Rule ID 2457 //
     /* 287592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287616 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287630 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287642 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 287661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287670 */     GIR_RootConstrainSelectedInstOperands,
     /* 287671 */     // GIR_Coverage, 2457,
     /* 287671 */     GIR_EraseRootFromParent_Done,
     /* 287672 */   // Label 5838: @287672
     /* 287672 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(287757), // Rule ID 2455 //
     /* 287677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287705 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287715 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287727 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 287746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287755 */     GIR_RootConstrainSelectedInstOperands,
     /* 287756 */     // GIR_Coverage, 2455,
     /* 287756 */     GIR_EraseRootFromParent_Done,
     /* 287757 */   // Label 5839: @287757
     /* 287757 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(287826), // Rule ID 2547 //
     /* 287762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287794 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287798 */     // MIs[2] Operand 1
     /* 287798 */     // No operand predicates
     /* 287798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287808 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 287811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287824 */     GIR_RootConstrainSelectedInstOperands,
     /* 287825 */     // GIR_Coverage, 2547,
     /* 287825 */     GIR_EraseRootFromParent_Done,
     /* 287826 */   // Label 5840: @287826
     /* 287826 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(287895), // Rule ID 5971 //
     /* 287831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287871 */     // MIs[2] Operand 1
     /* 287871 */     // No operand predicates
     /* 287871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287877 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 287880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287893 */     GIR_RootConstrainSelectedInstOperands,
     /* 287894 */     // GIR_Coverage, 5971,
     /* 287894 */     GIR_EraseRootFromParent_Done,
     /* 287895 */   // Label 5841: @287895
     /* 287895 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(287957), // Rule ID 4823 //
     /* 287900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 287933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287940 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 287943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287955 */     GIR_RootConstrainSelectedInstOperands,
     /* 287956 */     // GIR_Coverage, 4823,
     /* 287956 */     GIR_EraseRootFromParent_Done,
     /* 287957 */   // Label 5842: @287957
     /* 287957 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(288019), // Rule ID 13589 //
     /* 287962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 287995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288002 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 288005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 288017 */     GIR_RootConstrainSelectedInstOperands,
     /* 288018 */     // GIR_Coverage, 13589,
     /* 288018 */     GIR_EraseRootFromParent_Done,
     /* 288019 */   // Label 5843: @288019
     /* 288019 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(288066), // Rule ID 4820 //
     /* 288024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288051 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288064 */     GIR_RootConstrainSelectedInstOperands,
     /* 288065 */     // GIR_Coverage, 4820,
     /* 288065 */     GIR_EraseRootFromParent_Done,
     /* 288066 */   // Label 5844: @288066
     /* 288066 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(288116), // Rule ID 13017 //
     /* 288071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288101 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288114 */     GIR_RootConstrainSelectedInstOperands,
     /* 288115 */     // GIR_Coverage, 13017,
     /* 288115 */     GIR_EraseRootFromParent_Done,
     /* 288116 */   // Label 5845: @288116
     /* 288116 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(288166), // Rule ID 648 //
     /* 288121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288151 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288164 */     GIR_RootConstrainSelectedInstOperands,
     /* 288165 */     // GIR_Coverage, 648,
     /* 288165 */     GIR_EraseRootFromParent_Done,
     /* 288166 */   // Label 5846: @288166
     /* 288166 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(288213), // Rule ID 13586 //
     /* 288171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288198 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288211 */     GIR_RootConstrainSelectedInstOperands,
     /* 288212 */     // GIR_Coverage, 13586,
     /* 288212 */     GIR_EraseRootFromParent_Done,
     /* 288213 */   // Label 5847: @288213
     /* 288213 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(288263), // Rule ID 660 //
     /* 288218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288248 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 288251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 288261 */     GIR_RootConstrainSelectedInstOperands,
     /* 288262 */     // GIR_Coverage, 660,
     /* 288262 */     GIR_EraseRootFromParent_Done,
     /* 288263 */   // Label 5848: @288263
     /* 288263 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(288294), // Rule ID 642 //
     /* 288268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288283 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 288288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288292 */     GIR_RootConstrainSelectedInstOperands,
     /* 288293 */     // GIR_Coverage, 642,
     /* 288293 */     GIR_Done,
     /* 288294 */   // Label 5849: @288294
     /* 288294 */   GIM_Reject,
     /* 288295 */ // Label 5815: @288295
     /* 288295 */ GIM_Reject,
     /* 288296 */ // Label 5741: @288296
     /* 288296 */ GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(289816),
     /* 288301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 288307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 288310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288314 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(288392), // Rule ID 6103 //
     /* 288319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 288356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288360 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288364 */     // MIs[3] Operand 1
     /* 288364 */     // No operand predicates
     /* 288364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288374 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288390 */     GIR_RootConstrainSelectedInstOperands,
     /* 288391 */     // GIR_Coverage, 6103,
     /* 288391 */     GIR_EraseRootFromParent_Done,
     /* 288392 */   // Label 5851: @288392
     /* 288392 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(288476), // Rule ID 6019 //
     /* 288397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288433 */     // MIs[2] Operand 1
     /* 288433 */     // No operand predicates
     /* 288433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288441 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288445 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288456 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 288467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288474 */     GIR_RootConstrainSelectedInstOperands,
     /* 288475 */     // GIR_Coverage, 6019,
     /* 288475 */     GIR_EraseRootFromParent_Done,
     /* 288476 */   // Label 5852: @288476
     /* 288476 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(288557), // Rule ID 6051 //
     /* 288481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288525 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288529 */     // MIs[3] Operand 1
     /* 288529 */     // No operand predicates
     /* 288529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288539 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288555 */     GIR_RootConstrainSelectedInstOperands,
     /* 288556 */     // GIR_Coverage, 6051,
     /* 288556 */     GIR_EraseRootFromParent_Done,
     /* 288557 */   // Label 5853: @288557
     /* 288557 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(288641), // Rule ID 6083 //
     /* 288562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288611 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288615 */     // MIs[3] Operand 1
     /* 288615 */     // No operand predicates
     /* 288615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288621 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288639 */     GIR_RootConstrainSelectedInstOperands,
     /* 288640 */     // GIR_Coverage, 6083,
     /* 288640 */     GIR_EraseRootFromParent_Done,
     /* 288641 */   // Label 5854: @288641
     /* 288641 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(288719), // Rule ID 6125 //
     /* 288646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 288687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288695 */     // MIs[3] Operand 1
     /* 288695 */     // No operand predicates
     /* 288695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288701 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288717 */     GIR_RootConstrainSelectedInstOperands,
     /* 288718 */     // GIR_Coverage, 6125,
     /* 288718 */     GIR_EraseRootFromParent_Done,
     /* 288719 */   // Label 5855: @288719
     /* 288719 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(288800), // Rule ID 5987 //
     /* 288724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288772 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288776 */     // MIs[3] Operand 1
     /* 288776 */     // No operand predicates
     /* 288776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288782 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288798 */     GIR_RootConstrainSelectedInstOperands,
     /* 288799 */     // GIR_Coverage, 5987,
     /* 288799 */     GIR_EraseRootFromParent_Done,
     /* 288800 */   // Label 5856: @288800
     /* 288800 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(288869), // Rule ID 2531 //
     /* 288805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288837 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288841 */     // MIs[2] Operand 1
     /* 288841 */     // No operand predicates
     /* 288841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288851 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 288854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288867 */     GIR_RootConstrainSelectedInstOperands,
     /* 288868 */     // GIR_Coverage, 2531,
     /* 288868 */     GIR_EraseRootFromParent_Done,
     /* 288869 */   // Label 5857: @288869
     /* 288869 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(288938), // Rule ID 5955 //
     /* 288874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288914 */     // MIs[2] Operand 1
     /* 288914 */     // No operand predicates
     /* 288914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288920 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 288923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288936 */     GIR_RootConstrainSelectedInstOperands,
     /* 288937 */     // GIR_Coverage, 5955,
     /* 288937 */     GIR_EraseRootFromParent_Done,
     /* 288938 */   // Label 5858: @288938
     /* 288938 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(289031), // Rule ID 6107 //
     /* 288943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288982 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 288985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289029 */     GIR_RootConstrainSelectedInstOperands,
     /* 289030 */     // GIR_Coverage, 6107,
     /* 289030 */     GIR_EraseRootFromParent_Done,
     /* 289031 */   // Label 5859: @289031
     /* 289031 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(289130), // Rule ID 6021 //
     /* 289036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289079 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289091 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 289122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289128 */     GIR_RootConstrainSelectedInstOperands,
     /* 289129 */     // GIR_Coverage, 6021,
     /* 289129 */     GIR_EraseRootFromParent_Done,
     /* 289130 */   // Label 5860: @289130
     /* 289130 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(289226), // Rule ID 6053 //
     /* 289135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289177 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289196 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289224 */     GIR_RootConstrainSelectedInstOperands,
     /* 289225 */     // GIR_Coverage, 6053,
     /* 289225 */     GIR_EraseRootFromParent_Done,
     /* 289226 */   // Label 5861: @289226
     /* 289226 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(289325), // Rule ID 6085 //
     /* 289231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289274 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289293 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289323 */     GIR_RootConstrainSelectedInstOperands,
     /* 289324 */     // GIR_Coverage, 6085,
     /* 289324 */     GIR_EraseRootFromParent_Done,
     /* 289325 */   // Label 5862: @289325
     /* 289325 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(289418), // Rule ID 6129 //
     /* 289330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289369 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289416 */     GIR_RootConstrainSelectedInstOperands,
     /* 289417 */     // GIR_Coverage, 6129,
     /* 289417 */     GIR_EraseRootFromParent_Done,
     /* 289418 */   // Label 5863: @289418
     /* 289418 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(289514), // Rule ID 5989 //
     /* 289423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289465 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289477 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289512 */     GIR_RootConstrainSelectedInstOperands,
     /* 289513 */     // GIR_Coverage, 5989,
     /* 289513 */     GIR_EraseRootFromParent_Done,
     /* 289514 */   // Label 5864: @289514
     /* 289514 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(289598), // Rule ID 2533 //
     /* 289519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289549 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289561 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 289584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289596 */     GIR_RootConstrainSelectedInstOperands,
     /* 289597 */     // GIR_Coverage, 2533,
     /* 289597 */     GIR_EraseRootFromParent_Done,
     /* 289598 */   // Label 5865: @289598
     /* 289598 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(289648), // Rule ID 13047 //
     /* 289603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289633 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 289636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289646 */     GIR_RootConstrainSelectedInstOperands,
     /* 289647 */     // GIR_Coverage, 13047,
     /* 289647 */     GIR_EraseRootFromParent_Done,
     /* 289648 */   // Label 5866: @289648
     /* 289648 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(289732), // Rule ID 5957 //
     /* 289653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289683 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289695 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289702 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 289718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289730 */     GIR_RootConstrainSelectedInstOperands,
     /* 289731 */     // GIR_Coverage, 5957,
     /* 289731 */     GIR_EraseRootFromParent_Done,
     /* 289732 */   // Label 5867: @289732
     /* 289732 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(289782), // Rule ID 1301 //
     /* 289737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289767 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 289770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289780 */     GIR_RootConstrainSelectedInstOperands,
     /* 289781 */     // GIR_Coverage, 1301,
     /* 289781 */     GIR_EraseRootFromParent_Done,
     /* 289782 */   // Label 5868: @289782
     /* 289782 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(289815), // Rule ID 1291 //
     /* 289787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289802 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 289805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 289813 */     GIR_RootConstrainSelectedInstOperands,
     /* 289814 */     // GIR_Coverage, 1291,
     /* 289814 */     GIR_EraseRootFromParent_Done,
     /* 289815 */   // Label 5869: @289815
     /* 289815 */   GIM_Reject,
     /* 289816 */ // Label 5850: @289816
     /* 289816 */ GIM_Reject,
     /* 289817 */ // Label 5742: @289817
     /* 289817 */ GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(291337),
     /* 289822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 289828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 289831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289835 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(289913), // Rule ID 6115 //
     /* 289840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 289848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 289877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289885 */     // MIs[3] Operand 1
     /* 289885 */     // No operand predicates
     /* 289885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289895 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 289898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289911 */     GIR_RootConstrainSelectedInstOperands,
     /* 289912 */     // GIR_Coverage, 6115,
     /* 289912 */     GIR_EraseRootFromParent_Done,
     /* 289913 */   // Label 5871: @289913
     /* 289913 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(289997), // Rule ID 6027 //
     /* 289918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 289929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289954 */     // MIs[2] Operand 1
     /* 289954 */     // No operand predicates
     /* 289954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289966 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289977 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 289980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 289988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289995 */     GIR_RootConstrainSelectedInstOperands,
     /* 289996 */     // GIR_Coverage, 6027,
     /* 289996 */     GIR_EraseRootFromParent_Done,
     /* 289997 */   // Label 5872: @289997
     /* 289997 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(290078), // Rule ID 6059 //
     /* 290002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290046 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290050 */     // MIs[3] Operand 1
     /* 290050 */     // No operand predicates
     /* 290050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290060 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290076 */     GIR_RootConstrainSelectedInstOperands,
     /* 290077 */     // GIR_Coverage, 6059,
     /* 290077 */     GIR_EraseRootFromParent_Done,
     /* 290078 */   // Label 5873: @290078
     /* 290078 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(290162), // Rule ID 6091 //
     /* 290083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290132 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290136 */     // MIs[3] Operand 1
     /* 290136 */     // No operand predicates
     /* 290136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290142 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290160 */     GIR_RootConstrainSelectedInstOperands,
     /* 290161 */     // GIR_Coverage, 6091,
     /* 290161 */     GIR_EraseRootFromParent_Done,
     /* 290162 */   // Label 5874: @290162
     /* 290162 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(290240), // Rule ID 6137 //
     /* 290167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290212 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290216 */     // MIs[3] Operand 1
     /* 290216 */     // No operand predicates
     /* 290216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290222 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290238 */     GIR_RootConstrainSelectedInstOperands,
     /* 290239 */     // GIR_Coverage, 6137,
     /* 290239 */     GIR_EraseRootFromParent_Done,
     /* 290240 */   // Label 5875: @290240
     /* 290240 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(290321), // Rule ID 5995 //
     /* 290245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290297 */     // MIs[3] Operand 1
     /* 290297 */     // No operand predicates
     /* 290297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290303 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290319 */     GIR_RootConstrainSelectedInstOperands,
     /* 290320 */     // GIR_Coverage, 5995,
     /* 290320 */     GIR_EraseRootFromParent_Done,
     /* 290321 */   // Label 5876: @290321
     /* 290321 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(290390), // Rule ID 2539 //
     /* 290326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290362 */     // MIs[2] Operand 1
     /* 290362 */     // No operand predicates
     /* 290362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290372 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 290375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290388 */     GIR_RootConstrainSelectedInstOperands,
     /* 290389 */     // GIR_Coverage, 2539,
     /* 290389 */     GIR_EraseRootFromParent_Done,
     /* 290390 */   // Label 5877: @290390
     /* 290390 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(290459), // Rule ID 5963 //
     /* 290395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290431 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290435 */     // MIs[2] Operand 1
     /* 290435 */     // No operand predicates
     /* 290435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290441 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 290444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290457 */     GIR_RootConstrainSelectedInstOperands,
     /* 290458 */     // GIR_Coverage, 5963,
     /* 290458 */     GIR_EraseRootFromParent_Done,
     /* 290459 */   // Label 5878: @290459
     /* 290459 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(290552), // Rule ID 6117 //
     /* 290464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290503 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290550 */     GIR_RootConstrainSelectedInstOperands,
     /* 290551 */     // GIR_Coverage, 6117,
     /* 290551 */     GIR_EraseRootFromParent_Done,
     /* 290552 */   // Label 5879: @290552
     /* 290552 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(290651), // Rule ID 6029 //
     /* 290557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290600 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290612 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 290643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290649 */     GIR_RootConstrainSelectedInstOperands,
     /* 290650 */     // GIR_Coverage, 6029,
     /* 290650 */     GIR_EraseRootFromParent_Done,
     /* 290651 */   // Label 5880: @290651
     /* 290651 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(290747), // Rule ID 6061 //
     /* 290656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 290679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290698 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290745 */     GIR_RootConstrainSelectedInstOperands,
     /* 290746 */     // GIR_Coverage, 6061,
     /* 290746 */     GIR_EraseRootFromParent_Done,
     /* 290747 */   // Label 5881: @290747
     /* 290747 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(290846), // Rule ID 6093 //
     /* 290752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 290780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290795 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290844 */     GIR_RootConstrainSelectedInstOperands,
     /* 290845 */     // GIR_Coverage, 6093,
     /* 290845 */     GIR_EraseRootFromParent_Done,
     /* 290846 */   // Label 5882: @290846
     /* 290846 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(290939), // Rule ID 6139 //
     /* 290851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290890 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290937 */     GIR_RootConstrainSelectedInstOperands,
     /* 290938 */     // GIR_Coverage, 6139,
     /* 290938 */     GIR_EraseRootFromParent_Done,
     /* 290939 */   // Label 5883: @290939
     /* 290939 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(291035), // Rule ID 5997 //
     /* 290944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 290971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290986 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291033 */     GIR_RootConstrainSelectedInstOperands,
     /* 291034 */     // GIR_Coverage, 5997,
     /* 291034 */     GIR_EraseRootFromParent_Done,
     /* 291035 */   // Label 5884: @291035
     /* 291035 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(291119), // Rule ID 2541 //
     /* 291040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291070 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 291105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291117 */     GIR_RootConstrainSelectedInstOperands,
     /* 291118 */     // GIR_Coverage, 2541,
     /* 291118 */     GIR_EraseRootFromParent_Done,
     /* 291119 */   // Label 5885: @291119
     /* 291119 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(291169), // Rule ID 13051 //
     /* 291124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291154 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 291157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291167 */     GIR_RootConstrainSelectedInstOperands,
     /* 291168 */     // GIR_Coverage, 13051,
     /* 291168 */     GIR_EraseRootFromParent_Done,
     /* 291169 */   // Label 5886: @291169
     /* 291169 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(291253), // Rule ID 5965 //
     /* 291174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291204 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 291239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291251 */     GIR_RootConstrainSelectedInstOperands,
     /* 291252 */     // GIR_Coverage, 5965,
     /* 291252 */     GIR_EraseRootFromParent_Done,
     /* 291253 */   // Label 5887: @291253
     /* 291253 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(291303), // Rule ID 1305 //
     /* 291258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291288 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 291291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291301 */     GIR_RootConstrainSelectedInstOperands,
     /* 291302 */     // GIR_Coverage, 1305,
     /* 291302 */     GIR_EraseRootFromParent_Done,
     /* 291303 */   // Label 5888: @291303
     /* 291303 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(291336), // Rule ID 1295 //
     /* 291308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291323 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 291326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 291334 */     GIR_RootConstrainSelectedInstOperands,
     /* 291335 */     // GIR_Coverage, 1295,
     /* 291335 */     GIR_EraseRootFromParent_Done,
     /* 291336 */   // Label 5889: @291336
     /* 291336 */   GIM_Reject,
     /* 291337 */ // Label 5870: @291337
     /* 291337 */ GIM_Reject,
     /* 291338 */ // Label 5743: @291338
     /* 291338 */ GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(292516),
     /* 291343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291349 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 291352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291356 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(291440), // Rule ID 6011 //
     /* 291361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291397 */     // MIs[2] Operand 1
     /* 291397 */     // No operand predicates
     /* 291397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291405 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291420 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291438 */     GIR_RootConstrainSelectedInstOperands,
     /* 291439 */     // GIR_Coverage, 6011,
     /* 291439 */     GIR_EraseRootFromParent_Done,
     /* 291440 */   // Label 5891: @291440
     /* 291440 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(291521), // Rule ID 6043 //
     /* 291445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291493 */     // MIs[3] Operand 1
     /* 291493 */     // No operand predicates
     /* 291493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291503 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291519 */     GIR_RootConstrainSelectedInstOperands,
     /* 291520 */     // GIR_Coverage, 6043,
     /* 291520 */     GIR_EraseRootFromParent_Done,
     /* 291521 */   // Label 5892: @291521
     /* 291521 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(291605), // Rule ID 6075 //
     /* 291526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291579 */     // MIs[3] Operand 1
     /* 291579 */     // No operand predicates
     /* 291579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291585 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291603 */     GIR_RootConstrainSelectedInstOperands,
     /* 291604 */     // GIR_Coverage, 6075,
     /* 291604 */     GIR_EraseRootFromParent_Done,
     /* 291605 */   // Label 5893: @291605
     /* 291605 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(291686), // Rule ID 5979 //
     /* 291610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291658 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291662 */     // MIs[3] Operand 1
     /* 291662 */     // No operand predicates
     /* 291662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291668 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291684 */     GIR_RootConstrainSelectedInstOperands,
     /* 291685 */     // GIR_Coverage, 5979,
     /* 291685 */     GIR_EraseRootFromParent_Done,
     /* 291686 */   // Label 5894: @291686
     /* 291686 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(291755), // Rule ID 2523 //
     /* 291691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291727 */     // MIs[2] Operand 1
     /* 291727 */     // No operand predicates
     /* 291727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291737 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 291740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291753 */     GIR_RootConstrainSelectedInstOperands,
     /* 291754 */     // GIR_Coverage, 2523,
     /* 291754 */     GIR_EraseRootFromParent_Done,
     /* 291755 */   // Label 5895: @291755
     /* 291755 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(291824), // Rule ID 5947 //
     /* 291760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291796 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291800 */     // MIs[2] Operand 1
     /* 291800 */     // No operand predicates
     /* 291800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291806 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 291809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291822 */     GIR_RootConstrainSelectedInstOperands,
     /* 291823 */     // GIR_Coverage, 5947,
     /* 291823 */     GIR_EraseRootFromParent_Done,
     /* 291824 */   // Label 5896: @291824
     /* 291824 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(291923), // Rule ID 6013 //
     /* 291829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 291849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291872 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 291875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 291894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 291904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 291915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291921 */     GIR_RootConstrainSelectedInstOperands,
     /* 291922 */     // GIR_Coverage, 6013,
     /* 291922 */     GIR_EraseRootFromParent_Done,
     /* 291923 */   // Label 5897: @291923
     /* 291923 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(292019), // Rule ID 6045 //
     /* 291928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 291951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 291960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291970 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 291973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 291992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292017 */     GIR_RootConstrainSelectedInstOperands,
     /* 292018 */     // GIR_Coverage, 6045,
     /* 292018 */     GIR_EraseRootFromParent_Done,
     /* 292019 */   // Label 5898: @292019
     /* 292019 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(292118), // Rule ID 6077 //
     /* 292024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292067 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292086 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292116 */     GIR_RootConstrainSelectedInstOperands,
     /* 292117 */     // GIR_Coverage, 6077,
     /* 292117 */     GIR_EraseRootFromParent_Done,
     /* 292118 */   // Label 5899: @292118
     /* 292118 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(292214), // Rule ID 5981 //
     /* 292123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292165 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292212 */     GIR_RootConstrainSelectedInstOperands,
     /* 292213 */     // GIR_Coverage, 5981,
     /* 292213 */     GIR_EraseRootFromParent_Done,
     /* 292214 */   // Label 5900: @292214
     /* 292214 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(292298), // Rule ID 2525 //
     /* 292219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292249 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292261 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292296 */     GIR_RootConstrainSelectedInstOperands,
     /* 292297 */     // GIR_Coverage, 2525,
     /* 292297 */     GIR_EraseRootFromParent_Done,
     /* 292298 */   // Label 5901: @292298
     /* 292298 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(292348), // Rule ID 13043 //
     /* 292303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292333 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 292336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292346 */     GIR_RootConstrainSelectedInstOperands,
     /* 292347 */     // GIR_Coverage, 13043,
     /* 292347 */     GIR_EraseRootFromParent_Done,
     /* 292348 */   // Label 5902: @292348
     /* 292348 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(292432), // Rule ID 5949 //
     /* 292353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292383 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292430 */     GIR_RootConstrainSelectedInstOperands,
     /* 292431 */     // GIR_Coverage, 5949,
     /* 292431 */     GIR_EraseRootFromParent_Done,
     /* 292432 */   // Label 5903: @292432
     /* 292432 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(292482), // Rule ID 1297 //
     /* 292437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292467 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 292470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292480 */     GIR_RootConstrainSelectedInstOperands,
     /* 292481 */     // GIR_Coverage, 1297,
     /* 292481 */     GIR_EraseRootFromParent_Done,
     /* 292482 */   // Label 5904: @292482
     /* 292482 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(292515), // Rule ID 1287 //
     /* 292487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292502 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 292505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292513 */     GIR_RootConstrainSelectedInstOperands,
     /* 292514 */     // GIR_Coverage, 1287,
     /* 292514 */     GIR_EraseRootFromParent_Done,
     /* 292515 */   // Label 5905: @292515
     /* 292515 */   GIM_Reject,
     /* 292516 */ // Label 5890: @292516
     /* 292516 */ GIM_Reject,
     /* 292517 */ // Label 5744: @292517
     /* 292517 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(294037),
     /* 292522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292535 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(292613), // Rule ID 6109 //
     /* 292540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 292577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292581 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292585 */     // MIs[3] Operand 1
     /* 292585 */     // No operand predicates
     /* 292585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292595 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292611 */     GIR_RootConstrainSelectedInstOperands,
     /* 292612 */     // GIR_Coverage, 6109,
     /* 292612 */     GIR_EraseRootFromParent_Done,
     /* 292613 */   // Label 5907: @292613
     /* 292613 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(292697), // Rule ID 6023 //
     /* 292618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292654 */     // MIs[2] Operand 1
     /* 292654 */     // No operand predicates
     /* 292654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292662 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292666 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292677 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 292688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292695 */     GIR_RootConstrainSelectedInstOperands,
     /* 292696 */     // GIR_Coverage, 6023,
     /* 292696 */     GIR_EraseRootFromParent_Done,
     /* 292697 */   // Label 5908: @292697
     /* 292697 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(292778), // Rule ID 6055 //
     /* 292702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292746 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292750 */     // MIs[3] Operand 1
     /* 292750 */     // No operand predicates
     /* 292750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292760 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292776 */     GIR_RootConstrainSelectedInstOperands,
     /* 292777 */     // GIR_Coverage, 6055,
     /* 292777 */     GIR_EraseRootFromParent_Done,
     /* 292778 */   // Label 5909: @292778
     /* 292778 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(292862), // Rule ID 6087 //
     /* 292783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292832 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292836 */     // MIs[3] Operand 1
     /* 292836 */     // No operand predicates
     /* 292836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292842 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292860 */     GIR_RootConstrainSelectedInstOperands,
     /* 292861 */     // GIR_Coverage, 6087,
     /* 292861 */     GIR_EraseRootFromParent_Done,
     /* 292862 */   // Label 5910: @292862
     /* 292862 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(292940), // Rule ID 6131 //
     /* 292867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 292908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292912 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292916 */     // MIs[3] Operand 1
     /* 292916 */     // No operand predicates
     /* 292916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292922 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292938 */     GIR_RootConstrainSelectedInstOperands,
     /* 292939 */     // GIR_Coverage, 6131,
     /* 292939 */     GIR_EraseRootFromParent_Done,
     /* 292940 */   // Label 5911: @292940
     /* 292940 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(293021), // Rule ID 5991 //
     /* 292945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292993 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292997 */     // MIs[3] Operand 1
     /* 292997 */     // No operand predicates
     /* 292997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293003 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293019 */     GIR_RootConstrainSelectedInstOperands,
     /* 293020 */     // GIR_Coverage, 5991,
     /* 293020 */     GIR_EraseRootFromParent_Done,
     /* 293021 */   // Label 5912: @293021
     /* 293021 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(293090), // Rule ID 2535 //
     /* 293026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293062 */     // MIs[2] Operand 1
     /* 293062 */     // No operand predicates
     /* 293062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293072 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293088 */     GIR_RootConstrainSelectedInstOperands,
     /* 293089 */     // GIR_Coverage, 2535,
     /* 293089 */     GIR_EraseRootFromParent_Done,
     /* 293090 */   // Label 5913: @293090
     /* 293090 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(293159), // Rule ID 5959 //
     /* 293095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293135 */     // MIs[2] Operand 1
     /* 293135 */     // No operand predicates
     /* 293135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293141 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293157 */     GIR_RootConstrainSelectedInstOperands,
     /* 293158 */     // GIR_Coverage, 5959,
     /* 293158 */     GIR_EraseRootFromParent_Done,
     /* 293159 */   // Label 5914: @293159
     /* 293159 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(293252), // Rule ID 6113 //
     /* 293164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293203 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293250 */     GIR_RootConstrainSelectedInstOperands,
     /* 293251 */     // GIR_Coverage, 6113,
     /* 293251 */     GIR_EraseRootFromParent_Done,
     /* 293252 */   // Label 5915: @293252
     /* 293252 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(293351), // Rule ID 6025 //
     /* 293257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293300 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293312 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293319 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 293343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293349 */     GIR_RootConstrainSelectedInstOperands,
     /* 293350 */     // GIR_Coverage, 6025,
     /* 293350 */     GIR_EraseRootFromParent_Done,
     /* 293351 */   // Label 5916: @293351
     /* 293351 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(293447), // Rule ID 6057 //
     /* 293356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293398 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293445 */     GIR_RootConstrainSelectedInstOperands,
     /* 293446 */     // GIR_Coverage, 6057,
     /* 293446 */     GIR_EraseRootFromParent_Done,
     /* 293447 */   // Label 5917: @293447
     /* 293447 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(293546), // Rule ID 6089 //
     /* 293452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293495 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293514 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293544 */     GIR_RootConstrainSelectedInstOperands,
     /* 293545 */     // GIR_Coverage, 6089,
     /* 293545 */     GIR_EraseRootFromParent_Done,
     /* 293546 */   // Label 5918: @293546
     /* 293546 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(293639), // Rule ID 6135 //
     /* 293551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293590 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293637 */     GIR_RootConstrainSelectedInstOperands,
     /* 293638 */     // GIR_Coverage, 6135,
     /* 293638 */     GIR_EraseRootFromParent_Done,
     /* 293639 */   // Label 5919: @293639
     /* 293639 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(293735), // Rule ID 5993 //
     /* 293644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293686 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293733 */     GIR_RootConstrainSelectedInstOperands,
     /* 293734 */     // GIR_Coverage, 5993,
     /* 293734 */     GIR_EraseRootFromParent_Done,
     /* 293735 */   // Label 5920: @293735
     /* 293735 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(293819), // Rule ID 2537 //
     /* 293740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293770 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293817 */     GIR_RootConstrainSelectedInstOperands,
     /* 293818 */     // GIR_Coverage, 2537,
     /* 293818 */     GIR_EraseRootFromParent_Done,
     /* 293819 */   // Label 5921: @293819
     /* 293819 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(293869), // Rule ID 13049 //
     /* 293824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293854 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 293854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 293857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293867 */     GIR_RootConstrainSelectedInstOperands,
     /* 293868 */     // GIR_Coverage, 13049,
     /* 293868 */     GIR_EraseRootFromParent_Done,
     /* 293869 */   // Label 5922: @293869
     /* 293869 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(293953), // Rule ID 5961 //
     /* 293874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293904 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293951 */     GIR_RootConstrainSelectedInstOperands,
     /* 293952 */     // GIR_Coverage, 5961,
     /* 293952 */     GIR_EraseRootFromParent_Done,
     /* 293953 */   // Label 5923: @293953
     /* 293953 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(294003), // Rule ID 1303 //
     /* 293958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293988 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 293988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 293991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294001 */     GIR_RootConstrainSelectedInstOperands,
     /* 294002 */     // GIR_Coverage, 1303,
     /* 294002 */     GIR_EraseRootFromParent_Done,
     /* 294003 */   // Label 5924: @294003
     /* 294003 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(294036), // Rule ID 1293 //
     /* 294008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294023 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 294023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 294026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 294034 */     GIR_RootConstrainSelectedInstOperands,
     /* 294035 */     // GIR_Coverage, 1293,
     /* 294035 */     GIR_EraseRootFromParent_Done,
     /* 294036 */   // Label 5925: @294036
     /* 294036 */   GIM_Reject,
     /* 294037 */ // Label 5906: @294037
     /* 294037 */ GIM_Reject,
     /* 294038 */ // Label 5745: @294038
     /* 294038 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(295216),
     /* 294043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294056 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(294140), // Rule ID 6007 //
     /* 294061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294097 */     // MIs[2] Operand 1
     /* 294097 */     // No operand predicates
     /* 294097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294109 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294120 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294138 */     GIR_RootConstrainSelectedInstOperands,
     /* 294139 */     // GIR_Coverage, 6007,
     /* 294139 */     GIR_EraseRootFromParent_Done,
     /* 294140 */   // Label 5927: @294140
     /* 294140 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(294221), // Rule ID 6039 //
     /* 294145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294193 */     // MIs[3] Operand 1
     /* 294193 */     // No operand predicates
     /* 294193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294203 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294219 */     GIR_RootConstrainSelectedInstOperands,
     /* 294220 */     // GIR_Coverage, 6039,
     /* 294220 */     GIR_EraseRootFromParent_Done,
     /* 294221 */   // Label 5928: @294221
     /* 294221 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(294305), // Rule ID 6071 //
     /* 294226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294279 */     // MIs[3] Operand 1
     /* 294279 */     // No operand predicates
     /* 294279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294285 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294303 */     GIR_RootConstrainSelectedInstOperands,
     /* 294304 */     // GIR_Coverage, 6071,
     /* 294304 */     GIR_EraseRootFromParent_Done,
     /* 294305 */   // Label 5929: @294305
     /* 294305 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(294386), // Rule ID 5975 //
     /* 294310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294362 */     // MIs[3] Operand 1
     /* 294362 */     // No operand predicates
     /* 294362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294368 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294384 */     GIR_RootConstrainSelectedInstOperands,
     /* 294385 */     // GIR_Coverage, 5975,
     /* 294385 */     GIR_EraseRootFromParent_Done,
     /* 294386 */   // Label 5930: @294386
     /* 294386 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(294455), // Rule ID 2519 //
     /* 294391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294427 */     // MIs[2] Operand 1
     /* 294427 */     // No operand predicates
     /* 294427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294437 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294453 */     GIR_RootConstrainSelectedInstOperands,
     /* 294454 */     // GIR_Coverage, 2519,
     /* 294454 */     GIR_EraseRootFromParent_Done,
     /* 294455 */   // Label 5931: @294455
     /* 294455 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(294524), // Rule ID 5943 //
     /* 294460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294496 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294500 */     // MIs[2] Operand 1
     /* 294500 */     // No operand predicates
     /* 294500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294506 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294522 */     GIR_RootConstrainSelectedInstOperands,
     /* 294523 */     // GIR_Coverage, 5943,
     /* 294523 */     GIR_EraseRootFromParent_Done,
     /* 294524 */   // Label 5932: @294524
     /* 294524 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(294623), // Rule ID 6009 //
     /* 294529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294572 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 294615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294621 */     GIR_RootConstrainSelectedInstOperands,
     /* 294622 */     // GIR_Coverage, 6009,
     /* 294622 */     GIR_EraseRootFromParent_Done,
     /* 294623 */   // Label 5933: @294623
     /* 294623 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(294719), // Rule ID 6041 //
     /* 294628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294670 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294682 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294689 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294717 */     GIR_RootConstrainSelectedInstOperands,
     /* 294718 */     // GIR_Coverage, 6041,
     /* 294718 */     GIR_EraseRootFromParent_Done,
     /* 294719 */   // Label 5934: @294719
     /* 294719 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(294818), // Rule ID 6073 //
     /* 294724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294767 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294786 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294816 */     GIR_RootConstrainSelectedInstOperands,
     /* 294817 */     // GIR_Coverage, 6073,
     /* 294817 */     GIR_EraseRootFromParent_Done,
     /* 294818 */   // Label 5935: @294818
     /* 294818 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(294914), // Rule ID 5977 //
     /* 294823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294865 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294912 */     GIR_RootConstrainSelectedInstOperands,
     /* 294913 */     // GIR_Coverage, 5977,
     /* 294913 */     GIR_EraseRootFromParent_Done,
     /* 294914 */   // Label 5936: @294914
     /* 294914 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(294998), // Rule ID 2521 //
     /* 294919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294949 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294996 */     GIR_RootConstrainSelectedInstOperands,
     /* 294997 */     // GIR_Coverage, 2521,
     /* 294997 */     GIR_EraseRootFromParent_Done,
     /* 294998 */   // Label 5937: @294998
     /* 294998 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(295048), // Rule ID 13045 //
     /* 295003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295033 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 295036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295046 */     GIR_RootConstrainSelectedInstOperands,
     /* 295047 */     // GIR_Coverage, 13045,
     /* 295047 */     GIR_EraseRootFromParent_Done,
     /* 295048 */   // Label 5938: @295048
     /* 295048 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(295132), // Rule ID 5945 //
     /* 295053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295083 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295102 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 295118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295130 */     GIR_RootConstrainSelectedInstOperands,
     /* 295131 */     // GIR_Coverage, 5945,
     /* 295131 */     GIR_EraseRootFromParent_Done,
     /* 295132 */   // Label 5939: @295132
     /* 295132 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(295182), // Rule ID 1299 //
     /* 295137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295167 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 295170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295180 */     GIR_RootConstrainSelectedInstOperands,
     /* 295181 */     // GIR_Coverage, 1299,
     /* 295181 */     GIR_EraseRootFromParent_Done,
     /* 295182 */   // Label 5940: @295182
     /* 295182 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(295215), // Rule ID 1289 //
     /* 295187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295202 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 295205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295213 */     GIR_RootConstrainSelectedInstOperands,
     /* 295214 */     // GIR_Coverage, 1289,
     /* 295214 */     GIR_EraseRootFromParent_Done,
     /* 295215 */   // Label 5941: @295215
     /* 295215 */   GIM_Reject,
     /* 295216 */ // Label 5926: @295216
     /* 295216 */ GIM_Reject,
     /* 295217 */ // Label 5746: @295217
     /* 295217 */ GIM_Reject,
     /* 295218 */ // Label 58: @295218
     /* 295218 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5950*/ GIMT_Encode4(295833),
     /* 295229 */ /*GILLT_s16*//*Label 5942*/ GIMT_Encode4(295269),
     /* 295233 */ /*GILLT_s32*//*Label 5943*/ GIMT_Encode4(295307),
     /* 295237 */ /*GILLT_s64*//*Label 5944*/ GIMT_Encode4(295345), GIMT_Encode4(0),
     /* 295245 */ /*GILLT_v2s32*//*Label 5945*/ GIMT_Encode4(295383),
     /* 295249 */ /*GILLT_v2s64*//*Label 5946*/ GIMT_Encode4(295421),
     /* 295253 */ /*GILLT_v4s16*//*Label 5947*/ GIMT_Encode4(295459),
     /* 295257 */ /*GILLT_v4s32*//*Label 5948*/ GIMT_Encode4(295497), GIMT_Encode4(0),
     /* 295265 */ /*GILLT_v8s16*//*Label 5949*/ GIMT_Encode4(295535),
     /* 295269 */ // Label 5942: @295269
     /* 295269 */ GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(295306), // Rule ID 590 //
     /* 295274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 295283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295295 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 295295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 295300 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295304 */   GIR_RootConstrainSelectedInstOperands,
     /* 295305 */   // GIR_Coverage, 590,
     /* 295305 */   GIR_Done,
     /* 295306 */ // Label 5951: @295306
     /* 295306 */ GIM_Reject,
     /* 295307 */ // Label 5943: @295307
     /* 295307 */ GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(295344), // Rule ID 592 //
     /* 295312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295333 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 295333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 295338 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295342 */   GIR_RootConstrainSelectedInstOperands,
     /* 295343 */   // GIR_Coverage, 592,
     /* 295343 */   GIR_Done,
     /* 295344 */ // Label 5952: @295344
     /* 295344 */ GIM_Reject,
     /* 295345 */ // Label 5944: @295345
     /* 295345 */ GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(295382), // Rule ID 594 //
     /* 295350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295371 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 295371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 295376 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295380 */   GIR_RootConstrainSelectedInstOperands,
     /* 295381 */   // GIR_Coverage, 594,
     /* 295381 */   GIR_Done,
     /* 295382 */ // Label 5953: @295382
     /* 295382 */ GIM_Reject,
     /* 295383 */ // Label 5945: @295383
     /* 295383 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(295420), // Rule ID 1221 //
     /* 295388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 295397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295409 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 295409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 295414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295418 */   GIR_RootConstrainSelectedInstOperands,
     /* 295419 */   // GIR_Coverage, 1221,
     /* 295419 */   GIR_Done,
     /* 295420 */ // Label 5954: @295420
     /* 295420 */ GIM_Reject,
     /* 295421 */ // Label 5946: @295421
     /* 295421 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(295458), // Rule ID 1225 //
     /* 295426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 295435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295447 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 295447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 295452 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295456 */   GIR_RootConstrainSelectedInstOperands,
     /* 295457 */   // GIR_Coverage, 1225,
     /* 295457 */   GIR_Done,
     /* 295458 */ // Label 5955: @295458
     /* 295458 */ GIM_Reject,
     /* 295459 */ // Label 5947: @295459
     /* 295459 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(295496), // Rule ID 1217 //
     /* 295464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 295470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 295473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295485 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 295485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 295490 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295494 */   GIR_RootConstrainSelectedInstOperands,
     /* 295495 */   // GIR_Coverage, 1217,
     /* 295495 */   GIR_Done,
     /* 295496 */ // Label 5956: @295496
     /* 295496 */ GIM_Reject,
     /* 295497 */ // Label 5948: @295497
     /* 295497 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(295534), // Rule ID 1223 //
     /* 295502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 295511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295523 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 295523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295532 */   GIR_RootConstrainSelectedInstOperands,
     /* 295533 */   // GIR_Coverage, 1223,
     /* 295533 */   GIR_Done,
     /* 295534 */ // Label 5957: @295534
     /* 295534 */ GIM_Reject,
     /* 295535 */ // Label 5949: @295535
     /* 295535 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(295832),
     /* 295540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 295546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295558 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(295577), // Rule ID 1219 //
     /* 295563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295566 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 295571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295575 */     GIR_RootConstrainSelectedInstOperands,
     /* 295576 */     // GIR_Coverage, 1219,
     /* 295576 */     GIR_Done,
     /* 295577 */   // Label 5959: @295577
     /* 295577 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(295831), // Rule ID 6916 //
     /* 295582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 295585 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 295585 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 295588 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 295592 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295597 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 295601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 295603 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 295606 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 295610 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295615 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 295619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 295621 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 295624 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295628 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295633 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 295636 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 295639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 295641 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 295644 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295648 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295653 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 295659 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295664 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295669 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 295672 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 295676 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295681 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 295684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 295686 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 295689 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295693 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295698 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 295704 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295709 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295714 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 295717 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 295721 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295726 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 295729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 295731 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 295734 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295738 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295743 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 295746 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 295749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 295751 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 295754 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 295758 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295763 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 295766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 295768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 295771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 295775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 295782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 295789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295794 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 295797 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 295800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 295803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 295821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 295829 */     GIR_RootConstrainSelectedInstOperands,
     /* 295830 */     // GIR_Coverage, 6916,
     /* 295830 */     GIR_EraseRootFromParent_Done,
     /* 295831 */   // Label 5960: @295831
     /* 295831 */   GIM_Reject,
     /* 295832 */ // Label 5958: @295832
     /* 295832 */ GIM_Reject,
     /* 295833 */ // Label 5950: @295833
     /* 295833 */ GIM_Reject,
     /* 295834 */ // Label 59: @295834
     /* 295834 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5969*/ GIMT_Encode4(299340),
     /* 295845 */ /*GILLT_s16*//*Label 5961*/ GIMT_Encode4(295885),
     /* 295849 */ /*GILLT_s32*//*Label 5962*/ GIMT_Encode4(297053),
     /* 295853 */ /*GILLT_s64*//*Label 5963*/ GIMT_Encode4(298076), GIMT_Encode4(0),
     /* 295861 */ /*GILLT_v2s32*//*Label 5964*/ GIMT_Encode4(299099),
     /* 295865 */ /*GILLT_v2s64*//*Label 5965*/ GIMT_Encode4(299126),
     /* 295869 */ /*GILLT_v4s16*//*Label 5966*/ GIMT_Encode4(299153),
     /* 295873 */ /*GILLT_v4s32*//*Label 5967*/ GIMT_Encode4(299233), GIMT_Encode4(0),
     /* 295881 */ /*GILLT_v8s16*//*Label 5968*/ GIMT_Encode4(299260),
     /* 295885 */ // Label 5961: @295885
     /* 295885 */ GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(297052),
     /* 295890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295897 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(296055), // Rule ID 4787 //
     /* 295902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 295913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 295921 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 295925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295966 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295971 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295982 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 295982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 295985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295994 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296022 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296053 */     GIR_RootConstrainSelectedInstOperands,
     /* 296054 */     // GIR_Coverage, 4787,
     /* 296054 */     GIR_EraseRootFromParent_Done,
     /* 296055 */   // Label 5971: @296055
     /* 296055 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(296213), // Rule ID 4786 //
     /* 296060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296104 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 296112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296129 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296140 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296140 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 296143 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296147 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296152 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296180 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296211 */     GIR_RootConstrainSelectedInstOperands,
     /* 296212 */     // GIR_Coverage, 4786,
     /* 296212 */     GIR_EraseRootFromParent_Done,
     /* 296213 */   // Label 5972: @296213
     /* 296213 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(296324), // Rule ID 4785 //
     /* 296218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296237 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296262 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296278 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296290 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296322 */     GIR_RootConstrainSelectedInstOperands,
     /* 296323 */     // GIR_Coverage, 4785,
     /* 296323 */     GIR_EraseRootFromParent_Done,
     /* 296324 */   // Label 5973: @296324
     /* 296324 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(296435), // Rule ID 4783 //
     /* 296329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296378 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296389 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296433 */     GIR_RootConstrainSelectedInstOperands,
     /* 296434 */     // GIR_Coverage, 4783,
     /* 296434 */     GIR_EraseRootFromParent_Done,
     /* 296435 */   // Label 5974: @296435
     /* 296435 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(296546), // Rule ID 4784 //
     /* 296440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296459 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296484 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296500 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296512 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296544 */     GIR_RootConstrainSelectedInstOperands,
     /* 296545 */     // GIR_Coverage, 4784,
     /* 296545 */     GIR_EraseRootFromParent_Done,
     /* 296546 */   // Label 5975: @296546
     /* 296546 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(296657), // Rule ID 4782 //
     /* 296551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296570 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296611 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296623 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296655 */     GIR_RootConstrainSelectedInstOperands,
     /* 296656 */     // GIR_Coverage, 4782,
     /* 296656 */     GIR_EraseRootFromParent_Done,
     /* 296657 */   // Label 5976: @296657
     /* 296657 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(296721), // Rule ID 650 //
     /* 296662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296681 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296702 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296719 */     GIR_RootConstrainSelectedInstOperands,
     /* 296720 */     // GIR_Coverage, 650,
     /* 296720 */     GIR_EraseRootFromParent_Done,
     /* 296721 */   // Label 5977: @296721
     /* 296721 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(296785), // Rule ID 649 //
     /* 296726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296745 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296766 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296783 */     GIR_RootConstrainSelectedInstOperands,
     /* 296784 */     // GIR_Coverage, 649,
     /* 296784 */     GIR_EraseRootFromParent_Done,
     /* 296785 */   // Label 5978: @296785
     /* 296785 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(296836), // Rule ID 626 //
     /* 296790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 296801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296821 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 296821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 296824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296834 */     GIR_RootConstrainSelectedInstOperands,
     /* 296835 */     // GIR_Coverage, 626,
     /* 296835 */     GIR_EraseRootFromParent_Done,
     /* 296836 */   // Label 5979: @296836
     /* 296836 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(296887), // Rule ID 625 //
     /* 296841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 296852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296872 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 296872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 296875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296885 */     GIR_RootConstrainSelectedInstOperands,
     /* 296886 */     // GIR_Coverage, 625,
     /* 296886 */     GIR_EraseRootFromParent_Done,
     /* 296887 */   // Label 5980: @296887
     /* 296887 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(296906), // Rule ID 524 //
     /* 296892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296899 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 296899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 296904 */     GIR_RootConstrainSelectedInstOperands,
     /* 296905 */     // GIR_Coverage, 524,
     /* 296905 */     GIR_Done,
     /* 296906 */   // Label 5981: @296906
     /* 296906 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(297051), // Rule ID 6283 //
     /* 296911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296915 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 296915 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 296918 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 296922 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 296929 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 296932 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 296936 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296941 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 296944 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296948 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 296951 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296956 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296961 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296966 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 296969 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296973 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296978 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 296981 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 296986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 296989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 296993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296998 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 297001 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 297006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 297008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297033 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 297040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297050 */     // GIR_Coverage, 6283,
     /* 297050 */     GIR_EraseRootFromParent_Done,
     /* 297051 */   // Label 5982: @297051
     /* 297051 */   GIM_Reject,
     /* 297052 */ // Label 5970: @297052
     /* 297052 */ GIM_Reject,
     /* 297053 */ // Label 5962: @297053
     /* 297053 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(298075),
     /* 297058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 297061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297065 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(297223), // Rule ID 4793 //
     /* 297070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297089 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297130 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297134 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297139 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297150 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297162 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297190 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297221 */     GIR_RootConstrainSelectedInstOperands,
     /* 297222 */     // GIR_Coverage, 4793,
     /* 297222 */     GIR_EraseRootFromParent_Done,
     /* 297223 */   // Label 5984: @297223
     /* 297223 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(297381), // Rule ID 4792 //
     /* 297228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297247 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297288 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297292 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297297 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297308 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297320 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297348 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297379 */     GIR_RootConstrainSelectedInstOperands,
     /* 297380 */     // GIR_Coverage, 4792,
     /* 297380 */     GIR_EraseRootFromParent_Done,
     /* 297381 */   // Label 5985: @297381
     /* 297381 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(297492), // Rule ID 4791 //
     /* 297386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297446 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297458 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297490 */     GIR_RootConstrainSelectedInstOperands,
     /* 297491 */     // GIR_Coverage, 4791,
     /* 297491 */     GIR_EraseRootFromParent_Done,
     /* 297492 */   // Label 5986: @297492
     /* 297492 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(297603), // Rule ID 4789 //
     /* 297497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297516 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297546 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297557 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297569 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297601 */     GIR_RootConstrainSelectedInstOperands,
     /* 297602 */     // GIR_Coverage, 4789,
     /* 297602 */     GIR_EraseRootFromParent_Done,
     /* 297603 */   // Label 5987: @297603
     /* 297603 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(297714), // Rule ID 4790 //
     /* 297608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297652 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297668 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297680 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297712 */     GIR_RootConstrainSelectedInstOperands,
     /* 297713 */     // GIR_Coverage, 4790,
     /* 297713 */     GIR_EraseRootFromParent_Done,
     /* 297714 */   // Label 5988: @297714
     /* 297714 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(297825), // Rule ID 4788 //
     /* 297719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297738 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297779 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297791 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297823 */     GIR_RootConstrainSelectedInstOperands,
     /* 297824 */     // GIR_Coverage, 4788,
     /* 297824 */     GIR_EraseRootFromParent_Done,
     /* 297825 */   // Label 5989: @297825
     /* 297825 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(297889), // Rule ID 652 //
     /* 297830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297849 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297870 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297887 */     GIR_RootConstrainSelectedInstOperands,
     /* 297888 */     // GIR_Coverage, 652,
     /* 297888 */     GIR_EraseRootFromParent_Done,
     /* 297889 */   // Label 5990: @297889
     /* 297889 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(297953), // Rule ID 651 //
     /* 297894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297913 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297934 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297951 */     GIR_RootConstrainSelectedInstOperands,
     /* 297952 */     // GIR_Coverage, 651,
     /* 297952 */     GIR_EraseRootFromParent_Done,
     /* 297953 */   // Label 5991: @297953
     /* 297953 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(298004), // Rule ID 628 //
     /* 297958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 297969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297989 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 297989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 297992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298002 */     GIR_RootConstrainSelectedInstOperands,
     /* 298003 */     // GIR_Coverage, 628,
     /* 298003 */     GIR_EraseRootFromParent_Done,
     /* 298004 */   // Label 5992: @298004
     /* 298004 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(298055), // Rule ID 627 //
     /* 298009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 298020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298040 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 298040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 298043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298053 */     GIR_RootConstrainSelectedInstOperands,
     /* 298054 */     // GIR_Coverage, 627,
     /* 298054 */     GIR_EraseRootFromParent_Done,
     /* 298055 */   // Label 5993: @298055
     /* 298055 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(298074), // Rule ID 525 //
     /* 298060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298067 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 298067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 298072 */     GIR_RootConstrainSelectedInstOperands,
     /* 298073 */     // GIR_Coverage, 525,
     /* 298073 */     GIR_Done,
     /* 298074 */   // Label 5994: @298074
     /* 298074 */   GIM_Reject,
     /* 298075 */ // Label 5983: @298075
     /* 298075 */ GIM_Reject,
     /* 298076 */ // Label 5963: @298076
     /* 298076 */ GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(299098),
     /* 298081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298088 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(298246), // Rule ID 4799 //
     /* 298093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298112 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298137 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298153 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298162 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298173 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298185 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298244 */     GIR_RootConstrainSelectedInstOperands,
     /* 298245 */     // GIR_Coverage, 4799,
     /* 298245 */     GIR_EraseRootFromParent_Done,
     /* 298246 */   // Label 5996: @298246
     /* 298246 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(298404), // Rule ID 4798 //
     /* 298251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298270 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298320 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298331 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298343 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298371 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298402 */     GIR_RootConstrainSelectedInstOperands,
     /* 298403 */     // GIR_Coverage, 4798,
     /* 298403 */     GIR_EraseRootFromParent_Done,
     /* 298404 */   // Label 5997: @298404
     /* 298404 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(298515), // Rule ID 4797 //
     /* 298409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298469 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298481 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298513 */     GIR_RootConstrainSelectedInstOperands,
     /* 298514 */     // GIR_Coverage, 4797,
     /* 298514 */     GIR_EraseRootFromParent_Done,
     /* 298515 */   // Label 5998: @298515
     /* 298515 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(298626), // Rule ID 4795 //
     /* 298520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298569 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298580 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298592 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298624 */     GIR_RootConstrainSelectedInstOperands,
     /* 298625 */     // GIR_Coverage, 4795,
     /* 298625 */     GIR_EraseRootFromParent_Done,
     /* 298626 */   // Label 5999: @298626
     /* 298626 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(298737), // Rule ID 4796 //
     /* 298631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298650 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298675 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298691 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298703 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298735 */     GIR_RootConstrainSelectedInstOperands,
     /* 298736 */     // GIR_Coverage, 4796,
     /* 298736 */     GIR_EraseRootFromParent_Done,
     /* 298737 */   // Label 6000: @298737
     /* 298737 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(298848), // Rule ID 4794 //
     /* 298742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298761 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298802 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298814 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298846 */     GIR_RootConstrainSelectedInstOperands,
     /* 298847 */     // GIR_Coverage, 4794,
     /* 298847 */     GIR_EraseRootFromParent_Done,
     /* 298848 */   // Label 6001: @298848
     /* 298848 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(298912), // Rule ID 654 //
     /* 298853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298893 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298910 */     GIR_RootConstrainSelectedInstOperands,
     /* 298911 */     // GIR_Coverage, 654,
     /* 298911 */     GIR_EraseRootFromParent_Done,
     /* 298912 */   // Label 6002: @298912
     /* 298912 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(298976), // Rule ID 653 //
     /* 298917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298936 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298957 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298974 */     GIR_RootConstrainSelectedInstOperands,
     /* 298975 */     // GIR_Coverage, 653,
     /* 298975 */     GIR_EraseRootFromParent_Done,
     /* 298976 */   // Label 6003: @298976
     /* 298976 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(299027), // Rule ID 630 //
     /* 298981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 298992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299012 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 299012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 299015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299025 */     GIR_RootConstrainSelectedInstOperands,
     /* 299026 */     // GIR_Coverage, 630,
     /* 299026 */     GIR_EraseRootFromParent_Done,
     /* 299027 */   // Label 6004: @299027
     /* 299027 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(299078), // Rule ID 629 //
     /* 299032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 299043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299063 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 299063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 299066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299076 */     GIR_RootConstrainSelectedInstOperands,
     /* 299077 */     // GIR_Coverage, 629,
     /* 299077 */     GIR_EraseRootFromParent_Done,
     /* 299078 */   // Label 6005: @299078
     /* 299078 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(299097), // Rule ID 526 //
     /* 299083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299090 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 299090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 299095 */     GIR_RootConstrainSelectedInstOperands,
     /* 299096 */     // GIR_Coverage, 526,
     /* 299096 */     GIR_Done,
     /* 299097 */   // Label 6006: @299097
     /* 299097 */   GIM_Reject,
     /* 299098 */ // Label 5995: @299098
     /* 299098 */ GIM_Reject,
     /* 299099 */ // Label 5964: @299099
     /* 299099 */ GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(299125), // Rule ID 853 //
     /* 299104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299118 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 299118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 299123 */   GIR_RootConstrainSelectedInstOperands,
     /* 299124 */   // GIR_Coverage, 853,
     /* 299124 */   GIR_Done,
     /* 299125 */ // Label 6007: @299125
     /* 299125 */ GIM_Reject,
     /* 299126 */ // Label 5965: @299126
     /* 299126 */ GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(299152), // Rule ID 855 //
     /* 299131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299145 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 299145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 299150 */   GIR_RootConstrainSelectedInstOperands,
     /* 299151 */   // GIR_Coverage, 855,
     /* 299151 */   GIR_Done,
     /* 299152 */ // Label 6008: @299152
     /* 299152 */ GIM_Reject,
     /* 299153 */ // Label 5966: @299153
     /* 299153 */ GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(299232),
     /* 299158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299169 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(299184), // Rule ID 851 //
     /* 299174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299177 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 299177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 299182 */     GIR_RootConstrainSelectedInstOperands,
     /* 299183 */     // GIR_Coverage, 851,
     /* 299183 */     GIR_Done,
     /* 299184 */   // Label 6010: @299184
     /* 299184 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(299231), // Rule ID 6286 //
     /* 299189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299192 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 299192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 299199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299204 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 299214 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 299217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 299222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299229 */     GIR_RootConstrainSelectedInstOperands,
     /* 299230 */     // GIR_Coverage, 6286,
     /* 299230 */     GIR_EraseRootFromParent_Done,
     /* 299231 */   // Label 6011: @299231
     /* 299231 */   GIM_Reject,
     /* 299232 */ // Label 6009: @299232
     /* 299232 */ GIM_Reject,
     /* 299233 */ // Label 5967: @299233
     /* 299233 */ GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(299259), // Rule ID 854 //
     /* 299238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299252 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 299252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 299257 */   GIR_RootConstrainSelectedInstOperands,
     /* 299258 */   // GIR_Coverage, 854,
     /* 299258 */   GIR_Done,
     /* 299259 */ // Label 6012: @299259
     /* 299259 */ GIM_Reject,
     /* 299260 */ // Label 5968: @299260
     /* 299260 */ GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(299339),
     /* 299265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299276 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(299291), // Rule ID 852 //
     /* 299281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299284 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 299284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 299289 */     GIR_RootConstrainSelectedInstOperands,
     /* 299290 */     // GIR_Coverage, 852,
     /* 299290 */     GIR_Done,
     /* 299291 */   // Label 6014: @299291
     /* 299291 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(299338), // Rule ID 6287 //
     /* 299296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299299 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 299299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 299306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299311 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 299321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 299324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 299329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299336 */     GIR_RootConstrainSelectedInstOperands,
     /* 299337 */     // GIR_Coverage, 6287,
     /* 299337 */     GIR_EraseRootFromParent_Done,
     /* 299338 */   // Label 6015: @299338
     /* 299338 */   GIM_Reject,
     /* 299339 */ // Label 6013: @299339
     /* 299339 */ GIM_Reject,
     /* 299340 */ // Label 5969: @299340
     /* 299340 */ GIM_Reject,
     /* 299341 */ // Label 60: @299341
     /* 299341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6020*/ GIMT_Encode4(299588),
     /* 299352 */ /*GILLT_s32*//*Label 6016*/ GIMT_Encode4(299380),
     /* 299356 */ /*GILLT_s64*//*Label 6017*/ GIMT_Encode4(299411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299368 */ /*GILLT_v2s64*//*Label 6018*/ GIMT_Encode4(299472), GIMT_Encode4(0),
     /* 299376 */ /*GILLT_v4s32*//*Label 6019*/ GIMT_Encode4(299530),
     /* 299380 */ // Label 6016: @299380
     /* 299380 */ GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(299410), // Rule ID 516 //
     /* 299385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299399 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 299399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 299404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299408 */   GIR_RootConstrainSelectedInstOperands,
     /* 299409 */   // GIR_Coverage, 516,
     /* 299409 */   GIR_Done,
     /* 299410 */ // Label 6021: @299410
     /* 299410 */ GIM_Reject,
     /* 299411 */ // Label 6017: @299411
     /* 299411 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(299441), // Rule ID 514 //
     /* 299416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299430 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 299430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 299435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299439 */   GIR_RootConstrainSelectedInstOperands,
     /* 299440 */   // GIR_Coverage, 514,
     /* 299440 */   GIR_Done,
     /* 299441 */ // Label 6022: @299441
     /* 299441 */ GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(299471), // Rule ID 518 //
     /* 299446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299460 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 299460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 299465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299469 */   GIR_RootConstrainSelectedInstOperands,
     /* 299470 */   // GIR_Coverage, 518,
     /* 299470 */   GIR_Done,
     /* 299471 */ // Label 6023: @299471
     /* 299471 */ GIM_Reject,
     /* 299472 */ // Label 6018: @299472
     /* 299472 */ GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(299529),
     /* 299477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299484 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(299508), // Rule ID 4842 //
     /* 299489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 299496 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 299496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 299499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299506 */     GIR_RootConstrainSelectedInstOperands,
     /* 299507 */     // GIR_Coverage, 4842,
     /* 299507 */     GIR_EraseRootFromParent_Done,
     /* 299508 */   // Label 6025: @299508
     /* 299508 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(299528), // Rule ID 4840 //
     /* 299513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299517 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 299517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 299522 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299526 */     GIR_RootConstrainSelectedInstOperands,
     /* 299527 */     // GIR_Coverage, 4840,
     /* 299527 */     GIR_Done,
     /* 299528 */   // Label 6026: @299528
     /* 299528 */   GIM_Reject,
     /* 299529 */ // Label 6024: @299529
     /* 299529 */ GIM_Reject,
     /* 299530 */ // Label 6019: @299530
     /* 299530 */ GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(299587),
     /* 299535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299542 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(299566), // Rule ID 4846 //
     /* 299547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 299554 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 299554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 299557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299564 */     GIR_RootConstrainSelectedInstOperands,
     /* 299565 */     // GIR_Coverage, 4846,
     /* 299565 */     GIR_EraseRootFromParent_Done,
     /* 299566 */   // Label 6028: @299566
     /* 299566 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(299586), // Rule ID 4844 //
     /* 299571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299575 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 299575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 299580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299584 */     GIR_RootConstrainSelectedInstOperands,
     /* 299585 */     // GIR_Coverage, 4844,
     /* 299585 */     GIR_Done,
     /* 299586 */   // Label 6029: @299586
     /* 299586 */   GIM_Reject,
     /* 299587 */ // Label 6027: @299587
     /* 299587 */ GIM_Reject,
     /* 299588 */ // Label 6020: @299588
     /* 299588 */ GIM_Reject,
     /* 299589 */ // Label 61: @299589
     /* 299589 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6034*/ GIMT_Encode4(299776),
     /* 299600 */ /*GILLT_s16*//*Label 6030*/ GIMT_Encode4(299628),
     /* 299604 */ /*GILLT_s32*//*Label 6031*/ GIMT_Encode4(299689), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299616 */ /*GILLT_v2s32*//*Label 6032*/ GIMT_Encode4(299720), GIMT_Encode4(0),
     /* 299624 */ /*GILLT_v4s16*//*Label 6033*/ GIMT_Encode4(299748),
     /* 299628 */ // Label 6030: @299628
     /* 299628 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(299658), // Rule ID 510 //
     /* 299633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299647 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 299647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 299652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299656 */   GIR_RootConstrainSelectedInstOperands,
     /* 299657 */   // GIR_Coverage, 510,
     /* 299657 */   GIR_Done,
     /* 299658 */ // Label 6035: @299658
     /* 299658 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(299688), // Rule ID 520 //
     /* 299663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299677 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 299677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 299682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299686 */   GIR_RootConstrainSelectedInstOperands,
     /* 299687 */   // GIR_Coverage, 520,
     /* 299687 */   GIR_Done,
     /* 299688 */ // Label 6036: @299688
     /* 299688 */ GIM_Reject,
     /* 299689 */ // Label 6031: @299689
     /* 299689 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(299719), // Rule ID 512 //
     /* 299694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299708 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 299708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 299713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299717 */   GIR_RootConstrainSelectedInstOperands,
     /* 299718 */   // GIR_Coverage, 512,
     /* 299718 */   GIR_Done,
     /* 299719 */ // Label 6037: @299719
     /* 299719 */ GIM_Reject,
     /* 299720 */ // Label 6032: @299720
     /* 299720 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(299747), // Rule ID 4850 //
     /* 299725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299736 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 299736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 299741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299745 */   GIR_RootConstrainSelectedInstOperands,
     /* 299746 */   // GIR_Coverage, 4850,
     /* 299746 */   GIR_Done,
     /* 299747 */ // Label 6038: @299747
     /* 299747 */ GIM_Reject,
     /* 299748 */ // Label 6033: @299748
     /* 299748 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(299775), // Rule ID 4852 //
     /* 299753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299764 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 299764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 299769 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299773 */   GIR_RootConstrainSelectedInstOperands,
     /* 299774 */   // GIR_Coverage, 4852,
     /* 299774 */   GIR_Done,
     /* 299775 */ // Label 6039: @299775
     /* 299775 */ GIM_Reject,
     /* 299776 */ // Label 6034: @299776
     /* 299776 */ GIM_Reject,
     /* 299777 */ // Label 62: @299777
     /* 299777 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6047*/ GIMT_Encode4(300839),
     /* 299788 */ /*GILLT_s32*//*Label 6040*/ GIMT_Encode4(299824),
     /* 299792 */ /*GILLT_s64*//*Label 6041*/ GIMT_Encode4(300211), GIMT_Encode4(0),
     /* 299800 */ /*GILLT_v2s32*//*Label 6042*/ GIMT_Encode4(300598),
     /* 299804 */ /*GILLT_v2s64*//*Label 6043*/ GIMT_Encode4(300672),
     /* 299808 */ /*GILLT_v4s16*//*Label 6044*/ GIMT_Encode4(300746),
     /* 299812 */ /*GILLT_v4s32*//*Label 6045*/ GIMT_Encode4(300777), GIMT_Encode4(0),
     /* 299820 */ /*GILLT_v8s16*//*Label 6046*/ GIMT_Encode4(300808),
     /* 299824 */ // Label 6040: @299824
     /* 299824 */ GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(299861), // Rule ID 4589 //
     /* 299829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 299844 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299850 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 299850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 299853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299859 */   GIR_RootConstrainSelectedInstOperands,
     /* 299860 */   // GIR_Coverage, 4589,
     /* 299860 */   GIR_EraseRootFromParent_Done,
     /* 299861 */ // Label 6048: @299861
     /* 299861 */ GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(299898), // Rule ID 4591 //
     /* 299866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 299881 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299887 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 299887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 299890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299892 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299896 */   GIR_RootConstrainSelectedInstOperands,
     /* 299897 */   // GIR_Coverage, 4591,
     /* 299897 */   GIR_EraseRootFromParent_Done,
     /* 299898 */ // Label 6049: @299898
     /* 299898 */ GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(299935), // Rule ID 4609 //
     /* 299903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299910 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 299918 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299924 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 299924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 299927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299929 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299933 */   GIR_RootConstrainSelectedInstOperands,
     /* 299934 */   // GIR_Coverage, 4609,
     /* 299934 */   GIR_EraseRootFromParent_Done,
     /* 299935 */ // Label 6050: @299935
     /* 299935 */ GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(299972), // Rule ID 4611 //
     /* 299940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 299955 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299961 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 299961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 299964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299966 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299970 */   GIR_RootConstrainSelectedInstOperands,
     /* 299971 */   // GIR_Coverage, 4611,
     /* 299971 */   GIR_EraseRootFromParent_Done,
     /* 299972 */ // Label 6051: @299972
     /* 299972 */ GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(300009), // Rule ID 4649 //
     /* 299977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299984 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 299992 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299998 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 299998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 300001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300003 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300007 */   GIR_RootConstrainSelectedInstOperands,
     /* 300008 */   // GIR_Coverage, 4649,
     /* 300008 */   GIR_EraseRootFromParent_Done,
     /* 300009 */ // Label 6052: @300009
     /* 300009 */ GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(300046), // Rule ID 4651 //
     /* 300014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300021 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300029 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300035 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 300038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300040 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300044 */   GIR_RootConstrainSelectedInstOperands,
     /* 300045 */   // GIR_Coverage, 4651,
     /* 300045 */   GIR_EraseRootFromParent_Done,
     /* 300046 */ // Label 6053: @300046
     /* 300046 */ GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(300083), // Rule ID 4629 //
     /* 300051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300058 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300066 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300070 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300072 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 300075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300077 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300081 */   GIR_RootConstrainSelectedInstOperands,
     /* 300082 */   // GIR_Coverage, 4629,
     /* 300082 */   GIR_EraseRootFromParent_Done,
     /* 300083 */ // Label 6054: @300083
     /* 300083 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(300120), // Rule ID 4631 //
     /* 300088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300103 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300107 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300109 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 300112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300114 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300118 */   GIR_RootConstrainSelectedInstOperands,
     /* 300119 */   // GIR_Coverage, 4631,
     /* 300119 */   GIR_EraseRootFromParent_Done,
     /* 300120 */ // Label 6055: @300120
     /* 300120 */ GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(300150), // Rule ID 395 //
     /* 300125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 300128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300139 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 300139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 300144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300148 */   GIR_RootConstrainSelectedInstOperands,
     /* 300149 */   // GIR_Coverage, 395,
     /* 300149 */   GIR_Done,
     /* 300150 */ // Label 6056: @300150
     /* 300150 */ GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(300180), // Rule ID 399 //
     /* 300155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300169 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 300169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 300174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300178 */   GIR_RootConstrainSelectedInstOperands,
     /* 300179 */   // GIR_Coverage, 399,
     /* 300179 */   GIR_Done,
     /* 300180 */ // Label 6057: @300180
     /* 300180 */ GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(300210), // Rule ID 403 //
     /* 300185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300199 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 300199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 300204 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300208 */   GIR_RootConstrainSelectedInstOperands,
     /* 300209 */   // GIR_Coverage, 403,
     /* 300209 */   GIR_Done,
     /* 300210 */ // Label 6058: @300210
     /* 300210 */ GIM_Reject,
     /* 300211 */ // Label 6041: @300211
     /* 300211 */ GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(300248), // Rule ID 4590 //
     /* 300216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300237 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 300240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300242 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300246 */   GIR_RootConstrainSelectedInstOperands,
     /* 300247 */   // GIR_Coverage, 4590,
     /* 300247 */   GIR_EraseRootFromParent_Done,
     /* 300248 */ // Label 6059: @300248
     /* 300248 */ GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(300285), // Rule ID 4592 //
     /* 300253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300268 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300274 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 300277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300279 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300283 */   GIR_RootConstrainSelectedInstOperands,
     /* 300284 */   // GIR_Coverage, 4592,
     /* 300284 */   GIR_EraseRootFromParent_Done,
     /* 300285 */ // Label 6060: @300285
     /* 300285 */ GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(300322), // Rule ID 4610 //
     /* 300290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300305 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300309 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300311 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 300314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300316 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300320 */   GIR_RootConstrainSelectedInstOperands,
     /* 300321 */   // GIR_Coverage, 4610,
     /* 300321 */   GIR_EraseRootFromParent_Done,
     /* 300322 */ // Label 6061: @300322
     /* 300322 */ GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(300359), // Rule ID 4612 //
     /* 300327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300342 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300348 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 300351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300353 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300357 */   GIR_RootConstrainSelectedInstOperands,
     /* 300358 */   // GIR_Coverage, 4612,
     /* 300358 */   GIR_EraseRootFromParent_Done,
     /* 300359 */ // Label 6062: @300359
     /* 300359 */ GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(300396), // Rule ID 4650 //
     /* 300364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300379 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300385 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 300388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300390 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300394 */   GIR_RootConstrainSelectedInstOperands,
     /* 300395 */   // GIR_Coverage, 4650,
     /* 300395 */   GIR_EraseRootFromParent_Done,
     /* 300396 */ // Label 6063: @300396
     /* 300396 */ GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(300433), // Rule ID 4652 //
     /* 300401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300416 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300422 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 300425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300427 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300431 */   GIR_RootConstrainSelectedInstOperands,
     /* 300432 */   // GIR_Coverage, 4652,
     /* 300432 */   GIR_EraseRootFromParent_Done,
     /* 300433 */ // Label 6064: @300433
     /* 300433 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(300470), // Rule ID 4630 //
     /* 300438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300453 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300459 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 300462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300464 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300468 */   GIR_RootConstrainSelectedInstOperands,
     /* 300469 */   // GIR_Coverage, 4630,
     /* 300469 */   GIR_EraseRootFromParent_Done,
     /* 300470 */ // Label 6065: @300470
     /* 300470 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(300507), // Rule ID 4632 //
     /* 300475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300490 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300496 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 300499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300501 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300505 */   GIR_RootConstrainSelectedInstOperands,
     /* 300506 */   // GIR_Coverage, 4632,
     /* 300506 */   GIR_EraseRootFromParent_Done,
     /* 300507 */ // Label 6066: @300507
     /* 300507 */ GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(300537), // Rule ID 397 //
     /* 300512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 300515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300526 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 300526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 300531 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300535 */   GIR_RootConstrainSelectedInstOperands,
     /* 300536 */   // GIR_Coverage, 397,
     /* 300536 */   GIR_Done,
     /* 300537 */ // Label 6067: @300537
     /* 300537 */ GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(300567), // Rule ID 401 //
     /* 300542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300556 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 300556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 300561 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300565 */   GIR_RootConstrainSelectedInstOperands,
     /* 300566 */   // GIR_Coverage, 401,
     /* 300566 */   GIR_Done,
     /* 300567 */ // Label 6068: @300567
     /* 300567 */ GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(300597), // Rule ID 405 //
     /* 300572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300586 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 300586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 300591 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300595 */   GIR_RootConstrainSelectedInstOperands,
     /* 300596 */   // GIR_Coverage, 405,
     /* 300596 */   GIR_Done,
     /* 300597 */ // Label 6069: @300597
     /* 300597 */ GIM_Reject,
     /* 300598 */ // Label 6042: @300598
     /* 300598 */ GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(300628), // Rule ID 836 //
     /* 300603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300617 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 300617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 300622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300626 */   GIR_RootConstrainSelectedInstOperands,
     /* 300627 */   // GIR_Coverage, 836,
     /* 300627 */   GIR_Done,
     /* 300628 */ // Label 6070: @300628
     /* 300628 */ GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(300671), // Rule ID 12828 //
     /* 300633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300643 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 300643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 300650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 300659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 300664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300669 */   GIR_RootConstrainSelectedInstOperands,
     /* 300670 */   // GIR_Coverage, 12828,
     /* 300670 */   GIR_EraseRootFromParent_Done,
     /* 300671 */ // Label 6071: @300671
     /* 300671 */ GIM_Reject,
     /* 300672 */ // Label 6043: @300672
     /* 300672 */ GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(300702), // Rule ID 840 //
     /* 300677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300691 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 300691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 300696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300700 */   GIR_RootConstrainSelectedInstOperands,
     /* 300701 */   // GIR_Coverage, 840,
     /* 300701 */   GIR_Done,
     /* 300702 */ // Label 6072: @300702
     /* 300702 */ GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(300745), // Rule ID 12826 //
     /* 300707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300717 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 300717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 300724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 300733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 300738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300743 */   GIR_RootConstrainSelectedInstOperands,
     /* 300744 */   // GIR_Coverage, 12826,
     /* 300744 */   GIR_EraseRootFromParent_Done,
     /* 300745 */ // Label 6073: @300745
     /* 300745 */ GIM_Reject,
     /* 300746 */ // Label 6044: @300746
     /* 300746 */ GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(300776), // Rule ID 832 //
     /* 300751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 300754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300765 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 300765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 300770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300774 */   GIR_RootConstrainSelectedInstOperands,
     /* 300775 */   // GIR_Coverage, 832,
     /* 300775 */   GIR_Done,
     /* 300776 */ // Label 6074: @300776
     /* 300776 */ GIM_Reject,
     /* 300777 */ // Label 6045: @300777
     /* 300777 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(300807), // Rule ID 838 //
     /* 300782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300796 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 300796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 300801 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300805 */   GIR_RootConstrainSelectedInstOperands,
     /* 300806 */   // GIR_Coverage, 838,
     /* 300806 */   GIR_Done,
     /* 300807 */ // Label 6075: @300807
     /* 300807 */ GIM_Reject,
     /* 300808 */ // Label 6046: @300808
     /* 300808 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(300838), // Rule ID 834 //
     /* 300813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 300816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300827 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 300827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 300832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300836 */   GIR_RootConstrainSelectedInstOperands,
     /* 300837 */   // GIR_Coverage, 834,
     /* 300837 */   GIR_Done,
     /* 300838 */ // Label 6076: @300838
     /* 300838 */ GIM_Reject,
     /* 300839 */ // Label 6047: @300839
     /* 300839 */ GIM_Reject,
     /* 300840 */ // Label 63: @300840
     /* 300840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6084*/ GIMT_Encode4(301902),
     /* 300851 */ /*GILLT_s32*//*Label 6077*/ GIMT_Encode4(300887),
     /* 300855 */ /*GILLT_s64*//*Label 6078*/ GIMT_Encode4(301274), GIMT_Encode4(0),
     /* 300863 */ /*GILLT_v2s32*//*Label 6079*/ GIMT_Encode4(301661),
     /* 300867 */ /*GILLT_v2s64*//*Label 6080*/ GIMT_Encode4(301735),
     /* 300871 */ /*GILLT_v4s16*//*Label 6081*/ GIMT_Encode4(301809),
     /* 300875 */ /*GILLT_v4s32*//*Label 6082*/ GIMT_Encode4(301840), GIMT_Encode4(0),
     /* 300883 */ /*GILLT_v8s16*//*Label 6083*/ GIMT_Encode4(301871),
     /* 300887 */ // Label 6077: @300887
     /* 300887 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(300924), // Rule ID 4599 //
     /* 300892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300907 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300913 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 300916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300918 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300922 */   GIR_RootConstrainSelectedInstOperands,
     /* 300923 */   // GIR_Coverage, 4599,
     /* 300923 */   GIR_EraseRootFromParent_Done,
     /* 300924 */ // Label 6085: @300924
     /* 300924 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(300961), // Rule ID 4601 //
     /* 300929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300936 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300940 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300944 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300950 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 300953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300959 */   GIR_RootConstrainSelectedInstOperands,
     /* 300960 */   // GIR_Coverage, 4601,
     /* 300960 */   GIR_EraseRootFromParent_Done,
     /* 300961 */ // Label 6086: @300961
     /* 300961 */ GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(300998), // Rule ID 4619 //
     /* 300966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300981 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300987 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 300990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300996 */   GIR_RootConstrainSelectedInstOperands,
     /* 300997 */   // GIR_Coverage, 4619,
     /* 300997 */   GIR_EraseRootFromParent_Done,
     /* 300998 */ // Label 6087: @300998
     /* 300998 */ GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(301035), // Rule ID 4621 //
     /* 301003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301024 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 301027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301029 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301033 */   GIR_RootConstrainSelectedInstOperands,
     /* 301034 */   // GIR_Coverage, 4621,
     /* 301034 */   GIR_EraseRootFromParent_Done,
     /* 301035 */ // Label 6088: @301035
     /* 301035 */ GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(301072), // Rule ID 4659 //
     /* 301040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301055 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301061 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 301064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301066 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301070 */   GIR_RootConstrainSelectedInstOperands,
     /* 301071 */   // GIR_Coverage, 4659,
     /* 301071 */   GIR_EraseRootFromParent_Done,
     /* 301072 */ // Label 6089: @301072
     /* 301072 */ GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(301109), // Rule ID 4661 //
     /* 301077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301092 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301098 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 301101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301103 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301107 */   GIR_RootConstrainSelectedInstOperands,
     /* 301108 */   // GIR_Coverage, 4661,
     /* 301108 */   GIR_EraseRootFromParent_Done,
     /* 301109 */ // Label 6090: @301109
     /* 301109 */ GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(301146), // Rule ID 4639 //
     /* 301114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301129 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301135 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 301138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301140 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301144 */   GIR_RootConstrainSelectedInstOperands,
     /* 301145 */   // GIR_Coverage, 4639,
     /* 301145 */   GIR_EraseRootFromParent_Done,
     /* 301146 */ // Label 6091: @301146
     /* 301146 */ GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(301183), // Rule ID 4641 //
     /* 301151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301158 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301166 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301172 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 301175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301177 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301181 */   GIR_RootConstrainSelectedInstOperands,
     /* 301182 */   // GIR_Coverage, 4641,
     /* 301182 */   GIR_EraseRootFromParent_Done,
     /* 301183 */ // Label 6092: @301183
     /* 301183 */ GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(301213), // Rule ID 407 //
     /* 301188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301202 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 301202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 301207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301211 */   GIR_RootConstrainSelectedInstOperands,
     /* 301212 */   // GIR_Coverage, 407,
     /* 301212 */   GIR_Done,
     /* 301213 */ // Label 6093: @301213
     /* 301213 */ GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(301243), // Rule ID 411 //
     /* 301218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301232 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 301232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 301237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301241 */   GIR_RootConstrainSelectedInstOperands,
     /* 301242 */   // GIR_Coverage, 411,
     /* 301242 */   GIR_Done,
     /* 301243 */ // Label 6094: @301243
     /* 301243 */ GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(301273), // Rule ID 415 //
     /* 301248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301262 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 301262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 301267 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301271 */   GIR_RootConstrainSelectedInstOperands,
     /* 301272 */   // GIR_Coverage, 415,
     /* 301272 */   GIR_Done,
     /* 301273 */ // Label 6095: @301273
     /* 301273 */ GIM_Reject,
     /* 301274 */ // Label 6078: @301274
     /* 301274 */ GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(301311), // Rule ID 4600 //
     /* 301279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301294 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301300 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 301303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301305 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301309 */   GIR_RootConstrainSelectedInstOperands,
     /* 301310 */   // GIR_Coverage, 4600,
     /* 301310 */   GIR_EraseRootFromParent_Done,
     /* 301311 */ // Label 6096: @301311
     /* 301311 */ GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(301348), // Rule ID 4602 //
     /* 301316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301337 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 301340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301346 */   GIR_RootConstrainSelectedInstOperands,
     /* 301347 */   // GIR_Coverage, 4602,
     /* 301347 */   GIR_EraseRootFromParent_Done,
     /* 301348 */ // Label 6097: @301348
     /* 301348 */ GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(301385), // Rule ID 4620 //
     /* 301353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301368 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301374 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 301377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301379 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301383 */   GIR_RootConstrainSelectedInstOperands,
     /* 301384 */   // GIR_Coverage, 4620,
     /* 301384 */   GIR_EraseRootFromParent_Done,
     /* 301385 */ // Label 6098: @301385
     /* 301385 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(301422), // Rule ID 4622 //
     /* 301390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301405 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301409 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301411 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 301414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301416 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301420 */   GIR_RootConstrainSelectedInstOperands,
     /* 301421 */   // GIR_Coverage, 4622,
     /* 301421 */   GIR_EraseRootFromParent_Done,
     /* 301422 */ // Label 6099: @301422
     /* 301422 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(301459), // Rule ID 4660 //
     /* 301427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301448 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 301451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301453 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301457 */   GIR_RootConstrainSelectedInstOperands,
     /* 301458 */   // GIR_Coverage, 4660,
     /* 301458 */   GIR_EraseRootFromParent_Done,
     /* 301459 */ // Label 6100: @301459
     /* 301459 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(301496), // Rule ID 4662 //
     /* 301464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301485 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 301488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301490 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301494 */   GIR_RootConstrainSelectedInstOperands,
     /* 301495 */   // GIR_Coverage, 4662,
     /* 301495 */   GIR_EraseRootFromParent_Done,
     /* 301496 */ // Label 6101: @301496
     /* 301496 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(301533), // Rule ID 4640 //
     /* 301501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301508 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301516 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301522 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 301525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301527 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301531 */   GIR_RootConstrainSelectedInstOperands,
     /* 301532 */   // GIR_Coverage, 4640,
     /* 301532 */   GIR_EraseRootFromParent_Done,
     /* 301533 */ // Label 6102: @301533
     /* 301533 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(301570), // Rule ID 4642 //
     /* 301538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301559 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 301562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301564 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301568 */   GIR_RootConstrainSelectedInstOperands,
     /* 301569 */   // GIR_Coverage, 4642,
     /* 301569 */   GIR_EraseRootFromParent_Done,
     /* 301570 */ // Label 6103: @301570
     /* 301570 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(301600), // Rule ID 409 //
     /* 301575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301589 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 301589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 301594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301598 */   GIR_RootConstrainSelectedInstOperands,
     /* 301599 */   // GIR_Coverage, 409,
     /* 301599 */   GIR_Done,
     /* 301600 */ // Label 6104: @301600
     /* 301600 */ GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(301630), // Rule ID 413 //
     /* 301605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301619 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 301619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 301624 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301628 */   GIR_RootConstrainSelectedInstOperands,
     /* 301629 */   // GIR_Coverage, 413,
     /* 301629 */   GIR_Done,
     /* 301630 */ // Label 6105: @301630
     /* 301630 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(301660), // Rule ID 417 //
     /* 301635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301649 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 301649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 301654 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301658 */   GIR_RootConstrainSelectedInstOperands,
     /* 301659 */   // GIR_Coverage, 417,
     /* 301659 */   GIR_Done,
     /* 301660 */ // Label 6106: @301660
     /* 301660 */ GIM_Reject,
     /* 301661 */ // Label 6079: @301661
     /* 301661 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(301691), // Rule ID 846 //
     /* 301666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301680 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 301680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 301685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301689 */   GIR_RootConstrainSelectedInstOperands,
     /* 301690 */   // GIR_Coverage, 846,
     /* 301690 */   GIR_Done,
     /* 301691 */ // Label 6107: @301691
     /* 301691 */ GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(301734), // Rule ID 12829 //
     /* 301696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301706 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 301706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 301713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301718 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 301727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301732 */   GIR_RootConstrainSelectedInstOperands,
     /* 301733 */   // GIR_Coverage, 12829,
     /* 301733 */   GIR_EraseRootFromParent_Done,
     /* 301734 */ // Label 6108: @301734
     /* 301734 */ GIM_Reject,
     /* 301735 */ // Label 6080: @301735
     /* 301735 */ GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(301765), // Rule ID 850 //
     /* 301740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301754 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 301754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 301759 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301763 */   GIR_RootConstrainSelectedInstOperands,
     /* 301764 */   // GIR_Coverage, 850,
     /* 301764 */   GIR_Done,
     /* 301765 */ // Label 6109: @301765
     /* 301765 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(301808), // Rule ID 12827 //
     /* 301770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301780 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 301780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 301787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 301801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301806 */   GIR_RootConstrainSelectedInstOperands,
     /* 301807 */   // GIR_Coverage, 12827,
     /* 301807 */   GIR_EraseRootFromParent_Done,
     /* 301808 */ // Label 6110: @301808
     /* 301808 */ GIM_Reject,
     /* 301809 */ // Label 6081: @301809
     /* 301809 */ GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(301839), // Rule ID 842 //
     /* 301814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301828 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 301828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 301833 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301837 */   GIR_RootConstrainSelectedInstOperands,
     /* 301838 */   // GIR_Coverage, 842,
     /* 301838 */   GIR_Done,
     /* 301839 */ // Label 6111: @301839
     /* 301839 */ GIM_Reject,
     /* 301840 */ // Label 6082: @301840
     /* 301840 */ GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(301870), // Rule ID 848 //
     /* 301845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301859 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 301859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 301864 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301868 */   GIR_RootConstrainSelectedInstOperands,
     /* 301869 */   // GIR_Coverage, 848,
     /* 301869 */   GIR_Done,
     /* 301870 */ // Label 6112: @301870
     /* 301870 */ GIM_Reject,
     /* 301871 */ // Label 6083: @301871
     /* 301871 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301901), // Rule ID 844 //
     /* 301876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301890 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 301890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 301895 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301899 */   GIR_RootConstrainSelectedInstOperands,
     /* 301900 */   // GIR_Coverage, 844,
     /* 301900 */   GIR_Done,
     /* 301901 */ // Label 6113: @301901
     /* 301901 */ GIM_Reject,
     /* 301902 */ // Label 6084: @301902
     /* 301902 */ GIM_Reject,
     /* 301903 */ // Label 64: @301903
     /* 301903 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6122*/ GIMT_Encode4(306299),
     /* 301914 */ /*GILLT_s16*//*Label 6114*/ GIMT_Encode4(301954),
     /* 301918 */ /*GILLT_s32*//*Label 6115*/ GIMT_Encode4(302235),
     /* 301922 */ /*GILLT_s64*//*Label 6116*/ GIMT_Encode4(304151), GIMT_Encode4(0),
     /* 301930 */ /*GILLT_v2s32*//*Label 6117*/ GIMT_Encode4(306055),
     /* 301934 */ /*GILLT_v2s64*//*Label 6118*/ GIMT_Encode4(306129),
     /* 301938 */ /*GILLT_v4s16*//*Label 6119*/ GIMT_Encode4(306206),
     /* 301942 */ /*GILLT_v4s32*//*Label 6120*/ GIMT_Encode4(306237), GIMT_Encode4(0),
     /* 301950 */ /*GILLT_v8s16*//*Label 6121*/ GIMT_Encode4(306268),
     /* 301954 */ // Label 6114: @301954
     /* 301954 */ GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(302057), // Rule ID 5259 //
     /* 301959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 301962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 301977 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301981 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301985 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301989 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301993 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301997 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302002 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302006 */   // MIs[1] Operand 2
     /* 302006 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 302017 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302019 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 302019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302031 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 302037 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302042 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 302050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302055 */   GIR_RootConstrainSelectedInstOperands,
     /* 302056 */   // GIR_Coverage, 5259,
     /* 302056 */   GIR_EraseRootFromParent_Done,
     /* 302057 */ // Label 6123: @302057
     /* 302057 */ GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(302114), // Rule ID 5250 //
     /* 302062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 302065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 302080 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302086 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 302086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 302093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302098 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 302107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302112 */   GIR_RootConstrainSelectedInstOperands,
     /* 302113 */   // GIR_Coverage, 5250,
     /* 302113 */   GIR_EraseRootFromParent_Done,
     /* 302114 */ // Label 6124: @302114
     /* 302114 */ GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(302144), // Rule ID 443 //
     /* 302119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302133 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 302133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 302138 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302142 */   GIR_RootConstrainSelectedInstOperands,
     /* 302143 */   // GIR_Coverage, 443,
     /* 302143 */   GIR_Done,
     /* 302144 */ // Label 6125: @302144
     /* 302144 */ GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(302174), // Rule ID 449 //
     /* 302149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 302163 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 302163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 302168 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302172 */   GIR_RootConstrainSelectedInstOperands,
     /* 302173 */   // GIR_Coverage, 449,
     /* 302173 */   GIR_Done,
     /* 302174 */ // Label 6126: @302174
     /* 302174 */ GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(302204), // Rule ID 491 //
     /* 302179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 302182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302193 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 302193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 302198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302202 */   GIR_RootConstrainSelectedInstOperands,
     /* 302203 */   // GIR_Coverage, 491,
     /* 302203 */   GIR_Done,
     /* 302204 */ // Label 6127: @302204
     /* 302204 */ GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(302234), // Rule ID 495 //
     /* 302209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 302212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302223 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 302223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 302228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302232 */   GIR_RootConstrainSelectedInstOperands,
     /* 302233 */   // GIR_Coverage, 495,
     /* 302233 */   GIR_Done,
     /* 302234 */ // Label 6128: @302234
     /* 302234 */ GIM_Reject,
     /* 302235 */ // Label 6115: @302235
     /* 302235 */ GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(302473), // Rule ID 6288 //
     /* 302240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302258 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302261 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 302268 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302274 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 302281 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302281 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 302284 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 302288 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302308 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302315 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 302318 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302322 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 302329 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 302332 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302336 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302341 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302344 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 302347 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 302350 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302355 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302360 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 302365 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 302368 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 302372 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302377 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302380 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 302383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302385 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302388 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302392 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302397 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 302404 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302409 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302414 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302417 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302421 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302426 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302429 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302446 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302453 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302471 */   GIR_RootConstrainSelectedInstOperands,
     /* 302472 */   // GIR_Coverage, 6288,
     /* 302472 */   GIR_EraseRootFromParent_Done,
     /* 302473 */ // Label 6129: @302473
     /* 302473 */ GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(302711), // Rule ID 6289 //
     /* 302478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302496 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302499 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 302506 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302512 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 302519 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302519 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 302522 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 302526 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302546 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302553 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 302556 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302560 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 302567 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 302570 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302574 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302579 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302582 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 302585 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 302588 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302593 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302598 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 302603 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 302606 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 302610 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302615 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302618 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 302621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302623 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302626 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302630 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302635 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 302642 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302647 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302652 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302655 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302659 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302664 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302667 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302684 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302696 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302709 */   GIR_RootConstrainSelectedInstOperands,
     /* 302710 */   // GIR_Coverage, 6289,
     /* 302710 */   GIR_EraseRootFromParent_Done,
     /* 302711 */ // Label 6130: @302711
     /* 302711 */ GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302900), // Rule ID 6292 //
     /* 302716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302734 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302737 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 302744 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302750 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 302757 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302757 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 302760 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 302764 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302784 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302791 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 302794 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302798 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302805 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302808 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302812 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302817 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302820 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 302823 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 302826 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302831 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302836 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302841 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302844 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302848 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302853 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302856 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302873 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302880 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302885 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302898 */   GIR_RootConstrainSelectedInstOperands,
     /* 302899 */   // GIR_Coverage, 6292,
     /* 302899 */   GIR_EraseRootFromParent_Done,
     /* 302900 */ // Label 6131: @302900
     /* 302900 */ GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(303089), // Rule ID 6293 //
     /* 302905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302923 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302926 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 302933 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302939 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 302946 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302946 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 302949 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 302953 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302973 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302980 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 302983 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302987 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302994 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302997 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303001 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303006 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303009 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303012 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303015 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303020 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303025 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303030 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303033 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303037 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303042 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303045 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303062 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303087 */   GIR_RootConstrainSelectedInstOperands,
     /* 303088 */   // GIR_Coverage, 6293,
     /* 303088 */   GIR_EraseRootFromParent_Done,
     /* 303089 */ // Label 6132: @303089
     /* 303089 */ GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(303322), // Rule ID 6290 //
     /* 303094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303104 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303112 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303115 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 303122 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303126 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303128 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 303135 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303135 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 303138 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 303142 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303157 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303164 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303167 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303171 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303178 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303181 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303185 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303190 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303193 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303196 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303199 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303204 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303209 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303214 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303217 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303221 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303226 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303229 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303234 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303237 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303241 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303246 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303253 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303258 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303263 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303266 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303270 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303275 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303278 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303295 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303307 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303320 */   GIR_RootConstrainSelectedInstOperands,
     /* 303321 */   // GIR_Coverage, 6290,
     /* 303321 */   GIR_EraseRootFromParent_Done,
     /* 303322 */ // Label 6133: @303322
     /* 303322 */ GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(303555), // Rule ID 6291 //
     /* 303327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303337 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303345 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303348 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 303355 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303361 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 303368 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303368 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 303371 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 303375 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303390 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303397 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303400 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303404 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303411 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303414 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303418 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303423 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303426 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303429 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303432 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303437 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303442 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303447 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303450 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303454 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303459 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303462 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303467 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303470 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303474 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303479 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303491 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303496 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303499 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303503 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303508 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303511 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303528 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303540 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303553 */   GIR_RootConstrainSelectedInstOperands,
     /* 303554 */   // GIR_Coverage, 6291,
     /* 303554 */   GIR_EraseRootFromParent_Done,
     /* 303555 */ // Label 6134: @303555
     /* 303555 */ GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(303739), // Rule ID 6294 //
     /* 303560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303578 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303581 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 303588 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303594 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 303601 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303601 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 303604 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 303608 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303623 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303630 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 303633 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303637 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303644 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303647 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303651 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303656 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303659 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303662 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303665 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303670 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303675 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303680 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303683 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303687 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303692 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303695 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303712 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303719 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303737 */   GIR_RootConstrainSelectedInstOperands,
     /* 303738 */   // GIR_Coverage, 6294,
     /* 303738 */   GIR_EraseRootFromParent_Done,
     /* 303739 */ // Label 6135: @303739
     /* 303739 */ GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(303923), // Rule ID 6295 //
     /* 303744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303762 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303765 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 303772 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303778 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 303785 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303785 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 303788 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 303792 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303807 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303814 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 303817 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303821 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303828 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303831 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303835 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303840 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303843 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303846 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303849 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303854 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303859 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303864 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303867 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303871 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303876 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303879 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303896 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303921 */   GIR_RootConstrainSelectedInstOperands,
     /* 303922 */   // GIR_Coverage, 6295,
     /* 303922 */   GIR_EraseRootFromParent_Done,
     /* 303923 */ // Label 6136: @303923
     /* 303923 */ GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(304003), // Rule ID 5255 //
     /* 303928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 303931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303946 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303950 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303954 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303959 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303965 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 303965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303977 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 303983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304001 */   GIR_RootConstrainSelectedInstOperands,
     /* 304002 */   // GIR_Coverage, 5255,
     /* 304002 */   GIR_EraseRootFromParent_Done,
     /* 304003 */ // Label 6137: @304003
     /* 304003 */ GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(304060), // Rule ID 5238 //
     /* 304008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 304011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 304026 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304032 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 304032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 304039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304044 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304058 */   GIR_RootConstrainSelectedInstOperands,
     /* 304059 */   // GIR_Coverage, 5238,
     /* 304059 */   GIR_EraseRootFromParent_Done,
     /* 304060 */ // Label 6138: @304060
     /* 304060 */ GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(304090), // Rule ID 445 //
     /* 304065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304079 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 304079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 304084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304088 */   GIR_RootConstrainSelectedInstOperands,
     /* 304089 */   // GIR_Coverage, 445,
     /* 304089 */   GIR_Done,
     /* 304090 */ // Label 6139: @304090
     /* 304090 */ GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(304120), // Rule ID 451 //
     /* 304095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304109 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 304109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 304114 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304118 */   GIR_RootConstrainSelectedInstOperands,
     /* 304119 */   // GIR_Coverage, 451,
     /* 304119 */   GIR_Done,
     /* 304120 */ // Label 6140: @304120
     /* 304120 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(304150), // Rule ID 497 //
     /* 304125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 304128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304139 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 304139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 304144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304148 */   GIR_RootConstrainSelectedInstOperands,
     /* 304149 */   // GIR_Coverage, 497,
     /* 304149 */   GIR_Done,
     /* 304150 */ // Label 6141: @304150
     /* 304150 */ GIM_Reject,
     /* 304151 */ // Label 6116: @304151
     /* 304151 */ GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(304337), // Rule ID 6300 //
     /* 304156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 304174 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 304181 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304187 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 304194 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304194 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304197 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 304201 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304221 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304228 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304231 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304235 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304242 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304245 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304249 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304254 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304257 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304260 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 304263 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304268 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304273 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304278 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304281 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304285 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304290 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304293 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304310 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304335 */   GIR_RootConstrainSelectedInstOperands,
     /* 304336 */   // GIR_Coverage, 6300,
     /* 304336 */   GIR_EraseRootFromParent_Done,
     /* 304337 */ // Label 6142: @304337
     /* 304337 */ GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(304523), // Rule ID 6301 //
     /* 304342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 304360 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304363 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 304367 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304373 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 304380 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304380 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304383 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 304387 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304407 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304414 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304417 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304421 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304428 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304431 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304435 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304440 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304443 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304446 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 304449 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304454 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304459 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304476 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304479 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304496 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304521 */   GIR_RootConstrainSelectedInstOperands,
     /* 304522 */   // GIR_Coverage, 6301,
     /* 304522 */   GIR_EraseRootFromParent_Done,
     /* 304523 */ // Label 6143: @304523
     /* 304523 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(304761), // Rule ID 6296 //
     /* 304528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304538 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304546 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304549 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 304556 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304562 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 304569 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304569 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 304572 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 304576 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304596 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304603 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 304606 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304610 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 304617 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 304620 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304624 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304629 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304632 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 304635 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 304638 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304643 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304648 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304653 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 304656 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 304660 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304665 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304668 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 304671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304673 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304676 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304680 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304685 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304692 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304697 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304702 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304705 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304709 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304714 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304717 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304734 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304759 */   GIR_RootConstrainSelectedInstOperands,
     /* 304760 */   // GIR_Coverage, 6296,
     /* 304760 */   GIR_EraseRootFromParent_Done,
     /* 304761 */ // Label 6144: @304761
     /* 304761 */ GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(304999), // Rule ID 6297 //
     /* 304766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304784 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304787 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 304794 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304800 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 304807 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304807 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 304810 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 304814 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304834 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304841 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 304844 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304848 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 304855 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 304858 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304862 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304867 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304870 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 304873 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 304876 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304881 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304886 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304891 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 304894 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 304898 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304903 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304906 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 304909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304911 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304914 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304918 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304923 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304930 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304935 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304940 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304943 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304947 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304952 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304955 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304972 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304997 */   GIR_RootConstrainSelectedInstOperands,
     /* 304998 */   // GIR_Coverage, 6297,
     /* 304998 */   GIR_EraseRootFromParent_Done,
     /* 304999 */ // Label 6145: @304999
     /* 304999 */ GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(305180), // Rule ID 6302 //
     /* 305004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305014 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305018 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 305022 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 305029 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305035 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 305042 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305042 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 305045 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 305049 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305064 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305071 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305074 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305078 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305085 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305088 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305092 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305097 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305100 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305103 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 305106 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305111 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305116 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305133 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305136 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305153 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305178 */   GIR_RootConstrainSelectedInstOperands,
     /* 305179 */   // GIR_Coverage, 6302,
     /* 305179 */   GIR_EraseRootFromParent_Done,
     /* 305180 */ // Label 6146: @305180
     /* 305180 */ GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(305361), // Rule ID 6303 //
     /* 305185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 305203 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 305210 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305216 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 305223 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305223 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 305226 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 305230 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305245 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305252 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305255 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305259 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305266 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305269 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305273 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305278 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305281 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305284 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 305287 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305292 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305297 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305302 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305305 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305309 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305314 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305317 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305334 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305359 */   GIR_RootConstrainSelectedInstOperands,
     /* 305360 */   // GIR_Coverage, 6303,
     /* 305360 */   GIR_EraseRootFromParent_Done,
     /* 305361 */ // Label 6147: @305361
     /* 305361 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(305594), // Rule ID 6298 //
     /* 305366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305384 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305387 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305394 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305400 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 305407 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305407 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305410 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 305414 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305429 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305436 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305439 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305443 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305450 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305453 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305457 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305462 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305465 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305468 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305471 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305476 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305481 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305486 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305489 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305493 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305498 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305501 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305506 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305509 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305513 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305518 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305525 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305530 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305535 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305538 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305542 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305547 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305550 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305567 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305592 */   GIR_RootConstrainSelectedInstOperands,
     /* 305593 */   // GIR_Coverage, 6298,
     /* 305593 */   GIR_EraseRootFromParent_Done,
     /* 305594 */ // Label 6148: @305594
     /* 305594 */ GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(305827), // Rule ID 6299 //
     /* 305599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305617 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305620 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305627 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305633 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 305640 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305640 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305643 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 305647 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305662 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305669 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305672 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305676 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305683 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305686 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305690 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305695 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305698 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305701 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305704 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305709 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305714 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305719 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305722 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305726 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305731 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305734 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305739 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305742 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305746 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305751 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305758 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305763 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305768 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305771 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305775 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305780 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305783 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305800 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305825 */   GIR_RootConstrainSelectedInstOperands,
     /* 305826 */   // GIR_Coverage, 6299,
     /* 305826 */   GIR_EraseRootFromParent_Done,
     /* 305827 */ // Label 6149: @305827
     /* 305827 */ GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(305907), // Rule ID 5257 //
     /* 305832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 305835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305850 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305854 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305858 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305863 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305869 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 305869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305881 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305905 */   GIR_RootConstrainSelectedInstOperands,
     /* 305906 */   // GIR_Coverage, 5257,
     /* 305906 */   GIR_EraseRootFromParent_Done,
     /* 305907 */ // Label 6150: @305907
     /* 305907 */ GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(305964), // Rule ID 5234 //
     /* 305912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 305915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 305930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305934 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305936 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 305936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 305943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305948 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305962 */   GIR_RootConstrainSelectedInstOperands,
     /* 305963 */   // GIR_Coverage, 5234,
     /* 305963 */   GIR_EraseRootFromParent_Done,
     /* 305964 */ // Label 6151: @305964
     /* 305964 */ GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(305994), // Rule ID 447 //
     /* 305969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 305983 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 305983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 305988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305992 */   GIR_RootConstrainSelectedInstOperands,
     /* 305993 */   // GIR_Coverage, 447,
     /* 305993 */   GIR_Done,
     /* 305994 */ // Label 6152: @305994
     /* 305994 */ GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(306024), // Rule ID 453 //
     /* 305999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 306013 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 306013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 306018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306022 */   GIR_RootConstrainSelectedInstOperands,
     /* 306023 */   // GIR_Coverage, 453,
     /* 306023 */   GIR_Done,
     /* 306024 */ // Label 6153: @306024
     /* 306024 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(306054), // Rule ID 493 //
     /* 306029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306043 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 306043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 306048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306052 */   GIR_RootConstrainSelectedInstOperands,
     /* 306053 */   // GIR_Coverage, 493,
     /* 306053 */   GIR_Done,
     /* 306054 */ // Label 6154: @306054
     /* 306054 */ GIM_Reject,
     /* 306055 */ // Label 6117: @306055
     /* 306055 */ GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(306085), // Rule ID 1010 //
     /* 306060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306074 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 306074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 306079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306083 */   GIR_RootConstrainSelectedInstOperands,
     /* 306084 */   // GIR_Coverage, 1010,
     /* 306084 */   GIR_Done,
     /* 306085 */ // Label 6155: @306085
     /* 306085 */ GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(306128), // Rule ID 12824 //
     /* 306090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306100 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 306100 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306103 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306107 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306112 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 306116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 306121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306126 */   GIR_RootConstrainSelectedInstOperands,
     /* 306127 */   // GIR_Coverage, 12824,
     /* 306127 */   GIR_EraseRootFromParent_Done,
     /* 306128 */ // Label 6156: @306128
     /* 306128 */ GIM_Reject,
     /* 306129 */ // Label 6118: @306129
     /* 306129 */ GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(306159), // Rule ID 1014 //
     /* 306134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306148 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 306148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306157 */   GIR_RootConstrainSelectedInstOperands,
     /* 306158 */   // GIR_Coverage, 1014,
     /* 306158 */   GIR_Done,
     /* 306159 */ // Label 6157: @306159
     /* 306159 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(306205), // Rule ID 12822 //
     /* 306164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306174 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 306174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 306181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306186 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 306190 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306203 */   GIR_RootConstrainSelectedInstOperands,
     /* 306204 */   // GIR_Coverage, 12822,
     /* 306204 */   GIR_EraseRootFromParent_Done,
     /* 306205 */ // Label 6158: @306205
     /* 306205 */ GIM_Reject,
     /* 306206 */ // Label 6119: @306206
     /* 306206 */ GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(306236), // Rule ID 1006 //
     /* 306211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306225 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 306225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 306230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306234 */   GIR_RootConstrainSelectedInstOperands,
     /* 306235 */   // GIR_Coverage, 1006,
     /* 306235 */   GIR_Done,
     /* 306236 */ // Label 6159: @306236
     /* 306236 */ GIM_Reject,
     /* 306237 */ // Label 6120: @306237
     /* 306237 */ GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(306267), // Rule ID 1012 //
     /* 306242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306256 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 306256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 306261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306265 */   GIR_RootConstrainSelectedInstOperands,
     /* 306266 */   // GIR_Coverage, 1012,
     /* 306266 */   GIR_Done,
     /* 306267 */ // Label 6160: @306267
     /* 306267 */ GIM_Reject,
     /* 306268 */ // Label 6121: @306268
     /* 306268 */ GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(306298), // Rule ID 1008 //
     /* 306273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306287 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 306287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 306292 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306296 */   GIR_RootConstrainSelectedInstOperands,
     /* 306297 */   // GIR_Coverage, 1008,
     /* 306297 */   GIR_Done,
     /* 306298 */ // Label 6161: @306298
     /* 306298 */ GIM_Reject,
     /* 306299 */ // Label 6122: @306299
     /* 306299 */ GIM_Reject,
     /* 306300 */ // Label 65: @306300
     /* 306300 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6170*/ GIMT_Encode4(310074),
     /* 306311 */ /*GILLT_s16*//*Label 6162*/ GIMT_Encode4(306351),
     /* 306315 */ /*GILLT_s32*//*Label 6163*/ GIMT_Encode4(306636),
     /* 306319 */ /*GILLT_s64*//*Label 6164*/ GIMT_Encode4(307964), GIMT_Encode4(0),
     /* 306327 */ /*GILLT_v2s32*//*Label 6165*/ GIMT_Encode4(309830),
     /* 306331 */ /*GILLT_v2s64*//*Label 6166*/ GIMT_Encode4(309904),
     /* 306335 */ /*GILLT_v4s16*//*Label 6167*/ GIMT_Encode4(309981),
     /* 306339 */ /*GILLT_v4s32*//*Label 6168*/ GIMT_Encode4(310012), GIMT_Encode4(0),
     /* 306347 */ /*GILLT_v8s16*//*Label 6169*/ GIMT_Encode4(310043),
     /* 306351 */ // Label 6162: @306351
     /* 306351 */ GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(306458), // Rule ID 5260 //
     /* 306356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 306359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 306374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306378 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306382 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306386 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306390 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306394 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306398 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306403 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306407 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 306418 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306420 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 306420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306432 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 306451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306456 */   GIR_RootConstrainSelectedInstOperands,
     /* 306457 */   // GIR_Coverage, 5260,
     /* 306457 */   GIR_EraseRootFromParent_Done,
     /* 306458 */ // Label 6171: @306458
     /* 306458 */ GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(306515), // Rule ID 5254 //
     /* 306463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 306466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306473 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306477 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 306481 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306487 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 306487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 306494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306499 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 306508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306513 */   GIR_RootConstrainSelectedInstOperands,
     /* 306514 */   // GIR_Coverage, 5254,
     /* 306514 */   GIR_EraseRootFromParent_Done,
     /* 306515 */ // Label 6172: @306515
     /* 306515 */ GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(306545), // Rule ID 467 //
     /* 306520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306534 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 306534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 306539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306543 */   GIR_RootConstrainSelectedInstOperands,
     /* 306544 */   // GIR_Coverage, 467,
     /* 306544 */   GIR_Done,
     /* 306545 */ // Label 6173: @306545
     /* 306545 */ GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(306575), // Rule ID 473 //
     /* 306550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 306564 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 306564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 306569 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306573 */   GIR_RootConstrainSelectedInstOperands,
     /* 306574 */   // GIR_Coverage, 473,
     /* 306574 */   GIR_Done,
     /* 306575 */ // Label 6174: @306575
     /* 306575 */ GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(306605), // Rule ID 499 //
     /* 306580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306594 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 306594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 306599 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306603 */   GIR_RootConstrainSelectedInstOperands,
     /* 306604 */   // GIR_Coverage, 499,
     /* 306604 */   GIR_Done,
     /* 306605 */ // Label 6175: @306605
     /* 306605 */ GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(306635), // Rule ID 503 //
     /* 306610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306624 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 306624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 306629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306633 */   GIR_RootConstrainSelectedInstOperands,
     /* 306634 */   // GIR_Coverage, 503,
     /* 306634 */   GIR_Done,
     /* 306635 */ // Label 6176: @306635
     /* 306635 */ GIM_Reject,
     /* 306636 */ // Label 6163: @306636
     /* 306636 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(306776), // Rule ID 5261 //
     /* 306641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 306659 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306662 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 306669 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306675 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 306682 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 306682 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 306685 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 306689 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 306704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 306709 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306742 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306748 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 306751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 306766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 306769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306774 */   GIR_RootConstrainSelectedInstOperands,
     /* 306775 */   // GIR_Coverage, 5261,
     /* 306775 */   GIR_EraseRootFromParent_Done,
     /* 306776 */ // Label 6177: @306776
     /* 306776 */ GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(306916), // Rule ID 5262 //
     /* 306781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 306799 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306802 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 306809 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306815 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 306822 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 306822 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 306825 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 306829 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 306844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 306849 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306856 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306859 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306863 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306882 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306885 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306888 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 306891 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306896 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306901 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 306906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 306909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306914 */   GIR_RootConstrainSelectedInstOperands,
     /* 306915 */   // GIR_Coverage, 5262,
     /* 306915 */   GIR_EraseRootFromParent_Done,
     /* 306916 */ // Label 6178: @306916
     /* 306916 */ GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(307056), // Rule ID 5265 //
     /* 306921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 306939 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306942 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 306949 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306953 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306955 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 306962 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 306962 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 306965 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 306969 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 306984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 306989 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306996 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306999 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307003 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307022 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307025 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307028 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307041 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307054 */   GIR_RootConstrainSelectedInstOperands,
     /* 307055 */   // GIR_Coverage, 5265,
     /* 307055 */   GIR_EraseRootFromParent_Done,
     /* 307056 */ // Label 6179: @307056
     /* 307056 */ GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(307196), // Rule ID 5266 //
     /* 307061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307079 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307082 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307089 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307095 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 307102 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 307102 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307105 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 307109 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307129 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307136 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307139 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307143 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307162 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307165 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307168 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307171 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307194 */   GIR_RootConstrainSelectedInstOperands,
     /* 307195 */   // GIR_Coverage, 5266,
     /* 307195 */   GIR_EraseRootFromParent_Done,
     /* 307196 */ // Label 6180: @307196
     /* 307196 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(307331), // Rule ID 5263 //
     /* 307201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307219 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307222 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307229 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307235 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 307242 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 307242 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307245 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 307249 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307264 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307300 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307303 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307329 */   GIR_RootConstrainSelectedInstOperands,
     /* 307330 */   // GIR_Coverage, 5263,
     /* 307330 */   GIR_EraseRootFromParent_Done,
     /* 307331 */ // Label 6181: @307331
     /* 307331 */ GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(307466), // Rule ID 5264 //
     /* 307336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307354 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307357 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307364 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307370 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 307377 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 307377 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307380 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 307384 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307399 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307406 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307409 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307413 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307432 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307435 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307438 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307441 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307464 */   GIR_RootConstrainSelectedInstOperands,
     /* 307465 */   // GIR_Coverage, 5264,
     /* 307465 */   GIR_EraseRootFromParent_Done,
     /* 307466 */ // Label 6182: @307466
     /* 307466 */ GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(307601), // Rule ID 5267 //
     /* 307471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307489 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307492 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307499 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307505 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 307512 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 307512 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307515 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 307519 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307534 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307541 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307544 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307548 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307567 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307570 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307573 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307599 */   GIR_RootConstrainSelectedInstOperands,
     /* 307600 */   // GIR_Coverage, 5267,
     /* 307600 */   GIR_EraseRootFromParent_Done,
     /* 307601 */ // Label 6183: @307601
     /* 307601 */ GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(307736), // Rule ID 5268 //
     /* 307606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307624 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307627 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307634 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307638 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307640 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 307647 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 307647 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307650 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 307654 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307669 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307676 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307679 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307683 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307702 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307705 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307708 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307734 */   GIR_RootConstrainSelectedInstOperands,
     /* 307735 */   // GIR_Coverage, 5268,
     /* 307735 */   GIR_EraseRootFromParent_Done,
     /* 307736 */ // Label 6184: @307736
     /* 307736 */ GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(307816), // Rule ID 5256 //
     /* 307741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307759 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307763 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307767 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307772 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307778 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 307778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307790 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 307796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307814 */   GIR_RootConstrainSelectedInstOperands,
     /* 307815 */   // GIR_Coverage, 5256,
     /* 307815 */   GIR_EraseRootFromParent_Done,
     /* 307816 */ // Label 6185: @307816
     /* 307816 */ GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(307873), // Rule ID 5246 //
     /* 307821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 307839 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307845 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 307845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 307852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307857 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307871 */   GIR_RootConstrainSelectedInstOperands,
     /* 307872 */   // GIR_Coverage, 5246,
     /* 307872 */   GIR_EraseRootFromParent_Done,
     /* 307873 */ // Label 6186: @307873
     /* 307873 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(307903), // Rule ID 469 //
     /* 307878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307892 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 307892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 307897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307901 */   GIR_RootConstrainSelectedInstOperands,
     /* 307902 */   // GIR_Coverage, 469,
     /* 307902 */   GIR_Done,
     /* 307903 */ // Label 6187: @307903
     /* 307903 */ GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(307933), // Rule ID 475 //
     /* 307908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307922 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 307922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 307927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307931 */   GIR_RootConstrainSelectedInstOperands,
     /* 307932 */   // GIR_Coverage, 475,
     /* 307932 */   GIR_Done,
     /* 307933 */ // Label 6188: @307933
     /* 307933 */ GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(307963), // Rule ID 505 //
     /* 307938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 307941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307952 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 307952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 307957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307961 */   GIR_RootConstrainSelectedInstOperands,
     /* 307962 */   // GIR_Coverage, 505,
     /* 307962 */   GIR_Done,
     /* 307963 */ // Label 6189: @307963
     /* 307963 */ GIM_Reject,
     /* 307964 */ // Label 6164: @307964
     /* 307964 */ GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(308101), // Rule ID 5277 //
     /* 307969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 307987 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 307994 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308000 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 308007 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 308007 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308010 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 308014 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308034 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308041 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308044 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308048 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308067 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308070 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308073 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308099 */   GIR_RootConstrainSelectedInstOperands,
     /* 308100 */   // GIR_Coverage, 5277,
     /* 308100 */   GIR_EraseRootFromParent_Done,
     /* 308101 */ // Label 6190: @308101
     /* 308101 */ GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(308238), // Rule ID 5278 //
     /* 308106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308124 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308131 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308137 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 308144 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 308144 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308147 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 308151 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308171 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308204 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308207 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308210 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308236 */   GIR_RootConstrainSelectedInstOperands,
     /* 308237 */   // GIR_Coverage, 5278,
     /* 308237 */   GIR_EraseRootFromParent_Done,
     /* 308238 */ // Label 6191: @308238
     /* 308238 */ GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(308378), // Rule ID 5269 //
     /* 308243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308261 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308264 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 308271 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308277 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 308284 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 308284 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 308287 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 308291 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308311 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308344 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308347 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308350 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 308353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308363 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 308368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308376 */   GIR_RootConstrainSelectedInstOperands,
     /* 308377 */   // GIR_Coverage, 5269,
     /* 308377 */   GIR_EraseRootFromParent_Done,
     /* 308378 */ // Label 6192: @308378
     /* 308378 */ GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(308518), // Rule ID 5270 //
     /* 308383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308401 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308404 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 308411 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308417 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 308424 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 308424 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 308427 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 308431 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308451 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308458 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308461 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308465 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308484 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308487 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308490 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 308493 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308498 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 308508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308516 */   GIR_RootConstrainSelectedInstOperands,
     /* 308517 */   // GIR_Coverage, 5270,
     /* 308517 */   GIR_EraseRootFromParent_Done,
     /* 308518 */ // Label 6193: @308518
     /* 308518 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(308658), // Rule ID 5273 //
     /* 308523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308541 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308544 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308551 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308557 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 308564 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 308564 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 308567 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 308571 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308591 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308598 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308601 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308605 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308624 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308627 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308630 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308638 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308643 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308656 */   GIR_RootConstrainSelectedInstOperands,
     /* 308657 */   // GIR_Coverage, 5273,
     /* 308657 */   GIR_EraseRootFromParent_Done,
     /* 308658 */ // Label 6194: @308658
     /* 308658 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(308798), // Rule ID 5274 //
     /* 308663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308681 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308684 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308691 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308697 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 308704 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 308704 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 308707 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 308711 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308731 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308738 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308741 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308745 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308764 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308770 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308783 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308796 */   GIR_RootConstrainSelectedInstOperands,
     /* 308797 */   // GIR_Coverage, 5274,
     /* 308797 */   GIR_EraseRootFromParent_Done,
     /* 308798 */ // Label 6195: @308798
     /* 308798 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(308930), // Rule ID 5279 //
     /* 308803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308821 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308824 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308828 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308834 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 308841 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 308841 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308844 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 308848 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308863 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308870 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308873 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308877 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308896 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308899 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308902 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308905 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308928 */   GIR_RootConstrainSelectedInstOperands,
     /* 308929 */   // GIR_Coverage, 5279,
     /* 308929 */   GIR_EraseRootFromParent_Done,
     /* 308930 */ // Label 6196: @308930
     /* 308930 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(309062), // Rule ID 5280 //
     /* 308935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308953 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308956 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308960 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308966 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 308973 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 308973 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308976 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 308980 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308995 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309002 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309005 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309009 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309037 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309042 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309060 */   GIR_RootConstrainSelectedInstOperands,
     /* 309061 */   // GIR_Coverage, 5280,
     /* 309061 */   GIR_EraseRootFromParent_Done,
     /* 309062 */ // Label 6197: @309062
     /* 309062 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(309197), // Rule ID 5271 //
     /* 309067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309085 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309088 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309095 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309099 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309101 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 309108 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 309108 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309111 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 309115 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309130 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309163 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309166 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309169 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309172 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309195 */   GIR_RootConstrainSelectedInstOperands,
     /* 309196 */   // GIR_Coverage, 5271,
     /* 309196 */   GIR_EraseRootFromParent_Done,
     /* 309197 */ // Label 6198: @309197
     /* 309197 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(309332), // Rule ID 5272 //
     /* 309202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309212 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309220 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309223 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309230 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309236 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 309243 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 309243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 309250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309265 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309272 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309275 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309279 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309298 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309301 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309304 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309307 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309330 */   GIR_RootConstrainSelectedInstOperands,
     /* 309331 */   // GIR_Coverage, 5272,
     /* 309331 */   GIR_EraseRootFromParent_Done,
     /* 309332 */ // Label 6199: @309332
     /* 309332 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(309467), // Rule ID 5275 //
     /* 309337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309355 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309358 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309365 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309371 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 309378 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 309378 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309381 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 309385 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309400 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309407 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309410 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309414 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309433 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309436 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309439 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309465 */   GIR_RootConstrainSelectedInstOperands,
     /* 309466 */   // GIR_Coverage, 5275,
     /* 309466 */   GIR_EraseRootFromParent_Done,
     /* 309467 */ // Label 6200: @309467
     /* 309467 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(309602), // Rule ID 5276 //
     /* 309472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309490 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309493 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309500 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309506 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 309513 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 309513 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309516 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 309520 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309535 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309542 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309545 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309549 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309574 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309587 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309600 */   GIR_RootConstrainSelectedInstOperands,
     /* 309601 */   // GIR_Coverage, 5276,
     /* 309601 */   GIR_EraseRootFromParent_Done,
     /* 309602 */ // Label 6201: @309602
     /* 309602 */ GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(309682), // Rule ID 5258 //
     /* 309607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309625 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309633 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309638 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309644 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 309644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309656 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309680 */   GIR_RootConstrainSelectedInstOperands,
     /* 309681 */   // GIR_Coverage, 5258,
     /* 309681 */   GIR_EraseRootFromParent_Done,
     /* 309682 */ // Label 6202: @309682
     /* 309682 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(309739), // Rule ID 5242 //
     /* 309687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 309705 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309711 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 309711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 309718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309723 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309737 */   GIR_RootConstrainSelectedInstOperands,
     /* 309738 */   // GIR_Coverage, 5242,
     /* 309738 */   GIR_EraseRootFromParent_Done,
     /* 309739 */ // Label 6203: @309739
     /* 309739 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(309769), // Rule ID 471 //
     /* 309744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 309758 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 309758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 309763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309767 */   GIR_RootConstrainSelectedInstOperands,
     /* 309768 */   // GIR_Coverage, 471,
     /* 309768 */   GIR_Done,
     /* 309769 */ // Label 6204: @309769
     /* 309769 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(309799), // Rule ID 477 //
     /* 309774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 309788 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 309788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 309793 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309797 */   GIR_RootConstrainSelectedInstOperands,
     /* 309798 */   // GIR_Coverage, 477,
     /* 309798 */   GIR_Done,
     /* 309799 */ // Label 6205: @309799
     /* 309799 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(309829), // Rule ID 501 //
     /* 309804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 309807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309818 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 309818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 309823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309827 */   GIR_RootConstrainSelectedInstOperands,
     /* 309828 */   // GIR_Coverage, 501,
     /* 309828 */   GIR_Done,
     /* 309829 */ // Label 6206: @309829
     /* 309829 */ GIM_Reject,
     /* 309830 */ // Label 6165: @309830
     /* 309830 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(309860), // Rule ID 1071 //
     /* 309835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309849 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 309849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 309854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309858 */   GIR_RootConstrainSelectedInstOperands,
     /* 309859 */   // GIR_Coverage, 1071,
     /* 309859 */   GIR_Done,
     /* 309860 */ // Label 6207: @309860
     /* 309860 */ GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(309903), // Rule ID 12825 //
     /* 309865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309875 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 309875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 309882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309887 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 309896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309901 */   GIR_RootConstrainSelectedInstOperands,
     /* 309902 */   // GIR_Coverage, 12825,
     /* 309902 */   GIR_EraseRootFromParent_Done,
     /* 309903 */ // Label 6208: @309903
     /* 309903 */ GIM_Reject,
     /* 309904 */ // Label 6166: @309904
     /* 309904 */ GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(309934), // Rule ID 1075 //
     /* 309909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309923 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 309923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 309928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309932 */   GIR_RootConstrainSelectedInstOperands,
     /* 309933 */   // GIR_Coverage, 1075,
     /* 309933 */   GIR_Done,
     /* 309934 */ // Label 6209: @309934
     /* 309934 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(309980), // Rule ID 12823 //
     /* 309939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309949 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 309949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 309956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309961 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309965 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 309973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309978 */   GIR_RootConstrainSelectedInstOperands,
     /* 309979 */   // GIR_Coverage, 12823,
     /* 309979 */   GIR_EraseRootFromParent_Done,
     /* 309980 */ // Label 6210: @309980
     /* 309980 */ GIM_Reject,
     /* 309981 */ // Label 6167: @309981
     /* 309981 */ GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(310011), // Rule ID 1067 //
     /* 309986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 309992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310000 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 310000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 310005 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310009 */   GIR_RootConstrainSelectedInstOperands,
     /* 310010 */   // GIR_Coverage, 1067,
     /* 310010 */   GIR_Done,
     /* 310011 */ // Label 6211: @310011
     /* 310011 */ GIM_Reject,
     /* 310012 */ // Label 6168: @310012
     /* 310012 */ GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(310042), // Rule ID 1073 //
     /* 310017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310031 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 310031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 310036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310040 */   GIR_RootConstrainSelectedInstOperands,
     /* 310041 */   // GIR_Coverage, 1073,
     /* 310041 */   GIR_Done,
     /* 310042 */ // Label 6212: @310042
     /* 310042 */ GIM_Reject,
     /* 310043 */ // Label 6169: @310043
     /* 310043 */ GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(310073), // Rule ID 1069 //
     /* 310048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310062 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 310062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 310067 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310071 */   GIR_RootConstrainSelectedInstOperands,
     /* 310072 */   // GIR_Coverage, 1069,
     /* 310072 */   GIR_Done,
     /* 310073 */ // Label 6213: @310073
     /* 310073 */ GIM_Reject,
     /* 310074 */ // Label 6170: @310074
     /* 310074 */ GIM_Reject,
     /* 310075 */ // Label 66: @310075
     /* 310075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6221*/ GIMT_Encode4(310394),
     /* 310086 */ /*GILLT_s32*//*Label 6214*/ GIMT_Encode4(310122),
     /* 310090 */ /*GILLT_s64*//*Label 6215*/ GIMT_Encode4(310195), GIMT_Encode4(0),
     /* 310098 */ /*GILLT_v2s32*//*Label 6216*/ GIMT_Encode4(310268),
     /* 310102 */ /*GILLT_v2s64*//*Label 6217*/ GIMT_Encode4(310292),
     /* 310106 */ /*GILLT_v4s16*//*Label 6218*/ GIMT_Encode4(310316),
     /* 310110 */ /*GILLT_v4s32*//*Label 6219*/ GIMT_Encode4(310343), GIMT_Encode4(0),
     /* 310118 */ /*GILLT_v8s16*//*Label 6220*/ GIMT_Encode4(310367),
     /* 310122 */ // Label 6214: @310122
     /* 310122 */ GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(310148), // Rule ID 4523 //
     /* 310127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310137 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 310137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 310142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310146 */   GIR_RootConstrainSelectedInstOperands,
     /* 310147 */   // GIR_Coverage, 4523,
     /* 310147 */   GIR_Done,
     /* 310148 */ // Label 6222: @310148
     /* 310148 */ GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(310171), // Rule ID 4525 //
     /* 310153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310160 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310169 */   GIR_RootConstrainSelectedInstOperands,
     /* 310170 */   // GIR_Coverage, 4525,
     /* 310170 */   GIR_Done,
     /* 310171 */ // Label 6223: @310171
     /* 310171 */ GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(310194), // Rule ID 4527 //
     /* 310176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310183 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310192 */   GIR_RootConstrainSelectedInstOperands,
     /* 310193 */   // GIR_Coverage, 4527,
     /* 310193 */   GIR_Done,
     /* 310194 */ // Label 6224: @310194
     /* 310194 */ GIM_Reject,
     /* 310195 */ // Label 6215: @310195
     /* 310195 */ GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(310221), // Rule ID 4524 //
     /* 310200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310210 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 310210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 310215 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310219 */   GIR_RootConstrainSelectedInstOperands,
     /* 310220 */   // GIR_Coverage, 4524,
     /* 310220 */   GIR_Done,
     /* 310221 */ // Label 6225: @310221
     /* 310221 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(310244), // Rule ID 4526 //
     /* 310226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310233 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 310238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310242 */   GIR_RootConstrainSelectedInstOperands,
     /* 310243 */   // GIR_Coverage, 4526,
     /* 310243 */   GIR_Done,
     /* 310244 */ // Label 6226: @310244
     /* 310244 */ GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(310267), // Rule ID 4528 //
     /* 310249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310256 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 310256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 310261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310265 */   GIR_RootConstrainSelectedInstOperands,
     /* 310266 */   // GIR_Coverage, 4528,
     /* 310266 */   GIR_Done,
     /* 310267 */ // Label 6227: @310267
     /* 310267 */ GIM_Reject,
     /* 310268 */ // Label 6216: @310268
     /* 310268 */ GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(310291), // Rule ID 4864 //
     /* 310273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310280 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 310280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 310285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310289 */   GIR_RootConstrainSelectedInstOperands,
     /* 310290 */   // GIR_Coverage, 4864,
     /* 310290 */   GIR_Done,
     /* 310291 */ // Label 6228: @310291
     /* 310291 */ GIM_Reject,
     /* 310292 */ // Label 6217: @310292
     /* 310292 */ GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(310315), // Rule ID 4866 //
     /* 310297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310304 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 310304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 310309 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310313 */   GIR_RootConstrainSelectedInstOperands,
     /* 310314 */   // GIR_Coverage, 4866,
     /* 310314 */   GIR_Done,
     /* 310315 */ // Label 6229: @310315
     /* 310315 */ GIM_Reject,
     /* 310316 */ // Label 6218: @310316
     /* 310316 */ GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(310342), // Rule ID 4859 //
     /* 310321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310331 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 310331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 310336 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310340 */   GIR_RootConstrainSelectedInstOperands,
     /* 310341 */   // GIR_Coverage, 4859,
     /* 310341 */   GIR_Done,
     /* 310342 */ // Label 6230: @310342
     /* 310342 */ GIM_Reject,
     /* 310343 */ // Label 6219: @310343
     /* 310343 */ GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(310366), // Rule ID 4865 //
     /* 310348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310355 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 310355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 310360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310364 */   GIR_RootConstrainSelectedInstOperands,
     /* 310365 */   // GIR_Coverage, 4865,
     /* 310365 */   GIR_Done,
     /* 310366 */ // Label 6231: @310366
     /* 310366 */ GIM_Reject,
     /* 310367 */ // Label 6220: @310367
     /* 310367 */ GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(310393), // Rule ID 4860 //
     /* 310372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310382 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 310382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 310387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310391 */   GIR_RootConstrainSelectedInstOperands,
     /* 310392 */   // GIR_Coverage, 4860,
     /* 310392 */   GIR_Done,
     /* 310393 */ // Label 6232: @310393
     /* 310393 */ GIM_Reject,
     /* 310394 */ // Label 6221: @310394
     /* 310394 */ GIM_Reject,
     /* 310395 */ // Label 67: @310395
     /* 310395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6240*/ GIMT_Encode4(310714),
     /* 310406 */ /*GILLT_s32*//*Label 6233*/ GIMT_Encode4(310442),
     /* 310410 */ /*GILLT_s64*//*Label 6234*/ GIMT_Encode4(310515), GIMT_Encode4(0),
     /* 310418 */ /*GILLT_v2s32*//*Label 6235*/ GIMT_Encode4(310588),
     /* 310422 */ /*GILLT_v2s64*//*Label 6236*/ GIMT_Encode4(310612),
     /* 310426 */ /*GILLT_v4s16*//*Label 6237*/ GIMT_Encode4(310636),
     /* 310430 */ /*GILLT_v4s32*//*Label 6238*/ GIMT_Encode4(310663), GIMT_Encode4(0),
     /* 310438 */ /*GILLT_v8s16*//*Label 6239*/ GIMT_Encode4(310687),
     /* 310442 */ // Label 6233: @310442
     /* 310442 */ GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(310468), // Rule ID 4547 //
     /* 310447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310457 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 310457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 310462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310466 */   GIR_RootConstrainSelectedInstOperands,
     /* 310467 */   // GIR_Coverage, 4547,
     /* 310467 */   GIR_Done,
     /* 310468 */ // Label 6241: @310468
     /* 310468 */ GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(310491), // Rule ID 4549 //
     /* 310473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310480 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 310485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310489 */   GIR_RootConstrainSelectedInstOperands,
     /* 310490 */   // GIR_Coverage, 4549,
     /* 310490 */   GIR_Done,
     /* 310491 */ // Label 6242: @310491
     /* 310491 */ GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(310514), // Rule ID 4551 //
     /* 310496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310503 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 310508 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310512 */   GIR_RootConstrainSelectedInstOperands,
     /* 310513 */   // GIR_Coverage, 4551,
     /* 310513 */   GIR_Done,
     /* 310514 */ // Label 6243: @310514
     /* 310514 */ GIM_Reject,
     /* 310515 */ // Label 6234: @310515
     /* 310515 */ GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(310541), // Rule ID 4548 //
     /* 310520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310530 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 310530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 310535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310539 */   GIR_RootConstrainSelectedInstOperands,
     /* 310540 */   // GIR_Coverage, 4548,
     /* 310540 */   GIR_Done,
     /* 310541 */ // Label 6244: @310541
     /* 310541 */ GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(310564), // Rule ID 4550 //
     /* 310546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310553 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 310558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310562 */   GIR_RootConstrainSelectedInstOperands,
     /* 310563 */   // GIR_Coverage, 4550,
     /* 310563 */   GIR_Done,
     /* 310564 */ // Label 6245: @310564
     /* 310564 */ GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(310587), // Rule ID 4552 //
     /* 310569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310576 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 310576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 310581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310585 */   GIR_RootConstrainSelectedInstOperands,
     /* 310586 */   // GIR_Coverage, 4552,
     /* 310586 */   GIR_Done,
     /* 310587 */ // Label 6246: @310587
     /* 310587 */ GIM_Reject,
     /* 310588 */ // Label 6235: @310588
     /* 310588 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(310611), // Rule ID 4874 //
     /* 310593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310600 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 310600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 310605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310609 */   GIR_RootConstrainSelectedInstOperands,
     /* 310610 */   // GIR_Coverage, 4874,
     /* 310610 */   GIR_Done,
     /* 310611 */ // Label 6247: @310611
     /* 310611 */ GIM_Reject,
     /* 310612 */ // Label 6236: @310612
     /* 310612 */ GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(310635), // Rule ID 4876 //
     /* 310617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310624 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 310624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 310629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310633 */   GIR_RootConstrainSelectedInstOperands,
     /* 310634 */   // GIR_Coverage, 4876,
     /* 310634 */   GIR_Done,
     /* 310635 */ // Label 6248: @310635
     /* 310635 */ GIM_Reject,
     /* 310636 */ // Label 6237: @310636
     /* 310636 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(310662), // Rule ID 4869 //
     /* 310641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310651 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 310651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 310656 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310660 */   GIR_RootConstrainSelectedInstOperands,
     /* 310661 */   // GIR_Coverage, 4869,
     /* 310661 */   GIR_Done,
     /* 310662 */ // Label 6249: @310662
     /* 310662 */ GIM_Reject,
     /* 310663 */ // Label 6238: @310663
     /* 310663 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(310686), // Rule ID 4875 //
     /* 310668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310675 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 310675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 310680 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310684 */   GIR_RootConstrainSelectedInstOperands,
     /* 310685 */   // GIR_Coverage, 4875,
     /* 310685 */   GIR_Done,
     /* 310686 */ // Label 6250: @310686
     /* 310686 */ GIM_Reject,
     /* 310687 */ // Label 6239: @310687
     /* 310687 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(310713), // Rule ID 4870 //
     /* 310692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310702 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 310702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 310707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310711 */   GIR_RootConstrainSelectedInstOperands,
     /* 310712 */   // GIR_Coverage, 4870,
     /* 310712 */   GIR_Done,
     /* 310713 */ // Label 6251: @310713
     /* 310713 */ GIM_Reject,
     /* 310714 */ // Label 6240: @310714
     /* 310714 */ GIM_Reject,
     /* 310715 */ // Label 68: @310715
     /* 310715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6260*/ GIMT_Encode4(311571),
     /* 310726 */ /*GILLT_s16*//*Label 6252*/ GIMT_Encode4(310766),
     /* 310730 */ /*GILLT_s32*//*Label 6253*/ GIMT_Encode4(310985),
     /* 310734 */ /*GILLT_s64*//*Label 6254*/ GIMT_Encode4(311059), GIMT_Encode4(0),
     /* 310742 */ /*GILLT_v2s32*//*Label 6255*/ GIMT_Encode4(311133),
     /* 310746 */ /*GILLT_v2s64*//*Label 6256*/ GIMT_Encode4(311207),
     /* 310750 */ /*GILLT_v4s16*//*Label 6257*/ GIMT_Encode4(311281),
     /* 310754 */ /*GILLT_v4s32*//*Label 6258*/ GIMT_Encode4(311389), GIMT_Encode4(0),
     /* 310762 */ /*GILLT_v8s16*//*Label 6259*/ GIMT_Encode4(311463),
     /* 310766 */ // Label 6252: @310766
     /* 310766 */ GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(310984),
     /* 310771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310778 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(310819), // Rule ID 5145 //
     /* 310783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 310794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310804 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 310804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 310807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310817 */     GIR_RootConstrainSelectedInstOperands,
     /* 310818 */     // GIR_Coverage, 5145,
     /* 310818 */     GIR_EraseRootFromParent_Done,
     /* 310819 */   // Label 6262: @310819
     /* 310819 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(310838), // Rule ID 521 //
     /* 310824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310831 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 310831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 310836 */     GIR_RootConstrainSelectedInstOperands,
     /* 310837 */     // GIR_Coverage, 521,
     /* 310837 */     GIR_Done,
     /* 310838 */   // Label 6263: @310838
     /* 310838 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(310983), // Rule ID 6282 //
     /* 310843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310847 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 310847 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 310850 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310854 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310861 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 310864 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310868 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310873 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 310876 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 310880 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 310883 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310888 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310893 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 310901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310910 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310913 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310918 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310921 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 310925 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310930 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310933 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 310938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310965 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 310972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310982 */     // GIR_Coverage, 6282,
     /* 310982 */     GIR_EraseRootFromParent_Done,
     /* 310983 */   // Label 6264: @310983
     /* 310983 */   GIM_Reject,
     /* 310984 */ // Label 6261: @310984
     /* 310984 */ GIM_Reject,
     /* 310985 */ // Label 6253: @310985
     /* 310985 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(311058),
     /* 310990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310997 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(311038), // Rule ID 5146 //
     /* 311002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311023 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 311023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 311026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311036 */     GIR_RootConstrainSelectedInstOperands,
     /* 311037 */     // GIR_Coverage, 5146,
     /* 311037 */     GIR_EraseRootFromParent_Done,
     /* 311038 */   // Label 6266: @311038
     /* 311038 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(311057), // Rule ID 522 //
     /* 311043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311050 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 311050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 311055 */     GIR_RootConstrainSelectedInstOperands,
     /* 311056 */     // GIR_Coverage, 522,
     /* 311056 */     GIR_Done,
     /* 311057 */   // Label 6267: @311057
     /* 311057 */   GIM_Reject,
     /* 311058 */ // Label 6265: @311058
     /* 311058 */ GIM_Reject,
     /* 311059 */ // Label 6254: @311059
     /* 311059 */ GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(311132),
     /* 311064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311071 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(311112), // Rule ID 5147 //
     /* 311076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311097 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 311097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 311100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311110 */     GIR_RootConstrainSelectedInstOperands,
     /* 311111 */     // GIR_Coverage, 5147,
     /* 311111 */     GIR_EraseRootFromParent_Done,
     /* 311112 */   // Label 6269: @311112
     /* 311112 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(311131), // Rule ID 523 //
     /* 311117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311124 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 311124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 311129 */     GIR_RootConstrainSelectedInstOperands,
     /* 311130 */     // GIR_Coverage, 523,
     /* 311130 */     GIR_Done,
     /* 311131 */   // Label 6270: @311131
     /* 311131 */   GIM_Reject,
     /* 311132 */ // Label 6268: @311132
     /* 311132 */ GIM_Reject,
     /* 311133 */ // Label 6255: @311133
     /* 311133 */ GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(311206),
     /* 311138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311145 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(311186), // Rule ID 4938 //
     /* 311150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 311169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311171 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 311171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 311174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311184 */     GIR_RootConstrainSelectedInstOperands,
     /* 311185 */     // GIR_Coverage, 4938,
     /* 311185 */     GIR_EraseRootFromParent_Done,
     /* 311186 */   // Label 6272: @311186
     /* 311186 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(311205), // Rule ID 761 //
     /* 311191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311198 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 311198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 311203 */     GIR_RootConstrainSelectedInstOperands,
     /* 311204 */     // GIR_Coverage, 761,
     /* 311204 */     GIR_Done,
     /* 311205 */   // Label 6273: @311205
     /* 311205 */   GIM_Reject,
     /* 311206 */ // Label 6271: @311206
     /* 311206 */ GIM_Reject,
     /* 311207 */ // Label 6256: @311207
     /* 311207 */ GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(311280),
     /* 311212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311219 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(311260), // Rule ID 4940 //
     /* 311224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 311243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311245 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 311245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 311248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311258 */     GIR_RootConstrainSelectedInstOperands,
     /* 311259 */     // GIR_Coverage, 4940,
     /* 311259 */     GIR_EraseRootFromParent_Done,
     /* 311260 */   // Label 6275: @311260
     /* 311260 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(311279), // Rule ID 763 //
     /* 311265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311272 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 311272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 311277 */     GIR_RootConstrainSelectedInstOperands,
     /* 311278 */     // GIR_Coverage, 763,
     /* 311278 */     GIR_Done,
     /* 311279 */   // Label 6276: @311279
     /* 311279 */   GIM_Reject,
     /* 311280 */ // Label 6274: @311280
     /* 311280 */ GIM_Reject,
     /* 311281 */ // Label 6257: @311281
     /* 311281 */ GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(311388),
     /* 311286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311293 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(311334), // Rule ID 4941 //
     /* 311298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 311317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311319 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 311319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 311322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311332 */     GIR_RootConstrainSelectedInstOperands,
     /* 311333 */     // GIR_Coverage, 4941,
     /* 311333 */     GIR_EraseRootFromParent_Done,
     /* 311334 */   // Label 6278: @311334
     /* 311334 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(311353), // Rule ID 759 //
     /* 311339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311346 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 311346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 311351 */     GIR_RootConstrainSelectedInstOperands,
     /* 311352 */     // GIR_Coverage, 759,
     /* 311352 */     GIR_Done,
     /* 311353 */   // Label 6279: @311353
     /* 311353 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(311387), // Rule ID 6284 //
     /* 311358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311365 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 311365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 311368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311372 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 311382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 311385 */     GIR_RootConstrainSelectedInstOperands,
     /* 311386 */     // GIR_Coverage, 6284,
     /* 311386 */     GIR_EraseRootFromParent_Done,
     /* 311387 */   // Label 6280: @311387
     /* 311387 */   GIM_Reject,
     /* 311388 */ // Label 6277: @311388
     /* 311388 */ GIM_Reject,
     /* 311389 */ // Label 6258: @311389
     /* 311389 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(311462),
     /* 311394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311401 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(311442), // Rule ID 4939 //
     /* 311406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 311425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311427 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 311427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 311430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311440 */     GIR_RootConstrainSelectedInstOperands,
     /* 311441 */     // GIR_Coverage, 4939,
     /* 311441 */     GIR_EraseRootFromParent_Done,
     /* 311442 */   // Label 6282: @311442
     /* 311442 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(311461), // Rule ID 762 //
     /* 311447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311454 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 311454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 311459 */     GIR_RootConstrainSelectedInstOperands,
     /* 311460 */     // GIR_Coverage, 762,
     /* 311460 */     GIR_Done,
     /* 311461 */   // Label 6283: @311461
     /* 311461 */   GIM_Reject,
     /* 311462 */ // Label 6281: @311462
     /* 311462 */ GIM_Reject,
     /* 311463 */ // Label 6259: @311463
     /* 311463 */ GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(311570),
     /* 311468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311475 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(311516), // Rule ID 4942 //
     /* 311480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 311499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311501 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 311501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 311504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311514 */     GIR_RootConstrainSelectedInstOperands,
     /* 311515 */     // GIR_Coverage, 4942,
     /* 311515 */     GIR_EraseRootFromParent_Done,
     /* 311516 */   // Label 6285: @311516
     /* 311516 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(311535), // Rule ID 760 //
     /* 311521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311528 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 311528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 311533 */     GIR_RootConstrainSelectedInstOperands,
     /* 311534 */     // GIR_Coverage, 760,
     /* 311534 */     GIR_Done,
     /* 311535 */   // Label 6286: @311535
     /* 311535 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311569), // Rule ID 6285 //
     /* 311540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311547 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 311547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 311550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311554 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 311564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 311567 */     GIR_RootConstrainSelectedInstOperands,
     /* 311568 */     // GIR_Coverage, 6285,
     /* 311568 */     GIR_EraseRootFromParent_Done,
     /* 311569 */   // Label 6287: @311569
     /* 311569 */   GIM_Reject,
     /* 311570 */ // Label 6284: @311570
     /* 311570 */ GIM_Reject,
     /* 311571 */ // Label 6260: @311571
     /* 311571 */ GIM_Reject,
     /* 311572 */ // Label 69: @311572
     /* 311572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6296*/ GIMT_Encode4(311853),
     /* 311583 */ /*GILLT_s16*//*Label 6288*/ GIMT_Encode4(311623),
     /* 311587 */ /*GILLT_s32*//*Label 6289*/ GIMT_Encode4(311650),
     /* 311591 */ /*GILLT_s64*//*Label 6290*/ GIMT_Encode4(311674), GIMT_Encode4(0),
     /* 311599 */ /*GILLT_v2s32*//*Label 6291*/ GIMT_Encode4(311698),
     /* 311603 */ /*GILLT_v2s64*//*Label 6292*/ GIMT_Encode4(311729),
     /* 311607 */ /*GILLT_v4s16*//*Label 6293*/ GIMT_Encode4(311760),
     /* 311611 */ /*GILLT_v4s32*//*Label 6294*/ GIMT_Encode4(311791), GIMT_Encode4(0),
     /* 311619 */ /*GILLT_v8s16*//*Label 6295*/ GIMT_Encode4(311822),
     /* 311623 */ // Label 6288: @311623
     /* 311623 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(311649), // Rule ID 4763 //
     /* 311628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311638 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 311638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 311641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311643 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311645 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311647 */   GIR_RootConstrainSelectedInstOperands,
     /* 311648 */   // GIR_Coverage, 4763,
     /* 311648 */   GIR_EraseRootFromParent_Done,
     /* 311649 */ // Label 6297: @311649
     /* 311649 */ GIM_Reject,
     /* 311650 */ // Label 6289: @311650
     /* 311650 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(311673), // Rule ID 4760 //
     /* 311655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311662 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 311662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 311665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311667 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311669 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311671 */   GIR_RootConstrainSelectedInstOperands,
     /* 311672 */   // GIR_Coverage, 4760,
     /* 311672 */   GIR_EraseRootFromParent_Done,
     /* 311673 */ // Label 6298: @311673
     /* 311673 */ GIM_Reject,
     /* 311674 */ // Label 6290: @311674
     /* 311674 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(311697), // Rule ID 4757 //
     /* 311679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311686 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 311686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 311689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311691 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311693 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311695 */   GIR_RootConstrainSelectedInstOperands,
     /* 311696 */   // GIR_Coverage, 4757,
     /* 311696 */   GIR_EraseRootFromParent_Done,
     /* 311697 */ // Label 6299: @311697
     /* 311697 */ GIM_Reject,
     /* 311698 */ // Label 6291: @311698
     /* 311698 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(311728), // Rule ID 4951 //
     /* 311703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311717 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 311717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 311720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311722 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311724 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311726 */   GIR_RootConstrainSelectedInstOperands,
     /* 311727 */   // GIR_Coverage, 4951,
     /* 311727 */   GIR_EraseRootFromParent_Done,
     /* 311728 */ // Label 6300: @311728
     /* 311728 */ GIM_Reject,
     /* 311729 */ // Label 6292: @311729
     /* 311729 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(311759), // Rule ID 4945 //
     /* 311734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311748 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 311748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 311751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311753 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311757 */   GIR_RootConstrainSelectedInstOperands,
     /* 311758 */   // GIR_Coverage, 4945,
     /* 311758 */   GIR_EraseRootFromParent_Done,
     /* 311759 */ // Label 6301: @311759
     /* 311759 */ GIM_Reject,
     /* 311760 */ // Label 6293: @311760
     /* 311760 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(311790), // Rule ID 4957 //
     /* 311765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311779 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 311779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 311782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311784 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311786 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311788 */   GIR_RootConstrainSelectedInstOperands,
     /* 311789 */   // GIR_Coverage, 4957,
     /* 311789 */   GIR_EraseRootFromParent_Done,
     /* 311790 */ // Label 6302: @311790
     /* 311790 */ GIM_Reject,
     /* 311791 */ // Label 6294: @311791
     /* 311791 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(311821), // Rule ID 4948 //
     /* 311796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311810 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 311810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 311813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311817 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311819 */   GIR_RootConstrainSelectedInstOperands,
     /* 311820 */   // GIR_Coverage, 4948,
     /* 311820 */   GIR_EraseRootFromParent_Done,
     /* 311821 */ // Label 6303: @311821
     /* 311821 */ GIM_Reject,
     /* 311822 */ // Label 6295: @311822
     /* 311822 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311852), // Rule ID 4954 //
     /* 311827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311841 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 311841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 311844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311846 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311848 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311850 */   GIR_RootConstrainSelectedInstOperands,
     /* 311851 */   // GIR_Coverage, 4954,
     /* 311851 */   GIR_EraseRootFromParent_Done,
     /* 311852 */ // Label 6304: @311852
     /* 311852 */ GIM_Reject,
     /* 311853 */ // Label 6296: @311853
     /* 311853 */ GIM_Reject,
     /* 311854 */ // Label 70: @311854
     /* 311854 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6313*/ GIMT_Encode4(312231),
     /* 311865 */ /*GILLT_s16*//*Label 6305*/ GIMT_Encode4(311905),
     /* 311869 */ /*GILLT_s32*//*Label 6306*/ GIMT_Encode4(311943),
     /* 311873 */ /*GILLT_s64*//*Label 6307*/ GIMT_Encode4(311981), GIMT_Encode4(0),
     /* 311881 */ /*GILLT_v2s32*//*Label 6308*/ GIMT_Encode4(312041),
     /* 311885 */ /*GILLT_v2s64*//*Label 6309*/ GIMT_Encode4(312079),
     /* 311889 */ /*GILLT_v4s16*//*Label 6310*/ GIMT_Encode4(312117),
     /* 311893 */ /*GILLT_v4s32*//*Label 6311*/ GIMT_Encode4(312155), GIMT_Encode4(0),
     /* 311901 */ /*GILLT_v8s16*//*Label 6312*/ GIMT_Encode4(312193),
     /* 311905 */ // Label 6305: @311905
     /* 311905 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(311942), // Rule ID 608 //
     /* 311910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 311919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311931 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 311931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 311936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311940 */   GIR_RootConstrainSelectedInstOperands,
     /* 311941 */   // GIR_Coverage, 608,
     /* 311941 */   GIR_Done,
     /* 311942 */ // Label 6314: @311942
     /* 311942 */ GIM_Reject,
     /* 311943 */ // Label 6306: @311943
     /* 311943 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(311980), // Rule ID 610 //
     /* 311948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 311957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311969 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 311969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 311974 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311978 */   GIR_RootConstrainSelectedInstOperands,
     /* 311979 */   // GIR_Coverage, 610,
     /* 311979 */   GIR_Done,
     /* 311980 */ // Label 6315: @311980
     /* 311980 */ GIM_Reject,
     /* 311981 */ // Label 6307: @311981
     /* 311981 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(312040),
     /* 311986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 311992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312004 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(312023), // Rule ID 612 //
     /* 312009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312012 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312017 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312021 */     GIR_RootConstrainSelectedInstOperands,
     /* 312022 */     // GIR_Coverage, 612,
     /* 312022 */     GIR_Done,
     /* 312023 */   // Label 6317: @312023
     /* 312023 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(312039), // Rule ID 4754 //
     /* 312028 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 312028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312033 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312037 */     GIR_RootConstrainSelectedInstOperands,
     /* 312038 */     // GIR_Coverage, 4754,
     /* 312038 */     GIR_Done,
     /* 312039 */   // Label 6318: @312039
     /* 312039 */   GIM_Reject,
     /* 312040 */ // Label 6316: @312040
     /* 312040 */ GIM_Reject,
     /* 312041 */ // Label 6308: @312041
     /* 312041 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(312078), // Rule ID 1266 //
     /* 312046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312067 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 312072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312076 */   GIR_RootConstrainSelectedInstOperands,
     /* 312077 */   // GIR_Coverage, 1266,
     /* 312077 */   GIR_Done,
     /* 312078 */ // Label 6319: @312078
     /* 312078 */ GIM_Reject,
     /* 312079 */ // Label 6309: @312079
     /* 312079 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(312116), // Rule ID 1270 //
     /* 312084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312105 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 312110 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312114 */   GIR_RootConstrainSelectedInstOperands,
     /* 312115 */   // GIR_Coverage, 1270,
     /* 312115 */   GIR_Done,
     /* 312116 */ // Label 6320: @312116
     /* 312116 */ GIM_Reject,
     /* 312117 */ // Label 6310: @312117
     /* 312117 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(312154), // Rule ID 1262 //
     /* 312122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312143 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 312148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312152 */   GIR_RootConstrainSelectedInstOperands,
     /* 312153 */   // GIR_Coverage, 1262,
     /* 312153 */   GIR_Done,
     /* 312154 */ // Label 6321: @312154
     /* 312154 */ GIM_Reject,
     /* 312155 */ // Label 6311: @312155
     /* 312155 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(312192), // Rule ID 1268 //
     /* 312160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312181 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 312186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312190 */   GIR_RootConstrainSelectedInstOperands,
     /* 312191 */   // GIR_Coverage, 1268,
     /* 312191 */   GIR_Done,
     /* 312192 */ // Label 6322: @312192
     /* 312192 */ GIM_Reject,
     /* 312193 */ // Label 6312: @312193
     /* 312193 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(312230), // Rule ID 1264 //
     /* 312198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312219 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 312224 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312228 */   GIR_RootConstrainSelectedInstOperands,
     /* 312229 */   // GIR_Coverage, 1264,
     /* 312229 */   GIR_Done,
     /* 312230 */ // Label 6323: @312230
     /* 312230 */ GIM_Reject,
     /* 312231 */ // Label 6313: @312231
     /* 312231 */ GIM_Reject,
     /* 312232 */ // Label 71: @312232
     /* 312232 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6332*/ GIMT_Encode4(312609),
     /* 312243 */ /*GILLT_s16*//*Label 6324*/ GIMT_Encode4(312283),
     /* 312247 */ /*GILLT_s32*//*Label 6325*/ GIMT_Encode4(312321),
     /* 312251 */ /*GILLT_s64*//*Label 6326*/ GIMT_Encode4(312359), GIMT_Encode4(0),
     /* 312259 */ /*GILLT_v2s32*//*Label 6327*/ GIMT_Encode4(312419),
     /* 312263 */ /*GILLT_v2s64*//*Label 6328*/ GIMT_Encode4(312457),
     /* 312267 */ /*GILLT_v4s16*//*Label 6329*/ GIMT_Encode4(312495),
     /* 312271 */ /*GILLT_v4s32*//*Label 6330*/ GIMT_Encode4(312533), GIMT_Encode4(0),
     /* 312279 */ /*GILLT_v8s16*//*Label 6331*/ GIMT_Encode4(312571),
     /* 312283 */ // Label 6324: @312283
     /* 312283 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(312320), // Rule ID 596 //
     /* 312288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312309 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 312309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 312314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312318 */   GIR_RootConstrainSelectedInstOperands,
     /* 312319 */   // GIR_Coverage, 596,
     /* 312319 */   GIR_Done,
     /* 312320 */ // Label 6333: @312320
     /* 312320 */ GIM_Reject,
     /* 312321 */ // Label 6325: @312321
     /* 312321 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(312358), // Rule ID 598 //
     /* 312326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312347 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 312347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 312352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312356 */   GIR_RootConstrainSelectedInstOperands,
     /* 312357 */   // GIR_Coverage, 598,
     /* 312357 */   GIR_Done,
     /* 312358 */ // Label 6334: @312358
     /* 312358 */ GIM_Reject,
     /* 312359 */ // Label 6326: @312359
     /* 312359 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(312418),
     /* 312364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312382 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(312401), // Rule ID 600 //
     /* 312387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312390 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 312395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312399 */     GIR_RootConstrainSelectedInstOperands,
     /* 312400 */     // GIR_Coverage, 600,
     /* 312400 */     GIR_Done,
     /* 312401 */   // Label 6336: @312401
     /* 312401 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(312417), // Rule ID 4753 //
     /* 312406 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 312406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 312411 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312415 */     GIR_RootConstrainSelectedInstOperands,
     /* 312416 */     // GIR_Coverage, 4753,
     /* 312416 */     GIR_Done,
     /* 312417 */   // Label 6337: @312417
     /* 312417 */   GIM_Reject,
     /* 312418 */ // Label 6335: @312418
     /* 312418 */ GIM_Reject,
     /* 312419 */ // Label 6327: @312419
     /* 312419 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312456), // Rule ID 1236 //
     /* 312424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312445 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 312450 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312454 */   GIR_RootConstrainSelectedInstOperands,
     /* 312455 */   // GIR_Coverage, 1236,
     /* 312455 */   GIR_Done,
     /* 312456 */ // Label 6338: @312456
     /* 312456 */ GIM_Reject,
     /* 312457 */ // Label 6328: @312457
     /* 312457 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312494), // Rule ID 1240 //
     /* 312462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312483 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 312488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312492 */   GIR_RootConstrainSelectedInstOperands,
     /* 312493 */   // GIR_Coverage, 1240,
     /* 312493 */   GIR_Done,
     /* 312494 */ // Label 6339: @312494
     /* 312494 */ GIM_Reject,
     /* 312495 */ // Label 6329: @312495
     /* 312495 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312532), // Rule ID 1232 //
     /* 312500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312521 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 312526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312530 */   GIR_RootConstrainSelectedInstOperands,
     /* 312531 */   // GIR_Coverage, 1232,
     /* 312531 */   GIR_Done,
     /* 312532 */ // Label 6340: @312532
     /* 312532 */ GIM_Reject,
     /* 312533 */ // Label 6330: @312533
     /* 312533 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(312570), // Rule ID 1238 //
     /* 312538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312559 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 312564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312568 */   GIR_RootConstrainSelectedInstOperands,
     /* 312569 */   // GIR_Coverage, 1238,
     /* 312569 */   GIR_Done,
     /* 312570 */ // Label 6341: @312570
     /* 312570 */ GIM_Reject,
     /* 312571 */ // Label 6331: @312571
     /* 312571 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(312608), // Rule ID 1234 //
     /* 312576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312597 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 312602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312606 */   GIR_RootConstrainSelectedInstOperands,
     /* 312607 */   // GIR_Coverage, 1234,
     /* 312607 */   GIR_Done,
     /* 312608 */ // Label 6342: @312608
     /* 312608 */ GIM_Reject,
     /* 312609 */ // Label 6332: @312609
     /* 312609 */ GIM_Reject,
     /* 312610 */ // Label 72: @312610
     /* 312610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6351*/ GIMT_Encode4(312959),
     /* 312621 */ /*GILLT_s16*//*Label 6343*/ GIMT_Encode4(312661),
     /* 312625 */ /*GILLT_s32*//*Label 6344*/ GIMT_Encode4(312699),
     /* 312629 */ /*GILLT_s64*//*Label 6345*/ GIMT_Encode4(312734), GIMT_Encode4(0),
     /* 312637 */ /*GILLT_v2s32*//*Label 6346*/ GIMT_Encode4(312769),
     /* 312641 */ /*GILLT_v2s64*//*Label 6347*/ GIMT_Encode4(312807),
     /* 312645 */ /*GILLT_v4s16*//*Label 6348*/ GIMT_Encode4(312845),
     /* 312649 */ /*GILLT_v4s32*//*Label 6349*/ GIMT_Encode4(312883), GIMT_Encode4(0),
     /* 312657 */ /*GILLT_v8s16*//*Label 6350*/ GIMT_Encode4(312921),
     /* 312661 */ // Label 6343: @312661
     /* 312661 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(312698), // Rule ID 4761 //
     /* 312666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312687 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 312687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 312692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312696 */   GIR_RootConstrainSelectedInstOperands,
     /* 312697 */   // GIR_Coverage, 4761,
     /* 312697 */   GIR_Done,
     /* 312698 */ // Label 6352: @312698
     /* 312698 */ GIM_Reject,
     /* 312699 */ // Label 6344: @312699
     /* 312699 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(312733), // Rule ID 4758 //
     /* 312704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312722 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 312722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 312727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312731 */   GIR_RootConstrainSelectedInstOperands,
     /* 312732 */   // GIR_Coverage, 4758,
     /* 312732 */   GIR_Done,
     /* 312733 */ // Label 6353: @312733
     /* 312733 */ GIM_Reject,
     /* 312734 */ // Label 6345: @312734
     /* 312734 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(312768), // Rule ID 4755 //
     /* 312739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312757 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 312757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312762 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312766 */   GIR_RootConstrainSelectedInstOperands,
     /* 312767 */   // GIR_Coverage, 4755,
     /* 312767 */   GIR_Done,
     /* 312768 */ // Label 6354: @312768
     /* 312768 */ GIM_Reject,
     /* 312769 */ // Label 6346: @312769
     /* 312769 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(312806), // Rule ID 4949 //
     /* 312774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312795 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 312800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312804 */   GIR_RootConstrainSelectedInstOperands,
     /* 312805 */   // GIR_Coverage, 4949,
     /* 312805 */   GIR_Done,
     /* 312806 */ // Label 6355: @312806
     /* 312806 */ GIM_Reject,
     /* 312807 */ // Label 6347: @312807
     /* 312807 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(312844), // Rule ID 4943 //
     /* 312812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312833 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 312838 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312842 */   GIR_RootConstrainSelectedInstOperands,
     /* 312843 */   // GIR_Coverage, 4943,
     /* 312843 */   GIR_Done,
     /* 312844 */ // Label 6356: @312844
     /* 312844 */ GIM_Reject,
     /* 312845 */ // Label 6348: @312845
     /* 312845 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(312882), // Rule ID 4955 //
     /* 312850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312871 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 312876 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312880 */   GIR_RootConstrainSelectedInstOperands,
     /* 312881 */   // GIR_Coverage, 4955,
     /* 312881 */   GIR_Done,
     /* 312882 */ // Label 6357: @312882
     /* 312882 */ GIM_Reject,
     /* 312883 */ // Label 6349: @312883
     /* 312883 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(312920), // Rule ID 4946 //
     /* 312888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312909 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 312914 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312918 */   GIR_RootConstrainSelectedInstOperands,
     /* 312919 */   // GIR_Coverage, 4946,
     /* 312919 */   GIR_Done,
     /* 312920 */ // Label 6358: @312920
     /* 312920 */ GIM_Reject,
     /* 312921 */ // Label 6350: @312921
     /* 312921 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(312958), // Rule ID 4952 //
     /* 312926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312947 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 312952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312956 */   GIR_RootConstrainSelectedInstOperands,
     /* 312957 */   // GIR_Coverage, 4952,
     /* 312957 */   GIR_Done,
     /* 312958 */ // Label 6359: @312958
     /* 312958 */ GIM_Reject,
     /* 312959 */ // Label 6351: @312959
     /* 312959 */ GIM_Reject,
     /* 312960 */ // Label 73: @312960
     /* 312960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6368*/ GIMT_Encode4(313309),
     /* 312971 */ /*GILLT_s16*//*Label 6360*/ GIMT_Encode4(313011),
     /* 312975 */ /*GILLT_s32*//*Label 6361*/ GIMT_Encode4(313049),
     /* 312979 */ /*GILLT_s64*//*Label 6362*/ GIMT_Encode4(313084), GIMT_Encode4(0),
     /* 312987 */ /*GILLT_v2s32*//*Label 6363*/ GIMT_Encode4(313119),
     /* 312991 */ /*GILLT_v2s64*//*Label 6364*/ GIMT_Encode4(313157),
     /* 312995 */ /*GILLT_v4s16*//*Label 6365*/ GIMT_Encode4(313195),
     /* 312999 */ /*GILLT_v4s32*//*Label 6366*/ GIMT_Encode4(313233), GIMT_Encode4(0),
     /* 313007 */ /*GILLT_v8s16*//*Label 6367*/ GIMT_Encode4(313271),
     /* 313011 */ // Label 6360: @313011
     /* 313011 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(313048), // Rule ID 4762 //
     /* 313016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313037 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 313037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 313042 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313046 */   GIR_RootConstrainSelectedInstOperands,
     /* 313047 */   // GIR_Coverage, 4762,
     /* 313047 */   GIR_Done,
     /* 313048 */ // Label 6369: @313048
     /* 313048 */ GIM_Reject,
     /* 313049 */ // Label 6361: @313049
     /* 313049 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(313083), // Rule ID 4759 //
     /* 313054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313072 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 313072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 313077 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313081 */   GIR_RootConstrainSelectedInstOperands,
     /* 313082 */   // GIR_Coverage, 4759,
     /* 313082 */   GIR_Done,
     /* 313083 */ // Label 6370: @313083
     /* 313083 */ GIM_Reject,
     /* 313084 */ // Label 6362: @313084
     /* 313084 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(313118), // Rule ID 4756 //
     /* 313089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313107 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 313107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 313112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313116 */   GIR_RootConstrainSelectedInstOperands,
     /* 313117 */   // GIR_Coverage, 4756,
     /* 313117 */   GIR_Done,
     /* 313118 */ // Label 6371: @313118
     /* 313118 */ GIM_Reject,
     /* 313119 */ // Label 6363: @313119
     /* 313119 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(313156), // Rule ID 4950 //
     /* 313124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313145 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 313150 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313154 */   GIR_RootConstrainSelectedInstOperands,
     /* 313155 */   // GIR_Coverage, 4950,
     /* 313155 */   GIR_Done,
     /* 313156 */ // Label 6372: @313156
     /* 313156 */ GIM_Reject,
     /* 313157 */ // Label 6364: @313157
     /* 313157 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(313194), // Rule ID 4944 //
     /* 313162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 313171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313183 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 313188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313192 */   GIR_RootConstrainSelectedInstOperands,
     /* 313193 */   // GIR_Coverage, 4944,
     /* 313193 */   GIR_Done,
     /* 313194 */ // Label 6373: @313194
     /* 313194 */ GIM_Reject,
     /* 313195 */ // Label 6365: @313195
     /* 313195 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(313232), // Rule ID 4956 //
     /* 313200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 313209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313221 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 313226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313230 */   GIR_RootConstrainSelectedInstOperands,
     /* 313231 */   // GIR_Coverage, 4956,
     /* 313231 */   GIR_Done,
     /* 313232 */ // Label 6374: @313232
     /* 313232 */ GIM_Reject,
     /* 313233 */ // Label 6366: @313233
     /* 313233 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(313270), // Rule ID 4947 //
     /* 313238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 313247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313259 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 313264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313268 */   GIR_RootConstrainSelectedInstOperands,
     /* 313269 */   // GIR_Coverage, 4947,
     /* 313269 */   GIR_Done,
     /* 313270 */ // Label 6375: @313270
     /* 313270 */ GIM_Reject,
     /* 313271 */ // Label 6367: @313271
     /* 313271 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(313308), // Rule ID 4953 //
     /* 313276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313297 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 313302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313306 */   GIR_RootConstrainSelectedInstOperands,
     /* 313307 */   // GIR_Coverage, 4953,
     /* 313307 */   GIR_Done,
     /* 313308 */ // Label 6376: @313308
     /* 313308 */ GIM_Reject,
     /* 313309 */ // Label 6368: @313309
     /* 313309 */ GIM_Reject,
     /* 313310 */ // Label 74: @313310
     /* 313310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6385*/ GIMT_Encode4(314012),
     /* 313321 */ /*GILLT_s16*//*Label 6377*/ GIMT_Encode4(313361),
     /* 313325 */ /*GILLT_s32*//*Label 6378*/ GIMT_Encode4(313399),
     /* 313329 */ /*GILLT_s64*//*Label 6379*/ GIMT_Encode4(313437), GIMT_Encode4(0),
     /* 313337 */ /*GILLT_v2s32*//*Label 6380*/ GIMT_Encode4(313497),
     /* 313341 */ /*GILLT_v2s64*//*Label 6381*/ GIMT_Encode4(313600),
     /* 313345 */ /*GILLT_v4s16*//*Label 6382*/ GIMT_Encode4(313703),
     /* 313349 */ /*GILLT_v4s32*//*Label 6383*/ GIMT_Encode4(313806), GIMT_Encode4(0),
     /* 313357 */ /*GILLT_v8s16*//*Label 6384*/ GIMT_Encode4(313909),
     /* 313361 */ // Label 6377: @313361
     /* 313361 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(313398), // Rule ID 614 //
     /* 313366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313387 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 313387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 313392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313396 */   GIR_RootConstrainSelectedInstOperands,
     /* 313397 */   // GIR_Coverage, 614,
     /* 313397 */   GIR_Done,
     /* 313398 */ // Label 6386: @313398
     /* 313398 */ GIM_Reject,
     /* 313399 */ // Label 6378: @313399
     /* 313399 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(313436), // Rule ID 616 //
     /* 313404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313425 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 313425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 313430 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313434 */   GIR_RootConstrainSelectedInstOperands,
     /* 313435 */   // GIR_Coverage, 616,
     /* 313435 */   GIR_Done,
     /* 313436 */ // Label 6387: @313436
     /* 313436 */ GIM_Reject,
     /* 313437 */ // Label 6379: @313437
     /* 313437 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(313496),
     /* 313442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313460 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(313479), // Rule ID 618 //
     /* 313465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313468 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 313468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 313473 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313477 */     GIR_RootConstrainSelectedInstOperands,
     /* 313478 */     // GIR_Coverage, 618,
     /* 313478 */     GIR_Done,
     /* 313479 */   // Label 6389: @313479
     /* 313479 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(313495), // Rule ID 4752 //
     /* 313484 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 313484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 313489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313493 */     GIR_RootConstrainSelectedInstOperands,
     /* 313494 */     // GIR_Coverage, 4752,
     /* 313494 */     GIR_Done,
     /* 313495 */   // Label 6390: @313495
     /* 313495 */   GIM_Reject,
     /* 313496 */ // Label 6388: @313496
     /* 313496 */ GIM_Reject,
     /* 313497 */ // Label 6380: @313497
     /* 313497 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(313599),
     /* 313502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313512 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(313571), // Rule ID 2357 //
     /* 313517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313556 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 313559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313569 */     GIR_RootConstrainSelectedInstOperands,
     /* 313570 */     // GIR_Coverage, 2357,
     /* 313570 */     GIR_EraseRootFromParent_Done,
     /* 313571 */   // Label 6392: @313571
     /* 313571 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(313598), // Rule ID 1281 //
     /* 313576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313587 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 313592 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313596 */     GIR_RootConstrainSelectedInstOperands,
     /* 313597 */     // GIR_Coverage, 1281,
     /* 313597 */     GIR_Done,
     /* 313598 */   // Label 6393: @313598
     /* 313598 */   GIM_Reject,
     /* 313599 */ // Label 6391: @313599
     /* 313599 */ GIM_Reject,
     /* 313600 */ // Label 6381: @313600
     /* 313600 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(313702),
     /* 313605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 313611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313615 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(313674), // Rule ID 2363 //
     /* 313620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313659 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 313662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313672 */     GIR_RootConstrainSelectedInstOperands,
     /* 313673 */     // GIR_Coverage, 2363,
     /* 313673 */     GIR_EraseRootFromParent_Done,
     /* 313674 */   // Label 6395: @313674
     /* 313674 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(313701), // Rule ID 1285 //
     /* 313679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313690 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 313695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313699 */     GIR_RootConstrainSelectedInstOperands,
     /* 313700 */     // GIR_Coverage, 1285,
     /* 313700 */     GIR_Done,
     /* 313701 */   // Label 6396: @313701
     /* 313701 */   GIM_Reject,
     /* 313702 */ // Label 6394: @313702
     /* 313702 */ GIM_Reject,
     /* 313703 */ // Label 6382: @313703
     /* 313703 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(313805),
     /* 313708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 313714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313718 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(313777), // Rule ID 2351 //
     /* 313723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313762 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 313765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313775 */     GIR_RootConstrainSelectedInstOperands,
     /* 313776 */     // GIR_Coverage, 2351,
     /* 313776 */     GIR_EraseRootFromParent_Done,
     /* 313777 */   // Label 6398: @313777
     /* 313777 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(313804), // Rule ID 1277 //
     /* 313782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313793 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 313798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313802 */     GIR_RootConstrainSelectedInstOperands,
     /* 313803 */     // GIR_Coverage, 1277,
     /* 313803 */     GIR_Done,
     /* 313804 */   // Label 6399: @313804
     /* 313804 */   GIM_Reject,
     /* 313805 */ // Label 6397: @313805
     /* 313805 */ GIM_Reject,
     /* 313806 */ // Label 6383: @313806
     /* 313806 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(313908),
     /* 313811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 313817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313821 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(313880), // Rule ID 2360 //
     /* 313826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313865 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 313868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313878 */     GIR_RootConstrainSelectedInstOperands,
     /* 313879 */     // GIR_Coverage, 2360,
     /* 313879 */     GIR_EraseRootFromParent_Done,
     /* 313880 */   // Label 6401: @313880
     /* 313880 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(313907), // Rule ID 1283 //
     /* 313885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313896 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 313901 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313905 */     GIR_RootConstrainSelectedInstOperands,
     /* 313906 */     // GIR_Coverage, 1283,
     /* 313906 */     GIR_Done,
     /* 313907 */   // Label 6402: @313907
     /* 313907 */   GIM_Reject,
     /* 313908 */ // Label 6400: @313908
     /* 313908 */ GIM_Reject,
     /* 313909 */ // Label 6384: @313909
     /* 313909 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(314011),
     /* 313914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313924 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(313983), // Rule ID 2354 //
     /* 313929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313968 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 313971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313981 */     GIR_RootConstrainSelectedInstOperands,
     /* 313982 */     // GIR_Coverage, 2354,
     /* 313982 */     GIR_EraseRootFromParent_Done,
     /* 313983 */   // Label 6404: @313983
     /* 313983 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(314010), // Rule ID 1279 //
     /* 313988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313999 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 314004 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314008 */     GIR_RootConstrainSelectedInstOperands,
     /* 314009 */     // GIR_Coverage, 1279,
     /* 314009 */     GIR_Done,
     /* 314010 */   // Label 6405: @314010
     /* 314010 */   GIM_Reject,
     /* 314011 */ // Label 6403: @314011
     /* 314011 */ GIM_Reject,
     /* 314012 */ // Label 6385: @314012
     /* 314012 */ GIM_Reject,
     /* 314013 */ // Label 75: @314013
     /* 314013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6414*/ GIMT_Encode4(314715),
     /* 314024 */ /*GILLT_s16*//*Label 6406*/ GIMT_Encode4(314064),
     /* 314028 */ /*GILLT_s32*//*Label 6407*/ GIMT_Encode4(314102),
     /* 314032 */ /*GILLT_s64*//*Label 6408*/ GIMT_Encode4(314140), GIMT_Encode4(0),
     /* 314040 */ /*GILLT_v2s32*//*Label 6409*/ GIMT_Encode4(314200),
     /* 314044 */ /*GILLT_v2s64*//*Label 6410*/ GIMT_Encode4(314303),
     /* 314048 */ /*GILLT_v4s16*//*Label 6411*/ GIMT_Encode4(314406),
     /* 314052 */ /*GILLT_v4s32*//*Label 6412*/ GIMT_Encode4(314509), GIMT_Encode4(0),
     /* 314060 */ /*GILLT_v8s16*//*Label 6413*/ GIMT_Encode4(314612),
     /* 314064 */ // Label 6406: @314064
     /* 314064 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(314101), // Rule ID 602 //
     /* 314069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 314078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314090 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 314090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 314095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314099 */   GIR_RootConstrainSelectedInstOperands,
     /* 314100 */   // GIR_Coverage, 602,
     /* 314100 */   GIR_Done,
     /* 314101 */ // Label 6415: @314101
     /* 314101 */ GIM_Reject,
     /* 314102 */ // Label 6407: @314102
     /* 314102 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(314139), // Rule ID 604 //
     /* 314107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 314116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314128 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 314128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 314133 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314137 */   GIR_RootConstrainSelectedInstOperands,
     /* 314138 */   // GIR_Coverage, 604,
     /* 314138 */   GIR_Done,
     /* 314139 */ // Label 6416: @314139
     /* 314139 */ GIM_Reject,
     /* 314140 */ // Label 6408: @314140
     /* 314140 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(314199),
     /* 314145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314163 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(314182), // Rule ID 606 //
     /* 314168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314171 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 314171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 314176 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314180 */     GIR_RootConstrainSelectedInstOperands,
     /* 314181 */     // GIR_Coverage, 606,
     /* 314181 */     GIR_Done,
     /* 314182 */   // Label 6418: @314182
     /* 314182 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(314198), // Rule ID 4751 //
     /* 314187 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 314187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 314192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314196 */     GIR_RootConstrainSelectedInstOperands,
     /* 314197 */     // GIR_Coverage, 4751,
     /* 314197 */     GIR_Done,
     /* 314198 */   // Label 6419: @314198
     /* 314198 */   GIM_Reject,
     /* 314199 */ // Label 6417: @314199
     /* 314199 */ GIM_Reject,
     /* 314200 */ // Label 6409: @314200
     /* 314200 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(314302),
     /* 314205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314215 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(314274), // Rule ID 2342 //
     /* 314220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314259 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 314262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314272 */     GIR_RootConstrainSelectedInstOperands,
     /* 314273 */     // GIR_Coverage, 2342,
     /* 314273 */     GIR_EraseRootFromParent_Done,
     /* 314274 */   // Label 6421: @314274
     /* 314274 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(314301), // Rule ID 1251 //
     /* 314279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314290 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 314295 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314299 */     GIR_RootConstrainSelectedInstOperands,
     /* 314300 */     // GIR_Coverage, 1251,
     /* 314300 */     GIR_Done,
     /* 314301 */   // Label 6422: @314301
     /* 314301 */   GIM_Reject,
     /* 314302 */ // Label 6420: @314302
     /* 314302 */ GIM_Reject,
     /* 314303 */ // Label 6410: @314303
     /* 314303 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(314405),
     /* 314308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 314314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314318 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(314377), // Rule ID 2348 //
     /* 314323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314362 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 314365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314375 */     GIR_RootConstrainSelectedInstOperands,
     /* 314376 */     // GIR_Coverage, 2348,
     /* 314376 */     GIR_EraseRootFromParent_Done,
     /* 314377 */   // Label 6424: @314377
     /* 314377 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(314404), // Rule ID 1255 //
     /* 314382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314393 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 314398 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314402 */     GIR_RootConstrainSelectedInstOperands,
     /* 314403 */     // GIR_Coverage, 1255,
     /* 314403 */     GIR_Done,
     /* 314404 */   // Label 6425: @314404
     /* 314404 */   GIM_Reject,
     /* 314405 */ // Label 6423: @314405
     /* 314405 */ GIM_Reject,
     /* 314406 */ // Label 6411: @314406
     /* 314406 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(314508),
     /* 314411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314421 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(314480), // Rule ID 2336 //
     /* 314426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314465 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 314468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314478 */     GIR_RootConstrainSelectedInstOperands,
     /* 314479 */     // GIR_Coverage, 2336,
     /* 314479 */     GIR_EraseRootFromParent_Done,
     /* 314480 */   // Label 6427: @314480
     /* 314480 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(314507), // Rule ID 1247 //
     /* 314485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314496 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 314501 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314505 */     GIR_RootConstrainSelectedInstOperands,
     /* 314506 */     // GIR_Coverage, 1247,
     /* 314506 */     GIR_Done,
     /* 314507 */   // Label 6428: @314507
     /* 314507 */   GIM_Reject,
     /* 314508 */ // Label 6426: @314508
     /* 314508 */ GIM_Reject,
     /* 314509 */ // Label 6412: @314509
     /* 314509 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(314611),
     /* 314514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 314520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314524 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(314583), // Rule ID 2345 //
     /* 314529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314568 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 314568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 314571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314581 */     GIR_RootConstrainSelectedInstOperands,
     /* 314582 */     // GIR_Coverage, 2345,
     /* 314582 */     GIR_EraseRootFromParent_Done,
     /* 314583 */   // Label 6430: @314583
     /* 314583 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(314610), // Rule ID 1253 //
     /* 314588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314599 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 314599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 314604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314608 */     GIR_RootConstrainSelectedInstOperands,
     /* 314609 */     // GIR_Coverage, 1253,
     /* 314609 */     GIR_Done,
     /* 314610 */   // Label 6431: @314610
     /* 314610 */   GIM_Reject,
     /* 314611 */ // Label 6429: @314611
     /* 314611 */ GIM_Reject,
     /* 314612 */ // Label 6413: @314612
     /* 314612 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(314714),
     /* 314617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 314623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314627 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(314686), // Rule ID 2339 //
     /* 314632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314671 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 314674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314684 */     GIR_RootConstrainSelectedInstOperands,
     /* 314685 */     // GIR_Coverage, 2339,
     /* 314685 */     GIR_EraseRootFromParent_Done,
     /* 314686 */   // Label 6433: @314686
     /* 314686 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(314713), // Rule ID 1249 //
     /* 314691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314702 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 314707 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314711 */     GIR_RootConstrainSelectedInstOperands,
     /* 314712 */     // GIR_Coverage, 1249,
     /* 314712 */     GIR_Done,
     /* 314713 */   // Label 6434: @314713
     /* 314713 */   GIM_Reject,
     /* 314714 */ // Label 6432: @314714
     /* 314714 */ GIM_Reject,
     /* 314715 */ // Label 6414: @314715
     /* 314715 */ GIM_Reject,
     /* 314716 */ // Label 76: @314716
     /* 314716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6443*/ GIMT_Encode4(315119),
     /* 314727 */ /*GILLT_s32*//*Label 6435*/ GIMT_Encode4(314767),
     /* 314731 */ /*GILLT_s64*//*Label 6436*/ GIMT_Encode4(314841), GIMT_Encode4(0),
     /* 314739 */ /*GILLT_v2s32*//*Label 6437*/ GIMT_Encode4(314915), GIMT_Encode4(0),
     /* 314747 */ /*GILLT_v4s16*//*Label 6438*/ GIMT_Encode4(314949),
     /* 314751 */ /*GILLT_v4s32*//*Label 6439*/ GIMT_Encode4(314983),
     /* 314755 */ /*GILLT_v8s8*//*Label 6440*/ GIMT_Encode4(315017),
     /* 314759 */ /*GILLT_v8s16*//*Label 6441*/ GIMT_Encode4(315051),
     /* 314763 */ /*GILLT_v16s8*//*Label 6442*/ GIMT_Encode4(315085),
     /* 314767 */ // Label 6435: @314767
     /* 314767 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(314840),
     /* 314772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 314778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314786 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(314820), // Rule ID 2319 //
     /* 314791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 314806 */     // MIs[1] Operand 1
     /* 314806 */     // No operand predicates
     /* 314806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314808 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 314808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 314811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 314818 */     GIR_RootConstrainSelectedInstOperands,
     /* 314819 */     // GIR_Coverage, 2319,
     /* 314819 */     GIR_EraseRootFromParent_Done,
     /* 314820 */   // Label 6445: @314820
     /* 314820 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(314839), // Rule ID 2318 //
     /* 314825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314832 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 314832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 314837 */     GIR_RootConstrainSelectedInstOperands,
     /* 314838 */     // GIR_Coverage, 2318,
     /* 314838 */     GIR_Done,
     /* 314839 */   // Label 6446: @314839
     /* 314839 */   GIM_Reject,
     /* 314840 */ // Label 6444: @314840
     /* 314840 */ GIM_Reject,
     /* 314841 */ // Label 6436: @314841
     /* 314841 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(314914),
     /* 314846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314860 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(314894), // Rule ID 2321 //
     /* 314865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 314880 */     // MIs[1] Operand 1
     /* 314880 */     // No operand predicates
     /* 314880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314882 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 314882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 314885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 314892 */     GIR_RootConstrainSelectedInstOperands,
     /* 314893 */     // GIR_Coverage, 2321,
     /* 314893 */     GIR_EraseRootFromParent_Done,
     /* 314894 */   // Label 6448: @314894
     /* 314894 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(314913), // Rule ID 2320 //
     /* 314899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314906 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 314906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 314911 */     GIR_RootConstrainSelectedInstOperands,
     /* 314912 */     // GIR_Coverage, 2320,
     /* 314912 */     GIR_Done,
     /* 314913 */   // Label 6449: @314913
     /* 314913 */   GIM_Reject,
     /* 314914 */ // Label 6447: @314914
     /* 314914 */ GIM_Reject,
     /* 314915 */ // Label 6437: @314915
     /* 314915 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(314948), // Rule ID 1407 //
     /* 314920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314941 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 314941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 314946 */   GIR_RootConstrainSelectedInstOperands,
     /* 314947 */   // GIR_Coverage, 1407,
     /* 314947 */   GIR_Done,
     /* 314948 */ // Label 6450: @314948
     /* 314948 */ GIM_Reject,
     /* 314949 */ // Label 6438: @314949
     /* 314949 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(314982), // Rule ID 1405 //
     /* 314954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314975 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 314975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 314980 */   GIR_RootConstrainSelectedInstOperands,
     /* 314981 */   // GIR_Coverage, 1405,
     /* 314981 */   GIR_Done,
     /* 314982 */ // Label 6451: @314982
     /* 314982 */ GIM_Reject,
     /* 314983 */ // Label 6439: @314983
     /* 314983 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(315016), // Rule ID 1408 //
     /* 314988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 314997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315009 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 315014 */   GIR_RootConstrainSelectedInstOperands,
     /* 315015 */   // GIR_Coverage, 1408,
     /* 315015 */   GIR_Done,
     /* 315016 */ // Label 6452: @315016
     /* 315016 */ GIM_Reject,
     /* 315017 */ // Label 6440: @315017
     /* 315017 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(315050), // Rule ID 1403 //
     /* 315022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315043 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 315048 */   GIR_RootConstrainSelectedInstOperands,
     /* 315049 */   // GIR_Coverage, 1403,
     /* 315049 */   GIR_Done,
     /* 315050 */ // Label 6453: @315050
     /* 315050 */ GIM_Reject,
     /* 315051 */ // Label 6441: @315051
     /* 315051 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(315084), // Rule ID 1406 //
     /* 315056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315077 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 315082 */   GIR_RootConstrainSelectedInstOperands,
     /* 315083 */   // GIR_Coverage, 1406,
     /* 315083 */   GIR_Done,
     /* 315084 */ // Label 6454: @315084
     /* 315084 */ GIM_Reject,
     /* 315085 */ // Label 6442: @315085
     /* 315085 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(315118), // Rule ID 1404 //
     /* 315090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315111 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 315116 */   GIR_RootConstrainSelectedInstOperands,
     /* 315117 */   // GIR_Coverage, 1404,
     /* 315117 */   GIR_Done,
     /* 315118 */ // Label 6455: @315118
     /* 315118 */ GIM_Reject,
     /* 315119 */ // Label 6443: @315119
     /* 315119 */ GIM_Reject,
     /* 315120 */ // Label 77: @315120
     /* 315120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6464*/ GIMT_Encode4(315523),
     /* 315131 */ /*GILLT_s32*//*Label 6456*/ GIMT_Encode4(315171),
     /* 315135 */ /*GILLT_s64*//*Label 6457*/ GIMT_Encode4(315245), GIMT_Encode4(0),
     /* 315143 */ /*GILLT_v2s32*//*Label 6458*/ GIMT_Encode4(315319), GIMT_Encode4(0),
     /* 315151 */ /*GILLT_v4s16*//*Label 6459*/ GIMT_Encode4(315353),
     /* 315155 */ /*GILLT_v4s32*//*Label 6460*/ GIMT_Encode4(315387),
     /* 315159 */ /*GILLT_v8s8*//*Label 6461*/ GIMT_Encode4(315421),
     /* 315163 */ /*GILLT_v8s16*//*Label 6462*/ GIMT_Encode4(315455),
     /* 315167 */ /*GILLT_v16s8*//*Label 6463*/ GIMT_Encode4(315489),
     /* 315171 */ // Label 6456: @315171
     /* 315171 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(315244),
     /* 315176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315190 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(315224), // Rule ID 2315 //
     /* 315195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 315210 */     // MIs[1] Operand 1
     /* 315210 */     // No operand predicates
     /* 315210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315212 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 315212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 315215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315222 */     GIR_RootConstrainSelectedInstOperands,
     /* 315223 */     // GIR_Coverage, 2315,
     /* 315223 */     GIR_EraseRootFromParent_Done,
     /* 315224 */   // Label 6466: @315224
     /* 315224 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(315243), // Rule ID 2314 //
     /* 315229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315236 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 315236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 315241 */     GIR_RootConstrainSelectedInstOperands,
     /* 315242 */     // GIR_Coverage, 2314,
     /* 315242 */     GIR_Done,
     /* 315243 */   // Label 6467: @315243
     /* 315243 */   GIM_Reject,
     /* 315244 */ // Label 6465: @315244
     /* 315244 */ GIM_Reject,
     /* 315245 */ // Label 6457: @315245
     /* 315245 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(315318),
     /* 315250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315264 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(315298), // Rule ID 2317 //
     /* 315269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 315284 */     // MIs[1] Operand 1
     /* 315284 */     // No operand predicates
     /* 315284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315286 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 315286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 315289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315296 */     GIR_RootConstrainSelectedInstOperands,
     /* 315297 */     // GIR_Coverage, 2317,
     /* 315297 */     GIR_EraseRootFromParent_Done,
     /* 315298 */   // Label 6469: @315298
     /* 315298 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(315317), // Rule ID 2316 //
     /* 315303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315310 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 315310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 315315 */     GIR_RootConstrainSelectedInstOperands,
     /* 315316 */     // GIR_Coverage, 2316,
     /* 315316 */     GIR_Done,
     /* 315317 */   // Label 6470: @315317
     /* 315317 */   GIM_Reject,
     /* 315318 */ // Label 6468: @315318
     /* 315318 */ GIM_Reject,
     /* 315319 */ // Label 6458: @315319
     /* 315319 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(315352), // Rule ID 1395 //
     /* 315324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315345 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 315345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 315350 */   GIR_RootConstrainSelectedInstOperands,
     /* 315351 */   // GIR_Coverage, 1395,
     /* 315351 */   GIR_Done,
     /* 315352 */ // Label 6471: @315352
     /* 315352 */ GIM_Reject,
     /* 315353 */ // Label 6459: @315353
     /* 315353 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(315386), // Rule ID 1393 //
     /* 315358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315379 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 315379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 315384 */   GIR_RootConstrainSelectedInstOperands,
     /* 315385 */   // GIR_Coverage, 1393,
     /* 315385 */   GIR_Done,
     /* 315386 */ // Label 6472: @315386
     /* 315386 */ GIM_Reject,
     /* 315387 */ // Label 6460: @315387
     /* 315387 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(315420), // Rule ID 1396 //
     /* 315392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315413 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 315418 */   GIR_RootConstrainSelectedInstOperands,
     /* 315419 */   // GIR_Coverage, 1396,
     /* 315419 */   GIR_Done,
     /* 315420 */ // Label 6473: @315420
     /* 315420 */ GIM_Reject,
     /* 315421 */ // Label 6461: @315421
     /* 315421 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(315454), // Rule ID 1391 //
     /* 315426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315447 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 315452 */   GIR_RootConstrainSelectedInstOperands,
     /* 315453 */   // GIR_Coverage, 1391,
     /* 315453 */   GIR_Done,
     /* 315454 */ // Label 6474: @315454
     /* 315454 */ GIM_Reject,
     /* 315455 */ // Label 6462: @315455
     /* 315455 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(315488), // Rule ID 1394 //
     /* 315460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315481 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 315486 */   GIR_RootConstrainSelectedInstOperands,
     /* 315487 */   // GIR_Coverage, 1394,
     /* 315487 */   GIR_Done,
     /* 315488 */ // Label 6475: @315488
     /* 315488 */ GIM_Reject,
     /* 315489 */ // Label 6463: @315489
     /* 315489 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(315522), // Rule ID 1392 //
     /* 315494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315515 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 315520 */   GIR_RootConstrainSelectedInstOperands,
     /* 315521 */   // GIR_Coverage, 1392,
     /* 315521 */   GIR_Done,
     /* 315522 */ // Label 6476: @315522
     /* 315522 */ GIM_Reject,
     /* 315523 */ // Label 6464: @315523
     /* 315523 */ GIM_Reject,
     /* 315524 */ // Label 78: @315524
     /* 315524 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6485*/ GIMT_Encode4(315927),
     /* 315535 */ /*GILLT_s32*//*Label 6477*/ GIMT_Encode4(315575),
     /* 315539 */ /*GILLT_s64*//*Label 6478*/ GIMT_Encode4(315649), GIMT_Encode4(0),
     /* 315547 */ /*GILLT_v2s32*//*Label 6479*/ GIMT_Encode4(315723), GIMT_Encode4(0),
     /* 315555 */ /*GILLT_v4s16*//*Label 6480*/ GIMT_Encode4(315757),
     /* 315559 */ /*GILLT_v4s32*//*Label 6481*/ GIMT_Encode4(315791),
     /* 315563 */ /*GILLT_v8s8*//*Label 6482*/ GIMT_Encode4(315825),
     /* 315567 */ /*GILLT_v8s16*//*Label 6483*/ GIMT_Encode4(315859),
     /* 315571 */ /*GILLT_v16s8*//*Label 6484*/ GIMT_Encode4(315893),
     /* 315575 */ // Label 6477: @315575
     /* 315575 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(315648),
     /* 315580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315594 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(315628), // Rule ID 2327 //
     /* 315599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 315614 */     // MIs[1] Operand 1
     /* 315614 */     // No operand predicates
     /* 315614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315616 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 315616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 315619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315626 */     GIR_RootConstrainSelectedInstOperands,
     /* 315627 */     // GIR_Coverage, 2327,
     /* 315627 */     GIR_EraseRootFromParent_Done,
     /* 315628 */   // Label 6487: @315628
     /* 315628 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(315647), // Rule ID 2326 //
     /* 315633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315640 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 315640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 315645 */     GIR_RootConstrainSelectedInstOperands,
     /* 315646 */     // GIR_Coverage, 2326,
     /* 315646 */     GIR_Done,
     /* 315647 */   // Label 6488: @315647
     /* 315647 */   GIM_Reject,
     /* 315648 */ // Label 6486: @315648
     /* 315648 */ GIM_Reject,
     /* 315649 */ // Label 6478: @315649
     /* 315649 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(315722),
     /* 315654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315668 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(315702), // Rule ID 2329 //
     /* 315673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 315688 */     // MIs[1] Operand 1
     /* 315688 */     // No operand predicates
     /* 315688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315690 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 315690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 315693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315700 */     GIR_RootConstrainSelectedInstOperands,
     /* 315701 */     // GIR_Coverage, 2329,
     /* 315701 */     GIR_EraseRootFromParent_Done,
     /* 315702 */   // Label 6490: @315702
     /* 315702 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(315721), // Rule ID 2328 //
     /* 315707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315714 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 315714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 315719 */     GIR_RootConstrainSelectedInstOperands,
     /* 315720 */     // GIR_Coverage, 2328,
     /* 315720 */     GIR_Done,
     /* 315721 */   // Label 6491: @315721
     /* 315721 */   GIM_Reject,
     /* 315722 */ // Label 6489: @315722
     /* 315722 */ GIM_Reject,
     /* 315723 */ // Label 6479: @315723
     /* 315723 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(315756), // Rule ID 1530 //
     /* 315728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315749 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 315749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 315754 */   GIR_RootConstrainSelectedInstOperands,
     /* 315755 */   // GIR_Coverage, 1530,
     /* 315755 */   GIR_Done,
     /* 315756 */ // Label 6492: @315756
     /* 315756 */ GIM_Reject,
     /* 315757 */ // Label 6480: @315757
     /* 315757 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(315790), // Rule ID 1528 //
     /* 315762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315783 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 315783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 315788 */   GIR_RootConstrainSelectedInstOperands,
     /* 315789 */   // GIR_Coverage, 1528,
     /* 315789 */   GIR_Done,
     /* 315790 */ // Label 6493: @315790
     /* 315790 */ GIM_Reject,
     /* 315791 */ // Label 6481: @315791
     /* 315791 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(315824), // Rule ID 1531 //
     /* 315796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315817 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 315822 */   GIR_RootConstrainSelectedInstOperands,
     /* 315823 */   // GIR_Coverage, 1531,
     /* 315823 */   GIR_Done,
     /* 315824 */ // Label 6494: @315824
     /* 315824 */ GIM_Reject,
     /* 315825 */ // Label 6482: @315825
     /* 315825 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(315858), // Rule ID 1526 //
     /* 315830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315851 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 315856 */   GIR_RootConstrainSelectedInstOperands,
     /* 315857 */   // GIR_Coverage, 1526,
     /* 315857 */   GIR_Done,
     /* 315858 */ // Label 6495: @315858
     /* 315858 */ GIM_Reject,
     /* 315859 */ // Label 6483: @315859
     /* 315859 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(315892), // Rule ID 1529 //
     /* 315864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315885 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 315890 */   GIR_RootConstrainSelectedInstOperands,
     /* 315891 */   // GIR_Coverage, 1529,
     /* 315891 */   GIR_Done,
     /* 315892 */ // Label 6496: @315892
     /* 315892 */ GIM_Reject,
     /* 315893 */ // Label 6484: @315893
     /* 315893 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(315926), // Rule ID 1527 //
     /* 315898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315919 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 315924 */   GIR_RootConstrainSelectedInstOperands,
     /* 315925 */   // GIR_Coverage, 1527,
     /* 315925 */   GIR_Done,
     /* 315926 */ // Label 6497: @315926
     /* 315926 */ GIM_Reject,
     /* 315927 */ // Label 6485: @315927
     /* 315927 */ GIM_Reject,
     /* 315928 */ // Label 79: @315928
     /* 315928 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6506*/ GIMT_Encode4(316331),
     /* 315939 */ /*GILLT_s32*//*Label 6498*/ GIMT_Encode4(315979),
     /* 315943 */ /*GILLT_s64*//*Label 6499*/ GIMT_Encode4(316053), GIMT_Encode4(0),
     /* 315951 */ /*GILLT_v2s32*//*Label 6500*/ GIMT_Encode4(316127), GIMT_Encode4(0),
     /* 315959 */ /*GILLT_v4s16*//*Label 6501*/ GIMT_Encode4(316161),
     /* 315963 */ /*GILLT_v4s32*//*Label 6502*/ GIMT_Encode4(316195),
     /* 315967 */ /*GILLT_v8s8*//*Label 6503*/ GIMT_Encode4(316229),
     /* 315971 */ /*GILLT_v8s16*//*Label 6504*/ GIMT_Encode4(316263),
     /* 315975 */ /*GILLT_v16s8*//*Label 6505*/ GIMT_Encode4(316297),
     /* 315979 */ // Label 6498: @315979
     /* 315979 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(316052),
     /* 315984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315998 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(316032), // Rule ID 2323 //
     /* 316003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 316018 */     // MIs[1] Operand 1
     /* 316018 */     // No operand predicates
     /* 316018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316020 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 316020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 316023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316030 */     GIR_RootConstrainSelectedInstOperands,
     /* 316031 */     // GIR_Coverage, 2323,
     /* 316031 */     GIR_EraseRootFromParent_Done,
     /* 316032 */   // Label 6508: @316032
     /* 316032 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(316051), // Rule ID 2322 //
     /* 316037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316044 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 316044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 316049 */     GIR_RootConstrainSelectedInstOperands,
     /* 316050 */     // GIR_Coverage, 2322,
     /* 316050 */     GIR_Done,
     /* 316051 */   // Label 6509: @316051
     /* 316051 */   GIM_Reject,
     /* 316052 */ // Label 6507: @316052
     /* 316052 */ GIM_Reject,
     /* 316053 */ // Label 6499: @316053
     /* 316053 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(316126),
     /* 316058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316072 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(316106), // Rule ID 2325 //
     /* 316077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 316092 */     // MIs[1] Operand 1
     /* 316092 */     // No operand predicates
     /* 316092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316094 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 316094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 316097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316104 */     GIR_RootConstrainSelectedInstOperands,
     /* 316105 */     // GIR_Coverage, 2325,
     /* 316105 */     GIR_EraseRootFromParent_Done,
     /* 316106 */   // Label 6511: @316106
     /* 316106 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(316125), // Rule ID 2324 //
     /* 316111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316118 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 316118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 316123 */     GIR_RootConstrainSelectedInstOperands,
     /* 316124 */     // GIR_Coverage, 2324,
     /* 316124 */     GIR_Done,
     /* 316125 */   // Label 6512: @316125
     /* 316125 */   GIM_Reject,
     /* 316126 */ // Label 6510: @316126
     /* 316126 */ GIM_Reject,
     /* 316127 */ // Label 6500: @316127
     /* 316127 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(316160), // Rule ID 1518 //
     /* 316132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 316141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316153 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 316153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 316158 */   GIR_RootConstrainSelectedInstOperands,
     /* 316159 */   // GIR_Coverage, 1518,
     /* 316159 */   GIR_Done,
     /* 316160 */ // Label 6513: @316160
     /* 316160 */ GIM_Reject,
     /* 316161 */ // Label 6501: @316161
     /* 316161 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(316194), // Rule ID 1516 //
     /* 316166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 316175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316187 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 316187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 316192 */   GIR_RootConstrainSelectedInstOperands,
     /* 316193 */   // GIR_Coverage, 1516,
     /* 316193 */   GIR_Done,
     /* 316194 */ // Label 6514: @316194
     /* 316194 */ GIM_Reject,
     /* 316195 */ // Label 6502: @316195
     /* 316195 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(316228), // Rule ID 1519 //
     /* 316200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316221 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 316221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 316226 */   GIR_RootConstrainSelectedInstOperands,
     /* 316227 */   // GIR_Coverage, 1519,
     /* 316227 */   GIR_Done,
     /* 316228 */ // Label 6515: @316228
     /* 316228 */ GIM_Reject,
     /* 316229 */ // Label 6503: @316229
     /* 316229 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(316262), // Rule ID 1514 //
     /* 316234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 316243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316255 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 316255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 316260 */   GIR_RootConstrainSelectedInstOperands,
     /* 316261 */   // GIR_Coverage, 1514,
     /* 316261 */   GIR_Done,
     /* 316262 */ // Label 6516: @316262
     /* 316262 */ GIM_Reject,
     /* 316263 */ // Label 6504: @316263
     /* 316263 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(316296), // Rule ID 1517 //
     /* 316268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316289 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 316289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 316294 */   GIR_RootConstrainSelectedInstOperands,
     /* 316295 */   // GIR_Coverage, 1517,
     /* 316295 */   GIR_Done,
     /* 316296 */ // Label 6517: @316296
     /* 316296 */ GIM_Reject,
     /* 316297 */ // Label 6505: @316297
     /* 316297 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(316330), // Rule ID 1515 //
     /* 316302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 316308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 316311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316323 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 316323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 316328 */   GIR_RootConstrainSelectedInstOperands,
     /* 316329 */   // GIR_Coverage, 1515,
     /* 316329 */   GIR_Done,
     /* 316330 */ // Label 6518: @316330
     /* 316330 */ GIM_Reject,
     /* 316331 */ // Label 6506: @316331
     /* 316331 */ GIM_Reject,
     /* 316332 */ // Label 80: @316332
     /* 316332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6528*/ GIMT_Encode4(317146),
     /* 316343 */ /*GILLT_s32*//*Label 6519*/ GIMT_Encode4(316383),
     /* 316347 */ /*GILLT_s64*//*Label 6520*/ GIMT_Encode4(316410), GIMT_Encode4(0),
     /* 316355 */ /*GILLT_v2s32*//*Label 6521*/ GIMT_Encode4(316489),
     /* 316359 */ /*GILLT_v2s64*//*Label 6522*/ GIMT_Encode4(316516),
     /* 316363 */ /*GILLT_v4s16*//*Label 6523*/ GIMT_Encode4(316699),
     /* 316367 */ /*GILLT_v4s32*//*Label 6524*/ GIMT_Encode4(316726),
     /* 316371 */ /*GILLT_v8s8*//*Label 6525*/ GIMT_Encode4(316909),
     /* 316375 */ /*GILLT_v8s16*//*Label 6526*/ GIMT_Encode4(316936),
     /* 316379 */ /*GILLT_v16s8*//*Label 6527*/ GIMT_Encode4(317119),
     /* 316383 */ // Label 6519: @316383
     /* 316383 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(316409), // Rule ID 2308 //
     /* 316388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316402 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 316402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 316407 */   GIR_RootConstrainSelectedInstOperands,
     /* 316408 */   // GIR_Coverage, 2308,
     /* 316408 */   GIR_Done,
     /* 316409 */ // Label 6529: @316409
     /* 316409 */ GIM_Reject,
     /* 316410 */ // Label 6520: @316410
     /* 316410 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(316488),
     /* 316415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316418 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(316441), // Rule ID 1645 //
     /* 316423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316434 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 316434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 316439 */     GIR_RootConstrainSelectedInstOperands,
     /* 316440 */     // GIR_Coverage, 1645,
     /* 316440 */     GIR_Done,
     /* 316441 */   // Label 6531: @316441
     /* 316441 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(316464), // Rule ID 2309 //
     /* 316446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316457 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 316457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 316462 */     GIR_RootConstrainSelectedInstOperands,
     /* 316463 */     // GIR_Coverage, 2309,
     /* 316463 */     GIR_Done,
     /* 316464 */   // Label 6532: @316464
     /* 316464 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(316487), // Rule ID 2505 //
     /* 316469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 316472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316480 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 316480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 316485 */     GIR_RootConstrainSelectedInstOperands,
     /* 316486 */     // GIR_Coverage, 2505,
     /* 316486 */     GIR_Done,
     /* 316487 */   // Label 6533: @316487
     /* 316487 */   GIM_Reject,
     /* 316488 */ // Label 6530: @316488
     /* 316488 */ GIM_Reject,
     /* 316489 */ // Label 6521: @316489
     /* 316489 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(316515), // Rule ID 707 //
     /* 316494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316508 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 316508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 316513 */   GIR_RootConstrainSelectedInstOperands,
     /* 316514 */   // GIR_Coverage, 707,
     /* 316514 */   GIR_Done,
     /* 316515 */ // Label 6534: @316515
     /* 316515 */ GIM_Reject,
     /* 316516 */ // Label 6522: @316516
     /* 316516 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(316698),
     /* 316521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316528 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(316606), // Rule ID 4829 //
     /* 316533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 316582 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 316589 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 316589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 316592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 316599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 316604 */     GIR_RootConstrainSelectedInstOperands,
     /* 316605 */     // GIR_Coverage, 4829,
     /* 316605 */     GIR_EraseRootFromParent_Done,
     /* 316606 */   // Label 6536: @316606
     /* 316606 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(316678), // Rule ID 4828 //
     /* 316611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316652 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316656 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316663 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 316663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 316666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 316672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 316676 */     GIR_RootConstrainSelectedInstOperands,
     /* 316677 */     // GIR_Coverage, 4828,
     /* 316677 */     GIR_EraseRootFromParent_Done,
     /* 316678 */   // Label 6537: @316678
     /* 316678 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(316697), // Rule ID 709 //
     /* 316683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316690 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 316690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 316695 */     GIR_RootConstrainSelectedInstOperands,
     /* 316696 */     // GIR_Coverage, 709,
     /* 316696 */     GIR_Done,
     /* 316697 */   // Label 6538: @316697
     /* 316697 */   GIM_Reject,
     /* 316698 */ // Label 6535: @316698
     /* 316698 */ GIM_Reject,
     /* 316699 */ // Label 6523: @316699
     /* 316699 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(316725), // Rule ID 705 //
     /* 316704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316718 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 316718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 316723 */   GIR_RootConstrainSelectedInstOperands,
     /* 316724 */   // GIR_Coverage, 705,
     /* 316724 */   GIR_Done,
     /* 316725 */ // Label 6539: @316725
     /* 316725 */ GIM_Reject,
     /* 316726 */ // Label 6524: @316726
     /* 316726 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(316908),
     /* 316731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316738 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(316816), // Rule ID 4827 //
     /* 316743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 316792 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 316799 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 316799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 316802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 316809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 316814 */     GIR_RootConstrainSelectedInstOperands,
     /* 316815 */     // GIR_Coverage, 4827,
     /* 316815 */     GIR_EraseRootFromParent_Done,
     /* 316816 */   // Label 6541: @316816
     /* 316816 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(316888), // Rule ID 4826 //
     /* 316821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316866 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316873 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 316873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 316876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 316882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 316886 */     GIR_RootConstrainSelectedInstOperands,
     /* 316887 */     // GIR_Coverage, 4826,
     /* 316887 */     GIR_EraseRootFromParent_Done,
     /* 316888 */   // Label 6542: @316888
     /* 316888 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(316907), // Rule ID 708 //
     /* 316893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316900 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 316900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 316905 */     GIR_RootConstrainSelectedInstOperands,
     /* 316906 */     // GIR_Coverage, 708,
     /* 316906 */     GIR_Done,
     /* 316907 */   // Label 6543: @316907
     /* 316907 */   GIM_Reject,
     /* 316908 */ // Label 6540: @316908
     /* 316908 */ GIM_Reject,
     /* 316909 */ // Label 6525: @316909
     /* 316909 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(316935), // Rule ID 703 //
     /* 316914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316928 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 316928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 316933 */   GIR_RootConstrainSelectedInstOperands,
     /* 316934 */   // GIR_Coverage, 703,
     /* 316934 */   GIR_Done,
     /* 316935 */ // Label 6544: @316935
     /* 316935 */ GIM_Reject,
     /* 316936 */ // Label 6526: @316936
     /* 316936 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(317118),
     /* 316941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316948 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(317026), // Rule ID 4825 //
     /* 316953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 317002 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 317009 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 317009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 317012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 317019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 317024 */     GIR_RootConstrainSelectedInstOperands,
     /* 317025 */     // GIR_Coverage, 4825,
     /* 317025 */     GIR_EraseRootFromParent_Done,
     /* 317026 */   // Label 6546: @317026
     /* 317026 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(317098), // Rule ID 4824 //
     /* 317031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 317047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317076 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317083 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 317083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 317086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 317092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 317096 */     GIR_RootConstrainSelectedInstOperands,
     /* 317097 */     // GIR_Coverage, 4824,
     /* 317097 */     GIR_EraseRootFromParent_Done,
     /* 317098 */   // Label 6547: @317098
     /* 317098 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(317117), // Rule ID 706 //
     /* 317103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317110 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 317110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 317115 */     GIR_RootConstrainSelectedInstOperands,
     /* 317116 */     // GIR_Coverage, 706,
     /* 317116 */     GIR_Done,
     /* 317117 */   // Label 6548: @317117
     /* 317117 */   GIM_Reject,
     /* 317118 */ // Label 6545: @317118
     /* 317118 */ GIM_Reject,
     /* 317119 */ // Label 6527: @317119
     /* 317119 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(317145), // Rule ID 704 //
     /* 317124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 317130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317138 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 317138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 317143 */   GIR_RootConstrainSelectedInstOperands,
     /* 317144 */   // GIR_Coverage, 704,
     /* 317144 */   GIR_Done,
     /* 317145 */ // Label 6549: @317145
     /* 317145 */ GIM_Reject,
     /* 317146 */ // Label 6528: @317146
     /* 317146 */ GIM_Reject,
     /* 317147 */ // Label 81: @317147
     /* 317147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6552*/ GIMT_Encode4(317312),
     /* 317158 */ /*GILLT_s32*//*Label 6550*/ GIMT_Encode4(317166),
     /* 317162 */ /*GILLT_s64*//*Label 6551*/ GIMT_Encode4(317239),
     /* 317166 */ // Label 6550: @317166
     /* 317166 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(317192), // Rule ID 4670 //
     /* 317171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317181 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 317181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 317186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317190 */   GIR_RootConstrainSelectedInstOperands,
     /* 317191 */   // GIR_Coverage, 4670,
     /* 317191 */   GIR_Done,
     /* 317192 */ // Label 6553: @317192
     /* 317192 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(317215), // Rule ID 4676 //
     /* 317197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317204 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 317204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 317209 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317213 */   GIR_RootConstrainSelectedInstOperands,
     /* 317214 */   // GIR_Coverage, 4676,
     /* 317214 */   GIR_Done,
     /* 317215 */ // Label 6554: @317215
     /* 317215 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(317238), // Rule ID 4678 //
     /* 317220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317227 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 317227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 317232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317236 */   GIR_RootConstrainSelectedInstOperands,
     /* 317237 */   // GIR_Coverage, 4678,
     /* 317237 */   GIR_Done,
     /* 317238 */ // Label 6555: @317238
     /* 317238 */ GIM_Reject,
     /* 317239 */ // Label 6551: @317239
     /* 317239 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(317265), // Rule ID 4672 //
     /* 317244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317254 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 317259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317263 */   GIR_RootConstrainSelectedInstOperands,
     /* 317264 */   // GIR_Coverage, 4672,
     /* 317264 */   GIR_Done,
     /* 317265 */ // Label 6556: @317265
     /* 317265 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(317288), // Rule ID 4680 //
     /* 317270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317277 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 317282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317286 */   GIR_RootConstrainSelectedInstOperands,
     /* 317287 */   // GIR_Coverage, 4680,
     /* 317287 */   GIR_Done,
     /* 317288 */ // Label 6557: @317288
     /* 317288 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(317311), // Rule ID 4682 //
     /* 317293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317300 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 317305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317309 */   GIR_RootConstrainSelectedInstOperands,
     /* 317310 */   // GIR_Coverage, 4682,
     /* 317310 */   GIR_Done,
     /* 317311 */ // Label 6558: @317311
     /* 317311 */ GIM_Reject,
     /* 317312 */ // Label 6552: @317312
     /* 317312 */ GIM_Reject,
     /* 317313 */ // Label 82: @317313
     /* 317313 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(317411),
     /* 317318 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 317321 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6563*/ GIMT_Encode4(317410),
     /* 317332 */   /*GILLT_s16*//*Label 6560*/ GIMT_Encode4(317344),
     /* 317336 */   /*GILLT_s32*//*Label 6561*/ GIMT_Encode4(317368),
     /* 317340 */   /*GILLT_s64*//*Label 6562*/ GIMT_Encode4(317389),
     /* 317344 */   // Label 6560: @317344
     /* 317344 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(317367), // Rule ID 4674 //
     /* 317349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317356 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 317361 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317365 */     GIR_RootConstrainSelectedInstOperands,
     /* 317366 */     // GIR_Coverage, 4674,
     /* 317366 */     GIR_Done,
     /* 317367 */   // Label 6564: @317367
     /* 317367 */   GIM_Reject,
     /* 317368 */   // Label 6561: @317368
     /* 317368 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(317388), // Rule ID 4684 //
     /* 317373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317377 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 317382 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317386 */     GIR_RootConstrainSelectedInstOperands,
     /* 317387 */     // GIR_Coverage, 4684,
     /* 317387 */     GIR_Done,
     /* 317388 */   // Label 6565: @317388
     /* 317388 */   GIM_Reject,
     /* 317389 */   // Label 6562: @317389
     /* 317389 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(317409), // Rule ID 4686 //
     /* 317394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317398 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 317403 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317407 */     GIR_RootConstrainSelectedInstOperands,
     /* 317408 */     // GIR_Coverage, 4686,
     /* 317408 */     GIR_Done,
     /* 317409 */   // Label 6566: @317409
     /* 317409 */   GIM_Reject,
     /* 317410 */   // Label 6563: @317410
     /* 317410 */   GIM_Reject,
     /* 317411 */ // Label 6559: @317411
     /* 317411 */ GIM_Reject,
     /* 317412 */ // Label 83: @317412
     /* 317412 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(317427), // Rule ID 225 //
     /* 317417 */   // MIs[0] addr
     /* 317417 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 317420 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 317420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 317425 */   GIR_RootConstrainSelectedInstOperands,
     /* 317426 */   // GIR_Coverage, 225,
     /* 317426 */   GIR_Done,
     /* 317427 */ // Label 6567: @317427
     /* 317427 */ GIM_Reject,
     /* 317428 */ // Label 84: @317428
     /* 317428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6579*/ GIMT_Encode4(322439),
     /* 317439 */ /*GILLT_s64*//*Label 6568*/ GIMT_Encode4(317511), GIMT_Encode4(0),
     /* 317447 */ /*GILLT_v2s32*//*Label 6569*/ GIMT_Encode4(317793), GIMT_Encode4(0),
     /* 317455 */ /*GILLT_v4s16*//*Label 6570*/ GIMT_Encode4(318075), GIMT_Encode4(0),
     /* 317463 */ /*GILLT_v8s8*//*Label 6571*/ GIMT_Encode4(318357), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 317475 */ /*GILLT_nxv1s1*//*Label 6572*/ GIMT_Encode4(318537),
     /* 317479 */ /*GILLT_nxv2s1*//*Label 6573*/ GIMT_Encode4(320800),
     /* 317483 */ /*GILLT_nxv2s16*//*Label 6574*/ GIMT_Encode4(321655),
     /* 317487 */ /*GILLT_nxv2s32*//*Label 6575*/ GIMT_Encode4(321942), GIMT_Encode4(0),
     /* 317495 */ /*GILLT_nxv4s1*//*Label 6576*/ GIMT_Encode4(322012),
     /* 317499 */ /*GILLT_nxv4s16*//*Label 6577*/ GIMT_Encode4(322299), GIMT_Encode4(0),
     /* 317507 */ /*GILLT_nxv8s1*//*Label 6578*/ GIMT_Encode4(322369),
     /* 317511 */ // Label 6568: @317511
     /* 317511 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(317792),
     /* 317516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317527 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(317591), // Rule ID 5395 //
     /* 317532 */     // MIs[0] Operand 2
     /* 317532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317543 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317590 */     // GIR_Coverage, 5395,
     /* 317590 */     GIR_EraseRootFromParent_Done,
     /* 317591 */   // Label 6581: @317591
     /* 317591 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(317655), // Rule ID 5400 //
     /* 317596 */     // MIs[0] Operand 2
     /* 317596 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317607 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317637 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317654 */     // GIR_Coverage, 5400,
     /* 317654 */     GIR_EraseRootFromParent_Done,
     /* 317655 */   // Label 6582: @317655
     /* 317655 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(317693), // Rule ID 6799 //
     /* 317660 */     // MIs[0] Operand 2
     /* 317660 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317671 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 317671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317676 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317692 */     // GIR_Coverage, 6799,
     /* 317692 */     GIR_EraseRootFromParent_Done,
     /* 317693 */   // Label 6583: @317693
     /* 317693 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(317731), // Rule ID 6800 //
     /* 317698 */     // MIs[0] Operand 2
     /* 317698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317709 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 317709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317714 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317730 */     // GIR_Coverage, 6800,
     /* 317730 */     GIR_EraseRootFromParent_Done,
     /* 317731 */   // Label 6584: @317731
     /* 317731 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(317791), // Rule ID 6804 //
     /* 317736 */     // MIs[0] Operand 2
     /* 317736 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317747 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 317747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 317754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317773 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317790 */     // GIR_Coverage, 6804,
     /* 317790 */     GIR_EraseRootFromParent_Done,
     /* 317791 */   // Label 6585: @317791
     /* 317791 */   GIM_Reject,
     /* 317792 */ // Label 6580: @317792
     /* 317792 */ GIM_Reject,
     /* 317793 */ // Label 6569: @317793
     /* 317793 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(318074),
     /* 317798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317809 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(317873), // Rule ID 5385 //
     /* 317814 */     // MIs[0] Operand 2
     /* 317814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 317825 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317855 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317872 */     // GIR_Coverage, 5385,
     /* 317872 */     GIR_EraseRootFromParent_Done,
     /* 317873 */   // Label 6587: @317873
     /* 317873 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(317937), // Rule ID 5390 //
     /* 317878 */     // MIs[0] Operand 2
     /* 317878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 317889 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317919 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317936 */     // GIR_Coverage, 5390,
     /* 317936 */     GIR_EraseRootFromParent_Done,
     /* 317937 */   // Label 6588: @317937
     /* 317937 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(317975), // Rule ID 6796 //
     /* 317942 */     // MIs[0] Operand 2
     /* 317942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317953 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 317953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317958 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317974 */     // GIR_Coverage, 6796,
     /* 317974 */     GIR_EraseRootFromParent_Done,
     /* 317975 */   // Label 6589: @317975
     /* 317975 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(318013), // Rule ID 6798 //
     /* 317980 */     // MIs[0] Operand 2
     /* 317980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317991 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 317991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317996 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318012 */     // GIR_Coverage, 6798,
     /* 318012 */     GIR_EraseRootFromParent_Done,
     /* 318013 */   // Label 6590: @318013
     /* 318013 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(318073), // Rule ID 6803 //
     /* 318018 */     // MIs[0] Operand 2
     /* 318018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318029 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318072 */     // GIR_Coverage, 6803,
     /* 318072 */     GIR_EraseRootFromParent_Done,
     /* 318073 */   // Label 6591: @318073
     /* 318073 */   GIM_Reject,
     /* 318074 */ // Label 6586: @318074
     /* 318074 */ GIM_Reject,
     /* 318075 */ // Label 6570: @318075
     /* 318075 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(318356),
     /* 318080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318091 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(318155), // Rule ID 5375 //
     /* 318096 */     // MIs[0] Operand 2
     /* 318096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 318107 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318127 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318154 */     // GIR_Coverage, 5375,
     /* 318154 */     GIR_EraseRootFromParent_Done,
     /* 318155 */   // Label 6593: @318155
     /* 318155 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(318219), // Rule ID 5380 //
     /* 318160 */     // MIs[0] Operand 2
     /* 318160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 318171 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318218 */     // GIR_Coverage, 5380,
     /* 318218 */     GIR_EraseRootFromParent_Done,
     /* 318219 */   // Label 6594: @318219
     /* 318219 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(318257), // Rule ID 6794 //
     /* 318224 */     // MIs[0] Operand 2
     /* 318224 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318235 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 318235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318240 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318256 */     // GIR_Coverage, 6794,
     /* 318256 */     GIR_EraseRootFromParent_Done,
     /* 318257 */   // Label 6595: @318257
     /* 318257 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(318295), // Rule ID 6797 //
     /* 318262 */     // MIs[0] Operand 2
     /* 318262 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318273 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 318273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318278 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318294 */     // GIR_Coverage, 6797,
     /* 318294 */     GIR_EraseRootFromParent_Done,
     /* 318295 */   // Label 6596: @318295
     /* 318295 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(318355), // Rule ID 6802 //
     /* 318300 */     // MIs[0] Operand 2
     /* 318300 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318311 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318337 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318354 */     // GIR_Coverage, 6802,
     /* 318354 */     GIR_EraseRootFromParent_Done,
     /* 318355 */   // Label 6597: @318355
     /* 318355 */   GIM_Reject,
     /* 318356 */ // Label 6592: @318356
     /* 318356 */ GIM_Reject,
     /* 318357 */ // Label 6571: @318357
     /* 318357 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(318536),
     /* 318362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 318365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318373 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(318437), // Rule ID 5370 //
     /* 318378 */     // MIs[0] Operand 2
     /* 318378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 318389 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318409 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318419 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318436 */     // GIR_Coverage, 5370,
     /* 318436 */     GIR_EraseRootFromParent_Done,
     /* 318437 */   // Label 6599: @318437
     /* 318437 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(318475), // Rule ID 6795 //
     /* 318442 */     // MIs[0] Operand 2
     /* 318442 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318453 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 318453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318458 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318474 */     // GIR_Coverage, 6795,
     /* 318474 */     GIR_EraseRootFromParent_Done,
     /* 318475 */   // Label 6600: @318475
     /* 318475 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(318535), // Rule ID 6801 //
     /* 318480 */     // MIs[0] Operand 2
     /* 318480 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318491 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318534 */     // GIR_Coverage, 6801,
     /* 318534 */     GIR_EraseRootFromParent_Done,
     /* 318535 */   // Label 6601: @318535
     /* 318535 */   GIM_Reject,
     /* 318536 */ // Label 6598: @318536
     /* 318536 */ GIM_Reject,
     /* 318537 */ // Label 6572: @318537
     /* 318537 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(318572), // Rule ID 8813 //
     /* 318542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 318548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318552 */   // MIs[0] Operand 2
     /* 318552 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318563 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 318563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318568 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 318570 */   GIR_RootConstrainSelectedInstOperands,
     /* 318571 */   // GIR_Coverage, 8813,
     /* 318571 */   GIR_EraseRootFromParent_Done,
     /* 318572 */ // Label 6602: @318572
     /* 318572 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(318607), // Rule ID 8814 //
     /* 318577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 318583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318587 */   // MIs[0] Operand 2
     /* 318587 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318598 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 318598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 318605 */   GIR_RootConstrainSelectedInstOperands,
     /* 318606 */   // GIR_Coverage, 8814,
     /* 318606 */   GIR_EraseRootFromParent_Done,
     /* 318607 */ // Label 6603: @318607
     /* 318607 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(318661), // Rule ID 8821 //
     /* 318612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318622 */   // MIs[0] Operand 2
     /* 318622 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318633 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318659 */   GIR_RootConstrainSelectedInstOperands,
     /* 318660 */   // GIR_Coverage, 8821,
     /* 318660 */   GIR_EraseRootFromParent_Done,
     /* 318661 */ // Label 6604: @318661
     /* 318661 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(318715), // Rule ID 8822 //
     /* 318666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318676 */   // MIs[0] Operand 2
     /* 318676 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318687 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318699 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318713 */   GIR_RootConstrainSelectedInstOperands,
     /* 318714 */   // GIR_Coverage, 8822,
     /* 318714 */   GIR_EraseRootFromParent_Done,
     /* 318715 */ // Label 6605: @318715
     /* 318715 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(318769), // Rule ID 8823 //
     /* 318720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318730 */   // MIs[0] Operand 2
     /* 318730 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 318741 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318767 */   GIR_RootConstrainSelectedInstOperands,
     /* 318768 */   // GIR_Coverage, 8823,
     /* 318768 */   GIR_EraseRootFromParent_Done,
     /* 318769 */ // Label 6606: @318769
     /* 318769 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(318823), // Rule ID 8824 //
     /* 318774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318784 */   // MIs[0] Operand 2
     /* 318784 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 318795 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318821 */   GIR_RootConstrainSelectedInstOperands,
     /* 318822 */   // GIR_Coverage, 8824,
     /* 318822 */   GIR_EraseRootFromParent_Done,
     /* 318823 */ // Label 6607: @318823
     /* 318823 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(318894), // Rule ID 8833 //
     /* 318828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 318834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318838 */   // MIs[0] Operand 2
     /* 318838 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318849 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 318849 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 318852 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318856 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318861 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318879 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318892 */   GIR_RootConstrainSelectedInstOperands,
     /* 318893 */   // GIR_Coverage, 8833,
     /* 318893 */   GIR_EraseRootFromParent_Done,
     /* 318894 */ // Label 6608: @318894
     /* 318894 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(318965), // Rule ID 8834 //
     /* 318899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 318905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318909 */   // MIs[0] Operand 2
     /* 318909 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318920 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 318920 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 318923 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318927 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318932 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318938 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318941 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318945 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318950 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318963 */   GIR_RootConstrainSelectedInstOperands,
     /* 318964 */   // GIR_Coverage, 8834,
     /* 318964 */   GIR_EraseRootFromParent_Done,
     /* 318965 */ // Label 6609: @318965
     /* 318965 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(319036), // Rule ID 8835 //
     /* 318970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 318976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318980 */   // MIs[0] Operand 2
     /* 318980 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 318991 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 318991 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 318994 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318998 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319003 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319021 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319034 */   GIR_RootConstrainSelectedInstOperands,
     /* 319035 */   // GIR_Coverage, 8835,
     /* 319035 */   GIR_EraseRootFromParent_Done,
     /* 319036 */ // Label 6610: @319036
     /* 319036 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(319107), // Rule ID 8836 //
     /* 319041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319051 */   // MIs[0] Operand 2
     /* 319051 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 319062 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319074 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319092 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319105 */   GIR_RootConstrainSelectedInstOperands,
     /* 319106 */   // GIR_Coverage, 8836,
     /* 319106 */   GIR_EraseRootFromParent_Done,
     /* 319107 */ // Label 6611: @319107
     /* 319107 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(319178), // Rule ID 8837 //
     /* 319112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319122 */   // MIs[0] Operand 2
     /* 319122 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 319133 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319133 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319136 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319140 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319145 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319163 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319176 */   GIR_RootConstrainSelectedInstOperands,
     /* 319177 */   // GIR_Coverage, 8837,
     /* 319177 */   GIR_EraseRootFromParent_Done,
     /* 319178 */ // Label 6612: @319178
     /* 319178 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(319249), // Rule ID 8838 //
     /* 319183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319193 */   // MIs[0] Operand 2
     /* 319193 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 319204 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319216 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319234 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319247 */   GIR_RootConstrainSelectedInstOperands,
     /* 319248 */   // GIR_Coverage, 8838,
     /* 319248 */   GIR_EraseRootFromParent_Done,
     /* 319249 */ // Label 6613: @319249
     /* 319249 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(319320), // Rule ID 8839 //
     /* 319254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319264 */   // MIs[0] Operand 2
     /* 319264 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 319275 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319275 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319278 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319282 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319287 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319305 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319318 */   GIR_RootConstrainSelectedInstOperands,
     /* 319319 */   // GIR_Coverage, 8839,
     /* 319319 */   GIR_EraseRootFromParent_Done,
     /* 319320 */ // Label 6614: @319320
     /* 319320 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(319391), // Rule ID 8840 //
     /* 319325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319335 */   // MIs[0] Operand 2
     /* 319335 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 319346 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319346 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319349 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319353 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319358 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319376 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319389 */   GIR_RootConstrainSelectedInstOperands,
     /* 319390 */   // GIR_Coverage, 8840,
     /* 319390 */   GIR_EraseRootFromParent_Done,
     /* 319391 */ // Label 6615: @319391
     /* 319391 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(319479), // Rule ID 8849 //
     /* 319396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319406 */   // MIs[0] Operand 2
     /* 319406 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 319417 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319417 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319420 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319424 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319429 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319447 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319464 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319477 */   GIR_RootConstrainSelectedInstOperands,
     /* 319478 */   // GIR_Coverage, 8849,
     /* 319478 */   GIR_EraseRootFromParent_Done,
     /* 319479 */ // Label 6616: @319479
     /* 319479 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(319567), // Rule ID 8850 //
     /* 319484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319494 */   // MIs[0] Operand 2
     /* 319494 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 319505 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319505 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319508 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319512 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319517 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319523 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319526 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319530 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319535 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319552 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319565 */   GIR_RootConstrainSelectedInstOperands,
     /* 319566 */   // GIR_Coverage, 8850,
     /* 319566 */   GIR_EraseRootFromParent_Done,
     /* 319567 */ // Label 6617: @319567
     /* 319567 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(319655), // Rule ID 8851 //
     /* 319572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319582 */   // MIs[0] Operand 2
     /* 319582 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 319593 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319593 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319596 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319600 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319605 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319611 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319614 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319618 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319623 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319640 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319653 */   GIR_RootConstrainSelectedInstOperands,
     /* 319654 */   // GIR_Coverage, 8851,
     /* 319654 */   GIR_EraseRootFromParent_Done,
     /* 319655 */ // Label 6618: @319655
     /* 319655 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(319743), // Rule ID 8852 //
     /* 319660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319670 */   // MIs[0] Operand 2
     /* 319670 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 319681 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319681 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319684 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319688 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319693 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319699 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319702 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319706 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319711 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319728 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319741 */   GIR_RootConstrainSelectedInstOperands,
     /* 319742 */   // GIR_Coverage, 8852,
     /* 319742 */   GIR_EraseRootFromParent_Done,
     /* 319743 */ // Label 6619: @319743
     /* 319743 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(319831), // Rule ID 8853 //
     /* 319748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319758 */   // MIs[0] Operand 2
     /* 319758 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 319769 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319769 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319772 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319776 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319781 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319787 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319790 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319794 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319799 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319816 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319829 */   GIR_RootConstrainSelectedInstOperands,
     /* 319830 */   // GIR_Coverage, 8853,
     /* 319830 */   GIR_EraseRootFromParent_Done,
     /* 319831 */ // Label 6620: @319831
     /* 319831 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(319919), // Rule ID 8854 //
     /* 319836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319846 */   // MIs[0] Operand 2
     /* 319846 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 319857 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319857 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319860 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319864 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319869 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319875 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319878 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319882 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319887 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319904 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319917 */   GIR_RootConstrainSelectedInstOperands,
     /* 319918 */   // GIR_Coverage, 8854,
     /* 319918 */   GIR_EraseRootFromParent_Done,
     /* 319919 */ // Label 6621: @319919
     /* 319919 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(320007), // Rule ID 8855 //
     /* 319924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319934 */   // MIs[0] Operand 2
     /* 319934 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 319945 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319945 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319948 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319952 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319957 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319963 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319966 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319970 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319975 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319992 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320005 */   GIR_RootConstrainSelectedInstOperands,
     /* 320006 */   // GIR_Coverage, 8855,
     /* 320006 */   GIR_EraseRootFromParent_Done,
     /* 320007 */ // Label 6622: @320007
     /* 320007 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(320095), // Rule ID 8856 //
     /* 320012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320022 */   // MIs[0] Operand 2
     /* 320022 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 320033 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320033 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320036 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320040 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320045 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320051 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320054 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320058 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320063 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320080 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320093 */   GIR_RootConstrainSelectedInstOperands,
     /* 320094 */   // GIR_Coverage, 8856,
     /* 320094 */   GIR_EraseRootFromParent_Done,
     /* 320095 */ // Label 6623: @320095
     /* 320095 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(320183), // Rule ID 8857 //
     /* 320100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320110 */   // MIs[0] Operand 2
     /* 320110 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 320121 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320121 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320124 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320128 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320133 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320139 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320142 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320146 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320151 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320168 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320181 */   GIR_RootConstrainSelectedInstOperands,
     /* 320182 */   // GIR_Coverage, 8857,
     /* 320182 */   GIR_EraseRootFromParent_Done,
     /* 320183 */ // Label 6624: @320183
     /* 320183 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(320271), // Rule ID 8858 //
     /* 320188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320198 */   // MIs[0] Operand 2
     /* 320198 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 320209 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320209 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320212 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320216 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320221 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320227 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320230 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320234 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320239 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320256 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320269 */   GIR_RootConstrainSelectedInstOperands,
     /* 320270 */   // GIR_Coverage, 8858,
     /* 320270 */   GIR_EraseRootFromParent_Done,
     /* 320271 */ // Label 6625: @320271
     /* 320271 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(320359), // Rule ID 8859 //
     /* 320276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320286 */   // MIs[0] Operand 2
     /* 320286 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 320297 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320297 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320300 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320304 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320309 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320315 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320318 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320322 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320327 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320344 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320357 */   GIR_RootConstrainSelectedInstOperands,
     /* 320358 */   // GIR_Coverage, 8859,
     /* 320358 */   GIR_EraseRootFromParent_Done,
     /* 320359 */ // Label 6626: @320359
     /* 320359 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(320447), // Rule ID 8860 //
     /* 320364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320374 */   // MIs[0] Operand 2
     /* 320374 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 320385 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320385 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320388 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320392 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320397 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320403 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320406 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320410 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320415 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320432 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320445 */   GIR_RootConstrainSelectedInstOperands,
     /* 320446 */   // GIR_Coverage, 8860,
     /* 320446 */   GIR_EraseRootFromParent_Done,
     /* 320447 */ // Label 6627: @320447
     /* 320447 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(320535), // Rule ID 8861 //
     /* 320452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320462 */   // MIs[0] Operand 2
     /* 320462 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 320473 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320473 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320476 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320480 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320485 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320503 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320520 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320533 */   GIR_RootConstrainSelectedInstOperands,
     /* 320534 */   // GIR_Coverage, 8861,
     /* 320534 */   GIR_EraseRootFromParent_Done,
     /* 320535 */ // Label 6628: @320535
     /* 320535 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(320623), // Rule ID 8862 //
     /* 320540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320550 */   // MIs[0] Operand 2
     /* 320550 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 320561 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320561 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320564 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320568 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320573 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320579 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320582 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320586 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320591 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320608 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320621 */   GIR_RootConstrainSelectedInstOperands,
     /* 320622 */   // GIR_Coverage, 8862,
     /* 320622 */   GIR_EraseRootFromParent_Done,
     /* 320623 */ // Label 6629: @320623
     /* 320623 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(320711), // Rule ID 8863 //
     /* 320628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320638 */   // MIs[0] Operand 2
     /* 320638 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 320649 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320649 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320652 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320656 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320661 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320667 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320670 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320674 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320679 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320696 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320709 */   GIR_RootConstrainSelectedInstOperands,
     /* 320710 */   // GIR_Coverage, 8863,
     /* 320710 */   GIR_EraseRootFromParent_Done,
     /* 320711 */ // Label 6630: @320711
     /* 320711 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(320799), // Rule ID 8864 //
     /* 320716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320726 */   // MIs[0] Operand 2
     /* 320726 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 320737 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320737 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320740 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320744 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320749 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320755 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320758 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320762 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320767 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320784 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320797 */   GIR_RootConstrainSelectedInstOperands,
     /* 320798 */   // GIR_Coverage, 8864,
     /* 320798 */   GIR_EraseRootFromParent_Done,
     /* 320799 */ // Label 6631: @320799
     /* 320799 */ GIM_Reject,
     /* 320800 */ // Label 6573: @320800
     /* 320800 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(320835), // Rule ID 8815 //
     /* 320805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 320811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320815 */   // MIs[0] Operand 2
     /* 320815 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320826 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 320826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320831 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 320833 */   GIR_RootConstrainSelectedInstOperands,
     /* 320834 */   // GIR_Coverage, 8815,
     /* 320834 */   GIR_EraseRootFromParent_Done,
     /* 320835 */ // Label 6632: @320835
     /* 320835 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(320870), // Rule ID 8816 //
     /* 320840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 320846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320850 */   // MIs[0] Operand 2
     /* 320850 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320861 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 320861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320866 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 320868 */   GIR_RootConstrainSelectedInstOperands,
     /* 320869 */   // GIR_Coverage, 8816,
     /* 320869 */   GIR_EraseRootFromParent_Done,
     /* 320870 */ // Label 6633: @320870
     /* 320870 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(320924), // Rule ID 8825 //
     /* 320875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 320881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320885 */   // MIs[0] Operand 2
     /* 320885 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320896 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 320896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320908 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320922 */   GIR_RootConstrainSelectedInstOperands,
     /* 320923 */   // GIR_Coverage, 8825,
     /* 320923 */   GIR_EraseRootFromParent_Done,
     /* 320924 */ // Label 6634: @320924
     /* 320924 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(320978), // Rule ID 8826 //
     /* 320929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 320935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320939 */   // MIs[0] Operand 2
     /* 320939 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320950 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 320950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320962 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320976 */   GIR_RootConstrainSelectedInstOperands,
     /* 320977 */   // GIR_Coverage, 8826,
     /* 320977 */   GIR_EraseRootFromParent_Done,
     /* 320978 */ // Label 6635: @320978
     /* 320978 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(321032), // Rule ID 8827 //
     /* 320983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 320989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320993 */   // MIs[0] Operand 2
     /* 320993 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321004 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321016 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321030 */   GIR_RootConstrainSelectedInstOperands,
     /* 321031 */   // GIR_Coverage, 8827,
     /* 321031 */   GIR_EraseRootFromParent_Done,
     /* 321032 */ // Label 6636: @321032
     /* 321032 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(321086), // Rule ID 8828 //
     /* 321037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321047 */   // MIs[0] Operand 2
     /* 321047 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321058 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321070 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321084 */   GIR_RootConstrainSelectedInstOperands,
     /* 321085 */   // GIR_Coverage, 8828,
     /* 321085 */   GIR_EraseRootFromParent_Done,
     /* 321086 */ // Label 6637: @321086
     /* 321086 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(321157), // Rule ID 8841 //
     /* 321091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321101 */   // MIs[0] Operand 2
     /* 321101 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321112 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321124 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321142 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321155 */   GIR_RootConstrainSelectedInstOperands,
     /* 321156 */   // GIR_Coverage, 8841,
     /* 321156 */   GIR_EraseRootFromParent_Done,
     /* 321157 */ // Label 6638: @321157
     /* 321157 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(321228), // Rule ID 8842 //
     /* 321162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321172 */   // MIs[0] Operand 2
     /* 321172 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321183 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321183 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321186 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321190 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321195 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321213 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321226 */   GIR_RootConstrainSelectedInstOperands,
     /* 321227 */   // GIR_Coverage, 8842,
     /* 321227 */   GIR_EraseRootFromParent_Done,
     /* 321228 */ // Label 6639: @321228
     /* 321228 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(321299), // Rule ID 8843 //
     /* 321233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321243 */   // MIs[0] Operand 2
     /* 321243 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321254 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321254 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321257 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321261 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321266 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321284 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321297 */   GIR_RootConstrainSelectedInstOperands,
     /* 321298 */   // GIR_Coverage, 8843,
     /* 321298 */   GIR_EraseRootFromParent_Done,
     /* 321299 */ // Label 6640: @321299
     /* 321299 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(321370), // Rule ID 8844 //
     /* 321304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321314 */   // MIs[0] Operand 2
     /* 321314 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321325 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321325 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321328 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321332 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321337 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321355 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321368 */   GIR_RootConstrainSelectedInstOperands,
     /* 321369 */   // GIR_Coverage, 8844,
     /* 321369 */   GIR_EraseRootFromParent_Done,
     /* 321370 */ // Label 6641: @321370
     /* 321370 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(321441), // Rule ID 8845 //
     /* 321375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321385 */   // MIs[0] Operand 2
     /* 321385 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 321396 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321396 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321399 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321403 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321408 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321426 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321439 */   GIR_RootConstrainSelectedInstOperands,
     /* 321440 */   // GIR_Coverage, 8845,
     /* 321440 */   GIR_EraseRootFromParent_Done,
     /* 321441 */ // Label 6642: @321441
     /* 321441 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(321512), // Rule ID 8846 //
     /* 321446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321456 */   // MIs[0] Operand 2
     /* 321456 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 321467 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321467 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321470 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321474 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321479 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321497 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321510 */   GIR_RootConstrainSelectedInstOperands,
     /* 321511 */   // GIR_Coverage, 8846,
     /* 321511 */   GIR_EraseRootFromParent_Done,
     /* 321512 */ // Label 6643: @321512
     /* 321512 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(321583), // Rule ID 8847 //
     /* 321517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321527 */   // MIs[0] Operand 2
     /* 321527 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 321538 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321538 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321541 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321545 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321550 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321581 */   GIR_RootConstrainSelectedInstOperands,
     /* 321582 */   // GIR_Coverage, 8847,
     /* 321582 */   GIR_EraseRootFromParent_Done,
     /* 321583 */ // Label 6644: @321583
     /* 321583 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(321654), // Rule ID 8848 //
     /* 321588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321598 */   // MIs[0] Operand 2
     /* 321598 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 321609 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321609 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321612 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321616 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321621 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321639 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321652 */   GIR_RootConstrainSelectedInstOperands,
     /* 321653 */   // GIR_Coverage, 8848,
     /* 321653 */   GIR_EraseRootFromParent_Done,
     /* 321654 */ // Label 6645: @321654
     /* 321654 */ GIM_Reject,
     /* 321655 */ // Label 6574: @321655
     /* 321655 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(321690), // Rule ID 8865 //
     /* 321660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 321666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321670 */   // MIs[0] Operand 2
     /* 321670 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321681 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 321681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321686 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 321688 */   GIR_RootConstrainSelectedInstOperands,
     /* 321689 */   // GIR_Coverage, 8865,
     /* 321689 */   GIR_EraseRootFromParent_Done,
     /* 321690 */ // Label 6646: @321690
     /* 321690 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(321725), // Rule ID 8866 //
     /* 321695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 321701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321705 */   // MIs[0] Operand 2
     /* 321705 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321716 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 321716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 321719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321721 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 321723 */   GIR_RootConstrainSelectedInstOperands,
     /* 321724 */   // GIR_Coverage, 8866,
     /* 321724 */   GIR_EraseRootFromParent_Done,
     /* 321725 */ // Label 6647: @321725
     /* 321725 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(321779), // Rule ID 8871 //
     /* 321730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321740 */   // MIs[0] Operand 2
     /* 321740 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321751 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 321758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321763 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321777 */   GIR_RootConstrainSelectedInstOperands,
     /* 321778 */   // GIR_Coverage, 8871,
     /* 321778 */   GIR_EraseRootFromParent_Done,
     /* 321779 */ // Label 6648: @321779
     /* 321779 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(321833), // Rule ID 8872 //
     /* 321784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321794 */   // MIs[0] Operand 2
     /* 321794 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321805 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 321812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321817 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 321826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321831 */   GIR_RootConstrainSelectedInstOperands,
     /* 321832 */   // GIR_Coverage, 8872,
     /* 321832 */   GIR_EraseRootFromParent_Done,
     /* 321833 */ // Label 6649: @321833
     /* 321833 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(321887), // Rule ID 8873 //
     /* 321838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321848 */   // MIs[0] Operand 2
     /* 321848 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321859 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 321866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321871 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321885 */   GIR_RootConstrainSelectedInstOperands,
     /* 321886 */   // GIR_Coverage, 8873,
     /* 321886 */   GIR_EraseRootFromParent_Done,
     /* 321887 */ // Label 6650: @321887
     /* 321887 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(321941), // Rule ID 8874 //
     /* 321892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321902 */   // MIs[0] Operand 2
     /* 321902 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321913 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 321920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 321934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321939 */   GIR_RootConstrainSelectedInstOperands,
     /* 321940 */   // GIR_Coverage, 8874,
     /* 321940 */   GIR_EraseRootFromParent_Done,
     /* 321941 */ // Label 6651: @321941
     /* 321941 */ GIM_Reject,
     /* 321942 */ // Label 6575: @321942
     /* 321942 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(322011),
     /* 321947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 321950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321954 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(321982), // Rule ID 8869 //
     /* 321959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321962 */     // MIs[0] Operand 2
     /* 321962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321973 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 321973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 321980 */     GIR_RootConstrainSelectedInstOperands,
     /* 321981 */     // GIR_Coverage, 8869,
     /* 321981 */     GIR_EraseRootFromParent_Done,
     /* 321982 */   // Label 6653: @321982
     /* 321982 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(322010), // Rule ID 8870 //
     /* 321987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321990 */     // MIs[0] Operand 2
     /* 321990 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 322001 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 322001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 322004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322008 */     GIR_RootConstrainSelectedInstOperands,
     /* 322009 */     // GIR_Coverage, 8870,
     /* 322009 */     GIR_EraseRootFromParent_Done,
     /* 322010 */   // Label 6654: @322010
     /* 322010 */   GIM_Reject,
     /* 322011 */ // Label 6652: @322011
     /* 322011 */ GIM_Reject,
     /* 322012 */ // Label 6576: @322012
     /* 322012 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(322047), // Rule ID 8817 //
     /* 322017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322027 */   // MIs[0] Operand 2
     /* 322027 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322038 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 322038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322043 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322045 */   GIR_RootConstrainSelectedInstOperands,
     /* 322046 */   // GIR_Coverage, 8817,
     /* 322046 */   GIR_EraseRootFromParent_Done,
     /* 322047 */ // Label 6655: @322047
     /* 322047 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(322082), // Rule ID 8818 //
     /* 322052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322062 */   // MIs[0] Operand 2
     /* 322062 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322073 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 322073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322078 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322080 */   GIR_RootConstrainSelectedInstOperands,
     /* 322081 */   // GIR_Coverage, 8818,
     /* 322081 */   GIR_EraseRootFromParent_Done,
     /* 322082 */ // Label 6656: @322082
     /* 322082 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(322136), // Rule ID 8829 //
     /* 322087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322097 */   // MIs[0] Operand 2
     /* 322097 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322108 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322120 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322134 */   GIR_RootConstrainSelectedInstOperands,
     /* 322135 */   // GIR_Coverage, 8829,
     /* 322135 */   GIR_EraseRootFromParent_Done,
     /* 322136 */ // Label 6657: @322136
     /* 322136 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(322190), // Rule ID 8830 //
     /* 322141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322151 */   // MIs[0] Operand 2
     /* 322151 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322162 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322174 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322188 */   GIR_RootConstrainSelectedInstOperands,
     /* 322189 */   // GIR_Coverage, 8830,
     /* 322189 */   GIR_EraseRootFromParent_Done,
     /* 322190 */ // Label 6658: @322190
     /* 322190 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(322244), // Rule ID 8831 //
     /* 322195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322205 */   // MIs[0] Operand 2
     /* 322205 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 322216 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322228 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322242 */   GIR_RootConstrainSelectedInstOperands,
     /* 322243 */   // GIR_Coverage, 8831,
     /* 322243 */   GIR_EraseRootFromParent_Done,
     /* 322244 */ // Label 6659: @322244
     /* 322244 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(322298), // Rule ID 8832 //
     /* 322249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322259 */   // MIs[0] Operand 2
     /* 322259 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 322270 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322282 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322296 */   GIR_RootConstrainSelectedInstOperands,
     /* 322297 */   // GIR_Coverage, 8832,
     /* 322297 */   GIR_EraseRootFromParent_Done,
     /* 322298 */ // Label 6660: @322298
     /* 322298 */ GIM_Reject,
     /* 322299 */ // Label 6577: @322299
     /* 322299 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(322368),
     /* 322304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322311 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(322339), // Rule ID 8867 //
     /* 322316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322319 */     // MIs[0] Operand 2
     /* 322319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322330 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 322330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 322333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322337 */     GIR_RootConstrainSelectedInstOperands,
     /* 322338 */     // GIR_Coverage, 8867,
     /* 322338 */     GIR_EraseRootFromParent_Done,
     /* 322339 */   // Label 6662: @322339
     /* 322339 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(322367), // Rule ID 8868 //
     /* 322344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322347 */     // MIs[0] Operand 2
     /* 322347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322358 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 322358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 322361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322365 */     GIR_RootConstrainSelectedInstOperands,
     /* 322366 */     // GIR_Coverage, 8868,
     /* 322366 */     GIR_EraseRootFromParent_Done,
     /* 322367 */   // Label 6663: @322367
     /* 322367 */   GIM_Reject,
     /* 322368 */ // Label 6661: @322368
     /* 322368 */ GIM_Reject,
     /* 322369 */ // Label 6578: @322369
     /* 322369 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(322438),
     /* 322374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322381 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(322409), // Rule ID 8819 //
     /* 322386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322389 */     // MIs[0] Operand 2
     /* 322389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322400 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 322400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322407 */     GIR_RootConstrainSelectedInstOperands,
     /* 322408 */     // GIR_Coverage, 8819,
     /* 322408 */     GIR_EraseRootFromParent_Done,
     /* 322409 */   // Label 6665: @322409
     /* 322409 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(322437), // Rule ID 8820 //
     /* 322414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322417 */     // MIs[0] Operand 2
     /* 322417 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 322428 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 322428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322435 */     GIR_RootConstrainSelectedInstOperands,
     /* 322436 */     // GIR_Coverage, 8820,
     /* 322436 */     GIR_EraseRootFromParent_Done,
     /* 322437 */   // Label 6666: @322437
     /* 322437 */   GIM_Reject,
     /* 322438 */ // Label 6664: @322438
     /* 322438 */ GIM_Reject,
     /* 322439 */ // Label 6579: @322439
     /* 322439 */ GIM_Reject,
     /* 322440 */ // Label 85: @322440
     /* 322440 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6682*/ GIMT_Encode4(349836),
     /* 322451 */ /*GILLT_s64*//*Label 6667*/ GIMT_Encode4(322535), GIMT_Encode4(0),
     /* 322459 */ /*GILLT_v2s32*//*Label 6668*/ GIMT_Encode4(323245),
     /* 322463 */ /*GILLT_v2s64*//*Label 6669*/ GIMT_Encode4(326776),
     /* 322467 */ /*GILLT_v4s16*//*Label 6670*/ GIMT_Encode4(329605),
     /* 322471 */ /*GILLT_v4s32*//*Label 6671*/ GIMT_Encode4(333245),
     /* 322475 */ /*GILLT_v8s8*//*Label 6672*/ GIMT_Encode4(335909),
     /* 322479 */ /*GILLT_v8s16*//*Label 6673*/ GIMT_Encode4(337753),
     /* 322483 */ /*GILLT_v16s8*//*Label 6674*/ GIMT_Encode4(340728), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 322495 */ /*GILLT_nxv2s16*//*Label 6675*/ GIMT_Encode4(342308),
     /* 322499 */ /*GILLT_nxv2s32*//*Label 6676*/ GIMT_Encode4(342433),
     /* 322503 */ /*GILLT_nxv2s64*//*Label 6677*/ GIMT_Encode4(342558), GIMT_Encode4(0),
     /* 322511 */ /*GILLT_nxv4s16*//*Label 6678*/ GIMT_Encode4(344472),
     /* 322515 */ /*GILLT_nxv4s32*//*Label 6679*/ GIMT_Encode4(344624), GIMT_Encode4(0),
     /* 322523 */ /*GILLT_nxv8s16*//*Label 6680*/ GIMT_Encode4(346592), GIMT_Encode4(0),
     /* 322531 */ /*GILLT_nxv16s8*//*Label 6681*/ GIMT_Encode4(348786),
     /* 322535 */ // Label 6667: @322535
     /* 322535 */ GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(323244),
     /* 322540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 322549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322553 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(322683), // Rule ID 5658 //
     /* 322558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322591 */     // MIs[2] Operand 1
     /* 322591 */     // No operand predicates
     /* 322591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 322595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322599 */     // MIs[3] Operand 1
     /* 322599 */     // No operand predicates
     /* 322599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322601 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 322601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 322604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322613 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 322616 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 322620 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 322623 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322628 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 322640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322645 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 322651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 322658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 322672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322682 */     // GIR_Coverage, 5658,
     /* 322682 */     GIR_EraseRootFromParent_Done,
     /* 322683 */   // Label 6684: @322683
     /* 322683 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(322844), // Rule ID 5659 //
     /* 322688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322721 */     // MIs[2] Operand 1
     /* 322721 */     // No operand predicates
     /* 322721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 322725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322729 */     // MIs[3] Operand 1
     /* 322729 */     // No operand predicates
     /* 322729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322731 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 322731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 322734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322743 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 322746 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322750 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 322753 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322758 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 322766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322775 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 322778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 322782 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 322785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 322802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322807 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 322813 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 322819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322826 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 322833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322843 */     // GIR_Coverage, 5659,
     /* 322843 */     GIR_EraseRootFromParent_Done,
     /* 322844 */   // Label 6685: @322844
     /* 322844 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(322974), // Rule ID 5682 //
     /* 322849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322882 */     // MIs[2] Operand 1
     /* 322882 */     // No operand predicates
     /* 322882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 322886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322890 */     // MIs[3] Operand 1
     /* 322890 */     // No operand predicates
     /* 322890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322892 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 322892 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 322895 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322899 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322904 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 322907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 322911 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 322914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 322931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 322942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 322949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322956 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 322963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322973 */     // GIR_Coverage, 5682,
     /* 322973 */     GIR_EraseRootFromParent_Done,
     /* 322974 */   // Label 6686: @322974
     /* 322974 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(323135), // Rule ID 5683 //
     /* 322979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323012 */     // MIs[2] Operand 1
     /* 323012 */     // No operand predicates
     /* 323012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 323016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323020 */     // MIs[3] Operand 1
     /* 323020 */     // No operand predicates
     /* 323020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323022 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 323022 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 323025 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323029 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323034 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 323037 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323041 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 323044 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323049 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 323057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323066 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 323069 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 323073 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 323076 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323081 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 323093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323098 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 323104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 323110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323117 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 323124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323134 */     // GIR_Coverage, 5683,
     /* 323134 */     GIR_EraseRootFromParent_Done,
     /* 323135 */   // Label 6687: @323135
     /* 323135 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(323171), // Rule ID 6575 //
     /* 323140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323158 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 323158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323170 */     // GIR_Coverage, 6575,
     /* 323170 */     GIR_EraseRootFromParent_Done,
     /* 323171 */   // Label 6688: @323171
     /* 323171 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(323207), // Rule ID 6577 //
     /* 323176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323194 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 323194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323206 */     // GIR_Coverage, 6577,
     /* 323206 */     GIR_EraseRootFromParent_Done,
     /* 323207 */   // Label 6689: @323207
     /* 323207 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(323243), // Rule ID 6579 //
     /* 323212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323230 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 323230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323233 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 323235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323242 */     // GIR_Coverage, 6579,
     /* 323242 */     GIR_EraseRootFromParent_Done,
     /* 323243 */   // Label 6690: @323243
     /* 323243 */   GIM_Reject,
     /* 323244 */ // Label 6683: @323244
     /* 323244 */ GIM_Reject,
     /* 323245 */ // Label 6668: @323245
     /* 323245 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(326775),
     /* 323250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 323259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323263 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(323372), // Rule ID 4214 //
     /* 323268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323272 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323278 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323288 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323295 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323312 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323339 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323371 */     // GIR_Coverage, 4214,
     /* 323371 */     GIR_EraseRootFromParent_Done,
     /* 323372 */   // Label 6692: @323372
     /* 323372 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(323481), // Rule ID 4215 //
     /* 323377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323381 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323404 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323421 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323480 */     // GIR_Coverage, 4215,
     /* 323480 */     GIR_EraseRootFromParent_Done,
     /* 323481 */   // Label 6693: @323481
     /* 323481 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(323590), // Rule ID 4322 //
     /* 323486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323506 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323530 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323557 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323589 */     // GIR_Coverage, 4322,
     /* 323589 */     GIR_EraseRootFromParent_Done,
     /* 323590 */   // Label 6694: @323590
     /* 323590 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(323699), // Rule ID 4323 //
     /* 323595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323615 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323622 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323639 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323666 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323698 */     // GIR_Coverage, 4323,
     /* 323698 */     GIR_EraseRootFromParent_Done,
     /* 323699 */   // Label 6695: @323699
     /* 323699 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(323804), // Rule ID 4220 //
     /* 323704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323727 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323744 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323771 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323803 */     // GIR_Coverage, 4220,
     /* 323803 */     GIR_EraseRootFromParent_Done,
     /* 323804 */   // Label 6696: @323804
     /* 323804 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(323909), // Rule ID 4222 //
     /* 323809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323825 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323832 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323849 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323876 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323908 */     // GIR_Coverage, 4222,
     /* 323908 */     GIR_EraseRootFromParent_Done,
     /* 323909 */   // Label 6697: @323909
     /* 323909 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(324014), // Rule ID 4328 //
     /* 323914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323930 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323937 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323954 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323981 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324013 */     // GIR_Coverage, 4328,
     /* 324013 */     GIR_EraseRootFromParent_Done,
     /* 324014 */   // Label 6698: @324014
     /* 324014 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(324119), // Rule ID 4330 //
     /* 324019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 324059 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 324066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324118 */     // GIR_Coverage, 4330,
     /* 324118 */     GIR_EraseRootFromParent_Done,
     /* 324119 */   // Label 6699: @324119
     /* 324119 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(324223), // Rule ID 4212 //
     /* 324124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324128 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324134 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324144 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324168 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324222 */     // GIR_Coverage, 4212,
     /* 324222 */     GIR_EraseRootFromParent_Done,
     /* 324223 */   // Label 6700: @324223
     /* 324223 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(324327), // Rule ID 4213 //
     /* 324228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324232 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324238 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324248 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324272 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324326 */     // GIR_Coverage, 4213,
     /* 324326 */     GIR_EraseRootFromParent_Done,
     /* 324327 */   // Label 6701: @324327
     /* 324327 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(324431), // Rule ID 4320 //
     /* 324332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324359 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324376 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324398 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324430 */     // GIR_Coverage, 4320,
     /* 324430 */     GIR_EraseRootFromParent_Done,
     /* 324431 */   // Label 6702: @324431
     /* 324431 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(324535), // Rule ID 4321 //
     /* 324436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324456 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324463 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324480 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324534 */     // GIR_Coverage, 4321,
     /* 324534 */     GIR_EraseRootFromParent_Done,
     /* 324535 */   // Label 6703: @324535
     /* 324535 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(324635), // Rule ID 4216 //
     /* 324540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324580 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324634 */     // GIR_Coverage, 4216,
     /* 324634 */     GIR_EraseRootFromParent_Done,
     /* 324635 */   // Label 6704: @324635
     /* 324635 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(324735), // Rule ID 4218 //
     /* 324640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324656 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324663 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324680 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324702 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324734 */     // GIR_Coverage, 4218,
     /* 324734 */     GIR_EraseRootFromParent_Done,
     /* 324735 */   // Label 6705: @324735
     /* 324735 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(324835), // Rule ID 4324 //
     /* 324740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324756 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324780 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324802 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324834 */     // GIR_Coverage, 4324,
     /* 324834 */     GIR_EraseRootFromParent_Done,
     /* 324835 */   // Label 6706: @324835
     /* 324835 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(324935), // Rule ID 4326 //
     /* 324840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324856 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324863 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324880 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324934 */     // GIR_Coverage, 4326,
     /* 324934 */     GIR_EraseRootFromParent_Done,
     /* 324935 */   // Label 6707: @324935
     /* 324935 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(325055), // Rule ID 6354 //
     /* 324940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324959 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324962 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324966 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 324973 */     // MIs[2] Rn
     /* 324973 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 324977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 324982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324988 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 324988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 324991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 324995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 325009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325024 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325037 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325054 */     // GIR_Coverage, 6354,
     /* 325054 */     GIR_EraseRootFromParent_Done,
     /* 325055 */   // Label 6708: @325055
     /* 325055 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(325175), // Rule ID 6356 //
     /* 325060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325079 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325082 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325086 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 325093 */     // MIs[2] Rn
     /* 325093 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 325097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 325102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325108 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 325108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 325111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 325129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325137 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325144 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325157 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325174 */     // GIR_Coverage, 6356,
     /* 325174 */     GIR_EraseRootFromParent_Done,
     /* 325175 */   // Label 6709: @325175
     /* 325175 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(325305), // Rule ID 5652 //
     /* 325180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325213 */     // MIs[2] Operand 1
     /* 325213 */     // No operand predicates
     /* 325213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325221 */     // MIs[3] Operand 1
     /* 325221 */     // No operand predicates
     /* 325221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325223 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325235 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325242 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325267 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325287 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325304 */     // GIR_Coverage, 5652,
     /* 325304 */     GIR_EraseRootFromParent_Done,
     /* 325305 */   // Label 6710: @325305
     /* 325305 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(325466), // Rule ID 5653 //
     /* 325310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325343 */     // MIs[2] Operand 1
     /* 325343 */     // No operand predicates
     /* 325343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325351 */     // MIs[3] Operand 1
     /* 325351 */     // No operand predicates
     /* 325351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325353 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325353 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325356 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325360 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325365 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325368 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325372 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325375 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325380 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325404 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325435 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325448 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325465 */     // GIR_Coverage, 5653,
     /* 325465 */     GIR_EraseRootFromParent_Done,
     /* 325466 */   // Label 6711: @325466
     /* 325466 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(325596), // Rule ID 5676 //
     /* 325471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325504 */     // MIs[2] Operand 1
     /* 325504 */     // No operand predicates
     /* 325504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325512 */     // MIs[3] Operand 1
     /* 325512 */     // No operand predicates
     /* 325512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325514 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325526 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325529 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325533 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325578 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325595 */     // GIR_Coverage, 5676,
     /* 325595 */     GIR_EraseRootFromParent_Done,
     /* 325596 */   // Label 6712: @325596
     /* 325596 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(325757), // Rule ID 5677 //
     /* 325601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325634 */     // MIs[2] Operand 1
     /* 325634 */     // No operand predicates
     /* 325634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325642 */     // MIs[3] Operand 1
     /* 325642 */     // No operand predicates
     /* 325642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325644 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325644 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325647 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325651 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325656 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325659 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325663 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325666 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325671 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325688 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325695 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325756 */     // GIR_Coverage, 5677,
     /* 325756 */     GIR_EraseRootFromParent_Done,
     /* 325757 */   // Label 6713: @325757
     /* 325757 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(325823), // Rule ID 5607 //
     /* 325762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325780 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 325780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 325783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325822 */     // GIR_Coverage, 5607,
     /* 325822 */     GIR_EraseRootFromParent_Done,
     /* 325823 */   // Label 6714: @325823
     /* 325823 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(325889), // Rule ID 5619 //
     /* 325828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325846 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 325846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 325849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325888 */     // GIR_Coverage, 5619,
     /* 325888 */     GIR_EraseRootFromParent_Done,
     /* 325889 */   // Label 6715: @325889
     /* 325889 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(326024), // Rule ID 5627 //
     /* 325894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 325906 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 325910 */     // MIs[1] Operand 1
     /* 325910 */     // No operand predicates
     /* 325910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 325914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325918 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 325922 */     // MIs[2] Operand 1
     /* 325922 */     // No operand predicates
     /* 325922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325924 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 325924 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 325927 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325931 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 325938 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 325941 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325945 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325950 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 325953 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325957 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325960 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325965 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325970 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 325982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325987 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 325993 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 325999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326006 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326023 */     // GIR_Coverage, 5627,
     /* 326023 */     GIR_EraseRootFromParent_Done,
     /* 326024 */   // Label 6716: @326024
     /* 326024 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(326156), // Rule ID 6362 //
     /* 326029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326041 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 326048 */     // MIs[1] Rn
     /* 326048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 326052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 326057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326065 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326069 */     // MIs[2] Operand 1
     /* 326069 */     // No operand predicates
     /* 326069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326071 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 326071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326083 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 326090 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 326110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 326121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326138 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326155 */     // GIR_Coverage, 6362,
     /* 326155 */     GIR_EraseRootFromParent_Done,
     /* 326156 */   // Label 6717: @326156
     /* 326156 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(326288), // Rule ID 6363 //
     /* 326161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 326180 */     // MIs[1] Rn
     /* 326180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 326184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 326189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326201 */     // MIs[2] Operand 1
     /* 326201 */     // No operand predicates
     /* 326201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326203 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 326203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326215 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326218 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 326222 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 326242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 326253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326257 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326270 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326287 */     // GIR_Coverage, 6363,
     /* 326287 */     GIR_EraseRootFromParent_Done,
     /* 326288 */   // Label 6718: @326288
     /* 326288 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(326471), // Rule ID 5685 //
     /* 326293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 326301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326318 */     // MIs[2] Operand 1
     /* 326318 */     // No operand predicates
     /* 326318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326320 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 326320 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 326323 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326327 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326334 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 326337 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326341 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326346 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326349 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 326353 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 326356 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326361 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326366 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326371 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326374 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326378 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326397 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326400 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 326404 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 326429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 326440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 326443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326470 */     // GIR_Coverage, 5685,
     /* 326470 */     GIR_EraseRootFromParent_Done,
     /* 326471 */   // Label 6719: @326471
     /* 326471 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(326649), // Rule ID 5630 //
     /* 326476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 326488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326496 */     // MIs[1] Operand 1
     /* 326496 */     // No operand predicates
     /* 326496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326498 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 326498 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 326501 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326505 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326512 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 326515 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326519 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326524 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326527 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326531 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 326534 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326539 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326544 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326549 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326552 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326556 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326575 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 326607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 326618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 326621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326648 */     // GIR_Coverage, 5630,
     /* 326648 */     GIR_EraseRootFromParent_Done,
     /* 326649 */   // Label 6720: @326649
     /* 326649 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(326774), // Rule ID 5633 //
     /* 326654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 326666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326674 */     // MIs[1] Operand 1
     /* 326674 */     // No operand predicates
     /* 326674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326676 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 326676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 326734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 326745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326756 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326773 */     // GIR_Coverage, 5633,
     /* 326773 */     GIR_EraseRootFromParent_Done,
     /* 326774 */   // Label 6721: @326774
     /* 326774 */   GIM_Reject,
     /* 326775 */ // Label 6691: @326775
     /* 326775 */ GIM_Reject,
     /* 326776 */ // Label 6669: @326776
     /* 326776 */ GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(329604),
     /* 326781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 326790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326794 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(326903), // Rule ID 4238 //
     /* 326799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326819 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326826 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 326843 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 326843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 326846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 326850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 326892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326902 */     // GIR_Coverage, 4238,
     /* 326902 */     GIR_EraseRootFromParent_Done,
     /* 326903 */   // Label 6723: @326903
     /* 326903 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(327012), // Rule ID 4239 //
     /* 326908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 326952 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 326952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 326955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 326959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327011 */     // GIR_Coverage, 4239,
     /* 327011 */     GIR_EraseRootFromParent_Done,
     /* 327012 */   // Label 6724: @327012
     /* 327012 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(327121), // Rule ID 4346 //
     /* 327017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327021 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327027 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327037 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327061 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327088 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327120 */     // GIR_Coverage, 4346,
     /* 327120 */     GIR_EraseRootFromParent_Done,
     /* 327121 */   // Label 6725: @327121
     /* 327121 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(327230), // Rule ID 4347 //
     /* 327126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327146 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327153 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327170 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327197 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327229 */     // GIR_Coverage, 4347,
     /* 327229 */     GIR_EraseRootFromParent_Done,
     /* 327230 */   // Label 6726: @327230
     /* 327230 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(327335), // Rule ID 4244 //
     /* 327235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327251 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327258 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327275 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327302 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327334 */     // GIR_Coverage, 4244,
     /* 327334 */     GIR_EraseRootFromParent_Done,
     /* 327335 */   // Label 6727: @327335
     /* 327335 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(327440), // Rule ID 4246 //
     /* 327340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327356 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327363 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327380 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327407 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327439 */     // GIR_Coverage, 4246,
     /* 327439 */     GIR_EraseRootFromParent_Done,
     /* 327440 */   // Label 6728: @327440
     /* 327440 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(327545), // Rule ID 4352 //
     /* 327445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327461 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327468 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327485 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327544 */     // GIR_Coverage, 4352,
     /* 327544 */     GIR_EraseRootFromParent_Done,
     /* 327545 */   // Label 6729: @327545
     /* 327545 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(327650), // Rule ID 4354 //
     /* 327550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327566 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327573 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327590 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327649 */     // GIR_Coverage, 4354,
     /* 327649 */     GIR_EraseRootFromParent_Done,
     /* 327650 */   // Label 6730: @327650
     /* 327650 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(327754), // Rule ID 4236 //
     /* 327655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327665 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327675 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327682 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 327699 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 327699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 327706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327721 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327753 */     // GIR_Coverage, 4236,
     /* 327753 */     GIR_EraseRootFromParent_Done,
     /* 327754 */   // Label 6731: @327754
     /* 327754 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(327858), // Rule ID 4237 //
     /* 327759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327763 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327769 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327779 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327786 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 327803 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 327803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 327810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327825 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327857 */     // GIR_Coverage, 4237,
     /* 327857 */     GIR_EraseRootFromParent_Done,
     /* 327858 */   // Label 6732: @327858
     /* 327858 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(327962), // Rule ID 4344 //
     /* 327863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327873 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327883 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327890 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 327907 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 327907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 327914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327929 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327961 */     // GIR_Coverage, 4344,
     /* 327961 */     GIR_EraseRootFromParent_Done,
     /* 327962 */   // Label 6733: @327962
     /* 327962 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(328066), // Rule ID 4345 //
     /* 327967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327977 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327987 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327994 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328011 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328033 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328065 */     // GIR_Coverage, 4345,
     /* 328065 */     GIR_EraseRootFromParent_Done,
     /* 328066 */   // Label 6734: @328066
     /* 328066 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(328166), // Rule ID 4240 //
     /* 328071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328087 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328111 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328165 */     // GIR_Coverage, 4240,
     /* 328165 */     GIR_EraseRootFromParent_Done,
     /* 328166 */   // Label 6735: @328166
     /* 328166 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(328266), // Rule ID 4242 //
     /* 328171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328187 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328194 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328211 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328233 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328265 */     // GIR_Coverage, 4242,
     /* 328265 */     GIR_EraseRootFromParent_Done,
     /* 328266 */   // Label 6736: @328266
     /* 328266 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(328366), // Rule ID 4348 //
     /* 328271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328287 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328294 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328311 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328333 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328365 */     // GIR_Coverage, 4348,
     /* 328365 */     GIR_EraseRootFromParent_Done,
     /* 328366 */   // Label 6737: @328366
     /* 328366 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(328466), // Rule ID 4350 //
     /* 328371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328387 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328394 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328411 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328433 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328465 */     // GIR_Coverage, 4350,
     /* 328465 */     GIR_EraseRootFromParent_Done,
     /* 328466 */   // Label 6738: @328466
     /* 328466 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(328544), // Rule ID 1934 //
     /* 328471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328511 */     // MIs[2] Operand 1
     /* 328511 */     // No operand predicates
     /* 328511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328519 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328523 */     // MIs[3] Operand 1
     /* 328523 */     // No operand predicates
     /* 328523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328525 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 328525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 328532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 328535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 328542 */     GIR_RootConstrainSelectedInstOperands,
     /* 328543 */     // GIR_Coverage, 1934,
     /* 328543 */     GIR_EraseRootFromParent_Done,
     /* 328544 */   // Label 6739: @328544
     /* 328544 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(328635), // Rule ID 7266 //
     /* 328549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 328552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 328564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328576 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 328579 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 328586 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 328589 */     // MIs[2] Rn
     /* 328589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 328593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 328598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328610 */     // MIs[3] Operand 1
     /* 328610 */     // No operand predicates
     /* 328610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328612 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15491>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 328612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 328615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 328619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 328622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 328626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 328633 */     GIR_RootConstrainSelectedInstOperands,
     /* 328634 */     // GIR_Coverage, 7266,
     /* 328634 */     GIR_EraseRootFromParent_Done,
     /* 328635 */   // Label 6740: @328635
     /* 328635 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(328702), // Rule ID 5656 //
     /* 328640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328673 */     // MIs[2] Operand 1
     /* 328673 */     // No operand predicates
     /* 328673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328681 */     // MIs[3] Operand 1
     /* 328681 */     // No operand predicates
     /* 328681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328683 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 328683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328700 */     GIR_RootConstrainSelectedInstOperands,
     /* 328701 */     // GIR_Coverage, 5656,
     /* 328701 */     GIR_EraseRootFromParent_Done,
     /* 328702 */   // Label 6741: @328702
     /* 328702 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(328800), // Rule ID 5657 //
     /* 328707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328740 */     // MIs[2] Operand 1
     /* 328740 */     // No operand predicates
     /* 328740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328748 */     // MIs[3] Operand 1
     /* 328748 */     // No operand predicates
     /* 328748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328750 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 328750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 328765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 328772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328798 */     GIR_RootConstrainSelectedInstOperands,
     /* 328799 */     // GIR_Coverage, 5657,
     /* 328799 */     GIR_EraseRootFromParent_Done,
     /* 328800 */   // Label 6742: @328800
     /* 328800 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(328867), // Rule ID 5680 //
     /* 328805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328838 */     // MIs[2] Operand 1
     /* 328838 */     // No operand predicates
     /* 328838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328846 */     // MIs[3] Operand 1
     /* 328846 */     // No operand predicates
     /* 328846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328848 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 328848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328865 */     GIR_RootConstrainSelectedInstOperands,
     /* 328866 */     // GIR_Coverage, 5680,
     /* 328866 */     GIR_EraseRootFromParent_Done,
     /* 328867 */   // Label 6743: @328867
     /* 328867 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(328965), // Rule ID 5681 //
     /* 328872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328905 */     // MIs[2] Operand 1
     /* 328905 */     // No operand predicates
     /* 328905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328913 */     // MIs[3] Operand 1
     /* 328913 */     // No operand predicates
     /* 328913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328915 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 328915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 328930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 328937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328963 */     GIR_RootConstrainSelectedInstOperands,
     /* 328964 */     // GIR_Coverage, 5681,
     /* 328964 */     GIR_EraseRootFromParent_Done,
     /* 328965 */   // Label 6744: @328965
     /* 328965 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(329031), // Rule ID 5611 //
     /* 328970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328988 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 328988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 328991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329030 */     // GIR_Coverage, 5611,
     /* 329030 */     GIR_EraseRootFromParent_Done,
     /* 329031 */   // Label 6745: @329031
     /* 329031 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(329097), // Rule ID 5621 //
     /* 329036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 329044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329054 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 329054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329096 */     // GIR_Coverage, 5621,
     /* 329096 */     GIR_EraseRootFromParent_Done,
     /* 329097 */   // Label 6746: @329097
     /* 329097 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(329175), // Rule ID 7265 //
     /* 329102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 329105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329117 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 329120 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 329127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 329130 */     // MIs[1] Rn
     /* 329130 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329151 */     // MIs[2] Operand 1
     /* 329151 */     // No operand predicates
     /* 329151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329153 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15491>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 329156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329173 */     GIR_RootConstrainSelectedInstOperands,
     /* 329174 */     // GIR_Coverage, 7265,
     /* 329174 */     GIR_EraseRootFromParent_Done,
     /* 329175 */   // Label 6747: @329175
     /* 329175 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(329244), // Rule ID 6345 //
     /* 329180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329199 */     // MIs[1] Rn
     /* 329199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329220 */     // MIs[2] Operand 1
     /* 329220 */     // No operand predicates
     /* 329220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329222 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 329225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329242 */     GIR_RootConstrainSelectedInstOperands,
     /* 329243 */     // GIR_Coverage, 6345,
     /* 329243 */     GIR_EraseRootFromParent_Done,
     /* 329244 */   // Label 6748: @329244
     /* 329244 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(329313), // Rule ID 6346 //
     /* 329249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329268 */     // MIs[1] Rn
     /* 329268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329289 */     // MIs[2] Operand 1
     /* 329289 */     // No operand predicates
     /* 329289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329291 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 329294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329311 */     GIR_RootConstrainSelectedInstOperands,
     /* 329312 */     // GIR_Coverage, 6346,
     /* 329312 */     GIR_EraseRootFromParent_Done,
     /* 329313 */   // Label 6749: @329313
     /* 329313 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(329362), // Rule ID 5628 //
     /* 329318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 329326 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 329330 */     // MIs[1] Operand 1
     /* 329330 */     // No operand predicates
     /* 329330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329338 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329342 */     // MIs[2] Operand 1
     /* 329342 */     // No operand predicates
     /* 329342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329344 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 329344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 329347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 329354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 329360 */     GIR_RootConstrainSelectedInstOperands,
     /* 329361 */     // GIR_Coverage, 5628,
     /* 329361 */     GIR_EraseRootFromParent_Done,
     /* 329362 */   // Label 6750: @329362
     /* 329362 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(329463), // Rule ID 5686 //
     /* 329367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 329375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329392 */     // MIs[2] Operand 1
     /* 329392 */     // No operand predicates
     /* 329392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329394 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 329394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 329397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 329427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 329455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329461 */     GIR_RootConstrainSelectedInstOperands,
     /* 329462 */     // GIR_Coverage, 5686,
     /* 329462 */     GIR_EraseRootFromParent_Done,
     /* 329463 */   // Label 6751: @329463
     /* 329463 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(329507), // Rule ID 1930 //
     /* 329468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329491 */     // MIs[1] Operand 1
     /* 329491 */     // No operand predicates
     /* 329491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329493 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 329493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 329496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 329503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329505 */     GIR_RootConstrainSelectedInstOperands,
     /* 329506 */     // GIR_Coverage, 1930,
     /* 329506 */     GIR_EraseRootFromParent_Done,
     /* 329507 */   // Label 6752: @329507
     /* 329507 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(329603), // Rule ID 5632 //
     /* 329512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329532 */     // MIs[1] Operand 1
     /* 329532 */     // No operand predicates
     /* 329532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329534 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 329534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 329537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329560 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 329567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329601 */     GIR_RootConstrainSelectedInstOperands,
     /* 329602 */     // GIR_Coverage, 5632,
     /* 329602 */     GIR_EraseRootFromParent_Done,
     /* 329603 */   // Label 6753: @329603
     /* 329603 */   GIM_Reject,
     /* 329604 */ // Label 6722: @329604
     /* 329604 */ GIM_Reject,
     /* 329605 */ // Label 6670: @329605
     /* 329605 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(333244),
     /* 329610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329613 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(329739), // Rule ID 4178 //
     /* 329618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329632 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329638 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329648 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329651 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329655 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 329662 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 329679 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 329679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 329682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 329686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 329728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329738 */     // GIR_Coverage, 4178,
     /* 329738 */     GIR_EraseRootFromParent_Done,
     /* 329739 */   // Label 6755: @329739
     /* 329739 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(329865), // Rule ID 4179 //
     /* 329744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329774 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329777 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329781 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 329788 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 329805 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 329805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 329808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 329812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329832 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 329854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329864 */     // GIR_Coverage, 4179,
     /* 329864 */     GIR_EraseRootFromParent_Done,
     /* 329865 */   // Label 6756: @329865
     /* 329865 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(329984), // Rule ID 4286 //
     /* 329870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 329873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329884 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329890 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329900 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329907 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 329924 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 329924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 329927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 329931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329951 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 329973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329983 */     // GIR_Coverage, 4286,
     /* 329983 */     GIR_EraseRootFromParent_Done,
     /* 329984 */   // Label 6757: @329984
     /* 329984 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(330103), // Rule ID 4287 //
     /* 329989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 329992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330003 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330009 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330019 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330022 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330026 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330043 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330070 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330102 */     // GIR_Coverage, 4287,
     /* 330102 */     GIR_EraseRootFromParent_Done,
     /* 330103 */   // Label 6758: @330103
     /* 330103 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(330225), // Rule ID 4184 //
     /* 330108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330134 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330137 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330141 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330148 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330165 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330192 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330224 */     // GIR_Coverage, 4184,
     /* 330224 */     GIR_EraseRootFromParent_Done,
     /* 330225 */   // Label 6759: @330225
     /* 330225 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(330347), // Rule ID 4186 //
     /* 330230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330256 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330259 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330263 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330270 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330287 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330346 */     // GIR_Coverage, 4186,
     /* 330346 */     GIR_EraseRootFromParent_Done,
     /* 330347 */   // Label 6760: @330347
     /* 330347 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(330462), // Rule ID 4292 //
     /* 330352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330378 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330385 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330402 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330429 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330461 */     // GIR_Coverage, 4292,
     /* 330461 */     GIR_EraseRootFromParent_Done,
     /* 330462 */   // Label 6761: @330462
     /* 330462 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(330577), // Rule ID 4294 //
     /* 330467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330493 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330500 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330517 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330544 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330576 */     // GIR_Coverage, 4294,
     /* 330576 */     GIR_EraseRootFromParent_Done,
     /* 330577 */   // Label 6762: @330577
     /* 330577 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(330698), // Rule ID 4176 //
     /* 330582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330596 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330602 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330612 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330615 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330619 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330626 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 330643 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 330643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 330650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330665 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330697 */     // GIR_Coverage, 4176,
     /* 330697 */     GIR_EraseRootFromParent_Done,
     /* 330698 */   // Label 6763: @330698
     /* 330698 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(330819), // Rule ID 4177 //
     /* 330703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330717 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330733 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330736 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330740 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330747 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 330764 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 330764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 330771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330786 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330818 */     // GIR_Coverage, 4177,
     /* 330818 */     GIR_EraseRootFromParent_Done,
     /* 330819 */   // Label 6764: @330819
     /* 330819 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(330933), // Rule ID 4284 //
     /* 330824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330838 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330844 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330854 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330861 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 330878 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 330878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 330885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330900 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330932 */     // GIR_Coverage, 4284,
     /* 330932 */     GIR_EraseRootFromParent_Done,
     /* 330933 */   // Label 6765: @330933
     /* 330933 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(331047), // Rule ID 4285 //
     /* 330938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330958 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330968 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330975 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 330992 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 330992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 330999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331014 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331046 */     // GIR_Coverage, 4285,
     /* 331046 */     GIR_EraseRootFromParent_Done,
     /* 331047 */   // Label 6766: @331047
     /* 331047 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(331164), // Rule ID 4180 //
     /* 331052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331078 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331081 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331085 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331092 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331109 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331131 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331163 */     // GIR_Coverage, 4180,
     /* 331163 */     GIR_EraseRootFromParent_Done,
     /* 331164 */   // Label 6767: @331164
     /* 331164 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(331281), // Rule ID 4182 //
     /* 331169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331195 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331198 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331202 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331209 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331226 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331248 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331280 */     // GIR_Coverage, 4182,
     /* 331280 */     GIR_EraseRootFromParent_Done,
     /* 331281 */   // Label 6768: @331281
     /* 331281 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(331391), // Rule ID 4288 //
     /* 331286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331312 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331319 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331336 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331358 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331390 */     // GIR_Coverage, 4288,
     /* 331390 */     GIR_EraseRootFromParent_Done,
     /* 331391 */   // Label 6769: @331391
     /* 331391 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(331501), // Rule ID 4290 //
     /* 331396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331422 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331429 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331446 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331468 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331500 */     // GIR_Coverage, 4290,
     /* 331500 */     GIR_EraseRootFromParent_Done,
     /* 331501 */   // Label 6770: @331501
     /* 331501 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(331631), // Rule ID 6358 //
     /* 331506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331535 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331538 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331542 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331549 */     // MIs[2] Rn
     /* 331549 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 331553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 331558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331564 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 331564 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 331567 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331571 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 331585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331593 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 331596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 331600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331613 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331630 */     // GIR_Coverage, 6358,
     /* 331630 */     GIR_EraseRootFromParent_Done,
     /* 331631 */   // Label 6771: @331631
     /* 331631 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(331771), // Rule ID 5646 //
     /* 331636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331679 */     // MIs[2] Operand 1
     /* 331679 */     // No operand predicates
     /* 331679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331687 */     // MIs[3] Operand 1
     /* 331687 */     // No operand predicates
     /* 331687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331689 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 331689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331701 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331704 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 331708 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 331711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 331728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 331739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 331746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331770 */     // GIR_Coverage, 5646,
     /* 331770 */     GIR_EraseRootFromParent_Done,
     /* 331771 */   // Label 6772: @331771
     /* 331771 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(331942), // Rule ID 5647 //
     /* 331776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331819 */     // MIs[2] Operand 1
     /* 331819 */     // No operand predicates
     /* 331819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331827 */     // MIs[3] Operand 1
     /* 331827 */     // No operand predicates
     /* 331827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331829 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 331829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 331832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331841 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 331844 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331848 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 331851 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331856 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 331880 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 331883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 331900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 331911 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 331914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 331917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331924 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331941 */     // GIR_Coverage, 5647,
     /* 331941 */     GIR_EraseRootFromParent_Done,
     /* 331942 */   // Label 6773: @331942
     /* 331942 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(332082), // Rule ID 5670 //
     /* 331947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331990 */     // MIs[2] Operand 1
     /* 331990 */     // No operand predicates
     /* 331990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331998 */     // MIs[3] Operand 1
     /* 331998 */     // No operand predicates
     /* 331998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332000 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332012 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332019 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332064 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332081 */     // GIR_Coverage, 5670,
     /* 332081 */     GIR_EraseRootFromParent_Done,
     /* 332082 */   // Label 6774: @332082
     /* 332082 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(332253), // Rule ID 5671 //
     /* 332087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332130 */     // MIs[2] Operand 1
     /* 332130 */     // No operand predicates
     /* 332130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332138 */     // MIs[3] Operand 1
     /* 332138 */     // No operand predicates
     /* 332138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332140 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 332143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332152 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 332155 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332159 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 332162 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332167 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332191 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 332225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332252 */     // GIR_Coverage, 5671,
     /* 332252 */     GIR_EraseRootFromParent_Done,
     /* 332253 */   // Label 6775: @332253
     /* 332253 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(332332), // Rule ID 5601 //
     /* 332258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332286 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 332286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 332302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 332321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332331 */     // GIR_Coverage, 5601,
     /* 332331 */     GIR_EraseRootFromParent_Done,
     /* 332332 */   // Label 6776: @332332
     /* 332332 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(332408), // Rule ID 5603 //
     /* 332337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332365 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 332365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 332368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332407 */     // GIR_Coverage, 5603,
     /* 332407 */     GIR_EraseRootFromParent_Done,
     /* 332408 */   // Label 6777: @332408
     /* 332408 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(332484), // Rule ID 5613 //
     /* 332413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332441 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 332441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 332444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332483 */     // GIR_Coverage, 5613,
     /* 332483 */     GIR_EraseRootFromParent_Done,
     /* 332484 */   // Label 6778: @332484
     /* 332484 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(332629), // Rule ID 5625 //
     /* 332489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 332511 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 332515 */     // MIs[1] Operand 1
     /* 332515 */     // No operand predicates
     /* 332515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332527 */     // MIs[2] Operand 1
     /* 332527 */     // No operand predicates
     /* 332527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332529 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332529 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 332532 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332536 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 332546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332555 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332558 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332562 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 332587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 332598 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 332604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332611 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332628 */     // GIR_Coverage, 5625,
     /* 332628 */     GIR_EraseRootFromParent_Done,
     /* 332629 */   // Label 6779: @332629
     /* 332629 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(332778), // Rule ID 6361 //
     /* 332634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332659 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 332663 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332670 */     // MIs[1] Rn
     /* 332670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332687 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332691 */     // MIs[2] Operand 1
     /* 332691 */     // No operand predicates
     /* 332691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332693 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332705 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332708 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 332712 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 332732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 332743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332747 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332760 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332777 */     // GIR_Coverage, 6361,
     /* 332777 */     GIR_EraseRootFromParent_Done,
     /* 332778 */   // Label 6780: @332778
     /* 332778 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(332920), // Rule ID 6364 //
     /* 332783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332805 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332808 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 332812 */     // MIs[1] Rn
     /* 332812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332829 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332833 */     // MIs[2] Operand 1
     /* 332833 */     // No operand predicates
     /* 332833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332835 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332847 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 332854 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 332874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 332885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332889 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332902 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332919 */     // GIR_Coverage, 6364,
     /* 332919 */     GIR_EraseRootFromParent_Done,
     /* 332920 */   // Label 6781: @332920
     /* 332920 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(333108), // Rule ID 5623 //
     /* 332925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 332947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 332955 */     // MIs[1] Operand 1
     /* 332955 */     // No operand predicates
     /* 332955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332957 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332957 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 332960 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332964 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332971 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 332974 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332978 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332983 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332986 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 332990 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 332993 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332998 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333003 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333008 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 333011 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333015 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 333025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 333066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 333080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 333083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333107 */     // GIR_Coverage, 5623,
     /* 333107 */     GIR_EraseRootFromParent_Done,
     /* 333108 */   // Label 6782: @333108
     /* 333108 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(333243), // Rule ID 5634 //
     /* 333113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 333135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 333143 */     // MIs[1] Operand 1
     /* 333143 */     // No operand predicates
     /* 333143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333145 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 333145 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 333148 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333152 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 333162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333171 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333174 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333178 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 333203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333208 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333225 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333242 */     // GIR_Coverage, 5634,
     /* 333242 */     GIR_EraseRootFromParent_Done,
     /* 333243 */   // Label 6783: @333243
     /* 333243 */   GIM_Reject,
     /* 333244 */ // Label 6754: @333244
     /* 333244 */ GIM_Reject,
     /* 333245 */ // Label 6671: @333245
     /* 333245 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(335908),
     /* 333250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333263 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(333372), // Rule ID 4202 //
     /* 333268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333272 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333278 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333288 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333295 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333312 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333339 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333371 */     // GIR_Coverage, 4202,
     /* 333371 */     GIR_EraseRootFromParent_Done,
     /* 333372 */   // Label 6785: @333372
     /* 333372 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(333481), // Rule ID 4203 //
     /* 333377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333381 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333404 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333421 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333480 */     // GIR_Coverage, 4203,
     /* 333480 */     GIR_EraseRootFromParent_Done,
     /* 333481 */   // Label 6786: @333481
     /* 333481 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(333590), // Rule ID 4310 //
     /* 333486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333506 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333530 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333557 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333589 */     // GIR_Coverage, 4310,
     /* 333589 */     GIR_EraseRootFromParent_Done,
     /* 333590 */   // Label 6787: @333590
     /* 333590 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(333699), // Rule ID 4311 //
     /* 333595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333615 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333622 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333639 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333666 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333698 */     // GIR_Coverage, 4311,
     /* 333698 */     GIR_EraseRootFromParent_Done,
     /* 333699 */   // Label 6788: @333699
     /* 333699 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(333804), // Rule ID 4208 //
     /* 333704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333727 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333744 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333771 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333803 */     // GIR_Coverage, 4208,
     /* 333803 */     GIR_EraseRootFromParent_Done,
     /* 333804 */   // Label 6789: @333804
     /* 333804 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(333909), // Rule ID 4210 //
     /* 333809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333825 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333832 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333849 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333876 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333908 */     // GIR_Coverage, 4210,
     /* 333908 */     GIR_EraseRootFromParent_Done,
     /* 333909 */   // Label 6790: @333909
     /* 333909 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(334014), // Rule ID 4316 //
     /* 333914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333930 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333937 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333954 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333981 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334013 */     // GIR_Coverage, 4316,
     /* 334013 */     GIR_EraseRootFromParent_Done,
     /* 334014 */   // Label 6791: @334014
     /* 334014 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(334119), // Rule ID 4318 //
     /* 334019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334059 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334118 */     // GIR_Coverage, 4318,
     /* 334118 */     GIR_EraseRootFromParent_Done,
     /* 334119 */   // Label 6792: @334119
     /* 334119 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(334223), // Rule ID 4200 //
     /* 334124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334128 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334134 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334144 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334168 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334222 */     // GIR_Coverage, 4200,
     /* 334222 */     GIR_EraseRootFromParent_Done,
     /* 334223 */   // Label 6793: @334223
     /* 334223 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(334327), // Rule ID 4201 //
     /* 334228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334232 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334238 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334248 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334272 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334326 */     // GIR_Coverage, 4201,
     /* 334326 */     GIR_EraseRootFromParent_Done,
     /* 334327 */   // Label 6794: @334327
     /* 334327 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(334431), // Rule ID 4308 //
     /* 334332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334359 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334376 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334398 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334430 */     // GIR_Coverage, 4308,
     /* 334430 */     GIR_EraseRootFromParent_Done,
     /* 334431 */   // Label 6795: @334431
     /* 334431 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(334535), // Rule ID 4309 //
     /* 334436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334456 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334463 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334480 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334534 */     // GIR_Coverage, 4309,
     /* 334534 */     GIR_EraseRootFromParent_Done,
     /* 334535 */   // Label 6796: @334535
     /* 334535 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(334635), // Rule ID 4204 //
     /* 334540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334580 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334634 */     // GIR_Coverage, 4204,
     /* 334634 */     GIR_EraseRootFromParent_Done,
     /* 334635 */   // Label 6797: @334635
     /* 334635 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(334735), // Rule ID 4206 //
     /* 334640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334656 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334663 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334680 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334702 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334734 */     // GIR_Coverage, 4206,
     /* 334734 */     GIR_EraseRootFromParent_Done,
     /* 334735 */   // Label 6798: @334735
     /* 334735 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(334835), // Rule ID 4312 //
     /* 334740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334756 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334780 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334802 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334834 */     // GIR_Coverage, 4312,
     /* 334834 */     GIR_EraseRootFromParent_Done,
     /* 334835 */   // Label 6799: @334835
     /* 334835 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(334935), // Rule ID 4314 //
     /* 334840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334856 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334863 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334880 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334934 */     // GIR_Coverage, 4314,
     /* 334934 */     GIR_EraseRootFromParent_Done,
     /* 334935 */   // Label 6800: @334935
     /* 334935 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(335013), // Rule ID 1933 //
     /* 334940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 334943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 334959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 334980 */     // MIs[2] Operand 1
     /* 334980 */     // No operand predicates
     /* 334980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334988 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 334992 */     // MIs[3] Operand 1
     /* 334992 */     // No operand predicates
     /* 334992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334994 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 334994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 334997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 335004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 335011 */     GIR_RootConstrainSelectedInstOperands,
     /* 335012 */     // GIR_Coverage, 1933,
     /* 335012 */     GIR_EraseRootFromParent_Done,
     /* 335013 */   // Label 6801: @335013
     /* 335013 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(335080), // Rule ID 5650 //
     /* 335018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335051 */     // MIs[2] Operand 1
     /* 335051 */     // No operand predicates
     /* 335051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335059 */     // MIs[3] Operand 1
     /* 335059 */     // No operand predicates
     /* 335059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335061 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335066 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335078 */     GIR_RootConstrainSelectedInstOperands,
     /* 335079 */     // GIR_Coverage, 5650,
     /* 335079 */     GIR_EraseRootFromParent_Done,
     /* 335080 */   // Label 6802: @335080
     /* 335080 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(335178), // Rule ID 5651 //
     /* 335085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335118 */     // MIs[2] Operand 1
     /* 335118 */     // No operand predicates
     /* 335118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335126 */     // MIs[3] Operand 1
     /* 335126 */     // No operand predicates
     /* 335126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335128 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335176 */     GIR_RootConstrainSelectedInstOperands,
     /* 335177 */     // GIR_Coverage, 5651,
     /* 335177 */     GIR_EraseRootFromParent_Done,
     /* 335178 */   // Label 6803: @335178
     /* 335178 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(335245), // Rule ID 5674 //
     /* 335183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335216 */     // MIs[2] Operand 1
     /* 335216 */     // No operand predicates
     /* 335216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335224 */     // MIs[3] Operand 1
     /* 335224 */     // No operand predicates
     /* 335224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335226 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335243 */     GIR_RootConstrainSelectedInstOperands,
     /* 335244 */     // GIR_Coverage, 5674,
     /* 335244 */     GIR_EraseRootFromParent_Done,
     /* 335245 */   // Label 6804: @335245
     /* 335245 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(335343), // Rule ID 5675 //
     /* 335250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335283 */     // MIs[2] Operand 1
     /* 335283 */     // No operand predicates
     /* 335283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335291 */     // MIs[3] Operand 1
     /* 335291 */     // No operand predicates
     /* 335291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335293 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335305 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335312 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335341 */     GIR_RootConstrainSelectedInstOperands,
     /* 335342 */     // GIR_Coverage, 5675,
     /* 335342 */     GIR_EraseRootFromParent_Done,
     /* 335343 */   // Label 6805: @335343
     /* 335343 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(335409), // Rule ID 5609 //
     /* 335348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335366 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 335366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335408 */     // GIR_Coverage, 5609,
     /* 335408 */     GIR_EraseRootFromParent_Done,
     /* 335409 */   // Label 6806: @335409
     /* 335409 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(335475), // Rule ID 5617 //
     /* 335414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335432 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 335432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335474 */     // GIR_Coverage, 5617,
     /* 335474 */     GIR_EraseRootFromParent_Done,
     /* 335475 */   // Label 6807: @335475
     /* 335475 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(335528), // Rule ID 5626 //
     /* 335480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 335492 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 335496 */     // MIs[1] Operand 1
     /* 335496 */     // No operand predicates
     /* 335496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335508 */     // MIs[2] Operand 1
     /* 335508 */     // No operand predicates
     /* 335508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335510 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 335510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 335513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 335517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 335520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 335526 */     GIR_RootConstrainSelectedInstOperands,
     /* 335527 */     // GIR_Coverage, 5626,
     /* 335527 */     GIR_EraseRootFromParent_Done,
     /* 335528 */   // Label 6808: @335528
     /* 335528 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(335597), // Rule ID 6343 //
     /* 335533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335552 */     // MIs[1] Rn
     /* 335552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 335556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335569 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335573 */     // MIs[2] Operand 1
     /* 335573 */     // No operand predicates
     /* 335573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335575 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 335575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 335578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 335585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335595 */     GIR_RootConstrainSelectedInstOperands,
     /* 335596 */     // GIR_Coverage, 6343,
     /* 335596 */     GIR_EraseRootFromParent_Done,
     /* 335597 */   // Label 6809: @335597
     /* 335597 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(335666), // Rule ID 6344 //
     /* 335602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335614 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335621 */     // MIs[1] Rn
     /* 335621 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 335625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335638 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335642 */     // MIs[2] Operand 1
     /* 335642 */     // No operand predicates
     /* 335642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335644 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 335644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 335647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 335654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335664 */     GIR_RootConstrainSelectedInstOperands,
     /* 335665 */     // GIR_Coverage, 6344,
     /* 335665 */     GIR_EraseRootFromParent_Done,
     /* 335666 */   // Label 6810: @335666
     /* 335666 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(335767), // Rule ID 5684 //
     /* 335671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 335679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 335683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335696 */     // MIs[2] Operand 1
     /* 335696 */     // No operand predicates
     /* 335696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335698 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 335698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 335731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 335734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 335759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335765 */     GIR_RootConstrainSelectedInstOperands,
     /* 335766 */     // GIR_Coverage, 5684,
     /* 335766 */     GIR_EraseRootFromParent_Done,
     /* 335767 */   // Label 6811: @335767
     /* 335767 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(335811), // Rule ID 1929 //
     /* 335772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 335787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335795 */     // MIs[1] Operand 1
     /* 335795 */     // No operand predicates
     /* 335795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335797 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 335797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 335800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 335807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335809 */     GIR_RootConstrainSelectedInstOperands,
     /* 335810 */     // GIR_Coverage, 1929,
     /* 335810 */     GIR_EraseRootFromParent_Done,
     /* 335811 */   // Label 6812: @335811
     /* 335811 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(335907), // Rule ID 5631 //
     /* 335816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 335828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335836 */     // MIs[1] Operand 1
     /* 335836 */     // No operand predicates
     /* 335836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335838 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 335838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 335841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335864 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 335871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 335874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 335896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 335899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335905 */     GIR_RootConstrainSelectedInstOperands,
     /* 335906 */     // GIR_Coverage, 5631,
     /* 335906 */     GIR_EraseRootFromParent_Done,
     /* 335907 */   // Label 6813: @335907
     /* 335907 */   GIM_Reject,
     /* 335908 */ // Label 6784: @335908
     /* 335908 */ GIM_Reject,
     /* 335909 */ // Label 6672: @335909
     /* 335909 */ GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(337752),
     /* 335914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 335917 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(336043), // Rule ID 4142 //
     /* 335922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 335925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335936 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335942 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335952 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335955 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335959 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 335966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 335983 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 335983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 335986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 335990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336042 */     // GIR_Coverage, 4142,
     /* 336042 */     GIR_EraseRootFromParent_Done,
     /* 336043 */   // Label 6815: @336043
     /* 336043 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(336169), // Rule ID 4143 //
     /* 336048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336062 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336068 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336078 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336081 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336085 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336092 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336109 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336136 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336168 */     // GIR_Coverage, 4143,
     /* 336168 */     GIR_EraseRootFromParent_Done,
     /* 336169 */   // Label 6816: @336169
     /* 336169 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(336291), // Rule ID 4148 //
     /* 336174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336200 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336203 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336207 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336214 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 336231 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336258 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336290 */     // GIR_Coverage, 4148,
     /* 336290 */     GIR_EraseRootFromParent_Done,
     /* 336291 */   // Label 6817: @336291
     /* 336291 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(336413), // Rule ID 4150 //
     /* 336296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336322 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336325 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336329 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336336 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336353 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336380 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336412 */     // GIR_Coverage, 4150,
     /* 336412 */     GIR_EraseRootFromParent_Done,
     /* 336413 */   // Label 6818: @336413
     /* 336413 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(336534), // Rule ID 4140 //
     /* 336418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336432 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336438 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336448 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336451 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336455 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336462 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336479 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 336479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336533 */     // GIR_Coverage, 4140,
     /* 336533 */     GIR_EraseRootFromParent_Done,
     /* 336534 */   // Label 6819: @336534
     /* 336534 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(336655), // Rule ID 4141 //
     /* 336539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336553 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336559 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336569 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336572 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336576 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336583 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 336600 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 336600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 336607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336622 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336654 */     // GIR_Coverage, 4141,
     /* 336654 */     GIR_EraseRootFromParent_Done,
     /* 336655 */   // Label 6820: @336655
     /* 336655 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(336772), // Rule ID 4144 //
     /* 336660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336686 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336689 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336693 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336700 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336717 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 336717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336739 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336771 */     // GIR_Coverage, 4144,
     /* 336771 */     GIR_EraseRootFromParent_Done,
     /* 336772 */   // Label 6821: @336772
     /* 336772 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(336889), // Rule ID 4146 //
     /* 336777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336806 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 336834 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 336834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 336841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336856 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336888 */     // GIR_Coverage, 4146,
     /* 336888 */     GIR_EraseRootFromParent_Done,
     /* 336889 */   // Label 6822: @336889
     /* 336889 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(337029), // Rule ID 5664 //
     /* 336894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 336920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336937 */     // MIs[2] Operand 1
     /* 336937 */     // No operand predicates
     /* 336937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336945 */     // MIs[3] Operand 1
     /* 336945 */     // No operand predicates
     /* 336945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336947 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336966 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 336986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337028 */     // GIR_Coverage, 5664,
     /* 337028 */     GIR_EraseRootFromParent_Done,
     /* 337029 */   // Label 6823: @337029
     /* 337029 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(337200), // Rule ID 5665 //
     /* 337034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 337060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337077 */     // MIs[2] Operand 1
     /* 337077 */     // No operand predicates
     /* 337077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337085 */     // MIs[3] Operand 1
     /* 337085 */     // No operand predicates
     /* 337085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337087 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337087 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337090 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337094 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337099 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337102 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337106 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 337109 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337114 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337131 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337138 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337169 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337182 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337199 */     // GIR_Coverage, 5665,
     /* 337199 */     GIR_EraseRootFromParent_Done,
     /* 337200 */   // Label 6824: @337200
     /* 337200 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(337279), // Rule ID 5596 //
     /* 337205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337233 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 337233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 337249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337278 */     // GIR_Coverage, 5596,
     /* 337278 */     GIR_EraseRootFromParent_Done,
     /* 337279 */   // Label 6825: @337279
     /* 337279 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(337428), // Rule ID 6360 //
     /* 337284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337309 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337313 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337320 */     // MIs[1] Rn
     /* 337320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337337 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337341 */     // MIs[2] Operand 1
     /* 337341 */     // No operand predicates
     /* 337341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337343 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337355 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337358 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337362 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 337382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337397 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337410 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337427 */     // GIR_Coverage, 6360,
     /* 337427 */     GIR_EraseRootFromParent_Done,
     /* 337428 */   // Label 6826: @337428
     /* 337428 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(337563), // Rule ID 5635 //
     /* 337433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337463 */     // MIs[1] Operand 1
     /* 337463 */     // No operand predicates
     /* 337463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337465 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 337465 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 337468 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337472 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 337482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337491 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337498 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337501 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 337523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337545 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337562 */     // GIR_Coverage, 5635,
     /* 337562 */     GIR_EraseRootFromParent_Done,
     /* 337563 */   // Label 6827: @337563
     /* 337563 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(337751), // Rule ID 5636 //
     /* 337568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 337571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337598 */     // MIs[1] Operand 1
     /* 337598 */     // No operand predicates
     /* 337598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337600 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337600 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 337603 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337607 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337614 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 337617 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337621 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337626 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337629 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337633 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 337636 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337641 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337646 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 337654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 337668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337677 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337680 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337684 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337714 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337750 */     // GIR_Coverage, 5636,
     /* 337750 */     GIR_EraseRootFromParent_Done,
     /* 337751 */   // Label 6828: @337751
     /* 337751 */   GIM_Reject,
     /* 337752 */ // Label 6814: @337752
     /* 337752 */ GIM_Reject,
     /* 337753 */ // Label 6673: @337753
     /* 337753 */ GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(340727),
     /* 337758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337761 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(337887), // Rule ID 4166 //
     /* 337766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337796 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337799 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337803 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337810 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337827 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337854 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337886 */     // GIR_Coverage, 4166,
     /* 337886 */     GIR_EraseRootFromParent_Done,
     /* 337887 */   // Label 6830: @337887
     /* 337887 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(338013), // Rule ID 4167 //
     /* 337892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337906 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337912 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337922 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337925 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337929 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337953 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337980 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338012 */     // GIR_Coverage, 4167,
     /* 338012 */     GIR_EraseRootFromParent_Done,
     /* 338013 */   // Label 6831: @338013
     /* 338013 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(338132), // Rule ID 4274 //
     /* 338018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338032 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338038 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338072 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338131 */     // GIR_Coverage, 4274,
     /* 338131 */     GIR_EraseRootFromParent_Done,
     /* 338132 */   // Label 6832: @338132
     /* 338132 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(338251), // Rule ID 4275 //
     /* 338137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338157 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338167 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338174 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338191 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338250 */     // GIR_Coverage, 4275,
     /* 338250 */     GIR_EraseRootFromParent_Done,
     /* 338251 */   // Label 6833: @338251
     /* 338251 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(338373), // Rule ID 4172 //
     /* 338256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338282 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338285 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338289 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338296 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338313 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338340 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338372 */     // GIR_Coverage, 4172,
     /* 338372 */     GIR_EraseRootFromParent_Done,
     /* 338373 */   // Label 6834: @338373
     /* 338373 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(338495), // Rule ID 4174 //
     /* 338378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338404 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338407 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338411 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338418 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338435 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338494 */     // GIR_Coverage, 4174,
     /* 338494 */     GIR_EraseRootFromParent_Done,
     /* 338495 */   // Label 6835: @338495
     /* 338495 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(338610), // Rule ID 4280 //
     /* 338500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338526 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338533 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338550 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338609 */     // GIR_Coverage, 4280,
     /* 338609 */     GIR_EraseRootFromParent_Done,
     /* 338610 */   // Label 6836: @338610
     /* 338610 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(338725), // Rule ID 4282 //
     /* 338615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338648 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338665 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338692 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338724 */     // GIR_Coverage, 4282,
     /* 338724 */     GIR_EraseRootFromParent_Done,
     /* 338725 */   // Label 6837: @338725
     /* 338725 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(338846), // Rule ID 4164 //
     /* 338730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338760 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338763 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338767 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338774 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338791 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 338791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338813 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338845 */     // GIR_Coverage, 4164,
     /* 338845 */     GIR_EraseRootFromParent_Done,
     /* 338846 */   // Label 6838: @338846
     /* 338846 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(338967), // Rule ID 4165 //
     /* 338851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338865 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338871 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338881 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338884 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338888 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338895 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338912 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 338912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338966 */     // GIR_Coverage, 4165,
     /* 338966 */     GIR_EraseRootFromParent_Done,
     /* 338967 */   // Label 6839: @338967
     /* 338967 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(339081), // Rule ID 4272 //
     /* 338972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338986 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338992 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339002 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339009 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339026 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339048 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339080 */     // GIR_Coverage, 4272,
     /* 339080 */     GIR_EraseRootFromParent_Done,
     /* 339081 */   // Label 6840: @339081
     /* 339081 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(339195), // Rule ID 4273 //
     /* 339086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339100 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339106 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339116 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339123 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339140 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339162 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339194 */     // GIR_Coverage, 4273,
     /* 339194 */     GIR_EraseRootFromParent_Done,
     /* 339195 */   // Label 6841: @339195
     /* 339195 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(339312), // Rule ID 4168 //
     /* 339200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339226 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339229 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339233 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339240 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339257 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339279 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339311 */     // GIR_Coverage, 4168,
     /* 339311 */     GIR_EraseRootFromParent_Done,
     /* 339312 */   // Label 6842: @339312
     /* 339312 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(339429), // Rule ID 4170 //
     /* 339317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339343 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339346 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339350 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339357 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339374 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339396 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339428 */     // GIR_Coverage, 4170,
     /* 339428 */     GIR_EraseRootFromParent_Done,
     /* 339429 */   // Label 6843: @339429
     /* 339429 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(339539), // Rule ID 4276 //
     /* 339434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339460 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339467 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339484 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339506 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339538 */     // GIR_Coverage, 4276,
     /* 339538 */     GIR_EraseRootFromParent_Done,
     /* 339539 */   // Label 6844: @339539
     /* 339539 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(339649), // Rule ID 4278 //
     /* 339544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339570 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339577 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339594 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339648 */     // GIR_Coverage, 4278,
     /* 339648 */     GIR_EraseRootFromParent_Done,
     /* 339649 */   // Label 6845: @339649
     /* 339649 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(339737), // Rule ID 1932 //
     /* 339654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339704 */     // MIs[2] Operand 1
     /* 339704 */     // No operand predicates
     /* 339704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339712 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339716 */     // MIs[3] Operand 1
     /* 339716 */     // No operand predicates
     /* 339716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339718 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 339718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 339735 */     GIR_RootConstrainSelectedInstOperands,
     /* 339736 */     // GIR_Coverage, 1932,
     /* 339736 */     GIR_EraseRootFromParent_Done,
     /* 339737 */   // Label 6846: @339737
     /* 339737 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(339814), // Rule ID 5644 //
     /* 339742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339785 */     // MIs[2] Operand 1
     /* 339785 */     // No operand predicates
     /* 339785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339793 */     // MIs[3] Operand 1
     /* 339793 */     // No operand predicates
     /* 339793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339795 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339812 */     GIR_RootConstrainSelectedInstOperands,
     /* 339813 */     // GIR_Coverage, 5644,
     /* 339813 */     GIR_EraseRootFromParent_Done,
     /* 339814 */   // Label 6847: @339814
     /* 339814 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(339922), // Rule ID 5645 //
     /* 339819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339862 */     // MIs[2] Operand 1
     /* 339862 */     // No operand predicates
     /* 339862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339870 */     // MIs[3] Operand 1
     /* 339870 */     // No operand predicates
     /* 339870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339872 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 339894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339920 */     GIR_RootConstrainSelectedInstOperands,
     /* 339921 */     // GIR_Coverage, 5645,
     /* 339921 */     GIR_EraseRootFromParent_Done,
     /* 339922 */   // Label 6848: @339922
     /* 339922 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(339999), // Rule ID 5668 //
     /* 339927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339970 */     // MIs[2] Operand 1
     /* 339970 */     // No operand predicates
     /* 339970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339978 */     // MIs[3] Operand 1
     /* 339978 */     // No operand predicates
     /* 339978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339980 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339997 */     GIR_RootConstrainSelectedInstOperands,
     /* 339998 */     // GIR_Coverage, 5668,
     /* 339998 */     GIR_EraseRootFromParent_Done,
     /* 339999 */   // Label 6849: @339999
     /* 339999 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(340107), // Rule ID 5669 //
     /* 340004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340047 */     // MIs[2] Operand 1
     /* 340047 */     // No operand predicates
     /* 340047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340055 */     // MIs[3] Operand 1
     /* 340055 */     // No operand predicates
     /* 340055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340057 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340094 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340105 */     GIR_RootConstrainSelectedInstOperands,
     /* 340106 */     // GIR_Coverage, 5669,
     /* 340106 */     GIR_EraseRootFromParent_Done,
     /* 340107 */   // Label 6850: @340107
     /* 340107 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(340186), // Rule ID 5599 //
     /* 340112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340140 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 340140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 340156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340185 */     // GIR_Coverage, 5599,
     /* 340185 */     GIR_EraseRootFromParent_Done,
     /* 340186 */   // Label 6851: @340186
     /* 340186 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(340262), // Rule ID 5605 //
     /* 340191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340219 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 340219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340261 */     // GIR_Coverage, 5605,
     /* 340261 */     GIR_EraseRootFromParent_Done,
     /* 340262 */   // Label 6852: @340262
     /* 340262 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(340338), // Rule ID 5615 //
     /* 340267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340295 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 340295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340337 */     // GIR_Coverage, 5615,
     /* 340337 */     GIR_EraseRootFromParent_Done,
     /* 340338 */   // Label 6853: @340338
     /* 340338 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(340401), // Rule ID 5624 //
     /* 340343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340365 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340369 */     // MIs[1] Operand 1
     /* 340369 */     // No operand predicates
     /* 340369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340381 */     // MIs[2] Operand 1
     /* 340381 */     // No operand predicates
     /* 340381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340383 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 340383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 340386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340399 */     GIR_RootConstrainSelectedInstOperands,
     /* 340400 */     // GIR_Coverage, 5624,
     /* 340400 */     GIR_EraseRootFromParent_Done,
     /* 340401 */   // Label 6854: @340401
     /* 340401 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(340487), // Rule ID 6342 //
     /* 340406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340431 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340435 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340442 */     // MIs[1] Rn
     /* 340442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340463 */     // MIs[2] Operand 1
     /* 340463 */     // No operand predicates
     /* 340463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340465 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340485 */     GIR_RootConstrainSelectedInstOperands,
     /* 340486 */     // GIR_Coverage, 6342,
     /* 340486 */     GIR_EraseRootFromParent_Done,
     /* 340487 */   // Label 6855: @340487
     /* 340487 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(340566), // Rule ID 6347 //
     /* 340492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340521 */     // MIs[1] Rn
     /* 340521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340542 */     // MIs[2] Operand 1
     /* 340542 */     // No operand predicates
     /* 340542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340544 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340564 */     GIR_RootConstrainSelectedInstOperands,
     /* 340565 */     // GIR_Coverage, 6347,
     /* 340565 */     GIR_EraseRootFromParent_Done,
     /* 340566 */   // Label 6856: @340566
     /* 340566 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(340620), // Rule ID 1928 //
     /* 340571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340604 */     // MIs[1] Operand 1
     /* 340604 */     // No operand predicates
     /* 340604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340606 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 340606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 340609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 340616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340618 */     GIR_RootConstrainSelectedInstOperands,
     /* 340619 */     // GIR_Coverage, 1928,
     /* 340619 */     GIR_EraseRootFromParent_Done,
     /* 340620 */   // Label 6857: @340620
     /* 340620 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(340726), // Rule ID 5629 //
     /* 340625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340655 */     // MIs[1] Operand 1
     /* 340655 */     // No operand predicates
     /* 340655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340657 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 340660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340690 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 340718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340724 */     GIR_RootConstrainSelectedInstOperands,
     /* 340725 */     // GIR_Coverage, 5629,
     /* 340725 */     GIR_EraseRootFromParent_Done,
     /* 340726 */   // Label 6858: @340726
     /* 340726 */   GIM_Reject,
     /* 340727 */ // Label 6829: @340727
     /* 340727 */ GIM_Reject,
     /* 340728 */ // Label 6674: @340728
     /* 340728 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(342307),
     /* 340733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 340736 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(340862), // Rule ID 4130 //
     /* 340741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340771 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340774 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340778 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340785 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 340802 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 340802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 340805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 340809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340829 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 340851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340861 */     // GIR_Coverage, 4130,
     /* 340861 */     GIR_EraseRootFromParent_Done,
     /* 340862 */   // Label 6860: @340862
     /* 340862 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(340988), // Rule ID 4131 //
     /* 340867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340900 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340904 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340911 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 340928 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 340928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 340931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 340935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 340977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340987 */     // GIR_Coverage, 4131,
     /* 340987 */     GIR_EraseRootFromParent_Done,
     /* 340988 */   // Label 6861: @340988
     /* 340988 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(341110), // Rule ID 4136 //
     /* 340993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341019 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341022 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341026 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341033 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 341050 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 341057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341077 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341109 */     // GIR_Coverage, 4136,
     /* 341109 */     GIR_EraseRootFromParent_Done,
     /* 341110 */   // Label 6862: @341110
     /* 341110 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(341232), // Rule ID 4138 //
     /* 341115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341144 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341148 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 341172 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 341179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341199 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341231 */     // GIR_Coverage, 4138,
     /* 341231 */     GIR_EraseRootFromParent_Done,
     /* 341232 */   // Label 6863: @341232
     /* 341232 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(341353), // Rule ID 4128 //
     /* 341237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341251 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341257 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341267 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341270 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341274 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341281 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341298 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 341298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341352 */     // GIR_Coverage, 4128,
     /* 341352 */     GIR_EraseRootFromParent_Done,
     /* 341353 */   // Label 6864: @341353
     /* 341353 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(341474), // Rule ID 4129 //
     /* 341358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341378 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341388 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341391 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341395 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 341419 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 341419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 341426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341473 */     // GIR_Coverage, 4129,
     /* 341473 */     GIR_EraseRootFromParent_Done,
     /* 341474 */   // Label 6865: @341474
     /* 341474 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(341591), // Rule ID 4132 //
     /* 341479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341508 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341512 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341519 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341536 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 341536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341558 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341590 */     // GIR_Coverage, 4132,
     /* 341590 */     GIR_EraseRootFromParent_Done,
     /* 341591 */   // Label 6866: @341591
     /* 341591 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(341708), // Rule ID 4134 //
     /* 341596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341622 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341625 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341629 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341636 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 341653 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 341653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 341660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341675 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341707 */     // GIR_Coverage, 4134,
     /* 341707 */     GIR_EraseRootFromParent_Done,
     /* 341708 */   // Label 6867: @341708
     /* 341708 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(341796), // Rule ID 1931 //
     /* 341713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 341742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 341763 */     // MIs[2] Operand 1
     /* 341763 */     // No operand predicates
     /* 341763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341771 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 341775 */     // MIs[3] Operand 1
     /* 341775 */     // No operand predicates
     /* 341775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341777 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 341777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 341780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 341784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 341787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 341794 */     GIR_RootConstrainSelectedInstOperands,
     /* 341795 */     // GIR_Coverage, 1931,
     /* 341795 */     GIR_EraseRootFromParent_Done,
     /* 341796 */   // Label 6868: @341796
     /* 341796 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(341873), // Rule ID 5662 //
     /* 341801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 341827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341844 */     // MIs[2] Operand 1
     /* 341844 */     // No operand predicates
     /* 341844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341852 */     // MIs[3] Operand 1
     /* 341852 */     // No operand predicates
     /* 341852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341854 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 341854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 341857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341871 */     GIR_RootConstrainSelectedInstOperands,
     /* 341872 */     // GIR_Coverage, 5662,
     /* 341872 */     GIR_EraseRootFromParent_Done,
     /* 341873 */   // Label 6869: @341873
     /* 341873 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(341981), // Rule ID 5663 //
     /* 341878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 341904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341921 */     // MIs[2] Operand 1
     /* 341921 */     // No operand predicates
     /* 341921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341929 */     // MIs[3] Operand 1
     /* 341929 */     // No operand predicates
     /* 341929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341931 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 341931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 341934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 341946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 341953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 341966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341979 */     GIR_RootConstrainSelectedInstOperands,
     /* 341980 */     // GIR_Coverage, 5663,
     /* 341980 */     GIR_EraseRootFromParent_Done,
     /* 341981 */   // Label 6870: @341981
     /* 341981 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(342060), // Rule ID 5594 //
     /* 341986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342014 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 342014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 342017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 342030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 342049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342059 */     // GIR_Coverage, 5594,
     /* 342059 */     GIR_EraseRootFromParent_Done,
     /* 342060 */   // Label 6871: @342060
     /* 342060 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(342146), // Rule ID 6341 //
     /* 342065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342090 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342094 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342101 */     // MIs[1] Rn
     /* 342101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342122 */     // MIs[2] Operand 1
     /* 342122 */     // No operand predicates
     /* 342122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342124 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 342127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342144 */     GIR_RootConstrainSelectedInstOperands,
     /* 342145 */     // GIR_Coverage, 6341,
     /* 342145 */     GIR_EraseRootFromParent_Done,
     /* 342146 */   // Label 6872: @342146
     /* 342146 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(342200), // Rule ID 1927 //
     /* 342151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342184 */     // MIs[1] Operand 1
     /* 342184 */     // No operand predicates
     /* 342184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342186 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 342186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 342189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 342196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342198 */     GIR_RootConstrainSelectedInstOperands,
     /* 342199 */     // GIR_Coverage, 1927,
     /* 342199 */     GIR_EraseRootFromParent_Done,
     /* 342200 */   // Label 6873: @342200
     /* 342200 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(342306), // Rule ID 5637 //
     /* 342205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 342208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342235 */     // MIs[1] Operand 1
     /* 342235 */     // No operand predicates
     /* 342235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342237 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 342240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 342254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 342270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 342273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 342291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 342298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342304 */     GIR_RootConstrainSelectedInstOperands,
     /* 342305 */     // GIR_Coverage, 5637,
     /* 342305 */     GIR_EraseRootFromParent_Done,
     /* 342306 */   // Label 6874: @342306
     /* 342306 */   GIM_Reject,
     /* 342307 */ // Label 6859: @342307
     /* 342307 */ GIM_Reject,
     /* 342308 */ // Label 6675: @342308
     /* 342308 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(342432), // Rule ID 10994 //
     /* 342313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 342316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 342319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342337 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 342337 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 342340 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 342344 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342349 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 342353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 342355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 342358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 342362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342367 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342370 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 342373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 342375 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 342378 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 342382 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342387 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 342390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 342395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 342399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342404 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342407 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342410 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 342413 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 342416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 342421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 342423 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 342425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342428 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 342430 */   GIR_RootConstrainSelectedInstOperands,
     /* 342431 */   // GIR_Coverage, 10994,
     /* 342431 */   GIR_EraseRootFromParent_Done,
     /* 342432 */ // Label 6875: @342432
     /* 342432 */ GIM_Reject,
     /* 342433 */ // Label 6676: @342433
     /* 342433 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(342557), // Rule ID 10997 //
     /* 342438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 342441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 342444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342462 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 342462 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 342465 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 342469 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342474 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 342478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 342480 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 342483 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 342487 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342492 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342495 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 342498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 342500 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 342503 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 342507 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342512 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 342515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 342520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 342524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342529 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342532 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342535 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 342538 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 342541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 342546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 342548 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 342550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342553 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 342555 */   GIR_RootConstrainSelectedInstOperands,
     /* 342556 */   // GIR_Coverage, 10997,
     /* 342556 */   GIR_EraseRootFromParent_Done,
     /* 342557 */ // Label 6876: @342557
     /* 342557 */ GIM_Reject,
     /* 342558 */ // Label 6677: @342558
     /* 342558 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(344471),
     /* 342563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 342566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342576 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(342685), // Rule ID 4262 //
     /* 342581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342585 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342591 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342601 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342608 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 342625 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 342632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342652 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342684 */     // GIR_Coverage, 4262,
     /* 342684 */     GIR_EraseRootFromParent_Done,
     /* 342685 */   // Label 6878: @342685
     /* 342685 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(342794), // Rule ID 4263 //
     /* 342690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342694 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342700 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342710 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342717 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 342734 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 342741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342761 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342793 */     // GIR_Coverage, 4263,
     /* 342793 */     GIR_EraseRootFromParent_Done,
     /* 342794 */   // Label 6879: @342794
     /* 342794 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(342903), // Rule ID 4370 //
     /* 342799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342819 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342826 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 342843 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 342850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342902 */     // GIR_Coverage, 4370,
     /* 342902 */     GIR_EraseRootFromParent_Done,
     /* 342903 */   // Label 6880: @342903
     /* 342903 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(343012), // Rule ID 4371 //
     /* 342908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 342952 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 342959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343011 */     // GIR_Coverage, 4371,
     /* 343011 */     GIR_EraseRootFromParent_Done,
     /* 343012 */   // Label 6881: @343012
     /* 343012 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(343117), // Rule ID 4268 //
     /* 343017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343040 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343057 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343084 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343116 */     // GIR_Coverage, 4268,
     /* 343116 */     GIR_EraseRootFromParent_Done,
     /* 343117 */   // Label 6882: @343117
     /* 343117 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(343222), // Rule ID 4270 //
     /* 343122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343138 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343145 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343162 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343221 */     // GIR_Coverage, 4270,
     /* 343221 */     GIR_EraseRootFromParent_Done,
     /* 343222 */   // Label 6883: @343222
     /* 343222 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(343327), // Rule ID 4376 //
     /* 343227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343243 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343250 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343267 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343326 */     // GIR_Coverage, 4376,
     /* 343326 */     GIR_EraseRootFromParent_Done,
     /* 343327 */   // Label 6884: @343327
     /* 343327 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(343432), // Rule ID 4378 //
     /* 343332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343348 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343355 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343372 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343399 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343431 */     // GIR_Coverage, 4378,
     /* 343431 */     GIR_EraseRootFromParent_Done,
     /* 343432 */   // Label 6885: @343432
     /* 343432 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(343536), // Rule ID 4260 //
     /* 343437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343441 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343447 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343457 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343464 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343481 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343503 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343535 */     // GIR_Coverage, 4260,
     /* 343535 */     GIR_EraseRootFromParent_Done,
     /* 343536 */   // Label 6886: @343536
     /* 343536 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(343640), // Rule ID 4261 //
     /* 343541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343545 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343551 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343561 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343568 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 343585 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 343585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 343592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343607 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343639 */     // GIR_Coverage, 4261,
     /* 343639 */     GIR_EraseRootFromParent_Done,
     /* 343640 */   // Label 6887: @343640
     /* 343640 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(343744), // Rule ID 4368 //
     /* 343645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343649 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343655 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343665 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343672 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343689 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343743 */     // GIR_Coverage, 4368,
     /* 343743 */     GIR_EraseRootFromParent_Done,
     /* 343744 */   // Label 6888: @343744
     /* 343744 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(343848), // Rule ID 4369 //
     /* 343749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343759 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343769 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 343793 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 343793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 343800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343847 */     // GIR_Coverage, 4369,
     /* 343847 */     GIR_EraseRootFromParent_Done,
     /* 343848 */   // Label 6889: @343848
     /* 343848 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(343948), // Rule ID 4264 //
     /* 343853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343869 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343893 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343947 */     // GIR_Coverage, 4264,
     /* 343947 */     GIR_EraseRootFromParent_Done,
     /* 343948 */   // Label 6890: @343948
     /* 343948 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(344048), // Rule ID 4266 //
     /* 343953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343969 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343976 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 343993 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 343993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344015 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344047 */     // GIR_Coverage, 4266,
     /* 344047 */     GIR_EraseRootFromParent_Done,
     /* 344048 */   // Label 6891: @344048
     /* 344048 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(344148), // Rule ID 4372 //
     /* 344053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344069 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344076 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 344093 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 344093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 344100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344115 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344147 */     // GIR_Coverage, 4372,
     /* 344147 */     GIR_EraseRootFromParent_Done,
     /* 344148 */   // Label 6892: @344148
     /* 344148 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(344248), // Rule ID 4374 //
     /* 344153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344169 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344176 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344193 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344247 */     // GIR_Coverage, 4374,
     /* 344247 */     GIR_EraseRootFromParent_Done,
     /* 344248 */   // Label 6893: @344248
     /* 344248 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(344359), // Rule ID 10993 //
     /* 344253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344264 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 344264 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344267 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 344271 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344276 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 344280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 344289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344294 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344297 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 344309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344314 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 344326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344331 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344337 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344340 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 344348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344350 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344357 */     GIR_RootConstrainSelectedInstOperands,
     /* 344358 */     // GIR_Coverage, 10993,
     /* 344358 */     GIR_EraseRootFromParent_Done,
     /* 344359 */   // Label 6894: @344359
     /* 344359 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(344470), // Rule ID 10999 //
     /* 344364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344375 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 344375 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344378 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 344382 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344387 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 344391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344396 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 344400 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344405 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344408 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344413 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344416 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 344420 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344425 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 344437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344451 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 344459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344461 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344468 */     GIR_RootConstrainSelectedInstOperands,
     /* 344469 */     // GIR_Coverage, 10999,
     /* 344469 */     GIR_EraseRootFromParent_Done,
     /* 344470 */   // Label 6895: @344470
     /* 344470 */   GIM_Reject,
     /* 344471 */ // Label 6877: @344471
     /* 344471 */ GIM_Reject,
     /* 344472 */ // Label 6678: @344472
     /* 344472 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(344623), // Rule ID 10995 //
     /* 344477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 344483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344497 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344501 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 344501 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 344504 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344508 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344513 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 344519 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344524 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344529 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344532 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 344536 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344541 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344546 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344549 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 344553 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344558 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344561 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344566 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344569 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 344573 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344578 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 344590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344598 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344604 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 344612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344614 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344619 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344621 */   GIR_RootConstrainSelectedInstOperands,
     /* 344622 */   // GIR_Coverage, 10995,
     /* 344622 */   GIR_EraseRootFromParent_Done,
     /* 344623 */ // Label 6896: @344623
     /* 344623 */ GIM_Reject,
     /* 344624 */ // Label 6679: @344624
     /* 344624 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(346591),
     /* 344629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 344632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344642 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(344751), // Rule ID 4226 //
     /* 344647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344667 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344674 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344691 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344718 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344750 */     // GIR_Coverage, 4226,
     /* 344750 */     GIR_EraseRootFromParent_Done,
     /* 344751 */   // Label 6898: @344751
     /* 344751 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(344860), // Rule ID 4227 //
     /* 344756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344783 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344800 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344859 */     // GIR_Coverage, 4227,
     /* 344859 */     GIR_EraseRootFromParent_Done,
     /* 344860 */   // Label 6899: @344860
     /* 344860 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(344969), // Rule ID 4334 //
     /* 344865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344909 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344936 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344968 */     // GIR_Coverage, 4334,
     /* 344968 */     GIR_EraseRootFromParent_Done,
     /* 344969 */   // Label 6900: @344969
     /* 344969 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(345078), // Rule ID 4335 //
     /* 344974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344978 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344994 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345001 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345018 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345045 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345077 */     // GIR_Coverage, 4335,
     /* 345077 */     GIR_EraseRootFromParent_Done,
     /* 345078 */   // Label 6901: @345078
     /* 345078 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(345183), // Rule ID 4232 //
     /* 345083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345099 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345106 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345123 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345150 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345182 */     // GIR_Coverage, 4232,
     /* 345182 */     GIR_EraseRootFromParent_Done,
     /* 345183 */   // Label 6902: @345183
     /* 345183 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(345288), // Rule ID 4234 //
     /* 345188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345204 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345211 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345228 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345255 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345287 */     // GIR_Coverage, 4234,
     /* 345287 */     GIR_EraseRootFromParent_Done,
     /* 345288 */   // Label 6903: @345288
     /* 345288 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(345393), // Rule ID 4340 //
     /* 345293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345309 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345316 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345333 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345392 */     // GIR_Coverage, 4340,
     /* 345392 */     GIR_EraseRootFromParent_Done,
     /* 345393 */   // Label 6904: @345393
     /* 345393 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(345498), // Rule ID 4342 //
     /* 345398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345414 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345421 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345438 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345465 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345497 */     // GIR_Coverage, 4342,
     /* 345497 */     GIR_EraseRootFromParent_Done,
     /* 345498 */   // Label 6905: @345498
     /* 345498 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(345602), // Rule ID 4224 //
     /* 345503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345507 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345513 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345523 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345526 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345530 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345547 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345569 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345601 */     // GIR_Coverage, 4224,
     /* 345601 */     GIR_EraseRootFromParent_Done,
     /* 345602 */   // Label 6906: @345602
     /* 345602 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(345706), // Rule ID 4225 //
     /* 345607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345627 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345634 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345651 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345673 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345705 */     // GIR_Coverage, 4225,
     /* 345705 */     GIR_EraseRootFromParent_Done,
     /* 345706 */   // Label 6907: @345706
     /* 345706 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(345810), // Rule ID 4332 //
     /* 345711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345731 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345738 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345755 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345809 */     // GIR_Coverage, 4332,
     /* 345809 */     GIR_EraseRootFromParent_Done,
     /* 345810 */   // Label 6908: @345810
     /* 345810 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(345914), // Rule ID 4333 //
     /* 345815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345859 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345881 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345913 */     // GIR_Coverage, 4333,
     /* 345913 */     GIR_EraseRootFromParent_Done,
     /* 345914 */   // Label 6909: @345914
     /* 345914 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(346014), // Rule ID 4228 //
     /* 345919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345935 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345942 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345959 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345981 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346013 */     // GIR_Coverage, 4228,
     /* 346013 */     GIR_EraseRootFromParent_Done,
     /* 346014 */   // Label 6910: @346014
     /* 346014 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(346114), // Rule ID 4230 //
     /* 346019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346059 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346081 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346113 */     // GIR_Coverage, 4230,
     /* 346113 */     GIR_EraseRootFromParent_Done,
     /* 346114 */   // Label 6911: @346114
     /* 346114 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(346214), // Rule ID 4336 //
     /* 346119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346135 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346142 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346159 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346181 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346213 */     // GIR_Coverage, 4336,
     /* 346213 */     GIR_EraseRootFromParent_Done,
     /* 346214 */   // Label 6912: @346214
     /* 346214 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(346314), // Rule ID 4338 //
     /* 346219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346235 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346242 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346259 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346281 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346313 */     // GIR_Coverage, 4338,
     /* 346313 */     GIR_EraseRootFromParent_Done,
     /* 346314 */   // Label 6913: @346314
     /* 346314 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(346452), // Rule ID 10992 //
     /* 346319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 346322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346330 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 346330 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 346333 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346337 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346342 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 346348 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346353 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346358 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 346361 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 346365 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346370 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 346375 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 346378 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 346382 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346387 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346390 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 346393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346395 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 346398 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 346402 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346407 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 346410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 346415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 346419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346424 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 346433 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 346436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 346441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 346443 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 346445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 346450 */     GIR_RootConstrainSelectedInstOperands,
     /* 346451 */     // GIR_Coverage, 10992,
     /* 346451 */     GIR_EraseRootFromParent_Done,
     /* 346452 */   // Label 6914: @346452
     /* 346452 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(346590), // Rule ID 10998 //
     /* 346457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 346460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346468 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 346468 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 346471 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346475 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346480 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 346486 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346491 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346496 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 346499 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 346503 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346508 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 346513 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 346516 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 346520 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346525 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346528 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 346531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 346536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 346540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346545 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 346548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 346553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 346557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346568 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 346571 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 346574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 346579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 346581 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 346583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 346588 */     GIR_RootConstrainSelectedInstOperands,
     /* 346589 */     // GIR_Coverage, 10998,
     /* 346589 */     GIR_EraseRootFromParent_Done,
     /* 346590 */   // Label 6915: @346590
     /* 346590 */   GIM_Reject,
     /* 346591 */ // Label 6897: @346591
     /* 346591 */ GIM_Reject,
     /* 346592 */ // Label 6680: @346592
     /* 346592 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(348785),
     /* 346597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 346600 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(346726), // Rule ID 4190 //
     /* 346605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346619 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346625 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346635 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346638 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346642 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346649 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 346666 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 346666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 346673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346693 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346725 */     // GIR_Coverage, 4190,
     /* 346725 */     GIR_EraseRootFromParent_Done,
     /* 346726 */   // Label 6917: @346726
     /* 346726 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(346852), // Rule ID 4191 //
     /* 346731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346745 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346751 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346761 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346764 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346768 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346775 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 346792 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 346792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 346799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346851 */     // GIR_Coverage, 4191,
     /* 346851 */     GIR_EraseRootFromParent_Done,
     /* 346852 */   // Label 6918: @346852
     /* 346852 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(346971), // Rule ID 4298 //
     /* 346857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346871 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346877 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346887 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346890 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346894 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 346911 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 346911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 346918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346938 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346970 */     // GIR_Coverage, 4298,
     /* 346970 */     GIR_EraseRootFromParent_Done,
     /* 346971 */   // Label 6919: @346971
     /* 346971 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(347090), // Rule ID 4299 //
     /* 346976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346990 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346996 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347006 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347013 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347030 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347057 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347089 */     // GIR_Coverage, 4299,
     /* 347089 */     GIR_EraseRootFromParent_Done,
     /* 347090 */   // Label 6920: @347090
     /* 347090 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(347212), // Rule ID 4196 //
     /* 347095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347121 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347124 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347128 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347135 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347152 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347179 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347211 */     // GIR_Coverage, 4196,
     /* 347211 */     GIR_EraseRootFromParent_Done,
     /* 347212 */   // Label 6921: @347212
     /* 347212 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(347334), // Rule ID 4198 //
     /* 347217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347243 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347246 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347250 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347257 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347274 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347301 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347333 */     // GIR_Coverage, 4198,
     /* 347333 */     GIR_EraseRootFromParent_Done,
     /* 347334 */   // Label 6922: @347334
     /* 347334 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(347449), // Rule ID 4304 //
     /* 347339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347365 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347372 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347389 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347416 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347448 */     // GIR_Coverage, 4304,
     /* 347448 */     GIR_EraseRootFromParent_Done,
     /* 347449 */   // Label 6923: @347449
     /* 347449 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(347564), // Rule ID 4306 //
     /* 347454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347480 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347487 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347504 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347531 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347563 */     // GIR_Coverage, 4306,
     /* 347563 */     GIR_EraseRootFromParent_Done,
     /* 347564 */   // Label 6924: @347564
     /* 347564 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(347685), // Rule ID 4188 //
     /* 347569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347599 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347602 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347606 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347613 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 347630 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 347630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 347637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347652 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347684 */     // GIR_Coverage, 4188,
     /* 347684 */     GIR_EraseRootFromParent_Done,
     /* 347685 */   // Label 6925: @347685
     /* 347685 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(347806), // Rule ID 4189 //
     /* 347690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347723 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347727 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347734 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 347751 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 347751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 347758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347773 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347805 */     // GIR_Coverage, 4189,
     /* 347805 */     GIR_EraseRootFromParent_Done,
     /* 347806 */   // Label 6926: @347806
     /* 347806 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(347920), // Rule ID 4296 //
     /* 347811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347825 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 347865 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 347865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 347872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347887 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347919 */     // GIR_Coverage, 4296,
     /* 347919 */     GIR_EraseRootFromParent_Done,
     /* 347920 */   // Label 6927: @347920
     /* 347920 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(348034), // Rule ID 4297 //
     /* 347925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347939 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347945 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347955 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347962 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 347979 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 347979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 347986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348001 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348033 */     // GIR_Coverage, 4297,
     /* 348033 */     GIR_EraseRootFromParent_Done,
     /* 348034 */   // Label 6928: @348034
     /* 348034 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(348151), // Rule ID 4192 //
     /* 348039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348065 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348068 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348072 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348079 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348096 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348150 */     // GIR_Coverage, 4192,
     /* 348150 */     GIR_EraseRootFromParent_Done,
     /* 348151 */   // Label 6929: @348151
     /* 348151 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(348268), // Rule ID 4194 //
     /* 348156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348185 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348189 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348196 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348213 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348235 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348267 */     // GIR_Coverage, 4194,
     /* 348267 */     GIR_EraseRootFromParent_Done,
     /* 348268 */   // Label 6930: @348268
     /* 348268 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(348378), // Rule ID 4300 //
     /* 348273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348299 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348306 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348323 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348345 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348377 */     // GIR_Coverage, 4300,
     /* 348377 */     GIR_EraseRootFromParent_Done,
     /* 348378 */   // Label 6931: @348378
     /* 348378 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(348488), // Rule ID 4302 //
     /* 348383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348409 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348416 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348433 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348487 */     // GIR_Coverage, 4302,
     /* 348487 */     GIR_EraseRootFromParent_Done,
     /* 348488 */   // Label 6932: @348488
     /* 348488 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(348636), // Rule ID 10991 //
     /* 348493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348514 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 348514 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 348517 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348521 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348526 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 348532 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348537 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348542 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 348545 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 348549 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348554 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 348557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 348559 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 348562 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 348566 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348571 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348574 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 348577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 348586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 348594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 348603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 348617 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 348620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 348625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 348627 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 348629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 348634 */     GIR_RootConstrainSelectedInstOperands,
     /* 348635 */     // GIR_Coverage, 10991,
     /* 348635 */     GIR_EraseRootFromParent_Done,
     /* 348636 */   // Label 6933: @348636
     /* 348636 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(348784), // Rule ID 10996 //
     /* 348641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348662 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 348662 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 348665 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348669 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348674 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 348680 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348685 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348690 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 348693 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 348697 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348702 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 348705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 348707 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 348710 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 348714 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348719 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348722 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 348725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348727 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348730 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 348734 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348739 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 348742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 348751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 348765 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 348768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 348773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 348775 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 348777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 348782 */     GIR_RootConstrainSelectedInstOperands,
     /* 348783 */     // GIR_Coverage, 10996,
     /* 348783 */     GIR_EraseRootFromParent_Done,
     /* 348784 */   // Label 6934: @348784
     /* 348784 */   GIM_Reject,
     /* 348785 */ // Label 6916: @348785
     /* 348785 */ GIM_Reject,
     /* 348786 */ // Label 6681: @348786
     /* 348786 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(349835),
     /* 348791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 348794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348804 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(348920), // Rule ID 4154 //
     /* 348809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348813 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348819 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348829 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348832 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348836 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348843 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 348860 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 348867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348887 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348919 */     // GIR_Coverage, 4154,
     /* 348919 */     GIR_EraseRootFromParent_Done,
     /* 348920 */   // Label 6936: @348920
     /* 348920 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(349036), // Rule ID 4155 //
     /* 348925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348929 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348935 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348945 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348948 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348952 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348959 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 348976 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 348983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349003 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349035 */     // GIR_Coverage, 4155,
     /* 349035 */     GIR_EraseRootFromParent_Done,
     /* 349036 */   // Label 6937: @349036
     /* 349036 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(349148), // Rule ID 4160 //
     /* 349041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349057 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349060 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349064 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 349088 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 349095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349115 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349147 */     // GIR_Coverage, 4160,
     /* 349147 */     GIR_EraseRootFromParent_Done,
     /* 349148 */   // Label 6938: @349148
     /* 349148 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(349260), // Rule ID 4162 //
     /* 349153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349169 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349172 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349176 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349183 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 349200 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 349207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349227 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349259 */     // GIR_Coverage, 4162,
     /* 349259 */     GIR_EraseRootFromParent_Done,
     /* 349260 */   // Label 6939: @349260
     /* 349260 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(349371), // Rule ID 4152 //
     /* 349265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349269 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349275 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349285 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349288 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349292 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349299 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349316 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349338 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349370 */     // GIR_Coverage, 4152,
     /* 349370 */     GIR_EraseRootFromParent_Done,
     /* 349371 */   // Label 6940: @349371
     /* 349371 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(349482), // Rule ID 4153 //
     /* 349376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349380 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349386 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349396 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349399 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349403 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 349427 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 349427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 349434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349449 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349481 */     // GIR_Coverage, 4153,
     /* 349481 */     GIR_EraseRootFromParent_Done,
     /* 349482 */   // Label 6941: @349482
     /* 349482 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(349589), // Rule ID 4156 //
     /* 349487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349503 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349506 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349510 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349517 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349534 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349556 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349588 */     // GIR_Coverage, 4156,
     /* 349588 */     GIR_EraseRootFromParent_Done,
     /* 349589 */   // Label 6942: @349589
     /* 349589 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(349696), // Rule ID 4158 //
     /* 349594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349613 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349617 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349624 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 349641 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 349641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 349648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349663 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349695 */     // GIR_Coverage, 4158,
     /* 349695 */     GIR_EraseRootFromParent_Done,
     /* 349696 */   // Label 6943: @349696
     /* 349696 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(349834), // Rule ID 10990 //
     /* 349701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349712 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 349712 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 349715 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349719 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349724 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 349730 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349735 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349740 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349743 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 349747 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349752 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349757 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349760 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 349764 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349769 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349772 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 349784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349789 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 349801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349815 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 349823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349825 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349830 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349832 */     GIR_RootConstrainSelectedInstOperands,
     /* 349833 */     // GIR_Coverage, 10990,
     /* 349833 */     GIR_EraseRootFromParent_Done,
     /* 349834 */   // Label 6944: @349834
     /* 349834 */   GIM_Reject,
     /* 349835 */ // Label 6935: @349835
     /* 349835 */ GIM_Reject,
     /* 349836 */ // Label 6682: @349836
     /* 349836 */ GIM_Reject,
     /* 349837 */ // Label 86: @349837
     /* 349837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6948*/ GIMT_Encode4(352754),
     /* 349848 */ /*GILLT_s16*//*Label 6945*/ GIMT_Encode4(349860),
     /* 349852 */ /*GILLT_s32*//*Label 6946*/ GIMT_Encode4(350494),
     /* 349856 */ /*GILLT_s64*//*Label 6947*/ GIMT_Encode4(352087),
     /* 349860 */ // Label 6945: @349860
     /* 349860 */ GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(349904), // Rule ID 11039 //
     /* 349865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 349871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349878 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 349882 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 349882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349887 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 349893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349903 */   // GIR_Coverage, 11039,
     /* 349903 */   GIR_EraseRootFromParent_Done,
     /* 349904 */ // Label 6949: @349904
     /* 349904 */ GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(349948), // Rule ID 11040 //
     /* 349909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 349915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349922 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 349926 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 349926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349931 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 349937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349947 */   // GIR_Coverage, 11040,
     /* 349947 */   GIR_EraseRootFromParent_Done,
     /* 349948 */ // Label 6950: @349948
     /* 349948 */ GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(349992), // Rule ID 11041 //
     /* 349953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 349959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349966 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 349970 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 349970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349975 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 349981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349991 */   // GIR_Coverage, 11041,
     /* 349991 */   GIR_EraseRootFromParent_Done,
     /* 349992 */ // Label 6951: @349992
     /* 349992 */ GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(350037), // Rule ID 5693 //
     /* 349997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350011 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350015 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 350015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350020 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 350026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350036 */   // GIR_Coverage, 5693,
     /* 350036 */   GIR_EraseRootFromParent_Done,
     /* 350037 */ // Label 6952: @350037
     /* 350037 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(350082), // Rule ID 5696 //
     /* 350042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350064 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350068 */   // MIs[1] Operand 1
     /* 350068 */   // No operand predicates
     /* 350068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350070 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 350070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 350073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350075 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350077 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 350080 */   GIR_RootConstrainSelectedInstOperands,
     /* 350081 */   // GIR_Coverage, 5696,
     /* 350081 */   GIR_EraseRootFromParent_Done,
     /* 350082 */ // Label 6953: @350082
     /* 350082 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(350158), // Rule ID 11014 //
     /* 350087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350100 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350108 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 350112 */   // MIs[1] Operand 1
     /* 350112 */   // No operand predicates
     /* 350112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350114 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 350114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 350121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350126 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350130 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350140 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350157 */   // GIR_Coverage, 11014,
     /* 350157 */   GIR_EraseRootFromParent_Done,
     /* 350158 */ // Label 6954: @350158
     /* 350158 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(350234), // Rule ID 11015 //
     /* 350163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350176 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350180 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350184 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 350188 */   // MIs[1] Operand 1
     /* 350188 */   // No operand predicates
     /* 350188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350190 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 350190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 350197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350202 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350216 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350233 */   // GIR_Coverage, 11015,
     /* 350233 */   GIR_EraseRootFromParent_Done,
     /* 350234 */ // Label 6955: @350234
     /* 350234 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(350310), // Rule ID 11016 //
     /* 350239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350260 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 350264 */   // MIs[1] Operand 1
     /* 350264 */   // No operand predicates
     /* 350264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350266 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 350266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 350273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350282 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350292 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350309 */   // GIR_Coverage, 11016,
     /* 350309 */   GIR_EraseRootFromParent_Done,
     /* 350310 */ // Label 6956: @350310
     /* 350310 */ GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(350371), // Rule ID 11004 //
     /* 350315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350332 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 350332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 350339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350344 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350350 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350354 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350367 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350369 */   GIR_RootConstrainSelectedInstOperands,
     /* 350370 */   // GIR_Coverage, 11004,
     /* 350370 */   GIR_EraseRootFromParent_Done,
     /* 350371 */ // Label 6957: @350371
     /* 350371 */ GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(350432), // Rule ID 11005 //
     /* 350376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350393 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 350393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 350400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350405 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350415 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350428 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350430 */   GIR_RootConstrainSelectedInstOperands,
     /* 350431 */   // GIR_Coverage, 11005,
     /* 350431 */   GIR_EraseRootFromParent_Done,
     /* 350432 */ // Label 6958: @350432
     /* 350432 */ GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(350493), // Rule ID 11006 //
     /* 350437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350454 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 350454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 350461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350466 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350472 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350476 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350489 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350491 */   GIR_RootConstrainSelectedInstOperands,
     /* 350492 */   // GIR_Coverage, 11006,
     /* 350492 */   GIR_EraseRootFromParent_Done,
     /* 350493 */ // Label 6959: @350493
     /* 350493 */ GIM_Reject,
     /* 350494 */ // Label 6946: @350494
     /* 350494 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(350539), // Rule ID 6868 //
     /* 350499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350513 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350517 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 350517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350522 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 350528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350538 */   // GIR_Coverage, 6868,
     /* 350538 */   GIR_EraseRootFromParent_Done,
     /* 350539 */ // Label 6960: @350539
     /* 350539 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(350584), // Rule ID 6869 //
     /* 350544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350558 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350562 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 350562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350567 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 350573 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350583 */   // GIR_Coverage, 6869,
     /* 350583 */   GIR_EraseRootFromParent_Done,
     /* 350584 */ // Label 6961: @350584
     /* 350584 */ GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(350628), // Rule ID 11035 //
     /* 350589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 350595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350602 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350606 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 350606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350611 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350627 */   // GIR_Coverage, 11035,
     /* 350627 */   GIR_EraseRootFromParent_Done,
     /* 350628 */ // Label 6962: @350628
     /* 350628 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(350672), // Rule ID 11036 //
     /* 350633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350646 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350650 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 350650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350655 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350671 */   // GIR_Coverage, 11036,
     /* 350671 */   GIR_EraseRootFromParent_Done,
     /* 350672 */ // Label 6963: @350672
     /* 350672 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(350716), // Rule ID 11037 //
     /* 350677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 350683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350690 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350694 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 350694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350699 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350715 */   // GIR_Coverage, 11037,
     /* 350715 */   GIR_EraseRootFromParent_Done,
     /* 350716 */ // Label 6964: @350716
     /* 350716 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(350760), // Rule ID 11042 //
     /* 350721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 350727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350734 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350738 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 350738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350743 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350759 */   // GIR_Coverage, 11042,
     /* 350759 */   GIR_EraseRootFromParent_Done,
     /* 350760 */ // Label 6965: @350760
     /* 350760 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(350804), // Rule ID 11043 //
     /* 350765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 350771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350778 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350782 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 350782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350787 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350803 */   // GIR_Coverage, 11043,
     /* 350803 */   GIR_EraseRootFromParent_Done,
     /* 350804 */ // Label 6966: @350804
     /* 350804 */ GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(350849), // Rule ID 5692 //
     /* 350809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350823 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350827 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 350827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350832 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 350838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350848 */   // GIR_Coverage, 5692,
     /* 350848 */   GIR_EraseRootFromParent_Done,
     /* 350849 */ // Label 6967: @350849
     /* 350849 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(350922), // Rule ID 11020 //
     /* 350854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 350860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350867 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350875 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 350879 */   // MIs[1] Operand 1
     /* 350879 */   // No operand predicates
     /* 350879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350881 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 350881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 350884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350893 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 350899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350904 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 350912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350917 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 350920 */   GIR_RootConstrainSelectedInstOperands,
     /* 350921 */   // GIR_Coverage, 11020,
     /* 350921 */   GIR_EraseRootFromParent_Done,
     /* 350922 */ // Label 6968: @350922
     /* 350922 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(350995), // Rule ID 11021 //
     /* 350927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350948 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350952 */   // MIs[1] Operand 1
     /* 350952 */   // No operand predicates
     /* 350952 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350954 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 350954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 350957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350966 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 350972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 350985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350990 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 350993 */   GIR_RootConstrainSelectedInstOperands,
     /* 350994 */   // GIR_Coverage, 11021,
     /* 350994 */   GIR_EraseRootFromParent_Done,
     /* 350995 */ // Label 6969: @350995
     /* 350995 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(351068), // Rule ID 11022 //
     /* 351000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351021 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351025 */   // MIs[1] Operand 1
     /* 351025 */   // No operand predicates
     /* 351025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351027 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 351027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 351030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351039 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 351045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 351058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351063 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 351066 */   GIR_RootConstrainSelectedInstOperands,
     /* 351067 */   // GIR_Coverage, 11022,
     /* 351067 */   GIR_EraseRootFromParent_Done,
     /* 351068 */ // Label 6970: @351068
     /* 351068 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(351116), // Rule ID 1919 //
     /* 351073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351098 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351102 */   // MIs[1] Operand 1
     /* 351102 */   // No operand predicates
     /* 351102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351104 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 351107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351109 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351111 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351114 */   GIR_RootConstrainSelectedInstOperands,
     /* 351115 */   // GIR_Coverage, 1919,
     /* 351115 */   GIR_EraseRootFromParent_Done,
     /* 351116 */ // Label 6971: @351116
     /* 351116 */ GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(351164), // Rule ID 1920 //
     /* 351121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351146 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351150 */   // MIs[1] Operand 1
     /* 351150 */   // No operand predicates
     /* 351150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351152 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 351155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351157 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351159 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351162 */   GIR_RootConstrainSelectedInstOperands,
     /* 351163 */   // GIR_Coverage, 1920,
     /* 351163 */   GIR_EraseRootFromParent_Done,
     /* 351164 */ // Label 6972: @351164
     /* 351164 */ GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(351212), // Rule ID 1921 //
     /* 351169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351194 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351198 */   // MIs[1] Operand 1
     /* 351198 */   // No operand predicates
     /* 351198 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351200 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 351203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351205 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351207 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351210 */   GIR_RootConstrainSelectedInstOperands,
     /* 351211 */   // GIR_Coverage, 1921,
     /* 351211 */   GIR_EraseRootFromParent_Done,
     /* 351212 */ // Label 6973: @351212
     /* 351212 */ GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(351260), // Rule ID 1923 //
     /* 351217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351242 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 351246 */   // MIs[1] Operand 1
     /* 351246 */   // No operand predicates
     /* 351246 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351248 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 351251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351253 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351255 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351258 */   GIR_RootConstrainSelectedInstOperands,
     /* 351259 */   // GIR_Coverage, 1923,
     /* 351259 */   GIR_EraseRootFromParent_Done,
     /* 351260 */ // Label 6974: @351260
     /* 351260 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(351308), // Rule ID 1924 //
     /* 351265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351290 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351294 */   // MIs[1] Operand 1
     /* 351294 */   // No operand predicates
     /* 351294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351296 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 351299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351301 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351303 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351306 */   GIR_RootConstrainSelectedInstOperands,
     /* 351307 */   // GIR_Coverage, 1924,
     /* 351307 */   GIR_EraseRootFromParent_Done,
     /* 351308 */ // Label 6975: @351308
     /* 351308 */ GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(351356), // Rule ID 1925 //
     /* 351313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351338 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351342 */   // MIs[1] Operand 1
     /* 351342 */   // No operand predicates
     /* 351342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351344 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 351347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351349 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351351 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351354 */   GIR_RootConstrainSelectedInstOperands,
     /* 351355 */   // GIR_Coverage, 1925,
     /* 351355 */   GIR_EraseRootFromParent_Done,
     /* 351356 */ // Label 6976: @351356
     /* 351356 */ GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(351401), // Rule ID 5695 //
     /* 351361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351383 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351387 */   // MIs[1] Operand 1
     /* 351387 */   // No operand predicates
     /* 351387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351389 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 351389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 351392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351394 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351396 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351399 */   GIR_RootConstrainSelectedInstOperands,
     /* 351400 */   // GIR_Coverage, 5695,
     /* 351400 */   GIR_EraseRootFromParent_Done,
     /* 351401 */ // Label 6977: @351401
     /* 351401 */ GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(351477), // Rule ID 11010 //
     /* 351406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351427 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 351431 */   // MIs[1] Operand 1
     /* 351431 */   // No operand predicates
     /* 351431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351433 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 351433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 351440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351445 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351449 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351459 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351476 */   // GIR_Coverage, 11010,
     /* 351476 */   GIR_EraseRootFromParent_Done,
     /* 351477 */ // Label 6978: @351477
     /* 351477 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(351553), // Rule ID 11011 //
     /* 351482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351503 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 351507 */   // MIs[1] Operand 1
     /* 351507 */   // No operand predicates
     /* 351507 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351509 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 351509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 351516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351525 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351535 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351552 */   // GIR_Coverage, 11011,
     /* 351552 */   GIR_EraseRootFromParent_Done,
     /* 351553 */ // Label 6979: @351553
     /* 351553 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(351629), // Rule ID 11012 //
     /* 351558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351579 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 351583 */   // MIs[1] Operand 1
     /* 351583 */   // No operand predicates
     /* 351583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351585 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 351585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 351592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351597 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351601 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351611 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351628 */   // GIR_Coverage, 11012,
     /* 351628 */   GIR_EraseRootFromParent_Done,
     /* 351629 */ // Label 6980: @351629
     /* 351629 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(351705), // Rule ID 11017 //
     /* 351634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351655 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 351659 */   // MIs[1] Operand 1
     /* 351659 */   // No operand predicates
     /* 351659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351661 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 351661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 351668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351673 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351677 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351687 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351704 */   // GIR_Coverage, 11017,
     /* 351704 */   GIR_EraseRootFromParent_Done,
     /* 351705 */ // Label 6981: @351705
     /* 351705 */ GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(351781), // Rule ID 11018 //
     /* 351710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 351716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351731 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 351735 */   // MIs[1] Operand 1
     /* 351735 */   // No operand predicates
     /* 351735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351737 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 351737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 351744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351749 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351753 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351763 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351780 */   // GIR_Coverage, 11018,
     /* 351780 */   GIR_EraseRootFromParent_Done,
     /* 351781 */ // Label 6982: @351781
     /* 351781 */ GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(351842), // Rule ID 11000 //
     /* 351786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351803 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 351803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 351810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351815 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 351825 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 351833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351838 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351840 */   GIR_RootConstrainSelectedInstOperands,
     /* 351841 */   // GIR_Coverage, 11000,
     /* 351841 */   GIR_EraseRootFromParent_Done,
     /* 351842 */ // Label 6983: @351842
     /* 351842 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(351903), // Rule ID 11001 //
     /* 351847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351864 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 351864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 351871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351876 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 351886 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 351894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351899 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351901 */   GIR_RootConstrainSelectedInstOperands,
     /* 351902 */   // GIR_Coverage, 11001,
     /* 351902 */   GIR_EraseRootFromParent_Done,
     /* 351903 */ // Label 6984: @351903
     /* 351903 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(351964), // Rule ID 11002 //
     /* 351908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351925 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 351925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 351932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351937 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 351947 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 351955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351960 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351962 */   GIR_RootConstrainSelectedInstOperands,
     /* 351963 */   // GIR_Coverage, 11002,
     /* 351963 */   GIR_EraseRootFromParent_Done,
     /* 351964 */ // Label 6985: @351964
     /* 351964 */ GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(352025), // Rule ID 11007 //
     /* 351969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351986 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 351986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 351993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351998 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352004 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352008 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 352016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352021 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352023 */   GIR_RootConstrainSelectedInstOperands,
     /* 352024 */   // GIR_Coverage, 11007,
     /* 352024 */   GIR_EraseRootFromParent_Done,
     /* 352025 */ // Label 6986: @352025
     /* 352025 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(352086), // Rule ID 11008 //
     /* 352030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 352036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352047 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 352047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352059 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352065 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352069 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 352077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352082 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352084 */   GIR_RootConstrainSelectedInstOperands,
     /* 352085 */   // GIR_Coverage, 11008,
     /* 352085 */   GIR_EraseRootFromParent_Done,
     /* 352086 */ // Label 6987: @352086
     /* 352086 */ GIM_Reject,
     /* 352087 */ // Label 6947: @352087
     /* 352087 */ GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(352132), // Rule ID 6867 //
     /* 352092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352106 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352110 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 352110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352115 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 352121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352131 */   // GIR_Coverage, 6867,
     /* 352131 */   GIR_EraseRootFromParent_Done,
     /* 352132 */ // Label 6988: @352132
     /* 352132 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(352176), // Rule ID 11038 //
     /* 352137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352150 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352154 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 352154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352159 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 352165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352175 */   // GIR_Coverage, 11038,
     /* 352175 */   GIR_EraseRootFromParent_Done,
     /* 352176 */ // Label 6989: @352176
     /* 352176 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(352220), // Rule ID 11044 //
     /* 352181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352194 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352198 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 352198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352203 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 352209 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352219 */   // GIR_Coverage, 11044,
     /* 352219 */   GIR_EraseRootFromParent_Done,
     /* 352220 */ // Label 6990: @352220
     /* 352220 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(352265), // Rule ID 5691 //
     /* 352225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352239 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352243 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 352243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352248 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 352254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352264 */   // GIR_Coverage, 5691,
     /* 352264 */   GIR_EraseRootFromParent_Done,
     /* 352265 */ // Label 6991: @352265
     /* 352265 */ GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(352338), // Rule ID 11023 //
     /* 352270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352291 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352295 */   // MIs[1] Operand 1
     /* 352295 */   // No operand predicates
     /* 352295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352297 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 352297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 352300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352309 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 352315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 352328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352333 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 352336 */   GIR_RootConstrainSelectedInstOperands,
     /* 352337 */   // GIR_Coverage, 11023,
     /* 352337 */   GIR_EraseRootFromParent_Done,
     /* 352338 */ // Label 6992: @352338
     /* 352338 */ GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(352386), // Rule ID 1922 //
     /* 352343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 352346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352368 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 352372 */   // MIs[1] Operand 1
     /* 352372 */   // No operand predicates
     /* 352372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352374 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 352374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 352377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352379 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352381 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352384 */   GIR_RootConstrainSelectedInstOperands,
     /* 352385 */   // GIR_Coverage, 1922,
     /* 352385 */   GIR_EraseRootFromParent_Done,
     /* 352386 */ // Label 6993: @352386
     /* 352386 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(352434), // Rule ID 1926 //
     /* 352391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352416 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352420 */   // MIs[1] Operand 1
     /* 352420 */   // No operand predicates
     /* 352420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352422 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 352422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 352425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352427 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352432 */   GIR_RootConstrainSelectedInstOperands,
     /* 352433 */   // GIR_Coverage, 1926,
     /* 352433 */   GIR_EraseRootFromParent_Done,
     /* 352434 */ // Label 6994: @352434
     /* 352434 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(352479), // Rule ID 5694 //
     /* 352439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352461 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352465 */   // MIs[1] Operand 1
     /* 352465 */   // No operand predicates
     /* 352465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352467 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 352467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 352470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352472 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352474 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352477 */   GIR_RootConstrainSelectedInstOperands,
     /* 352478 */   // GIR_Coverage, 5694,
     /* 352478 */   GIR_EraseRootFromParent_Done,
     /* 352479 */ // Label 6995: @352479
     /* 352479 */ GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(352555), // Rule ID 11013 //
     /* 352484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352505 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352509 */   // MIs[1] Operand 1
     /* 352509 */   // No operand predicates
     /* 352509 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352511 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 352511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352527 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352537 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352554 */   // GIR_Coverage, 11013,
     /* 352554 */   GIR_EraseRootFromParent_Done,
     /* 352555 */ // Label 6996: @352555
     /* 352555 */ GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(352631), // Rule ID 11019 //
     /* 352560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352581 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352585 */   // MIs[1] Operand 1
     /* 352585 */   // No operand predicates
     /* 352585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352587 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 352587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352603 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352613 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352630 */   // GIR_Coverage, 11019,
     /* 352630 */   GIR_EraseRootFromParent_Done,
     /* 352631 */ // Label 6997: @352631
     /* 352631 */ GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(352692), // Rule ID 11003 //
     /* 352636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352653 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 352653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352665 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352675 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 352683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352688 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352690 */   GIR_RootConstrainSelectedInstOperands,
     /* 352691 */   // GIR_Coverage, 11003,
     /* 352691 */   GIR_EraseRootFromParent_Done,
     /* 352692 */ // Label 6998: @352692
     /* 352692 */ GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(352753), // Rule ID 11009 //
     /* 352697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352714 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 352714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352726 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352736 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 352744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352749 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352751 */   GIR_RootConstrainSelectedInstOperands,
     /* 352752 */   // GIR_Coverage, 11009,
     /* 352752 */   GIR_EraseRootFromParent_Done,
     /* 352753 */ // Label 6999: @352753
     /* 352753 */ GIM_Reject,
     /* 352754 */ // Label 6948: @352754
     /* 352754 */ GIM_Reject,
     /* 352755 */ // Label 87: @352755
     /* 352755 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7007*/ GIMT_Encode4(354460),
     /* 352766 */ /*GILLT_nxv2s16*//*Label 7000*/ GIMT_Encode4(352806),
     /* 352770 */ /*GILLT_nxv2s32*//*Label 7001*/ GIMT_Encode4(353101),
     /* 352774 */ /*GILLT_nxv2s64*//*Label 7002*/ GIMT_Encode4(353339), GIMT_Encode4(0),
     /* 352782 */ /*GILLT_nxv4s16*//*Label 7003*/ GIMT_Encode4(353596),
     /* 352786 */ /*GILLT_nxv4s32*//*Label 7004*/ GIMT_Encode4(353834), GIMT_Encode4(0),
     /* 352794 */ /*GILLT_nxv8s16*//*Label 7005*/ GIMT_Encode4(354091), GIMT_Encode4(0),
     /* 352802 */ /*GILLT_nxv16s8*//*Label 7006*/ GIMT_Encode4(354370),
     /* 352806 */ // Label 7000: @352806
     /* 352806 */ GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(353100),
     /* 352811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 352814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352818 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(352875), // Rule ID 2661 //
     /* 352823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 352859 */     // MIs[2] Operand 1
     /* 352859 */     // No operand predicates
     /* 352859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352861 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 352861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 352864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 352870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 352873 */     GIR_RootConstrainSelectedInstOperands,
     /* 352874 */     // GIR_Coverage, 2661,
     /* 352874 */     GIR_EraseRootFromParent_Done,
     /* 352875 */   // Label 7009: @352875
     /* 352875 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(352932), // Rule ID 2663 //
     /* 352880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 352895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352912 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352916 */     // MIs[2] Operand 1
     /* 352916 */     // No operand predicates
     /* 352916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352918 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 352918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 352927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 352930 */     GIR_RootConstrainSelectedInstOperands,
     /* 352931 */     // GIR_Coverage, 2663,
     /* 352931 */     GIR_EraseRootFromParent_Done,
     /* 352932 */   // Label 7010: @352932
     /* 352932 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(352989), // Rule ID 8183 //
     /* 352937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352969 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 352973 */     // MIs[2] Operand 1
     /* 352973 */     // No operand predicates
     /* 352973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352975 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 352975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 352978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 352984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 352987 */     GIR_RootConstrainSelectedInstOperands,
     /* 352988 */     // GIR_Coverage, 8183,
     /* 352988 */     GIR_EraseRootFromParent_Done,
     /* 352989 */   // Label 7011: @352989
     /* 352989 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(353023), // Rule ID 8226 //
     /* 352994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353005 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 353009 */     // MIs[1] Operand 1
     /* 353009 */     // No operand predicates
     /* 353009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353011 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 353011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 353014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353016 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 353021 */     GIR_RootConstrainSelectedInstOperands,
     /* 353022 */     // GIR_Coverage, 8226,
     /* 353022 */     GIR_EraseRootFromParent_Done,
     /* 353023 */   // Label 7012: @353023
     /* 353023 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(353099), // Rule ID 8204 //
     /* 353028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353035 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353068 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 353071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353097 */     GIR_RootConstrainSelectedInstOperands,
     /* 353098 */     // GIR_Coverage, 8204,
     /* 353098 */     GIR_EraseRootFromParent_Done,
     /* 353099 */   // Label 7013: @353099
     /* 353099 */   GIM_Reject,
     /* 353100 */ // Label 7008: @353100
     /* 353100 */ GIM_Reject,
     /* 353101 */ // Label 7001: @353101
     /* 353101 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(353338),
     /* 353106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 353109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353113 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(353170), // Rule ID 8192 //
     /* 353118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353154 */     // MIs[2] Operand 1
     /* 353154 */     // No operand predicates
     /* 353154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353156 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353168 */     GIR_RootConstrainSelectedInstOperands,
     /* 353169 */     // GIR_Coverage, 8192,
     /* 353169 */     GIR_EraseRootFromParent_Done,
     /* 353170 */   // Label 7015: @353170
     /* 353170 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(353227), // Rule ID 8201 //
     /* 353175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 353190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353211 */     // MIs[2] Operand 1
     /* 353211 */     // No operand predicates
     /* 353211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353213 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353225 */     GIR_RootConstrainSelectedInstOperands,
     /* 353226 */     // GIR_Coverage, 8201,
     /* 353226 */     GIR_EraseRootFromParent_Done,
     /* 353227 */   // Label 7016: @353227
     /* 353227 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(353261), // Rule ID 8228 //
     /* 353232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353243 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 353247 */     // MIs[1] Operand 1
     /* 353247 */     // No operand predicates
     /* 353247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353249 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 353249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 353252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353254 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 353259 */     GIR_RootConstrainSelectedInstOperands,
     /* 353260 */     // GIR_Coverage, 8228,
     /* 353260 */     GIR_EraseRootFromParent_Done,
     /* 353261 */   // Label 7017: @353261
     /* 353261 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(353337), // Rule ID 8206 //
     /* 353266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353273 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353299 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353306 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 353309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353335 */     GIR_RootConstrainSelectedInstOperands,
     /* 353336 */     // GIR_Coverage, 8206,
     /* 353336 */     GIR_EraseRootFromParent_Done,
     /* 353337 */   // Label 7018: @353337
     /* 353337 */   GIM_Reject,
     /* 353338 */ // Label 7014: @353338
     /* 353338 */ GIM_Reject,
     /* 353339 */ // Label 7002: @353339
     /* 353339 */ GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(353595),
     /* 353344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 353347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353351 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(353408), // Rule ID 2658 //
     /* 353356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353392 */     // MIs[2] Operand 1
     /* 353392 */     // No operand predicates
     /* 353392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353394 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353406 */     GIR_RootConstrainSelectedInstOperands,
     /* 353407 */     // GIR_Coverage, 2658,
     /* 353407 */     GIR_EraseRootFromParent_Done,
     /* 353408 */   // Label 7020: @353408
     /* 353408 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(353465), // Rule ID 8198 //
     /* 353413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353445 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353449 */     // MIs[2] Operand 1
     /* 353449 */     // No operand predicates
     /* 353449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353451 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353463 */     GIR_RootConstrainSelectedInstOperands,
     /* 353464 */     // GIR_Coverage, 8198,
     /* 353464 */     GIR_EraseRootFromParent_Done,
     /* 353465 */   // Label 7021: @353465
     /* 353465 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(353499), // Rule ID 8229 //
     /* 353470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353481 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 353485 */     // MIs[1] Operand 1
     /* 353485 */     // No operand predicates
     /* 353485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353487 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 353487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 353490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353492 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 353497 */     GIR_RootConstrainSelectedInstOperands,
     /* 353498 */     // GIR_Coverage, 8229,
     /* 353498 */     GIR_EraseRootFromParent_Done,
     /* 353499 */   // Label 7022: @353499
     /* 353499 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(353518), // Rule ID 2382 //
     /* 353504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 353511 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 353511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353516 */     GIR_RootConstrainSelectedInstOperands,
     /* 353517 */     // GIR_Coverage, 2382,
     /* 353517 */     GIR_Done,
     /* 353518 */   // Label 7023: @353518
     /* 353518 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(353594), // Rule ID 8207 //
     /* 353523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353530 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353592 */     GIR_RootConstrainSelectedInstOperands,
     /* 353593 */     // GIR_Coverage, 8207,
     /* 353593 */     GIR_EraseRootFromParent_Done,
     /* 353594 */   // Label 7024: @353594
     /* 353594 */   GIM_Reject,
     /* 353595 */ // Label 7019: @353595
     /* 353595 */ GIM_Reject,
     /* 353596 */ // Label 7003: @353596
     /* 353596 */ GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(353833),
     /* 353601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 353604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353608 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(353665), // Rule ID 2662 //
     /* 353613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353649 */     // MIs[2] Operand 1
     /* 353649 */     // No operand predicates
     /* 353649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353651 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353663 */     GIR_RootConstrainSelectedInstOperands,
     /* 353664 */     // GIR_Coverage, 2662,
     /* 353664 */     GIR_EraseRootFromParent_Done,
     /* 353665 */   // Label 7026: @353665
     /* 353665 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(353722), // Rule ID 8186 //
     /* 353670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353702 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 353706 */     // MIs[2] Operand 1
     /* 353706 */     // No operand predicates
     /* 353706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353708 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 353708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353720 */     GIR_RootConstrainSelectedInstOperands,
     /* 353721 */     // GIR_Coverage, 8186,
     /* 353721 */     GIR_EraseRootFromParent_Done,
     /* 353722 */   // Label 7027: @353722
     /* 353722 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(353756), // Rule ID 8225 //
     /* 353727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353738 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 353742 */     // MIs[1] Operand 1
     /* 353742 */     // No operand predicates
     /* 353742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353744 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 353744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 353747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353749 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 353754 */     GIR_RootConstrainSelectedInstOperands,
     /* 353755 */     // GIR_Coverage, 8225,
     /* 353755 */     GIR_EraseRootFromParent_Done,
     /* 353756 */   // Label 7028: @353756
     /* 353756 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(353832), // Rule ID 8203 //
     /* 353761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353768 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353794 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 353804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353830 */     GIR_RootConstrainSelectedInstOperands,
     /* 353831 */     // GIR_Coverage, 8203,
     /* 353831 */     GIR_EraseRootFromParent_Done,
     /* 353832 */   // Label 7029: @353832
     /* 353832 */   GIM_Reject,
     /* 353833 */ // Label 7025: @353833
     /* 353833 */ GIM_Reject,
     /* 353834 */ // Label 7004: @353834
     /* 353834 */ GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(354090),
     /* 353839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 353842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353846 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(353903), // Rule ID 2655 //
     /* 353851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353887 */     // MIs[2] Operand 1
     /* 353887 */     // No operand predicates
     /* 353887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353889 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353901 */     GIR_RootConstrainSelectedInstOperands,
     /* 353902 */     // GIR_Coverage, 2655,
     /* 353902 */     GIR_EraseRootFromParent_Done,
     /* 353903 */   // Label 7031: @353903
     /* 353903 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(353960), // Rule ID 8195 //
     /* 353908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353940 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353944 */     // MIs[2] Operand 1
     /* 353944 */     // No operand predicates
     /* 353944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353946 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353958 */     GIR_RootConstrainSelectedInstOperands,
     /* 353959 */     // GIR_Coverage, 8195,
     /* 353959 */     GIR_EraseRootFromParent_Done,
     /* 353960 */   // Label 7032: @353960
     /* 353960 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(353994), // Rule ID 8227 //
     /* 353965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353976 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 353980 */     // MIs[1] Operand 1
     /* 353980 */     // No operand predicates
     /* 353980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353982 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 353982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 353985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353987 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 353992 */     GIR_RootConstrainSelectedInstOperands,
     /* 353993 */     // GIR_Coverage, 8227,
     /* 353993 */     GIR_EraseRootFromParent_Done,
     /* 353994 */   // Label 7033: @353994
     /* 353994 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(354013), // Rule ID 2381 //
     /* 353999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354006 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 354011 */     GIR_RootConstrainSelectedInstOperands,
     /* 354012 */     // GIR_Coverage, 2381,
     /* 354012 */     GIR_Done,
     /* 354013 */   // Label 7034: @354013
     /* 354013 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(354089), // Rule ID 8205 //
     /* 354018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354025 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354025 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354028 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354032 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354051 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 354061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354087 */     GIR_RootConstrainSelectedInstOperands,
     /* 354088 */     // GIR_Coverage, 8205,
     /* 354088 */     GIR_EraseRootFromParent_Done,
     /* 354089 */   // Label 7035: @354089
     /* 354089 */   GIM_Reject,
     /* 354090 */ // Label 7030: @354090
     /* 354090 */ GIM_Reject,
     /* 354091 */ // Label 7005: @354091
     /* 354091 */ GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(354155), // Rule ID 2652 //
     /* 354096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354114 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354118 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354122 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354127 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354131 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354135 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354139 */   // MIs[2] Operand 1
     /* 354139 */   // No operand predicates
     /* 354139 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354141 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354146 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354150 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354153 */   GIR_RootConstrainSelectedInstOperands,
     /* 354154 */   // GIR_Coverage, 2652,
     /* 354154 */   GIR_EraseRootFromParent_Done,
     /* 354155 */ // Label 7036: @354155
     /* 354155 */ GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(354219), // Rule ID 8189 //
     /* 354160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354178 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354182 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354186 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354191 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354195 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354199 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354203 */   // MIs[2] Operand 1
     /* 354203 */   // No operand predicates
     /* 354203 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354205 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354210 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354214 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354217 */   GIR_RootConstrainSelectedInstOperands,
     /* 354218 */   // GIR_Coverage, 8189,
     /* 354218 */   GIR_EraseRootFromParent_Done,
     /* 354219 */ // Label 7037: @354219
     /* 354219 */ GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(354260), // Rule ID 8224 //
     /* 354224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 354242 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 354246 */   // MIs[1] Operand 1
     /* 354246 */   // No operand predicates
     /* 354246 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354248 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 354248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 354251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354253 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 354258 */   GIR_RootConstrainSelectedInstOperands,
     /* 354259 */   // GIR_Coverage, 8224,
     /* 354259 */   GIR_EraseRootFromParent_Done,
     /* 354260 */ // Label 7038: @354260
     /* 354260 */ GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(354286), // Rule ID 2380 //
     /* 354265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354279 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 354284 */   GIR_RootConstrainSelectedInstOperands,
     /* 354285 */   // GIR_Coverage, 2380,
     /* 354285 */   GIR_Done,
     /* 354286 */ // Label 7039: @354286
     /* 354286 */ GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(354369), // Rule ID 8202 //
     /* 354291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354305 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354305 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354308 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354312 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354338 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 354341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354367 */   GIR_RootConstrainSelectedInstOperands,
     /* 354368 */   // GIR_Coverage, 8202,
     /* 354368 */   GIR_EraseRootFromParent_Done,
     /* 354369 */ // Label 7040: @354369
     /* 354369 */ GIM_Reject,
     /* 354370 */ // Label 7006: @354370
     /* 354370 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(354459),
     /* 354375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354382 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(354439), // Rule ID 2649 //
     /* 354387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 354402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354419 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 354423 */     // MIs[2] Operand 1
     /* 354423 */     // No operand predicates
     /* 354423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354425 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 354425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 354428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354437 */     GIR_RootConstrainSelectedInstOperands,
     /* 354438 */     // GIR_Coverage, 2649,
     /* 354438 */     GIR_EraseRootFromParent_Done,
     /* 354439 */   // Label 7042: @354439
     /* 354439 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(354458), // Rule ID 2379 //
     /* 354444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354451 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 354456 */     GIR_RootConstrainSelectedInstOperands,
     /* 354457 */     // GIR_Coverage, 2379,
     /* 354457 */     GIR_Done,
     /* 354458 */   // Label 7043: @354458
     /* 354458 */   GIM_Reject,
     /* 354459 */ // Label 7041: @354459
     /* 354459 */ GIM_Reject,
     /* 354460 */ // Label 7007: @354460
     /* 354460 */ GIM_Reject,
     /* 354461 */ // Label 88: @354461
     /* 354461 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7046*/ GIMT_Encode4(354612),
     /* 354472 */ /*GILLT_s32*//*Label 7044*/ GIMT_Encode4(354480),
     /* 354476 */ /*GILLT_s64*//*Label 7045*/ GIMT_Encode4(354546),
     /* 354480 */ // Label 7044: @354480
     /* 354480 */ GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(354545),
     /* 354485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354496 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(354511), // Rule ID 2312 //
     /* 354501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 354504 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 354509 */     GIR_RootConstrainSelectedInstOperands,
     /* 354510 */     // GIR_Coverage, 2312,
     /* 354510 */     GIR_Done,
     /* 354511 */   // Label 7048: @354511
     /* 354511 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(354544), // Rule ID 3947 //
     /* 354516 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 354516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 354523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 354532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 354537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354542 */     GIR_RootConstrainSelectedInstOperands,
     /* 354543 */     // GIR_Coverage, 3947,
     /* 354543 */     GIR_EraseRootFromParent_Done,
     /* 354544 */   // Label 7049: @354544
     /* 354544 */   GIM_Reject,
     /* 354545 */ // Label 7047: @354545
     /* 354545 */ GIM_Reject,
     /* 354546 */ // Label 7045: @354546
     /* 354546 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(354611),
     /* 354551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 354554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354562 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(354577), // Rule ID 2313 //
     /* 354567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 354570 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 354570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 354575 */     GIR_RootConstrainSelectedInstOperands,
     /* 354576 */     // GIR_Coverage, 2313,
     /* 354576 */     GIR_Done,
     /* 354577 */   // Label 7051: @354577
     /* 354577 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(354610), // Rule ID 3948 //
     /* 354582 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 354582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 354589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 354598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 354603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354608 */     GIR_RootConstrainSelectedInstOperands,
     /* 354609 */     // GIR_Coverage, 3948,
     /* 354609 */     GIR_EraseRootFromParent_Done,
     /* 354610 */   // Label 7052: @354610
     /* 354610 */   GIM_Reject,
     /* 354611 */ // Label 7050: @354611
     /* 354611 */ GIM_Reject,
     /* 354612 */ // Label 7046: @354612
     /* 354612 */ GIM_Reject,
     /* 354613 */ // Label 89: @354613
     /* 354613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7061*/ GIMT_Encode4(355286),
     /* 354624 */ /*GILLT_s32*//*Label 7053*/ GIMT_Encode4(354664),
     /* 354628 */ /*GILLT_s64*//*Label 7054*/ GIMT_Encode4(354894), GIMT_Encode4(0),
     /* 354636 */ /*GILLT_v2s32*//*Label 7055*/ GIMT_Encode4(355124), GIMT_Encode4(0),
     /* 354644 */ /*GILLT_v4s16*//*Label 7056*/ GIMT_Encode4(355151),
     /* 354648 */ /*GILLT_v4s32*//*Label 7057*/ GIMT_Encode4(355178),
     /* 354652 */ /*GILLT_v8s8*//*Label 7058*/ GIMT_Encode4(355205),
     /* 354656 */ /*GILLT_v8s16*//*Label 7059*/ GIMT_Encode4(355232),
     /* 354660 */ /*GILLT_v16s8*//*Label 7060*/ GIMT_Encode4(355259),
     /* 354664 */ // Label 7053: @354664
     /* 354664 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(354893),
     /* 354669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354676 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(354776), // Rule ID 3949 //
     /* 354681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 354689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 354693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 354697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 354705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 354709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 354717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 354721 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 354725 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 354729 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 354733 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 354737 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 354741 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354746 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 354750 */     // MIs[3] Rn
     /* 354750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 354755 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 354759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 354763 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 354765 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 354768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 354774 */     GIR_RootConstrainSelectedInstOperands,
     /* 354775 */     // GIR_Coverage, 3949,
     /* 354775 */     GIR_EraseRootFromParent_Done,
     /* 354776 */   // Label 7063: @354776
     /* 354776 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(354876), // Rule ID 13508 //
     /* 354781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 354789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 354793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 354797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 354805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 354809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 354817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 354821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 354825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 354829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 354838 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 354842 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 354846 */     // MIs[4] Rn
     /* 354846 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 354851 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 354855 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 354859 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 354863 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 354865 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 354868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 354874 */     GIR_RootConstrainSelectedInstOperands,
     /* 354875 */     // GIR_Coverage, 13508,
     /* 354875 */     GIR_EraseRootFromParent_Done,
     /* 354876 */   // Label 7064: @354876
     /* 354876 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(354892), // Rule ID 180 //
     /* 354881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354885 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 354890 */     GIR_RootConstrainSelectedInstOperands,
     /* 354891 */     // GIR_Coverage, 180,
     /* 354891 */     GIR_Done,
     /* 354892 */   // Label 7065: @354892
     /* 354892 */   GIM_Reject,
     /* 354893 */ // Label 7062: @354893
     /* 354893 */ GIM_Reject,
     /* 354894 */ // Label 7054: @354894
     /* 354894 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(355123),
     /* 354899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 354902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354906 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(355006), // Rule ID 3950 //
     /* 354911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 354919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 354923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 354935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 354939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 354947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 354951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 354955 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 354959 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 354963 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 354967 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 354971 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354976 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 354980 */     // MIs[3] Rn
     /* 354980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 354985 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 354989 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 354993 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 354995 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 354995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 354998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 355004 */     GIR_RootConstrainSelectedInstOperands,
     /* 355005 */     // GIR_Coverage, 3950,
     /* 355005 */     GIR_EraseRootFromParent_Done,
     /* 355006 */   // Label 7067: @355006
     /* 355006 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(355106), // Rule ID 13509 //
     /* 355011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 355019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 355035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 355039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 355047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 355051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 355055 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 355059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 355068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 355072 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 355076 */     // MIs[4] Rn
     /* 355076 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 355081 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 355085 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355093 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355095 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 355098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 355104 */     GIR_RootConstrainSelectedInstOperands,
     /* 355105 */     // GIR_Coverage, 13509,
     /* 355105 */     GIR_EraseRootFromParent_Done,
     /* 355106 */   // Label 7068: @355106
     /* 355106 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(355122), // Rule ID 181 //
     /* 355111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355115 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 355120 */     GIR_RootConstrainSelectedInstOperands,
     /* 355121 */     // GIR_Coverage, 181,
     /* 355121 */     GIR_Done,
     /* 355122 */   // Label 7069: @355122
     /* 355122 */   GIM_Reject,
     /* 355123 */ // Label 7066: @355123
     /* 355123 */ GIM_Reject,
     /* 355124 */ // Label 7055: @355124
     /* 355124 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(355150), // Rule ID 720 //
     /* 355129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355143 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 355143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 355148 */   GIR_RootConstrainSelectedInstOperands,
     /* 355149 */   // GIR_Coverage, 720,
     /* 355149 */   GIR_Done,
     /* 355150 */ // Label 7070: @355150
     /* 355150 */ GIM_Reject,
     /* 355151 */ // Label 7056: @355151
     /* 355151 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(355177), // Rule ID 718 //
     /* 355156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355170 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 355170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 355175 */   GIR_RootConstrainSelectedInstOperands,
     /* 355176 */   // GIR_Coverage, 718,
     /* 355176 */   GIR_Done,
     /* 355177 */ // Label 7071: @355177
     /* 355177 */ GIM_Reject,
     /* 355178 */ // Label 7057: @355178
     /* 355178 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(355204), // Rule ID 721 //
     /* 355183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355197 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 355197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 355202 */   GIR_RootConstrainSelectedInstOperands,
     /* 355203 */   // GIR_Coverage, 721,
     /* 355203 */   GIR_Done,
     /* 355204 */ // Label 7072: @355204
     /* 355204 */ GIM_Reject,
     /* 355205 */ // Label 7058: @355205
     /* 355205 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(355231), // Rule ID 716 //
     /* 355210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355224 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 355229 */   GIR_RootConstrainSelectedInstOperands,
     /* 355230 */   // GIR_Coverage, 716,
     /* 355230 */   GIR_Done,
     /* 355231 */ // Label 7073: @355231
     /* 355231 */ GIM_Reject,
     /* 355232 */ // Label 7059: @355232
     /* 355232 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(355258), // Rule ID 719 //
     /* 355237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355251 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 355251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 355256 */   GIR_RootConstrainSelectedInstOperands,
     /* 355257 */   // GIR_Coverage, 719,
     /* 355257 */   GIR_Done,
     /* 355258 */ // Label 7074: @355258
     /* 355258 */ GIM_Reject,
     /* 355259 */ // Label 7060: @355259
     /* 355259 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(355285), // Rule ID 717 //
     /* 355264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355278 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 355283 */   GIR_RootConstrainSelectedInstOperands,
     /* 355284 */   // GIR_Coverage, 717,
     /* 355284 */   GIR_Done,
     /* 355285 */ // Label 7075: @355285
     /* 355285 */ GIM_Reject,
     /* 355286 */ // Label 7061: @355286
     /* 355286 */ GIM_Reject,
     /* 355287 */ // Label 90: @355287
     /* 355287 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7080*/ GIMT_Encode4(355446),
     /* 355298 */ /*GILLT_s32*//*Label 7076*/ GIMT_Encode4(355338),
     /* 355302 */ /*GILLT_s64*//*Label 7077*/ GIMT_Encode4(355365), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 355326 */ /*GILLT_v8s8*//*Label 7078*/ GIMT_Encode4(355392), GIMT_Encode4(0),
     /* 355334 */ /*GILLT_v16s8*//*Label 7079*/ GIMT_Encode4(355419),
     /* 355338 */ // Label 7076: @355338
     /* 355338 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(355364), // Rule ID 2310 //
     /* 355343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355357 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 355362 */   GIR_RootConstrainSelectedInstOperands,
     /* 355363 */   // GIR_Coverage, 2310,
     /* 355363 */   GIR_Done,
     /* 355364 */ // Label 7081: @355364
     /* 355364 */ GIM_Reject,
     /* 355365 */ // Label 7077: @355365
     /* 355365 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(355391), // Rule ID 2311 //
     /* 355370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355384 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 355389 */   GIR_RootConstrainSelectedInstOperands,
     /* 355390 */   // GIR_Coverage, 2311,
     /* 355390 */   GIR_Done,
     /* 355391 */ // Label 7082: @355391
     /* 355391 */ GIM_Reject,
     /* 355392 */ // Label 7078: @355392
     /* 355392 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(355418), // Rule ID 757 //
     /* 355397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355411 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 355416 */   GIR_RootConstrainSelectedInstOperands,
     /* 355417 */   // GIR_Coverage, 757,
     /* 355417 */   GIR_Done,
     /* 355418 */ // Label 7083: @355418
     /* 355418 */ GIM_Reject,
     /* 355419 */ // Label 7079: @355419
     /* 355419 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(355445), // Rule ID 758 //
     /* 355424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355438 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 355443 */   GIR_RootConstrainSelectedInstOperands,
     /* 355444 */   // GIR_Coverage, 758,
     /* 355444 */   GIR_Done,
     /* 355445 */ // Label 7084: @355445
     /* 355445 */ GIM_Reject,
     /* 355446 */ // Label 7080: @355446
     /* 355446 */ GIM_Reject,
     /* 355447 */ // Label 91: @355447
     /* 355447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7092*/ GIMT_Encode4(355760),
     /* 355458 */ /*GILLT_s32*//*Label 7085*/ GIMT_Encode4(355494),
     /* 355462 */ /*GILLT_s64*//*Label 7086*/ GIMT_Encode4(355567), GIMT_Encode4(0),
     /* 355470 */ /*GILLT_v2s32*//*Label 7087*/ GIMT_Encode4(355640),
     /* 355474 */ /*GILLT_v2s64*//*Label 7088*/ GIMT_Encode4(355664),
     /* 355478 */ /*GILLT_v4s16*//*Label 7089*/ GIMT_Encode4(355688),
     /* 355482 */ /*GILLT_v4s32*//*Label 7090*/ GIMT_Encode4(355712), GIMT_Encode4(0),
     /* 355490 */ /*GILLT_v8s16*//*Label 7091*/ GIMT_Encode4(355736),
     /* 355494 */ // Label 7085: @355494
     /* 355494 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(355566),
     /* 355499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355506 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(355549), // Rule ID 3953 //
     /* 355511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 355519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 355536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355538 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 355541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355547 */     GIR_RootConstrainSelectedInstOperands,
     /* 355548 */     // GIR_Coverage, 3953,
     /* 355548 */     GIR_EraseRootFromParent_Done,
     /* 355549 */   // Label 7094: @355549
     /* 355549 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(355565), // Rule ID 185 //
     /* 355554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355558 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 355563 */     GIR_RootConstrainSelectedInstOperands,
     /* 355564 */     // GIR_Coverage, 185,
     /* 355564 */     GIR_Done,
     /* 355565 */   // Label 7095: @355565
     /* 355565 */   GIM_Reject,
     /* 355566 */ // Label 7093: @355566
     /* 355566 */ GIM_Reject,
     /* 355567 */ // Label 7086: @355567
     /* 355567 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(355639),
     /* 355572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355579 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(355622), // Rule ID 3954 //
     /* 355584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 355592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 355609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355611 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 355614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355620 */     GIR_RootConstrainSelectedInstOperands,
     /* 355621 */     // GIR_Coverage, 3954,
     /* 355621 */     GIR_EraseRootFromParent_Done,
     /* 355622 */   // Label 7097: @355622
     /* 355622 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(355638), // Rule ID 186 //
     /* 355627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355631 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 355636 */     GIR_RootConstrainSelectedInstOperands,
     /* 355637 */     // GIR_Coverage, 186,
     /* 355637 */     GIR_Done,
     /* 355638 */   // Label 7098: @355638
     /* 355638 */   GIM_Reject,
     /* 355639 */ // Label 7096: @355639
     /* 355639 */ GIM_Reject,
     /* 355640 */ // Label 7087: @355640
     /* 355640 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(355663), // Rule ID 4928 //
     /* 355645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355656 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 355656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 355661 */   GIR_RootConstrainSelectedInstOperands,
     /* 355662 */   // GIR_Coverage, 4928,
     /* 355662 */   GIR_Done,
     /* 355663 */ // Label 7099: @355663
     /* 355663 */ GIM_Reject,
     /* 355664 */ // Label 7088: @355664
     /* 355664 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(355687), // Rule ID 4930 //
     /* 355669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355680 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 355680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 355685 */   GIR_RootConstrainSelectedInstOperands,
     /* 355686 */   // GIR_Coverage, 4930,
     /* 355686 */   GIR_Done,
     /* 355687 */ // Label 7100: @355687
     /* 355687 */ GIM_Reject,
     /* 355688 */ // Label 7089: @355688
     /* 355688 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(355711), // Rule ID 4926 //
     /* 355693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355704 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 355704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 355709 */   GIR_RootConstrainSelectedInstOperands,
     /* 355710 */   // GIR_Coverage, 4926,
     /* 355710 */   GIR_Done,
     /* 355711 */ // Label 7101: @355711
     /* 355711 */ GIM_Reject,
     /* 355712 */ // Label 7090: @355712
     /* 355712 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(355735), // Rule ID 4929 //
     /* 355717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355728 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 355728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 355733 */   GIR_RootConstrainSelectedInstOperands,
     /* 355734 */   // GIR_Coverage, 4929,
     /* 355734 */   GIR_Done,
     /* 355735 */ // Label 7102: @355735
     /* 355735 */ GIM_Reject,
     /* 355736 */ // Label 7091: @355736
     /* 355736 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(355759), // Rule ID 4927 //
     /* 355741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355752 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 355752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 355757 */   GIR_RootConstrainSelectedInstOperands,
     /* 355758 */   // GIR_Coverage, 4927,
     /* 355758 */   GIR_Done,
     /* 355759 */ // Label 7103: @355759
     /* 355759 */ GIM_Reject,
     /* 355760 */ // Label 7092: @355760
     /* 355760 */ GIM_Reject,
     /* 355761 */ // Label 92: @355761
     /* 355761 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7108*/ GIMT_Encode4(355914),
     /* 355772 */ /*GILLT_s32*//*Label 7104*/ GIMT_Encode4(355812),
     /* 355776 */ /*GILLT_s64*//*Label 7105*/ GIMT_Encode4(355836), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 355800 */ /*GILLT_v8s8*//*Label 7106*/ GIMT_Encode4(355860), GIMT_Encode4(0),
     /* 355808 */ /*GILLT_v16s8*//*Label 7107*/ GIMT_Encode4(355887),
     /* 355812 */ // Label 7104: @355812
     /* 355812 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(355835), // Rule ID 182 //
     /* 355817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355828 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 355833 */   GIR_RootConstrainSelectedInstOperands,
     /* 355834 */   // GIR_Coverage, 182,
     /* 355834 */   GIR_Done,
     /* 355835 */ // Label 7109: @355835
     /* 355835 */ GIM_Reject,
     /* 355836 */ // Label 7105: @355836
     /* 355836 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(355859), // Rule ID 183 //
     /* 355841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355852 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 355857 */   GIR_RootConstrainSelectedInstOperands,
     /* 355858 */   // GIR_Coverage, 183,
     /* 355858 */   GIR_Done,
     /* 355859 */ // Label 7110: @355859
     /* 355859 */ GIM_Reject,
     /* 355860 */ // Label 7106: @355860
     /* 355860 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(355886), // Rule ID 967 //
     /* 355865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355879 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 355884 */   GIR_RootConstrainSelectedInstOperands,
     /* 355885 */   // GIR_Coverage, 967,
     /* 355885 */   GIR_Done,
     /* 355886 */ // Label 7111: @355886
     /* 355886 */ GIM_Reject,
     /* 355887 */ // Label 7107: @355887
     /* 355887 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(355913), // Rule ID 968 //
     /* 355892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355906 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 355911 */   GIR_RootConstrainSelectedInstOperands,
     /* 355912 */   // GIR_Coverage, 968,
     /* 355912 */   GIR_Done,
     /* 355913 */ // Label 7112: @355913
     /* 355913 */ GIM_Reject,
     /* 355914 */ // Label 7108: @355914
     /* 355914 */ GIM_Reject,
     /* 355915 */ // Label 93: @355915
     /* 355915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7121*/ GIMT_Encode4(356405),
     /* 355926 */ /*GILLT_s16*//*Label 7113*/ GIMT_Encode4(355966),
     /* 355930 */ /*GILLT_s32*//*Label 7114*/ GIMT_Encode4(355997),
     /* 355934 */ /*GILLT_s64*//*Label 7115*/ GIMT_Encode4(356028), GIMT_Encode4(0),
     /* 355942 */ /*GILLT_v2s32*//*Label 7116*/ GIMT_Encode4(356059),
     /* 355946 */ /*GILLT_v2s64*//*Label 7117*/ GIMT_Encode4(356090),
     /* 355950 */ /*GILLT_v4s16*//*Label 7118*/ GIMT_Encode4(356121),
     /* 355954 */ /*GILLT_v4s32*//*Label 7119*/ GIMT_Encode4(356152), GIMT_Encode4(0),
     /* 355962 */ /*GILLT_v8s16*//*Label 7120*/ GIMT_Encode4(356183),
     /* 355966 */ // Label 7113: @355966
     /* 355966 */ GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(355996), // Rule ID 552 //
     /* 355971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 355974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 355977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355985 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 355985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 355990 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 355994 */   GIR_RootConstrainSelectedInstOperands,
     /* 355995 */   // GIR_Coverage, 552,
     /* 355995 */   GIR_Done,
     /* 355996 */ // Label 7122: @355996
     /* 355996 */ GIM_Reject,
     /* 355997 */ // Label 7114: @355997
     /* 355997 */ GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(356027), // Rule ID 554 //
     /* 356002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356016 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 356021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356025 */   GIR_RootConstrainSelectedInstOperands,
     /* 356026 */   // GIR_Coverage, 554,
     /* 356026 */   GIR_Done,
     /* 356027 */ // Label 7123: @356027
     /* 356027 */ GIM_Reject,
     /* 356028 */ // Label 7115: @356028
     /* 356028 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(356058), // Rule ID 556 //
     /* 356033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356047 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 356052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356056 */   GIR_RootConstrainSelectedInstOperands,
     /* 356057 */   // GIR_Coverage, 556,
     /* 356057 */   GIR_Done,
     /* 356058 */ // Label 7124: @356058
     /* 356058 */ GIM_Reject,
     /* 356059 */ // Label 7116: @356059
     /* 356059 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(356089), // Rule ID 906 //
     /* 356064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356078 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 356083 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356087 */   GIR_RootConstrainSelectedInstOperands,
     /* 356088 */   // GIR_Coverage, 906,
     /* 356088 */   GIR_Done,
     /* 356089 */ // Label 7125: @356089
     /* 356089 */ GIM_Reject,
     /* 356090 */ // Label 7117: @356090
     /* 356090 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(356120), // Rule ID 910 //
     /* 356095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356109 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 356114 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356118 */   GIR_RootConstrainSelectedInstOperands,
     /* 356119 */   // GIR_Coverage, 910,
     /* 356119 */   GIR_Done,
     /* 356120 */ // Label 7126: @356120
     /* 356120 */ GIM_Reject,
     /* 356121 */ // Label 7118: @356121
     /* 356121 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(356151), // Rule ID 902 //
     /* 356126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356140 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 356145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356149 */   GIR_RootConstrainSelectedInstOperands,
     /* 356150 */   // GIR_Coverage, 902,
     /* 356150 */   GIR_Done,
     /* 356151 */ // Label 7127: @356151
     /* 356151 */ GIM_Reject,
     /* 356152 */ // Label 7119: @356152
     /* 356152 */ GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(356182), // Rule ID 908 //
     /* 356157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356171 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356176 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356180 */   GIR_RootConstrainSelectedInstOperands,
     /* 356181 */   // GIR_Coverage, 908,
     /* 356181 */   GIR_Done,
     /* 356182 */ // Label 7128: @356182
     /* 356182 */ GIM_Reject,
     /* 356183 */ // Label 7120: @356183
     /* 356183 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(356404),
     /* 356188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356199 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(356218), // Rule ID 904 //
     /* 356204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356207 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 356207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 356212 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356216 */     GIR_RootConstrainSelectedInstOperands,
     /* 356217 */     // GIR_Coverage, 904,
     /* 356217 */     GIR_Done,
     /* 356218 */   // Label 7130: @356218
     /* 356218 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(356403), // Rule ID 6900 //
     /* 356223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 356226 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 356226 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 356229 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 356233 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356238 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 356244 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 356247 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356251 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356256 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 356259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 356261 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 356264 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356268 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356273 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 356279 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356284 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356289 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 356292 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 356296 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356301 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 356304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356306 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 356309 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356313 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356318 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356323 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 356326 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 356330 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356335 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 356338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356366 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356369 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 356375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 356393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 356401 */     GIR_RootConstrainSelectedInstOperands,
     /* 356402 */     // GIR_Coverage, 6900,
     /* 356402 */     GIR_EraseRootFromParent_Done,
     /* 356403 */   // Label 7131: @356403
     /* 356403 */   GIM_Reject,
     /* 356404 */ // Label 7129: @356404
     /* 356404 */ GIM_Reject,
     /* 356405 */ // Label 7121: @356405
     /* 356405 */ GIM_Reject,
     /* 356406 */ // Label 94: @356406
     /* 356406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7140*/ GIMT_Encode4(356705),
     /* 356417 */ /*GILLT_s16*//*Label 7132*/ GIMT_Encode4(356457),
     /* 356421 */ /*GILLT_s32*//*Label 7133*/ GIMT_Encode4(356488),
     /* 356425 */ /*GILLT_s64*//*Label 7134*/ GIMT_Encode4(356519), GIMT_Encode4(0),
     /* 356433 */ /*GILLT_v2s32*//*Label 7135*/ GIMT_Encode4(356550),
     /* 356437 */ /*GILLT_v2s64*//*Label 7136*/ GIMT_Encode4(356581),
     /* 356441 */ /*GILLT_v4s16*//*Label 7137*/ GIMT_Encode4(356612),
     /* 356445 */ /*GILLT_v4s32*//*Label 7138*/ GIMT_Encode4(356643), GIMT_Encode4(0),
     /* 356453 */ /*GILLT_v8s16*//*Label 7139*/ GIMT_Encode4(356674),
     /* 356457 */ // Label 7132: @356457
     /* 356457 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(356487), // Rule ID 570 //
     /* 356462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 356465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356476 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 356481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356485 */   GIR_RootConstrainSelectedInstOperands,
     /* 356486 */   // GIR_Coverage, 570,
     /* 356486 */   GIR_Done,
     /* 356487 */ // Label 7141: @356487
     /* 356487 */ GIM_Reject,
     /* 356488 */ // Label 7133: @356488
     /* 356488 */ GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(356518), // Rule ID 572 //
     /* 356493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356507 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 356512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356516 */   GIR_RootConstrainSelectedInstOperands,
     /* 356517 */   // GIR_Coverage, 572,
     /* 356517 */   GIR_Done,
     /* 356518 */ // Label 7142: @356518
     /* 356518 */ GIM_Reject,
     /* 356519 */ // Label 7134: @356519
     /* 356519 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(356549), // Rule ID 574 //
     /* 356524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356538 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 356543 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356547 */   GIR_RootConstrainSelectedInstOperands,
     /* 356548 */   // GIR_Coverage, 574,
     /* 356548 */   GIR_Done,
     /* 356549 */ // Label 7143: @356549
     /* 356549 */ GIM_Reject,
     /* 356550 */ // Label 7135: @356550
     /* 356550 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(356580), // Rule ID 953 //
     /* 356555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356569 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 356574 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356578 */   GIR_RootConstrainSelectedInstOperands,
     /* 356579 */   // GIR_Coverage, 953,
     /* 356579 */   GIR_Done,
     /* 356580 */ // Label 7144: @356580
     /* 356580 */ GIM_Reject,
     /* 356581 */ // Label 7136: @356581
     /* 356581 */ GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(356611), // Rule ID 957 //
     /* 356586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356600 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 356605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356609 */   GIR_RootConstrainSelectedInstOperands,
     /* 356610 */   // GIR_Coverage, 957,
     /* 356610 */   GIR_Done,
     /* 356611 */ // Label 7145: @356611
     /* 356611 */ GIM_Reject,
     /* 356612 */ // Label 7137: @356612
     /* 356612 */ GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(356642), // Rule ID 949 //
     /* 356617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356631 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 356636 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356640 */   GIR_RootConstrainSelectedInstOperands,
     /* 356641 */   // GIR_Coverage, 949,
     /* 356641 */   GIR_Done,
     /* 356642 */ // Label 7146: @356642
     /* 356642 */ GIM_Reject,
     /* 356643 */ // Label 7138: @356643
     /* 356643 */ GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(356673), // Rule ID 955 //
     /* 356648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356662 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 356667 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356671 */   GIR_RootConstrainSelectedInstOperands,
     /* 356672 */   // GIR_Coverage, 955,
     /* 356672 */   GIR_Done,
     /* 356673 */ // Label 7147: @356673
     /* 356673 */ GIM_Reject,
     /* 356674 */ // Label 7139: @356674
     /* 356674 */ GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(356704), // Rule ID 951 //
     /* 356679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356693 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 356693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 356698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356702 */   GIR_RootConstrainSelectedInstOperands,
     /* 356703 */   // GIR_Coverage, 951,
     /* 356703 */   GIR_Done,
     /* 356704 */ // Label 7148: @356704
     /* 356704 */ GIM_Reject,
     /* 356705 */ // Label 7140: @356705
     /* 356705 */ GIM_Reject,
     /* 356706 */ // Label 95: @356706
     /* 356706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7157*/ GIMT_Encode4(357196),
     /* 356717 */ /*GILLT_s16*//*Label 7149*/ GIMT_Encode4(356757),
     /* 356721 */ /*GILLT_s32*//*Label 7150*/ GIMT_Encode4(356788),
     /* 356725 */ /*GILLT_s64*//*Label 7151*/ GIMT_Encode4(356819), GIMT_Encode4(0),
     /* 356733 */ /*GILLT_v2s32*//*Label 7152*/ GIMT_Encode4(356850),
     /* 356737 */ /*GILLT_v2s64*//*Label 7153*/ GIMT_Encode4(356881),
     /* 356741 */ /*GILLT_v4s16*//*Label 7154*/ GIMT_Encode4(356912),
     /* 356745 */ /*GILLT_v4s32*//*Label 7155*/ GIMT_Encode4(356943), GIMT_Encode4(0),
     /* 356753 */ /*GILLT_v8s16*//*Label 7156*/ GIMT_Encode4(356974),
     /* 356757 */ // Label 7149: @356757
     /* 356757 */ GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356787), // Rule ID 540 //
     /* 356762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 356765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356776 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 356781 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356785 */   GIR_RootConstrainSelectedInstOperands,
     /* 356786 */   // GIR_Coverage, 540,
     /* 356786 */   GIR_Done,
     /* 356787 */ // Label 7158: @356787
     /* 356787 */ GIM_Reject,
     /* 356788 */ // Label 7150: @356788
     /* 356788 */ GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356818), // Rule ID 542 //
     /* 356793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356807 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 356812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356816 */   GIR_RootConstrainSelectedInstOperands,
     /* 356817 */   // GIR_Coverage, 542,
     /* 356817 */   GIR_Done,
     /* 356818 */ // Label 7159: @356818
     /* 356818 */ GIM_Reject,
     /* 356819 */ // Label 7151: @356819
     /* 356819 */ GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356849), // Rule ID 544 //
     /* 356824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356838 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 356843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356847 */   GIR_RootConstrainSelectedInstOperands,
     /* 356848 */   // GIR_Coverage, 544,
     /* 356848 */   GIR_Done,
     /* 356849 */ // Label 7160: @356849
     /* 356849 */ GIM_Reject,
     /* 356850 */ // Label 7152: @356850
     /* 356850 */ GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(356880), // Rule ID 886 //
     /* 356855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356869 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 356874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356878 */   GIR_RootConstrainSelectedInstOperands,
     /* 356879 */   // GIR_Coverage, 886,
     /* 356879 */   GIR_Done,
     /* 356880 */ // Label 7161: @356880
     /* 356880 */ GIM_Reject,
     /* 356881 */ // Label 7153: @356881
     /* 356881 */ GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(356911), // Rule ID 890 //
     /* 356886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356900 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 356905 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356909 */   GIR_RootConstrainSelectedInstOperands,
     /* 356910 */   // GIR_Coverage, 890,
     /* 356910 */   GIR_Done,
     /* 356911 */ // Label 7162: @356911
     /* 356911 */ GIM_Reject,
     /* 356912 */ // Label 7154: @356912
     /* 356912 */ GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(356942), // Rule ID 882 //
     /* 356917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356931 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 356936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356940 */   GIR_RootConstrainSelectedInstOperands,
     /* 356941 */   // GIR_Coverage, 882,
     /* 356941 */   GIR_Done,
     /* 356942 */ // Label 7163: @356942
     /* 356942 */ GIM_Reject,
     /* 356943 */ // Label 7155: @356943
     /* 356943 */ GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(356973), // Rule ID 888 //
     /* 356948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356962 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 356967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356971 */   GIR_RootConstrainSelectedInstOperands,
     /* 356972 */   // GIR_Coverage, 888,
     /* 356972 */   GIR_Done,
     /* 356973 */ // Label 7164: @356973
     /* 356973 */ GIM_Reject,
     /* 356974 */ // Label 7156: @356974
     /* 356974 */ GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(357195),
     /* 356979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356990 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357009), // Rule ID 884 //
     /* 356995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356998 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 356998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 357003 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357007 */     GIR_RootConstrainSelectedInstOperands,
     /* 357008 */     // GIR_Coverage, 884,
     /* 357008 */     GIR_Done,
     /* 357009 */   // Label 7166: @357009
     /* 357009 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357194), // Rule ID 6902 //
     /* 357014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357017 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357017 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 357020 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 357024 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357029 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 357035 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 357038 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357042 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357047 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 357050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 357052 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 357055 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357059 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357064 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 357070 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357075 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357080 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357083 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 357087 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357092 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 357095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357097 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357100 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357104 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357109 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357114 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 357117 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 357121 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357126 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 357129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 357184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 357192 */     GIR_RootConstrainSelectedInstOperands,
     /* 357193 */     // GIR_Coverage, 6902,
     /* 357193 */     GIR_EraseRootFromParent_Done,
     /* 357194 */   // Label 7167: @357194
     /* 357194 */   GIM_Reject,
     /* 357195 */ // Label 7165: @357195
     /* 357195 */ GIM_Reject,
     /* 357196 */ // Label 7157: @357196
     /* 357196 */ GIM_Reject,
     /* 357197 */ // Label 96: @357197
     /* 357197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7176*/ GIMT_Encode4(357687),
     /* 357208 */ /*GILLT_s16*//*Label 7168*/ GIMT_Encode4(357248),
     /* 357212 */ /*GILLT_s32*//*Label 7169*/ GIMT_Encode4(357279),
     /* 357216 */ /*GILLT_s64*//*Label 7170*/ GIMT_Encode4(357310), GIMT_Encode4(0),
     /* 357224 */ /*GILLT_v2s32*//*Label 7171*/ GIMT_Encode4(357341),
     /* 357228 */ /*GILLT_v2s64*//*Label 7172*/ GIMT_Encode4(357372),
     /* 357232 */ /*GILLT_v4s16*//*Label 7173*/ GIMT_Encode4(357403),
     /* 357236 */ /*GILLT_v4s32*//*Label 7174*/ GIMT_Encode4(357434), GIMT_Encode4(0),
     /* 357244 */ /*GILLT_v8s16*//*Label 7175*/ GIMT_Encode4(357465),
     /* 357248 */ // Label 7168: @357248
     /* 357248 */ GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(357278), // Rule ID 558 //
     /* 357253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 357256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357267 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 357267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 357272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357276 */   GIR_RootConstrainSelectedInstOperands,
     /* 357277 */   // GIR_Coverage, 558,
     /* 357277 */   GIR_Done,
     /* 357278 */ // Label 7177: @357278
     /* 357278 */ GIM_Reject,
     /* 357279 */ // Label 7169: @357279
     /* 357279 */ GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(357309), // Rule ID 560 //
     /* 357284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357298 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 357298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 357303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357307 */   GIR_RootConstrainSelectedInstOperands,
     /* 357308 */   // GIR_Coverage, 560,
     /* 357308 */   GIR_Done,
     /* 357309 */ // Label 7178: @357309
     /* 357309 */ GIM_Reject,
     /* 357310 */ // Label 7170: @357310
     /* 357310 */ GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(357340), // Rule ID 562 //
     /* 357315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357329 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 357329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 357334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357338 */   GIR_RootConstrainSelectedInstOperands,
     /* 357339 */   // GIR_Coverage, 562,
     /* 357339 */   GIR_Done,
     /* 357340 */ // Label 7179: @357340
     /* 357340 */ GIM_Reject,
     /* 357341 */ // Label 7171: @357341
     /* 357341 */ GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(357371), // Rule ID 916 //
     /* 357346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357360 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 357365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357369 */   GIR_RootConstrainSelectedInstOperands,
     /* 357370 */   // GIR_Coverage, 916,
     /* 357370 */   GIR_Done,
     /* 357371 */ // Label 7180: @357371
     /* 357371 */ GIM_Reject,
     /* 357372 */ // Label 7172: @357372
     /* 357372 */ GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(357402), // Rule ID 920 //
     /* 357377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357391 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 357396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357400 */   GIR_RootConstrainSelectedInstOperands,
     /* 357401 */   // GIR_Coverage, 920,
     /* 357401 */   GIR_Done,
     /* 357402 */ // Label 7181: @357402
     /* 357402 */ GIM_Reject,
     /* 357403 */ // Label 7173: @357403
     /* 357403 */ GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(357433), // Rule ID 912 //
     /* 357408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357422 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 357427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357431 */   GIR_RootConstrainSelectedInstOperands,
     /* 357432 */   // GIR_Coverage, 912,
     /* 357432 */   GIR_Done,
     /* 357433 */ // Label 7182: @357433
     /* 357433 */ GIM_Reject,
     /* 357434 */ // Label 7174: @357434
     /* 357434 */ GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(357464), // Rule ID 918 //
     /* 357439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357453 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357462 */   GIR_RootConstrainSelectedInstOperands,
     /* 357463 */   // GIR_Coverage, 918,
     /* 357463 */   GIR_Done,
     /* 357464 */ // Label 7183: @357464
     /* 357464 */ GIM_Reject,
     /* 357465 */ // Label 7175: @357465
     /* 357465 */ GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(357686),
     /* 357470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357481 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(357500), // Rule ID 914 //
     /* 357486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357489 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 357494 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357498 */     GIR_RootConstrainSelectedInstOperands,
     /* 357499 */     // GIR_Coverage, 914,
     /* 357499 */     GIR_Done,
     /* 357500 */   // Label 7185: @357500
     /* 357500 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(357685), // Rule ID 6910 //
     /* 357505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357508 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357508 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 357511 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 357515 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357520 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 357526 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 357529 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357533 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357538 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 357541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 357543 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 357546 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357550 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357555 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 357561 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357566 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357571 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357574 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 357578 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357583 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 357586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357588 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357591 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357595 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357600 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357605 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 357608 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 357612 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357617 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 357620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357648 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357654 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 357675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 357683 */     GIR_RootConstrainSelectedInstOperands,
     /* 357684 */     // GIR_Coverage, 6910,
     /* 357684 */     GIR_EraseRootFromParent_Done,
     /* 357685 */   // Label 7186: @357685
     /* 357685 */   GIM_Reject,
     /* 357686 */ // Label 7184: @357686
     /* 357686 */ GIM_Reject,
     /* 357687 */ // Label 7176: @357687
     /* 357687 */ GIM_Reject,
     /* 357688 */ // Label 97: @357688
     /* 357688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7195*/ GIMT_Encode4(358178),
     /* 357699 */ /*GILLT_s16*//*Label 7187*/ GIMT_Encode4(357739),
     /* 357703 */ /*GILLT_s32*//*Label 7188*/ GIMT_Encode4(357770),
     /* 357707 */ /*GILLT_s64*//*Label 7189*/ GIMT_Encode4(357801), GIMT_Encode4(0),
     /* 357715 */ /*GILLT_v2s32*//*Label 7190*/ GIMT_Encode4(357832),
     /* 357719 */ /*GILLT_v2s64*//*Label 7191*/ GIMT_Encode4(357863),
     /* 357723 */ /*GILLT_v4s16*//*Label 7192*/ GIMT_Encode4(357894),
     /* 357727 */ /*GILLT_v4s32*//*Label 7193*/ GIMT_Encode4(357925), GIMT_Encode4(0),
     /* 357735 */ /*GILLT_v8s16*//*Label 7194*/ GIMT_Encode4(357956),
     /* 357739 */ // Label 7187: @357739
     /* 357739 */ GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(357769), // Rule ID 534 //
     /* 357744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 357747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357758 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 357758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 357763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357767 */   GIR_RootConstrainSelectedInstOperands,
     /* 357768 */   // GIR_Coverage, 534,
     /* 357768 */   GIR_Done,
     /* 357769 */ // Label 7196: @357769
     /* 357769 */ GIM_Reject,
     /* 357770 */ // Label 7188: @357770
     /* 357770 */ GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(357800), // Rule ID 536 //
     /* 357775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357789 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 357789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 357794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357798 */   GIR_RootConstrainSelectedInstOperands,
     /* 357799 */   // GIR_Coverage, 536,
     /* 357799 */   GIR_Done,
     /* 357800 */ // Label 7197: @357800
     /* 357800 */ GIM_Reject,
     /* 357801 */ // Label 7189: @357801
     /* 357801 */ GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(357831), // Rule ID 538 //
     /* 357806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357820 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 357820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 357825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357829 */   GIR_RootConstrainSelectedInstOperands,
     /* 357830 */   // GIR_Coverage, 538,
     /* 357830 */   GIR_Done,
     /* 357831 */ // Label 7198: @357831
     /* 357831 */ GIM_Reject,
     /* 357832 */ // Label 7190: @357832
     /* 357832 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(357862), // Rule ID 876 //
     /* 357837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357851 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 357856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357860 */   GIR_RootConstrainSelectedInstOperands,
     /* 357861 */   // GIR_Coverage, 876,
     /* 357861 */   GIR_Done,
     /* 357862 */ // Label 7199: @357862
     /* 357862 */ GIM_Reject,
     /* 357863 */ // Label 7191: @357863
     /* 357863 */ GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(357893), // Rule ID 880 //
     /* 357868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357882 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 357887 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357891 */   GIR_RootConstrainSelectedInstOperands,
     /* 357892 */   // GIR_Coverage, 880,
     /* 357892 */   GIR_Done,
     /* 357893 */ // Label 7200: @357893
     /* 357893 */ GIM_Reject,
     /* 357894 */ // Label 7192: @357894
     /* 357894 */ GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(357924), // Rule ID 872 //
     /* 357899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357913 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 357918 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357922 */   GIR_RootConstrainSelectedInstOperands,
     /* 357923 */   // GIR_Coverage, 872,
     /* 357923 */   GIR_Done,
     /* 357924 */ // Label 7201: @357924
     /* 357924 */ GIM_Reject,
     /* 357925 */ // Label 7193: @357925
     /* 357925 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(357955), // Rule ID 878 //
     /* 357930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357944 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 357949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357953 */   GIR_RootConstrainSelectedInstOperands,
     /* 357954 */   // GIR_Coverage, 878,
     /* 357954 */   GIR_Done,
     /* 357955 */ // Label 7202: @357955
     /* 357955 */ GIM_Reject,
     /* 357956 */ // Label 7194: @357956
     /* 357956 */ GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(358177),
     /* 357961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357972 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(357991), // Rule ID 874 //
     /* 357977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357980 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 357985 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357989 */     GIR_RootConstrainSelectedInstOperands,
     /* 357990 */     // GIR_Coverage, 874,
     /* 357990 */     GIR_Done,
     /* 357991 */   // Label 7204: @357991
     /* 357991 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(358176), // Rule ID 6904 //
     /* 357996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357999 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357999 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 358002 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 358006 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358011 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 358017 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 358020 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358024 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358029 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 358032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 358034 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 358037 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358041 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358046 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358052 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358057 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358062 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 358065 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 358069 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358074 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 358077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 358079 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 358082 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358086 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358091 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358096 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 358099 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 358103 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358108 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 358111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358113 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358116 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358120 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358145 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 358148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 358166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 358174 */     GIR_RootConstrainSelectedInstOperands,
     /* 358175 */     // GIR_Coverage, 6904,
     /* 358175 */     GIR_EraseRootFromParent_Done,
     /* 358176 */   // Label 7205: @358176
     /* 358176 */   GIM_Reject,
     /* 358177 */ // Label 7203: @358177
     /* 358177 */ GIM_Reject,
     /* 358178 */ // Label 7195: @358178
     /* 358178 */ GIM_Reject,
     /* 358179 */ // Label 98: @358179
     /* 358179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7214*/ GIMT_Encode4(359304),
     /* 358190 */ /*GILLT_s16*//*Label 7206*/ GIMT_Encode4(358230),
     /* 358194 */ /*GILLT_s32*//*Label 7207*/ GIMT_Encode4(358456),
     /* 358198 */ /*GILLT_s64*//*Label 7208*/ GIMT_Encode4(358682), GIMT_Encode4(0),
     /* 358206 */ /*GILLT_v2s32*//*Label 7209*/ GIMT_Encode4(358854),
     /* 358210 */ /*GILLT_v2s64*//*Label 7210*/ GIMT_Encode4(358892),
     /* 358214 */ /*GILLT_v4s16*//*Label 7211*/ GIMT_Encode4(358930),
     /* 358218 */ /*GILLT_v4s32*//*Label 7212*/ GIMT_Encode4(358968), GIMT_Encode4(0),
     /* 358226 */ /*GILLT_v8s16*//*Label 7213*/ GIMT_Encode4(359006),
     /* 358230 */ // Label 7206: @358230
     /* 358230 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(358455),
     /* 358235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 358238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358245 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(358336), // Rule ID 6824 //
     /* 358250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358287 */     // MIs[2] Rn
     /* 358287 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358292 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358298 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 358298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358310 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 358329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358334 */     GIR_RootConstrainSelectedInstOperands,
     /* 358335 */     // GIR_Coverage, 6824,
     /* 358335 */     GIR_EraseRootFromParent_Done,
     /* 358336 */   // Label 7216: @358336
     /* 358336 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(358427), // Rule ID 13649 //
     /* 358341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358362 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358378 */     // MIs[2] Rn
     /* 358378 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358389 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 358389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 358420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358425 */     GIR_RootConstrainSelectedInstOperands,
     /* 358426 */     // GIR_Coverage, 13649,
     /* 358426 */     GIR_EraseRootFromParent_Done,
     /* 358427 */   // Label 7217: @358427
     /* 358427 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(358454), // Rule ID 583 //
     /* 358432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 358435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358443 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 358443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 358448 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358452 */     GIR_RootConstrainSelectedInstOperands,
     /* 358453 */     // GIR_Coverage, 583,
     /* 358453 */     GIR_Done,
     /* 358454 */   // Label 7218: @358454
     /* 358454 */   GIM_Reject,
     /* 358455 */ // Label 7215: @358455
     /* 358455 */ GIM_Reject,
     /* 358456 */ // Label 7207: @358456
     /* 358456 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(358681),
     /* 358461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358471 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(358562), // Rule ID 6822 //
     /* 358476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358497 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358513 */     // MIs[2] Rn
     /* 358513 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358518 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358524 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 358524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 358555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358560 */     GIR_RootConstrainSelectedInstOperands,
     /* 358561 */     // GIR_Coverage, 6822,
     /* 358561 */     GIR_EraseRootFromParent_Done,
     /* 358562 */   // Label 7220: @358562
     /* 358562 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(358653), // Rule ID 13647 //
     /* 358567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358588 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358604 */     // MIs[2] Rn
     /* 358604 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358609 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358615 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 358615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358627 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 358646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358651 */     GIR_RootConstrainSelectedInstOperands,
     /* 358652 */     // GIR_Coverage, 13647,
     /* 358652 */     GIR_EraseRootFromParent_Done,
     /* 358653 */   // Label 7221: @358653
     /* 358653 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(358680), // Rule ID 585 //
     /* 358658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358669 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 358669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 358674 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358678 */     GIR_RootConstrainSelectedInstOperands,
     /* 358679 */     // GIR_Coverage, 585,
     /* 358679 */     GIR_Done,
     /* 358680 */   // Label 7222: @358680
     /* 358680 */   GIM_Reject,
     /* 358681 */ // Label 7219: @358681
     /* 358681 */ GIM_Reject,
     /* 358682 */ // Label 7208: @358682
     /* 358682 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(358853),
     /* 358687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358697 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(358761), // Rule ID 6820 //
     /* 358702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358723 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358739 */     // MIs[2] Rn
     /* 358739 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358744 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358750 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 358750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 358753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358759 */     GIR_RootConstrainSelectedInstOperands,
     /* 358760 */     // GIR_Coverage, 6820,
     /* 358760 */     GIR_EraseRootFromParent_Done,
     /* 358761 */   // Label 7224: @358761
     /* 358761 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(358825), // Rule ID 13645 //
     /* 358766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358787 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358803 */     // MIs[2] Rn
     /* 358803 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358814 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 358814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 358817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358823 */     GIR_RootConstrainSelectedInstOperands,
     /* 358824 */     // GIR_Coverage, 13645,
     /* 358824 */     GIR_EraseRootFromParent_Done,
     /* 358825 */   // Label 7225: @358825
     /* 358825 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(358852), // Rule ID 587 //
     /* 358830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358841 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 358841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 358846 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358850 */     GIR_RootConstrainSelectedInstOperands,
     /* 358851 */     // GIR_Coverage, 587,
     /* 358851 */     GIR_Done,
     /* 358852 */   // Label 7226: @358852
     /* 358852 */   GIM_Reject,
     /* 358853 */ // Label 7223: @358853
     /* 358853 */ GIM_Reject,
     /* 358854 */ // Label 7209: @358854
     /* 358854 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(358891), // Rule ID 1195 //
     /* 358859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 358868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358880 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 358880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 358885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358889 */   GIR_RootConstrainSelectedInstOperands,
     /* 358890 */   // GIR_Coverage, 1195,
     /* 358890 */   GIR_Done,
     /* 358891 */ // Label 7227: @358891
     /* 358891 */ GIM_Reject,
     /* 358892 */ // Label 7210: @358892
     /* 358892 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(358929), // Rule ID 1199 //
     /* 358897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 358906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358918 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 358918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 358923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358927 */   GIR_RootConstrainSelectedInstOperands,
     /* 358928 */   // GIR_Coverage, 1199,
     /* 358928 */   GIR_Done,
     /* 358929 */ // Label 7228: @358929
     /* 358929 */ GIM_Reject,
     /* 358930 */ // Label 7211: @358930
     /* 358930 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(358967), // Rule ID 1191 //
     /* 358935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 358938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 358941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 358944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358956 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 358956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 358961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358965 */   GIR_RootConstrainSelectedInstOperands,
     /* 358966 */   // GIR_Coverage, 1191,
     /* 358966 */   GIR_Done,
     /* 358967 */ // Label 7229: @358967
     /* 358967 */ GIM_Reject,
     /* 358968 */ // Label 7212: @358968
     /* 358968 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(359005), // Rule ID 1197 //
     /* 358973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 358982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358994 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 358994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 358999 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359003 */   GIR_RootConstrainSelectedInstOperands,
     /* 359004 */   // GIR_Coverage, 1197,
     /* 359004 */   GIR_Done,
     /* 359005 */ // Label 7230: @359005
     /* 359005 */ GIM_Reject,
     /* 359006 */ // Label 7213: @359006
     /* 359006 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(359303),
     /* 359011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 359017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359029 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(359048), // Rule ID 1193 //
     /* 359034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359037 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 359037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 359042 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359046 */     GIR_RootConstrainSelectedInstOperands,
     /* 359047 */     // GIR_Coverage, 1193,
     /* 359047 */     GIR_Done,
     /* 359048 */   // Label 7232: @359048
     /* 359048 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(359302), // Rule ID 6913 //
     /* 359053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359056 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 359056 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 359059 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359063 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359068 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 359074 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 359077 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359081 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359086 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 359092 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 359095 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359099 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359104 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 359107 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 359110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 359112 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 359115 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359119 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359124 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 359130 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359135 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359140 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359143 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359147 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359152 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359157 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359160 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359164 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359169 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359175 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359180 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359185 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359188 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359192 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359197 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359202 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359205 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359209 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359214 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359217 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 359220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359222 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 359225 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 359229 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359234 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 359237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 359292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 359300 */     GIR_RootConstrainSelectedInstOperands,
     /* 359301 */     // GIR_Coverage, 6913,
     /* 359301 */     GIR_EraseRootFromParent_Done,
     /* 359302 */   // Label 7233: @359302
     /* 359302 */   GIM_Reject,
     /* 359303 */ // Label 7231: @359303
     /* 359303 */ GIM_Reject,
     /* 359304 */ // Label 7214: @359304
     /* 359304 */ GIM_Reject,
     /* 359305 */ // Label 99: @359305
     /* 359305 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7242*/ GIMT_Encode4(359920),
     /* 359316 */ /*GILLT_s16*//*Label 7234*/ GIMT_Encode4(359356),
     /* 359320 */ /*GILLT_s32*//*Label 7235*/ GIMT_Encode4(359394),
     /* 359324 */ /*GILLT_s64*//*Label 7236*/ GIMT_Encode4(359432), GIMT_Encode4(0),
     /* 359332 */ /*GILLT_v2s32*//*Label 7237*/ GIMT_Encode4(359470),
     /* 359336 */ /*GILLT_v2s64*//*Label 7238*/ GIMT_Encode4(359508),
     /* 359340 */ /*GILLT_v4s16*//*Label 7239*/ GIMT_Encode4(359546),
     /* 359344 */ /*GILLT_v4s32*//*Label 7240*/ GIMT_Encode4(359584), GIMT_Encode4(0),
     /* 359352 */ /*GILLT_v8s16*//*Label 7241*/ GIMT_Encode4(359622),
     /* 359356 */ // Label 7234: @359356
     /* 359356 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(359393), // Rule ID 631 //
     /* 359361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 359364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359382 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 359382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 359387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359391 */   GIR_RootConstrainSelectedInstOperands,
     /* 359392 */   // GIR_Coverage, 631,
     /* 359392 */   GIR_Done,
     /* 359393 */ // Label 7243: @359393
     /* 359393 */ GIM_Reject,
     /* 359394 */ // Label 7235: @359394
     /* 359394 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(359431), // Rule ID 633 //
     /* 359399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 359405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359420 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 359420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 359425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359429 */   GIR_RootConstrainSelectedInstOperands,
     /* 359430 */   // GIR_Coverage, 633,
     /* 359430 */   GIR_Done,
     /* 359431 */ // Label 7244: @359431
     /* 359431 */ GIM_Reject,
     /* 359432 */ // Label 7236: @359432
     /* 359432 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(359469), // Rule ID 635 //
     /* 359437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 359443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359458 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 359458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 359463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359467 */   GIR_RootConstrainSelectedInstOperands,
     /* 359468 */   // GIR_Coverage, 635,
     /* 359468 */   GIR_Done,
     /* 359469 */ // Label 7245: @359469
     /* 359469 */ GIM_Reject,
     /* 359470 */ // Label 7237: @359470
     /* 359470 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(359507), // Rule ID 1335 //
     /* 359475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 359481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 359484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359496 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 359496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 359501 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359505 */   GIR_RootConstrainSelectedInstOperands,
     /* 359506 */   // GIR_Coverage, 1335,
     /* 359506 */   GIR_Done,
     /* 359507 */ // Label 7246: @359507
     /* 359507 */ GIM_Reject,
     /* 359508 */ // Label 7238: @359508
     /* 359508 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(359545), // Rule ID 1339 //
     /* 359513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 359522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359534 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 359534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 359539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359543 */   GIR_RootConstrainSelectedInstOperands,
     /* 359544 */   // GIR_Coverage, 1339,
     /* 359544 */   GIR_Done,
     /* 359545 */ // Label 7247: @359545
     /* 359545 */ GIM_Reject,
     /* 359546 */ // Label 7239: @359546
     /* 359546 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(359583), // Rule ID 1331 //
     /* 359551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 359560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359572 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 359572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 359577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359581 */   GIR_RootConstrainSelectedInstOperands,
     /* 359582 */   // GIR_Coverage, 1331,
     /* 359582 */   GIR_Done,
     /* 359583 */ // Label 7248: @359583
     /* 359583 */ GIM_Reject,
     /* 359584 */ // Label 7240: @359584
     /* 359584 */ GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(359621), // Rule ID 1337 //
     /* 359589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 359598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359610 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 359610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 359615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359619 */   GIR_RootConstrainSelectedInstOperands,
     /* 359620 */   // GIR_Coverage, 1337,
     /* 359620 */   GIR_Done,
     /* 359621 */ // Label 7249: @359621
     /* 359621 */ GIM_Reject,
     /* 359622 */ // Label 7241: @359622
     /* 359622 */ GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(359919),
     /* 359627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 359633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359645 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(359664), // Rule ID 1333 //
     /* 359650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359653 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 359653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 359658 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359662 */     GIR_RootConstrainSelectedInstOperands,
     /* 359663 */     // GIR_Coverage, 1333,
     /* 359663 */     GIR_Done,
     /* 359664 */   // Label 7251: @359664
     /* 359664 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(359918), // Rule ID 6919 //
     /* 359669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359672 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 359672 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 359675 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359679 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359684 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 359690 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 359693 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359697 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359702 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 359708 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 359711 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 359715 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359720 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 359723 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 359726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 359728 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 359731 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359735 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359740 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 359746 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359751 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359756 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359759 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359763 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359768 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359773 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359776 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359780 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359785 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359791 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359796 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359801 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359804 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359808 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359813 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359818 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359821 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 359825 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359830 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359833 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 359836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 359841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 359845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359850 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 359853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 359908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 359916 */     GIR_RootConstrainSelectedInstOperands,
     /* 359917 */     // GIR_Coverage, 6919,
     /* 359917 */     GIR_EraseRootFromParent_Done,
     /* 359918 */   // Label 7252: @359918
     /* 359918 */   GIM_Reject,
     /* 359919 */ // Label 7250: @359919
     /* 359919 */ GIM_Reject,
     /* 359920 */ // Label 7242: @359920
     /* 359920 */ GIM_Reject,
     /* 359921 */ // Label 100: @359921
     /* 359921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7261*/ GIMT_Encode4(363642),
     /* 359932 */ /*GILLT_s16*//*Label 7253*/ GIMT_Encode4(359972),
     /* 359936 */ /*GILLT_s32*//*Label 7254*/ GIMT_Encode4(360526),
     /* 359940 */ /*GILLT_s64*//*Label 7255*/ GIMT_Encode4(361074), GIMT_Encode4(0),
     /* 359948 */ /*GILLT_v2s32*//*Label 7256*/ GIMT_Encode4(361622),
     /* 359952 */ /*GILLT_v2s64*//*Label 7257*/ GIMT_Encode4(362152),
     /* 359956 */ /*GILLT_v4s16*//*Label 7258*/ GIMT_Encode4(362510),
     /* 359960 */ /*GILLT_v4s32*//*Label 7259*/ GIMT_Encode4(362852), GIMT_Encode4(0),
     /* 359968 */ /*GILLT_v8s16*//*Label 7260*/ GIMT_Encode4(363210),
     /* 359972 */ // Label 7253: @359972
     /* 359972 */ GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(360525),
     /* 359977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359987 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(360100), // Rule ID 6146 //
     /* 359992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360016 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360053 */     // MIs[3] Operand 1
     /* 360053 */     // No operand predicates
     /* 360053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360055 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 360095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360098 */     GIR_RootConstrainSelectedInstOperands,
     /* 360099 */     // GIR_Coverage, 6146,
     /* 360099 */     GIR_EraseRootFromParent_Done,
     /* 360100 */   // Label 7263: @360100
     /* 360100 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(360213), // Rule ID 13620 //
     /* 360105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360141 */     // MIs[2] Operand 1
     /* 360141 */     // No operand predicates
     /* 360141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360153 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 360157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360162 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 360166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360168 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360180 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360211 */     GIR_RootConstrainSelectedInstOperands,
     /* 360212 */     // GIR_Coverage, 13620,
     /* 360212 */     GIR_EraseRootFromParent_Done,
     /* 360213 */   // Label 7264: @360213
     /* 360213 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(360292), // Rule ID 13557 //
     /* 360218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360252 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 360252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360264 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 360270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360290 */     GIR_RootConstrainSelectedInstOperands,
     /* 360291 */     // GIR_Coverage, 13557,
     /* 360291 */     GIR_EraseRootFromParent_Done,
     /* 360292 */   // Label 7265: @360292
     /* 360292 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(360371), // Rule ID 4742 //
     /* 360297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360331 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 360331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360343 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 360349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360369 */     GIR_RootConstrainSelectedInstOperands,
     /* 360370 */     // GIR_Coverage, 4742,
     /* 360370 */     GIR_EraseRootFromParent_Done,
     /* 360371 */   // Label 7266: @360371
     /* 360371 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(360434), // Rule ID 13172 //
     /* 360376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 360400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360412 */     // MIs[2] Operand 1
     /* 360412 */     // No operand predicates
     /* 360412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360418 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360432 */     GIR_RootConstrainSelectedInstOperands,
     /* 360433 */     // GIR_Coverage, 13172,
     /* 360433 */     GIR_EraseRootFromParent_Done,
     /* 360434 */   // Label 7267: @360434
     /* 360434 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(360497), // Rule ID 2004 //
     /* 360439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 360467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360479 */     // MIs[2] Operand 1
     /* 360479 */     // No operand predicates
     /* 360479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360481 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360495 */     GIR_RootConstrainSelectedInstOperands,
     /* 360496 */     // GIR_Coverage, 2004,
     /* 360496 */     GIR_EraseRootFromParent_Done,
     /* 360497 */   // Label 7268: @360497
     /* 360497 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(360524), // Rule ID 619 //
     /* 360502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360513 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 360513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360518 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360522 */     GIR_RootConstrainSelectedInstOperands,
     /* 360523 */     // GIR_Coverage, 619,
     /* 360523 */     GIR_Done,
     /* 360524 */   // Label 7269: @360524
     /* 360524 */   GIM_Reject,
     /* 360525 */ // Label 7262: @360525
     /* 360525 */ GIM_Reject,
     /* 360526 */ // Label 7254: @360526
     /* 360526 */ GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(361073),
     /* 360531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360541 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(360654), // Rule ID 6148 //
     /* 360546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360603 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 360607 */     // MIs[3] Operand 1
     /* 360607 */     // No operand predicates
     /* 360607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360609 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 360609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360621 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 360627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 360640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 360649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360652 */     GIR_RootConstrainSelectedInstOperands,
     /* 360653 */     // GIR_Coverage, 6148,
     /* 360653 */     GIR_EraseRootFromParent_Done,
     /* 360654 */   // Label 7271: @360654
     /* 360654 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(360767), // Rule ID 13622 //
     /* 360659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 360695 */     // MIs[2] Operand 1
     /* 360695 */     // No operand predicates
     /* 360695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360707 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 360711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360716 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 360720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360722 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 360722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360734 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 360740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 360753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360765 */     GIR_RootConstrainSelectedInstOperands,
     /* 360766 */     // GIR_Coverage, 13622,
     /* 360766 */     GIR_EraseRootFromParent_Done,
     /* 360767 */   // Label 7272: @360767
     /* 360767 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(360843), // Rule ID 13559 //
     /* 360772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360803 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 360803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360815 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 360821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 360834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360841 */     GIR_RootConstrainSelectedInstOperands,
     /* 360842 */     // GIR_Coverage, 13559,
     /* 360842 */     GIR_EraseRootFromParent_Done,
     /* 360843 */   // Label 7273: @360843
     /* 360843 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(360919), // Rule ID 4744 //
     /* 360848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360879 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 360879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360891 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 360897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 360910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360917 */     GIR_RootConstrainSelectedInstOperands,
     /* 360918 */     // GIR_Coverage, 4744,
     /* 360918 */     GIR_EraseRootFromParent_Done,
     /* 360919 */   // Label 7274: @360919
     /* 360919 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(360982), // Rule ID 13174 //
     /* 360924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 360960 */     // MIs[2] Operand 1
     /* 360960 */     // No operand predicates
     /* 360960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360966 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 360969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360980 */     GIR_RootConstrainSelectedInstOperands,
     /* 360981 */     // GIR_Coverage, 13174,
     /* 360981 */     GIR_EraseRootFromParent_Done,
     /* 360982 */   // Label 7275: @360982
     /* 360982 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(361045), // Rule ID 2006 //
     /* 360987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361027 */     // MIs[2] Operand 1
     /* 361027 */     // No operand predicates
     /* 361027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361029 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 361032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361043 */     GIR_RootConstrainSelectedInstOperands,
     /* 361044 */     // GIR_Coverage, 2006,
     /* 361044 */     GIR_EraseRootFromParent_Done,
     /* 361045 */   // Label 7276: @361045
     /* 361045 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(361072), // Rule ID 621 //
     /* 361050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361061 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 361061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 361066 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361070 */     GIR_RootConstrainSelectedInstOperands,
     /* 361071 */     // GIR_Coverage, 621,
     /* 361071 */     GIR_Done,
     /* 361072 */   // Label 7277: @361072
     /* 361072 */   GIM_Reject,
     /* 361073 */ // Label 7270: @361073
     /* 361073 */ GIM_Reject,
     /* 361074 */ // Label 7255: @361074
     /* 361074 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(361621),
     /* 361079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 361082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361089 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(361202), // Rule ID 6150 //
     /* 361094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361151 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361155 */     // MIs[3] Operand 1
     /* 361155 */     // No operand predicates
     /* 361155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361157 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 361157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361169 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361200 */     GIR_RootConstrainSelectedInstOperands,
     /* 361201 */     // GIR_Coverage, 6150,
     /* 361201 */     GIR_EraseRootFromParent_Done,
     /* 361202 */   // Label 7279: @361202
     /* 361202 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(361315), // Rule ID 13624 //
     /* 361207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361239 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361243 */     // MIs[2] Operand 1
     /* 361243 */     // No operand predicates
     /* 361243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361251 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361255 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 361259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361264 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 361268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361270 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 361270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361282 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361313 */     GIR_RootConstrainSelectedInstOperands,
     /* 361314 */     // GIR_Coverage, 13624,
     /* 361314 */     GIR_EraseRootFromParent_Done,
     /* 361315 */   // Label 7280: @361315
     /* 361315 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(361391), // Rule ID 13561 //
     /* 361320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361351 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 361351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361363 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 361369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361389 */     GIR_RootConstrainSelectedInstOperands,
     /* 361390 */     // GIR_Coverage, 13561,
     /* 361390 */     GIR_EraseRootFromParent_Done,
     /* 361391 */   // Label 7281: @361391
     /* 361391 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(361467), // Rule ID 4746 //
     /* 361396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361427 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 361427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 361445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361465 */     GIR_RootConstrainSelectedInstOperands,
     /* 361466 */     // GIR_Coverage, 4746,
     /* 361466 */     GIR_EraseRootFromParent_Done,
     /* 361467 */   // Label 7282: @361467
     /* 361467 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(361530), // Rule ID 13176 //
     /* 361472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361508 */     // MIs[2] Operand 1
     /* 361508 */     // No operand predicates
     /* 361508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361514 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361528 */     GIR_RootConstrainSelectedInstOperands,
     /* 361529 */     // GIR_Coverage, 13176,
     /* 361529 */     GIR_EraseRootFromParent_Done,
     /* 361530 */   // Label 7283: @361530
     /* 361530 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(361593), // Rule ID 2008 //
     /* 361535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361571 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361575 */     // MIs[2] Operand 1
     /* 361575 */     // No operand predicates
     /* 361575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361577 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361591 */     GIR_RootConstrainSelectedInstOperands,
     /* 361592 */     // GIR_Coverage, 2008,
     /* 361592 */     GIR_EraseRootFromParent_Done,
     /* 361593 */   // Label 7284: @361593
     /* 361593 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(361620), // Rule ID 623 //
     /* 361598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361609 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 361609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361614 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361618 */     GIR_RootConstrainSelectedInstOperands,
     /* 361619 */     // GIR_Coverage, 623,
     /* 361619 */     GIR_Done,
     /* 361620 */   // Label 7285: @361620
     /* 361620 */   GIM_Reject,
     /* 361621 */ // Label 7278: @361621
     /* 361621 */ GIM_Reject,
     /* 361622 */ // Label 7256: @361622
     /* 361622 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(362151),
     /* 361627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 361630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 361633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361637 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(361723), // Rule ID 13164 //
     /* 361642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 361653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361686 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361690 */     // MIs[3] Operand 1
     /* 361690 */     // No operand predicates
     /* 361690 */     // MIs[1] Operand 2
     /* 361690 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 361701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361707 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361721 */     GIR_RootConstrainSelectedInstOperands,
     /* 361722 */     // GIR_Coverage, 13164,
     /* 361722 */     GIR_EraseRootFromParent_Done,
     /* 361723 */   // Label 7287: @361723
     /* 361723 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(361809), // Rule ID 1996 //
     /* 361728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 361743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361776 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361780 */     // MIs[3] Operand 1
     /* 361780 */     // No operand predicates
     /* 361780 */     // MIs[1] Operand 2
     /* 361780 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 361791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361793 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361807 */     GIR_RootConstrainSelectedInstOperands,
     /* 361808 */     // GIR_Coverage, 1996,
     /* 361808 */     GIR_EraseRootFromParent_Done,
     /* 361809 */   // Label 7288: @361809
     /* 361809 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(361872), // Rule ID 13165 //
     /* 361814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361846 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361850 */     // MIs[2] Operand 1
     /* 361850 */     // No operand predicates
     /* 361850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361856 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361870 */     GIR_RootConstrainSelectedInstOperands,
     /* 361871 */     // GIR_Coverage, 13165,
     /* 361871 */     GIR_EraseRootFromParent_Done,
     /* 361872 */   // Label 7289: @361872
     /* 361872 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(361935), // Rule ID 1997 //
     /* 361877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361917 */     // MIs[2] Operand 1
     /* 361917 */     // No operand predicates
     /* 361917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361919 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361933 */     GIR_RootConstrainSelectedInstOperands,
     /* 361934 */     // GIR_Coverage, 1997,
     /* 361934 */     GIR_EraseRootFromParent_Done,
     /* 361935 */   // Label 7290: @361935
     /* 361935 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(362029), // Rule ID 13626 //
     /* 361940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 361948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 361952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361963 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 361966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 361980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 361999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362027 */     GIR_RootConstrainSelectedInstOperands,
     /* 362028 */     // GIR_Coverage, 13626,
     /* 362028 */     GIR_EraseRootFromParent_Done,
     /* 362029 */   // Label 7291: @362029
     /* 362029 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(362123), // Rule ID 6152 //
     /* 362034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362057 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362057 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362060 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362064 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 362093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362121 */     GIR_RootConstrainSelectedInstOperands,
     /* 362122 */     // GIR_Coverage, 6152,
     /* 362122 */     GIR_EraseRootFromParent_Done,
     /* 362123 */   // Label 7292: @362123
     /* 362123 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(362150), // Rule ID 1315 //
     /* 362128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362139 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 362139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 362144 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362148 */     GIR_RootConstrainSelectedInstOperands,
     /* 362149 */     // GIR_Coverage, 1315,
     /* 362149 */     GIR_Done,
     /* 362150 */   // Label 7293: @362150
     /* 362150 */   GIM_Reject,
     /* 362151 */ // Label 7286: @362151
     /* 362151 */ GIM_Reject,
     /* 362152 */ // Label 7257: @362152
     /* 362152 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(362509),
     /* 362157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 362163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362167 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(362230), // Rule ID 13170 //
     /* 362172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 362183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362208 */     // MIs[2] Operand 1
     /* 362208 */     // No operand predicates
     /* 362208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362214 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362228 */     GIR_RootConstrainSelectedInstOperands,
     /* 362229 */     // GIR_Coverage, 13170,
     /* 362229 */     GIR_EraseRootFromParent_Done,
     /* 362230 */   // Label 7295: @362230
     /* 362230 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(362293), // Rule ID 2002 //
     /* 362235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 362250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362271 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362275 */     // MIs[2] Operand 1
     /* 362275 */     // No operand predicates
     /* 362275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362277 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362291 */     GIR_RootConstrainSelectedInstOperands,
     /* 362292 */     // GIR_Coverage, 2002,
     /* 362292 */     GIR_EraseRootFromParent_Done,
     /* 362293 */   // Label 7296: @362293
     /* 362293 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(362387), // Rule ID 13630 //
     /* 362298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362321 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362385 */     GIR_RootConstrainSelectedInstOperands,
     /* 362386 */     // GIR_Coverage, 13630,
     /* 362386 */     GIR_EraseRootFromParent_Done,
     /* 362387 */   // Label 7297: @362387
     /* 362387 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(362481), // Rule ID 6156 //
     /* 362392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362415 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362441 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362479 */     GIR_RootConstrainSelectedInstOperands,
     /* 362480 */     // GIR_Coverage, 6156,
     /* 362480 */     GIR_EraseRootFromParent_Done,
     /* 362481 */   // Label 7298: @362481
     /* 362481 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(362508), // Rule ID 1319 //
     /* 362486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362497 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 362497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 362502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362506 */     GIR_RootConstrainSelectedInstOperands,
     /* 362507 */     // GIR_Coverage, 1319,
     /* 362507 */     GIR_Done,
     /* 362508 */   // Label 7299: @362508
     /* 362508 */   GIM_Reject,
     /* 362509 */ // Label 7294: @362509
     /* 362509 */ GIM_Reject,
     /* 362510 */ // Label 7258: @362510
     /* 362510 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(362851),
     /* 362515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 362521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362525 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(362611), // Rule ID 13158 //
     /* 362530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362578 */     // MIs[3] Operand 1
     /* 362578 */     // No operand predicates
     /* 362578 */     // MIs[1] Operand 2
     /* 362578 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 362589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362595 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362609 */     GIR_RootConstrainSelectedInstOperands,
     /* 362610 */     // GIR_Coverage, 13158,
     /* 362610 */     GIR_EraseRootFromParent_Done,
     /* 362611 */   // Label 7301: @362611
     /* 362611 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(362697), // Rule ID 1990 //
     /* 362616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362664 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362668 */     // MIs[3] Operand 1
     /* 362668 */     // No operand predicates
     /* 362668 */     // MIs[1] Operand 2
     /* 362668 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 362679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362681 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362695 */     GIR_RootConstrainSelectedInstOperands,
     /* 362696 */     // GIR_Coverage, 1990,
     /* 362696 */     GIR_EraseRootFromParent_Done,
     /* 362697 */   // Label 7302: @362697
     /* 362697 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(362760), // Rule ID 13159 //
     /* 362702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362738 */     // MIs[2] Operand 1
     /* 362738 */     // No operand predicates
     /* 362738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362744 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362758 */     GIR_RootConstrainSelectedInstOperands,
     /* 362759 */     // GIR_Coverage, 13159,
     /* 362759 */     GIR_EraseRootFromParent_Done,
     /* 362760 */   // Label 7303: @362760
     /* 362760 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(362823), // Rule ID 1991 //
     /* 362765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362805 */     // MIs[2] Operand 1
     /* 362805 */     // No operand predicates
     /* 362805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362807 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362821 */     GIR_RootConstrainSelectedInstOperands,
     /* 362822 */     // GIR_Coverage, 1991,
     /* 362822 */     GIR_EraseRootFromParent_Done,
     /* 362823 */   // Label 7304: @362823
     /* 362823 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(362850), // Rule ID 1311 //
     /* 362828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362839 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 362839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 362844 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362848 */     GIR_RootConstrainSelectedInstOperands,
     /* 362849 */     // GIR_Coverage, 1311,
     /* 362849 */     GIR_Done,
     /* 362850 */   // Label 7305: @362850
     /* 362850 */   GIM_Reject,
     /* 362851 */ // Label 7300: @362851
     /* 362851 */ GIM_Reject,
     /* 362852 */ // Label 7259: @362852
     /* 362852 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(363209),
     /* 362857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 362863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362867 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(362930), // Rule ID 13168 //
     /* 362872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362908 */     // MIs[2] Operand 1
     /* 362908 */     // No operand predicates
     /* 362908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362914 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 362917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362928 */     GIR_RootConstrainSelectedInstOperands,
     /* 362929 */     // GIR_Coverage, 13168,
     /* 362929 */     GIR_EraseRootFromParent_Done,
     /* 362930 */   // Label 7307: @362930
     /* 362930 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(362993), // Rule ID 2000 //
     /* 362935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362975 */     // MIs[2] Operand 1
     /* 362975 */     // No operand predicates
     /* 362975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362977 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 362980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362991 */     GIR_RootConstrainSelectedInstOperands,
     /* 362992 */     // GIR_Coverage, 2000,
     /* 362992 */     GIR_EraseRootFromParent_Done,
     /* 362993 */   // Label 7308: @362993
     /* 362993 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(363087), // Rule ID 13628 //
     /* 362998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 363006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363021 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 363024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 363057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363085 */     GIR_RootConstrainSelectedInstOperands,
     /* 363086 */     // GIR_Coverage, 13628,
     /* 363086 */     GIR_EraseRootFromParent_Done,
     /* 363087 */   // Label 7309: @363087
     /* 363087 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(363181), // Rule ID 6154 //
     /* 363092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 363104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363115 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 363118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 363151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363179 */     GIR_RootConstrainSelectedInstOperands,
     /* 363180 */     // GIR_Coverage, 6154,
     /* 363180 */     GIR_EraseRootFromParent_Done,
     /* 363181 */   // Label 7310: @363181
     /* 363181 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(363208), // Rule ID 1317 //
     /* 363186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363197 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 363197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363202 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363206 */     GIR_RootConstrainSelectedInstOperands,
     /* 363207 */     // GIR_Coverage, 1317,
     /* 363207 */     GIR_Done,
     /* 363208 */   // Label 7311: @363208
     /* 363208 */   GIM_Reject,
     /* 363209 */ // Label 7306: @363209
     /* 363209 */ GIM_Reject,
     /* 363210 */ // Label 7260: @363210
     /* 363210 */ GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(363641),
     /* 363215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 363221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363225 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(363288), // Rule ID 13162 //
     /* 363230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363262 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363266 */     // MIs[2] Operand 1
     /* 363266 */     // No operand predicates
     /* 363266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363272 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 363275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363286 */     GIR_RootConstrainSelectedInstOperands,
     /* 363287 */     // GIR_Coverage, 13162,
     /* 363287 */     GIR_EraseRootFromParent_Done,
     /* 363288 */   // Label 7313: @363288
     /* 363288 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(363351), // Rule ID 1994 //
     /* 363293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363329 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363333 */     // MIs[2] Operand 1
     /* 363333 */     // No operand predicates
     /* 363333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363335 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 363338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363349 */     GIR_RootConstrainSelectedInstOperands,
     /* 363350 */     // GIR_Coverage, 1994,
     /* 363350 */     GIR_EraseRootFromParent_Done,
     /* 363351 */   // Label 7314: @363351
     /* 363351 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(363378), // Rule ID 1313 //
     /* 363356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363367 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 363367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 363372 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363376 */     GIR_RootConstrainSelectedInstOperands,
     /* 363377 */     // GIR_Coverage, 1313,
     /* 363377 */     GIR_Done,
     /* 363378 */   // Label 7315: @363378
     /* 363378 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(363640), // Rule ID 6917 //
     /* 363383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 363386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363394 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 363394 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 363397 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363401 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363406 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 363412 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 363415 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363419 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363424 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 363430 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 363433 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363437 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363442 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 363445 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 363448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 363450 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 363453 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363457 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363462 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 363468 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363473 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363478 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 363481 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363485 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363490 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 363493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 363495 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 363498 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363502 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363507 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363513 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363518 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363523 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 363526 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363530 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363535 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 363538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363540 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 363543 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363547 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363552 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363555 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 363558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 363560 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 363563 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 363567 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363572 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 363575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 363612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 363630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 363638 */     GIR_RootConstrainSelectedInstOperands,
     /* 363639 */     // GIR_Coverage, 6917,
     /* 363639 */     GIR_EraseRootFromParent_Done,
     /* 363640 */   // Label 7316: @363640
     /* 363640 */   GIM_Reject,
     /* 363641 */ // Label 7312: @363641
     /* 363641 */ GIM_Reject,
     /* 363642 */ // Label 7261: @363642
     /* 363642 */ GIM_Reject,
     /* 363643 */ // Label 101: @363643
     /* 363643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7325*/ GIMT_Encode4(364258),
     /* 363654 */ /*GILLT_s16*//*Label 7317*/ GIMT_Encode4(363694),
     /* 363658 */ /*GILLT_s32*//*Label 7318*/ GIMT_Encode4(363732),
     /* 363662 */ /*GILLT_s64*//*Label 7319*/ GIMT_Encode4(363770), GIMT_Encode4(0),
     /* 363670 */ /*GILLT_v2s32*//*Label 7320*/ GIMT_Encode4(363808),
     /* 363674 */ /*GILLT_v2s64*//*Label 7321*/ GIMT_Encode4(363846),
     /* 363678 */ /*GILLT_v4s16*//*Label 7322*/ GIMT_Encode4(363884),
     /* 363682 */ /*GILLT_v4s32*//*Label 7323*/ GIMT_Encode4(363922), GIMT_Encode4(0),
     /* 363690 */ /*GILLT_v8s16*//*Label 7324*/ GIMT_Encode4(363960),
     /* 363694 */ // Label 7317: @363694
     /* 363694 */ GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(363731), // Rule ID 589 //
     /* 363699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363720 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 363720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 363725 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363729 */   GIR_RootConstrainSelectedInstOperands,
     /* 363730 */   // GIR_Coverage, 589,
     /* 363730 */   GIR_Done,
     /* 363731 */ // Label 7326: @363731
     /* 363731 */ GIM_Reject,
     /* 363732 */ // Label 7318: @363732
     /* 363732 */ GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(363769), // Rule ID 591 //
     /* 363737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363758 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 363758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 363763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363767 */   GIR_RootConstrainSelectedInstOperands,
     /* 363768 */   // GIR_Coverage, 591,
     /* 363768 */   GIR_Done,
     /* 363769 */ // Label 7327: @363769
     /* 363769 */ GIM_Reject,
     /* 363770 */ // Label 7319: @363770
     /* 363770 */ GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(363807), // Rule ID 593 //
     /* 363775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 363781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363796 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 363796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 363801 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363805 */   GIR_RootConstrainSelectedInstOperands,
     /* 363806 */   // GIR_Coverage, 593,
     /* 363806 */   GIR_Done,
     /* 363807 */ // Label 7328: @363807
     /* 363807 */ GIM_Reject,
     /* 363808 */ // Label 7320: @363808
     /* 363808 */ GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(363845), // Rule ID 1220 //
     /* 363813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 363819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 363822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363834 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 363834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 363839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363843 */   GIR_RootConstrainSelectedInstOperands,
     /* 363844 */   // GIR_Coverage, 1220,
     /* 363844 */   GIR_Done,
     /* 363845 */ // Label 7329: @363845
     /* 363845 */ GIM_Reject,
     /* 363846 */ // Label 7321: @363846
     /* 363846 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(363883), // Rule ID 1224 //
     /* 363851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 363860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363872 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 363872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 363877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363881 */   GIR_RootConstrainSelectedInstOperands,
     /* 363882 */   // GIR_Coverage, 1224,
     /* 363882 */   GIR_Done,
     /* 363883 */ // Label 7330: @363883
     /* 363883 */ GIM_Reject,
     /* 363884 */ // Label 7322: @363884
     /* 363884 */ GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(363921), // Rule ID 1216 //
     /* 363889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 363898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363910 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 363910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 363915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363919 */   GIR_RootConstrainSelectedInstOperands,
     /* 363920 */   // GIR_Coverage, 1216,
     /* 363920 */   GIR_Done,
     /* 363921 */ // Label 7331: @363921
     /* 363921 */ GIM_Reject,
     /* 363922 */ // Label 7323: @363922
     /* 363922 */ GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(363959), // Rule ID 1222 //
     /* 363927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 363936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363948 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 363948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 363953 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363957 */   GIR_RootConstrainSelectedInstOperands,
     /* 363958 */   // GIR_Coverage, 1222,
     /* 363958 */   GIR_Done,
     /* 363959 */ // Label 7332: @363959
     /* 363959 */ GIM_Reject,
     /* 363960 */ // Label 7324: @363960
     /* 363960 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(364257),
     /* 363965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 363971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363983 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(364002), // Rule ID 1218 //
     /* 363988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363991 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 363991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 363996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364000 */     GIR_RootConstrainSelectedInstOperands,
     /* 364001 */     // GIR_Coverage, 1218,
     /* 364001 */     GIR_Done,
     /* 364002 */   // Label 7334: @364002
     /* 364002 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(364256), // Rule ID 6915 //
     /* 364007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 364010 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 364010 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 364013 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364017 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364022 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 364028 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 364031 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364035 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364040 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 364046 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 364049 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364053 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364058 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 364061 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 364064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 364066 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 364069 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364073 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364078 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 364084 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364089 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364094 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 364097 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364101 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364106 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 364109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 364111 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 364114 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364118 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364123 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364129 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364134 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364139 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 364142 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364146 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364151 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 364154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364156 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 364159 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364163 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364168 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364171 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 364174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364176 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 364179 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 364183 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364188 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 364191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 364246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 364254 */     GIR_RootConstrainSelectedInstOperands,
     /* 364255 */     // GIR_Coverage, 6915,
     /* 364255 */     GIR_EraseRootFromParent_Done,
     /* 364256 */   // Label 7335: @364256
     /* 364256 */   GIM_Reject,
     /* 364257 */ // Label 7333: @364257
     /* 364257 */ GIM_Reject,
     /* 364258 */ // Label 7325: @364258
     /* 364258 */ GIM_Reject,
     /* 364259 */ // Label 102: @364259
     /* 364259 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7344*/ GIMT_Encode4(379865),
     /* 364270 */ /*GILLT_s16*//*Label 7336*/ GIMT_Encode4(364310),
     /* 364274 */ /*GILLT_s32*//*Label 7337*/ GIMT_Encode4(367084),
     /* 364278 */ /*GILLT_s64*//*Label 7338*/ GIMT_Encode4(370014), GIMT_Encode4(0),
     /* 364286 */ /*GILLT_v2s32*//*Label 7339*/ GIMT_Encode4(372944),
     /* 364290 */ /*GILLT_v2s64*//*Label 7340*/ GIMT_Encode4(374465),
     /* 364294 */ /*GILLT_v4s16*//*Label 7341*/ GIMT_Encode4(375986),
     /* 364298 */ /*GILLT_v4s32*//*Label 7342*/ GIMT_Encode4(377165), GIMT_Encode4(0),
     /* 364306 */ /*GILLT_v8s16*//*Label 7343*/ GIMT_Encode4(378686),
     /* 364310 */ // Label 7336: @364310
     /* 364310 */ GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(367083),
     /* 364315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 364324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364328 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(364478), // Rule ID 4804 //
     /* 364333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364382 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 364386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 364398 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364405 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364405 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364408 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364412 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364417 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 364464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 364476 */     GIR_RootConstrainSelectedInstOperands,
     /* 364477 */     // GIR_Coverage, 4804,
     /* 364477 */     GIR_EraseRootFromParent_Done,
     /* 364478 */   // Label 7346: @364478
     /* 364478 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(364625), // Rule ID 4768 //
     /* 364483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364544 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 364548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364554 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364566 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 364613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 364623 */     GIR_RootConstrainSelectedInstOperands,
     /* 364624 */     // GIR_Coverage, 4768,
     /* 364624 */     GIR_EraseRootFromParent_Done,
     /* 364625 */   // Label 7347: @364625
     /* 364625 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(364772), // Rule ID 13570 //
     /* 364630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364666 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 364670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364682 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364686 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364691 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 364695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364701 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364713 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364741 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 364760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 364770 */     GIR_RootConstrainSelectedInstOperands,
     /* 364771 */     // GIR_Coverage, 13570,
     /* 364771 */     GIR_EraseRootFromParent_Done,
     /* 364772 */   // Label 7348: @364772
     /* 364772 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(364903), // Rule ID 5984 //
     /* 364777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364801 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 364838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 364842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364846 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364850 */     // MIs[4] Operand 1
     /* 364850 */     // No operand predicates
     /* 364850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 364856 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 364856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364868 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 364887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 364891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 364898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 364901 */     GIR_RootConstrainSelectedInstOperands,
     /* 364902 */     // GIR_Coverage, 5984,
     /* 364902 */     GIR_EraseRootFromParent_Done,
     /* 364903 */   // Label 7349: @364903
     /* 364903 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(365034), // Rule ID 6016 //
     /* 364908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 364932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364940 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364944 */     // MIs[2] Operand 1
     /* 364944 */     // No operand predicates
     /* 364944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 364956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 364960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364964 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364968 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 364972 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364977 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 364981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364985 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 364987 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 364987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364999 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365032 */     GIR_RootConstrainSelectedInstOperands,
     /* 365033 */     // GIR_Coverage, 6016,
     /* 365033 */     GIR_EraseRootFromParent_Done,
     /* 365034 */   // Label 7350: @365034
     /* 365034 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(365165), // Rule ID 6080 //
     /* 365039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365087 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365091 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365095 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 365104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365108 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365112 */     // MIs[4] Operand 1
     /* 365112 */     // No operand predicates
     /* 365112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365116 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365118 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365130 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 365160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 365163 */     GIR_RootConstrainSelectedInstOperands,
     /* 365164 */     // GIR_Coverage, 6080,
     /* 365164 */     GIR_EraseRootFromParent_Done,
     /* 365165 */   // Label 7351: @365165
     /* 365165 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(365296), // Rule ID 6048 //
     /* 365170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365214 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365218 */     // MIs[3] Operand 1
     /* 365218 */     // No operand predicates
     /* 365218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 365222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365230 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 365234 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365239 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 365243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365247 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365249 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365294 */     GIR_RootConstrainSelectedInstOperands,
     /* 365295 */     // GIR_Coverage, 6048,
     /* 365295 */     GIR_EraseRootFromParent_Done,
     /* 365296 */   // Label 7352: @365296
     /* 365296 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(365431), // Rule ID 2446 //
     /* 365301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365350 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365360 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 365360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 365363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365372 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365400 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 365419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365429 */     GIR_RootConstrainSelectedInstOperands,
     /* 365430 */     // GIR_Coverage, 2446,
     /* 365430 */     GIR_EraseRootFromParent_Done,
     /* 365431 */   // Label 7353: @365431
     /* 365431 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(365550), // Rule ID 5952 //
     /* 365436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365493 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365497 */     // MIs[3] Operand 1
     /* 365497 */     // No operand predicates
     /* 365497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365503 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 365534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365548 */     GIR_RootConstrainSelectedInstOperands,
     /* 365549 */     // GIR_Coverage, 5952,
     /* 365549 */     GIR_EraseRootFromParent_Done,
     /* 365550 */   // Label 7354: @365550
     /* 365550 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(365669), // Rule ID 2528 //
     /* 365555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365591 */     // MIs[2] Operand 1
     /* 365591 */     // No operand predicates
     /* 365591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365603 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365607 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365612 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 365616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365622 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365634 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 365653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365667 */     GIR_RootConstrainSelectedInstOperands,
     /* 365668 */     // GIR_Coverage, 2528,
     /* 365668 */     GIR_EraseRootFromParent_Done,
     /* 365669 */   // Label 7355: @365669
     /* 365669 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(365769), // Rule ID 4766 //
     /* 365674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365725 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 365725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365737 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 365756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365767 */     GIR_RootConstrainSelectedInstOperands,
     /* 365768 */     // GIR_Coverage, 4766,
     /* 365768 */     GIR_EraseRootFromParent_Done,
     /* 365769 */   // Label 7356: @365769
     /* 365769 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(365869), // Rule ID 4802 //
     /* 365774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365798 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365825 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 365825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365837 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 365856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 365863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 365867 */     GIR_RootConstrainSelectedInstOperands,
     /* 365868 */     // GIR_Coverage, 4802,
     /* 365868 */     GIR_EraseRootFromParent_Done,
     /* 365869 */   // Label 7357: @365869
     /* 365869 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(365966), // Rule ID 13566 //
     /* 365874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365910 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365924 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 365924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365936 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 365955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365964 */     GIR_RootConstrainSelectedInstOperands,
     /* 365965 */     // GIR_Coverage, 13566,
     /* 365965 */     GIR_EraseRootFromParent_Done,
     /* 365966 */   // Label 7358: @365966
     /* 365966 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(366066), // Rule ID 13568 //
     /* 365971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366012 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366022 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366034 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366064 */     GIR_RootConstrainSelectedInstOperands,
     /* 366065 */     // GIR_Coverage, 13568,
     /* 366065 */     GIR_EraseRootFromParent_Done,
     /* 366066 */   // Label 7359: @366066
     /* 366066 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(366166), // Rule ID 4800 //
     /* 366071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 366115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366122 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366134 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 366153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 366164 */     GIR_RootConstrainSelectedInstOperands,
     /* 366165 */     // GIR_Coverage, 4800,
     /* 366165 */     GIR_EraseRootFromParent_Done,
     /* 366166 */   // Label 7360: @366166
     /* 366166 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(366263), // Rule ID 4764 //
     /* 366171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366211 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366221 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366233 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366261 */     GIR_RootConstrainSelectedInstOperands,
     /* 366262 */     // GIR_Coverage, 4764,
     /* 366262 */     GIR_EraseRootFromParent_Done,
     /* 366263 */   // Label 7361: @366263
     /* 366263 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(366347), // Rule ID 6014 //
     /* 366268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366304 */     // MIs[2] Operand 1
     /* 366304 */     // No operand predicates
     /* 366304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366312 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 366316 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366327 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366345 */     GIR_RootConstrainSelectedInstOperands,
     /* 366346 */     // GIR_Coverage, 6014,
     /* 366346 */     GIR_EraseRootFromParent_Done,
     /* 366347 */   // Label 7362: @366347
     /* 366347 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(366428), // Rule ID 6046 //
     /* 366352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366400 */     // MIs[3] Operand 1
     /* 366400 */     // No operand predicates
     /* 366400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366410 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366426 */     GIR_RootConstrainSelectedInstOperands,
     /* 366427 */     // GIR_Coverage, 6046,
     /* 366427 */     GIR_EraseRootFromParent_Done,
     /* 366428 */   // Label 7363: @366428
     /* 366428 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(366512), // Rule ID 6078 //
     /* 366433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366482 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366486 */     // MIs[3] Operand 1
     /* 366486 */     // No operand predicates
     /* 366486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366492 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366510 */     GIR_RootConstrainSelectedInstOperands,
     /* 366511 */     // GIR_Coverage, 6078,
     /* 366511 */     GIR_EraseRootFromParent_Done,
     /* 366512 */   // Label 7364: @366512
     /* 366512 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(366593), // Rule ID 5982 //
     /* 366517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366565 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366569 */     // MIs[3] Operand 1
     /* 366569 */     // No operand predicates
     /* 366569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366575 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366591 */     GIR_RootConstrainSelectedInstOperands,
     /* 366592 */     // GIR_Coverage, 5982,
     /* 366592 */     GIR_EraseRootFromParent_Done,
     /* 366593 */   // Label 7365: @366593
     /* 366593 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(366678), // Rule ID 2444 //
     /* 366598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366636 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366648 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 366667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 366674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366676 */     GIR_RootConstrainSelectedInstOperands,
     /* 366677 */     // GIR_Coverage, 2444,
     /* 366677 */     GIR_EraseRootFromParent_Done,
     /* 366678 */   // Label 7366: @366678
     /* 366678 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(366763), // Rule ID 2442 //
     /* 366683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366721 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 366752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366761 */     GIR_RootConstrainSelectedInstOperands,
     /* 366762 */     // GIR_Coverage, 2442,
     /* 366762 */     GIR_EraseRootFromParent_Done,
     /* 366763 */   // Label 7367: @366763
     /* 366763 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(366832), // Rule ID 2526 //
     /* 366768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366804 */     // MIs[2] Operand 1
     /* 366804 */     // No operand predicates
     /* 366804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366814 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 366817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366830 */     GIR_RootConstrainSelectedInstOperands,
     /* 366831 */     // GIR_Coverage, 2526,
     /* 366831 */     GIR_EraseRootFromParent_Done,
     /* 366832 */   // Label 7368: @366832
     /* 366832 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(366901), // Rule ID 5950 //
     /* 366837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366877 */     // MIs[2] Operand 1
     /* 366877 */     // No operand predicates
     /* 366877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366883 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 366886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366899 */     GIR_RootConstrainSelectedInstOperands,
     /* 366900 */     // GIR_Coverage, 5950,
     /* 366900 */     GIR_EraseRootFromParent_Done,
     /* 366901 */   // Label 7369: @366901
     /* 366901 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(366951), // Rule ID 13012 //
     /* 366906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366936 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366949 */     GIR_RootConstrainSelectedInstOperands,
     /* 366950 */     // GIR_Coverage, 13012,
     /* 366950 */     GIR_EraseRootFromParent_Done,
     /* 366951 */   // Label 7370: @366951
     /* 366951 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(367001), // Rule ID 643 //
     /* 366956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366986 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366999 */     GIR_RootConstrainSelectedInstOperands,
     /* 367000 */     // GIR_Coverage, 643,
     /* 367000 */     GIR_EraseRootFromParent_Done,
     /* 367001 */   // Label 7371: @367001
     /* 367001 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(367051), // Rule ID 655 //
     /* 367006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367036 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 367039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 367045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 367049 */     GIR_RootConstrainSelectedInstOperands,
     /* 367050 */     // GIR_Coverage, 655,
     /* 367050 */     GIR_EraseRootFromParent_Done,
     /* 367051 */   // Label 7372: @367051
     /* 367051 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(367082), // Rule ID 637 //
     /* 367056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367071 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 367076 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367080 */     GIR_RootConstrainSelectedInstOperands,
     /* 367081 */     // GIR_Coverage, 637,
     /* 367081 */     GIR_Done,
     /* 367082 */   // Label 7373: @367082
     /* 367082 */   GIM_Reject,
     /* 367083 */ // Label 7345: @367083
     /* 367083 */ GIM_Reject,
     /* 367084 */ // Label 7337: @367084
     /* 367084 */ GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(370013),
     /* 367089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 367098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367102 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(367252), // Rule ID 4810 //
     /* 367107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367131 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367156 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367179 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367191 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367219 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 367238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 367250 */     GIR_RootConstrainSelectedInstOperands,
     /* 367251 */     // GIR_Coverage, 4810,
     /* 367251 */     GIR_EraseRootFromParent_Done,
     /* 367252 */   // Label 7375: @367252
     /* 367252 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(367399), // Rule ID 4774 //
     /* 367257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367281 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367318 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367328 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367340 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367368 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 367387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367397 */     GIR_RootConstrainSelectedInstOperands,
     /* 367398 */     // GIR_Coverage, 4774,
     /* 367398 */     GIR_EraseRootFromParent_Done,
     /* 367399 */   // Label 7376: @367399
     /* 367399 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(367546), // Rule ID 13576 //
     /* 367404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367465 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367475 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367487 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 367534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367544 */     GIR_RootConstrainSelectedInstOperands,
     /* 367545 */     // GIR_Coverage, 13576,
     /* 367545 */     GIR_EraseRootFromParent_Done,
     /* 367546 */   // Label 7377: @367546
     /* 367546 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(367677), // Rule ID 6000 //
     /* 367551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367603 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367607 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367620 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367624 */     // MIs[4] Operand 1
     /* 367624 */     // No operand predicates
     /* 367624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367628 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367630 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367642 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 367661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 367672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 367675 */     GIR_RootConstrainSelectedInstOperands,
     /* 367676 */     // GIR_Coverage, 6000,
     /* 367676 */     GIR_EraseRootFromParent_Done,
     /* 367677 */   // Label 7378: @367677
     /* 367677 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(367808), // Rule ID 6032 //
     /* 367682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367718 */     // MIs[2] Operand 1
     /* 367718 */     // No operand predicates
     /* 367718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 367734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367742 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367746 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367751 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 367755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367761 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367773 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 367792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367806 */     GIR_RootConstrainSelectedInstOperands,
     /* 367807 */     // GIR_Coverage, 6032,
     /* 367807 */     GIR_EraseRootFromParent_Done,
     /* 367808 */   // Label 7379: @367808
     /* 367808 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(367939), // Rule ID 6096 //
     /* 367813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367882 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367886 */     // MIs[4] Operand 1
     /* 367886 */     // No operand predicates
     /* 367886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367890 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367892 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367904 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 367923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 367934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 367937 */     GIR_RootConstrainSelectedInstOperands,
     /* 367938 */     // GIR_Coverage, 6096,
     /* 367938 */     GIR_EraseRootFromParent_Done,
     /* 367939 */   // Label 7380: @367939
     /* 367939 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(368070), // Rule ID 6064 //
     /* 367944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367988 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367992 */     // MIs[3] Operand 1
     /* 367992 */     // No operand predicates
     /* 367992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 367996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 368008 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368013 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 368017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368023 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368035 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 368054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368068 */     GIR_RootConstrainSelectedInstOperands,
     /* 368069 */     // GIR_Coverage, 6064,
     /* 368069 */     GIR_EraseRootFromParent_Done,
     /* 368070 */   // Label 7381: @368070
     /* 368070 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(368205), // Rule ID 2452 //
     /* 368075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368124 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368134 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 368137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368146 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 368193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 368201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368203 */     GIR_RootConstrainSelectedInstOperands,
     /* 368204 */     // GIR_Coverage, 2452,
     /* 368204 */     GIR_EraseRootFromParent_Done,
     /* 368205 */   // Label 7382: @368205
     /* 368205 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(368324), // Rule ID 5968 //
     /* 368210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368271 */     // MIs[3] Operand 1
     /* 368271 */     // No operand predicates
     /* 368271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368277 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368289 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 368308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368322 */     GIR_RootConstrainSelectedInstOperands,
     /* 368323 */     // GIR_Coverage, 5968,
     /* 368323 */     GIR_EraseRootFromParent_Done,
     /* 368324 */   // Label 7383: @368324
     /* 368324 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(368443), // Rule ID 2544 //
     /* 368329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368365 */     // MIs[2] Operand 1
     /* 368365 */     // No operand predicates
     /* 368365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368377 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368386 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 368390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368396 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368408 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 368427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368441 */     GIR_RootConstrainSelectedInstOperands,
     /* 368442 */     // GIR_Coverage, 2544,
     /* 368442 */     GIR_EraseRootFromParent_Done,
     /* 368443 */   // Label 7384: @368443
     /* 368443 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(368543), // Rule ID 4772 //
     /* 368448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368472 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368499 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368541 */     GIR_RootConstrainSelectedInstOperands,
     /* 368542 */     // GIR_Coverage, 4772,
     /* 368542 */     GIR_EraseRootFromParent_Done,
     /* 368543 */   // Label 7385: @368543
     /* 368543 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(368643), // Rule ID 4808 //
     /* 368548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368572 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368599 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368611 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 368630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 368637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 368641 */     GIR_RootConstrainSelectedInstOperands,
     /* 368642 */     // GIR_Coverage, 4808,
     /* 368642 */     GIR_EraseRootFromParent_Done,
     /* 368643 */   // Label 7386: @368643
     /* 368643 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(368740), // Rule ID 13572 //
     /* 368648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368698 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368738 */     GIR_RootConstrainSelectedInstOperands,
     /* 368739 */     // GIR_Coverage, 13572,
     /* 368739 */     GIR_EraseRootFromParent_Done,
     /* 368740 */   // Label 7387: @368740
     /* 368740 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(368840), // Rule ID 13574 //
     /* 368745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368796 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368808 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368838 */     GIR_RootConstrainSelectedInstOperands,
     /* 368839 */     // GIR_Coverage, 13574,
     /* 368839 */     GIR_EraseRootFromParent_Done,
     /* 368840 */   // Label 7388: @368840
     /* 368840 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(368940), // Rule ID 4806 //
     /* 368845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368896 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368908 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 368927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 368938 */     GIR_RootConstrainSelectedInstOperands,
     /* 368939 */     // GIR_Coverage, 4806,
     /* 368939 */     GIR_EraseRootFromParent_Done,
     /* 368940 */   // Label 7389: @368940
     /* 368940 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(369037), // Rule ID 4770 //
     /* 368945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368985 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368995 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369007 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369035 */     GIR_RootConstrainSelectedInstOperands,
     /* 369036 */     // GIR_Coverage, 4770,
     /* 369036 */     GIR_EraseRootFromParent_Done,
     /* 369037 */   // Label 7390: @369037
     /* 369037 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(369115), // Rule ID 6118 //
     /* 369042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 369079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369083 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369087 */     // MIs[3] Operand 1
     /* 369087 */     // No operand predicates
     /* 369087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369097 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369113 */     GIR_RootConstrainSelectedInstOperands,
     /* 369114 */     // GIR_Coverage, 6118,
     /* 369114 */     GIR_EraseRootFromParent_Done,
     /* 369115 */   // Label 7391: @369115
     /* 369115 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(369199), // Rule ID 6030 //
     /* 369120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369156 */     // MIs[2] Operand 1
     /* 369156 */     // No operand predicates
     /* 369156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 369168 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369179 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 369190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369197 */     GIR_RootConstrainSelectedInstOperands,
     /* 369198 */     // GIR_Coverage, 6030,
     /* 369198 */     GIR_EraseRootFromParent_Done,
     /* 369199 */   // Label 7392: @369199
     /* 369199 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(369280), // Rule ID 6062 //
     /* 369204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369252 */     // MIs[3] Operand 1
     /* 369252 */     // No operand predicates
     /* 369252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369262 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369278 */     GIR_RootConstrainSelectedInstOperands,
     /* 369279 */     // GIR_Coverage, 6062,
     /* 369279 */     GIR_EraseRootFromParent_Done,
     /* 369280 */   // Label 7393: @369280
     /* 369280 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(369364), // Rule ID 6094 //
     /* 369285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369338 */     // MIs[3] Operand 1
     /* 369338 */     // No operand predicates
     /* 369338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369344 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369362 */     GIR_RootConstrainSelectedInstOperands,
     /* 369363 */     // GIR_Coverage, 6094,
     /* 369363 */     GIR_EraseRootFromParent_Done,
     /* 369364 */   // Label 7394: @369364
     /* 369364 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(369442), // Rule ID 6140 //
     /* 369369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 369410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369414 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369418 */     // MIs[3] Operand 1
     /* 369418 */     // No operand predicates
     /* 369418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369424 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369440 */     GIR_RootConstrainSelectedInstOperands,
     /* 369441 */     // GIR_Coverage, 6140,
     /* 369441 */     GIR_EraseRootFromParent_Done,
     /* 369442 */   // Label 7395: @369442
     /* 369442 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(369523), // Rule ID 5998 //
     /* 369447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369495 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369499 */     // MIs[3] Operand 1
     /* 369499 */     // No operand predicates
     /* 369499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369505 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369521 */     GIR_RootConstrainSelectedInstOperands,
     /* 369522 */     // GIR_Coverage, 5998,
     /* 369522 */     GIR_EraseRootFromParent_Done,
     /* 369523 */   // Label 7396: @369523
     /* 369523 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(369608), // Rule ID 2450 //
     /* 369528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369566 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369578 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 369584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 369597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369606 */     GIR_RootConstrainSelectedInstOperands,
     /* 369607 */     // GIR_Coverage, 2450,
     /* 369607 */     GIR_EraseRootFromParent_Done,
     /* 369608 */   // Label 7397: @369608
     /* 369608 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(369693), // Rule ID 2448 //
     /* 369613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369641 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369651 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 369651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 369682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369691 */     GIR_RootConstrainSelectedInstOperands,
     /* 369692 */     // GIR_Coverage, 2448,
     /* 369692 */     GIR_EraseRootFromParent_Done,
     /* 369693 */   // Label 7398: @369693
     /* 369693 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(369762), // Rule ID 2542 //
     /* 369698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369730 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369734 */     // MIs[2] Operand 1
     /* 369734 */     // No operand predicates
     /* 369734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369744 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 369747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369760 */     GIR_RootConstrainSelectedInstOperands,
     /* 369761 */     // GIR_Coverage, 2542,
     /* 369761 */     GIR_EraseRootFromParent_Done,
     /* 369762 */   // Label 7399: @369762
     /* 369762 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(369831), // Rule ID 5966 //
     /* 369767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369807 */     // MIs[2] Operand 1
     /* 369807 */     // No operand predicates
     /* 369807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369813 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 369816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369829 */     GIR_RootConstrainSelectedInstOperands,
     /* 369830 */     // GIR_Coverage, 5966,
     /* 369830 */     GIR_EraseRootFromParent_Done,
     /* 369831 */   // Label 7400: @369831
     /* 369831 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(369881), // Rule ID 13014 //
     /* 369836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369866 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369879 */     GIR_RootConstrainSelectedInstOperands,
     /* 369880 */     // GIR_Coverage, 13014,
     /* 369880 */     GIR_EraseRootFromParent_Done,
     /* 369881 */   // Label 7401: @369881
     /* 369881 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(369931), // Rule ID 645 //
     /* 369886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369916 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369929 */     GIR_RootConstrainSelectedInstOperands,
     /* 369930 */     // GIR_Coverage, 645,
     /* 369930 */     GIR_EraseRootFromParent_Done,
     /* 369931 */   // Label 7402: @369931
     /* 369931 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(369981), // Rule ID 657 //
     /* 369936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369966 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 369969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 369979 */     GIR_RootConstrainSelectedInstOperands,
     /* 369980 */     // GIR_Coverage, 657,
     /* 369980 */     GIR_EraseRootFromParent_Done,
     /* 369981 */   // Label 7403: @369981
     /* 369981 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(370012), // Rule ID 639 //
     /* 369986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370001 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 370006 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370010 */     GIR_RootConstrainSelectedInstOperands,
     /* 370011 */     // GIR_Coverage, 639,
     /* 370011 */     GIR_Done,
     /* 370012 */   // Label 7404: @370012
     /* 370012 */   GIM_Reject,
     /* 370013 */ // Label 7374: @370013
     /* 370013 */ GIM_Reject,
     /* 370014 */ // Label 7338: @370014
     /* 370014 */ GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(372943),
     /* 370019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370032 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(370182), // Rule ID 4816 //
     /* 370037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370086 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 370102 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370109 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370109 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370112 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370116 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370121 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370149 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 370168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 370180 */     GIR_RootConstrainSelectedInstOperands,
     /* 370181 */     // GIR_Coverage, 4816,
     /* 370181 */     GIR_EraseRootFromParent_Done,
     /* 370182 */   // Label 7406: @370182
     /* 370182 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(370329), // Rule ID 4780 //
     /* 370187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370248 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370258 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370270 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370298 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 370317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370327 */     GIR_RootConstrainSelectedInstOperands,
     /* 370328 */     // GIR_Coverage, 4780,
     /* 370328 */     GIR_EraseRootFromParent_Done,
     /* 370329 */   // Label 7407: @370329
     /* 370329 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(370476), // Rule ID 13582 //
     /* 370334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370370 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370390 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370395 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370405 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370405 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370408 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370412 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370417 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 370464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370474 */     GIR_RootConstrainSelectedInstOperands,
     /* 370475 */     // GIR_Coverage, 13582,
     /* 370475 */     GIR_EraseRootFromParent_Done,
     /* 370476 */   // Label 7408: @370476
     /* 370476 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(370607), // Rule ID 6004 //
     /* 370481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370529 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370533 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370542 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370546 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370550 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370554 */     // MIs[4] Operand 1
     /* 370554 */     // No operand predicates
     /* 370554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370558 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370560 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370572 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 370602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 370605 */     GIR_RootConstrainSelectedInstOperands,
     /* 370606 */     // GIR_Coverage, 6004,
     /* 370606 */     GIR_EraseRootFromParent_Done,
     /* 370607 */   // Label 7409: @370607
     /* 370607 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(370738), // Rule ID 6036 //
     /* 370612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370648 */     // MIs[2] Operand 1
     /* 370648 */     // No operand predicates
     /* 370648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 370660 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 370664 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370668 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370672 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370676 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370681 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 370685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370689 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370691 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370703 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370736 */     GIR_RootConstrainSelectedInstOperands,
     /* 370737 */     // GIR_Coverage, 6036,
     /* 370737 */     GIR_EraseRootFromParent_Done,
     /* 370738 */   // Label 7410: @370738
     /* 370738 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(370869), // Rule ID 6100 //
     /* 370743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370779 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370791 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370799 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370808 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370812 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370816 */     // MIs[4] Operand 1
     /* 370816 */     // No operand predicates
     /* 370816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370820 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370822 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370834 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 370864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 370867 */     GIR_RootConstrainSelectedInstOperands,
     /* 370868 */     // GIR_Coverage, 6100,
     /* 370868 */     GIR_EraseRootFromParent_Done,
     /* 370869 */   // Label 7411: @370869
     /* 370869 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(371000), // Rule ID 6068 //
     /* 370874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 370914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370918 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370922 */     // MIs[3] Operand 1
     /* 370922 */     // No operand predicates
     /* 370922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 370926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370930 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370934 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370938 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370943 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 370947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370951 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370953 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370965 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 370995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 370998 */     GIR_RootConstrainSelectedInstOperands,
     /* 370999 */     // GIR_Coverage, 6068,
     /* 370999 */     GIR_EraseRootFromParent_Done,
     /* 371000 */   // Label 7412: @371000
     /* 371000 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(371135), // Rule ID 2458 //
     /* 371005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371054 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371064 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 371067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371076 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371104 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 371123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371133 */     GIR_RootConstrainSelectedInstOperands,
     /* 371134 */     // GIR_Coverage, 2458,
     /* 371134 */     GIR_EraseRootFromParent_Done,
     /* 371135 */   // Label 7413: @371135
     /* 371135 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(371254), // Rule ID 5972 //
     /* 371140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371164 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371197 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371201 */     // MIs[3] Operand 1
     /* 371201 */     // No operand predicates
     /* 371201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371207 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371219 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 371238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371252 */     GIR_RootConstrainSelectedInstOperands,
     /* 371253 */     // GIR_Coverage, 5972,
     /* 371253 */     GIR_EraseRootFromParent_Done,
     /* 371254 */   // Label 7414: @371254
     /* 371254 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(371373), // Rule ID 2548 //
     /* 371259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371295 */     // MIs[2] Operand 1
     /* 371295 */     // No operand predicates
     /* 371295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371303 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371307 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371311 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371316 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371326 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 371357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371371 */     GIR_RootConstrainSelectedInstOperands,
     /* 371372 */     // GIR_Coverage, 2548,
     /* 371372 */     GIR_EraseRootFromParent_Done,
     /* 371373 */   // Label 7415: @371373
     /* 371373 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(371473), // Rule ID 4778 //
     /* 371378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371402 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371429 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371441 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371471 */     GIR_RootConstrainSelectedInstOperands,
     /* 371472 */     // GIR_Coverage, 4778,
     /* 371472 */     GIR_EraseRootFromParent_Done,
     /* 371473 */   // Label 7416: @371473
     /* 371473 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(371573), // Rule ID 4814 //
     /* 371478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371502 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371529 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371541 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 371560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 371567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 371571 */     GIR_RootConstrainSelectedInstOperands,
     /* 371572 */     // GIR_Coverage, 4814,
     /* 371572 */     GIR_EraseRootFromParent_Done,
     /* 371573 */   // Label 7417: @371573
     /* 371573 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(371670), // Rule ID 13578 //
     /* 371578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371614 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371628 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371640 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 371663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371668 */     GIR_RootConstrainSelectedInstOperands,
     /* 371669 */     // GIR_Coverage, 13578,
     /* 371669 */     GIR_EraseRootFromParent_Done,
     /* 371670 */   // Label 7418: @371670
     /* 371670 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(371770), // Rule ID 13580 //
     /* 371675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371716 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371726 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371738 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371768 */     GIR_RootConstrainSelectedInstOperands,
     /* 371769 */     // GIR_Coverage, 13580,
     /* 371769 */     GIR_EraseRootFromParent_Done,
     /* 371770 */   // Label 7419: @371770
     /* 371770 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(371870), // Rule ID 4812 //
     /* 371775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371826 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371838 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 371857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 371868 */     GIR_RootConstrainSelectedInstOperands,
     /* 371869 */     // GIR_Coverage, 4812,
     /* 371869 */     GIR_EraseRootFromParent_Done,
     /* 371870 */   // Label 7420: @371870
     /* 371870 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(371967), // Rule ID 4776 //
     /* 371875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371915 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371925 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371937 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371965 */     GIR_RootConstrainSelectedInstOperands,
     /* 371966 */     // GIR_Coverage, 4776,
     /* 371966 */     GIR_EraseRootFromParent_Done,
     /* 371967 */   // Label 7421: @371967
     /* 371967 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(372045), // Rule ID 6122 //
     /* 371972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372013 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372017 */     // MIs[3] Operand 1
     /* 372017 */     // No operand predicates
     /* 372017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372027 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372043 */     GIR_RootConstrainSelectedInstOperands,
     /* 372044 */     // GIR_Coverage, 6122,
     /* 372044 */     GIR_EraseRootFromParent_Done,
     /* 372045 */   // Label 7422: @372045
     /* 372045 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(372129), // Rule ID 6034 //
     /* 372050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372082 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372086 */     // MIs[2] Operand 1
     /* 372086 */     // No operand predicates
     /* 372086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 372098 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372109 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 372120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372127 */     GIR_RootConstrainSelectedInstOperands,
     /* 372128 */     // GIR_Coverage, 6034,
     /* 372128 */     GIR_EraseRootFromParent_Done,
     /* 372129 */   // Label 7423: @372129
     /* 372129 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(372210), // Rule ID 6066 //
     /* 372134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372178 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372182 */     // MIs[3] Operand 1
     /* 372182 */     // No operand predicates
     /* 372182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372192 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372208 */     GIR_RootConstrainSelectedInstOperands,
     /* 372209 */     // GIR_Coverage, 6066,
     /* 372209 */     GIR_EraseRootFromParent_Done,
     /* 372210 */   // Label 7424: @372210
     /* 372210 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(372294), // Rule ID 6098 //
     /* 372215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372264 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372268 */     // MIs[3] Operand 1
     /* 372268 */     // No operand predicates
     /* 372268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372274 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372292 */     GIR_RootConstrainSelectedInstOperands,
     /* 372293 */     // GIR_Coverage, 6098,
     /* 372293 */     GIR_EraseRootFromParent_Done,
     /* 372294 */   // Label 7425: @372294
     /* 372294 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(372372), // Rule ID 6144 //
     /* 372299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372344 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372348 */     // MIs[3] Operand 1
     /* 372348 */     // No operand predicates
     /* 372348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372354 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372370 */     GIR_RootConstrainSelectedInstOperands,
     /* 372371 */     // GIR_Coverage, 6144,
     /* 372371 */     GIR_EraseRootFromParent_Done,
     /* 372372 */   // Label 7426: @372372
     /* 372372 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(372453), // Rule ID 6002 //
     /* 372377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372429 */     // MIs[3] Operand 1
     /* 372429 */     // No operand predicates
     /* 372429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372435 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372451 */     GIR_RootConstrainSelectedInstOperands,
     /* 372452 */     // GIR_Coverage, 6002,
     /* 372452 */     GIR_EraseRootFromParent_Done,
     /* 372453 */   // Label 7427: @372453
     /* 372453 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(372538), // Rule ID 2456 //
     /* 372458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372482 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372496 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372508 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372536 */     GIR_RootConstrainSelectedInstOperands,
     /* 372537 */     // GIR_Coverage, 2456,
     /* 372537 */     GIR_EraseRootFromParent_Done,
     /* 372538 */   // Label 7428: @372538
     /* 372538 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(372623), // Rule ID 2454 //
     /* 372543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372571 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372581 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 372581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372593 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372621 */     GIR_RootConstrainSelectedInstOperands,
     /* 372622 */     // GIR_Coverage, 2454,
     /* 372622 */     GIR_EraseRootFromParent_Done,
     /* 372623 */   // Label 7429: @372623
     /* 372623 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(372692), // Rule ID 2546 //
     /* 372628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372664 */     // MIs[2] Operand 1
     /* 372664 */     // No operand predicates
     /* 372664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372674 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 372677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372690 */     GIR_RootConstrainSelectedInstOperands,
     /* 372691 */     // GIR_Coverage, 2546,
     /* 372691 */     GIR_EraseRootFromParent_Done,
     /* 372692 */   // Label 7430: @372692
     /* 372692 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(372761), // Rule ID 5970 //
     /* 372697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372733 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372737 */     // MIs[2] Operand 1
     /* 372737 */     // No operand predicates
     /* 372737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372743 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 372746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372759 */     GIR_RootConstrainSelectedInstOperands,
     /* 372760 */     // GIR_Coverage, 5970,
     /* 372760 */     GIR_EraseRootFromParent_Done,
     /* 372761 */   // Label 7431: @372761
     /* 372761 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(372811), // Rule ID 13016 //
     /* 372766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372796 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372809 */     GIR_RootConstrainSelectedInstOperands,
     /* 372810 */     // GIR_Coverage, 13016,
     /* 372810 */     GIR_EraseRootFromParent_Done,
     /* 372811 */   // Label 7432: @372811
     /* 372811 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(372861), // Rule ID 647 //
     /* 372816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372846 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372859 */     GIR_RootConstrainSelectedInstOperands,
     /* 372860 */     // GIR_Coverage, 647,
     /* 372860 */     GIR_EraseRootFromParent_Done,
     /* 372861 */   // Label 7433: @372861
     /* 372861 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(372911), // Rule ID 659 //
     /* 372866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372896 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 372899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 372909 */     GIR_RootConstrainSelectedInstOperands,
     /* 372910 */     // GIR_Coverage, 659,
     /* 372910 */     GIR_EraseRootFromParent_Done,
     /* 372911 */   // Label 7434: @372911
     /* 372911 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(372942), // Rule ID 641 //
     /* 372916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372931 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372936 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372940 */     GIR_RootConstrainSelectedInstOperands,
     /* 372941 */     // GIR_Coverage, 641,
     /* 372941 */     GIR_Done,
     /* 372942 */   // Label 7435: @372942
     /* 372942 */   GIM_Reject,
     /* 372943 */ // Label 7405: @372943
     /* 372943 */ GIM_Reject,
     /* 372944 */ // Label 7339: @372944
     /* 372944 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(374464),
     /* 372949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 372955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 372958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372962 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(373040), // Rule ID 6102 //
     /* 372967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 372975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 373004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373008 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373012 */     // MIs[3] Operand 1
     /* 373012 */     // No operand predicates
     /* 373012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373022 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373038 */     GIR_RootConstrainSelectedInstOperands,
     /* 373039 */     // GIR_Coverage, 6102,
     /* 373039 */     GIR_EraseRootFromParent_Done,
     /* 373040 */   // Label 7437: @373040
     /* 373040 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(373124), // Rule ID 6018 //
     /* 373045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373077 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373081 */     // MIs[2] Operand 1
     /* 373081 */     // No operand predicates
     /* 373081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373093 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373104 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 373115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373122 */     GIR_RootConstrainSelectedInstOperands,
     /* 373123 */     // GIR_Coverage, 6018,
     /* 373123 */     GIR_EraseRootFromParent_Done,
     /* 373124 */   // Label 7438: @373124
     /* 373124 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(373205), // Rule ID 6050 //
     /* 373129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373173 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373177 */     // MIs[3] Operand 1
     /* 373177 */     // No operand predicates
     /* 373177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373187 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373203 */     GIR_RootConstrainSelectedInstOperands,
     /* 373204 */     // GIR_Coverage, 6050,
     /* 373204 */     GIR_EraseRootFromParent_Done,
     /* 373205 */   // Label 7439: @373205
     /* 373205 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(373289), // Rule ID 6082 //
     /* 373210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373259 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373263 */     // MIs[3] Operand 1
     /* 373263 */     // No operand predicates
     /* 373263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373269 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373287 */     GIR_RootConstrainSelectedInstOperands,
     /* 373288 */     // GIR_Coverage, 6082,
     /* 373288 */     GIR_EraseRootFromParent_Done,
     /* 373289 */   // Label 7440: @373289
     /* 373289 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(373367), // Rule ID 6124 //
     /* 373294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 373335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373339 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373343 */     // MIs[3] Operand 1
     /* 373343 */     // No operand predicates
     /* 373343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373349 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373365 */     GIR_RootConstrainSelectedInstOperands,
     /* 373366 */     // GIR_Coverage, 6124,
     /* 373366 */     GIR_EraseRootFromParent_Done,
     /* 373367 */   // Label 7441: @373367
     /* 373367 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(373448), // Rule ID 5986 //
     /* 373372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373420 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373424 */     // MIs[3] Operand 1
     /* 373424 */     // No operand predicates
     /* 373424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373430 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373446 */     GIR_RootConstrainSelectedInstOperands,
     /* 373447 */     // GIR_Coverage, 5986,
     /* 373447 */     GIR_EraseRootFromParent_Done,
     /* 373448 */   // Label 7442: @373448
     /* 373448 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(373517), // Rule ID 2530 //
     /* 373453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373489 */     // MIs[2] Operand 1
     /* 373489 */     // No operand predicates
     /* 373489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373499 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 373502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373515 */     GIR_RootConstrainSelectedInstOperands,
     /* 373516 */     // GIR_Coverage, 2530,
     /* 373516 */     GIR_EraseRootFromParent_Done,
     /* 373517 */   // Label 7443: @373517
     /* 373517 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(373586), // Rule ID 5954 //
     /* 373522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373562 */     // MIs[2] Operand 1
     /* 373562 */     // No operand predicates
     /* 373562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373568 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 373571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373584 */     GIR_RootConstrainSelectedInstOperands,
     /* 373585 */     // GIR_Coverage, 5954,
     /* 373585 */     GIR_EraseRootFromParent_Done,
     /* 373586 */   // Label 7444: @373586
     /* 373586 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(373679), // Rule ID 6106 //
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373630 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373649 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373677 */     GIR_RootConstrainSelectedInstOperands,
     /* 373678 */     // GIR_Coverage, 6106,
     /* 373678 */     GIR_EraseRootFromParent_Done,
     /* 373679 */   // Label 7445: @373679
     /* 373679 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(373778), // Rule ID 6020 //
     /* 373684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373727 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 373770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373776 */     GIR_RootConstrainSelectedInstOperands,
     /* 373777 */     // GIR_Coverage, 6020,
     /* 373777 */     GIR_EraseRootFromParent_Done,
     /* 373778 */   // Label 7446: @373778
     /* 373778 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(373874), // Rule ID 6052 //
     /* 373783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 373806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373825 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373837 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373872 */     GIR_RootConstrainSelectedInstOperands,
     /* 373873 */     // GIR_Coverage, 6052,
     /* 373873 */     GIR_EraseRootFromParent_Done,
     /* 373874 */   // Label 7447: @373874
     /* 373874 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(373973), // Rule ID 6084 //
     /* 373879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 373907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373922 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373941 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373971 */     GIR_RootConstrainSelectedInstOperands,
     /* 373972 */     // GIR_Coverage, 6084,
     /* 373972 */     GIR_EraseRootFromParent_Done,
     /* 373973 */   // Label 7448: @373973
     /* 373973 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(374066), // Rule ID 6128 //
     /* 373978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374017 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374064 */     GIR_RootConstrainSelectedInstOperands,
     /* 374065 */     // GIR_Coverage, 6128,
     /* 374065 */     GIR_EraseRootFromParent_Done,
     /* 374066 */   // Label 7449: @374066
     /* 374066 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(374162), // Rule ID 5988 //
     /* 374071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 374098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374113 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374160 */     GIR_RootConstrainSelectedInstOperands,
     /* 374161 */     // GIR_Coverage, 5988,
     /* 374161 */     GIR_EraseRootFromParent_Done,
     /* 374162 */   // Label 7450: @374162
     /* 374162 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(374246), // Rule ID 2532 //
     /* 374167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374197 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374244 */     GIR_RootConstrainSelectedInstOperands,
     /* 374245 */     // GIR_Coverage, 2532,
     /* 374245 */     GIR_EraseRootFromParent_Done,
     /* 374246 */   // Label 7451: @374246
     /* 374246 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(374296), // Rule ID 13046 //
     /* 374251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374281 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 374284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374294 */     GIR_RootConstrainSelectedInstOperands,
     /* 374295 */     // GIR_Coverage, 13046,
     /* 374295 */     GIR_EraseRootFromParent_Done,
     /* 374296 */   // Label 7452: @374296
     /* 374296 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(374380), // Rule ID 5956 //
     /* 374301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374331 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374350 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374378 */     GIR_RootConstrainSelectedInstOperands,
     /* 374379 */     // GIR_Coverage, 5956,
     /* 374379 */     GIR_EraseRootFromParent_Done,
     /* 374380 */   // Label 7453: @374380
     /* 374380 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(374430), // Rule ID 1300 //
     /* 374385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374415 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 374418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374428 */     GIR_RootConstrainSelectedInstOperands,
     /* 374429 */     // GIR_Coverage, 1300,
     /* 374429 */     GIR_EraseRootFromParent_Done,
     /* 374430 */   // Label 7454: @374430
     /* 374430 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(374463), // Rule ID 1290 //
     /* 374435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374450 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 374453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 374461 */     GIR_RootConstrainSelectedInstOperands,
     /* 374462 */     // GIR_Coverage, 1290,
     /* 374462 */     GIR_EraseRootFromParent_Done,
     /* 374463 */   // Label 7455: @374463
     /* 374463 */   GIM_Reject,
     /* 374464 */ // Label 7436: @374464
     /* 374464 */ GIM_Reject,
     /* 374465 */ // Label 7340: @374465
     /* 374465 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(375985),
     /* 374470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 374476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 374479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374483 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(374561), // Rule ID 6114 //
     /* 374488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 374525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374529 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374533 */     // MIs[3] Operand 1
     /* 374533 */     // No operand predicates
     /* 374533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374541 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374543 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374559 */     GIR_RootConstrainSelectedInstOperands,
     /* 374560 */     // GIR_Coverage, 6114,
     /* 374560 */     GIR_EraseRootFromParent_Done,
     /* 374561 */   // Label 7457: @374561
     /* 374561 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(374645), // Rule ID 6026 //
     /* 374566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374602 */     // MIs[2] Operand 1
     /* 374602 */     // No operand predicates
     /* 374602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374614 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374625 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 374636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374643 */     GIR_RootConstrainSelectedInstOperands,
     /* 374644 */     // GIR_Coverage, 6026,
     /* 374644 */     GIR_EraseRootFromParent_Done,
     /* 374645 */   // Label 7458: @374645
     /* 374645 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(374726), // Rule ID 6058 //
     /* 374650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374698 */     // MIs[3] Operand 1
     /* 374698 */     // No operand predicates
     /* 374698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374708 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374724 */     GIR_RootConstrainSelectedInstOperands,
     /* 374725 */     // GIR_Coverage, 6058,
     /* 374725 */     GIR_EraseRootFromParent_Done,
     /* 374726 */   // Label 7459: @374726
     /* 374726 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(374810), // Rule ID 6090 //
     /* 374731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374784 */     // MIs[3] Operand 1
     /* 374784 */     // No operand predicates
     /* 374784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374790 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374808 */     GIR_RootConstrainSelectedInstOperands,
     /* 374809 */     // GIR_Coverage, 6090,
     /* 374809 */     GIR_EraseRootFromParent_Done,
     /* 374810 */   // Label 7460: @374810
     /* 374810 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(374888), // Rule ID 6136 //
     /* 374815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 374856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374860 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374864 */     // MIs[3] Operand 1
     /* 374864 */     // No operand predicates
     /* 374864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374870 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374886 */     GIR_RootConstrainSelectedInstOperands,
     /* 374887 */     // GIR_Coverage, 6136,
     /* 374887 */     GIR_EraseRootFromParent_Done,
     /* 374888 */   // Label 7461: @374888
     /* 374888 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(374969), // Rule ID 5994 //
     /* 374893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374941 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374945 */     // MIs[3] Operand 1
     /* 374945 */     // No operand predicates
     /* 374945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374951 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374967 */     GIR_RootConstrainSelectedInstOperands,
     /* 374968 */     // GIR_Coverage, 5994,
     /* 374968 */     GIR_EraseRootFromParent_Done,
     /* 374969 */   // Label 7462: @374969
     /* 374969 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(375038), // Rule ID 2538 //
     /* 374974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375010 */     // MIs[2] Operand 1
     /* 375010 */     // No operand predicates
     /* 375010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375020 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375036 */     GIR_RootConstrainSelectedInstOperands,
     /* 375037 */     // GIR_Coverage, 2538,
     /* 375037 */     GIR_EraseRootFromParent_Done,
     /* 375038 */   // Label 7463: @375038
     /* 375038 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(375107), // Rule ID 5962 //
     /* 375043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375083 */     // MIs[2] Operand 1
     /* 375083 */     // No operand predicates
     /* 375083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375089 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375105 */     GIR_RootConstrainSelectedInstOperands,
     /* 375106 */     // GIR_Coverage, 5962,
     /* 375106 */     GIR_EraseRootFromParent_Done,
     /* 375107 */   // Label 7464: @375107
     /* 375107 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(375200), // Rule ID 6116 //
     /* 375112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375151 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375170 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375198 */     GIR_RootConstrainSelectedInstOperands,
     /* 375199 */     // GIR_Coverage, 6116,
     /* 375199 */     GIR_EraseRootFromParent_Done,
     /* 375200 */   // Label 7465: @375200
     /* 375200 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(375299), // Rule ID 6028 //
     /* 375205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375248 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375260 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375297 */     GIR_RootConstrainSelectedInstOperands,
     /* 375298 */     // GIR_Coverage, 6028,
     /* 375298 */     GIR_EraseRootFromParent_Done,
     /* 375299 */   // Label 7466: @375299
     /* 375299 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(375395), // Rule ID 6060 //
     /* 375304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375346 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375358 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375393 */     GIR_RootConstrainSelectedInstOperands,
     /* 375394 */     // GIR_Coverage, 6060,
     /* 375394 */     GIR_EraseRootFromParent_Done,
     /* 375395 */   // Label 7467: @375395
     /* 375395 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(375494), // Rule ID 6092 //
     /* 375400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375443 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375455 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375492 */     GIR_RootConstrainSelectedInstOperands,
     /* 375493 */     // GIR_Coverage, 6092,
     /* 375493 */     GIR_EraseRootFromParent_Done,
     /* 375494 */   // Label 7468: @375494
     /* 375494 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(375587), // Rule ID 6138 //
     /* 375499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375538 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375557 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375585 */     GIR_RootConstrainSelectedInstOperands,
     /* 375586 */     // GIR_Coverage, 6138,
     /* 375586 */     GIR_EraseRootFromParent_Done,
     /* 375587 */   // Label 7469: @375587
     /* 375587 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(375683), // Rule ID 5996 //
     /* 375592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375634 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375681 */     GIR_RootConstrainSelectedInstOperands,
     /* 375682 */     // GIR_Coverage, 5996,
     /* 375682 */     GIR_EraseRootFromParent_Done,
     /* 375683 */   // Label 7470: @375683
     /* 375683 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(375767), // Rule ID 2540 //
     /* 375688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375718 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375730 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375765 */     GIR_RootConstrainSelectedInstOperands,
     /* 375766 */     // GIR_Coverage, 2540,
     /* 375766 */     GIR_EraseRootFromParent_Done,
     /* 375767 */   // Label 7471: @375767
     /* 375767 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(375817), // Rule ID 13050 //
     /* 375772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375802 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 375805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375815 */     GIR_RootConstrainSelectedInstOperands,
     /* 375816 */     // GIR_Coverage, 13050,
     /* 375816 */     GIR_EraseRootFromParent_Done,
     /* 375817 */   // Label 7472: @375817
     /* 375817 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(375901), // Rule ID 5964 //
     /* 375822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375852 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375899 */     GIR_RootConstrainSelectedInstOperands,
     /* 375900 */     // GIR_Coverage, 5964,
     /* 375900 */     GIR_EraseRootFromParent_Done,
     /* 375901 */   // Label 7473: @375901
     /* 375901 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(375951), // Rule ID 1304 //
     /* 375906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375936 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 375939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375949 */     GIR_RootConstrainSelectedInstOperands,
     /* 375950 */     // GIR_Coverage, 1304,
     /* 375950 */     GIR_EraseRootFromParent_Done,
     /* 375951 */   // Label 7474: @375951
     /* 375951 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(375984), // Rule ID 1294 //
     /* 375956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375971 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 375974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 375982 */     GIR_RootConstrainSelectedInstOperands,
     /* 375983 */     // GIR_Coverage, 1294,
     /* 375983 */     GIR_EraseRootFromParent_Done,
     /* 375984 */   // Label 7475: @375984
     /* 375984 */   GIM_Reject,
     /* 375985 */ // Label 7456: @375985
     /* 375985 */ GIM_Reject,
     /* 375986 */ // Label 7341: @375986
     /* 375986 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(377164),
     /* 375991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 375997 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 376000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376004 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(376088), // Rule ID 6010 //
     /* 376009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376045 */     // MIs[2] Operand 1
     /* 376045 */     // No operand predicates
     /* 376045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376057 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376068 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 376079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376086 */     GIR_RootConstrainSelectedInstOperands,
     /* 376087 */     // GIR_Coverage, 6010,
     /* 376087 */     GIR_EraseRootFromParent_Done,
     /* 376088 */   // Label 7477: @376088
     /* 376088 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(376169), // Rule ID 6042 //
     /* 376093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376137 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376141 */     // MIs[3] Operand 1
     /* 376141 */     // No operand predicates
     /* 376141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376151 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376167 */     GIR_RootConstrainSelectedInstOperands,
     /* 376168 */     // GIR_Coverage, 6042,
     /* 376168 */     GIR_EraseRootFromParent_Done,
     /* 376169 */   // Label 7478: @376169
     /* 376169 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(376253), // Rule ID 6074 //
     /* 376174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376223 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376227 */     // MIs[3] Operand 1
     /* 376227 */     // No operand predicates
     /* 376227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376233 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376251 */     GIR_RootConstrainSelectedInstOperands,
     /* 376252 */     // GIR_Coverage, 6074,
     /* 376252 */     GIR_EraseRootFromParent_Done,
     /* 376253 */   // Label 7479: @376253
     /* 376253 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(376334), // Rule ID 5978 //
     /* 376258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376306 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376310 */     // MIs[3] Operand 1
     /* 376310 */     // No operand predicates
     /* 376310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376316 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376332 */     GIR_RootConstrainSelectedInstOperands,
     /* 376333 */     // GIR_Coverage, 5978,
     /* 376333 */     GIR_EraseRootFromParent_Done,
     /* 376334 */   // Label 7480: @376334
     /* 376334 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(376403), // Rule ID 2522 //
     /* 376339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376375 */     // MIs[2] Operand 1
     /* 376375 */     // No operand predicates
     /* 376375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376385 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376401 */     GIR_RootConstrainSelectedInstOperands,
     /* 376402 */     // GIR_Coverage, 2522,
     /* 376402 */     GIR_EraseRootFromParent_Done,
     /* 376403 */   // Label 7481: @376403
     /* 376403 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(376472), // Rule ID 5946 //
     /* 376408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376448 */     // MIs[2] Operand 1
     /* 376448 */     // No operand predicates
     /* 376448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376454 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376470 */     GIR_RootConstrainSelectedInstOperands,
     /* 376471 */     // GIR_Coverage, 5946,
     /* 376471 */     GIR_EraseRootFromParent_Done,
     /* 376472 */   // Label 7482: @376472
     /* 376472 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(376571), // Rule ID 6012 //
     /* 376477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376520 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376539 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376569 */     GIR_RootConstrainSelectedInstOperands,
     /* 376570 */     // GIR_Coverage, 6012,
     /* 376570 */     GIR_EraseRootFromParent_Done,
     /* 376571 */   // Label 7483: @376571
     /* 376571 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(376667), // Rule ID 6044 //
     /* 376576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376618 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376637 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376665 */     GIR_RootConstrainSelectedInstOperands,
     /* 376666 */     // GIR_Coverage, 6044,
     /* 376666 */     GIR_EraseRootFromParent_Done,
     /* 376667 */   // Label 7484: @376667
     /* 376667 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(376766), // Rule ID 6076 //
     /* 376672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376715 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376764 */     GIR_RootConstrainSelectedInstOperands,
     /* 376765 */     // GIR_Coverage, 6076,
     /* 376765 */     GIR_EraseRootFromParent_Done,
     /* 376766 */   // Label 7485: @376766
     /* 376766 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(376862), // Rule ID 5980 //
     /* 376771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376813 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376860 */     GIR_RootConstrainSelectedInstOperands,
     /* 376861 */     // GIR_Coverage, 5980,
     /* 376861 */     GIR_EraseRootFromParent_Done,
     /* 376862 */   // Label 7486: @376862
     /* 376862 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(376946), // Rule ID 2524 //
     /* 376867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376897 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376944 */     GIR_RootConstrainSelectedInstOperands,
     /* 376945 */     // GIR_Coverage, 2524,
     /* 376945 */     GIR_EraseRootFromParent_Done,
     /* 376946 */   // Label 7487: @376946
     /* 376946 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(376996), // Rule ID 13042 //
     /* 376951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376981 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 376981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 376984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376994 */     GIR_RootConstrainSelectedInstOperands,
     /* 376995 */     // GIR_Coverage, 13042,
     /* 376995 */     GIR_EraseRootFromParent_Done,
     /* 376996 */   // Label 7488: @376996
     /* 376996 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(377080), // Rule ID 5948 //
     /* 377001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377031 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377050 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 377066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377078 */     GIR_RootConstrainSelectedInstOperands,
     /* 377079 */     // GIR_Coverage, 5948,
     /* 377079 */     GIR_EraseRootFromParent_Done,
     /* 377080 */   // Label 7489: @377080
     /* 377080 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(377130), // Rule ID 1296 //
     /* 377085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377115 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 377118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377128 */     GIR_RootConstrainSelectedInstOperands,
     /* 377129 */     // GIR_Coverage, 1296,
     /* 377129 */     GIR_EraseRootFromParent_Done,
     /* 377130 */   // Label 7490: @377130
     /* 377130 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(377163), // Rule ID 1286 //
     /* 377135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377150 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 377153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 377161 */     GIR_RootConstrainSelectedInstOperands,
     /* 377162 */     // GIR_Coverage, 1286,
     /* 377162 */     GIR_EraseRootFromParent_Done,
     /* 377163 */   // Label 7491: @377163
     /* 377163 */   GIM_Reject,
     /* 377164 */ // Label 7476: @377164
     /* 377164 */ GIM_Reject,
     /* 377165 */ // Label 7342: @377165
     /* 377165 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(378685),
     /* 377170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 377176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 377179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377183 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(377261), // Rule ID 6108 //
     /* 377188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377229 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377233 */     // MIs[3] Operand 1
     /* 377233 */     // No operand predicates
     /* 377233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377243 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377259 */     GIR_RootConstrainSelectedInstOperands,
     /* 377260 */     // GIR_Coverage, 6108,
     /* 377260 */     GIR_EraseRootFromParent_Done,
     /* 377261 */   // Label 7493: @377261
     /* 377261 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(377345), // Rule ID 6022 //
     /* 377266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377302 */     // MIs[2] Operand 1
     /* 377302 */     // No operand predicates
     /* 377302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377314 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377325 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 377336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377343 */     GIR_RootConstrainSelectedInstOperands,
     /* 377344 */     // GIR_Coverage, 6022,
     /* 377344 */     GIR_EraseRootFromParent_Done,
     /* 377345 */   // Label 7494: @377345
     /* 377345 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(377426), // Rule ID 6054 //
     /* 377350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377398 */     // MIs[3] Operand 1
     /* 377398 */     // No operand predicates
     /* 377398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377408 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377424 */     GIR_RootConstrainSelectedInstOperands,
     /* 377425 */     // GIR_Coverage, 6054,
     /* 377425 */     GIR_EraseRootFromParent_Done,
     /* 377426 */   // Label 7495: @377426
     /* 377426 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(377510), // Rule ID 6086 //
     /* 377431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377480 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377484 */     // MIs[3] Operand 1
     /* 377484 */     // No operand predicates
     /* 377484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377490 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377508 */     GIR_RootConstrainSelectedInstOperands,
     /* 377509 */     // GIR_Coverage, 6086,
     /* 377509 */     GIR_EraseRootFromParent_Done,
     /* 377510 */   // Label 7496: @377510
     /* 377510 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(377588), // Rule ID 6130 //
     /* 377515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377560 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377564 */     // MIs[3] Operand 1
     /* 377564 */     // No operand predicates
     /* 377564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377570 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377586 */     GIR_RootConstrainSelectedInstOperands,
     /* 377587 */     // GIR_Coverage, 6130,
     /* 377587 */     GIR_EraseRootFromParent_Done,
     /* 377588 */   // Label 7497: @377588
     /* 377588 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(377669), // Rule ID 5990 //
     /* 377593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377641 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377645 */     // MIs[3] Operand 1
     /* 377645 */     // No operand predicates
     /* 377645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377651 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377667 */     GIR_RootConstrainSelectedInstOperands,
     /* 377668 */     // GIR_Coverage, 5990,
     /* 377668 */     GIR_EraseRootFromParent_Done,
     /* 377669 */   // Label 7498: @377669
     /* 377669 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(377738), // Rule ID 2534 //
     /* 377674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377710 */     // MIs[2] Operand 1
     /* 377710 */     // No operand predicates
     /* 377710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377720 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 377723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377736 */     GIR_RootConstrainSelectedInstOperands,
     /* 377737 */     // GIR_Coverage, 2534,
     /* 377737 */     GIR_EraseRootFromParent_Done,
     /* 377738 */   // Label 7499: @377738
     /* 377738 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(377807), // Rule ID 5958 //
     /* 377743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377783 */     // MIs[2] Operand 1
     /* 377783 */     // No operand predicates
     /* 377783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377789 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 377792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377805 */     GIR_RootConstrainSelectedInstOperands,
     /* 377806 */     // GIR_Coverage, 5958,
     /* 377806 */     GIR_EraseRootFromParent_Done,
     /* 377807 */   // Label 7500: @377807
     /* 377807 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(377900), // Rule ID 6112 //
     /* 377812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377851 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377863 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377898 */     GIR_RootConstrainSelectedInstOperands,
     /* 377899 */     // GIR_Coverage, 6112,
     /* 377899 */     GIR_EraseRootFromParent_Done,
     /* 377900 */   // Label 7501: @377900
     /* 377900 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(377999), // Rule ID 6024 //
     /* 377905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377948 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377960 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 377991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377997 */     GIR_RootConstrainSelectedInstOperands,
     /* 377998 */     // GIR_Coverage, 6024,
     /* 377998 */     GIR_EraseRootFromParent_Done,
     /* 377999 */   // Label 7502: @377999
     /* 377999 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(378095), // Rule ID 6056 //
     /* 378004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378046 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378093 */     GIR_RootConstrainSelectedInstOperands,
     /* 378094 */     // GIR_Coverage, 6056,
     /* 378094 */     GIR_EraseRootFromParent_Done,
     /* 378095 */   // Label 7503: @378095
     /* 378095 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(378194), // Rule ID 6088 //
     /* 378100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378143 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378192 */     GIR_RootConstrainSelectedInstOperands,
     /* 378193 */     // GIR_Coverage, 6088,
     /* 378193 */     GIR_EraseRootFromParent_Done,
     /* 378194 */   // Label 7504: @378194
     /* 378194 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(378287), // Rule ID 6134 //
     /* 378199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378238 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378285 */     GIR_RootConstrainSelectedInstOperands,
     /* 378286 */     // GIR_Coverage, 6134,
     /* 378286 */     GIR_EraseRootFromParent_Done,
     /* 378287 */   // Label 7505: @378287
     /* 378287 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(378383), // Rule ID 5992 //
     /* 378292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378334 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378381 */     GIR_RootConstrainSelectedInstOperands,
     /* 378382 */     // GIR_Coverage, 5992,
     /* 378382 */     GIR_EraseRootFromParent_Done,
     /* 378383 */   // Label 7506: @378383
     /* 378383 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(378467), // Rule ID 2536 //
     /* 378388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378418 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378465 */     GIR_RootConstrainSelectedInstOperands,
     /* 378466 */     // GIR_Coverage, 2536,
     /* 378466 */     GIR_EraseRootFromParent_Done,
     /* 378467 */   // Label 7507: @378467
     /* 378467 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(378517), // Rule ID 13048 //
     /* 378472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378502 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 378505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378515 */     GIR_RootConstrainSelectedInstOperands,
     /* 378516 */     // GIR_Coverage, 13048,
     /* 378516 */     GIR_EraseRootFromParent_Done,
     /* 378517 */   // Label 7508: @378517
     /* 378517 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(378601), // Rule ID 5960 //
     /* 378522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378552 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378564 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378599 */     GIR_RootConstrainSelectedInstOperands,
     /* 378600 */     // GIR_Coverage, 5960,
     /* 378600 */     GIR_EraseRootFromParent_Done,
     /* 378601 */   // Label 7509: @378601
     /* 378601 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(378651), // Rule ID 1302 //
     /* 378606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378636 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 378639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378649 */     GIR_RootConstrainSelectedInstOperands,
     /* 378650 */     // GIR_Coverage, 1302,
     /* 378650 */     GIR_EraseRootFromParent_Done,
     /* 378651 */   // Label 7510: @378651
     /* 378651 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(378684), // Rule ID 1292 //
     /* 378656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378671 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 378674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 378682 */     GIR_RootConstrainSelectedInstOperands,
     /* 378683 */     // GIR_Coverage, 1292,
     /* 378683 */     GIR_EraseRootFromParent_Done,
     /* 378684 */   // Label 7511: @378684
     /* 378684 */   GIM_Reject,
     /* 378685 */ // Label 7492: @378685
     /* 378685 */ GIM_Reject,
     /* 378686 */ // Label 7343: @378686
     /* 378686 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(379864),
     /* 378691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 378697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 378700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378704 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(378788), // Rule ID 6006 //
     /* 378709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378741 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378745 */     // MIs[2] Operand 1
     /* 378745 */     // No operand predicates
     /* 378745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378757 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378768 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 378771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 378779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378786 */     GIR_RootConstrainSelectedInstOperands,
     /* 378787 */     // GIR_Coverage, 6006,
     /* 378787 */     GIR_EraseRootFromParent_Done,
     /* 378788 */   // Label 7513: @378788
     /* 378788 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(378869), // Rule ID 6038 //
     /* 378793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378841 */     // MIs[3] Operand 1
     /* 378841 */     // No operand predicates
     /* 378841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378851 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 378854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378867 */     GIR_RootConstrainSelectedInstOperands,
     /* 378868 */     // GIR_Coverage, 6038,
     /* 378868 */     GIR_EraseRootFromParent_Done,
     /* 378869 */   // Label 7514: @378869
     /* 378869 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(378953), // Rule ID 6070 //
     /* 378874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378923 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378927 */     // MIs[3] Operand 1
     /* 378927 */     // No operand predicates
     /* 378927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378933 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 378936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378951 */     GIR_RootConstrainSelectedInstOperands,
     /* 378952 */     // GIR_Coverage, 6070,
     /* 378952 */     GIR_EraseRootFromParent_Done,
     /* 378953 */   // Label 7515: @378953
     /* 378953 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(379034), // Rule ID 5974 //
     /* 378958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379010 */     // MIs[3] Operand 1
     /* 379010 */     // No operand predicates
     /* 379010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379016 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379032 */     GIR_RootConstrainSelectedInstOperands,
     /* 379033 */     // GIR_Coverage, 5974,
     /* 379033 */     GIR_EraseRootFromParent_Done,
     /* 379034 */   // Label 7516: @379034
     /* 379034 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(379103), // Rule ID 2518 //
     /* 379039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379075 */     // MIs[2] Operand 1
     /* 379075 */     // No operand predicates
     /* 379075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379085 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379101 */     GIR_RootConstrainSelectedInstOperands,
     /* 379102 */     // GIR_Coverage, 2518,
     /* 379102 */     GIR_EraseRootFromParent_Done,
     /* 379103 */   // Label 7517: @379103
     /* 379103 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(379172), // Rule ID 5942 //
     /* 379108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379148 */     // MIs[2] Operand 1
     /* 379148 */     // No operand predicates
     /* 379148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379154 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379170 */     GIR_RootConstrainSelectedInstOperands,
     /* 379171 */     // GIR_Coverage, 5942,
     /* 379171 */     GIR_EraseRootFromParent_Done,
     /* 379172 */   // Label 7518: @379172
     /* 379172 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(379271), // Rule ID 6008 //
     /* 379177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379220 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379232 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 379263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379269 */     GIR_RootConstrainSelectedInstOperands,
     /* 379270 */     // GIR_Coverage, 6008,
     /* 379270 */     GIR_EraseRootFromParent_Done,
     /* 379271 */   // Label 7519: @379271
     /* 379271 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(379367), // Rule ID 6040 //
     /* 379276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379318 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379330 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379365 */     GIR_RootConstrainSelectedInstOperands,
     /* 379366 */     // GIR_Coverage, 6040,
     /* 379366 */     GIR_EraseRootFromParent_Done,
     /* 379367 */   // Label 7520: @379367
     /* 379367 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(379466), // Rule ID 6072 //
     /* 379372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379415 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379464 */     GIR_RootConstrainSelectedInstOperands,
     /* 379465 */     // GIR_Coverage, 6072,
     /* 379465 */     GIR_EraseRootFromParent_Done,
     /* 379466 */   // Label 7521: @379466
     /* 379466 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(379562), // Rule ID 5976 //
     /* 379471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379513 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379560 */     GIR_RootConstrainSelectedInstOperands,
     /* 379561 */     // GIR_Coverage, 5976,
     /* 379561 */     GIR_EraseRootFromParent_Done,
     /* 379562 */   // Label 7522: @379562
     /* 379562 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(379646), // Rule ID 2520 //
     /* 379567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379597 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379644 */     GIR_RootConstrainSelectedInstOperands,
     /* 379645 */     // GIR_Coverage, 2520,
     /* 379645 */     GIR_EraseRootFromParent_Done,
     /* 379646 */   // Label 7523: @379646
     /* 379646 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(379696), // Rule ID 13044 //
     /* 379651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379681 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 379684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379694 */     GIR_RootConstrainSelectedInstOperands,
     /* 379695 */     // GIR_Coverage, 13044,
     /* 379695 */     GIR_EraseRootFromParent_Done,
     /* 379696 */   // Label 7524: @379696
     /* 379696 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(379780), // Rule ID 5944 //
     /* 379701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379731 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379778 */     GIR_RootConstrainSelectedInstOperands,
     /* 379779 */     // GIR_Coverage, 5944,
     /* 379779 */     GIR_EraseRootFromParent_Done,
     /* 379780 */   // Label 7525: @379780
     /* 379780 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(379830), // Rule ID 1298 //
     /* 379785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379815 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 379818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379828 */     GIR_RootConstrainSelectedInstOperands,
     /* 379829 */     // GIR_Coverage, 1298,
     /* 379829 */     GIR_EraseRootFromParent_Done,
     /* 379830 */   // Label 7526: @379830
     /* 379830 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(379863), // Rule ID 1288 //
     /* 379835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379850 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 379853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 379861 */     GIR_RootConstrainSelectedInstOperands,
     /* 379862 */     // GIR_Coverage, 1288,
     /* 379862 */     GIR_EraseRootFromParent_Done,
     /* 379863 */   // Label 7527: @379863
     /* 379863 */   GIM_Reject,
     /* 379864 */ // Label 7512: @379864
     /* 379864 */ GIM_Reject,
     /* 379865 */ // Label 7344: @379865
     /* 379865 */ GIM_Reject,
     /* 379866 */ // Label 103: @379866
     /* 379866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7536*/ GIMT_Encode4(380165),
     /* 379877 */ /*GILLT_s16*//*Label 7528*/ GIMT_Encode4(379917),
     /* 379881 */ /*GILLT_s32*//*Label 7529*/ GIMT_Encode4(379948),
     /* 379885 */ /*GILLT_s64*//*Label 7530*/ GIMT_Encode4(379979), GIMT_Encode4(0),
     /* 379893 */ /*GILLT_v2s32*//*Label 7531*/ GIMT_Encode4(380010),
     /* 379897 */ /*GILLT_v2s64*//*Label 7532*/ GIMT_Encode4(380041),
     /* 379901 */ /*GILLT_v4s16*//*Label 7533*/ GIMT_Encode4(380072),
     /* 379905 */ /*GILLT_v4s32*//*Label 7534*/ GIMT_Encode4(380103), GIMT_Encode4(0),
     /* 379913 */ /*GILLT_v8s16*//*Label 7535*/ GIMT_Encode4(380134),
     /* 379917 */ // Label 7528: @379917
     /* 379917 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(379947), // Rule ID 569 //
     /* 379922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 379928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379936 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 379936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 379941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379945 */   GIR_RootConstrainSelectedInstOperands,
     /* 379946 */   // GIR_Coverage, 569,
     /* 379946 */   GIR_Done,
     /* 379947 */ // Label 7537: @379947
     /* 379947 */ GIM_Reject,
     /* 379948 */ // Label 7529: @379948
     /* 379948 */ GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(379978), // Rule ID 571 //
     /* 379953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 379959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379967 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 379967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 379972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379976 */   GIR_RootConstrainSelectedInstOperands,
     /* 379977 */   // GIR_Coverage, 571,
     /* 379977 */   GIR_Done,
     /* 379978 */ // Label 7538: @379978
     /* 379978 */ GIM_Reject,
     /* 379979 */ // Label 7530: @379979
     /* 379979 */ GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(380009), // Rule ID 573 //
     /* 379984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 379990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379998 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 379998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 380003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380007 */   GIR_RootConstrainSelectedInstOperands,
     /* 380008 */   // GIR_Coverage, 573,
     /* 380008 */   GIR_Done,
     /* 380009 */ // Label 7539: @380009
     /* 380009 */ GIM_Reject,
     /* 380010 */ // Label 7531: @380010
     /* 380010 */ GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(380040), // Rule ID 952 //
     /* 380015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380029 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 380034 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380038 */   GIR_RootConstrainSelectedInstOperands,
     /* 380039 */   // GIR_Coverage, 952,
     /* 380039 */   GIR_Done,
     /* 380040 */ // Label 7540: @380040
     /* 380040 */ GIM_Reject,
     /* 380041 */ // Label 7532: @380041
     /* 380041 */ GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(380071), // Rule ID 956 //
     /* 380046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380060 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 380065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380069 */   GIR_RootConstrainSelectedInstOperands,
     /* 380070 */   // GIR_Coverage, 956,
     /* 380070 */   GIR_Done,
     /* 380071 */ // Label 7541: @380071
     /* 380071 */ GIM_Reject,
     /* 380072 */ // Label 7533: @380072
     /* 380072 */ GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(380102), // Rule ID 948 //
     /* 380077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380091 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 380096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380100 */   GIR_RootConstrainSelectedInstOperands,
     /* 380101 */   // GIR_Coverage, 948,
     /* 380101 */   GIR_Done,
     /* 380102 */ // Label 7542: @380102
     /* 380102 */ GIM_Reject,
     /* 380103 */ // Label 7534: @380103
     /* 380103 */ GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(380133), // Rule ID 954 //
     /* 380108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380122 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 380127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380131 */   GIR_RootConstrainSelectedInstOperands,
     /* 380132 */   // GIR_Coverage, 954,
     /* 380132 */   GIR_Done,
     /* 380133 */ // Label 7543: @380133
     /* 380133 */ GIM_Reject,
     /* 380134 */ // Label 7535: @380134
     /* 380134 */ GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(380164), // Rule ID 950 //
     /* 380139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380153 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 380158 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380162 */   GIR_RootConstrainSelectedInstOperands,
     /* 380163 */   // GIR_Coverage, 950,
     /* 380163 */   GIR_Done,
     /* 380164 */ // Label 7544: @380164
     /* 380164 */ GIM_Reject,
     /* 380165 */ // Label 7536: @380165
     /* 380165 */ GIM_Reject,
     /* 380166 */ // Label 104: @380166
     /* 380166 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(380179), // Rule ID 6429 //
     /* 380171 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 380171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 380177 */   GIR_RootConstrainSelectedInstOperands,
     /* 380178 */   // GIR_Coverage, 6429,
     /* 380178 */   GIR_EraseRootFromParent_Done,
     /* 380179 */ // Label 7545: @380179
     /* 380179 */ GIM_Reject,
     /* 380180 */ // Label 105: @380180
     /* 380180 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(380200), // Rule ID 6430 //
     /* 380185 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 380185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380188 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 380198 */   GIR_RootConstrainSelectedInstOperands,
     /* 380199 */   // GIR_Coverage, 6430,
     /* 380199 */   GIR_EraseRootFromParent_Done,
     /* 380200 */ // Label 7546: @380200
     /* 380200 */ GIM_Reject,
     /* 380201 */ // Label 106: @380201
     /* 380201 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(380225), // Rule ID 6431 //
     /* 380206 */   // MIs[0] kind
     /* 380206 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 380209 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 380214 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 380214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380217 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 380223 */   GIR_RootConstrainSelectedInstOperands,
     /* 380224 */   // GIR_Coverage, 6431,
     /* 380224 */   GIR_EraseRootFromParent_Done,
     /* 380225 */ // Label 7547: @380225
     /* 380225 */ GIM_Reject,
     /* 380226 */ // Label 107: @380226
     /* 380226 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7551*/ GIMT_Encode4(380535),
     /* 380237 */ /*GILLT_s16*//*Label 7548*/ GIMT_Encode4(380249),
     /* 380241 */ /*GILLT_s32*//*Label 7549*/ GIMT_Encode4(380402),
     /* 380245 */ /*GILLT_s64*//*Label 7550*/ GIMT_Encode4(380507),
     /* 380249 */ // Label 7548: @380249
     /* 380249 */ GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(380350), // Rule ID 5536 //
     /* 380254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380268 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 380268 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 380271 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 380275 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380280 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380284 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380290 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380293 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 380297 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380302 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 380305 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380323 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 380330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380335 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 380343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380348 */   GIR_RootConstrainSelectedInstOperands,
     /* 380349 */   // GIR_Coverage, 5536,
     /* 380349 */   GIR_EraseRootFromParent_Done,
     /* 380350 */ // Label 7552: @380350
     /* 380350 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(380401), // Rule ID 5537 //
     /* 380355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380369 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 380369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 380376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380381 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380385 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 380394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380399 */   GIR_RootConstrainSelectedInstOperands,
     /* 380400 */   // GIR_Coverage, 5537,
     /* 380400 */   GIR_EraseRootFromParent_Done,
     /* 380401 */ // Label 7553: @380401
     /* 380401 */ GIM_Reject,
     /* 380402 */ // Label 7549: @380402
     /* 380402 */ GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(380479), // Rule ID 5538 //
     /* 380407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380418 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 380418 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380421 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 380425 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380430 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380434 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380452 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 380459 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380464 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 380472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380477 */   GIR_RootConstrainSelectedInstOperands,
     /* 380478 */   // GIR_Coverage, 5538,
     /* 380478 */   GIR_EraseRootFromParent_Done,
     /* 380479 */ // Label 7554: @380479
     /* 380479 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(380506), // Rule ID 5539 //
     /* 380484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380495 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 380500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380504 */   GIR_RootConstrainSelectedInstOperands,
     /* 380505 */   // GIR_Coverage, 5539,
     /* 380505 */   GIR_Done,
     /* 380506 */ // Label 7555: @380506
     /* 380506 */ GIM_Reject,
     /* 380507 */ // Label 7550: @380507
     /* 380507 */ GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(380534), // Rule ID 5540 //
     /* 380512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380523 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 380528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380532 */   GIR_RootConstrainSelectedInstOperands,
     /* 380533 */   // GIR_Coverage, 5540,
     /* 380533 */   GIR_Done,
     /* 380534 */ // Label 7556: @380534
     /* 380534 */ GIM_Reject,
     /* 380535 */ // Label 7551: @380535
     /* 380535 */ GIM_Reject,
     /* 380536 */ // Label 108: @380536
     /* 380536 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7560*/ GIMT_Encode4(380706),
     /* 380547 */ /*GILLT_s16*//*Label 7557*/ GIMT_Encode4(380559),
     /* 380551 */ /*GILLT_s32*//*Label 7558*/ GIMT_Encode4(380620),
     /* 380555 */ /*GILLT_s64*//*Label 7559*/ GIMT_Encode4(380678),
     /* 380559 */ // Label 7557: @380559
     /* 380559 */ GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(380589), // Rule ID 1935 //
     /* 380564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380578 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 380583 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380587 */   GIR_RootConstrainSelectedInstOperands,
     /* 380588 */   // GIR_Coverage, 1935,
     /* 380588 */   GIR_Done,
     /* 380589 */ // Label 7561: @380589
     /* 380589 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(380619), // Rule ID 1937 //
     /* 380594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380608 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 380613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380617 */   GIR_RootConstrainSelectedInstOperands,
     /* 380618 */   // GIR_Coverage, 1937,
     /* 380618 */   GIR_Done,
     /* 380619 */ // Label 7562: @380619
     /* 380619 */ GIM_Reject,
     /* 380620 */ // Label 7558: @380620
     /* 380620 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(380650), // Rule ID 1939 //
     /* 380625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380639 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 380644 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380648 */   GIR_RootConstrainSelectedInstOperands,
     /* 380649 */   // GIR_Coverage, 1939,
     /* 380649 */   GIR_Done,
     /* 380650 */ // Label 7563: @380650
     /* 380650 */ GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(380677), // Rule ID 5546 //
     /* 380655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380666 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 380671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380675 */   GIR_RootConstrainSelectedInstOperands,
     /* 380676 */   // GIR_Coverage, 5546,
     /* 380676 */   GIR_Done,
     /* 380677 */ // Label 7564: @380677
     /* 380677 */ GIM_Reject,
     /* 380678 */ // Label 7559: @380678
     /* 380678 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(380705), // Rule ID 5548 //
     /* 380683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380694 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 380699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380703 */   GIR_RootConstrainSelectedInstOperands,
     /* 380704 */   // GIR_Coverage, 5548,
     /* 380704 */   GIR_Done,
     /* 380705 */ // Label 7565: @380705
     /* 380705 */ GIM_Reject,
     /* 380706 */ // Label 7560: @380706
     /* 380706 */ GIM_Reject,
     /* 380707 */ // Label 109: @380707
     /* 380707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7569*/ GIMT_Encode4(380877),
     /* 380718 */ /*GILLT_s16*//*Label 7566*/ GIMT_Encode4(380730),
     /* 380722 */ /*GILLT_s32*//*Label 7567*/ GIMT_Encode4(380791),
     /* 380726 */ /*GILLT_s64*//*Label 7568*/ GIMT_Encode4(380849),
     /* 380730 */ // Label 7566: @380730
     /* 380730 */ GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(380760), // Rule ID 1947 //
     /* 380735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380749 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 380754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380758 */   GIR_RootConstrainSelectedInstOperands,
     /* 380759 */   // GIR_Coverage, 1947,
     /* 380759 */   GIR_Done,
     /* 380760 */ // Label 7570: @380760
     /* 380760 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(380790), // Rule ID 1949 //
     /* 380765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380779 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 380784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380788 */   GIR_RootConstrainSelectedInstOperands,
     /* 380789 */   // GIR_Coverage, 1949,
     /* 380789 */   GIR_Done,
     /* 380790 */ // Label 7571: @380790
     /* 380790 */ GIM_Reject,
     /* 380791 */ // Label 7567: @380791
     /* 380791 */ GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(380821), // Rule ID 1951 //
     /* 380796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380810 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 380815 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380819 */   GIR_RootConstrainSelectedInstOperands,
     /* 380820 */   // GIR_Coverage, 1951,
     /* 380820 */   GIR_Done,
     /* 380821 */ // Label 7572: @380821
     /* 380821 */ GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(380848), // Rule ID 5554 //
     /* 380826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380837 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 380842 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380846 */   GIR_RootConstrainSelectedInstOperands,
     /* 380847 */   // GIR_Coverage, 5554,
     /* 380847 */   GIR_Done,
     /* 380848 */ // Label 7573: @380848
     /* 380848 */ GIM_Reject,
     /* 380849 */ // Label 7568: @380849
     /* 380849 */ GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(380876), // Rule ID 5556 //
     /* 380854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380865 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 380870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380874 */   GIR_RootConstrainSelectedInstOperands,
     /* 380875 */   // GIR_Coverage, 5556,
     /* 380875 */   GIR_Done,
     /* 380876 */ // Label 7574: @380876
     /* 380876 */ GIM_Reject,
     /* 380877 */ // Label 7569: @380877
     /* 380877 */ GIM_Reject,
     /* 380878 */ // Label 110: @380878
     /* 380878 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7578*/ GIMT_Encode4(381048),
     /* 380889 */ /*GILLT_s16*//*Label 7575*/ GIMT_Encode4(380901),
     /* 380893 */ /*GILLT_s32*//*Label 7576*/ GIMT_Encode4(380962),
     /* 380897 */ /*GILLT_s64*//*Label 7577*/ GIMT_Encode4(381020),
     /* 380901 */ // Label 7575: @380901
     /* 380901 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(380931), // Rule ID 1941 //
     /* 380906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380920 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 380925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380929 */   GIR_RootConstrainSelectedInstOperands,
     /* 380930 */   // GIR_Coverage, 1941,
     /* 380930 */   GIR_Done,
     /* 380931 */ // Label 7579: @380931
     /* 380931 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(380961), // Rule ID 1943 //
     /* 380936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380950 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 380955 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380959 */   GIR_RootConstrainSelectedInstOperands,
     /* 380960 */   // GIR_Coverage, 1943,
     /* 380960 */   GIR_Done,
     /* 380961 */ // Label 7580: @380961
     /* 380961 */ GIM_Reject,
     /* 380962 */ // Label 7576: @380962
     /* 380962 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(380992), // Rule ID 1945 //
     /* 380967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380981 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 380986 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380990 */   GIR_RootConstrainSelectedInstOperands,
     /* 380991 */   // GIR_Coverage, 1945,
     /* 380991 */   GIR_Done,
     /* 380992 */ // Label 7581: @380992
     /* 380992 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(381019), // Rule ID 5550 //
     /* 380997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381008 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 381013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381017 */   GIR_RootConstrainSelectedInstOperands,
     /* 381018 */   // GIR_Coverage, 5550,
     /* 381018 */   GIR_Done,
     /* 381019 */ // Label 7582: @381019
     /* 381019 */ GIM_Reject,
     /* 381020 */ // Label 7577: @381020
     /* 381020 */ GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(381047), // Rule ID 5552 //
     /* 381025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381036 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 381041 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381045 */   GIR_RootConstrainSelectedInstOperands,
     /* 381046 */   // GIR_Coverage, 5552,
     /* 381046 */   GIR_Done,
     /* 381047 */ // Label 7583: @381047
     /* 381047 */ GIM_Reject,
     /* 381048 */ // Label 7578: @381048
     /* 381048 */ GIM_Reject,
     /* 381049 */ // Label 111: @381049
     /* 381049 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7587*/ GIMT_Encode4(381219),
     /* 381060 */ /*GILLT_s16*//*Label 7584*/ GIMT_Encode4(381072),
     /* 381064 */ /*GILLT_s32*//*Label 7585*/ GIMT_Encode4(381133),
     /* 381068 */ /*GILLT_s64*//*Label 7586*/ GIMT_Encode4(381191),
     /* 381072 */ // Label 7584: @381072
     /* 381072 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(381102), // Rule ID 1953 //
     /* 381077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381091 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 381091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 381096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381100 */   GIR_RootConstrainSelectedInstOperands,
     /* 381101 */   // GIR_Coverage, 1953,
     /* 381101 */   GIR_Done,
     /* 381102 */ // Label 7588: @381102
     /* 381102 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(381132), // Rule ID 1955 //
     /* 381107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381121 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 381121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 381126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381130 */   GIR_RootConstrainSelectedInstOperands,
     /* 381131 */   // GIR_Coverage, 1955,
     /* 381131 */   GIR_Done,
     /* 381132 */ // Label 7589: @381132
     /* 381132 */ GIM_Reject,
     /* 381133 */ // Label 7585: @381133
     /* 381133 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(381163), // Rule ID 1957 //
     /* 381138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381152 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 381152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 381157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381161 */   GIR_RootConstrainSelectedInstOperands,
     /* 381162 */   // GIR_Coverage, 1957,
     /* 381162 */   GIR_Done,
     /* 381163 */ // Label 7590: @381163
     /* 381163 */ GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(381190), // Rule ID 5558 //
     /* 381168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381179 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 381184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381188 */   GIR_RootConstrainSelectedInstOperands,
     /* 381189 */   // GIR_Coverage, 5558,
     /* 381189 */   GIR_Done,
     /* 381190 */ // Label 7591: @381190
     /* 381190 */ GIM_Reject,
     /* 381191 */ // Label 7586: @381191
     /* 381191 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(381218), // Rule ID 5560 //
     /* 381196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381207 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 381212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381216 */   GIR_RootConstrainSelectedInstOperands,
     /* 381217 */   // GIR_Coverage, 5560,
     /* 381217 */   GIR_Done,
     /* 381218 */ // Label 7592: @381218
     /* 381218 */ GIM_Reject,
     /* 381219 */ // Label 7587: @381219
     /* 381219 */ GIM_Reject,
     /* 381220 */ // Label 112: @381220
     /* 381220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7597*/ GIMT_Encode4(382348),
     /* 381231 */ /*GILLT_s8*//*Label 7593*/ GIMT_Encode4(381247),
     /* 381235 */ /*GILLT_s16*//*Label 7594*/ GIMT_Encode4(381294),
     /* 381239 */ /*GILLT_s32*//*Label 7595*/ GIMT_Encode4(381709),
     /* 381243 */ /*GILLT_s64*//*Label 7596*/ GIMT_Encode4(382162),
     /* 381247 */ // Label 7593: @381247
     /* 381247 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(381270), // Rule ID 5805 //
     /* 381252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 381259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381263 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 381263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 381268 */   GIR_RootConstrainSelectedInstOperands,
     /* 381269 */   // GIR_Coverage, 5805,
     /* 381269 */   GIR_Done,
     /* 381270 */ // Label 7598: @381270
     /* 381270 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(381293), // Rule ID 5806 //
     /* 381275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 381282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381286 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 381286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 381291 */   GIR_RootConstrainSelectedInstOperands,
     /* 381292 */   // GIR_Coverage, 5806,
     /* 381292 */   GIR_Done,
     /* 381293 */ // Label 7599: @381293
     /* 381293 */ GIM_Reject,
     /* 381294 */ // Label 7594: @381294
     /* 381294 */ GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(381344), // Rule ID 5752 //
     /* 381299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381314 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381317 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381322 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 381326 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381333 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 381336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381338 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381342 */   GIR_RootConstrainSelectedInstOperands,
     /* 381343 */   // GIR_Coverage, 5752,
     /* 381343 */   GIR_EraseRootFromParent_Done,
     /* 381344 */ // Label 7600: @381344
     /* 381344 */ GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(381394), // Rule ID 5754 //
     /* 381349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381364 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381367 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381372 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 381376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381383 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 381386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381388 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381392 */   GIR_RootConstrainSelectedInstOperands,
     /* 381393 */   // GIR_Coverage, 5754,
     /* 381393 */   GIR_EraseRootFromParent_Done,
     /* 381394 */ // Label 7601: @381394
     /* 381394 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(381444), // Rule ID 5762 //
     /* 381399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381414 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381417 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 381426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381433 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 381436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381438 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381442 */   GIR_RootConstrainSelectedInstOperands,
     /* 381443 */   // GIR_Coverage, 5762,
     /* 381443 */   GIR_EraseRootFromParent_Done,
     /* 381444 */ // Label 7602: @381444
     /* 381444 */ GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(381494), // Rule ID 5764 //
     /* 381449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381464 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381467 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381472 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 381476 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381483 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 381486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381492 */   GIR_RootConstrainSelectedInstOperands,
     /* 381493 */   // GIR_Coverage, 5764,
     /* 381493 */   GIR_EraseRootFromParent_Done,
     /* 381494 */ // Label 7603: @381494
     /* 381494 */ GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(381536), // Rule ID 5761 //
     /* 381499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381514 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381518 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381525 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 381528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381530 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381534 */   GIR_RootConstrainSelectedInstOperands,
     /* 381535 */   // GIR_Coverage, 5761,
     /* 381535 */   GIR_EraseRootFromParent_Done,
     /* 381536 */ // Label 7604: @381536
     /* 381536 */ GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(381578), // Rule ID 5763 //
     /* 381541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381556 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381560 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381567 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 381570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381572 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381576 */   GIR_RootConstrainSelectedInstOperands,
     /* 381577 */   // GIR_Coverage, 5763,
     /* 381577 */   GIR_EraseRootFromParent_Done,
     /* 381578 */ // Label 7605: @381578
     /* 381578 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(381620), // Rule ID 5751 //
     /* 381583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 381598 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381602 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381609 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 381612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381614 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381618 */   GIR_RootConstrainSelectedInstOperands,
     /* 381619 */   // GIR_Coverage, 5751,
     /* 381619 */   GIR_EraseRootFromParent_Done,
     /* 381620 */ // Label 7606: @381620
     /* 381620 */ GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(381662), // Rule ID 5753 //
     /* 381625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 381640 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381644 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381651 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 381654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381656 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381660 */   GIR_RootConstrainSelectedInstOperands,
     /* 381661 */   // GIR_Coverage, 5753,
     /* 381661 */   GIR_EraseRootFromParent_Done,
     /* 381662 */ // Label 7607: @381662
     /* 381662 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(381685), // Rule ID 5807 //
     /* 381667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381678 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 381678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 381683 */   GIR_RootConstrainSelectedInstOperands,
     /* 381684 */   // GIR_Coverage, 5807,
     /* 381684 */   GIR_Done,
     /* 381685 */ // Label 7608: @381685
     /* 381685 */ GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(381708), // Rule ID 5808 //
     /* 381690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381701 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 381701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 381706 */   GIR_RootConstrainSelectedInstOperands,
     /* 381707 */   // GIR_Coverage, 5808,
     /* 381707 */   GIR_Done,
     /* 381708 */ // Label 7609: @381708
     /* 381708 */ GIM_Reject,
     /* 381709 */ // Label 7595: @381709
     /* 381709 */ GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(381759), // Rule ID 5756 //
     /* 381714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381729 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381732 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381737 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 381741 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381748 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 381748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 381751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381757 */   GIR_RootConstrainSelectedInstOperands,
     /* 381758 */   // GIR_Coverage, 5756,
     /* 381758 */   GIR_EraseRootFromParent_Done,
     /* 381759 */ // Label 7610: @381759
     /* 381759 */ GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(381809), // Rule ID 5758 //
     /* 381764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381779 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381782 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381787 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 381791 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381798 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 381798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 381801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381803 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381807 */   GIR_RootConstrainSelectedInstOperands,
     /* 381808 */   // GIR_Coverage, 5758,
     /* 381808 */   GIR_EraseRootFromParent_Done,
     /* 381809 */ // Label 7611: @381809
     /* 381809 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(381859), // Rule ID 5766 //
     /* 381814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381829 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381832 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 381841 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381848 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 381848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 381851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381853 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381857 */   GIR_RootConstrainSelectedInstOperands,
     /* 381858 */   // GIR_Coverage, 5766,
     /* 381858 */   GIR_EraseRootFromParent_Done,
     /* 381859 */ // Label 7612: @381859
     /* 381859 */ GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(381909), // Rule ID 5768 //
     /* 381864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381879 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381882 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381887 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 381891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381898 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 381898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 381901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381903 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381907 */   GIR_RootConstrainSelectedInstOperands,
     /* 381908 */   // GIR_Coverage, 5768,
     /* 381908 */   GIR_EraseRootFromParent_Done,
     /* 381909 */ // Label 7613: @381909
     /* 381909 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(381951), // Rule ID 5765 //
     /* 381914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381929 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381940 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 381940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 381943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381945 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381949 */   GIR_RootConstrainSelectedInstOperands,
     /* 381950 */   // GIR_Coverage, 5765,
     /* 381950 */   GIR_EraseRootFromParent_Done,
     /* 381951 */ // Label 7614: @381951
     /* 381951 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(381993), // Rule ID 5767 //
     /* 381956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381963 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381971 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381982 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 381982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 381985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381987 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381991 */   GIR_RootConstrainSelectedInstOperands,
     /* 381992 */   // GIR_Coverage, 5767,
     /* 381992 */   GIR_EraseRootFromParent_Done,
     /* 381993 */ // Label 7615: @381993
     /* 381993 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(382035), // Rule ID 5755 //
     /* 381998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382013 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382017 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382024 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 382024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 382027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382029 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382033 */   GIR_RootConstrainSelectedInstOperands,
     /* 382034 */   // GIR_Coverage, 5755,
     /* 382034 */   GIR_EraseRootFromParent_Done,
     /* 382035 */ // Label 7616: @382035
     /* 382035 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(382077), // Rule ID 5757 //
     /* 382040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382055 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382066 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 382066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 382069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382071 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382075 */   GIR_RootConstrainSelectedInstOperands,
     /* 382076 */   // GIR_Coverage, 5757,
     /* 382076 */   GIR_EraseRootFromParent_Done,
     /* 382077 */ // Label 7617: @382077
     /* 382077 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(382138), // Rule ID 5809 //
     /* 382082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382093 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 382100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382120 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382137 */   // GIR_Coverage, 5809,
     /* 382137 */   GIR_EraseRootFromParent_Done,
     /* 382138 */ // Label 7618: @382138
     /* 382138 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(382161), // Rule ID 5810 //
     /* 382143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382154 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 382159 */   GIR_RootConstrainSelectedInstOperands,
     /* 382160 */   // GIR_Coverage, 5810,
     /* 382160 */   GIR_Done,
     /* 382161 */ // Label 7619: @382161
     /* 382161 */ GIM_Reject,
     /* 382162 */ // Label 7596: @382162
     /* 382162 */ GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(382347),
     /* 382167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382174 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(382217), // Rule ID 5760 //
     /* 382179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382187 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382190 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 382195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 382199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382206 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 382209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382215 */     GIR_RootConstrainSelectedInstOperands,
     /* 382216 */     // GIR_Coverage, 5760,
     /* 382216 */     GIR_EraseRootFromParent_Done,
     /* 382217 */   // Label 7621: @382217
     /* 382217 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(382260), // Rule ID 5770 //
     /* 382222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382230 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382233 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 382238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 382242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382249 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 382252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382258 */     GIR_RootConstrainSelectedInstOperands,
     /* 382259 */     // GIR_Coverage, 5770,
     /* 382259 */     GIR_EraseRootFromParent_Done,
     /* 382260 */   // Label 7622: @382260
     /* 382260 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(382295), // Rule ID 5769 //
     /* 382265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 382273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382284 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 382287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382293 */     GIR_RootConstrainSelectedInstOperands,
     /* 382294 */     // GIR_Coverage, 5769,
     /* 382294 */     GIR_EraseRootFromParent_Done,
     /* 382295 */   // Label 7623: @382295
     /* 382295 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(382330), // Rule ID 5759 //
     /* 382300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382319 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 382322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382328 */     GIR_RootConstrainSelectedInstOperands,
     /* 382329 */     // GIR_Coverage, 5759,
     /* 382329 */     GIR_EraseRootFromParent_Done,
     /* 382330 */   // Label 7624: @382330
     /* 382330 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(382346), // Rule ID 5811 //
     /* 382335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382339 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 382339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 382344 */     GIR_RootConstrainSelectedInstOperands,
     /* 382345 */     // GIR_Coverage, 5811,
     /* 382345 */     GIR_Done,
     /* 382346 */   // Label 7625: @382346
     /* 382346 */   GIM_Reject,
     /* 382347 */ // Label 7620: @382347
     /* 382347 */ GIM_Reject,
     /* 382348 */ // Label 7597: @382348
     /* 382348 */ GIM_Reject,
     /* 382349 */ // Label 113: @382349
     /* 382349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7629*/ GIMT_Encode4(382551),
     /* 382360 */ /*GILLT_s8*//*Label 7626*/ GIMT_Encode4(382372),
     /* 382364 */ /*GILLT_s16*//*Label 7627*/ GIMT_Encode4(382419),
     /* 382368 */ /*GILLT_s32*//*Label 7628*/ GIMT_Encode4(382466),
     /* 382372 */ // Label 7626: @382372
     /* 382372 */ GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(382395), // Rule ID 5902 //
     /* 382377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382388 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 382393 */   GIR_RootConstrainSelectedInstOperands,
     /* 382394 */   // GIR_Coverage, 5902,
     /* 382394 */   GIR_Done,
     /* 382395 */ // Label 7630: @382395
     /* 382395 */ GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(382418), // Rule ID 5903 //
     /* 382400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382411 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 382416 */   GIR_RootConstrainSelectedInstOperands,
     /* 382417 */   // GIR_Coverage, 5903,
     /* 382417 */   GIR_Done,
     /* 382418 */ // Label 7631: @382418
     /* 382418 */ GIM_Reject,
     /* 382419 */ // Label 7627: @382419
     /* 382419 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(382442), // Rule ID 5904 //
     /* 382424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382435 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 382440 */   GIR_RootConstrainSelectedInstOperands,
     /* 382441 */   // GIR_Coverage, 5904,
     /* 382441 */   GIR_Done,
     /* 382442 */ // Label 7632: @382442
     /* 382442 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(382465), // Rule ID 5905 //
     /* 382447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382458 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 382463 */   GIR_RootConstrainSelectedInstOperands,
     /* 382464 */   // GIR_Coverage, 5905,
     /* 382464 */   GIR_Done,
     /* 382465 */ // Label 7633: @382465
     /* 382465 */ GIM_Reject,
     /* 382466 */ // Label 7628: @382466
     /* 382466 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(382489), // Rule ID 5906 //
     /* 382471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382482 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 382487 */   GIR_RootConstrainSelectedInstOperands,
     /* 382488 */   // GIR_Coverage, 5906,
     /* 382488 */   GIR_Done,
     /* 382489 */ // Label 7634: @382489
     /* 382489 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(382550), // Rule ID 5907 //
     /* 382494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382505 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 382512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382532 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382549 */   // GIR_Coverage, 5907,
     /* 382549 */   GIR_EraseRootFromParent_Done,
     /* 382550 */ // Label 7635: @382550
     /* 382550 */ GIM_Reject,
     /* 382551 */ // Label 7629: @382551
     /* 382551 */ GIM_Reject,
     /* 382552 */ // Label 114: @382552
     /* 382552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7639*/ GIMT_Encode4(382754),
     /* 382563 */ /*GILLT_s8*//*Label 7636*/ GIMT_Encode4(382575),
     /* 382567 */ /*GILLT_s16*//*Label 7637*/ GIMT_Encode4(382622),
     /* 382571 */ /*GILLT_s32*//*Label 7638*/ GIMT_Encode4(382669),
     /* 382575 */ // Label 7636: @382575
     /* 382575 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(382598), // Rule ID 5896 //
     /* 382580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382591 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 382596 */   GIR_RootConstrainSelectedInstOperands,
     /* 382597 */   // GIR_Coverage, 5896,
     /* 382597 */   GIR_Done,
     /* 382598 */ // Label 7640: @382598
     /* 382598 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(382621), // Rule ID 5897 //
     /* 382603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382614 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 382619 */   GIR_RootConstrainSelectedInstOperands,
     /* 382620 */   // GIR_Coverage, 5897,
     /* 382620 */   GIR_Done,
     /* 382621 */ // Label 7641: @382621
     /* 382621 */ GIM_Reject,
     /* 382622 */ // Label 7637: @382622
     /* 382622 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(382645), // Rule ID 5898 //
     /* 382627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382638 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 382643 */   GIR_RootConstrainSelectedInstOperands,
     /* 382644 */   // GIR_Coverage, 5898,
     /* 382644 */   GIR_Done,
     /* 382645 */ // Label 7642: @382645
     /* 382645 */ GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(382668), // Rule ID 5899 //
     /* 382650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382661 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 382666 */   GIR_RootConstrainSelectedInstOperands,
     /* 382667 */   // GIR_Coverage, 5899,
     /* 382667 */   GIR_Done,
     /* 382668 */ // Label 7643: @382668
     /* 382668 */ GIM_Reject,
     /* 382669 */ // Label 7638: @382669
     /* 382669 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(382692), // Rule ID 5900 //
     /* 382674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382685 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 382690 */   GIR_RootConstrainSelectedInstOperands,
     /* 382691 */   // GIR_Coverage, 5900,
     /* 382691 */   GIR_Done,
     /* 382692 */ // Label 7644: @382692
     /* 382692 */ GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(382753), // Rule ID 5901 //
     /* 382697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382708 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 382715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382720 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382724 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382735 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382752 */   // GIR_Coverage, 5901,
     /* 382752 */   GIR_EraseRootFromParent_Done,
     /* 382753 */ // Label 7645: @382753
     /* 382753 */ GIM_Reject,
     /* 382754 */ // Label 7639: @382754
     /* 382754 */ GIM_Reject,
     /* 382755 */ // Label 115: @382755
     /* 382755 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7649*/ GIMT_Encode4(382957),
     /* 382766 */ /*GILLT_s8*//*Label 7646*/ GIMT_Encode4(382778),
     /* 382770 */ /*GILLT_s16*//*Label 7647*/ GIMT_Encode4(382825),
     /* 382774 */ /*GILLT_s32*//*Label 7648*/ GIMT_Encode4(382872),
     /* 382778 */ // Label 7646: @382778
     /* 382778 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(382801), // Rule ID 5890 //
     /* 382783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382794 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 382799 */   GIR_RootConstrainSelectedInstOperands,
     /* 382800 */   // GIR_Coverage, 5890,
     /* 382800 */   GIR_Done,
     /* 382801 */ // Label 7650: @382801
     /* 382801 */ GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(382824), // Rule ID 5891 //
     /* 382806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382817 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 382822 */   GIR_RootConstrainSelectedInstOperands,
     /* 382823 */   // GIR_Coverage, 5891,
     /* 382823 */   GIR_Done,
     /* 382824 */ // Label 7651: @382824
     /* 382824 */ GIM_Reject,
     /* 382825 */ // Label 7647: @382825
     /* 382825 */ GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(382848), // Rule ID 5892 //
     /* 382830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382841 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 382846 */   GIR_RootConstrainSelectedInstOperands,
     /* 382847 */   // GIR_Coverage, 5892,
     /* 382847 */   GIR_Done,
     /* 382848 */ // Label 7652: @382848
     /* 382848 */ GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(382871), // Rule ID 5893 //
     /* 382853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382864 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 382869 */   GIR_RootConstrainSelectedInstOperands,
     /* 382870 */   // GIR_Coverage, 5893,
     /* 382870 */   GIR_Done,
     /* 382871 */ // Label 7653: @382871
     /* 382871 */ GIM_Reject,
     /* 382872 */ // Label 7648: @382872
     /* 382872 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(382895), // Rule ID 5894 //
     /* 382877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382888 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 382893 */   GIR_RootConstrainSelectedInstOperands,
     /* 382894 */   // GIR_Coverage, 5894,
     /* 382894 */   GIR_Done,
     /* 382895 */ // Label 7654: @382895
     /* 382895 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(382956), // Rule ID 5895 //
     /* 382900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382911 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 382918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382923 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382938 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382955 */   // GIR_Coverage, 5895,
     /* 382955 */   GIR_EraseRootFromParent_Done,
     /* 382956 */ // Label 7655: @382956
     /* 382956 */ GIM_Reject,
     /* 382957 */ // Label 7649: @382957
     /* 382957 */ GIM_Reject,
     /* 382958 */ // Label 116: @382958
     /* 382958 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7659*/ GIMT_Encode4(383160),
     /* 382969 */ /*GILLT_s8*//*Label 7656*/ GIMT_Encode4(382981),
     /* 382973 */ /*GILLT_s16*//*Label 7657*/ GIMT_Encode4(383028),
     /* 382977 */ /*GILLT_s32*//*Label 7658*/ GIMT_Encode4(383075),
     /* 382981 */ // Label 7656: @382981
     /* 382981 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(383004), // Rule ID 5884 //
     /* 382986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382997 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 383002 */   GIR_RootConstrainSelectedInstOperands,
     /* 383003 */   // GIR_Coverage, 5884,
     /* 383003 */   GIR_Done,
     /* 383004 */ // Label 7660: @383004
     /* 383004 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(383027), // Rule ID 5885 //
     /* 383009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383020 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 383020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 383025 */   GIR_RootConstrainSelectedInstOperands,
     /* 383026 */   // GIR_Coverage, 5885,
     /* 383026 */   GIR_Done,
     /* 383027 */ // Label 7661: @383027
     /* 383027 */ GIM_Reject,
     /* 383028 */ // Label 7657: @383028
     /* 383028 */ GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(383051), // Rule ID 5886 //
     /* 383033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383044 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 383044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 383049 */   GIR_RootConstrainSelectedInstOperands,
     /* 383050 */   // GIR_Coverage, 5886,
     /* 383050 */   GIR_Done,
     /* 383051 */ // Label 7662: @383051
     /* 383051 */ GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(383074), // Rule ID 5887 //
     /* 383056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383067 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 383067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 383072 */   GIR_RootConstrainSelectedInstOperands,
     /* 383073 */   // GIR_Coverage, 5887,
     /* 383073 */   GIR_Done,
     /* 383074 */ // Label 7663: @383074
     /* 383074 */ GIM_Reject,
     /* 383075 */ // Label 7658: @383075
     /* 383075 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(383098), // Rule ID 5888 //
     /* 383080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383091 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 383091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 383096 */   GIR_RootConstrainSelectedInstOperands,
     /* 383097 */   // GIR_Coverage, 5888,
     /* 383097 */   GIR_Done,
     /* 383098 */ // Label 7664: @383098
     /* 383098 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(383159), // Rule ID 5889 //
     /* 383103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383114 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 383114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 383121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383126 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383130 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383141 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 383148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383158 */   // GIR_Coverage, 5889,
     /* 383158 */   GIR_EraseRootFromParent_Done,
     /* 383159 */ // Label 7665: @383159
     /* 383159 */ GIM_Reject,
     /* 383160 */ // Label 7659: @383160
     /* 383160 */ GIM_Reject,
     /* 383161 */ // Label 117: @383161
     /* 383161 */ GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(383300),
     /* 383166 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 383169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 383173 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(383207), // Rule ID 257 //
     /* 383178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 383185 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 383185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 383188 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383205 */     GIR_RootConstrainSelectedInstOperands,
     /* 383206 */     // GIR_Coverage, 257,
     /* 383206 */     GIR_EraseRootFromParent_Done,
     /* 383207 */   // Label 7667: @383207
     /* 383207 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(383241), // Rule ID 258 //
     /* 383212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 383219 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 383219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 383222 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383239 */     GIR_RootConstrainSelectedInstOperands,
     /* 383240 */     // GIR_Coverage, 258,
     /* 383240 */     GIR_EraseRootFromParent_Done,
     /* 383241 */   // Label 7668: @383241
     /* 383241 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(383270), // Rule ID 273 //
     /* 383246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 383253 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 383253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 383256 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383268 */     GIR_RootConstrainSelectedInstOperands,
     /* 383269 */     // GIR_Coverage, 273,
     /* 383269 */     GIR_EraseRootFromParent_Done,
     /* 383270 */   // Label 7669: @383270
     /* 383270 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(383299), // Rule ID 294 //
     /* 383275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 383282 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 383282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 383285 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383297 */     GIR_RootConstrainSelectedInstOperands,
     /* 383298 */     // GIR_Coverage, 294,
     /* 383298 */     GIR_EraseRootFromParent_Done,
     /* 383299 */   // Label 7670: @383299
     /* 383299 */   GIM_Reject,
     /* 383300 */ // Label 7666: @383300
     /* 383300 */ GIM_Reject,
     /* 383301 */ // Label 118: @383301
     /* 383301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7683*/ GIMT_Encode4(383840),
     /* 383312 */ /*GILLT_s64*//*Label 7671*/ GIMT_Encode4(383396), GIMT_Encode4(0),
     /* 383320 */ /*GILLT_v2s32*//*Label 7672*/ GIMT_Encode4(383434),
     /* 383324 */ /*GILLT_v2s64*//*Label 7673*/ GIMT_Encode4(383472),
     /* 383328 */ /*GILLT_v4s16*//*Label 7674*/ GIMT_Encode4(383510),
     /* 383332 */ /*GILLT_v4s32*//*Label 7675*/ GIMT_Encode4(383548),
     /* 383336 */ /*GILLT_v8s8*//*Label 7676*/ GIMT_Encode4(383586),
     /* 383340 */ /*GILLT_v8s16*//*Label 7677*/ GIMT_Encode4(383624),
     /* 383344 */ /*GILLT_v16s8*//*Label 7678*/ GIMT_Encode4(383662), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 383364 */ /*GILLT_nxv2s64*//*Label 7679*/ GIMT_Encode4(383700), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 383376 */ /*GILLT_nxv4s32*//*Label 7680*/ GIMT_Encode4(383735), GIMT_Encode4(0),
     /* 383384 */ /*GILLT_nxv8s16*//*Label 7681*/ GIMT_Encode4(383770), GIMT_Encode4(0),
     /* 383392 */ /*GILLT_nxv16s8*//*Label 7682*/ GIMT_Encode4(383805),
     /* 383396 */ // Label 7671: @383396
     /* 383396 */ GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(383433), // Rule ID 5006 //
     /* 383401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 383404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 383407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383426 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 383426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383431 */   GIR_RootConstrainSelectedInstOperands,
     /* 383432 */   // GIR_Coverage, 5006,
     /* 383432 */   GIR_Done,
     /* 383433 */ // Label 7684: @383433
     /* 383433 */ GIM_Reject,
     /* 383434 */ // Label 7672: @383434
     /* 383434 */ GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(383471), // Rule ID 5005 //
     /* 383439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 383445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 383448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383464 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 383464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383469 */   GIR_RootConstrainSelectedInstOperands,
     /* 383470 */   // GIR_Coverage, 5005,
     /* 383470 */   GIR_Done,
     /* 383471 */ // Label 7685: @383471
     /* 383471 */ GIM_Reject,
     /* 383472 */ // Label 7673: @383472
     /* 383472 */ GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(383509), // Rule ID 5010 //
     /* 383477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 383483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 383486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383502 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 383502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383507 */   GIR_RootConstrainSelectedInstOperands,
     /* 383508 */   // GIR_Coverage, 5010,
     /* 383508 */   GIR_Done,
     /* 383509 */ // Label 7686: @383509
     /* 383509 */ GIM_Reject,
     /* 383510 */ // Label 7674: @383510
     /* 383510 */ GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(383547), // Rule ID 5004 //
     /* 383515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 383521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 383524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383536 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383540 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 383540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383545 */   GIR_RootConstrainSelectedInstOperands,
     /* 383546 */   // GIR_Coverage, 5004,
     /* 383546 */   GIR_Done,
     /* 383547 */ // Label 7687: @383547
     /* 383547 */ GIM_Reject,
     /* 383548 */ // Label 7675: @383548
     /* 383548 */ GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(383585), // Rule ID 5009 //
     /* 383553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 383559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 383562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383574 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383578 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 383578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383583 */   GIR_RootConstrainSelectedInstOperands,
     /* 383584 */   // GIR_Coverage, 5009,
     /* 383584 */   GIR_Done,
     /* 383585 */ // Label 7688: @383585
     /* 383585 */ GIM_Reject,
     /* 383586 */ // Label 7676: @383586
     /* 383586 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(383623), // Rule ID 5003 //
     /* 383591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 383594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 383597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 383600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383616 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 383616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383621 */   GIR_RootConstrainSelectedInstOperands,
     /* 383622 */   // GIR_Coverage, 5003,
     /* 383622 */   GIR_Done,
     /* 383623 */ // Label 7689: @383623
     /* 383623 */ GIM_Reject,
     /* 383624 */ // Label 7677: @383624
     /* 383624 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(383661), // Rule ID 5008 //
     /* 383629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 383635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 383638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383650 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383654 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 383654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383659 */   GIR_RootConstrainSelectedInstOperands,
     /* 383660 */   // GIR_Coverage, 5008,
     /* 383660 */   GIR_Done,
     /* 383661 */ // Label 7690: @383661
     /* 383661 */ GIM_Reject,
     /* 383662 */ // Label 7678: @383662
     /* 383662 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(383699), // Rule ID 5007 //
     /* 383667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 383673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 383676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383692 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 383692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383697 */   GIR_RootConstrainSelectedInstOperands,
     /* 383698 */   // GIR_Coverage, 5007,
     /* 383698 */   GIR_Done,
     /* 383699 */ // Label 7691: @383699
     /* 383699 */ GIM_Reject,
     /* 383700 */ // Label 7679: @383700
     /* 383700 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(383734), // Rule ID 11676 //
     /* 383705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 383711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 383714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 383717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383721 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 383721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383726 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383728 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383730 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383732 */   GIR_RootConstrainSelectedInstOperands,
     /* 383733 */   // GIR_Coverage, 11676,
     /* 383733 */   GIR_EraseRootFromParent_Done,
     /* 383734 */ // Label 7692: @383734
     /* 383734 */ GIM_Reject,
     /* 383735 */ // Label 7680: @383735
     /* 383735 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(383769), // Rule ID 11674 //
     /* 383740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 383746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 383749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 383752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383756 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 383756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383761 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383763 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383765 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383767 */   GIR_RootConstrainSelectedInstOperands,
     /* 383768 */   // GIR_Coverage, 11674,
     /* 383768 */   GIR_EraseRootFromParent_Done,
     /* 383769 */ // Label 7693: @383769
     /* 383769 */ GIM_Reject,
     /* 383770 */ // Label 7681: @383770
     /* 383770 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(383804), // Rule ID 11672 //
     /* 383775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 383781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 383784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 383787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383791 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 383791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383796 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383798 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383800 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383802 */   GIR_RootConstrainSelectedInstOperands,
     /* 383803 */   // GIR_Coverage, 11672,
     /* 383803 */   GIR_EraseRootFromParent_Done,
     /* 383804 */ // Label 7694: @383804
     /* 383804 */ GIM_Reject,
     /* 383805 */ // Label 7682: @383805
     /* 383805 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(383839), // Rule ID 11670 //
     /* 383810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 383816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 383819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 383822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383826 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 383826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383831 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383833 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383835 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383837 */   GIR_RootConstrainSelectedInstOperands,
     /* 383838 */   // GIR_Coverage, 11670,
     /* 383838 */   GIR_EraseRootFromParent_Done,
     /* 383839 */ // Label 7695: @383839
     /* 383839 */ GIM_Reject,
     /* 383840 */ // Label 7683: @383840
     /* 383840 */ GIM_Reject,
     /* 383841 */ // Label 119: @383841
     /* 383841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7704*/ GIMT_Encode4(385663),
     /* 383852 */ /*GILLT_s64*//*Label 7696*/ GIMT_Encode4(383888), GIMT_Encode4(0),
     /* 383860 */ /*GILLT_v2s32*//*Label 7697*/ GIMT_Encode4(384083),
     /* 383864 */ /*GILLT_v2s64*//*Label 7698*/ GIMT_Encode4(384330),
     /* 383868 */ /*GILLT_v4s16*//*Label 7699*/ GIMT_Encode4(384577),
     /* 383872 */ /*GILLT_v4s32*//*Label 7700*/ GIMT_Encode4(384853),
     /* 383876 */ /*GILLT_v8s8*//*Label 7701*/ GIMT_Encode4(385100),
     /* 383880 */ /*GILLT_v8s16*//*Label 7702*/ GIMT_Encode4(385245),
     /* 383884 */ /*GILLT_v16s8*//*Label 7703*/ GIMT_Encode4(385521),
     /* 383888 */ // Label 7696: @383888
     /* 383888 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(384082),
     /* 383893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 383896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383900 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(383947), // Rule ID 6327 //
     /* 383905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 383920 */     // MIs[1] Rn
     /* 383920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 383924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 383929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383931 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 383931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 383934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 383936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 383945 */     GIR_RootConstrainSelectedInstOperands,
     /* 383946 */     // GIR_Coverage, 6327,
     /* 383946 */     GIR_EraseRootFromParent_Done,
     /* 383947 */   // Label 7706: @383947
     /* 383947 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(383994), // Rule ID 6338 //
     /* 383952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 383967 */     // MIs[1] Rn
     /* 383967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 383971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 383976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383978 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 383978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 383981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 383983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 383992 */     GIR_RootConstrainSelectedInstOperands,
     /* 383993 */     // GIR_Coverage, 6338,
     /* 383993 */     GIR_EraseRootFromParent_Done,
     /* 383994 */   // Label 7707: @383994
     /* 383994 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(384041), // Rule ID 12915 //
     /* 383999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384007 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384014 */     // MIs[1] Rn
     /* 384014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384025 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 384028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384039 */     GIR_RootConstrainSelectedInstOperands,
     /* 384040 */     // GIR_Coverage, 12915,
     /* 384040 */     GIR_EraseRootFromParent_Done,
     /* 384041 */   // Label 7708: @384041
     /* 384041 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(384061), // Rule ID 5562 //
     /* 384046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384050 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 384050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384060 */     // GIR_Coverage, 5562,
     /* 384060 */     GIR_Done,
     /* 384061 */   // Label 7709: @384061
     /* 384061 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(384081), // Rule ID 5563 //
     /* 384066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384070 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 384070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384080 */     // GIR_Coverage, 5563,
     /* 384080 */     GIR_Done,
     /* 384081 */   // Label 7710: @384081
     /* 384081 */   GIM_Reject,
     /* 384082 */ // Label 7705: @384082
     /* 384082 */ GIM_Reject,
     /* 384083 */ // Label 7697: @384083
     /* 384083 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(384329),
     /* 384088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384095 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(384142), // Rule ID 6324 //
     /* 384100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384115 */     // MIs[1] Rn
     /* 384115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384126 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384140 */     GIR_RootConstrainSelectedInstOperands,
     /* 384141 */     // GIR_Coverage, 6324,
     /* 384141 */     GIR_EraseRootFromParent_Done,
     /* 384142 */   // Label 7712: @384142
     /* 384142 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(384189), // Rule ID 6335 //
     /* 384147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384162 */     // MIs[1] Rn
     /* 384162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384173 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384187 */     GIR_RootConstrainSelectedInstOperands,
     /* 384188 */     // GIR_Coverage, 6335,
     /* 384188 */     GIR_EraseRootFromParent_Done,
     /* 384189 */   // Label 7713: @384189
     /* 384189 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(384236), // Rule ID 12912 //
     /* 384194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384209 */     // MIs[1] Rn
     /* 384209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384220 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384234 */     GIR_RootConstrainSelectedInstOperands,
     /* 384235 */     // GIR_Coverage, 12912,
     /* 384235 */     GIR_EraseRootFromParent_Done,
     /* 384236 */   // Label 7714: @384236
     /* 384236 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(384255), // Rule ID 1909 //
     /* 384241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384248 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 384248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 384253 */     GIR_RootConstrainSelectedInstOperands,
     /* 384254 */     // GIR_Coverage, 1909,
     /* 384254 */     GIR_Done,
     /* 384255 */   // Label 7715: @384255
     /* 384255 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(384328), // Rule ID 5564 //
     /* 384260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384264 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 384267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 384281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384290 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384297 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 384300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 384318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384326 */     GIR_RootConstrainSelectedInstOperands,
     /* 384327 */     // GIR_Coverage, 5564,
     /* 384327 */     GIR_EraseRootFromParent_Done,
     /* 384328 */   // Label 7716: @384328
     /* 384328 */   GIM_Reject,
     /* 384329 */ // Label 7711: @384329
     /* 384329 */ GIM_Reject,
     /* 384330 */ // Label 7698: @384330
     /* 384330 */ GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(384576),
     /* 384335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 384338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384342 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(384389), // Rule ID 6326 //
     /* 384347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384355 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384362 */     // MIs[1] Rn
     /* 384362 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384373 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384387 */     GIR_RootConstrainSelectedInstOperands,
     /* 384388 */     // GIR_Coverage, 6326,
     /* 384388 */     GIR_EraseRootFromParent_Done,
     /* 384389 */   // Label 7718: @384389
     /* 384389 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(384436), // Rule ID 6337 //
     /* 384394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384409 */     // MIs[1] Rn
     /* 384409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384420 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384434 */     GIR_RootConstrainSelectedInstOperands,
     /* 384435 */     // GIR_Coverage, 6337,
     /* 384435 */     GIR_EraseRootFromParent_Done,
     /* 384436 */   // Label 7719: @384436
     /* 384436 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(384483), // Rule ID 12914 //
     /* 384441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384456 */     // MIs[1] Rn
     /* 384456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384467 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384481 */     GIR_RootConstrainSelectedInstOperands,
     /* 384482 */     // GIR_Coverage, 12914,
     /* 384482 */     GIR_EraseRootFromParent_Done,
     /* 384483 */   // Label 7720: @384483
     /* 384483 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(384502), // Rule ID 1911 //
     /* 384488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384495 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 384495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 384500 */     GIR_RootConstrainSelectedInstOperands,
     /* 384501 */     // GIR_Coverage, 1911,
     /* 384501 */     GIR_Done,
     /* 384502 */   // Label 7721: @384502
     /* 384502 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(384575), // Rule ID 5566 //
     /* 384507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384511 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 384514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 384528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 384547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 384565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384573 */     GIR_RootConstrainSelectedInstOperands,
     /* 384574 */     // GIR_Coverage, 5566,
     /* 384574 */     GIR_EraseRootFromParent_Done,
     /* 384575 */   // Label 7722: @384575
     /* 384575 */   GIM_Reject,
     /* 384576 */ // Label 7717: @384576
     /* 384576 */ GIM_Reject,
     /* 384577 */ // Label 7699: @384577
     /* 384577 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(384638), // Rule ID 6322 //
     /* 384582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384597 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384600 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384604 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384611 */   // MIs[1] Rn
     /* 384611 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384615 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384622 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 384625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384627 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384636 */   GIR_RootConstrainSelectedInstOperands,
     /* 384637 */   // GIR_Coverage, 6322,
     /* 384637 */   GIR_EraseRootFromParent_Done,
     /* 384638 */ // Label 7723: @384638
     /* 384638 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(384692), // Rule ID 6339 //
     /* 384643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384658 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384665 */   // MIs[1] Rn
     /* 384665 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384669 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384676 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 384679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384681 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384690 */   GIR_RootConstrainSelectedInstOperands,
     /* 384691 */   // GIR_Coverage, 6339,
     /* 384691 */   GIR_EraseRootFromParent_Done,
     /* 384692 */ // Label 7724: @384692
     /* 384692 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(384746), // Rule ID 12910 //
     /* 384697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384712 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384715 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384719 */   // MIs[1] Rn
     /* 384719 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384723 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384730 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 384733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384735 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384744 */   GIR_RootConstrainSelectedInstOperands,
     /* 384745 */   // GIR_Coverage, 12910,
     /* 384745 */   GIR_EraseRootFromParent_Done,
     /* 384746 */ // Label 7725: @384746
     /* 384746 */ GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(384772), // Rule ID 1907 //
     /* 384751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384765 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 384765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 384770 */   GIR_RootConstrainSelectedInstOperands,
     /* 384771 */   // GIR_Coverage, 1907,
     /* 384771 */   GIR_Done,
     /* 384772 */ // Label 7726: @384772
     /* 384772 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(384852), // Rule ID 5567 //
     /* 384777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384788 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384788 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 384791 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384795 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 384805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384814 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384817 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384821 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 384824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384834 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 384842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384850 */   GIR_RootConstrainSelectedInstOperands,
     /* 384851 */   // GIR_Coverage, 5567,
     /* 384851 */   GIR_EraseRootFromParent_Done,
     /* 384852 */ // Label 7727: @384852
     /* 384852 */ GIM_Reject,
     /* 384853 */ // Label 7700: @384853
     /* 384853 */ GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(385099),
     /* 384858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384865 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(384912), // Rule ID 6325 //
     /* 384870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384878 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384881 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384885 */     // MIs[1] Rn
     /* 384885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384896 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 384899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384910 */     GIR_RootConstrainSelectedInstOperands,
     /* 384911 */     // GIR_Coverage, 6325,
     /* 384911 */     GIR_EraseRootFromParent_Done,
     /* 384912 */   // Label 7729: @384912
     /* 384912 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(384959), // Rule ID 6336 //
     /* 384917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384932 */     // MIs[1] Rn
     /* 384932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384943 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 384946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384957 */     GIR_RootConstrainSelectedInstOperands,
     /* 384958 */     // GIR_Coverage, 6336,
     /* 384958 */     GIR_EraseRootFromParent_Done,
     /* 384959 */   // Label 7730: @384959
     /* 384959 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(385006), // Rule ID 12913 //
     /* 384964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384979 */     // MIs[1] Rn
     /* 384979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384990 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 384993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385004 */     GIR_RootConstrainSelectedInstOperands,
     /* 385005 */     // GIR_Coverage, 12913,
     /* 385005 */     GIR_EraseRootFromParent_Done,
     /* 385006 */   // Label 7731: @385006
     /* 385006 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(385025), // Rule ID 1910 //
     /* 385011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385018 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 385018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 385023 */     GIR_RootConstrainSelectedInstOperands,
     /* 385024 */     // GIR_Coverage, 1910,
     /* 385024 */     GIR_Done,
     /* 385025 */   // Label 7732: @385025
     /* 385025 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(385098), // Rule ID 5565 //
     /* 385030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385034 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 385037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 385051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 385088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385096 */     GIR_RootConstrainSelectedInstOperands,
     /* 385097 */     // GIR_Coverage, 5565,
     /* 385097 */     GIR_EraseRootFromParent_Done,
     /* 385098 */   // Label 7733: @385098
     /* 385098 */   GIM_Reject,
     /* 385099 */ // Label 7728: @385099
     /* 385099 */ GIM_Reject,
     /* 385100 */ // Label 7701: @385100
     /* 385100 */ GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(385157), // Rule ID 12908 //
     /* 385105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 385108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385120 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385127 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 385131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385133 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385140 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 385143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385155 */   GIR_RootConstrainSelectedInstOperands,
     /* 385156 */   // GIR_Coverage, 12908,
     /* 385156 */   GIR_EraseRootFromParent_Done,
     /* 385157 */ // Label 7734: @385157
     /* 385157 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(385218), // Rule ID 6320 //
     /* 385162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385177 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385180 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385184 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385191 */   // MIs[1] Rn
     /* 385191 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385202 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 385205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385216 */   GIR_RootConstrainSelectedInstOperands,
     /* 385217 */   // GIR_Coverage, 6320,
     /* 385217 */   GIR_EraseRootFromParent_Done,
     /* 385218 */ // Label 7735: @385218
     /* 385218 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(385244), // Rule ID 1905 //
     /* 385223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385237 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 385237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 385242 */   GIR_RootConstrainSelectedInstOperands,
     /* 385243 */   // GIR_Coverage, 1905,
     /* 385243 */   GIR_Done,
     /* 385244 */ // Label 7736: @385244
     /* 385244 */ GIM_Reject,
     /* 385245 */ // Label 7702: @385245
     /* 385245 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(385306), // Rule ID 6323 //
     /* 385250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385265 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385268 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385272 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 385279 */   // MIs[1] Rn
     /* 385279 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385283 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385290 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385295 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385304 */   GIR_RootConstrainSelectedInstOperands,
     /* 385305 */   // GIR_Coverage, 6323,
     /* 385305 */   GIR_EraseRootFromParent_Done,
     /* 385306 */ // Label 7737: @385306
     /* 385306 */ GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(385360), // Rule ID 6340 //
     /* 385311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385326 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385329 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385333 */   // MIs[1] Rn
     /* 385333 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385337 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385344 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385349 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385353 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385358 */   GIR_RootConstrainSelectedInstOperands,
     /* 385359 */   // GIR_Coverage, 6340,
     /* 385359 */   GIR_EraseRootFromParent_Done,
     /* 385360 */ // Label 7738: @385360
     /* 385360 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(385414), // Rule ID 12911 //
     /* 385365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385380 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385387 */   // MIs[1] Rn
     /* 385387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385391 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385398 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385412 */   GIR_RootConstrainSelectedInstOperands,
     /* 385413 */   // GIR_Coverage, 12911,
     /* 385413 */   GIR_EraseRootFromParent_Done,
     /* 385414 */ // Label 7739: @385414
     /* 385414 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(385440), // Rule ID 1908 //
     /* 385419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385433 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 385433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 385438 */   GIR_RootConstrainSelectedInstOperands,
     /* 385439 */   // GIR_Coverage, 1908,
     /* 385439 */   GIR_Done,
     /* 385440 */ // Label 7740: @385440
     /* 385440 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(385520), // Rule ID 5568 //
     /* 385445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385456 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 385459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 385473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385482 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385489 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 385492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385518 */   GIR_RootConstrainSelectedInstOperands,
     /* 385519 */   // GIR_Coverage, 5568,
     /* 385519 */   GIR_EraseRootFromParent_Done,
     /* 385520 */ // Label 7741: @385520
     /* 385520 */ GIM_Reject,
     /* 385521 */ // Label 7703: @385521
     /* 385521 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(385582), // Rule ID 6321 //
     /* 385526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385541 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385544 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385548 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385555 */   // MIs[1] Rn
     /* 385555 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385559 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385566 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 385569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385571 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385580 */   GIR_RootConstrainSelectedInstOperands,
     /* 385581 */   // GIR_Coverage, 6321,
     /* 385581 */   GIR_EraseRootFromParent_Done,
     /* 385582 */ // Label 7742: @385582
     /* 385582 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(385636), // Rule ID 12909 //
     /* 385587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 385590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385594 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385598 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385602 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385609 */   // MIs[1] Rn
     /* 385609 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385613 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385620 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 385623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385625 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385629 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385634 */   GIR_RootConstrainSelectedInstOperands,
     /* 385635 */   // GIR_Coverage, 12909,
     /* 385635 */   GIR_EraseRootFromParent_Done,
     /* 385636 */ // Label 7743: @385636
     /* 385636 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(385662), // Rule ID 1906 //
     /* 385641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385655 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 385655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 385660 */   GIR_RootConstrainSelectedInstOperands,
     /* 385661 */   // GIR_Coverage, 1906,
     /* 385661 */   GIR_Done,
     /* 385662 */ // Label 7744: @385662
     /* 385662 */ GIM_Reject,
     /* 385663 */ // Label 7704: @385663
     /* 385663 */ GIM_Reject,
     /* 385664 */ // Label 120: @385664
     /* 385664 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7747*/ GIMT_Encode4(385918),
     /* 385675 */ /*GILLT_v4s16*//*Label 7745*/ GIMT_Encode4(385691), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 385687 */ /*GILLT_v8s16*//*Label 7746*/ GIMT_Encode4(385777),
     /* 385691 */ // Label 7745: @385691
     /* 385691 */ GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(385776),
     /* 385696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385710 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(385744), // Rule ID 1915 //
     /* 385715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385730 */     // MIs[1] Operand 1
     /* 385730 */     // No operand predicates
     /* 385730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385732 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 385732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 385735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385742 */     GIR_RootConstrainSelectedInstOperands,
     /* 385743 */     // GIR_Coverage, 1915,
     /* 385743 */     GIR_EraseRootFromParent_Done,
     /* 385744 */   // Label 7749: @385744
     /* 385744 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(385775), // Rule ID 5569 //
     /* 385749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385761 */     // MIs[1] Operand 1
     /* 385761 */     // No operand predicates
     /* 385761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385763 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 385763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 385766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 385773 */     GIR_RootConstrainSelectedInstOperands,
     /* 385774 */     // GIR_Coverage, 5569,
     /* 385774 */     GIR_EraseRootFromParent_Done,
     /* 385775 */   // Label 7750: @385775
     /* 385775 */   GIM_Reject,
     /* 385776 */ // Label 7748: @385776
     /* 385776 */ GIM_Reject,
     /* 385777 */ // Label 7746: @385777
     /* 385777 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(385917),
     /* 385782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385792 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(385843), // Rule ID 6331 //
     /* 385797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385805 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385808 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385812 */     // MIs[1] Rn
     /* 385812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385827 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385841 */     GIR_RootConstrainSelectedInstOperands,
     /* 385842 */     // GIR_Coverage, 6331,
     /* 385842 */     GIR_EraseRootFromParent_Done,
     /* 385843 */   // Label 7752: @385843
     /* 385843 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(385881), // Rule ID 1916 //
     /* 385848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385867 */     // MIs[1] Operand 1
     /* 385867 */     // No operand predicates
     /* 385867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385869 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 385869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385879 */     GIR_RootConstrainSelectedInstOperands,
     /* 385880 */     // GIR_Coverage, 1916,
     /* 385880 */     GIR_EraseRootFromParent_Done,
     /* 385881 */   // Label 7753: @385881
     /* 385881 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(385916), // Rule ID 5570 //
     /* 385886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385902 */     // MIs[1] Operand 1
     /* 385902 */     // No operand predicates
     /* 385902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385904 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 385904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 385914 */     GIR_RootConstrainSelectedInstOperands,
     /* 385915 */     // GIR_Coverage, 5570,
     /* 385915 */     GIR_EraseRootFromParent_Done,
     /* 385916 */   // Label 7754: @385916
     /* 385916 */   GIM_Reject,
     /* 385917 */ // Label 7751: @385917
     /* 385917 */ GIM_Reject,
     /* 385918 */ // Label 7747: @385918
     /* 385918 */ GIM_Reject,
     /* 385919 */ // Label 121: @385919
     /* 385919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 7757*/ GIMT_Encode4(386173),
     /* 385930 */ /*GILLT_v2s32*//*Label 7755*/ GIMT_Encode4(385946), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 385942 */ /*GILLT_v4s32*//*Label 7756*/ GIMT_Encode4(386032),
     /* 385946 */ // Label 7755: @385946
     /* 385946 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(386031),
     /* 385951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385965 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(385999), // Rule ID 1913 //
     /* 385970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385985 */     // MIs[1] Operand 1
     /* 385985 */     // No operand predicates
     /* 385985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385987 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 385987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 385990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385997 */     GIR_RootConstrainSelectedInstOperands,
     /* 385998 */     // GIR_Coverage, 1913,
     /* 385998 */     GIR_EraseRootFromParent_Done,
     /* 385999 */   // Label 7759: @385999
     /* 385999 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(386030), // Rule ID 5571 //
     /* 386004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386016 */     // MIs[1] Operand 1
     /* 386016 */     // No operand predicates
     /* 386016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386018 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 386018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 386021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386028 */     GIR_RootConstrainSelectedInstOperands,
     /* 386029 */     // GIR_Coverage, 5571,
     /* 386029 */     GIR_EraseRootFromParent_Done,
     /* 386030 */   // Label 7760: @386030
     /* 386030 */   GIM_Reject,
     /* 386031 */ // Label 7758: @386031
     /* 386031 */ GIM_Reject,
     /* 386032 */ // Label 7756: @386032
     /* 386032 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(386172),
     /* 386037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386047 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(386098), // Rule ID 6333 //
     /* 386052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386067 */     // MIs[1] Rn
     /* 386067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386082 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 386085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386096 */     GIR_RootConstrainSelectedInstOperands,
     /* 386097 */     // GIR_Coverage, 6333,
     /* 386097 */     GIR_EraseRootFromParent_Done,
     /* 386098 */   // Label 7762: @386098
     /* 386098 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(386136), // Rule ID 1914 //
     /* 386103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386122 */     // MIs[1] Operand 1
     /* 386122 */     // No operand predicates
     /* 386122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386124 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 386127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386134 */     GIR_RootConstrainSelectedInstOperands,
     /* 386135 */     // GIR_Coverage, 1914,
     /* 386135 */     GIR_EraseRootFromParent_Done,
     /* 386136 */   // Label 7763: @386136
     /* 386136 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(386171), // Rule ID 5572 //
     /* 386141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386157 */     // MIs[1] Operand 1
     /* 386157 */     // No operand predicates
     /* 386157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386159 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 386159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 386162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386169 */     GIR_RootConstrainSelectedInstOperands,
     /* 386170 */     // GIR_Coverage, 5572,
     /* 386170 */     GIR_EraseRootFromParent_Done,
     /* 386171 */   // Label 7764: @386171
     /* 386171 */   GIM_Reject,
     /* 386172 */ // Label 7761: @386172
     /* 386172 */ GIM_Reject,
     /* 386173 */ // Label 7757: @386173
     /* 386173 */ GIM_Reject,
     /* 386174 */ // Label 122: @386174
     /* 386174 */ GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(386319),
     /* 386179 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 386182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386192 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(386243), // Rule ID 6334 //
     /* 386197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386212 */     // MIs[1] Rn
     /* 386212 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386227 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 386230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386241 */     GIR_RootConstrainSelectedInstOperands,
     /* 386242 */     // GIR_Coverage, 6334,
     /* 386242 */     GIR_EraseRootFromParent_Done,
     /* 386243 */   // Label 7766: @386243
     /* 386243 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(386318),
     /* 386248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386252 */     GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(386286), // Rule ID 1912 //
     /* 386257 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386260 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386264 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386268 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386272 */       // MIs[1] Operand 1
     /* 386272 */       // No operand predicates
     /* 386272 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386274 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 386277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386279 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386281 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386284 */       GIR_RootConstrainSelectedInstOperands,
     /* 386285 */       // GIR_Coverage, 1912,
     /* 386285 */       GIR_EraseRootFromParent_Done,
     /* 386286 */     // Label 7768: @386286
     /* 386286 */     GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(386317), // Rule ID 5573 //
     /* 386291 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386295 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386299 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386303 */       // MIs[1] Operand 1
     /* 386303 */       // No operand predicates
     /* 386303 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386305 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 386305 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 386308 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386310 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386312 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386315 */       GIR_RootConstrainSelectedInstOperands,
     /* 386316 */       // GIR_Coverage, 5573,
     /* 386316 */       GIR_EraseRootFromParent_Done,
     /* 386317 */     // Label 7769: @386317
     /* 386317 */     GIM_Reject,
     /* 386318 */   // Label 7767: @386318
     /* 386318 */   GIM_Reject,
     /* 386319 */ // Label 7765: @386319
     /* 386319 */ GIM_Reject,
     /* 386320 */ // Label 123: @386320
     /* 386320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7772*/ GIMT_Encode4(386498),
     /* 386331 */ /*GILLT_v8s8*//*Label 7770*/ GIMT_Encode4(386343), GIMT_Encode4(0),
     /* 386339 */ /*GILLT_v16s8*//*Label 7771*/ GIMT_Encode4(386392),
     /* 386343 */ // Label 7770: @386343
     /* 386343 */ GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(386391), // Rule ID 1917 //
     /* 386348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386373 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386377 */   // MIs[1] Operand 1
     /* 386377 */   // No operand predicates
     /* 386377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386379 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 386382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386384 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386386 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386389 */   GIR_RootConstrainSelectedInstOperands,
     /* 386390 */   // GIR_Coverage, 1917,
     /* 386390 */   GIR_EraseRootFromParent_Done,
     /* 386391 */ // Label 7773: @386391
     /* 386391 */ GIM_Reject,
     /* 386392 */ // Label 7771: @386392
     /* 386392 */ GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(386497),
     /* 386397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386407 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(386458), // Rule ID 6329 //
     /* 386412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386427 */     // MIs[1] Rn
     /* 386427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386442 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 386445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386456 */     GIR_RootConstrainSelectedInstOperands,
     /* 386457 */     // GIR_Coverage, 6329,
     /* 386457 */     GIR_EraseRootFromParent_Done,
     /* 386458 */   // Label 7775: @386458
     /* 386458 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(386496), // Rule ID 1918 //
     /* 386463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386482 */     // MIs[1] Operand 1
     /* 386482 */     // No operand predicates
     /* 386482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386484 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 386487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386494 */     GIR_RootConstrainSelectedInstOperands,
     /* 386495 */     // GIR_Coverage, 1918,
     /* 386495 */     GIR_EraseRootFromParent_Done,
     /* 386496 */   // Label 7776: @386496
     /* 386496 */   GIM_Reject,
     /* 386497 */ // Label 7774: @386497
     /* 386497 */ GIM_Reject,
     /* 386498 */ // Label 7772: @386498
     /* 386498 */ GIM_Reject,
     /* 386499 */ // Label 124: @386499
     /* 386499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7786*/ GIMT_Encode4(388148),
     /* 386510 */ /*GILLT_s64*//*Label 7777*/ GIMT_Encode4(386594), GIMT_Encode4(0),
     /* 386518 */ /*GILLT_v2s32*//*Label 7778*/ GIMT_Encode4(386915),
     /* 386522 */ /*GILLT_v2s64*//*Label 7779*/ GIMT_Encode4(387236),
     /* 386526 */ /*GILLT_v4s16*//*Label 7780*/ GIMT_Encode4(387319),
     /* 386530 */ /*GILLT_v4s32*//*Label 7781*/ GIMT_Encode4(387640),
     /* 386534 */ /*GILLT_v8s8*//*Label 7782*/ GIMT_Encode4(387723),
     /* 386538 */ /*GILLT_v8s16*//*Label 7783*/ GIMT_Encode4(387932),
     /* 386542 */ /*GILLT_v16s8*//*Label 7784*/ GIMT_Encode4(388015), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 386590 */ /*GILLT_nxv16s8*//*Label 7785*/ GIMT_Encode4(388101),
     /* 386594 */ // Label 7777: @386594
     /* 386594 */ GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(386914),
     /* 386599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 386602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386609 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(386724), // Rule ID 5396 //
     /* 386614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386631 */     // MIs[1] Operand 2
     /* 386631 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 386642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386650 */     // MIs[2] Rn
     /* 386650 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386655 */     // MIs[2] Operand 2
     /* 386655 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 386666 */     // MIs[0] imm
     /* 386666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386674 */     // MIs[3] Operand 1
     /* 386674 */     // No operand predicates
     /* 386674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386676 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 386676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 386683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 386699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386706 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 386713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386723 */     // GIR_Coverage, 5396,
     /* 386723 */     GIR_EraseRootFromParent_Done,
     /* 386724 */   // Label 7788: @386724
     /* 386724 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(386839), // Rule ID 5401 //
     /* 386729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386746 */     // MIs[1] Operand 2
     /* 386746 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 386757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386765 */     // MIs[2] Rn
     /* 386765 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386770 */     // MIs[2] Operand 2
     /* 386770 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 386781 */     // MIs[0] imm
     /* 386781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386789 */     // MIs[3] Operand 1
     /* 386789 */     // No operand predicates
     /* 386789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386791 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 386791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 386798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 386814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 386828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386838 */     // GIR_Coverage, 5401,
     /* 386838 */     GIR_EraseRootFromParent_Done,
     /* 386839 */   // Label 7789: @386839
     /* 386839 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(386876), // Rule ID 5393 //
     /* 386844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386852 */     // MIs[0] imm
     /* 386852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 386856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386860 */     // MIs[1] Operand 1
     /* 386860 */     // No operand predicates
     /* 386860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386862 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 386862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 386865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386874 */     GIR_RootConstrainSelectedInstOperands,
     /* 386875 */     // GIR_Coverage, 5393,
     /* 386875 */     GIR_EraseRootFromParent_Done,
     /* 386876 */   // Label 7790: @386876
     /* 386876 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(386913), // Rule ID 5398 //
     /* 386881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386889 */     // MIs[0] imm
     /* 386889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 386893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386897 */     // MIs[1] Operand 1
     /* 386897 */     // No operand predicates
     /* 386897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386899 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 386899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 386902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386911 */     GIR_RootConstrainSelectedInstOperands,
     /* 386912 */     // GIR_Coverage, 5398,
     /* 386912 */     GIR_EraseRootFromParent_Done,
     /* 386913 */   // Label 7791: @386913
     /* 386913 */   GIM_Reject,
     /* 386914 */ // Label 7787: @386914
     /* 386914 */ GIM_Reject,
     /* 386915 */ // Label 7778: @386915
     /* 386915 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(387235),
     /* 386920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 386926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386930 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(387045), // Rule ID 5386 //
     /* 386935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386952 */     // MIs[1] Operand 2
     /* 386952 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 386963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386971 */     // MIs[2] Rn
     /* 386971 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386976 */     // MIs[2] Operand 2
     /* 386976 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 386987 */     // MIs[0] imm
     /* 386987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386995 */     // MIs[3] Operand 1
     /* 386995 */     // No operand predicates
     /* 386995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386997 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 386997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387044 */     // GIR_Coverage, 5386,
     /* 387044 */     GIR_EraseRootFromParent_Done,
     /* 387045 */   // Label 7793: @387045
     /* 387045 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(387160), // Rule ID 5391 //
     /* 387050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387067 */     // MIs[1] Operand 2
     /* 387067 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387086 */     // MIs[2] Rn
     /* 387086 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387091 */     // MIs[2] Operand 2
     /* 387091 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 387102 */     // MIs[0] imm
     /* 387102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387110 */     // MIs[3] Operand 1
     /* 387110 */     // No operand predicates
     /* 387110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387112 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387142 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387159 */     // GIR_Coverage, 5391,
     /* 387159 */     GIR_EraseRootFromParent_Done,
     /* 387160 */   // Label 7794: @387160
     /* 387160 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(387197), // Rule ID 5383 //
     /* 387165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387173 */     // MIs[0] imm
     /* 387173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387181 */     // MIs[1] Operand 1
     /* 387181 */     // No operand predicates
     /* 387181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387183 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387195 */     GIR_RootConstrainSelectedInstOperands,
     /* 387196 */     // GIR_Coverage, 5383,
     /* 387196 */     GIR_EraseRootFromParent_Done,
     /* 387197 */   // Label 7795: @387197
     /* 387197 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(387234), // Rule ID 5388 //
     /* 387202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387210 */     // MIs[0] imm
     /* 387210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387218 */     // MIs[1] Operand 1
     /* 387218 */     // No operand predicates
     /* 387218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387220 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387232 */     GIR_RootConstrainSelectedInstOperands,
     /* 387233 */     // GIR_Coverage, 5388,
     /* 387233 */     GIR_EraseRootFromParent_Done,
     /* 387234 */   // Label 7796: @387234
     /* 387234 */   GIM_Reject,
     /* 387235 */ // Label 7792: @387235
     /* 387235 */ GIM_Reject,
     /* 387236 */ // Label 7779: @387236
     /* 387236 */ GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(387318),
     /* 387241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 387247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387259 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(387288), // Rule ID 5394 //
     /* 387264 */     // MIs[0] imm
     /* 387264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387272 */     // MIs[1] Operand 1
     /* 387272 */     // No operand predicates
     /* 387272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387274 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387286 */     GIR_RootConstrainSelectedInstOperands,
     /* 387287 */     // GIR_Coverage, 5394,
     /* 387287 */     GIR_EraseRootFromParent_Done,
     /* 387288 */   // Label 7798: @387288
     /* 387288 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(387317), // Rule ID 5399 //
     /* 387293 */     // MIs[0] imm
     /* 387293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387301 */     // MIs[1] Operand 1
     /* 387301 */     // No operand predicates
     /* 387301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387303 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387315 */     GIR_RootConstrainSelectedInstOperands,
     /* 387316 */     // GIR_Coverage, 5399,
     /* 387316 */     GIR_EraseRootFromParent_Done,
     /* 387317 */   // Label 7799: @387317
     /* 387317 */   GIM_Reject,
     /* 387318 */ // Label 7797: @387318
     /* 387318 */ GIM_Reject,
     /* 387319 */ // Label 7780: @387319
     /* 387319 */ GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(387639),
     /* 387324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 387330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387334 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(387449), // Rule ID 5376 //
     /* 387339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387356 */     // MIs[1] Operand 2
     /* 387356 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387375 */     // MIs[2] Rn
     /* 387375 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387380 */     // MIs[2] Operand 2
     /* 387380 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 387391 */     // MIs[0] imm
     /* 387391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387399 */     // MIs[3] Operand 1
     /* 387399 */     // No operand predicates
     /* 387399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387401 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387431 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387448 */     // GIR_Coverage, 5376,
     /* 387448 */     GIR_EraseRootFromParent_Done,
     /* 387449 */   // Label 7801: @387449
     /* 387449 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(387564), // Rule ID 5381 //
     /* 387454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387471 */     // MIs[1] Operand 2
     /* 387471 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387490 */     // MIs[2] Rn
     /* 387490 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387495 */     // MIs[2] Operand 2
     /* 387495 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 387506 */     // MIs[0] imm
     /* 387506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387514 */     // MIs[3] Operand 1
     /* 387514 */     // No operand predicates
     /* 387514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387516 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387546 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387563 */     // GIR_Coverage, 5381,
     /* 387563 */     GIR_EraseRootFromParent_Done,
     /* 387564 */   // Label 7802: @387564
     /* 387564 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(387601), // Rule ID 5373 //
     /* 387569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387577 */     // MIs[0] imm
     /* 387577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387585 */     // MIs[1] Operand 1
     /* 387585 */     // No operand predicates
     /* 387585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387587 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387599 */     GIR_RootConstrainSelectedInstOperands,
     /* 387600 */     // GIR_Coverage, 5373,
     /* 387600 */     GIR_EraseRootFromParent_Done,
     /* 387601 */   // Label 7803: @387601
     /* 387601 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(387638), // Rule ID 5378 //
     /* 387606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387614 */     // MIs[0] imm
     /* 387614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387622 */     // MIs[1] Operand 1
     /* 387622 */     // No operand predicates
     /* 387622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387624 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387636 */     GIR_RootConstrainSelectedInstOperands,
     /* 387637 */     // GIR_Coverage, 5378,
     /* 387637 */     GIR_EraseRootFromParent_Done,
     /* 387638 */   // Label 7804: @387638
     /* 387638 */   GIM_Reject,
     /* 387639 */ // Label 7800: @387639
     /* 387639 */ GIM_Reject,
     /* 387640 */ // Label 7781: @387640
     /* 387640 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(387722),
     /* 387645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 387651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387663 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(387692), // Rule ID 5384 //
     /* 387668 */     // MIs[0] imm
     /* 387668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387676 */     // MIs[1] Operand 1
     /* 387676 */     // No operand predicates
     /* 387676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387678 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387690 */     GIR_RootConstrainSelectedInstOperands,
     /* 387691 */     // GIR_Coverage, 5384,
     /* 387691 */     GIR_EraseRootFromParent_Done,
     /* 387692 */   // Label 7806: @387692
     /* 387692 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(387721), // Rule ID 5389 //
     /* 387697 */     // MIs[0] imm
     /* 387697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387705 */     // MIs[1] Operand 1
     /* 387705 */     // No operand predicates
     /* 387705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387707 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387719 */     GIR_RootConstrainSelectedInstOperands,
     /* 387720 */     // GIR_Coverage, 5389,
     /* 387720 */     GIR_EraseRootFromParent_Done,
     /* 387721 */   // Label 7807: @387721
     /* 387721 */   GIM_Reject,
     /* 387722 */ // Label 7805: @387722
     /* 387722 */ GIM_Reject,
     /* 387723 */ // Label 7782: @387723
     /* 387723 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(387931),
     /* 387728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 387731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 387734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387738 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(387853), // Rule ID 5371 //
     /* 387743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387760 */     // MIs[1] Operand 2
     /* 387760 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387779 */     // MIs[2] Rn
     /* 387779 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387784 */     // MIs[2] Operand 2
     /* 387784 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 387795 */     // MIs[0] imm
     /* 387795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387803 */     // MIs[3] Operand 1
     /* 387803 */     // No operand predicates
     /* 387803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387805 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387835 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387852 */     // GIR_Coverage, 5371,
     /* 387852 */     GIR_EraseRootFromParent_Done,
     /* 387853 */   // Label 7809: @387853
     /* 387853 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(387893), // Rule ID 1861 //
     /* 387858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387869 */     // MIs[0] imm
     /* 387869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387877 */     // MIs[1] Operand 1
     /* 387877 */     // No operand predicates
     /* 387877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387879 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387891 */     GIR_RootConstrainSelectedInstOperands,
     /* 387892 */     // GIR_Coverage, 1861,
     /* 387892 */     GIR_EraseRootFromParent_Done,
     /* 387893 */   // Label 7810: @387893
     /* 387893 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(387930), // Rule ID 5368 //
     /* 387898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387906 */     // MIs[0] imm
     /* 387906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387914 */     // MIs[1] Operand 1
     /* 387914 */     // No operand predicates
     /* 387914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387916 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387928 */     GIR_RootConstrainSelectedInstOperands,
     /* 387929 */     // GIR_Coverage, 5368,
     /* 387929 */     GIR_EraseRootFromParent_Done,
     /* 387930 */   // Label 7811: @387930
     /* 387930 */   GIM_Reject,
     /* 387931 */ // Label 7808: @387931
     /* 387931 */ GIM_Reject,
     /* 387932 */ // Label 7783: @387932
     /* 387932 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(388014),
     /* 387937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 387943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387955 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(387984), // Rule ID 5374 //
     /* 387960 */     // MIs[0] imm
     /* 387960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387968 */     // MIs[1] Operand 1
     /* 387968 */     // No operand predicates
     /* 387968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387970 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387982 */     GIR_RootConstrainSelectedInstOperands,
     /* 387983 */     // GIR_Coverage, 5374,
     /* 387983 */     GIR_EraseRootFromParent_Done,
     /* 387984 */   // Label 7813: @387984
     /* 387984 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(388013), // Rule ID 5379 //
     /* 387989 */     // MIs[0] imm
     /* 387989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387997 */     // MIs[1] Operand 1
     /* 387997 */     // No operand predicates
     /* 387997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387999 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388011 */     GIR_RootConstrainSelectedInstOperands,
     /* 388012 */     // GIR_Coverage, 5379,
     /* 388012 */     GIR_EraseRootFromParent_Done,
     /* 388013 */   // Label 7814: @388013
     /* 388013 */   GIM_Reject,
     /* 388014 */ // Label 7812: @388014
     /* 388014 */ GIM_Reject,
     /* 388015 */ // Label 7784: @388015
     /* 388015 */ GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(388100),
     /* 388020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 388026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388038 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(388070), // Rule ID 1862 //
     /* 388043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388046 */     // MIs[0] imm
     /* 388046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388054 */     // MIs[1] Operand 1
     /* 388054 */     // No operand predicates
     /* 388054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388056 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388068 */     GIR_RootConstrainSelectedInstOperands,
     /* 388069 */     // GIR_Coverage, 1862,
     /* 388069 */     GIR_EraseRootFromParent_Done,
     /* 388070 */   // Label 7816: @388070
     /* 388070 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(388099), // Rule ID 5369 //
     /* 388075 */     // MIs[0] imm
     /* 388075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388083 */     // MIs[1] Operand 1
     /* 388083 */     // No operand predicates
     /* 388083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388085 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388097 */     GIR_RootConstrainSelectedInstOperands,
     /* 388098 */     // GIR_Coverage, 5369,
     /* 388098 */     GIR_EraseRootFromParent_Done,
     /* 388099 */   // Label 7817: @388099
     /* 388099 */   GIM_Reject,
     /* 388100 */ // Label 7815: @388100
     /* 388100 */ GIM_Reject,
     /* 388101 */ // Label 7785: @388101
     /* 388101 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(388147), // Rule ID 2719 //
     /* 388106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 388115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388119 */   // MIs[0] Op3
     /* 388119 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388127 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 388131 */   // MIs[1] Operand 1
     /* 388131 */   // No operand predicates
     /* 388131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388133 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 388133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 388136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 388138 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 388140 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 388142 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 388145 */   GIR_RootConstrainSelectedInstOperands,
     /* 388146 */   // GIR_Coverage, 2719,
     /* 388146 */   GIR_EraseRootFromParent_Done,
     /* 388147 */ // Label 7818: @388147
     /* 388147 */ GIM_Reject,
     /* 388148 */ // Label 7786: @388148
     /* 388148 */ GIM_Reject,
     /* 388149 */ // Label 125: @388149
     /* 388149 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7826*/ GIMT_Encode4(388487),
     /* 388160 */ /*GILLT_s32*//*Label 7819*/ GIMT_Encode4(388196),
     /* 388164 */ /*GILLT_s64*//*Label 7820*/ GIMT_Encode4(388234), GIMT_Encode4(0),
     /* 388172 */ /*GILLT_v2s32*//*Label 7821*/ GIMT_Encode4(388297),
     /* 388176 */ /*GILLT_v2s64*//*Label 7822*/ GIMT_Encode4(388335),
     /* 388180 */ /*GILLT_v4s16*//*Label 7823*/ GIMT_Encode4(388373),
     /* 388184 */ /*GILLT_v4s32*//*Label 7824*/ GIMT_Encode4(388411), GIMT_Encode4(0),
     /* 388192 */ /*GILLT_v8s16*//*Label 7825*/ GIMT_Encode4(388449),
     /* 388196 */ // Label 7819: @388196
     /* 388196 */ GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(388233), // Rule ID 1615 //
     /* 388201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 388210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388222 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 388222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 388227 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388231 */   GIR_RootConstrainSelectedInstOperands,
     /* 388232 */   // GIR_Coverage, 1615,
     /* 388232 */   GIR_Done,
     /* 388233 */ // Label 7827: @388233
     /* 388233 */ GIM_Reject,
     /* 388234 */ // Label 7820: @388234
     /* 388234 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(388296),
     /* 388239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388257 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(388276), // Rule ID 1614 //
     /* 388262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388265 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 388265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 388270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388274 */     GIR_RootConstrainSelectedInstOperands,
     /* 388275 */     // GIR_Coverage, 1614,
     /* 388275 */     GIR_Done,
     /* 388276 */   // Label 7829: @388276
     /* 388276 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(388295), // Rule ID 5149 //
     /* 388281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388284 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 388284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 388289 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388293 */     GIR_RootConstrainSelectedInstOperands,
     /* 388294 */     // GIR_Coverage, 5149,
     /* 388294 */     GIR_Done,
     /* 388295 */   // Label 7830: @388295
     /* 388295 */   GIM_Reject,
     /* 388296 */ // Label 7828: @388296
     /* 388296 */ GIM_Reject,
     /* 388297 */ // Label 7821: @388297
     /* 388297 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(388334), // Rule ID 1203 //
     /* 388302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 388311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388323 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 388328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388332 */   GIR_RootConstrainSelectedInstOperands,
     /* 388333 */   // GIR_Coverage, 1203,
     /* 388333 */   GIR_Done,
     /* 388334 */ // Label 7831: @388334
     /* 388334 */ GIM_Reject,
     /* 388335 */ // Label 7822: @388335
     /* 388335 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(388372), // Rule ID 1205 //
     /* 388340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 388349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388361 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 388366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388370 */   GIR_RootConstrainSelectedInstOperands,
     /* 388371 */   // GIR_Coverage, 1205,
     /* 388371 */   GIR_Done,
     /* 388372 */ // Label 7832: @388372
     /* 388372 */ GIM_Reject,
     /* 388373 */ // Label 7823: @388373
     /* 388373 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(388410), // Rule ID 1201 //
     /* 388378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 388387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388399 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 388404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388408 */   GIR_RootConstrainSelectedInstOperands,
     /* 388409 */   // GIR_Coverage, 1201,
     /* 388409 */   GIR_Done,
     /* 388410 */ // Label 7833: @388410
     /* 388410 */ GIM_Reject,
     /* 388411 */ // Label 7824: @388411
     /* 388411 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(388448), // Rule ID 1204 //
     /* 388416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 388425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388437 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 388437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 388442 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388446 */   GIR_RootConstrainSelectedInstOperands,
     /* 388447 */   // GIR_Coverage, 1204,
     /* 388447 */   GIR_Done,
     /* 388448 */ // Label 7834: @388448
     /* 388448 */ GIM_Reject,
     /* 388449 */ // Label 7825: @388449
     /* 388449 */ GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(388486), // Rule ID 1202 //
     /* 388454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 388463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388475 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 388475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 388480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388484 */   GIR_RootConstrainSelectedInstOperands,
     /* 388485 */   // GIR_Coverage, 1202,
     /* 388485 */   GIR_Done,
     /* 388486 */ // Label 7835: @388486
     /* 388486 */ GIM_Reject,
     /* 388487 */ // Label 7826: @388487
     /* 388487 */ GIM_Reject,
     /* 388488 */ // Label 126: @388488
     /* 388488 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7842*/ GIMT_Encode4(388717),
     /* 388499 */ /*GILLT_s64*//*Label 7836*/ GIMT_Encode4(388531), GIMT_Encode4(0),
     /* 388507 */ /*GILLT_v2s32*//*Label 7837*/ GIMT_Encode4(388562),
     /* 388511 */ /*GILLT_v2s64*//*Label 7838*/ GIMT_Encode4(388593),
     /* 388515 */ /*GILLT_v4s16*//*Label 7839*/ GIMT_Encode4(388624),
     /* 388519 */ /*GILLT_v4s32*//*Label 7840*/ GIMT_Encode4(388655), GIMT_Encode4(0),
     /* 388527 */ /*GILLT_v8s16*//*Label 7841*/ GIMT_Encode4(388686),
     /* 388531 */ // Label 7836: @388531
     /* 388531 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(388561), // Rule ID 2504 //
     /* 388536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388550 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 388550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 388555 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388559 */   GIR_RootConstrainSelectedInstOperands,
     /* 388560 */   // GIR_Coverage, 2504,
     /* 388560 */   GIR_Done,
     /* 388561 */ // Label 7843: @388561
     /* 388561 */ GIM_Reject,
     /* 388562 */ // Label 7837: @388562
     /* 388562 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(388592), // Rule ID 766 //
     /* 388567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388581 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 388581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 388586 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388590 */   GIR_RootConstrainSelectedInstOperands,
     /* 388591 */   // GIR_Coverage, 766,
     /* 388591 */   GIR_Done,
     /* 388592 */ // Label 7844: @388592
     /* 388592 */ GIM_Reject,
     /* 388593 */ // Label 7838: @388593
     /* 388593 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(388623), // Rule ID 768 //
     /* 388598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388612 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 388612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 388617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388621 */   GIR_RootConstrainSelectedInstOperands,
     /* 388622 */   // GIR_Coverage, 768,
     /* 388622 */   GIR_Done,
     /* 388623 */ // Label 7845: @388623
     /* 388623 */ GIM_Reject,
     /* 388624 */ // Label 7839: @388624
     /* 388624 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(388654), // Rule ID 764 //
     /* 388629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388643 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 388643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 388648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388652 */   GIR_RootConstrainSelectedInstOperands,
     /* 388653 */   // GIR_Coverage, 764,
     /* 388653 */   GIR_Done,
     /* 388654 */ // Label 7846: @388654
     /* 388654 */ GIM_Reject,
     /* 388655 */ // Label 7840: @388655
     /* 388655 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(388685), // Rule ID 767 //
     /* 388660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388674 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 388674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 388679 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388683 */   GIR_RootConstrainSelectedInstOperands,
     /* 388684 */   // GIR_Coverage, 767,
     /* 388684 */   GIR_Done,
     /* 388685 */ // Label 7847: @388685
     /* 388685 */ GIM_Reject,
     /* 388686 */ // Label 7841: @388686
     /* 388686 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(388716), // Rule ID 765 //
     /* 388691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388705 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 388705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 388710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388714 */   GIR_RootConstrainSelectedInstOperands,
     /* 388715 */   // GIR_Coverage, 765,
     /* 388715 */   GIR_Done,
     /* 388716 */ // Label 7848: @388716
     /* 388716 */ GIM_Reject,
     /* 388717 */ // Label 7842: @388717
     /* 388717 */ GIM_Reject,
     /* 388718 */ // Label 127: @388718
     /* 388718 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7856*/ GIMT_Encode4(389381),
     /* 388729 */ /*GILLT_s32*//*Label 7849*/ GIMT_Encode4(388765),
     /* 388733 */ /*GILLT_s64*//*Label 7850*/ GIMT_Encode4(388803), GIMT_Encode4(0),
     /* 388741 */ /*GILLT_v2s32*//*Label 7851*/ GIMT_Encode4(388866),
     /* 388745 */ /*GILLT_v2s64*//*Label 7852*/ GIMT_Encode4(388969),
     /* 388749 */ /*GILLT_v4s16*//*Label 7853*/ GIMT_Encode4(389072),
     /* 388753 */ /*GILLT_v4s32*//*Label 7854*/ GIMT_Encode4(389175), GIMT_Encode4(0),
     /* 388761 */ /*GILLT_v8s16*//*Label 7855*/ GIMT_Encode4(389278),
     /* 388765 */ // Label 7849: @388765
     /* 388765 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(388802), // Rule ID 1617 //
     /* 388770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 388779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388791 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 388791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 388796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388800 */   GIR_RootConstrainSelectedInstOperands,
     /* 388801 */   // GIR_Coverage, 1617,
     /* 388801 */   GIR_Done,
     /* 388802 */ // Label 7857: @388802
     /* 388802 */ GIM_Reject,
     /* 388803 */ // Label 7850: @388803
     /* 388803 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(388865),
     /* 388808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388826 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(388845), // Rule ID 1616 //
     /* 388831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388834 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 388834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 388839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388843 */     GIR_RootConstrainSelectedInstOperands,
     /* 388844 */     // GIR_Coverage, 1616,
     /* 388844 */     GIR_Done,
     /* 388845 */   // Label 7859: @388845
     /* 388845 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(388864), // Rule ID 5150 //
     /* 388850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388853 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 388853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 388858 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388862 */     GIR_RootConstrainSelectedInstOperands,
     /* 388863 */     // GIR_Coverage, 5150,
     /* 388863 */     GIR_Done,
     /* 388864 */   // Label 7860: @388864
     /* 388864 */   GIM_Reject,
     /* 388865 */ // Label 7858: @388865
     /* 388865 */ GIM_Reject,
     /* 388866 */ // Label 7851: @388866
     /* 388866 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(388968),
     /* 388871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 388877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388881 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(388940), // Rule ID 1165 //
     /* 388886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 388897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 388914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388925 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 388928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388938 */     GIR_RootConstrainSelectedInstOperands,
     /* 388939 */     // GIR_Coverage, 1165,
     /* 388939 */     GIR_EraseRootFromParent_Done,
     /* 388940 */   // Label 7862: @388940
     /* 388940 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(388967), // Rule ID 1208 //
     /* 388945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388956 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 388961 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388965 */     GIR_RootConstrainSelectedInstOperands,
     /* 388966 */     // GIR_Coverage, 1208,
     /* 388966 */     GIR_Done,
     /* 388967 */   // Label 7863: @388967
     /* 388967 */   GIM_Reject,
     /* 388968 */ // Label 7861: @388968
     /* 388968 */ GIM_Reject,
     /* 388969 */ // Label 7852: @388969
     /* 388969 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(389071),
     /* 388974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 388980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388984 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(389043), // Rule ID 1169 //
     /* 388989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389028 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 389031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389041 */     GIR_RootConstrainSelectedInstOperands,
     /* 389042 */     // GIR_Coverage, 1169,
     /* 389042 */     GIR_EraseRootFromParent_Done,
     /* 389043 */   // Label 7865: @389043
     /* 389043 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(389070), // Rule ID 1210 //
     /* 389048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389059 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 389064 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389068 */     GIR_RootConstrainSelectedInstOperands,
     /* 389069 */     // GIR_Coverage, 1210,
     /* 389069 */     GIR_Done,
     /* 389070 */   // Label 7866: @389070
     /* 389070 */   GIM_Reject,
     /* 389071 */ // Label 7864: @389071
     /* 389071 */ GIM_Reject,
     /* 389072 */ // Label 7853: @389072
     /* 389072 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(389174),
     /* 389077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 389083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389087 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(389146), // Rule ID 1161 //
     /* 389092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389131 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 389134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389144 */     GIR_RootConstrainSelectedInstOperands,
     /* 389145 */     // GIR_Coverage, 1161,
     /* 389145 */     GIR_EraseRootFromParent_Done,
     /* 389146 */   // Label 7868: @389146
     /* 389146 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(389173), // Rule ID 1206 //
     /* 389151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389162 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 389167 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389171 */     GIR_RootConstrainSelectedInstOperands,
     /* 389172 */     // GIR_Coverage, 1206,
     /* 389172 */     GIR_Done,
     /* 389173 */   // Label 7869: @389173
     /* 389173 */   GIM_Reject,
     /* 389174 */ // Label 7867: @389174
     /* 389174 */ GIM_Reject,
     /* 389175 */ // Label 7854: @389175
     /* 389175 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(389277),
     /* 389180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389190 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(389249), // Rule ID 1167 //
     /* 389195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389234 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 389237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389247 */     GIR_RootConstrainSelectedInstOperands,
     /* 389248 */     // GIR_Coverage, 1167,
     /* 389248 */     GIR_EraseRootFromParent_Done,
     /* 389249 */   // Label 7871: @389249
     /* 389249 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(389276), // Rule ID 1209 //
     /* 389254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389265 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 389270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389274 */     GIR_RootConstrainSelectedInstOperands,
     /* 389275 */     // GIR_Coverage, 1209,
     /* 389275 */     GIR_Done,
     /* 389276 */   // Label 7872: @389276
     /* 389276 */   GIM_Reject,
     /* 389277 */ // Label 7870: @389277
     /* 389277 */ GIM_Reject,
     /* 389278 */ // Label 7855: @389278
     /* 389278 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(389380),
     /* 389283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 389289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389293 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(389352), // Rule ID 1163 //
     /* 389298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389337 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 389337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 389340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389350 */     GIR_RootConstrainSelectedInstOperands,
     /* 389351 */     // GIR_Coverage, 1163,
     /* 389351 */     GIR_EraseRootFromParent_Done,
     /* 389352 */   // Label 7874: @389352
     /* 389352 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(389379), // Rule ID 1207 //
     /* 389357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389368 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 389368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 389373 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389377 */     GIR_RootConstrainSelectedInstOperands,
     /* 389378 */     // GIR_Coverage, 1207,
     /* 389378 */     GIR_Done,
     /* 389379 */   // Label 7875: @389379
     /* 389379 */   GIM_Reject,
     /* 389380 */ // Label 7873: @389380
     /* 389380 */ GIM_Reject,
     /* 389381 */ // Label 7856: @389381
     /* 389381 */ GIM_Reject,
     /* 389382 */ // Label 128: @389382
     /* 389382 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7882*/ GIMT_Encode4(389611),
     /* 389393 */ /*GILLT_s64*//*Label 7876*/ GIMT_Encode4(389425), GIMT_Encode4(0),
     /* 389401 */ /*GILLT_v2s32*//*Label 7877*/ GIMT_Encode4(389456),
     /* 389405 */ /*GILLT_v2s64*//*Label 7878*/ GIMT_Encode4(389487),
     /* 389409 */ /*GILLT_v4s16*//*Label 7879*/ GIMT_Encode4(389518),
     /* 389413 */ /*GILLT_v4s32*//*Label 7880*/ GIMT_Encode4(389549), GIMT_Encode4(0),
     /* 389421 */ /*GILLT_v8s16*//*Label 7881*/ GIMT_Encode4(389580),
     /* 389425 */ // Label 7876: @389425
     /* 389425 */ GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(389455), // Rule ID 5180 //
     /* 389430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389444 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 389444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 389449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389453 */   GIR_RootConstrainSelectedInstOperands,
     /* 389454 */   // GIR_Coverage, 5180,
     /* 389454 */   GIR_Done,
     /* 389455 */ // Label 7883: @389455
     /* 389455 */ GIM_Reject,
     /* 389456 */ // Label 7877: @389456
     /* 389456 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(389486), // Rule ID 771 //
     /* 389461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389475 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 389475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 389480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389484 */   GIR_RootConstrainSelectedInstOperands,
     /* 389485 */   // GIR_Coverage, 771,
     /* 389485 */   GIR_Done,
     /* 389486 */ // Label 7884: @389486
     /* 389486 */ GIM_Reject,
     /* 389487 */ // Label 7878: @389487
     /* 389487 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(389517), // Rule ID 773 //
     /* 389492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389506 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 389506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 389511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389515 */   GIR_RootConstrainSelectedInstOperands,
     /* 389516 */   // GIR_Coverage, 773,
     /* 389516 */   GIR_Done,
     /* 389517 */ // Label 7885: @389517
     /* 389517 */ GIM_Reject,
     /* 389518 */ // Label 7879: @389518
     /* 389518 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(389548), // Rule ID 769 //
     /* 389523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389537 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 389537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 389542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389546 */   GIR_RootConstrainSelectedInstOperands,
     /* 389547 */   // GIR_Coverage, 769,
     /* 389547 */   GIR_Done,
     /* 389548 */ // Label 7886: @389548
     /* 389548 */ GIM_Reject,
     /* 389549 */ // Label 7880: @389549
     /* 389549 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(389579), // Rule ID 772 //
     /* 389554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389568 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 389568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 389573 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389577 */   GIR_RootConstrainSelectedInstOperands,
     /* 389578 */   // GIR_Coverage, 772,
     /* 389578 */   GIR_Done,
     /* 389579 */ // Label 7887: @389579
     /* 389579 */ GIM_Reject,
     /* 389580 */ // Label 7881: @389580
     /* 389580 */ GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(389610), // Rule ID 770 //
     /* 389585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389599 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 389599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 389604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389608 */   GIR_RootConstrainSelectedInstOperands,
     /* 389609 */   // GIR_Coverage, 770,
     /* 389609 */   GIR_Done,
     /* 389610 */ // Label 7888: @389610
     /* 389610 */ GIM_Reject,
     /* 389611 */ // Label 7882: @389611
     /* 389611 */ GIM_Reject,
     /* 389612 */ // Label 129: @389612
     /* 389612 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7896*/ GIMT_Encode4(390275),
     /* 389623 */ /*GILLT_s32*//*Label 7889*/ GIMT_Encode4(389659),
     /* 389627 */ /*GILLT_s64*//*Label 7890*/ GIMT_Encode4(389697), GIMT_Encode4(0),
     /* 389635 */ /*GILLT_v2s32*//*Label 7891*/ GIMT_Encode4(389760),
     /* 389639 */ /*GILLT_v2s64*//*Label 7892*/ GIMT_Encode4(389863),
     /* 389643 */ /*GILLT_v4s16*//*Label 7893*/ GIMT_Encode4(389966),
     /* 389647 */ /*GILLT_v4s32*//*Label 7894*/ GIMT_Encode4(390069), GIMT_Encode4(0),
     /* 389655 */ /*GILLT_v8s16*//*Label 7895*/ GIMT_Encode4(390172),
     /* 389659 */ // Label 7889: @389659
     /* 389659 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(389696), // Rule ID 1619 //
     /* 389664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 389673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389685 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 389685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 389690 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389694 */   GIR_RootConstrainSelectedInstOperands,
     /* 389695 */   // GIR_Coverage, 1619,
     /* 389695 */   GIR_Done,
     /* 389696 */ // Label 7897: @389696
     /* 389696 */ GIM_Reject,
     /* 389697 */ // Label 7890: @389697
     /* 389697 */ GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(389759),
     /* 389702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389720 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(389739), // Rule ID 1618 //
     /* 389725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389728 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 389728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 389733 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389737 */     GIR_RootConstrainSelectedInstOperands,
     /* 389738 */     // GIR_Coverage, 1618,
     /* 389738 */     GIR_Done,
     /* 389739 */   // Label 7899: @389739
     /* 389739 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(389758), // Rule ID 5151 //
     /* 389744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389747 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 389747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 389752 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389756 */     GIR_RootConstrainSelectedInstOperands,
     /* 389757 */     // GIR_Coverage, 5151,
     /* 389757 */     GIR_Done,
     /* 389758 */   // Label 7900: @389758
     /* 389758 */   GIM_Reject,
     /* 389759 */ // Label 7898: @389759
     /* 389759 */ GIM_Reject,
     /* 389760 */ // Label 7891: @389760
     /* 389760 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(389862),
     /* 389765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 389771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389775 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(389834), // Rule ID 1175 //
     /* 389780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389819 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 389822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389832 */     GIR_RootConstrainSelectedInstOperands,
     /* 389833 */     // GIR_Coverage, 1175,
     /* 389833 */     GIR_EraseRootFromParent_Done,
     /* 389834 */   // Label 7902: @389834
     /* 389834 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(389861), // Rule ID 1213 //
     /* 389839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389850 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 389855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389859 */     GIR_RootConstrainSelectedInstOperands,
     /* 389860 */     // GIR_Coverage, 1213,
     /* 389860 */     GIR_Done,
     /* 389861 */   // Label 7903: @389861
     /* 389861 */   GIM_Reject,
     /* 389862 */ // Label 7901: @389862
     /* 389862 */ GIM_Reject,
     /* 389863 */ // Label 7892: @389863
     /* 389863 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(389965),
     /* 389868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 389874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389878 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(389937), // Rule ID 1179 //
     /* 389883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389922 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 389925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389935 */     GIR_RootConstrainSelectedInstOperands,
     /* 389936 */     // GIR_Coverage, 1179,
     /* 389936 */     GIR_EraseRootFromParent_Done,
     /* 389937 */   // Label 7905: @389937
     /* 389937 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(389964), // Rule ID 1215 //
     /* 389942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389953 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 389958 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389962 */     GIR_RootConstrainSelectedInstOperands,
     /* 389963 */     // GIR_Coverage, 1215,
     /* 389963 */     GIR_Done,
     /* 389964 */   // Label 7906: @389964
     /* 389964 */   GIM_Reject,
     /* 389965 */ // Label 7904: @389965
     /* 389965 */ GIM_Reject,
     /* 389966 */ // Label 7893: @389966
     /* 389966 */ GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(390068),
     /* 389971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 389977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389981 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(390040), // Rule ID 1171 //
     /* 389986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390025 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 390025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 390028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390038 */     GIR_RootConstrainSelectedInstOperands,
     /* 390039 */     // GIR_Coverage, 1171,
     /* 390039 */     GIR_EraseRootFromParent_Done,
     /* 390040 */   // Label 7908: @390040
     /* 390040 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(390067), // Rule ID 1211 //
     /* 390045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390056 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 390056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 390061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390065 */     GIR_RootConstrainSelectedInstOperands,
     /* 390066 */     // GIR_Coverage, 1211,
     /* 390066 */     GIR_Done,
     /* 390067 */   // Label 7909: @390067
     /* 390067 */   GIM_Reject,
     /* 390068 */ // Label 7907: @390068
     /* 390068 */ GIM_Reject,
     /* 390069 */ // Label 7894: @390069
     /* 390069 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(390171),
     /* 390074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 390080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390084 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(390143), // Rule ID 1177 //
     /* 390089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390128 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 390131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390141 */     GIR_RootConstrainSelectedInstOperands,
     /* 390142 */     // GIR_Coverage, 1177,
     /* 390142 */     GIR_EraseRootFromParent_Done,
     /* 390143 */   // Label 7911: @390143
     /* 390143 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(390170), // Rule ID 1214 //
     /* 390148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390159 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 390164 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390168 */     GIR_RootConstrainSelectedInstOperands,
     /* 390169 */     // GIR_Coverage, 1214,
     /* 390169 */     GIR_Done,
     /* 390170 */   // Label 7912: @390170
     /* 390170 */   GIM_Reject,
     /* 390171 */ // Label 7910: @390171
     /* 390171 */ GIM_Reject,
     /* 390172 */ // Label 7895: @390172
     /* 390172 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(390274),
     /* 390177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390187 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(390246), // Rule ID 1173 //
     /* 390192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390231 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 390231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 390234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390244 */     GIR_RootConstrainSelectedInstOperands,
     /* 390245 */     // GIR_Coverage, 1173,
     /* 390245 */     GIR_EraseRootFromParent_Done,
     /* 390246 */   // Label 7914: @390246
     /* 390246 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(390273), // Rule ID 1212 //
     /* 390251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390262 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 390262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 390267 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390271 */     GIR_RootConstrainSelectedInstOperands,
     /* 390272 */     // GIR_Coverage, 1212,
     /* 390272 */     GIR_Done,
     /* 390273 */   // Label 7915: @390273
     /* 390273 */   GIM_Reject,
     /* 390274 */ // Label 7913: @390274
     /* 390274 */ GIM_Reject,
     /* 390275 */ // Label 7896: @390275
     /* 390275 */ GIM_Reject,
     /* 390276 */ // Label 130: @390276
     /* 390276 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7922*/ GIMT_Encode4(390505),
     /* 390287 */ /*GILLT_s64*//*Label 7916*/ GIMT_Encode4(390319), GIMT_Encode4(0),
     /* 390295 */ /*GILLT_v2s32*//*Label 7917*/ GIMT_Encode4(390350),
     /* 390299 */ /*GILLT_v2s64*//*Label 7918*/ GIMT_Encode4(390381),
     /* 390303 */ /*GILLT_v4s16*//*Label 7919*/ GIMT_Encode4(390412),
     /* 390307 */ /*GILLT_v4s32*//*Label 7920*/ GIMT_Encode4(390443), GIMT_Encode4(0),
     /* 390315 */ /*GILLT_v8s16*//*Label 7921*/ GIMT_Encode4(390474),
     /* 390319 */ // Label 7916: @390319
     /* 390319 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(390349), // Rule ID 5181 //
     /* 390324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390338 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 390343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390347 */   GIR_RootConstrainSelectedInstOperands,
     /* 390348 */   // GIR_Coverage, 5181,
     /* 390348 */   GIR_Done,
     /* 390349 */ // Label 7923: @390349
     /* 390349 */ GIM_Reject,
     /* 390350 */ // Label 7917: @390350
     /* 390350 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(390380), // Rule ID 776 //
     /* 390355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390369 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 390374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390378 */   GIR_RootConstrainSelectedInstOperands,
     /* 390379 */   // GIR_Coverage, 776,
     /* 390379 */   GIR_Done,
     /* 390380 */ // Label 7924: @390380
     /* 390380 */ GIM_Reject,
     /* 390381 */ // Label 7918: @390381
     /* 390381 */ GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(390411), // Rule ID 778 //
     /* 390386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390400 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 390405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390409 */   GIR_RootConstrainSelectedInstOperands,
     /* 390410 */   // GIR_Coverage, 778,
     /* 390410 */   GIR_Done,
     /* 390411 */ // Label 7925: @390411
     /* 390411 */ GIM_Reject,
     /* 390412 */ // Label 7919: @390412
     /* 390412 */ GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(390442), // Rule ID 774 //
     /* 390417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390431 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 390436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390440 */   GIR_RootConstrainSelectedInstOperands,
     /* 390441 */   // GIR_Coverage, 774,
     /* 390441 */   GIR_Done,
     /* 390442 */ // Label 7926: @390442
     /* 390442 */ GIM_Reject,
     /* 390443 */ // Label 7920: @390443
     /* 390443 */ GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(390473), // Rule ID 777 //
     /* 390448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390462 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 390467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390471 */   GIR_RootConstrainSelectedInstOperands,
     /* 390472 */   // GIR_Coverage, 777,
     /* 390472 */   GIR_Done,
     /* 390473 */ // Label 7927: @390473
     /* 390473 */ GIM_Reject,
     /* 390474 */ // Label 7921: @390474
     /* 390474 */ GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(390504), // Rule ID 775 //
     /* 390479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390493 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 390498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390502 */   GIR_RootConstrainSelectedInstOperands,
     /* 390503 */   // GIR_Coverage, 775,
     /* 390503 */   GIR_Done,
     /* 390504 */ // Label 7928: @390504
     /* 390504 */ GIM_Reject,
     /* 390505 */ // Label 7922: @390505
     /* 390505 */ GIM_Reject,
     /* 390506 */ // Label 131: @390506
     /* 390506 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7935*/ GIMT_Encode4(390735),
     /* 390517 */ /*GILLT_s64*//*Label 7929*/ GIMT_Encode4(390549), GIMT_Encode4(0),
     /* 390525 */ /*GILLT_v2s32*//*Label 7930*/ GIMT_Encode4(390580),
     /* 390529 */ /*GILLT_v2s64*//*Label 7931*/ GIMT_Encode4(390611),
     /* 390533 */ /*GILLT_v4s16*//*Label 7932*/ GIMT_Encode4(390642),
     /* 390537 */ /*GILLT_v4s32*//*Label 7933*/ GIMT_Encode4(390673), GIMT_Encode4(0),
     /* 390545 */ /*GILLT_v8s16*//*Label 7934*/ GIMT_Encode4(390704),
     /* 390549 */ // Label 7929: @390549
     /* 390549 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(390579), // Rule ID 5182 //
     /* 390554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390568 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 390573 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390577 */   GIR_RootConstrainSelectedInstOperands,
     /* 390578 */   // GIR_Coverage, 5182,
     /* 390578 */   GIR_Done,
     /* 390579 */ // Label 7936: @390579
     /* 390579 */ GIM_Reject,
     /* 390580 */ // Label 7930: @390580
     /* 390580 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(390610), // Rule ID 781 //
     /* 390585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390599 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 390604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390608 */   GIR_RootConstrainSelectedInstOperands,
     /* 390609 */   // GIR_Coverage, 781,
     /* 390609 */   GIR_Done,
     /* 390610 */ // Label 7937: @390610
     /* 390610 */ GIM_Reject,
     /* 390611 */ // Label 7931: @390611
     /* 390611 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(390641), // Rule ID 783 //
     /* 390616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390630 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 390635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390639 */   GIR_RootConstrainSelectedInstOperands,
     /* 390640 */   // GIR_Coverage, 783,
     /* 390640 */   GIR_Done,
     /* 390641 */ // Label 7938: @390641
     /* 390641 */ GIM_Reject,
     /* 390642 */ // Label 7932: @390642
     /* 390642 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(390672), // Rule ID 779 //
     /* 390647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390661 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 390666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390670 */   GIR_RootConstrainSelectedInstOperands,
     /* 390671 */   // GIR_Coverage, 779,
     /* 390671 */   GIR_Done,
     /* 390672 */ // Label 7939: @390672
     /* 390672 */ GIM_Reject,
     /* 390673 */ // Label 7933: @390673
     /* 390673 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(390703), // Rule ID 782 //
     /* 390678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390692 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 390697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390701 */   GIR_RootConstrainSelectedInstOperands,
     /* 390702 */   // GIR_Coverage, 782,
     /* 390702 */   GIR_Done,
     /* 390703 */ // Label 7940: @390703
     /* 390703 */ GIM_Reject,
     /* 390704 */ // Label 7934: @390704
     /* 390704 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(390734), // Rule ID 780 //
     /* 390709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390723 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 390728 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390732 */   GIR_RootConstrainSelectedInstOperands,
     /* 390733 */   // GIR_Coverage, 780,
     /* 390733 */   GIR_Done,
     /* 390734 */ // Label 7941: @390734
     /* 390734 */ GIM_Reject,
     /* 390735 */ // Label 7935: @390735
     /* 390735 */ GIM_Reject,
     /* 390736 */ // Label 132: @390736
     /* 390736 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7948*/ GIMT_Encode4(390965),
     /* 390747 */ /*GILLT_s64*//*Label 7942*/ GIMT_Encode4(390779), GIMT_Encode4(0),
     /* 390755 */ /*GILLT_v2s32*//*Label 7943*/ GIMT_Encode4(390810),
     /* 390759 */ /*GILLT_v2s64*//*Label 7944*/ GIMT_Encode4(390841),
     /* 390763 */ /*GILLT_v4s16*//*Label 7945*/ GIMT_Encode4(390872),
     /* 390767 */ /*GILLT_v4s32*//*Label 7946*/ GIMT_Encode4(390903), GIMT_Encode4(0),
     /* 390775 */ /*GILLT_v8s16*//*Label 7947*/ GIMT_Encode4(390934),
     /* 390779 */ // Label 7942: @390779
     /* 390779 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(390809), // Rule ID 5183 //
     /* 390784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390798 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 390803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390807 */   GIR_RootConstrainSelectedInstOperands,
     /* 390808 */   // GIR_Coverage, 5183,
     /* 390808 */   GIR_Done,
     /* 390809 */ // Label 7949: @390809
     /* 390809 */ GIM_Reject,
     /* 390810 */ // Label 7943: @390810
     /* 390810 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(390840), // Rule ID 786 //
     /* 390815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390829 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 390834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390838 */   GIR_RootConstrainSelectedInstOperands,
     /* 390839 */   // GIR_Coverage, 786,
     /* 390839 */   GIR_Done,
     /* 390840 */ // Label 7950: @390840
     /* 390840 */ GIM_Reject,
     /* 390841 */ // Label 7944: @390841
     /* 390841 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(390871), // Rule ID 788 //
     /* 390846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390860 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 390865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390869 */   GIR_RootConstrainSelectedInstOperands,
     /* 390870 */   // GIR_Coverage, 788,
     /* 390870 */   GIR_Done,
     /* 390871 */ // Label 7951: @390871
     /* 390871 */ GIM_Reject,
     /* 390872 */ // Label 7945: @390872
     /* 390872 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(390902), // Rule ID 784 //
     /* 390877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390891 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 390896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390900 */   GIR_RootConstrainSelectedInstOperands,
     /* 390901 */   // GIR_Coverage, 784,
     /* 390901 */   GIR_Done,
     /* 390902 */ // Label 7952: @390902
     /* 390902 */ GIM_Reject,
     /* 390903 */ // Label 7946: @390903
     /* 390903 */ GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(390933), // Rule ID 787 //
     /* 390908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390922 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 390927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390931 */   GIR_RootConstrainSelectedInstOperands,
     /* 390932 */   // GIR_Coverage, 787,
     /* 390932 */   GIR_Done,
     /* 390933 */ // Label 7953: @390933
     /* 390933 */ GIM_Reject,
     /* 390934 */ // Label 7947: @390934
     /* 390934 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(390964), // Rule ID 785 //
     /* 390939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390953 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 390958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390962 */   GIR_RootConstrainSelectedInstOperands,
     /* 390963 */   // GIR_Coverage, 785,
     /* 390963 */   GIR_Done,
     /* 390964 */ // Label 7954: @390964
     /* 390964 */ GIM_Reject,
     /* 390965 */ // Label 7948: @390965
     /* 390965 */ GIM_Reject,
     /* 390966 */ // Label 133: @390966
     /* 390966 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7959*/ GIMT_Encode4(391119),
     /* 390977 */ /*GILLT_s32*//*Label 7955*/ GIMT_Encode4(391017),
     /* 390981 */ /*GILLT_s64*//*Label 7956*/ GIMT_Encode4(391041), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391005 */ /*GILLT_v8s8*//*Label 7957*/ GIMT_Encode4(391065), GIMT_Encode4(0),
     /* 391013 */ /*GILLT_v16s8*//*Label 7958*/ GIMT_Encode4(391092),
     /* 391017 */ // Label 7955: @391017
     /* 391017 */ GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(391040), // Rule ID 3957 //
     /* 391022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391033 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 391038 */   GIR_RootConstrainSelectedInstOperands,
     /* 391039 */   // GIR_Coverage, 3957,
     /* 391039 */   GIR_Done,
     /* 391040 */ // Label 7960: @391040
     /* 391040 */ GIM_Reject,
     /* 391041 */ // Label 7956: @391041
     /* 391041 */ GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(391064), // Rule ID 3958 //
     /* 391046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391057 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 391062 */   GIR_RootConstrainSelectedInstOperands,
     /* 391063 */   // GIR_Coverage, 3958,
     /* 391063 */   GIR_Done,
     /* 391064 */ // Label 7961: @391064
     /* 391064 */ GIM_Reject,
     /* 391065 */ // Label 7957: @391065
     /* 391065 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(391091), // Rule ID 969 //
     /* 391070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391084 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 391089 */   GIR_RootConstrainSelectedInstOperands,
     /* 391090 */   // GIR_Coverage, 969,
     /* 391090 */   GIR_Done,
     /* 391091 */ // Label 7962: @391091
     /* 391091 */ GIM_Reject,
     /* 391092 */ // Label 7958: @391092
     /* 391092 */ GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(391118), // Rule ID 970 //
     /* 391097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391111 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 391116 */   GIR_RootConstrainSelectedInstOperands,
     /* 391117 */   // GIR_Coverage, 970,
     /* 391117 */   GIR_Done,
     /* 391118 */ // Label 7963: @391118
     /* 391118 */ GIM_Reject,
     /* 391119 */ // Label 7959: @391119
     /* 391119 */ GIM_Reject,
     /* 391120 */ // Label 134: @391120
     /* 391120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 7968*/ GIMT_Encode4(391295),
     /* 391131 */ /*GILLT_v4s16*//*Label 7964*/ GIMT_Encode4(391151), GIMT_Encode4(0),
     /* 391139 */ /*GILLT_v8s8*//*Label 7965*/ GIMT_Encode4(391196),
     /* 391143 */ /*GILLT_v8s16*//*Label 7966*/ GIMT_Encode4(391223),
     /* 391147 */ /*GILLT_v16s8*//*Label 7967*/ GIMT_Encode4(391268),
     /* 391151 */ // Label 7964: @391151
     /* 391151 */ GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(391195),
     /* 391156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391167 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(391182), // Rule ID 973 //
     /* 391172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391175 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 391180 */     GIR_RootConstrainSelectedInstOperands,
     /* 391181 */     // GIR_Coverage, 973,
     /* 391181 */     GIR_Done,
     /* 391182 */   // Label 7970: @391182
     /* 391182 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(391194), // Rule ID 4902 //
     /* 391187 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 391192 */     GIR_RootConstrainSelectedInstOperands,
     /* 391193 */     // GIR_Coverage, 4902,
     /* 391193 */     GIR_Done,
     /* 391194 */   // Label 7971: @391194
     /* 391194 */   GIM_Reject,
     /* 391195 */ // Label 7969: @391195
     /* 391195 */ GIM_Reject,
     /* 391196 */ // Label 7965: @391196
     /* 391196 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(391222), // Rule ID 971 //
     /* 391201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391215 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 391220 */   GIR_RootConstrainSelectedInstOperands,
     /* 391221 */   // GIR_Coverage, 971,
     /* 391221 */   GIR_Done,
     /* 391222 */ // Label 7972: @391222
     /* 391222 */ GIM_Reject,
     /* 391223 */ // Label 7966: @391223
     /* 391223 */ GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(391267),
     /* 391228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391239 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(391254), // Rule ID 974 //
     /* 391244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391247 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 391252 */     GIR_RootConstrainSelectedInstOperands,
     /* 391253 */     // GIR_Coverage, 974,
     /* 391253 */     GIR_Done,
     /* 391254 */   // Label 7974: @391254
     /* 391254 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(391266), // Rule ID 4904 //
     /* 391259 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 391264 */     GIR_RootConstrainSelectedInstOperands,
     /* 391265 */     // GIR_Coverage, 4904,
     /* 391265 */     GIR_Done,
     /* 391266 */   // Label 7975: @391266
     /* 391266 */   GIM_Reject,
     /* 391267 */ // Label 7973: @391267
     /* 391267 */ GIM_Reject,
     /* 391268 */ // Label 7967: @391268
     /* 391268 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(391294), // Rule ID 972 //
     /* 391273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391287 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 391292 */   GIR_RootConstrainSelectedInstOperands,
     /* 391293 */   // GIR_Coverage, 972,
     /* 391293 */   GIR_Done,
     /* 391294 */ // Label 7976: @391294
     /* 391294 */ GIM_Reject,
     /* 391295 */ // Label 7968: @391295
     /* 391295 */ GIM_Reject,
     /* 391296 */ // Label 135: @391296
     /* 391296 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 7983*/ GIMT_Encode4(391569),
     /* 391307 */ /*GILLT_v2s32*//*Label 7977*/ GIMT_Encode4(391335), GIMT_Encode4(0),
     /* 391315 */ /*GILLT_v4s16*//*Label 7978*/ GIMT_Encode4(391380),
     /* 391319 */ /*GILLT_v4s32*//*Label 7979*/ GIMT_Encode4(391425),
     /* 391323 */ /*GILLT_v8s8*//*Label 7980*/ GIMT_Encode4(391470),
     /* 391327 */ /*GILLT_v8s16*//*Label 7981*/ GIMT_Encode4(391497),
     /* 391331 */ /*GILLT_v16s8*//*Label 7982*/ GIMT_Encode4(391542),
     /* 391335 */ // Label 7977: @391335
     /* 391335 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(391379),
     /* 391340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391351 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(391366), // Rule ID 979 //
     /* 391356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391359 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 391364 */     GIR_RootConstrainSelectedInstOperands,
     /* 391365 */     // GIR_Coverage, 979,
     /* 391365 */     GIR_Done,
     /* 391366 */   // Label 7985: @391366
     /* 391366 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(391378), // Rule ID 4906 //
     /* 391371 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 391376 */     GIR_RootConstrainSelectedInstOperands,
     /* 391377 */     // GIR_Coverage, 4906,
     /* 391377 */     GIR_Done,
     /* 391378 */   // Label 7986: @391378
     /* 391378 */   GIM_Reject,
     /* 391379 */ // Label 7984: @391379
     /* 391379 */ GIM_Reject,
     /* 391380 */ // Label 7978: @391380
     /* 391380 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(391424),
     /* 391385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391396 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(391411), // Rule ID 977 //
     /* 391401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391404 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 391409 */     GIR_RootConstrainSelectedInstOperands,
     /* 391410 */     // GIR_Coverage, 977,
     /* 391410 */     GIR_Done,
     /* 391411 */   // Label 7988: @391411
     /* 391411 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(391423), // Rule ID 4903 //
     /* 391416 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 391421 */     GIR_RootConstrainSelectedInstOperands,
     /* 391422 */     // GIR_Coverage, 4903,
     /* 391422 */     GIR_Done,
     /* 391423 */   // Label 7989: @391423
     /* 391423 */   GIM_Reject,
     /* 391424 */ // Label 7987: @391424
     /* 391424 */ GIM_Reject,
     /* 391425 */ // Label 7979: @391425
     /* 391425 */ GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(391469),
     /* 391430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391441 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(391456), // Rule ID 980 //
     /* 391446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391449 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 391454 */     GIR_RootConstrainSelectedInstOperands,
     /* 391455 */     // GIR_Coverage, 980,
     /* 391455 */     GIR_Done,
     /* 391456 */   // Label 7991: @391456
     /* 391456 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(391468), // Rule ID 4907 //
     /* 391461 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 391466 */     GIR_RootConstrainSelectedInstOperands,
     /* 391467 */     // GIR_Coverage, 4907,
     /* 391467 */     GIR_Done,
     /* 391468 */   // Label 7992: @391468
     /* 391468 */   GIM_Reject,
     /* 391469 */ // Label 7990: @391469
     /* 391469 */ GIM_Reject,
     /* 391470 */ // Label 7980: @391470
     /* 391470 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(391496), // Rule ID 975 //
     /* 391475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391489 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 391494 */   GIR_RootConstrainSelectedInstOperands,
     /* 391495 */   // GIR_Coverage, 975,
     /* 391495 */   GIR_Done,
     /* 391496 */ // Label 7993: @391496
     /* 391496 */ GIM_Reject,
     /* 391497 */ // Label 7981: @391497
     /* 391497 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(391541),
     /* 391502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391513 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(391528), // Rule ID 978 //
     /* 391518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391521 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 391526 */     GIR_RootConstrainSelectedInstOperands,
     /* 391527 */     // GIR_Coverage, 978,
     /* 391527 */     GIR_Done,
     /* 391528 */   // Label 7995: @391528
     /* 391528 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(391540), // Rule ID 4905 //
     /* 391533 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 391538 */     GIR_RootConstrainSelectedInstOperands,
     /* 391539 */     // GIR_Coverage, 4905,
     /* 391539 */     GIR_Done,
     /* 391540 */   // Label 7996: @391540
     /* 391540 */   GIM_Reject,
     /* 391541 */ // Label 7994: @391541
     /* 391541 */ GIM_Reject,
     /* 391542 */ // Label 7982: @391542
     /* 391542 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(391568), // Rule ID 976 //
     /* 391547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391561 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 391566 */   GIR_RootConstrainSelectedInstOperands,
     /* 391567 */   // GIR_Coverage, 976,
     /* 391567 */   GIR_Done,
     /* 391568 */ // Label 7997: @391568
     /* 391568 */ GIM_Reject,
     /* 391569 */ // Label 7983: @391569
     /* 391569 */ GIM_Reject,
     /* 391570 */ // Label 136: @391570
     /* 391570 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8004*/ GIMT_Encode4(391775),
     /* 391581 */ /*GILLT_s64*//*Label 7998*/ GIMT_Encode4(391613), GIMT_Encode4(0),
     /* 391589 */ /*GILLT_v2s32*//*Label 7999*/ GIMT_Encode4(391640),
     /* 391593 */ /*GILLT_v2s64*//*Label 8000*/ GIMT_Encode4(391667),
     /* 391597 */ /*GILLT_v4s16*//*Label 8001*/ GIMT_Encode4(391694),
     /* 391601 */ /*GILLT_v4s32*//*Label 8002*/ GIMT_Encode4(391721), GIMT_Encode4(0),
     /* 391609 */ /*GILLT_v8s16*//*Label 8003*/ GIMT_Encode4(391748),
     /* 391613 */ // Label 7998: @391613
     /* 391613 */ GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(391639), // Rule ID 1001 //
     /* 391618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391632 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 391632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 391637 */   GIR_RootConstrainSelectedInstOperands,
     /* 391638 */   // GIR_Coverage, 1001,
     /* 391638 */   GIR_Done,
     /* 391639 */ // Label 8005: @391639
     /* 391639 */ GIM_Reject,
     /* 391640 */ // Label 7999: @391640
     /* 391640 */ GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(391666), // Rule ID 997 //
     /* 391645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391659 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 391659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 391664 */   GIR_RootConstrainSelectedInstOperands,
     /* 391665 */   // GIR_Coverage, 997,
     /* 391665 */   GIR_Done,
     /* 391666 */ // Label 8006: @391666
     /* 391666 */ GIM_Reject,
     /* 391667 */ // Label 8000: @391667
     /* 391667 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(391693), // Rule ID 1003 //
     /* 391672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391686 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 391686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 391691 */   GIR_RootConstrainSelectedInstOperands,
     /* 391692 */   // GIR_Coverage, 1003,
     /* 391692 */   GIR_Done,
     /* 391693 */ // Label 8007: @391693
     /* 391693 */ GIM_Reject,
     /* 391694 */ // Label 8001: @391694
     /* 391694 */ GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(391720), // Rule ID 993 //
     /* 391699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391713 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 391713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 391718 */   GIR_RootConstrainSelectedInstOperands,
     /* 391719 */   // GIR_Coverage, 993,
     /* 391719 */   GIR_Done,
     /* 391720 */ // Label 8008: @391720
     /* 391720 */ GIM_Reject,
     /* 391721 */ // Label 8002: @391721
     /* 391721 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(391747), // Rule ID 999 //
     /* 391726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391740 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 391740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 391745 */   GIR_RootConstrainSelectedInstOperands,
     /* 391746 */   // GIR_Coverage, 999,
     /* 391746 */   GIR_Done,
     /* 391747 */ // Label 8009: @391747
     /* 391747 */ GIM_Reject,
     /* 391748 */ // Label 8003: @391748
     /* 391748 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(391774), // Rule ID 995 //
     /* 391753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391767 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 391767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 391772 */   GIR_RootConstrainSelectedInstOperands,
     /* 391773 */   // GIR_Coverage, 995,
     /* 391773 */   GIR_Done,
     /* 391774 */ // Label 8010: @391774
     /* 391774 */ GIM_Reject,
     /* 391775 */ // Label 8004: @391775
     /* 391775 */ GIM_Reject,
     /* 391776 */ // Label 137: @391776
     /* 391776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8013*/ GIMT_Encode4(392174),
     /* 391787 */ /*GILLT_v2s64*//*Label 8011*/ GIMT_Encode4(391799), GIMT_Encode4(0),
     /* 391795 */ /*GILLT_v4s32*//*Label 8012*/ GIMT_Encode4(391937),
     /* 391799 */ // Label 8011: @391799
     /* 391799 */ GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(391858), // Rule ID 5786 //
     /* 391804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391815 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 391815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 391822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 391847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391857 */   // GIR_Coverage, 5786,
     /* 391857 */   GIR_EraseRootFromParent_Done,
     /* 391858 */ // Label 8014: @391858
     /* 391858 */ GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(391936), // Rule ID 5908 //
     /* 391863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391874 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 391874 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 391877 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 391881 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391886 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 391895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 391917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 391920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391935 */   // GIR_Coverage, 5908,
     /* 391935 */   GIR_EraseRootFromParent_Done,
     /* 391936 */ // Label 8015: @391936
     /* 391936 */ GIM_Reject,
     /* 391937 */ // Label 8012: @391937
     /* 391937 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(391996), // Rule ID 5782 //
     /* 391942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391953 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 391953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 391956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 391960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391965 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 391985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391995 */   // GIR_Coverage, 5782,
     /* 391995 */   GIR_EraseRootFromParent_Done,
     /* 391996 */ // Label 8016: @391996
     /* 391996 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(392055), // Rule ID 5783 //
     /* 392001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392012 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 392012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 392019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 392044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392054 */   // GIR_Coverage, 5783,
     /* 392054 */   GIR_EraseRootFromParent_Done,
     /* 392055 */ // Label 8017: @392055
     /* 392055 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(392114), // Rule ID 5784 //
     /* 392060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392071 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 392071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 392074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 392078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392083 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 392103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392113 */   // GIR_Coverage, 5784,
     /* 392113 */   GIR_EraseRootFromParent_Done,
     /* 392114 */ // Label 8018: @392114
     /* 392114 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(392173), // Rule ID 5785 //
     /* 392119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392130 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 392130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 392137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 392162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392172 */   // GIR_Coverage, 5785,
     /* 392172 */   GIR_EraseRootFromParent_Done,
     /* 392173 */ // Label 8019: @392173
     /* 392173 */ GIM_Reject,
     /* 392174 */ // Label 8013: @392174
     /* 392174 */ GIM_Reject,
     /* 392175 */ // Label 138: @392175
     /* 392175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8024*/ GIMT_Encode4(392544),
     /* 392186 */ /*GILLT_v2s32*//*Label 8020*/ GIMT_Encode4(392246), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392198 */ /*GILLT_v4s32*//*Label 8021*/ GIMT_Encode4(392366), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392230 */ /*GILLT_nxv2s64*//*Label 8022*/ GIMT_Encode4(392486), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392242 */ /*GILLT_nxv4s32*//*Label 8023*/ GIMT_Encode4(392515),
     /* 392246 */ // Label 8020: @392246
     /* 392246 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(392365),
     /* 392251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 392257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 392260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392272 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(392345), // Rule ID 26 //
     /* 392277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 392284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 392288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392321 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392325 */     // MIs[3] Operand 1
     /* 392325 */     // No operand predicates
     /* 392325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392327 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 392330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 392334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392343 */     GIR_RootConstrainSelectedInstOperands,
     /* 392344 */     // GIR_Coverage, 26,
     /* 392344 */     GIR_EraseRootFromParent_Done,
     /* 392345 */   // Label 8026: @392345
     /* 392345 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(392364), // Rule ID 22 //
     /* 392350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392357 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 392357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 392362 */     GIR_RootConstrainSelectedInstOperands,
     /* 392363 */     // GIR_Coverage, 22,
     /* 392363 */     GIR_Done,
     /* 392364 */   // Label 8027: @392364
     /* 392364 */   GIM_Reject,
     /* 392365 */ // Label 8025: @392365
     /* 392365 */ GIM_Reject,
     /* 392366 */ // Label 8021: @392366
     /* 392366 */ GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(392485),
     /* 392371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 392377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 392380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392392 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(392465), // Rule ID 27 //
     /* 392397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 392404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 392408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392445 */     // MIs[3] Operand 1
     /* 392445 */     // No operand predicates
     /* 392445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392447 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 392450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 392454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392463 */     GIR_RootConstrainSelectedInstOperands,
     /* 392464 */     // GIR_Coverage, 27,
     /* 392464 */     GIR_EraseRootFromParent_Done,
     /* 392465 */   // Label 8029: @392465
     /* 392465 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(392484), // Rule ID 23 //
     /* 392470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392477 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 392477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 392482 */     GIR_RootConstrainSelectedInstOperands,
     /* 392483 */     // GIR_Coverage, 23,
     /* 392483 */     GIR_Done,
     /* 392484 */   // Label 8030: @392484
     /* 392484 */   GIM_Reject,
     /* 392485 */ // Label 8028: @392485
     /* 392485 */ GIM_Reject,
     /* 392486 */ // Label 8022: @392486
     /* 392486 */ GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(392514), // Rule ID 2972 //
     /* 392491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 392497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 392500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 392503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392507 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 392507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 392512 */   GIR_RootConstrainSelectedInstOperands,
     /* 392513 */   // GIR_Coverage, 2972,
     /* 392513 */   GIR_Done,
     /* 392514 */ // Label 8031: @392514
     /* 392514 */ GIM_Reject,
     /* 392515 */ // Label 8023: @392515
     /* 392515 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(392543), // Rule ID 2971 //
     /* 392520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 392529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 392532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392536 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 392536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 392541 */   GIR_RootConstrainSelectedInstOperands,
     /* 392542 */   // GIR_Coverage, 2971,
     /* 392542 */   GIR_Done,
     /* 392543 */ // Label 8032: @392543
     /* 392543 */ GIM_Reject,
     /* 392544 */ // Label 8024: @392544
     /* 392544 */ GIM_Reject,
     /* 392545 */ // Label 139: @392545
     /* 392545 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8036*/ GIMT_Encode4(392661),
     /* 392556 */ /*GILLT_s16*//*Label 8033*/ GIMT_Encode4(392568),
     /* 392560 */ /*GILLT_s32*//*Label 8034*/ GIMT_Encode4(392599),
     /* 392564 */ /*GILLT_s64*//*Label 8035*/ GIMT_Encode4(392630),
     /* 392568 */ // Label 8033: @392568
     /* 392568 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(392598), // Rule ID 1651 //
     /* 392573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 392576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392587 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 392592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392596 */   GIR_RootConstrainSelectedInstOperands,
     /* 392597 */   // GIR_Coverage, 1651,
     /* 392597 */   GIR_Done,
     /* 392598 */ // Label 8037: @392598
     /* 392598 */ GIM_Reject,
     /* 392599 */ // Label 8034: @392599
     /* 392599 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(392629), // Rule ID 1650 //
     /* 392604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 392607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392618 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 392623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392627 */   GIR_RootConstrainSelectedInstOperands,
     /* 392628 */   // GIR_Coverage, 1650,
     /* 392628 */   GIR_Done,
     /* 392629 */ // Label 8038: @392629
     /* 392629 */ GIM_Reject,
     /* 392630 */ // Label 8035: @392630
     /* 392630 */ GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(392660), // Rule ID 1649 //
     /* 392635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 392638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392649 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 392654 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392658 */   GIR_RootConstrainSelectedInstOperands,
     /* 392659 */   // GIR_Coverage, 1649,
     /* 392659 */   GIR_Done,
     /* 392660 */ // Label 8039: @392660
     /* 392660 */ GIM_Reject,
     /* 392661 */ // Label 8036: @392661
     /* 392661 */ GIM_Reject,
     /* 392662 */ // Label 140: @392662
     /* 392662 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8043*/ GIMT_Encode4(393894),
     /* 392673 */ /*GILLT_v2s64*//*Label 8040*/ GIMT_Encode4(392693), GIMT_Encode4(0),
     /* 392681 */ /*GILLT_v4s32*//*Label 8041*/ GIMT_Encode4(393254), GIMT_Encode4(0),
     /* 392689 */ /*GILLT_v8s16*//*Label 8042*/ GIMT_Encode4(393815),
     /* 392693 */ // Label 8040: @392693
     /* 392693 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(393253),
     /* 392698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 392704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392708 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(392800), // Rule ID 2047 //
     /* 392713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392757 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392761 */     // MIs[3] Operand 1
     /* 392761 */     // No operand predicates
     /* 392761 */     // MIs[1] Operand 2
     /* 392761 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 392772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 392781 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 392784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 392791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392798 */     GIR_RootConstrainSelectedInstOperands,
     /* 392799 */     // GIR_Coverage, 2047,
     /* 392799 */     GIR_EraseRootFromParent_Done,
     /* 392800 */   // Label 8045: @392800
     /* 392800 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(392892), // Rule ID 13213 //
     /* 392805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392853 */     // MIs[3] Operand 1
     /* 392853 */     // No operand predicates
     /* 392853 */     // MIs[1] Operand 2
     /* 392853 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 392864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 392873 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 392876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 392883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392890 */     GIR_RootConstrainSelectedInstOperands,
     /* 392891 */     // GIR_Coverage, 13213,
     /* 392891 */     GIR_EraseRootFromParent_Done,
     /* 392892 */   // Label 8046: @392892
     /* 392892 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(392978), // Rule ID 13211 //
     /* 392897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392941 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392945 */     // MIs[3] Operand 1
     /* 392945 */     // No operand predicates
     /* 392945 */     // MIs[1] Operand 2
     /* 392945 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 392956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392962 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 392965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392976 */     GIR_RootConstrainSelectedInstOperands,
     /* 392977 */     // GIR_Coverage, 13211,
     /* 392977 */     GIR_EraseRootFromParent_Done,
     /* 392978 */   // Label 8047: @392978
     /* 392978 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(393064), // Rule ID 2045 //
     /* 392983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393031 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393035 */     // MIs[3] Operand 1
     /* 393035 */     // No operand predicates
     /* 393035 */     // MIs[1] Operand 2
     /* 393035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393048 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393062 */     GIR_RootConstrainSelectedInstOperands,
     /* 393063 */     // GIR_Coverage, 2045,
     /* 393063 */     GIR_EraseRootFromParent_Done,
     /* 393064 */   // Label 8048: @393064
     /* 393064 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(393103), // Rule ID 1734 //
     /* 393069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393086 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 393086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 393089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393101 */     GIR_RootConstrainSelectedInstOperands,
     /* 393102 */     // GIR_Coverage, 1734,
     /* 393102 */     GIR_EraseRootFromParent_Done,
     /* 393103 */   // Label 8049: @393103
     /* 393103 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(393166), // Rule ID 13212 //
     /* 393108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393140 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393144 */     // MIs[2] Operand 1
     /* 393144 */     // No operand predicates
     /* 393144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393150 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393164 */     GIR_RootConstrainSelectedInstOperands,
     /* 393165 */     // GIR_Coverage, 13212,
     /* 393165 */     GIR_EraseRootFromParent_Done,
     /* 393166 */   // Label 8050: @393166
     /* 393166 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(393229), // Rule ID 2046 //
     /* 393171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393211 */     // MIs[2] Operand 1
     /* 393211 */     // No operand predicates
     /* 393211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393213 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393227 */     GIR_RootConstrainSelectedInstOperands,
     /* 393228 */     // GIR_Coverage, 2046,
     /* 393228 */     GIR_EraseRootFromParent_Done,
     /* 393229 */   // Label 8051: @393229
     /* 393229 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(393252), // Rule ID 1733 //
     /* 393234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393245 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 393245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 393250 */     GIR_RootConstrainSelectedInstOperands,
     /* 393251 */     // GIR_Coverage, 1733,
     /* 393251 */     GIR_Done,
     /* 393252 */   // Label 8052: @393252
     /* 393252 */   GIM_Reject,
     /* 393253 */ // Label 8044: @393253
     /* 393253 */ GIM_Reject,
     /* 393254 */ // Label 8041: @393254
     /* 393254 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(393814),
     /* 393259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393269 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(393361), // Rule ID 2044 //
     /* 393274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393318 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393322 */     // MIs[3] Operand 1
     /* 393322 */     // No operand predicates
     /* 393322 */     // MIs[1] Operand 2
     /* 393322 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 393333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393342 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 393345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393359 */     GIR_RootConstrainSelectedInstOperands,
     /* 393360 */     // GIR_Coverage, 2044,
     /* 393360 */     GIR_EraseRootFromParent_Done,
     /* 393361 */   // Label 8054: @393361
     /* 393361 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(393453), // Rule ID 13210 //
     /* 393366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393414 */     // MIs[3] Operand 1
     /* 393414 */     // No operand predicates
     /* 393414 */     // MIs[1] Operand 2
     /* 393414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 393425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393434 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 393437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393451 */     GIR_RootConstrainSelectedInstOperands,
     /* 393452 */     // GIR_Coverage, 13210,
     /* 393452 */     GIR_EraseRootFromParent_Done,
     /* 393453 */   // Label 8055: @393453
     /* 393453 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(393539), // Rule ID 13208 //
     /* 393458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393502 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393506 */     // MIs[3] Operand 1
     /* 393506 */     // No operand predicates
     /* 393506 */     // MIs[1] Operand 2
     /* 393506 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393523 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393537 */     GIR_RootConstrainSelectedInstOperands,
     /* 393538 */     // GIR_Coverage, 13208,
     /* 393538 */     GIR_EraseRootFromParent_Done,
     /* 393539 */   // Label 8056: @393539
     /* 393539 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(393625), // Rule ID 2042 //
     /* 393544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393596 */     // MIs[3] Operand 1
     /* 393596 */     // No operand predicates
     /* 393596 */     // MIs[1] Operand 2
     /* 393596 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393609 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393623 */     GIR_RootConstrainSelectedInstOperands,
     /* 393624 */     // GIR_Coverage, 2042,
     /* 393624 */     GIR_EraseRootFromParent_Done,
     /* 393625 */   // Label 8057: @393625
     /* 393625 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(393664), // Rule ID 1732 //
     /* 393630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393647 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 393647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 393650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393662 */     GIR_RootConstrainSelectedInstOperands,
     /* 393663 */     // GIR_Coverage, 1732,
     /* 393663 */     GIR_EraseRootFromParent_Done,
     /* 393664 */   // Label 8058: @393664
     /* 393664 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(393727), // Rule ID 13209 //
     /* 393669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393705 */     // MIs[2] Operand 1
     /* 393705 */     // No operand predicates
     /* 393705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393711 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393725 */     GIR_RootConstrainSelectedInstOperands,
     /* 393726 */     // GIR_Coverage, 13209,
     /* 393726 */     GIR_EraseRootFromParent_Done,
     /* 393727 */   // Label 8059: @393727
     /* 393727 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(393790), // Rule ID 2043 //
     /* 393732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393768 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393772 */     // MIs[2] Operand 1
     /* 393772 */     // No operand predicates
     /* 393772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393774 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393788 */     GIR_RootConstrainSelectedInstOperands,
     /* 393789 */     // GIR_Coverage, 2043,
     /* 393789 */     GIR_EraseRootFromParent_Done,
     /* 393790 */   // Label 8060: @393790
     /* 393790 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(393813), // Rule ID 1731 //
     /* 393795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393806 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 393806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 393811 */     GIR_RootConstrainSelectedInstOperands,
     /* 393812 */     // GIR_Coverage, 1731,
     /* 393812 */     GIR_Done,
     /* 393813 */   // Label 8061: @393813
     /* 393813 */   GIM_Reject,
     /* 393814 */ // Label 8053: @393814
     /* 393814 */ GIM_Reject,
     /* 393815 */ // Label 8042: @393815
     /* 393815 */ GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(393893),
     /* 393820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393830 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(393869), // Rule ID 1730 //
     /* 393835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 393845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 393852 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 393852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 393855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393867 */     GIR_RootConstrainSelectedInstOperands,
     /* 393868 */     // GIR_Coverage, 1730,
     /* 393868 */     GIR_EraseRootFromParent_Done,
     /* 393869 */   // Label 8063: @393869
     /* 393869 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(393892), // Rule ID 1729 //
     /* 393874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393885 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 393885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 393890 */     GIR_RootConstrainSelectedInstOperands,
     /* 393891 */     // GIR_Coverage, 1729,
     /* 393891 */     GIR_Done,
     /* 393892 */   // Label 8064: @393892
     /* 393892 */   GIM_Reject,
     /* 393893 */ // Label 8062: @393893
     /* 393893 */ GIM_Reject,
     /* 393894 */ // Label 8043: @393894
     /* 393894 */ GIM_Reject,
     /* 393895 */ // Label 141: @393895
     /* 393895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8083*/ GIMT_Encode4(394674),
     /* 393906 */ /*GILLT_v2s32*//*Label 8065*/ GIMT_Encode4(393982),
     /* 393910 */ /*GILLT_v2s64*//*Label 8066*/ GIMT_Encode4(394037),
     /* 393914 */ /*GILLT_v4s16*//*Label 8067*/ GIMT_Encode4(394092),
     /* 393918 */ /*GILLT_v4s32*//*Label 8068*/ GIMT_Encode4(394147),
     /* 393922 */ /*GILLT_v8s8*//*Label 8069*/ GIMT_Encode4(394202),
     /* 393926 */ /*GILLT_v8s16*//*Label 8070*/ GIMT_Encode4(394236),
     /* 393930 */ /*GILLT_v16s8*//*Label 8071*/ GIMT_Encode4(394291), GIMT_Encode4(0),
     /* 393938 */ /*GILLT_nxv2s1*//*Label 8072*/ GIMT_Encode4(394325),
     /* 393942 */ /*GILLT_nxv2s16*//*Label 8073*/ GIMT_Encode4(394351),
     /* 393946 */ /*GILLT_nxv2s32*//*Label 8074*/ GIMT_Encode4(394377),
     /* 393950 */ /*GILLT_nxv2s64*//*Label 8075*/ GIMT_Encode4(394403),
     /* 393954 */ /*GILLT_nxv4s1*//*Label 8076*/ GIMT_Encode4(394450),
     /* 393958 */ /*GILLT_nxv4s16*//*Label 8077*/ GIMT_Encode4(394476),
     /* 393962 */ /*GILLT_nxv4s32*//*Label 8078*/ GIMT_Encode4(394502),
     /* 393966 */ /*GILLT_nxv8s1*//*Label 8079*/ GIMT_Encode4(394549),
     /* 393970 */ /*GILLT_nxv8s16*//*Label 8080*/ GIMT_Encode4(394575),
     /* 393974 */ /*GILLT_nxv16s1*//*Label 8081*/ GIMT_Encode4(394622),
     /* 393978 */ /*GILLT_nxv16s8*//*Label 8082*/ GIMT_Encode4(394648),
     /* 393982 */ // Label 8065: @393982
     /* 393982 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(394036),
     /* 393987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 393993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394005 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(394020), // Rule ID 1867 //
     /* 394010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394013 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 394013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 394018 */     GIR_RootConstrainSelectedInstOperands,
     /* 394019 */     // GIR_Coverage, 1867,
     /* 394019 */     GIR_Done,
     /* 394020 */   // Label 8085: @394020
     /* 394020 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(394035), // Rule ID 2496 //
     /* 394025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394028 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 394033 */     GIR_RootConstrainSelectedInstOperands,
     /* 394034 */     // GIR_Coverage, 2496,
     /* 394034 */     GIR_Done,
     /* 394035 */   // Label 8086: @394035
     /* 394035 */   GIM_Reject,
     /* 394036 */ // Label 8084: @394036
     /* 394036 */ GIM_Reject,
     /* 394037 */ // Label 8066: @394037
     /* 394037 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(394091),
     /* 394042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394060 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(394075), // Rule ID 1869 //
     /* 394065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394068 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 394068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 394073 */     GIR_RootConstrainSelectedInstOperands,
     /* 394074 */     // GIR_Coverage, 1869,
     /* 394074 */     GIR_Done,
     /* 394075 */   // Label 8088: @394075
     /* 394075 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(394090), // Rule ID 2498 //
     /* 394080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394083 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 394088 */     GIR_RootConstrainSelectedInstOperands,
     /* 394089 */     // GIR_Coverage, 2498,
     /* 394089 */     GIR_Done,
     /* 394090 */   // Label 8089: @394090
     /* 394090 */   GIM_Reject,
     /* 394091 */ // Label 8087: @394091
     /* 394091 */ GIM_Reject,
     /* 394092 */ // Label 8067: @394092
     /* 394092 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(394146),
     /* 394097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394115 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(394130), // Rule ID 1865 //
     /* 394120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394123 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 394128 */     GIR_RootConstrainSelectedInstOperands,
     /* 394129 */     // GIR_Coverage, 1865,
     /* 394129 */     GIR_Done,
     /* 394130 */   // Label 8091: @394130
     /* 394130 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(394145), // Rule ID 2494 //
     /* 394135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394138 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 394143 */     GIR_RootConstrainSelectedInstOperands,
     /* 394144 */     // GIR_Coverage, 2494,
     /* 394144 */     GIR_Done,
     /* 394145 */   // Label 8092: @394145
     /* 394145 */   GIM_Reject,
     /* 394146 */ // Label 8090: @394146
     /* 394146 */ GIM_Reject,
     /* 394147 */ // Label 8068: @394147
     /* 394147 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(394201),
     /* 394152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394170 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(394185), // Rule ID 1868 //
     /* 394175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394178 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 394178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 394183 */     GIR_RootConstrainSelectedInstOperands,
     /* 394184 */     // GIR_Coverage, 1868,
     /* 394184 */     GIR_Done,
     /* 394185 */   // Label 8094: @394185
     /* 394185 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(394200), // Rule ID 2497 //
     /* 394190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394193 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 394198 */     GIR_RootConstrainSelectedInstOperands,
     /* 394199 */     // GIR_Coverage, 2497,
     /* 394199 */     GIR_Done,
     /* 394200 */   // Label 8095: @394200
     /* 394200 */   GIM_Reject,
     /* 394201 */ // Label 8093: @394201
     /* 394201 */ GIM_Reject,
     /* 394202 */ // Label 8069: @394202
     /* 394202 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(394235), // Rule ID 1863 //
     /* 394207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394228 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 394228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 394233 */   GIR_RootConstrainSelectedInstOperands,
     /* 394234 */   // GIR_Coverage, 1863,
     /* 394234 */   GIR_Done,
     /* 394235 */ // Label 8096: @394235
     /* 394235 */ GIM_Reject,
     /* 394236 */ // Label 8070: @394236
     /* 394236 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(394290),
     /* 394241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394259 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(394274), // Rule ID 1866 //
     /* 394264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394267 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 394267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 394272 */     GIR_RootConstrainSelectedInstOperands,
     /* 394273 */     // GIR_Coverage, 1866,
     /* 394273 */     GIR_Done,
     /* 394274 */   // Label 8098: @394274
     /* 394274 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(394289), // Rule ID 2495 //
     /* 394279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394282 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 394287 */     GIR_RootConstrainSelectedInstOperands,
     /* 394288 */     // GIR_Coverage, 2495,
     /* 394288 */     GIR_Done,
     /* 394289 */   // Label 8099: @394289
     /* 394289 */   GIM_Reject,
     /* 394290 */ // Label 8097: @394290
     /* 394290 */ GIM_Reject,
     /* 394291 */ // Label 8071: @394291
     /* 394291 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(394324), // Rule ID 1864 //
     /* 394296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 394305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394317 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 394317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 394322 */   GIR_RootConstrainSelectedInstOperands,
     /* 394323 */   // GIR_Coverage, 1864,
     /* 394323 */   GIR_Done,
     /* 394324 */ // Label 8100: @394324
     /* 394324 */ GIM_Reject,
     /* 394325 */ // Label 8072: @394325
     /* 394325 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(394350), // Rule ID 8809 //
     /* 394330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 394336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 394339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394343 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 394343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 394348 */   GIR_RootConstrainSelectedInstOperands,
     /* 394349 */   // GIR_Coverage, 8809,
     /* 394349 */   GIR_Done,
     /* 394350 */ // Label 8101: @394350
     /* 394350 */ GIM_Reject,
     /* 394351 */ // Label 8073: @394351
     /* 394351 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(394376), // Rule ID 8785 //
     /* 394356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 394362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 394365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394369 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 394369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394374 */   GIR_RootConstrainSelectedInstOperands,
     /* 394375 */   // GIR_Coverage, 8785,
     /* 394375 */   GIR_Done,
     /* 394376 */ // Label 8102: @394376
     /* 394376 */ GIM_Reject,
     /* 394377 */ // Label 8074: @394377
     /* 394377 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(394402), // Rule ID 8786 //
     /* 394382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 394388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 394391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394395 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 394395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394400 */   GIR_RootConstrainSelectedInstOperands,
     /* 394401 */   // GIR_Coverage, 8786,
     /* 394401 */   GIR_Done,
     /* 394402 */ // Label 8103: @394402
     /* 394402 */ GIM_Reject,
     /* 394403 */ // Label 8075: @394403
     /* 394403 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(394449),
     /* 394408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 394411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 394414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394418 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(394433), // Rule ID 8781 //
     /* 394423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394426 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 394426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394431 */     GIR_RootConstrainSelectedInstOperands,
     /* 394432 */     // GIR_Coverage, 8781,
     /* 394432 */     GIR_Done,
     /* 394433 */   // Label 8105: @394433
     /* 394433 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(394448), // Rule ID 8787 //
     /* 394438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394441 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 394441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394446 */     GIR_RootConstrainSelectedInstOperands,
     /* 394447 */     // GIR_Coverage, 8787,
     /* 394447 */     GIR_Done,
     /* 394448 */   // Label 8106: @394448
     /* 394448 */   GIM_Reject,
     /* 394449 */ // Label 8104: @394449
     /* 394449 */ GIM_Reject,
     /* 394450 */ // Label 8076: @394450
     /* 394450 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(394475), // Rule ID 8808 //
     /* 394455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 394461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 394464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394468 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 394468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 394473 */   GIR_RootConstrainSelectedInstOperands,
     /* 394474 */   // GIR_Coverage, 8808,
     /* 394474 */   GIR_Done,
     /* 394475 */ // Label 8107: @394475
     /* 394475 */ GIM_Reject,
     /* 394476 */ // Label 8077: @394476
     /* 394476 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(394501), // Rule ID 8783 //
     /* 394481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 394487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 394490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394494 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 394494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394499 */   GIR_RootConstrainSelectedInstOperands,
     /* 394500 */   // GIR_Coverage, 8783,
     /* 394500 */   GIR_Done,
     /* 394501 */ // Label 8108: @394501
     /* 394501 */ GIM_Reject,
     /* 394502 */ // Label 8078: @394502
     /* 394502 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(394548),
     /* 394507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 394510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 394513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394517 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(394532), // Rule ID 8780 //
     /* 394522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394525 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 394525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394530 */     GIR_RootConstrainSelectedInstOperands,
     /* 394531 */     // GIR_Coverage, 8780,
     /* 394531 */     GIR_Done,
     /* 394532 */   // Label 8110: @394532
     /* 394532 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(394547), // Rule ID 8784 //
     /* 394537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394540 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 394540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394545 */     GIR_RootConstrainSelectedInstOperands,
     /* 394546 */     // GIR_Coverage, 8784,
     /* 394546 */     GIR_Done,
     /* 394547 */   // Label 8111: @394547
     /* 394547 */   GIM_Reject,
     /* 394548 */ // Label 8109: @394548
     /* 394548 */ GIM_Reject,
     /* 394549 */ // Label 8079: @394549
     /* 394549 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(394574), // Rule ID 8807 //
     /* 394554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 394560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 394563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394567 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 394567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 394572 */   GIR_RootConstrainSelectedInstOperands,
     /* 394573 */   // GIR_Coverage, 8807,
     /* 394573 */   GIR_Done,
     /* 394574 */ // Label 8112: @394574
     /* 394574 */ GIM_Reject,
     /* 394575 */ // Label 8080: @394575
     /* 394575 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(394621),
     /* 394580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 394583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 394586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394590 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(394605), // Rule ID 8779 //
     /* 394595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394598 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 394598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 394603 */     GIR_RootConstrainSelectedInstOperands,
     /* 394604 */     // GIR_Coverage, 8779,
     /* 394604 */     GIR_Done,
     /* 394605 */   // Label 8114: @394605
     /* 394605 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(394620), // Rule ID 8782 //
     /* 394610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394613 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 394613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 394618 */     GIR_RootConstrainSelectedInstOperands,
     /* 394619 */     // GIR_Coverage, 8782,
     /* 394619 */     GIR_Done,
     /* 394620 */   // Label 8115: @394620
     /* 394620 */   GIM_Reject,
     /* 394621 */ // Label 8113: @394621
     /* 394621 */ GIM_Reject,
     /* 394622 */ // Label 8081: @394622
     /* 394622 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(394647), // Rule ID 2405 //
     /* 394627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 394633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 394636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394640 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 394640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 394645 */   GIR_RootConstrainSelectedInstOperands,
     /* 394646 */   // GIR_Coverage, 2405,
     /* 394646 */   GIR_Done,
     /* 394647 */ // Label 8116: @394647
     /* 394647 */ GIM_Reject,
     /* 394648 */ // Label 8082: @394648
     /* 394648 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(394673), // Rule ID 8778 //
     /* 394653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 394659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 394662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394666 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 394666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 394671 */   GIR_RootConstrainSelectedInstOperands,
     /* 394672 */   // GIR_Coverage, 8778,
     /* 394672 */   GIR_Done,
     /* 394673 */ // Label 8117: @394673
     /* 394673 */ GIM_Reject,
     /* 394674 */ // Label 8083: @394674
     /* 394674 */ GIM_Reject,
     /* 394675 */ // Label 142: @394675
     /* 394675 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8136*/ GIMT_Encode4(395454),
     /* 394686 */ /*GILLT_v2s32*//*Label 8118*/ GIMT_Encode4(394762),
     /* 394690 */ /*GILLT_v2s64*//*Label 8119*/ GIMT_Encode4(394817),
     /* 394694 */ /*GILLT_v4s16*//*Label 8120*/ GIMT_Encode4(394872),
     /* 394698 */ /*GILLT_v4s32*//*Label 8121*/ GIMT_Encode4(394927),
     /* 394702 */ /*GILLT_v8s8*//*Label 8122*/ GIMT_Encode4(394982),
     /* 394706 */ /*GILLT_v8s16*//*Label 8123*/ GIMT_Encode4(395016),
     /* 394710 */ /*GILLT_v16s8*//*Label 8124*/ GIMT_Encode4(395071), GIMT_Encode4(0),
     /* 394718 */ /*GILLT_nxv2s1*//*Label 8125*/ GIMT_Encode4(395105),
     /* 394722 */ /*GILLT_nxv2s16*//*Label 8126*/ GIMT_Encode4(395131),
     /* 394726 */ /*GILLT_nxv2s32*//*Label 8127*/ GIMT_Encode4(395157),
     /* 394730 */ /*GILLT_nxv2s64*//*Label 8128*/ GIMT_Encode4(395183),
     /* 394734 */ /*GILLT_nxv4s1*//*Label 8129*/ GIMT_Encode4(395230),
     /* 394738 */ /*GILLT_nxv4s16*//*Label 8130*/ GIMT_Encode4(395256),
     /* 394742 */ /*GILLT_nxv4s32*//*Label 8131*/ GIMT_Encode4(395282),
     /* 394746 */ /*GILLT_nxv8s1*//*Label 8132*/ GIMT_Encode4(395329),
     /* 394750 */ /*GILLT_nxv8s16*//*Label 8133*/ GIMT_Encode4(395355),
     /* 394754 */ /*GILLT_nxv16s1*//*Label 8134*/ GIMT_Encode4(395402),
     /* 394758 */ /*GILLT_nxv16s8*//*Label 8135*/ GIMT_Encode4(395428),
     /* 394762 */ // Label 8118: @394762
     /* 394762 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(394816),
     /* 394767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394785 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(394800), // Rule ID 1874 //
     /* 394790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394793 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 394793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 394798 */     GIR_RootConstrainSelectedInstOperands,
     /* 394799 */     // GIR_Coverage, 1874,
     /* 394799 */     GIR_Done,
     /* 394800 */   // Label 8138: @394800
     /* 394800 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(394815), // Rule ID 5405 //
     /* 394805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394808 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 394813 */     GIR_RootConstrainSelectedInstOperands,
     /* 394814 */     // GIR_Coverage, 5405,
     /* 394814 */     GIR_Done,
     /* 394815 */   // Label 8139: @394815
     /* 394815 */   GIM_Reject,
     /* 394816 */ // Label 8137: @394816
     /* 394816 */ GIM_Reject,
     /* 394817 */ // Label 8119: @394817
     /* 394817 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(394871),
     /* 394822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394840 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(394855), // Rule ID 1876 //
     /* 394845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394848 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 394848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 394853 */     GIR_RootConstrainSelectedInstOperands,
     /* 394854 */     // GIR_Coverage, 1876,
     /* 394854 */     GIR_Done,
     /* 394855 */   // Label 8141: @394855
     /* 394855 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(394870), // Rule ID 5407 //
     /* 394860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394863 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 394868 */     GIR_RootConstrainSelectedInstOperands,
     /* 394869 */     // GIR_Coverage, 5407,
     /* 394869 */     GIR_Done,
     /* 394870 */   // Label 8142: @394870
     /* 394870 */   GIM_Reject,
     /* 394871 */ // Label 8140: @394871
     /* 394871 */ GIM_Reject,
     /* 394872 */ // Label 8120: @394872
     /* 394872 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(394926),
     /* 394877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394895 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(394910), // Rule ID 1872 //
     /* 394900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394903 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 394908 */     GIR_RootConstrainSelectedInstOperands,
     /* 394909 */     // GIR_Coverage, 1872,
     /* 394909 */     GIR_Done,
     /* 394910 */   // Label 8144: @394910
     /* 394910 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(394925), // Rule ID 5403 //
     /* 394915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394918 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 394923 */     GIR_RootConstrainSelectedInstOperands,
     /* 394924 */     // GIR_Coverage, 5403,
     /* 394924 */     GIR_Done,
     /* 394925 */   // Label 8145: @394925
     /* 394925 */   GIM_Reject,
     /* 394926 */ // Label 8143: @394926
     /* 394926 */ GIM_Reject,
     /* 394927 */ // Label 8121: @394927
     /* 394927 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(394981),
     /* 394932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394950 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(394965), // Rule ID 1875 //
     /* 394955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394958 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 394958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 394963 */     GIR_RootConstrainSelectedInstOperands,
     /* 394964 */     // GIR_Coverage, 1875,
     /* 394964 */     GIR_Done,
     /* 394965 */   // Label 8147: @394965
     /* 394965 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(394980), // Rule ID 5406 //
     /* 394970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394973 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 394978 */     GIR_RootConstrainSelectedInstOperands,
     /* 394979 */     // GIR_Coverage, 5406,
     /* 394979 */     GIR_Done,
     /* 394980 */   // Label 8148: @394980
     /* 394980 */   GIM_Reject,
     /* 394981 */ // Label 8146: @394981
     /* 394981 */ GIM_Reject,
     /* 394982 */ // Label 8122: @394982
     /* 394982 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(395015), // Rule ID 1870 //
     /* 394987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395008 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 395008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 395013 */   GIR_RootConstrainSelectedInstOperands,
     /* 395014 */   // GIR_Coverage, 1870,
     /* 395014 */   GIR_Done,
     /* 395015 */ // Label 8149: @395015
     /* 395015 */ GIM_Reject,
     /* 395016 */ // Label 8123: @395016
     /* 395016 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(395070),
     /* 395021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395039 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(395054), // Rule ID 1873 //
     /* 395044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395047 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 395047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 395052 */     GIR_RootConstrainSelectedInstOperands,
     /* 395053 */     // GIR_Coverage, 1873,
     /* 395053 */     GIR_Done,
     /* 395054 */   // Label 8151: @395054
     /* 395054 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(395069), // Rule ID 5404 //
     /* 395059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395062 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 395067 */     GIR_RootConstrainSelectedInstOperands,
     /* 395068 */     // GIR_Coverage, 5404,
     /* 395068 */     GIR_Done,
     /* 395069 */   // Label 8152: @395069
     /* 395069 */   GIM_Reject,
     /* 395070 */ // Label 8150: @395070
     /* 395070 */ GIM_Reject,
     /* 395071 */ // Label 8124: @395071
     /* 395071 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(395104), // Rule ID 1871 //
     /* 395076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395097 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 395102 */   GIR_RootConstrainSelectedInstOperands,
     /* 395103 */   // GIR_Coverage, 1871,
     /* 395103 */   GIR_Done,
     /* 395104 */ // Label 8153: @395104
     /* 395104 */ GIM_Reject,
     /* 395105 */ // Label 8125: @395105
     /* 395105 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(395130), // Rule ID 8812 //
     /* 395110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 395116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 395119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395123 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 395123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 395128 */   GIR_RootConstrainSelectedInstOperands,
     /* 395129 */   // GIR_Coverage, 8812,
     /* 395129 */   GIR_Done,
     /* 395130 */ // Label 8154: @395130
     /* 395130 */ GIM_Reject,
     /* 395131 */ // Label 8126: @395131
     /* 395131 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(395156), // Rule ID 8795 //
     /* 395136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 395142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 395145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395149 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 395149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395154 */   GIR_RootConstrainSelectedInstOperands,
     /* 395155 */   // GIR_Coverage, 8795,
     /* 395155 */   GIR_Done,
     /* 395156 */ // Label 8155: @395156
     /* 395156 */ GIM_Reject,
     /* 395157 */ // Label 8127: @395157
     /* 395157 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(395182), // Rule ID 8796 //
     /* 395162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 395168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 395171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395175 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 395175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395180 */   GIR_RootConstrainSelectedInstOperands,
     /* 395181 */   // GIR_Coverage, 8796,
     /* 395181 */   GIR_Done,
     /* 395182 */ // Label 8156: @395182
     /* 395182 */ GIM_Reject,
     /* 395183 */ // Label 8128: @395183
     /* 395183 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(395229),
     /* 395188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 395194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395198 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(395213), // Rule ID 8791 //
     /* 395203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395206 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 395206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395211 */     GIR_RootConstrainSelectedInstOperands,
     /* 395212 */     // GIR_Coverage, 8791,
     /* 395212 */     GIR_Done,
     /* 395213 */   // Label 8158: @395213
     /* 395213 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(395228), // Rule ID 8797 //
     /* 395218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395221 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 395221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395226 */     GIR_RootConstrainSelectedInstOperands,
     /* 395227 */     // GIR_Coverage, 8797,
     /* 395227 */     GIR_Done,
     /* 395228 */   // Label 8159: @395228
     /* 395228 */   GIM_Reject,
     /* 395229 */ // Label 8157: @395229
     /* 395229 */ GIM_Reject,
     /* 395230 */ // Label 8129: @395230
     /* 395230 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(395255), // Rule ID 8811 //
     /* 395235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 395241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 395244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395248 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 395248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 395253 */   GIR_RootConstrainSelectedInstOperands,
     /* 395254 */   // GIR_Coverage, 8811,
     /* 395254 */   GIR_Done,
     /* 395255 */ // Label 8160: @395255
     /* 395255 */ GIM_Reject,
     /* 395256 */ // Label 8130: @395256
     /* 395256 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(395281), // Rule ID 8793 //
     /* 395261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 395267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 395270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395274 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 395274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395279 */   GIR_RootConstrainSelectedInstOperands,
     /* 395280 */   // GIR_Coverage, 8793,
     /* 395280 */   GIR_Done,
     /* 395281 */ // Label 8161: @395281
     /* 395281 */ GIM_Reject,
     /* 395282 */ // Label 8131: @395282
     /* 395282 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(395328),
     /* 395287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 395293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395297 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(395312), // Rule ID 8790 //
     /* 395302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395305 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 395305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395310 */     GIR_RootConstrainSelectedInstOperands,
     /* 395311 */     // GIR_Coverage, 8790,
     /* 395311 */     GIR_Done,
     /* 395312 */   // Label 8163: @395312
     /* 395312 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(395327), // Rule ID 8794 //
     /* 395317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395320 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 395320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395325 */     GIR_RootConstrainSelectedInstOperands,
     /* 395326 */     // GIR_Coverage, 8794,
     /* 395326 */     GIR_Done,
     /* 395327 */   // Label 8164: @395327
     /* 395327 */   GIM_Reject,
     /* 395328 */ // Label 8162: @395328
     /* 395328 */ GIM_Reject,
     /* 395329 */ // Label 8132: @395329
     /* 395329 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(395354), // Rule ID 8810 //
     /* 395334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 395340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 395343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395347 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 395347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 395352 */   GIR_RootConstrainSelectedInstOperands,
     /* 395353 */   // GIR_Coverage, 8810,
     /* 395353 */   GIR_Done,
     /* 395354 */ // Label 8165: @395354
     /* 395354 */ GIM_Reject,
     /* 395355 */ // Label 8133: @395355
     /* 395355 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(395401),
     /* 395360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 395363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395370 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(395385), // Rule ID 8789 //
     /* 395375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395378 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 395378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 395383 */     GIR_RootConstrainSelectedInstOperands,
     /* 395384 */     // GIR_Coverage, 8789,
     /* 395384 */     GIR_Done,
     /* 395385 */   // Label 8167: @395385
     /* 395385 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(395400), // Rule ID 8792 //
     /* 395390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395393 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 395393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 395398 */     GIR_RootConstrainSelectedInstOperands,
     /* 395399 */     // GIR_Coverage, 8792,
     /* 395399 */     GIR_Done,
     /* 395400 */   // Label 8168: @395400
     /* 395400 */   GIM_Reject,
     /* 395401 */ // Label 8166: @395401
     /* 395401 */ GIM_Reject,
     /* 395402 */ // Label 8134: @395402
     /* 395402 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(395427), // Rule ID 2409 //
     /* 395407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 395413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 395416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395420 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 395420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 395425 */   GIR_RootConstrainSelectedInstOperands,
     /* 395426 */   // GIR_Coverage, 2409,
     /* 395426 */   GIR_Done,
     /* 395427 */ // Label 8169: @395427
     /* 395427 */ GIM_Reject,
     /* 395428 */ // Label 8135: @395428
     /* 395428 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(395453), // Rule ID 8788 //
     /* 395433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395446 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 395446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 395451 */   GIR_RootConstrainSelectedInstOperands,
     /* 395452 */   // GIR_Coverage, 8788,
     /* 395452 */   GIR_Done,
     /* 395453 */ // Label 8170: @395453
     /* 395453 */ GIM_Reject,
     /* 395454 */ // Label 8136: @395454
     /* 395454 */ GIM_Reject,
     /* 395455 */ // Label 143: @395455
     /* 395455 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8177*/ GIMT_Encode4(395660),
     /* 395466 */ /*GILLT_s64*//*Label 8171*/ GIMT_Encode4(395498), GIMT_Encode4(0),
     /* 395474 */ /*GILLT_v2s32*//*Label 8172*/ GIMT_Encode4(395525),
     /* 395478 */ /*GILLT_v2s64*//*Label 8173*/ GIMT_Encode4(395552),
     /* 395482 */ /*GILLT_v4s16*//*Label 8174*/ GIMT_Encode4(395579),
     /* 395486 */ /*GILLT_v4s32*//*Label 8175*/ GIMT_Encode4(395606), GIMT_Encode4(0),
     /* 395494 */ /*GILLT_v8s16*//*Label 8176*/ GIMT_Encode4(395633),
     /* 395498 */ // Label 8171: @395498
     /* 395498 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(395524), // Rule ID 1062 //
     /* 395503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395517 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 395517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 395522 */   GIR_RootConstrainSelectedInstOperands,
     /* 395523 */   // GIR_Coverage, 1062,
     /* 395523 */   GIR_Done,
     /* 395524 */ // Label 8178: @395524
     /* 395524 */ GIM_Reject,
     /* 395525 */ // Label 8172: @395525
     /* 395525 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(395551), // Rule ID 1058 //
     /* 395530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395544 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 395544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 395549 */   GIR_RootConstrainSelectedInstOperands,
     /* 395550 */   // GIR_Coverage, 1058,
     /* 395550 */   GIR_Done,
     /* 395551 */ // Label 8179: @395551
     /* 395551 */ GIM_Reject,
     /* 395552 */ // Label 8173: @395552
     /* 395552 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(395578), // Rule ID 1064 //
     /* 395557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395571 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 395571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 395576 */   GIR_RootConstrainSelectedInstOperands,
     /* 395577 */   // GIR_Coverage, 1064,
     /* 395577 */   GIR_Done,
     /* 395578 */ // Label 8180: @395578
     /* 395578 */ GIM_Reject,
     /* 395579 */ // Label 8174: @395579
     /* 395579 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(395605), // Rule ID 1054 //
     /* 395584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395598 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 395598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 395603 */   GIR_RootConstrainSelectedInstOperands,
     /* 395604 */   // GIR_Coverage, 1054,
     /* 395604 */   GIR_Done,
     /* 395605 */ // Label 8181: @395605
     /* 395605 */ GIM_Reject,
     /* 395606 */ // Label 8175: @395606
     /* 395606 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(395632), // Rule ID 1060 //
     /* 395611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395625 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 395625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 395630 */   GIR_RootConstrainSelectedInstOperands,
     /* 395631 */   // GIR_Coverage, 1060,
     /* 395631 */   GIR_Done,
     /* 395632 */ // Label 8182: @395632
     /* 395632 */ GIM_Reject,
     /* 395633 */ // Label 8176: @395633
     /* 395633 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(395659), // Rule ID 1056 //
     /* 395638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395652 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 395652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 395657 */   GIR_RootConstrainSelectedInstOperands,
     /* 395658 */   // GIR_Coverage, 1056,
     /* 395658 */   GIR_Done,
     /* 395659 */ // Label 8183: @395659
     /* 395659 */ GIM_Reject,
     /* 395660 */ // Label 8177: @395660
     /* 395660 */ GIM_Reject,
     /* 395661 */ // Label 144: @395661
     /* 395661 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8186*/ GIMT_Encode4(396527),
     /* 395672 */ /*GILLT_v2s64*//*Label 8184*/ GIMT_Encode4(395684), GIMT_Encode4(0),
     /* 395680 */ /*GILLT_v4s32*//*Label 8185*/ GIMT_Encode4(395978),
     /* 395684 */ // Label 8184: @395684
     /* 395684 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(395766), // Rule ID 5772 //
     /* 395689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 395704 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 395707 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 395712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395723 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 395723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 395726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 395730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 395739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 395755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395765 */   // GIR_Coverage, 5772,
     /* 395765 */   GIR_EraseRootFromParent_Done,
     /* 395766 */ // Label 8187: @395766
     /* 395766 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(395840), // Rule ID 5771 //
     /* 395771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 395786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395790 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395795 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395797 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 395797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 395800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 395804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395809 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 395813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 395829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395839 */   // GIR_Coverage, 5771,
     /* 395839 */   GIR_EraseRootFromParent_Done,
     /* 395840 */ // Label 8188: @395840
     /* 395840 */ GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(395899), // Rule ID 5781 //
     /* 395845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395856 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 395856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 395863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395868 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 395888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395898 */   // GIR_Coverage, 5781,
     /* 395898 */   GIR_EraseRootFromParent_Done,
     /* 395899 */ // Label 8189: @395899
     /* 395899 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(395977), // Rule ID 5909 //
     /* 395904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395915 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 395915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 395918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 395922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395927 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 395936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 395958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 395961 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395976 */   // GIR_Coverage, 5909,
     /* 395976 */   GIR_EraseRootFromParent_Done,
     /* 395977 */ // Label 8190: @395977
     /* 395977 */ GIM_Reject,
     /* 395978 */ // Label 8185: @395978
     /* 395978 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(396060), // Rule ID 5774 //
     /* 395983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395990 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 395998 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396001 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396006 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396010 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396015 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396017 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 396017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396029 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396059 */   // GIR_Coverage, 5774,
     /* 396059 */   GIR_EraseRootFromParent_Done,
     /* 396060 */ // Label 8191: @396060
     /* 396060 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(396142), // Rule ID 5776 //
     /* 396065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396080 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396083 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396088 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396092 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396097 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396099 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 396099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396111 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396141 */   // GIR_Coverage, 5776,
     /* 396141 */   GIR_EraseRootFromParent_Done,
     /* 396142 */ // Label 8192: @396142
     /* 396142 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(396216), // Rule ID 5773 //
     /* 396147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396162 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396166 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396173 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 396173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396185 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396210 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396215 */   // GIR_Coverage, 5773,
     /* 396215 */   GIR_EraseRootFromParent_Done,
     /* 396216 */ // Label 8193: @396216
     /* 396216 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(396290), // Rule ID 5775 //
     /* 396221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396236 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396240 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396247 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 396247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396289 */   // GIR_Coverage, 5775,
     /* 396289 */   GIR_EraseRootFromParent_Done,
     /* 396290 */ // Label 8194: @396290
     /* 396290 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(396349), // Rule ID 5777 //
     /* 396295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396306 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 396306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396338 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396348 */   // GIR_Coverage, 5777,
     /* 396348 */   GIR_EraseRootFromParent_Done,
     /* 396349 */ // Label 8195: @396349
     /* 396349 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(396408), // Rule ID 5778 //
     /* 396354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396365 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 396365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 396372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396377 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396407 */   // GIR_Coverage, 5778,
     /* 396407 */   GIR_EraseRootFromParent_Done,
     /* 396408 */ // Label 8196: @396408
     /* 396408 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(396467), // Rule ID 5779 //
     /* 396413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396424 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 396424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396466 */   // GIR_Coverage, 5779,
     /* 396466 */   GIR_EraseRootFromParent_Done,
     /* 396467 */ // Label 8197: @396467
     /* 396467 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(396526), // Rule ID 5780 //
     /* 396472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396483 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 396483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 396490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396525 */   // GIR_Coverage, 5780,
     /* 396525 */   GIR_EraseRootFromParent_Done,
     /* 396526 */ // Label 8198: @396526
     /* 396526 */ GIM_Reject,
     /* 396527 */ // Label 8186: @396527
     /* 396527 */ GIM_Reject,
     /* 396528 */ // Label 145: @396528
     /* 396528 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8203*/ GIMT_Encode4(396897),
     /* 396539 */ /*GILLT_v2s32*//*Label 8199*/ GIMT_Encode4(396599), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396551 */ /*GILLT_v4s32*//*Label 8200*/ GIMT_Encode4(396719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396583 */ /*GILLT_nxv2s64*//*Label 8201*/ GIMT_Encode4(396839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396595 */ /*GILLT_nxv4s32*//*Label 8202*/ GIMT_Encode4(396868),
     /* 396599 */ // Label 8199: @396599
     /* 396599 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(396718),
     /* 396604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 396613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396625 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(396698), // Rule ID 28 //
     /* 396630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 396637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 396641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 396653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396678 */     // MIs[3] Operand 1
     /* 396678 */     // No operand predicates
     /* 396678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396680 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 396683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 396687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396696 */     GIR_RootConstrainSelectedInstOperands,
     /* 396697 */     // GIR_Coverage, 28,
     /* 396697 */     GIR_EraseRootFromParent_Done,
     /* 396698 */   // Label 8205: @396698
     /* 396698 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(396717), // Rule ID 24 //
     /* 396703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396710 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 396710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 396715 */     GIR_RootConstrainSelectedInstOperands,
     /* 396716 */     // GIR_Coverage, 24,
     /* 396716 */     GIR_Done,
     /* 396717 */   // Label 8206: @396717
     /* 396717 */   GIM_Reject,
     /* 396718 */ // Label 8204: @396718
     /* 396718 */ GIM_Reject,
     /* 396719 */ // Label 8200: @396719
     /* 396719 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(396838),
     /* 396724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 396733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396745 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(396818), // Rule ID 29 //
     /* 396750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 396757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 396761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 396773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396794 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396798 */     // MIs[3] Operand 1
     /* 396798 */     // No operand predicates
     /* 396798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396800 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 396803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 396807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396816 */     GIR_RootConstrainSelectedInstOperands,
     /* 396817 */     // GIR_Coverage, 29,
     /* 396817 */     GIR_EraseRootFromParent_Done,
     /* 396818 */   // Label 8208: @396818
     /* 396818 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(396837), // Rule ID 25 //
     /* 396823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396830 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 396830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 396835 */     GIR_RootConstrainSelectedInstOperands,
     /* 396836 */     // GIR_Coverage, 25,
     /* 396836 */     GIR_Done,
     /* 396837 */   // Label 8209: @396837
     /* 396837 */   GIM_Reject,
     /* 396838 */ // Label 8207: @396838
     /* 396838 */ GIM_Reject,
     /* 396839 */ // Label 8201: @396839
     /* 396839 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(396867), // Rule ID 7499 //
     /* 396844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 396847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 396850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 396853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 396856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396860 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 396860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 396865 */   GIR_RootConstrainSelectedInstOperands,
     /* 396866 */   // GIR_Coverage, 7499,
     /* 396866 */   GIR_Done,
     /* 396867 */ // Label 8210: @396867
     /* 396867 */ GIM_Reject,
     /* 396868 */ // Label 8202: @396868
     /* 396868 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(396896), // Rule ID 7498 //
     /* 396873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 396876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 396879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 396882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 396885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396889 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 396889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 396894 */   GIR_RootConstrainSelectedInstOperands,
     /* 396895 */   // GIR_Coverage, 7498,
     /* 396895 */   GIR_Done,
     /* 396896 */ // Label 8211: @396896
     /* 396896 */ GIM_Reject,
     /* 396897 */ // Label 8203: @396897
     /* 396897 */ GIM_Reject,
     /* 396898 */ // Label 146: @396898
     /* 396898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8215*/ GIMT_Encode4(397014),
     /* 396909 */ /*GILLT_s16*//*Label 8212*/ GIMT_Encode4(396921),
     /* 396913 */ /*GILLT_s32*//*Label 8213*/ GIMT_Encode4(396952),
     /* 396917 */ /*GILLT_s64*//*Label 8214*/ GIMT_Encode4(396983),
     /* 396921 */ // Label 8212: @396921
     /* 396921 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(396951), // Rule ID 1662 //
     /* 396926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 396929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396940 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 396945 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396949 */   GIR_RootConstrainSelectedInstOperands,
     /* 396950 */   // GIR_Coverage, 1662,
     /* 396950 */   GIR_Done,
     /* 396951 */ // Label 8216: @396951
     /* 396951 */ GIM_Reject,
     /* 396952 */ // Label 8213: @396952
     /* 396952 */ GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(396982), // Rule ID 1661 //
     /* 396957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 396960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396971 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 396976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396980 */   GIR_RootConstrainSelectedInstOperands,
     /* 396981 */   // GIR_Coverage, 1661,
     /* 396981 */   GIR_Done,
     /* 396982 */ // Label 8217: @396982
     /* 396982 */ GIM_Reject,
     /* 396983 */ // Label 8214: @396983
     /* 396983 */ GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(397013), // Rule ID 1660 //
     /* 396988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 396991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397002 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 397002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 397007 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397011 */   GIR_RootConstrainSelectedInstOperands,
     /* 397012 */   // GIR_Coverage, 1660,
     /* 397012 */   GIR_Done,
     /* 397013 */ // Label 8218: @397013
     /* 397013 */ GIM_Reject,
     /* 397014 */ // Label 8215: @397014
     /* 397014 */ GIM_Reject,
     /* 397015 */ // Label 147: @397015
     /* 397015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8222*/ GIMT_Encode4(398247),
     /* 397026 */ /*GILLT_v2s64*//*Label 8219*/ GIMT_Encode4(397046), GIMT_Encode4(0),
     /* 397034 */ /*GILLT_v4s32*//*Label 8220*/ GIMT_Encode4(397607), GIMT_Encode4(0),
     /* 397042 */ /*GILLT_v8s16*//*Label 8221*/ GIMT_Encode4(398168),
     /* 397046 */ // Label 8219: @397046
     /* 397046 */ GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(397606),
     /* 397051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397061 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(397153), // Rule ID 2099 //
     /* 397066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397110 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397114 */     // MIs[3] Operand 1
     /* 397114 */     // No operand predicates
     /* 397114 */     // MIs[1] Operand 2
     /* 397114 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 397125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397134 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 397137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397151 */     GIR_RootConstrainSelectedInstOperands,
     /* 397152 */     // GIR_Coverage, 2099,
     /* 397152 */     GIR_EraseRootFromParent_Done,
     /* 397153 */   // Label 8224: @397153
     /* 397153 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(397245), // Rule ID 13243 //
     /* 397158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397202 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397206 */     // MIs[3] Operand 1
     /* 397206 */     // No operand predicates
     /* 397206 */     // MIs[1] Operand 2
     /* 397206 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 397217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397226 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 397229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397243 */     GIR_RootConstrainSelectedInstOperands,
     /* 397244 */     // GIR_Coverage, 13243,
     /* 397244 */     GIR_EraseRootFromParent_Done,
     /* 397245 */   // Label 8225: @397245
     /* 397245 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(397331), // Rule ID 13241 //
     /* 397250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397298 */     // MIs[3] Operand 1
     /* 397298 */     // No operand predicates
     /* 397298 */     // MIs[1] Operand 2
     /* 397298 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397315 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397329 */     GIR_RootConstrainSelectedInstOperands,
     /* 397330 */     // GIR_Coverage, 13241,
     /* 397330 */     GIR_EraseRootFromParent_Done,
     /* 397331 */   // Label 8226: @397331
     /* 397331 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(397417), // Rule ID 2097 //
     /* 397336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397384 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397388 */     // MIs[3] Operand 1
     /* 397388 */     // No operand predicates
     /* 397388 */     // MIs[1] Operand 2
     /* 397388 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397401 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397415 */     GIR_RootConstrainSelectedInstOperands,
     /* 397416 */     // GIR_Coverage, 2097,
     /* 397416 */     GIR_EraseRootFromParent_Done,
     /* 397417 */   // Label 8227: @397417
     /* 397417 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(397456), // Rule ID 1824 //
     /* 397422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397439 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 397439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 397442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 397454 */     GIR_RootConstrainSelectedInstOperands,
     /* 397455 */     // GIR_Coverage, 1824,
     /* 397455 */     GIR_EraseRootFromParent_Done,
     /* 397456 */   // Label 8228: @397456
     /* 397456 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(397519), // Rule ID 13242 //
     /* 397461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397497 */     // MIs[2] Operand 1
     /* 397497 */     // No operand predicates
     /* 397497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397503 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397517 */     GIR_RootConstrainSelectedInstOperands,
     /* 397518 */     // GIR_Coverage, 13242,
     /* 397518 */     GIR_EraseRootFromParent_Done,
     /* 397519 */   // Label 8229: @397519
     /* 397519 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(397582), // Rule ID 2098 //
     /* 397524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397564 */     // MIs[2] Operand 1
     /* 397564 */     // No operand predicates
     /* 397564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397566 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397580 */     GIR_RootConstrainSelectedInstOperands,
     /* 397581 */     // GIR_Coverage, 2098,
     /* 397581 */     GIR_EraseRootFromParent_Done,
     /* 397582 */   // Label 8230: @397582
     /* 397582 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(397605), // Rule ID 1823 //
     /* 397587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397598 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 397598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 397603 */     GIR_RootConstrainSelectedInstOperands,
     /* 397604 */     // GIR_Coverage, 1823,
     /* 397604 */     GIR_Done,
     /* 397605 */   // Label 8231: @397605
     /* 397605 */   GIM_Reject,
     /* 397606 */ // Label 8223: @397606
     /* 397606 */ GIM_Reject,
     /* 397607 */ // Label 8220: @397607
     /* 397607 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(398167),
     /* 397612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397622 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(397714), // Rule ID 2096 //
     /* 397627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397671 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397675 */     // MIs[3] Operand 1
     /* 397675 */     // No operand predicates
     /* 397675 */     // MIs[1] Operand 2
     /* 397675 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 397686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 397695 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 397698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397712 */     GIR_RootConstrainSelectedInstOperands,
     /* 397713 */     // GIR_Coverage, 2096,
     /* 397713 */     GIR_EraseRootFromParent_Done,
     /* 397714 */   // Label 8233: @397714
     /* 397714 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(397806), // Rule ID 13240 //
     /* 397719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397767 */     // MIs[3] Operand 1
     /* 397767 */     // No operand predicates
     /* 397767 */     // MIs[1] Operand 2
     /* 397767 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 397778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 397787 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 397790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397804 */     GIR_RootConstrainSelectedInstOperands,
     /* 397805 */     // GIR_Coverage, 13240,
     /* 397805 */     GIR_EraseRootFromParent_Done,
     /* 397806 */   // Label 8234: @397806
     /* 397806 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(397892), // Rule ID 13238 //
     /* 397811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397855 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397859 */     // MIs[3] Operand 1
     /* 397859 */     // No operand predicates
     /* 397859 */     // MIs[1] Operand 2
     /* 397859 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397876 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 397879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397890 */     GIR_RootConstrainSelectedInstOperands,
     /* 397891 */     // GIR_Coverage, 13238,
     /* 397891 */     GIR_EraseRootFromParent_Done,
     /* 397892 */   // Label 8235: @397892
     /* 397892 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(397978), // Rule ID 2094 //
     /* 397897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397945 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397949 */     // MIs[3] Operand 1
     /* 397949 */     // No operand predicates
     /* 397949 */     // MIs[1] Operand 2
     /* 397949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397962 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 397965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397976 */     GIR_RootConstrainSelectedInstOperands,
     /* 397977 */     // GIR_Coverage, 2094,
     /* 397977 */     GIR_EraseRootFromParent_Done,
     /* 397978 */   // Label 8236: @397978
     /* 397978 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(398017), // Rule ID 1822 //
     /* 397983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 397993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398000 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 398000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 398003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 398015 */     GIR_RootConstrainSelectedInstOperands,
     /* 398016 */     // GIR_Coverage, 1822,
     /* 398016 */     GIR_EraseRootFromParent_Done,
     /* 398017 */   // Label 8237: @398017
     /* 398017 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(398080), // Rule ID 13239 //
     /* 398022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398058 */     // MIs[2] Operand 1
     /* 398058 */     // No operand predicates
     /* 398058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398064 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398078 */     GIR_RootConstrainSelectedInstOperands,
     /* 398079 */     // GIR_Coverage, 13239,
     /* 398079 */     GIR_EraseRootFromParent_Done,
     /* 398080 */   // Label 8238: @398080
     /* 398080 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(398143), // Rule ID 2095 //
     /* 398085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398125 */     // MIs[2] Operand 1
     /* 398125 */     // No operand predicates
     /* 398125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398127 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398141 */     GIR_RootConstrainSelectedInstOperands,
     /* 398142 */     // GIR_Coverage, 2095,
     /* 398142 */     GIR_EraseRootFromParent_Done,
     /* 398143 */   // Label 8239: @398143
     /* 398143 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(398166), // Rule ID 1821 //
     /* 398148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398159 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 398164 */     GIR_RootConstrainSelectedInstOperands,
     /* 398165 */     // GIR_Coverage, 1821,
     /* 398165 */     GIR_Done,
     /* 398166 */   // Label 8240: @398166
     /* 398166 */   GIM_Reject,
     /* 398167 */ // Label 8232: @398167
     /* 398167 */ GIM_Reject,
     /* 398168 */ // Label 8221: @398168
     /* 398168 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(398246),
     /* 398173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398183 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(398222), // Rule ID 1820 //
     /* 398188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 398198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 398205 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 398205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 398208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 398220 */     GIR_RootConstrainSelectedInstOperands,
     /* 398221 */     // GIR_Coverage, 1820,
     /* 398221 */     GIR_EraseRootFromParent_Done,
     /* 398222 */   // Label 8242: @398222
     /* 398222 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(398245), // Rule ID 1819 //
     /* 398227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398238 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 398238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 398243 */     GIR_RootConstrainSelectedInstOperands,
     /* 398244 */     // GIR_Coverage, 1819,
     /* 398244 */     GIR_Done,
     /* 398245 */   // Label 8243: @398245
     /* 398245 */   GIM_Reject,
     /* 398246 */ // Label 8241: @398246
     /* 398246 */ GIM_Reject,
     /* 398247 */ // Label 8222: @398247
     /* 398247 */ GIM_Reject,
     /* 398248 */ // Label 148: @398248
     /* 398248 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8262*/ GIMT_Encode4(399027),
     /* 398259 */ /*GILLT_v2s32*//*Label 8244*/ GIMT_Encode4(398335),
     /* 398263 */ /*GILLT_v2s64*//*Label 8245*/ GIMT_Encode4(398390),
     /* 398267 */ /*GILLT_v4s16*//*Label 8246*/ GIMT_Encode4(398445),
     /* 398271 */ /*GILLT_v4s32*//*Label 8247*/ GIMT_Encode4(398500),
     /* 398275 */ /*GILLT_v8s8*//*Label 8248*/ GIMT_Encode4(398555),
     /* 398279 */ /*GILLT_v8s16*//*Label 8249*/ GIMT_Encode4(398589),
     /* 398283 */ /*GILLT_v16s8*//*Label 8250*/ GIMT_Encode4(398644), GIMT_Encode4(0),
     /* 398291 */ /*GILLT_nxv2s1*//*Label 8251*/ GIMT_Encode4(398678),
     /* 398295 */ /*GILLT_nxv2s16*//*Label 8252*/ GIMT_Encode4(398704),
     /* 398299 */ /*GILLT_nxv2s32*//*Label 8253*/ GIMT_Encode4(398730),
     /* 398303 */ /*GILLT_nxv2s64*//*Label 8254*/ GIMT_Encode4(398756),
     /* 398307 */ /*GILLT_nxv4s1*//*Label 8255*/ GIMT_Encode4(398803),
     /* 398311 */ /*GILLT_nxv4s16*//*Label 8256*/ GIMT_Encode4(398829),
     /* 398315 */ /*GILLT_nxv4s32*//*Label 8257*/ GIMT_Encode4(398855),
     /* 398319 */ /*GILLT_nxv8s1*//*Label 8258*/ GIMT_Encode4(398902),
     /* 398323 */ /*GILLT_nxv8s16*//*Label 8259*/ GIMT_Encode4(398928),
     /* 398327 */ /*GILLT_nxv16s1*//*Label 8260*/ GIMT_Encode4(398975),
     /* 398331 */ /*GILLT_nxv16s8*//*Label 8261*/ GIMT_Encode4(399001),
     /* 398335 */ // Label 8244: @398335
     /* 398335 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(398389),
     /* 398340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398358 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(398373), // Rule ID 1881 //
     /* 398363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398366 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 398366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 398371 */     GIR_RootConstrainSelectedInstOperands,
     /* 398372 */     // GIR_Coverage, 1881,
     /* 398372 */     GIR_Done,
     /* 398373 */   // Label 8264: @398373
     /* 398373 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(398388), // Rule ID 5410 //
     /* 398378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398381 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 398386 */     GIR_RootConstrainSelectedInstOperands,
     /* 398387 */     // GIR_Coverage, 5410,
     /* 398387 */     GIR_Done,
     /* 398388 */   // Label 8265: @398388
     /* 398388 */   GIM_Reject,
     /* 398389 */ // Label 8263: @398389
     /* 398389 */ GIM_Reject,
     /* 398390 */ // Label 8245: @398390
     /* 398390 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(398444),
     /* 398395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398413 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(398428), // Rule ID 1883 //
     /* 398418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398421 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 398421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 398426 */     GIR_RootConstrainSelectedInstOperands,
     /* 398427 */     // GIR_Coverage, 1883,
     /* 398427 */     GIR_Done,
     /* 398428 */   // Label 8267: @398428
     /* 398428 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(398443), // Rule ID 5412 //
     /* 398433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398436 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 398441 */     GIR_RootConstrainSelectedInstOperands,
     /* 398442 */     // GIR_Coverage, 5412,
     /* 398442 */     GIR_Done,
     /* 398443 */   // Label 8268: @398443
     /* 398443 */   GIM_Reject,
     /* 398444 */ // Label 8266: @398444
     /* 398444 */ GIM_Reject,
     /* 398445 */ // Label 8246: @398445
     /* 398445 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(398499),
     /* 398450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398468 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(398483), // Rule ID 1879 //
     /* 398473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398476 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 398481 */     GIR_RootConstrainSelectedInstOperands,
     /* 398482 */     // GIR_Coverage, 1879,
     /* 398482 */     GIR_Done,
     /* 398483 */   // Label 8270: @398483
     /* 398483 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(398498), // Rule ID 5408 //
     /* 398488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398491 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 398496 */     GIR_RootConstrainSelectedInstOperands,
     /* 398497 */     // GIR_Coverage, 5408,
     /* 398497 */     GIR_Done,
     /* 398498 */   // Label 8271: @398498
     /* 398498 */   GIM_Reject,
     /* 398499 */ // Label 8269: @398499
     /* 398499 */ GIM_Reject,
     /* 398500 */ // Label 8247: @398500
     /* 398500 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(398554),
     /* 398505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398523 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(398538), // Rule ID 1882 //
     /* 398528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398531 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 398531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 398536 */     GIR_RootConstrainSelectedInstOperands,
     /* 398537 */     // GIR_Coverage, 1882,
     /* 398537 */     GIR_Done,
     /* 398538 */   // Label 8273: @398538
     /* 398538 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(398553), // Rule ID 5411 //
     /* 398543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398546 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 398546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 398551 */     GIR_RootConstrainSelectedInstOperands,
     /* 398552 */     // GIR_Coverage, 5411,
     /* 398552 */     GIR_Done,
     /* 398553 */   // Label 8274: @398553
     /* 398553 */   GIM_Reject,
     /* 398554 */ // Label 8272: @398554
     /* 398554 */ GIM_Reject,
     /* 398555 */ // Label 8248: @398555
     /* 398555 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(398588), // Rule ID 1877 //
     /* 398560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398581 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 398581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 398586 */   GIR_RootConstrainSelectedInstOperands,
     /* 398587 */   // GIR_Coverage, 1877,
     /* 398587 */   GIR_Done,
     /* 398588 */ // Label 8275: @398588
     /* 398588 */ GIM_Reject,
     /* 398589 */ // Label 8249: @398589
     /* 398589 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(398643),
     /* 398594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398612 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(398627), // Rule ID 1880 //
     /* 398617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398620 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 398620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 398625 */     GIR_RootConstrainSelectedInstOperands,
     /* 398626 */     // GIR_Coverage, 1880,
     /* 398626 */     GIR_Done,
     /* 398627 */   // Label 8277: @398627
     /* 398627 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(398642), // Rule ID 5409 //
     /* 398632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398635 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 398635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 398640 */     GIR_RootConstrainSelectedInstOperands,
     /* 398641 */     // GIR_Coverage, 5409,
     /* 398641 */     GIR_Done,
     /* 398642 */   // Label 8278: @398642
     /* 398642 */   GIM_Reject,
     /* 398643 */ // Label 8276: @398643
     /* 398643 */ GIM_Reject,
     /* 398644 */ // Label 8250: @398644
     /* 398644 */ GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(398677), // Rule ID 1878 //
     /* 398649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 398658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398670 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 398670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 398675 */   GIR_RootConstrainSelectedInstOperands,
     /* 398676 */   // GIR_Coverage, 1878,
     /* 398676 */   GIR_Done,
     /* 398677 */ // Label 8279: @398677
     /* 398677 */ GIM_Reject,
     /* 398678 */ // Label 8251: @398678
     /* 398678 */ GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(398703), // Rule ID 8803 //
     /* 398683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 398689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 398692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398696 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 398696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 398701 */   GIR_RootConstrainSelectedInstOperands,
     /* 398702 */   // GIR_Coverage, 8803,
     /* 398702 */   GIR_Done,
     /* 398703 */ // Label 8280: @398703
     /* 398703 */ GIM_Reject,
     /* 398704 */ // Label 8252: @398704
     /* 398704 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(398729), // Rule ID 8765 //
     /* 398709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 398715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 398718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398722 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 398722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398727 */   GIR_RootConstrainSelectedInstOperands,
     /* 398728 */   // GIR_Coverage, 8765,
     /* 398728 */   GIR_Done,
     /* 398729 */ // Label 8281: @398729
     /* 398729 */ GIM_Reject,
     /* 398730 */ // Label 8253: @398730
     /* 398730 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(398755), // Rule ID 8766 //
     /* 398735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 398741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 398744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398748 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 398748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398753 */   GIR_RootConstrainSelectedInstOperands,
     /* 398754 */   // GIR_Coverage, 8766,
     /* 398754 */   GIR_Done,
     /* 398755 */ // Label 8282: @398755
     /* 398755 */ GIM_Reject,
     /* 398756 */ // Label 8254: @398756
     /* 398756 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(398802),
     /* 398761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 398764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 398767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398771 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(398786), // Rule ID 8761 //
     /* 398776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398779 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 398779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398784 */     GIR_RootConstrainSelectedInstOperands,
     /* 398785 */     // GIR_Coverage, 8761,
     /* 398785 */     GIR_Done,
     /* 398786 */   // Label 8284: @398786
     /* 398786 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(398801), // Rule ID 8767 //
     /* 398791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398794 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 398794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398799 */     GIR_RootConstrainSelectedInstOperands,
     /* 398800 */     // GIR_Coverage, 8767,
     /* 398800 */     GIR_Done,
     /* 398801 */   // Label 8285: @398801
     /* 398801 */   GIM_Reject,
     /* 398802 */ // Label 8283: @398802
     /* 398802 */ GIM_Reject,
     /* 398803 */ // Label 8255: @398803
     /* 398803 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(398828), // Rule ID 8802 //
     /* 398808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 398814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 398817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398821 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 398821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 398826 */   GIR_RootConstrainSelectedInstOperands,
     /* 398827 */   // GIR_Coverage, 8802,
     /* 398827 */   GIR_Done,
     /* 398828 */ // Label 8286: @398828
     /* 398828 */ GIM_Reject,
     /* 398829 */ // Label 8256: @398829
     /* 398829 */ GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(398854), // Rule ID 8763 //
     /* 398834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 398840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 398843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398847 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 398847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 398852 */   GIR_RootConstrainSelectedInstOperands,
     /* 398853 */   // GIR_Coverage, 8763,
     /* 398853 */   GIR_Done,
     /* 398854 */ // Label 8287: @398854
     /* 398854 */ GIM_Reject,
     /* 398855 */ // Label 8257: @398855
     /* 398855 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(398901),
     /* 398860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 398863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 398866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398870 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(398885), // Rule ID 8760 //
     /* 398875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398878 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 398878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 398883 */     GIR_RootConstrainSelectedInstOperands,
     /* 398884 */     // GIR_Coverage, 8760,
     /* 398884 */     GIR_Done,
     /* 398885 */   // Label 8289: @398885
     /* 398885 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(398900), // Rule ID 8764 //
     /* 398890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398893 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 398893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 398898 */     GIR_RootConstrainSelectedInstOperands,
     /* 398899 */     // GIR_Coverage, 8764,
     /* 398899 */     GIR_Done,
     /* 398900 */   // Label 8290: @398900
     /* 398900 */   GIM_Reject,
     /* 398901 */ // Label 8288: @398901
     /* 398901 */ GIM_Reject,
     /* 398902 */ // Label 8258: @398902
     /* 398902 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(398927), // Rule ID 8801 //
     /* 398907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 398913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 398916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398920 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 398920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 398925 */   GIR_RootConstrainSelectedInstOperands,
     /* 398926 */   // GIR_Coverage, 8801,
     /* 398926 */   GIR_Done,
     /* 398927 */ // Label 8291: @398927
     /* 398927 */ GIM_Reject,
     /* 398928 */ // Label 8259: @398928
     /* 398928 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(398974),
     /* 398933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 398936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 398939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398943 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(398958), // Rule ID 8759 //
     /* 398948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398951 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 398951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 398956 */     GIR_RootConstrainSelectedInstOperands,
     /* 398957 */     // GIR_Coverage, 8759,
     /* 398957 */     GIR_Done,
     /* 398958 */   // Label 8293: @398958
     /* 398958 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(398973), // Rule ID 8762 //
     /* 398963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398966 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 398966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 398971 */     GIR_RootConstrainSelectedInstOperands,
     /* 398972 */     // GIR_Coverage, 8762,
     /* 398972 */     GIR_Done,
     /* 398973 */   // Label 8294: @398973
     /* 398973 */   GIM_Reject,
     /* 398974 */ // Label 8292: @398974
     /* 398974 */ GIM_Reject,
     /* 398975 */ // Label 8260: @398975
     /* 398975 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(399000), // Rule ID 2397 //
     /* 398980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 398986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 398989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398993 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 398993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 398998 */   GIR_RootConstrainSelectedInstOperands,
     /* 398999 */   // GIR_Coverage, 2397,
     /* 398999 */   GIR_Done,
     /* 399000 */ // Label 8295: @399000
     /* 399000 */ GIM_Reject,
     /* 399001 */ // Label 8261: @399001
     /* 399001 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(399026), // Rule ID 8758 //
     /* 399006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399019 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 399019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 399024 */   GIR_RootConstrainSelectedInstOperands,
     /* 399025 */   // GIR_Coverage, 8758,
     /* 399025 */   GIR_Done,
     /* 399026 */ // Label 8296: @399026
     /* 399026 */ GIM_Reject,
     /* 399027 */ // Label 8262: @399027
     /* 399027 */ GIM_Reject,
     /* 399028 */ // Label 149: @399028
     /* 399028 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8315*/ GIMT_Encode4(399807),
     /* 399039 */ /*GILLT_v2s32*//*Label 8297*/ GIMT_Encode4(399115),
     /* 399043 */ /*GILLT_v2s64*//*Label 8298*/ GIMT_Encode4(399170),
     /* 399047 */ /*GILLT_v4s16*//*Label 8299*/ GIMT_Encode4(399225),
     /* 399051 */ /*GILLT_v4s32*//*Label 8300*/ GIMT_Encode4(399280),
     /* 399055 */ /*GILLT_v8s8*//*Label 8301*/ GIMT_Encode4(399335),
     /* 399059 */ /*GILLT_v8s16*//*Label 8302*/ GIMT_Encode4(399369),
     /* 399063 */ /*GILLT_v16s8*//*Label 8303*/ GIMT_Encode4(399424), GIMT_Encode4(0),
     /* 399071 */ /*GILLT_nxv2s1*//*Label 8304*/ GIMT_Encode4(399458),
     /* 399075 */ /*GILLT_nxv2s16*//*Label 8305*/ GIMT_Encode4(399484),
     /* 399079 */ /*GILLT_nxv2s32*//*Label 8306*/ GIMT_Encode4(399510),
     /* 399083 */ /*GILLT_nxv2s64*//*Label 8307*/ GIMT_Encode4(399536),
     /* 399087 */ /*GILLT_nxv4s1*//*Label 8308*/ GIMT_Encode4(399583),
     /* 399091 */ /*GILLT_nxv4s16*//*Label 8309*/ GIMT_Encode4(399609),
     /* 399095 */ /*GILLT_nxv4s32*//*Label 8310*/ GIMT_Encode4(399635),
     /* 399099 */ /*GILLT_nxv8s1*//*Label 8311*/ GIMT_Encode4(399682),
     /* 399103 */ /*GILLT_nxv8s16*//*Label 8312*/ GIMT_Encode4(399708),
     /* 399107 */ /*GILLT_nxv16s1*//*Label 8313*/ GIMT_Encode4(399755),
     /* 399111 */ /*GILLT_nxv16s8*//*Label 8314*/ GIMT_Encode4(399781),
     /* 399115 */ // Label 8297: @399115
     /* 399115 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(399169),
     /* 399120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399138 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(399153), // Rule ID 1888 //
     /* 399143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399146 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 399146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 399151 */     GIR_RootConstrainSelectedInstOperands,
     /* 399152 */     // GIR_Coverage, 1888,
     /* 399152 */     GIR_Done,
     /* 399153 */   // Label 8317: @399153
     /* 399153 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(399168), // Rule ID 5415 //
     /* 399158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399161 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 399166 */     GIR_RootConstrainSelectedInstOperands,
     /* 399167 */     // GIR_Coverage, 5415,
     /* 399167 */     GIR_Done,
     /* 399168 */   // Label 8318: @399168
     /* 399168 */   GIM_Reject,
     /* 399169 */ // Label 8316: @399169
     /* 399169 */ GIM_Reject,
     /* 399170 */ // Label 8298: @399170
     /* 399170 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(399224),
     /* 399175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399193 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(399208), // Rule ID 1890 //
     /* 399198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399201 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 399201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 399206 */     GIR_RootConstrainSelectedInstOperands,
     /* 399207 */     // GIR_Coverage, 1890,
     /* 399207 */     GIR_Done,
     /* 399208 */   // Label 8320: @399208
     /* 399208 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(399223), // Rule ID 5417 //
     /* 399213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399216 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 399221 */     GIR_RootConstrainSelectedInstOperands,
     /* 399222 */     // GIR_Coverage, 5417,
     /* 399222 */     GIR_Done,
     /* 399223 */   // Label 8321: @399223
     /* 399223 */   GIM_Reject,
     /* 399224 */ // Label 8319: @399224
     /* 399224 */ GIM_Reject,
     /* 399225 */ // Label 8299: @399225
     /* 399225 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(399279),
     /* 399230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399248 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(399263), // Rule ID 1886 //
     /* 399253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399256 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 399256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 399261 */     GIR_RootConstrainSelectedInstOperands,
     /* 399262 */     // GIR_Coverage, 1886,
     /* 399262 */     GIR_Done,
     /* 399263 */   // Label 8323: @399263
     /* 399263 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(399278), // Rule ID 5413 //
     /* 399268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399271 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 399276 */     GIR_RootConstrainSelectedInstOperands,
     /* 399277 */     // GIR_Coverage, 5413,
     /* 399277 */     GIR_Done,
     /* 399278 */   // Label 8324: @399278
     /* 399278 */   GIM_Reject,
     /* 399279 */ // Label 8322: @399279
     /* 399279 */ GIM_Reject,
     /* 399280 */ // Label 8300: @399280
     /* 399280 */ GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(399334),
     /* 399285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399303 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(399318), // Rule ID 1889 //
     /* 399308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399311 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 399311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 399316 */     GIR_RootConstrainSelectedInstOperands,
     /* 399317 */     // GIR_Coverage, 1889,
     /* 399317 */     GIR_Done,
     /* 399318 */   // Label 8326: @399318
     /* 399318 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(399333), // Rule ID 5416 //
     /* 399323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399326 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 399331 */     GIR_RootConstrainSelectedInstOperands,
     /* 399332 */     // GIR_Coverage, 5416,
     /* 399332 */     GIR_Done,
     /* 399333 */   // Label 8327: @399333
     /* 399333 */   GIM_Reject,
     /* 399334 */ // Label 8325: @399334
     /* 399334 */ GIM_Reject,
     /* 399335 */ // Label 8301: @399335
     /* 399335 */ GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(399368), // Rule ID 1884 //
     /* 399340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399361 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 399361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 399366 */   GIR_RootConstrainSelectedInstOperands,
     /* 399367 */   // GIR_Coverage, 1884,
     /* 399367 */   GIR_Done,
     /* 399368 */ // Label 8328: @399368
     /* 399368 */ GIM_Reject,
     /* 399369 */ // Label 8302: @399369
     /* 399369 */ GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(399423),
     /* 399374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399392 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(399407), // Rule ID 1887 //
     /* 399397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399400 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 399400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 399405 */     GIR_RootConstrainSelectedInstOperands,
     /* 399406 */     // GIR_Coverage, 1887,
     /* 399406 */     GIR_Done,
     /* 399407 */   // Label 8330: @399407
     /* 399407 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(399422), // Rule ID 5414 //
     /* 399412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399415 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 399420 */     GIR_RootConstrainSelectedInstOperands,
     /* 399421 */     // GIR_Coverage, 5414,
     /* 399421 */     GIR_Done,
     /* 399422 */   // Label 8331: @399422
     /* 399422 */   GIM_Reject,
     /* 399423 */ // Label 8329: @399423
     /* 399423 */ GIM_Reject,
     /* 399424 */ // Label 8303: @399424
     /* 399424 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(399457), // Rule ID 1885 //
     /* 399429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399450 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 399450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 399455 */   GIR_RootConstrainSelectedInstOperands,
     /* 399456 */   // GIR_Coverage, 1885,
     /* 399456 */   GIR_Done,
     /* 399457 */ // Label 8332: @399457
     /* 399457 */ GIM_Reject,
     /* 399458 */ // Label 8304: @399458
     /* 399458 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(399483), // Rule ID 8806 //
     /* 399463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 399469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 399472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399476 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 399476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 399481 */   GIR_RootConstrainSelectedInstOperands,
     /* 399482 */   // GIR_Coverage, 8806,
     /* 399482 */   GIR_Done,
     /* 399483 */ // Label 8333: @399483
     /* 399483 */ GIM_Reject,
     /* 399484 */ // Label 8305: @399484
     /* 399484 */ GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(399509), // Rule ID 8775 //
     /* 399489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 399495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 399498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399502 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 399502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399507 */   GIR_RootConstrainSelectedInstOperands,
     /* 399508 */   // GIR_Coverage, 8775,
     /* 399508 */   GIR_Done,
     /* 399509 */ // Label 8334: @399509
     /* 399509 */ GIM_Reject,
     /* 399510 */ // Label 8306: @399510
     /* 399510 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(399535), // Rule ID 8776 //
     /* 399515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 399521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 399524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399528 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 399528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399533 */   GIR_RootConstrainSelectedInstOperands,
     /* 399534 */   // GIR_Coverage, 8776,
     /* 399534 */   GIR_Done,
     /* 399535 */ // Label 8335: @399535
     /* 399535 */ GIM_Reject,
     /* 399536 */ // Label 8307: @399536
     /* 399536 */ GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(399582),
     /* 399541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 399544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 399547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399551 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(399566), // Rule ID 8771 //
     /* 399556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399559 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 399559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399564 */     GIR_RootConstrainSelectedInstOperands,
     /* 399565 */     // GIR_Coverage, 8771,
     /* 399565 */     GIR_Done,
     /* 399566 */   // Label 8337: @399566
     /* 399566 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(399581), // Rule ID 8777 //
     /* 399571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399574 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 399574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399579 */     GIR_RootConstrainSelectedInstOperands,
     /* 399580 */     // GIR_Coverage, 8777,
     /* 399580 */     GIR_Done,
     /* 399581 */   // Label 8338: @399581
     /* 399581 */   GIM_Reject,
     /* 399582 */ // Label 8336: @399582
     /* 399582 */ GIM_Reject,
     /* 399583 */ // Label 8308: @399583
     /* 399583 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(399608), // Rule ID 8805 //
     /* 399588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 399594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 399597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399601 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 399601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 399606 */   GIR_RootConstrainSelectedInstOperands,
     /* 399607 */   // GIR_Coverage, 8805,
     /* 399607 */   GIR_Done,
     /* 399608 */ // Label 8339: @399608
     /* 399608 */ GIM_Reject,
     /* 399609 */ // Label 8309: @399609
     /* 399609 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(399634), // Rule ID 8773 //
     /* 399614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 399620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 399623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399627 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 399627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 399632 */   GIR_RootConstrainSelectedInstOperands,
     /* 399633 */   // GIR_Coverage, 8773,
     /* 399633 */   GIR_Done,
     /* 399634 */ // Label 8340: @399634
     /* 399634 */ GIM_Reject,
     /* 399635 */ // Label 8310: @399635
     /* 399635 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(399681),
     /* 399640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 399643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 399646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399650 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(399665), // Rule ID 8770 //
     /* 399655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399658 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 399658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 399663 */     GIR_RootConstrainSelectedInstOperands,
     /* 399664 */     // GIR_Coverage, 8770,
     /* 399664 */     GIR_Done,
     /* 399665 */   // Label 8342: @399665
     /* 399665 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(399680), // Rule ID 8774 //
     /* 399670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399673 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 399673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 399678 */     GIR_RootConstrainSelectedInstOperands,
     /* 399679 */     // GIR_Coverage, 8774,
     /* 399679 */     GIR_Done,
     /* 399680 */   // Label 8343: @399680
     /* 399680 */   GIM_Reject,
     /* 399681 */ // Label 8341: @399681
     /* 399681 */ GIM_Reject,
     /* 399682 */ // Label 8311: @399682
     /* 399682 */ GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(399707), // Rule ID 8804 //
     /* 399687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 399693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 399696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399700 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 399700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 399705 */   GIR_RootConstrainSelectedInstOperands,
     /* 399706 */   // GIR_Coverage, 8804,
     /* 399706 */   GIR_Done,
     /* 399707 */ // Label 8344: @399707
     /* 399707 */ GIM_Reject,
     /* 399708 */ // Label 8312: @399708
     /* 399708 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(399754),
     /* 399713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 399716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 399719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399723 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(399738), // Rule ID 8769 //
     /* 399728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399731 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 399731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 399736 */     GIR_RootConstrainSelectedInstOperands,
     /* 399737 */     // GIR_Coverage, 8769,
     /* 399737 */     GIR_Done,
     /* 399738 */   // Label 8346: @399738
     /* 399738 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(399753), // Rule ID 8772 //
     /* 399743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399746 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 399746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 399751 */     GIR_RootConstrainSelectedInstOperands,
     /* 399752 */     // GIR_Coverage, 8772,
     /* 399752 */     GIR_Done,
     /* 399753 */   // Label 8347: @399753
     /* 399753 */   GIM_Reject,
     /* 399754 */ // Label 8345: @399754
     /* 399754 */ GIM_Reject,
     /* 399755 */ // Label 8313: @399755
     /* 399755 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(399780), // Rule ID 2401 //
     /* 399760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 399766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 399769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399773 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 399773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 399778 */   GIR_RootConstrainSelectedInstOperands,
     /* 399779 */   // GIR_Coverage, 2401,
     /* 399779 */   GIR_Done,
     /* 399780 */ // Label 8348: @399780
     /* 399780 */ GIM_Reject,
     /* 399781 */ // Label 8314: @399781
     /* 399781 */ GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(399806), // Rule ID 8768 //
     /* 399786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399799 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 399799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 399804 */   GIR_RootConstrainSelectedInstOperands,
     /* 399805 */   // GIR_Coverage, 8768,
     /* 399805 */   GIR_Done,
     /* 399806 */ // Label 8349: @399806
     /* 399806 */ GIM_Reject,
     /* 399807 */ // Label 8315: @399807
     /* 399807 */ GIM_Reject,
     /* 399808 */ // Label 150: @399808
     /* 399808 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8358*/ GIMT_Encode4(400505),
     /* 399819 */ /*GILLT_s64*//*Label 8350*/ GIMT_Encode4(399855), GIMT_Encode4(0),
     /* 399827 */ /*GILLT_v2s32*//*Label 8351*/ GIMT_Encode4(399966),
     /* 399831 */ /*GILLT_v2s64*//*Label 8352*/ GIMT_Encode4(400043),
     /* 399835 */ /*GILLT_v4s16*//*Label 8353*/ GIMT_Encode4(400120),
     /* 399839 */ /*GILLT_v4s32*//*Label 8354*/ GIMT_Encode4(400197),
     /* 399843 */ /*GILLT_v8s8*//*Label 8355*/ GIMT_Encode4(400274),
     /* 399847 */ /*GILLT_v8s16*//*Label 8356*/ GIMT_Encode4(400351),
     /* 399851 */ /*GILLT_v16s8*//*Label 8357*/ GIMT_Encode4(400428),
     /* 399855 */ // Label 8350: @399855
     /* 399855 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(399965),
     /* 399860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399871 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(399896), // Rule ID 5187 //
     /* 399876 */     // MIs[0] Operand 2
     /* 399876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 399887 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 399887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 399890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399894 */     GIR_RootConstrainSelectedInstOperands,
     /* 399895 */     // GIR_Coverage, 5187,
     /* 399895 */     GIR_EraseRootFromParent_Done,
     /* 399896 */   // Label 8360: @399896
     /* 399896 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(399930), // Rule ID 2111 //
     /* 399901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399904 */     // MIs[0] imm
     /* 399904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 399916 */     // MIs[1] Operand 1
     /* 399916 */     // No operand predicates
     /* 399916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399918 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 399918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 399921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399928 */     GIR_RootConstrainSelectedInstOperands,
     /* 399929 */     // GIR_Coverage, 2111,
     /* 399929 */     GIR_EraseRootFromParent_Done,
     /* 399930 */   // Label 8361: @399930
     /* 399930 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(399964), // Rule ID 6196 //
     /* 399935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399938 */     // MIs[0] imm
     /* 399938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 399950 */     // MIs[1] Operand 1
     /* 399950 */     // No operand predicates
     /* 399950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399952 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 399952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 399955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399962 */     GIR_RootConstrainSelectedInstOperands,
     /* 399963 */     // GIR_Coverage, 6196,
     /* 399963 */     GIR_EraseRootFromParent_Done,
     /* 399964 */   // Label 8362: @399964
     /* 399964 */   GIM_Reject,
     /* 399965 */ // Label 8359: @399965
     /* 399965 */ GIM_Reject,
     /* 399966 */ // Label 8351: @399966
     /* 399966 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(400042),
     /* 399971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399982 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(400007), // Rule ID 4832 //
     /* 399987 */     // MIs[0] Operand 2
     /* 399987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 399998 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 399998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 400001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400005 */     GIR_RootConstrainSelectedInstOperands,
     /* 400006 */     // GIR_Coverage, 4832,
     /* 400006 */     GIR_EraseRootFromParent_Done,
     /* 400007 */   // Label 8364: @400007
     /* 400007 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(400041), // Rule ID 2218 //
     /* 400012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400015 */     // MIs[0] imm
     /* 400015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400027 */     // MIs[1] Operand 1
     /* 400027 */     // No operand predicates
     /* 400027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400029 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 400032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400039 */     GIR_RootConstrainSelectedInstOperands,
     /* 400040 */     // GIR_Coverage, 2218,
     /* 400040 */     GIR_EraseRootFromParent_Done,
     /* 400041 */   // Label 8365: @400041
     /* 400041 */   GIM_Reject,
     /* 400042 */ // Label 8363: @400042
     /* 400042 */ GIM_Reject,
     /* 400043 */ // Label 8352: @400043
     /* 400043 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(400119),
     /* 400048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400059 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(400084), // Rule ID 4836 //
     /* 400064 */     // MIs[0] Operand 2
     /* 400064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 400075 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 400075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 400078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400082 */     GIR_RootConstrainSelectedInstOperands,
     /* 400083 */     // GIR_Coverage, 4836,
     /* 400083 */     GIR_EraseRootFromParent_Done,
     /* 400084 */   // Label 8367: @400084
     /* 400084 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(400118), // Rule ID 2220 //
     /* 400089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400092 */     // MIs[0] imm
     /* 400092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400104 */     // MIs[1] Operand 1
     /* 400104 */     // No operand predicates
     /* 400104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400106 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 400109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400116 */     GIR_RootConstrainSelectedInstOperands,
     /* 400117 */     // GIR_Coverage, 2220,
     /* 400117 */     GIR_EraseRootFromParent_Done,
     /* 400118 */   // Label 8368: @400118
     /* 400118 */   GIM_Reject,
     /* 400119 */ // Label 8366: @400119
     /* 400119 */ GIM_Reject,
     /* 400120 */ // Label 8353: @400120
     /* 400120 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(400196),
     /* 400125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400136 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(400161), // Rule ID 4831 //
     /* 400141 */     // MIs[0] Operand 2
     /* 400141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 400152 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 400152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 400155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400159 */     GIR_RootConstrainSelectedInstOperands,
     /* 400160 */     // GIR_Coverage, 4831,
     /* 400160 */     GIR_EraseRootFromParent_Done,
     /* 400161 */   // Label 8370: @400161
     /* 400161 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(400195), // Rule ID 2216 //
     /* 400166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400169 */     // MIs[0] imm
     /* 400169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400181 */     // MIs[1] Operand 1
     /* 400181 */     // No operand predicates
     /* 400181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400183 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 400186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400193 */     GIR_RootConstrainSelectedInstOperands,
     /* 400194 */     // GIR_Coverage, 2216,
     /* 400194 */     GIR_EraseRootFromParent_Done,
     /* 400195 */   // Label 8371: @400195
     /* 400195 */   GIM_Reject,
     /* 400196 */ // Label 8369: @400196
     /* 400196 */ GIM_Reject,
     /* 400197 */ // Label 8354: @400197
     /* 400197 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(400273),
     /* 400202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400213 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(400238), // Rule ID 4835 //
     /* 400218 */     // MIs[0] Operand 2
     /* 400218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 400229 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 400229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 400232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400236 */     GIR_RootConstrainSelectedInstOperands,
     /* 400237 */     // GIR_Coverage, 4835,
     /* 400237 */     GIR_EraseRootFromParent_Done,
     /* 400238 */   // Label 8373: @400238
     /* 400238 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(400272), // Rule ID 2219 //
     /* 400243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400246 */     // MIs[0] imm
     /* 400246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400258 */     // MIs[1] Operand 1
     /* 400258 */     // No operand predicates
     /* 400258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400260 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 400263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400270 */     GIR_RootConstrainSelectedInstOperands,
     /* 400271 */     // GIR_Coverage, 2219,
     /* 400271 */     GIR_EraseRootFromParent_Done,
     /* 400272 */   // Label 8374: @400272
     /* 400272 */   GIM_Reject,
     /* 400273 */ // Label 8372: @400273
     /* 400273 */ GIM_Reject,
     /* 400274 */ // Label 8355: @400274
     /* 400274 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(400350),
     /* 400279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400290 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(400315), // Rule ID 4830 //
     /* 400295 */     // MIs[0] Operand 2
     /* 400295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 400306 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 400306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 400309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400313 */     GIR_RootConstrainSelectedInstOperands,
     /* 400314 */     // GIR_Coverage, 4830,
     /* 400314 */     GIR_EraseRootFromParent_Done,
     /* 400315 */   // Label 8376: @400315
     /* 400315 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(400349), // Rule ID 2214 //
     /* 400320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400323 */     // MIs[0] imm
     /* 400323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400335 */     // MIs[1] Operand 1
     /* 400335 */     // No operand predicates
     /* 400335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400337 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 400340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400347 */     GIR_RootConstrainSelectedInstOperands,
     /* 400348 */     // GIR_Coverage, 2214,
     /* 400348 */     GIR_EraseRootFromParent_Done,
     /* 400349 */   // Label 8377: @400349
     /* 400349 */   GIM_Reject,
     /* 400350 */ // Label 8375: @400350
     /* 400350 */ GIM_Reject,
     /* 400351 */ // Label 8356: @400351
     /* 400351 */ GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(400427),
     /* 400356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400367 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(400392), // Rule ID 4834 //
     /* 400372 */     // MIs[0] Operand 2
     /* 400372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 400383 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 400383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 400386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400390 */     GIR_RootConstrainSelectedInstOperands,
     /* 400391 */     // GIR_Coverage, 4834,
     /* 400391 */     GIR_EraseRootFromParent_Done,
     /* 400392 */   // Label 8379: @400392
     /* 400392 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(400426), // Rule ID 2217 //
     /* 400397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400400 */     // MIs[0] imm
     /* 400400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400412 */     // MIs[1] Operand 1
     /* 400412 */     // No operand predicates
     /* 400412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400414 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 400417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400424 */     GIR_RootConstrainSelectedInstOperands,
     /* 400425 */     // GIR_Coverage, 2217,
     /* 400425 */     GIR_EraseRootFromParent_Done,
     /* 400426 */   // Label 8380: @400426
     /* 400426 */   GIM_Reject,
     /* 400427 */ // Label 8378: @400427
     /* 400427 */ GIM_Reject,
     /* 400428 */ // Label 8357: @400428
     /* 400428 */ GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(400504),
     /* 400433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400444 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(400469), // Rule ID 4833 //
     /* 400449 */     // MIs[0] Operand 2
     /* 400449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 400460 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 400460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 400463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400467 */     GIR_RootConstrainSelectedInstOperands,
     /* 400468 */     // GIR_Coverage, 4833,
     /* 400468 */     GIR_EraseRootFromParent_Done,
     /* 400469 */   // Label 8382: @400469
     /* 400469 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(400503), // Rule ID 2215 //
     /* 400474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400477 */     // MIs[0] imm
     /* 400477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400489 */     // MIs[1] Operand 1
     /* 400489 */     // No operand predicates
     /* 400489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400491 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 400494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400501 */     GIR_RootConstrainSelectedInstOperands,
     /* 400502 */     // GIR_Coverage, 2215,
     /* 400502 */     GIR_EraseRootFromParent_Done,
     /* 400503 */   // Label 8383: @400503
     /* 400503 */   GIM_Reject,
     /* 400504 */ // Label 8381: @400504
     /* 400504 */ GIM_Reject,
     /* 400505 */ // Label 8358: @400505
     /* 400505 */ GIM_Reject,
     /* 400506 */ // Label 151: @400506
     /* 400506 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8392*/ GIMT_Encode4(400961),
     /* 400517 */ /*GILLT_s64*//*Label 8384*/ GIMT_Encode4(400553), GIMT_Encode4(0),
     /* 400525 */ /*GILLT_v2s32*//*Label 8385*/ GIMT_Encode4(400639),
     /* 400529 */ /*GILLT_v2s64*//*Label 8386*/ GIMT_Encode4(400685),
     /* 400533 */ /*GILLT_v4s16*//*Label 8387*/ GIMT_Encode4(400731),
     /* 400537 */ /*GILLT_v4s32*//*Label 8388*/ GIMT_Encode4(400777),
     /* 400541 */ /*GILLT_v8s8*//*Label 8389*/ GIMT_Encode4(400823),
     /* 400545 */ /*GILLT_v8s16*//*Label 8390*/ GIMT_Encode4(400869),
     /* 400549 */ /*GILLT_v16s8*//*Label 8391*/ GIMT_Encode4(400915),
     /* 400553 */ // Label 8384: @400553
     /* 400553 */ GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(400638),
     /* 400558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400569 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(400603), // Rule ID 2120 //
     /* 400574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400577 */     // MIs[0] imm
     /* 400577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400589 */     // MIs[1] Operand 1
     /* 400589 */     // No operand predicates
     /* 400589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400591 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 400594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400601 */     GIR_RootConstrainSelectedInstOperands,
     /* 400602 */     // GIR_Coverage, 2120,
     /* 400602 */     GIR_EraseRootFromParent_Done,
     /* 400603 */   // Label 8394: @400603
     /* 400603 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(400637), // Rule ID 6202 //
     /* 400608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400611 */     // MIs[0] imm
     /* 400611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400623 */     // MIs[1] Operand 1
     /* 400623 */     // No operand predicates
     /* 400623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400625 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 400625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 400628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400635 */     GIR_RootConstrainSelectedInstOperands,
     /* 400636 */     // GIR_Coverage, 6202,
     /* 400636 */     GIR_EraseRootFromParent_Done,
     /* 400637 */   // Label 8395: @400637
     /* 400637 */   GIM_Reject,
     /* 400638 */ // Label 8393: @400638
     /* 400638 */ GIM_Reject,
     /* 400639 */ // Label 8385: @400639
     /* 400639 */ GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(400684), // Rule ID 2277 //
     /* 400644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400658 */   // MIs[0] imm
     /* 400658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400666 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400670 */   // MIs[1] Operand 1
     /* 400670 */   // No operand predicates
     /* 400670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400672 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 400675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400677 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400679 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400682 */   GIR_RootConstrainSelectedInstOperands,
     /* 400683 */   // GIR_Coverage, 2277,
     /* 400683 */   GIR_EraseRootFromParent_Done,
     /* 400684 */ // Label 8396: @400684
     /* 400684 */ GIM_Reject,
     /* 400685 */ // Label 8386: @400685
     /* 400685 */ GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(400730), // Rule ID 2279 //
     /* 400690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400704 */   // MIs[0] imm
     /* 400704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400712 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400716 */   // MIs[1] Operand 1
     /* 400716 */   // No operand predicates
     /* 400716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400718 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 400721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400723 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400725 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400728 */   GIR_RootConstrainSelectedInstOperands,
     /* 400729 */   // GIR_Coverage, 2279,
     /* 400729 */   GIR_EraseRootFromParent_Done,
     /* 400730 */ // Label 8397: @400730
     /* 400730 */ GIM_Reject,
     /* 400731 */ // Label 8387: @400731
     /* 400731 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(400776), // Rule ID 2275 //
     /* 400736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400750 */   // MIs[0] imm
     /* 400750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400758 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400762 */   // MIs[1] Operand 1
     /* 400762 */   // No operand predicates
     /* 400762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400764 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 400767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400769 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400771 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400774 */   GIR_RootConstrainSelectedInstOperands,
     /* 400775 */   // GIR_Coverage, 2275,
     /* 400775 */   GIR_EraseRootFromParent_Done,
     /* 400776 */ // Label 8398: @400776
     /* 400776 */ GIM_Reject,
     /* 400777 */ // Label 8388: @400777
     /* 400777 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(400822), // Rule ID 2278 //
     /* 400782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400796 */   // MIs[0] imm
     /* 400796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400804 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400808 */   // MIs[1] Operand 1
     /* 400808 */   // No operand predicates
     /* 400808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400810 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 400813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400817 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400820 */   GIR_RootConstrainSelectedInstOperands,
     /* 400821 */   // GIR_Coverage, 2278,
     /* 400821 */   GIR_EraseRootFromParent_Done,
     /* 400822 */ // Label 8399: @400822
     /* 400822 */ GIM_Reject,
     /* 400823 */ // Label 8389: @400823
     /* 400823 */ GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(400868), // Rule ID 2273 //
     /* 400828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400842 */   // MIs[0] imm
     /* 400842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400850 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400854 */   // MIs[1] Operand 1
     /* 400854 */   // No operand predicates
     /* 400854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400856 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 400859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400861 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400863 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400866 */   GIR_RootConstrainSelectedInstOperands,
     /* 400867 */   // GIR_Coverage, 2273,
     /* 400867 */   GIR_EraseRootFromParent_Done,
     /* 400868 */ // Label 8400: @400868
     /* 400868 */ GIM_Reject,
     /* 400869 */ // Label 8390: @400869
     /* 400869 */ GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(400914), // Rule ID 2276 //
     /* 400874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400888 */   // MIs[0] imm
     /* 400888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400896 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400900 */   // MIs[1] Operand 1
     /* 400900 */   // No operand predicates
     /* 400900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400902 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 400905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400907 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400909 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400912 */   GIR_RootConstrainSelectedInstOperands,
     /* 400913 */   // GIR_Coverage, 2276,
     /* 400913 */   GIR_EraseRootFromParent_Done,
     /* 400914 */ // Label 8401: @400914
     /* 400914 */ GIM_Reject,
     /* 400915 */ // Label 8391: @400915
     /* 400915 */ GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(400960), // Rule ID 2274 //
     /* 400920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400934 */   // MIs[0] imm
     /* 400934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400942 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400946 */   // MIs[1] Operand 1
     /* 400946 */   // No operand predicates
     /* 400946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400948 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 400951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400953 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400955 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400958 */   GIR_RootConstrainSelectedInstOperands,
     /* 400959 */   // GIR_Coverage, 2274,
     /* 400959 */   GIR_EraseRootFromParent_Done,
     /* 400960 */ // Label 8402: @400960
     /* 400960 */ GIM_Reject,
     /* 400961 */ // Label 8392: @400961
     /* 400961 */ GIM_Reject,
     /* 400962 */ // Label 152: @400962
     /* 400962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8421*/ GIMT_Encode4(401741),
     /* 400973 */ /*GILLT_v2s32*//*Label 8403*/ GIMT_Encode4(401049),
     /* 400977 */ /*GILLT_v2s64*//*Label 8404*/ GIMT_Encode4(401104),
     /* 400981 */ /*GILLT_v4s16*//*Label 8405*/ GIMT_Encode4(401159),
     /* 400985 */ /*GILLT_v4s32*//*Label 8406*/ GIMT_Encode4(401214),
     /* 400989 */ /*GILLT_v8s8*//*Label 8407*/ GIMT_Encode4(401269),
     /* 400993 */ /*GILLT_v8s16*//*Label 8408*/ GIMT_Encode4(401303),
     /* 400997 */ /*GILLT_v16s8*//*Label 8409*/ GIMT_Encode4(401358), GIMT_Encode4(0),
     /* 401005 */ /*GILLT_nxv2s1*//*Label 8410*/ GIMT_Encode4(401392),
     /* 401009 */ /*GILLT_nxv2s16*//*Label 8411*/ GIMT_Encode4(401418),
     /* 401013 */ /*GILLT_nxv2s32*//*Label 8412*/ GIMT_Encode4(401444),
     /* 401017 */ /*GILLT_nxv2s64*//*Label 8413*/ GIMT_Encode4(401470),
     /* 401021 */ /*GILLT_nxv4s1*//*Label 8414*/ GIMT_Encode4(401517),
     /* 401025 */ /*GILLT_nxv4s16*//*Label 8415*/ GIMT_Encode4(401543),
     /* 401029 */ /*GILLT_nxv4s32*//*Label 8416*/ GIMT_Encode4(401569),
     /* 401033 */ /*GILLT_nxv8s1*//*Label 8417*/ GIMT_Encode4(401616),
     /* 401037 */ /*GILLT_nxv8s16*//*Label 8418*/ GIMT_Encode4(401642),
     /* 401041 */ /*GILLT_nxv16s1*//*Label 8419*/ GIMT_Encode4(401689),
     /* 401045 */ /*GILLT_nxv16s8*//*Label 8420*/ GIMT_Encode4(401715),
     /* 401049 */ // Label 8403: @401049
     /* 401049 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(401103),
     /* 401054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401072 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(401087), // Rule ID 1895 //
     /* 401077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401080 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 401085 */     GIR_RootConstrainSelectedInstOperands,
     /* 401086 */     // GIR_Coverage, 1895,
     /* 401086 */     GIR_Done,
     /* 401087 */   // Label 8423: @401087
     /* 401087 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(401102), // Rule ID 5420 //
     /* 401092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401095 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 401100 */     GIR_RootConstrainSelectedInstOperands,
     /* 401101 */     // GIR_Coverage, 5420,
     /* 401101 */     GIR_Done,
     /* 401102 */   // Label 8424: @401102
     /* 401102 */   GIM_Reject,
     /* 401103 */ // Label 8422: @401103
     /* 401103 */ GIM_Reject,
     /* 401104 */ // Label 8404: @401104
     /* 401104 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(401158),
     /* 401109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401127 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(401142), // Rule ID 1897 //
     /* 401132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401135 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 401140 */     GIR_RootConstrainSelectedInstOperands,
     /* 401141 */     // GIR_Coverage, 1897,
     /* 401141 */     GIR_Done,
     /* 401142 */   // Label 8426: @401142
     /* 401142 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(401157), // Rule ID 5422 //
     /* 401147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401150 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 401155 */     GIR_RootConstrainSelectedInstOperands,
     /* 401156 */     // GIR_Coverage, 5422,
     /* 401156 */     GIR_Done,
     /* 401157 */   // Label 8427: @401157
     /* 401157 */   GIM_Reject,
     /* 401158 */ // Label 8425: @401158
     /* 401158 */ GIM_Reject,
     /* 401159 */ // Label 8405: @401159
     /* 401159 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(401213),
     /* 401164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401182 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(401197), // Rule ID 1893 //
     /* 401187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401190 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 401195 */     GIR_RootConstrainSelectedInstOperands,
     /* 401196 */     // GIR_Coverage, 1893,
     /* 401196 */     GIR_Done,
     /* 401197 */   // Label 8429: @401197
     /* 401197 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(401212), // Rule ID 5418 //
     /* 401202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401205 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 401210 */     GIR_RootConstrainSelectedInstOperands,
     /* 401211 */     // GIR_Coverage, 5418,
     /* 401211 */     GIR_Done,
     /* 401212 */   // Label 8430: @401212
     /* 401212 */   GIM_Reject,
     /* 401213 */ // Label 8428: @401213
     /* 401213 */ GIM_Reject,
     /* 401214 */ // Label 8406: @401214
     /* 401214 */ GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(401268),
     /* 401219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401237 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(401252), // Rule ID 1896 //
     /* 401242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401245 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 401245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 401250 */     GIR_RootConstrainSelectedInstOperands,
     /* 401251 */     // GIR_Coverage, 1896,
     /* 401251 */     GIR_Done,
     /* 401252 */   // Label 8432: @401252
     /* 401252 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(401267), // Rule ID 5421 //
     /* 401257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401260 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 401265 */     GIR_RootConstrainSelectedInstOperands,
     /* 401266 */     // GIR_Coverage, 5421,
     /* 401266 */     GIR_Done,
     /* 401267 */   // Label 8433: @401267
     /* 401267 */   GIM_Reject,
     /* 401268 */ // Label 8431: @401268
     /* 401268 */ GIM_Reject,
     /* 401269 */ // Label 8407: @401269
     /* 401269 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(401302), // Rule ID 1891 //
     /* 401274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 401283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401295 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 401300 */   GIR_RootConstrainSelectedInstOperands,
     /* 401301 */   // GIR_Coverage, 1891,
     /* 401301 */   GIR_Done,
     /* 401302 */ // Label 8434: @401302
     /* 401302 */ GIM_Reject,
     /* 401303 */ // Label 8408: @401303
     /* 401303 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(401357),
     /* 401308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401326 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(401341), // Rule ID 1894 //
     /* 401331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401334 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 401334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 401339 */     GIR_RootConstrainSelectedInstOperands,
     /* 401340 */     // GIR_Coverage, 1894,
     /* 401340 */     GIR_Done,
     /* 401341 */   // Label 8436: @401341
     /* 401341 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(401356), // Rule ID 5419 //
     /* 401346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401349 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 401354 */     GIR_RootConstrainSelectedInstOperands,
     /* 401355 */     // GIR_Coverage, 5419,
     /* 401355 */     GIR_Done,
     /* 401356 */   // Label 8437: @401356
     /* 401356 */   GIM_Reject,
     /* 401357 */ // Label 8435: @401357
     /* 401357 */ GIM_Reject,
     /* 401358 */ // Label 8409: @401358
     /* 401358 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(401391), // Rule ID 1892 //
     /* 401363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 401372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401384 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 401389 */   GIR_RootConstrainSelectedInstOperands,
     /* 401390 */   // GIR_Coverage, 1892,
     /* 401390 */   GIR_Done,
     /* 401391 */ // Label 8438: @401391
     /* 401391 */ GIM_Reject,
     /* 401392 */ // Label 8410: @401392
     /* 401392 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(401417), // Rule ID 3328 //
     /* 401397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 401403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 401406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401410 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 401410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 401415 */   GIR_RootConstrainSelectedInstOperands,
     /* 401416 */   // GIR_Coverage, 3328,
     /* 401416 */   GIR_Done,
     /* 401417 */ // Label 8439: @401417
     /* 401417 */ GIM_Reject,
     /* 401418 */ // Label 8411: @401418
     /* 401418 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(401443), // Rule ID 2865 //
     /* 401423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 401429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 401432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401436 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 401436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401441 */   GIR_RootConstrainSelectedInstOperands,
     /* 401442 */   // GIR_Coverage, 2865,
     /* 401442 */   GIR_Done,
     /* 401443 */ // Label 8440: @401443
     /* 401443 */ GIM_Reject,
     /* 401444 */ // Label 8412: @401444
     /* 401444 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(401469), // Rule ID 2866 //
     /* 401449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 401455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 401458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401462 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 401462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401467 */   GIR_RootConstrainSelectedInstOperands,
     /* 401468 */   // GIR_Coverage, 2866,
     /* 401468 */   GIR_Done,
     /* 401469 */ // Label 8441: @401469
     /* 401469 */ GIM_Reject,
     /* 401470 */ // Label 8413: @401470
     /* 401470 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(401516),
     /* 401475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 401478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 401481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401485 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(401500), // Rule ID 2861 //
     /* 401490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401493 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 401493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401498 */     GIR_RootConstrainSelectedInstOperands,
     /* 401499 */     // GIR_Coverage, 2861,
     /* 401499 */     GIR_Done,
     /* 401500 */   // Label 8443: @401500
     /* 401500 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(401515), // Rule ID 2867 //
     /* 401505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401508 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 401508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401513 */     GIR_RootConstrainSelectedInstOperands,
     /* 401514 */     // GIR_Coverage, 2867,
     /* 401514 */     GIR_Done,
     /* 401515 */   // Label 8444: @401515
     /* 401515 */   GIM_Reject,
     /* 401516 */ // Label 8442: @401516
     /* 401516 */ GIM_Reject,
     /* 401517 */ // Label 8414: @401517
     /* 401517 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(401542), // Rule ID 3327 //
     /* 401522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 401528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 401531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401535 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 401535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 401540 */   GIR_RootConstrainSelectedInstOperands,
     /* 401541 */   // GIR_Coverage, 3327,
     /* 401541 */   GIR_Done,
     /* 401542 */ // Label 8445: @401542
     /* 401542 */ GIM_Reject,
     /* 401543 */ // Label 8415: @401543
     /* 401543 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(401568), // Rule ID 2863 //
     /* 401548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 401554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 401557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401561 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 401561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 401566 */   GIR_RootConstrainSelectedInstOperands,
     /* 401567 */   // GIR_Coverage, 2863,
     /* 401567 */   GIR_Done,
     /* 401568 */ // Label 8446: @401568
     /* 401568 */ GIM_Reject,
     /* 401569 */ // Label 8416: @401569
     /* 401569 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(401615),
     /* 401574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 401577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 401580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401584 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(401599), // Rule ID 2860 //
     /* 401589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401592 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 401592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 401597 */     GIR_RootConstrainSelectedInstOperands,
     /* 401598 */     // GIR_Coverage, 2860,
     /* 401598 */     GIR_Done,
     /* 401599 */   // Label 8448: @401599
     /* 401599 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(401614), // Rule ID 2864 //
     /* 401604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401607 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 401607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 401612 */     GIR_RootConstrainSelectedInstOperands,
     /* 401613 */     // GIR_Coverage, 2864,
     /* 401613 */     GIR_Done,
     /* 401614 */   // Label 8449: @401614
     /* 401614 */   GIM_Reject,
     /* 401615 */ // Label 8447: @401615
     /* 401615 */ GIM_Reject,
     /* 401616 */ // Label 8417: @401616
     /* 401616 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(401641), // Rule ID 3326 //
     /* 401621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 401627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 401630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401634 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 401634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 401639 */   GIR_RootConstrainSelectedInstOperands,
     /* 401640 */   // GIR_Coverage, 3326,
     /* 401640 */   GIR_Done,
     /* 401641 */ // Label 8450: @401641
     /* 401641 */ GIM_Reject,
     /* 401642 */ // Label 8418: @401642
     /* 401642 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(401688),
     /* 401647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 401650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 401653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401657 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(401672), // Rule ID 2859 //
     /* 401662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401665 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 401665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 401670 */     GIR_RootConstrainSelectedInstOperands,
     /* 401671 */     // GIR_Coverage, 2859,
     /* 401671 */     GIR_Done,
     /* 401672 */   // Label 8452: @401672
     /* 401672 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(401687), // Rule ID 2862 //
     /* 401677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401680 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 401680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 401685 */     GIR_RootConstrainSelectedInstOperands,
     /* 401686 */     // GIR_Coverage, 2862,
     /* 401686 */     GIR_Done,
     /* 401687 */   // Label 8453: @401687
     /* 401687 */   GIM_Reject,
     /* 401688 */ // Label 8451: @401688
     /* 401688 */ GIM_Reject,
     /* 401689 */ // Label 8419: @401689
     /* 401689 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(401714), // Rule ID 2389 //
     /* 401694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 401700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 401703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401707 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 401707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 401712 */   GIR_RootConstrainSelectedInstOperands,
     /* 401713 */   // GIR_Coverage, 2389,
     /* 401713 */   GIR_Done,
     /* 401714 */ // Label 8454: @401714
     /* 401714 */ GIM_Reject,
     /* 401715 */ // Label 8420: @401715
     /* 401715 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(401740), // Rule ID 2858 //
     /* 401720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 401726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 401729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401733 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 401733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 401738 */   GIR_RootConstrainSelectedInstOperands,
     /* 401739 */   // GIR_Coverage, 2858,
     /* 401739 */   GIR_Done,
     /* 401740 */ // Label 8455: @401740
     /* 401740 */ GIM_Reject,
     /* 401741 */ // Label 8421: @401741
     /* 401741 */ GIM_Reject,
     /* 401742 */ // Label 153: @401742
     /* 401742 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8474*/ GIMT_Encode4(402521),
     /* 401753 */ /*GILLT_v2s32*//*Label 8456*/ GIMT_Encode4(401829),
     /* 401757 */ /*GILLT_v2s64*//*Label 8457*/ GIMT_Encode4(401884),
     /* 401761 */ /*GILLT_v4s16*//*Label 8458*/ GIMT_Encode4(401939),
     /* 401765 */ /*GILLT_v4s32*//*Label 8459*/ GIMT_Encode4(401994),
     /* 401769 */ /*GILLT_v8s8*//*Label 8460*/ GIMT_Encode4(402049),
     /* 401773 */ /*GILLT_v8s16*//*Label 8461*/ GIMT_Encode4(402083),
     /* 401777 */ /*GILLT_v16s8*//*Label 8462*/ GIMT_Encode4(402138), GIMT_Encode4(0),
     /* 401785 */ /*GILLT_nxv2s1*//*Label 8463*/ GIMT_Encode4(402172),
     /* 401789 */ /*GILLT_nxv2s16*//*Label 8464*/ GIMT_Encode4(402198),
     /* 401793 */ /*GILLT_nxv2s32*//*Label 8465*/ GIMT_Encode4(402224),
     /* 401797 */ /*GILLT_nxv2s64*//*Label 8466*/ GIMT_Encode4(402250),
     /* 401801 */ /*GILLT_nxv4s1*//*Label 8467*/ GIMT_Encode4(402297),
     /* 401805 */ /*GILLT_nxv4s16*//*Label 8468*/ GIMT_Encode4(402323),
     /* 401809 */ /*GILLT_nxv4s32*//*Label 8469*/ GIMT_Encode4(402349),
     /* 401813 */ /*GILLT_nxv8s1*//*Label 8470*/ GIMT_Encode4(402396),
     /* 401817 */ /*GILLT_nxv8s16*//*Label 8471*/ GIMT_Encode4(402422),
     /* 401821 */ /*GILLT_nxv16s1*//*Label 8472*/ GIMT_Encode4(402469),
     /* 401825 */ /*GILLT_nxv16s8*//*Label 8473*/ GIMT_Encode4(402495),
     /* 401829 */ // Label 8456: @401829
     /* 401829 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(401883),
     /* 401834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401852 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(401867), // Rule ID 1902 //
     /* 401857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401860 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 401865 */     GIR_RootConstrainSelectedInstOperands,
     /* 401866 */     // GIR_Coverage, 1902,
     /* 401866 */     GIR_Done,
     /* 401867 */   // Label 8476: @401867
     /* 401867 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(401882), // Rule ID 5425 //
     /* 401872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401875 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 401880 */     GIR_RootConstrainSelectedInstOperands,
     /* 401881 */     // GIR_Coverage, 5425,
     /* 401881 */     GIR_Done,
     /* 401882 */   // Label 8477: @401882
     /* 401882 */   GIM_Reject,
     /* 401883 */ // Label 8475: @401883
     /* 401883 */ GIM_Reject,
     /* 401884 */ // Label 8457: @401884
     /* 401884 */ GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(401938),
     /* 401889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401907 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(401922), // Rule ID 1904 //
     /* 401912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401915 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 401920 */     GIR_RootConstrainSelectedInstOperands,
     /* 401921 */     // GIR_Coverage, 1904,
     /* 401921 */     GIR_Done,
     /* 401922 */   // Label 8479: @401922
     /* 401922 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(401937), // Rule ID 5427 //
     /* 401927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401930 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 401935 */     GIR_RootConstrainSelectedInstOperands,
     /* 401936 */     // GIR_Coverage, 5427,
     /* 401936 */     GIR_Done,
     /* 401937 */   // Label 8480: @401937
     /* 401937 */   GIM_Reject,
     /* 401938 */ // Label 8478: @401938
     /* 401938 */ GIM_Reject,
     /* 401939 */ // Label 8458: @401939
     /* 401939 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(401993),
     /* 401944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401962 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(401977), // Rule ID 1900 //
     /* 401967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401970 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 401975 */     GIR_RootConstrainSelectedInstOperands,
     /* 401976 */     // GIR_Coverage, 1900,
     /* 401976 */     GIR_Done,
     /* 401977 */   // Label 8482: @401977
     /* 401977 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(401992), // Rule ID 5423 //
     /* 401982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401985 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 401990 */     GIR_RootConstrainSelectedInstOperands,
     /* 401991 */     // GIR_Coverage, 5423,
     /* 401991 */     GIR_Done,
     /* 401992 */   // Label 8483: @401992
     /* 401992 */   GIM_Reject,
     /* 401993 */ // Label 8481: @401993
     /* 401993 */ GIM_Reject,
     /* 401994 */ // Label 8459: @401994
     /* 401994 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(402048),
     /* 401999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402017 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(402032), // Rule ID 1903 //
     /* 402022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402025 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 402025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 402030 */     GIR_RootConstrainSelectedInstOperands,
     /* 402031 */     // GIR_Coverage, 1903,
     /* 402031 */     GIR_Done,
     /* 402032 */   // Label 8485: @402032
     /* 402032 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(402047), // Rule ID 5426 //
     /* 402037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402040 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 402045 */     GIR_RootConstrainSelectedInstOperands,
     /* 402046 */     // GIR_Coverage, 5426,
     /* 402046 */     GIR_Done,
     /* 402047 */   // Label 8486: @402047
     /* 402047 */   GIM_Reject,
     /* 402048 */ // Label 8484: @402048
     /* 402048 */ GIM_Reject,
     /* 402049 */ // Label 8460: @402049
     /* 402049 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(402082), // Rule ID 1898 //
     /* 402054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 402063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402075 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 402075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 402080 */   GIR_RootConstrainSelectedInstOperands,
     /* 402081 */   // GIR_Coverage, 1898,
     /* 402081 */   GIR_Done,
     /* 402082 */ // Label 8487: @402082
     /* 402082 */ GIM_Reject,
     /* 402083 */ // Label 8461: @402083
     /* 402083 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(402137),
     /* 402088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402106 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(402121), // Rule ID 1901 //
     /* 402111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402114 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 402114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 402119 */     GIR_RootConstrainSelectedInstOperands,
     /* 402120 */     // GIR_Coverage, 1901,
     /* 402120 */     GIR_Done,
     /* 402121 */   // Label 8489: @402121
     /* 402121 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(402136), // Rule ID 5424 //
     /* 402126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402129 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 402134 */     GIR_RootConstrainSelectedInstOperands,
     /* 402135 */     // GIR_Coverage, 5424,
     /* 402135 */     GIR_Done,
     /* 402136 */   // Label 8490: @402136
     /* 402136 */   GIM_Reject,
     /* 402137 */ // Label 8488: @402137
     /* 402137 */ GIM_Reject,
     /* 402138 */ // Label 8462: @402138
     /* 402138 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(402171), // Rule ID 1899 //
     /* 402143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 402152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402164 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 402164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 402169 */   GIR_RootConstrainSelectedInstOperands,
     /* 402170 */   // GIR_Coverage, 1899,
     /* 402170 */   GIR_Done,
     /* 402171 */ // Label 8491: @402171
     /* 402171 */ GIM_Reject,
     /* 402172 */ // Label 8463: @402172
     /* 402172 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(402197), // Rule ID 8800 //
     /* 402177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 402183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 402186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402190 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 402190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 402195 */   GIR_RootConstrainSelectedInstOperands,
     /* 402196 */   // GIR_Coverage, 8800,
     /* 402196 */   GIR_Done,
     /* 402197 */ // Label 8492: @402197
     /* 402197 */ GIM_Reject,
     /* 402198 */ // Label 8464: @402198
     /* 402198 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(402223), // Rule ID 8755 //
     /* 402203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 402209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 402212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402216 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 402216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402221 */   GIR_RootConstrainSelectedInstOperands,
     /* 402222 */   // GIR_Coverage, 8755,
     /* 402222 */   GIR_Done,
     /* 402223 */ // Label 8493: @402223
     /* 402223 */ GIM_Reject,
     /* 402224 */ // Label 8465: @402224
     /* 402224 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(402249), // Rule ID 8756 //
     /* 402229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 402235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 402238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402242 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 402242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402247 */   GIR_RootConstrainSelectedInstOperands,
     /* 402248 */   // GIR_Coverage, 8756,
     /* 402248 */   GIR_Done,
     /* 402249 */ // Label 8494: @402249
     /* 402249 */ GIM_Reject,
     /* 402250 */ // Label 8466: @402250
     /* 402250 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(402296),
     /* 402255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 402258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 402261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402265 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(402280), // Rule ID 8751 //
     /* 402270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402273 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 402273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402278 */     GIR_RootConstrainSelectedInstOperands,
     /* 402279 */     // GIR_Coverage, 8751,
     /* 402279 */     GIR_Done,
     /* 402280 */   // Label 8496: @402280
     /* 402280 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(402295), // Rule ID 8757 //
     /* 402285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402288 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 402288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402293 */     GIR_RootConstrainSelectedInstOperands,
     /* 402294 */     // GIR_Coverage, 8757,
     /* 402294 */     GIR_Done,
     /* 402295 */   // Label 8497: @402295
     /* 402295 */   GIM_Reject,
     /* 402296 */ // Label 8495: @402296
     /* 402296 */ GIM_Reject,
     /* 402297 */ // Label 8467: @402297
     /* 402297 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(402322), // Rule ID 8799 //
     /* 402302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 402308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 402311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402315 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 402315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 402320 */   GIR_RootConstrainSelectedInstOperands,
     /* 402321 */   // GIR_Coverage, 8799,
     /* 402321 */   GIR_Done,
     /* 402322 */ // Label 8498: @402322
     /* 402322 */ GIM_Reject,
     /* 402323 */ // Label 8468: @402323
     /* 402323 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(402348), // Rule ID 8753 //
     /* 402328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 402334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 402337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402341 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 402341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402346 */   GIR_RootConstrainSelectedInstOperands,
     /* 402347 */   // GIR_Coverage, 8753,
     /* 402347 */   GIR_Done,
     /* 402348 */ // Label 8499: @402348
     /* 402348 */ GIM_Reject,
     /* 402349 */ // Label 8469: @402349
     /* 402349 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(402395),
     /* 402354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 402357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 402360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402364 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(402379), // Rule ID 8750 //
     /* 402369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402372 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 402372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402377 */     GIR_RootConstrainSelectedInstOperands,
     /* 402378 */     // GIR_Coverage, 8750,
     /* 402378 */     GIR_Done,
     /* 402379 */   // Label 8501: @402379
     /* 402379 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(402394), // Rule ID 8754 //
     /* 402384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402387 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 402387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402392 */     GIR_RootConstrainSelectedInstOperands,
     /* 402393 */     // GIR_Coverage, 8754,
     /* 402393 */     GIR_Done,
     /* 402394 */   // Label 8502: @402394
     /* 402394 */   GIM_Reject,
     /* 402395 */ // Label 8500: @402395
     /* 402395 */ GIM_Reject,
     /* 402396 */ // Label 8470: @402396
     /* 402396 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(402421), // Rule ID 8798 //
     /* 402401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 402407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 402410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402414 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 402414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 402419 */   GIR_RootConstrainSelectedInstOperands,
     /* 402420 */   // GIR_Coverage, 8798,
     /* 402420 */   GIR_Done,
     /* 402421 */ // Label 8503: @402421
     /* 402421 */ GIM_Reject,
     /* 402422 */ // Label 8471: @402422
     /* 402422 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(402468),
     /* 402427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 402430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 402433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402437 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(402452), // Rule ID 8749 //
     /* 402442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402445 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 402445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 402450 */     GIR_RootConstrainSelectedInstOperands,
     /* 402451 */     // GIR_Coverage, 8749,
     /* 402451 */     GIR_Done,
     /* 402452 */   // Label 8505: @402452
     /* 402452 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(402467), // Rule ID 8752 //
     /* 402457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402460 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 402460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 402465 */     GIR_RootConstrainSelectedInstOperands,
     /* 402466 */     // GIR_Coverage, 8752,
     /* 402466 */     GIR_Done,
     /* 402467 */   // Label 8506: @402467
     /* 402467 */   GIM_Reject,
     /* 402468 */ // Label 8504: @402468
     /* 402468 */ GIM_Reject,
     /* 402469 */ // Label 8472: @402469
     /* 402469 */ GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(402494), // Rule ID 2393 //
     /* 402474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 402480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 402483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402487 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 402487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 402492 */   GIR_RootConstrainSelectedInstOperands,
     /* 402493 */   // GIR_Coverage, 2393,
     /* 402493 */   GIR_Done,
     /* 402494 */ // Label 8507: @402494
     /* 402494 */ GIM_Reject,
     /* 402495 */ // Label 8473: @402495
     /* 402495 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(402520), // Rule ID 8748 //
     /* 402500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 402506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 402509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402513 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 402513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 402518 */   GIR_RootConstrainSelectedInstOperands,
     /* 402519 */   // GIR_Coverage, 8748,
     /* 402519 */   GIR_Done,
     /* 402520 */ // Label 8508: @402520
     /* 402520 */ GIM_Reject,
     /* 402521 */ // Label 8474: @402521
     /* 402521 */ GIM_Reject,
     /* 402522 */ // Label 154: @402522
     /* 402522 */ GIM_Reject,
     /* 402523 */ }; // Size: 402523 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
